/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/charCode","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],le=function(X){for(var e=[],i=0,r=X.length;i<r;i++)e[i]=ce[X[i]];return e};define(ce[138],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=i,e.$gb=r,e.$hb=k,e.$ib=A,e.$jb=O,e.$kb=I,e.$lb=E,e.$nb=f,e.$ob=d,e.$pb=$,e.$qb=y,e.$rb=h;function i(g,m){const w=r(g,m);if(w!==-1)return g[w]}function r(g,m,w=g.length-1){for(let p=w;p>=0;p--){const v=g[p];if(m(v))return p}return-1}function k(g,m){const w=A(g,m);return w===-1?void 0:g[w]}function A(g,m,w=0,p=g.length){let v=w,S=p;for(;v<S;){const o=Math.floor((v+S)/2);m(g[o])?v=o+1:S=o}return v-1}function O(g,m){const w=I(g,m);return w===g.length?void 0:g[w]}function I(g,m,w=0,p=g.length){let v=w,S=p;for(;v<S;){const o=Math.floor((v+S)/2);m(g[o])?S=o:v=o+1}return v}function E(g,m,w=0,p=g.length){const v=I(g,m,w,p);return v===g.length?-1:v}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!m(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const w=A(this.e,m,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$mb=c;function f(g,m){if(g.length===0)return;let w=g[0];for(let p=1;p<g.length;p++){const v=g[p];m(v,w)>0&&(w=v)}return w}function d(g,m){if(g.length===0)return;let w=g[0];for(let p=1;p<g.length;p++){const v=g[p];m(v,w)>=0&&(w=v)}return w}function $(g,m){return f(g,(w,p)=>-m(w,p))}function y(g,m){if(g.length===0)return-1;let w=0;for(let p=1;p<g.length;p++){const v=g[p];m(v,g[w])>0&&(w=p)}return w}function h(g,m){for(const w of g){const p=m(w);if(p!==void 0)return p}}}),define(ce[39],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(ce[139],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=r,e.$M=k,e.$N=A;function i(O,I){const E=Object.create(null);for(const c of O){const f=I(c);let d=E[f];d||(d=E[f]=[]),d.push(c)}return E}function r(O,I){const E=[],c=[];for(const f of O)I.has(f)||E.push(f);for(const f of I)O.has(f)||c.push(f);return{removed:E,added:c}}function k(O,I){const E=[],c=[];for(const[f,d]of O)I.has(f)||E.push(d);for(const[f,d]of I)O.has(f)||c.push(d);return{removed:E,added:c}}function A(O,I){const E=new Set;for(const c of I)O.has(c)&&E.add(c);return E}}),define(ce[140],le([0,1,39]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=e.$4s=void 0;function r(E,c){const f=Math.pow(10,c);return Math.round(E*f)/f}class k{constructor(c,f,d,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=r(Math.max(Math.min(1,$),0),3)}static equals(c,f){return c.r===f.r&&c.g===f.g&&c.b===f.b&&c.a===f.a}}e.$4s=k;class A{constructor(c,f,d,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,f),0),3),this.l=r(Math.max(Math.min(1,d),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.l===f.l&&c.a===f.a}static fromRGBA(c){const f=c.r/255,d=c.g/255,$=c.b/255,y=c.a,h=Math.max(f,d,$),g=Math.min(f,d,$);let m=0,w=0;const p=(g+h)/2,v=h-g;if(v>0){switch(w=Math.min(p<=.5?v/(2*p):v/(2-2*p),1),h){case f:m=(d-$)/v+(d<$?6:0);break;case d:m=($-f)/v+2;break;case $:m=(f-d)/v+4;break}m*=60,m=Math.round(m)}return new A(m,w,p,y)}static i(c,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?c+(f-c)*6*d:d<1/2?f:d<2/3?c+(f-c)*(2/3-d)*6:c}static toRGBA(c){const f=c.h/360,{s:d,l:$,a:y}=c;let h,g,m;if(d===0)h=g=m=$;else{const w=$<.5?$*(1+d):$+d-$*d,p=2*$-w;h=A.i(p,w,f+1/3),g=A.i(p,w,f),m=A.i(p,w,f-1/3)}return new k(Math.round(h*255),Math.round(g*255),Math.round(m*255),y)}}e.$5s=A;class O{constructor(c,f,d,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,f),0),3),this.v=r(Math.max(Math.min(1,d),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.v===f.v&&c.a===f.a}static fromRGBA(c){const f=c.r/255,d=c.g/255,$=c.b/255,y=Math.max(f,d,$),h=Math.min(f,d,$),g=y-h,m=y===0?0:g/y;let w;return g===0?w=0:y===f?w=((d-$)/g%6+6)%6:y===d?w=($-f)/g+2:w=(f-d)/g+4,new O(Math.round(w*60),m,y,c.a)}static toRGBA(c){const{h:f,s:d,v:$,a:y}=c,h=$*d,g=h*(1-Math.abs(f/60%2-1)),m=$-h;let[w,p,v]=[0,0,0];return f<60?(w=h,p=g):f<120?(w=g,p=h):f<180?(p=h,v=g):f<240?(p=g,v=h):f<300?(w=g,v=h):f<=360&&(w=h,v=g),w=Math.round((w+m)*255),p=Math.round((p+m)*255),v=Math.round((v+m)*255),new k(w,p,v,y)}}e.$6s=O;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,f){return!c&&!f?!0:!c||!f?!1:c.equals(f)}get hsla(){return this.i?this.i:A.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof k)this.rgba=c;else if(c instanceof A)this.i=c,this.rgba=A.toRGBA(c);else if(c instanceof O)this.j=c,this.rgba=O.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&k.equals(this.rgba,c.rgba)&&A.equals(this.hsla,c.hsla)&&O.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),f=I.k(this.rgba.g),d=I.k(this.rgba.b),$=.2126*c+.7152*f+.0722*d;return r($,4)}static k(c){const f=c/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f>d}isDarkerThan(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f<d}lighten(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:f,g:d,b:$,a:y}=this.rgba;return new I(new k(f,d,$,y*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const f=c.rgba,d=this.rgba.a,$=f.a,y=d+$*(1-d);if(y<1e-6)return I.transparent;const h=this.rgba.r*d/y+f.r*$*(1-d)/y,g=this.rgba.g*d/y+f.g*$*(1-d)/y,m=this.rgba.b*d/y+f.b*$*(1-d)/y;return new I(new k(h,g,m,y))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:f,g:d,b:$,a:y}=this.rgba;return new I(new k(c.rgba.r-y*(c.rgba.r-f),c.rgba.g-y*(c.rgba.g-d),c.rgba.b-y*(c.rgba.b-$),1))}flatten(...c){const f=c.reduceRight((d,$)=>I.o($,d));return I.o(this,f)}static o(c,f){const d=1-c.rgba.a;return new I(new k(d*f.rgba.r+c.rgba.a*c.rgba.r,d*f.rgba.g+c.rgba.a*c.rgba.g,d*f.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,f,d){if(c.isLighterThan(f))return c;d=d||.5;const $=c.getRelativeLuminance(),y=f.getRelativeLuminance();return d=d*(y-$)/y,c.lighten(d)}static getDarkerColor(c,f,d){if(c.isDarkerThan(f))return c;d=d||.5;const $=c.getRelativeLuminance(),y=f.getRelativeLuminance();return d=d*($-y)/$,c.darken(d)}static{this.white=new I(new k(255,255,255,1))}static{this.black=new I(new k(0,0,0,1))}static{this.red=new I(new k(255,0,0,1))}static{this.blue=new I(new k(0,0,255,1))}static{this.green=new I(new k(0,255,0,1))}static{this.cyan=new I(new k(0,255,255,1))}static{this.lightgrey=new I(new k(211,211,211,1))}static{this.transparent=new I(new k(0,0,0,0))}}e.$7s=I,function(E){let c;(function(f){let d;(function($){function y(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:E.Format.CSS.formatRGBA(s)}$.formatRGB=y;function h(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}$.formatRGBA=h;function g(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(s)}$.formatHSL=g;function m(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}$.formatHSLA=m;function w(s){const a=s.toString(16);return a.length!==2?"0"+a:a}function p(s){return`#${w(s.rgba.r)}${w(s.rgba.g)}${w(s.rgba.b)}`}$.formatHex=p;function v(s,a=!1){return a&&s.rgba.a===1?E.Format.CSS.formatHex(s):`#${w(s.rgba.r)}${w(s.rgba.g)}${w(s.rgba.b)}${w(Math.round(s.rgba.a*255))}`}$.formatHexA=v;function S(s){return s.isOpaque()?E.Format.CSS.formatHex(s):E.Format.CSS.formatRGBA(s)}$.format=S;function o(s){const a=s.length;if(a===0||s.charCodeAt(0)!==i.CharCode.Hash)return null;if(a===7){const n=16*t(s.charCodeAt(1))+t(s.charCodeAt(2)),l=16*t(s.charCodeAt(3))+t(s.charCodeAt(4)),u=16*t(s.charCodeAt(5))+t(s.charCodeAt(6));return new E(new k(n,l,u,1))}if(a===9){const n=16*t(s.charCodeAt(1))+t(s.charCodeAt(2)),l=16*t(s.charCodeAt(3))+t(s.charCodeAt(4)),u=16*t(s.charCodeAt(5))+t(s.charCodeAt(6)),b=16*t(s.charCodeAt(7))+t(s.charCodeAt(8));return new E(new k(n,l,u,b/255))}if(a===4){const n=t(s.charCodeAt(1)),l=t(s.charCodeAt(2)),u=t(s.charCodeAt(3));return new E(new k(16*n+n,16*l+l,16*u+u))}if(a===5){const n=t(s.charCodeAt(1)),l=t(s.charCodeAt(2)),u=t(s.charCodeAt(3)),b=t(s.charCodeAt(4));return new E(new k(16*n+n,16*l+l,16*u+u,(16*b+b)/255))}return null}$.parseHex=o;function t(s){switch(s){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(c=E.Format||(E.Format={}))}(I||(e.$7s=I={}))}),define(ce[53],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=r,e.$6h=k,e.$7h=A;function i(O){return(I,E,c)=>{let f=null,d=null;if(typeof c.value=="function"?(f="value",d=c.value):typeof c.get=="function"&&(f="get",d=c.get),!d)throw new Error("not supported");c[f]=O(d,E)}}function r(O,I,E){let c=null,f=null;if(typeof E.value=="function"?(c="value",f=E.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(c="get",f=E.get),!f)throw new Error("not supported");const d=`$memoize$${I}`;E[c]=function(...$){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,$)}),this[d]}}function k(O,I,E){return i((c,f)=>{const d=`$debounce$${f}`,$=`$debounce$result$${f}`;return function(...y){this[$]||(this[$]=E?E():void 0),clearTimeout(this[d]),I&&(this[$]=I(this[$],...y),y=[this[$]]),this[d]=setTimeout(()=>{c.apply(this,y),this[$]=E?E():void 0},O)}})}function A(O,I,E){return i((c,f)=>{const d=`$throttle$timer$${f}`,$=`$throttle$result$${f}`,y=`$throttle$lastRun$${f}`,h=`$throttle$pending$${f}`;return function(...g){if(this[$]||(this[$]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),I&&(this[$]=I(this[$],...g)),this[h])return;const m=this[y]+O;m<=Date.now()?(this[y]=Date.now(),c.apply(this,[this[$]]),this[$]=E?E():void 0):(this[h]=!0,this[d]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),c.apply(this,[this[$]]),this[$]=E?E():void 0},m-Date.now()))}})}}),define(ce[16],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=r,e.$Z=k,e.$1=A,e.$2=O,e.$3=I,e.$4=c,e.$6=d,e.$7=$,e.$8=y,e.$0=g;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?v.isErrorNoTelemetry(t)?new v(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=i,e.$X=new i;function r(o){e.$X.setUnexpectedErrorHandler(o)}function k(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(o){c(o)||e.$X.onUnexpectedError(o)}function O(o){c(o)||e.$X.onUnexpectedExternalError(o)}function I(o){if(o instanceof Error){const{name:t,message:s}=o,a=o.stacktrace||o.stack;return{$isError:!0,name:t,message:s,stack:a,noTelemetry:v.isErrorNoTelemetry(o)}}return o}const E="Canceled";function c(o){return o instanceof f?!0:o instanceof Error&&o.name===E&&o.message===E}class f extends Error{constructor(){super(E),this.name=this.message}}e.$5=f;function d(){const o=new Error(E);return o.name=o.message,o}function $(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class h extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=h;function g(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class w extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=w;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class v extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof v)return t;const s=new v;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=v;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$cb=S}),define(ce[22],le([0,1,16,138]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=k,e.$tb=A,e.$ub=O,e.$vb=I,e.$wb=E,e.$xb=c,e.$yb=f,e.$zb=d,e.$Ab=$,e.$Bb=y,e.$Cb=h,e.$Db=g,e.$Eb=m,e.top=w,e.$Gb=p,e.$Hb=S,e.$Ib=o,e.$Jb=t,e.$Kb=s,e.$Lb=a,e.$Mb=n,e.$Nb=l,e.$Ob=u,e.$Pb=b,e.$Qb=P,e.$Rb=R,e.$Sb=D,e.$Tb=T,e.$Ub=j,e.$Vb=F,e.$Wb=W,e.$Xb=C,e.$Yb=z,e.$Zb=se,e.$1b=ie,e.$2b=oe,e.$3b=K,e.$4b=te,e.$5b=q,e.$6b=V,e.$7b=ae,e.$0b=ne;function k(N,H=0){return N[N.length-(1+H)]}function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function O(N,H,Q=(J,x)=>J===x){if(N===H)return!0;if(!N||!H||N.length!==H.length)return!1;for(let J=0,x=N.length;J<x;J++)if(!Q(N[J],H[J]))return!1;return!0}function I(N,H){const Q=N.length-1;H<Q&&(N[H]=N[Q]),N.pop()}function E(N,H,Q){return c(N.length,J=>Q(N[J],H))}function c(N,H){let Q=0,J=N-1;for(;Q<=J;){const x=(Q+J)/2|0,ee=H(x);if(ee<0)Q=x+1;else if(ee>0)J=x-1;else return x}return-(Q+1)}function f(N,H,Q){if(N=N|0,N>=H.length)throw new TypeError("invalid index");const J=H[Math.floor(H.length*Math.random())],x=[],ee=[],de=[];for(const me of H){const pe=Q(me,J);pe<0?x.push(me):pe>0?ee.push(me):de.push(me)}return N<x.length?f(N,x,Q):N<x.length+de.length?de[0]:f(N-(x.length+de.length),ee,Q)}function d(N,H){const Q=[];let J;for(const x of N.slice(0).sort(H))!J||H(J[0],x)!==0?(J=[x],Q.push(J)):J.push(x);return Q}function*$(N,H){let Q,J;for(const x of N)J!==void 0&&H(J,x)?Q.push(x):(Q&&(yield Q),Q=[x]),J=x;Q&&(yield Q)}function y(N,H){for(let Q=0;Q<=N.length;Q++)H(Q===0?void 0:N[Q-1],Q===N.length?void 0:N[Q])}function h(N,H){for(let Q=0;Q<N.length;Q++)H(Q===0?void 0:N[Q-1],N[Q],Q+1===N.length?void 0:N[Q+1])}function g(N,H,Q){const J=[];function x(me,pe,Ie){if(pe===0&&Ie.length===0)return;const ke=J[J.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=pe,ke.toInsert.push(...Ie)):J.push({start:me,deleteCount:pe,toInsert:Ie})}let ee=0,de=0;for(;;){if(ee===N.length){x(ee,0,H.slice(de));break}if(de===H.length){x(ee,N.length-ee,[]);break}const me=N[ee],pe=H[de],Ie=Q(me,pe);Ie===0?(ee+=1,de+=1):Ie<0?(x(ee,1,[]),ee+=1):Ie>0&&(x(ee,0,[pe]),de+=1)}return J}function m(N,H,Q){const J=g(N,H,Q),x=[],ee=[];for(const de of J)x.push(...N.slice(de.start,de.start+de.deleteCount)),ee.push(...de.toInsert);return{removed:x,added:ee}}function w(N,H,Q){if(Q===0)return[];const J=N.slice(0,Q).sort(H);return v(N,H,J,Q,N.length),J}function p(N,H,Q,J,x){return Q===0?Promise.resolve([]):new Promise((ee,de)=>{(async()=>{const me=N.length,pe=N.slice(0,Q).sort(H);for(let Ie=Q,ke=Math.min(Q+J,me);Ie<me;Ie=ke,ke=Math.min(ke+J,me)){if(Ie>Q&&await new Promise(Pe=>setTimeout(Pe)),x&&x.isCancellationRequested)throw new i.$5;v(N,H,pe,Ie,ke)}return pe})().then(ee,de)})}function v(N,H,Q,J,x){for(const ee=Q.length;J<x;J++){const de=N[J];if(H(de,Q[ee-1])<0){Q.pop();const me=(0,r.$kb)(Q,pe=>H(de,pe)<0);Q.splice(me,0,de)}}}function S(N){return N.filter(H=>!!H)}function o(N){let H=0;for(let Q=0;Q<N.length;Q++)N[Q]&&(N[H]=N[Q],H+=1);N.length=H}function t(N,H,Q){N.splice(Q,0,N.splice(H,1)[0])}function s(N){return!Array.isArray(N)||N.length===0}function a(N){return Array.isArray(N)&&N.length>0}function n(N,H=Q=>Q){const Q=new Set;return N.filter(J=>{const x=H(J);return Q.has(x)?!1:(Q.add(x),!0)})}function l(N){const H=new Set;return Q=>{const J=N(Q);return H.has(J)?!1:(H.add(J),!0)}}function u(N,H){return N.length>0?N[0]:H}function b(N,H){return N.length>0?N[N.length-1]:H}function P(N,H,Q=(J,x)=>J===x){let J=0;for(let x=0,ee=Math.min(N.length,H.length);x<ee&&Q(N[x],H[x]);x++)J++;return J}function R(N,H){let Q=typeof H=="number"?N:0;typeof H=="number"?Q=N:(Q=0,H=N);const J=[];if(Q<=H)for(let x=Q;x<H;x++)J.push(x);else for(let x=Q;x>H;x--)J.push(x);return J}function D(N,H,Q){return N.reduce((J,x)=>(J[H(x)]=Q?Q(x):x,J),Object.create(null))}function T(N,H){return N.push(H),()=>j(N,H)}function j(N,H){const Q=N.indexOf(H);if(Q>-1)return N.splice(Q,1),H}function F(N,H,Q){const J=N.slice(0,H),x=N.slice(H);return J.concat(Q,x)}function W(N,H){let Q;if(typeof H=="number"){let J=H;Q=()=>{const x=Math.sin(J++)*179426549;return x-Math.floor(x)}}else Q=Math.random;for(let J=N.length-1;J>0;J-=1){const x=Math.floor(Q()*(J+1)),ee=N[J];N[J]=N[x],N[x]=ee}}function C(N,H){const Q=N.indexOf(H);Q>-1&&(N.splice(Q,1),N.unshift(H))}function z(N,H){const Q=N.indexOf(H);Q>-1&&(N.splice(Q,1),N.push(H))}function se(N,H){for(const Q of H)N.push(Q)}function ie(N,H){return Array.isArray(N)?N.map(H):H(N)}function oe(N){return Array.isArray(N)?N:[N]}function K(N){return N[Math.floor(Math.random()*N.length)]}function te(N,H,Q){const J=L(N,H),x=N.length,ee=Q.length;N.length=x+ee;for(let de=x-1;de>=J;de--)N[de+ee]=N[de];for(let de=0;de<ee;de++)N[de+J]=Q[de]}function q(N,H,Q,J){const x=L(N,H);let ee=N.splice(x,Q);return ee===void 0&&(ee=[]),te(N,x,J),ee}function L(N,H){return H<0?Math.max(H+N.length,0):Math.min(H,N.length)}var B;(function(N){function H(ee){return ee<0}N.isLessThan=H;function Q(ee){return ee<=0}N.isLessThanOrEqual=Q;function J(ee){return ee>0}N.isGreaterThan=J;function x(ee){return ee===0}N.isNeitherLessOrGreaterThan=x,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function V(N,H){return(Q,J)=>H(N(Q),N(J))}function ae(...N){return(H,Q)=>{for(const J of N){const x=J(H,Q);if(!B.isNeitherLessOrGreaterThan(x))return x}return B.neitherLessOrGreaterThan}}const G=(N,H)=>N-H;e.$8b=G;const he=(N,H)=>(0,e.$8b)(N?1:0,H?1:0);e.$9b=he;function ne(N){return(H,Q)=>-N(H,Q)}class Z{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let Q=this.c;for(;Q<this.g.length&&H(this.g[Q]);)Q++;const J=Q===this.c?null:this.g.slice(this.c,Q);return this.c=Q,J}takeFromEndWhile(H){let Q=this.d;for(;Q>=0&&H(this.g[Q]);)Q--;const J=Q===this.d?null:this.g.slice(Q+1,this.d+1);return this.d=Q,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const Q=this.g.slice(this.c,this.c+H);return this.c+=H,Q}}e.$$b=Z;class U{static{this.empty=new U(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(Q=>(H(Q),!0))}toArray(){const H=[];return this.iterate(Q=>(H.push(Q),!0)),H}filter(H){return new U(Q=>this.iterate(J=>H(J)?Q(J):!0))}map(H){return new U(Q=>this.iterate(J=>Q(H(J))))}some(H){let Q=!1;return this.iterate(J=>(Q=H(J),!Q)),Q}findFirst(H){let Q;return this.iterate(J=>H(J)?(Q=J,!1):!0),Q}findLast(H){let Q;return this.iterate(J=>(H(J)&&(Q=J),!0)),Q}findLastMaxBy(H){let Q,J=!0;return this.iterate(x=>((J||B.isGreaterThan(H(x,Q)))&&(J=!1,Q=x),!0)),Q}}e.$_b=U;class M{constructor(H){this.c=H}static createSortPermutation(H,Q){const J=Array.from(H.keys()).sort((x,ee)=>Q(H[x],H[ee]));return new M(J)}apply(H){return H.map((Q,J)=>H[this.c[J]])}inverse(){const H=this.c.slice();for(let Q=0;Q<this.c.length;Q++)H[this.c[Q]]=Q;return new M(H)}}e.$ac=M}),define(ce[141],le([0,1,16]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$ed=k,e.$fd=A,e.$gd=O,e.$hd=I,e.$id=E;function r(c,f){if(!c)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function k(c,f="Unreachable"){throw new Error(f)}function A(c,f="unexpected state"){if(!c)throw new i.$cb(`Assertion Failed: ${f}`)}function O(c){c||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function E(c,f){let d=0;for(;d<c.length-1;){const $=c[d],y=c[d+1];if(!f($,y))return!1;d++}return!0}}),define(ce[89],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=i;function i(r,k){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,k)try{I=r.apply(A,arguments)}finally{k()}else I=r.apply(A,arguments);return I}}}),define(ce[75],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(r){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=k;const A=Object.freeze([]);function O(){return A}r.empty=O;function*I(t){yield t}r.single=I;function E(t){return k(t)?t:I(t)}r.wrap=E;function c(t){return t||A}r.from=c;function*f(t){for(let s=t.length-1;s>=0;s--)yield t[s]}r.reverse=f;function d(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=d;function $(t){return t[Symbol.iterator]().next().value}r.first=$;function y(t,s){for(const a of t)if(s(a))return!0;return!1}r.some=y;function h(t,s){for(const a of t)if(s(a))return a}r.find=h;function*g(t,s){for(const a of t)s(a)&&(yield a)}r.filter=g;function*m(t,s){let a=0;for(const n of t)yield s(n,a++)}r.map=m;function*w(...t){for(const s of t)yield*s}r.concat=w;function p(t,s,a){let n=a;for(const l of t)n=s(n,l);return n}r.reduce=p;function*v(t,s,a=t.length){for(s<0&&(s+=t.length),a<0?a+=t.length:a>t.length&&(a=t.length);s<a;s++)yield t[s]}r.slice=v;function S(t,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,t];const n=t[Symbol.iterator]();for(let l=0;l<s;l++){const u=n.next();if(u.done)return[a,r.empty()];a.push(u.value)}return[a,{[Symbol.iterator](){return n}}]}r.consume=S;async function o(t){const s=[];for await(const a of t)s.push(a);return Promise.resolve(s)}r.asyncToArray=o})(i||(e.Iterable=i={}))}),define(ce[40],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=O,e.$On=d,e.$Pn=$,e.$Qn=y,e.$Rn=h,e.$Sn=g,e.$Tn=m,e.$Un=w,e.$Vn=p,e.$Wn=v,e.$Xn=S,e.$Yn=o;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,s=!1){let a=0;const n=t.length;let l="",u=0,b=r.Unknown,P=i.None;function R(z){let se=0,ie=0;for(;se<z;){const oe=t.charCodeAt(a);if(oe>=f._0&&oe<=f._9)ie=ie*16+oe-f._0;else if(oe>=f.A&&oe<=f.F)ie=ie*16+oe-f.A+10;else if(oe>=f.a&&oe<=f.f)ie=ie*16+oe-f.a+10;else break;a++,se++}return se<z&&(ie=-1),ie}function D(z){a=z,l="",u=0,b=r.Unknown,P=i.None}function T(){const z=a;if(t.charCodeAt(a)===f._0)a++;else for(a++;a<t.length&&c(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===f.dot)if(a++,a<t.length&&c(t.charCodeAt(a)))for(a++;a<t.length&&c(t.charCodeAt(a));)a++;else return P=i.UnexpectedEndOfNumber,t.substring(z,a);let se=a;if(a<t.length&&(t.charCodeAt(a)===f.E||t.charCodeAt(a)===f.e))if(a++,(a<t.length&&t.charCodeAt(a)===f.plus||t.charCodeAt(a)===f.minus)&&a++,a<t.length&&c(t.charCodeAt(a))){for(a++;a<t.length&&c(t.charCodeAt(a));)a++;se=a}else P=i.UnexpectedEndOfNumber;return t.substring(z,se)}function j(){let z="",se=a;for(;;){if(a>=n){z+=t.substring(se,a),P=i.UnexpectedEndOfString;break}const ie=t.charCodeAt(a);if(ie===f.doubleQuote){z+=t.substring(se,a),a++;break}if(ie===f.backslash){if(z+=t.substring(se,a),a++,a>=n){P=i.UnexpectedEndOfString;break}switch(t.charCodeAt(a++)){case f.doubleQuote:z+='"';break;case f.backslash:z+="\\";break;case f.slash:z+="/";break;case f.b:z+="\b";break;case f.f:z+="\f";break;case f.n:z+=`
`;break;case f.r:z+="\r";break;case f.t:z+="	";break;case f.u:{const K=R(4);K>=0?z+=String.fromCharCode(K):P=i.InvalidUnicode;break}default:P=i.InvalidEscapeCharacter}se=a;continue}if(ie>=0&&ie<=31)if(E(ie)){z+=t.substring(se,a),P=i.UnexpectedEndOfString;break}else P=i.InvalidCharacter;a++}return z}function F(){if(l="",P=i.None,u=a,a>=n)return u=n,b=r.EOF;let z=t.charCodeAt(a);if(I(z)){do a++,l+=String.fromCharCode(z),z=t.charCodeAt(a);while(I(z));return b=r.Trivia}if(E(z))return a++,l+=String.fromCharCode(z),z===f.carriageReturn&&t.charCodeAt(a)===f.lineFeed&&(a++,l+=`
`),b=r.LineBreakTrivia;switch(z){case f.openBrace:return a++,b=r.OpenBraceToken;case f.closeBrace:return a++,b=r.CloseBraceToken;case f.openBracket:return a++,b=r.OpenBracketToken;case f.closeBracket:return a++,b=r.CloseBracketToken;case f.colon:return a++,b=r.ColonToken;case f.comma:return a++,b=r.CommaToken;case f.doubleQuote:return a++,l=j(),b=r.StringLiteral;case f.slash:{const se=a-1;if(t.charCodeAt(a+1)===f.slash){for(a+=2;a<n&&!E(t.charCodeAt(a));)a++;return l=t.substring(se,a),b=r.LineCommentTrivia}if(t.charCodeAt(a+1)===f.asterisk){a+=2;const ie=n-1;let oe=!1;for(;a<ie;){if(t.charCodeAt(a)===f.asterisk&&t.charCodeAt(a+1)===f.slash){a+=2,oe=!0;break}a++}return oe||(a++,P=i.UnexpectedEndOfComment),l=t.substring(se,a),b=r.BlockCommentTrivia}return l+=String.fromCharCode(z),a++,b=r.Unknown}case f.minus:if(l+=String.fromCharCode(z),a++,a===n||!c(t.charCodeAt(a)))return b=r.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return l+=T(),b=r.NumericLiteral;default:for(;a<n&&W(z);)a++,z=t.charCodeAt(a);if(u!==a){switch(l=t.substring(u,a),l){case"true":return b=r.TrueKeyword;case"false":return b=r.FalseKeyword;case"null":return b=r.NullKeyword}return b=r.Unknown}return l+=String.fromCharCode(z),a++,b=r.Unknown}}function W(z){if(I(z)||E(z))return!1;switch(z){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function C(){let z;do z=F();while(z>=r.LineCommentTrivia&&z<=r.Trivia);return z}return{setPosition:D,getPosition:()=>a,scan:s?C:F,getToken:()=>b,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>P}}function I(t){return t===f.space||t===f.tab||t===f.verticalTab||t===f.formFeed||t===f.nonBreakingSpace||t===f.ogham||t>=f.enQuad&&t<=f.zeroWidthSpace||t===f.narrowNoBreakSpace||t===f.mathematicalSpace||t===f.ideographicSpace||t===f.byteOrderMark}function E(t){return t===f.lineFeed||t===f.carriageReturn||t===f.lineSeparator||t===f.paragraphSeparator}function c(t){return t>=f._0&&t<=f._9}var f;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(f||(f={}));function d(t,s){const a=[],n=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(R,D,T,j){u.value=R,u.offset=D,u.length=T,u.type=j,u.colonOffset=void 0,l=u}try{v(t,{onObjectBegin:(R,D)=>{if(s<=R)throw n;l=void 0,b=s>R,a.push("")},onObjectProperty:(R,D,T)=>{if(s<D||(P(R,D,T,"property"),a[a.length-1]=R,s<=D+T))throw n},onObjectEnd:(R,D)=>{if(s<=R)throw n;l=void 0,a.pop()},onArrayBegin:(R,D)=>{if(s<=R)throw n;l=void 0,a.push(0)},onArrayEnd:(R,D)=>{if(s<=R)throw n;l=void 0,a.pop()},onLiteralValue:(R,D,T)=>{if(s<D||(P(R,D,T,o(R)),s<=D+T))throw n},onSeparator:(R,D,T)=>{if(s<=D)throw n;if(R===":"&&l&&l.type==="property")l.colonOffset=D,b=!1,l=void 0;else if(R===","){const j=a[a.length-1];typeof j=="number"?a[a.length-1]=j+1:(b=!0,a[a.length-1]=""),l=void 0}}})}catch(R){if(R!==n)throw R}return{path:a,previousNode:l,isAtPropertyKey:b,matches:R=>{let D=0;for(let T=0;D<R.length&&T<a.length;T++)if(R[D]===a[T]||R[D]==="*")D++;else if(R[D]!=="**")return!1;return D===R.length}}}function $(t,s=[],a=A.DEFAULT){let n=null,l=[];const u=[];function b(R){Array.isArray(l)?l.push(R):n!==null&&(l[n]=R)}return v(t,{onObjectBegin:()=>{const R={};b(R),u.push(l),l=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const R=[];b(R),u.push(l),l=R,n=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:b,onError:(R,D,T)=>{s.push({error:R,offset:D,length:T})}},a),l[0]}function y(t,s=[],a=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function u(R){return n.children.push(R),R}v(t,{onObjectBegin:R=>{n=u({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,D,T)=>{n=u({type:"property",offset:D,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:D,length:T,parent:n})},onObjectEnd:(R,D)=>{n.length=R+D-n.offset,n=n.parent,l(R+D)},onArrayBegin:(R,D)=>{n=u({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,D)=>{n.length=R+D-n.offset,n=n.parent,l(R+D)},onLiteralValue:(R,D,T)=>{u({type:o(R),offset:D,length:T,parent:n,value:R}),l(D+T)},onSeparator:(R,D,T)=>{n.type==="property"&&(R===":"?n.colonOffset=D:R===","&&l(D))},onError:(R,D,T)=>{s.push({error:R,offset:D,length:T})}},a);const P=n.children[0];return P&&delete P.parent,P}function h(t,s){if(!t)return;let a=t;for(const n of s)if(typeof n=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===n){a=u.children[1],l=!0;break}if(!l)return}else{const l=n;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}function g(t){if(!t.parent||!t.parent.children)return[];const s=g(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;s.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&s.push(a)}return s}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const s=Object.create(null);for(const a of t.children){const n=a.children[1];n&&(s[a.children[0].value]=m(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function w(t,s,a=!1){return s>=t.offset&&s<t.offset+t.length||a&&s===t.offset+t.length}function p(t,s,a=!1){if(w(t,s,a)){const n=t.children;if(Array.isArray(n))for(let l=0;l<n.length&&n[l].offset<=s;l++){const u=p(n[l],s,a);if(u)return u}return t}}function v(t,s,a=A.DEFAULT){const n=O(t,!1);function l(ae){return ae?()=>ae(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(ae){return ae?G=>ae(G,n.getTokenOffset(),n.getTokenLength()):()=>!0}const b=l(s.onObjectBegin),P=u(s.onObjectProperty),R=l(s.onObjectEnd),D=l(s.onArrayBegin),T=l(s.onArrayEnd),j=u(s.onLiteralValue),F=u(s.onSeparator),W=l(s.onComment),C=u(s.onError),z=a&&a.disallowComments,se=a&&a.allowTrailingComma;function ie(){for(;;){const ae=n.scan();switch(n.getTokenError()){case i.InvalidUnicode:oe(k.InvalidUnicode);break;case i.InvalidEscapeCharacter:oe(k.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:oe(k.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:z||oe(k.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:oe(k.UnexpectedEndOfString);break;case i.InvalidCharacter:oe(k.InvalidCharacter);break}switch(ae){case r.LineCommentTrivia:case r.BlockCommentTrivia:z?oe(k.InvalidCommentToken):W();break;case r.Unknown:oe(k.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return ae}}}function oe(ae,G=[],he=[]){if(C(ae),G.length+he.length>0){let ne=n.getToken();for(;ne!==r.EOF;){if(G.indexOf(ne)!==-1){ie();break}else if(he.indexOf(ne)!==-1)break;ne=ie()}}}function K(ae){const G=n.getTokenValue();return ae?j(G):P(G),ie(),!0}function te(){switch(n.getToken()){case r.NumericLiteral:{let ae=0;try{ae=JSON.parse(n.getTokenValue()),typeof ae!="number"&&(oe(k.InvalidNumberFormat),ae=0)}catch{oe(k.InvalidNumberFormat)}j(ae);break}case r.NullKeyword:j(null);break;case r.TrueKeyword:j(!0);break;case r.FalseKeyword:j(!1);break;default:return!1}return ie(),!0}function q(){return n.getToken()!==r.StringLiteral?(oe(k.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(K(!1),n.getToken()===r.ColonToken?(F(":"),ie(),V()||oe(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):oe(k.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function L(){b(),ie();let ae=!1;for(;n.getToken()!==r.CloseBraceToken&&n.getToken()!==r.EOF;){if(n.getToken()===r.CommaToken){if(ae||oe(k.ValueExpected,[],[]),F(","),ie(),n.getToken()===r.CloseBraceToken&&se)break}else ae&&oe(k.CommaExpected,[],[]);q()||oe(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),ae=!0}return R(),n.getToken()!==r.CloseBraceToken?oe(k.CloseBraceExpected,[r.CloseBraceToken],[]):ie(),!0}function B(){D(),ie();let ae=!1;for(;n.getToken()!==r.CloseBracketToken&&n.getToken()!==r.EOF;){if(n.getToken()===r.CommaToken){if(ae||oe(k.ValueExpected,[],[]),F(","),ie(),n.getToken()===r.CloseBracketToken&&se)break}else ae&&oe(k.CommaExpected,[],[]);V()||oe(k.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),ae=!0}return T(),n.getToken()!==r.CloseBracketToken?oe(k.CloseBracketExpected,[r.CloseBracketToken],[]):ie(),!0}function V(){switch(n.getToken()){case r.OpenBracketToken:return B();case r.OpenBraceToken:return L();case r.StringLiteral:return K(!0);default:return te()}}return ie(),n.getToken()===r.EOF?a.allowEmptyContent?!0:(oe(k.ValueExpected,[],[]),!1):V()?(n.getToken()!==r.EOF&&oe(k.EndOfFileExpected,[],[]),!0):(oe(k.ValueExpected,[],[]),!1)}function S(t,s){const a=O(t),n=[];let l,u=0,b;do switch(b=a.getPosition(),l=a.scan(),l){case r.LineCommentTrivia:case r.BlockCommentTrivia:case r.EOF:u!==b&&n.push(t.substring(u,b)),s!==void 0&&n.push(a.getTokenValue().replace(/[^\r\n]/g,s)),u=a.getPosition();break}while(l!==r.EOF);return n.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,40]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=r,e.$1n=k,e.$2n=I,e.$3n=E;function r(c,f,d){let $,y,h,g,m;if(f){for(g=f.offset,m=g+f.length,h=g;h>0&&!E(c,h-1);)h--;let b=m;for(;b<c.length&&!E(c,b);)b++;y=c.substring(h,b),$=O(y,d)}else y=c,$=0,h=0,g=0,m=c.length;const w=I(d,c);let p=!1,v=0,S;d.insertSpaces?S=A(" ",d.tabSize||4):S="	";const o=(0,i.$Nn)(y,!1);let t=!1;function s(){return w+A(S,$+v)}function a(){let b=o.scan();for(p=!1;b===i.SyntaxKind.Trivia||b===i.SyntaxKind.LineBreakTrivia;)p=p||b===i.SyntaxKind.LineBreakTrivia,b=o.scan();return t=b===i.SyntaxKind.Unknown||o.getTokenError()!==i.ScanError.None,b}const n=[];function l(b,P,R){!t&&P<m&&R>g&&c.substring(P,R)!==b&&n.push({offset:P,length:R-P,content:b})}let u=a();if(u!==i.SyntaxKind.EOF){const b=o.getTokenOffset()+h,P=A(S,$);l(P,h,b)}for(;u!==i.SyntaxKind.EOF;){let b=o.getTokenOffset()+o.getTokenLength()+h,P=a(),R="";for(;!p&&(P===i.SyntaxKind.LineCommentTrivia||P===i.SyntaxKind.BlockCommentTrivia);){const T=o.getTokenOffset()+h;l(" ",b,T),b=o.getTokenOffset()+o.getTokenLength()+h,R=P===i.SyntaxKind.LineCommentTrivia?s():"",P=a()}if(P===i.SyntaxKind.CloseBraceToken)u!==i.SyntaxKind.OpenBraceToken&&(v--,R=s());else if(P===i.SyntaxKind.CloseBracketToken)u!==i.SyntaxKind.OpenBracketToken&&(v--,R=s());else{switch(u){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:v++,R=s();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:R=s();break;case i.SyntaxKind.BlockCommentTrivia:p?R=s():R=" ";break;case i.SyntaxKind.ColonToken:R=" ";break;case i.SyntaxKind.StringLiteral:if(P===i.SyntaxKind.ColonToken){R="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:P===i.SyntaxKind.LineCommentTrivia||P===i.SyntaxKind.BlockCommentTrivia?R=" ":P!==i.SyntaxKind.CommaToken&&P!==i.SyntaxKind.EOF&&(t=!0);break;case i.SyntaxKind.Unknown:t=!0;break}p&&(P===i.SyntaxKind.LineCommentTrivia||P===i.SyntaxKind.BlockCommentTrivia)&&(R=s())}const D=o.getTokenOffset()+h;l(R,b,D),u=P}return n}function k(c,f){const d=JSON.stringify(c,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?d.replace(/\r\n|\r|\n/g,f.eol):d}function A(c,f){let d="";for(let $=0;$<f;$++)d+=c;return d}function O(c,f){let d=0,$=0;const y=f.tabSize||4;for(;d<c.length;){const h=c.charAt(d);if(h===" ")$++;else if(h==="	")$+=y;else break;d++}return Math.floor($/y)}function I(c,f){for(let d=0;d<f.length;d++){const $=f.charAt(d);if($==="\r")return d+1<f.length&&f.charAt(d+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return c&&c.eol||`
`}function E(c,f){return`\r
`.indexOf(c.charAt(f))!==-1}}),define(ce[108],le([0,1,40,142]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=k,e.$5n=A,e.$6n=O,e.$7n=I,e.$8n=E;function k(c,f,d){return A(c,f,void 0,d)}function A(c,f,d,$,y){const h=f.slice(),g=[],m=(0,i.$Qn)(c,g);let w,p;for(;h.length>0&&(p=h.pop(),w=(0,i.$Rn)(m,h),w===void 0&&d!==void 0);)typeof p=="string"?d={[p]:d}:d=[d];if(w)if(w.type==="object"&&typeof p=="string"&&Array.isArray(w.children)){const v=(0,i.$Rn)(w,[p]);if(v!==void 0)if(d===void 0){if(!v.parent)throw new Error("Malformed AST");const S=w.children.indexOf(v.parent);let o,t=v.parent.offset+v.parent.length;if(S>0){const s=w.children[S-1];o=s.offset+s.length}else o=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return O(c,{offset:o,length:t-o,content:""},$)}else return O(c,{offset:v.offset,length:v.length,content:JSON.stringify(d)},$);else{if(d===void 0)return[];const S=`${JSON.stringify(p)}: ${JSON.stringify(d)}`,o=y?y(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(o>0){const s=w.children[o-1];t={offset:s.offset+s.length,length:0,content:","+S}}else w.children.length===0?t={offset:w.offset+1,length:0,content:S}:t={offset:w.offset+1,length:0,content:S+","};return O(c,t,$)}}else if(w.type==="array"&&typeof p=="number"&&Array.isArray(w.children))if(d!==void 0){const v=`${JSON.stringify(d)}`;let S;if(w.children.length===0||p===0)S={offset:w.offset+1,length:0,content:w.children.length===0?v:v+","};else{const o=p===-1||p>w.children.length?w.children.length:p,t=w.children[o-1];S={offset:t.offset+t.length,length:0,content:","+v}}return O(c,S,$)}else{const v=p,S=w.children[v];let o;if(w.children.length===1)o={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===v){const t=w.children[v-1],s=t.offset+t.length,a=w.offset+w.length;o={offset:s,length:a-2-s,content:""}}else o={offset:S.offset,length:w.children[v+1].offset-S.offset,content:""};return O(c,o,$)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${w.type}`);else return d===void 0?[]:O(c,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(d)},$)}function O(c,f,d){let $=I(c,f),y=f.offset,h=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;y>0&&!(0,r.$3n)($,y-1);)y--;for(;h<$.length&&!(0,r.$3n)($,h);)h++}const g=(0,r.$Zn)($,{offset:y,length:h-y},d);for(let w=g.length-1;w>=0;w--){const p=g[w];$=I($,p),y=Math.min(y,p.offset),h=Math.max(h,p.offset+p.length),h+=p.content.length-p.length}const m=c.length-($.length-h)-y;return[{offset:y,length:m,content:$.substring(y,h)}]}function I(c,f){return c.substring(0,f.offset)+f.content+c.substring(f.offset+f.length)}function E(c,f){const d=f.slice(0).sort((y,h)=>{const g=y.offset-h.offset;return g===0?y.length-h.length:g});let $=c.length;for(let y=d.length-1;y>=0;y--){const h=d[y];if(h.offset+h.length<=$)c=I(c,h);else throw new Error("Overlapping edit");$=h.offset}return c}}),define(ce[65],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(ce[109],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(A){this.element=A,this.next=i.Undefined,this.prev=i.Undefined}}class r{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let A=this.a;for(;A!==i.Undefined;){const O=A.next;A.prev=i.Undefined,A.next=i.Undefined,A=O}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new i(A);if(this.a===i.Undefined)this.a=I,this.b=I;else if(O){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(I))}}shift(){if(this.a!==i.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==i.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==i.Undefined&&A.next!==i.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===i.Undefined&&A.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):A.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):A.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==i.Undefined;)yield A.element,A=A.next}}e.$5c=r}),define(ce[32],le([0,1]),function(X,e){"use strict";var i,r,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=O,e.$zc=I,e.$Ic=S;function A(o,t,s){let a=o.get(t);return a===void 0&&(a=s,o.set(t,a)),a}function O(o){const t=[];return o.forEach((s,a)=>{t.push(`${a} => ${s}`)}),`Map(${o.size}) {${t.join(", ")}}`}function I(o){const t=[];return o.forEach(s=>{t.push(s)}),`Set(${o.size}) {${t.join(", ")}}`}class E{constructor(t,s){this.uri=t,this.value=s}}function c(o){return Array.isArray(o)}class f{static{this.c=t=>t.toString()}constructor(t,s){if(this[i]="ResourceMap",t instanceof f)this.d=new Map(t.d),this.e=s??f.c;else if(c(t)){this.d=new Map,this.e=s??f.c;for(const[a,n]of t)this.set(a,n)}else this.d=new Map,this.e=t??f.c}set(t,s){return this.d.set(this.e(t),new E(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[a,n]of this.d)t(n.value,n.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=f;class d{constructor(t,s){this[r]="ResourceSet",!t||typeof t=="function"?this.c=new f(t):(this.c=new f(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((a,n)=>t.call(s,n,n,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=d;var $;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})($||(e.Touch=$={}));class y{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=$.None){const a=this.c.get(t);if(a)return s!==$.None&&this.m(a,s),a.value}set(t,s,a=$.None){let n=this.c.get(t);if(n)n.value=s,a!==$.None&&this.m(n,a);else{switch(n={key:t,value:s,next:void 0,previous:void 0},a){case $.None:this.k(n);break;case $.AsOld:this.j(n);break;case $.AsNew:this.k(n);break;default:this.k(n);break}this.c.set(t,n),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const a=this.g;let n=this.d;for(;n;){if(s?t.bind(s)(n.value,n.key,this):t(n.value,n.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const t=this,s=this.g;let a=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.key,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return n}values(){const t=this,s=this.g;let a=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.value,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return n}entries(){const t=this,s=this.g;let a=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:[a.key,a.value],done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return n}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,a=this.size;for(;s&&a>t;)this.c.delete(s.key),s=s.next,a--;this.d=s,this.f=a,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,a=this.size;for(;s&&a>t;)this.c.delete(s.key),s=s.previous,a--;this.e=s,this.f=a,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,a=t.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==$.AsOld&&s!==$.AsNew)){if(s===$.AsOld){if(t===this.d)return;const a=t.next,n=t.previous;t===this.e?(n.next=void 0,this.e=n):(a.previous=n,n.next=a),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===$.AsNew){if(t===this.e)return;const a=t.next,n=t.previous;t===this.d?(a.previous=void 0,this.d=a):(a.previous=n,n.next=a),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,a)=>{t.push([a,s])}),t}fromJSON(t){this.clear();for(const[s,a]of t)this.set(s,a)}}e.$Cc=y;class h extends y{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=$.AsNew){return super.get(t,s)}peek(t){return super.get(t,$.None)}set(t,s){return super.set(t,s,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends h{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Dc=g;class m extends h{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Ec=m;class w{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Fc=w;class p{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,a]of t)this.set(s,a)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((a,n)=>{t.call(s,a,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class v{constructor(){this.c=new Map}add(t,s){let a=this.c.get(t);a||(a=new Set,this.c.set(t,a)),a.add(s)}delete(t,s){const a=this.c.get(t);a&&(a.delete(s),a.size===0&&this.c.delete(t))}forEach(t,s){const a=this.c.get(t);a&&a.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Hc=v;function S(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[s,a]of o)if(!t.has(s)||t.get(s)!==a)return!1;for(const[s]of t)if(!o.has(s))return!1;return!0}}),define(ce[2],le([0,1,22,139,32,89,75]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=f,e.$Lc=d,e.$Mc=$,e.$Nc=g,e.$Oc=m,e.$Pc=w,e.$Qc=p,e.$Rc=v,e.$Sc=S,e.$3c=R;const I=!1;let E=null;class c{constructor(){this.b=new Map}static{this.a=0}c(j){let F=this.b.get(j);return F||(F={parent:null,source:null,isSingleton:!1,value:j,idx:c.a++},this.b.set(j,F)),F}trackDisposable(j){const F=this.c(j);F.source||(F.source=new Error().stack)}setParent(j,F){const W=this.c(j);W.parent=F}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,F){const W=F.get(j);if(W)return W;const C=j.parent?this.f(this.c(j.parent),F):j;return F.set(j,C),C}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,j).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(j=10,F){let W;if(F)W=F;else{const oe=new Map,K=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,oe).isSingleton);if(K.length===0)return;const te=new Set(K.map(q=>q.value));if(W=K.filter(q=>!(q.parent&&te.has(q.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function C(oe){function K(q,L){for(;q.length>0&&L.some(B=>typeof B=="string"?B===q[0]:q[0].match(B));)q.shift()}const te=oe.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return K(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const z=new k.$Hc;for(const oe of W){const K=C(oe);for(let te=0;te<=K.length;te++)z.add(K.slice(0,te).join(`
`),oe)}W.sort((0,i.$6b)(oe=>oe.idx,i.$8b));let se="",ie=0;for(const oe of W.slice(0,j)){ie++;const K=C(oe),te=[];for(let q=0;q<K.length;q++){let L=K[q];L=`(shared with ${z.get(K.slice(0,q+1).join(`
`)).size}/${W.length} leaks) at ${L}`;const V=z.get(K.slice(0,q).join(`
`)),ae=(0,r.$K)([...V].map(G=>C(G)[q]),G=>G);delete ae[K[q]];for(const[G,he]of Object.entries(ae))te.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);te.unshift(L)}se+=`


==================== Leaking disposable ${ie}/${W.length}: ${oe.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return W.length>j&&(se+=`


... and ${W.length-j} more leaking disposables

`),{leaks:W,details:se}}}e.$Jc=c;function f(T){E=T}if(I){const T="__is_disposable_tracked__";f(new class{trackDisposable(j){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[T]||console.log(F)},3e3)}setParent(j,F){if(j&&j!==t.None)try{j[T]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[T]=!0}catch{}}markAsSingleton(j){}})}function d(T){return E?.trackDisposable(T),T}function $(T){E?.markAsDisposed(T)}function y(T,j){E?.setParent(T,j)}function h(T,j){if(E)for(const F of T)E.setParent(F,j)}function g(T){return E?.markAsSingleton(T),T}function m(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function w(T){if(O.Iterable.is(T)){const j=[];for(const F of T)if(F)try{F.dispose()}catch(W){j.push(W)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function p(T){for(const j of T)m(j)&&j.dispose();return[]}function v(...T){const j=S(()=>w(T));return h(T,j),j}function S(T){const j=d({dispose:(0,A.$db)(()=>{$(j),T()})});return j}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return y(j,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),y(j,null))}}e.$Tc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,d(this),y(this.q,this)}dispose(){$(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Uc=t;class s{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&y(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&y(j,null),j}}e.$Vc=s;class a{constructor(j){this.a=new s,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=a;class n{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(j){let F=j;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,$(this))},this}}e.$Yc=l;class u{constructor(){this.a=new Map}acquire(j,...F){let W=this.a.get(j);W||(W={counter:0,object:this.b(j,...F)},this.a.set(j,W));const{object:C}=W,z=(0,A.$db)(()=>{--W.counter===0&&(this.c(j,W.object),this.a.delete(j))});return W.counter++,{object:C,dispose:z}}}e.$Zc=u;class b{constructor(j){this.a=j}async acquire(j,...F){const W=this.a.acquire(j,...F);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(C){throw W.dispose(),C}}}e.$1c=b;class P{constructor(j){this.object=j}dispose(){}}e.$2c=P;function R(T){const j=new o;try{T(j)}finally{j.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,F,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(j)?.dispose(),this.a.set(j,F)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}deleteAndLeak(j){const F=this.a.get(j);return this.a.delete(j),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=D}),define(ce[90],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(ce[76],le([0,1,32]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0,e.$gm=k,e.$hm=O;const r=new i.$Dc(1e4);function k(c){return E(c,"NFC",r)}const A=new i.$Dc(1e4);function O(c){return E(c,"NFD",A)}const I=/[^\u0000-\u0080]/;function E(c,f,d){if(!c)return c;const $=d.get(c);if($)return $;let y;return I.test(c)?y=c.normalize(f):y=c,d.set(c,y),y}e.$im=function(){const c=/[\u0300-\u036f]/g;return function(f){return O(f).replace(c,"")}}()}),define(ce[143],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=void 0,e.$Gm=i,e.rot=r;function i(I,E,c){return Math.min(Math.max(I,E),c)}function r(I,E){return(E+I%E)%E}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Im=k;class A{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jm=A;class O{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const c=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Km=O}),function(){function X(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function O(E){A.push(E,Date.now())}function I(){const E=[];for(let c=0;c<A.length;c+=2)E.push({name:A[c],startTime:A[c+1]});return E}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(k+O.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function i(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=i(r))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var r in i)(typeof exports=="object"?exports:X)[r]=i[r]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function i(r){if(e[r])return e[r].exports;var k=e[r]={i:r,l:!1,exports:{}};return X[r].call(k.exports,k,k.exports,i),k.l=!0,k.exports}return i.m=X,i.c=e,i.d=function(r,k,A){i.o(r,k)||Object.defineProperty(r,k,{enumerable:!0,get:A})},i.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},i.t=function(r,k){if(1&k&&(r=i(r)),8&k||4&k&&typeof r=="object"&&r&&r.__esModule)return r;var A=Object.create(null);if(i.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:r}),2&k&&typeof r!="string")for(var O in r)i.d(A,O,function(I){return r[I]}.bind(null,O));return A},i.n=function(r){var k=r&&r.__esModule?function(){return r.default}:function(){return r};return i.d(k,"a",k),k},i.o=function(r,k){return Object.prototype.hasOwnProperty.call(r,k)},i.p="",i(i.s=0)}([function(X,e,i){(function(r){var k;e=X.exports=he,k=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],c=0,f=c++;E[f]="0|[1-9]\\d*";var d=c++;E[d]="[0-9]+";var $=c++;E[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=c++;E[y]="("+E[f]+")\\.("+E[f]+")\\.("+E[f]+")";var h=c++;E[h]="("+E[d]+")\\.("+E[d]+")\\.("+E[d]+")";var g=c++;E[g]="(?:"+E[f]+"|"+E[$]+")";var m=c++;E[m]="(?:"+E[d]+"|"+E[$]+")";var w=c++;E[w]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var p=c++;E[p]="(?:-?("+E[m]+"(?:\\."+E[m]+")*))";var v=c++;E[v]="[0-9A-Za-z-]+";var S=c++;E[S]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var o=c++,t="v?"+E[y]+E[w]+"?"+E[S]+"?";E[o]="^"+t+"$";var s="[v=\\s]*"+E[h]+E[p]+"?"+E[S]+"?",a=c++;E[a]="^"+s+"$";var n=c++;E[n]="((?:<|>)?=?)";var l=c++;E[l]=E[d]+"|x|X|\\*";var u=c++;E[u]=E[f]+"|x|X|\\*";var b=c++;E[b]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[w]+")?"+E[S]+"?)?)?";var P=c++;E[P]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[p]+")?"+E[S]+"?)?)?";var R=c++;E[R]="^"+E[n]+"\\s*"+E[b]+"$";var D=c++;E[D]="^"+E[n]+"\\s*"+E[P]+"$";var T=c++;E[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=c++;E[j]="(?:~>?)";var F=c++;E[F]="(\\s*)"+E[j]+"\\s+",I[F]=new RegExp(E[F],"g");var W=c++;E[W]="^"+E[j]+E[b]+"$";var C=c++;E[C]="^"+E[j]+E[P]+"$";var z=c++;E[z]="(?:\\^)";var se=c++;E[se]="(\\s*)"+E[z]+"\\s+",I[se]=new RegExp(E[se],"g");var ie=c++;E[ie]="^"+E[z]+E[b]+"$";var oe=c++;E[oe]="^"+E[z]+E[P]+"$";var K=c++;E[K]="^"+E[n]+"\\s*("+s+")$|^$";var te=c++;E[te]="^"+E[n]+"\\s*("+t+")$|^$";var q=c++;E[q]="(\\s*)"+E[n]+"\\s*("+s+"|"+E[b]+")",I[q]=new RegExp(E[q],"g");var L=c++;E[L]="^\\s*("+E[b]+")\\s+-\\s+("+E[b]+")\\s*$";var B=c++;E[B]="^\\s*("+E[P]+")\\s+-\\s+("+E[P]+")\\s*$";var V=c++;E[V]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)k(ae,E[ae]),I[ae]||(I[ae]=new RegExp(E[ae]));function G(Y,ue){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>A||!(ue?I[a]:I[o]).test(Y))return null;try{return new he(Y,ue)}catch{return null}}function he(Y,ue){if(Y instanceof he){if(Y.loose===ue)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof he))return new he(Y,ue);k("SemVer",Y,ue),this.loose=ue;var fe=Y.trim().match(ue?I[a]:I[o]);if(!fe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var De=+be;if(De>=0&&De<O)return De}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(Y,ue){var fe=G(Y,ue);return fe?fe.version:null},e.clean=function(Y,ue){var fe=G(Y.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return k("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),Z(this.major,Y.major)||Z(this.minor,Y.minor)||Z(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=Y.prerelease[ue];if(k("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return Z(fe,be)}while(++ue)},he.prototype.inc=function(Y,ue){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(Y,fe).inc(ue,be).version}catch{return null}},e.diff=function(Y,ue){if(H(Y,ue))return null;var fe=G(Y),be=G(ue);if(fe.prerelease.length||be.prerelease.length){for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==be[De])return"pre"+De;return"prerelease"}for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==be[De])return De},e.compareIdentifiers=Z;var ne=/^[0-9]+$/;function Z(Y,ue){var fe=ne.test(Y),be=ne.test(ue);return fe&&be&&(Y=+Y,ue=+ue),fe&&!be?-1:be&&!fe?1:Y<ue?-1:Y>ue?1:0}function U(Y,ue,fe){return new he(Y,fe).compare(new he(ue,fe))}function M(Y,ue,fe){return U(Y,ue,fe)>0}function N(Y,ue,fe){return U(Y,ue,fe)<0}function H(Y,ue,fe){return U(Y,ue,fe)===0}function Q(Y,ue,fe){return U(Y,ue,fe)!==0}function J(Y,ue,fe){return U(Y,ue,fe)>=0}function x(Y,ue,fe){return U(Y,ue,fe)<=0}function ee(Y,ue,fe,be){var De;switch(ue){case"===":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),De=Y===fe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),De=Y!==fe;break;case"":case"=":case"==":De=H(Y,fe,be);break;case"!=":De=Q(Y,fe,be);break;case">":De=M(Y,fe,be);break;case">=":De=J(Y,fe,be);break;case"<":De=N(Y,fe,be);break;case"<=":De=x(Y,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return De}function de(Y,ue){if(Y instanceof de){if(Y.loose===ue)return Y;Y=Y.value}if(!(this instanceof de))return new de(Y,ue);k("comparator",Y,ue),this.loose=ue,this.parse(Y),this.semver===me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Y,ue){return Z(ue,Y)},e.major=function(Y,ue){return new he(Y,ue).major},e.minor=function(Y,ue){return new he(Y,ue).minor},e.patch=function(Y,ue){return new he(Y,ue).patch},e.compare=U,e.compareLoose=function(Y,ue){return U(Y,ue,!0)},e.rcompare=function(Y,ue,fe){return U(ue,Y,fe)},e.sort=function(Y,ue){return Y.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(Y,ue){return Y.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=M,e.lt=N,e.eq=H,e.neq=Q,e.gte=J,e.lte=x,e.cmp=ee,e.Comparator=de;var me={};function pe(Y,ue){if(Y instanceof pe)return Y.loose===ue?Y:new pe(Y.raw,ue);if(Y instanceof de)return new pe(Y.value,ue);if(!(this instanceof pe))return new pe(Y,ue);if(this.loose=ue,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ie(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,ue,fe,be,De,Ne,Ue,Re,Ce,Ve,Qe,ze,Je){return((ue=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(De)?">="+fe+"."+be+".0":">="+ue)+" "+(Re=Ie(Ce)?"":Ie(Ve)?"<"+(+Ce+1)+".0.0":Ie(Qe)?"<"+Ce+"."+(+Ve+1)+".0":ze?"<="+Ce+"."+Ve+"."+Qe+"-"+ze:"<="+Re)).trim()}function Pe(Y,ue){for(var fe=0;fe<Y.length;fe++)if(!Y[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<Y.length;fe++)if(k(Y[fe].semver),Y[fe].semver!==me&&Y[fe].semver.prerelease.length>0){var be=Y[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function Ae(Y,ue,fe){try{ue=new pe(ue,fe)}catch{return!1}return ue.test(Y)}function $e(Y,ue,fe,be){var De,Ne,Ue,Re,Ce;switch(Y=new he(Y,be),ue=new pe(ue,be),fe){case">":De=M,Ne=x,Ue=N,Re=">",Ce=">=";break;case"<":De=N,Ne=J,Ue=M,Re="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(Y,ue,be))return!1;for(var Ve=0;Ve<ue.set.length;++Ve){var Qe=ue.set[Ve],ze=null,Je=null;if(Qe.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),ze=ze||Xe,Je=Je||Xe,De(Xe.semver,ze.semver,be)?ze=Xe:Ue(Xe.semver,Je.semver,be)&&(Je=Xe)}),ze.operator===Re||ze.operator===Ce||(!Je.operator||Je.operator===Re)&&Ne(Y,Je.semver)||Je.operator===Ce&&Ue(Y,Je.semver))return!1}return!0}de.prototype.parse=function(Y){var ue=this.loose?I[K]:I[te],fe=Y.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+Y);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(Y){return k("Comparator.test",Y,this.loose),this.semver===me||(typeof Y=="string"&&(Y=new he(Y,this.loose)),ee(Y,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Y,ue){if(!(Y instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new pe(Y.value,ue),Ae(this.value,fe,ue);if(Y.operator==="")return fe=new pe(this.value,ue),Ae(Y.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ne=this.semver.version===Y.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Re=ee(this.semver,"<",Y.semver,ue)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ce=ee(this.semver,">",Y.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return be||De||Ne&&Ue||Re||Ce},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(Y){var ue=this.loose;Y=Y.trim(),k("range",Y,ue);var fe=ue?I[B]:I[L];Y=Y.replace(fe,ke),k("hyphen replace",Y),Y=Y.replace(I[q],"$1$2$3"),k("comparator trim",Y,I[q]),Y=(Y=(Y=Y.replace(I[F],"$1~")).replace(I[se],"$1^")).split(/\s+/).join(" ");var be=ue?I[K]:I[te],De=Y.split(" ").map(function(Ne){return function(Ue,Re){return k("comp",Ue),Ue=function(Ce,Ve){return Ce.trim().split(/\s+/).map(function(Qe){return function(ze,Je){k("caret",ze,Je);var Xe=Je?I[oe]:I[ie];return ze.replace(Xe,function(Ke,Fe,_,ge,we){var ye;return k("caret",ze,Ke,Fe,_,ge,we),Ie(Fe)?ye="":Ie(_)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ie(ge)?ye=Fe==="0"?">="+Fe+"."+_+".0 <"+Fe+"."+(+_+1)+".0":">="+Fe+"."+_+".0 <"+(+Fe+1)+".0.0":we?(k("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=Fe==="0"?_==="0"?">="+Fe+"."+_+"."+ge+we+" <"+Fe+"."+_+"."+(+ge+1):">="+Fe+"."+_+"."+ge+we+" <"+Fe+"."+(+_+1)+".0":">="+Fe+"."+_+"."+ge+we+" <"+(+Fe+1)+".0.0"):(k("no pr"),ye=Fe==="0"?_==="0"?">="+Fe+"."+_+"."+ge+" <"+Fe+"."+_+"."+(+ge+1):">="+Fe+"."+_+"."+ge+" <"+Fe+"."+(+_+1)+".0":">="+Fe+"."+_+"."+ge+" <"+(+Fe+1)+".0.0"),k("caret return",ye),ye})}(Qe,Ve)}).join(" ")}(Ue,Re),k("caret",Ue),Ue=function(Ce,Ve){return Ce.trim().split(/\s+/).map(function(Qe){return function(ze,Je){var Xe=Je?I[C]:I[W];return ze.replace(Xe,function(Ke,Fe,_,ge,we){var ye;return k("tilde",ze,Ke,Fe,_,ge,we),Ie(Fe)?ye="":Ie(_)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ie(ge)?ye=">="+Fe+"."+_+".0 <"+Fe+"."+(+_+1)+".0":we?(k("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=">="+Fe+"."+_+"."+ge+we+" <"+Fe+"."+(+_+1)+".0"):ye=">="+Fe+"."+_+"."+ge+" <"+Fe+"."+(+_+1)+".0",k("tilde return",ye),ye})}(Qe,Ve)}).join(" ")}(Ue,Re),k("tildes",Ue),Ue=function(Ce,Ve){return k("replaceXRanges",Ce,Ve),Ce.split(/\s+/).map(function(Qe){return function(ze,Je){ze=ze.trim();var Xe=Je?I[D]:I[R];return ze.replace(Xe,function(Ke,Fe,_,ge,we,ye){k("xRange",ze,Ke,Fe,_,ge,we,ye);var Le=Ie(_),We=Le||Ie(ge),Ye=We||Ie(we);return Fe==="="&&Ye&&(Fe=""),Le?Ke=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&Ye?(We&&(ge=0),Ye&&(we=0),Fe===">"?(Fe=">=",We?(_=+_+1,ge=0,we=0):Ye&&(ge=+ge+1,we=0)):Fe==="<="&&(Fe="<",We?_=+_+1:ge=+ge+1),Ke=Fe+_+"."+ge+"."+we):We?Ke=">="+_+".0.0 <"+(+_+1)+".0.0":Ye&&(Ke=">="+_+"."+ge+".0 <"+_+"."+(+ge+1)+".0"),k("xRange return",Ke),Ke})}(Qe,Ve)}).join(" ")}(Ue,Re),k("xrange",Ue),Ue=function(Ce,Ve){return k("replaceStars",Ce,Ve),Ce.trim().replace(I[V],"")}(Ue,Re),k("stars",Ue),Ue}(Ne,ue)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(be)})),De=De.map(function(Ne){return new de(Ne,ue)})},pe.prototype.intersects=function(Y,ue){if(!(Y instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return Y.set.some(function(De){return De.every(function(Ne){return be.intersects(Ne,ue)})})})})},e.toComparators=function(Y,ue){return new pe(Y,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],Y))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(Y,ue,fe){var be=null,De=null;try{var Ne=new pe(ue,fe)}catch{return null}return Y.forEach(function(Ue){Ne.test(Ue)&&(be&&De.compare(Ue)!==-1||(De=new he(be=Ue,fe)))}),be},e.minSatisfying=function(Y,ue,fe){var be=null,De=null;try{var Ne=new pe(ue,fe)}catch{return null}return Y.forEach(function(Ue){Ne.test(Ue)&&(be&&De.compare(Ue)!==1||(De=new he(be=Ue,fe)))}),be},e.validRange=function(Y,ue){try{return new pe(Y,ue).range||"*"}catch{return null}},e.ltr=function(Y,ue,fe){return $e(Y,ue,"<",fe)},e.gtr=function(Y,ue,fe){return $e(Y,ue,">",fe)},e.outside=$e,e.prerelease=function(Y,ue){var fe=G(Y,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Y,ue,fe){return Y=new pe(Y,fe),ue=new pe(ue,fe),Y.intersects(ue)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var ue=Y.match(I[T]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,i(1))},function(X,e){var i,r,k=X.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(m){if(i===setTimeout)return setTimeout(m,0);if((i===A||!i)&&setTimeout)return i=setTimeout,setTimeout(m,0);try{return i(m,0)}catch{try{return i.call(null,m,0)}catch{return i.call(this,m,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:A}catch{i=A}try{r=typeof clearTimeout=="function"?clearTimeout:O}catch{r=O}})();var E,c=[],f=!1,d=-1;function $(){f&&E&&(f=!1,E.length?c=E.concat(c):d=-1,c.length&&y())}function y(){if(!f){var m=I($);f=!0;for(var w=c.length;w;){for(E=c,c=[];++d<w;)E&&E[d].run();d=-1,w=c.length}E=null,f=!1,function(p){if(r===clearTimeout)return clearTimeout(p);if((r===O||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(p);try{r(p)}catch{try{return r.call(null,p)}catch{return r.call(this,p)}}}(m)}}function h(m,w){this.fun=m,this.array=w}function g(){}k.nextTick=function(m){var w=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)w[p-1]=arguments[p];c.push(new h(m,w)),c.length!==1||f||I(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=g,k.addListener=g,k.once=g,k.off=g,k.removeListener=g,k.removeAllListeners=g,k.emit=g,k.prependListener=g,k.prependOnceListener=g,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ce[144],le([0,1]),function(X,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class r{constructor(I,E,c){this.level=I,this.key=E,this.value=c,this.forward=[]}}const k=void 0;class A{constructor(I,E=2**16){this.comparator=I,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(E)|0),this.e=new r(this.c,k,k)}get size(){return this.f}clear(){this.e=new r(this.c,k,k),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,E){return A.h(this,I,E,this.comparator)&&(this.f+=1),this}delete(I){const E=A.k(this,I,this.comparator);return E&&(this.f-=1),E}forEach(I,E){let c=this.e.forward[0];for(;c;)I.call(E,c.value,c.key,this),c=c.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",E=this.e.forward[0];for(;E;)I+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return I}static g(I,E,c){let f=I.e;for(let d=I.d-1;d>=0;d--)for(;f.forward[d]&&c(f.forward[d].key,E)<0;)f=f.forward[d];if(f=f.forward[0],f&&c(f.key,E)===0)return f}static h(I,E,c,f){const d=[];let $=I.e;for(let y=I.d-1;y>=0;y--){for(;$.forward[y]&&f($.forward[y].key,E)<0;)$=$.forward[y];d[y]=$}if($=$.forward[0],$&&f($.key,E)===0)return $.value=c,!1;{const y=A.j(I);if(y>I.d){for(let h=I.d;h<y;h++)d[h]=I.e;I.d=y}$=new r(y,E,c);for(let h=0;h<y;h++)$.forward[h]=d[h].forward[h],d[h].forward[h]=$;return!0}}static j(I,E=.5){let c=1;for(;Math.random()<E&&c<I.c;)c+=1;return c}static k(I,E,c){const f=[];let d=I.e;for(let $=I.d-1;$>=0;$--){for(;d.forward[$]&&c(d.forward[$].key,E)<0;)d=d.forward[$];f[$]=d}if(d=d.forward[0],!d||c(d.key,E)!==0)return!1;for(let $=0;$<I.d&&f[$].forward[$]===d;$++)f[$].forward[$]=d.forward[$];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.$Hs=A}),define(ce[77],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(A){return new r(A)}constructor(A){this.c=i&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=r}),define(ce[3],le([0,1,16,89,2,109,77]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=y;const I=!1,E=!1,c=!1;var f;(function(C){C.None=()=>k.$Uc.None;function z(ke){if(c){const{onDidAddListener:Pe}=ke,Ae=g.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),Pe?.()}}}function se(ke,Pe){return G(ke,()=>{},0,void 0,!0,void 0,Pe)}C.defer=se;function ie(ke){return(Pe,Ae=null,$e)=>{let Y=!1,ue;return ue=ke(fe=>{if(!Y)return ue?ue.dispose():Y=!0,Pe.call(Ae,fe)},null,$e),Y&&ue.dispose(),ue}}C.once=ie;function oe(ke,Pe,Ae){return V(($e,Y=null,ue)=>ke(fe=>$e.call(Y,Pe(fe)),null,ue),Ae)}C.map=oe;function K(ke,Pe,Ae){return V(($e,Y=null,ue)=>ke(fe=>{Pe(fe),$e.call(Y,fe)},null,ue),Ae)}C.forEach=K;function te(ke,Pe,Ae){return V(($e,Y=null,ue)=>ke(fe=>Pe(fe)&&$e.call(Y,fe),null,ue),Ae)}C.filter=te;function q(ke){return ke}C.signal=q;function L(...ke){return(Pe,Ae=null,$e)=>{const Y=(0,k.$Rc)(...ke.map(ue=>ue(fe=>Pe.call(Ae,fe))));return ae(Y,$e)}}C.any=L;function B(ke,Pe,Ae,$e){let Y=Ae;return oe(ke,ue=>(Y=Pe(Y,ue),Y),$e)}C.reduce=B;function V(ke,Pe){let Ae;const $e={onWillAddFirstListener(){Ae=ke(Y.fire,Y)},onDidRemoveLastListener(){Ae?.dispose()}};Pe||z($e);const Y=new s($e);return Pe?.add(Y),Y.event}function ae(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function G(ke,Pe,Ae=100,$e=!1,Y=!1,ue,fe){let be,De,Ne,Ue=0,Re;const Ce={leakWarningThreshold:ue,onWillAddFirstListener(){be=ke(Qe=>{Ue++,De=Pe(De,Qe),$e&&!Ne&&(Ve.fire(De),De=void 0),Re=()=>{const ze=De;De=void 0,Ne=void 0,(!$e||Ue>1)&&Ve.fire(ze),Ue=0},typeof Ae=="number"?(clearTimeout(Ne),Ne=setTimeout(Re,Ae)):Ne===void 0&&(Ne=0,queueMicrotask(Re))})},onWillRemoveListener(){Y&&Ue>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,be.dispose()}};fe||z(Ce);const Ve=new s(Ce);return fe?.add(Ve),Ve.event}C.debounce=G;function he(ke,Pe=0,Ae){return C.debounce(ke,($e,Y)=>$e?($e.push(Y),$e):[Y],Pe,void 0,!0,void 0,Ae)}C.accumulate=he;function ne(ke,Pe=($e,Y)=>$e===Y,Ae){let $e=!0,Y;return te(ke,ue=>{const fe=$e||!Pe(ue,Y);return $e=!1,Y=ue,fe},Ae)}C.latch=ne;function Z(ke,Pe,Ae){return[C.filter(ke,Pe,Ae),C.filter(ke,$e=>!Pe($e),Ae)]}C.split=Z;function U(ke,Pe=!1,Ae=[],$e){let Y=Ae.slice(),ue=ke(De=>{Y?Y.push(De):be.fire(De)});$e&&$e.add(ue);const fe=()=>{Y?.forEach(De=>be.fire(De)),Y=null},be=new s({onWillAddFirstListener(){ue||(ue=ke(De=>be.fire(De)),$e&&$e.add(ue))},onDidAddFirstListener(){Y&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}C.buffer=U;function M(ke,Pe){return($e,Y,ue)=>{const fe=Pe(new H);return ke(function(be){const De=fe.evaluate(be);De!==N&&$e.call(Y,De)},void 0,ue)}}C.chain=M;const N=Symbol("HaltChainable");class H{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Ae=>(Pe(Ae),Ae)),this}filter(Pe){return this.f.push(Ae=>Pe(Ae)?Ae:N),this}reduce(Pe,Ae){let $e=Ae;return this.f.push(Y=>($e=Pe($e,Y),$e)),this}latch(Pe=(Ae,$e)=>Ae===$e){let Ae=!0,$e;return this.f.push(Y=>{const ue=Ae||!Pe(Y,$e);return Ae=!1,$e=Y,ue?Y:N}),this}evaluate(Pe){for(const Ae of this.f)if(Pe=Ae(Pe),Pe===N)break;return Pe}}function Q(ke,Pe,Ae=$e=>$e){const $e=(...be)=>fe.fire(Ae(...be)),Y=()=>ke.on(Pe,$e),ue=()=>ke.removeListener(Pe,$e),fe=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}C.fromNodeEventEmitter=Q;function J(ke,Pe,Ae=$e=>$e){const $e=(...be)=>fe.fire(Ae(...be)),Y=()=>ke.addEventListener(Pe,$e),ue=()=>ke.removeEventListener(Pe,$e),fe=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}C.fromDOMEventEmitter=J;function x(ke){return new Promise(Pe=>ie(ke)(Pe))}C.toPromise=x;function ee(ke){const Pe=new s;return ke.then(Ae=>{Pe.fire(Ae)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}C.fromPromise=ee;function de(ke,Pe,Ae){return Pe(Ae),ke($e=>Pe($e))}C.runAndSubscribe=de;class me{constructor(Pe,Ae){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Ae||z($e),this.emitter=new s($e),Ae&&Ae.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Ae){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(ke,Pe){return new me(ke,Pe).emitter.event}C.fromObservable=pe;function Ie(ke){return(Pe,Ae,$e)=>{let Y=0,ue=!1;const fe={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(ke.reportChanges(),ue&&(ue=!1,Pe.call(Ae)))},handlePossibleChange(){},handleChange(){ue=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof k.$Tc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Ie})(f||(e.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${d.f++}`,d.all.add(this)}start(z){this.g=new O.$be,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$de=d;let $=-1;function y(C){const z=$;return $=C,{dispose(){$=z}}}class h{constructor(z,se,ie=Math.random().toString(18).slice(2,5)){this.h=z,this.threshold=se,this.name=ie,this.g=0}dispose(){this.f?.clear()}check(z,se){const ie=this.threshold;if(ie<=0||se<ie)return;this.f||(this.f=new Map);const oe=this.f.get(z.value)||0;if(this.f.set(z.value,oe+1),this.g-=1,this.g<=0){this.g=ie*.5;const[K,te]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${te}):`;console.warn(q),console.warn(K);const L=new m(q,K);this.h(L)}return()=>{const K=this.f.get(z.value)||0;this.f.set(z.value,K-1)}}getMostFrequentStack(){if(!this.f)return;let z,se=0;for(const[ie,oe]of this.f)(!z||se<oe)&&(z=[ie,oe],se=oe);return z}}class g{static create(){const z=new Error;return new g(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(z,se){super(z),this.name="ListenerLeakError",this.stack=se}}e.$fe=m;class w extends Error{constructor(z,se){super(z),this.name="ListenerRefusalError",this.stack=se}}e.$ge=w;let p=0;class v{constructor(z){this.value=z,this.id=p++}}const S=2,o=(C,z)=>{if(C instanceof v)z(C);else for(let se=0;se<C.length;se++){const ie=C[se];ie&&z(ie)}},t=I?new FinalizationRegistry(C=>{typeof C=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(C))}):void 0;class s{constructor(z){this.w=0,this.f=z,this.g=$>0||this.f?.leakWarningThreshold?new h(z?.onListenerError??i.$1,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const z=this.t;queueMicrotask(()=>{o(z,se=>se.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,se,ie)=>{if(this.g&&this.w>this.g.threshold**2){const L=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(L);const B=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],V=new w(`${L}. HINT: Stack shows most frequent listener (${B[1]}-times)`,B[0]);return(this.f?.onListenerError||i.$1)(V),k.$Uc.None}if(this.m)return k.$Uc.None;se&&(z=z.bind(se));const oe=new v(z);let K,te;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(oe.stack=g.create(),K=this.g.check(oe.stack,this.w+1)),E&&(oe.stack=te??g.create()),this.t?this.t instanceof v?(this.u??=new n,this.t=[this.t,oe]):this.t.push(oe):(this.f?.onWillAddFirstListener?.(this),this.t=oe,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,k.$Sc)(()=>{t?.unregister(q),K?.(),this.x(oe)});if(ie instanceof k.$Tc?ie.add(q):Array.isArray(ie)&&ie.push(q),t){const L=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(q,L,q)}return q},this.q}x(z){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const se=this.t,ie=se.indexOf(z);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,se[ie]=void 0;const oe=this.u.current===this;if(this.w*S<=se.length){let K=0;for(let te=0;te<se.length;te++)se[te]?se[K++]=se[te]:oe&&(this.u.end--,K<this.u.i&&this.u.i--);se.length=K}}y(z,se){if(!z)return;const ie=this.f?.onListenerError||i.$1;if(!ie){z.value(se);return}try{z.value(se)}catch(oe){ie(oe)}}z(z){const se=z.current.t;for(;z.i<z.end;)this.y(se[z.i++],z.value);z.reset()}fire(z){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof v)this.y(this.t,z);else{const se=this.u;se.enqueue(this,z,this.t.length),this.z(se)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=s;const a=()=>new n;e.$ie=a;class n{constructor(){this.i=-1,this.end=0}enqueue(z,se,ie){this.i=0,this.end=ie,this.current=z,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends s{async fireAsync(z,se,ie){if(this.t)for(this.h||(this.h=new A.$5c),o(this.t,oe=>this.h.push([oe.value,z]));this.h.size>0&&!se.isCancellationRequested;){const[oe,K]=this.h.shift(),te=[],q={...K,token:se,waitUntil:L=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");ie&&(L=ie(L,oe)),te.push(L)}};try{oe(q)}catch(L){(0,i.$1)(L);continue}Object.freeze(te),await Promise.allSettled(te).then(L=>{for(const B of L)B.status==="rejected"&&(0,i.$1)(B.reason)})}}}e.$je=l;class u extends s{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new A.$5c,this.A=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.A(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.w&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$ke=u;class b extends u{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$le=b;class P extends s{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$me=P;class R{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const se={event:z,listener:null};this.h.push(se),this.g&&this.m(se);const ie=()=>{this.g&&this.o(se);const oe=this.h.indexOf(se);this.h.splice(oe,1)};return(0,k.$Sc)((0,r.$db)(ie))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(se=>this.f.fire(se))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$ne=R;class D{constructor(z,se,ie,oe){this.f=new k.$Tc;const K=this.f.add(new R),te=this.f.add(new k.$4c);function q(L){te.set(L,K.add(oe(L)))}for(const L of z)q(L);this.f.add(se(L=>{q(L)})),this.f.add(ie(L=>{te.deleteAndDispose(L)})),this.event=K.event}dispose(){this.f.dispose()}}e.$oe=D;class T{constructor(){this.f=[]}wrapEvent(z,se,ie){return(oe,K,te)=>z(q=>{const L=this.f[this.f.length-1];if(!se){L?L.buffers.push(()=>oe.call(K,q)):oe.call(K,q);return}const B=L;if(!B){oe.call(K,se(ie,q));return}B.items??=[],B.items.push(q),B.buffers.length===0&&L.buffers.push(()=>{B.reducedResult??=ie?B.items.reduce(se,ie):B.items.reduce(se),oe.call(K,B.reducedResult)})},void 0,te)}bufferEvents(z){const se={buffers:new Array};this.f.push(se);const ie=z();return this.f.pop(),se.buffers.forEach(oe=>oe()),ie}}e.$pe=T;class j{constructor(){this.f=!1,this.g=f.None,this.h=k.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=j;class F{static const(z){return new W(z)}constructor(z){this.g=z,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$re=F;class W{constructor(z){this.value=z,this.onDidChange=f.None}}}),define(ce[23],le([0,1,3]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=I;const r=Object.freeze(function(E,c){const f=setTimeout(E.bind(c),0);return{dispose(){clearTimeout(f)}}});var k;(function(E){function c(f){return f===E.None||f===E.Cancelled||f instanceof A?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}E.isCancellationToken=c,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(k||(e.CancellationToken=k={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new i.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=k.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=k.None}}e.$se=O;function I(E){const c=new O;return E.add({dispose(){c.cancel()}}),c.token}}),define(ce[145],le([0,1,23]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=k;class r{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new i.$se,c=this.b(E.token);return this.a={promise:c,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$5e=r;function k(I){return I}class A{constructor(E,c){this.a=void 0,this.b=void 0,typeof E=="function"?(this.c=E,this.d=k):(this.c=c,this.d=E.getCacheKey)}get(E){const c=this.d(E);return this.b!==c&&(this.b=c,this.a=this.c(E)),this.a}}e.$7e=A;class O{get cachedValues(){return this.a}constructor(E,c){this.a=new Map,this.b=new Map,typeof E=="function"?(this.c=E,this.d=k):(this.c=c,this.d=E.getCacheKey)}get(E){const c=this.d(E);if(this.b.has(c))return this.b.get(c);const f=this.c(E);return this.a.set(E,f),this.b.set(c,f),f}}e.$8e=O}),define(ce[66],le([0,1,16,2]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=k,e.$ve=A,e.$we=O,e.$xe=I,e.$ye=c,e.$ze=f,e.$Ae=d,e.$Be=$,e.$Ce=y,e.$De=h,e.$Ee=g,e.$Fe=m,e.$Ge=w,e.$He=p,e.$Ie=v;function k(S){const o=S;return o?typeof o.read=="function":!1}function A(S){const o=S;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function O(S){const o=S;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function I(S,o){return new E(S,o)}class E{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,i.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let s;switch(o){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(t);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,o){const t=[];let s;for(;(s=S.read())!==null;)t.push(s);return o(t)}function f(S,o,t){const s=[];let a;for(;(a=S.read())!==null&&s.length<t;)s.push(a);return a===null&&s.length>0?o(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const n=a;return a=void 0,n}return S.read()}}}function d(S,o){return new Promise((t,s)=>{const a=[];$(S,{onData:n=>{o&&a.push(n)},onError:n=>{o?s(n):t(void 0)},onEnd:()=>{t(o?o(a):void 0)}})})}function $(S,o,t){S.on("error",s=>{t?.isCancellationRequested||o.onError(s)}),S.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),S.on("data",s=>{t?.isCancellationRequested||o.onData(s)})}function y(S,o){return new Promise((t,s)=>{const a=new r.$Tc,n=[],l=P=>{if(n.push(P),n.length>o)return a.dispose(),S.pause(),t({stream:S,buffer:n,ended:!1})},u=P=>(a.dispose(),s(P)),b=()=>(a.dispose(),t({stream:S,buffer:n,ended:!0}));a.add((0,r.$Sc)(()=>S.removeListener("error",u))),S.on("error",u),a.add((0,r.$Sc)(()=>S.removeListener("end",b))),S.on("end",b),a.add((0,r.$Sc)(()=>S.removeListener("data",l))),S.on("data",l)})}function h(S,o){const t=I(o);return t.end(S),t}function g(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function m(S){let o=!1;return{read:()=>o?null:(o=!0,S)}}function w(S,o,t){const s=I(t);return $(S,{onData:a=>s.write(o.data(a)),onError:a=>s.error(o.error?o.error(a):a),onEnd:()=>s.end()}),s}function p(S,o,t){let s=!1;return{read:()=>{const a=o.read();return s?a:(s=!0,a!==null?t([S,a]):S)}}}function v(S,o,t){let s=!1;const a=I(t);return $(o,{onData:n=>s?a.write(n):(s=!0,a.write(t([S,n]))),onError:n=>a.error(n),onEnd:()=>{s||(s=!0,a.write(S)),a.end()}}),a}}),define(ce[17],le([0,1,65,66]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=c,e.$Le=f,e.$Me=d,e.$Ne=$,e.$Oe=y,e.$Pe=h,e.$Qe=g,e.$Re=m,e.$Se=w,e.$Te=p,e.$Ue=v,e.$Ve=S,e.$We=o,e.$Xe=t,e.$Ye=s,e.$Ze=a,e.$1e=n,e.$2e=l,e.$3e=u,e.$4e=R;const k=typeof Buffer<"u",A=new i.$V(()=>new Uint8Array(256));let O,I;class E{static alloc(T){return k?new E(Buffer.allocUnsafe(T)):new E(new Uint8Array(T))}static wrap(T){return k&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new E(T)}static fromString(T,j){return!(j?.dontUseNodeBuffer||!1)&&k?new E(Buffer.from(T)):(O||(O=new TextEncoder),new E(O.encode(T)))}static fromByteArray(T){const j=E.alloc(T.length);for(let F=0,W=T.length;F<W;F++)j.buffer[F]=T[F];return j}static concat(T,j){if(typeof j>"u"){j=0;for(let C=0,z=T.length;C<z;C++)j+=T[C].byteLength}const F=E.alloc(j);let W=0;for(let C=0,z=T.length;C<z;C++){const se=T[C];F.set(se,W),W+=se.byteLength}return F}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=E.alloc(this.byteLength);return T.set(this),T}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(T,j){return new E(this.buffer.subarray(T,j))}set(T,j){if(T instanceof E)this.buffer.set(T.buffer,j);else if(T instanceof Uint8Array)this.buffer.set(T,j);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),j);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return $(this.buffer,T)}writeUInt32BE(T,j){y(this.buffer,T,j)}readUInt32LE(T){return h(this.buffer,T)}writeUInt32LE(T,j){g(this.buffer,T,j)}readUInt8(T){return m(this.buffer,T)}writeUInt8(T,j){w(this.buffer,T,j)}indexOf(T,j=0){return c(this.buffer,T instanceof E?T.buffer:T,j)}}e.$Je=E;function c(D,T,j=0){const F=T.byteLength,W=D.byteLength;if(F===0)return 0;if(F===1)return D.indexOf(T[0]);if(F>W-j)return-1;const C=A.value;C.fill(T.length);for(let oe=0;oe<T.length;oe++)C[T[oe]]=T.length-oe-1;let z=j+T.length-1,se=z,ie=-1;for(;z<W;)if(D[z]===T[se]){if(se===0){ie=z;break}z--,se--}else z+=Math.max(T.length-se,C[D[z]]),se=T.length-1;return ie}function f(D,T){return D[T+0]<<0>>>0|D[T+1]<<8>>>0}function d(D,T,j){D[j+0]=T&255,T=T>>>8,D[j+1]=T&255}function $(D,T){return D[T]*2**24+D[T+1]*2**16+D[T+2]*2**8+D[T+3]}function y(D,T,j){D[j+3]=T,T=T>>>8,D[j+2]=T,T=T>>>8,D[j+1]=T,T=T>>>8,D[j]=T}function h(D,T){return D[T+0]<<0>>>0|D[T+1]<<8>>>0|D[T+2]<<16>>>0|D[T+3]<<24>>>0}function g(D,T,j){D[j+0]=T&255,T=T>>>8,D[j+1]=T&255,T=T>>>8,D[j+2]=T&255,T=T>>>8,D[j+3]=T&255}function m(D,T){return D[T]}function w(D,T,j){D[j]=T}function p(D){return r.$ye(D,T=>E.concat(T))}function v(D){return r.$Fe(D)}function S(D){return r.$Ae(D,T=>E.concat(T))}async function o(D){return D.ended?E.concat(D.buffer):E.concat([...D.buffer,await S(D.stream)])}function t(D){return r.$De(D,T=>E.concat(T))}function s(D){return r.$Ge(D,{data:T=>typeof T=="string"?E.fromString(T):E.wrap(T)},T=>E.concat(T))}function a(D){return r.$xe(T=>E.concat(T),D)}function n(D,T){return r.$He(D,T,j=>E.concat(j))}function l(D,T){return r.$Ie(D,T,j=>E.concat(j))}function u(D){let T=0,j=0,F=0;const W=new Uint8Array(Math.floor(D.length/4*3)),C=se=>{switch(j){case 3:W[F++]=T|se,j=0;break;case 2:W[F++]=T|se>>>2,T=se<<6,j=3;break;case 1:W[F++]=T|se>>>4,T=se<<4,j=2;break;default:T=se<<2,j=1}};for(let se=0;se<D.length;se++){const ie=D.charCodeAt(se);if(ie>=65&&ie<=90)C(ie-65);else if(ie>=97&&ie<=122)C(ie-97+26);else if(ie>=48&&ie<=57)C(ie-48+52);else if(ie===43||ie===45)C(62);else if(ie===47||ie===95)C(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${D[se]}`)}}const z=F;for(;j>0;)C(0);return E.wrap(W).slice(0,z)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:D},T=!0,j=!1){const F=j?P:b;let W="";const C=D.byteLength%3;let z=0;for(;z<D.byteLength-C;z+=3){const se=D[z+0],ie=D[z+1],oe=D[z+2];W+=F[se>>>2],W+=F[(se<<4|ie>>>4)&63],W+=F[(ie<<2|oe>>>6)&63],W+=F[oe&63]}if(C===1){const se=D[z+0];W+=F[se>>>2],W+=F[se<<4&63],T&&(W+="==")}else if(C===2){const se=D[z+0],ie=D[z+1];W+=F[se>>>2],W+=F[(se<<4|ie>>>4)&63],W+=F[ie<<2&63],T&&(W+="=")}return W}}),define(ce[146],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ce[12],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=i,e.$bg=r,e.$cg=k,e.$dg=A,e.$eg=O,e.$fg=I,e.$gg=E,e.$hg=c,e.$ig=f,e.$jg=d,e.$kg=$,e.$lg=y,e.$mg=h,e.$ng=m,e.$og=w,e.$pg=p,e.$qg=v,e.$rg=S;function i(o){return typeof o=="string"}function r(o){return Array.isArray(o)&&o.every(t=>i(t))}function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function O(o){return typeof o=="number"&&!isNaN(o)}function I(o){return!!o&&typeof o[Symbol.iterator]=="function"}function E(o){return o===!0||o===!1}function c(o){return typeof o>"u"}function f(o){return!d(o)}function d(o){return c(o)||o===null}function $(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(d(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function h(...o){const t=[];for(let s=0;s<o.length;s++){const a=o[s];if(d(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(a)}return t}const g=Object.prototype.hasOwnProperty;function m(o){if(!k(o))return!1;for(const t in o)if(g.call(o,t))return!1;return!0}function w(o){return typeof o=="function"}function p(...o){return o.length>0&&o.every(w)}function v(o,t){const s=Math.min(o.length,t.length);for(let a=0;a<s;a++)S(o[a],t[a])}function S(o,t){if(i(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(w(t)){try{if(o instanceof t)return}catch{}if(!d(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[110],le([0,1,12]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=k,e.$Vj=A;const r=Object.create(null);function k(O,I){if((0,i.$ag)(I)){const E=r[I];if(E===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=E}return r[O]=I,{id:O}}function A(){return r}}),define(ce[147],le([0,1,110]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,i.$Uj)("add",6e4),plus:(0,i.$Uj)("plus",6e4),gistNew:(0,i.$Uj)("gist-new",6e4),repoCreate:(0,i.$Uj)("repo-create",6e4),lightbulb:(0,i.$Uj)("lightbulb",60001),lightBulb:(0,i.$Uj)("light-bulb",60001),repo:(0,i.$Uj)("repo",60002),repoDelete:(0,i.$Uj)("repo-delete",60002),gistFork:(0,i.$Uj)("gist-fork",60003),repoForked:(0,i.$Uj)("repo-forked",60003),gitPullRequest:(0,i.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Uj)("record-keys",60005),keyboard:(0,i.$Uj)("keyboard",60005),tag:(0,i.$Uj)("tag",60006),gitPullRequestLabel:(0,i.$Uj)("git-pull-request-label",60006),tagAdd:(0,i.$Uj)("tag-add",60006),tagRemove:(0,i.$Uj)("tag-remove",60006),person:(0,i.$Uj)("person",60007),personFollow:(0,i.$Uj)("person-follow",60007),personOutline:(0,i.$Uj)("person-outline",60007),personFilled:(0,i.$Uj)("person-filled",60007),gitBranch:(0,i.$Uj)("git-branch",60008),gitBranchCreate:(0,i.$Uj)("git-branch-create",60008),gitBranchDelete:(0,i.$Uj)("git-branch-delete",60008),sourceControl:(0,i.$Uj)("source-control",60008),mirror:(0,i.$Uj)("mirror",60009),mirrorPublic:(0,i.$Uj)("mirror-public",60009),star:(0,i.$Uj)("star",60010),starAdd:(0,i.$Uj)("star-add",60010),starDelete:(0,i.$Uj)("star-delete",60010),starEmpty:(0,i.$Uj)("star-empty",60010),comment:(0,i.$Uj)("comment",60011),commentAdd:(0,i.$Uj)("comment-add",60011),alert:(0,i.$Uj)("alert",60012),warning:(0,i.$Uj)("warning",60012),search:(0,i.$Uj)("search",60013),searchSave:(0,i.$Uj)("search-save",60013),logOut:(0,i.$Uj)("log-out",60014),signOut:(0,i.$Uj)("sign-out",60014),logIn:(0,i.$Uj)("log-in",60015),signIn:(0,i.$Uj)("sign-in",60015),eye:(0,i.$Uj)("eye",60016),eyeUnwatch:(0,i.$Uj)("eye-unwatch",60016),eyeWatch:(0,i.$Uj)("eye-watch",60016),circleFilled:(0,i.$Uj)("circle-filled",60017),primitiveDot:(0,i.$Uj)("primitive-dot",60017),closeDirty:(0,i.$Uj)("close-dirty",60017),debugBreakpoint:(0,i.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Uj)("primitive-square",60018),edit:(0,i.$Uj)("edit",60019),pencil:(0,i.$Uj)("pencil",60019),info:(0,i.$Uj)("info",60020),issueOpened:(0,i.$Uj)("issue-opened",60020),gistPrivate:(0,i.$Uj)("gist-private",60021),gitForkPrivate:(0,i.$Uj)("git-fork-private",60021),lock:(0,i.$Uj)("lock",60021),mirrorPrivate:(0,i.$Uj)("mirror-private",60021),close:(0,i.$Uj)("close",60022),removeClose:(0,i.$Uj)("remove-close",60022),x:(0,i.$Uj)("x",60022),repoSync:(0,i.$Uj)("repo-sync",60023),sync:(0,i.$Uj)("sync",60023),clone:(0,i.$Uj)("clone",60024),desktopDownload:(0,i.$Uj)("desktop-download",60024),beaker:(0,i.$Uj)("beaker",60025),microscope:(0,i.$Uj)("microscope",60025),vm:(0,i.$Uj)("vm",60026),deviceDesktop:(0,i.$Uj)("device-desktop",60026),file:(0,i.$Uj)("file",60027),fileText:(0,i.$Uj)("file-text",60027),more:(0,i.$Uj)("more",60028),ellipsis:(0,i.$Uj)("ellipsis",60028),kebabHorizontal:(0,i.$Uj)("kebab-horizontal",60028),mailReply:(0,i.$Uj)("mail-reply",60029),reply:(0,i.$Uj)("reply",60029),organization:(0,i.$Uj)("organization",60030),organizationFilled:(0,i.$Uj)("organization-filled",60030),organizationOutline:(0,i.$Uj)("organization-outline",60030),newFile:(0,i.$Uj)("new-file",60031),fileAdd:(0,i.$Uj)("file-add",60031),newFolder:(0,i.$Uj)("new-folder",60032),fileDirectoryCreate:(0,i.$Uj)("file-directory-create",60032),trash:(0,i.$Uj)("trash",60033),trashcan:(0,i.$Uj)("trashcan",60033),history:(0,i.$Uj)("history",60034),clock:(0,i.$Uj)("clock",60034),folder:(0,i.$Uj)("folder",60035),fileDirectory:(0,i.$Uj)("file-directory",60035),symbolFolder:(0,i.$Uj)("symbol-folder",60035),logoGithub:(0,i.$Uj)("logo-github",60036),markGithub:(0,i.$Uj)("mark-github",60036),github:(0,i.$Uj)("github",60036),terminal:(0,i.$Uj)("terminal",60037),console:(0,i.$Uj)("console",60037),repl:(0,i.$Uj)("repl",60037),zap:(0,i.$Uj)("zap",60038),symbolEvent:(0,i.$Uj)("symbol-event",60038),error:(0,i.$Uj)("error",60039),stop:(0,i.$Uj)("stop",60039),variable:(0,i.$Uj)("variable",60040),symbolVariable:(0,i.$Uj)("symbol-variable",60040),array:(0,i.$Uj)("array",60042),symbolArray:(0,i.$Uj)("symbol-array",60042),symbolModule:(0,i.$Uj)("symbol-module",60043),symbolPackage:(0,i.$Uj)("symbol-package",60043),symbolNamespace:(0,i.$Uj)("symbol-namespace",60043),symbolObject:(0,i.$Uj)("symbol-object",60043),symbolMethod:(0,i.$Uj)("symbol-method",60044),symbolFunction:(0,i.$Uj)("symbol-function",60044),symbolConstructor:(0,i.$Uj)("symbol-constructor",60044),symbolBoolean:(0,i.$Uj)("symbol-boolean",60047),symbolNull:(0,i.$Uj)("symbol-null",60047),symbolNumeric:(0,i.$Uj)("symbol-numeric",60048),symbolNumber:(0,i.$Uj)("symbol-number",60048),symbolStructure:(0,i.$Uj)("symbol-structure",60049),symbolStruct:(0,i.$Uj)("symbol-struct",60049),symbolParameter:(0,i.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Uj)("symbol-type-parameter",60050),symbolKey:(0,i.$Uj)("symbol-key",60051),symbolText:(0,i.$Uj)("symbol-text",60051),symbolReference:(0,i.$Uj)("symbol-reference",60052),goToFile:(0,i.$Uj)("go-to-file",60052),symbolEnum:(0,i.$Uj)("symbol-enum",60053),symbolValue:(0,i.$Uj)("symbol-value",60053),symbolRuler:(0,i.$Uj)("symbol-ruler",60054),symbolUnit:(0,i.$Uj)("symbol-unit",60054),activateBreakpoints:(0,i.$Uj)("activate-breakpoints",60055),archive:(0,i.$Uj)("archive",60056),arrowBoth:(0,i.$Uj)("arrow-both",60057),arrowDown:(0,i.$Uj)("arrow-down",60058),arrowLeft:(0,i.$Uj)("arrow-left",60059),arrowRight:(0,i.$Uj)("arrow-right",60060),arrowSmallDown:(0,i.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Uj)("arrow-small-up",60064),arrowUp:(0,i.$Uj)("arrow-up",60065),bell:(0,i.$Uj)("bell",60066),bold:(0,i.$Uj)("bold",60067),book:(0,i.$Uj)("book",60068),bookmark:(0,i.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Uj)("briefcase",60076),broadcast:(0,i.$Uj)("broadcast",60077),browser:(0,i.$Uj)("browser",60078),bug:(0,i.$Uj)("bug",60079),calendar:(0,i.$Uj)("calendar",60080),caseSensitive:(0,i.$Uj)("case-sensitive",60081),check:(0,i.$Uj)("check",60082),checklist:(0,i.$Uj)("checklist",60083),chevronDown:(0,i.$Uj)("chevron-down",60084),chevronLeft:(0,i.$Uj)("chevron-left",60085),chevronRight:(0,i.$Uj)("chevron-right",60086),chevronUp:(0,i.$Uj)("chevron-up",60087),chromeClose:(0,i.$Uj)("chrome-close",60088),chromeMaximize:(0,i.$Uj)("chrome-maximize",60089),chromeMinimize:(0,i.$Uj)("chrome-minimize",60090),chromeRestore:(0,i.$Uj)("chrome-restore",60091),circleOutline:(0,i.$Uj)("circle-outline",60092),circle:(0,i.$Uj)("circle",60092),debugBreakpointUnverified:(0,i.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Uj)("circle-slash",60093),circuitBoard:(0,i.$Uj)("circuit-board",60094),clearAll:(0,i.$Uj)("clear-all",60095),clippy:(0,i.$Uj)("clippy",60096),closeAll:(0,i.$Uj)("close-all",60097),cloudDownload:(0,i.$Uj)("cloud-download",60098),cloudUpload:(0,i.$Uj)("cloud-upload",60099),code:(0,i.$Uj)("code",60100),collapseAll:(0,i.$Uj)("collapse-all",60101),colorMode:(0,i.$Uj)("color-mode",60102),commentDiscussion:(0,i.$Uj)("comment-discussion",60103),creditCard:(0,i.$Uj)("credit-card",60105),dash:(0,i.$Uj)("dash",60108),dashboard:(0,i.$Uj)("dashboard",60109),database:(0,i.$Uj)("database",60110),debugContinue:(0,i.$Uj)("debug-continue",60111),debugDisconnect:(0,i.$Uj)("debug-disconnect",60112),debugPause:(0,i.$Uj)("debug-pause",60113),debugRestart:(0,i.$Uj)("debug-restart",60114),debugStart:(0,i.$Uj)("debug-start",60115),debugStepInto:(0,i.$Uj)("debug-step-into",60116),debugStepOut:(0,i.$Uj)("debug-step-out",60117),debugStepOver:(0,i.$Uj)("debug-step-over",60118),debugStop:(0,i.$Uj)("debug-stop",60119),debug:(0,i.$Uj)("debug",60120),deviceCameraVideo:(0,i.$Uj)("device-camera-video",60121),deviceCamera:(0,i.$Uj)("device-camera",60122),deviceMobile:(0,i.$Uj)("device-mobile",60123),diffAdded:(0,i.$Uj)("diff-added",60124),diffIgnored:(0,i.$Uj)("diff-ignored",60125),diffModified:(0,i.$Uj)("diff-modified",60126),diffRemoved:(0,i.$Uj)("diff-removed",60127),diffRenamed:(0,i.$Uj)("diff-renamed",60128),diff:(0,i.$Uj)("diff",60129),diffSidebyside:(0,i.$Uj)("diff-sidebyside",60129),discard:(0,i.$Uj)("discard",60130),editorLayout:(0,i.$Uj)("editor-layout",60131),emptyWindow:(0,i.$Uj)("empty-window",60132),exclude:(0,i.$Uj)("exclude",60133),extensions:(0,i.$Uj)("extensions",60134),eyeClosed:(0,i.$Uj)("eye-closed",60135),fileBinary:(0,i.$Uj)("file-binary",60136),fileCode:(0,i.$Uj)("file-code",60137),fileMedia:(0,i.$Uj)("file-media",60138),filePdf:(0,i.$Uj)("file-pdf",60139),fileSubmodule:(0,i.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Uj)("file-symlink-file",60142),fileZip:(0,i.$Uj)("file-zip",60143),files:(0,i.$Uj)("files",60144),filter:(0,i.$Uj)("filter",60145),flame:(0,i.$Uj)("flame",60146),foldDown:(0,i.$Uj)("fold-down",60147),foldUp:(0,i.$Uj)("fold-up",60148),fold:(0,i.$Uj)("fold",60149),folderActive:(0,i.$Uj)("folder-active",60150),folderOpened:(0,i.$Uj)("folder-opened",60151),gear:(0,i.$Uj)("gear",60152),gift:(0,i.$Uj)("gift",60153),gistSecret:(0,i.$Uj)("gist-secret",60154),gist:(0,i.$Uj)("gist",60155),gitCommit:(0,i.$Uj)("git-commit",60156),gitCompare:(0,i.$Uj)("git-compare",60157),compareChanges:(0,i.$Uj)("compare-changes",60157),gitMerge:(0,i.$Uj)("git-merge",60158),githubAction:(0,i.$Uj)("github-action",60159),githubAlt:(0,i.$Uj)("github-alt",60160),globe:(0,i.$Uj)("globe",60161),grabber:(0,i.$Uj)("grabber",60162),graph:(0,i.$Uj)("graph",60163),gripper:(0,i.$Uj)("gripper",60164),heart:(0,i.$Uj)("heart",60165),home:(0,i.$Uj)("home",60166),horizontalRule:(0,i.$Uj)("horizontal-rule",60167),hubot:(0,i.$Uj)("hubot",60168),inbox:(0,i.$Uj)("inbox",60169),issueReopened:(0,i.$Uj)("issue-reopened",60171),issues:(0,i.$Uj)("issues",60172),italic:(0,i.$Uj)("italic",60173),jersey:(0,i.$Uj)("jersey",60174),json:(0,i.$Uj)("json",60175),kebabVertical:(0,i.$Uj)("kebab-vertical",60176),key:(0,i.$Uj)("key",60177),law:(0,i.$Uj)("law",60178),lightbulbAutofix:(0,i.$Uj)("lightbulb-autofix",60179),linkExternal:(0,i.$Uj)("link-external",60180),link:(0,i.$Uj)("link",60181),listOrdered:(0,i.$Uj)("list-ordered",60182),listUnordered:(0,i.$Uj)("list-unordered",60183),liveShare:(0,i.$Uj)("live-share",60184),loading:(0,i.$Uj)("loading",60185),location:(0,i.$Uj)("location",60186),mailRead:(0,i.$Uj)("mail-read",60187),mail:(0,i.$Uj)("mail",60188),markdown:(0,i.$Uj)("markdown",60189),megaphone:(0,i.$Uj)("megaphone",60190),mention:(0,i.$Uj)("mention",60191),milestone:(0,i.$Uj)("milestone",60192),gitPullRequestMilestone:(0,i.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Uj)("mortar-board",60193),move:(0,i.$Uj)("move",60194),multipleWindows:(0,i.$Uj)("multiple-windows",60195),mute:(0,i.$Uj)("mute",60196),noNewline:(0,i.$Uj)("no-newline",60197),note:(0,i.$Uj)("note",60198),octoface:(0,i.$Uj)("octoface",60199),openPreview:(0,i.$Uj)("open-preview",60200),package:(0,i.$Uj)("package",60201),paintcan:(0,i.$Uj)("paintcan",60202),pin:(0,i.$Uj)("pin",60203),play:(0,i.$Uj)("play",60204),run:(0,i.$Uj)("run",60204),plug:(0,i.$Uj)("plug",60205),preserveCase:(0,i.$Uj)("preserve-case",60206),preview:(0,i.$Uj)("preview",60207),project:(0,i.$Uj)("project",60208),pulse:(0,i.$Uj)("pulse",60209),question:(0,i.$Uj)("question",60210),quote:(0,i.$Uj)("quote",60211),radioTower:(0,i.$Uj)("radio-tower",60212),reactions:(0,i.$Uj)("reactions",60213),references:(0,i.$Uj)("references",60214),refresh:(0,i.$Uj)("refresh",60215),regex:(0,i.$Uj)("regex",60216),remoteExplorer:(0,i.$Uj)("remote-explorer",60217),remote:(0,i.$Uj)("remote",60218),remove:(0,i.$Uj)("remove",60219),replaceAll:(0,i.$Uj)("replace-all",60220),replace:(0,i.$Uj)("replace",60221),repoClone:(0,i.$Uj)("repo-clone",60222),repoForcePush:(0,i.$Uj)("repo-force-push",60223),repoPull:(0,i.$Uj)("repo-pull",60224),repoPush:(0,i.$Uj)("repo-push",60225),report:(0,i.$Uj)("report",60226),requestChanges:(0,i.$Uj)("request-changes",60227),rocket:(0,i.$Uj)("rocket",60228),rootFolderOpened:(0,i.$Uj)("root-folder-opened",60229),rootFolder:(0,i.$Uj)("root-folder",60230),rss:(0,i.$Uj)("rss",60231),ruby:(0,i.$Uj)("ruby",60232),saveAll:(0,i.$Uj)("save-all",60233),saveAs:(0,i.$Uj)("save-as",60234),save:(0,i.$Uj)("save",60235),screenFull:(0,i.$Uj)("screen-full",60236),screenNormal:(0,i.$Uj)("screen-normal",60237),searchStop:(0,i.$Uj)("search-stop",60238),server:(0,i.$Uj)("server",60240),settingsGear:(0,i.$Uj)("settings-gear",60241),settings:(0,i.$Uj)("settings",60242),shield:(0,i.$Uj)("shield",60243),smiley:(0,i.$Uj)("smiley",60244),sortPrecedence:(0,i.$Uj)("sort-precedence",60245),splitHorizontal:(0,i.$Uj)("split-horizontal",60246),splitVertical:(0,i.$Uj)("split-vertical",60247),squirrel:(0,i.$Uj)("squirrel",60248),starFull:(0,i.$Uj)("star-full",60249),starHalf:(0,i.$Uj)("star-half",60250),symbolClass:(0,i.$Uj)("symbol-class",60251),symbolColor:(0,i.$Uj)("symbol-color",60252),symbolConstant:(0,i.$Uj)("symbol-constant",60253),symbolEnumMember:(0,i.$Uj)("symbol-enum-member",60254),symbolField:(0,i.$Uj)("symbol-field",60255),symbolFile:(0,i.$Uj)("symbol-file",60256),symbolInterface:(0,i.$Uj)("symbol-interface",60257),symbolKeyword:(0,i.$Uj)("symbol-keyword",60258),symbolMisc:(0,i.$Uj)("symbol-misc",60259),symbolOperator:(0,i.$Uj)("symbol-operator",60260),symbolProperty:(0,i.$Uj)("symbol-property",60261),wrench:(0,i.$Uj)("wrench",60261),wrenchSubaction:(0,i.$Uj)("wrench-subaction",60261),symbolSnippet:(0,i.$Uj)("symbol-snippet",60262),tasklist:(0,i.$Uj)("tasklist",60263),telescope:(0,i.$Uj)("telescope",60264),textSize:(0,i.$Uj)("text-size",60265),threeBars:(0,i.$Uj)("three-bars",60266),thumbsdown:(0,i.$Uj)("thumbsdown",60267),thumbsup:(0,i.$Uj)("thumbsup",60268),tools:(0,i.$Uj)("tools",60269),triangleDown:(0,i.$Uj)("triangle-down",60270),triangleLeft:(0,i.$Uj)("triangle-left",60271),triangleRight:(0,i.$Uj)("triangle-right",60272),triangleUp:(0,i.$Uj)("triangle-up",60273),twitter:(0,i.$Uj)("twitter",60274),unfold:(0,i.$Uj)("unfold",60275),unlock:(0,i.$Uj)("unlock",60276),unmute:(0,i.$Uj)("unmute",60277),unverified:(0,i.$Uj)("unverified",60278),verified:(0,i.$Uj)("verified",60279),versions:(0,i.$Uj)("versions",60280),vmActive:(0,i.$Uj)("vm-active",60281),vmOutline:(0,i.$Uj)("vm-outline",60282),vmRunning:(0,i.$Uj)("vm-running",60283),watch:(0,i.$Uj)("watch",60284),whitespace:(0,i.$Uj)("whitespace",60285),wholeWord:(0,i.$Uj)("whole-word",60286),window:(0,i.$Uj)("window",60287),wordWrap:(0,i.$Uj)("word-wrap",60288),zoomIn:(0,i.$Uj)("zoom-in",60289),zoomOut:(0,i.$Uj)("zoom-out",60290),listFilter:(0,i.$Uj)("list-filter",60291),listFlat:(0,i.$Uj)("list-flat",60292),listSelection:(0,i.$Uj)("list-selection",60293),selection:(0,i.$Uj)("selection",60293),listTree:(0,i.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Uj)("symbol-string",60301),debugReverseContinue:(0,i.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Uj)("debug-step-back",60303),debugRestartFrame:(0,i.$Uj)("debug-restart-frame",60304),debugAlt:(0,i.$Uj)("debug-alt",60305),callIncoming:(0,i.$Uj)("call-incoming",60306),callOutgoing:(0,i.$Uj)("call-outgoing",60307),menu:(0,i.$Uj)("menu",60308),expandAll:(0,i.$Uj)("expand-all",60309),feedback:(0,i.$Uj)("feedback",60310),gitPullRequestReviewer:(0,i.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Uj)("ungroup-by-ref-type",60312),account:(0,i.$Uj)("account",60313),gitPullRequestAssignee:(0,i.$Uj)("git-pull-request-assignee",60313),bellDot:(0,i.$Uj)("bell-dot",60314),debugConsole:(0,i.$Uj)("debug-console",60315),library:(0,i.$Uj)("library",60316),output:(0,i.$Uj)("output",60317),runAll:(0,i.$Uj)("run-all",60318),syncIgnored:(0,i.$Uj)("sync-ignored",60319),pinned:(0,i.$Uj)("pinned",60320),githubInverted:(0,i.$Uj)("github-inverted",60321),serverProcess:(0,i.$Uj)("server-process",60322),serverEnvironment:(0,i.$Uj)("server-environment",60323),pass:(0,i.$Uj)("pass",60324),issueClosed:(0,i.$Uj)("issue-closed",60324),stopCircle:(0,i.$Uj)("stop-circle",60325),playCircle:(0,i.$Uj)("play-circle",60326),record:(0,i.$Uj)("record",60327),debugAltSmall:(0,i.$Uj)("debug-alt-small",60328),vmConnect:(0,i.$Uj)("vm-connect",60329),cloud:(0,i.$Uj)("cloud",60330),merge:(0,i.$Uj)("merge",60331),export:(0,i.$Uj)("export",60332),graphLeft:(0,i.$Uj)("graph-left",60333),magnet:(0,i.$Uj)("magnet",60334),notebook:(0,i.$Uj)("notebook",60335),redo:(0,i.$Uj)("redo",60336),checkAll:(0,i.$Uj)("check-all",60337),pinnedDirty:(0,i.$Uj)("pinned-dirty",60338),passFilled:(0,i.$Uj)("pass-filled",60339),circleLargeFilled:(0,i.$Uj)("circle-large-filled",60340),circleLarge:(0,i.$Uj)("circle-large",60341),circleLargeOutline:(0,i.$Uj)("circle-large-outline",60341),combine:(0,i.$Uj)("combine",60342),gather:(0,i.$Uj)("gather",60342),table:(0,i.$Uj)("table",60343),variableGroup:(0,i.$Uj)("variable-group",60344),typeHierarchy:(0,i.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Uj)("git-pull-request-create",60348),runAbove:(0,i.$Uj)("run-above",60349),runBelow:(0,i.$Uj)("run-below",60350),notebookTemplate:(0,i.$Uj)("notebook-template",60351),debugRerun:(0,i.$Uj)("debug-rerun",60352),workspaceTrusted:(0,i.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Uj)("workspace-unknown",60355),terminalCmd:(0,i.$Uj)("terminal-cmd",60356),terminalDebian:(0,i.$Uj)("terminal-debian",60357),terminalLinux:(0,i.$Uj)("terminal-linux",60358),terminalPowershell:(0,i.$Uj)("terminal-powershell",60359),terminalTmux:(0,i.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Uj)("terminal-ubuntu",60361),terminalBash:(0,i.$Uj)("terminal-bash",60362),arrowSwap:(0,i.$Uj)("arrow-swap",60363),copy:(0,i.$Uj)("copy",60364),personAdd:(0,i.$Uj)("person-add",60365),filterFilled:(0,i.$Uj)("filter-filled",60366),wand:(0,i.$Uj)("wand",60367),debugLineByLine:(0,i.$Uj)("debug-line-by-line",60368),inspect:(0,i.$Uj)("inspect",60369),layers:(0,i.$Uj)("layers",60370),layersDot:(0,i.$Uj)("layers-dot",60371),layersActive:(0,i.$Uj)("layers-active",60372),compass:(0,i.$Uj)("compass",60373),compassDot:(0,i.$Uj)("compass-dot",60374),compassActive:(0,i.$Uj)("compass-active",60375),azure:(0,i.$Uj)("azure",60376),issueDraft:(0,i.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Uj)("git-pull-request-draft",60379),debugAll:(0,i.$Uj)("debug-all",60380),debugCoverage:(0,i.$Uj)("debug-coverage",60381),runErrors:(0,i.$Uj)("run-errors",60382),folderLibrary:(0,i.$Uj)("folder-library",60383),debugContinueSmall:(0,i.$Uj)("debug-continue-small",60384),beakerStop:(0,i.$Uj)("beaker-stop",60385),graphLine:(0,i.$Uj)("graph-line",60386),graphScatter:(0,i.$Uj)("graph-scatter",60387),pieChart:(0,i.$Uj)("pie-chart",60388),bracket:(0,i.$Uj)("bracket",60175),bracketDot:(0,i.$Uj)("bracket-dot",60389),bracketError:(0,i.$Uj)("bracket-error",60390),lockSmall:(0,i.$Uj)("lock-small",60391),azureDevops:(0,i.$Uj)("azure-devops",60392),verifiedFilled:(0,i.$Uj)("verified-filled",60393),newline:(0,i.$Uj)("newline",60394),layout:(0,i.$Uj)("layout",60395),layoutActivitybarLeft:(0,i.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Uj)("layout-panel-right",60401),layoutPanel:(0,i.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Uj)("layout-statusbar",60405),layoutMenubar:(0,i.$Uj)("layout-menubar",60406),layoutCentered:(0,i.$Uj)("layout-centered",60407),target:(0,i.$Uj)("target",60408),indent:(0,i.$Uj)("indent",60409),recordSmall:(0,i.$Uj)("record-small",60410),errorSmall:(0,i.$Uj)("error-small",60411),terminalDecorationError:(0,i.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Uj)("layout-sidebar-left-off",60418),blank:(0,i.$Uj)("blank",60419),heartFilled:(0,i.$Uj)("heart-filled",60420),map:(0,i.$Uj)("map",60421),mapHorizontal:(0,i.$Uj)("map-horizontal",60421),foldHorizontal:(0,i.$Uj)("fold-horizontal",60421),mapFilled:(0,i.$Uj)("map-filled",60422),mapHorizontalFilled:(0,i.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Uj)("circle-small",60423),bellSlash:(0,i.$Uj)("bell-slash",60424),bellSlashDot:(0,i.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Uj)("search-fuzzy",60429),commentDraft:(0,i.$Uj)("comment-draft",60430),send:(0,i.$Uj)("send",60431),sparkle:(0,i.$Uj)("sparkle",60432),insert:(0,i.$Uj)("insert",60433),mic:(0,i.$Uj)("mic",60434),thumbsdownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Uj)("thumbsup-filled",60436),coffee:(0,i.$Uj)("coffee",60437),snake:(0,i.$Uj)("snake",60438),game:(0,i.$Uj)("game",60439),vr:(0,i.$Uj)("vr",60440),chip:(0,i.$Uj)("chip",60441),piano:(0,i.$Uj)("piano",60442),music:(0,i.$Uj)("music",60443),micFilled:(0,i.$Uj)("mic-filled",60444),repoFetch:(0,i.$Uj)("repo-fetch",60445),copilot:(0,i.$Uj)("copilot",60446),lightbulbSparkle:(0,i.$Uj)("lightbulb-sparkle",60447),robot:(0,i.$Uj)("robot",60448),sparkleFilled:(0,i.$Uj)("sparkle-filled",60449),diffSingle:(0,i.$Uj)("diff-single",60450),diffMultiple:(0,i.$Uj)("diff-multiple",60451),surroundWith:(0,i.$Uj)("surround-with",60452),share:(0,i.$Uj)("share",60453),gitStash:(0,i.$Uj)("git-stash",60454),gitStashApply:(0,i.$Uj)("git-stash-apply",60455),gitStashPop:(0,i.$Uj)("git-stash-pop",60456),vscode:(0,i.$Uj)("vscode",60457),vscodeInsiders:(0,i.$Uj)("vscode-insiders",60458),codeOss:(0,i.$Uj)("code-oss",60459),runCoverage:(0,i.$Uj)("run-coverage",60460),runAllCoverage:(0,i.$Uj)("run-all-coverage",60461),coverage:(0,i.$Uj)("coverage",60462),githubProject:(0,i.$Uj)("github-project",60463),mapVertical:(0,i.$Uj)("map-vertical",60464),foldVertical:(0,i.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Uj)("fold-vertical-filled",60465),goToSearch:(0,i.$Uj)("go-to-search",60466),percentage:(0,i.$Uj)("percentage",60467),sortPercentage:(0,i.$Uj)("sort-percentage",60467),attach:(0,i.$Uj)("attach",60468)}}),define(ce[78],le([0,1,110,147]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=k;function k(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,i.$Uj)("dialog-error","error"),dialogWarning:(0,i.$Uj)("dialog-warning","warning"),dialogInfo:(0,i.$Uj)("dialog-info","info"),dialogClose:(0,i.$Uj)("dialog-close","close"),treeItemExpanded:(0,i.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Uj)("tree-item-loading","loading"),menuSelection:(0,i.$Uj)("menu-selection","check"),menuSubmenu:(0,i.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Uj)("toolbar-more","more"),quickInputBack:(0,i.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Uj)("drop-down-button",60084),symbolCustomColor:(0,i.$Uj)("symbol-customcolor",60252),exportIcon:(0,i.$Uj)("export",60332),workspaceUnspecified:(0,i.$Uj)("workspace-unspecified",60355),newLine:(0,i.$Uj)("newline",60394),thumbsDownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Uj)("thumbsup-filled",60436),gitFetch:(0,i.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...r.$Wj,...e.$Yj}}),define(ce[35],le([0,1,12]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=r,e.$0n=k,e.$$n=O,e.$_n=E,e.$ao=c,e.$bo=f,e.$co=d,e.$do=$,e.$eo=y,e.$fo=h,e.$go=g,e.$ho=m,e.$io=w;function r(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([S,o])=>{v[S]=o&&typeof o=="object"?r(o):o}),v}function k(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const S=v.shift();Object.freeze(S);for(const o in S)if(A.call(S,o)){const t=S[o];typeof t=="object"&&!Object.isFrozen(t)&&!(0,i.$dg)(t)&&v.push(t)}}return p}const A=Object.prototype.hasOwnProperty;function O(p,v){return I(p,v,new Set)}function I(p,v,S){if((0,i.$jg)(p))return p;const o=v(p);if(typeof o<"u")return o;if(Array.isArray(p)){const t=[];for(const s of p)t.push(I(s,v,S));return t}if((0,i.$cg)(p)){if(S.has(p))throw new Error("Cannot clone recursive data-structure");S.add(p);const t={};for(const s in p)A.call(p,s)&&(t[s]=I(p[s],v,S));return S.delete(p),t}return p}function E(p,v,S=!0){return(0,i.$cg)(p)?((0,i.$cg)(v)&&Object.keys(v).forEach(o=>{o in p?S&&((0,i.$cg)(p[o])&&(0,i.$cg)(v[o])?E(p[o],v[o],S):p[o]=v[o]):p[o]=v[o]}),p):v}function c(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let S,o;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(S=0;S<p.length;S++)if(!c(p[S],v[S]))return!1}else{const t=[];for(o in p)t.push(o);t.sort();const s=[];for(o in v)s.push(o);if(s.sort(),!c(t,s))return!1;for(S=0;S<t.length;S++)if(!c(p[t[S]],v[t[S]]))return!1}return!0}function f(p){const v=new Set;return JSON.stringify(p,(S,o)=>{if((0,i.$cg)(o)||Array.isArray(o)){if(v.has(o))return"[Circular]";v.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function d(p,v){const S=Object.create(null);return!p||!v||Object.keys(v).forEach(t=>{const s=p[t],a=v[t];c(s,a)||(S[t]=a)}),S}function $(p,v){const S=v.toLowerCase(),o=Object.keys(p).find(t=>t.toLowerCase()===S);return o?p[o]:p[v]}function y(p,v){const S=Object.create(null);for(const[o,t]of Object.entries(p))v(o,t)&&(S[o]=t);return S}function h(p){let v=[];for(;Object.prototype!==p;)v=v.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return v}function g(p){const v=[];for(const S of h(p))typeof p[S]=="function"&&v.push(S);return v}function m(p,v){const S=t=>function(){const s=Array.prototype.slice.call(arguments,0);return v(t,s)},o={};for(const t of p)o[t]=S(t);return o}function w(p,v){const S={};for(const[o,t]of Object.entries(p))S[o]=v(t,o);return S}}),define(ce[111],le([0,1,78]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=k;var r;(function(O){function I(E){return E&&typeof E=="object"&&typeof E.id=="string"}O.isThemeColor=I})(r||(e.ThemeColor=r={}));function k(O){return{id:O}}var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function E(p){const v=I.exec(p.id);if(!v)return E(i.$Zj.error);const[,S,o]=v,t=["codicon","codicon-"+S];return o&&t.push("codicon-modifier-"+o.substring(1)),t}O.asClassNameArray=E;function c(p){return E(p).join(" ")}O.asClassName=c;function f(p){return"."+E(p).join(".")}O.asCSSSelector=f;function d(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||r.isThemeColor(p.color))}O.isThemeIcon=d;const $=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function y(p){const v=$.exec(p);if(!v)return;const[,S]=v;return{id:S}}O.fromString=y;function h(p){return{id:p}}O.fromId=h;function g(p,v){let S=p.id;const o=S.lastIndexOf("~");return o!==-1&&(S=S.substring(0,o)),v&&(S=`${S}~${v}`),{id:S}}O.modify=g;function m(p){const v=p.id.lastIndexOf("~");if(v!==-1)return p.id.substring(v+1)}O.getModifier=m;function w(p,v){return p.id===v.id&&p.color?.id===v.color?.id}O.isEqual=w})(A||(e.ThemeIcon=A={}))}),define(ce[148],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=r,e.$0e=k;var i;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function r(A){return A<0?0:A>i.MAX_UINT_8?i.MAX_UINT_8:A|0}function k(A){return A<0?0:A>i.MAX_UINT_32?i.MAX_UINT_32:A|0}}),define(ce[26],le([0,1,145,39,65,148]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=O,e.$_e=E,e.$af=f,e.$bf=d,e.$cf=$,e.$df=y,e.$ef=h,e.$ff=g,e.$gf=m,e.$hf=w,e.$if=p,e.$jf=v,e.$kf=S,e.$lf=o,e.$mf=t,e.$nf=s,e.$of=a,e.$pf=n,e.$qf=l,e.$rf=u,e.$sf=b,e.$tf=P,e.$uf=R,e.$vf=D,e.$wf=T,e.$xf=j,e.$yf=F,e.$zf=W,e.$Af=C,e.$Bf=z,e.$Cf=se,e.$Df=ie,e.$Ef=oe,e.$Ff=K,e.$Gf=te,e.$Hf=q,e.$If=L,e.$Lf=G,e.$Mf=he,e.$Nf=ne,e.$Of=Z,e.$Pf=N,e.$Qf=Q,e.$Sf=J,e.$Tf=x,e.$Uf=ee,e.$Vf=de,e.$Wf=pe,e.$Xf=Ie,e.$Yf=Pe,e.$1f=Ae,e.$2f=$e,e.$3f=Y,e.$4f=ue,e.$5f=fe,e.$6f=be,e.$7f=De,e.$8f=Ne,e.$9f=Qe;function O(_){return!_||typeof _!="string"?!0:_.trim().length===0}const I=/{(\d+)}/g;function E(_,...ge){return ge.length===0?_:_.replace(I,function(we,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=ge.length?we:ge[Le]})}const c=/{([^}]+)}/g;function f(_,ge){return Object.keys(ge).length===0?_:_.replace(c,(we,ye)=>ge[ye]??we)}function d(_){return _.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function $(_){return _.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(_){return _.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(_,ge){let we=0,ye=_.indexOf(ge);for(;ye!==-1;)we++,ye=_.indexOf(ge,ye+ge.length);return we}function g(_,ge,we="\u2026"){return _.length<=ge?_:`${_.substr(0,ge)}${we}`}function m(_,ge,we="\u2026"){if(_.length<=ge)return _;const ye=Math.ceil(ge/2)-we.length/2,Le=Math.floor(ge/2)-we.length/2;return`${_.substr(0,ye)}${we}${_.substr(_.length-Le)}`}function w(_,ge=" "){const we=p(_,ge);return v(we,ge)}function p(_,ge){if(!_||!ge)return _;const we=ge.length;if(we===0||_.length===0)return _;let ye=0;for(;_.indexOf(ge,ye)===ye;)ye=ye+we;return _.substring(ye)}function v(_,ge){if(!_||!ge)return _;const we=ge.length,ye=_.length;if(we===0||ye===0)return _;let Le=ye,We=-1;for(;We=_.lastIndexOf(ge,Le-1),!(We===-1||We+we!==Le);){if(We===0)return"";Le=We}return _.substring(0,Le)}function S(_){return _.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(_){return _.replace(/\*/g,"")}function t(_,ge,we={}){if(!_)throw new Error("Cannot create regex from empty string");ge||(_=y(_)),we.wholeWord&&(/\B/.test(_.charAt(0))||(_="\\b"+_),/\B/.test(_.charAt(_.length-1))||(_=_+"\\b"));let ye="";return we.global&&(ye+="g"),we.matchCase||(ye+="i"),we.multiline&&(ye+="m"),we.unicode&&(ye+="u"),new RegExp(_,ye)}function s(_){return _.source==="^"||_.source==="^$"||_.source==="$"||_.source==="^\\s*$"?!1:!!(_.exec("")&&_.lastIndex===0)}function a(_){return _.split(/\r\n|\r|\n/)}function n(_){const ge=[],we=_.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(we.length/2);ye++)ge.push(we[2*ye]+(we[2*ye+1]??""));return ge}function l(_){for(let ge=0,we=_.length;ge<we;ge++){const ye=_.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function u(_,ge=0,we=_.length){for(let ye=ge;ye<we;ye++){const Le=_.charCodeAt(ye);if(Le!==r.CharCode.Space&&Le!==r.CharCode.Tab)return _.substring(ge,ye)}return _.substring(ge,we)}function b(_,ge=_.length-1){for(let we=ge;we>=0;we--){const ye=_.charCodeAt(we);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return we}return-1}function P(_,ge,we){const ye=[];let Le=0;for(const We of _.matchAll(ge)){if(ye.push(_.slice(Le,We.index)),We.index===void 0)throw new Error("match.index should be defined");Le=We.index+We[0].length,ye.push(we(We[0],...We.slice(1),We.index,_,We.groups))}return ye.push(_.slice(Le)),Promise.all(ye).then(We=>We.join(""))}function R(_,ge){return _<ge?-1:_>ge?1:0}function D(_,ge,we=0,ye=_.length,Le=0,We=ge.length){for(;we<ye&&Le<We;we++,Le++){const nt=_.charCodeAt(we),rt=ge.charCodeAt(Le);if(nt<rt)return-1;if(nt>rt)return 1}const Ye=ye-we,at=We-Le;return Ye<at?-1:Ye>at?1:0}function T(_,ge){return j(_,ge,0,_.length,0,ge.length)}function j(_,ge,we=0,ye=_.length,Le=0,We=ge.length){for(;we<ye&&Le<We;we++,Le++){let nt=_.charCodeAt(we),rt=ge.charCodeAt(Le);if(nt===rt)continue;if(nt>=128||rt>=128)return D(_.toLowerCase(),ge.toLowerCase(),we,ye,Le,We);W(nt)&&(nt-=32),W(rt)&&(rt-=32);const _e=nt-rt;if(_e!==0)return _e}const Ye=ye-we,at=We-Le;return Ye<at?-1:Ye>at?1:0}function F(_){return _>=r.CharCode.Digit0&&_<=r.CharCode.Digit9}function W(_){return _>=r.CharCode.a&&_<=r.CharCode.z}function C(_){return _>=r.CharCode.A&&_<=r.CharCode.Z}function z(_,ge){return _.length===ge.length&&j(_,ge)===0}function se(_,ge){const we=ge.length;return ge.length>_.length?!1:j(_,ge,0,we)===0}function ie(_,ge){const we=Math.min(_.length,ge.length);let ye;for(ye=0;ye<we;ye++)if(_.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return we}function oe(_,ge){const we=Math.min(_.length,ge.length);let ye;const Le=_.length-1,We=ge.length-1;for(ye=0;ye<we;ye++)if(_.charCodeAt(Le-ye)!==ge.charCodeAt(We-ye))return ye;return we}function K(_){return 55296<=_&&_<=56319}function te(_){return 56320<=_&&_<=57343}function q(_,ge){return(_-55296<<10)+(ge-56320)+65536}function L(_,ge,we){const ye=_.charCodeAt(we);if(K(ye)&&we+1<ge){const Le=_.charCodeAt(we+1);if(te(Le))return q(ye,Le)}return ye}function B(_,ge){const we=_.charCodeAt(ge-1);if(te(we)&&ge>1){const ye=_.charCodeAt(ge-2);if(K(ye))return q(ye,we)}return we}class V{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=B(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=L(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Jf=V;class ae{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new V(ge,we)}nextGraphemeLength(){const ge=Ce.getInstance(),we=this.c,ye=we.offset;let Le=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const We=we.offset,Ye=ge.getGraphemeBreakType(we.nextCodePoint());if(Ue(Le,Ye)){we.setOffset(We);break}Le=Ye}return we.offset-ye}prevGraphemeLength(){const ge=Ce.getInstance(),we=this.c,ye=we.offset;let Le=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const We=we.offset,Ye=ge.getGraphemeBreakType(we.prevCodePoint());if(Ue(Ye,Le)){we.setOffset(We);break}Le=Ye}return ye-we.offset}eol(){return this.c.eol()}}e.$Kf=ae;function G(_,ge){return new ae(_,ge).nextGraphemeLength()}function he(_,ge){return new ae(_,ge).prevGraphemeLength()}function ne(_,ge){ge>0&&te(_.charCodeAt(ge))&&ge--;const we=ge+G(_,ge);return[we-he(_,we),we]}function Z(_){const ge=new ae(_);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let U;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(_){return U||(U=M()),U.test(_)}const H=/^[\t\n\r\x20-\x7E]*$/;function Q(_){return H.test(_)}e.$Rf=/[\u2028\u2029]/;function J(_){return e.$Rf.test(_)}function x(_){return _>=11904&&_<=55215||_>=63744&&_<=64255||_>=65281&&_<=65374}function ee(_){return _>=127462&&_<=127487||_===8986||_===8987||_===9200||_===9203||_>=9728&&_<=10175||_===11088||_===11093||_>=127744&&_<=128591||_>=128640&&_<=128764||_>=128992&&_<=129008||_>=129280&&_<=129535||_>=129648&&_<=129782}function de(_,ge,we=""){const ye=_.trimStart();if(ye.length<ge)return ye;const Le=/\b/g;let We=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<ge);)We=Le.lastIndex,Le.lastIndex+=1;return We===0?ye:we+ye.substring(We).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(_){let ge=0;for(const we of _.matchAll(me))ge!==we.index&&(yield{isCode:!1,str:_.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==_.length&&(yield{isCode:!1,str:_.substring(ge)})}function Ie(_){return _&&(_=_.replace(me,"")),_}const ke=/\\\[.*?\\\]/g;function Pe(_){return Ie(_).replace(ke,"")}e.$Zf=String.fromCharCode(r.CharCode.UTF8_BOM);function Ae(_){return!!(_&&_.length>0&&_.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(_){return Ae(_)?_.substr(1):_}function Y(_,ge){if(!_||!ge||_.length<ge.length)return!1;const we=ge.length,ye=_.toLowerCase();let Le=0,We=-1;for(;Le<we;){const Ye=ye.indexOf(ge[Le],We+1);if(Ye<0)return!1;We=Ye,Le++}return!0}function ue(_,ge=!1){return _?(ge&&(_=_.replace(/\\./g,"")),_.toLowerCase()!==_):!1}function fe(_){return _.charAt(0).toUpperCase()+_.slice(1)}function be(_,ge=1){if(ge===0)return"";let we=-1;do we=_.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?_:(_[we-1]==="\r"&&we--,_.substr(0,we))}function De(_){const ge=r.CharCode.Z-r.CharCode.A+1;return _=_%(2*ge),_<ge?String.fromCharCode(r.CharCode.a+_):String.fromCharCode(r.CharCode.A+_-ge)}function Ne(_){return Ce.getInstance().getGraphemeBreakType(_)}function Ue(_,ge){return _===Re.Other?ge!==Re.Extend&&ge!==Re.SpacingMark:_===Re.CR&&ge===Re.LF?!1:_===Re.Control||_===Re.CR||_===Re.LF||ge===Re.Control||ge===Re.CR||ge===Re.LF?!0:!(_===Re.L&&(ge===Re.L||ge===Re.V||ge===Re.LV||ge===Re.LVT)||(_===Re.LV||_===Re.V)&&(ge===Re.V||ge===Re.T)||(_===Re.LVT||_===Re.T)&&ge===Re.T||ge===Re.Extend||ge===Re.ZWJ||ge===Re.SpacingMark||_===Re.Prepend||_===Re.ZWJ&&ge===Re.Extended_Pictographic||_===Re.Regional_Indicator&&ge===Re.Regional_Indicator)}var Re;(function(_){_[_.Other=0]="Other",_[_.Prepend=1]="Prepend",_[_.CR=2]="CR",_[_.LF=3]="LF",_[_.Control=4]="Control",_[_.Extend=5]="Extend",_[_.Regional_Indicator=6]="Regional_Indicator",_[_.SpacingMark=7]="SpacingMark",_[_.L=8]="L",_[_.V=9]="V",_[_.T=10]="T",_[_.LV=11]="LV",_[_.LVT=12]="LVT",_[_.ZWJ=13]="ZWJ",_[_.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Ve()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Re.LF:ge===r.CharCode.CarriageReturn?Re.CR:Re.Control;if(ge<127)return Re.Other;const we=this.d,ye=we.length/3;let Le=1;for(;Le<=ye;)if(ge<we[3*Le])Le=2*Le;else if(ge>we[3*Le+1])Le=2*Le+1;else return we[3*Le+2];return Re.Other}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(_,ge){if(_===0)return 0;const we=ze(_,ge);if(we!==void 0)return we;const ye=new V(ge,_);return ye.prevCodePoint(),ye.offset}function ze(_,ge){const we=new V(ge,_);let ye=we.prevCodePoint();for(;Je(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(we.offset===0)return;ye=we.prevCodePoint()}if(!ee(ye))return;let Le=we.offset;return Le>0&&we.prevCodePoint()===Xe.zwj&&(Le=we.offset),Le}function Je(_){return 127995<=_&&_<=127999}var Xe;(function(_){_[_.zwj=8205]="zwj",_[_.emojiVariantSelector=65039]="emojiVariantSelector",_[_.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$0f="\xA0";class Ke{static{this.c=new k.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$7e({getCacheKey:JSON.stringify},ge=>{function we(_e){const ct=new Map;for(let ot=0;ot<_e.length;ot+=2)ct.set(_e[ot],_e[ot+1]);return ct}function ye(_e,ct){const ot=new Map(_e);for(const[ut,ft]of ct)ot.set(ut,ft);return ot}function Le(_e,ct){if(!_e)return ct;const ot=new Map;for(const[ut,ft]of _e)ct.has(ut)&&ot.set(ut,ft);return ot}const We=this.c.value;let Ye=ge.filter(_e=>!_e.startsWith("_")&&_e in We);Ye.length===0&&(Ye=["_default"]);let at;for(const _e of Ye){const ct=we(We[_e]);at=Le(at,ct)}const nt=we(We._common),rt=ye(nt,at);return new Ke(rt)})}static getInstance(ge){return Ke.d.get(Array.from(ge))}static{this.e=new k.$V(()=>Object.keys(Ke.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Ke;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(ge){return Fe.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&Fe.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Fe.e()}}e.$_f=Fe}),define(ce[47],le([0,1,26]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=r,e.$pj=k,e.$qj=A,e.$rj=I,e.$tj=g;function r(w){return k(w,0)}function k(w,p){switch(typeof w){case"object":return w===null?A(349,p):Array.isArray(w)?E(w,p):c(w,p);case"string":return I(w,p);case"boolean":return O(w,p);case"number":return A(w,p);case"undefined":return A(937,p);default:return A(617,p)}}function A(w,p){return(p<<5)-p+w|0}function O(w,p){return A(w?433:863,p)}function I(w,p){p=A(149417,p);for(let v=0,S=w.length;v<S;v++)p=A(w.charCodeAt(v),p);return p}function E(w,p){return p=A(104579,p),w.reduce((v,S)=>k(S,v),p)}function c(w,p){return p=A(181387,p),Object.keys(w).sort().reduce((v,S)=>(v=I(S,v),k(w[S],v)),p)}class f{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=k(p,this.g),this.g}}e.$sj=f;var d;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function $(w,p,v=32){const S=v-p,o=~((1<<S)-1);return(w<<p|(o&w)>>>S)>>>0}function y(w,p=0,v=w.byteLength,S=0){for(let o=0;o<v;o++)w[p+o]=S}function h(w,p,v="0"){for(;w.length<p;)w=v+w;return w}function g(w,p=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(v=>v.toString(16).padStart(2,"0")).join(""):h((w>>>0).toString(16),p/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const v=p.length;if(v===0)return;const S=this.p;let o=this.r,t=this.u,s,a;for(t!==0?(s=t,a=-1,t=0):(s=p.charCodeAt(0),a=0);;){let n=s;if(i.$Ff(s))if(a+1<v){const l=p.charCodeAt(a+1);i.$Gf(l)?(a++,n=i.$Hf(s,l)):n=d.UNICODE_REPLACEMENT}else{t=s;break}else i.$Gf(s)&&(n=d.UNICODE_REPLACEMENT);if(o=this.w(S,o,n),a++,a<v)s=p.charCodeAt(a);else break}this.r=o,this.u=t}w(p,v,S){return S<128?p[v++]=S:S<2048?(p[v++]=192|(S&1984)>>>6,p[v++]=128|(S&63)>>>0):S<65536?(p[v++]=224|(S&61440)>>>12,p[v++]=128|(S&4032)>>>6,p[v++]=128|(S&63)>>>0):(p[v++]=240|(S&1835008)>>>18,p[v++]=128|(S&258048)>>>12,p[v++]=128|(S&4032)>>>6,p[v++]=128|(S&63)>>>0),v>=d.BLOCK_SIZE&&(this.y(),v-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,p[0]=p[d.BLOCK_SIZE+0],p[1]=p[d.BLOCK_SIZE+1],p[2]=p[d.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=m.g,v=this.q;for(let b=0;b<64;b+=4)p.setUint32(b,v.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)p.setUint32(b,$(p.getUint32(b-12,!1)^p.getUint32(b-32,!1)^p.getUint32(b-56,!1)^p.getUint32(b-64,!1),1),!1);let S=this.h,o=this.l,t=this.m,s=this.n,a=this.o,n,l,u;for(let b=0;b<80;b++)b<20?(n=o&t|~o&s,l=1518500249):b<40?(n=o^t^s,l=1859775393):b<60?(n=o&t|o&s|t&s,l=2400959708):(n=o^t^s,l=3395469782),u=$(S,5)+n+a+l+p.getUint32(b*4,!1)&4294967295,a=s,s=t,t=$(o,30),o=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+a&4294967295}}e.$uj=m}),define(ce[79],le([0,1,26]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(r||(r={})),function(k){const A="error",O="warning",I="warn",E="info",c="ignore";function f($){return $?i.$Bf(A,$)?k.Error:i.$Bf(O,$)||i.$Bf(I,$)?k.Warning:i.$Bf(E,$)?k.Info:k.Ignore:k.Ignore}k.fromValue=f;function d($){switch($){case k.Error:return A;case k.Warning:return O;case k.Info:return E;default:return c}}k.toString=d}(r||(r={})),e.default=r}),define(ce[61],le([0,1,22,39,26]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class A{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const g=h.charCodeAt(0),m=this.b.charCodeAt(this.c);return g-m}value(){return this.b[this.c]}}e.$Ci=A;class O{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,k.$vf)(h,this.b,0,h.length,this.c,this.d):(0,k.$xf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=O;class I{constructor(h=!0,g=!0){this.f=h,this.g=g}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let g=h.length-1;g>=0;g--,this.c--){const m=this.b.charCodeAt(g);if(!(m===r.CharCode.Slash||this.f&&m===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===r.CharCode.Slash||this.f&&g===r.CharCode.Backslash)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,k.$vf)(h,this.b,0,h.length,this.d,this.e):(0,k.$xf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=I;var E;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(E||(E={}));class c{constructor(h,g){this.f=h,this.g=g,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(E.Scheme),this.c.authority&&this.d.push(E.Authority),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(E.Path)),this.g(h)||(this.c.query&&this.d.push(E.Query),this.c.fragment&&this.d.push(E.Fragment)),this.e=0,this}next(){return this.d[this.e]===E.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===E.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===E.Scheme)return(0,k.$wf)(h,this.c.scheme);if(this.d[this.e]===E.Authority)return(0,k.$wf)(h,this.c.authority);if(this.d[this.e]===E.Path)return this.b.cmp(h);if(this.d[this.e]===E.Query)return(0,k.$uf)(h,this.c.query);if(this.d[this.e]===E.Fragment)return(0,k.$uf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===E.Scheme)return this.c.scheme;if(this.d[this.e]===E.Authority)return this.c.authority;if(this.d[this.e]===E.Path)return this.b.value();if(this.d[this.e]===E.Query)return this.c.query;if(this.d[this.e]===E.Fragment)return this.c.fragment;throw new Error}}e.$Fi=c;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(d||(d={}));class ${static forUris(h=()=>!1,g=()=>!1){return new $(new c(h,g))}static forPaths(h=!1){return new $(new I(void 0,!h))}static forStrings(){return new $(new A)}static forConfigKeys(){return new $(new O)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,g){if(g){const m=g.slice(0);(0,i.$Wb)(m);for(const w of m)this.set(w,h)}else{const m=h.slice(0);(0,i.$Wb)(m);for(const w of m)this.set(w[0],w[1])}}set(h,g){const m=this.b.reset(h);let w;this.c||(this.c=new f,this.c.segment=m.value());const p=[];for(w=this.c;;){const S=m.cmp(w.segment);if(S>0)w.left||(w.left=new f,w.left.segment=m.value()),p.push([d.Left,w]),w=w.left;else if(S<0)w.right||(w.right=new f,w.right.segment=m.value()),p.push([d.Right,w]),w=w.right;else if(m.hasNext())m.next(),w.mid||(w.mid=new f,w.mid.segment=m.value()),p.push([d.Mid,w]),w=w.mid;else break}const v=w.value;w.value=g,w.key=h;for(let S=p.length-1;S>=0;S--){const o=p[S][1];o.updateHeight();const t=o.balanceFactor();if(t<-1||t>1){const s=p[S][0],a=p[S+1][0];if(s===d.Right&&a===d.Right)p[S][1]=o.rotateLeft();else if(s===d.Left&&a===d.Left)p[S][1]=o.rotateRight();else if(s===d.Right&&a===d.Left)o.right=p[S+1][1]=p[S+1][1].rotateRight(),p[S][1]=o.rotateLeft();else if(s===d.Left&&a===d.Right)o.left=p[S+1][1]=p[S+1][1].rotateLeft(),p[S][1]=o.rotateRight();else throw new Error;if(S>0)switch(p[S-1][0]){case d.Left:p[S-1][1].left=p[S][1];break;case d.Right:p[S-1][1].right=p[S][1];break;case d.Mid:p[S-1][1].mid=p[S][1];break}else this.c=p[0][1]}}return v}get(h){return this.d(h)?.value}d(h){const g=this.b.reset(h);let m=this.c;for(;m;){const w=g.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(g.hasNext())g.next(),m=m.mid;else break}return m}has(h){const g=this.d(h);return!(g?.value===void 0&&g?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,g){const m=this.b.reset(h),w=[];let p=this.c;for(;p;){const v=m.cmp(p.segment);if(v>0)w.push([d.Left,p]),p=p.left;else if(v<0)w.push([d.Right,p]),p=p.right;else if(m.hasNext())m.next(),w.push([d.Mid,p]),p=p.mid;else break}if(p){if(g?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const v=this.f(p.right);if(v.key){const{key:S,value:o,segment:t}=v;this.e(v.key,!1),p.key=S,p.value=o,p.segment=t}}else{const v=p.left??p.right;if(w.length>0){const[S,o]=w[w.length-1];switch(S){case d.Left:o.left=v;break;case d.Mid:o.mid=v;break;case d.Right:o.right=v;break}}else this.c=v}for(let v=w.length-1;v>=0;v--){const S=w[v][1];S.updateHeight();const o=S.balanceFactor();if(o>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),w[v][1]=S.rotateLeft()):o<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),w[v][1]=S.rotateRight()),v>0)switch(w[v-1][0]){case d.Left:w[v-1][1].left=w[v][1];break;case d.Right:w[v-1][1].right=w[v][1];break;case d.Mid:w[v-1][1].mid=w[v][1];break}else this.c=w[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const g=this.b.reset(h);let m=this.c,w;for(;m;){const p=g.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(g.hasNext())g.next(),w=m.value||w,m=m.mid;else break}return m&&m.value||w}findSuperstr(h){return this.g(h,!1)}g(h,g){const m=this.b.reset(h);let w=this.c;for(;w;){const p=m.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[g,m]of this)h(m,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const g=[];return this.j(h,g),g[Symbol.iterator]()}j(h,g){h&&(h.left&&this.j(h.left,g),h.value&&g.push([h.key,h.value]),h.mid&&this.j(h.mid,g),h.right&&this.j(h.right,g))}_isBalanced(){const h=g=>{if(!g)return!0;const m=g.balanceFactor();return m<-1||m>1?!1:h(g.left)&&h(g.right)};return h(this.c)}}e.$Gi=$}),define(ce[33],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=r;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(k){return i.test(k)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let E=0;E<I.length;E++)I[E]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let E=0,c="";return c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c+="-",c+=O[A[E++]],c+=O[A[E++]],c+="-",c+=O[A[E++]],c+=O[A[E++]],c+="-",c+=O[A[E++]],c+=O[A[E++]],c+="-",c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c+=O[A[E++]],c}}()}),define(ce[149],le([0,1,91,44,89]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lW=A;async function A(O,I){if(await new Promise((f,d)=>{const $=r.createReadStream(O),y=i.createHash("sha256");$.pipe(y);const h=(0,k.$db)((g,m)=>{$.removeAllListeners(),y.removeAllListeners(),g?d(g):f(m)});$.once("error",h),$.once("end",h),y.once("error",h),y.once("data",g=>h(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(ce[150],le([0,1,27]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=A;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(O){const I=O.replace(/\-/g,":").toLowerCase();return!r.has(I)}function A(){const O=(0,i.networkInterfaces)();for(const I in O){const E=O[I];if(E){for(const{mac:c}of E)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[112],le([0,1,92]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=r,e.$1g=A;function r(I,E,c,f=1){let d=!1;return new Promise($=>{const y=setTimeout(()=>{if(!d)return d=!0,$(0)},c);k(I,E,f,h=>{if(!d)return d=!0,clearTimeout(y),$(h)})})}function k(I,E,c,f){if(E===0)return f(0);const d=new i.Socket;d.once("connect",()=>(O(d),k(I+c,E-1,c,f))),d.once("data",()=>{}),d.once("error",$=>(O(d),$.code!=="ECONNREFUSED"?k(I+c,E-1,c,f):f(I))),d.connect(I,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,E,c,f="127.0.0.1"){let d=!1,$,y=1;const h=i.createServer({pauseOnConnect:!0});function g(m,w){d||(d=!0,h.removeAllListeners(),h.close(),$&&clearTimeout($),w(m))}return new Promise(m=>{$=setTimeout(()=>{g(0,m)},c),h.on("listening",()=>{g(I,m)}),h.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&y<E?(I++,y++,h.listen(I,f)):g(0,m)}),h.on("close",()=>{g(0,m)}),h.listen(I,f)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(E){console.error(E)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function i(E){const c=new Set;if(Array.isArray(E))for(const f of E)typeof f=="string"&&c.add(f);return Array.from(c)}function r(){const E=e();return E?Array.from(E):[]}function k(E){if(process.platform!=="win32")return;const c=e();if(c)if(typeof E=="string")c.add(E.toLowerCase());else for(const f of i(E))k(f)}function A(E){if(typeof E!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let f;for(const d of c){if(E.indexOf(d)!==0)continue;const y=E.indexOf("\\",d.length);if(y===-1)continue;const h=E.substring(d.length,y);if(h){f=h;break}}return f}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:k,getUNCHost:A,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[151],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rW=e.$qW=void 0,e.$qW="vscode:contextmenu",e.$rW="vscode:onCloseContextMenu"}),define(ce[152],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yW=void 0;class i{constructor(k,A){this.a=k,this.onMessage=A}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$yW=i}),define(ce[153],le([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ce[154],le([0,1,153]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=c,e.$8m=f,e.$9m=d;const r=60,k=r*60,A=k*24,O=A*7,I=A*30,E=A*365;function c($,y,h,g){typeof $!="number"&&($=$.getTime());const m=Math.round((new Date().getTime()-$)/1e3);if(m<-30)return(0,i.localize)(0,null,c(new Date().getTime()+m*1e3,!1));if(!g&&m<30)return(0,i.localize)(1,null);let w;return m<r?(w=m,y?w===1?h?(0,i.localize)(2,null,w):(0,i.localize)(3,null,w):h?(0,i.localize)(4,null,w):(0,i.localize)(5,null,w):w===1?h?(0,i.localize)(6,null,w):(0,i.localize)(7,null,w):h?(0,i.localize)(8,null,w):(0,i.localize)(9,null,w)):m<k?(w=Math.floor(m/r),y?w===1?h?(0,i.localize)(10,null,w):(0,i.localize)(11,null,w):h?(0,i.localize)(12,null,w):(0,i.localize)(13,null,w):w===1?h?(0,i.localize)(14,null,w):(0,i.localize)(15,null,w):h?(0,i.localize)(16,null,w):(0,i.localize)(17,null,w)):m<A?(w=Math.floor(m/k),y?w===1?h?(0,i.localize)(18,null,w):(0,i.localize)(19,null,w):h?(0,i.localize)(20,null,w):(0,i.localize)(21,null,w):w===1?h?(0,i.localize)(22,null,w):(0,i.localize)(23,null,w):h?(0,i.localize)(24,null,w):(0,i.localize)(25,null,w)):m<O?(w=Math.floor(m/A),y?w===1?(0,i.localize)(26,null,w):(0,i.localize)(27,null,w):w===1?(0,i.localize)(28,null,w):(0,i.localize)(29,null,w)):m<I?(w=Math.floor(m/O),y?w===1?h?(0,i.localize)(30,null,w):(0,i.localize)(31,null,w):h?(0,i.localize)(32,null,w):(0,i.localize)(33,null,w):w===1?h?(0,i.localize)(34,null,w):(0,i.localize)(35,null,w):h?(0,i.localize)(36,null,w):(0,i.localize)(37,null,w)):m<E?(w=Math.floor(m/I),y?w===1?h?(0,i.localize)(38,null,w):(0,i.localize)(39,null,w):h?(0,i.localize)(40,null,w):(0,i.localize)(41,null,w):w===1?h?(0,i.localize)(42,null,w):(0,i.localize)(43,null,w):h?(0,i.localize)(44,null,w):(0,i.localize)(45,null,w)):(w=Math.floor(m/E),y?w===1?h?(0,i.localize)(46,null,w):(0,i.localize)(47,null,w):h?(0,i.localize)(48,null,w):(0,i.localize)(49,null,w):w===1?h?(0,i.localize)(50,null,w):(0,i.localize)(51,null,w):h?(0,i.localize)(52,null,w):(0,i.localize)(53,null,w))}function f($,y){const h=Math.abs($/1e3);return h<1?y?(0,i.localize)(54,null,$):(0,i.localize)(55,null,$):h<r?y?(0,i.localize)(56,null,Math.round($)/1e3):(0,i.localize)(57,null,Math.round($)/1e3):h<k?y?(0,i.localize)(58,null,Math.round($/(1e3*r))):(0,i.localize)(59,null,Math.round($/(1e3*r))):h<A?y?(0,i.localize)(60,null,Math.round($/(1e3*k))):(0,i.localize)(61,null,Math.round($/(1e3*k))):(0,i.localize)(62,null,Math.round($/(1e3*A)))}function d($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[155],le([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ce[48],le([0,1,22,12,155]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=E,e.$mj=c,e.$nj=f;function A(d,$){return $&&(d.stack||d.stacktrace)?k.localize(0,null,I(d),O(d.stack)||O(d.stacktrace)):I(d)}function O(d){return Array.isArray(d)?d.join(`
`):d}function I(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?k.localize(1,null,d.message):d.message||k.localize(2,null)}function E(d=null,$=!1){if(!d)return k.localize(3,null);if(Array.isArray(d)){const y=i.$Hb(d),h=E(y[0],$);return y.length>1?k.localize(4,null,h,y.length):h}if(r.$ag(d))return d;if(d.detail){const y=d.detail;if(y.error)return A(y.error,$);if(y.exception)return A(y.exception,$)}return d.stack?A(d,$):d.message?d.message:k.localize(5,null)}function c(d){const $=d;return $ instanceof Error&&Array.isArray($.actions)}function f(d,$){let y;return typeof d=="string"?y=new Error(d):y=d,y.actions=$,y}}),define(ce[156],le([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ce[157],le([0,1,156,40]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=k;function k(A){switch(A){case r.ParseErrorCode.InvalidSymbol:return(0,i.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,i.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,i.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,i.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(8,null);default:return""}}}),define(ce[158],le([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ce[4],le([0,1,158]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=P,e.$J=R,e.$g="en";let r=!1,k=!1,A=!1,O=!1,I=!1,E=!1,c=!1,f=!1,d=!1,$=!1,y,h=e.$g,g=e.$g,m,w;const p=globalThis;let v;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?v=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const S=typeof v?.versions?.electron=="string",o=S&&v?.type==="renderer";if(typeof v=="object"){r=v.platform==="win32",k=v.platform==="darwin",A=v.platform==="linux",O=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,c=S,d=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,h=e.$g;const D=v.env.VSCODE_NLS_CONFIG;if(D)try{const T=JSON.parse(D),j=T.availableLanguages["*"];y=T.locale,g=T.osLocale,h=j||e.$g,m=T._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!o?(w=navigator.userAgent,r=w.indexOf("Windows")>=0,k=w.indexOf("Macintosh")>=0,f=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=w.indexOf("Linux")>=0,$=w?.indexOf("Mobi")>=0,E=!0,y=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,h=y,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(D){switch(D){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let a=t.Web;k?a=t.Mac:r?a=t.Windows:A&&(a=t.Linux),e.$i=r,e.$j=k,e.$k=A,e.$l=O,e.$m=I,e.$n=c,e.$o=E,e.$p=E&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=f,e.$s=$,e.$t=d,e.$u=a,e.$v=w,e.$w=h;var n;(function(D){function T(){return e.$w}D.value=T;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}D.isDefaultVariant=j;function F(){return e.$w==="en"}D.isDefault=F})(n||(e.Language=n={})),e.$x=y,e.$y=g,e.$z=m,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const D=[];p.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let F=0,W=D.length;F<W;F++){const C=D[F];if(C.id===j.data.vscodeScheduleAsyncWork){D.splice(F,1),C.callback();return}}});let T=0;return j=>{const F=++T;D.push({id:F,callback:j}),p.postMessage({vscodeScheduleAsyncWork:F},"*")}}return D=>setTimeout(D)})();var l;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=k||f?l.Macintosh:r?l.Windows:l.Linux;let u=!0,b=!1;function P(){if(!b){b=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,u=new Uint16Array(D.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(D){return parseFloat(D)>=20}}),define(ce[36],le([0,1,4]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const A=k.process;r={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$dc=r.platform,e.$ec=r.arch}),define(ce[9],le([0,1,36]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const r=65,k=97,A=90,O=122,I=46,E=47,c=92,f=58,d=63;class $ extends Error{constructor(s,a,n){let l;typeof a=="string"&&a.indexOf("not ")===0?(l="must not be",a=a.replace(/^not /,"")):l="must be";const u=s.indexOf(".")!==-1?"property":"argument";let b=`The "${s}" ${u} ${l} of type ${a}`;b+=`. Received type ${typeof n}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,s){if(t===null||typeof t!="object")throw new $(s,"Object",t)}function h(t,s){if(typeof t!="string")throw new $(s,"string",t)}const g=i.$dc==="win32";function m(t){return t===E||t===c}function w(t){return t===E}function p(t){return t>=r&&t<=A||t>=k&&t<=O}function v(t,s,a,n){let l="",u=0,b=-1,P=0,R=0;for(let D=0;D<=t.length;++D){if(D<t.length)R=t.charCodeAt(D);else{if(n(R))break;R=E}if(n(R)){if(!(b===D-1||P===1))if(P===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const T=l.lastIndexOf(a);T===-1?(l="",u=0):(l=l.slice(0,T),u=l.length-1-l.lastIndexOf(a)),b=D,P=0;continue}else if(l.length!==0){l="",u=0,b=D,P=0;continue}}s&&(l+=l.length>0?`${a}..`:"..",u=2)}else l.length>0?l+=`${a}${t.slice(b+1,D)}`:l=t.slice(b+1,D),u=D-b-1;b=D,P=0}else R===I&&P!==-1?++P:P=-1}return l}function S(t,s){y(s,"pathObject");const a=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${n}`:`${a}${t}${n}`:n}e.$fc={resolve(...t){let s="",a="",n=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],h(u,"path"),u.length===0)continue}else s.length===0?u=i.cwd():(u=i.env[`=${s}`]||i.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==s.toLowerCase()&&u.charCodeAt(2)===c)&&(u=`${s}\\`));const b=u.length;let P=0,R="",D=!1;const T=u.charCodeAt(0);if(b===1)m(T)&&(P=1,D=!0);else if(m(T))if(D=!0,m(u.charCodeAt(1))){let j=2,F=j;for(;j<b&&!m(u.charCodeAt(j));)j++;if(j<b&&j!==F){const W=u.slice(F,j);for(F=j;j<b&&m(u.charCodeAt(j));)j++;if(j<b&&j!==F){for(F=j;j<b&&!m(u.charCodeAt(j));)j++;(j===b||j!==F)&&(R=`\\\\${W}\\${u.slice(F,j)}`,P=j)}}}else P=1;else p(T)&&u.charCodeAt(1)===f&&(R=u.slice(0,2),P=2,b>2&&m(u.charCodeAt(2))&&(D=!0,P=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(n){if(s.length>0)break}else if(a=`${u.slice(P)}\\${a}`,n=D,D&&s.length>0)break}return a=v(a,!n,"\\",m),n?`${s}\\${a}`:`${s}${a}`||"."},normalize(t){h(t,"path");const s=t.length;if(s===0)return".";let a=0,n,l=!1;const u=t.charCodeAt(0);if(s===1)return w(u)?"\\":t;if(m(u))if(l=!0,m(t.charCodeAt(1))){let P=2,R=P;for(;P<s&&!m(t.charCodeAt(P));)P++;if(P<s&&P!==R){const D=t.slice(R,P);for(R=P;P<s&&m(t.charCodeAt(P));)P++;if(P<s&&P!==R){for(R=P;P<s&&!m(t.charCodeAt(P));)P++;if(P===s)return`\\\\${D}\\${t.slice(R)}\\`;P!==R&&(n=`\\\\${D}\\${t.slice(R,P)}`,a=P)}}}else a=1;else p(u)&&t.charCodeAt(1)===f&&(n=t.slice(0,2),a=2,s>2&&m(t.charCodeAt(2))&&(l=!0,a=3));let b=a<s?v(t.slice(a),!l,"\\",m):"";return b.length===0&&!l&&(b="."),b.length>0&&m(t.charCodeAt(s-1))&&(b+="\\"),n===void 0?l?`\\${b}`:b:l?`${n}\\${b}`:`${n}${b}`},isAbsolute(t){h(t,"path");const s=t.length;if(s===0)return!1;const a=t.charCodeAt(0);return m(a)||s>2&&p(a)&&t.charCodeAt(1)===f&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,a;for(let u=0;u<t.length;++u){const b=t[u];h(b,"path"),b.length>0&&(s===void 0?s=a=b:s+=`\\${b}`)}if(s===void 0)return".";let n=!0,l=0;if(typeof a=="string"&&m(a.charCodeAt(0))){++l;const u=a.length;u>1&&m(a.charCodeAt(1))&&(++l,u>2&&(m(a.charCodeAt(2))?++l:n=!1))}if(n){for(;l<s.length&&m(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.$fc.normalize(s)},relative(t,s){if(h(t,"from"),h(s,"to"),t===s)return"";const a=e.$fc.resolve(t),n=e.$fc.resolve(s);if(a===n||(t=a.toLowerCase(),s=n.toLowerCase(),t===s))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===c;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===c;)u--;const b=u-l;let P=0;for(;P<s.length&&s.charCodeAt(P)===c;)P++;let R=s.length;for(;R-1>P&&s.charCodeAt(R-1)===c;)R--;const D=R-P,T=b<D?b:D;let j=-1,F=0;for(;F<T;F++){const C=t.charCodeAt(l+F);if(C!==s.charCodeAt(P+F))break;C===c&&(j=F)}if(F!==T){if(j===-1)return n}else{if(D>T){if(s.charCodeAt(P+F)===c)return n.slice(P+F+1);if(F===2)return n.slice(P+F)}b>T&&(t.charCodeAt(l+F)===c?j=F:F===2&&(j=3)),j===-1&&(j=0)}let W="";for(F=l+j+1;F<=u;++F)(F===u||t.charCodeAt(F)===c)&&(W+=W.length===0?"..":"\\..");return P+=j,W.length>0?`${W}${n.slice(P,R)}`:(n.charCodeAt(P)===c&&++P,n.slice(P,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$fc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===c){if(s.charCodeAt(1)===c){const a=s.charCodeAt(2);if(a!==d&&a!==I)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===c)return`\\\\?\\${s}`;return t},dirname(t){h(t,"path");const s=t.length;if(s===0)return".";let a=-1,n=0;const l=t.charCodeAt(0);if(s===1)return m(l)?t:".";if(m(l)){if(a=n=1,m(t.charCodeAt(1))){let P=2,R=P;for(;P<s&&!m(t.charCodeAt(P));)P++;if(P<s&&P!==R){for(R=P;P<s&&m(t.charCodeAt(P));)P++;if(P<s&&P!==R){for(R=P;P<s&&!m(t.charCodeAt(P));)P++;if(P===s)return t;P!==R&&(a=n=P+1)}}}}else p(l)&&t.charCodeAt(1)===f&&(a=s>2&&m(t.charCodeAt(2))?3:2,n=a);let u=-1,b=!0;for(let P=s-1;P>=n;--P)if(m(t.charCodeAt(P))){if(!b){u=P;break}}else b=!1;if(u===-1){if(a===-1)return".";u=a}return t.slice(0,u)},basename(t,s){s!==void 0&&h(s,"ext"),h(t,"path");let a=0,n=-1,l=!0,u;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===f&&(a=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let b=s.length-1,P=-1;for(u=t.length-1;u>=a;--u){const R=t.charCodeAt(u);if(m(R)){if(!l){a=u+1;break}}else P===-1&&(l=!1,P=u+1),b>=0&&(R===s.charCodeAt(b)?--b===-1&&(n=u):(b=-1,n=P))}return a===n?n=P:n===-1&&(n=t.length),t.slice(a,n)}for(u=t.length-1;u>=a;--u)if(m(t.charCodeAt(u))){if(!l){a=u+1;break}}else n===-1&&(l=!1,n=u+1);return n===-1?"":t.slice(a,n)},extname(t){h(t,"path");let s=0,a=-1,n=0,l=-1,u=!0,b=0;t.length>=2&&t.charCodeAt(1)===f&&p(t.charCodeAt(0))&&(s=n=2);for(let P=t.length-1;P>=s;--P){const R=t.charCodeAt(P);if(m(R)){if(!u){n=P+1;break}continue}l===-1&&(u=!1,l=P+1),R===I?a===-1?a=P:b!==1&&(b=1):a!==-1&&(b=-1)}return a===-1||l===-1||b===0||b===1&&a===l-1&&a===n+1?"":t.slice(a,l)},format:S.bind(null,"\\"),parse(t){h(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const a=t.length;let n=0,l=t.charCodeAt(0);if(a===1)return m(l)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(m(l)){if(n=1,m(t.charCodeAt(1))){let j=2,F=j;for(;j<a&&!m(t.charCodeAt(j));)j++;if(j<a&&j!==F){for(F=j;j<a&&m(t.charCodeAt(j));)j++;if(j<a&&j!==F){for(F=j;j<a&&!m(t.charCodeAt(j));)j++;j===a?n=j:j!==F&&(n=j+1)}}}}else if(p(l)&&t.charCodeAt(1)===f){if(a<=2)return s.root=s.dir=t,s;if(n=2,m(t.charCodeAt(2))){if(a===3)return s.root=s.dir=t,s;n=3}}n>0&&(s.root=t.slice(0,n));let u=-1,b=n,P=-1,R=!0,D=t.length-1,T=0;for(;D>=n;--D){if(l=t.charCodeAt(D),m(l)){if(!R){b=D+1;break}continue}P===-1&&(R=!1,P=D+1),l===I?u===-1?u=D:T!==1&&(T=1):u!==-1&&(T=-1)}return P!==-1&&(u===-1||T===0||T===1&&u===P-1&&u===b+1?s.base=s.name=t.slice(b,P):(s.name=t.slice(b,u),s.base=t.slice(b,P),s.ext=t.slice(u,P))),b>0&&b!==n?s.dir=t.slice(0,b-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(g){const t=/\\/g;return()=>{const s=i.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();e.$gc={resolve(...t){let s="",a=!1;for(let n=t.length-1;n>=-1&&!a;n--){const l=n>=0?t[n]:o();h(l,"path"),l.length!==0&&(s=`${l}/${s}`,a=l.charCodeAt(0)===E)}return s=v(s,!a,"/",w),a?`/${s}`:s.length>0?s:"."},normalize(t){if(h(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===E,a=t.charCodeAt(t.length-1)===E;return t=v(t,!s,"/",w),t.length===0?s?"/":a?"./":".":(a&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return h(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let s;for(let a=0;a<t.length;++a){const n=t[a];h(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.$gc.normalize(s)},relative(t,s){if(h(t,"from"),h(s,"to"),t===s||(t=e.$gc.resolve(t),s=e.$gc.resolve(s),t===s))return"";const a=1,n=t.length,l=n-a,u=1,b=s.length-u,P=l<b?l:b;let R=-1,D=0;for(;D<P;D++){const j=t.charCodeAt(a+D);if(j!==s.charCodeAt(u+D))break;j===E&&(R=D)}if(D===P)if(b>P){if(s.charCodeAt(u+D)===E)return s.slice(u+D+1);if(D===0)return s.slice(u+D)}else l>P&&(t.charCodeAt(a+D)===E?R=D:D===0&&(R=0));let T="";for(D=a+R+1;D<=n;++D)(D===n||t.charCodeAt(D)===E)&&(T+=T.length===0?"..":"/..");return`${T}${s.slice(u+R)}`},toNamespacedPath(t){return t},dirname(t){if(h(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===E;let a=-1,n=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===E){if(!n){a=l;break}}else n=!1;return a===-1?s?"/":".":s&&a===1?"//":t.slice(0,a)},basename(t,s){s!==void 0&&h(s,"ext"),h(t,"path");let a=0,n=-1,l=!0,u;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let b=s.length-1,P=-1;for(u=t.length-1;u>=0;--u){const R=t.charCodeAt(u);if(R===E){if(!l){a=u+1;break}}else P===-1&&(l=!1,P=u+1),b>=0&&(R===s.charCodeAt(b)?--b===-1&&(n=u):(b=-1,n=P))}return a===n?n=P:n===-1&&(n=t.length),t.slice(a,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===E){if(!l){a=u+1;break}}else n===-1&&(l=!1,n=u+1);return n===-1?"":t.slice(a,n)},extname(t){h(t,"path");let s=-1,a=0,n=-1,l=!0,u=0;for(let b=t.length-1;b>=0;--b){const P=t.charCodeAt(b);if(P===E){if(!l){a=b+1;break}continue}n===-1&&(l=!1,n=b+1),P===I?s===-1?s=b:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||n===-1||u===0||u===1&&s===n-1&&s===a+1?"":t.slice(s,n)},format:S.bind(null,"/"),parse(t){h(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const a=t.charCodeAt(0)===E;let n;a?(s.root="/",n=1):n=0;let l=-1,u=0,b=-1,P=!0,R=t.length-1,D=0;for(;R>=n;--R){const T=t.charCodeAt(R);if(T===E){if(!P){u=R+1;break}continue}b===-1&&(P=!1,b=R+1),T===I?l===-1?l=R:D!==1&&(D=1):l!==-1&&(D=-1)}if(b!==-1){const T=u===0&&a?1:u;l===-1||D===0||D===1&&l===b-1&&l===u+1?s.base=s.name=t.slice(T,b):(s.name=t.slice(T,l),s.base=t.slice(T,b),s.ext=t.slice(l,b))}return u>0?s.dir=t.slice(0,u-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(ce[31],le([0,1,39,9,4,26,12]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=I,e.$tg=E,e.$ug=c,e.$vg=f,e.$wg=d,e.$xg=g,e.$yg=m,e.$zg=w,e.$Ag=p,e.$Bg=v,e.$Cg=S,e.$Dg=o,e.$Eg=t,e.$Fg=s,e.$Gg=a,e.$Hg=n,e.$Ig=b;function I(P){return P===i.CharCode.Slash||P===i.CharCode.Backslash}function E(P){return P.replace(/[\\/]/g,r.$gc.sep)}function c(P){return P.indexOf("/")===-1&&(P=E(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function f(P,R=r.$gc.sep){if(!P)return"";const D=P.length,T=P.charCodeAt(0);if(I(T)){if(I(P.charCodeAt(1))&&!I(P.charCodeAt(2))){let F=3;const W=F;for(;F<D&&!I(P.charCodeAt(F));F++);if(W!==F&&!I(P.charCodeAt(F+1))){for(F+=1;F<D;F++)if(I(P.charCodeAt(F)))return P.slice(0,F+1).replace(/[\\/]/g,R)}}return R}else if(p(T)&&P.charCodeAt(1)===i.CharCode.Colon)return I(P.charCodeAt(2))?P.slice(0,2)+R:P.slice(0,2);let j=P.indexOf("://");if(j!==-1){for(j+=3;j<D;j++)if(I(P.charCodeAt(j)))return P.slice(0,j+1)}return""}function d(P){if(!k.$i||!P||P.length<5)return!1;let R=P.charCodeAt(0);if(R!==i.CharCode.Backslash||(R=P.charCodeAt(1),R!==i.CharCode.Backslash))return!1;let D=2;const T=D;for(;D<P.length&&(R=P.charCodeAt(D),R!==i.CharCode.Backslash);D++);return!(T===D||(R=P.charCodeAt(D+1),isNaN(R)||R===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,y=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(P,R=k.$i){const D=R?$:y;return!(!P||P.length===0||/^\s+$/.test(P)||(D.lastIndex=0,D.test(P))||R&&h.test(P)||P==="."||P===".."||R&&P[P.length-1]==="."||R&&P.length!==P.trim().length||P.length>255)}function m(P,R,D){const T=P===R;return!D||T?T:!P||!R?!1:(0,A.$Bf)(P,R)}function w(P,R,D,T=r.sep){if(P===R)return!0;if(!P||!R||R.length>P.length)return!1;if(D){if(!(0,A.$Cf)(P,R))return!1;if(R.length===P.length)return!0;let F=R.length;return R.charAt(R.length-1)===T&&F--,P.charAt(F)===T}return R.charAt(R.length-1)!==T&&(R+=T),P.indexOf(R)===0}function p(P){return P>=i.CharCode.A&&P<=i.CharCode.Z||P>=i.CharCode.a&&P<=i.CharCode.z}function v(P,R){return k.$i&&P.endsWith(":")&&(P+=r.sep),(0,r.$ic)(P)||(P=(0,r.$jc)(R,P)),P=(0,r.$hc)(P),S(P)}function S(P){return k.$i?(P=(0,A.$jf)(P,r.sep),P.endsWith(":")&&(P+=r.sep)):(P=(0,A.$jf)(P,r.sep),P||(P=r.sep)),P}function o(P){const R=(0,r.$hc)(P);return k.$i?P.length>3?!1:t(R)&&(P.length===2||R.charCodeAt(2)===i.CharCode.Backslash):R===r.$gc.sep}function t(P,R=k.$i){return R?p(P.charCodeAt(0))&&P.charCodeAt(1)===i.CharCode.Colon:!1}function s(P,R=k.$i){return t(P,R)?P[0]:void 0}function a(P,R,D){return R.length>P.length?-1:P===R?0:(D&&(P=P.toLowerCase(),R=R.toLowerCase()),P.indexOf(R))}function n(P){const R=P.split(":");let D,T,j;for(const F of R){const W=Number(F);(0,O.$eg)(W)?T===void 0?T=W:j===void 0&&(j=W):D=D?[D,F].join(":"):F}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:T!==void 0?T:void 0,column:j!==void 0?j:T!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(P,R,D=8){let T="";for(let F=0;F<D;F++){let W;F===0&&k.$i&&!R&&(D===3||D===4)?W=u:W=l,T+=W.charAt(Math.floor(Math.random()*W.length))}let j;return R?j=`${R}-${T}`:j=T,P?(0,r.$jc)(P,j):j}}),define(ce[80],le([0,1,4]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$rm=A,e.$sm=O;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(I,...E){const c=E.reduce(($,y)=>($[y]=!0,$),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter($=>!c[$]).forEach($=>{for(let y=0;y<f.length;y++)if($.search(f[y])!==-1){delete I[$];break}})}function O(I){I&&(delete I.DEBUG,i.$j&&delete I.DYLD_LIBRARY_PATH,i.$k&&delete I.LD_PRELOAD)}}),define(ce[7],le([0,1,39,90,9,4]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=m,e.$wc=t;const O=/^\w[\w\d+.-]*$/,I=/^\//,E=/^\/\//;function c(u,b){if(!u.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!O.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!I.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(u,b){return!u&&!b?"file":u}function d(u,b){switch(u){case"https":case"http":case"file":b?b[0]!==y&&(b=y+b):b=y;break}return b}const $="",y="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(b){return b instanceof g?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,P,R,D,T,j=!1){typeof b=="object"?(this.scheme=b.scheme||$,this.authority=b.authority||$,this.path=b.path||$,this.query=b.query||$,this.fragment=b.fragment||$):(this.scheme=f(b,j),this.authority=P||$,this.path=d(this.scheme,R||$),this.query=D||$,this.fragment=T||$,c(this,j))}get fsPath(){return t(this,!1)}with(b){if(!b)return this;let{scheme:P,authority:R,path:D,query:T,fragment:j}=b;return P===void 0?P=this.scheme:P===null&&(P=$),R===void 0?R=this.authority:R===null&&(R=$),D===void 0?D=this.path:D===null&&(D=$),T===void 0?T=this.query:T===null&&(T=$),j===void 0?j=this.fragment:j===null&&(j=$),P===this.scheme&&R===this.authority&&D===this.path&&T===this.query&&j===this.fragment?this:new p(P,R,D,T,j)}static parse(b,P=!1){const R=h.exec(b);return R?new p(R[2]||$,l(R[4]||$),l(R[5]||$),l(R[7]||$),l(R[9]||$),P):new p($,$,$,$,$)}static file(b){let P=$;if(A.$i&&(b=b.replace(/\\/g,y)),b[0]===y&&b[1]===y){const R=b.indexOf(y,2);R===-1?(P=b.substring(2),b=y):(P=b.substring(2,R),b=b.substring(R)||y)}return new p("file",P,b,$,$)}static from(b,P){return new p(b.scheme,b.authority,b.path,b.query,b.fragment,P)}static joinPath(b,...P){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return A.$i&&b.scheme==="file"?R=g.file(k.$fc.join(t(b,!0),...P)).path:R=k.$gc.join(b.path,...P),b.with({path:R})}toString(b=!1){return s(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof g)return b;{const P=new p(b);return P._formatted=b.external??null,P._fsPath=b._sep===w?b.fsPath??null:null,P}}else return b}}e.URI=g;function m(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const w=A.$i?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(b=!1){return b?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const b={$mid:r.MarshalledId.Uri};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=w),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function S(u,b,P){let R,D=-1;for(let T=0;T<u.length;T++){const j=u.charCodeAt(T);if(j>=i.CharCode.a&&j<=i.CharCode.z||j>=i.CharCode.A&&j<=i.CharCode.Z||j>=i.CharCode.Digit0&&j<=i.CharCode.Digit9||j===i.CharCode.Dash||j===i.CharCode.Period||j===i.CharCode.Underline||j===i.CharCode.Tilde||b&&j===i.CharCode.Slash||P&&j===i.CharCode.OpenSquareBracket||P&&j===i.CharCode.CloseSquareBracket||P&&j===i.CharCode.Colon)D!==-1&&(R+=encodeURIComponent(u.substring(D,T)),D=-1),R!==void 0&&(R+=u.charAt(T));else{R===void 0&&(R=u.substr(0,T));const F=v[j];F!==void 0?(D!==-1&&(R+=encodeURIComponent(u.substring(D,T)),D=-1),R+=F):D===-1&&(D=T)}}return D!==-1&&(R+=encodeURIComponent(u.substring(D))),R!==void 0?R:u}function o(u){let b;for(let P=0;P<u.length;P++){const R=u.charCodeAt(P);R===i.CharCode.Hash||R===i.CharCode.QuestionMark?(b===void 0&&(b=u.substr(0,P)),b+=v[R]):b!==void 0&&(b+=u[P])}return b!==void 0?b:u}function t(u,b){let P;return u.authority&&u.path.length>1&&u.scheme==="file"?P=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===i.CharCode.Slash&&(u.path.charCodeAt(1)>=i.CharCode.A&&u.path.charCodeAt(1)<=i.CharCode.Z||u.path.charCodeAt(1)>=i.CharCode.a&&u.path.charCodeAt(1)<=i.CharCode.z)&&u.path.charCodeAt(2)===i.CharCode.Colon?b?P=u.path.substr(1):P=u.path[1].toLowerCase()+u.path.substr(2):P=u.path,A.$i&&(P=P.replace(/\//g,"\\")),P}function s(u,b){const P=b?o:S;let R="",{scheme:D,authority:T,path:j,query:F,fragment:W}=u;if(D&&(R+=D,R+=":"),(T||D==="file")&&(R+=y,R+=y),T){let C=T.indexOf("@");if(C!==-1){const z=T.substr(0,C);T=T.substr(C+1),C=z.lastIndexOf(":"),C===-1?R+=P(z,!1,!1):(R+=P(z.substr(0,C),!1,!1),R+=":",R+=P(z.substr(C+1),!1,!0)),R+="@"}T=T.toLowerCase(),C=T.lastIndexOf(":"),C===-1?R+=P(T,!1,!0):(R+=P(T.substr(0,C),!1,!0),R+=T.substr(C))}if(j){if(j.length>=3&&j.charCodeAt(0)===i.CharCode.Slash&&j.charCodeAt(2)===i.CharCode.Colon){const C=j.charCodeAt(1);C>=i.CharCode.A&&C<=i.CharCode.Z&&(j=`/${String.fromCharCode(C+32)}:${j.substr(3)}`)}else if(j.length>=2&&j.charCodeAt(1)===i.CharCode.Colon){const C=j.charCodeAt(0);C>=i.CharCode.A&&C<=i.CharCode.Z&&(j=`${String.fromCharCode(C+32)}:${j.substr(2)}`)}R+=P(j,!0,!1)}return F&&(R+="?",R+=P(F,!1,!1)),W&&(R+="#",R+=b?W:S(W,!1,!1)),R}function a(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+a(u.substr(3)):u}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(u){return u.match(n)?u.replace(n,b=>a(b)):u}}),define(ce[159],le([0,1,7]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=r,e.$5q=k,e.$6q=A,e.log=I;function r(c){const f=c;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function k(c){const f=[];let d;try{const $=JSON.parse(c.arguments),y=$[$.length-1];y&&y.__$stack&&($.pop(),d=y.__$stack),f.push(...$)}catch{f.push("Unable to log remote console arguments",c.arguments)}return{args:f,stack:d}}function A(c){if(typeof c!="string")return A(k(c).stack);const f=c;if(f){const d=O(f),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if($&&$.length===4)return{uri:i.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function O(c){if(!c)return c;const f=c.indexOf(`
`);return f===-1?c:c.substring(0,f)}function I(c,f){const{args:d,stack:$}=k(c),y=typeof d[0]=="string"&&d.length===1;let h=O($);h&&(h=`(${h.trim()})`);let g=[];if(typeof d[0]=="string"?h&&y?g=[`%c[${f}] %c${d[0]} %c${h}`,E("blue"),E(""),E("grey")]:g=[`%c[${f}] %c${d[0]}`,E("blue"),E(""),...d.slice(1)]:g=[`%c[${f}]%`,E("blue"),...d],h&&!y&&g.push(h),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function E(c){return`color: ${c}`}}),define(ce[81],le([0,1,17,7,90]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=A,e.$9h=O,e.$0h=E;function A(c){return JSON.stringify(c,I)}function O(c){let f=JSON.parse(c);return f=E(f),f}function I(c,f){return f instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function E(c,f=0){if(!c||f>200)return c;if(typeof c=="object"){switch(c.$mid){case k.MarshalledId.Uri:return r.URI.revive(c);case k.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case k.MarshalledId.Date:return new Date(c.source)}if(c instanceof i.$Je||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let d=0;d<c.length;++d)c[d]=E(c[d],f+1);else for(const d in c)Object.hasOwnProperty.call(c,d)&&(c[d]=E(c[d],f+1))}return c}}),define(ce[13],le([0,1,16,4,26,7,9]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=E,e.$Kg=c,e.$Og=d;var I;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(I||(e.Schemas=I={}));function E(h,g){return A.URI.isUri(h)?(0,k.$Bf)(h.scheme,g):(0,k.$Cf)(h,g+":")}function c(h,...g){return g.some(m=>E(h,m))}e.$Lg="vscode-tkn",e.$Mg="tkn";class f{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,m){this.f=d(g,m)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,I.vscodeRemoteResource)}set(g,m,w){this.a[g]=m,this.b[g]=w}setConnectionToken(g,m){this.c[g]=m}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(o){return i.$1(o),g}const m=g.authority;let w=this.a[m];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const p=this.b[m],v=this.c[m];let S=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(S+=`&${e.$Mg}=${encodeURIComponent(v)}`),A.URI.from({scheme:r.$o?this.d:I.vscodeRemoteResource,authority:`${w}:${p}`,path:this.g,query:S})}}e.$Ng=new f;function d(h,g){return O.$gc.join(g??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class ${static{this.a=e.$Tg}asBrowserUri(g){const m=this.b(g,X);return this.uriToBrowserUri(m)}uriToBrowserUri(g){return g.scheme===I.vscodeRemote?e.$Ng.rewrite(g):g.scheme===I.file&&(r.$m||r.$q===`${I.vscodeFileResource}://${$.a}`)?g.with({scheme:I.vscodeFileResource,authority:g.authority||$.a,query:null,fragment:null}):g}asFileUri(g){const m=this.b(g,X);return this.uriToFileUri(m)}uriToFileUri(g){return g.scheme===I.vscodeFileResource?g.with({scheme:I.file,authority:g.authority!==$.a?g.authority:null,query:null,fragment:null}):g}b(g,m){return A.URI.isUri(g)?g:A.URI.parse(m.toUrl(g))}}e.$Ug=new $;var y;(function(h){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(g.get("3"));const m="vscode-coi";function w(v){let S;typeof v=="string"?S=new URL(v).searchParams:v instanceof URL?S=v.searchParams:A.URI.isUri(v)&&(S=new URL(v.toString(!0)).searchParams);const o=S?.get(m);if(o)return g.get(o)}h.getHeadersFromQuery=w;function p(v,S,o){if(!globalThis.crossOriginIsolated)return;const t=S&&o?"3":o?"2":"1";v instanceof URLSearchParams?v.set(m,t):v[m]=t}h.addSearchParam=p})(y||(e.COI=y={}))}),define(ce[19],le([0,1,39,31,13,9,4,26,7]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=c,e.$kh=d,e.$lh=y;function c(h){return(0,E.$wc)(h,!0)}class f{constructor(g){this.a=g}compare(g,m,w=!1){return g===m?0:(0,I.$uf)(this.getComparisonKey(g,w),this.getComparisonKey(m,w))}isEqual(g,m,w=!1){return g===m?!0:!g||!m?!1:this.getComparisonKey(g,w)===this.getComparisonKey(m,w)}getComparisonKey(g,m=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,m,w=!1){if(g.scheme===m.scheme){if(g.scheme===k.Schemas.file)return r.$zg(c(g),c(m),this.a(g))&&g.query===m.query&&(w||g.fragment===m.fragment);if((0,e.$gh)(g.authority,m.authority))return r.$zg(g.path,m.path,this.a(g),"/")&&g.query===m.query&&(w||g.fragment===m.fragment)}return!1}joinPath(g,...m){return E.URI.joinPath(g,...m)}basenameOrAuthority(g){return(0,e.$$g)(g)||g.authority}basename(g){return A.$gc.basename(g.path)}extname(g){return A.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let m;return g.scheme===k.Schemas.file?m=E.URI.file(A.$mc(c(g))).path:(m=A.$gc.dirname(g.path),g.authority&&m.length&&m.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),m="/")),g.with({path:m})}normalizePath(g){if(!g.path.length)return g;let m;return g.scheme===k.Schemas.file?m=E.URI.file(A.$hc(c(g))).path:m=A.$gc.normalize(g.path),g.with({path:m})}relativePath(g,m){if(g.scheme!==m.scheme||!(0,e.$gh)(g.authority,m.authority))return;if(g.scheme===k.Schemas.file){const v=A.$lc(c(g),c(m));return O.$i?r.$tg(v):v}let w=g.path||"/";const p=m.path||"/";if(this.a(g)){let v=0;for(const S=Math.min(w.length,p.length);v<S&&!(w.charCodeAt(v)!==p.charCodeAt(v)&&w.charAt(v).toLowerCase()!==p.charAt(v).toLowerCase());v++);w=p.substr(0,v)+w.substr(v)}return A.$gc.relative(w,p)}resolvePath(g,m){if(g.scheme===k.Schemas.file){const w=E.URI.file(A.$kc(c(g),m));return g.with({authority:w.authority,path:w.path})}return m=r.$ug(m),g.with({path:A.$gc.resolve(g.path,m)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,m){return g===m||g!==void 0&&m!==void 0&&(0,I.$Bf)(g,m)}hasTrailingPathSeparator(g,m=A.sep){if(g.scheme===k.Schemas.file){const w=c(g);return w.length>r.$vg(w).length&&w[w.length-1]===m}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,m=A.sep){return(0,e.$hh)(g,m)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,m=A.sep){let w=!1;if(g.scheme===k.Schemas.file){const p=c(g);w=p!==void 0&&p.length===r.$vg(p).length&&p[p.length-1]===m}else{m="/";const p=g.path;w=p.length===1&&p.charCodeAt(p.length-1)===i.CharCode.Slash}return!w&&!(0,e.$hh)(g,m)?g.with({path:g.path+"/"}):g}}e.$3g=f,e.$4g=new f(()=>!1),e.$5g=new f(h=>h.scheme===k.Schemas.file?!O.$k:!0),e.$6g=new f(h=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function d(h,g){const m=[];for(let w=0;w<h.length;w++){const p=g(h[w]);h.some((v,S)=>S===w?!1:(0,e.$8g)(p,g(v)))||m.push(h[w])}return m}var $;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function g(m){const w=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(S=>{const[o,t]=S.split(":");o&&t&&w.set(o,t)});const v=m.path.substring(0,m.path.indexOf(";"));return v&&w.set(h.META_DATA_MIME,v),w}h.parseMetaData=g})($||(e.DataUri=$={}));function y(h,g,m){if(g){let w=h.path;return w&&w[0]!==A.$gc.sep&&(w=A.$gc.sep+w),h.with({scheme:m,authority:g,path:w})}return h.with({scheme:m})}}),define(ce[8],le([0,1,23,16,3,2,19,4,146,65]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=f,e.$nh=d,e.$oh=$,e.$ph=y,e.$qh=h,e.$rh=g,e.$sh=m,e.$th=w,e.$Bh=u,e.$Ch=b,e.$Dh=P,e.$Eh=R,e.$Fh=D,e.$Uh=L,e.$3h=H;function f(J){return!!J&&typeof J.then=="function"}function d(J){const x=new i.$se,ee=J(x.token),de=new Promise((me,pe)=>{const Ie=x.token.onCancellationRequested(()=>{Ie.dispose(),pe(new r.$5)});Promise.resolve(ee).then(ke=>{Ie.dispose(),x.dispose(),me(ke)},ke=>{Ie.dispose(),x.dispose(),pe(ke)})});return new class{cancel(){x.cancel(),x.dispose()}then(me,pe){return de.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function $(J,x,ee){return new Promise((de,me)=>{const pe=x.onCancellationRequested(()=>{pe.dispose(),de(ee)});J.then(de,me).finally(()=>pe.dispose())})}function y(J,x){return new Promise((ee,de)=>{const me=x.onCancellationRequested(()=>{me.dispose(),de(new r.$5)});J.then(ee,de).finally(()=>me.dispose())})}async function h(J){let x=-1;const ee=J.map((de,me)=>de.then(pe=>(x=me,pe)));try{return await Promise.race(ee)}finally{J.forEach((de,me)=>{me!==x&&de.cancel()})}}function g(J,x,ee){let de;const me=setTimeout(()=>{de?.(void 0),ee?.()},x);return Promise.race([J.finally(()=>clearTimeout(me)),new Promise(pe=>de=pe)])}function m(J){return new Promise((x,ee)=>{const de=J();f(de)?de.then(x,ee):x(de)})}function w(){let J,x;return{promise:new Promise((de,me)=>{J=de,x=me}),resolve:J,reject:x}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(x){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=x,!this.b){const ee=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ee,ee).then(de)})}return new Promise((ee,de)=>{this.b.then(ee,de)})}return this.a=x(),new Promise((ee,de)=>{this.a.then(me=>{this.a=null,ee(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$uh=p;class v{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.$vh=v;class S{constructor(){this.a=new Map}queue(x,ee){const me=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(x)===me&&this.a.delete(x)});return this.a.set(x,me),me}}e.$wh=S;const o=(J,x)=>{let ee=!0;const de=setTimeout(()=>{ee=!1,x()},J);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(de),ee=!1}}},t=J=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,J())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class s{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,ee=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ee===E.$ce?t(de):o(ee,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=s;class a{constructor(x){this.a=new s(x),this.b=new p}trigger(x,ee){return this.a.trigger(()=>this.b.queue(x),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=a;class n{constructor(){this.a=!1,this.b=new Promise((x,ee)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=n;class l extends n{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.$Ah=l;function u(J,x){return x?new Promise((ee,de)=>{const me=setTimeout(()=>{pe.dispose(),ee()},J),pe=x.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),de(new r.$5)})}):d(ee=>u(J,ee))}function b(J,x=0,ee){const de=setTimeout(()=>{J(),ee&&me.dispose()},x),me=(0,A.$Sc)(()=>{clearTimeout(de),ee?.deleteAndLeak(me)});return ee?.add(me),me}function P(J){const x=[];let ee=0;const de=J.length;function me(){return ee<de?J[ee++]():null}function pe(Ie){Ie!=null&&x.push(Ie);const ke=me();return ke?ke.then(pe):Promise.resolve(x)}return Promise.resolve(null).then(pe)}function R(J,x=de=>!!de,ee=null){let de=0;const me=J.length,pe=()=>{if(de>=me)return Promise.resolve(ee);const Ie=J[de++];return Promise.resolve(Ie()).then(Pe=>x(Pe)?Promise.resolve(Pe):pe())};return pe()}function D(J,x=de=>!!de,ee=null){if(J.length===0)return Promise.resolve(ee);let de=J.length;const me=()=>{de=-1;for(const pe of J)pe.cancel?.()};return new Promise((pe,Ie)=>{for(const ke of J)ke.then(Pe=>{--de>=0&&x(Pe)?(me(),pe(Pe)):de===0&&pe(ee)}).catch(Pe=>{--de>=0&&(me(),Ie(Pe))})})}class T{constructor(x){this.a=0,this.b=!1,this.f=x,this.g=[],this.d=0,this.h=new k.$he}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(x){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,de)=>{this.g.push({factory:x,c:ee,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const x=this.g.shift();this.d++;const ee=x.factory();ee.then(x.c,x.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=T;class j extends T{constructor(){super(1)}}e.$Hh=j;class F{constructor(){this.a=new B,this.b=0}queue(x){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,x())):this.a.run(this.b++,x())}}e.$Ih=F;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const x=new G;return this.b.add(x),x.p}g(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueSize(x,ee=O.$4g){const de=ee.getComparisonKey(x);return this.a.get(de)?.size??0}queueFor(x,ee,de=O.$4g){const me=de.getComparisonKey(x);let pe=this.a.get(me);if(!pe){pe=new j;const Ie=this.f++,ke=k.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(Ie,ke),this.a.set(me,pe)}return pe.queue(ee)}h(){this.g()&&this.j()}j(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=W;class C{constructor(x,ee){this.b=!1,this.a=-1,typeof x=="function"&&typeof ee=="number"&&this.setIfNotSet(x,ee)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,ee){if(this.b)throw new r.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},ee)}setIfNotSet(x,ee){if(this.b)throw new r.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},ee))}}e.$Kh=C;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(x,ee,de=globalThis){if(this.f)throw new r.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{x()},ee);this.d=(0,A.$Sc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=z;class se{constructor(x,ee){this.b=-1,this.a=x,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=se;class ie{constructor(x,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=x,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=ie;class oe extends se{constructor(x,ee){super(x,ee),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.$Oh=oe;class K extends A.$Uc{constructor(x,ee){super(),this.g=x,this.h=ee,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of x)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(J,x)=>{(0,I.$B)(()=>{if(ee)return;const de=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$Rh=(J,x,ee)=>{const de=J.requestIdleCallback(x,typeof ee=="number"?{timeout:ee}:void 0);let me=!1;return{dispose(){me||(me=!0,J.cancelIdleCallback(de))}}},e.$Qh=J=>(0,e.$Rh)(globalThis,J)}();class te{constructor(x,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Rh)(x,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=te;class q extends te{constructor(x){super(globalThis,x)}}e.$Th=q;async function L(J,x,ee){let de;for(let me=0;me<ee;me++)try{return await J()}catch(pe){de=pe,await u(x)}throw de}class B{isRunning(x){return typeof x=="number"?this.a?.taskId===x:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(x,ee,de){return this.a={taskId:x,cancel:()=>de?.(),promise:ee},ee.then(()=>this.d(x),()=>this.d(x)),ee}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}queue(x){if(this.b)this.b.run=x;else{const{promise:ee,resolve:de,reject:me}=w();this.b={run:x,promise:ee,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=B;class V{constructor(x,ee=()=>Date.now()){this.d=x,this.f=ee,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.$Wh=V;var ae;(function(J){J[J.Resolved=0]="Resolved",J[J.Rejected=1]="Rejected"})(ae||(ae={}));class G{get isRejected(){return this.d?.outcome===ae.Rejected}get isResolved(){return this.d?.outcome===ae.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ae.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((x,ee)=>{this.a=x,this.b=ee})}complete(x){return new Promise(ee=>{this.a(x),this.d={outcome:ae.Resolved,value:x},ee()})}error(x){return new Promise(ee=>{this.b(x),this.d={outcome:ae.Rejected,value:x},ee()})}cancel(){return this.error(new r.$5)}}e.$Xh=G;var he;(function(J){async function x(de){let me;const pe=await Promise.all(de.map(Ie=>Ie.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return pe}J.settled=x;function ee(de){return new Promise(async(me,pe)=>{try{await de(me,pe)}catch(Ie){pe(Ie)}})}J.withAsyncBody=ee})(he||(e.Promises=he={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(x){this.a=void 0,this.b=void 0,this.d=!1,this.promise=x.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new r.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=ne;class Z{constructor(x){this.b=x,this.a=new c.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=Z;var U;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(U||(U={}));class M{static fromArray(x){return new M(ee=>{ee.emitMany(x)})}static fromPromise(x){return new M(async ee=>{ee.emitMany(await x)})}static fromPromises(x){return new M(async ee=>{await Promise.all(x.map(async de=>ee.emitOne(await de)))})}static merge(x){return new M(async ee=>{await Promise.all(x.map(async de=>{for await(const me of de)ee.emitOne(me)}))})}static{this.EMPTY=M.fromArray([])}constructor(x,ee){this.a=U.Initial,this.b=[],this.d=null,this.f=ee,this.g=new k.$he,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(x(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(x,ee){return new M(async de=>{for await(const me of x)de.emitOne(ee(me))})}map(x){return M.map(this,x)}static filter(x,ee){return new M(async de=>{for await(const me of x)ee(me)&&de.emitOne(me)})}filter(x){return M.filter(this,x)}static coalesce(x){return M.filter(x,ee=>!!ee)}coalesce(){return M.coalesce(this)}static async toPromise(x){const ee=[];for await(const de of x)ee.push(de);return ee}toPromise(){return M.toPromise(this)}h(x){this.a===U.Initial&&(this.b.push(x),this.g.fire())}j(x){this.a===U.Initial&&(this.b=this.b.concat(x),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(x){this.a===U.Initial&&(this.a=U.DoneError,this.d=x,this.g.fire())}}e.$1h=M;class N extends M{constructor(x,ee){super(ee),this.m=x}cancel(){this.m.cancel()}}e.$2h=N;function H(J){const x=new i.$se,ee=J(x.token);return new N(x,async de=>{const me=x.token.onCancellationRequested(()=>{me.dispose(),x.dispose(),de.reject(new r.$5)});try{for await(const pe of ee){if(x.token.isCancellationRequested)return;de.emitOne(pe)}me.dispose(),x.dispose()}catch(pe){me.dispose(),x.dispose(),de.reject(pe)}})}class Q{constructor(x){this.a=new G,this.b=new M(me=>{if(ee){me.reject(ee);return}return de&&me.emitMany(de),this.d=pe=>me.reject(pe),this.f=pe=>me.emitOne(pe),this.a.p},x);let ee,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ee||(ee=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(x){this.d(x),this.a.complete()}emitOne(x){this.f(x)}}e.$4h=Q}),define(ce[113],le([0,1,22,8,39,31,32,9,4,26]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=f,e.$sk=g,e.$tk=F,e.$uk=W,e.$vk=C,e.$wk=z,e.$xk=se,e.$yk=te;function f(){return Object.create(null)}e.$qk="**",e.$rk="/";const d="[/\\\\]",$="[^/\\\\]",y=/\//g;function h(q,L){switch(q){case 0:return"";case 1:return`${$}*?`;default:return`(?:${d}|${$}+${d}${L?`|${d}${$}+`:""})*?`}}function g(q,L){if(!q)return[];const B=[];let V=!1,ae=!1,G="";for(const he of q){switch(he){case L:if(!V&&!ae){B.push(G),G="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}G+=he}return G&&B.push(G),B}function m(q){if(!q)return"";let L="";const B=g(q,e.$rk);if(B.every(V=>V===e.$qk))L=".*";else{let V=!1;B.forEach((ae,G)=>{if(ae===e.$qk){if(V)return;L+=h(2,G===B.length-1)}else{let he=!1,ne="",Z=!1,U="";for(const M of ae){if(M!=="}"&&he){ne+=M;continue}if(Z&&(M!=="]"||!U)){let N;M==="-"?N=M:(M==="^"||M==="!")&&!U?N="^":M===e.$rk?N="":N=(0,c.$df)(M),U+=N;continue}switch(M){case"{":he=!0;continue;case"[":Z=!0;continue;case"}":{const H=`(?:${g(ne,",").map(Q=>m(Q)).join("|")})`;L+=H,he=!1,ne="";break}case"]":{L+="["+U+"]",Z=!1,U="";break}case"?":L+=$;continue;case"*":L+=h(1);continue;default:L+=(0,c.$df)(M)}}G<B.length-1&&(B[G+1]!==e.$qk||G+2<B.length)&&(L+=d)}V=ae===e.$qk})}return L}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new O.$Dc(1e4),a=function(){return!1},n=function(){return null};function l(q,L){if(!q)return n;let B;typeof q!="string"?B=q.pattern:B=q,B=B.trim();const V=`${B}_${!!L.trimForExclusions}`;let ae=s.get(V);if(ae)return u(ae,q);let G;return w.test(B)?ae=P(B.substr(4),B):(G=p.exec(b(B,L)))?ae=R(G[1],B):(L.trimForExclusions?S:v).test(B)?ae=D(B,L):(G=o.exec(b(B,L)))?ae=T(G[1].substr(1),B,!0):(G=t.exec(b(B,L)))?ae=T(G[1],B,!1):ae=j(B),s.set(V,ae),u(ae,q)}function u(q,L){if(typeof L=="string")return q;const B=function(V,ae){return(0,A.$zg)(V,L.base,!E.$k)?q((0,c.$if)(V.substr(L.base.length),I.sep),ae):null};return B.allBasenames=q.allBasenames,B.allPaths=q.allPaths,B.basenames=q.basenames,B.patterns=q.patterns,B}function b(q,L){return L.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function P(q,L){return function(B,V){return typeof B=="string"&&B.endsWith(q)?L:null}}function R(q,L){const B=`/${q}`,V=`\\${q}`,ae=function(he,ne){return typeof he!="string"?null:ne?ne===q?L:null:he===q||he.endsWith(B)||he.endsWith(V)?L:null},G=[q];return ae.basenames=G,ae.patterns=[L],ae.allBasenames=G,ae}function D(q,L){const B=K(q.slice(1,-1).split(",").map(ne=>l(ne,L)).filter(ne=>ne!==n),q),V=B.length;if(!V)return n;if(V===1)return B[0];const ae=function(ne,Z){for(let U=0,M=B.length;U<M;U++)if(B[U](ne,Z))return q;return null},G=B.find(ne=>!!ne.allBasenames);G&&(ae.allBasenames=G.allBasenames);const he=B.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function T(q,L,B){const V=I.sep===I.$gc.sep,ae=V?q:q.replace(y,I.sep),G=I.sep+ae,he=I.$gc.sep+q;let ne;return B?ne=function(Z,U){return typeof Z=="string"&&(Z===ae||Z.endsWith(G)||!V&&(Z===q||Z.endsWith(he)))?L:null}:ne=function(Z,U){return typeof Z=="string"&&(Z===ae||!V&&Z===q)?L:null},ne.allPaths=[(B?"*/":"./")+q],ne}function j(q){try{const L=new RegExp(`^${m(q)}$`);return function(B){return L.lastIndex=0,typeof B=="string"&&L.test(B)?q:null}}catch{return n}}function F(q,L,B){return!q||typeof L!="string"?!1:W(q)(L,void 0,B)}function W(q,L={}){if(!q)return a;if(typeof q=="string"||C(q)){const B=l(q,L);if(B===n)return a;const V=function(ae,G){return!!B(ae,G)};return B.allBasenames&&(V.allBasenames=B.allBasenames),B.allPaths&&(V.allPaths=B.allPaths),V}return ie(q,L)}function C(q){const L=q;return L?typeof L.base=="string"&&typeof L.pattern=="string":!1}function z(q){return q.allBasenames||[]}function se(q){return q.allPaths||[]}function ie(q,L){const B=K(Object.getOwnPropertyNames(q).map(ne=>oe(ne,q[ne],L)).filter(ne=>ne!==n)),V=B.length;if(!V)return n;if(!B.some(ne=>!!ne.requiresSiblings)){if(V===1)return B[0];const ne=function(M,N){let H;for(let Q=0,J=B.length;Q<J;Q++){const x=B[Q](M,N);if(typeof x=="string")return x;(0,r.$mh)(x)&&(H||(H=[]),H.push(x))}return H?(async()=>{for(const Q of H){const J=await Q;if(typeof J=="string")return J}return null})():null},Z=B.find(M=>!!M.allBasenames);Z&&(ne.allBasenames=Z.allBasenames);const U=B.reduce((M,N)=>N.allPaths?M.concat(N.allPaths):M,[]);return U.length&&(ne.allPaths=U),ne}const ae=function(ne,Z,U){let M,N;for(let H=0,Q=B.length;H<Q;H++){const J=B[H];J.requiresSiblings&&U&&(Z||(Z=(0,I.$nc)(ne)),M||(M=Z.substr(0,Z.length-(0,I.$oc)(ne).length)));const x=J(ne,Z,M,U);if(typeof x=="string")return x;(0,r.$mh)(x)&&(N||(N=[]),N.push(x))}return N?(async()=>{for(const H of N){const Q=await H;if(typeof Q=="string")return Q}return null})():null},G=B.find(ne=>!!ne.allBasenames);G&&(ae.allBasenames=G.allBasenames);const he=B.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function oe(q,L,B){if(L===!1)return n;const V=l(q,B);if(V===n)return n;if(typeof L=="boolean")return V;if(L){const ae=L.when;if(typeof ae=="string"){const G=(he,ne,Z,U)=>{if(!U||!V(he,ne))return null;const M=ae.replace("$(basename)",()=>Z),N=U(M);return(0,r.$mh)(N)?N.then(H=>H?q:null):N?q:null};return G.requiresSiblings=!0,G}}return V}function K(q,L){const B=q.filter(ne=>!!ne.basenames);if(B.length<2)return q;const V=B.reduce((ne,Z)=>{const U=Z.basenames;return U?ne.concat(U):ne},[]);let ae;if(L){ae=[];for(let ne=0,Z=V.length;ne<Z;ne++)ae.push(L)}else ae=B.reduce((ne,Z)=>{const U=Z.patterns;return U?ne.concat(U):ne},[]);const G=function(ne,Z){if(typeof ne!="string")return null;if(!Z){let M;for(M=ne.length;M>0;M--){const N=ne.charCodeAt(M-1);if(N===k.CharCode.Slash||N===k.CharCode.Backslash)break}Z=ne.substr(M)}const U=V.indexOf(Z);return U!==-1?ae[U]:null};G.basenames=V,G.patterns=ae,G.allBasenames=V;const he=q.filter(ne=>!ne.basenames);return he.push(G),he}function te(q,L){return(0,i.$ub)(q,L,(B,V)=>typeof B=="string"&&typeof V=="string"?B===V:typeof B!="string"&&typeof V!="string"?B.base===V.base&&B.pattern===V.pattern:!1)}}),define(ce[49],le([0,1,22,31,9,4,19,26]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=E,e.$Nw=f,e.$Ow=$,e.$Pw=y,e.$Qw=w,e.$Rw=v,e.$Sw=S,e.$Tw=o,e.$Uw=t,e.$Vw=s;function E(n,l){const{os:u,tildify:b,relative:P}=l;if(P){const T=c(n,P,u);if(typeof T=="string")return T}let R=n.fsPath;if(u===A.OperatingSystem.Windows&&!A.$i?R=R.replace(/\//g,"\\"):u!==A.OperatingSystem.Windows&&A.$i&&(R=R.replace(/\\/g,"/")),u!==A.OperatingSystem.Windows&&b?.userHome){const T=b.userHome.fsPath;let j;n.scheme!==b.userHome.scheme&&n.path[0]===k.$gc.sep&&n.path[1]!==k.$gc.sep?j=b.userHome.with({path:n.path}).fsPath:j=R,R=$(j,T,u)}return(u===A.OperatingSystem.Windows?k.$fc:k.$gc).normalize(f(R,u===A.OperatingSystem.Windows))}function c(n,l,u){const b=u===A.OperatingSystem.Windows?k.$fc:k.$gc,P=u===A.OperatingSystem.Linux?O.$4g:O.$6g,R=l.getWorkspace(),D=(0,i.$Ob)(R.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path[0]===k.$gc.sep&&n.path[1]!==k.$gc.sep&&(n=D.uri.with({path:n.path}));const T=l.getWorkspaceFolder(n);if(!T)return;let j;if(P.isEqual(T.uri,n)?j="":j=P.relativePath(T.uri,n)??"",j&&(j=b.normalize(j)),R.folders.length>1&&!l.noPrefix){const F=T.name?T.name:P.basenameOrAuthority(T.uri);j=j?`${F} \u2022 ${j}`:F}return j}function f(n,l=A.$i){return(0,r.$Eg)(n,l)?n.charAt(0).toUpperCase()+n.slice(1):n}let d=Object.create(null);function $(n,l,u=A.OS){if(u===A.OperatingSystem.Windows||!n||!l)return n;let b=d.original===l?d.normalized:void 0;b||(b=l,A.$i&&(b=(0,r.$tg)(b)),b=`${(0,I.$jf)(b,k.$gc.sep)}${k.$gc.sep}`,d={original:l,normalized:b});let P=n;return A.$i&&(P=(0,r.$tg)(P)),(u===A.OperatingSystem.Linux?P.startsWith(b):(0,I.$Cf)(P,b))?`~/${P.substr(b.length)}`:n}function y(n,l){return n.replace(/^~($|\/|\\)/,`${l}$1`)}const h="\u2026",g="\\\\",m="~";function w(n,l=k.sep){const u=new Array(n.length);let b=!1;for(let P=0;P<n.length;P++){const R=n[P];if(R===""){u[P]=`.${l}`;continue}if(!R){u[P]=R;continue}b=!0;let D="",T=R;T.indexOf(g)===0?(D=T.substr(0,T.indexOf(g)+g.length),T=T.substr(T.indexOf(g)+g.length)):T.indexOf(l)===0?(D=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length)):T.indexOf(m)===0&&(D=T.substr(0,T.indexOf(m)+m.length),T=T.substr(T.indexOf(m)+m.length));const j=T.split(l);for(let F=1;b&&F<=j.length;F++)for(let W=j.length-F;b&&W>=0;W--){b=!1;let C=j.slice(W,W+F).join(l);for(let z=0;!b&&z<n.length;z++)if(z!==P&&n[z]&&n[z].indexOf(C)>-1){const se=W+F===j.length,ie=W>0&&n[z].indexOf(l)>-1?l+C:C,oe=n[z].endsWith(ie);b=!se||oe}if(!b){let z="";(j[0].endsWith(":")||D!=="")&&(W===1&&(W=0,F++,C=j[0]+l+C),W>0&&(z=j[0]+l),z=D+z),W>0&&(z=z+h+l),z=z+C,W+F<j.length&&(z=z+l+h),u[P]=z}}b&&(u[P]=R)}return u}var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function v(n,l=Object.create(null)){const u=[];let b=!1,P="";for(const R of n)if(R==="$"||b&&R==="{")P&&u.push({value:P,type:p.TEXT}),P="",b=!0;else if(R==="}"&&b){const D=l[P];if(typeof D=="string")D.length&&u.push({value:D,type:p.VARIABLE});else if(D){const T=u[u.length-1];(!T||T.type!==p.SEPARATOR)&&u.push({value:D.label,type:p.SEPARATOR})}P="",b=!1}else P+=R;return P&&!b&&u.push({value:P,type:p.TEXT}),u.filter((R,D)=>{if(R.type===p.SEPARATOR){const T=u[D-1],j=u[D+1];return[T,j].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(R=>R.value).join("")}function S(n,l){return A.$j||l?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):n.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function o(n,l){return A.$j||l?n.replace(/\(&&\w\)|&&/g,""):A.$i?n.replace(/&&|&/g,u=>u==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function s(n){if(n.endsWith("]")){const l=n.lastIndexOf(" [",n.length-2);if(l!==-1){const u=a(n.substring(0,l)),b=n.substring(l);return{name:u.name+b,parentPath:u.parentPath}}}return a(n)}function a(n){const l=n.indexOf("/")!==-1?k.$gc:k.$fc,u=l.basename(n),b=l.dirname(n);return u.length?{name:u,parentPath:b}:{name:b,parentPath:""}}}),define(ce[160],le([0,1,17,90,7]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=E,e.$Gn=f,e.$Hn=d;function A($){return $.toJSON()}class O{constructor(y){this.a=y}transformIncoming(y){const h=this.a.transformIncoming(y);return h===y?y:A(k.URI.from(h))}transformOutgoing(y){const h=this.a.transformOutgoing(y);return h===y?y:A(k.URI.from(h))}transformOutgoingURI(y){const h=this.a.transformOutgoing(y);return h===y?y:k.URI.from(h)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Dn=O,e.$En=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function I($,y,h){if(!$||h>200)return null;if(typeof $=="object"){if($ instanceof k.URI)return y.transformOutgoing($);for(const g in $)if(Object.hasOwnProperty.call($,g)){const m=I($[g],y,h+1);m!==null&&($[g]=m)}}return null}function E($,y){const h=I($,y,0);return h===null?$:h}function c($,y,h,g){if(!$||g>200)return null;if(typeof $=="object"){if($.$mid===r.MarshalledId.Uri)return h?k.URI.revive(y.transformIncoming($)):y.transformIncoming($);if($ instanceof i.$Je)return null;for(const m in $)if(Object.hasOwnProperty.call($,m)){const w=c($[m],y,h,g+1);w!==null&&($[m]=w)}}return null}function f($,y){const h=c($,y,!1,0);return h===null?$:h}function d($,y){const h=c($,y,!0,0);return h===null?$:h}}),define(ce[93],le([0,1,27,61,33,150,4]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Kn=E,e.$Ln=d,e.$Mn=$,e.$Jn=new class{c(y){return this.a||(this.a=r.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,h=0;const g=(0,i.networkInterfaces)();for(const m in g){const w=g[m];if(w)for(const{mac:p,internal:v}of w)v||(h+=1,this.c(p.toUpperCase())&&(y+=1))}this.b=h>0?y/h:0}return this.b}};let I;async function E(y){return I||(I=(async()=>await c(y)||k.$Wg())()),I}async function c(y){try{const h=await new Promise((m,w)=>{X(["crypto"],m,w)}),g=(0,A.$In)();return h.createHash("sha256").update(g,"utf8").digest("hex")}catch(h){y(h);return}}const f="Software\\Microsoft\\SQMClient";async function d(y){if(O.$i){const h=await new Promise((g,m)=>{X(["@vscode/windows-registry"],g,m)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(g){return y(g),""}}return""}async function $(y){try{return await(await new Promise((m,w)=>{X(["@vscode/deviceid"],m,w)})).getDeviceId()}catch(h){return y(h),""}}}),define(ce[21],le([0,1,44,27,161,8,31,76,9,4,19,7]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=v,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=P;var $;(function(ie){ie[ie.UNLINK=0]="UNLINK",ie[ie.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function y(ie,oe=$.UNLINK,K){if((0,O.$Dg)(ie))throw new Error("rimraf - will refuse to recursively delete root");return oe===$.UNLINK?g(ie):h(ie,K)}async function h(ie,oe=(0,O.$Ig)((0,r.tmpdir)())){try{try{await i.promises.rename(ie,oe)}catch(K){return K.code==="ENOENT"?void 0:g(ie)}g(oe).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function g(ie){return(0,k.promisify)(i.rm)(ie,{recursive:!0,force:!0,maxRetries:3})}function m(ie){if((0,O.$Dg)(ie))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(ie,{recursive:!0,force:!0,maxRetries:3})}async function w(ie,oe){return S(await(oe?p(ie):(0,k.promisify)(i.readdir)(ie)))}async function p(ie){try{return await(0,k.promisify)(i.readdir)(ie,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const oe=[],K=await w(ie);for(const te of K){let q=!1,L=!1,B=!1;try{const V=await e.Promises.lstat((0,E.$jc)(ie,te));q=V.isFile(),L=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}oe.push({name:te,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>B})}return oe}function v(ie){return S(i.readdirSync(ie))}function S(ie){return ie.map(oe=>typeof oe=="string"?c.$j?(0,I.$gm)(oe):oe:(oe.name=c.$j?(0,I.$gm)(oe.name):oe.name,oe))}async function o(ie){const oe=await w(ie),K=[];for(const te of oe)await s.existsDirectory((0,E.$jc)(ie,te))&&K.push(te);return K}function t(ie,oe=1e3){return new Promise(K=>{let te=!1;const q=setInterval(()=>{te||(te=!0,i.access(ie,L=>{te=!1,L&&(clearInterval(q),K(void 0))}))},oe)})}var s;(function(ie){async function oe(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw V}throw B}}ie.stat=oe;async function K(q){try{const{stat:L,symbolicLink:B}=await ie.stat(q);return L.isFile()&&B?.dangling!==!0}catch{}return!1}ie.existsFile=K;async function te(q){try{const{stat:L,symbolicLink:B}=await ie.stat(q);return L.isDirectory()&&B?.dangling!==!0}catch{}return!1}ie.existsDirectory=te})(s||(e.SymlinkSupport=s={}));const a=new A.$Jh;function n(ie,oe,K){return a.queueFor(d.URI.file(ie),()=>{const te=R(K);return new Promise((q,L)=>b(ie,oe,te,B=>B?L(B):q()))},f.$5g)}let l=!0;function u(ie){l=ie}function b(ie,oe,K,te){if(!l)return i.writeFile(ie,oe,{mode:K.mode,flag:K.flag},te);i.open(ie,K.flag,K.mode,(q,L)=>{if(q)return te(q);i.writeFile(L,oe,B=>{if(B)return i.close(L,()=>te(B));i.fdatasync(L,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),u(!1)),i.close(L,ae=>te(ae))))})})}function P(ie,oe,K){const te=R(K);if(!l)return i.writeFileSync(ie,oe,{mode:te.mode,flag:te.flag});const q=i.openSync(ie,te.flag,te.mode);try{i.writeFileSync(q,oe);try{i.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u(!1)}}finally{i.closeSync(q)}}function R(ie){return ie?{mode:typeof ie.mode=="number"?ie.mode:438,flag:typeof ie.flag=="string"?ie.flag:"w"}:{mode:438,flag:"w"}}async function D(ie,oe,K=6e4){if(ie!==oe)try{c.$i&&typeof K=="number"?await T(ie,oe,Date.now(),K):await(0,k.promisify)(i.rename)(ie,oe)}catch(te){if(ie.toLowerCase()!==oe.toLowerCase()&&te.code==="EXDEV"||ie.endsWith("."))await j(ie,oe,{preserveSymlinks:!1}),await y(ie,$.MOVE);else throw te}}async function T(ie,oe,K,te,q=0){try{return await(0,k.promisify)(i.rename)(ie,oe)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-K>=te)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let B=!1;try{const{stat:V}=await s.stat(oe);V.isFile()||(B=!0)}catch{}if(B)throw L}return await(0,A.$Bh)(Math.min(100,q*10)),T(ie,oe,K,te,q+1)}}async function j(ie,oe,K){return W(ie,oe,{root:{source:ie,target:oe},options:K,handledSourcePaths:new Set})}const F=511;async function W(ie,oe,K){if(K.handledSourcePaths.has(ie))return;K.handledSourcePaths.add(ie);const{stat:te,symbolicLink:q}=await s.stat(ie);if(q){if(K.options.preserveSymlinks)try{return await se(ie,oe,K)}catch{}if(q.dangling)return}return te.isDirectory()?C(ie,oe,te.mode&F,K):z(ie,oe,te.mode&F)}async function C(ie,oe,K,te){await e.Promises.mkdir(oe,{recursive:!0,mode:K});const q=await w(ie);for(const L of q)await W((0,E.$jc)(ie,L),(0,E.$jc)(oe,L),te)}async function z(ie,oe,K){await e.Promises.copyFile(ie,oe),await e.Promises.chmod(oe,K)}async function se(ie,oe,K){let te=await e.Promises.readlink(ie);(0,O.$zg)(te,K.root.source,!c.$k)&&(te=(0,E.$jc)(K.root.target,te.substr(K.root.source.length+1))),await e.Promises.symlink(te,oe)}e.Promises=new class{get access(){return(0,k.promisify)(i.access)}get stat(){return(0,k.promisify)(i.stat)}get lstat(){return(0,k.promisify)(i.lstat)}get utimes(){return(0,k.promisify)(i.utimes)}get read(){return(ie,oe,K,te,q)=>new Promise((L,B)=>{i.read(ie,oe,K,te,q,(V,ae,G)=>V?B(V):L({bytesRead:ae,buffer:G}))})}get readFile(){return(0,k.promisify)(i.readFile)}get write(){return(ie,oe,K,te,q)=>new Promise((L,B)=>{i.write(ie,oe,K,te,q,(V,ae,G)=>V?B(V):L({bytesWritten:ae,buffer:G}))})}get appendFile(){return(0,k.promisify)(i.appendFile)}get fdatasync(){return(0,k.promisify)(i.fdatasync)}get truncate(){return(0,k.promisify)(i.truncate)}get copyFile(){return(0,k.promisify)(i.copyFile)}get open(){return(0,k.promisify)(i.open)}get close(){return(0,k.promisify)(i.close)}get symlink(){return(0,k.promisify)(i.symlink)}get readlink(){return(0,k.promisify)(i.readlink)}get chmod(){return(0,k.promisify)(i.chmod)}get mkdir(){return(0,k.promisify)(i.mkdir)}get unlink(){return(0,k.promisify)(i.unlink)}get rmdir(){return(0,k.promisify)(i.rmdir)}get realpath(){return(0,k.promisify)(i.realpath)}async exists(ie){try{return await e.Promises.access(ie),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return o}get writeFile(){return n}get rm(){return y}get rename(){return D}get copy(){return j}}}),define(ce[114],le([0,1,44,9,4,26,21]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=I,e.$ar=E,e.$br=c,e.$cr=f;function I($){if(k.$k)return $;const y=(0,r.$mc)($);if($===y)return $;const h=((0,r.$nc)($)||$).toLowerCase();try{const m=(0,O.readdirSync)(y).filter(w=>w.toLowerCase()===h);if(m.length===1){const w=I(y);if(w)return(0,r.$jc)(w,m[0])}else if(m.length>1){const w=m.indexOf(h);if(w>=0){const p=I(y);if(p)return(0,r.$jc)(p,m[w])}}}catch{}return null}async function E($,y){if(k.$k)return $;const h=(0,r.$mc)($);if($===h)return $;const g=((0,r.$nc)($)||$).toLowerCase();try{if(y?.isCancellationRequested)return null;const w=(await O.Promises.readdir(h)).filter(p=>p.toLowerCase()===g);if(w.length===1){const p=await E(h,y);if(p)return(0,r.$jc)(p,w[0])}else if(w.length>1){const p=w.indexOf(g);if(p>=0){const v=await E(h,y);if(v)return(0,r.$jc)(v,w[p])}}}catch{}return null}async function c($){try{return await O.Promises.realpath($)}catch{const h=d($);return await O.Promises.access(h,i.constants.R_OK),h}}function f($){try{return i.realpathSync($)}catch{const h=d($);return i.accessSync(h,i.constants.R_OK),h}}function d($){return(0,A.$jf)((0,r.$hc)($),r.sep)}}),define(ce[115],le([0,1,27,9,21]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=p,e.$qm=v;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var E;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(E||(E={}));let c;switch(process.arch){case"ia32":c=E.x86;break;case"arm":case"arm64":c=E.ARM;break;default:c=E.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?E.ARM:E.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=E.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=E.x86:f=E.x64;class d{constructor(o,t,s){this.exePath=o,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:S=!1}={}){return S?c===E.x64?process.env["ProgramFiles(x86)"]||null:f===E.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:S=!1,findPreview:o=!1}={}){const t=$({useAlternateBitness:S});if(!t)return null;const s=r.$jc(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let a=-1,n=null;for(const b of await k.Promises.readdir(s)){let P=-1;if(o){const D=b.indexOf("-");if(D<0)continue;const T=b.substring(0,D);if(!A.test(T)||b.substring(D+1)!=="preview")continue;P=parseInt(T,10)}else{if(!A.test(b))continue;P=parseInt(b,10)}if(P<=a)continue;const R=r.$jc(s,b,"pwsh.exe");await k.SymlinkSupport.existsFile(R)&&(n=R,a=P)}if(!n)return null;const l=t.includes("x86")?" (x86)":"",u=o?" Preview":"";return new d(n,`PowerShell${u}${l}`,!0)}async function h({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const o=r.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const a of await k.Promises.readdir(o))if(t.test(a)){const n=r.$jc(o,a,"pwsh.exe");return new d(n,s)}return null}function g(){const S=r.$jc(i.homedir(),".dotnet","tools","pwsh.exe");return new d(S,".NET Core PowerShell Global Tool")}function m(){const S=r.$jc(process.env.windir,c===E.x86&&f!==E.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(S,"Windows PowerShell",!0)}async function*w(){let S=await y();S&&(yield S),S=await y({useAlternateBitness:!0}),S&&(yield S),S=await h(),S&&(yield S),S=g(),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await h({findPreview:!0}),S&&(yield S),S=await y({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=m(),S&&(yield S)}async function*p(){for await(const S of w())await S.exists()&&(yield S)}async function v(){for await(const S of p())return S;return null}}),define(ce[94],le([0,1,9,4,36,80,12,21]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$tm=E,e.$um=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function E(d=k.env){return d.comspec||"cmd.exe"}function c(d){let $=[],y=!1;const h=function(g){if(y){$.push(g);return}(!d.send(g,w=>{if(w&&console.error(w),y=!1,$.length>0){const p=$.slice(0);$=[],p.forEach(v=>h(v))}})||r.$i)&&(y=!0)};return{send:h}}var f;(function(d){async function $(y,h,g){if(i.$ic(y))return y;if(h===void 0&&(h=k.cwd()),i.$mc(y)!=="."||(g===void 0&&O.$ag(k.env.PATH)&&(g=k.env.PATH.split(i.$tc)),g===void 0||g.length===0))return i.$jc(h,y);async function w(p){if(await I.Promises.exists(p)){let v;try{v=await I.Promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(v=await I.Promises.lstat(p))}return v?!v.isDirectory():!1}return!1}for(const p of g){let v;if(i.$ic(p)?v=i.$jc(p,y):v=i.$jc(h,p,y),await w(v))return v;let S=v+".com";if(await w(S)||(S=v+".exe",await w(S)))return S}return i.$jc(h,y)}d.findExecutable=$})(f||(e.win32=f={}))}),define(ce[116],le([0,1,50,13]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=k;function k(O){return new Promise((I,E)=>{let c;const f=new Map;function d(y,h,g,m,w){const p=f.get(h);if(y===O||p){const v={name:$(g),cmd:g,pid:y,ppid:h,load:m,mem:w};f.set(y,v),y===O&&(c=v),p&&(p.children||(p.children=[]),p.children.push(v),p.children.length>1&&(p.children=p.children.sort((S,o)=>S.pid-o.pid)))}}function $(y){const h=/--utility-sub-type=network/i,g=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,w=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"electron-crash-reporter";if(m.exec(y))return"winpty-agent";if(w.exec(y))return"conpty-agent";let v=p.exec(y);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?h.exec(y)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const S=/[a-zA-Z-]+\.js/g;let o="";do v=S.exec(y),v&&(o+=v+" ");while(v);return o&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron-nodejs (${o})`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,g)=>{X(["@vscode/windows-process-tree"],h,g)}).then(h=>{h.getProcessList(O,g=>{if(!g){E(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(g,m=>{const w=new Map;m.forEach(p=>{const v=y(p.commandLine||"");w.set(p.pid,{name:$(v),cmd:v,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),c=w.get(O),c?(w.forEach(p=>{const v=w.get(p.ppid);v&&(v.children||(v.children=[]),v.children.push(p))}),w.forEach(p=>{p.children&&(p.children=p.children.sort((v,S)=>v.pid-S.pid))}),I(c)):E(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[c];const g=[];for(;h.length;){const w=h.shift();w&&(g.push(w.pid),w.children&&(h=h.concat(w.children)))}let m=JSON.stringify(r.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+g.join(" "),(0,i.exec)(m,{},(w,p,v)=>{if(w||v)E(w||new Error(v.toString()));else{const S=p.toString().split(`
`);for(let o=0;o<g.length;o++){const t=f.get(g[o]);t.load=parseFloat(S[o])}if(!c){E(new Error(`Root process ${O} not found`));return}I(c)}})};(0,i.exec)("which ps",{},(h,g,m)=>{if(h||m)if(process.platform!=="linux")E(h||new Error(m.toString()));else{const w=JSON.stringify(r.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(w,{},(p,v,S)=>{p||S?E(p||new Error(S.toString())):(A(v,d),y())})}else{const w=g.toString().trim();(0,i.exec)(`${w} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,S,o)=>{v||o&&!o.includes("screen size is bogus")?E(v||new Error(o.toString())):(A(S,d),process.platform==="linux"?y():c?I(c):E(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=O.toString().split(`
`);for(const f of c){const d=E.exec(f.trim());d&&d.length===6&&I(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(ce[117],le([0,1,27,4,115,94]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=O;async function O(d,$){return d===r.OperatingSystem.Windows?r.$i?f():A.$tm($):E(d,$)}let I=null;function E(d,$){if(r.$k&&d===r.OperatingSystem.Macintosh||r.$j&&d===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let y;if(r.$i)y="/bin/bash";else{if(y=$.SHELL,!y)try{y=(0,i.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}I=y}return I}let c=null;async function f(){return c||(c=(await(0,k.$qm)()).exePath),c}});var Se=this&&this.__decorate||function(X,e,i,r){var k=arguments.length,A=k<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(X,e,i,r);else for(var I=X.length-1;I>=0;I--)(O=X[I])&&(A=(k<3?O(A):k>3?O(e,i,A):O(e,i))||A);return k>3&&A&&Object.defineProperty(e,i,A),A};define(ce[45],le([0,1,22,8,17,23,53,16,3,2,81,26,12]),function(X,e,i,r,k,A,O,I,E,c,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=u,e.$bi=b,e.$gi=F,e.$hi=W;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function h(q){switch(q){case y.Promise:return"req";case y.PromiseCancel:return"cancel";case y.EventListen:return"subscribe";case y.EventDispose:return"unsubscribe"}}var g;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(g||(g={}));function m(q){switch(q){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var w;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(w||(w={}));function p(q){let L=0;for(let B=0;;B+=7){const V=q.read(1);if(L|=(V.buffer[0]&127)<<B,!(V.buffer[0]&128))return L}}const v=a(0);function S(q,L){if(L===0){q.write(v);return}let B=0;for(let ae=L;ae!==0;ae=ae>>>7)B++;const V=k.$Je.alloc(B);for(let ae=0;L!==0;ae++)V.buffer[ae]=L&127,L=L>>>7,L>0&&(V.buffer[ae]|=128);q.write(V)}class o{constructor(L){this.b=L,this.a=0}read(L){const B=this.b.slice(this.a,this.a+L);return this.a+=B.byteLength,B}}e.$$h=o;class t{constructor(){this.a=[]}get buffer(){return k.$Je.concat(this.a)}write(L){this.a.push(L)}}e.$_h=t;var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(s||(s={}));function a(q){const L=k.$Je.alloc(1);return L.writeUInt8(q,0),L}const n={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object),Uint:a(s.Int)},l=typeof Buffer<"u";function u(q,L){if(typeof L>"u")q.write(n.Undefined);else if(typeof L=="string"){const B=k.$Je.fromString(L);q.write(n.String),S(q,B.byteLength),q.write(B)}else if(l&&Buffer.isBuffer(L)){const B=k.$Je.wrap(L);q.write(n.Buffer),S(q,B.byteLength),q.write(B)}else if(L instanceof k.$Je)q.write(n.VSBuffer),S(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(n.Array),S(q,L.length);for(const B of L)u(q,B)}else if(typeof L=="number"&&(L|0)===L)q.write(n.Uint),S(q,L);else{const B=k.$Je.fromString(JSON.stringify(L));q.write(n.Object),S(q,B.byteLength),q.write(B)}}function b(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read(p(q)).toString();case s.Buffer:return q.read(p(q)).buffer;case s.VSBuffer:return q.read(p(q));case s.Array:{const B=p(q),V=[];for(let ae=0;ae<B;ae++)V.push(b(q));return V}case s.Object:return JSON.parse(q.read(p(q)).toString());case s.Int:return p(q)}}class P{constructor(L,B,V=null,ae=1e3){this.h=L,this.j=B,this.k=V,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:g.Initialize})}registerChannel(L,B){this.b.set(L,B),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case g.Initialize:{const B=this.o([L.type]);this.k?.logOutgoing(B,0,R.OtherSide,m(L.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const B=this.o([L.type,L.id],L.data);this.k?.logOutgoing(B,L.id,R.OtherSide,m(L.type),L.data);return}}}o(L,B=void 0){const V=new t;return u(V,L),u(V,B),this.p(V.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const B=new o(L),V=b(B),ae=b(B),G=V[0];switch(G){case y.Promise:return this.k?.logIncoming(L.byteLength,V[1],R.OtherSide,`${h(G)}: ${V[2]}.${V[3]}`,ae),this.s({type:G,id:V[1],channelName:V[2],name:V[3],arg:ae});case y.EventListen:return this.k?.logIncoming(L.byteLength,V[1],R.OtherSide,`${h(G)}: ${V[2]}.${V[3]}`,ae),this.t({type:G,id:V[1],channelName:V[2],name:V[3],arg:ae});case y.PromiseCancel:return this.k?.logIncoming(L.byteLength,V[1],R.OtherSide,`${h(G)}`),this.u({type:G,id:V[1]});case y.EventDispose:return this.k?.logIncoming(L.byteLength,V[1],R.OtherSide,`${h(G)}`),this.u({type:G,id:V[1]})}}s(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const V=new A.$se;let ae;try{ae=B.call(this.j,L.name,L.arg,V.token)}catch(ne){ae=Promise.reject(ne)}const G=L.id;ae.then(ne=>{this.m({id:G,data:ne,type:g.PromiseSuccess})},ne=>{ne instanceof Error?this.m({id:G,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:g.PromiseError}):this.m({id:G,data:ne,type:g.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,c.$Sc)(()=>V.cancel());this.d.set(L.id,he)}t(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const V=L.id,G=B.listen(this.j,L.name,L.arg)(he=>this.m({id:V,data:he,type:g.EventFire}));this.d.set(L.id,G)}u(L){const B=this.d.get(L.id);B&&(B.dispose(),this.d.delete(L.id))}v(L){let B=this.g.get(L.channelName);B||(B=[],this.g.set(L.channelName,B));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===y.Promise&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);B.push({request:L,timeoutTimer:V})}w(L){const B=this.g.get(L);if(B){for(const V of B)switch(clearTimeout(V.timeoutTimer),V.request.type){case y.Promise:this.s(V.request);break;case y.EventListen:this.t(V.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ci=P;var R;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class D{constructor(L,B=null){this.l=L,this.a=!1,this.b=w.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=B}getChannel(L){const B=this;return{call(V,ae,G){return B.a?Promise.reject(new I.$5):B.m(L,V,ae,G)},listen(V,ae){return B.a?E.Event.None:B.o(L,V,ae)}}}m(L,B,V,ae=A.CancellationToken.None){const G=this.g++,he=y.Promise,ne={id:G,type:he,channelName:L,name:B,arg:V};if(ae.isCancellationRequested)return Promise.reject(new I.$5);let Z;return new Promise((M,N)=>{if(ae.isCancellationRequested)return N(new I.$5);const H=()=>{const ee=de=>{switch(de.type){case g.PromiseSuccess:this.f.delete(G),M(de.data);break;case g.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,N(me);break}case g.PromiseErrorObj:this.f.delete(G),N(de.data);break}};this.f.set(G,ee),this.p(ne)};let Q=null;this.b===w.Idle?H():(Q=(0,r.$nh)(ee=>this.u()),Q.then(()=>{Q=null,H()}));const J=()=>{Q?(Q.cancel(),Q=null):this.p({id:G,type:y.PromiseCancel}),N(new I.$5)},x=ae.onCancellationRequested(J);Z=(0,c.$Rc)((0,c.$Sc)(J),x),this.d.add(Z)}).finally(()=>{Z.dispose(),this.d.delete(Z)})}o(L,B,V){const ae=this.g++,G=y.EventListen,he={id:ae,type:G,channelName:L,name:B,arg:V};let ne=null;const Z=new E.$he({onWillAddFirstListener:()=>{ne=(0,r.$nh)(M=>this.u()),ne.then(()=>{ne=null,this.d.add(Z),this.p(he)})},onDidRemoveLastListener:()=>{ne?(ne.cancel(),ne=null):(this.d.delete(Z),this.p({id:ae,type:y.EventDispose}))}}),U=M=>Z.fire(M.data);return this.f.set(ae,U),Z.event}p(L){switch(L.type){case y.Promise:case y.EventListen:{const B=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(B,L.id,R.LocalSide,`${h(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case y.PromiseCancel:case y.EventDispose:{const B=this.q([L.type,L.id]);this.j?.logOutgoing(B,L.id,R.LocalSide,h(L.type));return}}}q(L,B=void 0){const V=new t;return u(V,L),u(V,B),this.r(V.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const B=new o(L),V=b(B),ae=b(B),G=V[0];switch(G){case g.Initialize:return this.j?.logIncoming(L.byteLength,0,R.LocalSide,m(G)),this.t({type:V[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(L.byteLength,V[1],R.LocalSide,m(G),ae),this.t({type:V[0],id:V[1],data:ae})}}t(L){if(L.type===g.Initialize){this.b=w.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$di=D,Se([O.$5h],D.prototype,"onDidInitializePromise",null);class T{get connections(){const L=[];return this.f.forEach(B=>L.push(B)),L}constructor(L,B,V){this.a=new Map,this.f=new Set,this.g=new E.$he,this.onDidAddConnection=this.g.event,this.h=new E.$he,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(L(({protocol:ae,onDidClientDisconnect:G})=>{const he=E.Event.once(ae.onMessage);this.j.add(he(ne=>{const Z=new o(ne),U=b(Z),M=new P(ae,U,B,V),N=new D(ae,B);this.a.forEach((Q,J)=>M.registerChannel(J,Q));const H={channelServer:M,channelClient:N,ctx:U};this.f.add(H),this.g.fire(H),this.j.add(G(()=>{M.dispose(),N.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(L,B){const V=this;return{call(ae,G,he){let ne;if((0,$.$og)(B)){const U=(0,i.$3b)(V.connections.filter(B));ne=U?Promise.resolve(U):E.Event.toPromise(E.Event.filter(V.onDidAddConnection,B))}else ne=B.routeCall(V,ae,G);const Z=ne.then(U=>U.channelClient.getChannel(L));return F(Z).call(ae,G,he)},listen(ae,G){if((0,$.$og)(B))return V.k(L,B,ae,G);const he=B.routeEvent(V,ae,G).then(ne=>ne.channelClient.getChannel(L));return F(he).listen(ae,G)}}}k(L,B,V,ae){const G=this;let he;const ne=new E.$he({onWillAddFirstListener:()=>{he=new c.$Tc;const Z=new E.$ne,U=new Map,M=H=>{const J=H.channelClient.getChannel(L).listen(V,ae),x=Z.add(J);U.set(H,x)},N=H=>{const Q=U.get(H);Q&&(Q.dispose(),U.delete(H))};G.connections.filter(B).forEach(M),E.Event.filter(G.onDidAddConnection,B)(M,void 0,he),G.onDidRemoveConnection(N,void 0,he),Z.event(ne.fire,ne,he),he.add(Z)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return ne.event}registerChannel(L,B){this.a.set(L,B);for(const V of this.f)V.channelServer.registerChannel(L,B)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=T;class j{constructor(L,B,V=null){const ae=new t;u(ae,B),L.send(ae.buffer),this.a=new D(L,V),this.d=new P(L,B,V)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,B){this.d.registerChannel(L,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=j;function F(q){return{call(L,B,V){return q.then(ae=>ae.call(L,B,V))},listen(L,B){const V=new E.$qe;return q.then(ae=>V.input=ae.listen(L,B)),V.event}}}function W(q){let L=!1;return{call(B,V,ae){return L?q.call(B,V,ae):(0,r.$Bh)(0).then(()=>L=!0).then(()=>q.call(B,V,ae))},listen(B,V){if(L)return q.listen(B,V);const ae=new E.$qe;return(0,r.$Bh)(0).then(()=>L=!0).then(()=>ae.input=q.listen(B,V)),ae.event}}}class C{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const B of L.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await E.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$ii=C;var z;(function(q){function L(G,he,ne){const Z=G,U=ne&&ne.disableMarshalling,M=new Map;for(const N in Z)V(N)&&M.set(N,E.Event.buffer(Z[N],!0,void 0,he));return new class{listen(N,H,Q){const J=M.get(H);if(J)return J;const x=Z[H];if(typeof x=="function"){if(ae(H))return x.call(Z,Q);if(V(H))return M.set(H,E.Event.buffer(Z[H],!0,void 0,he)),M.get(H)}throw new I.$bb(`Event not found: ${H}`)}call(N,H,Q){const J=Z[H];if(typeof J=="function"){if(!U&&Array.isArray(Q))for(let ee=0;ee<Q.length;ee++)Q[ee]=(0,f.$0h)(Q[ee]);let x=J.apply(Z,Q);return x instanceof Promise||(x=Promise.resolve(x)),x}throw new I.$bb(`Method not found: ${H}`)}}}q.fromService=L;function B(G,he){const ne=he&&he.disableMarshalling;return new Proxy({},{get(Z,U){if(typeof U=="string")return he?.properties?.has(U)?he.properties.get(U):ae(U)?function(M){return G.listen(U,M)}:V(U)?G.listen(U):async function(...M){let N;he&&!(0,$.$jg)(he.context)?N=[he.context,...M]:N=M;const H=await G.call(U,N);return ne?H:(0,f.$0h)(H)};throw new I.$bb(`Property not found: ${String(U)}`)}})}q.toService=B;function V(G){return G[0]==="o"&&G[1]==="n"&&d.$Af(G.charCodeAt(2))}function ae(G){return/^onDynamic/.test(G)&&d.$Af(G.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ie(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function oe(q){return Array.isArray(q)?q.map(ie):ie(q)}function K(q,L,B,V,ae,G,he){he=oe(he);const ne=se[ae],Z=ne[V%ne.length];let U=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test(G)?(U=U.concat(he),U.push(")")):U.push(he),console.log.apply(console,U)}class te{constructor(L,B){this.d=L,this.f=B,this.a=0,this.b=0}logOutgoing(L,B,V,ae,G){this.b+=L,K(this.d,this.b,L,B,V,ae,G)}logIncoming(L,B,V,ae,G){this.a+=L,K(this.f,this.a,L,B,V,ae,G)}}e.$ji=te}),define(ce[162],le([0,1,17,3,45]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wW=e.$vW=void 0;class A{constructor(E){this.a=E,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?i.$Je.wrap(c.data):i.$Je.alloc(0)),E.start()}send(E){this.a.postMessage(E.buffer)}disconnect(){this.a.close()}}e.$vW=A;class O extends k.$fi{constructor(E,c){const f=new A(E);super(f,c),this.b=f}dispose(){this.b.disconnect(),super.dispose()}}e.$wW=O}),define(ce[118],le([0,1,17,3,2,45]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const l=new WeakMap;let u=0;function b(R,D){if(!l.has(R)){const T=String(++u);l.set(R,T)}return l.get(R)}function P(R,D,T,j){if(!n.enableDiagnostics)return;const F=b(R,D);if(j instanceof i.$Je||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const W=i.$Je.alloc(j.byteLength);W.set(j),n.records.push({timestamp:Date.now(),id:F,label:D,type:T,buff:W})}else n.records.push({timestamp:Date.now(),id:F,label:D,type:T,data:j})}n.traceSocketEvent=P})(I||(e.SocketDiagnostics=I={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let c=null;function f(){return c||(c=i.$Je.alloc(0)),c}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,u){if(l===0)return f();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const D=this.a[0];return u&&(this.a.shift(),this.b-=l),D}if(this.a[0].byteLength>l){const D=this.a[0].slice(0,l);return u&&(this.a[0]=this.a[0].slice(l),this.b-=l),D}const b=i.$Je.alloc(l);let P=0,R=0;for(;l>0;){const D=this.a[R];if(D.byteLength>l){const T=D.slice(0,l);b.set(T,P),P+=l,u&&(this.a[R]=D.slice(l),this.b-=l),l-=l}else b.set(D,P),P+=D.byteLength,u?(this.a.shift(),this.b-=D.byteLength):R++,l-=D.byteLength}return b}}e.$ki=d;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function y(n){switch(n){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class g{constructor(l,u,b,P){this.type=l,this.id=u,this.ack=b,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends k.$Uc{constructor(l){super(),this.f=this.B(new r.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:h.HeaderLength,messageType:$.None,id:0,ack:0},this.a=l,this.b=!1,this.c=new d,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,P=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=h.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,u),this.f.fire(new g(b,P,R,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=i.$Je.alloc(h.HeaderLength);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,l.data),this.j(u,l.data)}g(l,u){const b=this.f===0;return this.d.push(l,u),this.f+=l.byteLength+u.byteLength,b}h(){const l=i.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,u){this.g(l,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:l.byteLength}),this.c.write(l)}}class p extends k.$Uc{constructor(l){super(),this.f=new r.$he,this.onMessage=this.f.event,this.g=new r.$he,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new w(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===$.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new g($.Regular,0,0,l))}}e.$li=p;class v extends A.$fi{static fromSocket(l,u){return new v(new p(l),u)}get onDidDispose(){return this.b.onDidDispose}constructor(l,u,b=null){super(l,u,b),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$mi=v;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$ni=S;class o{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,u=this.a;for(;u;)u=u.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let u=0,b=this.a;for(;b;)l[u++]=b.data,b=b.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const u=new o(l);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const l=Date.now();for(let u=0;u<s.a;u++)this.c[u]=l-1e3*u;setInterval(()=>{for(let u=s.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),u=(1+s.a)*1e3;let b=0;for(let P=0;P<s.a;P++)l-this.c[P]<=u&&b++;return 1-b/s.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??s.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new k.$Tc,this.o=l.socket,this.p=this.r.add(new w(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},h.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new g($.Disconnect,0,0,f());this.p.write(l),this.p.flush()}sendPause(){const l=new g($.Pause,0,0,f());this.p.write(l)}sendResume(){const l=new g($.Resume,0,0,f());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,u){this.a=!0,this.r.dispose(),this.r=new k.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new w(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new g($.Ack,0,this.h,f());this.p.write(l);const u=this.b.toArray();for(let b=0,P=u.length;b<P;b++)this.p.write(u[b]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const u=this.b.peek();if(u&&u.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case $.None:break;case $.Regular:{if(l.id>this.g)if(l.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new g($.ReplayRequest,0,0,f())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case $.Control:{this.u.fire(l.data);break}case $.Ack:break;case $.Disconnect:{this.w.fire();break}case $.ReplayRequest:{const u=this.b.toArray();for(let b=0,P=u.length;b<P;b++)this.p.write(u[b]);this.B();break}case $.Pause:{this.p.pause();break}case $.Resume:{this.p.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const u=++this.c;this.h=this.g;const b=new g($.Regular,u,this.h,l);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(l){const u=new g($.Control,0,0,l);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=h.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},h.AcknowledgeTime-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),u=Date.now()-l.writtenTime,b=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(u>=h.TimeoutTime&&b>=h.TimeoutTime&&P>=h.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:b});return}const R=Math.max(h.TimeoutTime-u,h.TimeoutTime-b,h.TimeoutTime-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new g($.Ack,0,this.h,f());this.p.write(l)}D(){this.h=this.g;const l=new g($.KeepAlive,0,this.h,f());this.p.write(l)}}e.$oi=a}),define(ce[37],le([0,1,14,16,13]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sW=void 0;class A{constructor(){this.a=new WeakMap}on(I,E){const c=(f,...d)=>{this.b(I,f)&&E(f,...d)};return this.a.set(E,c),i.ipcMain.on(I,c),this}once(I,E){return i.ipcMain.once(I,(c,...f)=>{this.b(I,c)&&E(c,...f)}),this}handle(I,E){return i.ipcMain.handle(I,(c,...f)=>this.b(I,c)?E(c,...f):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return i.ipcMain.removeHandler(I),this}removeListener(I,E){const c=this.a.get(E);return c&&(i.ipcMain.removeListener(I,c),this.a.delete(E)),this}b(I,E){if(!I||!I.startsWith("vscode:"))return(0,r.$1)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=E.senderFrame,f=c.url;if(!f||f==="about:blank")return!0;let d="unknown";try{d=new URL(f).host}catch{return(0,r.$1)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${f}'.`),!1}return d!==k.$Tg?((0,r.$1)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${d}'.`),!1):c.parent!==null?((0,r.$1)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${d}' is not a main frame.`),!1):!0}}e.$sW=new A}),define(ce[163],le([0,1,14,37,151]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tW=A;function A(){r.$sW.on(k.$qW,(I,E,c,f,d)=>{const $=O(I,f,c);$.popup({x:d?d.x:void 0,y:d?d.y:void 0,positioningItem:d?d.positioningItem:void 0,callback:()=>{$&&I.sender.send(k.$rW,E)}})})}function O(I,E,c){const f=new i.Menu;return c.forEach(d=>{let $;d.type==="separator"?$=new i.MenuItem({type:d.type}):Array.isArray(d.submenu)?$=new i.MenuItem({submenu:O(I,E,d.submenu),label:d.label}):$=new i.MenuItem({label:d.label,type:d.type,accelerator:d.accelerator,checked:d.checked,enabled:d.enabled,visible:d.visible,click:(y,h,g)=>I.sender.send(E,d.id,g)}),f.append($)}),f}}),define(ce[164],le([0,1,37,17,3,2,45,152]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=void 0;function E(f,d){const $=k.Event.fromNodeEventEmitter(i.$sW,d,(h,g)=>({event:h,message:g})),y=k.Event.filter($,({event:h})=>h.sender.id===f);return k.Event.map(y,({message:h})=>h&&r.$Je.wrap(h))}class c extends O.$ei{static{this.b=new Map}static d(){const d=k.Event.fromNodeEventEmitter(i.$sW,"vscode:hello",({sender:$})=>$);return k.Event.map(d,$=>{const y=$.id;c.b.get(y)?.dispose();const g=new k.$he;c.b.set(y,(0,A.$Sc)(()=>g.fire()));const m=E(y,"vscode:message"),w=k.Event.any(k.Event.signal(E(y,"vscode:disconnect")),g.event);return{protocol:new I.$yW($,m),onDidClientDisconnect:w}})}constructor(){super(c.d())}}e.$zW=c}),define(ce[119],le([0,1,37,3,33,162]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AW=void 0,e.$BW=I;class O extends A.$wW{constructor(c,f){super({addEventListener:(d,$)=>c.addListener(d,$),removeEventListener:(d,$)=>c.removeListener(d,$),postMessage:d=>c.postMessage(d),start:()=>c.start(),close:()=>c.close()},f)}}e.$AW=O;async function I(E){if(E.isDestroyed()||E.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,k.$Wg)();E.webContents.send("vscode:createMessageChannel",c);const f=r.Event.fromNodeEventEmitter(i.$sW,"vscode:createMessageChannelResult",($,y)=>({nonce:y,port:$.ports[0]})),{port:d}=await r.Event.toPromise(r.Event.once(r.Event.filter(f,$=>$.nonce===c)));return d}}),define(ce[165],le([0,1,50,8,17,23,159,16,3,2,35,94,80,45]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class h extends y.$ci{constructor(w){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",p=>k.$Je.wrap(Buffer.from(p,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.$8q=h;class g{constructor(w,p){this.i=w,this.j=p,this.c=new Set,this.g=new Map,this.h=new E.$he,this.onDidProcessExit=this.h.event;const v=p&&p.timeout?p.timeout:6e4;this.b=new r.$xh(v),this.d=null,this.f=null}getChannel(w){const p=this;return{call(v,S,o){return p.k(w,v,S,o)},listen(v,S){return p.l(w,v,S)}}}k(w,p,v,S=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const o=this.n(w),t=(0,r.$nh)(n=>o.call(p,v,n)),s=S.onCancellationRequested(()=>t.cancel()),a=(0,c.$Sc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{s.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(w,p,v){if(!this.b)return E.Event.None;this.b.cancel();let S;const o=new E.$he({onWillAddFirstListener:()=>{S=this.n(w).listen(p,v)(o.fire,o),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const w=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,f.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,$.$sm)(p.env),this.d=(0,i.fork)(this.i,w,p);const v=new E.$he,o=E.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,O.$4q)(u)){(0,O.log)(u,`IPC Library: ${this.j.serverName}`);return}v.fire(k.$Je.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,d.$um)(this.d):this.d,s=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),a=v.event,n={send:s,onMessage:a};this.f=new y.$di(n);const l=()=>this.o();process.once("exit",l),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,b)=>{process.removeListener("exit",l),o.dispose(),this.c.forEach(P=>(0,c.$Pc)(P)),this.c.clear(),u!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:b})})}return this.f}n(w){let p=this.g.get(w);return p||(p=this.m.getChannel(w),this.g.set(w,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9q=g}),define(ce[120],le([0,1,8,3,2,81,12]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=E;var I;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function E($){const y=$;return y?.changed instanceof Map||y?.deleted instanceof Set}var c;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(c||(e.StorageState=c={}));class f extends k.$Uc{static{this.a=100}constructor(y,h=Object.create(null)){super(),this.r=y,this.s=h,this.b=this.B(new r.$ke),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new i.$yh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((h,g)=>this.w(g,h)),y.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(y,h){if(this.c===c.Closed)return;let g=!1;(0,O.$jg)(h)?g=this.f.delete(y):this.f.get(y)!==h&&(this.f.set(y,h),g=!0),g&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,h){const g=this.f.get(y);return(0,O.$jg)(g)?h:g}getBoolean(y,h){const g=this.get(y);return(0,O.$jg)(g)?h:g==="true"}getNumber(y,h){const g=this.get(y);return(0,O.$jg)(g)?h:parseInt(g,10)}getObject(y,h){const g=this.get(y);return(0,O.$jg)(g)?h:(0,A.$9h)(g)}async set(y,h,g=!1){if(this.c===c.Closed)return;if((0,O.$jg)(h))return this.delete(y,g);const m=(0,O.$cg)(h)||Array.isArray(h)?(0,A.$8h)(h):String(h);if(this.f.get(y)!==m)return this.f.set(y,m),this.j.set(y,m),this.h.delete(y),this.b.fire({key:y,external:g}),this.D()}async delete(y,h=!1){if(!(this.c===c.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:h}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(!(this.c===c.Closed||this.m))return this.D(y)}async D(y){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$5p=f;class d{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((h,g)=>this.a.set(g,h)),y.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$6p=d}),define(ce[166],le([0,1,8,3,32,9,21]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XW=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return r.Event.None}static{this.a=2e3}static{this.b=256}constructor(f,d=Object.create(null)){this.g=f,this.h=d,this.c=(0,A.$nc)(this.g),this.d=new E(this.h.logging),this.f=this.n(this.g)}async getItems(){const f=await this.f,d=new Map;return(await this.s(f,"SELECT * FROM ItemTable")).forEach(y=>d.set(y.key,y.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(f){const d=await this.f;return this.j(d,f)}j(f,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,k.$yc)(d.insert):"0"}), delete(${d.delete?(0,k.$zc)(d.delete):"0"})`),this.t(f,()=>{const $=d.insert,y=d.delete;if($&&$.size>0){const h=[];h.push([]);let g=0;$.forEach((m,w)=>{let p=h[g];p.length>I.b&&(g++,p=[],h.push(p)),p.push(w,m)}),h.forEach(m=>{this.u(f,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,w=>w.run(m),()=>{const w=[];let p=0;return $.forEach((v,S)=>{w.push(S),p+=v.length}),`Keys: ${w.join(", ")} Length: ${p}`})})}if(y&&y.size){const h=[];h.push([]);let g=0;y.forEach(m=>{let w=h[g];w.length>I.b&&(g++,w=[],h.push(w)),w.push(m)}),h.forEach(m=>{this.u(f,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,w=>w.run(m),()=>{const w=[];return y.forEach(p=>{w.push(p)}),`Keys: ${w.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const f=await this.f;return this.q(f,"VACUUM")}async close(f){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,f)}k(f,d){return new Promise(($,y)=>{f.db.close(h=>(h&&this.o(f,`[storage ${this.c}] close(): ${h}`),this.g===I.IN_MEMORY_PATH?$():!f.isErroneous&&!f.isInMemory?this.l().then($,g=>(this.d.error(`[storage ${this.c}] backup(): ${g}`),$())):typeof d=="function"?O.Promises.unlink(this.g).then(()=>this.p(this.g).then(g=>{const m=()=>this.k(g,void 0);return this.j(g,{insert:d()}).then(()=>m(),w=>(m(),Promise.reject(w)))})).then($,y):y(h||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const f=this.m(this.g);return O.Promises.copy(this.g,f,{preserveSymlinks:!1})}m(f){return`${f}.backup`}async checkIntegrity(f){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${f})`);const d=await this.f,$=await this.r(d,f?"PRAGMA integrity_check":"PRAGMA quick_check"),y=f?$.integrity_check:$.quick_check;return d.isErroneous?`${y} (last error: ${d.lastError})`:d.isInMemory?`${y} (in-memory!)`:y}async n(f,d=!0){this.d.trace(`[storage ${this.c}] open(${f}, retryOnBusy: ${d})`);try{return await this.p(f)}catch($){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${$}`),$.code==="SQLITE_BUSY"&&d)return await(0,i.$Bh)(I.a),this.n(f,!1);try{await O.Promises.unlink(f);try{await O.Promises.rename(this.m(f),f,!1)}catch{}return await this.p(f)}catch(y){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${y}`),this.p(I.IN_MEMORY_PATH)}}}o(f,d){f.isErroneous=!0,f.lastError=d,this.d.error(d)}p(f){return new Promise((d,$)=>{new Promise((y,h)=>{X(["@vscode/sqlite3"],y,h)}).then(y=>{const h={db:new(this.d.isTracing?y.verbose().Database:y.Database)(f,g=>g?h.db&&g.code!=="SQLITE_CANTOPEN"?h.db.close(()=>$(g)):$(g):this.q(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(h),m=>h.db.close(()=>$(m)))),isInMemory:f===I.IN_MEMORY_PATH};h.db.on("error",g=>this.o(h,`[storage ${this.c}] Error (event): ${g}`)),this.d.isTracing&&h.db.on("trace",g=>this.d.trace(`[storage ${this.c}] Trace (event): ${g}`))},$)})}q(f,d){return new Promise(($,y)=>{f.db.exec(d,h=>h?(this.o(f,`[storage ${this.c}] exec(): ${h}`),y(h)):$())})}r(f,d){return new Promise(($,y)=>{f.db.get(d,(h,g)=>h?(this.o(f,`[storage ${this.c}] get(): ${h}`),y(h)):$(g))})}s(f,d){return new Promise(($,y)=>{f.db.all(d,(h,g)=>h?(this.o(f,`[storage ${this.c}] all(): ${h}`),y(h)):$(g))})}t(f,d){return new Promise(($,y)=>{f.db.serialize(()=>{f.db.run("BEGIN TRANSACTION"),d(),f.db.run("END TRANSACTION",h=>h?(this.o(f,`[storage ${this.c}] transaction(): ${h}`),y(h)):$())})})}u(f,d,$,y){const h=f.db.prepare(d),g=m=>{this.o(f,`[storage ${this.c}] prepare(): ${m} (${d}). Details: ${y()}`)};h.on("error",g),$(h),h.finalize(m=>{m&&g(m),h.removeListener("error",g)})}}e.$XW=I;class E{static{this.a="VSCODE_TRACE_STORAGE"}constructor(f){f&&typeof f.logTrace=="function"&&process.env[E.a]&&(this.b=f.logTrace),f&&typeof f.logError=="function"&&(this.c=f.logError)}get isTracing(){return!!this.b}trace(f){this.b?.(f)}error(f){this.c?.(f)}}}),define(ce[167],le([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ce[168],le([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[169],le([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[170],le([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ce[171],le([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ce[172],le([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ce[173],le([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ce[174],le([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ce[175],le([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[176],le([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[177],le([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[178],le([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[179],le([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ce[180],le([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ce[181],le([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ce[182],le([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ce[183],le([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ce[184],le([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[185],le([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ce[186],le([11,10]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(ce[187],le([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ce[188],le([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ce[189],le([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ce[190],le([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ce[191],le([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[192],le([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ce[193],le([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ce[194],le([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ce[195],le([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[196],le([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ce[197],le([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ce[198],le([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ce[199],le([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ce[200],le([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ce[201],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggb=i,e.$hgb=r;function i(k){return k&&k.hasOwnProperty("folderUri")}function r(k){return k&&k.hasOwnProperty("workspace")}}),define(ce[202],le([0,1,7]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=r,e.$6cc=k,e.$7cc=A;function r(O){return typeof O?.backupFolder=="string"}function k(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(E=>({workspace:{id:E.id,configPath:i.URI.parse(E.configURIPath)},remoteAuthority:E.remoteAuthority})))}catch{}return I}function A(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(E=>({folderUri:i.URI.parse(E.folderUri),remoteAuthority:E.remoteAuthority})))}catch{}return I}}),define(ce[203],le([0,1,39,16,170]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var A;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...f){switch(f.length){case 1:return(0,k.localize)(0,null,f[0]);case 2:return(0,k.localize)(1,null,f[0],f[1]);case 3:return(0,k.localize)(2,null,f[0],f[1],f[2]);default:return}}const I=(0,k.localize)(3,null),E=(0,k.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return d.isTripleEq?"===":"==";case A.NotEq:return d.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return d.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return d.lexeme;case A.QuotedStr:return d.lexeme;case A.Error:return d.lexeme;case A.EOF:return"EOF";default:throw(0,r.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(A.LParen);break;case i.CharCode.CloseParen:this.k(A.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:$})}else this.k(A.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:$})}else this.h(i.CharCode.Tilde)?this.k(A.RegexOp):this.l(O("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?A.LtEq:A.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?A.GtEq:A.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(A.And):this.l(O("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(A.Or):this.l(O("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const $=this.d,y=this.c.substring(this.d,this.e),h={type:A.Error,offset:this.d,lexeme:y};this.g.push({offset:$,lexeme:y,additionalInfo:d}),this.f.push(h)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const $=this.c.substring(this.d,this.e),y=c.b.get($);y?this.k(y):this.f.push({type:A.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,$=!1,y=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(E);return}const g=this.c.charCodeAt(d);if($)$=!1;else if(g===i.CharCode.Slash&&!y){d++;break}else g===i.CharCode.OpenSquareBracket?y=!0:g===i.CharCode.Backslash?$=!0:g===i.CharCode.CloseSquareBracket&&(y=!1);d++}for(;d<this.c.length&&c.a.has(this.c.charCodeAt(d));)d++;this.e=d;const h=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=c}),define(ce[204],le([0,1,3,2]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=void 0;class k{constructor(){this.a=new i.$he,this.b=new i.$he,this.c=new i.$he,this.d=new i.$he}static{this.ChannelName="extensionhostdebugservice"}call(I,E,c){switch(E){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,E,c){switch(E){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Po=k;class A extends r.$Uc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,E,c){this.b.call("attach",[I,E,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,E){this.b.call("terminate",[I,E])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,E){return this.b.call("openExtensionDevelopmentHostWindow",[I,E])}}e.$Qo=A}),define(ce[205],le([0,1,154,53,13,9,36,19,7]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$_m=f,e.$an=d,e.$0m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,A.$mc)(k.$Ug.asFileUri("").fsPath)}get userHome(){return E.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return E.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.b.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,I.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const y=(0,i.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",y)}return E.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$bh)(E.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=O.env.VSCODE_PORTABLE;return y?E.URI.file((0,A.$jc)(y,"argv.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,A.$kc)(y):(0,A.$hc)((0,A.$jc)(k.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const y=this.args["extensions-download-dir"];return y?E.URI.file((0,A.$kc)(y)):E.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,A.$kc)(y);const h=O.env.VSCODE_EXTENSIONS;if(h)return h;const g=O.env.VSCODE_PORTABLE;return g?(0,A.$jc)(g,"extensions"):(0,I.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(h=>/^[^:/?#]+?:\/\//.test(h)?E.URI.parse(h):E.URI.file((0,A.$hc)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?E.URI.parse(y):E.URI.file((0,A.$hc)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.$0m.test(y))}get extensionLogLevel(){const y=[];for(const h of this.args.log||[]){const g=e.$0m.exec(h);g&&g[1]&&g[2]&&y.push([g[1],g[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,I.$bh)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=O.env.VSCODE_PORTABLE;return y?E.URI.file((0,A.$jc)(y,"policy.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this.a}constructor(y,h,g){this.a=y,this.b=h,this.c=g,this.editSessionId=this.args.editSessionId}}e.$$m=c,Se([r.$5h],c.prototype,"appRoot",null),Se([r.$5h],c.prototype,"userHome",null),Se([r.$5h],c.prototype,"userDataPath",null),Se([r.$5h],c.prototype,"appSettingsHome",null),Se([r.$5h],c.prototype,"tmpDir",null),Se([r.$5h],c.prototype,"cacheHome",null),Se([r.$5h],c.prototype,"stateResource",null),Se([r.$5h],c.prototype,"userRoamingDataHome",null),Se([r.$5h],c.prototype,"userDataSyncHome",null),Se([r.$5h],c.prototype,"sync",null),Se([r.$5h],c.prototype,"machineSettingsResource",null),Se([r.$5h],c.prototype,"workspaceStorageHome",null),Se([r.$5h],c.prototype,"localHistoryHome",null),Se([r.$5h],c.prototype,"keyboardLayoutResource",null),Se([r.$5h],c.prototype,"argvResource",null),Se([r.$5h],c.prototype,"isExtensionDevelopment",null),Se([r.$5h],c.prototype,"untitledWorkspacesHome",null),Se([r.$5h],c.prototype,"builtinExtensionsPath",null),Se([r.$5h],c.prototype,"extensionsPath",null),Se([r.$5h],c.prototype,"extensionDevelopmentLocationURI",null),Se([r.$5h],c.prototype,"extensionDevelopmentKind",null),Se([r.$5h],c.prototype,"extensionTestsLocationURI",null),Se([r.$5h],c.prototype,"debugExtensionHost",null),Se([r.$5h],c.prototype,"logLevel",null),Se([r.$5h],c.prototype,"extensionLogLevel",null),Se([r.$5h],c.prototype,"serviceMachineIdResource",null),Se([r.$5h],c.prototype,"disableTelemetry",null),Se([r.$5h],c.prototype,"disableWorkspaceTrust",null),Se([r.$5h],c.prototype,"useInMemorySecretStorage",null),Se([r.$5h],c.prototype,"policyFile",null);function f($,y){return d($["inspect-extensions"],$["inspect-brk-extensions"],5870,y,$.debugId,$.extensionEnvironment)}function d($,y,h,g,m,w){const v=Number(y||$)||(g?null:h),S=v?!!y:!1;let o;if(w)try{o=JSON.parse(w)}catch{}return{port:v,break:S,debugId:m,env:o}}}),define(ce[121],le([0,1,316,4,173]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0,e.$ym=I,e.$zm=c,e.$Am=y,e.$Bm=h;const A={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$wm=["tunnel","serve-web"],e.$xm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(g,m,w=O){const p=g.find(u=>u.length>0&&u[0]!=="-"),v={},S=["_"],o=[],t={};let s;for(const u in m){const b=m[u];b.type==="subcommand"?u===p&&(s=b):(b.alias&&(v[u]=b.alias),b.type==="string"||b.type==="string[]"?(S.push(u),b.deprecates&&S.push(...b.deprecates)):b.type==="boolean"&&(o.push(u),b.deprecates&&o.push(...b.deprecates)),b.global&&(t[u]=b))}if(s&&p){const u=t;for(const D in s.options)u[D]=s.options[D];const b=g.filter(D=>D!==p),P=w.getSubcommandReporter?w.getSubcommandReporter(p):void 0,R=I(b,u,P);return{[p]:R,_:[]}}const a=i(g,{string:S,boolean:o,alias:v}),n={},l=a;n._=a._.map(u=>String(u)).filter(u=>u.length>0),delete l._;for(const u in m){const b=m[u];if(b.type==="subcommand")continue;b.alias&&delete l[b.alias];let P=l[u];if(b.deprecates)for(const R of b.deprecates)l.hasOwnProperty(R)&&(P||(P=l[R],P&&w.onDeprecatedOption(R,b.deprecationMessage||(0,k.localize)(39,null,u))),delete l[R]);if(typeof P<"u"){if(b.type==="string[]"){if(Array.isArray(P)||(P=[P]),!b.allowEmptyValue){const R=P.filter(D=>D.length>0);R.length!==P.length&&(w.onEmptyValue(u),P=R.length>0?R:void 0)}}else b.type==="string"&&(Array.isArray(P)?(P=P.pop(),w.onMultipleValues(u,P)):!P&&!b.allowEmptyValue&&(w.onEmptyValue(u),P=void 0));n[u]=P,b.deprecationMessage&&w.onDeprecatedOption(u,b.deprecationMessage)}delete l[u]}for(const u in l)w.onUnknownOption(u);return n}function E(g,m){let w="";return m.args&&(Array.isArray(m.args)?w=` <${m.args.join("> <")}>`:w=` <${m.args}>`),m.alias?`-${m.alias} --${g}${w}`:`--${g}${w}`}function c(g,m){const w=[];for(const p in g){const v=g[p],S=E(p,v);w.push([S,v.description])}return f(w,m)}function f(g,m){const p=g.reduce((o,t)=>Math.max(o,t[0].length),12)+2+1;if(m-p<25)return g.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=m-p-1,S=[];for(const o of g){const t=o[0],s=$(o[1],v),a=d(p-t.length-2);S.push("  "+t+a+s[0]);for(let n=1;n<s.length;n++)S.push(d(p)+s[n])}return S}function d(g){return" ".repeat(g)}function $(g,m){const w=[];for(;g.length;){const p=g.length<m?g.length:g.lastIndexOf(" ",m),v=g.slice(0,p).trim();g=g.slice(p),w.push(v)}return w}function y(g,m,w,p,v){const S=process.stdout.isTTY&&process.stdout.columns||80,o=v?.noInputFiles!==!0?`[${(0,k.localize)(40,null)}...]`:"",t=[`${g} ${w}`];t.push(""),t.push(`${(0,k.localize)(41,null)}: ${m} [${(0,k.localize)(42,null)}]${o}`),t.push(""),v?.noPipe!==!0&&(r.$i?t.push((0,k.localize)(43,null,m)):t.push((0,k.localize)(44,null,m)),t.push(""));const s={},a=[];for(const n in p){const l=p[n];if(l.type==="subcommand")l.description&&a.push({command:n,description:l.description});else if(l.description&&l.cat){let u=s[l.cat];u||(s[l.cat]=u={}),u[n]=l}}for(const n in s){const l=n,u=s[l];u&&(t.push(A[l]),t.push(...c(u,S)),t.push(""))}return a.length&&(t.push((0,k.localize)(45,null)),t.push(...f(a.map(n=>[n.command,n.description]),S)),t.push("")),t.join(`
`)}function h(g,m){return`${g||(0,k.localize)(46,null)}
${m||(0,k.localize)(47,null)}
${process.arch}`}}),define(ce[67],le([0,1,317,174,121]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=I,e.$Dm=E,e.$Em=c,e.$Fm=f;function A(d,$){const y=(v,S)=>{console.warn((0,r.localize)(0,null,v,S))},h=v=>{console.warn((0,r.localize)(1,null,v))},g=(v,S)=>{console.warn((0,r.localize)(2,null,v,S))},m=v=>({onUnknownOption:S=>{k.$wm.includes(v)||console.warn((0,r.localize)(3,null,S,v))},onMultipleValues:y,onEmptyValue:h,onDeprecatedOption:g,getSubcommandReporter:k.$wm.includes(v)?m:void 0}),w={onUnknownOption:v=>{console.warn((0,r.localize)(4,null,v))},onMultipleValues:y,onEmptyValue:h,onDeprecatedOption:g,getSubcommandReporter:m},p=(0,k.$ym)(d,k.$xm,$?w:void 0);return p.goto&&p._.forEach(v=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,r.localize)(5,null))),p}function O(d){const $=d.findIndex(y=>!/^-/.test(y));if($>-1)return[...d.slice(0,$),...d.slice($+1)]}function I(d){let[,...$]=d;process.env.VSCODE_DEV&&($=O($)||[]);const y=!f(process.env);return A($,y)}function E(d){let[,,...$]=d;return process.env.VSCODE_DEV&&($=O($)||[]),A($,!0)}function c(d,...$){const y=d.indexOf("--");return y===-1?d.push(...$):d.splice(y,0,...$),d}function f(d){return d.VSCODE_CLI==="1"}}),function(){"use strict";function X(e,i,r){function k(O,I){const E=A(O,I),c=[E];return e.isAbsolute(E)||c.unshift(r),e.resolve(...c)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const f=O["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(d,"AppData","Roaming")}break;case"darwin":c=e.join(i.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:k}}if(typeof define=="function")define(ce[206],le([122,27,36]),function(e,i,r){return X(e,i,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=X(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,205,206]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0,e.$cn=O,e.$dn=I;class A extends r.$$m{constructor(c,f){super(c,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,f.nameShort)},f)}}e.$bn=A;function O(E,c){return(0,r.$an)(E["inspect-ptyhost"],E["inspect-brk-ptyhost"],5877,c,E.extensionEnvironment)}function I(E,c){return(0,r.$an)(E["inspect-sharedprocess"],E["inspect-brk-sharedprocess"],5879,c,E.extensionEnvironment)}}),define(ce[207],le([0,1,44,27,31]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=A;function A(O){const I=(0,k.$Ig)((0,r.tmpdir)());try{return(0,i.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(E){O&&console.error(`Failed to create marker file for --wait: ${E}`);return}}}),define(ce[208],le([0,1,12,176]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=k;function k(O,I,E,c){try{A(O,I,E,c)}catch(f){O.error(f?.message??f)}return I}function A(O,I,E,c){const f=(d,$,y)=>{const h=d[$];if((0,i.$ag)(h)){const g=h,m=g.length;if(m>1&&g[0]==="%"&&g[m-1]==="%"){const w=g.substr(1,m-2);let p=E[w];p===void 0&&c&&(p=c[w]);const v=typeof p=="string"?p:p?.message,S=c?.[w],o=typeof S=="string"?S:S?.message;if(!v){o||O.warn(`[${I.name}]: ${(0,r.localize)(0,null,w)}`);return}if(y&&($==="title"||$==="category")&&o&&o!==v){const t={value:v,original:o};d[$]=t}else d[$]=v}}else if((0,i.$cg)(h))for(const g in h)h.hasOwnProperty(g)&&(g==="commands"?f(h,g,!0):f(h,g,y));else if(Array.isArray(h))for(let g=0;g<h.length;g++)f(h,g,y)};for(const d in I)I.hasOwnProperty(d)&&f(I,d)}}),define(ce[209],le([0,1,19,79,178,210]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=E,e.$Pp=c,e.$Qp=f,e.$Rp=d,e.$Sp=$,e.$Tp=y,e.$Up=h;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(w){return w=w.trim(),w==="*"||O.test(w)}function c(w){if(!E(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=w.match(O);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function f(w){if(!w)return null;const p=w.majorBase,v=w.majorMustEqual,S=w.minorBase;let o=w.minorMustEqual;const t=w.patchBase;let s=w.patchMustEqual;w.hasCaret&&(p===0||(o=!1),s=!1);let a=0;if(w.preRelease){const n=I.exec(w.preRelease);if(n){const[,l,u,b]=n;a=Date.UTC(Number(l),Number(u)-1,Number(b))}}return{majorBase:p,majorMustEqual:v,minorBase:S,minorMustEqual:o,patchBase:t,patchMustEqual:s,isMinimum:w.hasGreaterEquals,notBefore:a}}function d(w,p,v){let S;typeof w=="string"?S=f(c(w)):S=w;let o;p instanceof Date?o=p.getTime():typeof p=="string"&&(o=new Date(p).getTime());let t;if(typeof v=="string"?t=f(c(v)):t=v,!S||!t)return!1;const s=S.majorBase,a=S.minorBase,n=S.patchBase;let l=t.majorBase,u=t.minorBase,b=t.patchBase;const P=t.notBefore;let R=t.majorMustEqual,D=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?s>l?!0:s<l?!1:a>u?!0:a<u||o&&o<P?!1:n>=b:(s===1&&l===0&&(!R||!D||!T)&&(l=1,u=0,b=0,R=!0,D=!1,T=!1),s<l?!1:s>l?!R:a<u?!1:a>u?!D:n<b?!1:n>b?!T:!(o&&o<P))}function $(w,p,v,S,o){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([r.default.Error,k.localize(0,null)]),t;if(typeof S.name!="string")return t.push([r.default.Error,k.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([r.default.Error,k.localize(2,null,"version")]),t;if(!S.engines)return t.push([r.default.Error,k.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([r.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!m(S.extensionDependencies))return t.push([r.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!m(S.activationEvents))return t.push([r.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([r.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([r.default.Warning,k.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([r.default.Error,k.localize(9,null,"main")]),t;{const n=(0,i.$bh)(v,S.main);(0,i.$8g)(n,v)||t.push([r.default.Warning,k.localize(10,null,n.path,v.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([r.default.Error,k.localize(11,null,"browser")]),t;{const n=(0,i.$bh)(v,S.browser);(0,i.$8g)(n,v)||t.push([r.default.Warning,k.localize(12,null,n.path,v.path)])}}if(!A.valid(S.version))return t.push([r.default.Error,k.localize(13,null)]),t;const s=[];if(!y(w,p,S,o,s))for(const n of s)t.push([r.default.Error,n]);return t}function y(w,p,v,S,o){return S||typeof v.main>"u"&&typeof v.browser>"u"?!0:g(w,p,v.engines.vscode,o)}function h(w,p,v){return w==="*"||g(p,v,w)}function g(w,p,v,S=[]){const o=f(c(v));if(!o)return S.push(k.localize(14,null,v)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return S.push(k.localize(15,null,v)),!1}else if(!o.majorMustEqual)return S.push(k.localize(16,null,v)),!1;return d(w,p,o)?!0:(S.push(k.localize(17,null,w,v)),!1)}function m(w){if(!Array.isArray(w))return!1;for(let p=0,v=w.length;p<v;p++)if(typeof w[p]!="string")return!1;return!0}}),define(ce[82],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class i{constructor(k,A=[],O=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$xi=i}),define(ce[211],le([0,1,82]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=A,e.$Gs=O;const r=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(I,E,c){E instanceof i.$xi||(E=new i.$xi(E,[],!!c)),r.push([I,E])}function O(){return r}}),define(ce[212],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class i{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$ir=i;class r{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),E=this.lookupOrInsertNode(O);I.outgoing.set(E.key,E),E.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new i(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),E=this.c(O,I);if(E)return E}}c(A,O){for(const[I,E]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const c=this.c(E,O);if(c)return c;O.delete(I)}}}e.$jr=r}),define(ce[6],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=k,e.$Bi=A;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(i||(e._util=i={})),e.$zi=k("instantiationService");function r(O,I,E){I[i.DI_TARGET]===I?I[i.DI_DEPENDENCIES].push({id:O,index:E}):(I[i.DI_DEPENDENCIES]=[{id:O,index:E}],I[i.DI_TARGET]=I)}function k(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const I=function(E,c,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,E,f)};return I.toString=()=>O,i.serviceIds.set(O,I),I}function A(O){return O}}),define(ce[83],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0,e.$Ydc=(0,i.$Ai)("auxiliaryWindowsMainService")}),define(ce[68],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0,e.$8cc=(0,i.$Ai)("backupMainService")}),define(ce[18],le([0,1,12,7,6]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=A,e.$9i=O,e.$0i=E,e.$$i=c,e.$_i=f,e.$aj=d,e.$bj=$,e.$cj=h,e.$dj=g,e.$ej=m,e.$7i=(0,k.$Ai)("configurationService");function A(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof r.URI)}function O(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof r.URI)}var I;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function E(w){switch(w){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(w){return w.applicationValue!==void 0||w.userValue!==void 0||w.userLocalValue!==void 0||w.userRemoteValue!==void 0||w.workspaceValue!==void 0||w.workspaceFolderValue!==void 0}function f(w,p){const v=Object.create(null);for(const S in w)d(v,S,w[S],p);return v}function d(w,p,v,S){const o=p.split("."),t=o.pop();let s=w;for(let a=0;a<o.length;a++){const n=o[a];let l=s[n];switch(typeof l){case"undefined":l=s[n]=Object.create(null);break;case"object":if(l===null){S(`Ignoring ${p} as ${o.slice(0,a+1).join(".")} is null`);return}break;default:S(`Ignoring ${p} as ${o.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}s=l}if(typeof s=="object"&&s!==null)try{s[t]=v}catch{S(`Ignoring ${p} as ${o.join(".")} is ${JSON.stringify(s)}`)}else S(`Ignoring ${p} as ${o.join(".")} is ${JSON.stringify(s)}`)}function $(w,p){const v=p.split(".");y(w,v)}function y(w,p){const v=p.shift();if(p.length===0){delete w[v];return}if(Object.keys(w).indexOf(v)!==-1){const S=w[v];typeof S=="object"&&!Array.isArray(S)&&(y(S,p),Object.keys(S).length===0&&delete w[v])}}function h(w,p,v){function S(s,a){let n=s;for(const l of a){if(typeof n!="object"||n===null)return;n=n[l]}return n}const o=p.split("."),t=S(w,o);return typeof t>"u"?v:t}function g(w,p,v){Object.keys(p).forEach(S=>{S!=="__proto__"&&(S in w?i.$cg(w[S])&&i.$cg(p[S])?g(w[S],p[S],v):v&&(w[S]=p[S]):w[S]=p[S])})}function m(w){return w.replace(/[\[\]]/g,"")}}),define(ce[123],le([0,1,39,4,26,203,6,169,16]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=f,e.$zj=a,e.$Aj=n,e.$Tj=G;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$j),c.set("isLinux",r.$k),c.set("isWindows",r.$i),c.set("isWeb",r.$o),c.set("isMacNative",r.$j&&!r.$o),c.set("isEdge",r.$H),c.set("isFirefox",r.$F),c.set("isChrome",r.$E),c.set("isSafari",r.$G);function f(Z,U){if(c.get(Z)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Z,U)}const d=Object.prototype.hasOwnProperty;var $;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const y={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),g=(0,I.localize)(1,null),m=(0,I.localize)(2,null),w=(0,I.localize)(3,null),p=(0,I.localize)(4,null),v=(0,I.localize)(5,null),S=(0,I.localize)(6,null),o=(0,I.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=y){this.k=U,this.d=new A.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const N=this.D(),H=N.type===A.TokenType.Str?v:void 0;throw this.h.push({message:p,offset:N.offset,lexeme:A.$vj.getLexeme(N),additionalInfo:H}),t.c}return M}catch(M){if(M!==t.c)throw M;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(A.TokenType.Or);){const M=this.o();U.push(M)}return U.length===1?U[0]:s.or(...U)}o(){const U=[this.s()];for(;this.y(A.TokenType.And);){const M=this.s();U.push(M)}return U.length===1?U[0]:s.and(...U)}s(){if(this.y(A.TokenType.Neg)){const U=this.D();switch(U.type){case A.TokenType.True:return this.z(),u.INSTANCE;case A.TokenType.False:return this.z(),b.INSTANCE;case A.TokenType.LParen:{this.z();const M=this.l();return this.A(A.TokenType.RParen,w),M?.negate()}case A.TokenType.Str:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case A.TokenType.True:return this.z(),s.true();case A.TokenType.False:return this.z(),s.false();case A.TokenType.LParen:{this.z();const M=this.l();return this.A(A.TokenType.RParen,w),M}case A.TokenType.Str:{const M=U.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==A.TokenType.RegexStr)throw this.B("REGEX",H);const Q=H.lexeme,J=Q.lastIndexOf("/"),x=J===Q.length-1?void 0:this.w(Q.substring(J+1));let ee;try{ee=new RegExp(Q.substring(1,J),x)}catch{throw this.B("REGEX",H)}return oe.create(M,ee)}switch(H.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const Q=[H.lexeme];this.z();let J=this.D(),x=0;for(let Ie=0;Ie<H.lexeme.length;Ie++)H.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?x++:H.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&x--;for(;!this.E()&&J.type!==A.TokenType.And&&J.type!==A.TokenType.Or;){switch(J.type){case A.TokenType.LParen:x++;break;case A.TokenType.RParen:x--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ie=0;Ie<J.lexeme.length;Ie++)J.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?x++:H.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&x--}if(x<0)break;Q.push(A.$vj.getLexeme(J)),this.z(),J=this.D()}const ee=Q.join(""),de=ee.lastIndexOf("/"),me=de===ee.length-1?void 0:this.w(ee.substring(de+1));let pe;try{pe=new RegExp(ee.substring(1,de),me)}catch{throw this.B("REGEX",H)}return s.regex(M,pe)}case A.TokenType.QuotedStr:{const Q=H.lexeme;this.z();let J=null;if(!(0,k.$$e)(Q)){const x=Q.indexOf("/"),ee=Q.lastIndexOf("/");if(x!==ee&&x>=0){const de=Q.slice(x+1,ee),me=Q[ee+1]==="i"?"i":"";try{J=new RegExp(de,me)}catch{throw this.B("REGEX",H)}}}if(J===null)throw this.B("REGEX",H);return oe.create(M,J)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,m);const H=this.u();return s.notIn(M,H)}switch(this.D().type){case A.TokenType.Eq:{this.z();const H=this.u();if(this.x().type===A.TokenType.QuotedStr)return s.equals(M,H);switch(H){case"true":return s.has(M);case"false":return s.not(M);default:return s.equals(M,H)}}case A.TokenType.NotEq:{this.z();const H=this.u();if(this.x().type===A.TokenType.QuotedStr)return s.notEquals(M,H);switch(H){case"true":return s.not(M);case"false":return s.has(M);default:return s.notEquals(M,H)}}case A.TokenType.Lt:return this.z(),se.create(M,this.u());case A.TokenType.LtEq:return this.z(),ie.create(M,this.u());case A.TokenType.Gt:return this.z(),C.create(M,this.u());case A.TokenType.GtEq:return this.z(),z.create(M,this.u());case A.TokenType.In:return this.z(),s.in(M,this.u());default:return s.has(M)}}case A.TokenType.EOF:throw this.h.push({message:S,offset:U.offset,lexeme:"",additionalInfo:o}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),U.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,M){if(this.C(U))return this.z();throw this.B(M,this.D())}B(U,M,N){const H=(0,I.localize)(8,null,U,A.$vj.getLexeme(M)),Q=M.offset,J=A.$vj.getLexeme(M);return this.h.push({message:H,offset:Q,lexeme:J,additionalInfo:N}),t.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$xj=t;class s{static false(){return u.INSTANCE}static true(){return b.INSTANCE}static has(U){return P.create(U)}static equals(U,M){return R.create(U,M)}static notEquals(U,M){return j.create(U,M)}static regex(U,M){return oe.create(U,M)}static in(U,M){return D.create(U,M)}static notIn(U,M){return T.create(U,M)}static not(U){return F.create(U)}static and(...U){return q.create(U,null,!0)}static or(...U){return L.create(U,null,!0)}static greater(U,M){return C.create(U,M)}static greaterEquals(U,M){return z.create(U,M)}static smaller(U,M){return se.create(U,M)}static smallerEquals(U,M){return ie.create(U,M)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$yj=s;function a(Z){const U=new t({regexParsingWithErrorRecovery:!1});return Z.map(M=>(U.parse(M),U.lexingErrors.length>0?U.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,I.localize)(9,null,N.additionalInfo):(0,I.localize)(10,null),offset:N.offset,length:N.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function n(Z,U){const M=Z?Z.substituteConstants():void 0,N=U?U.substituteConstants():void 0;return!M&&!N?!0:!M||!N?!1:M.equals(N)}function l(Z,U){return Z.cmp(U)}class u{static{this.INSTANCE=new u}constructor(){this.type=$.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return b.INSTANCE}}e.$Bj=u;class b{static{this.INSTANCE=new b}constructor(){this.type=$.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$Cj=b;class P{static create(U,M=null){const N=c.get(U);return typeof N=="boolean"?N?b.INSTANCE:u.INSTANCE:new P(U,M)}constructor(U,M){this.key=U,this.c=M,this.type=$.Defined}cmp(U){return U.type!==this.type?this.type-U.type:V(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=c.get(this.key);return typeof U=="boolean"?U?b.INSTANCE:u.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Dj=P;class R{static create(U,M,N=null){if(typeof M=="boolean")return M?P.create(U,N):F.create(U,N);const H=c.get(U);return typeof H=="boolean"?M===(H?"true":"false")?b.INSTANCE:u.INSTANCE:new R(U,M,N)}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.Equals}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const M=U?"true":"false";return this.d===M?b.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ej=R;class D{static create(U,M){return new D(U,M)}constructor(U,M){this.d=U,this.f=M,this.type=$.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const M=U.getValue(this.f),N=U.getValue(this.d);return Array.isArray(M)?M.includes(N):typeof N=="string"&&typeof M=="object"&&M!==null?d.call(M,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Fj=D;class T{static create(U,M){return new T(U,M)}constructor(U,M){this.d=U,this.f=M,this.type=$.NotIn,this.c=D.create(U,M)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=T;class j{static create(U,M,N=null){if(typeof M=="boolean")return M?F.create(U,N):P.create(U,N);const H=c.get(U);return typeof H=="boolean"?M===(H?"true":"false")?u.INSTANCE:b.INSTANCE:new j(U,M,N)}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const M=U?"true":"false";return this.d===M?u.INSTANCE:b.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Hj=j;class F{static create(U,M=null){const N=c.get(U);return typeof N=="boolean"?N?u.INSTANCE:b.INSTANCE:new F(U,M)}constructor(U,M){this.c=U,this.d=M,this.type=$.Not}cmp(U){return U.type!==this.type?this.type-U.type:V(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=c.get(this.c);return typeof U=="boolean"?U?u.INSTANCE:b.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=P.create(this.c,this)),this.d}}e.$Ij=F;function W(Z,U){if(typeof Z=="string"){const M=parseFloat(Z);isNaN(M)||(Z=M)}return typeof Z=="string"||typeof Z=="number"?U(Z):u.INSTANCE}class C{static create(U,M,N=null){return W(M,H=>new C(U,H,N))}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.Greater}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Jj=C;class z{static create(U,M,N=null){return W(M,H=>new z(U,H,N))}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Kj=z;class se{static create(U,M,N=null){return W(M,H=>new se(U,H,N))}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Lj=se;class ie{static create(U,M,N=null){return W(M,H=>new ie(U,H,N))}constructor(U,M,N){this.c=U,this.d=M,this.f=N,this.type=$.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=ie;class oe{static create(U,M){return new oe(U,M)}constructor(U,M){this.d=U,this.f=M,this.type=$.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const M=this.f?this.f.source:"",N=U.f?U.f.source:"";return M<N?-1:M>N?1:0}equals(U){if(U.type===this.type){const M=this.f?this.f.source:"",N=U.f?U.f.source:"";return this.d===U.d&&M===N}return!1}substituteConstants(){return this}evaluate(U){const M=U.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Nj=oe;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=$.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Oj=K;function te(Z){let U=null;for(let M=0,N=Z.length;M<N;M++){const H=Z[M].substituteConstants();if(Z[M]!==H&&U===null){U=[];for(let Q=0;Q<M;Q++)U[Q]=Z[Q]}U!==null&&(U[M]=H)}return U===null?Z:U}class q{static create(U,M,N){return q.d(U,M,N)}constructor(U,M){this.expr=U,this.c=M,this.type=$.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const H=l(this.expr[M],U.expr[M]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(U.expr[M]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:q.create(U,this.c,!1)}evaluate(U){for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].evaluate(U))return!1;return!0}static d(U,M,N){const H=[];let Q=!1;for(const J of U)if(J){if(J.type===$.True){Q=!0;continue}if(J.type===$.False)return u.INSTANCE;if(J.type===$.And){H.push(...J.expr);continue}H.push(J)}if(H.length===0&&Q)return b.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(l);for(let J=1;J<H.length;J++)H[J-1].equals(H[J])&&(H.splice(J,1),J--);if(H.length===1)return H[0];for(;H.length>1;){const J=H[H.length-1];if(J.type!==$.Or)break;H.pop();const x=H.pop(),ee=H.length===0,de=L.create(J.expr.map(me=>q.create([me,x],null,N)),null,ee);de&&(H.push(de),H.sort(l))}if(H.length===1)return H[0];if(N){for(let J=0;J<H.length;J++)for(let x=J+1;x<H.length;x++)if(H[J].negate().equals(H[x]))return u.INSTANCE;if(H.length===1)return H[0]}return new q(H,M)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const M of this.expr)U.push(...M.keys());return U}map(U){return new q(this.expr.map(M=>M.map(U)),null)}negate(){if(!this.c){const U=[];for(const M of this.expr)U.push(M.negate());this.c=L.create(U,this,!0)}return this.c}}e.$Pj=q;class L{static create(U,M,N){return L.d(U,M,N)}constructor(U,M){this.expr=U,this.c=M,this.type=$.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const H=l(this.expr[M],U.expr[M]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(U.expr[M]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:L.create(U,this.c,!1)}evaluate(U){for(let M=0,N=this.expr.length;M<N;M++)if(this.expr[M].evaluate(U))return!0;return!1}static d(U,M,N){let H=[],Q=!1;if(U){for(let J=0,x=U.length;J<x;J++){const ee=U[J];if(ee){if(ee.type===$.False){Q=!0;continue}if(ee.type===$.True)return b.INSTANCE;if(ee.type===$.Or){H=H.concat(ee.expr);continue}H.push(ee)}}if(H.length===0&&Q)return u.INSTANCE;H.sort(l)}if(H.length!==0){if(H.length===1)return H[0];for(let J=1;J<H.length;J++)H[J-1].equals(H[J])&&(H.splice(J,1),J--);if(H.length===1)return H[0];if(N){for(let J=0;J<H.length;J++)for(let x=J+1;x<H.length;x++)if(H[J].negate().equals(H[x]))return b.INSTANCE;if(H.length===1)return H[0]}return new L(H,M)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const M of this.expr)U.push(...M.keys());return U}map(U){return new L(this.expr.map(M=>M.map(U)),null)}negate(){if(!this.c){const U=[];for(const M of this.expr)U.push(M.negate());for(;U.length>1;){const M=U.shift(),N=U.shift(),H=[];for(const Q of ne(M))for(const J of ne(N))H.push(q.create([Q,J],null,!1));U.unshift(L.create(H,null,!1))}this.c=L.create(U,this,!0)}return this.c}}e.$Qj=L;class B extends P{static{this.d=[]}static all(){return B.d.values()}constructor(U,M,N){super(U,null),this.f=M,typeof N=="object"?B.d.push({...N,key:U}):N!==!0&&B.d.push({key:U,description:N,type:M!=null?typeof M:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return R.create(this.key,U)}notEqualsTo(U){return j.create(this.key,U)}}e.$Rj=B,e.$Sj=(0,O.$Ai)("contextKeyService");function V(Z,U){return Z<U?-1:Z>U?1:0}function ae(Z,U,M,N){return Z<M?-1:Z>M?1:U<N?-1:U>N?1:0}function G(Z,U){if(Z.type===$.False||U.type===$.True)return!0;if(Z.type===$.Or)return U.type===$.Or?he(Z.expr,U.expr):!1;if(U.type===$.Or){for(const M of U.expr)if(G(Z,M))return!0;return!1}if(Z.type===$.And){if(U.type===$.And)return he(U.expr,Z.expr);for(const M of Z.expr)if(G(M,U))return!0;return!1}return Z.equals(U)}function he(Z,U){let M=0,N=0;for(;M<Z.length&&N<U.length;){const H=Z[M].cmp(U[N]);if(H<0)return!1;H===0&&M++,N++}return M===Z.length}function ne(Z){return Z.type===$.Or?Z.expr:[Z]}}),define(ce[96],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$in=e.ID=void 0,e.$jn=r,e.ID="diagnosticsService",e.$in=(0,i.$Ai)(e.ID);function r(A){return!!A.hostName&&!!A.errorMessage}class k{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$kn=k}),define(ce[124],le([0,1,19,79,171,6,49,4,35]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Yw=e.$Xw=e.$Ww=void 0,e.$Zw=y,e.$1w=h,e.$Ww=(0,A.$Ai)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class f{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,w){const p=[];switch(w){case c.Confirmation:{const v=m;v.primaryButton?p.push(v.primaryButton):p.push((0,k.localize)(0,null)),v.cancelButton?p.push(v.cancelButton):p.push((0,k.localize)(1,null));break}case c.Prompt:{const v=m;Array.isArray(v.buttons)&&v.buttons.length>0&&p.push(...v.buttons.map(S=>S.label)),v.cancelButton&&(v.cancelButton===!0?p.push((0,k.localize)(2,null)):typeof v.cancelButton=="string"?p.push(v.cancelButton):v.cancelButton.label?p.push(v.cancelButton.label):p.push((0,k.localize)(3,null))),p.length===0&&p.push((0,k.localize)(4,null));break}case c.Input:{const v=m;v.primaryButton?p.push(v.primaryButton):p.push((0,k.localize)(5,null)),v.cancelButton?p.push(v.cancelButton):p.push((0,k.localize)(6,null));break}}return p}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===r.default.Info?"info":m===r.default.Error?"error":m===r.default.Warning?"warning":"none"}f(m,w,p){const v=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&v.push(m.cancelButton);let S=v[w]?.run({checkboxChecked:p});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:p}}}e.$Xw=f,e.$Yw=(0,A.$Ai)("fileDialogService");var d;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const $=10;function y(g){const m=[];return m.push(...g.slice(0,$).map(w=>typeof w=="string"?w:(0,i.$$g)(w))),g.length>$&&(g.length-$===1?m.push((0,k.localize)(7,null)):m.push((0,k.localize)(8,null,g.length-$))),m.push(""),m.join(`
`)}function h(g,m){const w=(0,E.$9n)(g);let p=(w.buttons??[]).map(t=>(0,O.$Tw)(t)),v=(g.buttons||[]).map((t,s)=>s),S=0,o=w.cancelId??p.length-1;if(p.length>1){const t=typeof o=="number"?p[o]:void 0;if(I.$k||I.$j){if(typeof t=="string"&&p.length>1&&o!==1){p.splice(o,1),p.splice(1,0,t);const s=v[o];v.splice(o,1),v.splice(1,0,s),o=1}I.$k&&p.length>1&&(p=p.reverse(),v=v.reverse(),S=p.length-1,typeof t=="string"&&(o=S-1))}else if(I.$i&&typeof t=="string"&&p.length>1&&o!==p.length-1){p.splice(o,1),p.push(t);const s=v[o];v.splice(o,1),v.push(s),o=p.length-1}}return w.buttons=p,w.defaultId=S,w.cancelId=o,w.noLink=!0,w.title=w.title||m.nameLong,{options:w,buttonIndeces:v}}}),define(ce[97],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$bX=e.$aX=void 0,e.$cX=A,e.$dX=O,e.$aX=(0,i.$Ai)("encryptionService"),e.$bX=(0,i.$Ai)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var k;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function A(I){return I===k.kwallet||I===k.kwallet5||I===k.kwallet6}function O(I){return I===k.gnomeAny||I===k.gnomeLibsecret||I===k.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,i.$Ai)("environmentService"),e.$Ii=(0,i.$Bi)(e.$Hi)}),define(ce[213],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=e.$Ndc=void 0,e.$Ndc=(0,i.$Ai)("extensionHostStarter"),e.$Odc="extensionHostStarter"}),define(ce[214],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=void 0,e.$$7b=(0,i.$Ai)("externalTerminal"),e.$_7b="Terminal.app"}),define(ce[215],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0,e.$Qdc=(0,i.$Ai)("externalTerminal")}),define(ce[216],le([0,1,50,53,13,9,4,80,21,94,179,214]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=e.$Rdc=void 0;const $=f.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(i,o,c.$tm(),t)}spawnTerminal(o,t,s,a){const n=t.windowsExec||h.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const l=A.$nc(n,".exe").toLowerCase();if(l==="cmder")return o.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return n.indexOf(" ")>=0&&u.push('""'),u.push(n),l==="wt"&&u.push("-d ."),new Promise((b,P)=>{const R=w(process),D=o.spawn(s,u,{cwd:a,env:R,detached:!0});D.on("error",P),D.on("exit",()=>b())})}async runInTerminal(o,t,s,a,n){const l="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows(),u=await h.f();return new Promise((b,P)=>{const R=`"${t} - ${$}"`,D=`"${s.join('" "')}" & pause`,T=Object.assign({},w(process),a);Object.keys(T).filter(z=>T[z]===null).forEach(z=>delete T[z]);const j={cwd:t,env:T,windowsVerbatimArguments:!0};let F,W;A.$nc(l,".exe")==="wt"?(F=l,W=["-d",".",h.b,"/c",D]):u?(F=u,W=["-d",".",l,"/c",D]):(F=h.b,W=["/c","start",R,"/wait",l,"/c",`"${D}"`]),i.spawn(F,W,j).on("error",z=>{P(p(z))}),b(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return h.d}static async f(){try{const o=await c.win32.findExecutable("wt");return await E.Promises.exists(o)?o:void 0}catch{return}}}e.$Rdc=h,Se([r.$5h],h,"f",null);class g extends y{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(i,o,t)}runInTerminal(o,t,s,a,n){const l=n.osxExec||d.$_7b;return new Promise((u,b)=>{if(l===d.$_7b||l==="iTerm.app"){const P=l===d.$_7b?"TerminalHelper":"iTermHelper",D=[k.$Ug.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",o||$,"-w",t];for(const F of s)D.push("-a"),D.push(F);if(a){const F=Object.assign({},w(process),a);for(const W in F){const C=F[W];C===null?(D.push("-u"),D.push(W)):(D.push("-e"),D.push(`${W}=${C}`))}}let T="";const j=i.spawn(g.b,D);j.on("error",F=>{b(p(F))}),j.stderr.on("data",F=>{T+=F.toString()}),j.on("exit",F=>{if(F===0)u(void 0);else if(T){const W=T.split(`
`,1);b(new Error(W[0]))}else b(new Error(f.localize(1,null,P,F)))})}else b(new Error(f.localize(2,null,l)))})}spawnTerminal(o,t,s){const a=t.osxExec||d.$_7b;return new Promise((n,l)=>{const u=["-a",a];s&&u.push(s);const b=w(process),P=o.spawn("/usr/bin/open",u,{cwd:s,env:b});P.on("error",l),P.on("exit",()=>n())})}}e.$Sdc=g;class m extends y{static{this.b=f.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(i,o,t)}runInTerminal(o,t,s,a,n){const l=n.linuxExec?Promise.resolve(n.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,b)=>{const P=[];l.then(R=>{R.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const D=`${v(s)}; echo; read -p "${m.b}" -n1;`;P.push(`''${D}''`);const T=Object.assign({},w(process),a);Object.keys(T).filter(C=>T[C]===null).forEach(C=>delete T[C]);const j={cwd:t,env:T};let F="";const W=i.spawn(R,P,j);W.on("error",C=>{b(p(C))}),W.stderr.on("data",C=>{F+=C.toString()}),W.on("exit",C=>{if(C===0)u(void 0);else if(F){const z=F.split(`
`,1);b(new Error(z[0]))}else b(new Error(f.localize(4,null,R,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$k)m.d=Promise.resolve("xterm");else{const o=await E.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(o,t,s){const a=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{a.then(u=>{const b=w(process),P=o.spawn(u,[],{cwd:s,env:b});P.on("error",l),P.on("exit",()=>n())})})}}e.$Tdc=m;function w(S){const o={...S.env};return(0,I.$rm)(o),o}function p(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(f.localize(5,null,S.path)):S}function v(S){let o="";for(const t of S)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ce[15],le([0,1,61,9,26,12,7,181,6,4,13,65]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=$,e.$9k=m,e.$0k=p,e.$$k=v,e.$_k=S,e.$al=o,e.$bl=t,e.$cl=s,e.$dl=a,e.$el=n,e.$fl=l,e.$hl=P,e.$il=R,e.$jl=D,e.$kl=T,e.$ll=j,e.$ol=se,e.$Al=L,e.$Bl=B,e.$Dl=ae,e.$7k=(0,E.$Ai)("fileService");function $(G){return G.create===!0}var y;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var h;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var g;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function m(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var w;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function p(G){return!!(G.capabilities&w.FileReadWrite)}function v(G){return!!(G.capabilities&w.FileFolderCopy)}function S(G){return!!(G.capabilities&w.FileClone)}function o(G){return!!(G.capabilities&w.FileOpenReadWriteClose)}function t(G){return!!(G.capabilities&w.FileReadStream)}function s(G){return p(G)?!!(G.capabilities&w.FileAtomicRead):!1}function a(G){return p(G)?!!(G.capabilities&w.FileAtomicWrite):!1}function n(G){return!!(G.capabilities&w.FileAtomicDelete)}function l(G){return!!(G.capabilities&w.Readonly)}var u;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class b extends Error{static create(he,ne){const Z=new b(he.toString(),ne);return D(Z,ne),Z}constructor(he,ne){super(he),this.code=ne}}e.$gl=b;function P(G,he){return b.create(G,he)}function R(G){return G||P((0,I.localize)(0,null),u.Unknown)}function D(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function T(G){if(!G)return u.Unknown;if(G instanceof b)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return u.Unknown;switch(he[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function j(G){if(G instanceof ie)return G.fileOperationResult;switch(T(G)){case u.FileNotFound:return te.FILE_NOT_FOUND;case u.FileIsADirectory:return te.FILE_IS_DIRECTORY;case u.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return te.FILE_WRITE_LOCKED;case u.NoPermissions:return te.FILE_PERMISSION_DENIED;case u.FileExists:return te.FILE_MOVE_CONFLICT;case u.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var F;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class W{constructor(he,ne,Z){this.resource=he,this.operation=ne,this.target=Z}isOperation(he){return this.operation===he}}e.$ml=W;var C;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class z{static{this.a=null}constructor(he,ne){this.c=ne,this.b=void 0,this.d=new d.$V(()=>{const Z=i.$Gi.forUris(()=>this.c);return Z.fill(this.rawAdded.map(U=>[U,!0])),Z}),this.f=new d.$V(()=>{const Z=i.$Gi.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(U=>[U,!0])),Z}),this.g=new d.$V(()=>{const Z=i.$Gi.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(U=>[U,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of he){switch(Z.type){case C.ADDED:this.rawAdded.push(Z.resource);break;case C.UPDATED:this.rawUpdated.push(Z.resource);break;case C.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==z.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(he,...ne){return this.h(he,{includeChildren:!1},...ne)}affects(he,...ne){return this.h(he,{includeChildren:!0},...ne)}h(he,ne,...Z){if(!he)return!1;const U=Z.length>0;return!!((!U||Z.includes(C.ADDED))&&(this.d.value.get(he)||ne.includeChildren&&this.d.value.findSuperstr(he))||(!U||Z.includes(C.UPDATED))&&(this.f.value.get(he)||ne.includeChildren&&this.f.value.findSuperstr(he))||(!U||Z.includes(C.DELETED))&&(this.g.value.findSubstr(he)||ne.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$nl=z;function se(G,he,ne){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==r.sep&&(he+=r.sep),ne?(0,k.$Cf)(G,he):G.indexOf(he)===0)}class ie extends Error{constructor(he,ne,Z){super(he),this.fileOperationResult=ne,this.options=Z}}e.$pl=ie;class oe extends ie{constructor(he,ne,Z,U){super(he,ne,U),this.fileOperationResult=ne,this.size=Z}}e.$ql=oe;class K extends ie{constructor(he,ne,Z){super(he,te.FILE_NOT_MODIFIED_SINCE,Z),this.stat=ne}}e.$rl=K;var te;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var q;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$zl="";function L(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function B(G,he){if(!he.hasProvider(O.URI.from({scheme:G.scheme})))return new Promise(ne=>{const Z=he.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===G.scheme&&U.added&&(Z.dispose(),ne())})})}class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(he){return(0,A.$eg)(he)||(he=0),he<V.KB?(0,I.localize)(1,null,he.toFixed(0)):he<V.MB?(0,I.localize)(2,null,(he/V.KB).toFixed(2)):he<V.GB?(0,I.localize)(3,null,(he/V.MB).toFixed(2)):he<V.TB?(0,I.localize)(4,null,(he/V.GB).toFixed(2)):(0,I.localize)(5,null,(he/V.TB).toFixed(2))}}e.$Cl=V;function ae(G){const he=typeof G=="string"||G?.scheme===f.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===f.Schemas.file?1024*V.MB:he?10*V.MB:c.$o?50*V.MB:1024*V.MB}}),define(ce[125],le([0,1,17,16,182,15]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=O;async function O(f,d,$,y,h,g){let m;try{await I(f,d,$,y,h,g)}catch(w){m=w}finally{m&&h.errorTransformer&&(m=h.errorTransformer(m)),typeof m<"u"&&$.error(m),$.end()}}async function I(f,d,$,y,h,g){E(g);const m=await f.open(d,{create:!1});try{E(g);let w=0,p=0,v=h&&typeof h.length=="number"?h.length:void 0,S=i.$Je.alloc(Math.min(h.bufferSize,typeof v=="number"?v:h.bufferSize)),o=h&&typeof h.position=="number"?h.position:0,t=0;do p=await f.read(m,o,S.buffer,t,S.byteLength-t),o+=p,t+=p,w+=p,typeof v=="number"&&(v-=p),t===S.byteLength&&(await $.write(y(S)),S=i.$Je.alloc(Math.min(h.bufferSize,typeof v=="number"?v:h.bufferSize)),t=0);while(p>0&&(typeof v!="number"||v>0)&&E(g)&&c(w,h));if(t>0){let s=t;typeof v=="number"&&(s=Math.min(t,v)),$.write(y(S.slice(0,s)))}}catch(w){throw(0,A.$il)(w)}finally{await f.close(m)}}function E(f){if(f.isCancellationRequested)throw(0,r.$6)();return!0}function c(f,d){if(typeof d?.limits?.size=="number"&&f>d.limits.size)throw(0,A.$hl)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[62],le([0,1,113,2,9,4,7,15]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=void 0,e.$Rq=E,e.$Sq=c,e.$Wq=y,e.$Xq=h,e.$Yq=g,e.$Zq=m,e.$1q=p,e.$2q=v;function E(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class f extends r.$Uc{static{this.a=3}static{this.b=10}constructor(o,t,s,a){super(),this.m=o,this.n=t,this.r=s,this.s=a,this.f=this.B(new r.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const o=new r.$Tc;this.f.value=o,this.c=this.t(o),this.c.setVerboseLogging(this.r),o.add(this.c.onDidChangeFile(t=>this.m(t))),o.add(this.c.onDidLogMessage(t=>this.n(t))),o.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(o,t){if(this.s.restartOnError&&this.g?.length)if(t){const s=this.h.get(t.path)??0;s<f.a?(this.z(`restarting watcher from error in watch request (retrying request): ${o} (${JSON.stringify(t)})`),this.h.set(t.path,s+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${o} (${JSON.stringify(t)})`),this.y(this.g.filter(a=>a.path!==t.path)))}else this.j<f.b?(this.z(`restarting watcher after unknown global error: ${o}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${o}`);else this.z(o)}y(o){this.u(),this.watch(o)}async watch(o){this.g=o,await this.c?.watch(o)}async setVerboseLogging(o){this.r=o,await this.c?.setVerboseLogging(o)}z(o){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${o}`})}C(o){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${o}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Tq=f;class d extends f{constructor(o,t,s){super(o,t,s,{type:"node.js",restartOnError:!1})}}e.$Uq=d;class $ extends f{constructor(o,t,s){super(o,t,s,{type:"universal",restartOnError:!0})}}e.$Vq=$;function y(S){return S.map(o=>({type:o.type,resource:O.URI.revive(o.resource),cId:o.cId}))}function h(S){const o=new w;for(const t of S)o.processEvent(t);return o.coalesce()}function g(S,o){return typeof o=="string"&&!o.startsWith(i.$qk)&&!(0,k.$ic)(o)?{base:S,pattern:o}:o}function m(S,o){const t=[];for(const s of o)t.push((0,i.$uk)(g(S,s)));return t}class w{constructor(){this.a=new Set,this.b=new Map}c(o){return A.$k?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let s=!1;if(t){const a=t.type,n=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===I.FileChangeType.DELETED||o.type===I.FileChangeType.ADDED)?s=!0:a===I.FileChangeType.ADDED&&n===I.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(t)):a===I.FileChangeType.DELETED&&n===I.FileChangeType.ADDED?t.type=I.FileChangeType.UPDATED:a===I.FileChangeType.ADDED&&n===I.FileChangeType.UPDATED||(t.type=n)}else s=!0;s&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(s=>s.type!==I.FileChangeType.DELETED?(o.push(s),!1):!0).sort((s,a)=>s.resource.fsPath.length-a.resource.fsPath.length).filter(s=>t.some(a=>(0,I.$ol)(s.resource.fsPath,a,!A.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(o)}}function p(S,o){if(typeof o=="number")switch(S.type){case I.FileChangeType.ADDED:return(o&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(o&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(o&I.FileChangeFilter.UPDATED)===0}return!1}function v(S){if(typeof S=="number"){const o=[];return S&I.FileChangeFilter.ADDED&&o.push("Added"),S&I.FileChangeFilter.DELETED&&o.push("Deleted"),S&I.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(ce[217],le([0,1,17,48,16,3,2,66,33,15,62]),function(X,e,i,r,k,A,O,I,E,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0,e.$6P="localFilesystem";class d extends O.$Uc{constructor(y,h){super(),this.a=y,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$he),this.onDidWatchError=this.g.event,this.h=(0,E.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(y){return this.a.call("stat",[y])}readdir(y){return this.a.call("readdir",[y])}async readFile(y,h){const{buffer:g}=await this.a.call("readFile",[y,h]);return g}readFileStream(y,h,g){const m=(0,I.$xe)(p=>i.$Je.concat(p.map(v=>i.$Je.wrap(v))).buffer),w=new O.$Tc;return w.add(this.a.listen("readFileStream",[y,h])(p=>{if(p instanceof i.$Je)m.write(p.buffer);else{if(p==="end")m.end();else{let v;if(p instanceof Error)v=p;else{const S=p;v=(0,c.$hl)(S.message??(0,r.$lj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}m.error(v),m.end()}w.dispose()}})),w.add(g.onCancellationRequested(()=>{m.error((0,k.$6)()),m.end(),w.dispose()})),m}writeFile(y,h,g){return this.a.call("writeFile",[y,i.$Je.wrap(h),g])}open(y,h){return this.a.call("open",[y,h])}close(y){return this.a.call("close",[y])}async read(y,h,g,m,w){const[p,v]=await this.a.call("read",[y,h,w]);return g.set(p.buffer.slice(0,v),m),v}write(y,h,g,m,w){return this.a.call("write",[y,h,i.$Je.wrap(g),m,w])}mkdir(y){return this.a.call("mkdir",[y])}delete(y,h){return this.a.call("delete",[y,h])}rename(y,h,g){return this.a.call("rename",[y,h,g])}copy(y,h,g){return this.a.call("copy",[y,h,g])}cloneFile(y,h){return this.a.call("cloneFile",[y,h])}j(){this.B(this.a.listen("fileChange",[this.h])(y=>{if(Array.isArray(y)){const h=y;this.f.fire((0,f.$Wq)(h))}else{const h=y;this.g.fire(h)}}))}watch(y,h){const g=(0,E.$Wg)();return this.a.call("watch",[this.h,g,y,h]),(0,O.$Sc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$7P=d}),define(ce[218],le([0,1,44,2,62,3,15,7,8]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class c extends r.$Uc{constructor(){super(),this.a=this.B(new A.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$4c),this.m=new Set,this.n=5007,this.r=new E.$Xh,this.P=!1,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,k.$Rq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new E.$Xh;try{this.h.clear(),this.g.clear();for(const $ of d)this.t($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const $=new r.$Tc;this.j.set(d.correlationId,$),await this.r.p,!$.isDisposed&&(this.z(d,$),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,$){this.C(d,$)?(this.N(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,$),this.m.add(d.correlationId))}C(d,$){const y=this.M?.subscribe(d.path,(h,g)=>{$.isDisposed||(h?this.z(d,$):g?.type===O.FileChangeType.ADDED&&this.F(d))});return y?($.add(y),!0):!1}D(d,$){let y=!1;const h=(g,m)=>{if($.isDisposed)return;const w=this.G(g),p=this.G(m),v=y;y=w,!w&&(p||v)&&this.F(d)};this.N(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.watchFile)(d.path,{persistent:!1,interval:this.n},h)}catch(g){this.O(`fs.watchFile() failed with error ${g} on path ${d.path} (correlationId: ${d.correlationId})`)}$.add((0,r.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.unwatchFile)(d.path,h)}catch(g){this.O(`fs.unwatchFile() failed with error ${g} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.N(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const $={resource:I.URI.file(d.path),type:O.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([$]),this.H($,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,$){if(this.P){const y=` >> normalized ${d.type===O.FileChangeType.ADDED?"[ADDED]":d.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.I(y,$)}}I(d,$){this.P&&this.N(`${d}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}J(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,k.$2q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.P=d}}e.$$q=c}),define(ce[219],le([0,1,44,8,23,31,2,76,9,4,19,7,114,21,15,62]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,e.$er=w;class m extends O.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(v,S,o,t,s,a){super(),this.s=v,this.t=S,this.u=o,this.w=t,this.y=s,this.z=a,this.c=this.B(new r.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new r.$Oh(n=>this.M(n),m.b)),this.g=(0,g.$Zq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$Zq)(this.s.path,this.s.includes):void 0,this.j=(0,g.$Rq)(this.s)?this.s.filter:void 0,this.m=new k.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const v=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await y.Promises.stat(v);if(this.m.token.isCancellationRequested)return;this.B(await this.G(v,S.isDirectory()))}catch(v){v.code!=="ENOENT"?this.O(v):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${v})`),this.D()}}D(){this.r=!0,this.w?.()}async F(v){let S=v.path;try{S=await y.Promises.realpath(v.path),v.path===S&&(S=await(0,$.$ar)(v.path,this.m.token)??v.path),v.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${S})`)}catch{}return S}async G(v,S){const o=new O.$Tc;return this.H(v,S,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(v,S,o)),o}H(v,S,o){if(S)return!1;const t=d.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(a,n)=>{if(!o.isDisposed)if(a){const l=await this.G(v,S);o.isDisposed?l.dispose():o.add(l)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:n.type,cId:this.s.correlationId},!0)});return s?(o.add(s),!0):!1}async I(v,S,o){if(c.$j&&(0,A.$zg)(v,"/Volumes/",!0)){this.O(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new k.$se(this.m.token);o.add((0,O.$Sc)(()=>t.dispose(!0)));const s=new O.$Tc;o.add(s);try{const a=d.URI.file(this.s.path),n=(0,E.$nc)(v),l=(0,i.watch)(v);s.add((0,O.$Sc)(()=>{l.removeAllListeners(),l.close()})),this.Q(`Started watching: '${v}'`);const u=new Set;if(S)try{for(const P of await y.Promises.readdir(v))u.add(P)}catch(P){this.O(P)}if(t.token.isCancellationRequested)return;const b=new Map;s.add((0,O.$Sc)(()=>{for(const[,P]of b)P.dispose();b.clear()})),l.on("error",(P,R)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${v} for changes using fs.watch() (${P}, ${R})`),this.D())}),l.on("change",(P,R)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${P}"] ${R}`);let D="";if(R&&(D=R.toString(),c.$j&&(D=(0,I.$gm)(D))),!(!D||P!=="change"&&P!=="rename"))if(S)if(P==="rename"){b.get(D)?.dispose();const T=setTimeout(async()=>{if(b.delete(D),D===n&&!await y.Promises.exists(v)){this.J(a);return}if(t.token.isCancellationRequested)return;const j=await this.N((0,E.$jc)(v,D));if(t.token.isCancellationRequested)return;let F;j?u.has(D)?F=h.FileChangeType.UPDATED:(F=h.FileChangeType.ADDED,u.add(D)):(u.delete(D),F=h.FileChangeType.DELETED),this.L({resource:(0,f.$bh)(a,D),type:F,cId:this.s.correlationId})},m.a);b.set(D,(0,O.$Sc)(()=>clearTimeout(T)))}else{let T;u.has(D)?T=h.FileChangeType.UPDATED:(T=h.FileChangeType.ADDED,u.add(D)),this.L({resource:(0,f.$bh)(a,D),type:T,cId:this.s.correlationId})}else if(P==="rename"||D!==n){const T=setTimeout(async()=>{const j=await y.Promises.exists(v);t.token.isCancellationRequested||(j?(this.L({resource:a,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(v,!1))):this.J(a))},m.a);s.clear(),s.add((0,O.$Sc)(()=>clearTimeout(T)))}else this.L({resource:a,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(a){t.token.isCancellationRequested||this.O(`Failed to watch ${v} for changes using fs.watch() (${a.toString()})`),this.D()}}J(v){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:v,type:h.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(v,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${v.type===h.FileChangeType.ADDED?"[ADDED]":v.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!S&&this.g.some(o=>o(v.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${v.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(o=>o(v.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${v.resource.fsPath}`):this.f.work(v))}M(v){const S=(0,g.$Xq)(v),o=[];for(const s of S){if((0,g.$1q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}o.push(s)}if(o.length===0)return;if(this.z)for(const s of o)this.R(` >> normalized ${s.type===h.FileChangeType.ADDED?"[ADDED]":s.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(v){if(c.$k)return y.Promises.exists(v);try{const S=(0,E.$nc)(v);return(await y.Promises.readdir((0,E.$mc)(v))).some(t=>t===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(v){this.z=v}O(v){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}P(v){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}Q(v){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}R(v){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${v}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$dr=m;async function w(p,v,S,o,t=512){const s=await y.Promises.open(p,"r"),a=Buffer.allocUnsafe(t),n=new k.$se(o);let l,u=!1;const b={path:p,excludes:[],recursive:!1},P=new m(b,void 0,R=>{(async()=>{for(const{type:D}of R)if(D===h.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:T}=await y.Promises.read(s,a,0,t,null);if(!T||n.token.isCancellationRequested)break;v(a.slice(0,T))}}catch(T){l=new Error(T),n.dispose(!0)}finally{u=!1}}})()});return await P.ready,S(),new Promise((R,D)=>{n.token.onCancellationRequested(async()=>{P.dispose();try{await y.Promises.close(s)}catch(T){l=new Error(T)}l?D(l):R()})})}}),define(ce[220],le([0,1,3,113,218,4,219,31]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class E extends k.$$q{constructor(f){super(),this.M=f,this.onDidError=i.Event.None,this.watchers=new Set}async L(f){f=this.X(f);const d=[],$=new Set(Array.from(this.watchers));for(const y of f){const h=this.S(y);h&&(0,r.$yk)(h.request.excludes,y.excludes)&&(0,r.$yk)(h.request.includes,y.includes)?$.delete(h):d.push(y)}d.length&&this.N(`Request to start watching: ${d.map(y=>this.J(y)).join(",")}`),$.size&&this.N(`Request to stop watching: ${Array.from($).map(y=>this.J(y.request)).join(",")}`);for(const y of $)this.W(y);for(const y of d)this.U(y)}S(f){for(const d of this.watchers)if(typeof f.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===f.correlationId)return d}else if((0,I.$yg)(d.request.path,f.path,!A.$k))return d}U(f){const d=new O.$dr(f,this.M,y=>this.a.fire(y),()=>this.c.fire(f),y=>this.b.fire(y),this.P),$={request:f,instance:d};this.watchers.add($)}async stop(){await super.stop();for(const f of this.watchers)this.W(f)}W(f){this.N("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}X(f){const d=new Map;for(const $ of f){const y=A.$k?$.path:$.path.toLowerCase();let h=d.get($.correlationId);h||(h=new Map,d.set($.correlationId,h)),h.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J($)}`),h.set(y,$)}return Array.from(d.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const d of this.watchers)d.instance.setVerboseLogging(f)}N(f,d){this.P&&this.b.fire({type:"trace",message:this.$(f,d)})}O(f){this.b.fire({type:"warn",message:this.$(f)})}$(f,d){return d?`[File Watcher (node.js)] ${f} (${this.J(d.request)})`:`[File Watcher (node.js)] ${f}`}}e.$fr=E}),define(ce[221],le([0,1,62,220]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class k extends i.$Uq{constructor(O,I,E){super(O,I,E),this.u()}t(O){return O.add(new r.$fr(void 0))}}e.$gr=k}),define(ce[222],le([0,1,13,45,165,62]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class O extends A.$Vq{constructor(E,c,f){super(E,c,f),this.u()}t(E){const c=E.add(new k.$9q(i.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(c.onDidProcessExit(({code:f,signal:d})=>this.w(`terminated by itself with code ${f}, signal: ${d} (ETERM)`))),r.ProxyChannel.toService((0,r.$hi)(c.getChannel("watcher")))}}e.$0q=O}),define(ce[98],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class i{constructor(...k){this.a=new Map;for(const[A,O]of k)this.set(A,O)}set(k,A){const O=this.a.get(k);return this.a.set(k,A),O}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$yi=i}),define(ce[223],le([0,1,8,16,2,82,212,6,98,109]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const f=!1;class d extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class ${constructor(m=new E.$yi,w=!1,p,v=f){this.i=m,this.j=w,this.k=p,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$zi,this),this._globalGraph=v?p?._globalGraph??new O.$jr(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,k.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,w){this.m();const p=this,v=new class extends ${dispose(){p.h.delete(v),super.dispose()}}(m,this.j,this,this.l);return this.h.add(v),w?.add(v),v}invokeFunction(m,...w){this.m();const p=h.traceInvocation(this.l,m);let v=!1;try{return m({get:o=>{if(v)throw(0,r.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,p);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...w)}finally{v=!0,p.stop()}}createInstance(m,...w){this.m();let p,v;return m instanceof A.$xi?(p=h.traceCreation(this.l,m.ctor),v=this.o(m.ctor,m.staticArguments.concat(w),p)):(p=h.traceCreation(this.l,m),v=this.o(m,w,p)),p.stop(),v}o(m,w=[],p){const v=I._util.getServiceDependencies(m).sort((t,s)=>t.index-s.index),S=[];for(const t of v){const s=this.s(t.id,p);s||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(s)}const o=v.length>0?v[0].index:w.length;if(w.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${w.length} static arguments`);const t=o-w.length;t>0?w=w.concat(new Array(t)):w=w.slice(0,o)}return Reflect.construct(m,w.concat(S))}q(m,w){if(this.i.get(m)instanceof A.$xi)this.i.set(m,w);else if(this.k)this.k.q(m,w);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const w=this.i.get(m);return!w&&this.k?this.k.r(m):w}s(m,w){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const p=this.r(m);return p instanceof A.$xi?this.u(m,p,w.branch(m,!0)):(w.branch(m,!1),p)}u(m,w,p){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,w,p)}finally{this.t.delete(m)}}v(m,w,p){const v=new O.$jr(t=>t.id.toString());let S=0;const o=[{id:m,desc:w,_trace:p}];for(;o.length;){const t=o.pop();if(v.lookupOrInsertNode(t),S++>1e3)throw new d(v);for(const s of I._util.getServiceDependencies(t.desc.ctor)){const a=this.r(s.id);if(a||this.y(`[createInstance] ${m} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),a instanceof A.$xi){const n={id:s.id,desc:a,_trace:t._trace.branch(s.id,!0)};v.insertEdge(t,n),o.push(n)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new d(v);break}for(const{data:s}of t){if(this.r(s.id)instanceof A.$xi){const n=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,n)}v.removeNode(s)}}return this.r(m)}w(m,w,p=[],v,S){if(this.i.get(m)instanceof A.$xi)return this.x(m,w,p,v,S,this.g);if(this.k)return this.k.w(m,w,p,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}x(m,w,p=[],v,S,o){if(v){const t=new $(void 0,this.j,this,this.l);t.c=String(m);const s=new Map,a=new i.$Th(()=>{const n=t.o(w,p,S);for(const[l,u]of s){const b=n[l];if(typeof b=="function")for(const P of u)P.disposable=b.apply(n,P.listener)}return s.clear(),o.add(n),n});return new Proxy(Object.create(null),{get(n,l){if(!a.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let P=s.get(l);return P||(P=new c.$5c,s.set(l,P)),(D,T,j)=>{if(a.isInitialized)return a.value[l](D,T,j);{const F={listener:[D,T,j],disposable:void 0},W=P.push(F);return(0,k.$Sc)(()=>{W(),F.disposable?.dispose()})}}}if(l in n)return n[l];const u=a.value;let b=u[l];return typeof b!="function"||(b=b.bind(u),n[l]=b),b},set(n,l,u){return a.value[l]=u,!0},getPrototypeOf(n){return w.prototype}})}else{const t=this.o(w,p,S);return o.add(t),t}}y(m,w){if(w&&console.warn(m),this.j)throw new Error(m)}}e.$kr=$;var y;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(y||(y={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(y.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,w){return m?new h(y.Invocation,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(m,w){return m?new h(y.Creation,w.name):h.c}static{this.f=0}constructor(m,w){this.type=m,this.name=w,this.g=Date.now(),this.h=[]}branch(m,w){const p=new h(y.Branch,m.toString());return this.h.push([m,w,p]),p}stop(){const m=Date.now()-this.g;h.f+=m;let w=!1;function p(S,o){const t=[],s=new Array(S+1).join("	");for(const[a,n,l]of o.h)if(n&&l){w=!0,t.push(`${s}CREATES -> ${a}`);const u=p(S+1,l);u&&t.push(u)}else t.push(`${s}uses -> ${a}`);return t.join(`
`)}const v=[`${this.type===y.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(m>2||w)&&h.all.add(v.join(`
`))}}e.$lr=h}),define(ce[224],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.IssueSource=e.IssueType=void 0;var r;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var k;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$C0b=(0,i.$Ai)("issueService")}),define(ce[5],le([0,1,186,48,3,47,2,32,4,19,12,7,123,6]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=g,e.log=w,e.$ik=b,e.$jk=P,e.$kk=R,e.$lk=D,e.$7j=(0,y.$Ai)("logService"),e.$8j=(0,y.$Ai)("loggerService");function h(){return new Date().toISOString()}function g(T){return(0,f.$eg)(T)}var m;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$0j=m.Info;function w(T,j,F){switch(j){case m.Trace:T.trace(F);break;case m.Debug:T.debug(F);break;case m.Info:T.info(F);break;case m.Warning:T.warn(F);break;case m.Error:T.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${j}`)}}function p(T,j=!1){let F="";for(let W=0;W<T.length;W++){let C=T[W];if(C instanceof Error&&(C=(0,r.$lj)(C,j)),typeof C=="object")try{C=JSON.stringify(C)}catch{}F+=(W>0?" ":"")+C}return F}class v extends O.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new k.$he),this.onDidChangeLogLevel=this.c.event}setLevel(j){this.b!==j&&(this.b=j,this.c.fire(this.b))}getLevel(){return this.b}f(j){return this.b!==m.Off&&this.b<=j}}e.$_j=v;class S extends v{constructor(j){super(),this.h=j}f(j){return this.h||super.f(j)}trace(j,...F){this.f(m.Trace)&&this.g(m.Trace,p([j,...F],!0))}debug(j,...F){this.f(m.Debug)&&this.g(m.Debug,p([j,...F]))}info(j,...F){this.f(m.Info)&&this.g(m.Info,p([j,...F]))}warn(j,...F){this.f(m.Warning)&&this.g(m.Warning,p([j,...F]))}error(j,...F){if(this.f(m.Error))if(j instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=j.stack,this.g(m.Error,p(W))}else this.g(m.Error,p([j,...F]))}flush(){}}e.$ak=S;class o extends v{constructor(j=e.$0j){super(),this.setLevel(j),this.g=!E.$i}trace(j,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,j,...F):console.log(`[main ${h()}]`,j,...F))}debug(j,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,j,...F):console.log(`[main ${h()}]`,j,...F))}info(j,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,j,...F):console.log(`[main ${h()}]`,j,...F))}warn(j,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,j,...F):console.warn(`[main ${h()}]`,j,...F))}error(j,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,j,...F):console.error(`[main ${h()}]`,j,...F))}flush(){}}e.$bk=o;class t extends v{constructor(j=e.$0j,F=!0){super(),this.g=F,this.setLevel(j)}trace(j,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",j,...F):console.log(j,...F))}debug(j,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",j,...F):console.log(j,...F))}info(j,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",j,...F):console.log(j,...F))}warn(j,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",j,...F):console.log(j,...F))}error(j,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",j,...F):console.error(j,...F))}flush(){}}e.$ck=t;class s extends v{constructor(j,F=e.$0j){super(),this.g=j,this.setLevel(F)}trace(j,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(j),...F])}debug(j,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(j),...F])}info(j,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(j),...F])}warn(j,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(j),...F])}error(j,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(j),...F])}h(j){return typeof j=="string"?j:(0,r.$lj)(j,this.f(m.Trace))}flush(){}}e.$dk=s;class a extends v{constructor(j){super(),this.g=j,j.length&&this.setLevel(j[0].getLevel())}setLevel(j){for(const F of this.g)F.setLevel(j);super.setLevel(j)}trace(j,...F){for(const W of this.g)W.trace(j,...F)}debug(j,...F){for(const W of this.g)W.debug(j,...F)}info(j,...F){for(const W of this.g)W.info(j,...F)}warn(j,...F){for(const W of this.g)W.warn(j,...F)}error(j,...F){for(const W of this.g)W.error(j,...F)}flush(){for(const j of this.g)j.flush()}dispose(){for(const j of this.g)j.dispose();super.dispose()}}e.$ek=a;class n extends O.$Uc{constructor(j,F,W){if(super(),this.h=j,this.j=F,this.b=new I.$Ac,this.c=this.B(new k.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$he),this.onDidChangeVisibility=this.g.event,W)for(const C of W)this.b.set(C.resource,{logger:void 0,info:C})}m(j){return(0,f.$ag)(j)?[...this.b.values()].find(F=>F.info.id===j):this.b.get(j)}getLogger(j){return this.m(j)?.logger}createLogger(j,F){const W=this.n(j),C=(0,f.$ag)(j)?j:F?.id??(0,A.$oj)(W.toString()).toString(16);let z=this.b.get(W)?.logger;const se=F?.logLevel==="always"?m.Trace:F?.logLevel;z||(z=this.s(W,se??this.getLogLevel(W)??this.h,{...F,id:C}));const ie={logger:z,info:{resource:W,id:C,logLevel:se,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(ie.info),this.b.set(W,ie),z}n(j){return(0,f.$ag)(j)?(0,c.$bh)(this.j,`${j}.log`):j}setLogLevel(j,F){if(d.URI.isUri(j)){const W=j,C=F,z=this.b.get(W);z&&C!==z.info.logLevel&&(z.info.logLevel=C===this.h?void 0:C,z.logger?.setLevel(C),this.b.set(z.info.resource,z),this.f.fire([W,C]))}else{this.h=j;for(const[W,C]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(j,F){const W=this.m(j);W&&F!==!W.info.hidden&&(W.info.hidden=!F,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,F]))}getLogLevel(j){let F;return j&&(F=this.b.get(j)?.info.logLevel),F??this.h}registerLogger(j){const F=this.b.get(j.resource);F?F.info.hidden!==j.hidden&&this.setVisibility(j.resource,!j.hidden):(this.b.set(j.resource,{info:j,logger:void 0}),this.c.fire({added:[j],removed:[]}))}deregisterLogger(j){const F=this.b.get(j);F&&(F.logger&&F.logger.dispose(),this.b.delete(j),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const j of this.b.values())yield j.info}getRegisteredLogger(j){return this.b.get(j)?.info}dispose(){this.b.forEach(j=>j.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=n;class l{constructor(){this.onDidChangeLogLevel=new k.$he().event}setLevel(j){}getLevel(){return m.Info}trace(j,...F){}debug(j,...F){}info(j,...F){}warn(j,...F){}error(j,...F){}critical(j,...F){}dispose(){}flush(){}}e.$gk=l;class u extends l{}e.$hk=u;function b(T){if(T.verbose)return m.Trace;if(typeof T.logLevel=="string"){const j=D(T.logLevel.toLowerCase());if(j!==void 0)return j}return e.$0j}function P(T){switch(T){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function R(T){switch(T){case m.Trace:return{original:"Trace",value:i.localize(0,null)};case m.Debug:return{original:"Debug",value:i.localize(1,null)};case m.Info:return{original:"Info",value:i.localize(2,null)};case m.Warning:return{original:"Warning",value:i.localize(3,null)};case m.Error:return{original:"Error",value:i.localize(4,null)};case m.Off:return{original:"Off",value:i.localize(5,null)}}}function D(T){switch(T){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$mk=new $.$Rj("logLevel",P(m.Info))});var re=this&&this.__param||function(X,e){return function(i,r){e(i,r,X)}};define(ce[225],le([0,1,14,4,97,5]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;const O=i.safeStorage;let I=class{constructor(c){this.a=c,i.app.commandLine.getSwitchValue("password-store")===k.PasswordStoreCLIOption.basic&&O.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const f=JSON.stringify(O.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),f}catch(f){throw this.a.error(f),f}}async decrypt(c){let f;try{if(f=JSON.parse(c),!f.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const d=Buffer.from(f.data);this.a.trace("[EncryptionMainService] Decrypting value.");const $=O.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),$}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$i)return Promise.resolve(k.KnownStorageProvider.dplib);if(r.$j)return Promise.resolve(k.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{const c=O.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(k.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$Mdc=I,e.$Mdc=I=Se([re(0,A.$7j)],I)}),define(ce[226],le([0,1,22,8,16,3,31,2,9,62,5]),function(X,e,i,r,k,A,O,I,E,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class d extends I.$Uc{constructor(y,h){super(),this.a=y,this.b=h,this.c=this.B(new A.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$yh(0)),this.w=[],this.y=this.B(new r.$yh(0))}watch(y,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(y,h):this.z(y,h)}n(y,h){const g={path:this.J(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},m=(0,i.$Tb)(this.j,g);return this.r(),(0,I.$Sc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,k.$1)(y))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,c.$Wq)(h)),h=>this.G(h),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.j)(0,c.$Sq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.j)(0,c.$Sq)(h)&&y.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,h){const g={path:this.J(y),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},m=(0,i.$Tb)(this.w,g);return this.C(),(0,I.$Sc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,k.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,c.$Wq)(y)),y=>this.G(y),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,E.$hc)(y.fsPath)}J(y){const h=this.I(y);return(0,O.$Cg)(h)}}e.$3q=d}),define(ce[227],le([0,1,22,8,17,23,3,47,75,2,61,13,69,19,66,180,15,125,5,16]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let o=class extends c.$Uc{static{S=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new O.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$he),this.Y=this.B(new O.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Jh)}registerProvider(s,a){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${s}`);const n=new c.$Tc;return this.h.set(s,a),this.c.fire({added:!0,scheme:s,provider:a}),n.add(a.onDidChangeFile(l=>{const u=new m.$nl(l,!this.S(a));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(l=>this.Z.fire(new Error(l)))),n.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:s}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:s,provider:a}),this.h.delete(s),(0,c.$Pc)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const a=[];this.f.fire({scheme:s,join(n){a.push(n)}}),!this.h.has(s)&&await r.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,a){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return E.Iterable.map(this.h,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async j(s){if(!(0,y.$fh)(s))throw new m.$pl((0,g.localize)(0,null,this.sb(s)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const a=this.h.get(s.scheme);if(!a){const n=new v.$bb;throw n.message=(0,g.localize)(1,null,s.toString()),n}return a}async m(s){const a=await this.j(s);if((0,m.$al)(a)||(0,m.$0k)(a)||(0,m.$bl)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const a=await this.j(s);if((0,m.$al)(a)||(0,m.$0k)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.s(s,a)}catch(n){throw(0,m.$kl)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$pl((0,g.localize)(2,null,this.sb(s)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$il)(n)}}async s(s,a){const n=await this.j(s),l=this.S(n),u=a?.resolveTo,b=a?.resolveSingleChildDescendants,P=a?.resolveMetadata,R=await n.stat(s);let D;return this.t(n,s,R,void 0,!!P,(T,j)=>(D||(D=f.$Gi.forUris(()=>!l),D.set(s,!0),u&&D.fill(!0,u)),D.get(T.resource)||D.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&b?j===1:!1))}async t(s,a,n,l,u,b){const{providerExtUri:P}=this.R(s),R={resource:a,name:P.basename(a),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(s.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Al)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&b(R,l)){try{const D=await s.readdir(a),T=await r.Promises.settled(D.map(async([j,F])=>{try{const W=P.joinPath(a,j),C=u?await s.stat(W):{type:F};return await this.t(s,W,C,D.length,u,b)}catch(W){return this.b.trace(W),null}}));R.children=(0,i.$Hb)(T)}catch(D){this.b.trace(D),R.children=[]}return R}return R}async resolveAll(s){return r.Promises.settled(s.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const a=await this.j(s),n=await a.stat(s);return this.t(a,s,n,void 0,!0,()=>!1)}async exists(s){const a=await this.j(s);try{return!!await a.stat(s)}catch{return!1}}async canCreateFile(s,a){try{await this.u(s,a)}catch(n){return n}return!0}async u(s,a){if(!a?.overwrite&&await this.exists(s))throw new m.$pl((0,g.localize)(3,null,this.sb(s)),m.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(s,a=k.$Je.fromString(""),n){await this.u(s,n);const l=await this.writeFile(s,a);return this.r.fire(new m.$ml(s,m.FileOperation.CREATE,l)),l}async writeFile(s,a,n){const l=this.qb(await this.n(s),s),{providerExtUri:u}=this.R(l);let b=n;if((0,m.$dl)(l)&&!b?.atomic){const P=l.enforceAtomicWriteFile?.(s);P&&(b={...n,atomic:P})}try{await this.w(l,s,b)||await this.U(l,u.dirname(s));let R;if((0,m.$0k)(l)&&!(a instanceof k.$Je))if((0,h.$ve)(a)){const D=await(0,h.$Ce)(a,3);D.ended?R=k.$Je.concat(D.buffer):R=D}else R=(0,h.$ze)(a,D=>k.$Je.concat(D),3);else R=a;!(0,m.$al)(l)||(0,m.$0k)(l)&&R instanceof k.$Je||(0,m.$0k)(l)&&(0,m.$dl)(l)&&b?.atomic?await this.hb(l,s,b,R):await this.db(l,s,b,R instanceof k.$Je?(0,k.$Ue)(R):R),this.r.fire(new m.$ml(s,m.FileOperation.WRITE))}catch(P){throw new m.$pl((0,g.localize)(4,null,this.sb(s),(0,m.$il)(P).toString()),(0,m.$ll)(P),b)}return this.resolve(s,{resolveMetadata:!0})}async w(s,a,n){const l=!!n?.unlock;if(l&&!(s.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(5,null,this.sb(a)));if(!!n?.atomic){if(!(s.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(6,null,this.sb(a)));if(!(s.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(7,null,this.sb(a)));if(l)throw new Error((0,g.localize)(8,null,this.sb(a)))}let b;try{b=await s.stat(a)}catch{return}if(b.type&m.FileType.Directory)throw new m.$pl((0,g.localize)(9,null,this.sb(a)),m.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.rb(a,b),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$zl&&typeof b.mtime=="number"&&typeof b.size=="number"&&n.mtime<b.mtime&&n.etag!==(0,m.$Al)({mtime:n.mtime,size:b.size}))throw new m.$pl((0,g.localize)(10,null),m.FileOperationResult.FILE_MODIFIED_SINCE,n);return b}async readFile(s,a,n){const l=await this.m(s);return a?.atomic?this.z(l,s,a,n):this.C(l,s,a,n)}async z(s,a,n,l){return new Promise((u,b)=>{this.cb.queueFor(a,async()=>{try{const P=await this.C(s,a,n,l);u(P)}catch(P){b(P)}},this.R(s).providerExtUri)})}async C(s,a,n,l){const u=await this.D(s,a,{...n,preferUnbuffered:!0},l);return{...u,value:await(0,k.$Ve)(u.value)}}async readFileStream(s,a,n){const l=await this.m(s);return this.D(l,s,a,n)}async D(s,a,n,l){const u=new A.$se(l);let b=n;(0,m.$cl)(s)&&s.enforceAtomicReadFile?.(a)&&(b={...n,atomic:!0});const P=this.J(a,b).then(D=>D,D=>{throw u.dispose(!0),D});let R;try{return typeof b?.etag=="string"&&b.etag!==m.$zl&&await P,b?.atomic&&(0,m.$cl)(s)||!((0,m.$al)(s)||(0,m.$bl)(s))||(0,m.$0k)(s)&&b?.preferUnbuffered?R=this.I(s,a,b):(0,m.$bl)(s)?R=this.G(s,a,u.token,b):R=this.H(s,a,u.token,b),R.on("end",()=>u.dispose()),R.on("error",()=>u.dispose()),{...await P,value:R}}catch(D){throw R&&await(0,h.$Ae)(R),this.F(D,a,b)}}F(s,a,n){const l=(0,g.localize)(11,null,this.sb(a),(0,m.$il)(s).toString());return s instanceof m.$rl?new m.$rl(l,s.stat,n):s instanceof m.$ql?new m.$ql(l,s.fileOperationResult,s.size,s.options):new m.$pl(l,(0,m.$ll)(s),n)}G(s,a,n,l=Object.create(null)){const u=s.readFileStream(a,l,n);return(0,h.$Ge)(u,{data:b=>b instanceof k.$Je?b:k.$Je.wrap(b),error:b=>this.F(b,a,l)},b=>k.$Je.concat(b))}H(s,a,n,l=Object.create(null)){const u=(0,k.$Ze)();return(0,w.$Pq)(s,a,u,b=>b,{...l,bufferSize:this.a,errorTransformer:b=>this.F(b,a,l)},n),u}I(s,a,n){const l=(0,h.$xe)(u=>k.$Je.concat(u));return(async()=>{try{let u;n?.atomic&&(0,m.$cl)(s)?u=await s.readFile(a,{atomic:!0}):u=await s.readFile(a),typeof n?.position=="number"&&(u=u.slice(n.position)),typeof n?.length=="number"&&(u=u.slice(0,n.length)),this.L(a,u.byteLength,n),l.end(k.$Je.wrap(u))}catch(u){l.error(u),l.end()}})(),l}async J(s,a){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new m.$pl((0,g.localize)(12,null,this.sb(s)),m.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==m.$zl&&a.etag===n.etag)throw new m.$rl((0,g.localize)(13,null),n,a);return this.L(s,n.size,a),n}L(s,a,n){if(typeof n?.limits?.size=="number"&&a>n.limits.size)throw new m.$ql((0,g.localize)(14,null,this.sb(s)),m.FileOperationResult.FILE_TOO_LARGE,a,n)}async canMove(s,a,n){return this.M(s,a,"move",n)}async canCopy(s,a,n){return this.M(s,a,"copy",n)}async M(s,a,n,l){if(s.toString()!==a.toString())try{const u=n==="move"?this.qb(await this.n(s),s):await this.m(s),b=this.qb(await this.n(a),a);await this.Q(u,s,b,a,n,l)}catch(u){return u}return!0}async move(s,a,n){const l=this.qb(await this.n(s),s),u=this.qb(await this.n(a),a),b=await this.N(l,s,u,a,"move",!!n),P=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new m.$ml(s,b==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,P)),P}async copy(s,a,n){const l=await this.m(s),u=this.qb(await this.n(a),a),b=await this.N(l,s,u,a,"copy",!!n),P=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new m.$ml(s,b==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,P)),P}async N(s,a,n,l,u,b){if(a.toString()===l.toString())return u;const{exists:P,isSameResourceWithDifferentPathCase:R}=await this.Q(s,a,n,l,u,b);if(P&&!R&&b&&await this.del(l,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(l)),u==="copy"){if(s===n&&(0,m.$$k)(s))await s.copy(a,l,{overwrite:b});else{const D=await this.resolve(a);D.isDirectory?await this.P(s,D,n,l):await this.O(s,a,n,l)}return u}else return s===n?(await s.rename(a,l,{overwrite:b}),u):(await this.N(s,a,n,l,"copy",b),await this.del(a,{recursive:!0}),"copy")}async O(s,a,n,l){if((0,m.$al)(s)&&(0,m.$al)(n))return this.jb(s,a,n,l);if((0,m.$al)(s)&&(0,m.$0k)(n))return this.pb(s,a,n,l);if((0,m.$0k)(s)&&(0,m.$al)(n))return this.nb(s,a,n,l);if((0,m.$0k)(s)&&(0,m.$0k)(n))return this.lb(s,a,n,l)}async P(s,a,n,l){await n.mkdir(l),Array.isArray(a.children)&&await r.Promises.settled(a.children.map(async u=>{const b=this.R(n).providerExtUri.joinPath(l,u.name);return u.isDirectory?this.P(s,await this.resolve(u.resource),n,b):this.O(s,u.resource,n,b)}))}async Q(s,a,n,l,u,b){let P=!1;if(s===n){const{providerExtUri:D,isPathCaseSensitive:T}=this.R(s);if(T||(P=D.isEqual(a,l)),P&&u==="copy")throw new Error((0,g.localize)(15,null,this.sb(a),this.sb(l)));if(!P&&D.isEqualOrParent(l,a))throw new Error((0,g.localize)(16,null,this.sb(a),this.sb(l)))}const R=await this.exists(l);if(R&&!P){if(!b)throw new m.$pl((0,g.localize)(17,null,this.sb(a),this.sb(l)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(s===n){const{providerExtUri:D}=this.R(s);if(D.isEqualOrParent(a,l))throw new Error((0,g.localize)(18,null,this.sb(a),this.sb(l)))}}return{exists:R,isSameResourceWithDifferentPathCase:P}}R(s){const a=this.S(s);return{providerExtUri:a?y.$4g:y.$6g,isPathCaseSensitive:a}}S(s){return!!(s.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const a=this.qb(await this.j(s),s);await this.U(a,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new m.$ml(s,m.FileOperation.CREATE,n)),n}async U(s,a){const n=[],{providerExtUri:l}=this.R(s);for(;!l.isEqual(a,l.dirname(a));)try{if(!((await s.stat(a)).type&m.FileType.Directory))throw new Error((0,g.localize)(19,null,this.sb(a)));break}catch(u){if((0,m.$kl)(u)!==m.FileSystemProviderErrorCode.FileNotFound)throw u;n.push(l.basename(a)),a=l.dirname(a)}for(let u=n.length-1;u>=0;u--){a=l.joinPath(a,n[u]);try{await s.mkdir(a)}catch(b){if((0,m.$kl)(b)!==m.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(s,a){try{await this.W(s,a)}catch(n){return n}return!0}async W(s,a){const n=this.qb(await this.j(s),s),l=!!a?.useTrash;if(l&&!(n.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(20,null,this.sb(s)));const u=a?.atomic;if(u&&!(n.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(21,null,this.sb(s)));if(l&&u)throw new Error((0,g.localize)(22,null,this.sb(s)));let b;try{b=await n.stat(s)}catch{}if(b)this.rb(s,b);else throw new m.$pl((0,g.localize)(23,null,this.sb(s)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,g.localize)(24,null,this.sb(s)))}return n}async del(s,a){const n=await this.W(s,a);let l=a;if((0,m.$el)(n)&&!l?.atomic){const R=n.enforceAtomicDelete?.(s);R&&(l={...a,atomic:R})}const u=!!l?.useTrash,b=!!l?.recursive,P=l?.atomic??!1;await n.delete(s,{recursive:b,useTrash:u,atomic:P}),this.r.fire(new m.$ml(s,m.FileOperation.DELETE))}async cloneFile(s,a){const n=await this.j(s),l=this.qb(await this.n(a),a);if(!(n===l&&this.R(n).providerExtUri.isEqual(s,a)))return n===l&&(0,m.$_k)(n)?n.cloneFile(s,a):(await this.U(l,this.R(l).providerExtUri.dirname(a)),n===l&&(0,m.$$k)(n)?this.cb.queueFor(s,()=>n.copy(s,a,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(s,()=>this.O(n,s,l,a),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(s,a){return this.watch(s,{...a,correlationId:S.ab++})}watch(s,a={recursive:!1,excludes:[]}){const n=new c.$Tc;let l=!1,u=()=>{l=!0};n.add((0,c.$Sc)(()=>u())),(async()=>{try{const P=await this.bb(s,a);l?(0,c.$Pc)(P):u=()=>(0,c.$Pc)(P)}catch(P){this.b.error(P)}})();const b=a.correlationId;if(typeof b=="number"){const P=n.add(new O.$he);return n.add(this.X.event(D=>{D.correlates(b)&&P.fire(D)})),{onDidChange:P.event,dispose:()=>n.dispose()}}return n}async bb(s,a){const n=await this.j(s),l=(0,I.$oj)([this.R(n).providerExtUri.getComparisonKey(s),a]);let u=this.$.get(l);return u||(u={count:0,disposable:n.watch(s,a)},this.$.set(l,u)),u.count+=1,(0,c.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,c.$Pc)(u.disposable),this.$.delete(l)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,c.$Pc)(s.disposable);this.$.clear()}async db(s,a,n,l){return this.cb.queueFor(a,async()=>{const u=await s.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,h.$ve)(l)||(0,h.$we)(l)?await this.eb(s,u,l):await this.fb(s,u,l)}catch(b){throw(0,m.$il)(b)}finally{await s.close(u)}},this.R(s).providerExtUri)}async eb(s,a,n){let l=0,u;if((0,h.$we)(n)){if(n.buffer.length>0){const b=k.$Je.concat(n.buffer);await this.gb(s,a,b,b.byteLength,l,0),l+=b.byteLength}if(n.ended)return;u=n.stream}else u=n;return new Promise((b,P)=>{(0,h.$Be)(u,{onData:async R=>{u.pause();try{await this.gb(s,a,R,R.byteLength,l,0)}catch(D){return P(D)}l+=R.byteLength,setTimeout(()=>u.resume())},onError:R=>P(R),onEnd:()=>b()})})}async fb(s,a,n){let l=0,u;for(;(u=n.read())!==null;)await this.gb(s,a,u,u.byteLength,l,0),l+=u.byteLength}async gb(s,a,n,l,u,b){let P=0;for(;P<l;){const R=await s.write(a,u+P,n.buffer,b+P,l-P);P+=R}}async hb(s,a,n,l){return this.cb.queueFor(a,()=>this.ib(s,a,n,l),this.R(s).providerExtUri)}async ib(s,a,n,l){let u;l instanceof k.$Je?u=l:(0,h.$ve)(l)?u=await(0,k.$Ve)(l):(0,h.$we)(l)?u=await(0,k.$We)(l):u=(0,k.$Te)(l),await s.writeFile(a,u.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(s,a,n,l){return this.cb.queueFor(l,()=>this.kb(s,a,n,l),this.R(n).providerExtUri)}async kb(s,a,n,l){let u,b;try{u=await s.open(a,{create:!1}),b=await n.open(l,{create:!0,unlock:!1});const P=k.$Je.alloc(this.a);let R=0,D=0,T=0;do T=await s.read(u,R,P.buffer,D,P.byteLength-D),await this.gb(n,b,P,T,R,D),R+=T,D+=T,D===P.byteLength&&(D=0);while(T>0)}catch(P){throw(0,m.$il)(P)}finally{await r.Promises.settled([typeof u=="number"?s.close(u):Promise.resolve(),typeof b=="number"?n.close(b):Promise.resolve()])}}async lb(s,a,n,l){return this.cb.queueFor(l,()=>this.mb(s,a,n,l),this.R(n).providerExtUri)}async mb(s,a,n,l){return n.writeFile(l,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,a,n,l){return this.cb.queueFor(l,()=>this.ob(s,a,n,l),this.R(n).providerExtUri)}async ob(s,a,n,l){const u=await n.open(l,{create:!0,unlock:!1});try{const b=await s.readFile(a);await this.gb(n,u,k.$Je.wrap(b),b.byteLength,0,0)}catch(b){throw(0,m.$il)(b)}finally{await n.close(u)}}async pb(s,a,n,l){const u=await(0,k.$Ve)(this.H(s,a,A.CancellationToken.None));await this.hb(n,l,void 0,u)}qb(s,a){if(s.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$pl((0,g.localize)(25,null,this.sb(a)),m.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,a){if((a.permissions??0)&m.FilePermission.Readonly)throw new m.$pl((0,g.localize)(26,null,this.sb(s)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString(!0)}};e.$Qq=o,e.$Qq=o=S=Se([re(0,p.$7j)],o)}),define(ce[99],le([0,1,44,318,8,32,17,3,31,2,9,4,19,66,21,184,15,125,226,48,222,221]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0,(()=>{try{(0,r.gracefulify)(i)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.$lj)(s)}`)}})();class t extends p.$3q{static{this.L=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=I.Event.None,this.P=new A.$Ac(l=>$.$5g.getComparisonKey(l)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,d.$k&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:n,symbolicLink:l}=await h.SymlinkSupport.stat(this.I(a));return{type:this.O(n,l),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await h.Promises.readdir(this.I(a),{withFileTypes:!0}),l=[];return await Promise.all(n.map(async u=>{try{let b;u.isSymbolicLink()?b=(await this.stat((0,$.$bh)(a,u.name))).type:b=this.O(u),l.push([u.name,b])}catch(b){this.a.trace(b)}})),l}catch(n){throw this.hb(n)}}O(a,n){let l;return n?.dangling?l=m.FileType.Unknown:a.isFile()?l=m.FileType.File:a.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,n&&(l|=m.FileType.SymbolicLink),l}async Q(a){const n=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let l;for(;l=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await l.wait();const u=new k.$zh;return this.P.set(a,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(a)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(a,n){let l;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),l=await this.Q(a));const u=this.I(a);return await h.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{l?.dispose()}}R(a){t.L&&this.a.trace(a)}readFileStream(a,n,l){const u=(0,y.$xe)(b=>O.$Je.concat(b.map(P=>O.$Je.wrap(P))).buffer);return(0,w.$Pq)(this,a,u,b=>b.buffer,{...n,bufferSize:256*1024},l),u}async writeFile(a,n,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.S(a)?this.U(a,(0,$.$bh)((0,$.$ah)(a),`${(0,$.$$g)(a)}${l.atomic.postfix}`),n,l):this.W(a,n,l)}async S(a){try{const n=this.I(a),{symbolicLink:l}=await h.SymlinkSupport.stat(n);if(l)return!1}catch{}return!0}async U(a,n,l,u){const b=new c.$Tc;try{b.add(await this.Q(a)),b.add(await this.Q(n)),await this.W(n,l,u,!0);try{await this.rename(n,a,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{b.dispose()}}async W(a,n,l,u){let b;try{const P=this.I(a);if(!l.create||!l.overwrite){if(await h.Promises.exists(P)){if(!l.overwrite)throw(0,m.$hl)((0,g.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.$hl)((0,g.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(a,{create:!0,unlock:l.unlock},u),await this.write(b,0,n,0,n.byteLength)}catch(P){throw await this.ib(a,P)}finally{typeof b=="number"&&await this.close(b)}}static{this.$=!0}static configureFlushOnWrite(a){t.$=a}async open(a,n,l){const u=this.I(a);let b;(0,m.$8k)(n)&&!l&&(b=await this.Q(a));let P;try{if((0,m.$8k)(n)&&n.unlock)try{const{stat:D}=await h.SymlinkSupport.stat(u);D.mode&128||await h.Promises.chmod(u,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let R;if((0,m.$8k)(n)){if(d.$i)try{await h.Promises.truncate(u,0),R="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}R||(R="w")}else R="r";P=await h.Promises.open(u,R)}catch(R){throw b?.dispose(),(0,m.$8k)(n)?await this.ib(a,R):this.hb(R)}if(this.X.set(P,0),(0,m.$8k)(n)&&this.Z.set(P,a),b){const R=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${u})`),this.Y.set(P,b),R&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${u})`),R.dispose())}return P}async close(a){const n=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&t.$)try{await h.Promises.fdatasync(a)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await h.Promises.close(a)}catch(l){throw this.hb(l)}finally{n&&(this.Y.get(a)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,l,u,b){const P=this.ab(a,n);let R=null;try{R=(await h.Promises.read(a,l,u,b,P)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(a,P,R)}return R}ab(a,n){return n===this.X.get(a)?null:n}bb(a,n,l){const u=this.X.get(a);typeof u=="number"&&(typeof n=="number"||(typeof l=="number"?this.X.set(a,u+l):this.X.delete(a)))}async write(a,n,l,u,b){return(0,k.$Uh)(()=>this.cb(a,n,l,u,b),100,3)}async cb(a,n,l,u,b){const P=this.ab(a,n);let R=null;try{R=(await h.Promises.write(a,l,u,b,P)).bytesWritten}catch(D){throw await this.ib(this.Z.get(a),D)}finally{this.bb(a,P,R)}return R}async mkdir(a){try{await h.Promises.mkdir(this.I(a))}catch(n){throw this.hb(n)}}async delete(a,n){try{const l=this.I(a);if(n.recursive){let u;n?.atomic!==!1&&n.atomic.postfix&&(u=(0,f.$jc)((0,f.$mc)(l),`${(0,f.$nc)(l)}${n.atomic.postfix}`)),await h.Promises.rm(l,h.RimRafMode.MOVE,u)}else try{await h.Promises.unlink(l)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let b=!1;try{const{stat:P,symbolicLink:R}=await h.SymlinkSupport.stat(l);b=P.isDirectory()&&!R}catch{}if(b)await h.Promises.rmdir(l);else throw u}else throw u}}catch(l){throw this.hb(l)}}async rename(a,n,l){const u=this.I(a),b=this.I(n);if(u!==b)try{await this.db(a,n,"move",l.overwrite),await h.Promises.rename(u,b)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,g.localize)(2,null,(0,f.$nc)(u),(0,f.$nc)((0,f.$mc)(b)),P.toString()))),this.hb(P)}}async copy(a,n,l){const u=this.I(a),b=this.I(n);if(u!==b)try{await this.db(a,n,"copy",l.overwrite),await h.Promises.copy(u,b,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,g.localize)(3,null,(0,f.$nc)(u),(0,f.$nc)((0,f.$mc)(b)),P.toString()))),this.hb(P)}}async db(a,n,l,u){const b=this.I(a),P=this.I(n);let R=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(R=(0,E.$yg)(b,P,!0)),R){if(l==="copy")throw(0,m.$hl)((0,g.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const T=await this.N(a);if(!T)throw(0,m.$hl)((0,g.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const j=await this.N(n);if(j){if(!u)throw(0,m.$hl)((0,g.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);T.type&m.FileType.File&&j.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.eb(a,n,!1)}async eb(a,n,l){const u=this.I(a),b=this.I(n),P=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,E.$yg)(u,b,!P))return;const R=new c.$Tc;try{R.add(await this.Q(a)),R.add(await this.Q(n)),l&&await h.Promises.mkdir((0,f.$mc)(b),{recursive:!0}),await h.Promises.copyFile(u,b)}catch(D){if(D.code==="ENOENT"&&!l)return this.eb(a,n,!0);throw this.hb(D)}finally{R.dispose()}}t(a,n,l){return new S.$0q(u=>a(u),u=>n(u),l)}F(a,n,l){return new o.$gr(u=>a(u),u=>n(u),l)}hb(a){if(a instanceof m.$gl)return a;let n=a,l;switch(a.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.$hl)(n,l)}async ib(a,n){let l=this.hb(n);if(a&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.I(a));u.mode&128||(l=(0,m.$hl)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return l}}e.$hr=t}),define(ce[228],le([0,1,3,99,2,17,66,23]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;class E extends k.$Uc{constructor(d,$){super(),this.a=d,this.b=$,this.F=new Map,this.G=new Map}call(d,$,y){const h=this.c(d);switch($){case"stat":return this.g(h,y[0]);case"readdir":return this.h(h,y[0]);case"open":return this.r(h,y[0],y[1]);case"close":return this.s(y[0]);case"read":return this.t(y[0],y[1],y[2]);case"readFile":return this.j(h,y[0],y[1]);case"write":return this.u(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.n(h,y[0],y[1],y[2]);case"rename":return this.z(h,y[0],y[1],y[2]);case"copy":return this.C(h,y[0],y[1],y[2]);case"cloneFile":return this.D(h,y[0],y[1]);case"mkdir":return this.w(h,y[0]);case"delete":return this.y(h,y[0],y[1]);case"watch":return this.I(h,y[0],y[1],y[2],y[3]);case"unwatch":return this.J(y[0],y[1])}throw new Error(`IPC Command ${$} not found`)}listen(d,$,y){const h=this.c(d);switch($){case"fileChange":return this.H(h,y[0]);case"readFileStream":return this.m(h,y[0],y[1])}throw new Error(`Unknown event ${$}`)}g(d,$){const y=this.f(d,$,!0);return this.a.stat(y)}h(d,$){const y=this.f(d,$);return this.a.readdir(y)}async j(d,$,y){const h=this.f(d,$,!0),g=await this.a.readFile(h,y);return A.$Je.wrap(g)}m(d,$,y){const h=this.f(d,$,!0),g=new I.$se,m=new i.$he({onDidRemoveLastListener:()=>{g.cancel()}}),w=this.a.readFileStream(h,y,g.token);return(0,O.$Be)(w,{onData:p=>m.fire(A.$Je.wrap(p)),onError:p=>m.fire(p),onEnd:()=>{m.fire("end"),m.dispose(),g.dispose()}}),m.event}n(d,$,y,h){const g=this.f(d,$);return this.a.writeFile(g,y.buffer,h)}r(d,$,y){const h=this.f(d,$,!0);return this.a.open(h,y)}s(d){return this.a.close(d)}async t(d,$,y){const h=A.$Je.alloc(y),m=await this.a.read(d,$,h.buffer,0,y);return[h,m]}u(d,$,y,h,g){return this.a.write(d,$,y.buffer,h,g)}w(d,$){const y=this.f(d,$);return this.a.mkdir(y)}y(d,$,y){const h=this.f(d,$);return this.a.delete(h,y)}z(d,$,y,h){const g=this.f(d,$),m=this.f(d,y);return this.a.rename(g,m,h)}C(d,$,y,h){const g=this.f(d,$),m=this.f(d,y);return this.a.copy(g,m,h)}D(d,$,y){const h=this.f(d,$),g=this.f(d,y);return this.a.cloneFile(h,g)}H(d,$){const y=new i.$he({onWillAddFirstListener:()=>{this.F.set($,this.L(d,y))},onDidRemoveLastListener:()=>{(0,k.$Pc)(this.F.get($)),this.F.delete($)}});return y.event}async I(d,$,y,h,g){const m=this.F.get($);if(m){const w=this.f(d,h),p=m.watch(y,w,g);this.G.set($+y,p)}}async J(d,$){const y=d+$,h=this.G.get(y);h&&((0,k.$Pc)(h),this.G.delete(y))}dispose(){super.dispose();for(const[,d]of this.G)d.dispose();this.G.clear();for(const[,d]of this.F)d.dispose();this.F.clear()}}e.$Rs=E;class c extends k.$Uc{constructor(d,$,y,h){super(),this.c=d,this.f=y,this.g=h,this.a=new Map,this.b=this.B(new r.$hr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h($)}h(d){const $=this.B(new i.$he);this.B($.event(y=>{d.fire(y.map(h=>({resource:this.c.transformOutgoingURI(h.resource),type:h.type,cId:h.cId})))})),this.B(this.b.onDidChangeFile(y=>$.fire(y))),this.B(this.b.onDidWatchError(y=>d.fire(y)))}j(d){}m(d){}watch(d,$,y){const h=this.m(this.g);return Array.isArray(h)&&(y.excludes=[...y.excludes,...h]),this.a.set(d,this.b.watch($,y)),(0,k.$Sc)(()=>{(0,k.$Pc)(this.a.get(d)),this.a.delete(d)})}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),super.dispose()}}e.$Ss=c}),define(ce[229],le([0,1,14,183,4,7,15,9,228,160,48]),function(X,e,i,r,k,A,O,I,E,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class d extends E.$Rs{constructor(h,g,m){super(h,g),this.M=m}c(h){return c.$En}f(h,g){return A.URI.revive(g)}async y(h,g,m){if(!m.useTrash)return super.y(h,g,m);const w=this.f(h,g),p=(0,I.$hc)(w.fsPath);try{await i.shell.trashItem(p)}catch(v){throw(0,O.$hl)(k.$i?(0,r.localize)(0,null,(0,I.$nc)(p),(0,f.$lj)(v)):(0,r.localize)(1,null,(0,I.$nc)(p),(0,f.$lj)(v)),O.FileSystemProviderErrorCode.Unknown)}}L(h,g){return new $(h,g,this.b,this.M)}}e.$Udc=d;class $ extends E.$Ss{watch(h,g,m){if(m.recursive)throw(0,O.$hl)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(h,g,m)}}}),define(ce[230],le([0,1,5]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;class r extends i.$ak{constructor(A=i.$0j){super(),this.m=[],this.n=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(A){this.n=A;for(const{level:O,message:I}of this.m)(0,i.log)(A,O,I);this.m=[]}g(A,O){this.n?(0,i.log)(this.n,A,O):this.getLevel()<=A&&this.m.push({level:A,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Bac=r}),define(ce[231],le([0,1,7,3,5,2]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=void 0;class O extends k.$fk{constructor(d,$,y,h,g){super($,y,h),this.r=d,this.t=g,this.B(g.listen("onDidChangeLogLevel",d)(m=>{(0,k.$9j)(m)?super.setLogLevel(m):super.setLogLevel(i.URI.revive(m[0]),m[1])})),this.B(g.listen("onDidChangeVisibility",d)(([m,w])=>super.setVisibility(i.URI.revive(m),w))),this.B(g.listen("onDidChangeLoggers",d)(({added:m,removed:w})=>{for(const p of m)super.registerLogger({...p,resource:i.URI.revive(p.resource)});for(const p of w)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new k.$dk({log:(d,$)=>{this.t.call("consoleLog",[d,$])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,$){super.setLogLevel(d,$),this.t.call("setLogLevel",[d,$])}setVisibility(d,$){super.setVisibility(d,$),this.t.call("setVisibility",[this.n(d),$])}s(d,$,y){return new I(this.t,d,$,y,this.r)}static setLogLevel(d,$,y){return d.call("setLogLevel",[$,y])}}e.$hs=O;class I extends k.$ak{constructor(d,$,y,h,g){super(h?.logLevel==="always"),this.r=d,this.s=$,this.m=!1,this.n=[],this.setLevel(y),this.r.call("createLogger",[$,h,g]).then(()=>{this.u(this.n),this.m=!0})}g(d,$){const y=[[d,$]];this.m?this.u(y):this.n.push(...y)}u(d){this.r.call("log",[this.s,d])}}class E{constructor(d,$){this.a=d,this.b=$}listen(d,$){const y=this.b(d);switch($){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(g=>this.c(g,y)),removed:[...h.removed].map(g=>this.c(g,y))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,h=>[y.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,h=>(0,k.$9j)(h)?h:[y.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${$}`)}async call(d,$,y){const h=this.b(d);switch($){case"setLogLevel":return(0,k.$9j)(y[0])?this.a.setLogLevel(y[0]):this.a.setLogLevel(i.URI.revive(h.transformIncoming(y[0][0])),y[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,h)))}throw new Error(`Call not found: ${$}`)}c(d,$){return{...d,resource:$.transformOutgoingURI(d.resource)}}}e.$is=E;class c extends A.$Uc{constructor(d,$){super(),$.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(y=>$.call("setLogLevel",[y]))),$.call("getRegisteredLoggers").then(y=>{for(const h of y)d.registerLogger({...h,resource:i.URI.revive(h.resource)})}),this.B($.listen("onDidChangeVisibility")(([y,h])=>d.setVisibility(i.URI.revive(y),h))),this.B($.listen("onDidChangeLoggers")(({added:y,removed:h})=>{for(const g of y)d.registerLogger({...g,resource:i.URI.revive(g.resource)});for(const g of h)d.deregisterLogger(g.resource)}))}}e.$js=c}),define(ce[232],le([0,1,2,5]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;class k extends i.$Uc{constructor(O,I=[]){super(),this.a=new r.$ek([O,...I]),this.B(O.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$lQ=k}),define(ce[233],le([0,1,32,7,5]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class A{constructor(I){this.b=I,this.a=new i.$Ac}listen(I,E,c){switch(E){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${E}`)}async call(I,E,c){switch(E){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,k.$9j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${E}`)}c(I,E,c){this.a.set(I,this.b.createLogger(I,E,c))}d(I,E){let c=console.log;switch(I){case k.LogLevel.Error:c=console.error;break;case k.LogLevel.Warning:c=console.warn;break;case k.LogLevel.Info:c=console.info;break}c.call(console,...E)}e(I,E){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[f,d]of E)(0,k.log)(c,f,d)}}e.$Rec=A}),define(ce[234],le([0,1,15,5]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function A(c,f,d,$,y){try{const h=await new Promise((m,w)=>{X(["@vscode/spdlog"],m,w)});h.setFlushOn(k.Trace);const g=await h.createAsyncRotatingLogger(c,f,d,$);return y?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(h){console.error(h)}return null}function O(c,f,d){switch(f){case r.LogLevel.Trace:c.trace(d);break;case r.LogLevel.Debug:c.debug(d);break;case r.LogLevel.Info:c.info(d);break;case r.LogLevel.Warning:c.warn(d);break;case r.LogLevel.Error:c.error(d);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function I(c,f){switch(f){case r.LogLevel.Trace:c.setLevel(k.Trace);break;case r.LogLevel.Debug:c.setLevel(k.Debug);break;case r.LogLevel.Info:c.setLevel(k.Info);break;case r.LogLevel.Warning:c.setLevel(k.Warning);break;case r.LogLevel.Error:c.setLevel(k.Error);break;case r.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class E extends r.$ak{constructor(f,d,$,y,h){super(),this.m=[],this.setLevel(h),this.n=this.s(f,d,$,y),this.B(this.onDidChangeLogLevel(g=>{this.r&&I(this.r,g)}))}async s(f,d,$,y){const h=$?6:1,g=30/h*i.$Cl.MB,m=await A(f,d,g,h,y);if(m){this.r=m,I(this.r,this.getLevel());for(const{level:w,message:p}of this.m)O(this.r,w,p);this.m=[]}}g(f,d){this.r?O(this.r,f,d):this.getLevel()<=f&&this.m.push({level:f,message:d})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$aQ=E}),define(ce[235],le([0,1,33,5,234]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class A extends r.$fk{s(I,E,c){return new k.$aQ((0,i.$Wg)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,E)}}e.$bQ=A}),define(ce[70],le([0,1,32,3,6,5,235]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=void 0,e.$pdc=(0,k.$Bi)(A.$8j);class I extends O.$bQ{constructor(){super(...arguments),this.u=new i.$Ac}createLogger(c,f,d){d!==void 0&&this.u.set(this.n(c),d);try{return super.createLogger(c,f)}catch($){throw this.u.delete(this.n(c)),$}}registerLogger(c,f){f!==void 0&&this.u.set(c.resource,f),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const f=[];for(const d of super.getRegisteredLoggers())c===this.u.get(d.resource)&&f.push(d);return f}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,f=>(0,A.$9j)(f)||this.w(f[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([f])=>this.w(f,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,f=>({added:[...f.added].filter($=>this.w($.resource,c)),removed:[...f.removed].filter($=>this.w($.resource,c))})),f=>f.added.length>0||f.removed.length>0)}deregisterLoggers(c){for(const[f,d]of this.u)d===c&&this.deregisterLogger(f)}w(c,f){const d=this.u.get(c);return d===void 0||d===f}dispose(){super.dispose(),this.u.clear()}}e.$qdc=I}),define(ce[236],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=i,e.$9dc=r,e.$0dc=k,e.$$dc=A;function i(O){return O.submenu!==void 0}function r(O){return O.id==="vscode.menubar.separator"}function k(O){return O.uri!==void 0}function A(O){return!i(O)&&!r(O)&&!k(O)}}),define(ce[41],le([0,1,3,75,2,6]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=void 0,e.$lo=(0,A.$Ai)("policy");class O extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const f=Object.keys(this.f).length;return this.f={...c,...this.f},f!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(d,[$,y])=>({...d,[$]:y}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[f,d])=>({...c,[f]:{definition:d,value:this.g.get(f)}}),{})}}e.$mo=O;class I{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$no=I}),define(ce[237],le([0,1,8,3,75,12,15,5,41]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;function c(d,$){const y=[];for(const h of new Set(k.Iterable.concat(d.keys(),$.keys())))d.get(h)!==$.get(h)&&y.push(h);return y}let f=class extends E.$mo{constructor($,y,h){super(),this.m=$,this.n=y,this.s=h,this.c=this.B(new i.$yh(500));const g=r.Event.filter(y.onDidFilesChange,m=>m.affects($));this.B(y.watch($)),this.B(g(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const $=new Map;try{const y=await this.n.readFile(this.m),h=JSON.parse(y.value.toString());if(!(0,A.$cg)(h))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(h))this.f[g]&&$.set(g,h[g])}catch(y){y.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",y)}return $}async w(){const $=await this.u(),y=c(this.g,$);this.g=$,y.length>0&&this.h.fire(y)}};e.$$ec=f,e.$$ec=f=Se([re(1,O.$7k),re(2,I.$7j)],f)}),define(ce[238],le([0,1,3,2,41]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0;class A{constructor(E){this.b=E,this.a=new r.$Tc}listen(E,c){switch(c){case"onDidChange":return i.Event.map(this.b.onDidChange,f=>f.reduce((d,$)=>({...d,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(E,c,f){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(f)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$Gec=A;class O extends k.$mo{constructor(E,c){super(),this.a=c;for(const f in E){const{definition:d,value:$}=E[f];this.f[f]=d,$!==void 0&&this.g.set(f,$)}this.a.listen("onDidChange")(f=>{for(const d in f){const $=f[d];$===null?this.g.delete(d):this.g.set(d,$)}this.h.fire(Object.keys(f))})}async j(E){const c=await this.a.call("updatePolicyDefinitions",E);for(const f in c)this.g.set(f,c[f])}}e.$Hec=O}),define(ce[239],le([0,1,41,8,2,5]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let O=class extends i.$mo{constructor(E,c){super(),this.m=E,this.n=c,this.a=new r.$uh,this.b=this.B(new k.$Vc)}async j(E){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(E).length} policy definitions`);const{createWatcher:c}=await new Promise((f,d)=>{X(["@vscode/policy-watcher"],f,d)});await this.a.queue(()=>new Promise((f,d)=>{try{this.b.value=c(this.n,E,$=>{this.t($),f()})}catch($){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",$),d($)}}))}t(E){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(E)}`);for(const c in E){const f=E[c];f===void 0?this.g.delete(c):this.g.set(c,f)}this.h.fire(Object.keys(E))}};e.$0ec=O,e.$0ec=O=Se([re(0,A.$7j)],O)}),define(ce[84],le([0,1,36]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const A=k.context.configuration();if(A)r=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:A.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ce[28],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,i.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(ce[240],le([0,1,8,5]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;let k=class{constructor(O,I,E){this.a=O,this.b=I,this.c=E}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Bh)(O);const E=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),E.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$Xdc=k,e.$Xdc=k=Se([re(2,r.$7j)],k)}),define(ce[85],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0,e.$$cc=(0,i.$Ai)("protocolMainService")}),define(ce[46],le([0,1,141,12]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class k{constructor(){this.a=new Map}add(O,I){i.ok(r.$ag(O)),i.ok(r.$cg(I)),i.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$jo=new k}),define(ce[241],le([0,1,3,46]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new i.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,c){this.a[k(E)]=c,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;r.$jo.add(e.$ko.JSONContribution,O)}),define(ce[54],le([0,1,22,3,12,168,18,241,46]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=g,e.$Ao=m,e.$Bo=w,e.$Co=v,e.$Do=S;var c;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$oo={Configuration:"base.contributions.configuration"};var f;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const d=E.$jo.as(I.$ko.JSONContribution);class ${constructor(){this.h=new Set,this.i=new r.$he,this.onDidSchemaChange=this.i.event,this.j=new r.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const a=new Set;this.n(t,s,a),d.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const s=new Set;this.o(t,s),d.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const a=new Set;this.o(s,a),this.n(t,!1,a),d.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const a=[];for(const{overrides:n,source:l}of t)for(const u in n)if(s.add(u),e.$yo.test(u)){const b=this.a.get(u),P=b?.valuesSources??new Map;if(l)for(const j of Object.keys(n[u]))P.set(j,l);const R={...b?.value||{},...n[u]};this.a.set(u,{source:l,value:R,valuesSources:P});const D=(0,O.$ej)(u),T={type:"object",default:R,description:A.localize(1,null,D),$ref:e.$vo,defaultDefaultValue:R,source:k.$ag(l)?void 0:l,defaultValueSource:l};a.push(...g(u)),this.d[u]=T,this.b.properties[u]=T}else{this.a.set(u,{value:n[u],source:l});const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}this.m(a)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:a,source:n}of t)for(const l in a){const u=this.a.get(l),b=k.$ag(n)?n:n?.id,P=k.$ag(u?.source)?u?.source:u?.source?.id;if(b===P)if(s.add(l),this.a.delete(l),e.$yo.test(l))delete this.d[l],delete this.b.properties[l];else{const R=this.d[l];R&&(this.w(l,R),this.r(l,R))}}this.u()}deltaConfiguration(t){let s=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,a){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,a),this.c.push(n),this.q(n)})}o(t,s){const a=n=>{if(n.properties)for(const l in n.properties){s.add(l);const u=this.d[l];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[l],this.s(l,n.properties[l])}n.allOf?.forEach(l=>a(l))};for(const n of t){a(n);const l=this.c.indexOf(n);l!==-1&&this.c.splice(l,1)}}p(t,s=!0,a,n,l=f.WINDOW,u){l=k.$jg(t.scope)?l:t.scope;const b=t.properties;if(b)for(const R in b){const D=b[R];if(s&&v(R,D)){delete b[R];continue}if(D.source=a,D.defaultDefaultValue=b[R].default,this.w(R,D),e.$yo.test(R)?D.scope=void 0:(D.scope=k.$jg(D.scope)?l:D.scope,D.restricted=k.$jg(D.restricted)?!!n?.includes(R):D.restricted),b[R].hasOwnProperty("included")&&!b[R].included){this.f[R]=b[R],delete b[R];continue}else this.d[R]=b[R],b[R].policy?.name&&this.e.set(b[R].policy.name,R);!b[R].deprecationMessage&&b[R].markdownDeprecationMessage&&(b[R].deprecationMessage=b[R].markdownDeprecationMessage),u.add(R)}const P=t.allOf;if(P)for(const R of P)this.p(R,s,a,n,l,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=a=>{const n=a.properties;if(n)for(const u in n)this.r(u,n[u]);a.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$po.properties[t]=s,s.scope){case f.APPLICATION:e.$qo.properties[t]=s;break;case f.MACHINE:e.$ro.properties[t]=s;break;case f.MACHINE_OVERRIDABLE:e.$so.properties[t]=s;break;case f.WINDOW:e.$to.properties[t]=s;break;case f.RESOURCE:e.$uo.properties[t]=s;break;case f.LANGUAGE_OVERRIDABLE:e.$uo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$po.properties[t],s.scope){case f.APPLICATION:delete e.$qo.properties[t];break;case f.MACHINE:delete e.$ro.properties[t];break;case f.MACHINE_OVERRIDABLE:delete e.$so.properties[t];break;case f.WINDOW:delete e.$to.properties[t];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,a={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$vo};this.w(s,a),e.$po.properties[s]=a,e.$qo.properties[s]=a,e.$ro.properties[s]=a,e.$so.properties[s]=a,e.$to.properties[s]=a,e.$uo.properties[s]=a}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=t,e.$qo.patternProperties[e.$xo]=t,e.$ro.patternProperties[e.$xo]=t,e.$so.patternProperties[e.$xo]=t,e.$to.patternProperties[e.$xo]=t,e.$uo.patternProperties[e.$xo]=t,this.i.fire()}w(t,s){const a=this.a.get(t);let n=a?.value,l=a?.source;k.$hg(n)&&(n=s.defaultDefaultValue,l=void 0),k.$hg(n)&&(n=w(s.type)),s.default=n,s.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.$xo=`^(${y})+$`,e.$yo=new RegExp(e.$xo);function g(o){const t=[];if(e.$yo.test(o)){let s=h.exec(o);for(;s?.length;){const a=s[1].trim();a&&t.push(a),s=h.exec(o)}}return(0,i.$Mb)(t)}function m(o){return o.reduce((t,s)=>`${t}[${s}]`,"")}function w(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new $;E.$jo.add(e.$oo.Configuration,p);function v(o,t){return o.trim()?e.$yo.test(o)?A.localize(7,null,o):p.getConfigurationProperties()[o]!==void 0?A.localize(8,null,o):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,o,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function S(){const o=[],t=p.getConfigurationProperties();for(const s of Object.keys(t))o.push([s,t[s].scope]);return o.push(["launch",f.RESOURCE]),o.push(["task",f.RESOURCE]),o}}),define(ce[126],le([0,1,22,3,40,2,32,35,12,7,18,54,15,46]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=S;function h(a){return Object.isFrozen(a)?a:I.$0n(a)}class g{static createEmptyModel(n){return new g({},[],[],void 0,n)}constructor(n,l,u,b,P){this.b=n,this.c=l,this.d=u,this.raw=b,this.f=P,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(l=>{if(l instanceof g)return l;const u=new m("",this.f);return u.parseRaw(l),u.configurationModel});this.g=n.reduce((l,u)=>u===l?u:l.merge(u),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,f.$cj)(this.contents,n):this.contents}inspect(n,l){const u=this;return{get value(){return h(u.rawConfiguration.getValue(n))},get override(){return l?h(u.rawConfiguration.getOverrideValue(n,l)):void 0},get merged(){return h(l?u.rawConfiguration.override(l).getValue(n):u.rawConfiguration.getValue(n))},get overrides(){const b=[];for(const{contents:P,identifiers:R,keys:D}of u.rawConfiguration.overrides){const T=new g(P,D,[],void 0,u.f).getValue(n);T!==void 0&&b.push({identifiers:R,value:T})}return b.length?h(b):void 0}}}getOverrideValue(n,l){const u=this.j(l);return u?n?(0,f.$cj)(u,n):u:void 0}getKeysForOverrideIdentifier(n){const l=[];for(const u of this.overrides)u.identifiers.includes(n)&&l.push(...u.keys);return i.$Mb(l)}getAllOverrideIdentifiers(){const n=[];for(const l of this.overrides)n.push(...l.identifiers);return i.$Mb(n)}override(n){let l=this.a.get(n);return l||(l=this.h(n),this.a.set(n,l)),l}merge(...n){const l=I.$9n(this.contents),u=I.$9n(this.overrides),b=[...this.keys],P=this.raw?.length?[...this.raw]:[this];for(const R of n)if(P.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(l,R.contents);for(const D of R.overrides){const[T]=u.filter(j=>i.$ub(j.identifiers,D.identifiers));T?(this.i(T.contents,D.contents),T.keys.push(...D.keys),T.keys=i.$Mb(T.keys)):u.push(I.$9n(D))}for(const D of R.keys)b.indexOf(D)===-1&&b.push(D)}return new g(l,b,u,P.every(R=>R instanceof g)?void 0:P,this.f)}h(n){const l=this.j(n);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const b of i.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let P=this.contents[b];const R=l[b];R&&(typeof P=="object"&&typeof R=="object"?(P=I.$9n(P),this.i(P,R)):P=R),u[b]=P}return new g(u,this.keys,this.overrides,void 0,this.f)}i(n,l){for(const u of Object.keys(l)){if(u in n&&E.$cg(n[u])&&E.$cg(l[u])){this.i(n[u],l[u]);continue}n[u]=I.$9n(l[u])}}j(n){let l=null,u=null;const b=P=>{P&&(u?this.i(u,P):u=I.$9n(P))};for(const P of this.overrides)P.identifiers.length===1&&P.identifiers[0]===n?l=P.contents:P.identifiers.includes(n)&&b(P.contents);return b(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,l){this.k(n,l,!0)}setValue(n,l){this.k(n,l,!1)}removeValue(n){const l=this.keys.indexOf(n);l!==-1&&(this.keys.splice(l,1),(0,f.$bj)(this.contents,n),d.$yo.test(n)&&this.overrides.splice(this.overrides.findIndex(u=>i.$ub(u.identifiers,(0,d.$zo)(n))),1))}k(n,l,u){(0,f.$aj)(this.contents,n,l,b=>this.f.error(b)),u=u||this.keys.indexOf(n)===-1,u&&this.keys.push(n),d.$yo.test(n)&&this.overrides.push({identifiers:(0,d.$zo)(n),keys:Object.keys(this.contents[n]),contents:(0,f.$_i)(this.contents[n],b=>this.f.error(b))})}}e.$Eo=g;class m{constructor(n,l){this.f=n,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,l){if(!E.$jg(n)){const u=this.h(n);this.parseRaw(u,l)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,l){this.a=n;const{contents:u,keys:b,overrides:P,restricted:R,hasExcludedProperties:D}=this.i(n,l);this.b=new g(u,b,P,D?[n]:void 0,this.g),this.c=R||[]}h(n){let l={},u=null,b=[];const P=[],R=[];function D(j){Array.isArray(b)?b.push(j):u!==null&&(b[u]=j)}const T={onObjectBegin:()=>{const j={};D(j),P.push(b),b=j,u=null},onObjectProperty:j=>{u=j},onObjectEnd:()=>{b=P.pop()},onArrayBegin:()=>{const j=[];D(j),P.push(b),b=j,u=null},onArrayEnd:()=>{b=P.pop()},onLiteralValue:D,onError:(j,F,W)=>{R.push({error:j,offset:F,length:W})}};if(n)try{k.$Wn(n,T),l=b[0]||{}}catch(j){this.g.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return l}i(n,l){const u=y.$jo.as(d.$oo.Configuration).getConfigurationProperties(),b=this.j(n,u,!0,l);n=b.raw;const P=(0,f.$_i)(n,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`)),R=Object.keys(n),D=this.l(n,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:P,keys:R,overrides:D,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}j(n,l,u,b){let P=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:P};const R={},D=[];for(const T in n)if(d.$yo.test(T)&&u){const j=this.j(n[T],l,!1,b);R[T]=j.raw,P=P||j.hasExcludedProperties,D.push(...j.restricted)}else{const j=l[T],F=j?typeof j.scope<"u"?j.scope:d.ConfigurationScope.WINDOW:void 0;j?.restricted&&D.push(T),!b.exclude?.includes(T)&&(b.include?.includes(T)||(F===void 0||b.scopes===void 0||b.scopes.includes(F))&&!(b.skipRestricted&&j?.restricted))?R[T]=n[T]:P=!0}return{raw:R,restricted:D,hasExcludedProperties:P}}l(n,l){const u=[];for(const b of Object.keys(n))if(d.$yo.test(b)){const P={};for(const R in n[b])P[R]=n[b][R];u.push({identifiers:(0,d.$zo)(b),keys:Object.keys(P),contents:(0,f.$_i)(P,l)})}return u}}e.$Fo=m;class w extends A.$Uc{constructor(n,l,u,b,P){super(),this.c=n,this.f=l,this.g=b,this.h=P,this.b=this.B(new r.$he),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),P),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation($.FileOperation.CREATE)||R.isOperation($.FileOperation.COPY)||R.isOperation($.FileOperation.DELETE)||R.isOperation($.FileOperation.WRITE))&&u.isEqual(R.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=w;class p{constructor(n,l,u,b,P,R,D,T,j,F,W,C,z){this.a=n,this.b=l,this.c=u,this.overrideIdentifiers=b,this.d=P,this.f=R,this.g=D,this.h=T,this.i=j,this.j=F,this.k=W,this.l=C,this.m=z}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class v{constructor(n,l,u,b,P,R,D,T,j,F){this.j=n,this.l=l,this.m=u,this.n=b,this.p=P,this.q=R,this.r=D,this.s=T,this.t=j,this.u=F,this.h=null,this.i=new O.$Ac,this.v=null}getValue(n,l,u){return this.w(n,l,u).getValue(n)}updateValue(n,l,u={}){let b;u.resource?(b=this.t.get(u.resource),b||(b=g.createEmptyModel(this.u),this.t.set(u.resource,b))):b=this.s,l===void 0?b.removeValue(n):b.setValue(n,l),u.resource||(this.h=null)}inspect(n,l,u){const b=this.w(n,l,u),P=this.A(l.resource,u),R=l.resource?this.t.get(l.resource)||this.s:this.s,D=new Set;for(const T of b.overrides)for(const j of T.identifiers)b.getOverrideValue(n,j)!==void 0&&D.add(j);return new p(n,l,b.getValue(n),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,P||void 0,R)}keys(n){const l=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,l){this.r.set(n,l),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,l){const u=[];if(!l){const{added:b,updated:P,removed:R}=t(this.j,n);l=[...b,...P,...R]}for(const b of l)for(const P of(0,d.$zo)(b)){const R=this.j.getKeysForOverrideIdentifier(P),D=n.getKeysForOverrideIdentifier(P),T=[...D.filter(j=>R.indexOf(j)===-1),...R.filter(j=>D.indexOf(j)===-1),...R.filter(j=>!I.$ao(this.j.override(P).getValue(j),n.override(P).getValue(j)))];u.push([P,T])}return this.updateDefaultConfiguration(n),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(n){const{added:l,updated:u,removed:b}=t(this.l,n),P=[...l,...u,...b];return P.length&&this.updatePolicyConfiguration(n),{keys:P,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:l,updated:u,removed:b,overrides:P}=t(this.applicationConfiguration,n),R=[...l,...u,...b];return R.length&&this.updateApplicationConfiguration(n),{keys:R,overrides:P}}compareAndUpdateLocalUserConfiguration(n){const{added:l,updated:u,removed:b,overrides:P}=t(this.localUserConfiguration,n),R=[...l,...u,...b];return R.length&&this.updateLocalUserConfiguration(n),{keys:R,overrides:P}}compareAndUpdateRemoteUserConfiguration(n){const{added:l,updated:u,removed:b,overrides:P}=t(this.remoteUserConfiguration,n),R=[...l,...u,...b];return R.length&&this.updateRemoteUserConfiguration(n),{keys:R,overrides:P}}compareAndUpdateWorkspaceConfiguration(n){const{added:l,updated:u,removed:b,overrides:P}=t(this.workspaceConfiguration,n),R=[...l,...u,...b];return R.length&&this.updateWorkspaceConfiguration(n),{keys:R,overrides:P}}compareAndUpdateFolderConfiguration(n,l){const u=this.folderConfigurations.get(n),{added:b,updated:P,removed:R,overrides:D}=t(u,l),T=[...b,...P,...R];return(T.length||!u)&&this.updateFolderConfiguration(n,l),{keys:T,overrides:D}}compareAndDeleteFolderConfiguration(n){const l=this.folderConfigurations.get(n);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:u,updated:b,removed:P,overrides:R}=t(l,void 0);return{keys:[...u,...b,...P],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,l,u){let b=this.x(l,u);return l.overrideIdentifier&&(b=b.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(b=b.merge(this.l)),b}x({resource:n},l){let u=this.y();if(l&&n){const b=l.getFolder(n);b&&(u=this.z(b.uri)||u);const P=this.t.get(n);P&&(u=u.merge(P))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let l=this.i.get(n);if(!l){const u=this.y(),b=this.r.get(n);b?(l=u.merge(b),this.i.set(n,l)):l=u}return l}A(n,l){if(l&&n){const u=l.getFolder(n);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,l)=>{const{contents:u,overrides:b,keys:P}=this.r.get(l);return n.push([l,{contents:u,overrides:b,keys:P}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(l=>n.add(l)),this.userConfiguration.keys.forEach(l=>n.add(l)),this.q.keys.forEach(l=>n.add(l)),this.r.forEach(l=>l.keys.forEach(u=>n.add(u))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(u=>n.add(u))),[...n.values()]}D(n){const l=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>l.add(u)),this.q.getKeysForOverrideIdentifier(n).forEach(u=>l.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(n).forEach(b=>l.add(b))),[...l.values()]}static parse(n,l){const u=this.E(n.defaults,l),b=this.E(n.policy,l),P=this.E(n.application,l),R=this.E(n.user,l),D=this.E(n.workspace,l),T=n.folders.reduce((j,F)=>(j.set(c.URI.revive(F[0]),this.E(F[1],l)),j),new O.$Ac);return new v(u,b,P,R,g.createEmptyModel(l),D,T,g.createEmptyModel(l),new O.$Ac,l)}static E(n,l){return new g(n.contents,n.keys,n.overrides,void 0,l)}}e.$Ho=v;function S(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,l=new Map;for(const b of a)b.keys.forEach(P=>n.add(P)),b.overrides.forEach(([P,R])=>{const D=(0,O.$xc)(l,P,new Set);R.forEach(T=>D.add(T))});const u=[];return l.forEach((b,P)=>u.push([P,[...b.values()]])),{keys:[...n.values()],overrides:u}}class o{constructor(n,l,u,b,P){this.change=n,this.f=l,this.g=u,this.h=b,this.i=P,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of n.keys)this.affectedKeys.add(R);for(const[,R]of n.overrides)for(const D of R)this.affectedKeys.add(D);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=v.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,l){const u=this.a+n,b=this.d.indexOf(u);if(b<0)return!1;const P=b+u.length;if(P>=this.d.length)return!1;const R=this.d.charCodeAt(P);if(R!==this.b&&R!==this.c)return!1;if(l){const D=this.previousConfiguration?this.previousConfiguration.getValue(n,l,this.f?.workspace):void 0,T=this.g.getValue(n,l,this.h);return!I.$ao(D,T)}return!0}}e.$Jo=o;function t(a,n){const{added:l,removed:u,updated:b}=s(n?.rawConfiguration,a?.rawConfiguration),P=[],R=a?.getAllOverrideIdentifiers()||[],D=n?.getAllOverrideIdentifiers()||[];if(n){const T=D.filter(j=>!R.includes(j));for(const j of T)P.push([j,n.getKeysForOverrideIdentifier(j)])}if(a){const T=R.filter(j=>!D.includes(j));for(const j of T)P.push([j,a.getKeysForOverrideIdentifier(j)])}if(n&&a){for(const T of R)if(D.includes(T)){const j=s({contents:a.getOverrideValue(void 0,T)||{},keys:a.getKeysForOverrideIdentifier(T)},{contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)});P.push([T,[...j.added,...j.removed,...j.updated]])}}return{added:l,removed:u,updated:b,overrides:P}}function s(a,n){const l=a?n?a.keys.filter(P=>n.keys.indexOf(P)===-1):[...a.keys]:[],u=n?a?n.keys.filter(P=>a.keys.indexOf(P)===-1):[...n.keys]:[],b=[];if(a&&n){for(const P of n.keys)if(a.keys.indexOf(P)!==-1){const R=(0,f.$cj)(n.contents,P),D=(0,f.$cj)(a.contents,P);I.$ao(R,D)||b.push(P)}}return{added:l,removed:u,updated:b}}}),define(ce[242],le([0,1,22,3,2,35,12,126,54,5,41,46]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=void 0;class $ extends k.$Uc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Eo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$jo.as(E.$oo.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:w})=>this.f(Array.from(m),w))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,w){this.j(m,d.$jo.as(E.$oo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=I.$Eo.createEmptyModel(this.c);const m=d.$jo.as(E.$oo.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,w){const p=this.g();for(const v of m){const S=p[v],o=w[v];S!==void 0?this.b.addValue(v,S):o?this.b.addValue(v,o.default):this.b.removeValue(v)}}}e.$Ko=$;class y{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Eo.createEmptyModel(new c.$hk)}async initialize(){return this.configurationModel}}e.$Lo=y;let h=class extends k.$Uc{get configurationModel(){return this.b}constructor(m,w,p){super(),this.c=m,this.f=w,this.g=p,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Eo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const w={},p=[],v=d.$jo.as(E.$oo.Configuration).getConfigurationProperties();for(const S of m){const o=v[S];if(!o){p.push(S);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}p.push(S),w[o.policy.name]={type:o.type}}}return(0,O.$ng)(w)||await this.f.updatePolicyDefinitions(w),p}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const w=d.$jo.as(E.$oo.Configuration).getPolicyConfigurations(),p=(0,i.$Hb)(m.map(v=>w.get(v)));this.m(p,!0)}m(m,w){this.g.trace("PolicyConfiguration#update",m);const p=d.$jo.as(E.$oo.Configuration).getConfigurationProperties(),v=[],S=this.b.isEmpty();for(const o of m){const t=p[o]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(S?s!==void 0:!(0,A.$ao)(this.b.getValue(o),s))&&v.push([o,s])}else this.b.getValue(o)!==void 0&&v.push([o,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const o=this.b;this.b=I.$Eo.createEmptyModel(this.g);for(const t of o.keys)this.b.setValue(t,o.getValue(t));for(const[t,s]of v)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);w&&this.a.fire(this.b)}}};e.$Mo=h,e.$Mo=h=Se([re(1,f.$lo),re(2,c.$7j)],h)}),define(ce[243],le([0,1,22,8,17,3,40,108,2,32,35,4,19,18,126,54,242,15,41]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;class v extends E.$Uc{constructor(t,s,a,n){super(),this.m=t,this.n=n,this.h=this.B(new A.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$Ko(n)),this.c=a instanceof p.$no?new m.$Lo:this.B(new m.$Mo(this.b,a,n)),this.f=this.B(new h.$Go(this.m,{},$.$5g,s,n)),this.a=new h.$Ho(this.b.configurationModel,this.c.configurationModel,h.$Eo.createEmptyModel(n),h.$Eo.createEmptyModel(n),h.$Eo.createEmptyModel(n),h.$Eo.createEmptyModel(n),new c.$Ac,h.$Eo.createEmptyModel(n),new c.$Ac,n),this.j=new S(t,s,this),this.g=this.B(new r.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:u})=>this.s(l,u))),this.B(this.c.onDidChangeConfiguration(l=>this.t(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,s,a]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$Ho(t,s,h.$Eo.createEmptyModel(this.n),a,h.$Eo.createEmptyModel(this.n),h.$Eo.createEmptyModel(this.n),new c.$Ac,h.$Eo.createEmptyModel(this.n),new c.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,s){const a=typeof t=="string"?t:void 0,n=(0,y.$8i)(t)?t:(0,y.$8i)(s)?s:{};return this.a.getValue(a,n,void 0)}async updateValue(t,s,a,n,l){const u=(0,y.$9i)(a)?a:(0,y.$8i)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,b=u?n:a;if(b!==void 0&&b!==y.ConfigurationTarget.USER_LOCAL&&b!==y.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${b}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,i.$Mb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const P=this.inspect(t,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(P.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,f.$ao)(s,P.defaultValue)&&(s=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const D=u.overrideIdentifiers.sort(),T=this.a.localUserConfiguration.overrides.find(j=>(0,i.$ub)([...j.identifiers].sort(),D));T&&(u.overrideIdentifiers=T.identifiers)}const R=u?.overrideIdentifiers?.length?[(0,g.$Ao)(u.overrideIdentifiers),t]:[t];await this.j.write(R,s),await this.reloadConfiguration()}inspect(t,s={}){return this.a.inspect(t,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const s=this.a.toData(),a=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(a,s,y.ConfigurationTarget.USER)}s(t,s){const a=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(t,s);this.u(n,a,y.ConfigurationTarget.DEFAULT)}t(t){const s=this.a.toData(),a=this.a.compareAndUpdatePolicyConfiguration(t);this.u(a,s,y.ConfigurationTarget.DEFAULT)}u(t,s,a){const n=new h.$Jo(t,{data:s},this.a,void 0,this.n);n.source=a,this.h.fire(n)}}e.$No=v;class S{constructor(t,s,a){this.b=t,this.c=s,this.d=a,this.a=new r.$Hh}write(t,s){return this.a.queue(()=>this.e(t,s))}async e(t,s){let a;try{a=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw u}const n=[];if((0,O.$Pn)(a,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const l=this.f(a,t,s);a=(0,I.$8n)(a,l),await this.c.writeFile(this.b,k.$Je.fromString(a))}f(t,s,a){const{tabSize:n,insertSpaces:l,eol:u}=this.h;if(!s.length){const b=JSON.stringify(a,null,l?" ".repeat(n):"	");return[{content:b,length:b.length,offset:0}]}return(0,I.$5n)(t,s,a,{tabSize:n,insertSpaces:l,eol:u})}get h(){if(!this.g){let t=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(t=s),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[244],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=e.$Wec=void 0,e.$Wec="request",e.$Xec="remoteResourceHandler";class i{async routeCall(k,A,O){if(A!==e.$Wec)throw new Error(`Call not found: ${A}`);const I=O[0];if(I?.authority){const E=k.connections.find(c=>c.ctx===I.authority);if(E)return E}throw new Error("Caller not found")}routeEvent(k,A){throw new Error(`Event not found: ${A}`)}}e.$Yec=i}),define(ce[245],le([0,1,16,6]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=c,e.$Ll=(0,r.$Ai)("remoteAuthorityResolverService");var k;(function(f){f[f.WebSocket=0]="WebSocket",f[f.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class A{constructor(d){this.id=d,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=A;class O{constructor(d,$){this.host=d,this.port=$,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=O;var I;(function(f){f.Unknown="Unknown",f.NotAvailable="NotAvailable",f.TemporarilyNotAvailable="TemporarilyNotAvailable",f.NoResolverFound="NoResolverFound",f.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class E extends i.$bb{static isNotAvailable(d){return d instanceof E&&d._code===I.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof E&&d._code===I.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof E&&d._code===I.NoResolverFound}static isInvalidAuthority(d){return d instanceof E&&d._code===I.InvalidAuthority}static isHandled(d){return d instanceof E&&d.isHandled}constructor(d,$=I.Unknown,y){super(d),this._message=d,this._code=$,this._detail=y,this.isHandled=$===I.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Ol=E;function c(f){const d=f.indexOf("+");return d===-1?f:f.substring(0,d)}}),define(ce[246],le([0,1,8,17,23,16,3,2,13,69,77,33,118,245]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=P,e.$Vl=R,e.$Wl=T;const h=30*1e3;var g;(function(ne){ne[ne.Management=1]="Management",ne[ne.ExtensionHost=2]="ExtensionHost",ne[ne.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function m(ne){switch(ne){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function w(ne){const Z=new k.$se;return setTimeout(()=>Z.cancel(),ne),Z.token}function p(ne,Z){if(ne.isCancellationRequested||Z.isCancellationRequested)return k.CancellationToken.Cancelled;const U=new k.$se;return ne.onCancellationRequested(()=>U.cancel()),Z.onCancellationRequested(()=>U.cancel()),U.token}class v{get didTimeout(){return this.c==="timedout"}constructor(Z){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$th)(),Z.isCancellationRequested?this.h():this.d.add(Z.onCancellationRequested(()=>this.h()))}registerDisposable(Z){this.c==="pending"?this.d.add(Z):Z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Z))}reject(Z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Z))}}function S(ne,Z){const U=new v(Z);return U.registerDisposable(ne.onControlMessage(M=>{const N=JSON.parse(M.toString()),H=L(N);H?U.reject(H):U.resolve(N)})),U.promise}function o(ne,Z,U,M,N,H,Q,J){const x=new v(J),ee=f.$be.create(!1);return ne.info(`Creating a socket (${Q})...`),c.mark(`code/willCreateSocket/${H}`),Z.connect(U,M,N,Q).then(de=>{x.didTimeout?(c.mark(`code/didCreateSocketError/${H}`),ne.info(`Creating a socket (${Q}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${H}`),ne.info(`Creating a socket (${Q}) was successful after ${ee.elapsed()} ms.`),x.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${H}`),ne.info(`Creating a socket (${Q}) returned an error after ${ee.elapsed()} ms.`),ne.error(de),x.reject(de)}),x.promise}function t(ne,Z){const U=new v(Z);return ne.then(M=>{U.didTimeout||U.resolve(M)},M=>{U.didTimeout||U.reject(M)}),U.promise}async function s(ne,Z,U,M){const N=G(ne,Z);ne.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let H;try{H=await o(ne.logService,ne.remoteSocketFactoryService,ne.connectTo,E.$Ng.getServerRootPath(),`reconnectionToken=${ne.reconnectionToken}&reconnection=${ne.reconnectionProtocol?"true":"false"}`,m(Z),`renderer-${m(Z)}-${ne.reconnectionToken}`,M)}catch(de){throw ne.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),ne.logService.error(de),de}ne.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Q,J;ne.reconnectionProtocol?(ne.reconnectionProtocol.beginAcceptReconnection(H,null),Q=ne.reconnectionProtocol,J=!1):(Q=new $.$oi({socket:H}),J=!0),ne.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const x=await t(ne.signService.createNewMessage((0,d.$Wg)()),M),ee={type:"auth",auth:ne.connectionToken||"00000000000000000000",data:x.data};Q.sendControl(r.$Je.fromString(JSON.stringify(ee)));try{const de=await S(Q,p(M,w(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(ne.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(ne.signService.validate(x,de.signedData),M)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const pe=await t(ne.signService.sign(de.data),M),Ie={type:"connectionType",commit:ne.commit,signedData:pe,desiredConnectionType:Z};return U&&(Ie.args=U),ne.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(r.$Je.fromString(JSON.stringify(Ie))),{protocol:Q,ownsProtocol:J}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(ne.logService.error(`${N} the handshake timed out. Error:`),ne.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(ne.logService.error(`${N} received error control message when negotiating connection. Error:`),ne.logService.error(de)),J&&q(Q),de}}async function a(ne,Z,U,M){const N=Date.now(),H=G(ne,Z),{protocol:Q,ownsProtocol:J}=await s(ne,Z,U,M),x=new v(M);return x.registerDisposable(Q.onControlMessage(ee=>{const de=JSON.parse(ee.toString()),me=L(de);me?(ne.logService.error(`${H} received error control message when negotiating connection. Error:`),ne.logService.error(me),J&&q(Q),x.reject(me)):(ne.reconnectionProtocol?.endAcceptReconnection(),ne.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(N)}!`),x.resolve({protocol:Q,firstMessage:de}))})),x.promise}async function n(ne,Z){const{protocol:U}=await a(ne,g.Management,void 0,Z);return{protocol:U}}async function l(ne,Z,U){const{protocol:M,firstMessage:N}=await a(ne,g.ExtensionHost,Z,U),H=N&&N.debugPort;return{protocol:M,debugPort:H}}async function u(ne,Z,U){const M=Date.now(),N=G(ne,g.Tunnel),{protocol:H}=await s(ne,g.Tunnel,Z,U);return ne.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${he(M)}!`),H}async function b(ne,Z,U){const{connectTo:M,connectionToken:N}=await ne.addressProvider.getAddress();return{commit:ne.commit,quality:ne.quality,connectTo:M,connectionToken:N,reconnectionToken:Z,reconnectionProtocol:U,remoteSocketFactoryService:ne.remoteSocketFactoryService,signService:ne.signService,logService:ne.logService}}async function P(ne,Z,U){return D(ne,async M=>{const{protocol:N}=await n(M,k.CancellationToken.None);return new K(ne,Z,U,M.reconnectionToken,N)})}async function R(ne,Z){return D(ne,async U=>{const{protocol:M,debugPort:N}=await l(U,Z,k.CancellationToken.None);return new te(ne,Z,U.reconnectionToken,M,N)})}async function D(ne,Z){for(let M=1;;M++)try{const N=(0,d.$Wg)(),H=await b(ne,N,null);return await Z(H)}catch(N){if(M<5)ne.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),ne.logService.error(N);else throw ne.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ne.logService.error(N),oe.triggerPermanentFailure(0,0,y.$Ol.isHandled(N)),N}}async function T(ne,Z,U){const M=await b(ne,(0,d.$Wg)(),null);return await u(M,{host:Z,port:U},k.CancellationToken.None)}function j(ne){return(0,i.$nh)(Z=>new Promise((U,M)=>{const N=setTimeout(U,ne*1e3);Z.onCancellationRequested(()=>{clearTimeout(N),U()})}))}var F;(function(ne){ne[ne.ConnectionLost=0]="ConnectionLost",ne[ne.ReconnectionWait=1]="ReconnectionWait",ne[ne.ReconnectionRunning=2]="ReconnectionRunning",ne[ne.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ne[ne.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class W{constructor(Z,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.type=F.ConnectionLost}}e.$Xl=W;class C{constructor(Z,U,M,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.durationSeconds=M,this.c=N,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=C;class z{constructor(Z,U,M){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=M,this.type=F.ReconnectionRunning}}e.$Zl=z;class se{constructor(Z,U,M){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=M,this.type=F.ConnectionGain}}e.$1l=se;class ie{constructor(Z,U,M,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=M,this.handled=N,this.type=F.ReconnectionPermanentFailure}}e.$2l=ie;class oe extends I.$Uc{static triggerPermanentFailure(Z,U,M){this._permanentFailure=!0,this.f=Z,this.g=U,this.h=M,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Z=>Z.y())}static debugPauseSocketWriting(){this.j.forEach(Z=>Z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(Z,U,M,N,H){super(),this.t=Z,this.u=U,this.reconnectionToken=M,this.protocol=N,this.w=H,this.m=this.B(new O.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new se(this.reconnectionToken,0,0)),this.B(N.onSocketClose(Q=>{const J=ae(this.t,this.reconnectionToken,!0);Q?Q.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${J} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.u.logService.error(Q.error)):(this.u.logService.info(`${J} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.u.logService.error(Q.event)):this.u.logService.info(`${J} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(Q=>{const J=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,I.$Sc)(()=>{const Q=oe.j.indexOf(this);Q>=0&&oe.j.splice(Q,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Z=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const N=M<U.length?U[M]:U[U.length-1];try{if(N>0){const Q=j(N);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Q)),this.u.logService.info(`${Z} waiting for ${N} seconds before reconnecting...`);try{await Q}catch{}}if(this.n){this.u.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this.u.logService.info(`${Z} resolving connection...`);const H=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Z} connecting to ${H.connectTo}...`),await this.G(H,w(h)),this.u.logService.info(`${Z} reconnected!`),this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this.u.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(y.$Ol.isTemporarilyNotAvailable(H)){this.u.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,A.$4)(H)){this.u.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof y.$Ol){this.u.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,y.$Ol.isHandled(H));break}this.u.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this.n&&!this.s)}C(Z,U,M){this.w?oe.triggerPermanentFailure(Z,U,M):this.D(Z,U,M)}D(Z,U,M){this.m.fire(new ie(this.reconnectionToken,Z,U,M)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=oe;class K extends oe{constructor(Z,U,M,N,H){super(g.Management,Z,N,H,!0),this.client=this.B(new $.$mi(H,{remoteAuthority:U,clientId:M},Z.ipcLogger))}async G(Z,U){await n(Z,U)}}e.$4l=K;class te extends oe{constructor(Z,U,M,N,H){super(g.ExtensionHost,Z,M,N,!1),this.H=U,this.debugPort=H}async G(Z,U){await l(Z,this.H,U)}}e.$5l=te;function q(ne){try{ne.acceptDisconnect();const Z=ne.getSocket();ne.dispose(),Z.dispose()}catch(Z){(0,A.$1)(Z)}}function L(ne){if(ne&&ne.type==="error"){const Z=new Error(`Connection error: ${ne.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function B(ne,Z){for(;ne.length<Z;)ne+=" ";return ne}function V(ne,Z){return`[remote-connection][${B(m(ne),13)}][${Z.substr(0,5)}\u2026]`}function ae(ne,Z,U){return`${V(ne,Z)}[${U?"reconnect":"initial"}]`}function G(ne,Z){return`${ae(Z,ne.reconnectionToken,!!ne.reconnectionProtocol)}[${ne.connectTo}]`}function he(ne){return`${Date.now()-ne} ms`}}),define(ce[71],le([0,1,13]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=r,e.$Nm=k,e.$Om=A,e.$Pm=O;function r(E){return E.scheme===i.Schemas.vscodeRemote?E.authority:void 0}function k(E){if(!E)return;const c=E.indexOf("+");return c<0?E:E.substr(0,c)}function A(E){const{host:c,port:f}=I(E);if(typeof f>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:f}}function O(E,c){let{host:f,port:d}=I(E);return typeof d>"u"&&(d=c),{host:f,port:d}}function I(E){const c=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const f=E.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const d=E.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:E,port:void 0}}}),define(ce[100],le([0,1,26,6,71]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=A,e.$Zm=d,e.$1m=$,e.$2m=y,e.$3m=h,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class E{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,w){if(typeof m>"u"||m===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof m=="string"||typeof w=="string"){const p=typeof m=="string"?m:m.value,v=typeof w=="string"?w:w.value;return i.$Bf(p,v)}return m._lower===w._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Wm=E;class c{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const w of m)this.add(w)}add(m){this.c.add(E.toKey(m))}delete(m){return this.c.delete(E.toKey(m))}has(m){return this.c.has(E.toKey(m))}}e.$Xm=c;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(E.toKey(m))}get(m){return this.c.get(E.toKey(m))}has(m){return this.c.has(E.toKey(m))}set(m,w){this.c.set(E.toKey(m),w)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=f;function d(g){return $(g)}function $(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function y(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function h(g,m){if(m){const w=`onResolveRemoteAuthority:${(0,k.$Nm)(m)}`;return!!g.activationEvents?.includes(w)}return!1}e.$4m=(0,r.$Ai)("IBuiltinExtensionsScannerService")}),define(ce[127],le([0,1,4,175,100,6]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=I,e.$9o=E,e.$0o=c,e.$$o=f,e.$_o=d,e.$ap=$,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var O;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(o){switch(o){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function E(o){switch(o){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function c(o,t){switch(o){case i.Platform.Windows:return t==="x64"?k.TargetPlatform.WIN32_X64:t==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case i.Platform.Linux:return t==="x64"?k.TargetPlatform.LINUX_X64:t==="arm64"?k.TargetPlatform.LINUX_ARM64:t==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?k.TargetPlatform.ALPINE_X64:t==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case i.Platform.Mac:return t==="x64"?k.TargetPlatform.DARWIN_X64:t==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case i.Platform.Web:return k.TargetPlatform.WEB}}function f(o,t){return t===k.TargetPlatform.WEB&&!o.includes(k.TargetPlatform.WEB)}function d(o,t,s){return f(t,s)?!1:o===k.TargetPlatform.UNDEFINED||o===k.TargetPlatform.UNIVERSAL?!0:o===k.TargetPlatform.UNKNOWN?!1:o===s}function $(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var y;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var h;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var g;(function(o){o.Install="install",o.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var m;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$bp=(0,A.$Ai)("extensionGalleryService");var w;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(w||(e.ExtensionGalleryErrorCode=w={}));class p extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$cp=p;var v;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class S extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$dp=S,e.$ep=(0,A.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,A.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,A.$Ai)("IExtensionTipsService"),e.$jp=(0,r.localize2)(0,"Extensions"),e.$kp=(0,r.localize2)(1,"Preferences")}),define(ce[247],le([0,1,2,6]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,r.$Ai)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,i.$Sc)(()=>{const E=this.a[O]?.indexOf(I);typeof E=="number"&&E>=0&&this.a[O]?.splice(E,1)})}b(O){return(this.a[O.type]||[]).find(E=>E.supports(O))}connect(O,I,E,c){const f=this.b(O);if(!f)throw new Error(`No socket factory found for ${O}`);return f.connect(O,I,E,c)}}e.$Rl=k}),define(ce[248],le([0,1,27,50,21,122]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=I;let O;async function I(y=!1){return(O===void 0||y)&&(O=E()),O}async function E(){const y=c();if(y===void 0)return!1;if(y>=22e3){const h=d();if(h)return new Promise(g=>{r.execFile(h,["--status"],m=>g(!m))})}else{const h=$();if(h)try{if((await k.Promises.stat(h)).isFile())return!0}catch{}}return!1}function c(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if(y)return parseInt(y[3])}function f(y){const h=process.env.SystemRoot;if(h){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(h,g?"Sysnative":"System32",y)}}function d(){return f("wsl.exe")}function $(){return f("lxss\\LxssManager.dll")}}),define(ce[55],le([0,1,17,16,2,189,54,6,5,46]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=$,e.$Yp=y,e.$Zp=h,e.$1p=g,e.$2p=m,e.$3p=w,e.$Vp=(0,I.$Ai)("requestService");class f{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.b[t];this.a=o}return this.a}}class d extends k.$Uc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,A.localize)(0,null),when:E.$mk.isEqualTo((0,E.$jk)(E.LogLevel.Trace)).serialize()})}async c(o,t,s){const a=`${o} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new f(t.headers??{}));try{const n=await s();return this.a.trace(`${a} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${a} - error`,t.type,(0,r.$0)(n)),n}}}e.$Wp=d;function $(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function y(S){return S.res.statusCode===204}async function h(S){return y(S)?null:(await(0,i.$Ve)(S.stream)).toString()}async function g(S){if(!$(S))throw new Error("Server returned "+S.res.statusCode);return h(S)}async function m(S){if(!$(S))throw new Error("Server returned "+S.res.statusCode);if(y(S))return null;const t=(await(0,i.$Ve)(S.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function w(S){v(S)}let p;function v(S){const o=c.$jo.as(O.$oo.Configuration),t=p;p={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[p],remove:t?[t]:[]})}v(O.ConfigurationScope.APPLICATION)}),define(ce[249],le([0,1,17,23]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0;class k{constructor(I){this.a=I}listen(I,E){throw new Error("Invalid listen")}call(I,E,c,f=r.CancellationToken.None){switch(E){case"request":return this.a.request(c[0],f).then(async({res:d,stream:$})=>{const y=await(0,i.$Ve)($);return[{statusCode:d.statusCode,headers:d.headers},y]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$3r=k;class A{constructor(I){this.a=I}async request(I,E){const[c,f]=await this.a.call("request",[I],E);return{res:c,stream:(0,i.$Xe)(f)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$4r=A}),define(ce[250],le([0,1,251,12]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=A;function k(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(O,I,E={}){const c=(0,i.parse)(O),f=E.proxyUrl||k(c,I);if(!f)return null;const d=(0,i.parse)(f);if(!/^https?:$/.test(d.protocol||""))return null;const $={host:d.hostname||"",port:(d.port?+d.port:0)||(d.protocol==="https"?443:80),auth:d.auth,rejectUnauthorized:(0,r.$gg)(E.strictSSL)?E.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((y,h)=>{X(["http-proxy-agent"],y,h)})).HttpProxyAgent(f,$):new(await new Promise((y,h)=>{X(["https-proxy-agent"],y,h)})).HttpsProxyAgent(f,$)}}),define(ce[252],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=void 0,e.$eec={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$fec={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$gec={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[101],le([0,1,50,9,190,23,48,16,4,33,117,67,8,143]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=g;let h;async function g(w,p,v,S){return v["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$Fm)(S)&&!v["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$Fm)(S)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=$.Promises.withAsyncBody(async(o,t)=>{const s=new A.$se;let a=1e4;const n=w.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(a=(0,y.$Gm)(n,1,120)*1e3);const l=setTimeout(()=>{s.dispose(!0),t(new Error((0,k.localize)(0,null)))},a);try{o(await m(p,s.token))}catch(u){!(0,I.$4)(u)&&!s.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,O.$lj)(u)))):o({})}finally{clearTimeout(l),s.dispose()}})),h)}async function m(w,p){const v=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",v);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",S);const o=(0,c.$Wg)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"({.*})"+o),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};w.trace("getUnixShellEnvironment#env",s);const a=await(0,f.$vm)(E.OS,s);return w.trace("getUnixShellEnvironment#shell",a),new Promise((n,l)=>{if(p.isCancellationRequested)return l(new I.$5);const u=(0,r.$nc)(a);let b,P;const R="";/^pwsh(-preview)?$/.test(u)?(b=`& '${process.execPath}' ${R} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,P=["-Login","-Command"]):u==="nu"?(b=`^'${process.execPath}' ${R} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,P=["-i","-l","-c"]):u==="xonsh"?(b=`import os, json; print("${o}", json.dumps(dict(os.environ)), "${o}")`,P=["-i","-l","-c"]):(b=`'${process.execPath}' ${R} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,u==="tcsh"||u==="csh"?P=["-ic"]:P=["-i","-l","-c"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),b);const D=(0,i.spawn)(a,[...P,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(D.kill(),l(new I.$5))),D.on("error",F=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,O.$lj)(F)),l(F)});const T=[];D.stdout.on("data",F=>T.push(F));const j=[];D.stderr.on("data",F=>j.push(F)),D.on("close",(F,W)=>{const C=Buffer.concat(T).toString("utf8");w.trace("getUnixShellEnvironment#raw",C);const z=Buffer.concat(j).toString("utf8");if(z.trim()&&w.trace("getUnixShellEnvironment#stderr",z),F||W)return l(new Error((0,k.localize)(2,null,F,W)));const se=t.exec(C),ie=se?se[1]:"{}";try{const oe=JSON.parse(ie);v?oe.ELECTRON_RUN_AS_NODE=v:delete oe.ELECTRON_RUN_AS_NODE,S?oe.ELECTRON_NO_ATTACH_CONSOLE=S:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",oe),n(oe)}catch(oe){w.error("getUnixShellEnvironment#errorCaught",(0,O.$lj)(oe)),l(oe)}})})}}),define(ce[253],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const A=await this.c();if(A){const O=String(i.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const O=this.b.get(k.id);if(!O)return!1;this.b.delete(k.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$4_b=i}),define(ce[102],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,i.$Ai)(e.$Sl)}),define(ce[254],le([0,1,253]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class r extends i.$4_b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>X(["vsda"],A,O))}}e.$9ec=r}),define(ce[34],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=void 0,e.$cQ=(0,i.$Ai)("stateReadService"),e.$dQ=(0,i.$Ai)("stateService")}),define(ce[128],le([0,1,8,17,2,12,38,15,5]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=e.$eQ=e.SaveStrategy=void 0;var c;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class f extends k.$Uc{constructor(h,g,m,w){super(),this.h=h,this.j=g,this.m=m,this.n=w,this.a=Object.create(null),this.b="",this.c=this.B(new i.$yh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(h)}}getItem(h,g){const m=this.a[h];return(0,A.$jg)(m)?g:m}setItem(h,g){this.setItems([{key:h,data:g}])}setItems(h){let g=!1;for(const{key:m,data:w}of h)this.a[m]!==w&&((0,A.$jg)(w)?(0,A.$hg)(this.a[m])||(this.a[m]=void 0,g=!0):(this.a[m]=w,g=!0));g&&this.s()}removeItem(h){(0,A.$hg)(this.a[h])||(this.a[h]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.n.writeFile(this.h,r.$Je.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(g){this.m.error(g)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$eQ=f;let d=class extends k.$Uc{constructor(h,g,m,w){super(),this.a=this.B(new f(g.stateResource,h,m,w))}async init(){await this.a.init()}getItem(h,g){return this.a.getItem(h,g)}};e.$fQ=d,e.$fQ=d=Se([re(1,O.$Hi),re(2,E.$7j),re(3,I.$7k)],d);class $ extends d{setItem(h,g){this.a.setItem(h,g)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$gQ=$}),define(ce[129],le([0,1,4,36,33]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=O,e.$mp=I;function A(E){if(i.$u===i.Platform.Linux&&/^penguin(\.|$)/i.test(E))return"chromebook"}function O(E,c,f,d,$,y,h,g,m,w){const p=Object.create(null);p["common.machineId"]=y,p["common.sqmId"]=h,p["common.devDeviceId"]=g,p.sessionID=(0,k.$Wg)()+Date.now(),p.commitHash=d,p.version=$,p["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,i.$h)(i.$u),p["common.nodePlatform"]=r.$dc,p["common.nodeArch"]=f,p["common.product"]=w||"desktop",m&&(p["common.msftInternal"]=m);let v=0;const S=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),i.$l&&(p["common.snap"]="true");const o=A(c);return o&&(p["common.platformDetail"]=o),p}function I(E){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const f=c.toLowerCase();return E.some(d=>f===d)}}),define(ce[24],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,i.$Ai)("telemetryService"),e.$7l=(0,i.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var r;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ce[255],le([0,1,27,8,40,13,9,4,7,93,21,116,96,15,28,24]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Ms=w,e.$Ns=v,e.$Os=S;const m=new Map;async function w(t,s){const a=`${t}::${s.join(":")}`,n=m.get(a);if(n)return n;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,b=new Map,P=2e4;function R(T,j,F,W){const C=j.substring(T.length+1);return r.Promises.withAsyncBody(async z=>{let se;try{se=await f.Promises.readdir(j,{withFileTypes:!0})}catch{z();return}if(W.count>=P){W.count+=se.length,W.maxReached=!0,z();return}let ie=se.length;if(ie===0){z();return}let oe=se;W.count+se.length>P&&(W.maxReached=!0,ie=P-W.count,oe=se.slice(0,ie)),W.count+=se.length;for(const K of oe)if(K.isDirectory()){if(F.includes(K.name)||await R(T,(0,O.$jc)(j,K.name),F,W),--ie===0){z();return}}else{const te=K.name.lastIndexOf(".");if(te>=0){const q=K.name.substring(te+1);q&&u.set(q,(u.get(q)??0)+1)}for(const q of l)q.relativePathPattern?.test(C)!==!1&&q.filePattern.test(K.name)&&b.set(q.tag,(b.get(q.tag)??0)+1);if(--ie===0){z();return}}})}const D=r.Promises.withAsyncBody(async T=>{const j={count:0,maxReached:!1};await R(t,t,s,j);const F=await S(t);T({configFiles:p(b),fileTypes:p(u),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return m.set(a,D),D}function p(t){return Array.from(t.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function v(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/y.$Cl.GB).toFixed(2)}GB (${(i.freemem()/y.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Jn.value()*100)}%`},s=i.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}async function S(t){try{const s=new Map,a=(0,O.$jc)(t,".vscode","launch.json"),n=await f.Promises.readFile(a),l=[],u=(0,k.$Pn)(n.toString(),l);if(l.length)return console.log(`Unable to parse ${a}`),[];if((0,k.$Yn)(u)==="object"&&u.configurations)for(const b of u.configurations){const P=b.type;P&&(s.has(P)?s.set(P,s.get(P)+1):s.set(P,1))}return p(s)}catch{return[]}}let o=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&a.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),a.push(`Memory (System):  ${(i.totalmem()/y.$Cl.GB).toFixed(2)}GB (${(i.freemem()/y.$Cl.GB).toFixed(2)}GB free)`),I.$i||a.push(`Load (avg):       ${i.loadavg().map(l=>Math.round(l)).join(", ")}`),a.push(`VM:               ${Math.round(c.$Jn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,d.$Ls)(s.mainPID),this.k(s)]).then(async n=>{let[l,u]=n,b=this.m(s,l);return a.forEach(P=>{if((0,$.$jn)(P))b+=`
${P.errorMessage}`,u+=`
${P.errorMessage}`;else if(b+=`

Remote: ${P.hostName}`,P.processes&&(b+=`
${this.m(s,P.processes)}`),P.workspaceMetadata){u+=`
|  Remote: ${P.hostName}`;for(const R of Object.keys(P.workspaceMetadata)){const D=P.workspaceMetadata[R];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${R}): ${T}`,u+=this.h(D)}}}),{processInfo:b,workspaceInfo:u}})}async getSystemInfo(s,a){const{memory:n,vmHint:l,os:u,cpus:b}=v(),P={os:u,memory:n,cpus:b,vmHint:l,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return I.$i||(P.load=`${i.loadavg().map(R=>Math.round(R)).join(", ")}`),I.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(s,a){const n=[];return(0,d.$Ls)(s.mainPID).then(async l=>(n.push(""),n.push(this.g(s)),n.push(""),n.push(this.m(s,l)),s.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(s))),a.forEach(u=>{if((0,$.$jn)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.f(u.machineInfo)),u.processes&&n.push(this.m(s,u.processes)),u.workspaceMetadata)for(const b of Object.keys(u.workspaceMetadata)){const P=u.workspaceMetadata[b];let R=`${P.fileCount} files`;P.maxFilesReached&&(R=`more than ${R}`),n.push(`Folder (${b}): ${R}`),n.push(this.h(P))}}),n.push(""),n.push(""),n.join(`
`)))}h(s){const a=[];let l=0;const u=(D,T)=>{const j=` ${D}(${T})`;l+j.length>60?(a.push(b),b="|                 ",l=b.length):l+=j.length,b+=j};let b="|      File types:";const P=10,R=s.fileTypes.length>P?P:s.fileTypes.length;for(let D=0;D<R;D++){const T=s.fileTypes[D];u(T.name,T.count)}if(a.push(b),s.configFiles.length>=0&&(b="|      Conf files:",l=0,s.configFiles.forEach(D=>{u(D.name,D.count)}),a.push(b)),s.launchConfigFiles.length>0){let D="|      Launch Configs:";s.launchConfigFiles.forEach(T=>{const j=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;D+=j}),a.push(D)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(n=>n.length));return Object.keys(s).map(n=>`${n}:  ${" ".repeat(a-n.length)}  ${s[n]}`).join(`
                  `)}k(s){const a=[],n=[];return s.windows.forEach(l=>{l.folderURIs.length===0||l.remoteAuthority||(a.push(`|  Window (${l.title})`),l.folderURIs.forEach(u=>{const b=E.URI.revive(u);if(b.scheme===A.Schemas.file){const P=b.fsPath;n.push(w(P,["node_modules",".git"]).then(R=>{let D=`${R.fileCount} files`;R.maxFilesReached&&(D=`more than ${D}`),a.push(`|    Folder (${(0,O.$nc)(P)}): ${D}`),a.push(this.h(R))}).catch(R=>{a.push(`|      Error: Unable to collect workspace stats for folder ${P} (${R.toString()})`)}))}else a.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(l=>a.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}m(s,a){const n=new Map;s.windows.forEach(u=>n.set(u.pid,`window [${u.id}] (${u.title})`)),s.pidToNames.forEach(({pid:u,name:b})=>n.set(u,b));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,n,l,a,0),l.join(`
`)}n(s,a,n,l,u){const b=u===0;let P;b?P=l.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(l.pid)?P=a.get(l.pid):P=`${"  ".repeat(u)} ${l.name}`;const R=process.platform==="win32"?l.mem:i.totalmem()*(l.mem/100);n.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/y.$Cl.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(l.children)&&l.children.forEach(D=>this.n(s,a,n,D,u+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:n}of s.folders){const l=E.URI.revive(n);if(l.scheme!==A.Schemas.file)continue;const u=l.fsPath;try{(await w(u,["node_modules",".git"])).fileTypes.forEach(P=>a.add(P.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const n=E.URI.revive(a);if(n.scheme!==A.Schemas.file)continue;const l=n.fsPath;try{const u=await w(l,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),u.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})}),u.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})}),u.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$Ps=o,e.$Ps=o=Se([re(0,g.$6l),re(1,h.$nk)],o)}),define(ce[256],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0;class i{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:E}){return this.b.forEach(c=>c.log(I,E)),Promise.resolve(null)}}e.$jec=i;class r{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$kec=r}),define(ce[56],le([0,1,35,12,71,129,24]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=f,e.$vp=d,e.$wp=$,e.$xp=y,e.$yp=g,e.$zp=w,e.$Ap=p,e.$Bp=o;class I{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$np=I;class E{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=E,e.$pp=new E;class c{async publicLog(s,a,n){}async publicLogError(s,a,n){}}e.$qp=c,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function f(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function d(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const s=t.getValue(O.$cm),a=t.getValue(O.$dm);if(t.getValue(O.$em)===!1||a===!1)return O.TelemetryLevel.NONE;switch(s??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function y(t){const s={},a={},n={};m(t,n);for(let l in n){l=l.length>150?l.substr(l.length-149):l;const u=n[l];typeof u=="number"?a[l]=u:typeof u=="boolean"?a[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),s[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(s[l]=u)}return{properties:s,measurements:a}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(t){if(!t)return"none";const s=(0,k.$Nm)(t);return h.has(s)?s:"other"}function m(t,s,a=0,n){if(t)for(const l of Object.getOwnPropertyNames(t)){const u=t[l],b=n?n+l:l;Array.isArray(u)?s[b]=(0,i.$bo)(u):u instanceof Date?s[b]=u.toISOString():(0,r.$cg)(u)?a<2?m(u,s,a+1,b+"."):s[b]=(0,i.$bo)(u):s[b]=u}}function w(t,s){const a=t.msftInternalDomains||[],n=s.getValue("telemetry.internalTesting");return(0,A.$mp)(a)||n}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function v(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const n=[];for(const P of s)for(;;){const R=P.exec(t);if(!R)break;n.push([R.index,P.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(a="";;){const P=u.exec(t);if(!P)break;const R=n.some(([D,T])=>P.index<T&&D<u.lastIndex);!l.test(P[0])&&!R&&(a+=t.substring(b,P.index)+"<REDACTED: user-file-path>",b=u.lastIndex)}return b<t.length&&(a+=t.substr(b)),a}function S(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of s)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function o(t,s){return(0,i.$$n)(t,a=>{if(a instanceof I||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let n=a.replaceAll("%20"," ");n=v(n,s);for(const l of s)n=n.replace(l,"");return n=S(n),n}})}}),define(ce[130],le([0,1,26,127,100,4,7,16,36,56]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=f,e.$Ep=h,e.$Fp=g,e.$Gp=m,e.$Hp=w,e.$Ip=p,e.$Jp=v,e.$Kp=S,e.$Mp=o,e.$Np=s;function f(a,n){return a.uuid&&n.uuid?a.uuid===n.uuid:a.id===n.id?!0:(0,i.$wf)(a.id,n.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const l=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,l,u)}static parse(n){const l=d.exec(n);return l&&l[1]&&l[2]?new $({id:l[1]},l[2],l[4]||void 0):null}constructor(n,l,u=k.TargetPlatform.UNDEFINED){this.identifier=n,this.version=l,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?f(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Dp=$;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(a){const n=y.exec(a);return n&&n[1]?[m(n[1]),n[2]]:[m(a),void 0]}function g(a,n){return`${a}.${n}`}function m(a){return a.toLowerCase()}function w(a,n){return m(g(a??k.$Sm,n))}function p(a,n){const l=[],u=b=>{for(const P of l)if(P.some(R=>f(n(R),n(b))))return P;return null};for(const b of a){const P=u(b);P?P.push(b):l.push([b])}return l}function v(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function S(a){return{id:new c.$np(a.identifier.id),name:new c.$np(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Lp=new k.$Wm("pprice.better-merge");function o(a,n){const l=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const b=u.shift();if(b&&l.every(P=>!f(P.identifier,{id:b}))){const P=a.filter(R=>f(R.identifier,{id:b}));P.length===1&&(l.push(P[0]),u.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function t(a,n){if(!A.$k)return!1;let l;try{l=(await a.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){n.debug("Error while getting the os-release file.",(0,I.$0)(b))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,n){const l=await t(a,n),u=(0,r.$0o)(l?"alpine":A.$u,E.$ec);return n.debug("ComputeTargetPlatform:",u),u}}),define(ce[257],le([0,1,2,35,4,26,191,18,54,84,28,46,24,56]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(w,p,v){this.k=p,this.l=v,this.d={},this.i=new i.$Tc,this.j=[],this.b=w.appenders,this.c=w.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=w.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!w.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,A.$df)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$df)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration($.$cm)||S.affectsConfiguration($.$em)||S.affectsConfiguration($.$dm))&&this.m()}))}setExperimentProperty(w,p){this.d[w]=p}m(){let w=(0,y.$wp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const v=p.usage?$.TelemetryLevel.USAGE:p.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;w=Math.min(w,v)}this.g=w}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(w,p,v){this.g<p||(v=(0,r.$_n)(v,this.d),v=(0,y.$Bp)(v,this.j),v=(0,r.$_n)(v,this.c),this.b.forEach(S=>S.log(w,v)))}publicLog(w,p){this.n(w,$.TelemetryLevel.USAGE,p)}publicLog2(w,p){this.publicLog(w,p)}publicLogError(w,p){this.h&&this.n(w,$.TelemetryLevel.ERROR,p)}publicLogError2(w,p){this.publicLogError(w,p)}};e.$8r=h,e.$8r=h=Se([re(1,I.$7i),re(2,f.$nk)],h);function g(){const m=(0,O.localize)(0,null,c.default.nameLong),w=c.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=k.$o?"":(0,O.localize)(3,null),v=(0,O.localize)(4,null),S=(0,O.localize)(5,null),o=(0,O.localize)(6,null),t=(0,O.localize)(7,null),s=`
|       | ${v} | ${S} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,O.localize)(8,null);return`
${m} ${w} ${p}

&nbsp;

${t}
${s}

&nbsp;

${a}
`}d.$jo.as(E.$oo.Configuration).registerConfiguration({id:$.$bm,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[$.$cm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:g(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:E.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$jo.as(E.$oo.Configuration).registerConfiguration({id:$.$bm,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[$.$em]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,O.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,O.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${$.$cm}#\``),scope:E.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[258],le([0,1,4,93,24]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=A,e.$Mec=O,e.$Nec=I;async function A(E,c){let f=E.getItem(k.$$l);return(typeof f!="string"||i.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,r.$Kn)(c.error.bind(c))),f}async function O(E,c){let f=E.getItem(k.$_l);return typeof f!="string"&&(f=await(0,r.$Ln)(c.error.bind(c))),f}async function I(E,c){let f=E.getItem(k.$am);return typeof f!="string"&&(f=await(0,r.$Mn)(c.error.bind(c))),f}}),define(ce[259],le([0,1,24,258]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=k,e.$Pec=A,e.$Qec=O;async function k(I,E){const c=await(0,r.$Lec)(I,E);return I.setItem(i.$$l,c),c}async function A(I,E){const c=await(0,r.$Mec)(I,E);return I.setItem(i.$_l,c),c}async function O(I,E){const c=await(0,r.$Nec)(I,E);return I.setItem(i.$am,c),c}}),define(ce[131],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(ce[260],le([0,1,4,131]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;const k=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(f){this.collections=f,this.a=new Map,this.b=new Map,f.forEach((d,$)=>{this.d(d,$);const y=d.map.entries();let h=y.next();for(;!h.done;){const g=h.value[1],m=h.value[0];let w=this.a.get(m);if(w||(w=[],this.a.set(m,w)),w.length>0&&w[0].type===r.EnvironmentVariableMutatorType.Replace){h=y.next();continue}const p={extensionIdentifier:$,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};p.scope||delete p.scope,w.unshift(p),h=y.next()}})}async applyToProcessEnvironment(f,d,$){let y;i.$i&&(y={},Object.keys(f).forEach(h=>y[h.toLowerCase()]=h));for(const[h,g]of this.getVariableMap(d)){const m=i.$i&&y[h.toLowerCase()]||h;for(const w of g){const p=$?await $(w.value):w.value;if(w.options?.applyAtProcessCreation??!0)switch(w.type){case r.EnvironmentVariableMutatorType.Append:f[m]=(f[m]||"")+p;break;case r.EnvironmentVariableMutatorType.Prepend:f[m]=p+(f[m]||"");break;case r.EnvironmentVariableMutatorType.Replace:f[m]=p;break}if(w.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${k.get(w.type)}`;f[v]=(f[v]?f[v]+":":"")+h+"="+this.c(p)}}}}c(f){return f.replaceAll(":","\\x3a")}diff(f,d){const $=new Map,y=new Map,h=new Map;if(f.getVariableMap(d).forEach((g,m)=>{const w=this.getVariableMap(d).get(m),p=I(g,w);p&&$.set(m,p)}),this.getVariableMap(d).forEach((g,m)=>{const w=f.getVariableMap(d).get(m),p=I(g,w);p&&h.set(m,p)}),this.getVariableMap(d).forEach((g,m)=>{const w=f.getVariableMap(d).get(m),p=E(g,w);p&&y.set(m,p)}),!($.size===0&&y.size===0&&h.size===0))return{added:$,changed:y,removed:h}}getVariableMap(f){const d=new Map;for(const $ of this.a.values()){const y=$.filter(h=>O(h,f));y.length>0&&d.set(y[0].variable,y)}return d}getDescriptionMap(f){const d=new Map;for(const $ of this.b.values()){const y=$.filter(h=>O(h,f,!0));for(const h of y)d.set(h.extensionIdentifier,h.description)}return d}d(f,d){if(!f.descriptionMap)return;const $=f.descriptionMap.entries();let y=$.next();for(;!y.done;){const h=y.value[1],g=y.value[0];let m=this.b.get(g);m||(m=[],this.b.set(g,m));const w={extensionIdentifier:d,scope:h.scope,description:h.description};w.scope||delete w.scope,m.push(w),y=$.next()}}}e.$zs=A;function O(c,f,d=!1){return c.scope?!!(c.scope.workspaceFolder&&f?.workspaceFolder&&c.scope.workspaceFolder.index===f.workspaceFolder.index):d?f===c.scope:!0}function I(c,f){if(!f)return c;const d=new Set;f.forEach(y=>d.add(y.extensionIdentifier));const $=[];return c.forEach(y=>{d.has(y.extensionIdentifier)||$.push(y)}),$.length===0?void 0:$}function E(c,f){if(!f)return;const d=new Map;f.forEach(y=>d.set(y.extensionIdentifier,y));const $=[];return c.forEach(y=>{const h=d.get(y.extensionIdentifier);h&&(y.type!==h.type||y.value!==h.value||y.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index)&&$.push(h)}),$.length===0?void 0:$}}),define(ce[261],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=i,e.$us=r,e.$vs=k,e.$ws=A,e.$xs=O,e.$ys=I;function i(E){return[...E.entries()]}function r(E){return E?[...E.entries()]:[]}function k(E){return new Map(E)}function A(E){return new Map(E??[])}function O(E){return Array.from(E.entries()).map(c=>[c[0],i(c[1].map),r(c[1].descriptionMap)])}function I(E){return new Map(E.map(c=>[c[0],{map:k(c[1]),descriptionMap:A(c[2])}]))}}),define(ce[262],le([0,1,8,23,3,2,5]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;let I=class extends A.$Uc{constructor(c,f){super(),this.h=f,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$he),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,A.$Sc)(()=>{for(const d of this.f.values())(0,A.$Pc)(d)}))}createRequest(c){return new Promise((f,d)=>{const $=++this.a;this.c.set($,f),this.g.fire({requestId:$,...c});const y=new r.$se;(0,i.$Bh)(this.b,y.token).then(()=>d(`Request ${$} timed out (${this.b}ms)`)),this.f.set($,[(0,A.$Sc)(()=>y.cancel())])})}acceptReply(c,f){const d=this.c.get(c);d?(this.c.delete(c),(0,A.$Pc)(this.f.get(c)||[]),this.f.delete(c),d(f)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$ks=I,e.$ks=I=Se([re(1,O.$7j)],I)}),define(ce[72],le([0,1,6,123,46]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ds=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$cs=void 0,e.$cs=new r.$Rj("terminalTabFocusMode",!1,!0);var A;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var O;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(o){o.PowerShell="pwsh",o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh",o.Python="python"})(I||(e.PosixShellType=I={}));var E;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash",o.Python="python"})(E||(e.WindowsShellType=E={}));var c;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var f;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(f||(e.TerminalIpcChannels=f={}));var d;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$ds=(0,i.$Ai)("ptyService");var $;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})($||(e.HeartbeatConstants=$={}));var y;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(y||(e.TerminalLocation=y={}));var h;(function(o){o.TerminalView="view",o.Editor="editor"})(h||(e.TerminalLocationString=h={}));var g;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var m;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var w;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(w||(e.ProfileSource=w={}));var p;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var v;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.$es={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}k.$jo.add(e.$es.Backend,new S),e.$fs=(0,i.$Ai)("localPtyService"),e.$gs=(0,i.$Ai)("terminalLogService")}),define(ce[263],le([0,1,78,7,193,111]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=O,e.$ms=c,e.$ns=f,e.$os=d;function O($,y){const h=[{name:null,description:(0,k.localize)(0,null)}];return h.push(...$.map(g=>({name:g.profileName,description:I(g)}))),y&&h.push(...y.map(g=>({name:g.title,description:E(g)}))),{values:h.map(g=>g.name),markdownDescriptions:h.map(g=>g.description)}}function I($){let y=`$(${A.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$Zj.terminal.id}) ${$.profileName}
- path: ${$.path}`;return $.args&&(typeof $.args=="string"?y+=`
- args: "${$.args}"`:y+=`
- args: [${$.args.length===0?"":`'${$.args.join("','")}'`}]`),$.overrideName!==void 0&&(y+=`
- overrideName: ${$.overrideName}`),$.color&&(y+=`
- color: ${$.color}`),$.env&&(y+=`
- env: ${JSON.stringify($.env)}`),y}function E($){return`$(${A.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$Zj.terminal.id}) ${$.title}
- extensionIdentifier: ${$.extensionIdentifier}`}function c($,y){if(!$&&!y)return!0;if(typeof $=="string"&&typeof y=="string")return $===y;if(Array.isArray($)&&Array.isArray(y)){if($.length!==y.length)return!1;for(let h=0;h<$.length;h++)if($[h]!==y[h])return!1;return!0}return!1}function f($,y){if(!$&&!y)return!0;if(!$||!y)return!1;if(A.ThemeIcon.isThemeIcon($)&&A.ThemeIcon.isThemeIcon(y))return $.id===y.id&&$.color===y.color;if(typeof $=="object"&&"light"in $&&"dark"in $&&typeof y=="object"&&"light"in y&&"dark"in y){const h=$,g=y;if((r.URI.isUri(h.light)||d(h.light))&&(r.URI.isUri(h.dark)||d(h.dark))&&(r.URI.isUri(g.light)||d(g.light))&&(r.URI.isUri(g.dark)||d(g.dark)))return h.light.path===g.light.path&&h.dark.path===g.dark.path}if(r.URI.isUri($)&&r.URI.isUri(y)||d($)||d(y)){const h=$,g=y;return h.path===g.path&&h.scheme===g.scheme}return!1}function d($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}}),define(ce[264],le([0,1,78,4,192,54,46,72,263]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=void 0,e.$rs=h,e.$ss=m,e.$ps={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$qs={type:"string",enum:Array.from((0,i.$Xj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,i.$Xj)(),w=>`$(${w.id})`)};const c={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),...e.$qs},color:{description:(0,k.localize)(3,null),...e.$ps},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},f={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...c}},d={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(6,null),type:["string"],items:{type:"string"}},...c}};function $(w){const p=w===r.Platform.Linux?"linux":w===r.Platform.Mac?"osx":"windows";return(0,k.localize)(7,null,(0,r.$h)(w),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,k.localize)(8,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:$(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(12,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(13,null),type:"string"},id:{description:(0,k.localize)(14,null),type:"string"},title:{description:(0,k.localize)(15,null),type:"string"},...c}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:$(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(16,null),type:"string"},id:{description:(0,k.localize)(17,null),type:"string"},title:{description:(0,k.localize)(18,null),type:"string"},...c}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:$(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(19,null),type:"string"},id:{description:(0,k.localize)(20,null),type:"string"},title:{description:(0,k.localize)(21,null),type:"string"},...c}},{type:"null"},f]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,k.localize)(22,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:A.ConfigurationScope.APPLICATION,description:(0,k.localize)(23,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:A.ConfigurationScope.APPLICATION,markdownDescription:(0,k.localize)(24,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:A.ConfigurationScope.APPLICATION,description:(0,k.localize)(25,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,k.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){O.$jo.as(A.$oo.Configuration).registerConfiguration(y),m()}let g;function m(w,p){const v=O.$jo.as(A.$oo.Configuration);let S;w&&(S=(0,E.$ls)(w?.profiles,p));const o=g;g={id:"terminal",order:100,title:(0,k.localize)(27,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(28,null),type:["string","null"],default:null,enum:w?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:w?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(29,null),type:["string","null"],default:null,enum:w?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:w?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(30,null),type:["string","null"],default:null,enum:w?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:w?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[g],remove:o?[o]:[]})}}),define(ce[265],le([0,1,27,13,35,9,4,36,26,12,21,131,261,260]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=h,e.$Bs=g,e.$Cs=m;function h(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let b=0;return u&&u.length===4&&(b=parseInt(u[3])),b}async function g(u,b,P,R=I.env,D=f.Promises.exists){if(A.$ic(u))return await D(u)?u:void 0;if(b===void 0&&(b=I.cwd()),A.$mc(u)!=="."){const W=A.$jc(b,u);return await D(W)?W:void 0}const j=(0,k.$do)(R,"PATH");if(P===void 0&&(0,c.$ag)(j)&&(P=j.split(A.$tc)),P===void 0||P.length===0){const W=A.$jc(b,u);return await D(W)?W:void 0}for(const W of P){let C;if(A.$ic(W)?C=A.$jc(W,u):C=A.$jc(b,W,u),await D(C))return C;if(O.$i){let z=C+".com";if(await D(z)||(z=C+".exe",await D(z)))return z}}const F=A.$jc(b,u);return await D(F)?F:void 0}function m(u,b,P,R,D){const T=O.$i&&(!b.windowsEnableConpty||h()<18309);if(!b.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||T)return;const j=u.args,F=I.$dc==="win32"?A.$nc(u.executable).toLowerCase():A.$nc(u.executable),W=A.$mc(r.$Ug.asFileUri("").fsPath);let C;const z={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(z.VSCODE_NONCE=b.shellIntegration.nonce),O.$i){if(F==="pwsh.exe"||F==="powershell.exe")return!j||n(j)?C=v.get(p.WindowsPwsh):a(j)&&(C=v.get(p.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,E.$_e)(C[C.length-1],W,""),b.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:z}):void 0;if(F==="bash.exe")return!j||j.length===0?C=v.get(p.Bash):l(j)&&(z.VSCODE_SHELL_LOGIN="1",w(b,z),C=v.get(p.Bash)),C?(C=[...C],C[C.length-1]=(0,E.$_e)(C[C.length-1],W),{newArgs:C,envMixin:z}):void 0;R.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(F){case"bash":return!j||j.length===0?C=v.get(p.Bash):l(j)&&(z.VSCODE_SHELL_LOGIN="1",w(b,z),C=v.get(p.Bash)),C?(C=[...C],C[C.length-1]=(0,E.$_e)(C[C.length-1],W),{newArgs:C,envMixin:z}):void 0;case"fish":{const se=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=A.$jc(W,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${se}:${ie}`,w(b,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!j||n(j)?C=v.get(p.Pwsh):a(j)&&(C=v.get(p.PwshLogin)),C?(b.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,E.$_e)(C[C.length-1],W,""),{newArgs:C,envMixin:z}):void 0;case"zsh":{if(!j||j.length===0?C=v.get(p.Zsh):l(j)?(C=v.get(p.ZshLogin),w(b,z)):(j===v.get(p.Zsh)||j===v.get(p.ZshLogin))&&(C=j),!C)return;C=[...C],C[C.length-1]=(0,E.$_e)(C[C.length-1],W);let se;try{se=i.userInfo().username}catch{se="unknown"}const ie=A.$jc(i.tmpdir(),`${se}-${D.applicationName}-zsh`);z.ZDOTDIR=ie;const oe=P?.ZDOTDIR??i.homedir()??"~";z.USER_ZDOTDIR=oe;const K=[];return K.push({source:A.$jc(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$jc(ie,".zshrc")}),K.push({source:A.$jc(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$jc(ie,".zprofile")}),K.push({source:A.$jc(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$jc(ie,".zshenv")}),K.push({source:A.$jc(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$jc(ie,".zlogin")}),{newArgs:C,envMixin:z,filesToCopy:K}}}R.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function w(u,b){if(O.$j&&u.environmentVariableCollections){const P=(0,$.$ys)(u.environmentVariableCollections),D=new y.$zs(P).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),T=[];if(D)for(const j of D)j.type===d.EnvironmentVariableMutatorType.Prepend&&T.push(j.value);T.length>0&&(b.VSCODE_PATH_PREFIX=T.join(""))}}var p;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(p||(p={}));const v=new Map;v.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(p.Zsh,["-i"]),v.set(p.ZshLogin,["-il"]),v.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],o=["--login","-l"],t=["-i","--interactive"],s=["-nol","-nologo"];function a(u){return typeof u=="string"?S.includes(u.toLowerCase()):u.length===1&&S.includes(u[0].toLowerCase())||u.length===2&&(S.includes(u[0].toLowerCase())||S.includes(u[1].toLowerCase()))&&(s.includes(u[0].toLowerCase())||s.includes(u[1].toLowerCase()))}function n(u){return typeof u=="string"?s.includes(u.toLowerCase()):u.length===0||u?.length===1&&s.includes(u[0].toLowerCase())}function l(u){return typeof u!="string"&&(u=u.filter(b=>!t.includes(b.toLowerCase()))),u==="string"&&o.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&o.includes(u[0].toLowerCase())}}),define(ce[266],le([0,1,50,78,9,4,12,21,115,72,265,122]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=g;var $;(function(b){b.UnixShellsPath="/etc/shells"})($||($={}));let y,h=!0;function g(b,P,R,D,T=process.env,j,F,W,C){return j=j||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},A.$i?m(R,j,T,F,D.getValue(c.TerminalSettingId.UseWslProfiles)!==!1,b&&typeof b=="object"?{...b}:D.getValue(c.TerminalSettingId.ProfilesWindows),typeof P=="string"?P:D.getValue(c.TerminalSettingId.DefaultProfileWindows),C,W):n(j,F,R,b&&typeof b=="object"?{...b}:D.getValue(A.$k?c.TerminalSettingId.ProfilesLinux:c.TerminalSettingId.ProfilesMacOs),typeof P=="string"?P:D.getValue(A.$k?c.TerminalSettingId.DefaultProfileLinux:c.TerminalSettingId.DefaultProfileMacOs),C,W,T)}async function m(b,P,R,D,T,j,F,W,C){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ie=!1;(0,f.$As)()>=16299&&(ie=!0),await S(W);const oe=new Map;if(b){oe.set("PowerShell",{source:c.ProfileSource.Pwsh,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:c.ProfileSource.GitBash,isAutoDetected:!0}),oe.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:r.$Zj.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$Zj.terminalBash,isAutoDetected:!0});const te=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",te],requiresPath:process.env.CMDER_ROOT?te:{path:te,isUnsafe:!0},isAutoDetected:!0})}l(j,oe);const K=await w(oe.entries(),F,P,R,D,C);if(b&&T)try{const te=await s(`${se}\\${ie?"wsl":"bash"}.exe`,F);for(const q of te)(!j||!(q.profileName in j))&&K.push(q)}catch{h&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return K}async function w(b,P,R,D=process.env,T,j){const F=[];for(const[W,C]of b)F.push(p(W,C,P,R,D,T,j));return(await Promise.all(F)).filter(W=>!!W)}async function p(b,P,R,D,T=process.env,j,F){if(P===null)return;let W,C,z;if("source"in P&&!("path"in P)){const K=y?.get(P.source);if(!K)return;W=K.paths,C=P.args||K.args,P.icon?z=v(P.icon):K.icon&&(z=K.icon)}else W=Array.isArray(P.path)?P.path:[P.path],C=A.$i||Array.isArray(P.args)?P.args:void 0,z=v(P.icon);let se;if(F){const K=W.map(q=>typeof q=="string"?q:q.path),te=await F(K);se=new Array(W.length);for(let q=0;q<W.length;q++)typeof W[q]=="string"?se[q]=te[q]:se[q]={path:te[q],isUnsafe:!0}}else se=W.slice();let ie;if(P.requiresPath){let K;if((0,O.$ag)(P.requiresPath)?K=P.requiresPath:(K=P.requiresPath.path,P.requiresPath.isUnsafe&&(ie=K)),!await D.existsFile(K))return}const oe=await u(b,R,se,D,T,C,P.env,P.overrideName,P.isAutoDetected,ie);if(!oe){j?.debug("Terminal profile not validated",b,W);return}return oe.isAutoDetected=P.isAutoDetected,oe.icon=z,oe.color=P.color,oe}function v(b){return typeof b=="string"?{id:b}:b}async function S(b){if(y&&!b)return;const[P,R]=await Promise.all([o(),b||t()]);y=new Map,y.set(c.ProfileSource.GitBash,{profileName:"Git Bash",paths:P,args:["--login","-i"]}),y.set(c.ProfileSource.Pwsh,{profileName:"PowerShell",paths:R,icon:r.$Zj.terminalPowershell})}async function o(){const b=new Set,P=await(0,f.$Bs)("git.exe");if(P){const T=(0,d.dirname)(P);b.add((0,d.resolve)(T,"../.."))}function R(T,j){j&&T.add(j)}R(b,process.env.ProgramW6432),R(b,process.env.ProgramFiles),R(b,process.env["ProgramFiles(X86)"]),R(b,`${process.env.LocalAppData}\\Program`);const D=[];for(const T of b)D.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function t(){const b=[];for await(const P of(0,E.$pm)())b.push(P.exePath);return b}async function s(b,P){const R=[],D=await new Promise((F,W)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,z)=>{if(C)return W("Problem occurred when getting wsl distros");F(z)})});if(!D)return[];const T=new RegExp(/[\r?\n]/),j=D.split(T).filter(F=>F.trim().length>0&&F!=="");for(const F of j){if(F===""||F.startsWith("docker-desktop"))continue;const W=`${F} (WSL)`,C={profileName:W,path:b,args:["-d",`${F}`],isDefault:W===P,icon:a(F),isAutoDetected:!1};R.push(C)}return R}function a(b){return b.includes("Ubuntu")?r.$Zj.terminalUbuntu:b.includes("Debian")?r.$Zj.terminalDebian:r.$Zj.terminalLinux}async function n(b,P,R,D,T,j,F,W){const C=new Map;if(R&&await b.existsFile($.UnixShellsPath)){const z=(await b.readFile($.UnixShellsPath)).toString(),se=(j||z.split(`
`)).map(oe=>{const K=oe.indexOf("#");return K===-1?oe:oe.substring(0,K)}).filter(oe=>oe.trim().length>0),ie=new Map;for(const oe of se){let K=(0,k.$nc)(oe),te=ie.get(K)||0;te++,te>1&&(K=`${K} (${te})`),ie.set(K,te),C.set(K,{path:oe,isAutoDetected:!0})}}return l(D,C),await w(C.entries(),T,b,W,P,F)}function l(b,P){if(b)for(const[R,D]of Object.entries(b))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?P.delete(R):(D.icon=D.icon||P.get(R)?.icon,P.set(R,D))}async function u(b,P,R,D,T,j,F,W,C,z){if(R.length===0)return Promise.resolve(void 0);const se=R.shift();if(se==="")return u(b,P,R,D,T,j,F,W,C);const ie=typeof se!="string"&&se.isUnsafe,oe=typeof se=="string"?se:se.path,K={profileName:b,path:oe,args:j,env:F,overrideName:W,isAutoDetected:C,isDefault:b===P,isUnsafePath:ie,requiresUnsafePath:z};if((0,k.$nc)(oe)===oe){const q=T.PATH?T.PATH.split(k.$tc):void 0,L=await(0,f.$Bs)(oe,void 0,q,void 0,D.existsFile);return L?(K.path=L,K.isFromPath=!0,K):u(b,P,R,D,T,j)}return await D.existsFile((0,k.$hc)(oe))?K:u(b,P,R,D,T,j,F,W,C)}}),define(ce[267],le([0,1,3,2,4,45,18,5,231,101,262,72,264,266,117,77]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;var m;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let w=class extends r.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(v,S,o,t){super(),this.M=v,this.N=S,this.O=o,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$he),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$he),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$he),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$he),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$he),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$he),this.onProcessData=this.D.event,this.F=this.B(new i.$he),this.onProcessReady=this.F.event,this.G=this.B(new i.$he),this.onProcessReplay=this.G.event,this.H=this.B(new i.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$he),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$he),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$he),this.onProcessExit=this.L.event,(0,$.$rs)(),this.B(this.M),this.B((0,r.$Sc)(()=>this.W())),this.j=this.B(new f.$ks(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&i.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue(d.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$i)return process.env;try{return await(0,c.$Lm)(this.N,this.O,{_:[]},process.env)}catch(v){return this.O.error("ptyHost was unable to resolve shell environment",v),{}}}U(){const v=this.M.start(),S=v.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(S.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(v.onDidProcessExit(s=>{this.u.fire(s.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=A.ProxyChannel.toService(S.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(s=>this.D.fire(s))),this.B(t.onProcessReady(s=>this.F.fire(s))),this.B(t.onProcessExit(s=>this.L.fire(s))),this.B(t.onDidChangeProperty(s=>this.J.fire(s))),this.B(t.onProcessReplay(s=>this.G.fire(s))),this.B(t.onProcessOrphanQuestion(s=>this.H.fire(s))),this.B(t.onDidRequestDetach(s=>this.I.fire(s))),this.B(new E.$js(this.P,S.getChannel(d.TerminalIpcChannels.Logger))),this.a=v,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async s=>{s.affectsConfiguration(d.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[v,t]}async createProcess(v,S,o,t,s,a,n,l,u,b,P){const R=setTimeout(()=>this.$(),d.HeartbeatConstants.CreateProcessTimeout),D=await this.f.createProcess(v,S,o,t,s,a,n,l,u,b,P);return clearTimeout(R),D}updateTitle(v,S,o){return this.f.updateTitle(v,S,o)}updateIcon(v,S,o,t){return this.f.updateIcon(v,S,o,t)}attachToProcess(v){return this.f.attachToProcess(v)}detachFromProcess(v,S){return this.f.detachFromProcess(v,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(v){return this.f.start(v)}shutdown(v,S){return this.f.shutdown(v,S)}input(v,S){return this.f.input(v,S)}processBinary(v,S){return this.f.processBinary(v,S)}resize(v,S,o){return this.f.resize(v,S,o)}clearBuffer(v){return this.f.clearBuffer(v)}acknowledgeDataEvent(v,S){return this.f.acknowledgeDataEvent(v,S)}setUnicodeVersion(v,S){return this.f.setUnicodeVersion(v,S)}getInitialCwd(v){return this.f.getInitialCwd(v)}getCwd(v){return this.f.getCwd(v)}async getLatency(){const v=new g.$be,S=await this.f.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...S]}orphanQuestionReply(v){return this.f.orphanQuestionReply(v)}installAutoReply(v,S){return this.f.installAutoReply(v,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(v){return this.f.uninstallAutoReply(v)}getDefaultSystemShell(v){return this.g?.getDefaultSystemShell(v)??(0,h.$vm)(v??k.OS,process.env)}async getProfiles(v,S,o,t=!1){const s=await this.S();return(0,y.$Ds)(S,o,t,this.N,s,void 0,this.O,this.bb.bind(this,v))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(v,S){return this.f.getWslPath(v,S)}getRevivedPtyNewId(v,S){return this.f.getRevivedPtyNewId(v,S)}setTerminalLayoutInfo(v){return this.f.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this.g?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,S){return this.f.requestDetachInstance(v,S)}async acceptDetachInstanceReply(v,S){return this.f.acceptDetachInstanceReply(v,S)}async freePortKillProcess(v){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(v)}async serializeTerminalState(v){return this.f.serializeTerminalState(v)}async reviveTerminalProcesses(v,S,o){return this.f.reviveTerminalProcesses(v,S,o)}async refreshProperty(v,S){return this.f.refreshProperty(v,S)}async updateProperty(v,S,o){return this.f.updateProperty(v,S,o)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(v){this.ab(),this.s=setTimeout(()=>this.Y(),v?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(v,S){return this.j.createRequest({workspaceId:v,originalText:S})}async acceptPtyHostResolvedVariables(v,S){this.j.acceptReply(v,S)}};e.$Es=w,e.$Es=w=Se([re(1,O.$7i),re(2,I.$7j),re(3,I.$8j)],w)}),define(ce[73],le([0,1,14,3,2,4,18,6,34]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;const c="#FFFFFF",f="#1E1E1E",d="#000000",$="#FFFFFF",y="theme",h="themeBackground",g="windowSplash";var m;(function(p){p.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",p.SYSTEM_COLOR_THEME="window.systemColorTheme"})(m||(m={})),e.$_cc=(0,I.$Ai)("themeMainService");let w=class extends k.$Uc{constructor(v,S){super(),this.b=v,this.c=S,this.a=this.B(new r.$he),this.onDidChangeColorScheme=this.a.event,A.$k||this.B(this.c.onDidChangeConfiguration(o=>{(o.affectsConfiguration(m.SYSTEM_COLOR_THEME)||o.affectsConfiguration(m.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(A.$k||this.c.getValue(m.DETECT_COLOR_SCHEME))i.nativeTheme.themeSource="system";else switch(this.c.getValue(m.SYSTEM_COLOR_THEME)){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?d:$;let S=this.b.getItem(h,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=d;break;case"hc-light":S=$;break;default:S=f}return A.$j&&S.toUpperCase()===f&&(S="#171717"),S}g(){switch(this.b.getItem(y,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(v,S){this.b.setItems([{key:y,data:S.baseTheme},{key:h,data:S.colorInfo.background},{key:g,data:S}]),typeof v=="number"&&this.h(v,S),this.f()}h(v,S){for(const o of i.BrowserWindow.getAllWindows())if(o.id===v){o.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};e.$adc=w,e.$adc=w=Se([re(0,E.$dQ),re(1,O.$7i)],w)}),define(ce[132],le([0,1,3,4,7,18,6,5]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$yw=e.$ww=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$sw=e.$rw=void 0,e.$tw=f,e.$uw=$,e.$vw=y,e.$xw=h,e.$zw=g,e.$Aw=m,e.$rw=(0,O.$Ai)("tunnelService"),e.$sw=(0,O.$Ai)("sharedTunnelsService");var E;(function(v){v.Http="http",v.Https="https"})(E||(e.TunnelProtocol=E={}));var c;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(c||(e.TunnelPrivacyId=c={}));function f(v){return!!v.forwardPort}var d;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function $(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(S)return{address:S[1],port:+S[2]}}function y(v){if(v.scheme!=="http"&&v.scheme!=="https"||!v.query)return;const S=v.query.split("&");for(const o of S){const t=o.split("=")[1];if(/^https?:/.exec(t)){const s=$(k.URI.parse(t));if(s)return s}}}e.$ww=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(v){return e.$ww.indexOf(v)>=0}e.$yw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(v){return e.$yw.indexOf(v)>=0}function m(v,S,o,t){if(o===r.OperatingSystem.Windows)return!1;if(o===r.OperatingSystem.Macintosh&&g(S)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(s?.length===4&&parseInt(s[1])>=18)return!1}return v<1024}class w{constructor(S,o,t){this.remoteAddress=S,this.localAddress=o,this.b=t,this.a=new i.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Bw=w;let p=class{constructor(S,o){this.k=S,this.l=o,this.a=new i.$he,this.onTunnelOpened=this.a.event,this.b=new i.$he,this.onTunnelClosed=this.b.event,this.c=new i.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const S=this.l.getValue("remote.localPortHost");return!S||S==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(S){return this.f=S,S?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(S){this.g=S.elevation,this.i=S.privacyOptions,this.h=S.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const S=[],o=Array.from(this.e.values());for(const t of o){const s=Array.from(t.values());for(const a of s){const n=await a.value;n&&typeof n!="string"&&S.push(n)}}return S}async dispose(){for(const S of this.e.values()){for(const{value:o}of S.values())await o.then(t=>typeof t!="string"?t?.dispose():void 0);S.clear()}this.e.clear()}setEnvironmentTunnel(S,o,t,s,a){this.q(S,o,Promise.resolve({tunnelRemoteHost:S,tunnelRemotePort:o,localAddress:t,privacy:s,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(S,o){(g(S)||h(S))&&(S=e.$ww[0]);const t=this.s(S,o);if(t)return++t.refcount,t.value}openTunnel(S,o,t,s,a,n=!1,l,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${t} on local port ${a}.`);const b=this.f??S;if(!b)return;if(o||(o="localhost"),s||(s=this.m),this.f&&this.j.has(t)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.t(b,o,t,s,a,n,l,u);return P?P.then(R=>{if(R){if(typeof R=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(o,t),R}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(o,t);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(R);return(R.tunnelRemoteHost!==o||R.tunnelRemotePort!==t)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&R.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}o(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const o=this.e.get(S.tunnelRemoteHost);if(o){const t=o.get(S.tunnelRemotePort);t&&(t.refcount--,await this.p(S.tunnelRemoteHost,S.tunnelRemotePort,t))}}}}async p(S,o,t){if(t.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${o}.`);const s=t.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(S)&&this.e.get(S).delete(o),s}}async closeTunnel(S,o){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${o} `);const t=this.e.get(S);if(t&&t.has(o)){const s=t.get(o);s.refcount=0,await this.p(S,o,s)}}q(S,o,t){this.e.has(S)||this.e.set(S,new Map),this.e.get(S).set(o,{refcount:1,value:t})}async r(S,o){const t=this.e.get(S);if(t){const s=t.get(o),a=s?await s.value:void 0;(!a||typeof a=="string")&&t.delete(o),t.size===0&&this.e.delete(S)}}s(S,o){const t=[S];h(S)?(t.push(...e.$ww),t.push(...e.$yw)):g(S)&&t.push(...e.$yw);const s=t.map(a=>this.e.get(a));for(const a of s){const n=a?.get(o);if(n)return n}}canTunnel(S){return!!$(S)}u(S,o,t,s,a,n,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${t} on local port ${s}.`);const u=t;this.j.add(u);const b=s===void 0?t:s,P={elevationRequired:a?this.isPortPrivileged(b):!1},R={remoteAddress:{host:o,port:t},localAddressPort:s,privacy:n,public:n?n!==c.Private:void 0,protocol:l},D=S.forwardPort(R,P);return D?(this.q(o,t,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),D}};e.$Cw=p,e.$Cw=p=Se([re(0,I.$7j),re(1,A.$7i)],p)}),define(ce[51],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rX=e.$qX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(r||(e.StateType=r={}));var k;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var A;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.$qX={Uninitialized:{type:r.Uninitialized},Disabled:O=>({type:r.Disabled,reason:O}),Idle:(O,I)=>({type:r.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:r.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:r.AvailableForDownload,update:O}),Downloading:{type:r.Downloading},Downloaded:O=>({type:r.Downloaded,update:O}),Updating:O=>({type:r.Updating,update:O}),Ready:O=>({type:r.Ready,update:O})},e.$rX=(0,i.$Ai)("updateService")}),define(ce[268],le([0,1,4,194,54,46]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.$jo.as(k.$oo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2,null),(0,r.localize)(3,null),(0,r.localize)(4,null),(0,r.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(6,null),deprecationMessage:(0,r.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,title:(0,r.localize)(8,null),description:(0,r.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ce[269],le([0,1,3,51]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=void 0;class k{constructor(I){this.a=I}listen(I,E){switch(E){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${E}`)}call(I,E,c){switch(E){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${E}`)}}e.$lec=k;class A{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new i.$he,this.onStateChange=this.a.event,this.b=r.$qX.Uninitialized,this.c.listen("onStateChange")(E=>this.state=E),this.c.call("_getInitialState").then(E=>this.state=E)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$mec=A}),define(ce[42],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,i.$Ai)("IUriIdentityService")}),define(ce[270],le([0,1,42,211,15,19,144,3,2]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class c{static{this._clock=0}constructor($){this.uri=$,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let f=class{constructor($){this.g=$,this.c=new E.$Tc,this.f=2**16;const y=new Map,h=g=>{let m=y.get(g.scheme);return m===void 0&&(m=$.hasProvider(g)&&!this.g.hasCapability(g,k.FileSystemProviderCapabilities.PathCaseSensitive),y.set(g.scheme,m)),m};this.c.add(I.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new A.$3g(h),this.d=new O.$Hs((g,m)=>this.extUri.compare(g,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$ch)($));const y=this.d.get($);return y?y.touch().uri.with({fragment:$.fragment}):(this.d.set($,new c($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((h,g)=>h[1].time<g[1].time?1:h[1].time>g[1].time?-1:0);c._clock=0,this.d.clear();const y=this.f*.5;for(let h=0;h<y;h++)this.d.set($[h][0],$[h][1].touch())}};e.$Is=f,e.$Is=f=Se([re(0,k.$7k)],f),(0,r.$Fs)(i.$El,f,r.InstantiationType.Delayed)}),define(ce[133],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hX=void 0,e.$hX=(0,i.$Ai)("urlService")}),define(ce[271],le([0,1,7]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=e.$tec=void 0;class r{constructor(I){this.a=I}listen(I,E){throw new Error(`Event not found: ${E}`)}call(I,E,c){switch(E){case"handleURL":return this.a.handleURL(i.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${E}`)}}e.$tec=r;class k{constructor(I){this.a=I}handleURL(I,E){return this.a.call("handleURL",[I.toJSON(),E])}}e.$uec=k;class A{constructor(I,E){this.a=I,this.b=E}async routeCall(I,E,c,f){if(E!=="handleURL")throw new Error(`Call not found: ${E}`);if(Array.isArray(c)&&c.length>0){const d=i.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const $=/\bwindowId=(\d+)/.exec(d.query);if($){const y=$[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${y}"`,d.toString(!0));const h=new RegExp(`window:${y}`),g=I.connections.find(m=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",m.ctx),h.test(m.ctx)));if(g)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),g;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,E,c,f)}routeEvent(I,E){throw new Error(`Event not found: ${E}`)}}e.$vec=A}),define(ce[272],le([0,1,8,2,7,28]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jX=e.$iX=void 0;class O extends r.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,f){const d=[...this.a.values()];return(0,i.$Eh)(d.map($=>()=>$.handleURL(c,f)),void 0,!1).then($=>$||!1)}registerHandler(c){return this.a.add(c),(0,r.$Sc)(()=>this.a.delete(c))}}e.$iX=O;let I=class extends O{constructor(c){super(),this.b=c}create(c){let{authority:f,path:d,query:$,fragment:y}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return f&&d&&d.indexOf("/")!==0&&(d=`/${d}`),k.URI.from({scheme:this.b.urlProtocol,authority:f,path:d,query:$,fragment:y})}};e.$jX=I,e.$jX=I=Se([re(0,A.$nk)],I)}),define(ce[273],le([0,1,14,8,3,2,4,7]),function(X,e,i,r,k,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class E extends A.$Uc{constructor(f,d,$,y,h,g){if(super(),this.c=d,this.f=g,this.a=[],this.b=0,f&&(g.trace("ElectronURLListener initialUrisToHandle:",f.map(p=>p.originalUrl)),this.a=f),O.$i){const p=y.isBuilt?[]:[`"${y.appRoot}"`];p.push("--open-url","--"),i.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,p)}const m=k.Event.map(k.Event.fromNodeEventEmitter(i.app,"open-url",(p,v)=>({event:p,url:v})),({event:p,url:v})=>(p.preventDefault(),v));this.B(m(p=>{const v=this.g(p);v&&this.c.open(v,{originalUrl:p})})),$.getWindows().filter(p=>p.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once($.onDidSignalReadyWindow)(()=>this.h())))}g(f){try{return I.URI.parse(f)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const f=[];for(const d of this.a)await this.c.open(d.uri,{originalUrl:d.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),f.push(d));f.length!==0&&(this.a=f,(0,r.$Ch)(()=>this.h(),500,this.q))}}e.$wec=E}),define(ce[274],le([0,1,3,2,15,61,32]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class I extends r.$Uc{constructor(c,f,d,$,y,h){super(),this.f=c,this.g=f,this.h=d,this.j=$,this.m=y,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$he),this.onDidChangeFile=this.a.event,this.b=A.$Gi.forUris(()=>!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Bc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,f){return this.g.open(this.t(c),f)}close(c){return this.g.close(c)}read(c,f,d,$,y){return this.g.read(c,f,d,$,y)}write(c,f,d,$,y){return this.g.write(c,f,d,$,y)}watch(c,f){this.b.set(c,c);const d=this.g.watch(this.t(c),f);return(0,r.$Sc)(()=>{this.b.delete(c),d.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,f,d){return this.g.rename(this.t(c),this.t(f),d)}readFile(c,f){return this.g.readFile(this.t(c),f)}readFileStream(c,f,d){return this.g.readFileStream(this.t(c),f,d)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,f,d){return this.g.writeFile(this.t(c),f,d)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,f){return this.g.delete(this.t(c),f)}copy(c,f,d){if((0,k.$$k)(this.g))return this.g.copy(this.t(c),this.t(f),d);throw new Error("copy not supported")}cloneFile(c,f){if((0,k.$_k)(this.g))return this.g.cloneFile(this.t(c),this.t(f));throw new Error("clone not supported")}s(c){const f=[];for(const d of c){if(d.resource.scheme!==this.f)continue;const $=this.u(d.resource);this.b.findSubstr($)&&f.push({resource:$,type:d.type,cId:d.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$_ec=I}),define(ce[275],le([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0,e.$Sec="utilityProcessWorker"}),define(ce[276],le([0,1,6]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0,e.$xec=(0,i.$Ai)("webviewManagerService")}),define(ce[277],le([0,1,14,2,13,7]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class O extends r.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const E=this.b.bind(this);i.protocol.registerFileProtocol(k.Schemas.vscodeWebview,E)}b(E,c){try{const f=A.URI.parse(E.url),d=O.a.get(f.path);if(typeof d=="string"){const $=`vs/workbench/contrib/webview/browser/pre/${d}`,y=k.$Ug.asFileUri($);return c({path:y.fsPath,headers:{...k.COI.getHeadersFromQuery(E.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$yec=O}),define(ce[57],le([0,1,4]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UD=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$LD=void 0,e.$MD=r,e.$ND=k,e.$OD=A,e.$PD=O,e.$QD=I,e.$RD=d,e.$SD=$,e.$TD=y,e.$VD=h,e.$WD=g,e.$XD=m,e.$LD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(w){return typeof w.parentId=="number"}function k(w){return!!w.workspaceUri}function A(w){return!!w.folderUri}function O(w){return!!w.fileUri}function I(w){const p=$(w),v=w.getValue("window.menuBarVisibility");return v==="default"||p&&v==="compact"||i.$j&&i.$m?"classic":v}var E;(function(w){w.TITLE_BAR_STYLE="window.titleBarStyle",w.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(E||(e.TitleBarSetting=E={}));var c;(function(w){w.NATIVE="native",w.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var f;(function(w){w.AUTO="auto",w.WINDOWED="windowed",w.NEVER="never"})(f||(e.CustomTitleBarVisibility=f={}));function d(w,p){return!0}function $(w,p){return p||(p=y(w)),p===c.NATIVE}function y(w){if(i.$o)return c.CUSTOM;const p=w.getValue("window");if(p){if(i.$j&&p.nativeTabs===!0||i.$j&&p.nativeFullScreen===!1)return c.NATIVE;const o=p.titleBarStyle;if(o===c.NATIVE||o===c.CUSTOM)return o}return i.$k?c.NATIVE:c.CUSTOM}e.$UD=35;function h(w){return!(!i.$i||i.$o||$(w))}function g(w){const p=w.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}function m(w=0){return Math.pow(1.2,w)}}),define(ce[52],le([0,1,14]),function(X,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$2cc=e.$1cc=e.UnloadReason=e.LoadReason=void 0;var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var k;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const A=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$1cc=A;const O=function(){const d=i.screen.getPrimaryDisplay().workArea,$=Math.max(d.x+d.width/2-800/2,0),y=Math.max(d.y+d.height/2-600/2,0);return{x:$,y,width:800,height:600,mode:I.Normal}};e.$2cc=O;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var E;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(E||(e.WindowError=E={}))}),define(ce[278],le([0,1,8,3,2]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class A extends k.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:E,getActiveWindowId:c}){super(),this.a=this.B(new k.$Tc),r.Event.latch(r.Event.any(I,E))(this.f,this,this.a),this.b=(0,i.$nh)(()=>c()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Eec=A}),define(ce[30],le([0,1,198,9,61,19,7,6,13]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=c,e.$Li=f,e.$Oi=d,e.$Pi=$,e.$Qi=y,e.$Ri=g,e.$Si=m,e.$Vi=v,e.$1i=S,e.$2i=o,e.$4i=t,e.$5i=s,e.$6i=a,e.$Ji=(0,I.$Ai)("contextService");function c(n){const l=n;return typeof l?.id=="string"&&O.URI.isUri(l.uri)}function f(n){return typeof n?.id=="string"&&!c(n)&&!$(n)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function d(n,l){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,r.$nc)(n)}:l?e.$Mi:e.$Ni;const u=n;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function $(n){const l=n;return typeof l?.id=="string"&&O.URI.isUri(l.configPath)}function y(n){const l=n;if(l?.uri)return{id:l.id,uri:O.URI.revive(l.uri)};const u=n;if(u?.configPath)return{id:u.id,configPath:O.URI.revive(u.configPath)};if(n?.id)return{id:n.id}}var h;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function g(n){const l=n;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function m(n){const l=n;return!!(l&&typeof l=="object"&&O.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class w{constructor(l,u,b,P,R){this.h=l,this.j=b,this.k=P,this.l=R,this.c=k.$Gi.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=k.$Gi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=w;class p{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.$bh)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=p;function v(n){return new p({uri:n,index:0,name:(0,A.$0g)(n)},{uri:n.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,i.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function S(n,l){return A.$5g.isEqualOrParent(n,l.untitledWorkspacesHome)}function o(n){let l;return O.URI.isUri(n)?l=n:l=n.configuration,l?.scheme===E.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$3i}function s(n,l){return!S(n,l)&&!o(n)}function a(n){return(typeof n=="string"?(0,r.$oc)(n):(0,A.$_g)(n))===e.$Xi}}),define(ce[58],le([0,1,14,8,47,49,2,76,4,21,172,124,6,5,28,30]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=void 0,e.$9cc=(0,$.$Ai)("dialogMainService");let m=class{constructor(p,v){this.d=p,this.e=v,this.a=new Map,this.b=new Map,this.c=new r.$Hh}pickFileFolder(p,v){return this.f({...p,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},v)}pickFolder(p,v){return this.f({...p,pickFolders:!0,title:(0,f.localize)(1,null)},v)}pickFile(p,v){return this.f({...p,pickFiles:!0,title:(0,f.localize)(2,null)},v)}pickWorkspace(p,v){const S=(0,f.localize)(3,null),o=(0,A.$Tw)((0,f.localize)(4,null)),t=g.$Yi;return this.f({...p,pickFiles:!0,title:S,filters:t,buttonLabel:o},v)}async f(p,v){const S={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(S.properties=void 0,p.pickFiles&&p.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),E.$j&&S.properties.push("treatPackageAsDirectory");const o=await this.showOpenDialog(S,(v||i.BrowserWindow.getFocusedWindow())??void 0);if(o&&o.filePaths&&o.filePaths.length>0)return o.filePaths}g(p){if(p){let v=this.b.get(p.id);return v||(v=new r.$Hh,this.b.set(p.id,v)),v}else return this.c}showMessageBox(p,v){return this.g(v).queue(async()=>{const{options:S,buttonIndeces:o}=(0,d.$1w)(p,this.e);let t;return v?t=await i.dialog.showMessageBox(v,S):t=await i.dialog.showMessageBox(S),{response:o[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(p,v){const S=this.j(p,v);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(v).queue(async()=>{let o;return v?o=await i.dialog.showSaveDialog(v,p):o=await i.dialog.showSaveDialog(p),o.filePath=this.h(o.filePath),o})}finally{(0,O.$Pc)(S)}}h(p){return p&&E.$j&&(p=(0,I.$gm)(p)),p}i(p){return p.map(v=>this.h(v))}async showOpenDialog(p,v){p.defaultPath&&(await c.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const S=this.j(p,v);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(v).queue(async()=>{let o;return v?o=await i.dialog.showOpenDialog(v,p):o=await i.dialog.showOpenDialog(p),o.filePaths=this.i(o.filePaths),o})}finally{(0,O.$Pc)(S)}}j(p,v){if(!v)return O.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",p);let S=this.a.get(v.id);S||(S=new Set,this.a.set(v.id,S));const o=(0,k.$oj)(p);if(!S.has(o))return this.d.trace("[DialogMainService]: new file dialog lock created",p),S.add(o),(0,O.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",p),S?.delete(o),S?.size===0&&this.a.delete(v.id)})}};e.$0cc=m,e.$0cc=m=Se([re(0,y.$7j),re(1,h.$nk)],m)}),define(ce[279],le([0,1,3,2,81,30]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class O extends r.$Uc{static{this.a=100}constructor(E,c){super(),this.f=E,this.g=c,this.b=this.B(new i.$he),this.c=new Map,this.h(c.applicationStorage,this.b)}h(E,c){this.B(i.Event.debounce(E.onDidChangeStorage,(f,d)=>(f?f.push(d):f=[d],f),O.a)(f=>{f.length&&c.fire(this.j(f,E))}))}j(E,c){const f=new Map,d=new Set;return E.forEach($=>{const y=c.get($.key);typeof y=="string"?f.set($.key,y):d.add($.key)}),{changed:Array.from(f.entries()),deleted:Array.from(d.values())}}listen(E,c,f){switch(c){case"onDidChangeStorage":{const d=f.profile?(0,k.$0h)(f.profile):void 0;if(!d)return this.b.event;let $=this.c.get(d.id);return $||($=this.B(new i.$he),this.h(this.g.profileStorage(d),$),this.c.set(d.id,$)),$.event}}throw new Error(`Event not found: ${c}`)}async call(E,c,f){const d=f.profile?(0,k.$0h)(f.profile):void 0,$=(0,A.$Qi)(f.workspace),y=await this.m(d,$);switch(c){case"getItems":return Array.from(y.items.entries());case"updateItems":{const h=f;if(h.insert)for(const[g,m]of h.insert)y.set(g,m);h.delete?.forEach(g=>y.delete(g));break}case"optimize":return y.optimize();case"isUsed":{const h=f.payload;if(typeof h=="string")return this.g.isUsed(h)}default:throw new Error(`Call not found: ${c}`)}}async m(E,c){let f;c?f=this.g.workspaceStorage(c):E?f=this.g.profileStorage(E):f=this.g.applicationStorage;try{await f.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":E?"profile":"application"} storage due to ${d}`)}return f}}e.$iec=O}),define(ce[43],le([0,1,47,3,2,19,7,195,38,15,6,5,30,32,42,8,33,26,12]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=S,e.$Hl=o,e.$Il=t;var v;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function S(n){const l=n;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&O.URI.isUri(l.location)&&O.URI.isUri(l.globalStorageHome)&&O.URI.isUri(l.settingsResource)&&O.URI.isUri(l.keybindingsResource)&&O.URI.isUri(l.tasksResource)&&O.URI.isUri(l.snippetsHome)&&O.URI.isUri(l.extensionsResource))}e.$Gl=(0,f.$Ai)("IUserDataProfilesService");function o(n,l){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:l}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:l}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:l}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:l}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:l}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:l}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:l}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:l}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,l,u,b,P,R){return{id:n,name:l,location:u,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:R&&P?.useDefaultFlags?.globalState?R.globalStorageHome:(0,A.$bh)(u,"globalStorage"),settingsResource:R&&P?.useDefaultFlags?.settings?R.settingsResource:(0,A.$bh)(u,"settings.json"),keybindingsResource:R&&P?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,A.$bh)(u,"keybindings.json"),tasksResource:R&&P?.useDefaultFlags?.tasks?R.tasksResource:(0,A.$bh)(u,"tasks.json"),snippetsHome:R&&P?.useDefaultFlags?.snippets?R.snippetsHome:(0,A.$bh)(u,"snippets"),extensionsResource:R&&P?.useDefaultFlags?.extensions?R.extensionsResource:(0,A.$bh)(u,"extensions.json"),cacheHome:(0,A.$bh)(b,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let s=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,u,b,P){super(),this.t=l,this.u=u,this.w=b,this.y=P,this.f=!0,this.h=this.B(new r.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),u=[l];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,p.$ag)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}u.push(t((0,A.$$g)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},l))}}catch(R){this.y.error(R)}const b=new y.$Ac,P=new Map;if(u.length)try{const R=this.Q();if(R.workspaces)for(const[D,T]of Object.entries(R.workspaces)){const j=O.URI.parse(D),F=u.find(W=>W.id===T);F&&b.set(j,F)}if(R.emptyWindows)for(const[D,T]of Object.entries(R.emptyWindows)){const j=u.find(F=>F.id===T);j&&P.set(D,j)}}catch(R){this.y.error(R)}this.z={profiles:u,workspaces:b,emptyWindows:P}}return this.z}D(){const l=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",b=new RegExp(`${(0,w.$df)(u)}\\s(\\d+)`);let P=0;for(const D of this.profiles){const T=b.exec(D.name),j=T?parseInt(T[1]):0;P=j>P?j:P}const R=`${u} ${P+1}`;return this.createProfile((0,i.$oj)((0,m.$Wg)()).toString(16),R,{transient:!0},l)}async createNamedProfile(l,u,b){return this.createProfile((0,i.$oj)((0,m.$Wg)()).toString(16),l,u,b)}async createProfile(l,u,b,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(l,u,b);return P&&await this.setProfileForWorkspace(P,R),R}async F(l,u,b){if(!(0,p.$ag)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(u);return P||(P=(async()=>{try{if(this.profiles.find(j=>j.name===u||j.id===l))throw new Error(`Profile with ${u} name already exists`);const D=t(l,u,(0,A.$bh)(this.profilesHome,l),this.g,b,this.defaultProfile);await this.u.createFolder(D.location);const T=[];return this.j.fire({profile:D,join(j){T.push(j)}}),await g.Promises.settled(T),this.I([D],[],[]),D}finally{this.r.delete(u)}})(),this.r.set(u,P)),P}async updateProfile(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(P=>P.id===l.id);if(!b)throw new Error(`Profile '${l.name}' does not exist`);return b=t(b.id,u.name??b.name,b.location,this.g,{shortName:u.shortName??b.shortName,icon:u.icon===null?void 0:u.icon??b.icon,transient:u.transient??b.isTransient,useDefaultFlags:u.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(P=>P.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const b=[];this.m.fire({profile:u,join(P){b.push(P)}});try{await Promise.allSettled(b)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(P){(0,c.$ll)(P)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(P)}}async setProfileForWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(P=>P.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);this.L(l,b)}unsetWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.G(l);return O.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(l){return(0,$.$Ki)(l)?l.uri:(0,$.$Pi)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location)))}I(l,u,b){const P=[...this.profiles,...l],R=[];this.s.profiles=[];for(let D of P)D.isDefault||u.some(T=>D.id===T.id)||(D=b.find(T=>D.id===T.id)??D,D.isTransient?this.s.profiles.push(D):R.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(R),this.z=void 0,this.J(l,u,b)}J(l,u,b){this.h.fire({added:l,removed:u,updated:b,all:this.profiles})}L(l,u,b){b=u?.isTransient?!0:b,b||this.L(l,void 0,!0);const P=this.G(l),R=b?this.s:this.C;O.URI.isUri(P)?(R.workspaces.delete(P),u&&R.workspaces.set(P,u)):(R.emptyWindows.delete(P),u&&R.emptyWindows.set(P,u)),b||this.M()}M(){const l={};for(const[b,P]of this.C.workspaces.entries())l[b.toString()]=P.id;const u={};for(const[b,P]of this.C.emptyWindows.entries())u[b.toString()]=P.id;this.R({workspaces:l,emptyWindows:u}),this.z=void 0}N(l){const u={},b=this.D();if(l.workspaces)for(const[R,D]of Object.entries(l.workspaces)){const T=O.URI.parse(D);u[R]=this.w.extUri.isEqual(T,b.location)?b.id:this.w.extUri.basename(T)}const P={};if(l.emptyWindows)for(const[R,D]of Object.entries(l.emptyWindows)){const T=O.URI.parse(D);P[R]=this.w.extUri.isEqual(T,b.location)?b.id:this.w.extUri.basename(T)}return{workspaces:u,emptyWindows:P}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Jl=s,e.$Jl=s=Se([re(0,E.$Hi),re(1,c.$7k),re(2,h.$El),re(3,d.$7j)],s);class a extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Kl=a}),define(ce[86],le([0,1,8,17,2,3,32,7,127,130,15,6,5,43,42,12,16,24]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class v extends Error{constructor(a,n){super(a),this.code=n}}e.$wq=v,e.$xq=(0,d.$Ai)("IExtensionsProfileScannerService");let S=class extends k.$Uc{constructor(a,n,l,u,b,P){super(),this.j=a,this.m=n,this.n=l,this.r=u,this.s=b,this.t=P,this.b=this.B(new A.$he),this.onAddExtensions=this.b.event,this.c=this.B(new A.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$he),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(a,n){return this.u(a,void 0,n)}async addExtensionsToProfile(a,n,l){const u=[],b=[];try{return await this.u(n,P=>{const R=[];if(l)R.push(...P);else for(const D of P)a.some(([T])=>(0,c.$Cp)(T.identifier,D.identifier)&&T.manifest.version!==D.version)?u.push(D):R.push(D);for(const[D,T]of a){const j=R.findIndex(W=>(0,c.$Cp)(W.identifier,D.identifier)&&W.version===D.manifest.version),F={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:T};j===-1?(b.push(F),R.push(F)):R.splice(j,1,F)}return b.length&&this.b.fire({extensions:b,profileLocation:n}),u.length&&this.f.fire({extensions:u,profileLocation:n}),R}),b.length&&this.c.fire({extensions:b,profileLocation:n}),u.length&&this.g.fire({extensions:u,profileLocation:n}),b}catch(P){throw b.length&&this.c.fire({extensions:b,error:P,profileLocation:n}),u.length&&this.g.fire({extensions:u,error:P,profileLocation:n}),P}}async updateMetadata(a,n){const l=[];return await this.u(n,u=>{const b=[];for(const P of u){const R=a.find(([D])=>(0,c.$Cp)(D.identifier,P.identifier)&&D.manifest.version===P.version);R&&(P.metadata={...P.metadata,...R[1]},l.push(P)),b.push(P)}return b}),l}async removeExtensionFromProfile(a,n){const l=[];try{await this.u(n,u=>{const b=[];for(const P of u)(0,c.$Cp)(P.identifier,a.identifier)?l.push(P):b.push(P);return l.length&&this.f.fire({extensions:l,profileLocation:n}),b}),l.length&&this.g.fire({extensions:l,profileLocation:n})}catch(u){throw l.length&&this.g.fire({extensions:l,error:u,profileLocation:n}),u}}async u(a,n,l){return this.F(a).queue(async()=>{let u=[],b;try{const P=await this.m.readFile(a);b=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,f.$ll)(P)!==f.FileOperationResult.FILE_NOT_FOUND)throw P;if(this.r.extUri.isEqual(a,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&l?.bailOutWhenFileNotFound)throw new v((0,m.$0)(P),p.ERROR_PROFILE_NOT_FOUND)}if(b){Array.isArray(b)||this.w(a);let P=!1;for(const R of b){o(R)||this.w(a);let D;if((0,g.$ag)(R.relativeLocation)&&R.relativeLocation)D=this.z(R.relativeLocation);else if((0,g.$ag)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{D=I.URI.revive(R.location);const T=this.y(D);T&&(P=!0,R.relativeLocation=T)}(0,g.$hg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(P=!0,R.metadata.hasPreReleaseVersion=!0),u.push({identifier:R.identifier,location:D,version:R.version,metadata:R.metadata})}P&&await this.m.writeFile(a,r.$Je.fromString(JSON.stringify(b)))}if(n){u=n(u);const P=u.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(a,r.$Je.fromString(JSON.stringify(P)))}return u})}w(a){const n=new v(`Invalid extensions content in ${a.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(a){return this.r.extUri.isEqual(this.r.extUri.dirname(a),this.j)?this.r.extUri.basename(a):void 0}z(a){return this.r.extUri.joinPath(this.j,a)}async D(){return this.C||(this.C=(async()=>{const a=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let l;try{l=(await this.m.readFile(a)).value.toString()}catch(b){if((0,f.$ll)(b)===f.FileOperationResult.FILE_NOT_FOUND)return;throw b}this.t.info("Migrating extensions from old default profile location",a.toString());let u;try{const b=JSON.parse(l);Array.isArray(b)&&b.every(P=>o(P))?u=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Je.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",a.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,f.$ll)(b)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",a.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(a)}catch(b){(0,f.$ll)(b)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(b)}try{await this.m.del(n)}catch(b){(0,f.$ll)(b)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(b)}return u})()),this.C}F(a){let n=this.h.get(a);return n||(n=new i.$Hh,this.h.set(a,n)),n}};e.$yq=S,e.$yq=S=Se([re(1,f.$7k),re(2,y.$Gl),re(3,h.$El),re(4,w.$6l),re(5,$.$7j)],S);function o(s){return(0,g.$cg)(s)&&(0,E.$ap)(s.identifier)&&(t(s.location)||(0,g.$ag)(s.location)&&s.location)&&((0,g.$hg)(s.relativeLocation)||(0,g.$ag)(s.relativeLocation))&&s.version&&(0,g.$ag)(s.version)}function t(s){return s?(0,g.$ag)(s.path)&&(0,g.$ag)(s.scheme):!1}}),define(ce[134],le([0,1,22,8,35,17,16,40,157,2,13,9,4,19,210,79,12,7,177,38,130,100,209,15,6,5,28,3,81,86,43,42,208]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=e.$Cq=e.$Bq=e.Translations=void 0,e.$Eq=se;var j;(function(oe){function K(te,q){if(te===q)return!0;const L=Object.keys(te),B=new Set;for(const V of Object.keys(q))B.add(V);if(L.length!==B.size)return!1;for(const V of L){if(te[V]!==q[V])return!1;B.delete(V)}return B.size===0}oe.equals=K})(j||(e.Translations=j={})),e.$Bq=(0,a.$Ai)("IExtensionsScannerService");let F=class extends c.$Uc{constructor(K,te,q,L,B,V,ae,G,he,ne,Z,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=te,this.r=q,this.s=L,this.t=B,this.u=V,this.w=ae,this.y=G,this.z=he,this.C=ne,this.D=Z,this.F=U,this.g=this.B(new u.$he),this.onDidChangeCache=this.g.event,this.h=(0,y.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Np)(this.w,this.y)),this.G}async scanAllExtensions(K,te,q){const[L,B]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(te)]),V=q?await this.scanExtensionsUnderDevelopment(K,[...L,...B]):[];return this.L(L,B,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const te=[];te.push(this.M(!!K.useCache,K.language)),te.push(this.N(K.language,!!K.checkControlFile));const[q,L]=await Promise.all(te);return this.J([...q,...L],o.ExtensionType.System,K,!1)}async scanUserExtensions(K){const te=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const q=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(te,!!K.profileLocation,o.ExtensionType.User,!K.includeUninstalled,K.language,!0,q,K.productVersion??this.R()),B=K.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let V;try{V=await B.scanExtensions(L)}catch(ae){if(ae instanceof P.$wq&&ae.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),V=await B.scanExtensions(L);else throw ae}return V=await this.J(V,o.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(K,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===f.Schemas.file).map(async L=>{const B=await this.P(L,!1,o.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(B)).map(ae=>(ae.type=te.find(G=>(0,S.$Cp)(G.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,B)))}))).flat();return this.J(q,"development",K,!0)}return[]}async scanExistingExtension(K,te,q){const L=await this.P(K,!1,te,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanExtension(L);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(K,te,q){const L=await this.P(K,!1,te,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanOneOrMultipleExtensions(L);return this.J(B,te,q,!0)}async scanMultipleExtensions(K,te,q){const L=[];return await Promise.all(K.map(async B=>{const V=await this.scanOneOrMultipleExtensions(B,te,q);L.push(...V)})),this.J(L,te,q,!0)}async scanMetadata(K){const te=(0,y.$bh)(K,"package.json"),q=(await this.w.readFile(te)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(K,te){const q=(0,y.$bh)(K,"package.json"),L=(await this.w.readFile(q)).value.toString(),B=JSON.parse(L);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,B.__metadata={...B.__metadata,...te},await this.w.writeFile((0,y.$bh)(K,"package.json"),A.$Je.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof P.$wq&&K.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Je.fromString(JSON.stringify([])))}catch(te){(0,s.$ll)(te)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,te,q,L){return q.includeAllVersions||(K=this.L(te===o.ExtensionType.System?K:void 0,te===o.ExtensionType.User?K:void 0,te==="development"?K:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(K=K.filter(B=>B.isValid)),K.sort((B,V)=>{const ae=d.$nc(B.location.fsPath),G=d.$nc(V.location.fsPath);return ae<G?-1:ae>G?1:0})}L(K,te,q,L,B){const V=(G,he,ne)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(B&&h.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(h.eq(G.manifest.version,he.manifest.version)){if(G.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return ne?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},ae=new o.$Ym;return K?.forEach(G=>{const he=ae.get(G.identifier.id);(!he||V(he,G,!1))&&ae.set(G.identifier.id,G)}),te?.forEach(G=>{const he=ae.get(G.identifier.id);if(!he&&K&&G.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||V(he,G,!1))&&ae.set(G.identifier.id,G)}),q?.forEach(G=>{const he=ae.get(G.identifier.id);(!he||V(he,G,!0))&&ae.set(G.identifier.id,G),ae.set(G.identifier.id,G)}),[...ae.values()]}async M(K,te){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,te,!0,void 0,this.R()),B=await(K&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",B.length),B}async N(K,te){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=te?await this.O():{},B=[],V=w.URI.file(d.$hc(d.$jc(f.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of q){const he=L[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":B.push((0,y.$bh)(V,G.name));break;default:B.push(w.URI.file(he));break}}const ae=await Promise.all(B.map(async G=>this.n.scanExtension(await this.P(G,!1,o.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,i.$Hb)(ae)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,te,q,L,B,V,ae,G){const he=await this.f(B??$.$w),ne=await this.Q(K),Z=te&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=Z?await this.Q(Z):void 0;return new W(K,ne,Z,U,te,ae,q,L,V,G.version,G.date,this.C.commit,!this.z.isBuilt,B,he)}async Q(K){try{const te=await this.w.stat(K);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Cq=F,e.$Cq=F=Se([re(4,R.$Gl),re(5,P.$xq),re(6,s.$7k),re(7,n.$7j),re(8,v.$Hi),re(9,l.$nk),re(10,D.$El),re(11,a.$zi)],F);class W{constructor(K,te,q,L,B,V,ae,G,he,ne,Z,U,M,N,H){this.location=K,this.mtime=te,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=B,this.profileScanOptions=V,this.type=ae,this.excludeObsolete=G,this.validate=he,this.productVersion=ne,this.productDate=Z,this.productCommit=U,this.devMode=M,this.language=N,this.translations=H}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,te){return(0,y.$7g)(K.location,te.location)&&K.mtime===te.mtime&&(0,y.$7g)(K.applicationExtensionslocation,te.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&K.profile===te.profile&&k.$ao(K.profileScanOptions,te.profileScanOptions)&&K.type===te.type&&K.excludeObsolete===te.excludeObsolete&&K.validate===te.validate&&K.productVersion===te.productVersion&&K.productDate===te.productDate&&K.productCommit===te.productCommit&&K.devMode===te.devMode&&K.language===te.language&&j.equals(K.translations,te.translations)}}e.$Dq=W;let C=class extends c.$Uc{constructor(K,te,q,L,B){super(),this.f=K,this.g=te,this.h=q,this.j=L,this.m=B}async scanExtensions(K){const te=K.profile?await this.r(K):await this.n(K);let q={};if(K.excludeObsolete&&K.type===o.ExtensionType.User)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,m.$ng)(q)?te:te.filter(L=>!q[S.$Dp.create(L).toString()])}async n(K){const te=await this.j.resolve(K.location);if(!te.children?.length)return[];const q=await Promise.all(te.children.map(async L=>{if(!L.isDirectory||K.type===o.ExtensionType.User&&(0,y.$$g)(L.resource).indexOf(".")===0)return null;const B=new W(L.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(B)}));return(0,i.$Hb)(q).sort((L,B)=>L.location.path<B.location.path?-1:1)}async r(K){let te=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){te=te.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(K.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,K);te.push(...q)}return te}async s(K,te,q){const L=await this.g.scanProfileExtensions(K,q.profileScanOptions);if(!L.length)return[];const B=await Promise.all(L.map(async V=>{if(te(V)){const ae=new W(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ae,V.metadata)}return null}));return(0,i.$Hb)(B)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,y.$bh)(K.location,"package.json"))){const te=await this.scanExtension(K);return te?[te]:[]}else return await this.scanExtensions(K)}catch(te){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,O.$0)(te)),[]}}async scanExtension(K,te){try{let q=await this.scanExtensionManifest(K.location);if(q){q.publisher||(q.publisher=o.$Sm),te=te??q.__metadata,delete q.__metadata;const L=(0,S.$Hp)(q.publisher,q.name),B=te?.id?{id:L,uuid:te.id}:{id:L},V=te?.isSystem?o.ExtensionType.System:K.type,ae=V===o.ExtensionType.System||!!te?.isBuiltin;q=await this.t(K.location,q,W.createNlsConfiguration(K));const G={type:V,identifier:B,manifest:q,location:K.location,isBuiltin:ae,targetPlatform:te?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(q){K.type!==o.ExtensionType.System&&this.m.error(q)}return null}validate(K,te){let q=!0;const L=(0,t.$Sp)(te.productVersion,te.productDate,te.location,K.manifest,K.isBuiltin);for(const[B,V]of L)B===g.default.Error&&(q=!1,this.m.error(this.z(te.location,V)));return K.isValid=q,K.validations=L,K}async scanExtensionManifest(K){const te=(0,y.$bh)(K,"package.json");let q;try{q=(await this.j.readFile(te)).value.toString()}catch(B){return(0,s.$ll)(B)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(K,(0,p.localize)(0,null,te.path,B.message))),null}let L;try{L=JSON.parse(q)}catch{const V=[];(0,I.$Pn)(q,V);for(const ae of V)this.m.error(this.z(K,(0,p.localize)(1,null,te.path,ae.offset,ae.length,(0,E.$zq)(ae.error))));return null}return(0,I.$Yn)(L)!=="object"?(this.m.error(this.z(K,(0,p.localize)(2,null,te.path))),null):L}async t(K,te,q){const L=await this.u(K,te,q);if(L)try{const B=[],V=await this.w(L.default,B);if(B.length>0)return B.forEach(G=>{this.m.error(this.z(K,(0,p.localize)(3,null,L.default?.path,(0,E.$zq)(G.error))))}),te;if((0,I.$Yn)(L)!=="object")return this.m.error(this.z(K,(0,p.localize)(4,null,L.default?.path))),te;const ae=L.values||Object.create(null);return(0,T.$Aq)(this.m,te,ae,V)}catch{}return te}async u(K,te,q){const L=(0,y.$bh)(K,"package.nls.json"),B=(he,ne)=>{ne.forEach(Z=>{this.m.error(this.z(K,(0,p.localize)(5,null,he?.path,(0,E.$zq)(Z.error))))})},V=he=>{this.m.error(this.z(K,(0,p.localize)(6,null,he?.path)))},ae=`${te.publisher}.${te.name}`,G=q.translations[ae];if(G)try{const he=w.URI.file(G),ne=(await this.j.readFile(he)).value.toString(),Z=[],U=(0,I.$Pn)(ne,Z);return Z.length>0?(B(he,Z),{values:void 0,default:L}):(0,I.$Yn)(U)!=="object"?(V(he),{values:void 0,default:L}):{values:U.contents?U.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let ne;try{ne=await this.y(K,q)}catch{return}if(!ne.localized)return{values:void 0,default:ne.original};try{const Z=(await this.j.readFile(ne.localized)).value.toString(),U=[],M=(0,I.$Pn)(Z,U);return U.length>0?(B(ne.localized,U),{values:void 0,default:ne.original}):(0,I.$Yn)(M)!=="object"?(V(ne.localized),{values:void 0,default:ne.original}):{values:M,default:ne.original}}catch{return{values:void 0,default:ne.original}}}}async w(K,te){if(K)try{const q=(await this.j.readFile(K)).value.toString();return(0,I.$Pn)(q,te)}catch{}}y(K,te){return new Promise((q,L)=>{const B=V=>{const ae=(0,y.$bh)(K,`package.nls.${V}.json`);this.j.exists(ae).then(G=>{G&&q({localized:ae,original:(0,y.$bh)(K,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?q({localized:(0,y.$bh)(K,"package.nls.json"),original:null}):(V=V.substring(0,he),B(V))})};if(te.devMode||te.pseudo||!te.language)return q({localized:(0,y.$bh)(K,"package.nls.json"),original:null});B(te.language)})}z(K,te){return`[${K.path}]: ${te}`}};C=Se([re(1,P.$xq),re(2,D.$El),re(3,s.$7k),re(4,n.$7j)],C);let z=class extends C{constructor(K,te,q,L,B,V,ae){super(te,L,B,V,ae),this.G=K,this.H=q,this.D=this.B(new r.$yh(3e3)),this.F=this.B(new u.$he),this.onDidChangeCache=this.F.event}async scanExtensions(K){const te=this.M(K),q=await this.I(te);if(this.C=K,q&&q.input&&W.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),q.result.map(B=>(B.location=w.URI.revive(B.location),B));const L=await super.scanExtensions(K);return await this.J(te,{input:K,result:L}),L}async I(K){try{const te=await this.j.readFile(K),q=JSON.parse(te.value.toString());return{result:q.result,input:(0,b.$0h)(q.input)}}catch(te){this.m.debug("Error while reading the extension cache file:",K.path,(0,O.$0)(te))}return null}async J(K,te){try{await this.j.writeFile(K,A.$Je.fromString(JSON.stringify(te)))}catch(q){this.m.debug("Error while writing the extension cache file:",K.path,(0,O.$0)(q))}}async L(){if(!this.C)return;const K=this.M(this.C),te=await this.I(K);if(!te)return;const q=te.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$ao(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(K),this.F.fire()}catch(B){this.m.error(B)}}M(K){const te=this.N(K);return this.h.extUri.joinPath(te.cacheHome,K.type===o.ExtensionType.System?o.$Rm:o.$Qm)}N(K){return K.type===o.ExtensionType.System?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(te=>this.h.extUri.isEqual(K.location,te.extensionsResource))??this.G:this.H.defaultProfile}};z=Se([re(2,R.$Gl),re(3,P.$xq),re(4,D.$El),re(5,s.$7k),re(6,n.$7j)],z);function se(oe,K){const te=(0,S.$Fp)(oe.manifest.publisher,oe.manifest.name);return{id:te,identifier:new o.$Wm(te),isBuiltin:oe.type===o.ExtensionType.System,isUserBuiltin:oe.type===o.ExtensionType.User&&oe.isBuiltin,isUnderDevelopment:K,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,publisherDisplayName:oe.publisherDisplayName,...oe.manifest}}class ie extends F{constructor(K,te,q,L,B,V,ae,G,he,ne,Z,U){super(K,te,(0,y.$bh)(q,".vscode-oss-dev","extensions","control.json"),L,B,V,ae,G,he,ne,Z,U),this.S=(async()=>{if($.$z)try{const M=await this.w.readFile(w.URI.file($.$z));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Fq=ie}),define(ce[280],le([0,1,5,43,42,24,86,15,38,7]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=void 0;let f=class extends O.$yq{constructor($,y,h,g,m,w){super(c.URI.file($.extensionsPath),y,h,g,m,w)}};e.$kQ=f,e.$kQ=f=Se([re(0,E.$Ii),re(1,I.$7k),re(2,r.$Gl),re(3,k.$El),re(4,A.$6l),re(5,i.$7j)],f)}),define(ce[281],le([0,1,7,38,86,134,15,6,5,28,42,43]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let $=class extends A.$Fq{constructor(h,g,m,w,p,v,S,o){super(i.URI.file(p.builtinExtensionsPath),i.URI.file(p.extensionsPath),p.userHome,h.defaultProfile,h,g,m,w,p,v,S,o)}};e.$Iec=$,e.$Iec=$=Se([re(0,d.$Gl),re(1,k.$xq),re(2,O.$7k),re(3,E.$7j),re(4,r.$Ii),re(5,c.$nk),re(6,f.$El),re(7,I.$zi)],$)}),define(ce[282],le([0,1,14,2,13,9,4,61,7,33,37,38,5,43]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;let h=class extends r.$Uc{constructor(m,w,p){super(),this.c=m,this.f=p,this.a=I.$Gi.forPaths(!O.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot(w.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(m.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:m}=i.session;m.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(w,p)=>this.j(w,p)),m.protocol.interceptFileProtocol(k.Schemas.file,(w,p)=>this.h(w,p)),this.B((0,r.$Sc)(()=>{m.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(m){const w=(0,A.$hc)(m);return this.a.get(w)?r.$Uc.None:(this.a.set(w,!0),(0,r.$Sc)(()=>this.a.delete(w)))}h(m,w){const p=E.URI.parse(m.url);return this.f.error(`Refused to load resource ${p.fsPath} from ${k.Schemas.file}: protocol (original URL: ${m.url})`),w({error:-3})}j(m,w){const p=this.m(m);let v;return this.c.crossOriginIsolated&&((0,A.$nc)(p)==="workbench.html"||(0,A.$nc)(p)==="workbench-dev.html"?v=k.COI.CoopAndCoep:v=k.COI.getHeadersFromQuery(m.url)),this.a.findSubstr(p)?w({path:p,headers:v}):this.b.has((0,A.$oc)(p).toLowerCase())?w({path:p}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),w({error:-3}))}m(m){const w=E.URI.parse(m.url),p=k.$Ug.uriToFileUri(w);return(0,A.$hc)(p.fsPath)}createIPCObjectUrl(){let m;const w=E.URI.from({scheme:"vscode",path:(0,c.$Wg)()}),p=w.toString(),v=async()=>m;return f.$sW.handle(p,v),this.f.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:w,update:S=>m=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${p}.`),f.$sW.removeHandler(p)}}}};e.$3ec=h,e.$3ec=h=Se([re(0,d.$Ii),re(1,y.$Gl),re(2,$.$7j)],h)}),define(ce[63],le([0,1,8,3,2,69,12,120,6,43]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=y,e.$_p=g,e.$bq=w,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,E.$Ai)("storageService");var f;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var d;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var $;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function y(p){const v=p.get(e.$8p);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class h extends k.$Uc{static{this.a=60*1e3}constructor(v={flushInterval:h.a}){super(),this.m=v,this.b=this.B(new r.$ke),this.c=this.B(new r.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$he),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,S,o){return r.Event.filter(this.b.event,t=>t.scope===v&&(S===void 0||t.key===S),o)}n(){this.j.value=(0,i.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,S){const{key:o,external:t}=S;if(o===e.$8p){switch(v){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:o,target:this.J(v)[o],external:t})}w(v){this.f.fire({reason:v})}get(v,S,o){return this.P(S)?.get(v,o)}getBoolean(v,S,o){return this.P(S)?.getBoolean(v,o)}getNumber(v,S,o){return this.P(S)?.getNumber(v,o)}getObject(v,S,o){return this.P(S)?.getObject(v,o)}storeAll(v,S){this.y(()=>{for(const o of v)this.store(o.key,o.value,o.scope,o.target,S)})}store(v,S,o,t,s=!1){if((0,O.$jg)(S)){this.remove(v,o,s);return}this.y(()=>{this.z(v,o,t),this.P(o)?.set(v,S,s)})}remove(v,S,o=!1){this.y(()=>{this.z(v,S,void 0),this.P(S)?.delete(v,o)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,S){const o=[],t=this.J(v);for(const s of Object.keys(t))t[s]===S&&o.push(s);return o}z(v,S,o,t=!1){const s=this.J(S);typeof o=="number"?s[v]!==o&&(s[v]=o,this.P(S)?.set(e.$8p,JSON.stringify(s),t)):typeof s[v]=="number"&&(delete s[v],this.P(S)?.set(e.$8p,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(v){switch(v){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(v){const S=this.P(v);return S?y(S):Object.create(null)}isNew(v){return this.getBoolean(e.$7p,v)===!0}async flush(v=f.NONE){this.f.fire({reason:v});const S=this.P(d.APPLICATION),o=this.P(d.PROFILE),t=this.P(d.WORKSPACE);switch(v){case f.NONE:await i.Promises.settled([S?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await i.Promises.settled([S?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(d.APPLICATION)?.items??new Map,S=this.P(d.PROFILE)?.items??new Map,o=this.P(d.WORKSPACE)?.items??new Map;return w(v,S,o,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,S){return this.w(f.NONE),(0,c.$Fl)(v)?this.R(v,S):this.S(v,S)}M(v,S){return!(v.id===S.id||g(S)&&g(v))}N(v,S,o){this.y(()=>{const t=new Set;for(const[s,a]of v)t.add(s),S.get(s)!==a&&this.u(o,{key:s,external:!0});for(const[s]of S.items)t.has(s)||this.u(o,{key:s,external:!0})})}}e.$$p=h;function g(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class m extends h{constructor(){super(),this.U=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(d.WORKSPACE,v))),this.B(this.W.onDidChangeStorage(v=>this.u(d.PROFILE,v))),this.B(this.U.onDidChangeStorage(v=>this.u(d.APPLICATION,v)))}P(v){switch(v){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(v){switch(v){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$aq=m;async function w(p,v,S,o,t,s){const a=j=>{try{return JSON.parse(j)}catch{return j}},n=new Map,l=new Map;p.forEach((j,F)=>{n.set(F,j),l.set(F,a(j))});const u=new Map,b=new Map;v.forEach((j,F)=>{u.set(F,j),b.set(F,a(j))});const P=new Map,R=new Map;S.forEach((j,F)=>{P.set(F,j),R.set(F,a(j))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const D=[];if(n.forEach((j,F)=>{D.push({key:F,value:j})}),console.table(D),console.groupEnd(),console.log(l),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];u.forEach((F,W)=>{j.push({key:W,value:F})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${s})`);const T=[];P.forEach((j,F)=>{T.push({key:F,value:j})}),console.table(T),console.groupEnd(),console.log(R)}}),define(ce[283],le([0,1,17,33,63]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=A;async function A(O,I,E){let c=E&&E.get("storage.serviceMachineId",k.StorageScope.APPLICATION)||null;if(c)return c;try{const d=(await I.readFile(O.serviceMachineIdResource)).value.toString();c=(0,r.$Vg)(d)?d:null}catch{c=null}if(!c){c=(0,r.$Wg)();try{await I.writeFile(O.serviceMachineIdResource,i.$Je.fromString(c))}catch{}}return E?.store("storage.serviceMachineId",c,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE),c}}),define(ce[284],le([0,1,283,24,56]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=A;async function A(O,I,E,c,f,d,$){const y={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,k.$up)(I,E)&&(0,k.$wp)(c)===r.TelemetryLevel.USAGE){const h=await(0,i.$cq)(E,f,d);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=$.machineId||h}return y}}),define(ce[285],le([0,1,22,8,3,2,9,77,7,21,120,166,5,63,24,30,13]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.$wdc=void 0;class w extends A.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(a,n){super(),this.m=a,this.n=n,this.b=this.B(new k.$he),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.$he),this.onDidCloseStorage=this.c.event,this.f=this.B(new f.$5p(new f.$6p,{hint:f.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new r.$Xh,this.whenInit=this.h.p,this.j=f.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===f.StorageState.None)try{const a=this.B(await this.t());this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(l=>this.b.fire(l))),await this.s(a);const n=a.getBoolean(y.$7p);n===void 0?a.set(y.$7p,!0):n&&a.set(y.$7p,!1)}catch(a){this.m.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.j=f.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===$.LogLevel.Trace?a=>this.m.trace(a):void 0,logError:a=>this.m.error(a)}}s(a){return a.init()}get items(){return this.f.items}get(a,n){return this.f.get(a,n)}set(a,n){return this.f.set(a,n)}delete(a){return this.f.delete(a)}optimize(){return this.f.optimize()}async close(){const a=new I.$be(!1);await this.w(),a.stop(),a.elapsed()>w.a&&await this.u(a),this.c.fire()}async u(a){if(this.path)try{const n=(0,i.top)(Array.from(this.f.items.entries()).map(([u,b])=>({key:u,length:b.length})),(u,b)=>b.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),l=(await this.n.stat(E.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${l}b, Large Keys: ${n}`)}catch(n){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async w(){this.g&&await this.g,this.j=f.StorageState.Closed,await this.f.close()}}class p extends w{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,O.$jc)(this.z.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,p.y)}constructor(a,n,l,u){super(l,u),this.z=a,this.C=n}async t(){return new f.$5p(new d.$XW(this.path??d.$XW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:f.StorageHint.STORAGE_IN_MEMORY})}}class v extends p{constructor(a,n,l,u){super(a,n,l,u)}}e.$wdc=v;class S extends p{constructor(a,n,l,u){super(n.defaultProfile,a,l,u)}async s(a){await super.s(a),this.G(a)}G(a){a.get(h.$9l,void 0)===void 0&&a.set(h.$9l,new Date().toUTCString());const l=a.get(h.$8l,void 0),u=new Date().toUTCString();a.set(h.$0l,typeof l>"u"?null:l),a.set(h.$8l,u)}}e.$xdc=S;class o extends w{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,O.$jc)(this.F.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.C.id,o.y)}constructor(a,n,l,u,b){super(l,b),this.C=a,this.D=n,this.F=u}async t(){const{storageFilePath:a,wasCreated:n}=await this.H();return new f.$5p(new d.$XW(a,{logging:this.r()}),{hint:this.D.useInMemoryStorage?f.StorageHint.STORAGE_IN_MEMORY:n?f.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$XW.IN_MEMORY_PATH,wasCreated:!0};const a=(0,O.$jc)(this.F.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.C.id),n=(0,O.$jc)(a,o.y);return await c.Promises.exists(a)?{storageFilePath:n,wasCreated:!1}:(await c.Promises.mkdir(a,{recursive:!0}),this.I(a),{storageFilePath:n,wasCreated:!0})}async I(a){let n;if((0,g.$Ki)(this.C)?n={folder:this.C.uri.toString()}:(0,g.$Pi)(this.C)&&(n={workspace:this.C.configPath.toString()}),n)try{const l=(0,O.$jc)(a,o.z);await c.Promises.exists(l)||await c.Promises.writeFile(l,JSON.stringify(n,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$ydc=o;class t extends w{get path(){}async t(){return new f.$5p(new f.$6p,{hint:f.StorageHint.STORAGE_IN_MEMORY})}}e.$zdc=t}),define(ce[286],le([0,1,3,2,63]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class A extends r.$Uc{constructor(I,E,c){super(),this.b=I,this.c=E,this.f=c;const f=this.B(new r.$Vc);this.a=this.B(new i.$he({onWillAddFirstListener:()=>f.value=this.g(),onDidRemoveLastListener:()=>f.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Tc;return I.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(E,c)=>(E?E.push(c.key):E=[c.key],E),100)(E=>this.h(E))),I.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(E,c)=>{E||(E=new Map);let f=E.get(c.profile.id);return f||E.set(c.profile.id,f={profile:c.profile,keys:[],storage:c.storage}),f.keys.push(c.key),E},100)(E=>this.j(E))),I}h(I){const E=I.includes(k.$8p)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(f=>f!==k.$8p),I.length){const f=(0,k.$0p)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(d=>({key:d,scope:k.StorageScope.PROFILE,target:f[d]}))})}this.m(E,c)}j(I){const E=[],c=new Map;for(const[f,d]of I.entries()){d.keys.includes(k.$8p)&&E.push(d.profile);const $=d.keys.filter(y=>y!==k.$8p);if($.length){const y=(0,k.$0p)(d.storage.storage);c.set(f,{profile:d.profile,changes:$.map(h=>({key:h,scope:k.StorageScope.PROFILE,target:y[h]}))})}}this.m(E,[...c.values()])}m(I,E){(I.length||E.length)&&this.a.fire({valueChanges:E,targetChanges:I})}listen(I,E,c){switch(E){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${E}`)}async call(I,E){throw new Error(`Call not found: ${E}`)}}e.$Kec=A}),define(ce[287],le([0,1,7,38,15,5,34,42,43,12,128]),function(X,e,i,r,k,A,O,I,E,c,f){"use strict";var d,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$iQ=e.$hQ=void 0;let y=class extends E.$Jl{static{d=this}static{this.a="profileAssociationsMigration"}constructor(w,p,v,S,o){super(v,S,p,o),this.U=w,this.W=v}O(){return this.U.getItem(d.b,[]).map(p=>({...p,location:(0,c.$ag)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):i.URI.revive(p.location)}))}Q(){const w=this.U.getItem(d.c,{});return this.U.getItem(d.a,!1)?w:this.N(w)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$hQ=y,e.$hQ=y=d=Se([re(0,O.$cQ),re(1,I.$El),re(2,r.$Ii),re(3,k.$7k),re(4,A.$7j)],y);let h=$=class extends y{constructor(w,p,v,S,o){super(w,p,v,S,o),this.$=w}P(w){w.length?this.$.setItem($.b,w.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem($.b)}O(){const w=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(w),this.$.setItem("userDataProfilesMigration",!0)),w}R(w){w.emptyWindows||w.workspaces?this.$.setItem($.c,w):this.$.removeItem($.c)}Q(){const w="workspaceAndProfileInfo",p=this.$.getItem(w,void 0);if(p){this.$.removeItem(w);const S=p.reduce((o,{workspace:t,profile:s})=>(o[i.URI.revive(t).toString()]=i.URI.revive(s).toString(),o),{});this.$.setItem($.c,{workspaces:S})}const v=super.Q();return this.$.getItem($.a,!1)||(this.R(v),this.$.setItem($.a,!0)),v}};e.$iQ=h,e.$iQ=h=$=Se([re(0,O.$dQ),re(1,I.$El),re(2,r.$Ii),re(3,k.$7k),re(4,A.$7j)],h);let g=class extends h{constructor(w,p,v,S){super(new f.$gQ(f.SaveStrategy.IMMEDIATE,p,S,v),w,p,v,S)}async init(){return await this.$.init(),super.init()}};e.$jQ=g,e.$jQ=g=Se([re(0,I.$El),re(1,r.$Ii),re(2,k.$7k),re(3,A.$7j)],g)}),define(ce[59],le([0,1,38,15,6,5,42,43,287,34]),function(X,e,i,r,k,A,O,I,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,k.$Bi)(I.$Gl);let f=class extends E.$iQ{constructor($,y,h,g,m){super($,y,h,g,m)}getAssociatedEmptyWindows(){const $=[];for(const y of this.C.emptyWindows.keys())$.push({id:y});return $}};e.$fdc=f,e.$fdc=f=Se([re(0,c.$dQ),re(1,O.$El),re(2,i.$Ii),re(3,r.$7k),re(4,A.$7j)],f)}),define(ce[135],le([0,1,19,7,30]),function(X,e,i,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=A,e.$hdc=O,e.$idc=I;async function A(E,c,f){for(const $ of E){const y=$.openedWorkspace;if((0,k.$Pi)(y)){const h=await f(y);if(h){if(h.folders.some(g=>i.$5g.isEqualOrParent(c,g.uri)))return $}else if(i.$5g.isEqualOrParent(c,y.configPath))return $}}const d=E.filter($=>(0,k.$Ki)($.openedWorkspace)&&i.$5g.isEqualOrParent(c,$.openedWorkspace.uri));if(d.length)return d.sort(($,y)=>-($.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}function O(E,c){for(const f of E)if((0,k.$Pi)(f.openedWorkspace)&&i.$5g.isEqual(f.openedWorkspace.configPath,c)||(0,k.$Ki)(f.openedWorkspace)&&i.$5g.isEqual(f.openedWorkspace.uri,c))return f}function I(E,c){const f=d=>c.some($=>i.$5g.isEqual(r.URI.file($),r.URI.file(d)));for(const d of E)if(d.config?.extensionDevelopmentPath?.some($=>f($)))return d}}),define(ce[103],le([0,1,31,40,108,49,13,9,4,19,7,6,71,30]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igb=void 0,e.$jgb=h,e.$kgb=g,e.$lgb=m,e.$mgb=w,e.$ngb=S,e.$ogb=t,e.$pgb=s,e.$qgb=b,e.$rgb=P,e.$igb=(0,d.$Ai)("workspacesService");function h(R){return R.hasOwnProperty("workspace")}function g(R){return R.hasOwnProperty("folderUri")}function m(R){return R.hasOwnProperty("fileUri")}function w(R){return p(R)||v(R)}function p(R){const D=R;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function v(R){const D=R;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function S(R,D,T,j,F){if(R.scheme!==j.scheme)return{name:T,uri:R.toString(!0)};let W=D?void 0:F.relativePath(j,R);if(W!==void 0)W.length===0?W=".":E.$i&&(W=o(W));else if(R.scheme===O.Schemas.file)W=R.fsPath,E.$i&&(W=o(W));else if(F.isEqualAuthority(R.authority,j.authority))W=R.path;else return{name:T,uri:R.toString(!0)};return{name:T,path:W}}function o(R){return R=(0,A.$Nw)(R),(0,i.$wg)(R)||(R=(0,i.$tg)(R)),R}function t(R,D,T){const j=[],F=new Set,W=T.dirname(D);for(const C of R){let z;if(p(C))C.path&&(z=T.resolvePath(W,C.path));else if(v(C))try{z=f.URI.parse(C.uri),z.path[0]!==I.$gc.sep&&(z=z.with({path:I.$gc.sep+z.path}))}catch(se){console.warn(se)}if(z){const se=T.getComparisonKey(z);if(!F.has(se)){F.add(se);const ie=C.name||T.basenameOrAuthority(z);j.push(new y.$Ui({uri:z,name:ie,index:j.length},C))}}}return j}function s(R,D,T,j,F){const W=a(D,R),C=F.dirname(D),z=F.dirname(j),se=[];for(const te of W.folders){const q=p(te)?F.resolvePath(C,te.path):f.URI.parse(te.uri);let L;T?L=!1:L=!p(te)||(0,I.$ic)(te.path),se.push(S(q,L,te.name,z,F))}const ie={insertSpaces:!1,tabSize:4,eol:E.$k||E.$j?`
`:`\r
`},oe=k.$5n(R,["folders"],se,ie);let K=k.$8n(R,oe);return(0,c.$gh)(W.remoteAuthority,(0,$.$Mm)(j))&&(K=k.$8n(K,k.$4n(K,["remoteAuthority"],ie))),K}function a(R,D){const T=r.$Pn(D);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(j=>w(j));else throw new Error(`${R} looks like an invalid workspace file.`);return T}function n(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function l(R){return typeof R.folderUri=="string"}function u(R){return typeof R.fileUri=="string"}function b(R,D){const T={workspaces:[],files:[]};if(R){const j=function(W,C){for(let z=0;z<W.length;z++)try{C(W[z],z)}catch(se){D.warn(`Error restoring recent entry ${JSON.stringify(W[z])}: ${se.toString()}. Skip entry.`)}},F=R;Array.isArray(F.entries)&&j(F.entries,W=>{const C=W.label,z=W.remoteAuthority;n(W)?T.workspaces.push({label:C,remoteAuthority:z,workspace:{id:W.workspace.id,configPath:f.URI.parse(W.workspace.configPath)}}):l(W)?T.workspaces.push({label:C,remoteAuthority:z,folderUri:f.URI.parse(W.folderUri)}):u(W)&&T.files.push({label:C,remoteAuthority:z,fileUri:f.URI.parse(W.fileUri)})})}return T}function P(R){const D={entries:[]};for(const T of R.workspaces)g(T)?D.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):D.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of R.files)D.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return D}}),define(ce[104],le([0,1,91,13,4,19]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0,e.$kdc=O,e.$ldc=I,e.$mdc=E,e.$jdc=128/4;function O(c){function f(){let d=c.scheme===r.Schemas.file?(0,A.$2g)(c):c.toString();return k.$k||(d=d.toLowerCase()),(0,i.createHash)("md5").update(d).digest("hex")}return{id:f(),configPath:c}}function I(c,f){function d(){if(c.scheme!==r.Schemas.file)return(0,i.createHash)("md5").update(c.toString()).digest("hex");if(!f)return;let y;return k.$k?y=f.ino:k.$j?y=f.birthtime.getTime():k.$i&&(typeof f.birthtimeMs=="number"?y=Math.floor(f.birthtimeMs):y=f.birthtime.getTime()),(0,i.createHash)("md5").update(c.fsPath).update(y?String(y):"").digest("hex")}const $=d();if(typeof $=="string")return{id:$,uri:c}}function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[105],le([0,1,91,92,27,288,17,16,3,2,9,4,33,45,118]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=a,e.$ti=n,e.$vi=b,e.$wi=P;class g{traceSocketEvent(D,T){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,T)}constructor(D,T=""){this.f=!0,this.debugLabel=T,this.socket=D,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const T=j=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,j),D(O.$Je.wrap(j))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(D){const T=j=>{D({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:j,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(D){const T=()=>{D()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,D),this.socket.write(D.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,I.$1)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,I.$1)(T)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((D,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),D();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),D()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$pi=g;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var w;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(w||(w={}));class p extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,T){this.socket.traceSocketEvent(D,T)}constructor(D,T,j,F){super(),this.f=this.B(new E.$he),this.g=this.B(new E.$he),this.h=!1,this.j={state:w.PeekHeader,readLen:m.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new v(this,T,j,F,this.f,(W,C)=>this.m(W,C))),this.B(this.a.onError(W=>{console.error(W),(0,I.$1)(W),this.g.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:W})})),this.b=new h.$ki,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let T=0;for(;T<D.byteLength;)this.a.writeMessage(D.slice(T,Math.min(T+m.MaxWebSocketMessageLength,D.byteLength)),{compressed:!0,opcode:2}),T+=m.MaxWebSocketMessageLength}m(D,{compressed:T,opcode:j}){if(this.h)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,D);let F=m.MinHeaderByteSize;D.byteLength<126?F+=0:D.byteLength<2**16?F+=2:F+=8;const W=O.$Je.alloc(F),C=T?64:0,z=j&15;if(W.writeUInt8(128|C|z,0),D.byteLength<126)W.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){W.writeUInt8(126,1);let se=1;W.writeUInt8(D.byteLength>>>8&255,++se),W.writeUInt8(D.byteLength>>>0&255,++se)}else{W.writeUInt8(127,1);let se=1;W.writeUInt8(0,++se),W.writeUInt8(0,++se),W.writeUInt8(0,++se),W.writeUInt8(0,++se),W.writeUInt8(D.byteLength>>>24&255,++se),W.writeUInt8(D.byteLength>>>16&255,++se),W.writeUInt8(D.byteLength>>>8&255,++se),W.writeUInt8(D.byteLength>>>0&255,++se)}this.socket.write(O.$Je.concat([W,D]))}end(){this.h=!0,this.socket.end()}n(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const T=this.b.peek(this.j.readLen),j=T.readUInt8(0),F=(j&128)>>>7,W=(j&64)>>>6,C=j&15,z=T.readUInt8(1),se=(z&128)>>>7,ie=z&127;this.j.state=w.ReadHeader,this.j.readLen=m.MinHeaderByteSize+(se?4:0)+(ie===126?2:0)+(ie===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=C,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const T=this.b.read(this.j.readLen),j=T.readUInt8(1),F=(j&128)>>>7;let W=j&127,C=1;W===126?W=T.readUInt8(++C)*2**8+T.readUInt8(++C):W===127&&(W=T.readUInt8(++C)*0+T.readUInt8(++C)*0+T.readUInt8(++C)*0+T.readUInt8(++C)*0+T.readUInt8(++C)*2**24+T.readUInt8(++C)*2**16+T.readUInt8(++C)*2**8+T.readUInt8(++C));let z=0;F&&(z=T.readUInt8(++C)*2**24+T.readUInt8(++C)*2**16+T.readUInt8(++C)*2**8+T.readUInt8(++C)),this.j.state=w.ReadBody,this.j.readLen=W,this.j.mask=z,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const T=this.b.read(this.j.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,T),t(T,this.j.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,T),this.j.state=w.PeekHeader,this.j.readLen=m.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(T,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(T,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=p;class v extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Je.alloc(0)}constructor(D,T,j,F,W,C){super(),this.n=D,this.r=W,this.s=C,this.a=this.B(new E.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,T?(this.b=this.B(new S(this.n,F,j,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(D,T){this.g.push({data:D,options:T}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:D,options:T}=this.g.shift();if(this.f&&T.compressed){const j=await this.w(this.f,D);this.s(j,T)}else this.s(D,{...T,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(D,T){return new Promise((j,F)=>{D.write(T),D.flush(W=>j(W))})}acceptFrame(D,T,j){this.h.push({data:D,isCompressed:T,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const T=await this.C(this.b,D.data,D.isLastFrameOfMessage);this.r.fire(T)}else this.r.fire(D.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(D,T,j){return new Promise((F,W)=>{D.write(T),j&&D.write(O.$Je.fromByteArray([0,0,255,255])),D.flush(C=>F(C))})}}class S extends c.$Uc{get recordedInflateBytes(){return this.j?O.$Je.concat(this.f):O.$Je.alloc(0)}constructor(D,T,j,F){super(),this.h=D,this.j=T,this.a=this.B(new E.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",W=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,W),this.g.push(O.$Je.wrap(W))}),j&&(this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const T=O.$Je.concat(this.g);this.g.length=0,D(T)})}}class o extends c.$Uc{constructor(D,T){super(),this.g=D,this.a=this.B(new E.$he),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,j),this.f.push(O.$Je.wrap(j))})}write(D){this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let T=O.$Je.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),D(T)})}}function t(R,D){if(D===0)return;const T=R.byteLength>>>2;for(let se=0;se<T;se++){const ie=R.readUInt32BE(se*4);R.writeUInt32BE(ie^D,se*4)}const j=T*4,F=R.byteLength-j,W=D>>>24&255,C=D>>>16&255,z=D>>>8&255;F>=1&&R.writeUInt8(R.readUInt8(j)^W,j),F>=2&&R.writeUInt8(R.readUInt8(j+1)^C,j+1),F>=3&&R.writeUInt8(R.readUInt8(j+2)^z,j+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const s={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function a(){const R=(0,$.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const D=process.platform!=="darwin"&&e.$ri?e.$ri:(0,k.tmpdir)(),T=(0,f.$jc)(D,`vscode-ipc-${R}.sock`);return l(T),T}function n(R,D,T){const F=(0,i.createHash)("sha256").update(R).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${T}-${D}-sock`;const W=T.substr(0,4),C=D.substr(0,6);let z;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?z=(0,f.$jc)(e.$ri,`vscode-${F}-${W}-${C}.sock`):z=(0,f.$jc)(R,`${W}-${C}.sock`),l(z),z}function l(R){const D=s[d.$u];typeof D=="number"&&R.length>=D&&console.warn(`WARNING: IPC handle "${R}" is longer than ${D} chars, try a shorter --user-data-dir`)}class u extends y.$ei{static b(D){const T=E.Event.fromNodeEventEmitter(D,"connection");return E.Event.map(T,j=>({protocol:new h.$li(new g(j,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(j,"close"))}))}constructor(D){super(u.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=u;function b(R){return new Promise((D,T)=>{const j=(0,r.createServer)();j.on("error",T),j.listen(R,()=>{j.removeListener("error",T),D(new u(j))})})}function P(R,D){return new Promise((T,j)=>{const F=(0,r.createConnection)(R,()=>{F.removeListener("error",j),T(h.$mi.fromSocket(new g(F,`ipc-client${D}`),D))});F.once("error",j)})}}),define(ce[25],le([0,1,53,9,4,105,38,95,6]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0,e.$3cc=(0,E.$Bi)(O.$Hi);class c extends I.$bn{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,r.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,r.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.$ti)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const $=d.slice(0,-17);if(this.d[$])continue;process.env[$]&&(this.d[$]=process.env[$]),process.env[d]?process.env[$]=process.env[d]:delete process.env[$]}}}restoreSnapExportedVariables(){if(k.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$4cc=c,Se([i.$5h],c.prototype,"cachedLanguagesPath",null),Se([i.$5h],c.prototype,"backupHome",null),Se([i.$5h],c.prototype,"mainIPCHandle",null),Se([i.$5h],c.prototype,"mainLockfile",null),Se([i.$5h],c.prototype,"disableUpdates",null),Se([i.$5h],c.prototype,"crossOriginIsolated",null),Se([i.$5h],c.prototype,"codeCachePath",null),Se([i.$5h],c.prototype,"useCodeCache",null)}),define(ce[289],le([0,1,91,31,13,9,4,19,21,202,18,25,34,15,5,201,30,104]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let v=class{static{p=this}static{this.a="backupWorkspaces"}constructor(o,t,s,a){this.j=o,this.k=t,this.l=s,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$5g,this.i={isEqual:(n,l)=>(0,r.$yg)(n,l,!O.$k)}}async initialize(){const o=this.m.getItem(p.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(o.emptyWindows),this.d=await this.u((0,c.$6cc)(o)),this.e=await this.v((0,c.$7cc)(o)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==y.$tl.OFF}q(){return this.s()===y.$tl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||y.$tl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(o,t){this.d.some(a=>o.workspace.id===a.workspace.id)||(this.d.push(o),this.C());const s=(0,A.$jc)(this.c,o.workspace.id);return t?this.t(s,t).then(()=>s):s}async t(o,t){if(await E.Promises.exists(o)&&await this.z(o),await E.Promises.exists(t))try{await E.Promises.rename(t,o,!1)}catch(s){this.l.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}registerFolderBackup(o){return this.e.some(t=>this.h.isEqual(o.folderUri,t.folderUri))||(this.e.push(o),this.C()),(0,A.$jc)(this.c,this.D(o))}registerEmptyWindowBackup(o){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,o.backupFolder))||(this.g.push(o),this.C()),(0,A.$jc)(this.c,o.backupFolder)}async u(o){if(!Array.isArray(o))return[];const t=new Set,s=[];for(const a of o){const n=a.workspace;if(!(0,m.$Pi)(n))return[];if(!t.has(n.id)){t.add(n.id);const l=(0,A.$jc)(this.c,n.id);await this.B(l)?n.configPath.scheme!==k.Schemas.file||await E.Promises.exists(n.configPath.fsPath)?s.push(a):await this.z(l):await this.x(l)}}return s}async v(o){if(!Array.isArray(o))return[];const t=[],s=new Set;for(const a of o){const n=a.folderUri,l=this.h.getComparisonKey(n);if(!s.has(l)){s.add(l);const u=(0,A.$jc)(this.c,this.D(a));await this.B(u)?n.scheme!==k.Schemas.file||await E.Promises.exists(n.fsPath)?t.push(a):await this.z(u):await this.x(u)}}return t}async w(o){if(!Array.isArray(o))return[];const t=[],s=new Set;for(const a of o){const n=a.backupFolder;if(typeof n!="string")return[];if(!s.has(n)){s.add(n);const l=(0,A.$jc)(this.c,n);await this.B(l)?t.push(a):await this.x(l)}}return t}async x(o){try{await E.Promises.rm(o,E.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let o=(0,w.$mdc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,o.id));)o=(0,w.$mdc)();return{backupFolder:o.id}}async z(o){const t=this.y(),s=(0,A.$jc)(this.c,t.backupFolder);try{await E.Promises.rename(o,s,!1)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const o=[];for(const t of this.d)await this.A(t)&&o.push(t);for(const t of this.e)await this.A(t)&&o.push(t);return o}A(o){let t;return(0,c.$5cc)(o)?t=(0,A.$jc)(this.c,o.backupFolder):(0,g.$ggb)(o)?t=(0,A.$jc)(this.c,this.D(o)):t=(0,A.$jc)(this.c,o.workspace.id),this.B(t)}async B(o){try{const t=await E.Promises.readdir(o);for(const s of t)try{if((await E.Promises.readdir((0,A.$jc)(o,s))).length>0)return!0}catch{}}catch{}return!1}C(){const o={workspaces:this.d.map(({workspace:t,remoteAuthority:s})=>{const a={id:t.id,configURIPath:t.configPath.toString()};return s&&(a.remoteAuthority=s),a}),folders:this.e.map(({folderUri:t,remoteAuthority:s})=>{const a={folderUri:t.toString()};return s&&(a.remoteAuthority=s),a}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:s})=>{const a={backupFolder:t};return s&&(a.remoteAuthority=s),a})};this.m.setItem(p.a,o)}D(o){const t=o.folderUri;let s;return t.scheme===k.Schemas.file?s=O.$k?t.fsPath:t.fsPath.toLowerCase():s=t.toString().toLowerCase(),(0,i.createHash)("md5").update(s).digest("hex")}};e.$Fdc=v,e.$Fdc=v=p=Se([re(0,d.$3cc),re(1,f.$7i),re(2,h.$7j),re(3,$.$dQ)],v)}),define(ce[20],le([0,1,14,37,8,3,2,4,36,12,6,5,34,52,25]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.LifecycleMainPhase=e.ShutdownReason=e.$udc=void 0,e.$udc=(0,f.$Ai)("lifecycleMainService");var m;(function(v){v[v.QUIT=1]="QUIT",v[v.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var w;(function(v){v[v.Starting=1]="Starting",v[v.Ready=2]="Ready",v[v.AfterWindowOpen=3]="AfterWindowOpen",v[v.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let p=class extends O.$Uc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,o,t){super(),this.F=S,this.G=o,this.H=t,this.c=this.B(new A.$he),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.$he),this.onWillShutdown=this.f.event,this.g=this.B(new A.$he),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.$he),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=w.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(w.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$j&&this.t===0&&this.L(m.QUIT))};i.app.addListener("before-quit",S);const o=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$j)&&i.app.quit()};i.app.addListener("window-all-closed",o),i.app.once("will-quit",t=>{this.S("Lifecycle#app.on(will-quit) - begin"),t.preventDefault(),this.L(m.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",S),i.app.removeListener("window-all-closed",o),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(S){if(this.y)return this.y;const o=this.F;this.S("Lifecycle#onWillShutdown.fire()");const t=[];return this.f.fire({reason:S,join(s,a){o.trace(`Lifecycle#onWillShutdown - begin '${s}'`),t.push(a.finally(()=>{o.trace(`Lifecycle#onWillShutdown - end '${s}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(t)}catch(s){this.F.error(s)}try{await this.G.close()}catch(s){this.F.error(s)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const o=this.C.get(this.n);o&&(o.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let o=this.C.get(S);o||(o=new k.$zh,this.C.set(S,o)),await o.wait()}registerWindow(S){const o=new O.$Tc;this.t++,o.add(S.onWillLoad(s=>this.g.fire({window:S,workspace:s.workspace,reason:s.reason})));const t=(0,c.$lg)(S.win);o.add(A.Event.fromNodeEventEmitter(t,"close")(s=>{const a=S.id;if(this.r.has(a)){this.r.delete(a);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),s.preventDefault(),this.unload(S,y.UnloadReason.CLOSE).then(n=>{if(n){this.r.delete(a);return}this.r.add(a),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(S),S.close()})})),o.add(A.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,o.dispose(),this.t===0&&(!I.$j||this.j)&&this.L(m.QUIT)}))}registerAuxWindow(S){const o=(0,c.$lg)(S.win),t=new O.$Tc;t.add(A.Event.fromNodeEventEmitter(o,"close")(s=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),s.preventDefault())})),t.add(A.Event.fromNodeEventEmitter(o,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),t.dispose()}))}async reload(S,o){await this.unload(S,y.UnloadReason.RELOAD)||S.reload(o)}unload(S,o){const t=this.z.get(S.id);if(t)return t;const s=this.M(S,o).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,s),s}async M(S,o){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const t=this.j?y.UnloadReason.QUIT:o,s=await this.P(S,t);return s?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(s)):(await this.Q(S,t),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,o){return new Promise(t=>{const s=this.s++,a=`vscode:ok${s}`,n=`vscode:cancel${s}`;r.$sW.once(a,()=>{t(!1)}),r.$sW.once(n,()=>{t(!0)}),S.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:n,reason:o})})}Q(S,o){return new Promise(t=>{const a=`vscode:reply${this.s++}`;r.$sW.once(a,()=>t()),S.send("vscode:onWillUnload",{replyChannel:a,reason:o})})}quit(S){return this.R(S).then(o=>{if(!o&&S)try{if(I.$i){const t=(0,E.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.F.error(t)}return o})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(g.b,!0),this.u=new Promise(o=>{this.w=o,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const o=process.argv.slice(1);if(S?.addArgs&&o.push(...S.addArgs),S?.removeArgs)for(const a of S.removeArgs){const n=o.indexOf(a);n>=0&&o.splice(n,1)}const t=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:o}))};i.app.once("quit",t),await this.quit(!0)&&i.app.removeListener("quit",t)}async kill(S){this.S("Lifecycle#kill()"),await this.L(m.KILL),await Promise.race([(0,k.$Bh)(1e3),(async()=>{for(const o of i.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let t;o.webContents&&!o.webContents.isDestroyed()?t=new Promise(s=>o.once("closed",s)):t=Promise.resolve(),o.destroy(),await t}})()]),i.app.exit(S)}};e.$vdc=p,e.$vdc=p=g=Se([re(0,d.$7j),re(1,$.$dQ),re(2,h.$3cc)],p)}),define(ce[290],le([0,1,4,3,2,6,20]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0,e.$3dc=(0,A.$Ai)("keyboardLayoutMainService");let I=class extends k.$Uc{constructor(f){super(),this.a=this.B(new r.$he),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,f.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const f=await new Promise((d,$)=>{X(["native-keymap"],d,$)});this.c=E(f),i.$t||f.onDidChangeKeyboardLayout(()=>{this.c=E(f),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$4dc=I,e.$4dc=I=Se([re(0,O.$udc)],I);function E(c){const f=c.getKeyMap(),d=c.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:d}}}),define(ce[291],le([0,1,251,8,17,16,12,18,38,101,5,55,250,288]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$7r=m;let h=class extends d.$Wp{constructor(p,v,S,o){super(o),this.m=p,this.n=v,this.r=S,this.s(),this.B(p.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,v){const{f:S,g:o}=this;let t;try{t=await(0,c.$Lm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const s={...process.env,...t},a=p.agent?p.agent:await(0,$.$5r)(p.url||"",s,{proxyUrl:S,strictSSL:o});return p.agent=a,p.strictSSL=o,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>m(p,v))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((v,S)=>{X(["@vscode/proxy-agent"],v,S)})).loadSystemCertificates({log:this.r})}};e.$6r=h,e.$6r=h=Se([re(0,I.$7i),re(1,E.$Ii),re(2,f.$7j),re(3,f.$8j)],h);async function g(w){return((0,i.parse)(w.url).protocol==="https:"?await new Promise((S,o)=>{X(["https"],S,o)}):await new Promise((S,o)=>{X(["http"],S,o)})).request}async function m(w,p){return r.Promises.withAsyncBody(async(v,S)=>{const o=(0,i.parse)(w.url),t=w.getRawRequest?w.getRawRequest(w):await g(w),s={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,O.$gg)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(s.auth=w.user+":"+w.password);const a=t(s,n=>{const l=(0,O.$eg)(w.followRedirects)?w.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&l>0&&n.headers.location)m({...w,url:n.headers.location,followRedirects:l-1},p).then(v,S);else{let u=n;!w.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(u=n.pipe((0,y.createGunzip)())),v({res:n,stream:(0,k.$Ye)(u)})}});a.on("error",S),w.timeout&&a.setTimeout(w.timeout),w.isChromiumNetwork&&a.removeHeader("Content-Length"),w.data&&typeof w.data=="string"&&a.write(w.data),a.end(),p.onCancellationRequested(()=>{a.abort(),S(new A.$5)})})}}),define(ce[292],le([0,1,14,291]),function(X,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;function k(O){return i.net.request}class A extends r.$6r{request(I,E){return super.request({...I||{},getRawRequest:k,isChromiumNetwork:!0},E)}}e.$8ec=A}),define(ce[87],le([0,1,7,3,2,38,15,6,20,5,63,285,43,59,42,13]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=e.$Bdc=e.$Adc=void 0,e.$Adc=(0,I.$Ai)("storageMainService");let m=class extends k.$Uc{constructor(v,S,o,t,s,a){super(),this.c=v,this.f=S,this.g=o,this.h=t,this.j=s,this.m=a,this.a=void 0,this.b=this.B(new r.$he),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(E.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)v.join("profileStorage",S.close());for(const[,S]of this.w)v.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.j.exists(v.profile.globalStorageHome)||await this.j.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const S=this.t.get(v.profile.id);S&&v.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const v=new d.$xdc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),v}profileStorage(v){if((0,f.$_p)(v))return this.applicationStorage;let S=this.t.get(v.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),S=this.B(this.u(v)),this.t.set(v.id,S);const o=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:v})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.t.delete(v.id),o.dispose()}))}return S}u(v){return this.a===E.ShutdownReason.KILL?new d.$zdc(this.c,this.j):new d.$wdc(v,this.n(),this.c,this.j)}workspaceStorage(v){let S=this.w.get(v.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),S=this.B(this.y(v)),this.w.set(v.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.w.delete(v.id)}))),S}y(v){return this.a===E.ShutdownReason.KILL?new d.$zdc(this.c,this.j):new d.$ydc(v,this.n(),this.c,this.f,this.j)}isUsed(v){const S=i.URI.file(v);for(const o of[this.applicationStorage,...this.t.values(),...this.w.values()])if(o.path&&this.m.extUri.isEqualOrParent(i.URI.file(o.path),S))return!0;return!1}};e.$Bdc=m,e.$Bdc=m=Se([re(0,c.$7j),re(1,A.$Hi),re(2,y.$edc),re(3,E.$udc),re(4,O.$7k),re(5,h.$El)],m),e.$Cdc=(0,I.$Ai)("applicationStorageMainService");let w=class extends f.$$p{constructor(v,S){super(),this.s=v,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(v){if(v===f.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(v){if(v===f.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Ddc=w,e.$Ddc=w=Se([re(0,$.$Gl),re(1,e.$Adc)],w)}),define(ce[293],le([0,1,92,27,112,105,8,2,4,18,5,28,246,247,102,132,17]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=e.$4ec=void 0;async function w(t,s,a,n,l){let u;for(let b=3;b&&(u?.dispose(),u=await new p(t,s,a,n,l).waitForReady(),!(l&&k.$Zg[l]||!k.$Zg[u.tunnelLocalPort]));b--);return u}class p extends I.$Uc{constructor(s,a,n,l,u){super(),this.m=a,this.n=u,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=i.createServer(),this.c=new O.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,a=(0,g.$zw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,k.$1g)(s,2,1e3,a),l=null;return this.b.listen(n,this.m),await this.c.wait(),l=this.b.address(),l||(n=0,this.b.listen(n,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(s){s.pause();const a=(0,g.$xw)(this.tunnelRemoteHost)||(0,g.$zw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$Wl)(this.a,a,this.tunnelRemotePort),l=n.getSocket(),u=n.readEntireBuffer();n.dispose(),u.byteLength>0&&s.write(u.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),l.end()}),s.on("close",()=>l.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),l instanceof A.$pi?l.socket.destroy():l.end()}),l instanceof A.$pi?this.t(s,l):this.s(s,l),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),l.end()})}s(s,a){a.onClose(()=>s.destroy()),a.onEnd(()=>s.end()),a.onData(n=>s.write(n.buffer)),s.on("data",n=>a.write(m.$Je.wrap(n))),s.resume()}t(s,a){const n=a.socket;n.on("end",()=>s.end()),n.on("close",()=>s.end()),n.on("error",()=>{s.destroy()}),n.pipe(s),s.pipe(n)}}e.$4ec=p;let v=class extends g.$Cw{constructor(s,a,n,l,u){super(a,u),this.v=s,this.w=n,this.y=l}isPortPrivileged(s){return(0,g.$Aw)(s,this.m,E.OS,r.release())}t(s,a,n,l,u,b,P,R){const D=this.s(a,n);if(D)return++D.refcount,D.value;if((0,g.$tw)(s))return this.u(s,a,n,u,b,P,R);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${n} on local port ${u}.`);const T={commit:this.y.commit,quality:this.y.quality,addressProvider:s,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=w(T,l,a,n,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(a,n,j),j}}};e.$5ec=v,e.$5ec=v=Se([re(0,y.$Ql),re(1,f.$7j),re(2,h.$Tl),re(3,d.$nk),re(4,c.$7i)],v);let S=class extends v{constructor(s,a,n,l,u){super(s,a,n,l,u)}};e.$6ec=S,e.$6ec=S=Se([re(0,y.$Ql),re(1,f.$7j),re(2,h.$Tl),re(3,d.$nk),re(4,c.$7i)],S);let o=class extends I.$Uc{constructor(s,a,n,l,u){super(),this.b=s,this.c=a,this.f=n,this.g=l,this.h=u,this.a=new Map}async openTunnel(s,a,n,l,u,b,P,R,D){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${l} on local port ${b}.`),!this.a.has(s)){const T=new S(this.b,this.c,this.g,this.f,this.h);this.B(T),this.a.set(s,T),T.onTunnelClosed(async()=>{(await T.tunnels).length===0&&(T.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(a,n,l,u,b,P,R,D)}};e.$7ec=o,e.$7ec=o=Se([re(0,y.$Ql),re(1,f.$7j),re(2,d.$nk),re(3,h.$Tl),re(4,c.$7i)],o)}),define(ce[106],le([0,1,8,23,3,18,25,20,5,28,55,51]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0,e.$nec=$;function $(h,g,m){return`${m.updateUrl}/api/update/${h}/${g}/${m.commit}`}let y=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,m,w,p,v,S){this.f=g,this.g=m,this.h=w,this.i=p,this.j=v,this.k=S,this.b=d.$qX.Uninitialized,this.c=new k.$he,this.onStateChange=this.c.event,g.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$qX.Disabled(d.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(d.$qX.Disabled(d.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$qX.Disabled(d.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.g.getValue("update.mode"),m=this.m(g);if(!m){this.d(d.$qX.Disabled(d.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(m),!this.a){this.d(d.$qX.Disabled(d.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const w=new URL(this.a);w.searchParams.set("prss","true"),this.a=w.toString()}if(this.d(d.$qX.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,w=>this.j.error(w))}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,i.$Bh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(m){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(m);return}}async _applySpecificUpdate(g){}q(){return d.UpdateType.Archive}r(){}};e.$oec=y,e.$oec=y=Se([re(0,I.$udc),re(1,A.$7i),re(2,O.$3cc),re(3,f.$Vp),re(4,E.$7j),re(5,c.$nk)],y)}),define(ce[294],le([0,1,14,53,3,47,2,18,25,20,5,28,55,24,51,106]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let m=class extends g.$oec{get v(){return k.Event.fromNodeEventEmitter(i.autoUpdater,"error",(p,v)=>v)}get w(){return k.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(p,v,S,o)=>({version:S,productVersion:S,timestamp:o}))}constructor(p,v,S,o,t,s,a){super(p,v,o,t,s,a),this.z=S,this.u=new O.$Tc,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!==h.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(p){this.z.publicLog2("update:error",{messageHash:String((0,A.$oj)(String(p)))}),this.j.error("UpdateService error:",p);const v=this.state.type===h.StateType.CheckingForUpdates&&this.state.explicit?p:void 0;this.d(h.$qX.Idle(h.UpdateType.Archive,v))}s(p){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,g.$nec)(v,p,this.k);try{i.autoUpdater.setFeedURL({url:S})}catch(o){this.j.error("Failed to set update feed URL",o);return}return S}t(p){this.d(h.$qX.CheckingForUpdates(p)),i.autoUpdater.checkForUpdates()}E(){this.state.type===h.StateType.CheckingForUpdates&&this.d(h.$qX.Downloading)}F(p){this.state.type===h.StateType.Downloading&&(this.d(h.$qX.Downloaded(p)),this.z.publicLog2("update:downloaded",{version:p.version}),this.d(h.$qX.Ready(p)))}G(){this.state.type===h.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$qX.Idle(h.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$pec=m,Se([r.$5h],m.prototype,"v",null),Se([r.$5h],m.prototype,"w",null),Se([r.$5h],m.prototype,"x",null),Se([r.$5h],m.prototype,"y",null),e.$pec=m=Se([re(0,c.$udc),re(1,I.$7i),re(2,y.$6l),re(3,E.$3cc),re(4,$.$Vp),re(5,f.$7j),re(6,d.$nk)],m)}),define(ce[295],le([0,1,50,44,8,3,9,25,20,5,24,51]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let $=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,m,w){if(this.f=g,this.g=w,this.a=d.$qX.Uninitialized,this.b=new A.$he,this.onStateChange=this.b.event,m.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$qX.Idle(this.k())),this.h(30*1e3).then(void 0,p=>this.g.error(p))}h(g=60*60*1e3){return(0,k.$Bh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return d.UpdateType.Snap}l(){}async _applySpecificUpdate(g){}};$=Se([re(0,E.$udc),re(1,I.$3cc),re(2,c.$7j)],$);let y=class extends ${constructor(g,m,w,p,v,S){super(w,p,v),this.o=g,this.p=m,this.q=S;const o=(0,r.watch)(O.$mc(this.o)),t=A.Event.fromNodeEventEmitter(o,"change",(l,u)=>u),s=A.Event.filter(t,l=>l==="current"),n=A.Event.debounce(s,(l,u)=>u,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{n.dispose(),o.close()})}m(){this.d(d.$qX.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(d.$qX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$qX.Idle(d.UpdateType.Snap)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$qX.Idle(d.UpdateType.Snap,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+O.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((w,p)=>(0,r.realpath)(`${O.$mc(this.o)}/current`,(v,S)=>v?p(v):w(S))),m=O.$nc(g);return this.p!==m}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$rec=y,e.$rec=y=Se([re(2,E.$udc),re(3,I.$3cc),re(4,c.$7j),re(5,f.$6l)],y)}),define(ce[29],le([0,1,14,4,6,52,57,73,28,18,25,9,140]),function(X,e,i,r,k,A,O,I,E,c,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$bdc=void 0,e.$cdc=h,e.$ddc=g,e.$bdc=(0,k.$Ai)("windowsMainService");var y;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(y||(e.OpenContext=y={}));function h(w,p,v){const S=w.get(I.$_cc),o=w.get(E.$nk),t=w.get(c.$7i),s=w.get(f.$3cc),a=t.getValue("window"),n={backgroundColor:S.getBackgroundColor(),minWidth:O.$LD.WIDTH,minHeight:O.$LD.HEIGHT,title:o.nameLong,show:p.mode!==A.WindowMode.Maximized&&p.mode!==A.WindowMode.Fullscreen,x:p.x,y:p.y,width:p.width,height:p.height,webPreferences:{...v,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,O.$XD)(p.zoomLevel??a?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$k?n.icon=(0,d.$jc)(s.appRoot,"resources/linux/code.png"):r.$i&&!s.isBuilt&&(n.icon=(0,d.$jc)(s.appRoot,"resources/win32/code_150x150.png")),r.$j&&(n.acceptFirstMouse=!0,a?.clickThroughInactive===!1&&(n.acceptFirstMouse=!1)),r.$j&&!(0,O.$WD)(t)&&(n.fullscreenable=!1),r.$j&&a?.nativeTabs===!0&&(n.tabbingIdentifier=o.nameShort),!(0,O.$SD)(t)&&(n.titleBarStyle="hidden",r.$j||(n.frame=!1),(0,O.$VD)(t))){const b=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),P=$.$7s.fromHex(b).isDarker()?"#FFFFFF":"#000000";n.titleBarOverlay={height:29,color:b,symbolColor:P}}return n}function g(w){let p,v=Number.MIN_VALUE;for(const S of w)S.lastFocusTime>v&&(v=S.lastFocusTime,p=S);return p}var m;(function(w){function p(S,o,t=i.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,o),typeof o.x!="number"||typeof o.y!="number"||typeof o.width!="number"||typeof o.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(o.width<=0||o.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const n=v(t[0]);if(S.trace("window#validateWindowState: single monitor working area",n),n){let l=function(){!o||typeof o.x!="number"||typeof o.y!="number"||!n||(o.x<n.x&&(o.x=n.x),o.y<n.y&&(o.y=n.y))};l(),o.width>n.width&&(o.width=n.width),o.height>n.height&&(o.height=n.height),o.x>n.x+n.width-128&&(o.x=n.x+n.width-o.width),o.y>n.y+n.height-128&&(o.y=n.y+n.height-o.height),l()}return o}if(o.display&&o.mode===A.WindowMode.Fullscreen){const n=t.find(l=>l.id===o.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const l=(0,A.$1cc)(A.WindowMode.Fullscreen);return l.x=n.bounds.x,l.y=n.bounds.y,l}}let s,a;try{s=i.screen.getDisplayMatching({x:o.x,y:o.y,width:o.width,height:o.height}),a=v(s),S.trace("window#validateWindowState: multi-monitor working area",a)}catch(n){S.error("window#validateWindowState: error finding display for window state",n)}if(s&&a&&o.x+o.width>a.x&&o.y+o.height>a.y&&o.x<a.x+a.width&&o.y<a.y+a.height)return o;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}w.validateWindowState=p;function v(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(m||(e.WindowStateValidator=m={}))}),define(ce[296],le([0,1,14,23,3,47,2,33,97,5,63,87,29]),function(X,e,i,r,k,A,O,I,E,c,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends O.$Uc{constructor(m,w,p,v){super(),this.g=m,this.h=w,this.j=p,this.m=v,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const m=k.Event.fromNodeEventEmitter(i.app,"login",(w,p,v,S,o)=>({event:w,webContents:p,req:v,authInfo:S,callback:o}));this.B(m(this.r,this))}async r({event:m,authInfo:w,req:p,callback:v}){if(!w.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&p.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{S=await this.b}finally{this.b=void 0}}v(S?.username,S?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(m);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const w=String((0,A.$oj)({scheme:m.scheme,host:m.host,port:m.port}));let p,v;try{const s=this.m.get(this.a+w,f.StorageScope.APPLICATION);if(s){const a=JSON.parse(await this.j.decrypt(s));p=a.username,v=a.password}}catch(s){this.g.error(s)}if(this.c!==y.StoredCredentialsUsed&&typeof p=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:p,password:v};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const o={authInfo:m,username:this.f?.username??p,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,I.$Wg)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,o),this.c=y.LoginDialogShown;const t=await new Promise(s=>{const a=async(n,l,u)=>{if(l===o.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",a),u){const b={username:u.username,password:u.password};try{if(u.remember){const P=await this.j.encrypt(JSON.stringify(b));this.m.store(this.a+w,P,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.m.remove(this.a+w,f.StorageScope.APPLICATION)}catch(P){this.g.error(P)}s({username:b.username,password:b.password})}else s(void 0)};S.win?.webContents.on("ipc-message",a)});return this.f=t,t}};e.$Edc=h,e.$Edc=h=Se([re(0,c.$7j),re(1,$.$bdc),re(2,E.$bX),re(3,d.$Cdc)],h)}),define(ce[297],le([0,1,92,204,121,29]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class O extends r.$Po{constructor(E){super(),this.f=E}call(E,c,f){return c==="openExtensionDevelopmentHostWindow"?this.g(f[0],f[1]):super.call(E,c,f)}async g(E,c){const f=(0,k.$ym)(E,k.$xm);f.debugRenderer=c;const d=f.extensionDevelopmentPath;if(!d)return{success:!1};const[$]=await this.f.openExtensionDevelopmentHostWindow(d,{context:A.OpenContext.API,cli:f,forceProfile:f.profile,forceTempProfile:f["profile-temp"]});if(!c)return{success:!0};const y=$.win;if(!y)return{success:!0};const h=y.webContents.debugger;let g=h.isAttached()?1/0:0;const m=(0,i.createServer)(w=>{g++===0&&h.attach();let p=!1;const v=t=>{p||w.write(JSON.stringify(t)+"\0")},S=(t,s,a,n)=>v({method:s,params:a,sessionId:n});y.on("close",()=>{h.removeListener("message",S),w.end(),p=!0}),h.addListener("message",S);let o=Buffer.alloc(0);w.on("data",t=>{o=Buffer.concat([o,t]);for(let s=o.indexOf(0);s!==-1;s=o.indexOf(0)){let a;try{const n=o.slice(0,s).toString("utf8");o=o.slice(s+1),a=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(a.method,a.params,a.sessionId).then(n=>v({id:a.id,sessionId:a.sessionId,result:n})).catch(n=>v({id:a.id,sessionId:a.sessionId,error:{code:0,message:n.message}}))}}),w.on("error",t=>{console.error("error on cdp pipe:",t)}),w.on("close",()=>{p=!0,--g===0&&h.detach()})});return await new Promise(w=>m.listen(0,w)),y.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$Gdc=O}),define(ce[298],le([0,1,14,22,4,7,21,18,67,6,5,133,29]),function(X,e,i,r,k,A,O,I,E,c,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.ID=void 0,e.ID="launchMainService",e.$6dc=(0,c.$Ai)(e.ID);let y=class{constructor(g,m,w,p){this.a=g,this.b=m,this.c=w,this.d=p}async start(g,m){this.a.trace("Received data from other instance: ",g,m),k.$j&&i.app.focus({steal:!0});const w=this.e(g);if(w.length){let p=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,r.$Ob)(await this.b.openEmptyWindow({context:$.OpenContext.DESKTOP}));v&&(p=v.ready())}p.then(()=>{for(const{uri:v,originalUrl:S}of w)this.c.open(v,{originalUrl:S})})}else return this.f(g,m)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,r.$Hb)(g._urls.map(m=>{try{return{uri:A.URI.parse(m),originalUrl:m}}catch{return null}})):[]}async f(g,m){const w=(0,E.$Fm)(m)?$.OpenContext.CLI:$.OpenContext.DESKTOP;let p=[];const v=g.wait&&g.waitMarkerFilePath?A.URI.file(g.waitMarkerFilePath):void 0,S=g.remote||void 0,o={context:w,cli:g,userEnv:g["preserve-env"]||w===$.OpenContext.CLI?m:void 0,waitMarkerFileURI:v,remoteAuthority:S,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,o);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let t=!1;if(g["new-window"]||o.forceProfile||o.forceTempProfile)t=!0;else if(g["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!k.$j}if(t)p=await this.b.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const s=this.b.getLastActiveWindow();s?(this.b.openExistingWindow(s,o),p=[s]):p=await this.b.open({...o,forceEmpty:!0})}}else p=await this.b.open({...o,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(v&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,O.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$7dc=y,e.$7dc=y=Se([re(0,f.$7j),re(1,$.$bdc),re(2,d.$hX),re(3,I.$7i)],y)}),define(ce[299],le([0,1,2,20,52,59,30,8,29]),function(X,e,i,r,k,A,O,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;let c=class extends i.$Uc{constructor(d,$,y){super(),this.a=$,this.b=y,this.B(d.onWillLoadWindow(h=>{h.reason===k.LoadReason.LOAD&&this.c(h.window)})),this.B(d.onBeforeCloseWindow(h=>this.c(h))),this.B(new I.$Mh(()=>this.g(),30*1e3)).schedule()}async c(d){const $=this.f(d),y=this.a.getProfileForWorkspace($);y?.isTransient&&(this.a.unsetWorkspace($,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,O.$Oi)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const $=this.b.getWindows().map(y=>this.f(y));for(const y of d)$.some(h=>h.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$Jec=c,e.$Jec=c=Se([re(0,r.$udc),re(1,A.$edc),re(2,E.$bdc)],c)}),define(ce[64],le([0,1,14,2,3,5,319,8,13,29,79,24,20,80,35,4,107]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=void 0;function p(o){return typeof o.responseWindowId=="number"}let v=class extends r.$Uc{static{w=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(w.b.values())}constructor(t,s,a){super(),this.w=t,this.y=s,this.z=a,this.c=String(++w.a),this.f=this.B(new k.$he),this.onStdout=this.f.event,this.g=this.B(new k.$he),this.onStderr=this.g.event,this.h=this.B(new k.$he),this.onMessage=this.h.event,this.j=this.B(new k.$he),this.onSpawn=this.j.event,this.m=this.B(new k.$he),this.onExit=this.m.event,this.n=this.B(new k.$he),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,s){let a;switch(this.t?.correlationId?a=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:a=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,s){case f.default.Error:this.w.error(a);break;case f.default.Warning:this.w.warn(a);break;case f.default.Info:this.w.trace(a);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",f.default.Error),!1):!0}start(t){const s=this.F(t);return s&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",f.default.Info),s}F(t){if(!this.D())return!1;this.t=t;const s=`${this.t.type}-${this.c}`,a=E.$Ug.asFileUri("bootstrap-fork.js").fsPath,n=this.t.args??[],l=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,P="pipe",R=this.G(t);return this.C("creating new...",f.default.Info),this.r=i.utilityProcess.fork(a,n,{serviceName:s,env:R,execArgv:l,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:b,stdio:P}),this.H(this.r,this.t,s),!0}G(t){const s=t.env?{...t.env}:{...(0,h.$9n)(process.env)};s.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(s.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),s.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,g.$i&&((0,m.isUNCAccessRestrictionsDisabled)()?s.NODE_DISABLE_UNC_ACCESS_CHECKS="1":s.NODE_UNC_HOST_ALLOWLIST=(0,m.getUNCHostAllowlist)().join("\\")),(0,y.$sm)(s);for(const a of Object.keys(s))s[a]=String(s[a]);return s}H(t,s,a){if(t.stdout){const n=new O.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stdout,"data")(l=>this.f.fire(typeof l=="string"?l:n.write(l))))}if(t.stderr){const n=new O.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stderr,"data")(l=>this.g.fire(typeof l=="string"?l:n.write(l))))}this.B(k.Event.fromNodeEventEmitter(t,"message")(n=>this.h.fire(n))),this.B(k.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&w.b.set(t.pid,{pid:t.pid,name:p(s)?`${s.type} [${s.responseWindowId}]`:s.type}),this.C("successfully created",f.default.Info),this.j.fire(t.pid)})),this.B(k.Event.fromNodeEventEmitter(t,"exit")(n=>{const l=this.I(n)?0:n;this.C(`received exit event with code ${l}`,f.default.Info),this.m.fire({pid:this.s,code:l,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(i.app,"child-process-gone",(n,l)=>({event:n,details:l}))(({details:n})=>{n.type==="Utility"&&n.name===a&&!this.I(n.exitCode)&&(this.C(`crashed with code ${n.exitCode} and reason '${n.reason}'`,f.default.Error),this.y.publicLog2("utilityprocesscrash",{type:s.type,reason:n.reason,code:n.exitCode}),this.n.fire({pid:this.s,code:n.exitCode,reason:n.reason}),this.J())}))}once(t,s){const a=this.B(this.h.event(n=>{n===t&&(a.dispose(),s())}))}postMessage(t,s){return this.r?(this.r.postMessage(t,s),!0):!1}connect(t){const{port1:s,port2:a}=new i.MessageChannelMain;return this.postMessage(t,[a]),s}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",f.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",f.default.Info),this.r.kill()?(this.C("successfully killed the process",f.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",f.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&w.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",f.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,I.$Bh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,f.default.Info),this.kill()))}};e.$Hdc=v,e.$Hdc=v=w=Se([re(0,A.$7j),re(1,d.$6l),re(2,$.$udc)],v);let S=class extends v{constructor(t,s,a,n){super(t,a,n),this.L=s}start(t){const s=this.L.getWindowById(t.responseWindowId);if(!s?.win||s.win.isDestroyed()||s.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",f.default.Error),!0;if(!super.F(t))return!1;this.M(s.win,t);const n=this.connect(t.payload);return s.win.webContents.postMessage(t.responseChannel,t.responseNonce,[n]),!0}M(t,s){s.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,a=>a.window.win===t)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Idc=S,e.$Idc=S=Se([re(0,A.$7j),re(1,c.$bdc),re(2,d.$6l),re(3,$.$udc)],S)}),define(ce[300],le([0,1,16,3,5,20,8,64,29,24]),function(X,e,i,r,k,A,O,I,E,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;let d=class{static{f=this}static{this.a=0}constructor(y,h,g,m){this.d=y,this.f=h,this.g=g,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const h=this.b.get(y);if(!h)throw new Error("Unknown extension host!");return h}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,i.$6)();const y=String(++f.a),h=new I.$Idc(this.d,this.g,this.h,this.f);return this.b.set(y,h),h.onExit(({pid:g,code:m,signal:w})=>{this.d.info(`Extension host with pid ${g} exited with code: ${m}, signal: ${w}.`),setTimeout(()=>{h.dispose(),this.b.delete(y)}),setTimeout(()=>{try{process.kill(g,0),this.d.error(`Extension host with pid ${g} still exists, forcefully killing it...`),process.kill(g)}catch{}},1e3)}),{id:y}}async start(y,h){if(this.c)throw(0,i.$6)();const g=this.i(y);return g.start({...h,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:h.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y}),{pid:await r.Event.toPromise(g.onSpawn)}}async enableInspectPort(y){if(this.c)throw(0,i.$6)();const h=this.b.get(y);return h?h.enableInspectPort():!1}async kill(y){if(this.c)throw(0,i.$6)();const h=this.b.get(y);h&&h.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const h=[];for(const[,g]of this.b)h.push(g.waitForExit(y));return O.Promises.settled(h).then(()=>{})}};e.$Pdc=d,e.$Pdc=d=f=Se([re(0,k.$7j),re(1,A.$udc),re(2,E.$bdc),re(3,c.$6l)],d)}),define(ce[301],le([0,1,37,8,2,25,20,5,43,41,70,64,56,95,12,252,3]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;let w=class extends k.$Uc{constructor(v,S,o,t,s,a,n,l,u){super(),this.g=v,this.h=S,this.j=o,this.m=t,this.n=s,this.r=a,this.s=n,this.t=l,this.u=u,this.a=new r.$zh,this.b=void 0,this.c=void 0,this.f=this.B(new m.$he),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$sW.on(g.$fec.request,(v,S)=>this.y(v,S,g.$fec.response)),i.$sW.on(g.$gec.request,(v,S)=>this.y(v,S,g.$gec.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(v,S,o){this.s.trace(`[SharedProcess] onWindowConnection for: ${o}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(o);if(v.sender.isDestroyed())return t.close();v.sender.postMessage(o,S,[t])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(g.$eec.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const v=new r.$Xh;this.b?.once(g.$eec.initDone,()=>v.complete()),await v.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const v=new r.$Xh;this.b?.once(g.$eec.ipcReady,()=>v.complete()),await v.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new d.$Hdc(this.s,$.$pp,this.r)),this.c=this.b.onMessage(o=>{typeof o.warning=="string"?this.s.warn(o.warning):typeof o.error=="string"&&this.s.error(o.error)});const v=(0,y.$dn)(this.m.args,this.m.isBuilt);let S;v.port&&(S=["--nolazy"],v.break?S.push(`--inspect-brk=${v.port}`):S.push(`--inspect=${v.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(v){return await this.F,(0,h.$lg)(this.b).connect(v)}};e.$hec=w,e.$hec=w=Se([re(3,A.$3cc),re(4,E.$Gl),re(5,O.$udc),re(6,I.$7j),re(7,f.$pdc),re(8,c.$lo)],w)}),define(ce[302],le([0,1,25,95,20,5,56,72,64,119,37,2,3,35,18,13]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;let m=class extends d.$Uc{constructor(p,v,S,o,t){super(),this.f=p,this.g=v,this.h=S,this.j=o,this.m=t,this.a=void 0,this.b=new $.$he,this.onRequestConnection=this.b.event,this.c=new $.$he,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),f.$sW.on("vscode:createPtyHostMessageChannel",(s,a)=>this.r(s,a)),this.B((0,d.$Sc)(()=>{f.$sW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$Hdc(this.m,O.$pp,this.j);const p=(0,r.$cn)(this.h.args,this.h.isBuilt),v=p.port?["--nolazy",`--inspect${p.break?"-brk":""}=${p.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:v,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),o=new c.$AW(S,"ptyHost"),t=new d.$Tc;return t.add(o),t.add((0,d.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:o,store:t,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const p={...(0,y.$9n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},v=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);v&&typeof v=="number"&&(p.VSCODE_LATENCY=String(v));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&(p.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),p}r(p,v){this.b.fire();const S=this.a.connect();if(p.sender.isDestroyed()){S.close();return}p.sender.postMessage("vscode:createPtyHostMessageChannelResult",v,[S])}};e.$Vec=m,e.$Vec=m=Se([re(1,h.$7i),re(2,i.$3cc),re(3,k.$udc),re(4,A.$7j)],m)}),define(ce[303],le([0,1,2,6,5,29,64,24,47,3,8,20]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0,e.$Tec=(0,r.$Ai)("utilityProcessWorker");let $=class extends i.$Uc{constructor(g,m,w,p){super(),this.b=g,this.c=m,this.f=w,this.g=p,this.a=new Map}async createWorker(g){const m=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${m})`);const w=this.h(g);this.a.has(w)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${m})`),this.disposeWorker(g));const p=new y(this.b,this.c,this.f,this.g,g);if(!p.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(w,p);const v=new f.$Xh;return c.Event.once(p.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(w),v.complete({reason:S})}),v.p}h(g){return(0,E.$oj)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const m=this.h(g),w=this.a.get(m);w&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),w.kill(),w.dispose(),this.a.delete(m))}};e.$Uec=$,e.$Uec=$=Se([re(0,k.$7j),re(1,A.$bdc),re(2,I.$6l),re(3,d.$udc)],$);let y=class extends i.$Uc{constructor(g,m,w,p,v){super(),this.c=g,this.f=m,this.g=w,this.h=p,this.j=v,this.a=this.B(new c.$he),this.onDidTerminate=this.a.event,this.b=this.B(new O.$Idc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(g=>this.a.fire({code:g.code,signal:g.signal}))),this.B(this.b.onCrash(g=>this.a.fire({code:g.code,signal:"ECRASH"})))}spawn(){const m=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:m,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};y=Se([re(0,k.$7j),re(1,A.$bdc),re(2,I.$6l),re(3,d.$udc)],y)}),define(ce[304],le([0,1,14,3,2,277,29]),function(X,e,i,r,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;let I=class extends k.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new r.$he),this.onFoundInFrame=this.a.event,this.B(new A.$yec)}async setIgnoreMenuShortcuts(c,f){let d;if(typeof c.windowId=="number"){const{windowId:$}=c,y=this.b.getWindowById($);if(!y?.win)throw new Error(`Invalid windowId: ${$}`);d=y.win.webContents}else{const{webContentsId:$}=c;if(d=i.webContents.fromId($),!d)throw new Error(`Invalid webContentsId: ${$}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts(f)}async findInFrame(c,f,d,$){const h=this.c(c,f);if(typeof h.findInFrame=="function"){h.findInFrame(d,{findNext:$.findNext,forward:$.forward});const g=(m,w)=>{w.finalUpdate&&(this.a.fire(w),h.removeListener("found-in-frame",g))};h.on("found-in-frame",g)}}async stopFindInFrame(c,f,d){const y=this.c(c,f);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(c,f){const d=this.b.getWindowById(c.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${c}`);const $=d.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===f);if(!$)throw new Error(`Unknown frame: ${f}`);return $}};e.$zec=I,e.$zec=I=Se([re(0,O.$bdc)],I)}),define(ce[305],le([0,1,14,2,4,19,7,18,20,5,34,29,52,30]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0,e.$Bec=m,e.$Cec=p;let g=class extends r.$Uc{static{h=this}static{this.a="windowsState"}get state(){return this.b}constructor(o,t,s,a,n){super(),this.g=o,this.h=t,this.j=s,this.m=a,this.n=n,this.b=m(this.h.getItem(h.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(o=>this.u(o)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(o=>{o.newCount-o.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(o=>this.u(o))}s(){this.f=!0,this.t()}t(){const o=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(l=>!l.isExtensionDevelopmentHost)),n&&(t.lastActiveWindow=this.w(n),t.lastActiveWindow.uiState.mode===$.WindowMode.Fullscreen&&o.add(t.lastActiveWindow.uiState.display))}const s=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);s&&(t.lastPluginDevelopmentHostWindow=this.w(s),t.lastPluginDevelopmentHostWindow.uiState.mode===$.WindowMode.Fullscreen&&(o.has(t.lastPluginDevelopmentHostWindow.uiState.display)?k.$j&&!s.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=$.WindowMode.Normal):o.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const l=this.w(n);return l.uiState.mode===$.WindowMode.Fullscreen&&(o.has(l.uiState.display)?k.$j&&l.windowId!==t.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(l.uiState.mode=$.WindowMode.Normal):o.add(l.uiState.display)),l}));const a=p(t);this.h.setItem(h.a,a),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",a)}u(o){if(this.j.quitRequested)return;const t=this.w(o);o.isExtensionDevelopmentHost&&!o.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!o.isExtensionDevelopmentHost&&o.openedWorkspace&&this.b.openedWindows.forEach(s=>{const a=(0,y.$Pi)(o.openedWorkspace)&&s.workspace?.id===o.openedWorkspace.id,n=(0,y.$Ki)(o.openedWorkspace)&&s.folderUri&&A.$5g.isEqual(s.folderUri,o.openedWorkspace.uri);(a||n)&&(s.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(o){return{windowId:o.id,workspace:(0,y.$Pi)(o.openedWorkspace)?o.openedWorkspace:void 0,folderUri:(0,y.$Ki)(o.openedWorkspace)?o.openedWorkspace.uri:void 0,backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.serializeWindowState()}}getNewWindowState(o){const t=this.z(o),s=this.n.getValue("window");if(t.mode===$.WindowMode.Fullscreen){let a;t.hasDefaultState?a=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):a=!!(this.j.wasRestarted||s?.restoreFullscreen),a||(t.mode=$.WindowMode.Normal)}return t}z(o){const t=this.g.getLastActiveWindow();if(!o.extensionTestsPath){if(o.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=o.workspace;if((0,y.$Pi)(b)){const R=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===b.id).map(D=>D.uiState);if(R.length)return R[0]}if((0,y.$Ki)(b)){const R=this.state.openedWindows.filter(D=>D.folderUri&&A.$5g.isEqual(D.folderUri,b.uri)).map(D=>D.uiState);if(R.length)return R[0]}else if(o.backupPath){const R=this.state.openedWindows.filter(D=>D.backupPath===o.backupPath).map(D=>D.uiState);if(R.length)return R[0]}const P=this.c||this.state.lastActiveWindow;if(!t&&P)return P.uiState}let s;const a=i.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(k.$j){const b=i.screen.getCursorScreenPoint();s=i.screen.getDisplayNearestPoint(b)}!s&&t&&(s=i.screen.getDisplayMatching(t.getBounds())),s||(s=i.screen.getPrimaryDisplay()||a[0])}let n=(0,$.$1cc)();n.x=Math.round(s.bounds.x+s.bounds.width/2-n.width/2),n.y=Math.round(s.bounds.y+s.bounds.height/2-n.height/2);const l=this.n.getValue("window");let u=!0;if(l?.newWindowDimensions){if(l.newWindowDimensions==="maximized")n.mode=$.WindowMode.Maximized,u=!1;else if(l.newWindowDimensions==="fullscreen")n.mode=$.WindowMode.Fullscreen,u=!1;else if((l.newWindowDimensions==="inherit"||l.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===$.WindowMode.Fullscreen?n.mode=$.WindowMode.Fullscreen:n={...b,zoomLevel:void 0},u=n.mode!==$.WindowMode.Fullscreen&&l.newWindowDimensions==="offset"}}return u&&(n=this.C(n)),n.hasDefaultState=!0,n}C(o){if(this.g.getWindows().length===0)return o;o.x=typeof o.x=="number"?o.x:0,o.y=typeof o.y=="number"?o.y:0;const t=this.g.getWindows().map(s=>s.getBounds());for(;t.some(s=>s.x===o.x||s.y===o.y);)o.x+=30,o.y+=30;return o}};e.$Aec=g,e.$Aec=g=h=Se([re(0,d.$bdc),re(1,f.$dQ),re(2,E.$udc),re(3,c.$7j),re(4,I.$7i)],g);function m(S){const o={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(o.lastActiveWindow=w(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(o.lastPluginDevelopmentHostWindow=w(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(o.openedWindows=t.openedWindows.map(s=>w(s))),o}function w(S){const o={uiState:S.uiState};return S.backupPath&&(o.backupPath=S.backupPath),S.remoteAuthority&&(o.remoteAuthority=S.remoteAuthority),S.folder&&(o.folderUri=O.URI.parse(S.folder)),S.workspaceIdentifier&&(o.workspace={id:S.workspaceIdentifier.id,configPath:O.URI.parse(S.workspaceIdentifier.configURIPath)}),o}function p(S){return{lastActiveWindow:S.lastActiveWindow&&v(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&v(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(o=>v(o))}}function v(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(ce[60],le([0,1,14,3,40,2,13,9,19,21,200,68,58,25,6,5,59,135,30,103,104]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0,e.$ndc=(0,h.$Ai)("workspacesManagementMainService");let o=class extends A.$Uc{constructor(s,a,n,l,u){super(),this.g=s,this.h=a,this.j=n,this.m=l,this.n=u,this.a=this.B(new r.$he),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new r.$he),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await c.Promises.readdir(this.c.with({scheme:O.Schemas.file}).fsPath)).map(a=>(0,E.$bh)(this.c,a,p.$Zi));for(const a of s){const n=(0,S.$kdc)(a),l=await this.resolveLocalWorkspace(a);l?this.f.push({workspace:n,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.r(s,a=>c.Promises.readFile(a,"utf8"))}r(s,a){if(this.s(s)&&s.scheme===O.Schemas.file)try{const n=a(s.fsPath);return n instanceof Promise?n.then(l=>this.t(s,l),l=>{}):this.t(s,n)}catch{return}}s(s){return(0,p.$1i)(s,this.g)||(0,p.$6i)(s)}t(s,a){try{const n=this.u(s,a),l=(0,S.$kdc)(s);return{id:l.id,configPath:l.configPath,folders:(0,v.$ogb)(n.folders,l.configPath,E.$5g),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}u(s,a){const n=(0,k.$Pn)(a);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(l=>(0,v.$mgb)(l));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(s,a){const{workspace:n,storedWorkspace:l}=this.w(s,a),u=n.configPath.fsPath;return await c.Promises.mkdir((0,I.$mc)(u),{recursive:!0}),await c.Promises.writeFile(u,JSON.stringify(l,null,"	")),this.f.push({workspace:n,remoteAuthority:a}),n}w(s=[],a){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,E.$bh)(this.c,n),u=(0,E.$bh)(l,p.$Zi),b=[];for(const P of s)b.push((0,v.$ngb)(P.uri,!0,P.name,l,E.$5g));return{workspace:(0,S.$kdc)(u),storedWorkspace:{folders:b,remoteAuthority:a}}}async getWorkspaceIdentifier(s){return(0,S.$kdc)(s)}isUntitledWorkspace(s){return(0,p.$1i)(s.configPath,this.g)}async deleteUntitledWorkspace(s){this.isUntitledWorkspace(s)&&(await this.y(s),this.j.isEnabled()&&this.j.unsetWorkspace(s),this.a.fire(s))}async y(s){const a=(0,E.$2g)(s.configPath);try{await c.Promises.rm((0,I.$mc)(a));const n=(0,I.$jc)(this.g.workspaceStorageHome.with({scheme:O.Schemas.file}).fsPath,s.id);await c.Promises.exists(n)&&await c.Promises.writeFile((0,I.$jc)(n,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==s.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${a} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,a,n){if(!s||!s.win||!s.isReady||!await this.z(s,a,n))return;const u=await this.C(s,(0,S.$kdc)(n));if(u)return this.b.fire({window:s,workspace:u.workspace}),u}async z(s,a,n){return n?(0,p.$Pi)(s.openedWorkspace)&&E.$5g.isEqual(s.openedWorkspace.configPath,n)?!1:(0,w.$hdc)(a,n)?(await this.n.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,E.$$g)(n)),detail:(0,f.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(s,a){if(!s.config)return;s.focus();let n;return s.config.extensionDevelopmentPath||(s.config.backupPath?n=await this.m.registerWorkspaceBackup({workspace:a,remoteAuthority:s.remoteAuthority},s.config.backupPath):n=this.m.registerWorkspaceBackup({workspace:a,remoteAuthority:s.remoteAuthority})),(0,p.$Pi)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=a,s.config.backupPath=n,{workspace:a,backupPath:n}}};e.$odc=o,e.$odc=o=Se([re(0,y.$3cc),re(1,g.$7j),re(2,m.$edc),re(3,d.$8cc),re(4,$.$9cc)],o)}),define(ce[136],le([0,1,14,37,23,6,29,30,60,12,5,64]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Kdc=(0,A.$Ai)(e.ID);let $=class{constructor(h,g,m){this.a=h,this.b=g,this.c=m}async getRemoteDiagnostics(h){const g=this.a.getWindows();return(await Promise.all(g.map(async w=>{const p=w.remoteAuthority;if(!p)return;const v=`vscode:getDiagnosticInfoResponse${w.id}`,S={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(w):void 0};return new Promise(o=>{w.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:S}),r.$sW.once(v,(t,s)=>{s||o({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),o(s)}),setTimeout(()=>{o({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(w=>!!w)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const m of i.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(m.id);w?h.push(await this.d(w)):h.push(this.e(m))}const g=[];for(const{pid:m,name:w}of d.$Hdc.getAll())g.push({pid:m,name:w});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,pidToNames:g,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(h){const g=await this.f(h),m=(0,c.$lg)(h.win);return this.e(m,g,h.remoteAuthority)}e(h,g=[],m){return{id:h.id,pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:g,remoteAuthority:m}}async f(h){const g=[],m=h.openedWorkspace;if((0,I.$Ki)(m))g.push(m.uri);else if((0,I.$Pi)(m)){const w=await this.b.resolveLocalWorkspace(m.configPath);w&&w.folders.forEach(v=>{g.push(v.uri)})}return g}};e.$Ldc=$,e.$Ldc=$=Se([re(0,O.$bdc),re(1,E.$ndc),re(2,f.$7j)],$)}),define(ce[74],le([0,1,50,14,27,161,53,3,2,13,9,4,7,114,93,21,112,188,58,25,6,20,5,28,73,29,30,60,17,248,240,83,16]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0,e.$Zdc=(0,S.$Ai)("nativeHostMainService");let j=class extends E.$Uc{constructor(W,C,z,se,ie,oe,K,te,q){super(),this.a=W,this.b=C,this.c=z,this.f=se,this.g=ie,this.h=oe,this.j=K,this.m=te,this.n=q,this.onDidOpenMainWindow=I.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:B,y:V})=>({windowId:L.id,x:B,y:V})),I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:B,y:V})=>({windowId:L.id,x:B,y:V}))),this.onDidMaximizeWindow=I.Event.any(I.Event.map(this.a.onDidMaximizeWindow,L=>L.id),I.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=I.Event.any(I.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),I.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=I.Event.any(I.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),I.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(L,B)=>B.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(L,B)=>B.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(r.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new I.$he),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(r.screen,"display-metrics-changed",(L,B,V)=>V),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),I.Event.fromNodeEventEmitter(r.screen,"display-added"),I.Event.fromNodeEventEmitter(r.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,C){const z=this.a.getWindows().map(ie=>({id:ie.id,workspace:ie.openedWorkspace??(0,l.$Oi)(ie.backupPath,ie.isExtensionDevelopmentHost),title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename(),dirty:ie.isDocumentEdited()})),se=[];return C.includeAuxiliaryWindows&&se.push(...this.b.getWindows().map(ie=>({id:ie.id,parentId:ie.parentId,title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename()}))),[...z,...se]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const C=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(C)return C.id}openWindow(W,C,z){return Array.isArray(C)?this.s(W,C,z):this.t(W,C)}async s(W,C,z=Object.create(null)){C.length>0&&await this.a.open({context:n.OpenContext.API,contextWindowId:W,urisToOpen:C,cli:this.g.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async t(W,C){await this.a.openEmptyWindow({context:n.OpenContext.API,contextWindowId:W},C)}async isFullScreen(W,C){return this.C(C?.targetWindowId,W)?.isFullScreen??!1}async toggleFullScreen(W,C){this.C(C?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,C){this.C(C?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const C=r.screen.getCursorScreenPoint(),z=r.screen.getDisplayNearestPoint(C);return{point:C,display:z.bounds}}async isMaximized(W,C){return this.C(C?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,C){this.C(C?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,C){this.C(C?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,C){this.C(C?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,C){this.C(C?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,C,z){const se=this.C(z?.targetWindowId,W);if(se?.win){if(se.win.isFullScreen()){const ie=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(se.win,"leave-full-screen")));se.win.setFullScreen(!1),await ie}se.win.setBounds(C)}}async updateWindowControls(W,C){this.C(C?.targetWindowId,W)?.updateWindowControls(C)}async focusWindow(W,C){this.C(C?.targetWindowId,W)?.focus({force:C?.force??!1})}async setMinimumSize(W,C,z){const se=this.D(W);if(se?.win){const[ie,oe]=se.win.getSize(),[K,te]=se.win.getMinimumSize(),[q,L]=[C??K,z??te],[B,V]=[Math.max(ie,q),Math.max(oe,L)];(K!==q||te!==L)&&se.win.setMinimumSize(q,L),(ie!==B||oe!==V)&&se.win.setSize(B,V)}}async saveWindowSplash(W,C){this.m.saveWindowSplash(W,C)}async installShellCommand(W){const{source:C,target:z}=await this.u();try{const{symbolicLink:se}=await g.SymlinkSupport.stat(C);if(se&&!se.dangling){const ie=await(0,y.$br)(C);if(z===ie)return}await g.Promises.unlink(C)}catch(se){if(se.code!=="ENOENT")throw se}try{await g.Promises.symlink(z,C)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ie}=await this.showMessageBox(W,{type:"info",message:(0,w.localize)(0,null,this.j.nameShort),buttons:[(0,w.localize)(1,null),(0,w.localize)(2,null)]});if(ie===1)throw new T.$5;try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${C}'\\" with administrator privileges"`;await(0,A.promisify)(i.exec)(oe)}catch{throw new Error((0,w.localize)(3,null,C))}}}async uninstallShellCommand(W){const{source:C}=await this.u();try{await g.Promises.unlink(C)}catch(z){switch(z.code){case"EACCES":{const{response:se}=await this.showMessageBox(W,{type:"info",message:(0,w.localize)(4,null,this.j.nameShort),buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null)]});if(se===1)throw new T.$5;try{const ie=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,A.promisify)(i.exec)(ie)}catch{throw new Error((0,w.localize)(7,null,C))}break}case"ENOENT":break;default:throw z}}}async u(){const W=(0,f.$kc)(this.g.appRoot,"bin","code"),C=`/usr/local/bin/${this.j.applicationName}`;if(!await g.Promises.exists(W))throw new Error((0,w.localize)(8,null,W));return{source:C,target:W}}async showMessageBox(W,C){const z=this.C(C?.targetWindowId,W);return this.c.showMessageBox(C,z?.win??void 0)}async showSaveDialog(W,C){const z=this.C(C?.targetWindowId,W);return this.c.showSaveDialog(C,z?.win??void 0)}async showOpenDialog(W,C){const z=this.C(C?.targetWindowId,W);return this.c.showOpenDialog(C,z?.win??void 0)}async pickFileFolderAndOpen(W,C){const z=await this.c.pickFileFolder(C);z&&await this.w(await Promise.all(z.map(async se=>await g.SymlinkSupport.existsDirectory(se)?{folderUri:$.URI.file(se)}:{fileUri:$.URI.file(se)})),C,W)}async pickFolderAndOpen(W,C){const z=await this.c.pickFolder(C);z&&await this.w(z.map(se=>({folderUri:$.URI.file(se)})),C,W)}async pickFileAndOpen(W,C){const z=await this.c.pickFile(C);z&&await this.w(z.map(se=>({fileUri:$.URI.file(se)})),C,W)}async pickWorkspaceAndOpen(W,C){const z=await this.c.pickWorkspace(C);z&&await this.w(z.map(se=>({workspaceUri:$.URI.file(se)})),C,W)}async w(W,C,z){await this.a.open({context:n.OpenContext.DIALOG,contextWindowId:z,cli:this.g.args,urisToOpen:W,forceNewWindow:C.forceNewWindow})}async showItemInFolder(W,C){r.shell.showItemInFolder(C)}async setRepresentedFilename(W,C,z){this.C(z?.targetWindowId,W)?.setRepresentedFilename(C)}async setDocumentEdited(W,C,z){this.C(z?.targetWindowId,W)?.setDocumentEdited(C)}async openExternal(W,C){return this.g.unsetSnapExportedVariables(),r.shell.openExternal(C),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,C){return r.shell.trashItem(C)}async isAdmin(){let W;return d.$i?W=(await new Promise((C,z)=>{X(["native-is-elevated"],C,z)}))():W=process.getuid?.()===0,W}async writeElevated(W,C,z,se){const ie=await new Promise((oe,K)=>{X(["@vscode/sudo-prompt"],oe,K)});return new Promise((oe,K)=>{const te=[`"${this.z}"`];se?.unlock&&te.push("--file-chmod"),te.push("--file-write",`"${C.fsPath}"`,`"${z.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:d.$j&&this.g.isBuilt?(0,f.$jc)((0,f.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ie.exec(te.join(" "),q,(L,B,V)=>{B&&this.h.trace(`[sudo-prompt] received stdout: ${B}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),L?K(L):oe(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:r.app.runningUnderARM64Translation}get z(){return d.$i?this.g.isBuilt?(0,f.$jc)((0,f.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,f.$jc)(this.g.appRoot,"scripts","code-cli.bat"):d.$k?this.g.isBuilt?(0,f.$jc)((0,f.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,f.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,f.$jc)(this.g.appRoot,"bin","code"):(0,f.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return h.$Jn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,P.$Wdc)()}async getProcessId(W){return this.C(void 0,W)?.win?.webContents.getOSProcessId()}async killProcess(W,C,z){process.kill(C,z)}async readClipboardText(W,C){return r.clipboard.readText(C)}async writeClipboardText(W,C,z){return r.clipboard.writeText(C,z)}async readClipboardFindText(W){return r.clipboard.readFindText()}async writeClipboardFindText(W,C){return r.clipboard.writeFindText(C)}async writeClipboardBuffer(W,C,z,se){return r.clipboard.writeBuffer(C,Buffer.from(z.buffer),se)}async readClipboardBuffer(W,C){return b.$Je.wrap(r.clipboard.readBuffer(C))}async hasClipboard(W,C,z){return r.clipboard.has(C,z)}async newWindowTab(){await this.a.open({context:n.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){r.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){r.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){r.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){r.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){r.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,C){this.D(W)?.updateTouchBar(C)}async notifyReady(W){this.D(W)?.setReady()}async relaunch(W,C){return this.f.relaunch(C)}async reload(W,C){const z=this.D(W);if(z){if((0,l.$Pi)(z.openedWorkspace)){const se=z.openedWorkspace.configPath;if(se.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(se))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.f.reload(z,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(W,C){return this.C(C?.targetWindowId,W)?.win?.close()}async quit(W){const C=this.a.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&C.win?C.win.close():this.f.quit()}async exit(W,C){await this.f.kill(C)}async resolveProxy(W,C){return this.D(W)?.win?.webContents?.session?.resolveProxy(C)}async loadCertificates(W){return(await new Promise((z,se)=>{X(["@vscode/proxy-agent"],z,se)})).loadSystemCertificates({log:this.h})}findFreePort(W,C,z,se,ie=1){return(0,m.$Yg)(C,z,se,ie)}async openDevTools(W,C){this.C(C?.targetWindowId,W)?.win?.webContents.openDevTools(C?.mode?{mode:C.mode,activate:C.activate}:void 0)}async toggleDevTools(W,C){this.C(C?.targetWindowId,W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,C,z){const se=this.D(W);if(!se||!se.win)throw new Error;return await new R.$Xdc(se.win,C,this.h).inspect(z)}async windowsGetStringRegKey(W,C,z,se){if(!d.$i)return;const ie=await new Promise((oe,K)=>{X(["@vscode/windows-registry"],oe,K)});try{return ie.GetStringRegKey(C,z,se)}catch{return}}C(W,C){return this.D(W)??this.F(W)??this.D(C)}D(W){if(typeof W=="number")return this.a.getWindowById(W)}F(W){if(typeof W!="number")return;const C=r.webContents.fromId(W);if(C)return this.b.getWindowByWebContents(C)}};e.$1dc=j,Se([O.$5h],j.prototype,"z",null),e.$1dc=j=Se([re(0,n.$bdc),re(1,D.$Ydc),re(2,p.$9cc),re(3,o.$udc),re(4,v.$3cc),re(5,t.$7j),re(6,s.$nk),re(7,a.$_cc),re(8,u.$ndc)],j)}),define(ce[306],le([0,1,14,27,8,23,31,2,13,4,116,37,185,96,136,58,25,5,74,84,28,85,34,64,57,29]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;const u="issue.processExplorerWindowState";let b=class{static{l=this}static{this.a="#1E1E1E"}constructor(D,T,j,F,W,C,z,se,ie,oe,K){this.g=D,this.h=T,this.i=j,this.j=F,this.k=W,this.l=C,this.m=z,this.n=se,this.o=ie,this.p=oe,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){d.$sW.on("vscode:listProcesses",async D=>{const T=[];try{T.push({name:(0,$.localize)(0,null),rootProcess:await(0,f.$Ls)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,y.$jn)(F)?T.push({name:F.hostName,rootProcess:F}):F.processes&&T.push({name:F.hostName,rootProcess:F.processes})})}catch(j){this.i.error(`Listing processes failed: ${j}`)}this.t(D,"vscode:listProcessesResponse",T)}),d.$sW.on("vscode:workbenchCommand",(D,T)=>{const{id:j,from:F,args:W}=T;let C;switch(F){case"processExplorer":C=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}C?.webContents.send("vscode:runAction",{id:j,from:F,args:W})}),d.$sW.on("vscode:closeProcessExplorer",D=>{this.d?.close()}),d.$sW.on("vscode:pidToNameRequest",async D=>{const T=await this.k.getMainDiagnostics(),j=[];for(const F of T.windows)j.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:W}of s.$Hdc.getAll())j.push([F,W]);this.t(D,"vscode:pidToNameResponse",j)})}async openReporter(D){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const T=new I.$Tc,j=T.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,j,{backgroundColor:D.styles.backgroundColor,title:(0,$.localize)(1,null),zoomLevel:D.zoomLevel,alwaysOnTop:!1},"issue-reporter"),j.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:D,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:v.default}),this.b.loadURL(E.$Ug.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,T.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,T.dispose())})}}async openProcessExplorer(D){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const T=new I.$Tc,j=T.add(this.n.createIPCObjectUrl()),F=this.p.getItem(u,void 0),W=P(F)?F:this.v(this.f,800,500);this.d=this.u(W,j,{backgroundColor:D.styles.backgroundColor,title:(0,$.localize)(2,null),zoomLevel:D.zoomLevel,alwaysOnTop:!0},"process-explorer"),j.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:D,product:v.default}),this.d.loadURL(E.$Ug.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,T.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,T.dispose())});const C=()=>{if(!this.d)return;const z=this.d.getSize(),se=this.d.getPosition();if(!z||!se)return;const ie={width:z[0],height:z[1],x:se[0],y:se[1]};this.p.setItem(u,ie)};this.d.on("moved",C),this.d.on("resized",C)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const D=await i.contentTracing.stopRecording(`${(0,O.$Ig)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,$.localize)(3,null),detail:(0,$.localize)(4,null,D),buttons:[(0,$.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,D)}async getSystemStatus(){const[D,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(D,T)}async $getSystemInfo(){const[D,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(D,T)}async $getPerformanceInfo(){try{const[D,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(D,T)}catch(D){throw this.i.warn("issueService#getPerformanceInfo ",D.message),D}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(D){this.i.error(D)}}async $showConfirmCloseDialog(){if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,$.localize)(6,null),buttons:[(0,$.localize)(7,null),(0,$.localize)(8,null)]},this.b);D===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,$.localize)(9,null),buttons:[(0,$.localize)(10,null),(0,$.localize)(11,null)]},this.b);return D===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const D=this.q.getWindowById(this.c.id);if(!D)throw new Error("Window not found");return D}async $sendReporterMenu(D,T){const j=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",W=new A.$se;return j.sendWhenReady(F,W.token,{replyChannel:F,extensionId:D,extensionName:T}),await(0,k.$rh)(new Promise(z=>d.$sW.once(`vscode:triggerReporterMenuResponse:${D}`,(se,ie)=>z(ie))),5e3,()=>{this.i.error(`Error: Extension ${D} timed out waiting for menu response`),W.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(D){D.isMinimized()&&D.restore(),D.focus()}t(D,T,...j){D.sender.isDestroyed()||D.sender.send(T,...j)}u(D,T,j,F){const W=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:D.width,height:D.height,minWidth:300,minHeight:200,x:D.x,y:D.y,title:j.title,backgroundColor:j.backgroundColor||l.a,webPreferences:{preload:E.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.$XD)(j.zoomLevel),sandbox:!0},alwaysOnTop:j.alwaysOnTop,experimentalDarkMode:!0});return W.setMenuBarVisibility(!1),W}v(D,T,j){let F;const W=i.screen.getAllDisplays();if(W.length===1)F=W[0];else{if(c.$j){const se=i.screen.getCursorScreenPoint();F=i.screen.getDisplayNearestPoint(se)}!F&&D&&(F=i.screen.getDisplayMatching(D.getBounds())),F||(F=i.screen.getPrimaryDisplay()||W[0])}const C=F.bounds,z={width:T,height:j,x:C.x+C.width/2-T/2,y:C.y+C.height/2-j/2};return C.width>0&&C.height>0&&(z.x<C.x&&(z.x=C.x),z.y<C.y&&(z.y=C.y),z.x>C.x+C.width&&(z.x=C.x),z.y>C.y+C.height&&(z.y=C.y),z.width>C.width&&(z.width=C.width),z.height>C.height&&(z.height=C.height)),z}};e.$2dc=b,e.$2dc=b=l=Se([re(1,m.$3cc),re(2,w.$7j),re(3,y.$in),re(4,h.$Kdc),re(5,g.$9cc),re(6,p.$Zdc),re(7,o.$$cc),re(8,S.$nk),re(9,t.$dQ),re(10,n.$bdc)],b);function P(R){return typeof R!="object"||R===null?!1:"x"in R&&"y"in R&&"width"in R&&"height"in R}}),define(ce[307],le([0,1,23,18,25,20,5,74,28,55,24,51,106]),function(X,e,i,r,k,A,O,I,E,c,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;let y=class extends $.$oec{constructor(g,m,w,p,v,S,o,t){super(g,m,p,v,S,t),this.e=w,this.u=o}s(g){return(0,$.$nec)(`linux-${process.arch}`,g,this.k)}t(g){this.a&&(this.d(d.$qX.CheckingForUpdates(g)),this.i.request({url:this.a},i.CancellationToken.None).then(c.$2p).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(d.$qX.Idle(d.UpdateType.Archive))):this.d(d.$qX.AvailableForDownload(m))}).then(void 0,m=>{this.j.error(m);const w=g?m.message||m:void 0;this.d(d.$qX.Idle(d.UpdateType.Archive,w))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(d.$qX.Idle(d.UpdateType.Archive))}};e.$qec=y,e.$qec=y=Se([re(0,A.$udc),re(1,r.$7i),re(2,f.$6l),re(3,k.$3cc),re(4,c.$Vp),re(5,O.$7j),re(6,I.$Zdc),re(7,E.$nk)],y)}),define(ce[308],le([0,1,50,44,27,8,23,53,47,9,7,149,21,18,25,15,20,5,74,28,55,24,51,106]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;async function a(b,P=1e3){for(;!b();)await(0,A.$Bh)(P)}let n;function l(){return typeof n>"u"&&(n=r.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?t.UpdateType.Setup:t.UpdateType.Archive),n}let u=class extends s.$oec{get cachePath(){const P=c.$jc((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return $.Promises.mkdir(P,{recursive:!0}).then(()=>P)}constructor(P,R,D,T,j,F,W,C,z){super(P,R,T,j,F,z),this.u=D,this.v=W,this.w=C,P.setRelaunchHandler(this)}handleRelaunch(P){return P?.addArgs||P?.removeArgs||this.state.type!==t.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$qX.Disabled(t.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(P){let R=`win32-${process.arch}`;return l()===t.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,s.$nec)(R,P,this.k)}t(P){this.a&&(this.d(t.$qX.CheckingForUpdates(P)),this.i.request({url:this.a},O.CancellationToken.None).then(S.$2p).then(R=>{const D=l();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!P}),this.d(t.$qX.Idle(D)),Promise.resolve(null)):D===t.UpdateType.Archive?(this.d(t.$qX.AvailableForDownload(R)),Promise.resolve(null)):(this.d(t.$qX.Downloading),this.C(R.version).then(()=>this.B(R.version).then(T=>$.Promises.exists(T).then(j=>{if(j)return Promise.resolve(T);const F=`${T}.tmp`;return this.i.request({url:R.url},O.CancellationToken.None).then(W=>this.v.writeFile(f.URI.file(F),W.stream)).then(R.sha256hash?()=>(0,d.$lW)(F,R.sha256hash):()=>{}).then(()=>$.Promises.rename(F,T,!1)).then(()=>T)})).then(T=>{this.e={packagePath:T},this.d(t.$qX.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$qX.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,E.$oj)(String(R)))}),this.j.error(R);const D=P?R.message||R:void 0;this.d(t.$qX.Idle(l(),D))}))}async o(P){P.update.url&&this.w.openExternal(void 0,P.update.url),this.d(t.$qX.Idle(l()))}async B(P){const R=await this.cachePath;return c.$jc(R,`CodeSetup-${this.k.quality}-${P}.exe`)}async C(P=null){const R=P?F=>!new RegExp(`${this.k.quality}-${P}\\.exe$`).test(F):()=>!0,D=await this.cachePath,j=(await $.Promises.readdir(D)).filter(R).map(async F=>{try{await $.Promises.unlink(c.$jc(D,F))}catch{}});await Promise.all(j)}async p(){if(this.state.type!==t.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const P=this.state.update;this.d(t.$qX.Updating(P));const R=await this.cachePath;this.e.updateFilePath=c.$jc(R,`CodeSetup-${this.k.quality}-${P.version}.flag`),await $.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$qX.Idle(l()))});const T=`${this.k.win32MutexName}-ready`,j=await new Promise((F,W)=>{X(["@vscode/windows-mutex"],F,W)});a(()=>j.isActive(T)).then(()=>this.d(t.$qX.Ready(P)))}r(){this.state.type!==t.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return l()}async _applySpecificUpdate(P){if(this.state.type!==t.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(t.$qX.Downloading),this.e={packagePath:P},this.d(t.$qX.Downloaded(D)),R?this.k.target==="user"&&this.p():this.d(t.$qX.Ready(D))}};e.$sec=u,Se([I.$5h],u.prototype,"cachePath",null),e.$sec=u=Se([re(0,m.$udc),re(1,y.$7i),re(2,o.$6l),re(3,h.$3cc),re(4,S.$Vp),re(5,w.$7j),re(6,g.$7k),re(7,p.$Zdc),re(8,v.$nk)],u)}),define(ce[137],le([0,1,14,8,23,48,3,2,13,69,4,7,196,27,68,18,58,25,67,15,20,5,28,85,284,87,24,111,73,57,29,30,60,52,41,34,59,70,22,6]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T,j,F,W,C,z,se,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=void 0;var oe;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(oe||(oe={}));class K extends I.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(O.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const B=!(0,P.$SD)(this.r);if(f.$j&&B&&L.setSheetOffset((0,f.$J)((0,y.release)())?28:22),B&&(f.$i&&(0,P.$VD)(this.r)||f.$j)){const V=this.s.getItem(K.D);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:P.$UD})}f.$i&&B&&L.hookWindowMessage(278,()=>{const[ae,G]=L.getPosition(),he=i.screen.getCursorScreenPoint(),ne=he.x-ae,Z=he.y-G;return!(ne>30&&Z>=0&&Z<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:ne,y:Z})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),f.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,B,V,ae){super(),this.r=L,this.s=B,this.t=V,this.u=ae,this.a=this.B(new O.$he),this.onDidClose=this.a.event,this.b=this.B(new O.$he),this.onDidMaximize=this.b.event,this.c=this.B(new O.$he),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$he),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$he),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$he),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,P.$VD)(this.r),this.G=void 0,this.H=void 0}w(L,B=i.screen.getAllDisplays().length>0){const V=this.r.getValue("window"),ae=f.$j&&V?.nativeTabs===!0;(f.$j||f.$i)&&B&&(!ae||i.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===j.WindowMode.Maximized||L.mode===j.WindowMode.Fullscreen)&&(this.m?.maximize(),L.mode===j.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){f.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return f.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){f.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return f.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){f.$j&&L?.force&&i.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(f.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const B=this.win;if(B){if(L.height&&this.s.setItem(te.D,L.height),f.$i&&this.F)B.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(f.$j&&L.height!==void 0){const V=(L.height-15)/2;V?B.setWindowButtonPosition({x:V,y:V}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,B){(0,P.$WD)(this.r)?this.J(L,B):this.M(L)}get isFullScreen(){if(f.$j&&typeof this.G=="boolean")return this.G;const L=this.win,B=L?.isFullScreen(),V=L?.isSimpleFullScreen();return!!(B||V)}J(L,B){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.L(L,B)}L(L,B){if(f.$j){this.G=L;const ae=this.H=new r.$Xh;(async()=>{const G=await Promise.race([ae.p,(0,r.$Bh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!G&&L&&B&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const B=this.win;B?.isFullScreen()&&this.L(!1,!1),B?.setSimpleFullScreen(L),B?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$rdc=K;let te=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,D.$Oi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,B,V,ae,G,he,ne,Z,U,M,N,H,Q,J,x,ee,de,me,pe,Ie,ke){super(M,Ie,ae,B),this.fb=V,this.gb=G,this.hb=he,this.ib=ne,this.jb=Z,this.kb=U,this.lb=N,this.mb=H,this.nb=Q,this.ob=J,this.pb=x,this.qb=ee,this.rb=de,this.sb=me,this.tb=pe,this.N=this.B(new O.$he),this.onWillLoad=this.N.event,this.O=this.B(new O.$he),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$he),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=oe.NONE;{const[Pe,Ae]=this.Eb(L.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(R.$cdc,this.U,{preload:E.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Ae),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=oe.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===oe.READY}get whenClosedOrLoaded(){return new Promise(L=>{function B(){V.dispose(),ae.dispose(),L()}const V=this.onDidClose(()=>B()),ae=this.onWillLoad(()=>B())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(j.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(B,V)=>V)(B=>this.yb(j.WindowError.PROCESS_GONE,{...B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(B,V,ae)=>({exitCode:V,reason:ae}))(({exitCode:B,reason:V})=>this.yb(j.WindowError.LOAD,{reason:V,exitCode:B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(B=>B.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(B=>this.Bb(B))),this.B(this.mb.onDidDeleteUntitledWorkspace(B=>this.Ab(B)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(B,V)=>{const ae=await this.xb();V({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,a.$dq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,B){switch(L){case j.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case j.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case j.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:B?.reason,code:B?.exitCode}),L){case j.WindowError.UNRESPONSIVE:case j.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===j.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null),(0,$.localize)(2,null)],message:(0,$.localize)(3,null),detail:(0,$.localize)(4,null),checkboxLabel:this.S?.workspace?(0,$.localize)(5,null):void 0},this.m);if(V!==2){const G=V===0;await this.zb(G,ae)}}else if(L===j.WindowError.PROCESS_GONE){let V;B?V=(0,$.localize)(7,null,B.reason,B.exitCode??"<unknown>"):V=(0,$.localize)(6,null);const{response:ae,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,$.localize)(8,null):(0,$.localize)(9,null),(0,$.localize)(10,null)],message:V,detail:this.S?.workspace?(0,$.localize)(11,null):(0,$.localize)(12,null),checkboxLabel:this.S?.workspace?(0,$.localize)(13,null):void 0},this.m),he=ae===0;await this.zb(he,G)}break}}async zb(L,B){const V=this.S?.workspace;if(B&&V)try{const ae=this.kb.workspaceStorage(V);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(L&&this.S){let ae,G;(0,D.$Ki)(V)?ae={folderUri:V.uri}:(0,D.$Pi)(V)?ae={workspaceUri:V.configPath}:G=!0,(0,se.$Ob)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const B=this.Gb();B!==this.W&&(this.W=B,this.Hb(B))}if(!L||L.affectsConfiguration("http.proxy")){let B=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.Z||V!==this.$)){this.Z=B,this.$=V;const ae=B||"",G=V?`${V},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(L){f.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,B=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!B.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,B),this.ub===oe.NONE?this.S=L:this.db=L,this.ub=oe.NAVIGATING,this.m.loadURL(E.$Ug.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Mh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:B.isReload?j.LoadReason.RELOAD:V?j.LoadReason.LOAD:j.LoadReason.INITIAL})}Cb(L,B){const V=(this.S??this.db)?.userEnv;if(V){const ae=(0,p.$Fm)(V)&&!(0,p.$Fm)(L.userEnv),G=this.isExtensionDevelopmentHost;(ae||G)&&(L.userEnv={...V,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(L["disable-extensions"]=B.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.bb.update(L)}async reload(L){const B=Object.assign({},this.S);B.workspace=await this.Db(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&L&&(B.verbose=L.verbose,B.debugId=L.debugId,B.extensionEnvironment=L.extensionEnvironment,B["inspect-extensions"]=L["inspect-extensions"],B["inspect-brk-extensions"]=L["inspect-brk-extensions"],B["extensions-dir"]=L["extensions-dir"]),B.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.gb.serialize(),B.continueOn=this.t.continueOn,B.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},B.logLevel=this.fb.getLogLevel(),B.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,D.$Pi)(L.workspace)){const B=L.workspace.configPath;if(B.scheme===E.Schemas.file&&!await this.ib.exists(B))return}else if((0,D.$Ki)(L.workspace)){const B=L.workspace.uri;if(B.scheme===E.Schemas.file&&!await this.ib.exists(B))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$1cc)();if(this.isFullScreen){let V;try{V=i.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,j.$1cc)();return{mode:j.WindowMode.Fullscreen,display:V?V.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let B;if(!f.$j&&this.m.isMaximized()?B=j.WindowMode.Maximized:B=j.WindowMode.Normal,B===j.WindowMode.Maximized?L.mode=j.WindowMode.Maximized:L.mode=j.WindowMode.Normal,B===j.WindowMode.Normal||B===j.WindowMode.Maximized){let V;B===j.WindowMode.Normal?V=this.getBounds():V=this.m.getNormalBounds(),L.x=V.x,L.y=V.y,L.width=V.width,L.height=V.height}return L.zoomLevel=this.ab,L}Eb(L){(0,c.mark)("code/willRestoreCodeWindowState");let B=!1;if(L){this.ab=L.zoomLevel;try{const V=i.screen.getAllDisplays();B=V.length>1,L=R.WindowStateValidator.validateWindowState(this.u,L,V)}catch(V){this.u.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$1cc)(),B]}getBounds(){const[L,B]=this.m.getPosition(),[V,ae]=this.m.getSize();return{x:L,y:B,width:V,height:ae}}I(L,B){super.I(L,B),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,P.$QD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,B=!0){f.$j||(L==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,$.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const B=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!B),this.m.autoHideMenuBar=B;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,B,...V){this.isReady?this.send(L,...V):this.ready().then(()=>{B.isCancellationRequested||this.send(L,...V)})}send(L,...B){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...B)}catch(V){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,A.$lj)(V)}`)}}}updateTouchBar(L){f.$j&&this.Y.forEach((B,V)=>{const ae=L[V];B.segments=this.Mb(ae)})}Kb(){if(f.$j){for(let L=0;L<10;L++){const B=this.Lb();this.Y.push(B)}this.m.setTouchBar(new i.TouchBar({items:this.Y}))}}Lb(L=[]){const B=this.Mb(L),V=new i.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:V.segments[ae].id,from:"touchbar"})}});return V}Mb(L=[]){return L.map(V=>{let ae;V.icon&&!u.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===E.Schemas.file&&(ae=i.nativeImage.createFromPath(d.URI.revive(V.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let G;return typeof V.title=="string"?G=V.title:G=V.title.value,{id:V.id,label:ae?void 0:G,icon:ae}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$sdc=te,e.$sdc=te=Se([re(1,o.$7j),re(2,z.$pdc),re(3,w.$3cc),re(4,F.$lo),re(5,C.$edc),re(6,v.$7k),re(7,n.$Cdc),re(8,n.$Adc),re(9,g.$7i),re(10,b.$_cc),re(11,T.$ndc),re(12,h.$8cc),re(13,l.$6l),re(14,m.$9cc),re(15,S.$udc),re(16,t.$nk),re(17,s.$$cc),re(18,R.$bdc),re(19,W.$dQ),re(20,ie.$zi)],te)}),define(ce[309],le([0,1,14,4,18,25,20,5,34,57,52,137]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;let $=class extends d.$rdc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,g,m,w,p,v){super(w,p,g,m),this.O=h,this.P=v,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(h){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),h&&!this.N&&(this.N=!0,this.w({x:h.x,y:h.y,width:h.width,height:h.height,mode:h.show===!1?f.WindowMode.Maximized:f.WindowMode.Normal})))}Q(){if(this.m)return;const h=i.BrowserWindow.fromWebContents(this.O);h&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(h),h.setMenu(null),(r.$i||r.$k)&&(0,c.$SD)(this.r)&&h.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(h){return this.O.id===h.id}};e.$tdc=$,e.$tdc=$=Se([re(1,A.$3cc),re(2,I.$7j),re(3,k.$7i),re(4,E.$dQ),re(5,O.$udc)],$)}),define(ce[310],le([0,1,14,3,2,13,37,309,6,5,52,29]),function(X,e,i,r,k,A,O,I,E,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;let $=class extends k.$Uc{constructor(h,g){super(),this.h=h,this.j=g,this.a=this.B(new r.$he),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$he),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$he),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$he),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(h,g)=>{const m=this.getWindowByWebContents(g.webContents);if(m)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),m.tryClaimWindow();else{const w=new k.$Tc;w.add(r.Event.fromNodeEventEmitter(g.webContents,"did-create-window",(p,v)=>({browserWindow:p,details:v}))(({browserWindow:p,details:v})=>{const S=this.getWindowByWebContents(p.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(v.options))})),w.add(r.Event.fromNodeEventEmitter(g,"closed")(()=>w.dispose()))}}),O.$sW.handle("vscode:registerAuxiliaryWindow",async(h,g)=>{const m=this.getWindowByWebContents(h.sender);return m&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),m.parentId=g),h.sender.id})}createWindow(h){return this.h.invokeFunction(d.$cdc,this.n(h),{preload:A.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(h){const g={},m=h.features.split(",");for(const p of m){const[v,S]=p.split("=");switch(v){case"width":g.width=parseInt(S,10);break;case"height":g.height=parseInt(S,10);break;case"left":g.x=parseInt(S,10);break;case"top":g.y=parseInt(S,10);break;case"window-maximized":g.mode=f.WindowMode.Maximized;break;case"window-fullscreen":g.mode=f.WindowMode.Fullscreen;break}}const w=d.WindowStateValidator.validateWindowState(this.j,g)??(0,f.$2cc)();return this.j.trace("[aux window] using window state",w),w}registerWindow(h){const g=new k.$Tc,m=this.h.createInstance(I.$tdc,h);this.g.set(m.id,m),g.add((0,k.$Sc)(()=>this.g.delete(m.id))),g.add(m.onDidMaximize(()=>this.a.fire(m))),g.add(m.onDidUnmaximize(()=>this.b.fire(m))),g.add(m.onDidEnterFullScreen(()=>this.c.fire({window:m,fullscreen:!0}))),g.add(m.onDidLeaveFullScreen(()=>this.c.fire({window:m,fullscreen:!1}))),g.add(m.onDidTriggerSystemContextMenu(({x:w,y:p})=>this.f.fire({window:m,x:w,y:p}))),r.Event.once(m.onDidClose)(()=>g.dispose())}getWindowByWebContents(h){const g=this.g.get(h.id);return g?.matches(h)?g:void 0}getFocusedWindow(){const h=i.BrowserWindow.getFocusedWindow();if(h)return this.getWindowByWebContents(h.webContents)}getLastActiveWindow(){return(0,d.$ddc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Zec=$,e.$Zec=$=Se([re(0,E.$zi),re(1,c.$7j)],$)}),define(ce[88],le([0,1,14,22,8,3,49,2,13,4,19,7,21,199,6,20,5,63,87,103,30,60,32,58]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0,e.$_dc=(0,h.$Ai)("workspacesHistoryMainService");let n=class extends I.$Uc{static{a=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(u,b,P,R,D){super(),this.f=u,this.g=b,this.h=P,this.j=R,this.m=D,this.c=this.B(new A.$he),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$yh(800)),this.n()}n(){this.h.when(g.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){let b=[],P=[];for(const D of u)if((0,v.$jgb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(b,D.workspace)&&b.push(D);else if((0,v.$kgb)(D))this.y(b,D.folderUri)||b.push(D);else{const T=this.z(P,D.fileUri),j=D.fileUri.scheme===E.Schemas.file&&a.G.indexOf((0,f.$$g)(D.fileUri))>=0;!T&&!j&&(P.push(D),c.$i&&D.fileUri.scheme===E.Schemas.file&&i.app.addRecentDocument(D.fileUri.fsPath))}const R=await this.r({workspaces:b,files:P});b=R.workspaces,P=R.files,b.length>a.a&&(b.length=a.a),P.length>a.a&&(P.length=a.a),await this.t({workspaces:b,files:P}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(u){const b=T=>{const j=this.u(T);for(const F of u)if(f.$5g.isEqual(F,j))return!1;return!0},P=await this.getRecentlyOpened(),R=P.workspaces.filter(b),D=P.files.filter(b);(R.length!==P.workspaces.length||D.length!==P.files.length)&&(await this.t({files:D,workspaces:R}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(u){if(u?.confirm){const{response:b}=await this.m.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null)],message:(0,y.localize)(2,null),detail:(0,y.localize)(3,null),cancelId:1});if(b!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(u){const b=new t.$Ac(D=>f.$5g.getComparisonKey(D));if(u?.workspaces)for(const D of u.workspaces)b.set(this.u(D),D);const P=new t.$Ac(D=>f.$5g.getComparisonKey(D));if(u?.files)for(const D of u.files)P.set(this.u(D),D);const R=await this.s();for(const D of R.workspaces){const T=b.get(this.u(D));T?T.label=T.label??D.label:b.set(this.u(D),D)}for(const D of R.files){const T=P.get(this.u(D));T?T.label=T.label??D.label:P.set(this.u(D),D)}return{workspaces:[...b.values()],files:[...P.values()]}}async s(){await this.j.whenReady;let u;const b=this.j.get(a.b,w.StorageScope.APPLICATION);if(typeof b=="string")try{u=JSON.parse(b)}catch(P){this.f.error("Unexpected error parsing opened paths list",P)}return(0,v.$qgb)(u,this.f)}async t(u){await this.j.whenReady,this.j.store(a.b,JSON.stringify((0,v.$rgb)(u)),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE)}u(u){return(0,v.$kgb)(u)?u.folderUri:(0,v.$lgb)(u)?u.fileUri:u.workspace.configPath}w(u,b){return!!u.find(P=>(0,v.$jgb)(P)&&P.workspace.id===b.id)}y(u,b){return!!u.find(P=>(0,v.$kgb)(P)&&f.$5g.isEqual(P.folderUri,b))}z(u,b){return!!u.find(P=>f.$5g.isEqual(P.fileUri,b))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(4,null),description:(0,y.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const b=[];for(const D of i.app.getJumpListSettings().removedItems){const T=D.args;if(T){const j=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(T);j&&b.push(d.URI.parse(j[2]))}}await this.removeRecentlyOpened(b);let P=!1;const R=(0,r.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,a.F).map(D=>{const T=(0,v.$jgb)(D)?D.workspace:D.folderUri,{title:j,description:F}=this.L(T,D.label);let W;return d.URI.isUri(T)?W=`--folder-uri "${T.toString()}"`:(P=!0,W=`--file-uri "${T.configPath.toString()}"`),{type:"task",title:j.substr(0,255),description:F.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&u.push({type:"custom",name:P?(0,y.localize)(6,null):(0,y.localize)(7,null),items:R})}u.push({type:"recent"});try{const b=i.app.setJumpList(u);b&&b!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${b}`)}catch(b){this.f.warn("updateWindowsJumpList#setJumpList",b)}}L(u,b){if(b)return{title:(0,O.$Vw)(b).name,description:b};if(d.URI.isUri(u))return{title:(0,f.$$g)(u),description:this.M(u)};if(this.g.isUntitledWorkspace(u))return{title:(0,y.localize)(8,null),description:""};let P=(0,f.$$g)(u.configPath);return P.endsWith(S.$Wi)&&(P=P.substr(0,P.length-S.$Wi.length-1)),{title:(0,y.localize)(9,null,P),description:this.M(u.configPath)}}M(u){return u.scheme==="file"?(0,O.$Nw)(u.fsPath):u.toString()}async N(){if(!c.$j)return;i.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),b=[];let P=0;for(let D=0;D<u.workspaces.length&&P<a.C;D++){const T=this.u(u.workspaces[D]);if(T.scheme===E.Schemas.file){const j=(0,f.$2g)(T);await $.Promises.exists(j)&&(b.push(j),P++)}}const R=[];for(let D=0;D<u.files.length&&P<a.D;D++){const T=this.u(u.files[D]);if(T.scheme===E.Schemas.file){const j=(0,f.$2g)(T);if(a.G.includes((0,f.$$g)(T))||b.includes(j))continue;await $.Promises.exists(j)&&(R.push(j),P++)}}R.reverse().forEach(D=>i.app.addRecentDocument(D)),b.reverse().forEach(D=>i.app.addRecentDocument(D))}};e.$aec=n,e.$aec=n=a=Se([re(0,m.$7j),re(1,o.$ndc),re(2,g.$udc),re(3,p.$Cdc),re(4,s.$9cc)],n)}),define(ce[311],le([0,1,14,8,23,49,4,7,187,83,18,25,20,5,236,74,28,34,24,51,57,29,88]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;const a="menu";let n=class{static{s=this}static{this.a="lastKnownMenubarData"}constructor(b,P,R,D,T,j,F,W,C,z,se,ie){this.n=b,this.o=P,this.p=R,this.q=D,this.r=T,this.s=j,this.t=F,this.u=W,this.v=C,this.w=z,this.x=se,this.y=ie,this.m=Object.create(null),this.g=new r.$Mh(()=>this.F(),0),this.h=new r.$Mh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(O.$j||(0,S.$SD)(P))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(s.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,F,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:o.OpenContext.MENU,contextWindowId:F?.id})},this.m["workbench.action.newWindow"]=(j,F,W)=>this.p.openEmptyWindow({context:o.OpenContext.MENU,contextWindowId:F?.id}),this.m["workbench.action.files.openFileFolder"]=(j,F,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(j,F,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(j,F,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const P=this.x.requestFeatureUrl;P&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(P,"openUserVoiceUrl"));const R=this.x.reportIssueUrl;R&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(R,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(O.$w){const j=D.indexOf("?")>0?"&":"?";this.ab(`${D}${j}lang=${O.$w}`,"openLicenseUrl")}else this.ab(D,"openLicenseUrl")});const T=this.x.privacyStatementUrl;T&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(T,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!O.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,P){this.k=b.menus,this.l=b.keybindings,this.t.setItem(s.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){O.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!O.$j)return;const b=i.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowByWebContents(b.webContents),this.E()}I(){const b=i.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(O.$j?new i.Menu:null);return}const P=new i.Menu;let R;if(O.$j){const T=new i.Menu;R=new i.MenuItem({label:this.x.nameShort,submenu:T}),this.K(T),P.append(R)}if(O.$j&&!this.c){this.c=!0;const T=new i.Menu;T.append(new i.MenuItem({label:this.cb(E.localize(0,null)),click:()=>this.p.openEmptyWindow({context:o.OpenContext.DOCK})})),i.app.dock.setMenu(T)}if(this.M("File")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(1,null)),submenu:T});this.O(T,"File"),P.append(j)}if(this.M("Edit")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(2,null)),submenu:T});this.O(T,"Edit"),P.append(j)}if(this.M("Selection")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(3,null)),submenu:T});this.O(T,"Selection"),P.append(j)}if(this.M("View")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(4,null)),submenu:T});this.O(T,"View"),P.append(j)}if(this.M("Go")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(5,null)),submenu:T});this.O(T,"Go"),P.append(j)}if(this.M("Run")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(6,null)),submenu:T});this.O(T,"Run"),P.append(j)}if(this.M("Terminal")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(7,null)),submenu:T});this.O(T,"Terminal"),P.append(j)}let D;if(this.M("Window")){const T=new i.Menu;D=new i.MenuItem({label:this.cb(E.localize(8,null)),submenu:T,role:"window"}),this.U(T)}if(D&&P.append(D),this.M("Help")){const T=new i.Menu,j=new i.MenuItem({label:this.cb(E.localize(9,null)),submenu:T,role:"help"});this.O(T,"Help"),P.append(j)}P.items&&P.items.length>0?this.J(P):this.J(null),this.h.schedule()}J(b){if(i.Menu.setApplicationMenu(b),b)for(const P of this.y.getWindows())P.win?.setMenu(null)}K(b){const P=this.W(E.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),R=this.V();let D;if(this.M("Preferences")){const ie=new i.Menu;this.O(ie,"Preferences"),D=new i.MenuItem({label:this.cb(E.localize(11,null)),submenu:ie})}const T=new i.Menu,j=new i.MenuItem({label:E.localize(12,null),role:"services",submenu:T}),F=new i.MenuItem({label:E.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new i.MenuItem({label:E.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),C=new i.MenuItem({label:E.localize(15,null),role:"unhide"}),z=new i.MenuItem(this.$("workbench.action.quit",{label:E.localize(16,null,this.x.nameLong),click:async(ie,oe,K)=>{const te=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||te?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),se=[P];se.push(...R),D&&se.push(l(),D),se.push(l(),j,l(),F,W,C,l(),z),se.forEach(ie=>b.append(ie))}async L(b){if(this.p.getWindowCount()===0)return!0;const P=this.o.getValue("window.confirmBeforeClose");if(P==="always"||P==="keyboardOnly"&&this.S(b)){const{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[E.localize(17,null),E.localize(18,null)],message:E.localize(19,null)});return R===0}return!0}M(b){if(!O.$j&&!(0,S.$SD)(this.o))return!1;switch(b){case"File":case"Help":if(O.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(O.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,P){P.forEach(R=>{if((0,h.$9dc)(R))b.append(l());else if((0,h.$8dc)(R)){const D=new i.Menu,T=new i.MenuItem({label:this.cb(R.label),submenu:D});this.N(D,R.submenu.items),b.append(T)}else(0,h.$0dc)(R)?b.append(this.Q(R)):(0,h.$$dc)(R)&&(R.id==="workbench.action.showAboutDialog"&&this.P(b),O.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[R.id]?b.append(new i.MenuItem(this.$(R.id,{label:this.cb(R.label),click:this.m[R.id]}))):b.append(this.W(R.label,R.id,!1,R.checked)):b.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)):b.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)))})}O(b,P){this.k&&this.k[P]&&this.N(b,this.k[P].items)}P(b){const P=this.V();P.length&&(P.forEach(R=>b.append(R)),b.append(l()))}Q(b){const P=I.URI.revive(b.uri),R=b.id,D=R==="openRecentFile"?{fileUri:P}:R==="openRecentWorkspace"?{workspaceUri:P}:{folderUri:P};return new i.MenuItem(this.$(R,{label:b.label,click:async(T,j,F)=>{const W=this.R(F);(await this.p.open({context:o.OpenContext.MENU,cli:this.q.args,urisToOpen:[D],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([P])}},!1))}R(b){return!!(b&&(!O.$j&&(b.ctrlKey||b.shiftKey)||O.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,P,R){const D={label:this.cb(b),role:R,enabled:!0};return new i.MenuItem(this.Z(P,D))}U(b){const P=new i.MenuItem({label:E.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),R=new i.MenuItem({label:E.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new i.MenuItem({label:E.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),T=this.W(E.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(l()),j.push(this.W(E.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(E.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(E.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(E.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(E.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[P,R,l(),T,...j,l(),D].forEach(F=>b.append(F))}V(){switch(this.n.state.type){case v.StateType.Idle:return[new i.MenuItem({label:this.cb(E.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case v.StateType.CheckingForUpdates:return[new i.MenuItem({label:E.localize(30,null),enabled:!1})];case v.StateType.AvailableForDownload:return[new i.MenuItem({label:this.cb(E.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case v.StateType.Downloading:return[new i.MenuItem({label:E.localize(32,null),enabled:!1})];case v.StateType.Downloaded:return O.$j?[]:[new i.MenuItem({label:this.cb(E.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case v.StateType.Updating:return[new i.MenuItem({label:E.localize(34,null),enabled:!1})];case v.StateType.Ready:return[new i.MenuItem({label:this.cb(E.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,P,R,D){const T=this.cb(b),j=typeof P=="function"?P:(se,ie,oe)=>{const K=se?se.userSettingsLabel:null;let te=P;Array.isArray(P)&&(te=this.R(oe)?P[1]:P[0]),K&&oe.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:te})},F=typeof R=="boolean"?R:this.p.getWindowCount()>0,W=typeof D=="boolean"?D:!1,C={label:T,click:j,enabled:F};W&&(C.type="checkbox",C.checked=W);let z;return typeof P=="string"?z=P:Array.isArray(P)&&(z=P[0]),O.$j&&(z==="editor.action.clipboardCutAction"?C.role="cut":z==="editor.action.clipboardCopyAction"?C.role="copy":z==="editor.action.clipboardPasteAction"&&(C.role="paste"),z==="undo"?C.click=this.X(j,{inDevTools:se=>se.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):z==="redo"?C.click=this.X(j,{inDevTools:se=>se.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):z==="editor.action.selectAll"&&(C.click=this.X(j,{inDevTools:se=>se.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.Z(z,C))}X(b,P){return(R,D,T)=>{const j=i.BrowserWindow.getFocusedWindow();if(!j)return P.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return P.inDevTools(j.webContents.devToolsWebContents);b(R,D||j,T)}}Y(b){let P=i.BrowserWindow.getFocusedWindow();if(P){const D=this.y.getWindowByWebContents(P.webContents);D&&(P=this.p.getWindowById(D.parentId)?.win??null)}if(!P){const D=this.p.getLastActiveWindow();D?.win?.isMinimized()&&(P=D.win)}const R=P?this.p.getWindowById(P.id):void 0;if(R){if(this.v.trace("menubar#runActionInRenderer",b),O.$j&&!this.q.isBuilt&&!R.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const D={id:b.commandId,from:"menu"};R.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:b.userSettingsLabel};R.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,P){const R=typeof b=="string"?this.l[b]:void 0;if(R?.label){if(R.isNative!==!1)P.accelerator=R.label,P.userSettingsLabel=R.userSettingsLabel;else if(typeof P.label=="string"){const D=P.label.indexOf("[");D>=0?P.label=`${P.label.substr(0,D)} [${R.label}]`:P.label=`${P.label} [${R.label}]`}}else P.accelerator=void 0;return P}$(b,P,R=!P.accelerator){R&&(P=this.Z(b,P));const D=P.click;return P.click=(T,j,F)=>{this.bb(b),D?.(T,j,F)},P}ab(b,P){this.w.openExternal(void 0,b),this.bb(P)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:a})}cb(b){return(0,A.$Sw)(b,!this.C)}};e.$bec=n,e.$bec=n=s=Se([re(0,v.$rX),re(1,f.$7i),re(2,o.$bdc),re(3,d.$3cc),re(4,p.$6l),re(5,t.$_dc),re(6,w.$dQ),re(7,$.$udc),re(8,y.$7j),re(9,g.$Zdc),re(10,m.$nk),re(11,c.$Ydc)],n);function l(){return new i.MenuItem({type:"separator"})}}),define(ce[312],le([0,1,6,20,5,311]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0,e.$cec=(0,i.$Ai)("menubarMainService");let O=class{constructor(E,c,f){this.b=E,this.c=c,this.d=f,this.a=this.e()}async e(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.b.createInstance(A.$bec)}async updateMenubar(E,c){this.d.trace("menubarService#updateMenubar",E),(await this.a).updateMenu(c,E)}};e.$dec=O,e.$dec=O=Se([re(0,i.$zi),re(1,r.$udc),re(2,k.$7j)],O)}),define(ce[313],le([0,1,14,21,107,27,22,23,39,3,31,49,2,13,9,69,4,36,19,12,7,197,68,18,58,25,15,6,20,5,84,85,71,34,57,137,29,135,305,30,104,88,60,52,73,41,59,70,83]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T,j,F,W,C,z,se,ie,oe,K,te,q,L,B,V,ae,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;function he(U){return(0,ie.$Pi)(U?.workspace)}function ne(U){return(0,ie.$Ki)(U?.workspace)}let Z=class extends $.$Uc{constructor(M,N,H,Q,J,x,ee,de,me,pe,Ie,ke,Pe,Ae,$e,Y,ue,fe,be,De,Ne){super(),this.s=M,this.t=N,this.u=H,this.w=Q,this.z=J,this.C=x,this.D=ee,this.F=de,this.G=me,this.H=pe,this.I=Ie,this.J=ke,this.L=Pe,this.M=Ae,this.N=$e,this.O=Y,this.P=ue,this.Q=fe,this.R=be,this.S=De,this.U=Ne,this.a=this.B(new c.$he),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$he),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$he),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$he),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$he),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$he),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$he),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$he),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new se.$Aec(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(M=>this.b.fire(M.window))),this.B(this.onDidSignalReadyWindow(M=>{if(M.config?.extensionDevelopmentPath||M.config?.extensionTestsPath){const N=new $.$Tc;if(N.add(c.Event.any(M.onDidClose,M.onDidDestroy)(()=>N.dispose())),M.config.extensionDevelopmentPath)for(const H of M.config.extensionDevelopmentPath)N.add(this.R.addValidFileRoot(H));M.config.extensionTestsPath&&N.add(this.R.addValidFileRoot(M.config.extensionTestsPath))}}))}openEmptyWindow(M,N){const H=this.G.args,Q=N?.remoteAuthority||void 0,J=!0,x=N?.forceReuseWindow,ee=!x;return this.open({...M,cli:H,forceEmpty:J,forceNewWindow:ee,forceReuseWindow:x,remoteAuthority:Q})}openExistingWindow(M,N){M.focus(),this.X(N,[M])}async open(M){this.z.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const N=[],H=[],Q=[],J=[],x=[];let ee,de=0;const me=await this.db(M);this.z.trace("windowsManager#open pathsToOpen",me);for(const Ae of me)ne(Ae)?M.addMode?N.push(Ae):H.push(Ae):he(Ae)?Q.push(Ae):Ae.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),ee.filesToOpenOrCreate.push(Ae)):Ae.backupPath?x.push({backupFolder:(0,h.$nc)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):de++;M.diffMode&&ee&&ee.filesToOpenOrCreate.length>=2&&(ee.filesToDiff=ee.filesToOpenOrCreate.slice(0,2),ee.filesToOpenOrCreate=[]),M.mergeMode&&ee&&ee.filesToOpenOrCreate.length===4&&(ee.filesToMerge=ee.filesToOpenOrCreate.slice(0,4),ee.filesToOpenOrCreate=[],ee.filesToDiff=[]),ee&&M.waitMarkerFileURI&&(ee.filesToWait={paths:(0,O.$Hb)([...ee.filesToDiff,ee.filesToMerge[3],...ee.filesToOpenOrCreate]),waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(J.push(...this.N.getUntitledWorkspaces()),Q.push(...J),x.push(...this.J.getEmptyWindowBackups())):x.length=0;const{windows:pe,filesOpenedInWindow:Ie}=await this.Y(M,Q,H,x,de,ee,N);if(this.z.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${Q.length}, foldersToOpen: ${H.length}, emptyToRestore: ${x.length}, emptyToOpen: ${de})`),pe.length>1)if(Ie)Ie.focus();else{const Ae=this.r.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let $e=!0,Y=!0;if(Ae){const ue=pe.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,Y=!1)}if($e)for(let ue=pe.length-1;ue>=0;ue--){const fe=pe[ue];if(!(fe.openedWorkspace&&J.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&x.some(be=>fe.backupPath&&be.backupFolder===(0,h.$nc)(fe.backupPath)))){fe.focus(),Y=!1;break}}Y&&pe[pe.length-1].focus()}const ke=ee&&ee.filesToDiff.length>0,Pe=ee&&ee.filesToMerge.length>0;if(!pe.some(Ae=>Ae.isExtensionDevelopmentHost)&&!ke&&!Pe&&!M.noRecentEntry){const Ae=[];for(const $e of me)he($e)&&!$e.transient?Ae.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):ne($e)?Ae.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Ae.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Ae)}return this.X(M,pe),pe}X(M,N){const H=M.waitMarkerFileURI;M.context===C.OpenContext.CLI&&H&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.Q.del(H)}catch{}})()}async Y(M,N,H,Q,J,x,ee){const de=[];let me;function pe(ue,fe){de.push(ue),fe&&(me=ue,x=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:ke}=this.pb(M);if(!M.initialStartup&&ee.length>0){const ue=ee[0].remoteAuthority,fe=this.vb(ue);fe&&pe(this.ab(fe,ee.map(be=>be.workspace.uri)))}const Pe=H.length+N.length+Q.length;if(x&&Pe===0){const ue=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],fe=this.getWindows().filter(De=>x&&(0,p.$gh)(De.remoteAuthority,x.remoteAuthority));let be;ue?.fileUri&&!ke&&((M.context===C.OpenContext.DESKTOP||M.context===C.OpenContext.CLI||M.context===C.OpenContext.DOCK)&&(be=await(0,z.$gdc)(fe,ue.fileUri,async De=>De.configPath.scheme===y.Schemas.file?this.N.resolveLocalWorkspace(De.configPath):void 0)),be||(be=this.wb(fe))),be?(0,ie.$Pi)(be.openedWorkspace)?N.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,ie.$Ki)(be.openedWorkspace)?H.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):pe(this.Z(M,be,x),!0):pe(await this.qb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile}),!0)}const Ae=(0,O.$Mb)(N,ue=>ue.workspace.id);if(Ae.length>0){const ue=(0,O.$Hb)(Ae.map(fe=>(0,z.$hdc)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,p.$gh)(x?.remoteAuthority,fe.remoteAuthority)?x:void 0;pe(this.Z(M,fe,be),!!be),Ie=!0}for(const fe of Ae){if(ue.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,De=(0,p.$gh)(x?.remoteAuthority,be)?x:void 0;pe(await this.cb(M,fe,Ie,De),!!De),Ie=!0}}const $e=(0,O.$Mb)(H,ue=>p.$5g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,O.$Hb)($e.map(fe=>(0,z.$hdc)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,p.$gh)(x?.remoteAuthority,fe.remoteAuthority)?x:void 0;pe(this.Z(M,fe,be),!!be),Ie=!0}for(const fe of $e){if(ue.some(Ne=>(0,ie.$Ki)(Ne.openedWorkspace)&&p.$5g.isEqual(Ne.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,De=(0,p.$gh)(x?.remoteAuthority,be)?x:void 0;pe(await this.cb(M,fe,Ie,De),!!De),Ie=!0}}const Y=(0,O.$Mb)(Q,ue=>ue.backupFolder);if(Y.length>0)for(const ue of Y){const fe=ue.remoteAuthority,be=(0,p.$gh)(x?.remoteAuthority,fe)?x:void 0;pe(await this.bb(M,!0,fe,be,ue),!!be),Ie=!0}if(de.length===0||x){x&&!J&&J++;const ue=x?x.remoteAuthority:M.remoteAuthority;for(let fe=0;fe<J;fe++)pe(await this.bb(M,Ie,ue,x),!!x),Ie=!0}return{windows:(0,O.$Mb)(de),filesOpenedInWindow:me}}Z(M,N,H){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:H}),this.$(N);const Q={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToMerge:H?.filesToMerge,filesToWait:H?.filesToWait,termProgram:M?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Q),N}$(M){let N=M;const H=i.BrowserWindow.getFocusedWindow();if(H&&H.id!==M.id){const Q=this.U.getWindowByWebContents(H.webContents);Q&&Q.parentId===M.id&&(N=Q)}N.focus()}ab(M,N){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),M.focus();const H={foldersToAdd:N};return M.sendWhenReady("vscode:addFolders",I.CancellationToken.None,H),M}bb(M,N,H,Q,J){this.z.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:H,filesToOpen:Q,forceNewWindow:N});let x;return!N&&typeof M.contextWindowId=="number"&&(x=this.getWindowById(M.contextWindowId)),this.qb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:H,forceNewWindow:N,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:Q,windowToUse:x,emptyWindowBackupInfo:J,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}cb(M,N,H,Q,J){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:Q}),!H&&!J&&typeof M.contextWindowId=="number"&&(J=this.getWindowById(M.contextWindowId)),this.qb({workspace:N.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:Q,windowToUse:J,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}async db(M){let N,H=!1,Q=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(N=await this.eb(M),H=!0):M.forceEmpty?N=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(N=await this.fb(M.cli),N.length===0&&N.push(Object.create(null)),H=!0):(N=await this.hb(),N.length===0&&N.push(Object.create(null)),Q=!0),!M.addMode&&H){const J=N.filter(x=>ne(x));if(J.length>1){const x=J[0].remoteAuthority;if(J.every(ee=>(0,p.$gh)(ee.remoteAuthority,x))){const ee=await this.N.createUntitledWorkspace(J.map(de=>({uri:de.workspace.uri})));N.push({workspace:ee,remoteAuthority:x}),N=N.filter(de=>!ne(de))}}}if(M.initialStartup&&!Q&&this.L.getValue("window")?.restoreWindows==="preserve"){const J=await this.hb();N.unshift(...J.filter(x=>he(x)||ne(x)||x.backupPath))}return N}async eb(M){const N={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority},H=await Promise.all((0,O.$Hb)(M.urisToOpen||[]).map(async Q=>{const J=await this.jb(Q,N);if(J)return J.label=Q.label,J;const x=this.lb(Q);this.P.showMessageBox({type:"info",buttons:[(0,o.localize)(0,null)],message:x.scheme===y.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:x.scheme===y.Schemas.file?(0,o.localize)(3,null,(0,d.$Mw)(x,{os:m.OS,tildify:this.G})):(0,o.localize)(4,null,x.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Hb)(H)}async fb(M){const N=[],H={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:M.diff&&M._.length===2||M.merge&&M._.length===4},Q=M["folder-uri"];if(Q){const ee=await Promise.all(Q.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},H)}));N.push(...(0,O.$Hb)(ee))}const J=M["file-uri"];if(J){const ee=await Promise.all(J.map(de=>{const me=this.gb(de);if(me)return this.jb((0,ie.$6i)(de)?{workspaceUri:me}:{fileUri:me},H)}));N.push(...(0,O.$Hb)(ee))}const x=await Promise.all(M._.map(ee=>H.remoteAuthority?this.ob(ee,H):this.mb(ee,H)));return N.push(...(0,O.$Hb)(x)),N}gb(M){try{const N=S.URI.parse(M);if(!N.scheme){this.z.error(`Invalid URI input string, scheme missing: ${M}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.z.error(`Invalid URI input string: ${M}, ${N.message}`)}}async hb(){const M=this.ib();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];M!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const H=await Promise.all(N.map(async Q=>{if(Q.workspace){const J=await this.jb({workspaceUri:Q.workspace.configPath},{remoteAuthority:Q.remoteAuthority,rejectTransientWorkspaces:!0});if(he(J))return J}else if(Q.folderUri){const J=await this.jb({folderUri:Q.folderUri},{remoteAuthority:Q.remoteAuthority});if(ne(J))return J}else if(M!=="folders"&&Q.backupPath)return{backupPath:Q.backupPath,remoteAuthority:Q.remoteAuthority}}));return(0,O.$Hb)(H)}}}ib(){let M;return this.I.wasRestarted?M="all":(M=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")),M}async jb(M,N=Object.create(null)){const H=this.lb(M);return H.scheme===y.Schemas.file?((0,F.$PD)(M)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.mb(H.fsPath,N)):this.kb(M,N)}kb(M,N){let H=this.lb(M);const Q=(0,T.$Mm)(H)||N.remoteAuthority;if(H=(0,p.$ih)((0,p.$ch)(H)),(0,F.$PD)(M)){if(N.gotoLineMode){const{path:J,line:x,column:ee}=(0,f.$Hg)(H.path);return{fileUri:H.with({path:J}),options:{selection:x?{startLineNumber:x,startColumn:ee||1}:void 0},remoteAuthority:Q}}return{fileUri:H,remoteAuthority:Q}}else if((0,F.$ND)(M))return{workspace:(0,oe.$kdc)(H),remoteAuthority:Q};return{workspace:(0,oe.$ldc)(H),remoteAuthority:Q}}lb(M){return(0,F.$ND)(M)?M.workspaceUri:(0,F.$OD)(M)?M.folderUri:M.fileUri}async mb(M,N,H){let Q,J;N.gotoLineMode&&({path:M,line:Q,column:J}=(0,f.$Hg)(M)),M=(0,f.$Bg)((0,h.$hc)(M),(0,w.cwd)());try{const x=await r.Promises.stat(M);if(x.isFile()){if(!N.forceOpenWorkspaceAsFile){const ee=await this.N.resolveLocalWorkspace(S.URI.file(M));if(ee)return ee.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ee.id,configPath:ee.configPath},type:l.FileType.File,exists:!0,remoteAuthority:ee.remoteAuthority,transient:ee.transient}}return{fileUri:S.URI.file(M),type:l.FileType.File,exists:!0,options:{selection:Q?{startLineNumber:Q,startColumn:J||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,oe.$ldc)(S.URI.file(M),x),type:l.FileType.Directory,exists:!0};if(!m.$i&&M==="/dev/null")return{fileUri:S.URI.file(M),type:l.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!H)return this.nb(M,N);const ee=S.URI.file(M);if(this.M.removeRecentlyOpened([ee]),N.ignoreFileNotFound)return{fileUri:ee,type:l.FileType.File,exists:!1}}}async nb(M,N){const H=S.URI.file(M),{response:Q,checkboxChecked:J}=await this.P.showMessageBox({type:"warning",buttons:[(0,o.localize)(5,null),(0,o.localize)(6,null),(0,o.localize)(7,null)],message:(0,o.localize)(8,null,H.authority),detail:(0,o.localize)(9,null,(0,d.$Mw)(H,{os:m.OS,tildify:this.G})),checkboxLabel:(0,o.localize)(10,null,H.authority),cancelId:1});if(Q===0){if((0,k.addUNCHostToAllowlist)(H.authority),J){const x={channel:"vscode:configureAllowedUNCHost",args:H.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.mb(M,N,!0)}if(Q===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(M,N)}ob(M,N){const H=M.charCodeAt(0),Q=N.remoteAuthority;let J,x;N.gotoLineMode&&({path:M,line:J,column:x}=(0,f.$Hg)(M)),H!==E.CharCode.Slash&&((0,f.$Ag)(H)&&M.charCodeAt(M.charCodeAt(1))===E.CharCode.Colon&&(M=(0,f.$tg)(M)),M=`/${M}`);const ee=S.URI.from({scheme:y.Schemas.vscodeRemote,authority:Q,path:M});if(M.charCodeAt(M.length-1)!==E.CharCode.Slash){if((0,ie.$6i)(M))return N.forceOpenWorkspaceAsFile?{fileUri:ee,options:{selection:J?{startLineNumber:J,startColumn:x||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,oe.$kdc)(ee),remoteAuthority:Q};if(N.gotoLineMode||h.$gc.basename(M).indexOf(".")!==-1)return{fileUri:ee,options:{selection:J?{startLineNumber:J,startColumn:x||1}:void 0},remoteAuthority:Q}}return{workspace:(0,oe.$ldc)(ee),remoteAuthority:Q}}pb(M){const N=this.L.getValue("window"),H=N?.openFoldersInNewWindow||"default",Q=N?.openFilesInNewWindow||"off";let J=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(H==="on"||H==="off")&&(J=H==="on");let x=!1;return M.forceNewWindow||M.forceReuseWindow?x=!!M.forceNewWindow&&!M.forceReuseWindow:(m.$j?M.context===C.OpenContext.DOCK&&(x=!0):M.context!==C.OpenContext.DIALOG&&M.context!==C.OpenContext.MENU&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!M.cli.extensionDevelopmentPath&&(Q==="on"||Q==="off")&&(x=Q==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(M,N){const H=(0,z.$idc)(this.getWindows(),M);if(H)return this.I.reload(H,N.cli),H.focus(),[H];let Q=N.cli["folder-uri"]||[],J=N.cli["file-uri"]||[],x=N.cli._;if(!x.length&&!Q.length&&!J.length&&!N.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,pe=me?.workspace??me?.folderUri;pe&&(S.URI.isUri(pe)?pe.scheme===y.Schemas.file?x=[pe.fsPath]:Q=[pe.toString()]:pe.configPath.scheme===y.Schemas.file?x=[(0,p.$2g)(pe.configPath)]:J=[pe.configPath.toString()])}let ee=N.remoteAuthority;for(const me of M)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=S.URI.parse(me),Ie=(0,T.$Mm)(pe);Ie&&(ee?(0,p.$gh)(Ie,ee)||this.z.error("more than one extension development path authority"):ee=Ie)}x=x.filter(me=>{const pe=S.URI.file(me);return(0,z.$hdc)(this.getWindows(),pe)?!1:(0,p.$gh)((0,T.$Mm)(pe),ee)}),Q=Q.filter(me=>{const pe=this.gb(me);return pe&&(0,z.$hdc)(this.getWindows(),pe)?!1:pe?(0,p.$gh)((0,T.$Mm)(pe),ee):!1}),J=J.filter(me=>{const pe=this.gb(me);return pe&&(0,z.$hdc)(this.getWindows(),pe)?!1:pe?(0,p.$gh)((0,T.$Mm)(pe),ee):!1}),N.cli._=x,N.cli["folder-uri"]=Q,N.cli["file-uri"]=J;const de={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!x.length&&!Q.length&&!J.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(de)}async qb(M){const N=this.L.getValue("window"),H=this.getLastActiveWindow(),J=(N?.newWindowProfile?this.H.profiles.find(de=>de.name===N.newWindowProfile):void 0)??H?.profile??this.H.defaultProfile;let x;!M.forceNewWindow&&!M.forceNewTabbedWindow&&(x=M.windowToUse||H,x&&x.focus());const ee={...this.G.args,...M.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:M.emptyWindowBackupInfo?(0,h.$jc)(this.G.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:J},homeDir:this.G.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:{...this.w,...M.userEnv},filesToOpenOrCreate:M.filesToOpen?.filesToOpenOrCreate,filesToDiff:M.filesToOpen?.filesToDiff,filesToMerge:M.filesToOpen?.filesToMerge,filesToWait:M.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:y.Schemas.file}).fsPath,product:R.default,isInitialStartup:M.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(x){const de=x.config;!ee.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ee.extensionDevelopmentPath=de.extensionDevelopmentPath,ee.extensionDevelopmentKind=de.extensionDevelopmentKind,ee["enable-proposed-api"]=de["enable-proposed-api"],ee.verbose=de.verbose,ee["inspect-extensions"]=de["inspect-extensions"],ee["inspect-brk-extensions"]=de["inspect-brk-extensions"],ee.debugId=de.debugId,ee.extensionEnvironment=de.extensionEnvironment,ee["extensions-dir"]=de["extensions-dir"],ee["disable-extensions"]=de["disable-extensions"]),ee.loggers={global:ee.loggers.global,window:de?.loggers.window??ee.loggers.window}}else{const de=this.r.getNewWindowState(ee);(0,g.mark)("code/willCreateCodeWindow");const me=x=this.O.createInstance(W.$sdc,{state:de,extensionDevelopmentPath:ee.extensionDevelopmentPath,isExtensionTestHost:!!ee.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),M.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const pe=new $.$Tc;pe.add(me.onDidSignalReady(()=>this.b.fire(me))),pe.add(c.Event.once(me.onDidClose)(()=>this.tb(me,pe))),pe.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),pe.add(me.onDidMaximize(()=>this.g.fire(me))),pe.add(me.onDidUnmaximize(()=>this.h.fire(me))),pe.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),pe.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),pe.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const Ie=(0,v.$lg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),pe.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ee.windowId=x.id,x.isReady?this.I.unload(x,q.UnloadReason.LOAD).then(async de=>{de||await this.rb(x,ee,M,J)}):await this.rb(x,ee,M,J),x}async rb(M,N,H,Q){if(N.extensionDevelopmentPath||((0,ie.$Pi)(N.workspace)?N.backupPath=this.J.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ie.$Ki)(N.workspace)?N.backupPath=this.J.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.J.registerEmptyWindowBackup({backupFolder:H.emptyWindowBackupInfo?.backupFolder??(0,oe.$mdc)().id,remoteAuthority:N.remoteAuthority})),this.H.isEnabled()){const J=N.workspace??(0,ie.$Oi)(N.backupPath,!1),x=this.sb(H,J,Q),ee=x instanceof Promise?await x:x;N.profiles.profile=ee,N.extensionDevelopmentPath||await this.H.setProfileForWorkspace(J,ee)}M.load(N)}sb(M,N,H){return M.forceProfile?this.H.profiles.find(Q=>Q.name===M.forceProfile)??this.H.createNamedProfile(M.forceProfile):M.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(N)??H}tb(M,N){this.n.delete(M.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}ub(M){this.n.delete(M.id),this.c.fire(M)}getFocusedWindow(){const M=i.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(M){return this.wb(this.getWindows().filter(N=>(0,p.$gh)(N.remoteAuthority,M)))}wb(M){return(0,C.$ddc)(M)}sendToFocused(M,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(M,I.CancellationToken.None,...N)}sendToOpeningWindow(M,...N){this.B(c.Event.once(this.onDidSignalReadyWindow)(H=>{H.sendWhenReady(M,I.CancellationToken.None,...N)}))}sendToAll(M,N,H){for(const Q of this.getWindows())H&&H.indexOf(Q.id)>=0||Q.sendWhenReady(M,I.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(M){return this.n.get(M)}getWindowByWebContents(M){const N=i.BrowserWindow.fromWebContents(M);if(!N)return;const H=this.getWindowById(N.id);return H?.matches(M)?H:void 0}};e.$Dec=Z,e.$Dec=Z=Se([re(4,P.$7j),re(5,ae.$pdc),re(6,j.$dQ),re(7,B.$lo),re(8,n.$3cc),re(9,V.$edc),re(10,b.$udc),re(11,t.$8cc),re(12,s.$7i),re(13,K.$_dc),re(14,te.$ndc),re(15,u.$zi),re(16,a.$9cc),re(17,l.$7k),re(18,D.$$cc),re(19,L.$_cc),re(20,G.$Ydc)],Z)}),define(ce[314],le([0,1,68,29,88,60]),function(X,e,i,r,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let O=class{constructor(E,c,f,d){this.a=E,this.b=c,this.c=f,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(E,c){const f=this.b.getWindowById(E);if(f)return this.a.enterWorkspace(f,this.b.getWindows(),c)}createUntitledWorkspace(E,c,f){return this.a.createUntitledWorkspace(c,f)}deleteUntitledWorkspace(E,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(E,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(E){return this.c.getRecentlyOpened()}addRecentlyOpened(E,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(E,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(E){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Fec=O,e.$Fec=O=Se([re(0,A.$ndc),re(1,r.$bdc),re(2,k.$_dc),re(3,i.$8cc)],O)}),define(ce[315],le([0,1,14,107,37,27,17,48,16,31,3,40,49,2,13,9,4,12,7,33,163,45,164,119,296,167,68,289,18,297,96,136,58,97,225,25,67,101,213,300,215,216,217,15,229,99,82,6,98,224,306,290,298,20,5,312,74,28,71,301,102,34,279,87,129,24,256,257,56,51,269,294,307,295,308,133,271,272,273,276,304,57,29,313,278,30,103,88,314,60,41,238,59,249,55,86,134,281,299,286,8,259,280,233,70,303,275,22,72,302,267,244,65,83,310,76]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T,j,F,W,C,z,se,ie,oe,K,te,q,L,B,V,ae,G,he,ne,Z,U,M,N,H,Q,J,x,ee,de,me,pe,Ie,ke,Pe,Ae,$e,Y,ue,fe,be,De,Ne,Ue,Re,Ce,Ve,Qe,ze,Je,Xe,Ke,Fe,_,ge,we,ye,Le,We,Ye,at,nt,rt,_e,ct,ot,ut,ft,Pt,gt,mt,It,At,Dt,$t,Rt,yt,ht,Ot,jt,wt,Tt,vt,Lt,Et){"use strict";var pt;Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let bt=class extends y.$Uc{static{pt=this}static{this.a={[h.Schemas.file]:"security.promptForLocalFileProtocolHandling",[h.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Oe,je,Te,ve,Ee,qe,xe,Ge,Me,He,Be,Ze){super(),this.g=Oe,this.h=je,this.j=Te,this.m=ve,this.n=Ee,this.s=qe,this.t=xe,this.u=Ge,this.w=Me,this.y=He,this.z=Be,this.C=Ze,this.D(),this.F()}D(){const Oe=Me=>Me?.startsWith(`${h.Schemas.vscodeWebview}://`),je=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Me,He,Be,Ze)=>Oe(Ze.requestingUrl)?Be(je.has(He)):Be(!1)),i.session.defaultSession.setPermissionCheckHandler((Me,He,Be,Ze)=>Oe(Ze.requestingUrl)?je.has(He):!1);const Te=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,h.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Me=>{for(let He=Me;He;He=He.parent)if(He.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Me=>Me.resourceType==="xhr"||ve(Me.frame),qe=Me=>{const He=Me.frame;if(!He||!this.b)return!1;const Be=i.BrowserWindow.getAllWindows();for(const Ze of Be)if(He.processId===Ze.webContents.mainFrame.processId)return!0;return!1},xe=(Me,He)=>{if(Me.path!=="/index.html")return!0;const Be=He.frame;if(!Be||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Be.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Me,He)=>{const Be=p.URI.parse(Me.url);return Be.scheme===h.Schemas.vscodeWebview&&!xe(Be,Me)?(this.m.error("Blocked vscode-webview request",Me.url),He({cancel:!0})):Be.scheme===h.Schemas.vscodeFileResource&&!qe(Me)?(this.m.error("Blocked vscode-file request",Me.url),He({cancel:!0})):Be.path.endsWith(".svg")&&!Te.has(Be.scheme)?He({cancel:!Ee(Me)}):He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Me,He)=>{const Be=Me.responseHeaders,Ze=Be["content-type"]||Be["Content-Type"];if(Ze&&Array.isArray(Ze)){const et=p.URI.parse(Me.url);if(et.path.endsWith(".svg")&&Te.has(et.scheme))return Be["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Be});if(!et.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ze.some(st=>st.toLowerCase().includes("image/svg")))return He({cancel:!Ee(Me)})}return He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Me,He)=>{if(Me.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Be=Me.responseHeaders??Object.create(null);if(Be["Access-Control-Allow-Origin"]===void 0)return Be["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:Be})}return He({cancel:!1})});const Ge=i.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,g.$jc)(this.s.codeCachePath,"chrome")),m.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,E.setUnexpectedErrorHandler)(Te=>this.H(Te)),process.on("uncaughtException",Te=>{(0,E.$Z)(Te)||(0,E.$1)(Te)}),process.on("unhandledRejection",Te=>(0,E.$1)(Te)),this.t.onWillShutdown(()=>this.dispose()),(0,S.$tW)(),i.app.on("accessibility-support-changed",(Te,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),i.app.on("activate",async(Te,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ke.OpenContext.DOCK})}),i.app.on("web-contents-created",(Te,ve)=>{ve?.opener?.url.startsWith(`${h.Schemas.vscodeFileResource}://${h.$Tg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Oe=[],je;i.app.on("open-file",(Te,ve)=>{ve=(0,Et.$gm)(ve),this.m.trace("app#open-file: ",ve),Te.preventDefault(),Oe.push((0,ge.$6i)(ve)?{workspaceUri:p.URI.file(ve)}:{fileUri:p.URI.file(ve)}),je!==void 0&&(clearTimeout(je),je=void 0),je=setTimeout(async()=>{await this.b?.open({context:Ke.OpenContext.DOCK,cli:this.s.args,urisToOpen:Oe,gotoLineMode:!1,preferNewWindow:!0}),Oe=[],je=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ke.OpenContext.DESKTOP})}),k.$sW.handle("vscode:fetchShellEnv",Te=>{const ve=this.b?.getWindowByWebContents(Te.sender);let Ee,qe;return ve?.config?(Ee=ve.config,qe={...process.env,...ve.config.userEnv}):(Ee=this.s.args,qe=process.env),this.X(Ee,qe,!1)}),k.$sW.handle("vscode:writeNlsFile",(Te,ve,Ee)=>{const qe=this.G([ve]);if(!qe||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,O.$Je.fromString(Ee))}),k.$sW.handle("vscode:readNlsFile",async(Te,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),k.$sW.on("vscode:toggleDevTools",Te=>Te.sender.toggleDevTools()),k.$sW.on("vscode:openDevTools",Te=>Te.sender.openDevTools()),k.$sW.on("vscode:reloadWindow",Te=>Te.sender.reload()),k.$sW.handle("vscode:notifyZoomLevel",async(Te,ve)=>{const Ee=this.b?.getWindowByWebContents(Te.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Oe){let je;for(const Te of Oe)typeof Te=="string"&&(typeof je!="string"?je=Te:je=(0,g.$jc)(je,Te));if(!(typeof je!="string"||!(0,g.$ic)(je)||!(0,c.$zg)(je,this.s.cachedLanguagesPath,!m.$k)))return p.URI.file(je)}H(Oe){if(Oe){const je={message:`[uncaught exception in main]: ${Oe.message}`,stack:Oe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(je))}this.m.error(`[uncaught exception in main]: ${Oe}`),Oe.stack&&this.m.error(Oe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Oe=this.z.win32AppUserModelId;m.$i&&Oe&&i.app.setAppUserModelId(Oe);try{m.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.m.error(Be)}const je=new t.$zW;this.t.onWillShutdown(Be=>{Be.reason===M.ShutdownReason.KILL&&je.dispose()}),this.m.trace("Resolving machine identifier...");const[Te,ve,Ee]=await Promise.all([(0,mt.$Oec)(this.w,this.m),(0,mt.$Pec)(this.w,this.m),(0,mt.$Qec)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Te}`);const{sharedProcessReady:qe,sharedProcessClient:xe}=this.P(Te,ve,Ee),Ge=await this.Q(Te,ve,Ee,qe);this.B(Ge.createInstance(a.$Edc)),this.B(Ge.createInstance(ft.$Jec)),Ge.invokeFunction(Be=>this.R(Be,je,xe));const Me=await Ge.invokeFunction(Be=>this.I(Be,je));this.J(je),this.t.phase=M.LifecycleMainPhase.Ready,await Ge.invokeFunction(Be=>this.S(Be,Me)),this.t.phase=M.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new gt.$Mh(()=>{this.B((0,gt.$Qh)(()=>this.t.phase=M.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Oe,je){const Te=this.b=Oe.get(Ke.$bdc),ve=Oe.get(Re.$hX),Ee=this.f=Oe.get(Q.$Zdc),qe=Oe.get(T.$9cc),xe=this;ve.registerHandler({async handleURL(et,st){return xe.O(Te,qe,ve,et,st)}});const Ge=this.B(new _.$Eec({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Me=new o.$ii(et=>Ge.getActiveClientId().then(st=>et===st)),He=new Ce.$vec(Me,this.m),Be=je.getChannel("urlHandler",He);ve.registerHandler(new Ce.$uec(Be));const Ze=await this.L(Te,qe);return this.B(new Qe.$wec(Ze?.urls,ve,Te,this.s,this.z,this.m)),Ze}J(Oe){const je=()=>({statusCode:404,data:"Not found"}),Te=new Tt.$V(()=>Oe.getChannel(wt.$Xec,new wt.$Yec));i.protocol.registerBufferProtocol(h.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const qe=p.URI.parse(ve.url);if(!qe.authority.startsWith("window:"))return Ee(je());Te.value.call(wt.$Wec,[qe]).then(xe=>Ee({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),Ee({statusCode:500,data:String(xe)})})})}async L(Oe,je){const Te=this.s.args["open-url"]?this.s.args._urls||[]:[];Te.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Te);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),Te.length+ve.length===0)return;const Ee=[...Te,...ve].map(Ge=>{try{return{uri:p.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),qe=[],xe=[];for(const Ge of Ee){if(!Ge)continue;const Me=this.N(Ge.uri);if(Me)if(await this.M(Me,Oe,je)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Me),qe.push(Me);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),xe.push(Ge)}return{urls:xe,openables:qe}}async M(Oe,je,Te){let ve,Ee;if((0,Xe.$ND)(Oe)?(ve=Oe.workspaceUri,Ee=(0,n.localize)(0,null,ve.scheme===h.Schemas.file?(0,$.$Mw)(ve,{os:m.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$OD)(Oe)?(ve=Oe.folderUri,Ee=(0,n.localize)(1,null,ve.scheme===h.Schemas.file?(0,$.$Mw)(ve,{os:m.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Oe.fileUri,Ee=(0,n.localize)(2,null,ve.scheme===h.Schemas.file?(0,$.$Mw)(ve,{os:m.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==h.Schemas.file&&ve.scheme!==h.Schemas.vscodeRemote||this.u.getValue(pt.a[ve.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ge}=await Te.showMessageBox({type:"warning",buttons:[(0,n.localize)(3,null),(0,n.localize)(4,null)],message:Ee,detail:(0,n.localize)(5,null),checkboxLabel:ve.scheme===h.Schemas.file?(0,n.localize)(6,null):(0,n.localize)(7,null),cancelId:1});if(xe!==0)return!0;if(Ge){const Me={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===h.Schemas.file?"local":"remote"};je.sendToFocused(Me.channel,Me.args),je.sendToOpeningWindow(Me.channel,Me.args)}return!1}N(Oe){if(Oe.path){if(Oe.authority===h.Schemas.file){const je=p.URI.file(Oe.fsPath);return(0,ge.$6i)(je)?{workspaceUri:je}:{fileUri:je}}else if(Oe.authority===h.Schemas.vscodeRemote){const je=Oe.path.indexOf(g.$gc.sep,1);if(je!==-1){const Te=Oe.path.substring(1,je),ve=Oe.path.substring(je);let Ee=Oe.query;const qe=new URLSearchParams(Oe.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Ee=qe.toString());const xe=p.URI.from({scheme:h.Schemas.vscodeRemote,authority:Te,path:ve,query:Ee,fragment:Oe.fragment});return(0,ge.$6i)(ve)?{workspaceUri:xe}:/:[\d]+$/.test(ve)?{fileUri:xe}:{folderUri:xe}}}}}async O(Oe,je,Te,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:p.URI.parse(ve.query).path,query:""}));let qe=!1;const xe=new URLSearchParams(ve.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),xe.delete("windowId"),ve=ve.with({query:xe.toString()}),qe=!0):m.$j&&Oe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),qe=!0);const Ge=xe.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),xe.delete("continueOn"),ve=ve.with({query:xe.toString()}),this.s.continueOn=Ge??void 0);const Me=this.N(ve);return Me?await this.M(Me,Oe,je)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Me,ve.toString(!0)),(0,yt.$Ob)(await Oe.open({context:Ke.OpenContext.API,cli:{...this.s.args},urisToOpen:[Me],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,yt.$Ob)(await Oe.open({context:Ke.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,x.$Mm)(ve)}))?.ready(),Te.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Oe,je,Te){const ve=this.B(this.j.createInstance(ee.$hec,Oe,je,Te));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new s.$AW(xe,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Oe,je,Te,ve){const Ee=new G.$yi;switch(process.platform){case"win32":Ee.set(ue.$rX,new V.$xi(Ue.$sec));break;case"linux":m.$l?Ee.set(ue.$rX,new V.$xi(Ne.$rec,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(ue.$rX,new V.$xi(De.$qec));break;case"darwin":Ee.set(ue.$rX,new V.$xi(be.$pec));break}Ee.set(Ke.$bdc,new V.$xi(Fe.$Dec,[Oe,je,Te,this.h],!1)),Ee.set(vt.$Ydc,new V.$xi(Lt.$Zec,void 0,!1));const qe=new T.$0cc(this.m,this.z);Ee.set(T.$9cc,qe),Ee.set(U.$6dc,new V.$xi(U.$7dc,void 0,!1)),Ee.set(D.$Kdc,new V.$xi(D.$Ldc,void 0,!1)),Ee.set(R.$in,o.ProxyChannel.toService((0,o.$gi)(ve.then(Be=>Be.getChannel("diagnostics"))))),Ee.set(he.$C0b,new V.$xi(ne.$2dc,[this.h])),Ee.set(j.$bX,new V.$xi(F.$Mdc)),Ee.set(Z.$3dc,new V.$xi(Z.$4dc)),Ee.set(Q.$Zdc,new V.$xi(Q.$1dc,void 0,!1)),Ee.set(ze.$xec,new V.$xi(Je.$zec)),Ee.set(H.$cec,new V.$xi(H.$dec)),Ee.set(se.$Ndc,new V.$xi(ie.$Pdc)),Ee.set(Ie.$Adc,new V.$xi(Ie.$Bdc)),Ee.set(Ie.$Cdc,new V.$xi(Ie.$Ddc));const xe=new Ot.$Vec({graceTime:ht.LocalReconnectConstants.GraceTime,shortGraceTime:ht.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(ht.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ge=new jt.$Es(xe,this.u,this.m,this.n);Ee.set(ht.$fs,Ge),m.$i?Ee.set(oe.$Qdc,new V.$xi(K.$Rdc)):m.$j?Ee.set(oe.$Qdc,new V.$xi(K.$Sdc)):m.$k&&Ee.set(oe.$Qdc,new V.$xi(K.$Tdc));const Me=new u.$Fdc(this.s,this.u,this.m,this.w);Ee.set(l.$8cc,Me);const He=new We.$odc(this.s,this.m,this.C,Me,qe);if(Ee.set(We.$ndc,He),Ee.set(we.$igb,new V.$xi(Le.$Fec,void 0,!1)),Ee.set(ye.$_dc,new V.$xi(ye.$aec,void 0,!1)),Ee.set(Re.$hX,new V.$xi(Ve.$jX,void 0,!1)),(0,Y.$up)(this.z,this.s)){const Be=(0,Y.$zp)(this.z,this.u),Ze=(0,o.$gi)(ve.then(dt=>dt.getChannel("telemetryAppender"))),et=new Ae.$kec(Ze),st=(0,ke.$lp)((0,A.release)(),(0,A.hostname)(),process.arch,this.z.commit,this.z.version,Oe,je,Te,Be),tt=(0,Y.$Ap)(this.s),lt={appenders:[et],commonProperties:st,piiPaths:tt,sendErrorTelemetry:!0};Ee.set(Pe.$6l,new V.$xi($e.$8r,[lt],!1))}else Ee.set(Pe.$6l,Y.$pp);return Ee.set(ct.$xq,new V.$xi(It.$kQ,void 0,!0)),Ee.set(ot.$Bq,new V.$xi(ut.$Iec,void 0,!0)),Ee.set($t.$Tec,new V.$xi($t.$Uec,void 0,!0)),await gt.Promises.settled([Me.initialize(),He.initialize()]),this.j.createChild(Ee)}R(Oe,je,Te){const ve=this.B(new y.$Tc),Ee=o.ProxyChannel.fromService(Oe.get(U.$6dc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const qe=o.ProxyChannel.fromService(Oe.get(D.$Kdc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const xe=ve.add(new at.$Gec(Oe.get(Ye.$lo)));je.registerChannel("policy",xe),Te.then(it=>it.registerChannel("policy",xe));const Ge=this.y.getProvider(h.Schemas.file);(0,w.$kg)(Ge instanceof B.$hr);const Me=ve.add(new L.$Udc(Ge,this.m,this.s));je.registerChannel(te.$6P,Me),Te.then(it=>it.registerChannel(te.$6P,Me));const He=o.ProxyChannel.fromService(Oe.get(nt.$edc),ve);je.registerChannel("userDataProfiles",He),Te.then(it=>it.registerChannel("userDataProfiles",He));const Be=new rt.$3r(Oe.get(_e.$Vp));Te.then(it=>it.registerChannel("request",Be));const Ze=new fe.$lec(Oe.get(ue.$rX));je.registerChannel("update",Ze);const et=o.ProxyChannel.fromService(Oe.get(he.$C0b),ve);je.registerChannel("issue",et);const st=o.ProxyChannel.fromService(Oe.get(j.$bX),ve);je.registerChannel("encryption",st);const tt=o.ProxyChannel.fromService(Oe.get(de.$Tl),ve);je.registerChannel("sign",tt);const lt=o.ProxyChannel.fromService(Oe.get(Z.$3dc),ve);je.registerChannel("keyboardLayout",lt),this.f=Oe.get(Q.$Zdc);const dt=o.ProxyChannel.fromService(this.f,ve);je.registerChannel("nativeHost",dt),Te.then(it=>it.registerChannel("nativeHost",dt));const Ut=o.ProxyChannel.fromService(Oe.get(we.$igb),ve);je.registerChannel("workspaces",Ut);const Mt=o.ProxyChannel.fromService(Oe.get(H.$cec),ve);je.registerChannel("menubar",Mt);const Ft=o.ProxyChannel.fromService(Oe.get(Re.$hX),ve);je.registerChannel("url",Ft);const Nt=o.ProxyChannel.fromService(Oe.get(ze.$xec),ve);je.registerChannel("webview",Nt);const St=ve.add(new pe.$iec(this.m,Oe.get(Ie.$Adc)));je.registerChannel("storage",St),Te.then(it=>it.registerChannel("storage",St));const Ct=ve.add(new Pt.$Kec(Oe.get(Ie.$Adc),Oe.get(nt.$edc),this.m));Te.then(it=>it.registerChannel("profileStorageListener",Ct));const Wt=o.ProxyChannel.fromService(Oe.get(ht.$fs),ve);je.registerChannel(ht.TerminalIpcChannels.LocalPty,Wt);const Bt=o.ProxyChannel.fromService(Oe.get(oe.$Qdc),ve);je.registerChannel("externalTerminal",Bt);const kt=new At.$Rec(Oe.get(Dt.$pdc));je.registerChannel("logger",kt),Te.then(it=>it.registerChannel("logger",kt));const zt=new P.$Gdc(Oe.get(Ke.$bdc));je.registerChannel("extensionhostdebugservice",zt);const qt=o.ProxyChannel.fromService(Oe.get(se.$Ndc),ve);je.registerChannel(se.$Odc,qt);const Ht=o.ProxyChannel.fromService(Oe.get($t.$Tec),ve);je.registerChannel(Rt.$Sec,Ht)}async S(Oe,je){const Te=this.b=Oe.get(Ke.$bdc);this.c=Oe.get(vt.$Ydc);const ve=(0,C.$Fm)(process.env)?Ke.OpenContext.CLI:Ke.OpenContext.DESKTOP,Ee=this.s.args;if(je){if(je.openables.length>0)return Te.open({context:ve,cli:Ee,urisToOpen:je.openables,gotoLineMode:!0,initialStartup:!0});if(je.urls.length>0)for(const tt of je.urls){const lt=new URLSearchParams(tt.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:lt.toString()}),Te.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,xe=Ee._.length,Ge=!!Ee["folder-uri"],Me=!!Ee["file-uri"],He=Ee["skip-add-to-recently-opened"]===!0,Be=Ee.wait&&Ee.waitMarkerFilePath?p.URI.file(Ee.waitMarkerFilePath):void 0,Ze=Ee.remote||void 0,et=Ee.profile,st=Ee["profile-temp"];if(!xe&&!Ge&&!Me){if(Ee["new-window"]||et||st)return Te.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:Be,initialStartup:!0,remoteAuthority:Ze,forceProfile:et,forceTempProfile:st});if(qe.length)return Te.open({context:Ke.OpenContext.DOCK,cli:Ee,urisToOpen:qe.map(tt=>(tt=(0,Et.$gm)(tt),(0,ge.$6i)(tt)?{workspaceUri:p.URI.file(tt)}:{fileUri:p.URI.file(tt)})),noRecentEntry:He,waitMarkerFileURI:Be,initialStartup:!0})}return Te.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:He,waitMarkerFileURI:Be,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:et,forceTempProfile:st})}U(){this.W(),i.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Oe,je)=>{je({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),this.X(this.s.args,process.env,!0),this.Y(),m.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Oe=this.z.win32MutexName;if(m.$i&&Oe)try{const je=await new Promise((ve,Ee)=>{X(["@vscode/windows-mutex"],ve,Ee)}),Te=new je.Mutex(Oe);f.Event.once(this.t.onWillShutdown)(()=>Te.release())}catch(je){this.m.error(je)}}async X(Oe,je,Te){try{return await(0,z.$Lm)(this.u,this.m,Oe,je)}catch(ve){const Ee=(0,I.$lj)(ve);Te?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const je=(await this.y.readFile(this.s.argvResource)).value.toString(),Te=JSON.parse((0,d.$Xn)(je)),Ee=(0,Y.$wp)(this.u)>=Pe.TelemetryLevel.CRASH;if(Te["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.$Wg)()}"`,"}"],xe=je.substring(0,je.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Je.fromString(xe))}else{const qe=je.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);qe!==je&&await this.y.writeFile(this.s.argvResource,O.$Je.fromString(qe))}}catch(Oe){this.m.error(Oe)}}};e.$1ec=bt,e.$1ec=bt=pt=Se([re(2,ae.$zi),re(3,N.$7j),re(4,N.$8j),re(5,W.$3cc),re(6,M.$udc),re(7,b.$7i),re(8,me.$dQ),re(9,q.$7k),re(10,J.$nk),re(11,nt.$edc)],bt)}),define(ce[320],le([0,1,14,44,7,22,8,48,16,31,3,49,13,9,69,4,36,26,21,45,105,315,10,18,243,255,25,67,207,15,227,99,82,223,98,20,230,5,84,28,85,282,132,293,55,292,102,254,34,56,73,59,41,239,237,2,42,270,70,232,124,128,274,107,268]),function(X,e,i,r,k,A,O,I,E,c,f,d,$,y,h,g,m,w,p,v,S,o,t,s,a,n,l,u,b,P,R,D,T,j,F,W,C,z,se,ie,oe,K,te,q,L,B,V,ae,G,he,ne,Z,U,M,N,H,Q,J,x,ee,de,me,pe,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch($e){console.error($e.message),i.app.exit(1)}}async a(){(0,E.setUnexpectedErrorHandler)(Re=>console.error(Re));const[$e,Y,ue,fe,be,De,Ne,Ue]=this.b();try{try{await this.d(ue,Ue,fe,be,Ne)}catch(Re){throw this.g(ue,Ne,Re),Re}await $e.invokeFunction(async Re=>{const Ce=Re.get(z.$7j),Ve=Re.get(W.$udc),Qe=Re.get(P.$7k),ze=Re.get(z.$8j),Je=await this.f(Ce,ue,Ve,$e,Ne,!0);return p.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Xe=>{Ce.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),De.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),f.Event.once(Ve.onWillShutdown)(Xe=>{Qe.dispose(),fe.dispose(),Xe.join("instanceLockfile",p.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(o.$1ec,Je,Y).startup()})}catch(Re){$e.invokeFunction(this.j,Re)}}b(){const $e=new F.$yi,Y=new H.$Tc;process.once("exit",()=>Y.dispose());const ue={_serviceBrand:void 0,...se.default};$e.set(ie.$nk,ue);const fe=new l.$4cc(this.k(),ue),be=this.c(fe);$e.set(l.$3cc,fe);const De=new x.$qdc((0,z.$ik)(fe),fe.logsHome);$e.set(x.$pdc,De);const Ne=new C.$Bac(De.getLogLevel()),Ue=Y.add(new ee.$lQ(Ne,[new z.$bk(De.getLogLevel())]));$e.set(z.$7j,Ue);const Re=new R.$Qq(Ue);$e.set(P.$7k,Re);const Ce=new D.$hr(Ue);Re.registerProvider($.Schemas.file,Ce);const Ve=new J.$Is(Re);$e.set(Q.$El,Ve);const Qe=new me.$gQ(me.SaveStrategy.DELAYED,fe,Ue,Re);$e.set(G.$cQ,Qe),$e.set(G.$dQ,Qe);const ze=new Z.$fdc(Qe,Ve,fe,Re,Ue);$e.set(Z.$edc,ze),Re.registerProvider($.Schemas.vscodeUserData,new pe.$_ec($.Schemas.file,Ce,$.Schemas.vscodeUserData,ze,Ve,Ue));const Je=g.$i&&ue.win32RegValueName?Y.add(new M.$0ec(Ue,ue.win32RegValueName)):fe.policyFile?Y.add(new N.$$ec(fe.policyFile,Re,Ue)):new U.$no;$e.set(U.$lo,Je);const Xe=new a.$No(ze.defaultProfile.settingsResource,Re,Je,Ue);return $e.set(s.$7i,Xe),$e.set(W.$udc,new T.$xi(W.$vdc,void 0,!1)),$e.set(L.$Vp,new T.$xi(B.$8ec,void 0,!0)),$e.set(ne.$_cc,new T.$xi(ne.$adc)),$e.set(V.$Tl,new T.$xi(ae.$9ec,void 0,!1)),$e.set(te.$rw,new T.$xi(q.$6ec)),$e.set(oe.$$cc,new K.$3ec(fe,ze,Ue)),[new j.$kr($e,!0),be,fe,Xe,Qe,Ne,ue,ze]}c($e){const Y={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(Y[ue]=fe)}),Object.assign(process.env,Y),Y}async d($e,Y,ue,fe,be){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:$.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:$.Schemas.file}).fsPath,$e.backupHome].map(De=>De?p.Promises.mkdir(De,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),Y.init()}e($e){if(g.$i){const Y=(0,Ie.getUNCHost)($e);Y&&(0,Ie.addUNCHostToAllowlist)(Y)}return $e}async f($e,Y,ue,fe,be,De){let Ne;try{(0,h.mark)("code/willStartMainServer"),Ne=await(0,S.$vi)(Y.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),f.Event.once(ue.onWillShutdown)(()=>Ne.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.g(Y,be,Ue),Ue;let Re;try{Re=await(0,S.$wi)(Y.mainIPCHandle,"main")}catch(ze){if(!De||g.$i||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.h((0,t.localize)(1,null,be.nameShort),(0,t.localize)(2,null),be),ze;try{(0,r.unlinkSync)(Y.mainIPCHandle)}catch(Je){throw $e.warn("Could not delete obsolete instance handle",Je),Je}return this.f($e,Y,ue,fe,be,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(ze),Re.dispose(),new Error(ze)}let Ce;!Y.args.wait&&!Y.args.status&&(Ce=setTimeout(()=>{this.h((0,t.localize)(3,null,be.nameShort),(0,t.localize)(4,null),be)},1e4));const Ve=v.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),Qe=v.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return fe.invokeFunction(async()=>{const ze=new n.$Ps(he.$pp,be),Je=await Qe.getMainDiagnostics(),Xe=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await ze.getDiagnostics(Je,Xe);throw console.log(Ke),new E.$ab});throw g.$i&&await this.i(Ve,$e),$e.trace("Sending env to running instance..."),await Ve.start(Y.args,process.env),Re.dispose(),Ce&&clearTimeout(Ce),new E.$ab("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,t.localize)(5,null,be.nameShort)),new E.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}g($e,Y,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,A.$Hb)([$e.userDataPath,$e.extensionsPath,S.$ri]).map(be=>(0,d.$Mw)(k.URI.file(be),{os:g.OS,tildify:$e}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,I.$lj)(ue),fe.join(`
`)),Y)}}h($e,Y,ue){i.dialog.showMessageBoxSync((0,de.$1w)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:Y},ue).options)}async i($e,Y){if(g.$i){const ue=await $e.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{X(["windows-foreground-love"],fe,be)})).allowSetForegroundWindow(ue)}catch(fe){Y.error(fe)}}}j($e,Y){const ue=$e.get(z.$7j),fe=$e.get(W.$udc);let be=0;Y&&(Y.isExpected?Y.message&&ue.trace(Y.message):(be=1,Y.stack?ue.error(Y.stack):ue.error(`Startup error: ${Y.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,u.$Cm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const Y=(0,b.$2ec)($e.verbose);Y&&((0,u.$Em)(process.argv,"--waitMarkerFilePath",Y),$e.waitMarkerFilePath=Y)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const Y=this.m($e._,$e.goto);$e._=Y}return $e}m($e,Y){const ue=(0,m.cwd)(),fe=$e.map(Ne=>{let Ue=String(Ne),Re;Y&&(Re=(0,c.$Hg)(Ue),Ue=Re.path),Ue&&(Ue=this.n(ue,Ue));const Ce=(0,c.$Bg)(Ue,ue),Ve=(0,y.$nc)(Ce);return Ve&&!(0,c.$xg)(Ve)?null:Y&&Re?(Re.path=Ce,this.o(Re)):Ce}),be=g.$i||g.$j,De=(0,A.$Mb)(fe,Ne=>Ne&&be?Ne.toLowerCase():Ne||"");return(0,A.$Hb)(De)}n($e,Y){return g.$i&&(Y=(0,w.$jf)(Y,'"')),Y=(0,w.$hf)((0,w.$hf)(Y," "),"	"),g.$i&&(Y=(0,y.$kc)($e,Y),Y=(0,w.$jf)(Y,".")),Y}o($e){const Y=[$e.path];return typeof $e.line=="number"&&Y.push(String($e.line)),typeof $e.column=="number"&&Y.push(String($e.column)),Y.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fc8762e773c35d4e52e8a7375704af2e24698e5d/core/vs/code/electron-main/main.js.map
