/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(Q){for(var t=[],P=0,O=Q.length;P<O;P++)t[P]=se[Q[P]];return t};define(se[75],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=t.LoaderEventType=t.$T=void 0,t.$T=!1;var P;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(P||(t.LoaderEventType=P={}));class O{static get(){const k=new Map,L=new Map,I=new Map,p=new Map;function l(w,R){w.has(R.detail)||w.set(R.detail,-R.timestamp)}function a(w,R){const d=w.get(R.detail);d&&(d>=0||w.set(R.detail,d+R.timestamp))}let c=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(c=Q.getStats().slice(0).sort((w,R)=>w.timestamp-R.timestamp));for(const w of c)switch(w.type){case P.BeginLoadingScript:l(k,w);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:a(k,w);break;case P.BeginInvokeFactory:l(L,w);break;case P.EndInvokeFactory:a(L,w);break;case P.NodeBeginNativeRequire:l(I,w);break;case P.NodeEndNativeRequire:a(I,w);break;case P.NodeBeginEvaluatingScript:l(p,w);break;case P.NodeEndEvaluatingScript:a(p,w);break}let f=0;I.forEach(w=>f+=w);function $(w){const R=[];return w.forEach((d,g)=>R.push([g,d])),R}return{amdLoad:$(k),amdInvoke:$(L),nodeRequire:$(I),nodeEval:$(p),nodeRequireTotal:f}}static toMarkdownTable(k,L){let I="";const p=[];return k.forEach((l,a)=>{p[a]=l.length}),L.forEach(l=>{l.forEach((a,c)=>{typeof a>"u"&&(a=l[c]="-");const f=a.toString().length;p[c]=Math.max(f,p[c])})}),k.forEach((l,a)=>{I+=`| ${l+" ".repeat(p[a]-l.toString().length)} `}),I+=`|
`,k.forEach((l,a)=>{I+=`| ${"-".repeat(p[a])} `}),I+=`|
`,L.forEach(l=>{l.forEach((a,c)=>{typeof a<"u"&&(I+=`| ${a+" ".repeat(p[c]-a.toString().length)} `)}),I+=`|
`}),I}}t.$U=O}),define(se[55],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=O,t.$6h=v,t.$7h=k;function P(L){return(I,p,l)=>{let a=null,c=null;if(typeof l.value=="function"?(a="value",c=l.value):typeof l.get=="function"&&(a="get",c=l.get),!c)throw new Error("not supported");l[a]=L(c,p)}}function O(L,I,p){let l=null,a=null;if(typeof p.value=="function"?(l="value",a=p.value,a.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(l="get",a=p.get),!a)throw new Error("not supported");const c=`$memoize$${I}`;p[l]=function(...f){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:a.apply(this,f)}),this[c]}}function v(L,I,p){return P((l,a)=>{const c=`$debounce$${a}`,f=`$debounce$result$${a}`;return function(...$){this[f]||(this[f]=p?p():void 0),clearTimeout(this[c]),I&&(this[f]=I(this[f],...$),$=[this[f]]),this[c]=setTimeout(()=>{l.apply(this,$),this[f]=p?p():void 0},L)}})}function k(L,I,p){return P((l,a)=>{const c=`$throttle$timer$${a}`,f=`$throttle$result$${a}`,$=`$throttle$lastRun$${a}`,w=`$throttle$pending$${a}`;return function(...R){if(this[f]||(this[f]=p?p():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),I&&(this[f]=I(this[f],...R)),this[w])return;const d=this[$]+L;d<=Date.now()?(this[$]=Date.now(),l.apply(this,[this[f]]),this[f]=p?p():void 0):(this[w]=!0,this[c]=setTimeout(()=>{this[w]=!1,this[$]=Date.now(),l.apply(this,[this[f]]),this[f]=p?p():void 0},d-Date.now()))}})}}),define(se[76],oe([0,1,9]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=O,t.$ed=v,t.$fd=k,t.$gd=L,t.$hd=I,t.$id=p;function O(l,a){if(!l)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}function v(l,a="Unreachable"){throw new Error(a)}function k(l,a="unexpected state"){if(!l)throw new P.$cb(`Assertion Failed: ${a}`)}function L(l){l||(0,P.$1)(new P.$cb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,P.$1)(new P.$cb("Assertion Failed"))}}function p(l,a){let c=0;for(;c<l.length-1;){const f=l[c],$=l[c+1];if(!a(f,$))return!1;c++}return!0}}),define(se[34],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Nn=L,t.$On=c,t.$Pn=f,t.$Qn=$,t.$Rn=w,t.$Sn=R,t.$Tn=d,t.$Un=g,t.$Vn=m,t.$Wn=S,t.$Xn=y,t.$Yn=u;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(t.ScanError=P={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(t.SyntaxKind=O={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(t.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(t.ParseOptions=k={}));function L(i,o=!1){let s=0;const e=i.length;let n="",r=0,h=O.Unknown,E=P.None;function N(ie){let ce=0,ue=0;for(;ce<ie;){const le=i.charCodeAt(s);if(le>=a._0&&le<=a._9)ue=ue*16+le-a._0;else if(le>=a.A&&le<=a.F)ue=ue*16+le-a.A+10;else if(le>=a.a&&le<=a.f)ue=ue*16+le-a.a+10;else break;s++,ce++}return ce<ie&&(ue=-1),ue}function A(ie){s=ie,n="",r=0,h=O.Unknown,E=P.None}function D(){const ie=s;if(i.charCodeAt(s)===a._0)s++;else for(s++;s<i.length&&l(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===a.dot)if(s++,s<i.length&&l(i.charCodeAt(s)))for(s++;s<i.length&&l(i.charCodeAt(s));)s++;else return E=P.UnexpectedEndOfNumber,i.substring(ie,s);let ce=s;if(s<i.length&&(i.charCodeAt(s)===a.E||i.charCodeAt(s)===a.e))if(s++,(s<i.length&&i.charCodeAt(s)===a.plus||i.charCodeAt(s)===a.minus)&&s++,s<i.length&&l(i.charCodeAt(s))){for(s++;s<i.length&&l(i.charCodeAt(s));)s++;ce=s}else E=P.UnexpectedEndOfNumber;return i.substring(ie,ce)}function C(){let ie="",ce=s;for(;;){if(s>=e){ie+=i.substring(ce,s),E=P.UnexpectedEndOfString;break}const ue=i.charCodeAt(s);if(ue===a.doubleQuote){ie+=i.substring(ce,s),s++;break}if(ue===a.backslash){if(ie+=i.substring(ce,s),s++,s>=e){E=P.UnexpectedEndOfString;break}switch(i.charCodeAt(s++)){case a.doubleQuote:ie+='"';break;case a.backslash:ie+="\\";break;case a.slash:ie+="/";break;case a.b:ie+="\b";break;case a.f:ie+="\f";break;case a.n:ie+=`
`;break;case a.r:ie+="\r";break;case a.t:ie+="	";break;case a.u:{const H=N(4);H>=0?ie+=String.fromCharCode(H):E=P.InvalidUnicode;break}default:E=P.InvalidEscapeCharacter}ce=s;continue}if(ue>=0&&ue<=31)if(p(ue)){ie+=i.substring(ce,s),E=P.UnexpectedEndOfString;break}else E=P.InvalidCharacter;s++}return ie}function M(){if(n="",E=P.None,r=s,s>=e)return r=e,h=O.EOF;let ie=i.charCodeAt(s);if(I(ie)){do s++,n+=String.fromCharCode(ie),ie=i.charCodeAt(s);while(I(ie));return h=O.Trivia}if(p(ie))return s++,n+=String.fromCharCode(ie),ie===a.carriageReturn&&i.charCodeAt(s)===a.lineFeed&&(s++,n+=`
`),h=O.LineBreakTrivia;switch(ie){case a.openBrace:return s++,h=O.OpenBraceToken;case a.closeBrace:return s++,h=O.CloseBraceToken;case a.openBracket:return s++,h=O.OpenBracketToken;case a.closeBracket:return s++,h=O.CloseBracketToken;case a.colon:return s++,h=O.ColonToken;case a.comma:return s++,h=O.CommaToken;case a.doubleQuote:return s++,n=C(),h=O.StringLiteral;case a.slash:{const ce=s-1;if(i.charCodeAt(s+1)===a.slash){for(s+=2;s<e&&!p(i.charCodeAt(s));)s++;return n=i.substring(ce,s),h=O.LineCommentTrivia}if(i.charCodeAt(s+1)===a.asterisk){s+=2;const ue=e-1;let le=!1;for(;s<ue;){if(i.charCodeAt(s)===a.asterisk&&i.charCodeAt(s+1)===a.slash){s+=2,le=!0;break}s++}return le||(s++,E=P.UnexpectedEndOfComment),n=i.substring(ce,s),h=O.BlockCommentTrivia}return n+=String.fromCharCode(ie),s++,h=O.Unknown}case a.minus:if(n+=String.fromCharCode(ie),s++,s===e||!l(i.charCodeAt(s)))return h=O.Unknown;case a._0:case a._1:case a._2:case a._3:case a._4:case a._5:case a._6:case a._7:case a._8:case a._9:return n+=D(),h=O.NumericLiteral;default:for(;s<e&&J(ie);)s++,ie=i.charCodeAt(s);if(r!==s){switch(n=i.substring(r,s),n){case"true":return h=O.TrueKeyword;case"false":return h=O.FalseKeyword;case"null":return h=O.NullKeyword}return h=O.Unknown}return n+=String.fromCharCode(ie),s++,h=O.Unknown}}function J(ie){if(I(ie)||p(ie))return!1;switch(ie){case a.closeBrace:case a.closeBracket:case a.openBrace:case a.openBracket:case a.doubleQuote:case a.colon:case a.comma:case a.slash:return!1}return!0}function ae(){let ie;do ie=M();while(ie>=O.LineCommentTrivia&&ie<=O.Trivia);return ie}return{setPosition:A,getPosition:()=>s,scan:o?ae:M,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>E}}function I(i){return i===a.space||i===a.tab||i===a.verticalTab||i===a.formFeed||i===a.nonBreakingSpace||i===a.ogham||i>=a.enQuad&&i<=a.zeroWidthSpace||i===a.narrowNoBreakSpace||i===a.mathematicalSpace||i===a.ideographicSpace||i===a.byteOrderMark}function p(i){return i===a.lineFeed||i===a.carriageReturn||i===a.lineSeparator||i===a.paragraphSeparator}function l(i){return i>=a._0&&i<=a._9}var a;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(a||(a={}));function c(i,o){const s=[],e=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function E(N,A,D,C){r.value=N,r.offset=A,r.length=D,r.type=C,r.colonOffset=void 0,n=r}try{S(i,{onObjectBegin:(N,A)=>{if(o<=N)throw e;n=void 0,h=o>N,s.push("")},onObjectProperty:(N,A,D)=>{if(o<A||(E(N,A,D,"property"),s[s.length-1]=N,o<=A+D))throw e},onObjectEnd:(N,A)=>{if(o<=N)throw e;n=void 0,s.pop()},onArrayBegin:(N,A)=>{if(o<=N)throw e;n=void 0,s.push(0)},onArrayEnd:(N,A)=>{if(o<=N)throw e;n=void 0,s.pop()},onLiteralValue:(N,A,D)=>{if(o<A||(E(N,A,D,u(N)),o<=A+D))throw e},onSeparator:(N,A,D)=>{if(o<=A)throw e;if(N===":"&&n&&n.type==="property")n.colonOffset=A,h=!1,n=void 0;else if(N===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(h=!0,s[s.length-1]=""),n=void 0}}})}catch(N){if(N!==e)throw N}return{path:s,previousNode:n,isAtPropertyKey:h,matches:N=>{let A=0;for(let D=0;A<N.length&&D<s.length;D++)if(N[A]===s[D]||N[A]==="*")A++;else if(N[A]!=="**")return!1;return A===N.length}}}function f(i,o=[],s=k.DEFAULT){let e=null,n=[];const r=[];function h(N){Array.isArray(n)?n.push(N):e!==null&&(n[e]=N)}return S(i,{onObjectBegin:()=>{const N={};h(N),r.push(n),n=N,e=null},onObjectProperty:N=>{e=N},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const N=[];h(N),r.push(n),n=N,e=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:h,onError:(N,A,D)=>{o.push({error:N,offset:A,length:D})}},s),n[0]}function $(i,o=[],s=k.DEFAULT){let e={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(N){e.type==="property"&&(e.length=N-e.offset,e=e.parent)}function r(N){return e.children.push(N),N}S(i,{onObjectBegin:N=>{e=r({type:"object",offset:N,length:-1,parent:e,children:[]})},onObjectProperty:(N,A,D)=>{e=r({type:"property",offset:A,length:-1,parent:e,children:[]}),e.children.push({type:"string",value:N,offset:A,length:D,parent:e})},onObjectEnd:(N,A)=>{e.length=N+A-e.offset,e=e.parent,n(N+A)},onArrayBegin:(N,A)=>{e=r({type:"array",offset:N,length:-1,parent:e,children:[]})},onArrayEnd:(N,A)=>{e.length=N+A-e.offset,e=e.parent,n(N+A)},onLiteralValue:(N,A,D)=>{r({type:u(N),offset:A,length:D,parent:e,value:N}),n(A+D)},onSeparator:(N,A,D)=>{e.type==="property"&&(N===":"?e.colonOffset=A:N===","&&n(A))},onError:(N,A,D)=>{o.push({error:N,offset:A,length:D})}},s);const E=e.children[0];return E&&delete E.parent,E}function w(i,o){if(!i)return;let s=i;for(const e of o)if(typeof e=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===e){s=r.children[1],n=!0;break}if(!n)return}else{const n=e;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}function R(i){if(!i.parent||!i.parent.children)return[];const o=R(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const o=Object.create(null);for(const s of i.children){const e=s.children[1];e&&(o[s.children[0].value]=d(e))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function g(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}function m(i,o,s=!1){if(g(i,o,s)){const e=i.children;if(Array.isArray(e))for(let n=0;n<e.length&&e[n].offset<=o;n++){const r=m(e[n],o,s);if(r)return r}return i}}function S(i,o,s=k.DEFAULT){const e=L(i,!1);function n(Y){return Y?()=>Y(e.getTokenOffset(),e.getTokenLength()):()=>!0}function r(Y){return Y?F=>Y(F,e.getTokenOffset(),e.getTokenLength()):()=>!0}const h=n(o.onObjectBegin),E=r(o.onObjectProperty),N=n(o.onObjectEnd),A=n(o.onArrayBegin),D=n(o.onArrayEnd),C=r(o.onLiteralValue),M=r(o.onSeparator),J=n(o.onComment),ae=r(o.onError),ie=s&&s.disallowComments,ce=s&&s.allowTrailingComma;function ue(){for(;;){const Y=e.scan();switch(e.getTokenError()){case P.InvalidUnicode:le(v.InvalidUnicode);break;case P.InvalidEscapeCharacter:le(v.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:le(v.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:ie||le(v.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:le(v.UnexpectedEndOfString);break;case P.InvalidCharacter:le(v.InvalidCharacter);break}switch(Y){case O.LineCommentTrivia:case O.BlockCommentTrivia:ie?le(v.InvalidCommentToken):J();break;case O.Unknown:le(v.InvalidSymbol);break;case O.Trivia:case O.LineBreakTrivia:break;default:return Y}}}function le(Y,F=[],z=[]){if(ae(Y),F.length+z.length>0){let x=e.getToken();for(;x!==O.EOF;){if(F.indexOf(x)!==-1){ue();break}else if(z.indexOf(x)!==-1)break;x=ue()}}}function H(Y){const F=e.getTokenValue();return Y?C(F):E(F),ue(),!0}function _(){switch(e.getToken()){case O.NumericLiteral:{let Y=0;try{Y=JSON.parse(e.getTokenValue()),typeof Y!="number"&&(le(v.InvalidNumberFormat),Y=0)}catch{le(v.InvalidNumberFormat)}C(Y);break}case O.NullKeyword:C(null);break;case O.TrueKeyword:C(!0);break;case O.FalseKeyword:C(!1);break;default:return!1}return ue(),!0}function B(){return e.getToken()!==O.StringLiteral?(le(v.PropertyNameExpected,[],[O.CloseBraceToken,O.CommaToken]),!1):(H(!1),e.getToken()===O.ColonToken?(M(":"),ue(),Z()||le(v.ValueExpected,[],[O.CloseBraceToken,O.CommaToken])):le(v.ColonExpected,[],[O.CloseBraceToken,O.CommaToken]),!0)}function U(){h(),ue();let Y=!1;for(;e.getToken()!==O.CloseBraceToken&&e.getToken()!==O.EOF;){if(e.getToken()===O.CommaToken){if(Y||le(v.ValueExpected,[],[]),M(","),ue(),e.getToken()===O.CloseBraceToken&&ce)break}else Y&&le(v.CommaExpected,[],[]);B()||le(v.ValueExpected,[],[O.CloseBraceToken,O.CommaToken]),Y=!0}return N(),e.getToken()!==O.CloseBraceToken?le(v.CloseBraceExpected,[O.CloseBraceToken],[]):ue(),!0}function G(){A(),ue();let Y=!1;for(;e.getToken()!==O.CloseBracketToken&&e.getToken()!==O.EOF;){if(e.getToken()===O.CommaToken){if(Y||le(v.ValueExpected,[],[]),M(","),ue(),e.getToken()===O.CloseBracketToken&&ce)break}else Y&&le(v.CommaExpected,[],[]);Z()||le(v.ValueExpected,[],[O.CloseBracketToken,O.CommaToken]),Y=!0}return D(),e.getToken()!==O.CloseBracketToken?le(v.CloseBracketExpected,[O.CloseBracketToken],[]):ue(),!0}function Z(){switch(e.getToken()){case O.OpenBracketToken:return G();case O.OpenBraceToken:return U();case O.StringLiteral:return H(!0);default:return _()}}return ue(),e.getToken()===O.EOF?s.allowEmptyContent?!0:(le(v.ValueExpected,[],[]),!1):Z()?(e.getToken()!==O.EOF&&le(v.EndOfFileExpected,[],[]),!0):(le(v.ValueExpected,[],[]),!1)}function y(i,o){const s=L(i),e=[];let n,r=0,h;do switch(h=s.getPosition(),n=s.scan(),n){case O.LineCommentTrivia:case O.BlockCommentTrivia:case O.EOF:r!==h&&e.push(i.substring(r,h)),o!==void 0&&e.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(n!==O.EOF);return e.join("")}function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[77],oe([0,1,34]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=O,t.$1n=v,t.$2n=I,t.$3n=p;function O(l,a,c){let f,$,w,R,d;if(a){for(R=a.offset,d=R+a.length,w=R;w>0&&!p(l,w-1);)w--;let h=d;for(;h<l.length&&!p(l,h);)h++;$=l.substring(w,h),f=L($,c)}else $=l,f=0,w=0,R=0,d=l.length;const g=I(c,l);let m=!1,S=0,y;c.insertSpaces?y=k(" ",c.tabSize||4):y="	";const u=(0,P.$Nn)($,!1);let i=!1;function o(){return g+k(y,f+S)}function s(){let h=u.scan();for(m=!1;h===P.SyntaxKind.Trivia||h===P.SyntaxKind.LineBreakTrivia;)m=m||h===P.SyntaxKind.LineBreakTrivia,h=u.scan();return i=h===P.SyntaxKind.Unknown||u.getTokenError()!==P.ScanError.None,h}const e=[];function n(h,E,N){!i&&E<d&&N>R&&l.substring(E,N)!==h&&e.push({offset:E,length:N-E,content:h})}let r=s();if(r!==P.SyntaxKind.EOF){const h=u.getTokenOffset()+w,E=k(y,f);n(E,w,h)}for(;r!==P.SyntaxKind.EOF;){let h=u.getTokenOffset()+u.getTokenLength()+w,E=s(),N="";for(;!m&&(E===P.SyntaxKind.LineCommentTrivia||E===P.SyntaxKind.BlockCommentTrivia);){const D=u.getTokenOffset()+w;n(" ",h,D),h=u.getTokenOffset()+u.getTokenLength()+w,N=E===P.SyntaxKind.LineCommentTrivia?o():"",E=s()}if(E===P.SyntaxKind.CloseBraceToken)r!==P.SyntaxKind.OpenBraceToken&&(S--,N=o());else if(E===P.SyntaxKind.CloseBracketToken)r!==P.SyntaxKind.OpenBracketToken&&(S--,N=o());else{switch(r){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:S++,N=o();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:N=o();break;case P.SyntaxKind.BlockCommentTrivia:m?N=o():N=" ";break;case P.SyntaxKind.ColonToken:N=" ";break;case P.SyntaxKind.StringLiteral:if(E===P.SyntaxKind.ColonToken){N="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:E===P.SyntaxKind.LineCommentTrivia||E===P.SyntaxKind.BlockCommentTrivia?N=" ":E!==P.SyntaxKind.CommaToken&&E!==P.SyntaxKind.EOF&&(i=!0);break;case P.SyntaxKind.Unknown:i=!0;break}m&&(E===P.SyntaxKind.LineCommentTrivia||E===P.SyntaxKind.BlockCommentTrivia)&&(N=o())}const A=u.getTokenOffset()+w;n(N,h,A),r=E}return e}function v(l,a){const c=JSON.stringify(l,void 0,a.insertSpaces?a.tabSize||4:"	");return a.eol!==void 0?c.replace(/\r\n|\r|\n/g,a.eol):c}function k(l,a){let c="";for(let f=0;f<a;f++)c+=l;return c}function L(l,a){let c=0,f=0;const $=a.tabSize||4;for(;c<l.length;){const w=l.charAt(c);if(w===" ")f++;else if(w==="	")f+=$;else break;c++}return Math.floor(f/$)}function I(l,a){for(let c=0;c<a.length;c++){const f=a.charAt(c);if(f==="\r")return c+1<a.length&&a.charAt(c+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return l&&l.eol||`
`}function p(l,a){return`\r
`.indexOf(l.charAt(a))!==-1}}),define(se[78],oe([0,1,34,77]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4n=v,t.$5n=k,t.$6n=L,t.$7n=I,t.$8n=p;function v(l,a,c){return k(l,a,void 0,c)}function k(l,a,c,f,$){const w=a.slice(),R=[],d=(0,P.$Qn)(l,R);let g,m;for(;w.length>0&&(m=w.pop(),g=(0,P.$Rn)(d,w),g===void 0&&c!==void 0);)typeof m=="string"?c={[m]:c}:c=[c];if(g)if(g.type==="object"&&typeof m=="string"&&Array.isArray(g.children)){const S=(0,P.$Rn)(g,[m]);if(S!==void 0)if(c===void 0){if(!S.parent)throw new Error("Malformed AST");const y=g.children.indexOf(S.parent);let u,i=S.parent.offset+S.parent.length;if(y>0){const o=g.children[y-1];u=o.offset+o.length}else u=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return L(l,{offset:u,length:i-u,content:""},f)}else return L(l,{offset:S.offset,length:S.length,content:JSON.stringify(c)},f);else{if(c===void 0)return[];const y=`${JSON.stringify(m)}: ${JSON.stringify(c)}`,u=$?$(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(u>0){const o=g.children[u-1];i={offset:o.offset+o.length,length:0,content:","+y}}else g.children.length===0?i={offset:g.offset+1,length:0,content:y}:i={offset:g.offset+1,length:0,content:y+","};return L(l,i,f)}}else if(g.type==="array"&&typeof m=="number"&&Array.isArray(g.children))if(c!==void 0){const S=`${JSON.stringify(c)}`;let y;if(g.children.length===0||m===0)y={offset:g.offset+1,length:0,content:g.children.length===0?S:S+","};else{const u=m===-1||m>g.children.length?g.children.length:m,i=g.children[u-1];y={offset:i.offset+i.length,length:0,content:","+S}}return L(l,y,f)}else{const S=m,y=g.children[S];let u;if(g.children.length===1)u={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===S){const i=g.children[S-1],o=i.offset+i.length,s=g.offset+g.length;u={offset:o,length:s-2-o,content:""}}else u={offset:y.offset,length:g.children[S+1].offset-y.offset,content:""};return L(l,u,f)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${g.type}`);else return c===void 0?[]:L(l,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(c)},f)}function L(l,a,c){let f=I(l,a),$=a.offset,w=a.offset+a.content.length;if(a.length===0||a.content.length===0){for(;$>0&&!(0,O.$3n)(f,$-1);)$--;for(;w<f.length&&!(0,O.$3n)(f,w);)w++}const R=(0,O.$Zn)(f,{offset:$,length:w-$},c);for(let g=R.length-1;g>=0;g--){const m=R[g];f=I(f,m),$=Math.min($,m.offset),w=Math.max(w,m.offset+m.length),w+=m.content.length-m.length}const d=l.length-(f.length-w)-$;return[{offset:$,length:d,content:f.substring($,w)}]}function I(l,a){return l.substring(0,a.offset)+a.content+l.substring(a.offset+a.length)}function p(l,a){const c=a.slice(0).sort(($,w)=>{const R=$.offset-w.offset;return R===0?$.length-w.length:R});let f=l.length;for(let $=c.length-1;$>=0;$--){const w=c[$];if(w.offset+w.length<=f)l=I(l,w);else throw new Error("Overlapping edit");f=w.offset}return l}}),define(se[79],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Km=t.$Jm=t.$Im=void 0,t.$Gm=P,t.rot=O;function P(I,p,l){return Math.min(Math.max(I,p),l)}function O(I,p){return(p+I%p)%p}class v{constructor(){this.a=0}getNext(){return this.a++}}t.$Im=v;class k{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Jm=k;class L{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const l=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Km=L}),function(){function Q(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function L(p){k.push(p,Date.now())}function I(){const p=[];for(let l=0;l<k.length;l+=2)p.push({name:k[l],startTime:k[l+1]});return p}return{mark:L,getMarks:I}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(v+L.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function P(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=t()),v.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),function(Q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var P=t();for(var O in P)(typeof exports=="object"?exports:Q)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(Q){var t={};function P(O){if(t[O])return t[O].exports;var v=t[O]={i:O,l:!1,exports:{}};return Q[O].call(v.exports,v,v.exports,P),v.l=!0,v.exports}return P.m=Q,P.c=t,P.d=function(O,v,k){P.o(O,v)||Object.defineProperty(O,v,{enumerable:!0,get:k})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,v){if(1&v&&(O=P(O)),8&v||4&v&&typeof O=="object"&&O&&O.__esModule)return O;var k=Object.create(null);if(P.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:O}),2&v&&typeof O!="string")for(var L in O)P.d(k,L,function(I){return O[I]}.bind(null,L));return k},P.n=function(O){var v=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(v,"a",v),v},P.o=function(O,v){return Object.prototype.hasOwnProperty.call(O,v)},P.p="",P(P.s=0)}([function(Q,t,P){(function(O){var v;t=Q.exports=z,v=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=t.re=[],p=t.src=[],l=0,a=l++;p[a]="0|[1-9]\\d*";var c=l++;p[c]="[0-9]+";var f=l++;p[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=l++;p[$]="("+p[a]+")\\.("+p[a]+")\\.("+p[a]+")";var w=l++;p[w]="("+p[c]+")\\.("+p[c]+")\\.("+p[c]+")";var R=l++;p[R]="(?:"+p[a]+"|"+p[f]+")";var d=l++;p[d]="(?:"+p[c]+"|"+p[f]+")";var g=l++;p[g]="(?:-("+p[R]+"(?:\\."+p[R]+")*))";var m=l++;p[m]="(?:-?("+p[d]+"(?:\\."+p[d]+")*))";var S=l++;p[S]="[0-9A-Za-z-]+";var y=l++;p[y]="(?:\\+("+p[S]+"(?:\\."+p[S]+")*))";var u=l++,i="v?"+p[$]+p[g]+"?"+p[y]+"?";p[u]="^"+i+"$";var o="[v=\\s]*"+p[w]+p[m]+"?"+p[y]+"?",s=l++;p[s]="^"+o+"$";var e=l++;p[e]="((?:<|>)?=?)";var n=l++;p[n]=p[c]+"|x|X|\\*";var r=l++;p[r]=p[a]+"|x|X|\\*";var h=l++;p[h]="[v=\\s]*("+p[r]+")(?:\\.("+p[r]+")(?:\\.("+p[r]+")(?:"+p[g]+")?"+p[y]+"?)?)?";var E=l++;p[E]="[v=\\s]*("+p[n]+")(?:\\.("+p[n]+")(?:\\.("+p[n]+")(?:"+p[m]+")?"+p[y]+"?)?)?";var N=l++;p[N]="^"+p[e]+"\\s*"+p[h]+"$";var A=l++;p[A]="^"+p[e]+"\\s*"+p[E]+"$";var D=l++;p[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=l++;p[C]="(?:~>?)";var M=l++;p[M]="(\\s*)"+p[C]+"\\s+",I[M]=new RegExp(p[M],"g");var J=l++;p[J]="^"+p[C]+p[h]+"$";var ae=l++;p[ae]="^"+p[C]+p[E]+"$";var ie=l++;p[ie]="(?:\\^)";var ce=l++;p[ce]="(\\s*)"+p[ie]+"\\s+",I[ce]=new RegExp(p[ce],"g");var ue=l++;p[ue]="^"+p[ie]+p[h]+"$";var le=l++;p[le]="^"+p[ie]+p[E]+"$";var H=l++;p[H]="^"+p[e]+"\\s*("+o+")$|^$";var _=l++;p[_]="^"+p[e]+"\\s*("+i+")$|^$";var B=l++;p[B]="(\\s*)"+p[e]+"\\s*("+o+"|"+p[h]+")",I[B]=new RegExp(p[B],"g");var U=l++;p[U]="^\\s*("+p[h]+")\\s+-\\s+("+p[h]+")\\s*$";var G=l++;p[G]="^\\s*("+p[E]+")\\s+-\\s+("+p[E]+")\\s*$";var Z=l++;p[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)v(Y,p[Y]),I[Y]||(I[Y]=new RegExp(p[Y]));function F(W,ee){if(W instanceof z)return W;if(typeof W!="string"||W.length>k||!(ee?I[s]:I[u]).test(W))return null;try{return new z(W,ee)}catch{return null}}function z(W,ee){if(W instanceof z){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof z))return new z(W,ee);v("SemVer",W,ee),this.loose=ee;var te=W.trim().match(ee?I[s]:I[u]);if(!te)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var be=+pe;if(be>=0&&be<L)return be}return pe}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}t.parse=F,t.valid=function(W,ee){var te=F(W,ee);return te?te.version:null},t.clean=function(W,ee){var te=F(W.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},t.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(W){return v("SemVer.compare",this.version,this.loose,W),W instanceof z||(W=new z(W,this.loose)),this.compareMain(W)||this.comparePre(W)},z.prototype.compareMain=function(W){return W instanceof z||(W=new z(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},z.prototype.comparePre=function(W){if(W instanceof z||(W=new z(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],pe=W.prerelease[ee];if(v("prerelease compare",ee,te,pe),te===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(te===void 0)return-1;if(te!==pe)return V(te,pe)}while(++ee)},z.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},t.inc=function(W,ee,te,pe){typeof te=="string"&&(pe=te,te=void 0);try{return new z(W,te).inc(ee,pe).version}catch{return null}},t.diff=function(W,ee){if(q(W,ee))return null;var te=F(W),pe=F(ee);if(te.prerelease.length||pe.prerelease.length){for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return"pre"+be;return"prerelease"}for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return be},t.compareIdentifiers=V;var x=/^[0-9]+$/;function V(W,ee){var te=x.test(W),pe=x.test(ee);return te&&pe&&(W=+W,ee=+ee),te&&!pe?-1:pe&&!te?1:W<ee?-1:W>ee?1:0}function b(W,ee,te){return new z(W,te).compare(new z(ee,te))}function T(W,ee,te){return b(W,ee,te)>0}function j(W,ee,te){return b(W,ee,te)<0}function q(W,ee,te){return b(W,ee,te)===0}function X(W,ee,te){return b(W,ee,te)!==0}function K(W,ee,te){return b(W,ee,te)>=0}function re(W,ee,te){return b(W,ee,te)<=0}function fe(W,ee,te,pe){var be;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W===te;break;case"!==":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W!==te;break;case"":case"=":case"==":be=q(W,te,pe);break;case"!=":be=X(W,te,pe);break;case">":be=T(W,te,pe);break;case">=":be=K(W,te,pe);break;case"<":be=j(W,te,pe);break;case"<=":be=re(W,te,pe);break;default:throw new TypeError("Invalid operator: "+ee)}return be}function he(W,ee){if(W instanceof he){if(W.loose===ee)return W;W=W.value}if(!(this instanceof he))return new he(W,ee);v("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}t.rcompareIdentifiers=function(W,ee){return V(ee,W)},t.major=function(W,ee){return new z(W,ee).major},t.minor=function(W,ee){return new z(W,ee).minor},t.patch=function(W,ee){return new z(W,ee).patch},t.compare=b,t.compareLoose=function(W,ee){return b(W,ee,!0)},t.rcompare=function(W,ee,te){return b(ee,W,te)},t.sort=function(W,ee){return W.sort(function(te,pe){return t.compare(te,pe,ee)})},t.rsort=function(W,ee){return W.sort(function(te,pe){return t.rcompare(te,pe,ee)})},t.gt=T,t.lt=j,t.eq=q,t.neq=X,t.gte=K,t.lte=re,t.cmp=fe,t.Comparator=he;var ve={};function me(W,ee){if(W instanceof me)return W.loose===ee?W:new me(W.raw,ee);if(W instanceof he)return new me(W.value,ee);if(!(this instanceof me))return new me(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function de(W,ee,te,pe,be,Ae,Pe,Le,Oe,De,Ue,Ne,Te){return((ee=ge(te)?"":ge(pe)?">="+te+".0.0":ge(be)?">="+te+"."+pe+".0":">="+ee)+" "+(Le=ge(Oe)?"":ge(De)?"<"+(+Oe+1)+".0.0":ge(Ue)?"<"+Oe+"."+(+De+1)+".0":Ne?"<="+Oe+"."+De+"."+Ue+"-"+Ne:"<="+Le)).trim()}function $e(W,ee){for(var te=0;te<W.length;te++)if(!W[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<W.length;te++)if(v(W[te].semver),W[te].semver!==ve&&W[te].semver.prerelease.length>0){var pe=W[te].semver;if(pe.major===ee.major&&pe.minor===ee.minor&&pe.patch===ee.patch)return!0}return!1}return!0}function ye(W,ee,te){try{ee=new me(ee,te)}catch{return!1}return ee.test(W)}function Ie(W,ee,te,pe){var be,Ae,Pe,Le,Oe;switch(W=new z(W,pe),ee=new me(ee,pe),te){case">":be=T,Ae=re,Pe=j,Le=">",Oe=">=";break;case"<":be=j,Ae=K,Pe=T,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(W,ee,pe))return!1;for(var De=0;De<ee.set.length;++De){var Ue=ee.set[De],Ne=null,Te=null;if(Ue.forEach(function(Ce){Ce.semver===ve&&(Ce=new he(">=0.0.0")),Ne=Ne||Ce,Te=Te||Ce,be(Ce.semver,Ne.semver,pe)?Ne=Ce:Pe(Ce.semver,Te.semver,pe)&&(Te=Ce)}),Ne.operator===Le||Ne.operator===Oe||(!Te.operator||Te.operator===Le)&&Ae(W,Te.semver)||Te.operator===Oe&&Pe(W,Te.semver))return!1}return!0}he.prototype.parse=function(W){var ee=this.loose?I[H]:I[_],te=W.match(ee);if(!te)throw new TypeError("Invalid comparator: "+W);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new z(te[2],this.loose):this.semver=ve},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return v("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new z(W,this.loose)),fe(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,ee){if(!(W instanceof he))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new me(W.value,ee),ye(this.value,te,ee);if(W.operator==="")return te=new me(this.value,ee),ye(W.semver,te,ee);var pe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Le=fe(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Oe=fe(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return pe||be||Ae&&Pe||Le||Oe},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),v("range",W,ee);var te=ee?I[G]:I[U];W=W.replace(te,de),v("hyphen replace",W),W=W.replace(I[B],"$1$2$3"),v("comparator trim",W,I[B]),W=(W=(W=W.replace(I[M],"$1~")).replace(I[ce],"$1^")).split(/\s+/).join(" ");var pe=ee?I[H]:I[_],be=W.split(" ").map(function(Ae){return function(Pe,Le){return v("comp",Pe),Pe=function(Oe,De){return Oe.trim().split(/\s+/).map(function(Ue){return function(Ne,Te){v("caret",Ne,Te);var Ce=Te?I[le]:I[ue];return Ne.replace(Ce,function(Fe,Ee,Se,ke,Re){var je;return v("caret",Ne,Fe,Ee,Se,ke,Re),ge(Ee)?je="":ge(Se)?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(ke)?je=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":Re?(v("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),je=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+ke+Re+" <"+Ee+"."+Se+"."+(+ke+1):">="+Ee+"."+Se+"."+ke+Re+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+ke+Re+" <"+(+Ee+1)+".0.0"):(v("no pr"),je=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+ke+" <"+Ee+"."+Se+"."+(+ke+1):">="+Ee+"."+Se+"."+ke+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+ke+" <"+(+Ee+1)+".0.0"),v("caret return",je),je})}(Ue,De)}).join(" ")}(Pe,Le),v("caret",Pe),Pe=function(Oe,De){return Oe.trim().split(/\s+/).map(function(Ue){return function(Ne,Te){var Ce=Te?I[ae]:I[J];return Ne.replace(Ce,function(Fe,Ee,Se,ke,Re){var je;return v("tilde",Ne,Fe,Ee,Se,ke,Re),ge(Ee)?je="":ge(Se)?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(ke)?je=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":Re?(v("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),je=">="+Ee+"."+Se+"."+ke+Re+" <"+Ee+"."+(+Se+1)+".0"):je=">="+Ee+"."+Se+"."+ke+" <"+Ee+"."+(+Se+1)+".0",v("tilde return",je),je})}(Ue,De)}).join(" ")}(Pe,Le),v("tildes",Pe),Pe=function(Oe,De){return v("replaceXRanges",Oe,De),Oe.split(/\s+/).map(function(Ue){return function(Ne,Te){Ne=Ne.trim();var Ce=Te?I[A]:I[N];return Ne.replace(Ce,function(Fe,Ee,Se,ke,Re,je){v("xRange",Ne,Fe,Ee,Se,ke,Re,je);var Me=ge(Se),ze=Me||ge(ke),qe=ze||ge(Re);return Ee==="="&&qe&&(Ee=""),Me?Fe=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&qe?(ze&&(ke=0),qe&&(Re=0),Ee===">"?(Ee=">=",ze?(Se=+Se+1,ke=0,Re=0):qe&&(ke=+ke+1,Re=0)):Ee==="<="&&(Ee="<",ze?Se=+Se+1:ke=+ke+1),Fe=Ee+Se+"."+ke+"."+Re):ze?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":qe&&(Fe=">="+Se+"."+ke+".0 <"+Se+"."+(+ke+1)+".0"),v("xRange return",Fe),Fe})}(Ue,De)}).join(" ")}(Pe,Le),v("xrange",Pe),Pe=function(Oe,De){return v("replaceStars",Oe,De),Oe.trim().replace(I[Z],"")}(Pe,Le),v("stars",Pe),Pe}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ae){return!!Ae.match(pe)})),be=be.map(function(Ae){return new he(Ae,ee)})},me.prototype.intersects=function(W,ee){if(!(W instanceof me))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(pe){return W.set.some(function(be){return be.every(function(Ae){return pe.intersects(Ae,ee)})})})})},t.toComparators=function(W,ee){return new me(W,ee).set.map(function(te){return te.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new z(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if($e(this.set[ee],W))return!0;return!1},t.satisfies=ye,t.maxSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Pe){Ae.test(Pe)&&(pe&&be.compare(Pe)!==-1||(be=new z(pe=Pe,te)))}),pe},t.minSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Pe){Ae.test(Pe)&&(pe&&be.compare(Pe)!==1||(be=new z(pe=Pe,te)))}),pe},t.validRange=function(W,ee){try{return new me(W,ee).range||"*"}catch{return null}},t.ltr=function(W,ee,te){return Ie(W,ee,"<",te)},t.gtr=function(W,ee,te){return Ie(W,ee,">",te)},t.outside=Ie,t.prerelease=function(W,ee){var te=F(W,ee);return te&&te.prerelease.length?te.prerelease:null},t.intersects=function(W,ee,te){return W=new me(W,te),ee=new me(ee,te),W.intersects(ee)},t.coerce=function(W){if(W instanceof z)return W;if(typeof W!="string")return null;var ee=W.match(I[D]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,P(1))},function(Q,t){var P,O,v=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(d){if(P===setTimeout)return setTimeout(d,0);if((P===k||!P)&&setTimeout)return P=setTimeout,setTimeout(d,0);try{return P(d,0)}catch{try{return P.call(null,d,0)}catch{return P.call(this,d,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:k}catch{P=k}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var p,l=[],a=!1,c=-1;function f(){a&&p&&(a=!1,p.length?l=p.concat(l):c=-1,l.length&&$())}function $(){if(!a){var d=I(f);a=!0;for(var g=l.length;g;){for(p=l,l=[];++c<g;)p&&p[c].run();c=-1,g=l.length}p=null,a=!1,function(m){if(O===clearTimeout)return clearTimeout(m);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(m);try{O(m)}catch{try{return O.call(null,m)}catch{return O.call(this,m)}}}(d)}}function w(d,g){this.fun=d,this.array=g}function R(){}v.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)g[m-1]=arguments[m];l.push(new w(d,g)),l.length!==1||a||I($)},w.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=R,v.addListener=R,v.once=R,v.off=R,v.removeListener=R,v.removeAllListeners=R,v.emit=R,v.prependListener=R,v.prependOnceListener=R,v.listeners=function(d){return[]},v.binding=function(d){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(d){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(se[80],oe([0,1]),function(Q,t){"use strict";var P;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0;class O{constructor(I,p,l){this.level=I,this.key=p,this.value=l,this.forward=[]}}const v=void 0;class k{constructor(I,p=2**16){this.comparator=I,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new O(this.c,v,v)}get size(){return this.f}clear(){this.e=new O(this.c,v,v),this.f=0}has(I){return!!k.g(this,I,this.comparator)}get(I){return k.g(this,I,this.comparator)?.value}set(I,p){return k.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=k.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let l=this.e.forward[0];for(;l;)I.call(p,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,l){let a=I.e;for(let c=I.d-1;c>=0;c--)for(;a.forward[c]&&l(a.forward[c].key,p)<0;)a=a.forward[c];if(a=a.forward[0],a&&l(a.key,p)===0)return a}static h(I,p,l,a){const c=[];let f=I.e;for(let $=I.d-1;$>=0;$--){for(;f.forward[$]&&a(f.forward[$].key,p)<0;)f=f.forward[$];c[$]=f}if(f=f.forward[0],f&&a(f.key,p)===0)return f.value=l,!1;{const $=k.j(I);if($>I.d){for(let w=I.d;w<$;w++)c[w]=I.e;I.d=$}f=new O($,p,l);for(let w=0;w<$;w++)f.forward[w]=c[w].forward[w],c[w].forward[w]=f;return!0}}static j(I,p=.5){let l=1;for(;Math.random()<p&&l<I.c;)l+=1;return l}static k(I,p,l){const a=[];let c=I.e;for(let f=I.d-1;f>=0;f--){for(;c.forward[f]&&l(c.forward[f].key,p)<0;)c=c.forward[f];a[f]=c}if(c=c.forward[0],!c||l(c.key,p)!==0)return!1;for(let f=0;f<I.d&&a[f].forward[f]===c;f++)a[f].forward[f]=c.forward[f];for(;I.d>0&&I.e.forward[I.d-1]===v;)I.d-=1;return!0}}t.$Hs=k}),define(se[46],oe([0,1,9,2]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=v,t.$ve=k,t.$we=L,t.$xe=I,t.$ye=l,t.$ze=a,t.$Ae=c,t.$Be=f,t.$Ce=$,t.$De=w,t.$Ee=R,t.$Fe=d,t.$Ge=g,t.$He=m,t.$Ie=S;function v(y){const u=y;return u?typeof u.read=="function":!1}function k(y){const u=y;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function L(y){const u=y;return u?k(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function I(y,u){return new p(y,u)}class p{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,P.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let o;switch(u){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(y,u){const i=[];let o;for(;(o=y.read())!==null;)i.push(o);return u(i)}function a(y,u,i){const o=[];let s;for(;(s=y.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const e=s;return s=void 0,e}return y.read()}}}function c(y,u){return new Promise((i,o)=>{const s=[];f(y,{onData:e=>{u&&s.push(e)},onError:e=>{u?o(e):i(void 0)},onEnd:()=>{i(u?u(s):void 0)}})})}function f(y,u,i){y.on("error",o=>{i?.isCancellationRequested||u.onError(o)}),y.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),y.on("data",o=>{i?.isCancellationRequested||u.onData(o)})}function $(y,u){return new Promise((i,o)=>{const s=new O.$Tc,e=[],n=E=>{if(e.push(E),e.length>u)return s.dispose(),y.pause(),i({stream:y,buffer:e,ended:!1})},r=E=>(s.dispose(),o(E)),h=()=>(s.dispose(),i({stream:y,buffer:e,ended:!0}));s.add((0,O.$Sc)(()=>y.removeListener("error",r))),y.on("error",r),s.add((0,O.$Sc)(()=>y.removeListener("end",h))),y.on("end",h),s.add((0,O.$Sc)(()=>y.removeListener("data",n))),y.on("data",n)})}function w(y,u){const i=I(u);return i.end(y),i}function R(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}function d(y){let u=!1;return{read:()=>u?null:(u=!0,y)}}function g(y,u,i){const o=I(i);return f(y,{onData:s=>o.write(u.data(s)),onError:s=>o.error(u.error?u.error(s):s),onEnd:()=>o.end()}),o}function m(y,u,i){let o=!1;return{read:()=>{const s=u.read();return o?s:(o=!0,s!==null?i([y,s]):y)}}}function S(y,u,i){let o=!1;const s=I(i);return f(u,{onData:e=>o?s.write(e):(o=!0,s.write(i([y,e]))),onError:e=>s.error(e),onEnd:()=>{o||(o=!0,s.write(y)),s.end()}}),s}}),define(se[14],oe([0,1,170,46]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=void 0,t.$Ke=l,t.$Le=a,t.$Me=c,t.$Ne=f,t.$Oe=$,t.$Pe=w,t.$Qe=R,t.$Re=d,t.$Se=g,t.$Te=m,t.$Ue=S,t.$Ve=y,t.$We=u,t.$Xe=i,t.$Ye=o,t.$Ze=s,t.$1e=e,t.$2e=n,t.$3e=r,t.$4e=N;const v=typeof Buffer<"u",k=new P.$V(()=>new Uint8Array(256));let L,I;class p{static alloc(D){return v?new p(Buffer.allocUnsafe(D)):new p(new Uint8Array(D))}static wrap(D){return v&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new p(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&v?new p(Buffer.from(D)):(L||(L=new TextEncoder),new p(L.encode(D)))}static fromByteArray(D){const C=p.alloc(D.length);for(let M=0,J=D.length;M<J;M++)C.buffer[M]=D[M];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let ae=0,ie=D.length;ae<ie;ae++)C+=D[ae].byteLength}const M=p.alloc(C);let J=0;for(let ae=0,ie=D.length;ae<ie;ae++){const ce=D[ae];M.set(ce,J),J+=ce.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=p.alloc(this.byteLength);return D.set(this),D}toString(){return v?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,C){return new p(this.buffer.subarray(D,C))}set(D,C){if(D instanceof p)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return f(this.buffer,D)}writeUInt32BE(D,C){$(this.buffer,D,C)}readUInt32LE(D){return w(this.buffer,D)}writeUInt32LE(D,C){R(this.buffer,D,C)}readUInt8(D){return d(this.buffer,D)}writeUInt8(D,C){g(this.buffer,D,C)}indexOf(D,C=0){return l(this.buffer,D instanceof p?D.buffer:D,C)}}t.$Je=p;function l(A,D,C=0){const M=D.byteLength,J=A.byteLength;if(M===0)return 0;if(M===1)return A.indexOf(D[0]);if(M>J-C)return-1;const ae=k.value;ae.fill(D.length);for(let le=0;le<D.length;le++)ae[D[le]]=D.length-le-1;let ie=C+D.length-1,ce=ie,ue=-1;for(;ie<J;)if(A[ie]===D[ce]){if(ce===0){ue=ie;break}ie--,ce--}else ie+=Math.max(D.length-ce,ae[A[ie]]),ce=D.length-1;return ue}function a(A,D){return A[D+0]<<0>>>0|A[D+1]<<8>>>0}function c(A,D,C){A[C+0]=D&255,D=D>>>8,A[C+1]=D&255}function f(A,D){return A[D]*2**24+A[D+1]*2**16+A[D+2]*2**8+A[D+3]}function $(A,D,C){A[C+3]=D,D=D>>>8,A[C+2]=D,D=D>>>8,A[C+1]=D,D=D>>>8,A[C]=D}function w(A,D){return A[D+0]<<0>>>0|A[D+1]<<8>>>0|A[D+2]<<16>>>0|A[D+3]<<24>>>0}function R(A,D,C){A[C+0]=D&255,D=D>>>8,A[C+1]=D&255,D=D>>>8,A[C+2]=D&255,D=D>>>8,A[C+3]=D&255}function d(A,D){return A[D]}function g(A,D,C){A[C]=D}function m(A){return O.$ye(A,D=>p.concat(D))}function S(A){return O.$Fe(A)}function y(A){return O.$Ae(A,D=>p.concat(D))}async function u(A){return A.ended?p.concat(A.buffer):p.concat([...A.buffer,await y(A.stream)])}function i(A){return O.$De(A,D=>p.concat(D))}function o(A){return O.$Ge(A,{data:D=>typeof D=="string"?p.fromString(D):p.wrap(D)},D=>p.concat(D))}function s(A){return O.$xe(D=>p.concat(D),A)}function e(A,D){return O.$He(A,D,C=>p.concat(C))}function n(A,D){return O.$Ie(A,D,C=>p.concat(C))}function r(A){let D=0,C=0,M=0;const J=new Uint8Array(Math.floor(A.length/4*3)),ae=ce=>{switch(C){case 3:J[M++]=D|ce,C=0;break;case 2:J[M++]=D|ce>>>2,D=ce<<6,C=3;break;case 1:J[M++]=D|ce>>>4,D=ce<<4,C=2;break;default:D=ce<<2,C=1}};for(let ce=0;ce<A.length;ce++){const ue=A.charCodeAt(ce);if(ue>=65&&ue<=90)ae(ue-65);else if(ue>=97&&ue<=122)ae(ue-97+26);else if(ue>=48&&ue<=57)ae(ue-48+52);else if(ue===43||ue===45)ae(62);else if(ue===47||ue===95)ae(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${A[ce]}`)}}const ie=M;for(;C>0;)ae(0);return p.wrap(J).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:A},D=!0,C=!1){const M=C?E:h;let J="";const ae=A.byteLength%3;let ie=0;for(;ie<A.byteLength-ae;ie+=3){const ce=A[ie+0],ue=A[ie+1],le=A[ie+2];J+=M[ce>>>2],J+=M[(ce<<4|ue>>>4)&63],J+=M[(ue<<2|le>>>6)&63],J+=M[le&63]}if(ae===1){const ce=A[ie+0];J+=M[ce>>>2],J+=M[ce<<4&63],D&&(J+="==")}else if(ae===2){const ce=A[ie+0],ue=A[ie+1];J+=M[ce>>>2],J+=M[(ce<<4|ue>>>4)&63],J+=M[ue<<2&63],D&&(J+="=")}return J}}),define(se[28],oe([0,1,3]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=O,t.$0n=v,t.$$n=L,t.$_n=p,t.$ao=l,t.$bo=a,t.$co=c,t.$do=f,t.$eo=$,t.$fo=w,t.$go=R,t.$ho=d,t.$io=g;function O(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const S=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([y,u])=>{S[y]=u&&typeof u=="object"?O(u):u}),S}function v(m){if(!m||typeof m!="object")return m;const S=[m];for(;S.length>0;){const y=S.shift();Object.freeze(y);for(const u in y)if(k.call(y,u)){const i=y[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,P.$dg)(i)&&S.push(i)}}return m}const k=Object.prototype.hasOwnProperty;function L(m,S){return I(m,S,new Set)}function I(m,S,y){if((0,P.$jg)(m))return m;const u=S(m);if(typeof u<"u")return u;if(Array.isArray(m)){const i=[];for(const o of m)i.push(I(o,S,y));return i}if((0,P.$cg)(m)){if(y.has(m))throw new Error("Cannot clone recursive data-structure");y.add(m);const i={};for(const o in m)k.call(m,o)&&(i[o]=I(m[o],S,y));return y.delete(m),i}return m}function p(m,S,y=!0){return(0,P.$cg)(m)?((0,P.$cg)(S)&&Object.keys(S).forEach(u=>{u in m?y&&((0,P.$cg)(m[u])&&(0,P.$cg)(S[u])?p(m[u],S[u],y):m[u]=S[u]):m[u]=S[u]}),m):S}function l(m,S){if(m===S)return!0;if(m==null||S===null||S===void 0||typeof m!=typeof S||typeof m!="object"||Array.isArray(m)!==Array.isArray(S))return!1;let y,u;if(Array.isArray(m)){if(m.length!==S.length)return!1;for(y=0;y<m.length;y++)if(!l(m[y],S[y]))return!1}else{const i=[];for(u in m)i.push(u);i.sort();const o=[];for(u in S)o.push(u);if(o.sort(),!l(i,o))return!1;for(y=0;y<i.length;y++)if(!l(m[i[y]],S[i[y]]))return!1}return!0}function a(m){const S=new Set;return JSON.stringify(m,(y,u)=>{if((0,P.$cg)(u)||Array.isArray(u)){if(S.has(u))return"[Circular]";S.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function c(m,S){const y=Object.create(null);return!m||!S||Object.keys(S).forEach(i=>{const o=m[i],s=S[i];l(o,s)||(y[i]=s)}),y}function f(m,S){const y=S.toLowerCase(),u=Object.keys(m).find(i=>i.toLowerCase()===y);return u?m[u]:m[S]}function $(m,S){const y=Object.create(null);for(const[u,i]of Object.entries(m))S(u,i)&&(y[u]=i);return y}function w(m){let S=[];for(;Object.prototype!==m;)S=S.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return S}function R(m){const S=[];for(const y of w(m))typeof m[y]=="function"&&S.push(y);return S}function d(m,S){const y=i=>function(){const o=Array.prototype.slice.call(arguments,0);return S(i,o)},u={};for(const i of m)u[i]=y(i);return u}function g(m,S){const y={};for(const[u,i]of Object.entries(m))y[u]=S(i,u);return y}}),define(se[43],oe([0,1,32]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uj=t.$sj=void 0,t.$oj=O,t.$pj=v,t.$qj=k,t.$rj=I,t.$tj=R;function O(g){return v(g,0)}function v(g,m){switch(typeof g){case"object":return g===null?k(349,m):Array.isArray(g)?p(g,m):l(g,m);case"string":return I(g,m);case"boolean":return L(g,m);case"number":return k(g,m);case"undefined":return k(937,m);default:return k(617,m)}}function k(g,m){return(m<<5)-m+g|0}function L(g,m){return k(g?433:863,m)}function I(g,m){m=k(149417,m);for(let S=0,y=g.length;S<y;S++)m=k(g.charCodeAt(S),m);return m}function p(g,m){return m=k(104579,m),g.reduce((S,y)=>v(y,S),m)}function l(g,m){return m=k(181387,m),Object.keys(g).sort().reduce((S,y)=>(S=I(y,S),v(g[y],S)),m)}class a{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=v(m,this.g),this.g}}t.$sj=a;var c;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function f(g,m,S=32){const y=S-m,u=~((1<<y)-1);return(g<<m|(u&g)>>>y)>>>0}function $(g,m=0,S=g.byteLength,y=0){for(let u=0;u<S;u++)g[m+u]=y}function w(g,m,S="0"){for(;g.length<m;)g=S+g;return g}function R(g,m=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(S=>S.toString(16).padStart(2,"0")).join(""):w((g>>>0).toString(16),m/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const S=m.length;if(S===0)return;const y=this.p;let u=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=m.charCodeAt(0),s=0);;){let e=o;if(P.$Ff(o))if(s+1<S){const n=m.charCodeAt(s+1);P.$Gf(n)?(s++,e=P.$Hf(o,n)):e=c.UNICODE_REPLACEMENT}else{i=o;break}else P.$Gf(o)&&(e=c.UNICODE_REPLACEMENT);if(u=this.w(y,u,e),s++,s<S)o=m.charCodeAt(s);else break}this.r=u,this.u=i}w(m,S,y){return y<128?m[S++]=y:y<2048?(m[S++]=192|(y&1984)>>>6,m[S++]=128|(y&63)>>>0):y<65536?(m[S++]=224|(y&61440)>>>12,m[S++]=128|(y&4032)>>>6,m[S++]=128|(y&63)>>>0):(m[S++]=240|(y&1835008)>>>18,m[S++]=128|(y&258048)>>>12,m[S++]=128|(y&4032)>>>6,m[S++]=128|(y&63)>>>0),S>=c.BLOCK_SIZE&&(this.y(),S-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,m[0]=m[c.BLOCK_SIZE+0],m[1]=m[c.BLOCK_SIZE+1],m[2]=m[c.BLOCK_SIZE+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=d.g,S=this.q;for(let h=0;h<64;h+=4)m.setUint32(h,S.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)m.setUint32(h,f(m.getUint32(h-12,!1)^m.getUint32(h-32,!1)^m.getUint32(h-56,!1)^m.getUint32(h-64,!1),1),!1);let y=this.h,u=this.l,i=this.m,o=this.n,s=this.o,e,n,r;for(let h=0;h<80;h++)h<20?(e=u&i|~u&o,n=1518500249):h<40?(e=u^i^o,n=1859775393):h<60?(e=u&i|u&o|i&o,n=2400959708):(e=u^i^o,n=3395469782),r=f(y,5)+e+s+n+m.getUint32(h*4,!1)&4294967295,s=o,o=i,i=f(u,30),u=y,y=r;this.h=this.h+y&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}t.$uj=d}),define(se[56],oe([0,1,32]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var O;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(O||(O={})),function(v){const k="error",L="warning",I="warn",p="info",l="ignore";function a(f){return f?P.$Bf(k,f)?v.Error:P.$Bf(L,f)||P.$Bf(I,f)?v.Warning:P.$Bf(p,f)?v.Info:v.Ignore:v.Ignore}v.fromValue=a;function c(f){switch(f){case v.Error:return k;case v.Warning:return L;case v.Info:return p;default:return l}}v.toString=c}(O||(O={})),t.default=O}),define(se[29],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wg=void 0,t.$Vg=O;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(v){return P.test(v)}t.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const k=new Uint8Array(16),L=[];for(let I=0;I<256;I++)L.push(I.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let p=0,l="";return l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l+="-",l+=L[k[p++]],l+=L[k[p++]],l+="-",l+=L[k[p++]],l+=L[k[p++]],l+="-",l+=L[k[p++]],l+=L[k[p++]],l+="-",l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l+=L[k[p++]],l}}()}),define(se[81],oe([0,1,35]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$In=k;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(L){const I=L.replace(/\-/g,":").toLowerCase();return!O.has(I)}function k(){const L=(0,P.networkInterfaces)();for(const I in L){const p=L[I];if(p){for(const{mac:l}of p)if(v(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[82],oe([7,4]),function(Q,t){return Q.create("vs/base/common/date",t)}),define(se[83],oe([0,1,82]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=l,t.$8m=a,t.$9m=c;const O=60,v=O*60,k=v*24,L=k*7,I=k*30,p=k*365;function l(f,$,w,R){typeof f!="number"&&(f=f.getTime());const d=Math.round((new Date().getTime()-f)/1e3);if(d<-30)return(0,P.localize)(0,null,l(new Date().getTime()+d*1e3,!1));if(!R&&d<30)return(0,P.localize)(1,null);let g;return d<O?(g=d,$?g===1?w?(0,P.localize)(2,null,g):(0,P.localize)(3,null,g):w?(0,P.localize)(4,null,g):(0,P.localize)(5,null,g):g===1?w?(0,P.localize)(6,null,g):(0,P.localize)(7,null,g):w?(0,P.localize)(8,null,g):(0,P.localize)(9,null,g)):d<v?(g=Math.floor(d/O),$?g===1?w?(0,P.localize)(10,null,g):(0,P.localize)(11,null,g):w?(0,P.localize)(12,null,g):(0,P.localize)(13,null,g):g===1?w?(0,P.localize)(14,null,g):(0,P.localize)(15,null,g):w?(0,P.localize)(16,null,g):(0,P.localize)(17,null,g)):d<k?(g=Math.floor(d/v),$?g===1?w?(0,P.localize)(18,null,g):(0,P.localize)(19,null,g):w?(0,P.localize)(20,null,g):(0,P.localize)(21,null,g):g===1?w?(0,P.localize)(22,null,g):(0,P.localize)(23,null,g):w?(0,P.localize)(24,null,g):(0,P.localize)(25,null,g)):d<L?(g=Math.floor(d/k),$?g===1?(0,P.localize)(26,null,g):(0,P.localize)(27,null,g):g===1?(0,P.localize)(28,null,g):(0,P.localize)(29,null,g)):d<I?(g=Math.floor(d/L),$?g===1?w?(0,P.localize)(30,null,g):(0,P.localize)(31,null,g):w?(0,P.localize)(32,null,g):(0,P.localize)(33,null,g):g===1?w?(0,P.localize)(34,null,g):(0,P.localize)(35,null,g):w?(0,P.localize)(36,null,g):(0,P.localize)(37,null,g)):d<p?(g=Math.floor(d/I),$?g===1?w?(0,P.localize)(38,null,g):(0,P.localize)(39,null,g):w?(0,P.localize)(40,null,g):(0,P.localize)(41,null,g):g===1?w?(0,P.localize)(42,null,g):(0,P.localize)(43,null,g):w?(0,P.localize)(44,null,g):(0,P.localize)(45,null,g)):(g=Math.floor(d/p),$?g===1?w?(0,P.localize)(46,null,g):(0,P.localize)(47,null,g):w?(0,P.localize)(48,null,g):(0,P.localize)(49,null,g):g===1?w?(0,P.localize)(50,null,g):(0,P.localize)(51,null,g):w?(0,P.localize)(52,null,g):(0,P.localize)(53,null,g))}function a(f,$){const w=Math.abs(f/1e3);return w<1?$?(0,P.localize)(54,null,f):(0,P.localize)(55,null,f):w<O?$?(0,P.localize)(56,null,Math.round(f)/1e3):(0,P.localize)(57,null,Math.round(f)/1e3):w<v?$?(0,P.localize)(58,null,Math.round(f/(1e3*O))):(0,P.localize)(59,null,Math.round(f/(1e3*O))):w<k?$?(0,P.localize)(60,null,Math.round(f/(1e3*v))):(0,P.localize)(61,null,Math.round(f/(1e3*v))):(0,P.localize)(62,null,Math.round(f/(1e3*k)))}function c(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[84],oe([7,4]),function(Q,t){return Q.create("vs/base/common/errorMessage",t)}),define(se[36],oe([0,1,20,3,84]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lj=p,t.$mj=l,t.$nj=a;function k(c,f){return f&&(c.stack||c.stacktrace)?v.localize(0,null,I(c),L(c.stack)||L(c.stacktrace)):I(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function I(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?v.localize(1,null,c.message):c.message||v.localize(2,null)}function p(c=null,f=!1){if(!c)return v.localize(3,null);if(Array.isArray(c)){const $=P.$Hb(c),w=p($[0],f);return $.length>1?v.localize(4,null,w,$.length):w}if(O.$ag(c))return c;if(c.detail){const $=c.detail;if($.error)return k($.error,f);if($.exception)return k($.exception,f)}return c.stack?k(c,f):c.message?c.message:v.localize(5,null)}function l(c){const f=c;return f instanceof Error&&Array.isArray(f.actions)}function a(c,f){let $;return typeof c=="string"?$=new Error(c):$=c,$.actions=f,$}}),define(se[85],oe([7,4]),function(Q,t){return Q.create("vs/base/common/jsonErrorMessages",t)}),define(se[86],oe([0,1,85,34]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zq=v;function v(k){switch(k){case O.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case O.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case O.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case O.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case O.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case O.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case O.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case O.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case O.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(se[57],oe([0,1,13]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$rm=k,t.$sm=L;var O;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(O||(t.Source=O={}));var v;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(v||(t.TerminateResponseCode=v={}));function k(I,...p){const l=p.reduce((f,$)=>(f[$]=!0,f),{}),a=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(f=>!l[f]).forEach(f=>{for(let $=0;$<a.length;$++)if(f.search(a[$])!==-1){delete I[f];break}})}function L(I){I&&(delete I.DEBUG,P.$j&&delete I.DYLD_LIBRARY_PATH,P.$k&&delete I.LD_PRELOAD)}}),define(se[87],oe([0,1,12]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4q=O,t.$5q=v,t.$6q=k,t.log=I;function O(l){const a=l;return a&&typeof a.type=="string"&&typeof a.severity=="string"}function v(l){const a=[];let c;try{const f=JSON.parse(l.arguments),$=f[f.length-1];$&&$.__$stack&&(f.pop(),c=$.__$stack),a.push(...f)}catch{a.push("Unable to log remote console arguments",l.arguments)}return{args:a,stack:c}}function k(l){if(typeof l!="string")return k(v(l).stack);const a=l;if(a){const c=L(a),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(f&&f.length===4)return{uri:P.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function L(l){if(!l)return l;const a=l.indexOf(`
`);return a===-1?l:l.substring(0,a)}function I(l,a){const{args:c,stack:f}=v(l),$=typeof c[0]=="string"&&c.length===1;let w=L(f);w&&(w=`(${w.trim()})`);let R=[];if(typeof c[0]=="string"?w&&$?R=[`%c[${a}] %c${c[0]} %c${w}`,p("blue"),p(""),p("grey")]:R=[`%c[${a}] %c${c[0]}`,p("blue"),p(""),...c.slice(1)]:R=[`%c[${a}]%`,p("blue"),...c],w&&!$&&R.push(w),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,R)}function p(l){return`color: ${l}`}}),define(se[47],oe([0,1,14,12,171]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8h=k,t.$9h=L,t.$0h=p;function k(l){return JSON.stringify(l,I)}function L(l){let a=JSON.parse(l);return a=p(a),a}function I(l,a){return a instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:a.source,flags:a.flags}:a}function p(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case v.MarshalledId.Uri:return O.URI.revive(l);case v.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case v.MarshalledId.Date:return new Date(l.source)}if(l instanceof P.$Je||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let c=0;c<l.length;++c)l[c]=p(l[c],a+1);else for(const c in l)Object.hasOwnProperty.call(l,c)&&(l[c]=p(l[c],a+1))}return l}}),define(se[88],oe([0,1,75,15,13,12]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gE=a;class L{constructor(f,$,w){this.id=f,this.dependencies=$,this.callback=w}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,$,w)=>{typeof f!="string"&&(w=$,$=f,f=null),(typeof $!="object"||!Array.isArray($))&&(w=$,$=null),this.c.push(new L(f,$,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const $=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!$)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(f){return new Promise(($,w)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const d=()=>{R.removeEventListener("load",g),R.removeEventListener("error",m)},g=S=>{d(),$(this.c.pop())},m=S=>{d(),w(S)};R.addEventListener("load",g),R.addEventListener("error",m),this.f&&(f=this.f.createScriptURL(f)),R.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(f){return new Promise(($,w)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),$(this.c.pop())}catch(R){w(R)}})}async j(f){try{const $=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,d=k.URI.parse(f).fsPath,g=$.readFileSync(d).toString(),m=R.wrap(g.replace(/^#!.*/,""));return new w.Script(m).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const p=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function a(c,f,$){if(P.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[c]&&(c=l[c]);const w=`${c}/${f}`;if(p.has(w))return p.get(w);let R;if(/^\w[\w\d+.-]*:\/\//.test(w))R=w;else{const S=`${$&&!v.$o?O.$Rg:O.$Qg}/${w}`;R=O.$Ug.asBrowserUri(S).toString(!0)}const d=I.INSTANCE.load(R);return p.set(w,d),d}else return await new Promise((w,R)=>{Q([c],w,R)})}}),define(se[89],oe([0,1,35,48,29,81,13]),function(Q,t,P,O,v,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jn=void 0,t.$Kn=p,t.$Ln=c,t.$Mn=f,t.$Jn=new class{c($){return this.a||(this.a=O.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,w=0;const R=(0,P.networkInterfaces)();for(const d in R){const g=R[d];if(g)for(const{mac:m,internal:S}of g)S||(w+=1,this.c(m.toUpperCase())&&($+=1))}this.b=w>0?$/w:0}return this.b}};let I;async function p($){return I||(I=(async()=>await l($)||v.$Wg())()),I}async function l($){try{const w=await new Promise((d,g)=>{Q(["crypto"],d,g)}),R=(0,k.$In)();return w.createHash("sha256").update(R,"utf8").digest("hex")}catch(w){$(w);return}}const a="Software\\Microsoft\\SQMClient";async function c($){if(L.$i){const w=await new Promise((R,d)=>{Q(["@vscode/windows-registry"],R,d)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",a,"MachineId")||""}catch(R){return $(R),""}}return""}async function f($){try{return await(await new Promise((d,g)=>{Q(["@vscode/deviceid"],d,g)})).getDeviceId()}catch(w){return $(w),""}}}),define(se[90],oe([0,1,35,16,25]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pm=m,t.$qm=S;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(p||(p={}));let l;switch(process.arch){case"ia32":l=p.x86;break;case"arm":case"arm64":l=p.ARM;break;default:l=p.x64;break}let a;process.env.PROCESSOR_ARCHITEW6432?a=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?a=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?a=p.x86:a=p.x64;class c{constructor(u,i,o){this.exePath=u,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function f({useAlternateBitness:y=!1}={}){return y?l===p.x64?process.env["ProgramFiles(x86)"]||null:a===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:y=!1,findPreview:u=!1}={}){const i=f({useAlternateBitness:y});if(!i)return null;const o=O.$jc(i,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(o))return null;let s=-1,e=null;for(const h of await v.Promises.readdir(o)){let E=-1;if(u){const A=h.indexOf("-");if(A<0)continue;const D=h.substring(0,A);if(!k.test(D)||h.substring(A+1)!=="preview")continue;E=parseInt(D,10)}else{if(!k.test(h))continue;E=parseInt(h,10)}if(E<=s)continue;const N=O.$jc(o,h,"pwsh.exe");await v.SymlinkSupport.existsFile(N)&&(e=N,s=E)}if(!e)return null;const n=i.includes("x86")?" (x86)":"",r=u?" Preview":"";return new c(e,`PowerShell${r}${n}`,!0)}async function w({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const u=O.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=y?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(u))if(i.test(s)){const e=O.$jc(u,s,"pwsh.exe");return new c(e,o)}return null}function R(){const y=O.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new c(y,".NET Core PowerShell Global Tool")}function d(){const y=O.$jc(process.env.windir,l===p.x86&&a!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(y,"Windows PowerShell",!0)}async function*g(){let y=await $();y&&(yield y),y=await $({useAlternateBitness:!0}),y&&(yield y),y=await w(),y&&(yield y),y=R(),y&&(yield y),y=await $({findPreview:!0}),y&&(yield y),y=await w({findPreview:!0}),y&&(yield y),y=await $({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=d(),y&&(yield y)}async function*m(){for await(const y of g())await y.exists()&&(yield y)}async function S(){for await(const y of m())return y;return null}}),define(se[58],oe([0,1,16,13,37,57,3,25]),function(Q,t,P,O,v,k,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$tm=p,t.$um=l,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function p(c=v.env){return c.comspec||"cmd.exe"}function l(c){let f=[],$=!1;const w=function(R){if($){f.push(R);return}(!c.send(R,g=>{if(g&&console.error(g),$=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(S=>w(S))}})||O.$i)&&($=!0)};return{send:w}}var a;(function(c){async function f($,w,R){if(P.$ic($))return $;if(w===void 0&&(w=v.cwd()),P.$mc($)!=="."||(R===void 0&&L.$ag(v.env.PATH)&&(R=v.env.PATH.split(P.$tc)),R===void 0||R.length===0))return P.$jc(w,$);async function g(m){if(await I.Promises.exists(m)){let S;try{S=await I.Promises.stat(m)}catch(y){y.message.startsWith("EACCES")&&(S=await I.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(const m of R){let S;if(P.$ic(m)?S=P.$jc(m,$):S=P.$jc(w,m,$),await g(S))return S;let y=S+".com";if(await g(y)||(y=S+".exe",await g(y)))return y}return P.$jc(w,$)}c.findExecutable=f})(a||(t.win32=a={}))}),define(se[91],oe([0,1,35,13,90,58]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vm=L;async function L(c,f){return c===O.OperatingSystem.Windows?O.$i?a():k.$tm(f):p(c,f)}let I=null;function p(c,f){if(O.$k&&c===O.OperatingSystem.Macintosh||O.$j&&c===O.OperatingSystem.Linux)return"/bin/bash";if(!I){let $;if(O.$i)$="/bin/bash";else{if($=f.SHELL,!$)try{$=(0,P.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}I=$}return I}let l=null;async function a(){return l||(l=(await(0,v.$qm)()).exePath),l}});var we=this&&this.__decorate||function(Q,t,P,O){var v=arguments.length,k=v<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,P):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,t,P,O);else for(var I=Q.length-1;I>=0;I--)(L=Q[I])&&(k=(v<3?L(k):v>3?L(t,P,k):L(t,P))||k);return v>3&&k&&Object.defineProperty(t,P,k),k};define(se[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.ProxyChannel=t.$ii=t.$fi=t.$ei=t.$di=t.RequestInitiator=t.$ci=t.$_h=t.$$h=void 0,t.$ai=r,t.$bi=h,t.$gi=M,t.$hi=J;var $;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})($||($={}));function w(B){switch(B){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function d(B){switch(B){case R.Initialize:return"init";case R.PromiseSuccess:return"reply:";case R.PromiseError:case R.PromiseErrorObj:return"replyErr:";case R.EventFire:return"event:"}}var g;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(g||(g={}));function m(B){let U=0;for(let G=0;;G+=7){const Z=B.read(1);if(U|=(Z.buffer[0]&127)<<G,!(Z.buffer[0]&128))return U}}const S=s(0);function y(B,U){if(U===0){B.write(S);return}let G=0;for(let Y=U;Y!==0;Y=Y>>>7)G++;const Z=v.$Je.alloc(G);for(let Y=0;U!==0;Y++)Z.buffer[Y]=U&127,U=U>>>7,U>0&&(Z.buffer[Y]|=128);B.write(Z)}class u{constructor(U){this.b=U,this.a=0}read(U){const G=this.b.slice(this.a,this.a+U);return this.a+=G.byteLength,G}}t.$$h=u;class i{constructor(){this.a=[]}get buffer(){return v.$Je.concat(this.a)}write(U){this.a.push(U)}}t.$_h=i;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function s(B){const U=v.$Je.alloc(1);return U.writeUInt8(B,0),U}const e={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function r(B,U){if(typeof U>"u")B.write(e.Undefined);else if(typeof U=="string"){const G=v.$Je.fromString(U);B.write(e.String),y(B,G.byteLength),B.write(G)}else if(n&&Buffer.isBuffer(U)){const G=v.$Je.wrap(U);B.write(e.Buffer),y(B,G.byteLength),B.write(G)}else if(U instanceof v.$Je)B.write(e.VSBuffer),y(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(e.Array),y(B,U.length);for(const G of U)r(B,G)}else if(typeof U=="number"&&(U|0)===U)B.write(e.Uint),y(B,U);else{const G=v.$Je.fromString(JSON.stringify(U));B.write(e.Object),y(B,G.byteLength),B.write(G)}}function h(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(m(B)).toString();case o.Buffer:return B.read(m(B)).buffer;case o.VSBuffer:return B.read(m(B));case o.Array:{const G=m(B),Z=[];for(let Y=0;Y<G;Y++)Z.push(h(B));return Z}case o.Object:return JSON.parse(B.read(m(B)).toString());case o.Int:return m(B)}}class E{constructor(U,G,Z=null,Y=1e3){this.h=U,this.j=G,this.k=Z,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:R.Initialize})}registerChannel(U,G){this.b.set(U,G),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case R.Initialize:{const G=this.o([U.type]);this.k?.logOutgoing(G,0,N.OtherSide,d(U.type));return}case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:{const G=this.o([U.type,U.id],U.data);this.k?.logOutgoing(G,U.id,N.OtherSide,d(U.type),U.data);return}}}o(U,G=void 0){const Z=new i;return r(Z,U),r(Z,G),this.p(Z.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const G=new u(U),Z=h(G),Y=h(G),F=Z[0];switch(F){case $.Promise:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${w(F)}: ${Z[2]}.${Z[3]}`,Y),this.s({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case $.EventListen:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${w(F)}: ${Z[2]}.${Z[3]}`,Y),this.t({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case $.PromiseCancel:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${w(F)}`),this.u({type:F,id:Z[1]});case $.EventDispose:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${w(F)}`),this.u({type:F,id:Z[1]})}}s(U){const G=this.b.get(U.channelName);if(!G){this.v(U);return}const Z=new k.$se;let Y;try{Y=G.call(this.j,U.name,U.arg,Z.token)}catch(x){Y=Promise.reject(x)}const F=U.id;Y.then(x=>{this.m({id:F,data:x,type:R.PromiseSuccess})},x=>{x instanceof Error?this.m({id:F,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:R.PromiseError}):this.m({id:F,data:x,type:R.PromiseErrorObj})}).finally(()=>{z.dispose(),this.d.delete(U.id)});const z=(0,l.$Sc)(()=>Z.cancel());this.d.set(U.id,z)}t(U){const G=this.b.get(U.channelName);if(!G){this.v(U);return}const Z=U.id,F=G.listen(this.j,U.name,U.arg)(z=>this.m({id:Z,data:z,type:R.EventFire}));this.d.set(U.id,F)}u(U){const G=this.d.get(U.id);G&&(G.dispose(),this.d.delete(U.id))}v(U){let G=this.g.get(U.channelName);G||(G=[],this.g.set(U.channelName,G));const Z=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===$.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:R.PromiseError})},this.l);G.push({request:U,timeoutTimer:Z})}w(U){const G=this.g.get(U);if(G){for(const Z of G)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case $.Promise:this.s(Z.request);break;case $.EventListen:this.t(Z.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}t.$ci=E;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(t.RequestInitiator=N={}));class A{constructor(U,G=null){this.l=U,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=G}getChannel(U){const G=this;return{call(Z,Y,F){return G.a?Promise.reject(new I.$5):G.m(U,Z,Y,F)},listen(Z,Y){return G.a?p.Event.None:G.o(U,Z,Y)}}}m(U,G,Z,Y=k.CancellationToken.None){const F=this.g++,z=$.Promise,x={id:F,type:z,channelName:U,name:G,arg:Z};if(Y.isCancellationRequested)return Promise.reject(new I.$5);let V;return new Promise((T,j)=>{if(Y.isCancellationRequested)return j(new I.$5);const q=()=>{const fe=he=>{switch(he.type){case R.PromiseSuccess:this.f.delete(F),T(he.data);break;case R.PromiseError:{this.f.delete(F);const ve=new Error(he.data.message);ve.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ve.name=he.data.name,j(ve);break}case R.PromiseErrorObj:this.f.delete(F),j(he.data);break}};this.f.set(F,fe),this.p(x)};let X=null;this.b===g.Idle?q():(X=(0,O.$nh)(fe=>this.u()),X.then(()=>{X=null,q()}));const K=()=>{X?(X.cancel(),X=null):this.p({id:F,type:$.PromiseCancel}),j(new I.$5)},re=Y.onCancellationRequested(K);V=(0,l.$Rc)((0,l.$Sc)(K),re),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(U,G,Z){const Y=this.g++,F=$.EventListen,z={id:Y,type:F,channelName:U,name:G,arg:Z};let x=null;const V=new p.$he({onWillAddFirstListener:()=>{x=(0,O.$nh)(T=>this.u()),x.then(()=>{x=null,this.d.add(V),this.p(z)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(V),this.p({id:Y,type:$.EventDispose}))}}),b=T=>V.fire(T.data);return this.f.set(Y,b),V.event}p(U){switch(U.type){case $.Promise:case $.EventListen:{const G=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(G,U.id,N.LocalSide,`${w(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case $.PromiseCancel:case $.EventDispose:{const G=this.q([U.type,U.id]);this.j?.logOutgoing(G,U.id,N.LocalSide,w(U.type));return}}}q(U,G=void 0){const Z=new i;return r(Z,U),r(Z,G),this.r(Z.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const G=new u(U),Z=h(G),Y=h(G),F=Z[0];switch(F){case R.Initialize:return this.j?.logIncoming(U.byteLength,0,N.LocalSide,d(F)),this.t({type:Z[0]});case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,Z[1],N.LocalSide,d(F),Y),this.t({type:Z[0],id:Z[1],data:Y})}}t(U){if(U.type===R.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}t.$di=A,we([L.$5h],A.prototype,"onDidInitializePromise",null);class D{get connections(){const U=[];return this.f.forEach(G=>U.push(G)),U}constructor(U,G,Z){this.a=new Map,this.f=new Set,this.g=new p.$he,this.onDidAddConnection=this.g.event,this.h=new p.$he,this.onDidRemoveConnection=this.h.event,this.j=new l.$Tc,this.j.add(U(({protocol:Y,onDidClientDisconnect:F})=>{const z=p.Event.once(Y.onMessage);this.j.add(z(x=>{const V=new u(x),b=h(V),T=new E(Y,b,G,Z),j=new A(Y,G);this.a.forEach((X,K)=>T.registerChannel(K,X));const q={channelServer:T,channelClient:j,ctx:b};this.f.add(q),this.g.fire(q),this.j.add(F(()=>{T.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(U,G){const Z=this;return{call(Y,F,z){let x;if((0,f.$og)(G)){const b=(0,P.$3b)(Z.connections.filter(G));x=b?Promise.resolve(b):p.Event.toPromise(p.Event.filter(Z.onDidAddConnection,G))}else x=G.routeCall(Z,Y,F);const V=x.then(b=>b.channelClient.getChannel(U));return M(V).call(Y,F,z)},listen(Y,F){if((0,f.$og)(G))return Z.k(U,G,Y,F);const z=G.routeEvent(Z,Y,F).then(x=>x.channelClient.getChannel(U));return M(z).listen(Y,F)}}}k(U,G,Z,Y){const F=this;let z;const x=new p.$he({onWillAddFirstListener:()=>{z=new l.$Tc;const V=new p.$ne,b=new Map,T=q=>{const K=q.channelClient.getChannel(U).listen(Z,Y),re=V.add(K);b.set(q,re)},j=q=>{const X=b.get(q);X&&(X.dispose(),b.delete(q))};F.connections.filter(G).forEach(T),p.Event.filter(F.onDidAddConnection,G)(T,void 0,z),F.onDidRemoveConnection(j,void 0,z),V.event(x.fire,x,z),z.add(V)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return x.event}registerChannel(U,G){this.a.set(U,G);for(const Z of this.f)Z.channelServer.registerChannel(U,G)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ei=D;class C{constructor(U,G,Z=null){const Y=new i;r(Y,G),U.send(Y.buffer),this.a=new A(U,Z),this.d=new E(U,G,Z)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,G){this.d.registerChannel(U,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$fi=C;function M(B){return{call(U,G,Z){return B.then(Y=>Y.call(U,G,Z))},listen(U,G){const Z=new p.$qe;return B.then(Y=>Z.input=Y.listen(U,G)),Z.event}}}function J(B){let U=!1;return{call(G,Z,Y){return U?B.call(G,Z,Y):(0,O.$Bh)(0).then(()=>U=!0).then(()=>B.call(G,Z,Y))},listen(G,Z){if(U)return B.listen(G,Z);const Y=new p.$qe;return(0,O.$Bh)(0).then(()=>U=!0).then(()=>Y.input=B.listen(G,Z)),Y.event}}}class ae{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const G of U.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await p.Event.toPromise(U.onDidAddConnection),await this.b(U)}}t.$ii=ae;var ie;(function(B){function U(F,z,x){const V=F,b=x&&x.disableMarshalling,T=new Map;for(const j in V)Z(j)&&T.set(j,p.Event.buffer(V[j],!0,void 0,z));return new class{listen(j,q,X){const K=T.get(q);if(K)return K;const re=V[q];if(typeof re=="function"){if(Y(q))return re.call(V,X);if(Z(q))return T.set(q,p.Event.buffer(V[q],!0,void 0,z)),T.get(q)}throw new I.$bb(`Event not found: ${q}`)}call(j,q,X){const K=V[q];if(typeof K=="function"){if(!b&&Array.isArray(X))for(let fe=0;fe<X.length;fe++)X[fe]=(0,a.$0h)(X[fe]);let re=K.apply(V,X);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new I.$bb(`Method not found: ${q}`)}}}B.fromService=U;function G(F,z){const x=z&&z.disableMarshalling;return new Proxy({},{get(V,b){if(typeof b=="string")return z?.properties?.has(b)?z.properties.get(b):Y(b)?function(T){return F.listen(b,T)}:Z(b)?F.listen(b):async function(...T){let j;z&&!(0,f.$jg)(z.context)?j=[z.context,...T]:j=T;const q=await F.call(b,j);return x?q:(0,a.$0h)(q)};throw new I.$bb(`Property not found: ${String(b)}`)}})}B.toService=G;function Z(F){return F[0]==="o"&&F[1]==="n"&&c.$Af(F.charCodeAt(2))}function Y(F){return/^onDynamic/.test(F)&&c.$Af(F.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function le(B){return Array.isArray(B)?B.map(ue):ue(B)}function H(B,U,G,Z,Y,F,z){z=le(z);const x=ce[Y],V=x[Z%x.length];let b=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(F)?(b=b.concat(z),b.push(")")):b.push(z),console.log.apply(console,b)}class _{constructor(U,G){this.d=U,this.f=G,this.a=0,this.b=0}logOutgoing(U,G,Z,Y,F){this.b+=U,H(this.d,this.b,U,G,Z,Y,F)}logIncoming(U,G,Z,Y,F){this.a+=U,H(this.f,this.a,U,G,Z,Y,F)}}t.$ji=_}),define(se[92],oe([0,1,60,8,14,22,87,9,5,2,28,58,57,59]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=t.$8q=void 0;class w extends $.$ci{constructor(g){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",m=>v.$Je.wrap(Buffer.from(m,"base64")))},g),process.once("disconnect",()=>this.dispose())}}t.$8q=w;class R{constructor(g,m){this.i=g,this.j=m,this.c=new Set,this.g=new Map,this.h=new p.$he,this.onDidProcessExit=this.h.event;const S=m&&m.timeout?m.timeout:6e4;this.b=new O.$xh(S),this.d=null,this.f=null}getChannel(g){const m=this;return{call(S,y,u){return m.k(g,S,y,u)},listen(S,y){return m.l(g,S,y)}}}k(g,m,S,y=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const u=this.n(g),i=(0,O.$nh)(e=>u.call(m,S,e)),o=y.onCancellationRequested(()=>i.cancel()),s=(0,l.$Sc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,m,S){if(!this.b)return p.Event.None;this.b.cancel();let y;const u=new p.$he({onWillAddFirstListener:()=>{y=this.n(g).listen(m,S)(u.fire,u),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,a.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,f.$sm)(m.env),this.d=(0,P.fork)(this.i,g,m);const S=new p.$he,u=p.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,L.$4q)(r)){(0,L.log)(r,`IPC Library: ${this.j.serverName}`);return}S.fire(v.$Je.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,c.$um)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),s=S.event,e={send:o,onMessage:s};this.f=new $.$di(e);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,h)=>{process.removeListener("exit",n),u.dispose(),this.c.forEach(E=>(0,l.$Pc)(E)),this.c.clear(),r!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:h})})}return this.f}n(g){let m=this.g.get(g);return m||(m=this.m.getChannel(g),this.g.set(g,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$9q=R}),define(se[93],oe([0,1,8,5,2,47,3]),function(Q,t,P,O,v,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6p=t.$5p=t.StorageState=t.StorageHint=void 0,t.$4p=p;var I;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(t.StorageHint=I={}));function p(f){const $=f;return $?.changed instanceof Map||$?.deleted instanceof Set}var l;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(l||(t.StorageState=l={}));class a extends v.$Uc{static{this.a=100}constructor($,w=Object.create(null)){super(),this.r=$,this.s=w,this.b=this.B(new O.$ke),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$yh(a.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((w,R)=>this.w(R,w)),$.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w($,w){if(this.c===l.Closed)return;let R=!1;(0,L.$jg)(w)?R=this.f.delete($):this.f.get($)!==w&&(this.f.set($,w),R=!0),R&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,w){const R=this.f.get($);return(0,L.$jg)(R)?w:R}getBoolean($,w){const R=this.get($);return(0,L.$jg)(R)?w:R==="true"}getNumber($,w){const R=this.get($);return(0,L.$jg)(R)?w:parseInt(R,10)}getObject($,w){const R=this.get($);return(0,L.$jg)(R)?w:(0,k.$9h)(R)}async set($,w,R=!1){if(this.c===l.Closed)return;if((0,L.$jg)(w))return this.delete($,R);const d=(0,L.$cg)(w)||Array.isArray(w)?(0,k.$8h)(w):String(w);if(this.f.get($)!==d)return this.f.set($,d),this.j.set($,d),this.h.delete($),this.b.fire({key:$,external:R}),this.D()}async delete($,w=!1){if(!(this.c===l.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:w}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===l.Closed||this.m))return this.D($)}async D($){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}t.$5p=a;class c{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((w,R)=>this.a.set(R,w)),$.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}t.$6p=c}),define(se[94],oe([7,4]),function(Q,t){return Q.create("vs/base/node/zip",t)}),define(se[49],oe([0,1,61,8,16,3,25,94]),function(Q,t,P,O,v,k,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pq=t.$oq=void 0,t.zip=d,t.$rq=g,t.$sq=S,t.$oq="end of central directory record signature not found";const p=new RegExp(t.$oq);class l extends Error{constructor(u,i){let o=i.message;switch(u){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=u,this.cause=i}}t.$pq=l;function a(y){const u=y.externalFileAttributes>>16||33188;return[448,56,7].map(i=>u&i).reduce((i,o)=>i+o,u&61440)}function c(y){if(y instanceof l)return y;let u;return p.test(y.message)&&(u="CorruptZip"),new l(u,y)}function f(y,u,i,o,s,e){const n=v.$mc(u),r=v.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(I.localize(0,null,u)));const h=v.$jc(o,u);let E;return e.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(L.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((N,A)=>{if(!e.isCancellationRequested)try{E=(0,P.createWriteStream)(h,{mode:i}),E.once("close",()=>N()),E.once("error",A),y.once("error",A),y.pipe(E)}catch(D){A(D)}}))}function $(y,u,i,o){let s=(0,O.$nh)(()=>Promise.resolve()),e=0;const n=o.onCancellationRequested(()=>{s.cancel(),y.close()});return new Promise((r,h)=>{const E=new O.$vh,N=A=>{A.isCancellationRequested||(e++,y.readEntry())};y.once("error",h),y.once("close",()=>s.then(()=>{o.isCancellationRequested||y.entryCount===e?r():h(new l("Incomplete",new Error(I.localize(1,null,e,y.entryCount))))},h)),y.readEntry(),y.on("entry",A=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(A.fileName)){N(o);return}const D=A.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(D)){const J=v.$jc(u,D);s=(0,O.$nh)(ae=>L.Promises.mkdir(J,{recursive:!0}).then(()=>N(ae)).then(void 0,h));return}const C=R(y,A),M=a(A);s=(0,O.$nh)(J=>E.queue(()=>C.then(ae=>f(ae,D,M,u,i,J).then(()=>N(J)))).then(null,h))})}).finally(()=>n.dispose())}async function w(y,u=!1){const{open:i}=await new Promise((o,s)=>{Q(["yauzl"],o,s)});return new Promise((o,s)=>{i(y,u?{lazyEntries:!0}:void 0,(e,n)=>{e?s(c(e)):o((0,k.$lg)(n))})})}function R(y,u){return new Promise((i,o)=>{y.openReadStream(u,(s,e)=>{s?o(c(s)):i((0,k.$lg)(e))})})}async function d(y,u){const{ZipFile:i}=await new Promise((o,s)=>{Q(["yazl"],o,s)});return new Promise((o,s)=>{const e=new i;u.forEach(r=>{r.contents?e.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&e.addFile(r.localPath,r.path)}),e.end();const n=(0,P.createWriteStream)(y);e.outputStream.pipe(n),e.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>o(y))})}function g(y,u,i={},o){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let e=w(y,!0);return i.overwrite&&(e=e.then(n=>L.Promises.rm(u).then(()=>n))),e.then(n=>$(n,u,{sourcePathRegex:s},o))}function m(y,u){return w(y).then(i=>new Promise((o,s)=>{i.on("entry",e=>{e.fileName===u&&R(i,e).then(n=>o(n),n=>s(n))}),i.once("close",()=>s(new Error(I.localize(2,null,u))))}))}function S(y,u){return m(y,u).then(i=>new Promise((o,s)=>{const e=[];i.once("error",s),i.on("data",n=>e.push(n)),i.on("end",()=>o(Buffer.concat(e)))}))}}),define(se[95],oe([7,4]),function(Q,t){return Q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(se[96],oe([7,4]),function(Q,t){return Q.create("vs/platform/contextkey/common/contextkey",t)}),define(se[97],oe([7,4]),function(Q,t){return Q.create("vs/platform/contextkey/common/scanner",t)}),define(se[98],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(se[99],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(se[100],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(se[101],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(se[102],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(se[103],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(se[104],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(se[105],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensions/common/extensionValidator",t)}),define(se[106],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/common/fileService",t)}),define(se[107],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/common/io",t)}),define(se[108],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(se[109],oe([7,4]),function(Q,t){return Q.create("vs/platform/languagePacks/common/languagePacks",t)}),define(se[110],oe([7,4]),function(Q,t){return Q.create("vs/platform/log/common/log",t)}),define(se[111],oe([7,4]),function(Q,t){return Q.create("vs/platform/request/common/request",t)}),define(se[112],oe([7,4]),function(Q,t){return Q.create("vs/platform/shell/node/shellEnv",t)}),define(se[113],oe([7,4]),function(Q,t){return Q.create("vs/platform/telemetry/common/telemetryService",t)}),define(se[114],oe([7,4]),function(Q,t){return Q.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(se[115],oe([7,4]),function(Q,t){return Q.create("vs/platform/workspace/common/workspace",t)}),define(se[116],oe([0,1,117,9,97]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vj=t.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(t.TokenType=k={}));function L(...a){switch(a.length){case 1:return(0,v.localize)(0,null,a[0]);case 2:return(0,v.localize)(1,null,a[0],a[1]);case 3:return(0,v.localize)(2,null,a[0],a[1],a[2]);default:return}}const I=(0,v.localize)(3,null),p=(0,v.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return c.isTripleEq?"===":"==";case k.NotEq:return c.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return c.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return c.lexeme;case k.QuotedStr:return c.lexeme;case k.Error:return c.lexeme;case k.EOF:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(k.LParen);break;case P.CharCode.CloseParen:this.k(k.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const f=this.h(P.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:f})}else this.k(k.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const f=this.h(P.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:f})}else this.h(P.CharCode.Tilde)?this.k(k.RegexOp):this.l(L("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?k.LtEq:k.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?k.GtEq:k.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(k.And):this.l(L("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(k.Or):this.l(L("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const f=this.d,$=this.c.substring(this.d,this.e),w={type:k.Error,offset:this.d,lexeme:$};this.g.push({offset:f,lexeme:$,additionalInfo:c}),this.f.push(w)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const f=this.c.substring(this.d,this.e),$=l.b.get(f);$?this.k($):this.f.push({type:k.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,f=!1,$=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(p);return}const R=this.c.charCodeAt(c);if(f)f=!1;else if(R===P.CharCode.Slash&&!$){c++;break}else R===P.CharCode.OpenSquareBracket?$=!0:R===P.CharCode.Backslash?f=!0:R===P.CharCode.CloseSquareBracket&&($=!1);c++}for(;c<this.c.length&&l.a.has(this.c.charCodeAt(c));)c++;this.e=c;const w=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}t.$vj=l}),define(se[118],oe([0,1,83,55,15,16,37,17,12]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$m=t.$0m=void 0,t.$_m=a,t.$an=c,t.$0m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,k.$mc)(v.$Ug.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,k.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,P.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$jc)(this.userDataPath,"logs",$)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$bh)(p.URI.file((0,k.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=L.env.VSCODE_PORTABLE;return $?p.URI.file((0,k.$jc)($,"argv.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,k.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,k.$kc)($):(0,k.$hc)((0,k.$jc)(v.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?p.URI.file((0,k.$kc)($)):p.URI.file((0,k.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,k.$kc)($);const w=L.env.VSCODE_EXTENSIONS;if(w)return w;const R=L.env.VSCODE_PORTABLE;return R?(0,k.$jc)(R,"extensions"):(0,I.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(w=>/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,k.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?p.URI.parse($):p.URI.file((0,k.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return a(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!t.$0m.test($))}get extensionLogLevel(){const $=[];for(const w of this.args.log||[]){const R=t.$0m.exec(w);R&&R[1]&&R[2]&&$.push([R[1],R[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,I.$bh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=L.env.VSCODE_PORTABLE;return $?p.URI.file((0,k.$jc)($,"policy.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,w,R){this.a=$,this.b=w,this.c=R,this.editSessionId=this.args.editSessionId}}t.$$m=l,we([O.$5h],l.prototype,"appRoot",null),we([O.$5h],l.prototype,"userHome",null),we([O.$5h],l.prototype,"userDataPath",null),we([O.$5h],l.prototype,"appSettingsHome",null),we([O.$5h],l.prototype,"tmpDir",null),we([O.$5h],l.prototype,"cacheHome",null),we([O.$5h],l.prototype,"stateResource",null),we([O.$5h],l.prototype,"userRoamingDataHome",null),we([O.$5h],l.prototype,"userDataSyncHome",null),we([O.$5h],l.prototype,"sync",null),we([O.$5h],l.prototype,"machineSettingsResource",null),we([O.$5h],l.prototype,"workspaceStorageHome",null),we([O.$5h],l.prototype,"localHistoryHome",null),we([O.$5h],l.prototype,"keyboardLayoutResource",null),we([O.$5h],l.prototype,"argvResource",null),we([O.$5h],l.prototype,"isExtensionDevelopment",null),we([O.$5h],l.prototype,"untitledWorkspacesHome",null),we([O.$5h],l.prototype,"builtinExtensionsPath",null),we([O.$5h],l.prototype,"extensionsPath",null),we([O.$5h],l.prototype,"extensionDevelopmentLocationURI",null),we([O.$5h],l.prototype,"extensionDevelopmentKind",null),we([O.$5h],l.prototype,"extensionTestsLocationURI",null),we([O.$5h],l.prototype,"debugExtensionHost",null),we([O.$5h],l.prototype,"logLevel",null),we([O.$5h],l.prototype,"extensionLogLevel",null),we([O.$5h],l.prototype,"serviceMachineIdResource",null),we([O.$5h],l.prototype,"disableTelemetry",null),we([O.$5h],l.prototype,"disableWorkspaceTrust",null),we([O.$5h],l.prototype,"useInMemorySecretStorage",null),we([O.$5h],l.prototype,"policyFile",null);function a(f,$){return c(f["inspect-extensions"],f["inspect-brk-extensions"],5870,$,f.debugId,f.extensionEnvironment)}function c(f,$,w,R,d,g){const S=Number($||f)||(R?null:w),y=S?!!$:!1;let u;if(g)try{u=JSON.parse(g)}catch{}return{port:S,break:y,debugId:d,env:u}}}),function(){"use strict";function Q(t,P,O){function v(L,I){const p=k(L,I),l=[p];return t.isAbsolute(p)||l.unshift(O),t.resolve(...l)}function k(L,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return t.join(p,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return t.join(l,I);const a=L["user-data-dir"];if(a)return a;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=t.join(c,"AppData","Roaming")}break;case"darwin":l=t.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||t.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(l,I)}return{getUserDataPath:v}}if(typeof define=="function")define(se[119],oe([172,35,37]),function(t,P,O){return Q(t,P,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),P=require("os");module.exports=Q(t,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[120],oe([0,1,35,118,119]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bn=void 0,t.$cn=L,t.$dn=I;class k extends O.$$m{constructor(l,a){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,v.getUserDataPath)(l,a.nameShort)},a)}}t.$bn=k;function L(p,l){return(0,O.$an)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,l,p.extensionEnvironment)}function I(p,l){return(0,O.$an)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,l,p.extensionEnvironment)}}),define(se[121],oe([0,1,3,101]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aq=v;function v(L,I,p,l){try{k(L,I,p,l)}catch(a){L.error(a?.message??a)}return I}function k(L,I,p,l){const a=(c,f,$)=>{const w=c[f];if((0,P.$ag)(w)){const R=w,d=R.length;if(d>1&&R[0]==="%"&&R[d-1]==="%"){const g=R.substr(1,d-2);let m=p[g];m===void 0&&l&&(m=l[g]);const S=typeof m=="string"?m:m?.message,y=l?.[g],u=typeof y=="string"?y:y?.message;if(!S){u||L.warn(`[${I.name}]: ${(0,O.localize)(0,null,g)}`);return}if($&&(f==="title"||f==="category")&&u&&u!==S){const i={value:S,original:u};c[f]=i}else c[f]=S}}else if((0,P.$cg)(w))for(const R in w)w.hasOwnProperty(R)&&(R==="commands"?a(w,R,!0):a(w,R,$));else if(Array.isArray(w))for(let R=0;R<w.length;R++)a(w,R,$)};for(const c in I)I.hasOwnProperty(c)&&a(I,c)}}),define(se[50],oe([0,1,17,56,105,44]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Op=p,t.$Pp=l,t.$Qp=a,t.$Rp=c,t.$Sp=f,t.$Tp=$,t.$Up=w;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function p(g){return g=g.trim(),g==="*"||L.test(g)}function l(g){if(!p(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=g.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function a(g){if(!g)return null;const m=g.majorBase,S=g.majorMustEqual,y=g.minorBase;let u=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(m===0||(u=!1),o=!1);let s=0;if(g.preRelease){const e=I.exec(g.preRelease);if(e){const[,n,r,h]=e;s=Date.UTC(Number(n),Number(r)-1,Number(h))}}return{majorBase:m,majorMustEqual:S,minorBase:y,minorMustEqual:u,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:s}}function c(g,m,S){let y;typeof g=="string"?y=a(l(g)):y=g;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let i;if(typeof S=="string"?i=a(l(S)):i=S,!y||!i)return!1;const o=y.majorBase,s=y.minorBase,e=y.patchBase;let n=i.majorBase,r=i.minorBase,h=i.patchBase;const E=i.notBefore;let N=i.majorMustEqual,A=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:s>r?!0:s<r||u&&u<E?!1:e>=h:(o===1&&n===0&&(!N||!A||!D)&&(n=1,r=0,h=0,N=!0,A=!1,D=!1),o<n?!1:o>n?!N:s<r?!1:s>r?!A:e<h?!1:e>h?!D:!(u&&u<E))}function f(g,m,S,y,u){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([O.default.Error,v.localize(0,null)]),i;if(typeof y.name!="string")return i.push([O.default.Error,v.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([O.default.Error,v.localize(2,null,"version")]),i;if(!y.engines)return i.push([O.default.Error,v.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([O.default.Error,v.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!d(y.extensionDependencies))return i.push([O.default.Error,v.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!d(y.activationEvents))return i.push([O.default.Error,v.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([O.default.Error,v.localize(7,null,"activationEvents","main","browser")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([O.default.Warning,v.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([O.default.Error,v.localize(9,null,"main")]),i;{const e=(0,P.$bh)(S,y.main);(0,P.$8g)(e,S)||i.push([O.default.Warning,v.localize(10,null,e.path,S.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([O.default.Error,v.localize(11,null,"browser")]),i;{const e=(0,P.$bh)(S,y.browser);(0,P.$8g)(e,S)||i.push([O.default.Warning,v.localize(12,null,e.path,S.path)])}}if(!k.valid(y.version))return i.push([O.default.Error,v.localize(13,null)]),i;const o=[];if(!$(g,m,y,u,o))for(const e of o)i.push([O.default.Error,e]);return i}function $(g,m,S,y,u){return y||typeof S.main>"u"&&typeof S.browser>"u"?!0:R(g,m,S.engines.vscode,u)}function w(g,m,S){return g==="*"||R(m,S,g)}function R(g,m,S,y=[]){const u=a(l(S));if(!u)return y.push(v.localize(14,null,S)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return y.push(v.localize(15,null,S)),!1}else if(!u.majorMustEqual)return y.push(v.localize(16,null,S)),!1;return c(g,m,u)?!0:(y.push(v.localize(17,null,g,S)),!1)}function d(g){if(!Array.isArray(g))return!1;for(let m=0,S=g.length;m<S;m++)if(typeof g[m]!="string")return!1;return!0}}),define(se[51],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xi=void 0;class P{constructor(v,k=[],L=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=L}}t.$xi=P}),define(se[122],oe([0,1,51]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Fs=k,t.$Gs=L;const O=[];var v;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(v||(t.InstantiationType=v={}));function k(I,p,l){p instanceof P.$xi||(p=new P.$xi(p,[],!!l)),O.push([I,p])}function L(){return O}}),define(se[123],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jr=t.$ir=void 0;class P{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.$ir=P;class O{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const I=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(L);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const I of this.a.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let I=this.a.get(L);return I||(I=new P(L,k),this.a.set(L,I)),I}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,I]of this.a)k.push(`${L}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const I=new Set([k]),p=this.c(L,I);if(p)return p}}c(k,L){for(const[I,p]of k.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const l=this.c(p,L);if(l)return l;L.delete(I)}}}t.$jr=O}),define(se[30],oe([0,1,3,12,11]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$7i=void 0,t.$8i=k,t.$9i=L,t.$0i=p,t.$$i=l,t.$_i=a,t.$aj=c,t.$bj=f,t.$cj=w,t.$dj=R,t.$ej=d,t.$7i=(0,v.$Ai)("configurationService");function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof O.URI)}function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof O.URI)}var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I||(t.ConfigurationTarget=I={}));function p(g){switch(g){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function a(g,m){const S=Object.create(null);for(const y in g)c(S,y,g[y],m);return S}function c(g,m,S,y){const u=m.split("."),i=u.pop();let o=g;for(let s=0;s<u.length;s++){const e=u[s];let n=o[e];switch(typeof n){case"undefined":n=o[e]=Object.create(null);break;case"object":if(n===null){y(`Ignoring ${m} as ${u.slice(0,s+1).join(".")} is null`);return}break;default:y(`Ignoring ${m} as ${u.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=S}catch{y(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(o)}`)}else y(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(o)}`)}function f(g,m){const S=m.split(".");$(g,S)}function $(g,m){const S=m.shift();if(m.length===0){delete g[S];return}if(Object.keys(g).indexOf(S)!==-1){const y=g[S];typeof y=="object"&&!Array.isArray(y)&&($(y,m),Object.keys(y).length===0&&delete g[S])}}function w(g,m,S){function y(o,s){let e=o;for(const n of s){if(typeof e!="object"||e===null)return;e=e[n]}return e}const u=m.split("."),i=y(g,u);return typeof i>"u"?S:i}function R(g,m,S){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in g?P.$cg(g[y])&&P.$cg(m[y])?R(g[y],m[y],S):S&&(g[y]=m[y]):g[y]=m[y])})}function d(g){return g.replace(/[\[\]]/g,"")}}),define(se[124],oe([0,1,117,13,32,116,11,96,9]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$yj=t.$xj=t.ContextKeyExprType=void 0,t.$wj=a,t.$zj=s,t.$Aj=e,t.$Tj=F;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",O.$j),l.set("isLinux",O.$k),l.set("isWindows",O.$i),l.set("isWeb",O.$o),l.set("isMacNative",O.$j&&!O.$o),l.set("isEdge",O.$H),l.set("isFirefox",O.$F),l.set("isChrome",O.$E),l.set("isSafari",O.$G);function a(V,b){if(l.get(V)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(V,b)}const c=Object.prototype.hasOwnProperty;var f;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(f||(t.ContextKeyExprType=f={}));const $={regexParsingWithErrorRecovery:!0},w=(0,I.localize)(0,null),R=(0,I.localize)(1,null),d=(0,I.localize)(2,null),g=(0,I.localize)(3,null),m=(0,I.localize)(4,null),S=(0,I.localize)(5,null),y=(0,I.localize)(6,null),u=(0,I.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=$){this.k=b,this.d=new k.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:R});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const j=this.D(),q=j.type===k.TokenType.Str?S:void 0;throw this.h.push({message:m,offset:j.offset,lexeme:k.$vj.getLexeme(j),additionalInfo:q}),i.c}return T}catch(T){if(T!==i.c)throw T;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(k.TokenType.Or);){const T=this.o();b.push(T)}return b.length===1?b[0]:o.or(...b)}o(){const b=[this.s()];for(;this.y(k.TokenType.And);){const T=this.s();b.push(T)}return b.length===1?b[0]:o.and(...b)}s(){if(this.y(k.TokenType.Neg)){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),r.INSTANCE;case k.TokenType.False:return this.z(),h.INSTANCE;case k.TokenType.LParen:{this.z();const T=this.l();return this.A(k.TokenType.RParen,g),T?.negate()}case k.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),o.true();case k.TokenType.False:return this.z(),o.false();case k.TokenType.LParen:{this.z();const T=this.l();return this.A(k.TokenType.RParen,g),T}case k.TokenType.Str:{const T=b.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==k.TokenType.RegexStr)throw this.B("REGEX",q);const X=q.lexeme,K=X.lastIndexOf("/"),re=K===X.length-1?void 0:this.w(X.substring(K+1));let fe;try{fe=new RegExp(X.substring(1,K),re)}catch{throw this.B("REGEX",q)}return le.create(T,fe)}switch(q.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const X=[q.lexeme];this.z();let K=this.D(),re=0;for(let ge=0;ge<q.lexeme.length;ge++)q.lexeme.charCodeAt(ge)===P.CharCode.OpenParen?re++:q.lexeme.charCodeAt(ge)===P.CharCode.CloseParen&&re--;for(;!this.E()&&K.type!==k.TokenType.And&&K.type!==k.TokenType.Or;){switch(K.type){case k.TokenType.LParen:re++;break;case k.TokenType.RParen:re--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let ge=0;ge<K.lexeme.length;ge++)K.lexeme.charCodeAt(ge)===P.CharCode.OpenParen?re++:q.lexeme.charCodeAt(ge)===P.CharCode.CloseParen&&re--}if(re<0)break;X.push(k.$vj.getLexeme(K)),this.z(),K=this.D()}const fe=X.join(""),he=fe.lastIndexOf("/"),ve=he===fe.length-1?void 0:this.w(fe.substring(he+1));let me;try{me=new RegExp(fe.substring(1,he),ve)}catch{throw this.B("REGEX",q)}return o.regex(T,me)}case k.TokenType.QuotedStr:{const X=q.lexeme;this.z();let K=null;if(!(0,v.$$e)(X)){const re=X.indexOf("/"),fe=X.lastIndexOf("/");if(re!==fe&&re>=0){const he=X.slice(re+1,fe),ve=X[fe+1]==="i"?"i":"";try{K=new RegExp(he,ve)}catch{throw this.B("REGEX",q)}}}if(K===null)throw this.B("REGEX",q);return le.create(T,K)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,d);const q=this.u();return o.notIn(T,q)}switch(this.D().type){case k.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return o.equals(T,q);switch(q){case"true":return o.has(T);case"false":return o.not(T);default:return o.equals(T,q)}}case k.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return o.notEquals(T,q);switch(q){case"true":return o.not(T);case"false":return o.has(T);default:return o.notEquals(T,q)}}case k.TokenType.Lt:return this.z(),ce.create(T,this.u());case k.TokenType.LtEq:return this.z(),ue.create(T,this.u());case k.TokenType.Gt:return this.z(),ae.create(T,this.u());case k.TokenType.GtEq:return this.z(),ie.create(T,this.u());case k.TokenType.In:return this.z(),o.in(T,this.u());default:return o.has(T)}}case k.TokenType.EOF:throw this.h.push({message:y,offset:b.offset,lexeme:"",additionalInfo:u}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),b.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,T){if(this.C(b))return this.z();throw this.B(T,this.D())}B(b,T,j){const q=(0,I.localize)(8,null,b,k.$vj.getLexeme(T)),X=T.offset,K=k.$vj.getLexeme(T);return this.h.push({message:q,offset:X,lexeme:K,additionalInfo:j}),i.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}t.$xj=i;class o{static false(){return r.INSTANCE}static true(){return h.INSTANCE}static has(b){return E.create(b)}static equals(b,T){return N.create(b,T)}static notEquals(b,T){return C.create(b,T)}static regex(b,T){return le.create(b,T)}static in(b,T){return A.create(b,T)}static notIn(b,T){return D.create(b,T)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return U.create(b,null,!0)}static greater(b,T){return ae.create(b,T)}static greaterEquals(b,T){return ie.create(b,T)}static smaller(b,T){return ce.create(b,T)}static smallerEquals(b,T){return ue.create(b,T)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}t.$yj=o;function s(V){const b=new i({regexParsingWithErrorRecovery:!1});return V.map(T=>(b.parse(T),b.lexingErrors.length>0?b.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,I.localize)(9,null,j.additionalInfo):(0,I.localize)(10,null),offset:j.offset,length:j.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function e(V,b){const T=V?V.substituteConstants():void 0,j=b?b.substituteConstants():void 0;return!T&&!j?!0:!T||!j?!1:T.equals(j)}function n(V,b){return V.cmp(b)}class r{static{this.INSTANCE=new r}constructor(){this.type=f.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return h.INSTANCE}}t.$Bj=r;class h{static{this.INSTANCE=new h}constructor(){this.type=f.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return r.INSTANCE}}t.$Cj=h;class E{static create(b,T=null){const j=l.get(b);return typeof j=="boolean"?j?h.INSTANCE:r.INSTANCE:new E(b,T)}constructor(b,T){this.key=b,this.c=T,this.type=f.Defined}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=l.get(this.key);return typeof b=="boolean"?b?h.INSTANCE:r.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}t.$Dj=E;class N{static create(b,T,j=null){if(typeof T=="boolean")return T?E.create(b,j):M.create(b,j);const q=l.get(b);return typeof q=="boolean"?T===(q?"true":"false")?h.INSTANCE:r.INSTANCE:new N(b,T,j)}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.Equals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=l.get(this.c);if(typeof b=="boolean"){const T=b?"true":"false";return this.d===T?h.INSTANCE:r.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}t.$Ej=N;class A{static create(b,T){return new A(b,T)}constructor(b,T){this.d=b,this.f=T,this.type=f.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const T=b.getValue(this.f),j=b.getValue(this.d);return Array.isArray(T)?T.includes(j):typeof j=="string"&&typeof T=="object"&&T!==null?c.call(T,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}t.$Fj=A;class D{static create(b,T){return new D(b,T)}constructor(b,T){this.d=b,this.f=T,this.type=f.NotIn,this.c=A.create(b,T)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Gj=D;class C{static create(b,T,j=null){if(typeof T=="boolean")return T?M.create(b,j):E.create(b,j);const q=l.get(b);return typeof q=="boolean"?T===(q?"true":"false")?r.INSTANCE:h.INSTANCE:new C(b,T,j)}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=l.get(this.c);if(typeof b=="boolean"){const T=b?"true":"false";return this.d===T?r.INSTANCE:h.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}t.$Hj=C;class M{static create(b,T=null){const j=l.get(b);return typeof j=="boolean"?j?r.INSTANCE:h.INSTANCE:new M(b,T)}constructor(b,T){this.c=b,this.d=T,this.type=f.Not}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=l.get(this.c);return typeof b=="boolean"?b?r.INSTANCE:h.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}t.$Ij=M;function J(V,b){if(typeof V=="string"){const T=parseFloat(V);isNaN(T)||(V=T)}return typeof V=="string"||typeof V=="number"?b(V):r.INSTANCE}class ae{static create(b,T,j=null){return J(T,q=>new ae(b,q,j))}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.Greater}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}t.$Jj=ae;class ie{static create(b,T,j=null){return J(T,q=>new ie(b,q,j))}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}t.$Kj=ie;class ce{static create(b,T,j=null){return J(T,q=>new ce(b,q,j))}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}t.$Lj=ce;class ue{static create(b,T,j=null){return J(T,q=>new ue(b,q,j))}constructor(b,T,j){this.c=b,this.d=T,this.f=j,this.type=f.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}t.$Mj=ue;class le{static create(b,T){return new le(b,T)}constructor(b,T){this.d=b,this.f=T,this.type=f.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const T=this.f?this.f.source:"",j=b.f?b.f.source:"";return T<j?-1:T>j?1:0}equals(b){if(b.type===this.type){const T=this.f?this.f.source:"",j=b.f?b.f.source:"";return this.d===b.d&&T===j}return!1}substituteConstants(){return this}evaluate(b){const T=b.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}t.$Nj=le;class H{static create(b){return new H(b)}constructor(b){this.c=b,this.type=f.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new H(this.c.map(b))}negate(){return this.c}}t.$Oj=H;function _(V){let b=null;for(let T=0,j=V.length;T<j;T++){const q=V[T].substituteConstants();if(V[T]!==q&&b===null){b=[];for(let X=0;X<T;X++)b[X]=V[X]}b!==null&&(b[T]=q)}return b===null?V:b}class B{static create(b,T,j){return B.d(b,T,j)}constructor(b,T){this.expr=b,this.c=T,this.type=f.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let T=0,j=this.expr.length;T<j;T++){const q=n(this.expr[T],b.expr[T]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let T=0,j=this.expr.length;T<j;T++)if(!this.expr[T].equals(b.expr[T]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let T=0,j=this.expr.length;T<j;T++)if(!this.expr[T].evaluate(b))return!1;return!0}static d(b,T,j){const q=[];let X=!1;for(const K of b)if(K){if(K.type===f.True){X=!0;continue}if(K.type===f.False)return r.INSTANCE;if(K.type===f.And){q.push(...K.expr);continue}q.push(K)}if(q.length===0&&X)return h.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];for(;q.length>1;){const K=q[q.length-1];if(K.type!==f.Or)break;q.pop();const re=q.pop(),fe=q.length===0,he=U.create(K.expr.map(ve=>B.create([ve,re],null,j)),null,fe);he&&(q.push(he),q.sort(n))}if(q.length===1)return q[0];if(j){for(let K=0;K<q.length;K++)for(let re=K+1;re<q.length;re++)if(q[K].negate().equals(q[re]))return r.INSTANCE;if(q.length===1)return q[0]}return new B(q,T)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const T of this.expr)b.push(...T.keys());return b}map(b){return new B(this.expr.map(T=>T.map(b)),null)}negate(){if(!this.c){const b=[];for(const T of this.expr)b.push(T.negate());this.c=U.create(b,this,!0)}return this.c}}t.$Pj=B;class U{static create(b,T,j){return U.d(b,T,j)}constructor(b,T){this.expr=b,this.c=T,this.type=f.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let T=0,j=this.expr.length;T<j;T++){const q=n(this.expr[T],b.expr[T]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let T=0,j=this.expr.length;T<j;T++)if(!this.expr[T].equals(b.expr[T]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:U.create(b,this.c,!1)}evaluate(b){for(let T=0,j=this.expr.length;T<j;T++)if(this.expr[T].evaluate(b))return!0;return!1}static d(b,T,j){let q=[],X=!1;if(b){for(let K=0,re=b.length;K<re;K++){const fe=b[K];if(fe){if(fe.type===f.False){X=!0;continue}if(fe.type===f.True)return h.INSTANCE;if(fe.type===f.Or){q=q.concat(fe.expr);continue}q.push(fe)}}if(q.length===0&&X)return r.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];if(j){for(let K=0;K<q.length;K++)for(let re=K+1;re<q.length;re++)if(q[K].negate().equals(q[re]))return h.INSTANCE;if(q.length===1)return q[0]}return new U(q,T)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const T of this.expr)b.push(...T.keys());return b}map(b){return new U(this.expr.map(T=>T.map(b)),null)}negate(){if(!this.c){const b=[];for(const T of this.expr)b.push(T.negate());for(;b.length>1;){const T=b.shift(),j=b.shift(),q=[];for(const X of x(T))for(const K of x(j))q.push(B.create([X,K],null,!1));b.unshift(U.create(q,null,!1))}this.c=U.create(b,this,!0)}return this.c}}t.$Qj=U;class G extends E{static{this.d=[]}static all(){return G.d.values()}constructor(b,T,j){super(b,null),this.f=T,typeof j=="object"?G.d.push({...j,key:b}):j!==!0&&G.d.push({key:b,description:j,type:T!=null?typeof T:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return N.create(this.key,b)}notEqualsTo(b){return C.create(this.key,b)}}t.$Rj=G,t.$Sj=(0,L.$Ai)("contextKeyService");function Z(V,b){return V<b?-1:V>b?1:0}function Y(V,b,T,j){return V<T?-1:V>T?1:b<j?-1:b>j?1:0}function F(V,b){if(V.type===f.False||b.type===f.True)return!0;if(V.type===f.Or)return b.type===f.Or?z(V.expr,b.expr):!1;if(b.type===f.Or){for(const T of b.expr)if(F(V,T))return!0;return!1}if(V.type===f.And){if(b.type===f.And)return z(b.expr,V.expr);for(const T of V.expr)if(F(T,b))return!0;return!1}return V.equals(b)}function z(V,b){let T=0,j=0;for(;T<V.length&&j<b.length;){const q=V[T].cmp(b[j]);if(q<0)return!1;q===0&&T++,j++}return T===V.length}function x(V){return V.type===f.Or?V.expr:[V]}}),define(se[62],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ro=void 0,t.$Ro=(0,P.$Ai)("downloadService")}),define(se[18],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ii=t.$Hi=void 0,t.$Hi=(0,P.$Ai)("environmentService"),t.$Ii=(0,P.$Bi)(t.$Hi)}),define(se[63],oe([0,1,14,9,107,10]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=L;async function L(a,c,f,$,w,R){let d;try{await I(a,c,f,$,w,R)}catch(g){d=g}finally{d&&w.errorTransformer&&(d=w.errorTransformer(d)),typeof d<"u"&&f.error(d),f.end()}}async function I(a,c,f,$,w,R){p(R);const d=await a.open(c,{create:!1});try{p(R);let g=0,m=0,S=w&&typeof w.length=="number"?w.length:void 0,y=P.$Je.alloc(Math.min(w.bufferSize,typeof S=="number"?S:w.bufferSize)),u=w&&typeof w.position=="number"?w.position:0,i=0;do m=await a.read(d,u,y.buffer,i,y.byteLength-i),u+=m,i+=m,g+=m,typeof S=="number"&&(S-=m),i===y.byteLength&&(await f.write($(y)),y=P.$Je.alloc(Math.min(w.bufferSize,typeof S=="number"?S:w.bufferSize)),i=0);while(m>0&&(typeof S!="number"||S>0)&&p(R)&&l(g,w));if(i>0){let o=i;typeof S=="number"&&(o=Math.min(i,S)),f.write($(y.slice(0,o)))}}catch(g){throw(0,k.$il)(g)}finally{await a.close(d)}}function p(a){if(a.isCancellationRequested)throw(0,O.$6)();return!0}function l(a,c){if(typeof c?.limits?.size=="number"&&a>c.limits.size)throw(0,k.$hl)((0,v.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[125],oe([0,1,61,2,52,5,10,12,8]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$q=void 0;class l extends O.$Uc{constructor(){super(),this.a=this.B(new k.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new p.$Xh,this.P=!1,this.B(this.f(c=>this.s(c)))}s(c){this.t(c)&&this.w(c)}t(c){return(0,v.$Rq)(c)}async watch(c){this.r.isSettled||this.r.complete(),this.r=new p.$Xh;try{this.h.clear(),this.g.clear();for(const f of c)this.t(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(c=>!this.j.has(c.correlationId))])}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async w(c){if(this.j.has(c.correlationId))return;const f=new O.$Tc;this.j.set(c.correlationId,f),await this.r.p,!f.isDisposed&&(this.z(c,f),this.u())}y(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.u()}z(c,f){this.C(c,f)?(this.N(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.D(c,f),this.m.add(c.correlationId))}C(c,f){const $=this.M?.subscribe(c.path,(w,R)=>{f.isDisposed||(w?this.z(c,f):R?.type===L.FileChangeType.ADDED&&this.F(c))});return $?(f.add($),!0):!1}D(c,f){let $=!1;const w=(R,d)=>{if(f.isDisposed)return;const g=this.G(R),m=this.G(d),S=$;$=g,!g&&(m||S)&&this.F(c)};this.N(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,P.watchFile)(c.path,{persistent:!1,interval:this.n},w)}catch(R){this.O(`fs.watchFile() failed with error ${R} on path ${c.path} (correlationId: ${c.correlationId})`)}f.add((0,O.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,P.unwatchFile)(c.path,w)}catch(R){this.O(`fs.unwatchFile() failed with error ${R} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}F(c){this.N(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const f={resource:I.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([f]),this.H(f,c),this.y(c)}G(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(c,f){if(this.P){const $=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.I($,f)}}I(c,f){this.P&&this.N(`${c}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}J(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,v.$2q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.P=c}}t.$$q=l}),define(se[126],oe([0,1,5,173,125,13,174,64]),function(Q,t,P,O,v,k,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fr=void 0;class p extends v.$$q{constructor(a){super(),this.M=a,this.onDidError=P.Event.None,this.watchers=new Set}async L(a){a=this.X(a);const c=[],f=new Set(Array.from(this.watchers));for(const $ of a){const w=this.S($);w&&(0,O.$yk)(w.request.excludes,$.excludes)&&(0,O.$yk)(w.request.includes,$.includes)?f.delete(w):c.push($)}c.length&&this.N(`Request to start watching: ${c.map($=>this.J($)).join(",")}`),f.size&&this.N(`Request to stop watching: ${Array.from(f).map($=>this.J($.request)).join(",")}`);for(const $ of f)this.W($);for(const $ of c)this.U($)}S(a){for(const c of this.watchers)if(typeof a.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===a.correlationId)return c}else if((0,I.$yg)(c.request.path,a.path,!k.$k))return c}U(a){const c=new L.$dr(a,this.M,$=>this.a.fire($),()=>this.c.fire(a),$=>this.b.fire($),this.P),f={request:a,instance:c};this.watchers.add(f)}async stop(){await super.stop();for(const a of this.watchers)this.W(a)}W(a){this.N("stopping file watcher",a),this.watchers.delete(a),a.instance.dispose()}X(a){const c=new Map;for(const f of a){const $=k.$k?f.path:f.path.toLowerCase();let w=c.get(f.correlationId);w||(w=new Map,c.set(f.correlationId,w)),w.has($)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(f)}`),w.set($,f)}return Array.from(c.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(a){super.setVerboseLogging(a);for(const c of this.watchers)c.instance.setVerboseLogging(a)}N(a,c){this.P&&this.b.fire({type:"trace",message:this.$(a,c)})}O(a){this.b.fire({type:"warn",message:this.$(a)})}$(a,c){return c?`[File Watcher (node.js)] ${a} (${this.J(c.request)})`:`[File Watcher (node.js)] ${a}`}}t.$fr=p}),define(se[127],oe([0,1,52,126]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=void 0;class v extends P.$Uq{constructor(L,I,p){super(L,I,p),this.u()}t(L){return L.add(new O.$fr(void 0))}}t.$gr=v}),define(se[128],oe([0,1,15,59,92,52]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0q=void 0;class L extends k.$Vq{constructor(p,l,a){super(p,l,a),this.u()}t(p){const l=p.add(new v.$9q(P.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(l.onDidProcessExit(({code:a,signal:c})=>this.w(`terminated by itself with code ${a}, signal: ${c} (ETERM)`))),O.ProxyChannel.toService((0,O.$hi)(l.getChannel("watcher")))}}t.$0q=L}),define(se[65],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yi=void 0;class P{constructor(...v){this.a=new Map;for(const[k,L]of v)this.set(k,L)}set(v,k){const L=this.a.get(v);return this.a.set(v,k),L}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}t.$yi=P}),define(se[129],oe([0,1,8,9,2,51,123,11,65,175]),function(Q,t,P,O,v,k,L,I,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lr=t.$kr=void 0;const a=!1;class c extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class f{constructor(d=new p.$yi,g=!1,m,S=a){this.i=d,this.j=g,this.k=m,this.l=S,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$zi,this),this._globalGraph=S?m?._globalGraph??new L.$jr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,v.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d,g){this.m();const m=this,S=new class extends f{dispose(){m.h.delete(S),super.dispose()}}(d,this.j,this,this.l);return this.h.add(S),g?.add(S),S}invokeFunction(d,...g){this.m();const m=w.traceInvocation(this.l,d);let S=!1;try{return d({get:u=>{if(S)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(u,m);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...g)}finally{S=!0,m.stop()}}createInstance(d,...g){this.m();let m,S;return d instanceof k.$xi?(m=w.traceCreation(this.l,d.ctor),S=this.o(d.ctor,d.staticArguments.concat(g),m)):(m=w.traceCreation(this.l,d),S=this.o(d,g,m)),m.stop(),S}o(d,g=[],m){const S=I._util.getServiceDependencies(d).sort((i,o)=>i.index-o.index),y=[];for(const i of S){const o=this.s(i.id,m);o||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(o)}const u=S.length>0?S[0].index:g.length;if(g.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);const i=u-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,u)}return Reflect.construct(d,g.concat(y))}q(d,g){if(this.i.get(d)instanceof k.$xi)this.i.set(d,g);else if(this.k)this.k.q(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const g=this.i.get(d);return!g&&this.k?this.k.r(d):g}s(d,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const m=this.r(d);return m instanceof k.$xi?this.u(d,m,g.branch(d,!0)):(g.branch(d,!1),m)}u(d,g,m){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,g,m)}finally{this.t.delete(d)}}v(d,g,m){const S=new L.$jr(i=>i.id.toString());let y=0;const u=[{id:d,desc:g,_trace:m}];for(;u.length;){const i=u.pop();if(S.lookupOrInsertNode(i),y++>1e3)throw new c(S);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof k.$xi){const e={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};S.insertEdge(i,e),u.push(e)}}}for(;;){const i=S.roots();if(i.length===0){if(!S.isEmpty())throw new c(S);break}for(const{data:o}of i){if(this.r(o.id)instanceof k.$xi){const e=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,e)}S.removeNode(o)}}return this.r(d)}w(d,g,m=[],S,y){if(this.i.get(d)instanceof k.$xi)return this.x(d,g,m,S,y,this.g);if(this.k)return this.k.w(d,g,m,S,y);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(d,g,m=[],S,y,u){if(S){const i=new f(void 0,this.j,this,this.l);i.c=String(d);const o=new Map,s=new P.$Th(()=>{const e=i.o(g,m,y);for(const[n,r]of o){const h=e[n];if(typeof h=="function")for(const E of r)E.disposable=h.apply(e,E.listener)}return o.clear(),u.add(e),e});return new Proxy(Object.create(null),{get(e,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let E=o.get(n);return E||(E=new l.$5c,o.set(n,E)),(A,D,C)=>{if(s.isInitialized)return s.value[n](A,D,C);{const M={listener:[A,D,C],disposable:void 0},J=E.push(M);return(0,v.$Sc)(()=>{J(),M.disposable?.dispose()})}}}if(n in e)return e[n];const r=s.value;let h=r[n];return typeof h!="function"||(h=h.bind(r),e[n]=h),h},set(e,n,r){return s.value[n]=r,!0},getPrototypeOf(e){return g.prototype}})}else{const i=this.o(g,m,y);return u.add(i),i}}y(d,g){if(g&&console.warn(d),this.j)throw new Error(d)}}t.$kr=f;var $;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})($||($={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(d,g){return d?new w($.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(d,g){return d?new w($.Creation,g.name):w.c}static{this.f=0}constructor(d,g){this.type=d,this.name=g,this.g=Date.now(),this.h=[]}branch(d,g){const m=new w($.Branch,d.toString());return this.h.push([d,g,m]),m}stop(){const d=Date.now()-this.g;w.f+=d;let g=!1;function m(y,u){const i=[],o=new Array(y+1).join("	");for(const[s,e,n]of u.h)if(e&&n){g=!0,i.push(`${o}CREATES -> ${s}`);const r=m(y+1,n);r&&i.push(r)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const S=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(d>2||g)&&w.all.add(S.join(`
`))}}t.$lr=w}),define(se[6],oe([0,1,110,36,5,43,2,31,13,17,3,12,124,11]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mk=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$0j=t.LogLevel=t.$8j=t.$7j=void 0,t.$9j=R,t.log=g,t.$ik=h,t.$jk=E,t.$kk=N,t.$lk=A,t.$7j=(0,$.$Ai)("logService"),t.$8j=(0,$.$Ai)("loggerService");function w(){return new Date().toISOString()}function R(D){return(0,a.$eg)(D)}var d;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(d||(t.LogLevel=d={})),t.$0j=d.Info;function g(D,C,M){switch(C){case d.Trace:D.trace(M);break;case d.Debug:D.debug(M);break;case d.Info:D.info(M);break;case d.Warning:D.warn(M);break;case d.Error:D.error(M);break;case d.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function m(D,C=!1){let M="";for(let J=0;J<D.length;J++){let ae=D[J];if(ae instanceof Error&&(ae=(0,O.$lj)(ae,C)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}M+=(J>0?" ":"")+ae}return M}class S extends L.$Uc{constructor(){super(...arguments),this.b=t.$0j,this.c=this.B(new v.$he),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==d.Off&&this.b<=C}}t.$_j=S;class y extends S{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...M){this.f(d.Trace)&&this.g(d.Trace,m([C,...M],!0))}debug(C,...M){this.f(d.Debug)&&this.g(d.Debug,m([C,...M]))}info(C,...M){this.f(d.Info)&&this.g(d.Info,m([C,...M]))}warn(C,...M){this.f(d.Warning)&&this.g(d.Warning,m([C,...M]))}error(C,...M){if(this.f(d.Error))if(C instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=C.stack,this.g(d.Error,m(J))}else this.g(d.Error,m([C,...M]))}flush(){}}t.$ak=y;class u extends S{constructor(C=t.$0j){super(),this.setLevel(C),this.g=!p.$i}trace(C,...M){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...M):console.log(`[main ${w()}]`,C,...M))}debug(C,...M){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...M):console.log(`[main ${w()}]`,C,...M))}info(C,...M){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...M):console.log(`[main ${w()}]`,C,...M))}warn(C,...M){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,C,...M):console.warn(`[main ${w()}]`,C,...M))}error(C,...M){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,C,...M):console.error(`[main ${w()}]`,C,...M))}flush(){}}t.$bk=u;class i extends S{constructor(C=t.$0j,M=!0){super(),this.g=M,this.setLevel(C)}trace(C,...M){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...M):console.log(C,...M))}debug(C,...M){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...M):console.log(C,...M))}info(C,...M){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...M):console.log(C,...M))}warn(C,...M){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...M):console.log(C,...M))}error(C,...M){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...M):console.error(C,...M))}flush(){}}t.$ck=i;class o extends S{constructor(C,M=t.$0j){super(),this.g=C,this.setLevel(M)}trace(C,...M){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(C),...M])}debug(C,...M){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(C),...M])}info(C,...M){this.f(d.Info)&&this.g.log(d.Info,[this.h(C),...M])}warn(C,...M){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(C),...M])}error(C,...M){this.f(d.Error)&&this.g.log(d.Error,[this.h(C),...M])}h(C){return typeof C=="string"?C:(0,O.$lj)(C,this.f(d.Trace))}flush(){}}t.$dk=o;class s extends S{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const M of this.g)M.setLevel(C);super.setLevel(C)}trace(C,...M){for(const J of this.g)J.trace(C,...M)}debug(C,...M){for(const J of this.g)J.debug(C,...M)}info(C,...M){for(const J of this.g)J.info(C,...M)}warn(C,...M){for(const J of this.g)J.warn(C,...M)}error(C,...M){for(const J of this.g)J.error(C,...M)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}t.$ek=s;class e extends L.$Uc{constructor(C,M,J){if(super(),this.h=C,this.j=M,this.b=new I.$Ac,this.c=this.B(new v.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$he),this.onDidChangeVisibility=this.g.event,J)for(const ae of J)this.b.set(ae.resource,{logger:void 0,info:ae})}m(C){return(0,a.$ag)(C)?[...this.b.values()].find(M=>M.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,M){const J=this.n(C),ae=(0,a.$ag)(C)?C:M?.id??(0,k.$oj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ce=M?.logLevel==="always"?d.Trace:M?.logLevel;ie||(ie=this.s(J,ce??this.getLogLevel(J)??this.h,{...M,id:ae}));const ue={logger:ie,info:{resource:J,id:ae,logLevel:ce,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ue.info),this.b.set(J,ue),ie}n(C){return(0,a.$ag)(C)?(0,l.$bh)(this.j,`${C}.log`):C}setLogLevel(C,M){if(c.URI.isUri(C)){const J=C,ae=M,ie=this.b.get(J);ie&&ae!==ie.info.logLevel&&(ie.info.logLevel=ae===this.h?void 0:ae,ie.logger?.setLevel(ae),this.b.set(ie.info.resource,ie),this.f.fire([J,ae]))}else{this.h=C;for(const[J,ae]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ae.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,M){const J=this.m(C);J&&M!==!J.info.hidden&&(J.info.hidden=!M,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,M]))}getLogLevel(C){let M;return C&&(M=this.b.get(C)?.info.logLevel),M??this.h}registerLogger(C){const M=this.b.get(C.resource);M?M.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const M=this.b.get(C);M&&(M.logger&&M.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}t.$fk=e;class n{constructor(){this.onDidChangeLogLevel=new v.$he().event}setLevel(C){}getLevel(){return d.Info}trace(C,...M){}debug(C,...M){}info(C,...M){}warn(C,...M){}error(C,...M){}critical(C,...M){}dispose(){}flush(){}}t.$gk=n;class r extends n{}t.$hk=r;function h(D){if(D.verbose)return d.Trace;if(typeof D.logLevel=="string"){const C=A(D.logLevel.toLowerCase());if(C!==void 0)return C}return t.$0j}function E(D){switch(D){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function N(D){switch(D){case d.Trace:return{original:"Trace",value:P.localize(0,null)};case d.Debug:return{original:"Debug",value:P.localize(1,null)};case d.Info:return{original:"Info",value:P.localize(2,null)};case d.Warning:return{original:"Warning",value:P.localize(3,null)};case d.Error:return{original:"Error",value:P.localize(4,null)};case d.Off:return{original:"Off",value:P.localize(5,null)}}}function A(D){switch(D){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}t.$mk=new f.$Rj("logLevel",E(d.Info))}),define(se[130],oe([0,1,20,8,9,5,64,2,16,52,6]),function(Q,t,P,O,v,k,L,I,p,l,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3q=void 0;class c extends I.$Uc{constructor($,w){super(),this.a=$,this.b=w,this.c=this.B(new k.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$yh(0)),this.w=[],this.y=this.B(new O.$yh(0))}watch($,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n($,w):this.z($,w)}n($,w){const R={path:this.J($),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},d=(0,P.$Tb)(this.j,R);return this.r(),(0,I.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,v.$1)($))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,l.$Wq)(w)),w=>this.G(w),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const w of this.j)(0,l.$Sq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const w of this.j)(0,l.$Sq)(w)&&$.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,w){const R={path:this.J($),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},d=(0,P.$Tb)(this.w,R);return this.C(),(0,I.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,v.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,l.$Wq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,p.$hc)($.fsPath)}J($){const w=this.I($);return(0,L.$Cg)(w)}}t.$3q=c});var ne=this&&this.__param||function(Q,t){return function(P,O){t(P,O,Q)}};define(se[131],oe([0,1,20,8,14,22,5,43,66,2,48,15,132,17,46,106,10,63,6,9]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S){"use strict";var y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=void 0;let u=class extends l.$Uc{static{y=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new L.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$he),this.Y=this.B(new L.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$Jh)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${o}`);const e=new l.$Tc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),e.add(s.onDidChangeFile(n=>{const r=new d.$nl(n,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&e.add(s.onDidWatchError(n=>this.Z.fire(new Error(n)))),e.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,l.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,l.$Pc)(e)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(e){s.push(e)}}),!this.h.has(o)&&await O.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const e=this.h.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return p.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,$.$fh)(o))throw new d.$pl((0,R.localize)(0,null,this.sb(o)),d.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const e=new S.$bb;throw e.message=(0,R.localize)(1,null,o.toString()),e}return s}async m(o){const s=await this.j(o);if((0,d.$al)(s)||(0,d.$0k)(s)||(0,d.$bl)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,d.$al)(s)||(0,d.$0k)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(e){throw(0,d.$kl)(e)===d.FileSystemProviderErrorCode.FileNotFound?new d.$pl((0,R.localize)(2,null,this.sb(o)),d.FileOperationResult.FILE_NOT_FOUND):(0,d.$il)(e)}}async s(o,s){const e=await this.j(o),n=this.S(e),r=s?.resolveTo,h=s?.resolveSingleChildDescendants,E=s?.resolveMetadata,N=await e.stat(o);let A;return this.t(e,o,N,void 0,!!E,(D,C)=>(A||(A=a.$Gi.forUris(()=>!n),A.set(o,!0),r&&A.fill(!0,r)),A.get(D.resource)||A.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&h?C===1:!1))}async t(o,s,e,n,r,h){const{providerExtUri:E}=this.R(o),N={resource:s,name:E.basename(s),isFile:(e.type&d.FileType.File)!==0,isDirectory:(e.type&d.FileType.Directory)!==0,isSymbolicLink:(e.type&d.FileType.SymbolicLink)!==0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:!!((e.permissions??0)&d.FilePermission.Readonly)||!!(o.capabilities&d.FileSystemProviderCapabilities.Readonly),locked:!!((e.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Al)({mtime:e.mtime,size:e.size}),children:void 0};if(N.isDirectory&&h(N,n)){try{const A=await o.readdir(s),D=await O.Promises.settled(A.map(async([C,M])=>{try{const J=E.joinPath(s,C),ae=r?await o.stat(J):{type:M};return await this.t(o,J,ae,A.length,r,h)}catch(J){return this.b.trace(J),null}}));N.children=(0,P.$Hb)(D)}catch(A){this.b.trace(A),N.children=[]}return N}return N}async resolveAll(o){return O.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(e){return this.b.trace(e),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),e=await s.stat(o);return this.t(s,o,e,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(e){return e}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new d.$pl((0,R.localize)(3,null,this.sb(o)),d.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(o,s=v.$Je.fromString(""),e){await this.u(o,e);const n=await this.writeFile(o,s);return this.r.fire(new d.$ml(o,d.FileOperation.CREATE,n)),n}async writeFile(o,s,e){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let h=e;if((0,d.$dl)(n)&&!h?.atomic){const E=n.enforceAtomicWriteFile?.(o);E&&(h={...e,atomic:E})}try{await this.w(n,o,h)||await this.U(n,r.dirname(o));let N;if((0,d.$0k)(n)&&!(s instanceof v.$Je))if((0,w.$ve)(s)){const A=await(0,w.$Ce)(s,3);A.ended?N=v.$Je.concat(A.buffer):N=A}else N=(0,w.$ze)(s,A=>v.$Je.concat(A),3);else N=s;!(0,d.$al)(n)||(0,d.$0k)(n)&&N instanceof v.$Je||(0,d.$0k)(n)&&(0,d.$dl)(n)&&h?.atomic?await this.hb(n,o,h,N):await this.db(n,o,h,N instanceof v.$Je?(0,v.$Ue)(N):N),this.r.fire(new d.$ml(o,d.FileOperation.WRITE))}catch(E){throw new d.$pl((0,R.localize)(4,null,this.sb(o),(0,d.$il)(E).toString()),(0,d.$ll)(E),h)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,e){const n=!!e?.unlock;if(n&&!(o.capabilities&d.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,R.localize)(5,null,this.sb(s)));if(!!e?.atomic){if(!(o.capabilities&d.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,R.localize)(6,null,this.sb(s)));if(!(o.capabilities&d.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,R.localize)(7,null,this.sb(s)));if(n)throw new Error((0,R.localize)(8,null,this.sb(s)))}let h;try{h=await o.stat(s)}catch{return}if(h.type&d.FileType.Directory)throw new d.$pl((0,R.localize)(9,null,this.sb(s)),d.FileOperationResult.FILE_IS_DIRECTORY,e);if(this.rb(s,h),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==d.$zl&&typeof h.mtime=="number"&&typeof h.size=="number"&&e.mtime<h.mtime&&e.etag!==(0,d.$Al)({mtime:e.mtime,size:h.size}))throw new d.$pl((0,R.localize)(10,null),d.FileOperationResult.FILE_MODIFIED_SINCE,e);return h}async readFile(o,s,e){const n=await this.m(o);return s?.atomic?this.z(n,o,s,e):this.C(n,o,s,e)}async z(o,s,e,n){return new Promise((r,h)=>{this.cb.queueFor(s,async()=>{try{const E=await this.C(o,s,e,n);r(E)}catch(E){h(E)}},this.R(o).providerExtUri)})}async C(o,s,e,n){const r=await this.D(o,s,{...e,preferUnbuffered:!0},n);return{...r,value:await(0,v.$Ve)(r.value)}}async readFileStream(o,s,e){const n=await this.m(o);return this.D(n,o,s,e)}async D(o,s,e,n){const r=new k.$se(n);let h=e;(0,d.$cl)(o)&&o.enforceAtomicReadFile?.(s)&&(h={...e,atomic:!0});const E=this.J(s,h).then(A=>A,A=>{throw r.dispose(!0),A});let N;try{return typeof h?.etag=="string"&&h.etag!==d.$zl&&await E,h?.atomic&&(0,d.$cl)(o)||!((0,d.$al)(o)||(0,d.$bl)(o))||(0,d.$0k)(o)&&h?.preferUnbuffered?N=this.I(o,s,h):(0,d.$bl)(o)?N=this.G(o,s,r.token,h):N=this.H(o,s,r.token,h),N.on("end",()=>r.dispose()),N.on("error",()=>r.dispose()),{...await E,value:N}}catch(A){throw N&&await(0,w.$Ae)(N),this.F(A,s,h)}}F(o,s,e){const n=(0,R.localize)(11,null,this.sb(s),(0,d.$il)(o).toString());return o instanceof d.$rl?new d.$rl(n,o.stat,e):o instanceof d.$ql?new d.$ql(n,o.fileOperationResult,o.size,o.options):new d.$pl(n,(0,d.$ll)(o),e)}G(o,s,e,n=Object.create(null)){const r=o.readFileStream(s,n,e);return(0,w.$Ge)(r,{data:h=>h instanceof v.$Je?h:v.$Je.wrap(h),error:h=>this.F(h,s,n)},h=>v.$Je.concat(h))}H(o,s,e,n=Object.create(null)){const r=(0,v.$Ze)();return(0,g.$Pq)(o,s,r,h=>h,{...n,bufferSize:this.a,errorTransformer:h=>this.F(h,s,n)},e),r}I(o,s,e){const n=(0,w.$xe)(r=>v.$Je.concat(r));return(async()=>{try{let r;e?.atomic&&(0,d.$cl)(o)?r=await o.readFile(s,{atomic:!0}):r=await o.readFile(s),typeof e?.position=="number"&&(r=r.slice(e.position)),typeof e?.length=="number"&&(r=r.slice(0,e.length)),this.L(s,r.byteLength,e),n.end(v.$Je.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new d.$pl((0,R.localize)(12,null,this.sb(o)),d.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==d.$zl&&s.etag===e.etag)throw new d.$rl((0,R.localize)(13,null),e,s);return this.L(o,e.size,s),e}L(o,s,e){if(typeof e?.limits?.size=="number"&&s>e.limits.size)throw new d.$ql((0,R.localize)(14,null,this.sb(o)),d.FileOperationResult.FILE_TOO_LARGE,s,e)}async canMove(o,s,e){return this.M(o,s,"move",e)}async canCopy(o,s,e){return this.M(o,s,"copy",e)}async M(o,s,e,n){if(o.toString()!==s.toString())try{const r=e==="move"?this.qb(await this.n(o),o):await this.m(o),h=this.qb(await this.n(s),s);await this.Q(r,o,h,s,e,n)}catch(r){return r}return!0}async move(o,s,e){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(s),s),h=await this.N(n,o,r,s,"move",!!e),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new d.$ml(o,h==="move"?d.FileOperation.MOVE:d.FileOperation.COPY,E)),E}async copy(o,s,e){const n=await this.m(o),r=this.qb(await this.n(s),s),h=await this.N(n,o,r,s,"copy",!!e),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new d.$ml(o,h==="copy"?d.FileOperation.COPY:d.FileOperation.MOVE,E)),E}async N(o,s,e,n,r,h){if(s.toString()===n.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:N}=await this.Q(o,s,e,n,r,h);if(E&&!N&&h&&await this.del(n,{recursive:!0}),await this.U(e,this.R(e).providerExtUri.dirname(n)),r==="copy"){if(o===e&&(0,d.$$k)(o))await o.copy(s,n,{overwrite:h});else{const A=await this.resolve(s);A.isDirectory?await this.P(o,A,e,n):await this.O(o,s,e,n)}return r}else return o===e?(await o.rename(s,n,{overwrite:h}),r):(await this.N(o,s,e,n,"copy",h),await this.del(s,{recursive:!0}),"copy")}async O(o,s,e,n){if((0,d.$al)(o)&&(0,d.$al)(e))return this.jb(o,s,e,n);if((0,d.$al)(o)&&(0,d.$0k)(e))return this.pb(o,s,e,n);if((0,d.$0k)(o)&&(0,d.$al)(e))return this.nb(o,s,e,n);if((0,d.$0k)(o)&&(0,d.$0k)(e))return this.lb(o,s,e,n)}async P(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await O.Promises.settled(s.children.map(async r=>{const h=this.R(e).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),e,h):this.O(o,r.resource,e,h)}))}async Q(o,s,e,n,r,h){let E=!1;if(o===e){const{providerExtUri:A,isPathCaseSensitive:D}=this.R(o);if(D||(E=A.isEqual(s,n)),E&&r==="copy")throw new Error((0,R.localize)(15,null,this.sb(s),this.sb(n)));if(!E&&A.isEqualOrParent(n,s))throw new Error((0,R.localize)(16,null,this.sb(s),this.sb(n)))}const N=await this.exists(n);if(N&&!E){if(!h)throw new d.$pl((0,R.localize)(17,null,this.sb(s),this.sb(n)),d.FileOperationResult.FILE_MOVE_CONFLICT);if(o===e){const{providerExtUri:A}=this.R(o);if(A.isEqualOrParent(s,n))throw new Error((0,R.localize)(18,null,this.sb(s),this.sb(n)))}}return{exists:N,isSameResourceWithDifferentPathCase:E}}R(o){const s=this.S(o);return{providerExtUri:s?$.$4g:$.$6g,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$ml(o,d.FileOperation.CREATE,e)),e}async U(o,s){const e=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&d.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(s)));break}catch(r){if((0,d.$kl)(r)!==d.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(n.basename(s)),s=n.dirname(s)}for(let r=e.length-1;r>=0;r--){s=n.joinPath(s,e[r]);try{await o.mkdir(s)}catch(h){if((0,d.$kl)(h)!==d.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(o,s){try{await this.W(o,s)}catch(e){return e}return!0}async W(o,s){const e=this.qb(await this.j(o),o),n=!!s?.useTrash;if(n&&!(e.capabilities&d.FileSystemProviderCapabilities.Trash))throw new Error((0,R.localize)(20,null,this.sb(o)));const r=s?.atomic;if(r&&!(e.capabilities&d.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,R.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,R.localize)(22,null,this.sb(o)));let h;try{h=await e.stat(o)}catch{}if(h)this.rb(o,h);else throw new d.$pl((0,R.localize)(23,null,this.sb(o)),d.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const N=await this.resolve(o);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(o)))}return e}async del(o,s){const e=await this.W(o,s);let n=s;if((0,d.$el)(e)&&!n?.atomic){const N=e.enforceAtomicDelete?.(o);N&&(n={...s,atomic:N})}const r=!!n?.useTrash,h=!!n?.recursive,E=n?.atomic??!1;await e.delete(o,{recursive:h,useTrash:r,atomic:E}),this.r.fire(new d.$ml(o,d.FileOperation.DELETE))}async cloneFile(o,s){const e=await this.j(o),n=this.qb(await this.n(s),s);if(!(e===n&&this.R(e).providerExtUri.isEqual(o,s)))return e===n&&(0,d.$_k)(e)?e.cloneFile(o,s):(await this.U(n,this.R(n).providerExtUri.dirname(s)),e===n&&(0,d.$$k)(e)?this.cb.queueFor(o,()=>e.copy(o,s,{overwrite:!0}),this.R(e).providerExtUri):this.cb.queueFor(o,()=>this.O(e,o,n,s),this.R(e).providerExtUri))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:y.ab++})}watch(o,s={recursive:!1,excludes:[]}){const e=new l.$Tc;let n=!1,r=()=>{n=!0};e.add((0,l.$Sc)(()=>r())),(async()=>{try{const E=await this.bb(o,s);n?(0,l.$Pc)(E):r=()=>(0,l.$Pc)(E)}catch(E){this.b.error(E)}})();const h=s.correlationId;if(typeof h=="number"){const E=e.add(new L.$he);return e.add(this.X.event(A=>{A.correlates(h)&&E.fire(A)})),{onDidChange:E.event,dispose:()=>e.dispose()}}return e}async bb(o,s){const e=await this.j(o),n=(0,I.$oj)([this.R(e).providerExtUri.getComparisonKey(o),s]);let r=this.$.get(n);return r||(r={count:0,disposable:e.watch(o,s)},this.$.set(n,r)),r.count+=1,(0,l.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,l.$Pc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Pc)(o.disposable);this.$.clear()}async db(o,s,e,n){return this.cb.queueFor(s,async()=>{const r=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,w.$ve)(n)||(0,w.$we)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(h){throw(0,d.$il)(h)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,s,e){let n=0,r;if((0,w.$we)(e)){if(e.buffer.length>0){const h=v.$Je.concat(e.buffer);await this.gb(o,s,h,h.byteLength,n,0),n+=h.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise((h,E)=>{(0,w.$Be)(r,{onData:async N=>{r.pause();try{await this.gb(o,s,N,N.byteLength,n,0)}catch(A){return E(A)}n+=N.byteLength,setTimeout(()=>r.resume())},onError:N=>E(N),onEnd:()=>h()})})}async fb(o,s,e){let n=0,r;for(;(r=e.read())!==null;)await this.gb(o,s,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,s,e,n,r,h){let E=0;for(;E<n;){const N=await o.write(s,r+E,e.buffer,h+E,n-E);E+=N}}async hb(o,s,e,n){return this.cb.queueFor(s,()=>this.ib(o,s,e,n),this.R(o).providerExtUri)}async ib(o,s,e,n){let r;n instanceof v.$Je?r=n:(0,w.$ve)(n)?r=await(0,v.$Ve)(n):(0,w.$we)(n)?r=await(0,v.$We)(n):r=(0,v.$Te)(n),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1,atomic:e?.atomic??!1})}async jb(o,s,e,n){return this.cb.queueFor(n,()=>this.kb(o,s,e,n),this.R(e).providerExtUri)}async kb(o,s,e,n){let r,h;try{r=await o.open(s,{create:!1}),h=await e.open(n,{create:!0,unlock:!1});const E=v.$Je.alloc(this.a);let N=0,A=0,D=0;do D=await o.read(r,N,E.buffer,A,E.byteLength-A),await this.gb(e,h,E,D,N,A),N+=D,A+=D,A===E.byteLength&&(A=0);while(D>0)}catch(E){throw(0,d.$il)(E)}finally{await O.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof h=="number"?e.close(h):Promise.resolve()])}}async lb(o,s,e,n){return this.cb.queueFor(n,()=>this.mb(o,s,e,n),this.R(e).providerExtUri)}async mb(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,e,n){return this.cb.queueFor(n,()=>this.ob(o,s,e,n),this.R(e).providerExtUri)}async ob(o,s,e,n){const r=await e.open(n,{create:!0,unlock:!1});try{const h=await o.readFile(s);await this.gb(e,r,v.$Je.wrap(h),h.byteLength,0,0)}catch(h){throw(0,d.$il)(h)}finally{await e.close(r)}}async pb(o,s,e,n){const r=await(0,v.$Ve)(this.H(o,s,k.CancellationToken.None));await this.hb(e,n,void 0,r)}qb(o,s){if(o.capabilities&d.FileSystemProviderCapabilities.Readonly)throw new d.$pl((0,R.localize)(25,null,this.sb(s)),d.FileOperationResult.FILE_PERMISSION_DENIED);return o}rb(o,s){if((s.permissions??0)&d.FilePermission.Readonly)throw new d.$pl((0,R.localize)(26,null,this.sb(o)),d.FileOperationResult.FILE_PERMISSION_DENIED)}sb(o){return o.scheme===c.Schemas.file?o.fsPath:o.toString(!0)}};t.$Qq=u,t.$Qq=u=y=we([ne(0,m.$7j)],u)}),define(se[133],oe([0,1,61,176,8,31,14,5,64,2,16,13,17,46,25,108,10,63,130,36,128,127]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hr=void 0,(()=>{try{(0,O.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,S.$lj)(o)}`)}})();class i extends m.$3q{static{this.L=!1}constructor(s,e){super(s,e),this.onDidChangeCapabilities=I.Event.None,this.P=new k.$Ac(n=>f.$5g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:e,symbolicLink:n}=await w.SymlinkSupport.stat(this.I(s));return{type:this.O(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size,permissions:e.mode&128?void 0:d.FilePermission.Locked}}catch(e){throw this.hb(e)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const e=await w.Promises.readdir(this.I(s),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async r=>{try{let h;r.isSymbolicLink()?h=(await this.stat((0,f.$bh)(s,r.name))).type:h=this.O(r),n.push([r.name,h])}catch(h){this.a.trace(h)}})),n}catch(e){throw this.hb(e)}}O(s,e){let n;return e?.dangling?n=d.FileType.Unknown:s.isFile()?n=d.FileType.File:s.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,e&&(n|=d.FileType.SymbolicLink),n}async Q(s){const e=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${e})`);let n;for(;n=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${e})`),await n.wait();const r=new v.$zh;return this.P.set(s,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${e})`),(0,l.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${e})`),this.P.get(s)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${e})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${e})`),r.open()})}async readFile(s,e){let n;try{e?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),n=await this.Q(s));const r=this.I(s);return await w.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(s){i.L&&this.a.trace(s)}readFileStream(s,e,n){const r=(0,$.$xe)(h=>L.$Je.concat(h.map(E=>L.$Je.wrap(E))).buffer);return(0,g.$Pq)(this,s,r,h=>h.buffer,{...e,bufferSize:256*1024},n),r}async writeFile(s,e,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(s)?this.U(s,(0,f.$bh)((0,f.$ah)(s),`${(0,f.$$g)(s)}${n.atomic.postfix}`),e,n):this.W(s,e,n)}async S(s){try{const e=this.I(s),{symbolicLink:n}=await w.SymlinkSupport.stat(e);if(n)return!1}catch{}return!0}async U(s,e,n,r){const h=new l.$Tc;try{h.add(await this.Q(s)),h.add(await this.Q(e)),await this.W(e,n,r,!0);try{await this.rename(e,s,{overwrite:!0})}catch(E){try{await this.delete(e,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{h.dispose()}}async W(s,e,n,r){let h;try{const E=this.I(s);if(!n.create||!n.overwrite){if(await w.Promises.exists(E)){if(!n.overwrite)throw(0,d.$hl)((0,R.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$hl)((0,R.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(s,{create:!0,unlock:n.unlock},r),await this.write(h,0,e,0,e.byteLength)}catch(E){throw await this.ib(s,E)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(s){i.$=s}async open(s,e,n){const r=this.I(s);let h;(0,d.$8k)(e)&&!n&&(h=await this.Q(s));let E;try{if((0,d.$8k)(e)&&e.unlock)try{const{stat:A}=await w.SymlinkSupport.stat(r);A.mode&128||await w.Promises.chmod(r,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let N;if((0,d.$8k)(e)){if(c.$i)try{await w.Promises.truncate(r,0),N="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}N||(N="w")}else N="r";E=await w.Promises.open(r,N)}catch(N){throw h?.dispose(),(0,d.$8k)(e)?await this.ib(s,N):this.hb(N)}if(this.X.set(E,0),(0,d.$8k)(e)&&this.Z.set(E,s),h){const N=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.Y.set(E,h),N&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),N.dispose())}return E}async close(s){const e=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&i.$)try{await w.Promises.fdatasync(s)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await w.Promises.close(s)}catch(n){throw this.hb(n)}finally{e&&(this.Y.get(s)===e&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),e.dispose())}}async read(s,e,n,r,h){const E=this.ab(s,e);let N=null;try{N=(await w.Promises.read(s,n,r,h,E)).bytesRead}catch(A){throw this.hb(A)}finally{this.bb(s,E,N)}return N}ab(s,e){return e===this.X.get(s)?null:e}bb(s,e,n){const r=this.X.get(s);typeof r=="number"&&(typeof e=="number"||(typeof n=="number"?this.X.set(s,r+n):this.X.delete(s)))}async write(s,e,n,r,h){return(0,v.$Uh)(()=>this.cb(s,e,n,r,h),100,3)}async cb(s,e,n,r,h){const E=this.ab(s,e);let N=null;try{N=(await w.Promises.write(s,n,r,h,E)).bytesWritten}catch(A){throw await this.ib(this.Z.get(s),A)}finally{this.bb(s,E,N)}return N}async mkdir(s){try{await w.Promises.mkdir(this.I(s))}catch(e){throw this.hb(e)}}async delete(s,e){try{const n=this.I(s);if(e.recursive){let r;e?.atomic!==!1&&e.atomic.postfix&&(r=(0,a.$jc)((0,a.$mc)(n),`${(0,a.$nc)(n)}${e.atomic.postfix}`)),await w.Promises.rm(n,w.RimRafMode.MOVE,r)}else try{await w.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let h=!1;try{const{stat:E,symbolicLink:N}=await w.SymlinkSupport.stat(n);h=E.isDirectory()&&!N}catch{}if(h)await w.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(s,e,n){const r=this.I(s),h=this.I(e);if(r!==h)try{await this.db(s,e,"move",n.overwrite),await w.Promises.rename(r,h)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,R.localize)(2,null,(0,a.$nc)(r),(0,a.$nc)((0,a.$mc)(h)),E.toString()))),this.hb(E)}}async copy(s,e,n){const r=this.I(s),h=this.I(e);if(r!==h)try{await this.db(s,e,"copy",n.overwrite),await w.Promises.copy(r,h,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,R.localize)(3,null,(0,a.$nc)(r),(0,a.$nc)((0,a.$mc)(h)),E.toString()))),this.hb(E)}}async db(s,e,n,r){const h=this.I(s),E=this.I(e);let N=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(N=(0,p.$yg)(h,E,!0)),N){if(n==="copy")throw(0,d.$hl)((0,R.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.N(s);if(!D)throw(0,d.$hl)((0,R.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(e);if(C){if(!r)throw(0,d.$hl)((0,R.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);D.type&d.FileType.File&&C.type&d.FileType.File||await this.delete(e,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,e){return this.eb(s,e,!1)}async eb(s,e,n){const r=this.I(s),h=this.I(e),E=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,p.$yg)(r,h,!E))return;const N=new l.$Tc;try{N.add(await this.Q(s)),N.add(await this.Q(e)),n&&await w.Promises.mkdir((0,a.$mc)(h),{recursive:!0}),await w.Promises.copyFile(r,h)}catch(A){if(A.code==="ENOENT"&&!n)return this.eb(s,e,!0);throw this.hb(A)}finally{N.dispose()}}t(s,e,n){return new y.$0q(r=>s(r),r=>e(r),n)}F(s,e,n){return new u.$gr(r=>s(r),r=>e(r),n)}hb(s){if(s instanceof d.$gl)return s;let e=s,n;switch(s.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":e=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$hl)(e,n)}async ib(s,e){let n=this.hb(e);if(s&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await w.SymlinkSupport.stat(this.I(s));r.mode&128||(n=(0,d.$hl)(e,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}t.$hr=i}),define(se[134],oe([0,1,2,6]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lQ=void 0;class v extends P.$Uc{constructor(L,I=[]){super(),this.a=new O.$ek([L,...I]),this.B(L.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...I){this.a.trace(L,...I)}debug(L,...I){this.a.debug(L,...I)}info(L,...I){this.a.info(L,...I)}warn(L,...I){this.a.warn(L,...I)}error(L,...I){this.a.error(L,...I)}flush(){this.a.flush()}}t.$lQ=v}),define(se[135],oe([0,1,10,6]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=void 0;var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v||(v={}));async function k(l,a,c,f,$){try{const w=await new Promise((d,g)=>{Q(["@vscode/spdlog"],d,g)});w.setFlushOn(v.Trace);const R=await w.createAsyncRotatingLogger(l,a,c,f);return $?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(w){console.error(w)}return null}function L(l,a,c){switch(a){case O.LogLevel.Trace:l.trace(c);break;case O.LogLevel.Debug:l.debug(c);break;case O.LogLevel.Info:l.info(c);break;case O.LogLevel.Warning:l.warn(c);break;case O.LogLevel.Error:l.error(c);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${a}`)}}function I(l,a){switch(a){case O.LogLevel.Trace:l.setLevel(v.Trace);break;case O.LogLevel.Debug:l.setLevel(v.Debug);break;case O.LogLevel.Info:l.setLevel(v.Info);break;case O.LogLevel.Warning:l.setLevel(v.Warning);break;case O.LogLevel.Error:l.setLevel(v.Error);break;case O.LogLevel.Off:l.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${a}`)}}class p extends O.$ak{constructor(a,c,f,$,w){super(),this.m=[],this.setLevel(w),this.n=this.s(a,c,f,$),this.B(this.onDidChangeLogLevel(R=>{this.r&&I(this.r,R)}))}async s(a,c,f,$){const w=f?6:1,R=30/w*P.$Cl.MB,d=await k(a,c,R,w,$);if(d){this.r=d,I(this.r,this.getLevel());for(const{level:g,message:m}of this.m)L(this.r,g,m);this.m=[]}}g(a,c){this.r?L(this.r,a,c):this.getLevel()<=a&&this.m.push({level:a,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$aQ=p}),define(se[136],oe([0,1,29,6,135]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bQ=void 0;class k extends O.$fk{s(I,p,l){return new v.$aQ((0,P.$Wg)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,p)}}t.$bQ=k}),define(se[39],oe([0,1,5,66,2,11]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$no=t.$mo=t.$lo=void 0,t.$lo=(0,k.$Ai)("policy");class L extends v.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const a=Object.keys(this.f).length;return this.f={...l,...this.f},a!==Object.keys(this.f).length&&await this.j(l),O.Iterable.reduce(this.g.entries(),(c,[f,$])=>({...c,[f]:$}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(l,[a,c])=>({...l,[a]:{definition:c,value:this.g.get(a)}}),{})}}t.$mo=L;class I{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$no=I}),define(se[137],oe([0,1,8,5,66,3,10,6,39]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$ec=void 0;function l(c,f){const $=[];for(const w of new Set(v.Iterable.concat(c.keys(),f.keys())))c.get(w)!==f.get(w)&&$.push(w);return $}let a=class extends p.$mo{constructor(f,$,w){super(),this.m=f,this.n=$,this.s=w,this.c=this.B(new P.$yh(500));const R=O.Event.filter($.onDidFilesChange,d=>d.affects(f));this.B($.watch(f)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const f=new Map;try{const $=await this.n.readFile(this.m),w=JSON.parse($.value.toString());if(!(0,k.$cg)(w))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(w))this.f[R]&&f.set(R,w[R])}catch($){$.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",$)}return f}async w(){const f=await this.u(),$=l(this.g,f);this.g=f,$.length>0&&this.h.fire($)}};t.$$ec=a,t.$$ec=a=we([ne(1,L.$7k),ne(2,I.$7j)],a)}),define(se[138],oe([0,1,39,8,2,6]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0ec=void 0;let L=class extends P.$mo{constructor(p,l){super(),this.m=p,this.n=l,this.a=new O.$uh,this.b=this.B(new v.$Vc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:l}=await new Promise((a,c)=>{Q(["@vscode/policy-watcher"],a,c)});await this.a.queue(()=>new Promise((a,c)=>{try{this.b.value=l(this.n,p,f=>{this.t(f),a()})}catch(f){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",f),c(f)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const l in p){const a=p[l];a===void 0?this.g.delete(l):this.g.set(l,a)}this.h.fire(Object.keys(p))}};t.$0ec=L,t.$0ec=L=we([ne(0,k.$7j)],L)}),define(se[33],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ok=t.$nk=void 0,t.$nk=(0,P.$Ai)("productService"),t.$ok="vscode://schemas/vscode-product"}),define(se[38],oe([0,1,76,3]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jo=void 0;class v{constructor(){this.a=new Map}add(L,I){P.ok(O.$ag(L)),P.ok(O.$cg(I)),P.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,I)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}t.$jo=new v}),define(se[139],oe([0,1,5,38]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ko=void 0,t.$ko={JSONContribution:"base.contributions.json"};function v(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this.b=new P.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,l){this.a[v(p)]=l,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const L=new k;O.$jo.add(t.$ko.JSONContribution,L)}),define(se[40],oe([0,1,20,5,3,95,30,139,38]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yo=t.$xo=t.$wo=t.$vo=t.$uo=t.$to=t.$so=t.$ro=t.$qo=t.$po=t.ConfigurationScope=t.$oo=t.EditPresentationTypes=void 0,t.$zo=R,t.$Ao=d,t.$Bo=g,t.$Co=S,t.$Do=y;var l;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(l||(t.EditPresentationTypes=l={})),t.$oo={Configuration:"base.contributions.configuration"};var a;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(a||(t.ConfigurationScope=a={})),t.$po={properties:{},patternProperties:{}},t.$qo={properties:{},patternProperties:{}},t.$ro={properties:{},patternProperties:{}},t.$so={properties:{},patternProperties:{}},t.$to={properties:{},patternProperties:{}},t.$uo={properties:{},patternProperties:{}},t.$vo="vscode://schemas/settings/resourceLanguage",t.$wo="vscode://schemas/settings/configurationDefaults";const c=p.$jo.as(I.$ko.JSONContribution);class f{constructor(){this.h=new Set,this.i=new O.$he,this.onDidSchemaChange=this.i.event,this.j=new O.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},c.registerSchema(t.$vo,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:e,source:n}of i)for(const r in e)if(o.add(r),t.$yo.test(r)){const h=this.a.get(r),E=h?.valuesSources??new Map;if(n)for(const C of Object.keys(e[r]))E.set(C,n);const N={...h?.value||{},...e[r]};this.a.set(r,{source:n,value:N,valuesSources:E});const A=(0,L.$ej)(r),D={type:"object",default:N,description:k.localize(1,null,A),$ref:t.$vo,defaultDefaultValue:N,source:v.$ag(n)?void 0:n,defaultValueSource:n};s.push(...R(r)),this.d[r]=D,this.b.properties[r]=D}else{this.a.set(r,{value:e[r],source:n});const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:e}of i)for(const n in s){const r=this.a.get(n),h=v.$ag(e)?e:e?.id,E=v.$ag(r?.source)?r?.source:r?.source?.id;if(h===E)if(o.add(n),this.a.delete(n),t.$yo.test(n))delete this.d[n],delete this.b.properties[n];else{const N=this.d[n];N&&(this.w(n,N),this.r(n,N))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(e=>{this.p(e,o,e.extensionInfo,e.restrictedProperties,void 0,s),this.c.push(e),this.q(e)})}o(i,o){const s=e=>{if(e.properties)for(const n in e.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,e.properties[n])}e.allOf?.forEach(n=>s(n))};for(const e of i){s(e);const n=this.c.indexOf(e);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,s,e,n=a.WINDOW,r){n=v.$jg(i.scope)?n:i.scope;const h=i.properties;if(h)for(const N in h){const A=h[N];if(o&&S(N,A)){delete h[N];continue}if(A.source=s,A.defaultDefaultValue=h[N].default,this.w(N,A),t.$yo.test(N)?A.scope=void 0:(A.scope=v.$jg(A.scope)?n:A.scope,A.restricted=v.$jg(A.restricted)?!!e?.includes(N):A.restricted),h[N].hasOwnProperty("included")&&!h[N].included){this.f[N]=h[N],delete h[N];continue}else this.d[N]=h[N],h[N].policy?.name&&this.e.set(h[N].policy.name,N);!h[N].deprecationMessage&&h[N].markdownDeprecationMessage&&(h[N].deprecationMessage=h[N].markdownDeprecationMessage),r.add(N)}const E=i.allOf;if(E)for(const N of E)this.p(N,o,s,e,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const e=s.properties;if(e)for(const r in e)this.r(r,e[r]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(t.$po.properties[i]=o,o.scope){case a.APPLICATION:t.$qo.properties[i]=o;break;case a.MACHINE:t.$ro.properties[i]=o;break;case a.MACHINE_OVERRIDABLE:t.$so.properties[i]=o;break;case a.WINDOW:t.$to.properties[i]=o;break;case a.RESOURCE:t.$uo.properties[i]=o;break;case a.LANGUAGE_OVERRIDABLE:t.$uo.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete t.$po.properties[i],o.scope){case a.APPLICATION:delete t.$qo.properties[i];break;case a.MACHINE:delete t.$ro.properties[i];break;case a.MACHINE_OVERRIDABLE:delete t.$so.properties[i];break;case a.WINDOW:delete t.$to.properties[i];break;case a.RESOURCE:case a.LANGUAGE_OVERRIDABLE:delete t.$uo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:t.$vo};this.w(o,s),t.$po.properties[o]=s,t.$qo.properties[o]=s,t.$ro.properties[o]=s,t.$so.properties[o]=s,t.$to.properties[o]=s,t.$uo.properties[o]=s}}v(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:t.$vo};t.$po.patternProperties[t.$xo]=i,t.$qo.patternProperties[t.$xo]=i,t.$ro.patternProperties[t.$xo]=i,t.$so.patternProperties[t.$xo]=i,t.$to.patternProperties[t.$xo]=i,t.$uo.patternProperties[t.$xo]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let e=s?.value,n=s?.source;v.$hg(e)&&(e=o.defaultDefaultValue,n=void 0),v.$hg(e)&&(e=g(o.type)),o.default=e,o.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",w=new RegExp($,"g");t.$xo=`^(${$})+$`,t.$yo=new RegExp(t.$xo);function R(u){const i=[];if(t.$yo.test(u)){let o=w.exec(u);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=w.exec(u)}}return(0,P.$Mb)(i)}function d(u){return u.reduce((i,o)=>`${i}[${o}]`,"")}function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new f;p.$jo.add(t.$oo.Configuration,m);function S(u,i){return u.trim()?t.$yo.test(u)?k.localize(7,null,u):m.getConfigurationProperties()[u]!==void 0?k.localize(8,null,u):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,u,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}function y(){const u=[],i=m.getConfigurationProperties();for(const o of Object.keys(i))u.push([o,i[o].scope]);return u.push(["launch",a.RESOURCE]),u.push(["task",a.RESOURCE]),u}}),define(se[67],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,38]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jo=t.$Ho=t.$Go=t.$Fo=t.$Eo=void 0,t.$Io=y;function w(s){return Object.isFrozen(s)?s:I.$0n(s)}class R{static createEmptyModel(e){return new R({},[],[],void 0,e)}constructor(e,n,r,h,E){this.b=e,this.c=n,this.d=r,this.raw=h,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const e=this.raw.map(n=>{if(n instanceof R)return n;const r=new d("",this.f);return r.parseRaw(n),r.configurationModel});this.g=e.reduce((n,r)=>r===n?r:n.merge(r),e[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(e){return e?(0,a.$cj)(this.contents,e):this.contents}inspect(e,n){const r=this;return{get value(){return w(r.rawConfiguration.getValue(e))},get override(){return n?w(r.rawConfiguration.getOverrideValue(e,n)):void 0},get merged(){return w(n?r.rawConfiguration.override(n).getValue(e):r.rawConfiguration.getValue(e))},get overrides(){const h=[];for(const{contents:E,identifiers:N,keys:A}of r.rawConfiguration.overrides){const D=new R(E,A,[],void 0,r.f).getValue(e);D!==void 0&&h.push({identifiers:N,value:D})}return h.length?w(h):void 0}}}getOverrideValue(e,n){const r=this.j(n);return r?e?(0,a.$cj)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const r of this.overrides)r.identifiers.includes(e)&&n.push(...r.keys);return P.$Mb(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return P.$Mb(e)}override(e){let n=this.a.get(e);return n||(n=this.h(e),this.a.set(e,n)),n}merge(...e){const n=I.$9n(this.contents),r=I.$9n(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const N of e)if(E.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(n,N.contents);for(const A of N.overrides){const[D]=r.filter(C=>P.$ub(C.identifiers,A.identifiers));D?(this.i(D.contents,A.contents),D.keys.push(...A.keys),D.keys=P.$Mb(D.keys)):r.push(I.$9n(A))}for(const A of N.keys)h.indexOf(A)===-1&&h.push(A)}return new R(n,h,r,E.every(N=>N instanceof R)?void 0:E,this.f)}h(e){const n=this.j(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const h of P.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let E=this.contents[h];const N=n[h];N&&(typeof E=="object"&&typeof N=="object"?(E=I.$9n(E),this.i(E,N)):E=N),r[h]=E}return new R(r,this.keys,this.overrides,void 0,this.f)}i(e,n){for(const r of Object.keys(n)){if(r in e&&p.$cg(e[r])&&p.$cg(n[r])){this.i(e[r],n[r]);continue}e[r]=I.$9n(n[r])}}j(e){let n=null,r=null;const h=E=>{E&&(r?this.i(r,E):r=I.$9n(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===e?n=E.contents:E.identifiers.includes(e)&&h(E.contents);return h(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(e,n){this.k(e,n,!0)}setValue(e,n){this.k(e,n,!1)}removeValue(e){const n=this.keys.indexOf(e);n!==-1&&(this.keys.splice(n,1),(0,a.$bj)(this.contents,e),c.$yo.test(e)&&this.overrides.splice(this.overrides.findIndex(r=>P.$ub(r.identifiers,(0,c.$zo)(e))),1))}k(e,n,r){(0,a.$aj)(this.contents,e,n,h=>this.f.error(h)),r=r||this.keys.indexOf(e)===-1,r&&this.keys.push(e),c.$yo.test(e)&&this.overrides.push({identifiers:(0,c.$zo)(e),keys:Object.keys(this.contents[e]),contents:(0,a.$_i)(this.contents[e],h=>this.f.error(h))})}}t.$Eo=R;class d{constructor(e,n){this.f=e,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||R.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(e,n){if(!p.$jg(e)){const r=this.h(e);this.parseRaw(r,n)}}reparse(e){this.a&&this.parseRaw(this.a,e)}parseRaw(e,n){this.a=e;const{contents:r,keys:h,overrides:E,restricted:N,hasExcludedProperties:A}=this.i(e,n);this.b=new R(r,h,E,A?[e]:void 0,this.g),this.c=N||[]}h(e){let n={},r=null,h=[];const E=[],N=[];function A(C){Array.isArray(h)?h.push(C):r!==null&&(h[r]=C)}const D={onObjectBegin:()=>{const C={};A(C),E.push(h),h=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const C=[];A(C),E.push(h),h=C,r=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:A,onError:(C,M,J)=>{N.push({error:C,offset:M,length:J})}};if(e)try{v.$Wn(e,D),n=h[0]||{}}catch(C){this.g.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return n}i(e,n){const r=$.$jo.as(c.$oo.Configuration).getConfigurationProperties(),h=this.j(e,r,!0,n);e=h.raw;const E=(0,a.$_i)(e,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),N=Object.keys(e),A=this.l(e,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:E,keys:N,overrides:A,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}j(e,n,r,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:e,restricted:[],hasExcludedProperties:E};const N={},A=[];for(const D in e)if(c.$yo.test(D)&&r){const C=this.j(e[D],n,!1,h);N[D]=C.raw,E=E||C.hasExcludedProperties,A.push(...C.restricted)}else{const C=n[D],M=C?typeof C.scope<"u"?C.scope:c.ConfigurationScope.WINDOW:void 0;C?.restricted&&A.push(D),!h.exclude?.includes(D)&&(h.include?.includes(D)||(M===void 0||h.scopes===void 0||h.scopes.includes(M))&&!(h.skipRestricted&&C?.restricted))?N[D]=e[D]:E=!0}return{raw:N,restricted:A,hasExcludedProperties:E}}l(e,n){const r=[];for(const h of Object.keys(e))if(c.$yo.test(h)){const E={};for(const N in e[h])E[N]=e[h][N];r.push({identifiers:(0,c.$zo)(h),keys:Object.keys(E),contents:(0,a.$_i)(E,n)})}return r}}t.$Fo=d;class g extends k.$Uc{constructor(e,n,r,h,E){super(),this.c=e,this.f=n,this.g=h,this.h=E,this.b=this.B(new O.$he),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),E),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(f.FileOperation.CREATE)||N.isOperation(f.FileOperation.COPY)||N.isOperation(f.FileOperation.DELETE)||N.isOperation(f.FileOperation.WRITE))&&r.isEqual(N.resource,e)))(()=>this.b.fire()))}async loadConfiguration(){try{const e=await this.g.readFile(this.c);return this.a.parse(e.value.toString()||"{}",this.f),this.a.configurationModel}catch{return R.createEmptyModel(this.h)}}reparse(e){return e&&(this.f=e),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$Go=g;class m{constructor(e,n,r,h,E,N,A,D,C,M,J,ae,ie){this.a=e,this.b=n,this.c=r,this.overrideIdentifiers=h,this.d=E,this.f=N,this.g=A,this.h=D,this.i=C,this.j=M,this.k=J,this.l=ae,this.m=ie}get value(){return w(this.c)}n(e){return e?.value!==void 0||e?.override!==void 0||e?.overrides!==void 0?e:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class S{constructor(e,n,r,h,E,N,A,D,C,M){this.j=e,this.l=n,this.m=r,this.n=h,this.p=E,this.q=N,this.r=A,this.s=D,this.t=C,this.u=M,this.h=null,this.i=new L.$Ac,this.v=null}getValue(e,n,r){return this.w(e,n,r).getValue(e)}updateValue(e,n,r={}){let h;r.resource?(h=this.t.get(r.resource),h||(h=R.createEmptyModel(this.u),this.t.set(r.resource,h))):h=this.s,n===void 0?h.removeValue(e):h.setValue(e,n),r.resource||(this.h=null)}inspect(e,n,r){const h=this.w(e,n,r),E=this.A(n.resource,r),N=n.resource?this.t.get(n.resource)||this.s:this.s,A=new Set;for(const D of h.overrides)for(const C of D.identifiers)h.getOverrideValue(e,C)!==void 0&&A.add(C);return new m(e,n,h.getValue(e),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,E||void 0,N)}keys(e){const n=this.A(void 0,e);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(e){this.j=e,this.h=null,this.i.clear()}updatePolicyConfiguration(e){this.l=e}updateApplicationConfiguration(e){this.m=e,this.h=null,this.i.clear()}updateLocalUserConfiguration(e){this.n=e,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(e){this.p=e,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(e){this.q=e,this.h=null,this.i.clear()}updateFolderConfiguration(e,n){this.r.set(e,n),this.i.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this.i.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const r=[];if(!n){const{added:h,updated:E,removed:N}=i(this.j,e);n=[...h,...E,...N]}for(const h of n)for(const E of(0,c.$zo)(h)){const N=this.j.getKeysForOverrideIdentifier(E),A=e.getKeysForOverrideIdentifier(E),D=[...A.filter(C=>N.indexOf(C)===-1),...N.filter(C=>A.indexOf(C)===-1),...N.filter(C=>!I.$ao(this.j.override(E).getValue(C),e.override(E).getValue(C)))];r.push([E,D])}return this.updateDefaultConfiguration(e),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(e){const{added:n,updated:r,removed:h}=i(this.l,e),E=[...n,...r,...h];return E.length&&this.updatePolicyConfiguration(e),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.applicationConfiguration,e),N=[...n,...r,...h];return N.length&&this.updateApplicationConfiguration(e),{keys:N,overrides:E}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.localUserConfiguration,e),N=[...n,...r,...h];return N.length&&this.updateLocalUserConfiguration(e),{keys:N,overrides:E}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.remoteUserConfiguration,e),N=[...n,...r,...h];return N.length&&this.updateRemoteUserConfiguration(e),{keys:N,overrides:E}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.workspaceConfiguration,e),N=[...n,...r,...h];return N.length&&this.updateWorkspaceConfiguration(e),{keys:N,overrides:E}}compareAndUpdateFolderConfiguration(e,n){const r=this.folderConfigurations.get(e),{added:h,updated:E,removed:N,overrides:A}=i(r,n),D=[...h,...E,...N];return(D.length||!r)&&this.updateFolderConfiguration(e,n),{keys:D,overrides:A}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:h,removed:E,overrides:N}=i(n,void 0);return{keys:[...r,...h,...E],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(e,n,r){let h=this.x(n,r);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(e)!==void 0&&(h=h.merge(this.l)),h}x({resource:e},n){let r=this.y();if(n&&e){const h=n.getFolder(e);h&&(r=this.z(h.uri)||r);const E=this.t.get(e);E&&(r=r.merge(E))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(e){let n=this.i.get(e);if(!n){const r=this.y(),h=this.r.get(e);h?(n=r.merge(h),this.i.set(e,n)):n=r}return n}A(e,n){if(n&&e){const r=n.getFolder(e);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((e,n)=>{const{contents:r,overrides:h,keys:E}=this.r.get(n);return e.push([n,{contents:r,overrides:h,keys:E}]),e},[])}}allKeys(){const e=new Set;return this.j.keys.forEach(n=>e.add(n)),this.userConfiguration.keys.forEach(n=>e.add(n)),this.q.keys.forEach(n=>e.add(n)),this.r.forEach(n=>n.keys.forEach(r=>e.add(r))),[...e.values()]}B(){const e=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}D(e){const n=new Set;return this.j.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(h=>n.add(h))),[...n.values()]}static parse(e,n){const r=this.E(e.defaults,n),h=this.E(e.policy,n),E=this.E(e.application,n),N=this.E(e.user,n),A=this.E(e.workspace,n),D=e.folders.reduce((C,M)=>(C.set(l.URI.revive(M[0]),this.E(M[1],n)),C),new L.$Ac);return new S(r,h,E,N,R.createEmptyModel(n),A,D,R.createEmptyModel(n),new L.$Ac,n)}static E(e,n){return new R(e.contents,e.keys,e.overrides,void 0,n)}}t.$Ho=S;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const h of s)h.keys.forEach(E=>e.add(E)),h.overrides.forEach(([E,N])=>{const A=(0,L.$xc)(n,E,new Set);N.forEach(D=>A.add(D))});const r=[];return n.forEach((h,E)=>r.push([E,[...h.values()]])),{keys:[...e.values()],overrides:r}}class u{constructor(e,n,r,h,E){this.change=e,this.f=n,this.g=r,this.h=h,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of e.keys)this.affectedKeys.add(N);for(const[,N]of e.overrides)for(const A of N)this.affectedKeys.add(A);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=S.parse(this.f.data,this.i)),this.j}affectsConfiguration(e,n){const r=this.a+e,h=this.d.indexOf(r);if(h<0)return!1;const E=h+r.length;if(E>=this.d.length)return!1;const N=this.d.charCodeAt(E);if(N!==this.b&&N!==this.c)return!1;if(n){const A=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.f?.workspace):void 0,D=this.g.getValue(e,n,this.h);return!I.$ao(A,D)}return!0}}t.$Jo=u;function i(s,e){const{added:n,removed:r,updated:h}=o(e?.rawConfiguration,s?.rawConfiguration),E=[],N=s?.getAllOverrideIdentifiers()||[],A=e?.getAllOverrideIdentifiers()||[];if(e){const D=A.filter(C=>!N.includes(C));for(const C of D)E.push([C,e.getKeysForOverrideIdentifier(C)])}if(s){const D=N.filter(C=>!A.includes(C));for(const C of D)E.push([C,s.getKeysForOverrideIdentifier(C)])}if(e&&s){for(const D of N)if(A.includes(D)){const C=o({contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)},{contents:e.getOverrideValue(void 0,D)||{},keys:e.getKeysForOverrideIdentifier(D)});E.push([D,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:r,updated:h,overrides:E}}function o(s,e){const n=s?e?s.keys.filter(E=>e.keys.indexOf(E)===-1):[...s.keys]:[],r=e?s?e.keys.filter(E=>s.keys.indexOf(E)===-1):[...e.keys]:[],h=[];if(s&&e){for(const E of e.keys)if(s.keys.indexOf(E)!==-1){const N=(0,a.$cj)(e.contents,E),A=(0,a.$cj)(s.contents,E);I.$ao(N,A)||h.push(E)}}return{added:n,removed:r,updated:h}}}),define(se[140],oe([0,1,20,5,2,28,3,67,40,6,39,38]),function(Q,t,P,O,v,k,L,I,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mo=t.$Lo=t.$Ko=void 0;class f extends v.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new O.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Eo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$jo.as(p.$oo.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:g})=>this.f(Array.from(d),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,g){this.j(d,c.$jo.as(p.$oo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=I.$Eo.createEmptyModel(this.c);const d=c.$jo.as(p.$oo.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,g){const m=this.g();for(const S of d){const y=m[S],u=g[S];y!==void 0?this.b.addValue(S,y):u?this.b.addValue(S,u.default):this.b.removeValue(S)}}}t.$Ko=f;class ${constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=I.$Eo.createEmptyModel(new l.$hk)}async initialize(){return this.configurationModel}}t.$Lo=$;let w=class extends v.$Uc{get configurationModel(){return this.b}constructor(d,g,m){super(),this.c=d,this.f=g,this.g=m,this.a=this.B(new O.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Eo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const g={},m=[],S=c.$jo.as(p.$oo.Configuration).getConfigurationProperties();for(const y of d){const u=S[y];if(!u){m.push(y);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}m.push(y),g[u.policy.name]={type:u.type}}}return(0,L.$ng)(g)||await this.f.updatePolicyDefinitions(g),m}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const g=c.$jo.as(p.$oo.Configuration).getPolicyConfigurations(),m=(0,P.$Hb)(d.map(S=>g.get(S)));this.m(m,!0)}m(d,g){this.g.trace("PolicyConfiguration#update",d);const m=c.$jo.as(p.$oo.Configuration).getConfigurationProperties(),S=[],y=this.b.isEmpty();for(const u of d){const i=m[u]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(y?o!==void 0:!(0,k.$ao)(this.b.getValue(u),o))&&S.push([u,o])}else this.b.getValue(u)!==void 0&&S.push([u,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const u=this.b;this.b=I.$Eo.createEmptyModel(this.g);for(const i of u.keys)this.b.setValue(i,u.getValue(i));for(const[i,o]of S)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);g&&this.a.fire(this.b)}}};t.$Mo=w,t.$Mo=w=we([ne(1,a.$lo),ne(2,l.$7j)],w)}),define(se[141],oe([0,1,20,8,14,5,34,78,2,31,28,13,17,30,67,40,140,10,39]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$No=void 0;class S extends p.$Uc{constructor(i,o,s,e){super(),this.m=i,this.n=e,this.h=this.B(new k.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Ko(e)),this.c=s instanceof m.$no?new d.$Lo:this.B(new d.$Mo(this.b,s,e)),this.f=this.B(new w.$Go(this.m,{},f.$5g,o,e)),this.a=new w.$Ho(this.b.configurationModel,this.c.configurationModel,w.$Eo.createEmptyModel(e),w.$Eo.createEmptyModel(e),w.$Eo.createEmptyModel(e),w.$Eo.createEmptyModel(e),new l.$Ac,w.$Eo.createEmptyModel(e),new l.$Ac,e),this.j=new y(i,o,this),this.g=this.B(new O.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[i,o,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.$Ho(i,o,w.$Eo.createEmptyModel(this.n),s,w.$Eo.createEmptyModel(this.n),w.$Eo.createEmptyModel(this.n),new l.$Ac,w.$Eo.createEmptyModel(this.n),new l.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(i,o){const s=typeof i=="string"?i:void 0,e=(0,$.$8i)(i)?i:(0,$.$8i)(o)?o:{};return this.a.getValue(s,e,void 0)}async updateValue(i,o,s,e,n){const r=(0,$.$9i)(s)?s:(0,$.$8i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,h=r?e:s;if(h!==void 0&&h!==$.ConfigurationTarget.USER_LOCAL&&h!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${i} to target ${h}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,P.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const E=this.inspect(i,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(E.policyValue!==void 0)throw new Error(`Unable to write ${i} because it is configured in system policy.`);if((0,a.$ao)(o,E.defaultValue)&&(o=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const A=r.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(C=>(0,P.$ub)([...C.identifiers].sort(),A));D&&(r.overrideIdentifiers=D.identifiers)}const N=r?.overrideIdentifiers?.length?[(0,R.$Ao)(r.overrideIdentifiers),i]:[i];await this.j.write(N,o),await this.reloadConfiguration()}inspect(i,o={}){return this.a.inspect(i,o,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const i=await this.f.loadConfiguration();this.r(i)}r(i){const o=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(i);this.u(s,o,$.ConfigurationTarget.USER)}s(i,o){const s=this.a.toData(),e=this.a.compareAndUpdateDefaultConfiguration(i,o);this.u(e,s,$.ConfigurationTarget.DEFAULT)}t(i){const o=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(i);this.u(s,o,$.ConfigurationTarget.DEFAULT)}u(i,o,s){const e=new w.$Jo(i,{data:o},this.a,void 0,this.n);e.source=s,this.h.fire(e)}}t.$No=S;class y{constructor(i,o,s){this.b=i,this.c=o,this.d=s,this.a=new O.$Hh}write(i,o){return this.a.queue(()=>this.e(i,o))}async e(i,o){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw r}const e=[];if((0,L.$Pn)(s,e,{allowTrailingComma:!0,allowEmptyContent:!0}),e.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(s,i,o);s=(0,I.$8n)(s,n),await this.c.writeFile(this.b,v.$Je.fromString(s))}f(i,o,s){const{tabSize:e,insertSpaces:n,eol:r}=this.h;if(!o.length){const h=JSON.stringify(s,null,n?" ".repeat(e):"	");return[{content:h,length:h.length,offset:0}]}return(0,I.$5n)(i,o,s,{tabSize:e,insertSpaces:n,eol:r})}get h(){if(!this.g){let i=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const o=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});o&&typeof o=="string"&&o!=="auto"&&(i=o),this.g={eol:i,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[68],oe([0,1,15]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mm=O,t.$Nm=v,t.$Om=k,t.$Pm=L;function O(p){return p.scheme===P.Schemas.vscodeRemote?p.authority:void 0}function v(p){if(!p)return;const l=p.indexOf("+");return l<0?p:p.substr(0,l)}function k(p){const{host:l,port:a}=I(p);if(typeof a>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:a}}function L(p,l){let{host:a,port:c}=I(p);return typeof c>"u"&&(c=l),{host:a,port:c}}function I(p){const l=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const a=p.match(/^(\[[0-9a-z:]+\])$/);if(a)return{host:a[1],port:void 0};const c=p.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:p,port:void 0}}}),define(se[26],oe([0,1,32,11,68]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4m=t.$Ym=t.$Xm=t.$Wm=t.TargetPlatform=t.ExtensionType=t.$Vm=t.$Tm=t.$Sm=t.$Rm=t.$Qm=void 0,t.$Um=k,t.$Zm=c,t.$1m=f,t.$2m=$,t.$3m=w,t.$Qm="extensions.user.cache",t.$Rm="extensions.builtin.cache",t.$Sm="undefined_publisher",t.$Tm=["ui","workspace","web"];function k(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}t.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(L||(t.ExtensionType=L={}));var I;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(I||(t.TargetPlatform=I={}));class p{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const m=typeof d=="string"?d:d.value,S=typeof g=="string"?g:g.value;return P.$Bf(m,S)}return d._lower===g._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}t.$Wm=p;class l{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const g of d)this.add(g)}add(d){this.c.add(p.toKey(d))}delete(d){return this.c.delete(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}}t.$Xm=l;class a{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(p.toKey(d))}get(d){return this.c.get(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}set(d,g){this.c.set(p.toKey(d),g)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$Ym=a;function c(R){return f(R)}function f(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function $(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function w(R,d){if(d){const g=`onResolveRemoteAuthority:${(0,v.$Nm)(d)}`;return!!R.activationEvents?.includes(g)}return!1}t.$4m=(0,O.$Ai)("IBuiltinExtensionsScannerService")}),define(se[21],oe([0,1,13,99,26,11]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kp=t.$jp=t.$ip=t.$hp=t.$gp=t.$fp=t.$ep=t.$dp=t.ExtensionManagementErrorCode=t.$cp=t.ExtensionGalleryErrorCode=t.$bp=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$7o=t.$6o=t.$5o=t.$4o=t.$3o=t.$2o=t.$1o=void 0,t.$8o=I,t.$9o=p,t.$0o=l,t.$$o=a,t.$_o=c,t.$ap=f,t.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$2o=new RegExp(t.$1o),t.$3o="__web_extension",t.$4o="skipWalkthrough",t.$5o="extensionInstallSource",t.$6o="dependecyOrPackExtensionInstall",t.$7o="clientTargetPlatform";var L;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(L||(t.ExtensionInstallSource=L={}));function I(u){switch(u){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function p(u){switch(u){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function l(u,i){switch(u){case P.Platform.Windows:return i==="x64"?v.TargetPlatform.WIN32_X64:i==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Linux:return i==="x64"?v.TargetPlatform.LINUX_X64:i==="arm64"?v.TargetPlatform.LINUX_ARM64:i==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?v.TargetPlatform.ALPINE_X64:i==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Mac:return i==="x64"?v.TargetPlatform.DARWIN_X64:i==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Web:return v.TargetPlatform.WEB}}function a(u,i){return i===v.TargetPlatform.WEB&&!u.includes(v.TargetPlatform.WEB)}function c(u,i,o){return a(i,o)?!1:u===v.TargetPlatform.UNDEFINED||u===v.TargetPlatform.UNIVERSAL?!0:u===v.TargetPlatform.UNKNOWN?!1:u===o}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var $;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})($||(t.SortBy=$={}));var w;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(w||(t.SortOrder=w={}));var R;(function(u){u.Install="install",u.Uninstall="uninstall"})(R||(t.StatisticType=R={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d||(t.InstallOperation=d={})),t.$bp=(0,k.$Ai)("extensionGalleryService");var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(g||(t.ExtensionGalleryErrorCode=g={}));class m extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.$cp=m;var S;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(S||(t.ExtensionManagementErrorCode=S={}));class y extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.$dp=y,t.$ep=(0,k.$Ai)("extensionManagementService"),t.$fp="extensionsIdentifiers/disabled",t.$gp="extensionsIdentifiers/enabled",t.$hp=(0,k.$Ai)("IGlobalExtensionEnablementService"),t.$ip=(0,k.$Ai)("IExtensionTipsService"),t.$jp=(0,O.localize2)(0,"Extensions"),t.$kp=(0,O.localize2)(1,"Preferences")}),define(se[142],oe([0,1,2,26,10]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=void 0;class k extends P.$Uc{constructor(I,p,l,a,c){super(),this.a=I,this.b=p,this.c=l,this.f=c,this.B(a.onDidInstallExtensions(f=>this.g(f))),this.B(a.onDidUninstallExtension(f=>this.h(f)))}g(I){for(const p of I)p.local&&this.invalidate(p.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const p of this.a.profiles)this.c.extUri.isEqual(p.extensionsResource,I)&&await this.j(p);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,O.$Qm))}catch(p){(0,v.$ll)(p)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(p)}}}t.$Kq=k}),define(se[69],oe([0,1,22,2,13,109,21,11]),function(Q,t,P,O,v,k,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=void 0,t.$Yr=p;function p(a){return a.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}t.$Zr=(0,I.$Ai)("languagePackService");let l=class extends O.$Uc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new P.$se;setTimeout(()=>c.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const w=f.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(d=>d.startsWith("lp-"))).map(R=>{const d=R.properties.localizedLanguages?.[0],g=p(R);return{...this.f(g,d,R),extensionId:R.identifier.id,galleryExtension:R}});return w.push(this.f("en","English")),w}f(c,f,$){const w=f??c;let R;if(w!==c&&(R=`(${c})`),c.toLowerCase()===v.$w.toLowerCase()&&(R??="",R+=(0,k.localize)(0,null)),$?.installCount){R??="";const d=$.installCount;let g;d>1e6?g=`${Math.floor(d/1e5)/10}M`:d>1e3?g=`${Math.floor(d/1e3)}K`:g=String(d),R+=` $(cloud-download) ${g}`}return{id:c,label:w,description:R}}};t.$1r=l,t.$1r=l=we([ne(0,L.$bp)],l)}),define(se[45],oe([0,1,14,9,2,111,40,11,6,38]),function(Q,t,P,O,v,k,L,I,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wp=t.$Vp=void 0,t.$Xp=f,t.$Yp=$,t.$Zp=w,t.$1p=R,t.$2p=d,t.$3p=g,t.$Vp=(0,I.$Ai)("requestService");class a{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class c extends v.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,k.localize)(0,null),when:p.$mk.isEqualTo((0,p.$jk)(p.LogLevel.Trace)).serialize()})}async c(u,i,o){const s=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${s} - begin`,i.type,new a(i.headers??{}));try{const e=await o();return this.a.trace(`${s} - end`,i.type,e.res.statusCode,e.res.headers),e}catch(e){throw this.a.error(`${s} - error`,i.type,(0,O.$0)(e)),e}}}t.$Wp=c;function f(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function $(y){return y.res.statusCode===204}async function w(y){return $(y)?null:(await(0,P.$Ve)(y.stream)).toString()}async function R(y){if(!f(y))throw new Error("Server returned "+y.res.statusCode);return w(y)}async function d(y){if(!f(y))throw new Error("Server returned "+y.res.statusCode);if($(y))return null;const i=(await(0,P.$Ve)(y.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function g(y){S(y)}let m;function S(y){const u=l.$jo.as(L.$oo.Configuration),i=m;m={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[m],remove:i?[i]:[]})}S(L.ConfigurationScope.APPLICATION)}),define(se[143],oe([0,1,22,15,10,45]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AQ=void 0;let L=class{constructor(p,l){this.a=p,this.b=l}async download(p,l,a=P.CancellationToken.None){if(p.scheme===O.Schemas.file||p.scheme===O.Schemas.vscodeRemote){await this.b.copy(p,l);return}const c={type:"GET",url:p.toString(!0)},f=await this.a.request(c,a);if(f.res.statusCode===200)await this.b.writeFile(l,f.stream);else{const $=await(0,k.$1p)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${$}`)}}};t.$AQ=L,t.$AQ=L=we([ne(0,k.$Vp),ne(1,v.$7k)],L)}),define(se[144],oe([0,1,145,3]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5r=k;function v(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(L,I,p={}){const l=(0,P.parse)(L),a=p.proxyUrl||v(l,I);if(!a)return null;const c=(0,P.parse)(a);if(!/^https?:$/.test(c.protocol||""))return null;const f={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,O.$gg)(p.strictSSL)?p.strictSSL:!0};return l.protocol==="http:"?new(await new Promise(($,w)=>{Q(["http-proxy-agent"],$,w)})).HttpProxyAgent(a,f):new(await new Promise(($,w)=>{Q(["https-proxy-agent"],$,w)})).HttpsProxyAgent(a,f)}}),define(se[146],oe([0,1,60,16,112,22,36,9,13,29,91,177,8,79]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lm=R;let w;async function R(g,m,S,y){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Fm)(y)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Fm)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=f.Promises.withAsyncBody(async(u,i)=>{const o=new k.$se;let s=1e4;const e=g.getValue("application.shellEnvironmentResolutionTimeout");typeof e=="number"&&(s=(0,$.$Gm)(e,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,v.localize)(0,null)))},s);try{u(await d(m,o.token))}catch(r){!(0,I.$4)(r)&&!o.token.isCancellationRequested?i(new Error((0,v.localize)(1,null,(0,L.$lj)(r)))):u({})}finally{clearTimeout(n),o.dispose()}})),w)}async function d(g,m){const S=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",S);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",y);const u=(0,l.$Wg)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"({.*})"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const s=await(0,a.$vm)(p.OS,o);return g.trace("getUnixShellEnvironment#shell",s),new Promise((e,n)=>{if(m.isCancellationRequested)return n(new I.$5);const r=(0,O.$nc)(s);let h,E;const N="";/^pwsh(-preview)?$/.test(r)?(h=`& '${process.execPath}' ${N} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,E=["-Login","-Command"]):r==="nu"?(h=`^'${process.execPath}' ${N} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,E=["-i","-l","-c"]):r==="xonsh"?(h=`import os, json; print("${u}", json.dumps(dict(os.environ)), "${u}")`,E=["-i","-l","-c"]):(h=`'${process.execPath}' ${N} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,r==="tcsh"||r==="csh"?E=["-ic"]:E=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),h);const A=(0,P.spawn)(s,[...E,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(A.kill(),n(new I.$5))),A.on("error",M=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,L.$lj)(M)),n(M)});const D=[];A.stdout.on("data",M=>D.push(M));const C=[];A.stderr.on("data",M=>C.push(M)),A.on("close",(M,J)=>{const ae=Buffer.concat(D).toString("utf8");g.trace("getUnixShellEnvironment#raw",ae);const ie=Buffer.concat(C).toString("utf8");if(ie.trim()&&g.trace("getUnixShellEnvironment#stderr",ie),M||J)return n(new Error((0,v.localize)(2,null,M,J)));const ce=i.exec(ae),ue=ce?ce[1]:"{}";try{const le=JSON.parse(ue);S?le.ELECTRON_RUN_AS_NODE=S:delete le.ELECTRON_RUN_AS_NODE,y?le.ELECTRON_NO_ATTACH_CONSOLE=y:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",le),e(le)}catch(le){g.error("getUnixShellEnvironment#errorCaught",(0,L.$lj)(le)),n(le)}})})}}),define(se[147],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=t.$cQ=void 0,t.$cQ=(0,P.$Ai)("stateReadService"),t.$dQ=(0,P.$Ai)("stateService")}),define(se[70],oe([0,1,8,14,2,3,18,10,6]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gQ=t.$fQ=t.$eQ=t.SaveStrategy=void 0;var l;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(l||(t.SaveStrategy=l={}));class a extends v.$Uc{constructor(w,R,d,g){super(),this.h=w,this.j=R,this.m=d,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new P.$yh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(w)}}getItem(w,R){const d=this.a[w];return(0,k.$jg)(d)?R:d}setItem(w,R){this.setItems([{key:w,data:R}])}setItems(w){let R=!1;for(const{key:d,data:g}of w)this.a[d]!==g&&((0,k.$jg)(g)?(0,k.$hg)(this.a[d])||(this.a[d]=void 0,R=!0):(this.a[d]=g,R=!0));R&&this.s()}removeItem(w){(0,k.$hg)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,O.$Je.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$eQ=a;let c=class extends v.$Uc{constructor(w,R,d,g){super(),this.a=this.B(new a(R.stateResource,w,d,g))}async init(){await this.a.init()}getItem(w,R){return this.a.getItem(w,R)}};t.$fQ=c,t.$fQ=c=we([ne(1,L.$Hi),ne(2,p.$7j),ne(3,I.$7k)],c);class f extends c{setItem(w,R){this.a.setItem(w,R)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}t.$gQ=f}),define(se[71],oe([0,1,13,37,29]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lp=L,t.$mp=I;function k(p){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function L(p,l,a,c,f,$,w,R,d,g){const m=Object.create(null);m["common.machineId"]=$,m["common.sqmId"]=w,m["common.devDeviceId"]=R,m.sessionID=(0,v.$Wg)()+Date.now(),m.commitHash=c,m.version=f,m["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,P.$h)(P.$u),m["common.nodePlatform"]=O.$dc,m["common.nodeArch"]=a,m["common.product"]=g||"desktop",d&&(m["common.msftInternal"]=d);let S=0;const y=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),P.$l&&(m["common.snap"]="true");const u=k(l);return u&&(m["common.platformDetail"]=u),m}function I(p){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const a=l.toLowerCase();return p.some(c=>a===c)}}),define(se[19],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=t.$$l=t.$0l=t.$9l=t.$8l=t.$7l=t.$6l=void 0,t.$6l=(0,P.$Ai)("telemetryService"),t.$7l=(0,P.$Ai)("customEndpointTelemetryService"),t.$8l="telemetry.currentSessionDate",t.$9l="telemetry.firstSessionDate",t.$0l="telemetry.lastSessionDate",t.$$l="telemetry.machineId",t.$_l="telemetry.sqmId",t.$am="telemetry.devDeviceId",t.$bm="telemetry",t.$cm="telemetry.telemetryLevel",t.$dm="telemetry.enableCrashReporter",t.$em="telemetry.enableTelemetry";var O;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(O||(t.TelemetryLevel=O={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(t.TelemetryConfiguration=v={}))}),define(se[72],oe([0,1,9,11,6,19]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jq=t.$iq=t.ExtensionSignatureVerificationCode=t.$hq=void 0,t.$hq=(0,O.$Ai)("IExtensionSignatureVerificationService");var L;(function(l){l.None="None",l.RequiredArgumentMissing="RequiredArgumentMissing",l.InvalidArgument="InvalidArgument",l.PackageIsUnreadable="PackageIsUnreadable",l.UnhandledException="UnhandledException",l.SignatureManifestIsMissing="SignatureManifestIsMissing",l.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",l.SignatureIsMissing="SignatureIsMissing",l.SignatureIsUnreadable="SignatureIsUnreadable",l.CertificateIsUnreadable="CertificateIsUnreadable",l.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",l.FileAlreadyExists="FileAlreadyExists",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",l.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",l.Success="Success",l.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",l.SignatureIsInvalid="SignatureIsInvalid",l.SignatureManifestIsInvalid="SignatureManifestIsInvalid",l.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",l.EntryIsMissing="EntryIsMissing",l.EntryIsTampered="EntryIsTampered",l.Untrusted="Untrusted",l.CertificateRevoked="CertificateRevoked",l.SignatureIsNotValid="SignatureIsNotValid",l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(t.ExtensionSignatureVerificationCode=L={}));class I extends Error{constructor(a){super(a),this.code=a}}t.$iq=I;let p=class{constructor(a,c){this.b=a,this.c=c}d(){return this.a||(this.a=new Promise((a,c)=>Q(["@vscode/vsce-sign"],async f=>a(f),c))),this.a}async verify(a,c,f,$){let w;const R=a.identifier.id;try{w=await this.d()}catch(S){return this.b.error("Could not load vsce-sign module",(0,P.$0)(S)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const d=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${R}...`),g=await w.verify(c,f,this.b.getLevel()===v.LogLevel.Trace)}catch(S){g={code:L.UnknownError,didExecute:!1,output:(0,P.$0)(S)}}const m=new Date().getTime()-d;if(this.b.info(`Extension signature verification result for ${R}: ${g.code}. Executed: ${g.didExecute}. Duration: ${m}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:a.version,code:g.code,internalCode:g.internalCode,duration:m,didExecute:g.didExecute,clientTargetPlatform:$}),g.code===L.Success)return!0;throw new I(g.code)}};t.$jq=p,t.$jq=p=we([ne(0,v.$7j),ne(1,k.$6l)],p)}),define(se[41],oe([0,1,28,3,68,71,19]),function(Q,t,P,O,v,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tp=t.$sp=t.$rp=t.$qp=t.$pp=t.$op=t.$np=void 0,t.$up=a,t.$vp=c,t.$wp=f,t.$xp=$,t.$yp=R,t.$zp=g,t.$Ap=m,t.$Bp=u;class I{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}t.$np=I;class p{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$op=p,t.$pp=new p;class l{async publicLog(o,s,e){}async publicLogError(o,s,e){}}t.$qp=l,t.$rp="telemetry",t.$sp="extensionTelemetryLog",t.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function a(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function c(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function f(i){const o=i.getValue(L.$cm),s=i.getValue(L.$dm);if(i.getValue(L.$em)===!1||s===!1)return L.TelemetryLevel.NONE;switch(o??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function $(i){const o={},s={},e={};d(i,e);for(let n in e){n=n.length>150?n.substr(n.length-149):n;const r=e[n];typeof r=="number"?s[n]=r:typeof r=="boolean"?s[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),o[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[n]=r)}return{properties:o,measurements:s}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(i){if(!i)return"none";const o=(0,v.$Nm)(i);return w.has(o)?o:"other"}function d(i,o,s=0,e){if(i)for(const n of Object.getOwnPropertyNames(i)){const r=i[n],h=e?e+n:n;Array.isArray(r)?o[h]=(0,P.$bo)(r):r instanceof Date?o[h]=r.toISOString():(0,O.$cg)(r)?s<2?d(r,o,s+1,h+"."):o[h]=(0,P.$bo)(r):o[h]=r}}function g(i,o){const s=i.msftInternalDomains||[],e=o.getValue("telemetry.internalTesting");return(0,k.$mp)(s)||e}function m(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function S(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let s=i;const e=[];for(const E of o)for(;;){const N=E.exec(i);if(!N)break;e.push([N.index,E.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(s="";;){const E=r.exec(i);if(!E)break;const N=e.some(([A,D])=>E.index<D&&A<r.lastIndex);!n.test(E[0])&&!N&&(s+=i.substring(h,E.index)+"<REDACTED: user-file-path>",h=r.lastIndex)}return h<i.length&&(s+=i.substr(h)),s}function y(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(i))return`<REDACTED: ${s.label}>`;return i}function u(i,o){return(0,P.$$n)(i,s=>{if(s instanceof I||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let e=s.replaceAll("%20"," ");e=S(e,o);for(const n of o)e=e.replace(n,"");return e=y(e),e}})}}),define(se[27],oe([0,1,32,21,26,13,12,9,37,41]),function(Q,t,P,O,v,k,L,I,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lp=t.$Dp=void 0,t.$Cp=a,t.$Ep=w,t.$Fp=R,t.$Gp=d,t.$Hp=g,t.$Ip=m,t.$Jp=S,t.$Kp=y,t.$Mp=u,t.$Np=o;function a(s,e){return s.uuid&&e.uuid?s.uuid===e.uuid:s.id===e.id?!0:(0,P.$wf)(s.id,e.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(e){const n=e.manifest?e.manifest.version:e.version,r=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new f(e.identifier,n,r)}static parse(e){const n=c.exec(e);return n&&n[1]&&n[2]?new f({id:n[1]},n[2],n[4]||void 0):null}constructor(e,n,r=v.TargetPlatform.UNDEFINED){this.identifier=e,this.version=n,this.targetPlatform=r,this.id=e.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof f?a(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.$Dp=f;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(s){const e=$.exec(s);return e&&e[1]?[d(e[1]),e[2]]:[d(s),void 0]}function R(s,e){return`${s}.${e}`}function d(s){return s.toLowerCase()}function g(s,e){return d(R(s??v.$Sm,e))}function m(s,e){const n=[],r=h=>{for(const E of n)if(E.some(N=>a(e(N),e(h))))return E;return null};for(const h of s){const E=r(h);E?E.push(h):n.push([h])}return n}function S(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function y(s){return{id:new l.$np(s.identifier.id),name:new l.$np(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}t.$Lp=new v.$Wm("pprice.better-merge");function u(s,e){const n=[],r=e.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const h=r.shift();if(h&&n.every(E=>!a(E.identifier,{id:h}))){const E=s.filter(N=>a(N.identifier,{id:h}));E.length===1&&(n.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function i(s,e){if(!k.$k)return!1;let n;try{n=(await s.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){e.debug("Error while getting the os-release file.",(0,I.$0)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,e){const n=await i(s,e),r=(0,O.$0o)(n?"alpine":k.$u,p.$ec);return e.debug("ComputeTargetPlatform:",r),r}}),define(se[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(Q,t,P,O,v,k,L,I,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kq=void 0;const f=R=>(0,p.localize)(0,null,R),$=(0,p.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(d,g,m){this.a=d,this.b=g,this.d=m}get f(){}async listExtensions(d,g,m){let S=await this.b.getInstalled(c.ExtensionType.User,m);const y=c.$Vm.map(i=>i.toLowerCase());if(g&&g!==""){if(y.indexOf(g.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}S=S.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){this.a.info("Possible Categories: "),y.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,p.localize)(2,null,this.f)),S=S.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let u;for(const i of S)u!==i.identifier.id&&(u=i.identifier.id,this.a.info(d?`${u}@${i.manifest.version}`:u))}async installExtensions(d,g,m,S){const y=[];try{d.length&&this.a.info(this.f?(0,p.localize)(3,null,this.f):(0,p.localize)(4,null));const u=[],i=[],o=(e,n,r)=>{i.push({id:e,version:n!=="prerelease"?n:void 0,installOptions:{...m,isBuiltin:r,installPreReleaseVersion:n==="prerelease"||m.installPreReleaseVersion}})};for(const e of d)if(e instanceof I.URI)u.push({vsix:e,installOptions:m});else{const[n,r]=(0,a.$Ep)(e);o(n,r,!1)}for(const e of g)if(e instanceof I.URI)u.push({vsix:e,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,r]=(0,a.$Ep)(e);o(n,r,!0)}const s=await this.b.getInstalled(void 0,m.profileLocation);if(u.length&&await Promise.all(u.map(async({vsix:e,installOptions:n})=>{try{await this.h(e,n,S,s)}catch(r){this.a.error(r),y.push(e.toString())}})),i.length){const e=await this.g(i,s,S);y.push(...e)}}catch(u){throw this.a.error((0,p.localize)(5,null,(0,O.$0)(u))),u}if(y.length)throw new Error((0,p.localize)(6,null,y.join(", ")))}async updateExtensions(d){const g=await this.b.getInstalled(c.ExtensionType.User,d),m=[];for(const i of g)i.identifier.uuid&&m.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,p.localize)(7,null,m.length));const S=await this.d.getExtensions(m,{compatible:!0},P.CancellationToken.None),y=[];for(const i of S)for(const o of g)(0,a.$Cp)(o.identifier,i.identifier)&&(0,L.gt)(i.version,o.manifest.version)&&y.push({extension:i,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:o.preRelease,profileLocation:d}});if(!y.length){this.a.info((0,p.localize)(8,null));return}this.a.info((0,p.localize)(9,null,y.map(i=>i.extension.identifier.id).join(", ")));const u=await this.b.installGalleryExtensions(y);for(const i of u)i.error?this.a.error((0,p.localize)(10,null,i.identifier.id,(0,O.$0)(i.error))):this.a.info((0,p.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(d,g,m){if(d=d.filter(({id:i,version:o})=>{const s=g.find(e=>(0,a.$Cp)(e.identifier,{id:i}));if(s){if(!m&&(!o||o==="prerelease"&&s.preRelease))return this.a.info((0,p.localize)(12,null,i,s.manifest.version,i)),!1;if(o&&s.manifest.version===o)return this.a.info((0,p.localize)(13,null,`${i}@${o}`)),!1}return!0}),!d.length)return[];const S=[],y=[],u=await this.j(d);if(await Promise.all(d.map(async({id:i,version:o,installOptions:s})=>{const e=u.get(i.toLowerCase());if(!e){this.a.error(`${f(o?`${i}@${o}`:i)}
${$}`),S.push(i);return}try{const r=await this.d.getManifest(e,P.CancellationToken.None);if(r&&!this.k(r))return}catch(r){this.a.error(r.message||r.stack||r),S.push(i);return}const n=g.find(r=>(0,a.$Cp)(r.identifier,e.identifier));if(n){if(e.version===n.manifest.version){this.a.info((0,p.localize)(14,null,o?`${i}@${o}`:i));return}this.a.info((0,p.localize)(15,null,i,e.version))}s.isBuiltin?this.a.info(o?(0,p.localize)(16,null,i,o):(0,p.localize)(17,null,i)):this.a.info(o?(0,p.localize)(18,null,i,o):(0,p.localize)(19,null,i)),y.push({extension:e,options:{...s,installGivenVersion:!!o}})})),y.length){const i=await this.b.installGalleryExtensions(y);for(const o of i)o.error?(this.a.error((0,p.localize)(20,null,o.identifier.id,(0,O.$0)(o.error))),S.push(o.identifier.id)):this.a.info((0,p.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return S}async h(d,g,m,S){const y=await this.b.getManifest(d);if(!y)throw new Error("Invalid vsix");if(await this.l(y,m,g.profileLocation,S))try{await this.b.install(d,g),this.a.info((0,p.localize)(22,null,(0,k.$$g)(d)))}catch(i){if((0,O.$4)(i))this.a.info((0,p.localize)(23,null,(0,k.$$g)(d)));else throw i}}async j(d){const g=new Map,m=d.some(u=>u.installOptions.installPreReleaseVersion),S=await this.b.getTargetPlatform(),y=[];for(const u of d)l.$2o.test(u.id)&&y.push({...u,preRelease:m});if(y.length){const u=await this.d.getExtensions(y,{targetPlatform:S},P.CancellationToken.None);for(const i of u)g.set(i.identifier.id.toLowerCase(),i)}return g}k(d){return!0}async l(d,g,m,S){if(!g){const y={id:(0,a.$Hp)(d.publisher,d.name)},u=S.find(i=>(0,a.$Cp)(y,i.identifier)&&(0,L.gt)(i.manifest.version,d.version));if(u)return this.a.info((0,p.localize)(24,null,u.identifier.id,u.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,g,m){const S=async u=>{if(u instanceof I.URI){const i=await this.b.getManifest(u);return(0,a.$Fp)(i.publisher,i.name)}return u},y=[];for(const u of d){const i=await S(u),s=(await this.b.getInstalled(void 0,m)).filter(e=>(0,a.$Cp)(e.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${$}`);if(s.some(e=>e.type===c.ExtensionType.System)){this.a.info((0,p.localize)(25,null,i));return}if(!g&&s.some(e=>e.isBuiltin)){this.a.info((0,p.localize)(26,null,i));return}this.a.info((0,p.localize)(27,null,i));for(const e of s)await this.b.uninstall(e,{profileLocation:m}),y.push(e);this.f?this.a.info((0,p.localize)(28,null,i,this.f)):this.a.info((0,p.localize)(29,null,i))}}async locateExtension(d){const g=await this.b.getInstalled();d.forEach(m=>{g.forEach(S=>{if(S.identifier.id===m&&S.location.scheme===v.Schemas.file){this.a.info(S.location.fsPath);return}})})}m(d){return this.f?(0,p.localize)(30,null,d,this.f):(0,p.localize)(31,null,d)}};t.$kq=w,t.$kq=w=we([ne(1,l.$ep),ne(2,l.$bp)],w)}),define(se[149],oe([0,1,5,2,31,27,26,10]),function(Q,t,P,O,v,k,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lq=void 0;class p extends O.$Uc{constructor(a,c,f,$,w,R,d){super(),this.f=a,this.g=c,this.h=f,this.j=$,this.m=w,this.n=R,this.r=d,this.a=this.B(new P.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$4c),this.s().then(null,g=>d.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(c=>(this.c.set(c.id,(0,O.$Rc)(this.n.watch(this.m.extUri.dirname(c.extensionsResource)),this.n.watch(c.extensionsResource))),this.G(c.extensionsResource))))}catch(c){throw this.r.error(c),c}}async w(a){for(const c of a.extensions)this.I(this.L(c.identifier,c.version),a.profileLocation)}async y(a){for(const c of a.extensions){const f=this.L(c.identifier,c.version);a.error?this.J(f,a.profileLocation):this.I(f,a.profileLocation)}}async z(a){for(const c of a.extensions)this.J(this.L(c.identifier,c.version),a.profileLocation)}async C(a){const c=[],f=[];for(const $ of a.extensions){const w=this.L($.identifier,$.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),f.push(this.f.scanInstalledExtensionAtLocation($.location).then(R=>{R?c.push(R):this.r.info("Extension not found at the location",$.location.toString())},R=>this.r.error(R)))))}try{await Promise.all(f),c.length&&await this.H(c)}catch($){this.r.error($)}}D(a){for(const c of this.h.profiles)a.contains(c.extensionsResource,I.FileChangeType.UPDATED,I.FileChangeType.ADDED)&&this.F(c.extensionsResource)}async F(a){const c=[],f=[],$=await this.j.scanProfileExtensions(a),w=new Set,R=new Set;for(const[d,g]of this.b)g.has(a)&&R.add(d);for(const d of $){const g=this.L(d.identifier,d.version);w.add(g),R.has(g)||(c.push(d.identifier),this.I(g,a))}for(const d of R)if(!w.has(d)){const g=this.M(d);g&&(f.push(g.identifier),this.J(d,a))}(c.length||f.length)&&this.a.fire({added:c.length?{extensions:c,profileLocation:a}:void 0,removed:f.length?{extensions:f,profileLocation:a}:void 0})}async G(a){const c=await this.j.scanProfileExtensions(a);for(const f of c)this.I(this.L(f.identifier,f.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,c){let f=this.b.get(a);f||this.b.set(a,f=new v.$Bc($=>this.m.extUri.getComparisonKey($))),f.add(c)}J(a,c){const f=this.b.get(a);f&&f.delete(c),f?.size||this.b.delete(a)}L(a,c){return`${L.$Wm.toKey(a.id)}@${c}`}M(a){const[c,f]=(0,k.$Ep)(a);return f?{identifier:{id:c},version:f}:void 0}}t.$Lq=p}),define(se[150],oe([0,1,178,20,8,2,15,16,25,18,21,27,6,69,12]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=void 0;let R=class extends $.$1r{constructor(S,y,u,i){super(u),this.h=S,this.j=i,this.g=this.B(new d(y,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(S,y){const i=(await this.g.getLanguagePacks())[y];if(!i){this.j.warn(`No language pack found for ${y}`);return}const o=i.translations[S];return o?w.URI.file(o):void 0}async getInstalledLanguages(){const S=await this.g.getLanguagePacks(),y=Object.keys(S).map(u=>{const i=S[u];return{...this.f(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((u,i)=>u.label.localeCompare(i.label)),y}async m(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",S.identifier.id),await this.update())}async n(S){const y=await this.g.getLanguagePacks();Object.keys(y).some(u=>y[u]&&y[u].extensions.some(i=>(0,c.$Cp)(i.extensionIdentifier,S.identifier)))&&(this.j.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(y);return!(0,O.$ub)(Object.keys(S),Object.keys(u))}};t.$2r=R,t.$2r=R=we([ne(0,a.$ep),ne(1,l.$Ii),ne(2,a.$bp),ne(3,f.$7j)],R);let d=class extends k.$Uc{constructor(S,y){super(),this.j=y,this.c={},this.f=(0,I.$jc)(S.userDataPath,"languagepacks.json"),this.g=new v.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(S){return this.s(y=>{Object.keys(y).forEach(u=>delete y[u]),this.m(y,...S)}).then(()=>this.c)}m(S,...y){for(const u of y)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(S,u);Object.keys(S).forEach(u=>this.r(S[u]))}n(S,y){const u=y.identifier,i=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const o of i)if(y.location.scheme===L.Schemas.file&&g(o)){let s=S[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},S[o.languageId]=s);const e=s.extensions.filter(n=>(0,c.$Cp)(n.extensionIdentifier,u))[0];e?e.version=y.manifest.version:s.extensions.push({extensionIdentifier:u,version:y.manifest.version});for(const n of o.translations)s.translations[n.id]=(0,I.$jc)(y.location.fsPath,n.path)}}r(S){if(S){const y=(0,P.createHash)("md5");for(const u of S.extensions)y.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);S.hash=y.digest("hex")}}s(S=()=>null){return this.g.queue(()=>{let y=null;return p.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(y=S(u),u)).then(u=>{for(const o of Object.keys(u))u[o]||delete u[o];this.c=u,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),p.Promises.writeFile(this.f,i)}).then(()=>y,u=>this.j.error(u))})}};d=we([ne(0,l.$Ii),ne(1,f.$7j)],d);function g(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const S of m.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(se[151],oe([0,1,88,9,28,41]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$P=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function p(a,c,f){const $=await(0,P.$gE)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,P.$gE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new $.AppInsightsCore,d=new w.PostChannel,g={instrumentationKey:a,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(f){g.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};g.extensionConfig[d.identifier]=m}return R.initialize(g,[]),R.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),R}class l{constructor(c,f,$,w,R){this.e=c,this.f=f,this.g=$,this.h=R,this.c=L,this.d=I,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=p(this.a,this.e,this.h)),this.b.then(f=>{c(f)},f=>{(0,O.$1)(f),console.error(f)})}}log(c,f){if(!this.a)return;f=(0,v.$_n)(f,this.g),f=(0,k.$xp)(f);const $=this.f+"/"+c;try{this.i(w=>{w.pluginVersionString=f?.properties.version??"Unknown",w.track({name:$,baseData:{name:$,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}t.$$P=l}),define(se[152],oe([0,1,2,28,13,32,113,30,40,153,33,38,19,41]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8r=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,m,S){this.k=m,this.l=S,this.d={},this.i=new P.$Tc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,k.$df)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$df)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(f.$cm)||y.affectsConfiguration(f.$em)||y.affectsConfiguration(f.$dm))&&this.m()}))}setExperimentProperty(g,m){this.d[g]=m}m(){let g=(0,$.$wp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const S=m.usage?f.TelemetryLevel.USAGE:m.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;g=Math.min(g,S)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,m,S){this.g<m||(S=(0,O.$_n)(S,this.d),S=(0,$.$Bp)(S,this.j),S=(0,O.$_n)(S,this.c),this.b.forEach(y=>y.log(g,S)))}publicLog(g,m){this.n(g,f.TelemetryLevel.USAGE,m)}publicLog2(g,m){this.publicLog(g,m)}publicLogError(g,m){this.h&&this.n(g,f.TelemetryLevel.ERROR,m)}publicLogError2(g,m){this.publicLogError(g,m)}};t.$8r=w,t.$8r=w=we([ne(1,I.$7i),ne(2,a.$nk)],w);function R(){const d=(0,L.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=v.$o?"":(0,L.localize)(3,null),S=(0,L.localize)(4,null),y=(0,L.localize)(5,null),u=(0,L.localize)(6,null),i=(0,L.localize)(7,null),o=`
|       | ${S} | ${y} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,L.localize)(8,null);return`
${d} ${g} ${m}

&nbsp;

${i}
${o}

&nbsp;

${s}
`}c.$jo.as(p.$oo.Configuration).registerConfiguration({id:f.$bm,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[f.$cm]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:R(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$jo.as(p.$oo.Configuration).registerConfiguration({id:f.$bm,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[f.$em]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,L.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,L.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${f.$cm}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],oe([0,1,14,22,179,151]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=void 0;async function L(a,c){const f=await c.request(a,O.CancellationToken.None),$=(await(0,P.$Ve)(f.stream)).toString(),w=f.res.statusCode??200;return{headers:f.res.headers,statusCode:w,responseData:$}}async function I(a){const c={method:a.type,headers:a.headers};return new Promise(($,w)=>{const R=v.request(a.url??"",c,d=>{d.on("data",function(g){$({headers:d.headers,statusCode:d.statusCode??200,responseData:g.toString()})}),d.on("error",function(g){w(g)})});R.write(a.data,d=>{d&&w(d)}),R.end()})}async function p(a,c,f){const $=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),w={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:$};try{const R=a?await L(w,a):await I(w);f(R.statusCode,R.headers,R.responseData)}catch{f(0,{})}}class l extends k.$$P{constructor(c,f,$,w,R){const d={sendPOST:(g,m)=>{p(c,g,m)}};super(f,$,w,R,d)}}t.$_P=l}),define(se[155],oe([0,1,16,25]),function(Q,t,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pfc=v;async function v(k,L){const I=Object.create(null),p=(a,c)=>{const f=JSON.parse(a);I[c]=f};if(L){const a=[],c=await O.Promises.readdir(L);for(const $ of c)try{(await O.Promises.stat((0,P.$jc)(L,$))).isDirectory()&&a.push($)}catch{}const f=[];for(const $ of a)(await O.Promises.readdir((0,P.$jc)(L,$))).filter(R=>R==="telemetry.json").length===1&&f.push($);for(const $ of f){const w=(await O.Promises.readFile((0,P.$jc)(L,$,"telemetry.json"))).toString();p(w,$)}}let l=(await O.Promises.readFile((0,P.$jc)(k,"telemetry-core.json"))).toString();return p(l,"vscode-core"),l=(await O.Promises.readFile((0,P.$jc)(k,"telemetry-extensions.json"))).toString(),p(l,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(se[156],oe([0,1,13,89,19]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lec=k,t.$Mec=L,t.$Nec=I;async function k(p,l){let a=p.getItem(v.$$l);return(typeof a!="string"||P.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.$Kn)(l.error.bind(l))),a}async function L(p,l){let a=p.getItem(v.$_l);return typeof a!="string"&&(a=await(0,O.$Ln)(l.error.bind(l))),a}async function I(p,l){let a=p.getItem(v.$am);return typeof a!="string"&&(a=await(0,O.$Mn)(l.error.bind(l))),a}}),define(se[23],oe([0,1,11]),function(Q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$El=void 0,t.$El=(0,P.$Ai)("IUriIdentityService")}),define(se[157],oe([0,1,23,122,10,17,80,5,2]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=void 0;class l{static{this._clock=0}constructor(f){this.uri=f,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let a=class{constructor(f){this.g=f,this.c=new p.$Tc,this.f=2**16;const $=new Map,w=R=>{let d=$.get(R.scheme);return d===void 0&&(d=f.hasProvider(R)&&!this.g.hasCapability(R,v.FileSystemProviderCapabilities.PathCaseSensitive),$.set(R.scheme,d)),d};this.c.add(I.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(R=>{$.delete(R.scheme)})),this.extUri=new k.$3g(w),this.d=new L.$Hs((R,d)=>this.extUri.compare(R,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,k.$ch)(f));const $=this.d.get(f);return $?$.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new l(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort((w,R)=>w[1].time<R[1].time?1:w[1].time>R[1].time?-1:0);l._clock=0,this.d.clear();const $=this.f*.5;for(let w=0;w<$;w++)this.d.set(f[w][0],f[w][1].touch())}};t.$Is=a,t.$Is=a=we([ne(0,v.$7k)],a),(0,O.$Fs)(P.$El,a,O.InstantiationType.Delayed)}),define(se[158],oe([0,1,5,2,10,48,31]),function(Q,t,P,O,v,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_ec=void 0;class I extends O.$Uc{constructor(l,a,c,f,$,w){super(),this.f=l,this.g=a,this.h=c,this.j=f,this.m=$,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$he),this.onDidChangeFile=this.a.event,this.b=k.$Gi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(f.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,a){return this.g.open(this.t(l),a)}close(l){return this.g.close(l)}read(l,a,c,f,$){return this.g.read(l,a,c,f,$)}write(l,a,c,f,$){return this.g.write(l,a,c,f,$)}watch(l,a){this.b.set(l,l);const c=this.g.watch(this.t(l),a);return(0,O.$Sc)(()=>{this.b.delete(l),c.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,a,c){return this.g.rename(this.t(l),this.t(a),c)}readFile(l,a){return this.g.readFile(this.t(l),a)}readFileStream(l,a,c){return this.g.readFileStream(this.t(l),a,c)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,a,c){return this.g.writeFile(this.t(l),a,c)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,a){return this.g.delete(this.t(l),a)}copy(l,a,c){if((0,v.$$k)(this.g))return this.g.copy(this.t(l),this.t(a),c);throw new Error("copy not supported")}cloneFile(l,a){if((0,v.$_k)(this.g))return this.g.cloneFile(this.t(l),this.t(a));throw new Error("clone not supported")}s(l){const a=[];for(const c of l){if(c.resource.scheme!==this.f)continue;const f=this.u(c.resource);this.b.findSubstr(f)&&a.push({resource:f,type:c.type,cId:c.cId})}a.length&&(this.n.debug("User data changed"),this.a.fire(a))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}t.$_ec=I}),define(se[159],oe([0,1,115,16,48,17,12,11,15]),function(Q,t,P,O,v,k,L,I,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3i=t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Ui=t.$Ti=t.WorkbenchState=t.$Ni=t.$Mi=t.$Ji=void 0,t.$Ki=l,t.$Li=a,t.$Oi=c,t.$Pi=f,t.$Qi=$,t.$Ri=R,t.$Si=d,t.$Vi=S,t.$1i=y,t.$2i=u,t.$4i=i,t.$5i=o,t.$6i=s,t.$Ji=(0,I.$Ai)("contextService");function l(e){const n=e;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}function a(e){return typeof e?.id=="string"&&!l(e)&&!f(e)}t.$Mi={id:"ext-dev"},t.$Ni={id:"empty-window"};function c(e,n){if(typeof e=="string"||typeof e>"u")return typeof e=="string"?{id:(0,O.$nc)(e)}:n?t.$Mi:t.$Ni;const r=e;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function f(e){const n=e;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}function $(e){const n=e;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const r=e;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(e?.id)return{id:e.id}}var w;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(w||(t.WorkbenchState=w={}));function R(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function d(e){const n=e;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class g{constructor(n,r,h,E,N){this.h=n,this.j=h,this.k=E,this.l=N,this.c=v.$Gi.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=v.$Gi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Ti=g;class m{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.$bh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$Ui=m;function S(e){return new m({uri:e,index:0,name:(0,k.$0g)(e)},{uri:e.toString()})}t.$Wi="code-workspace",t.$Xi=`.${t.$Wi}`,t.$Yi=[{name:(0,P.localize)(0,null),extensions:[t.$Wi]}],t.$Zi="workspace.json";function y(e,n){return k.$5g.isEqualOrParent(e,n.untitledWorkspacesHome)}function u(e){let n;return L.URI.isUri(e)?n=e:n=e.configuration,n?.scheme===p.Schemas.tmp}t.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(e){return e.id===t.$3i}function o(e,n){return!y(e,n)&&!u(e)}function s(e){return(typeof e=="string"?(0,O.$oc)(e):(0,k.$_g)(e))===t.$Xi}}),define(se[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kl=t.$Jl=t.$Gl=t.ProfileResourceType=void 0,t.$Fl=y,t.$Hl=u,t.$Il=i;var S;(function(e){e.Settings="settings",e.Keybindings="keybindings",e.Snippets="snippets",e.Tasks="tasks",e.Extensions="extensions",e.GlobalState="globalState"})(S||(t.ProfileResourceType=S={}));function y(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}t.$Gl=(0,a.$Ai)("IUserDataProfilesService");function u(e,n){return{id:e.id,isDefault:e.isDefault,name:e.name,shortName:e.shortName,icon:e.icon,location:L.URI.revive(e.location).with({scheme:n}),globalStorageHome:L.URI.revive(e.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(e.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(e.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(e.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(e.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(e.extensionsResource).with({scheme:n}),cacheHome:L.URI.revive(e.cacheHome).with({scheme:n}),useDefaultFlags:e.useDefaultFlags,isTransient:e.isTransient}}function i(e,n,r,h,E,N){return{id:e,name:n,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:N&&E?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$bh)(r,"globalStorage"),settingsResource:N&&E?.useDefaultFlags?.settings?N.settingsResource:(0,k.$bh)(r,"settings.json"),keybindingsResource:N&&E?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$bh)(r,"keybindings.json"),tasksResource:N&&E?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$bh)(r,"tasks.json"),snippetsHome:N&&E?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$bh)(r,"snippets"),extensionsResource:N&&E?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$bh)(r,"extensions.json"),cacheHome:(0,k.$bh)(h,e),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let o=class extends v.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,h,E){super(),this.t=n,this.u=r,this.w=h,this.y=E,this.f=!0,this.h=this.B(new O.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,k.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,m.$ag)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}r.push(i((0,k.$$g)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},n))}}catch(N){this.y.error(N)}const h=new $.$Ac,E=new Map;if(r.length)try{const N=this.Q();if(N.workspaces)for(const[A,D]of Object.entries(N.workspaces)){const C=L.URI.parse(A),M=r.find(J=>J.id===D);M&&h.set(C,M)}if(N.emptyWindows)for(const[A,D]of Object.entries(N.emptyWindows)){const C=r.find(M=>M.id===D);C&&E.set(A,C)}}catch(N){this.y.error(N)}this.z={profiles:r,workspaces:h,emptyWindows:E}}return this.z}D(){const n=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",h=new RegExp(`${(0,g.$df)(r)}\\s(\\d+)`);let E=0;for(const A of this.profiles){const D=h.exec(A.name),C=D?parseInt(D[1]):0;E=C>E?C:E}const N=`${r} ${E+1}`;return this.createProfile((0,P.$oj)((0,d.$Wg)()).toString(16),N,{transient:!0},n)}async createNamedProfile(n,r,h){return this.createProfile((0,P.$oj)((0,d.$Wg)()).toString(16),n,r,h)}async createProfile(n,r,h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(n,r,h);return E&&await this.setProfileForWorkspace(E,N),N}async F(n,r,h){if(!(0,m.$ag)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{if(this.profiles.find(C=>C.name===r||C.id===n))throw new Error(`Profile with ${r} name already exists`);const A=i(n,r,(0,k.$bh)(this.profilesHome,n),this.g,h,this.defaultProfile);await this.u.createFolder(A.location);const D=[];return this.j.fire({profile:A,join(C){D.push(C)}}),await R.Promises.settled(D),this.I([A],[],[]),A}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(E=>E.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);return h=i(h.id,r.name??h.name,h.location,this.g,{shortName:r.shortName??h.shortName,icon:r.icon===null?void 0:r.icon??h.icon,transient:r.transient??h.isTransient,useDefaultFlags:r.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const h=[];this.m.fire({profile:r,join(E){h.push(E)}});try{await Promise.allSettled(h)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,l.$ll)(E)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(E=>E.id===r.id);if(!h)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,h)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return L.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,f.$Ki)(n)?n.uri:(0,f.$Pi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,h){const E=[...this.profiles,...n],N=[];this.s.profiles=[];for(let A of E)A.isDefault||r.some(D=>A.id===D.id)||(A=h.find(D=>A.id===D.id)??A,A.isTransient?this.s.profiles.push(A):N.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags}));this.P(N),this.z=void 0,this.J(n,r,h)}J(n,r,h){this.h.fire({added:n,removed:r,updated:h,all:this.profiles})}L(n,r,h){h=r?.isTransient?!0:h,h||this.L(n,void 0,!0);const E=this.G(n),N=h?this.s:this.C;L.URI.isUri(E)?(N.workspaces.delete(E),r&&N.workspaces.set(E,r)):(N.emptyWindows.delete(E),r&&N.emptyWindows.set(E,r)),h||this.M()}M(){const n={};for(const[h,E]of this.C.workspaces.entries())n[h.toString()]=E.id;const r={};for(const[h,E]of this.C.emptyWindows.entries())r[h.toString()]=E.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},h=this.D();if(n.workspaces)for(const[N,A]of Object.entries(n.workspaces)){const D=L.URI.parse(A);r[N]=this.w.extUri.isEqual(D,h.location)?h.id:this.w.extUri.basename(D)}const E={};if(n.emptyWindows)for(const[N,A]of Object.entries(n.emptyWindows)){const D=L.URI.parse(A);E[N]=this.w.extUri.isEqual(D,h.location)?h.id:this.w.extUri.basename(D)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};t.$Jl=o,t.$Jl=o=we([ne(0,p.$Hi),ne(1,l.$7k),ne(2,w.$El),ne(3,c.$7j)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}t.$Kl=s}),define(se[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vq=t.$tq=void 0,t.$uq=u;let y=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(e,n,r,h,E,N){super(),this.z=e,this.C=n,this.D=r,this.F=h,this.G=E,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$he),this.s=this.B(new L.$he),this.t=this.B(new L.$he),this.u=this.B(new L.$he),this.w=this.B(new L.$he),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(e){const n=await this.getTargetPlatform();return e.allTargetPlatforms.some(r=>(0,f.$_o)(r,e.allTargetPlatforms,n))}async installFromGallery(e,n={}){try{const h=(await this.installGalleryExtensions([{extension:e,options:n}])).find(({identifier:E})=>(0,$.$Cp)(E,e.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new f.$dp(`Unknown error while installing extension ${e.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(r){throw u(r)}}async installGalleryExtensions(e){if(!this.z.isEnabled())throw new f.$dp(c.localize(0,null),f.ExtensionManagementErrorCode.NotAllowed);const n=[],r=[];return await Promise.allSettled(e.map(async({extension:h,options:E})=>{try{const N=await this.N(h,!!E?.installGivenVersion,!!E?.installPreReleaseVersion,E.productVersion??{version:this.G.version,date:this.G.date});r.push({...N,options:E})}catch(N){n.push({identifier:h.identifier,operation:f.InstallOperation.Install,source:h,error:N})}})),r.length&&n.push(...await this.I(r)),n}async uninstall(e,n={}){return this.F.trace("ExtensionManagementService#uninstall",e.identifier.id),this.P(e,n)}async toggleAppliationScope(e,n){if((0,w.$Zm)(e.manifest)||e.isBuiltin)return e;if(e.isApplicationScoped){let r=await this.updateMetadata(e,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(r=await this.$(e,this.H.defaultProfile.extensionsResource,n));for(const h of this.H.profiles){const E=(await this.getInstalled(w.ExtensionType.User,h.extensionsResource)).find(N=>(0,$.$Cp)(N.identifier,e.identifier));E?this.w.fire(E):this.u.fire({identifier:e.identifier,profileLocation:h.extensionsResource})}return r}else{const r=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(e,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(e,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:r.identifier,operation:f.InstallOperation.Install,local:r,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),r}}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.g||e-this.h>1e3*60*5)&&(this.g=this.W(),this.h=e),this.g}registerParticipant(e){this.y.push(e)}async I(e){const n=new Map,r=new Map,h=[],E=(A,D)=>`${$.$Dp.create(A).toString()}-${D.toString()}`,N=(A,D,C,M)=>{const J=this.Y(A,D,C),ae=`${(0,$.$Hp)(A.publisher,A.name)}-${C.profileLocation.toString()}`;r.set(ae,{task:J,root:M}),this.n.fire({identifier:J.identifier,source:D,profileLocation:C.profileLocation}),this.F.info("Installing extension:",J.identifier.id,C.profileLocation.toString()),a.URI.isUri(D)||this.j.set(E(D,C.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:A,extension:D,options:C}of e){const M=C.isApplicationScoped||C.isBuiltin||(0,w.$Zm)(A),J={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!a.URI.isUri(D),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},ae=a.URI.isUri(D)?void 0:this.j.get(E(D,J.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,J.profileLocation.toString()),h.push(ae.task.waitUntilTaskIsFinished())):N(A,D,J,void 0)}return await Promise.all([...r.values()].map(async({task:A})=>{if(A.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const D=await this.M(A.identifier,A.manifest,!!A.options.installOnlyNewlyAddedFromExtensionPack,!!A.options.installPreReleaseVersion,A.options.profileLocation,A.options.productVersion),C=await this.getInstalled(void 0,A.options.profileLocation,A.options.productVersion),M={...A.options,context:{...A.options.context,[f.$6o]:!0}};for(const{gallery:J,manifest:ae}of(0,P.$Mb)(D,({gallery:ie})=>ie.identifier.id)){if(r.has(`${J.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const ie=this.j.get(E(J,M.profileLocation));if(ie){if(this.J(A,ie.task)){const ce=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ce.id,A.identifier.id,M.profileLocation.toString()),ie.waitingTasks.push(A),h.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,ue=>ue.some(le=>(0,$.$Cp)(le.identifier,ce)))).then(ue=>{if(this.F.info("Finished waiting for already requested installing extension",ce.id,A.identifier.id,M.profileLocation.toString()),!ue.find(H=>(0,$.$Cp)(H.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else C.some(({identifier:ce})=>(0,$.$Cp)(ce,J.identifier))||N(ae,J,M,A)}}catch(D){if(a.URI.isUri(A.source))(0,P.$Lb)(A.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",A.identifier.id,D.message),(0,P.$Lb)(A.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",A.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),D}})),await this.L([...r.entries()].map(async([A,{task:D}])=>{const C=new Date().getTime();let M;try{M=await D.run(),await this.L(this.y.map(J=>J.postInstall(M,D.source,D.options,v.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(J){const ae=u(J);throw a.URI.isUri(D.source)||i(this.C,D.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Kp)(D.source),error:ae,source:D.options.context?.[f.$5o]}),n.set(A,{error:ae,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,k.$0)(ae),D.options.profileLocation.toString()),ae}if(!a.URI.isUri(D.source)){const J=D.operation===f.InstallOperation.Update,ae=J?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(i(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Kp)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:ae,source:D.options.context?.[f.$5o]}),p.$o&&D.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,f.StatisticType.Install)}catch{}}n.set(A,{local:M,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:M.isApplicationScoped})})),h.length&&await this.L(h),[...n.values()]}catch(A){const D=(J,ae,ie)=>{const ce=[];J.manifest.extensionDependencies?.length&&ce.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ce.push(...J.manifest.extensionPack);for(const ue of ce){if(ie.includes(ue.toLowerCase()))continue;ie.push(ue.toLowerCase());const le=n.get(`${ue.toLowerCase()}-${ae.toString()}`);le?.local&&(ie=D(le.local,ae,ie))}return ie},C=J=>({identifier:J.identifier,operation:f.InstallOperation.Install,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:A}),M=[];for(const[J,{task:ae,root:ie}]of r){const ce=n.get(J);ce?ce.local&&ie&&!n.get(`${ie.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(M.push(this.Z(ce.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(J,C(ae))):(ae.cancel(),n.set(J,C(ae)))}for(const[J,{task:ae}]of r){const ie=n.get(J);if(!ie?.local||ae.options.donotIncludePackAndDependencies)continue;D(ie.local,ae.options.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ue=>r.has(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!n.get(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(M.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(J,C(ae)))}throw M.length&&await Promise.allSettled(M.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,k.$0)(ae))}})),A}finally{for(const{task:A}of r.values())A.source&&!a.URI.isUri(A.source)&&this.j.delete(E(A.source,A.options.profileLocation));if(n.size){const A=[...n.values()];for(const D of A)D.local&&this.F.info("Extension installed successfully:",D.identifier.id,D.profileLocation.toString());this.s.fire(A)}}}J(e,n){for(const[,{task:r,waitingTasks:h}]of this.j.entries())if(r===e&&(h.includes(n)||h.some(E=>this.J(E,n)))||r===n&&h[0]&&!this.J(e,h[0]))return!1;return!0}async L(e,n){const r=[],h=[],E=await Promise.allSettled(e);for(const A of E)A.status==="fulfilled"?r.push(A.value):h.push(u(A.reason,n));if(!h.length)return r;if(h.length===1)throw h[0];let N=new f.$dp("",f.ExtensionManagementErrorCode.Unknown);for(const A of h)N=new f.$dp(N.message?`${N.message}, ${A.message}`:A.message,A.code!==f.ExtensionManagementErrorCode.Unknown&&A.code!==f.ExtensionManagementErrorCode.Internal?A.code:N.code);throw N}async M(e,n,r,h,E,N){if(!this.z.isEnabled())return[];const A=await this.getInstalled(void 0,E,N),D=[],C=[],M=async(J,ae)=>{D.push(J);const ie=ae.extensionDependencies||[],ce=[...ie];if(ae.extensionPack){const ue=r?A.find(le=>(0,$.$Cp)(le.identifier,J)):void 0;for(const le of ae.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(H=>(0,$.$Cp)({id:H},{id:le}))||ce.every(H=>!(0,$.$Cp)({id:H},{id:le}))&&ce.push(le)}if(ce.length){const ue=ce.filter(le=>D.every(H=>!(0,$.$Cp)(H,{id:le})));if(ue.length){const le=await this.z.getExtensions(ue.map(H=>({id:H,preRelease:h})),v.CancellationToken.None);for(const H of le){if(D.find(U=>(0,$.$Cp)(U,H.identifier)))continue;const _=ie.some(U=>(0,$.$Cp)({id:U},H.identifier));let B;try{B=await this.N(H,!1,h,N)}catch(U){if(_)throw U;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,k.$0)(U));continue}C.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(e,n),C}async N(e,n,r,h){let E;const N=await this.getExtensionsControlManifest();if(N.malicious.some(C=>(0,$.$Cp)(e.identifier,C)))throw new f.$dp(c.localize(1,null,e.identifier.id),f.ExtensionManagementErrorCode.Malicious);const A=N.deprecated[e.identifier.id.toLowerCase()];if(A?.extension?.autoMigrate){if(this.F.info(`The '${e.identifier.id}' extension is deprecated, fetching the compatible '${A.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:A.extension.id,preRelease:A.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},v.CancellationToken.None))[0],!E)throw new f.$dp(c.localize(2,null,e.identifier.id,A.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(e)){const C=await this.getTargetPlatform();throw new f.$dp(c.localize(3,null,e.identifier.id,this.G.nameLong,(0,f.$8o)(C)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(e,n,r,h),!E)throw!r&&e.properties.isPreReleaseVersion&&(await this.z.getExtensions([e.identifier],v.CancellationToken.None))[0]?new f.$dp(c.localize(4,null,e.displayName??e.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$dp(c.localize(5,null,e.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const D=await this.z.getManifest(E,v.CancellationToken.None);if(D===null)throw new f.$dp(`Missing manifest for extension ${E.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(D.version!==E.version)throw new f.$dp(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:D}}async O(e,n,r,h){const E=await this.getTargetPlatform();let N=null;return!n&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==r&&(N=(await this.z.getExtensions([{...e.identifier,preRelease:r}],{targetPlatform:E,compatible:!0,productVersion:h},v.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(e,r,E,h)&&(N=e),N||(n?N=(await this.z.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:E,compatible:!0,productVersion:h},v.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(e,r,E,h)),N}async P(e,n){const r={...n,profileLocation:e.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},h=M=>`${M.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,E=this.m.get(h(e.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",e.identifier.id),E.waitUntilTaskIsFinished();const N=M=>{const J=this.Z(M,r);return this.m.set(h(J.extension.identifier),J),r.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped}),J},A=(M,J)=>{J?r.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,J.message):r.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Jp)(M),error:J}),this.u.fire({identifier:M.identifier,error:J?.code,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],C=[];try{D.push(N(e));const M=await this.getInstalled(w.ExtensionType.User,r.profileLocation);if(r.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const J=this.S(e,M);for(const ae of J)this.m.has(h(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):D.push(N(ae))}r.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.Q(D.map(J=>J.extension),M,e),await this.L(D.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ae=>ae.postUninstall(J.extension,r,v.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,f.StatisticType.Uninstall)}catch{}A(J.extension)}catch(ae){const ie=u(ae);throw A(J.extension,ie),ie}finally{C.push(J)}}))}catch(M){const J=u(M);for(const ae of D){try{ae.cancel()}catch{}C.includes(ae)||A(ae.extension,J)}throw J}finally{for(const M of D)this.m.delete(h(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(e,n,r){for(const h of e){const E=this.U(h,n);if(E.length){const N=E.filter(A=>!e.some(D=>(0,$.$Cp)(D.identifier,A.identifier)));if(N.length)throw new Error(this.R(h,N,r))}}}R(e,n,r){return r===e?n.length===1?c.localize(6,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(7,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(8,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?c.localize(9,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(10,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(11,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(e,n,r=[]){if(r.indexOf(e)!==-1)return[];r.push(e);const h=e.manifest.extensionPack?e.manifest.extensionPack:[];if(h.length){const E=n.filter(A=>!A.isBuiltin&&h.some(D=>(0,$.$Cp)({id:D},A.identifier))),N=[];for(const A of E)N.push(...this.S(A,n,r));return[...E,...N]}return[]}U(e,n){return n.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(h=>(0,$.$Cp)({id:h},e.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(e){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$0)(e)),{malicious:[],deprecated:{},search:[]}}}};t.$tq=y,t.$tq=y=we([ne(0,f.$bp),ne(1,g.$6l),ne(2,m.$El),ne(3,R.$7j),ne(4,d.$nk),ne(5,S.$Gl)],y);function u(s,e){if(s instanceof f.$dp)return s;let n;return s instanceof f.$cp?n=new f.$dp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):n=new f.$dp(s.message,(0,k.$4)(s)?f.ExtensionManagementErrorCode.Cancelled:e??f.ExtensionManagementErrorCode.Internal),n.stack=s.stack,n}function i(s,e,{extensionData:n,verificationStatus:r,duration:h,error:E,source:N,durationSinceUpdate:A}){let D,C;(0,l.$ig)(r)&&(r===!0?r="Verified":(r===!1||(D=f.ExtensionManagementErrorCode.Signature,C=r),r="Unverified")),E&&(D=E.code,E.code===f.ExtensionManagementErrorCode.Signature&&(C=E.message)),s.publicLog(e,{...n,verificationStatus:r,success:!E,duration:h,errorcode:D,errorcodeDetail:C,durationSinceUpdate:A,source:N})}class o{constructor(){this.d=new O.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,O.$nh)(e=>this.h(e))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$nh)(e=>new Promise((n,r)=>{const h=e.onCancellationRequested(()=>{h.dispose(),r(new k.$5)})})),this.d.open()),this.g.cancel()}}t.$vq=o}),define(se[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yq=t.$xq=t.$wq=t.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(t.ExtensionsProfileScanningErrorCode=m={}));class S extends Error{constructor(s,e){super(s),this.code=e}}t.$wq=S,t.$xq=(0,c.$Ai)("IExtensionsProfileScannerService");let y=class extends v.$Uc{constructor(s,e,n,r,h,E){super(),this.j=s,this.m=e,this.n=n,this.r=r,this.s=h,this.t=E,this.b=this.B(new k.$he),this.onAddExtensions=this.b.event,this.c=this.B(new k.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$he),this.onDidRemoveExtensions=this.g.event,this.h=new L.$Ac}scanProfileExtensions(s,e){return this.u(s,void 0,e)}async addExtensionsToProfile(s,e,n){const r=[],h=[];try{return await this.u(e,E=>{const N=[];if(n)N.push(...E);else for(const A of E)s.some(([D])=>(0,l.$Cp)(D.identifier,A.identifier)&&D.manifest.version!==A.version)?r.push(A):N.push(A);for(const[A,D]of s){const C=N.findIndex(J=>(0,l.$Cp)(J.identifier,A.identifier)&&J.version===A.manifest.version),M={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:D};C===-1?(h.push(M),N.push(M)):N.splice(C,1,M)}return h.length&&this.b.fire({extensions:h,profileLocation:e}),r.length&&this.f.fire({extensions:r,profileLocation:e}),N}),h.length&&this.c.fire({extensions:h,profileLocation:e}),r.length&&this.g.fire({extensions:r,profileLocation:e}),h}catch(E){throw h.length&&this.c.fire({extensions:h,error:E,profileLocation:e}),r.length&&this.g.fire({extensions:r,error:E,profileLocation:e}),E}}async updateMetadata(s,e){const n=[];return await this.u(e,r=>{const h=[];for(const E of r){const N=s.find(([A])=>(0,l.$Cp)(A.identifier,E.identifier)&&A.manifest.version===E.version);N&&(E.metadata={...E.metadata,...N[1]},n.push(E)),h.push(E)}return h}),n}async removeExtensionFromProfile(s,e){const n=[];try{await this.u(e,r=>{const h=[];for(const E of r)(0,l.$Cp)(E.identifier,s.identifier)?n.push(E):h.push(E);return n.length&&this.f.fire({extensions:n,profileLocation:e}),h}),n.length&&this.g.fire({extensions:n,profileLocation:e})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:e}),r}}async u(s,e,n){return this.F(s).queue(async()=>{let r=[],h;try{const E=await this.m.readFile(s);h=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,a.$ll)(E)!==a.FileOperationResult.FILE_NOT_FOUND)throw E;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&n?.bailOutWhenFileNotFound)throw new S((0,d.$0)(E),m.ERROR_PROFILE_NOT_FOUND)}if(h){Array.isArray(h)||this.w(s);let E=!1;for(const N of h){u(N)||this.w(s);let A;if((0,R.$ag)(N.relativeLocation)&&N.relativeLocation)A=this.z(N.relativeLocation);else if((0,R.$ag)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{A=I.URI.revive(N.location);const D=this.y(A);D&&(E=!0,N.relativeLocation=D)}(0,R.$hg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(E=!0,N.metadata.hasPreReleaseVersion=!0),r.push({identifier:N.identifier,location:A,version:N.version,metadata:N.metadata})}E&&await this.m.writeFile(s,O.$Je.fromString(JSON.stringify(h)))}if(e){r=e(r);const E=r.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(s,O.$Je.fromString(JSON.stringify(E)))}return r})}w(s){const e=new S(`Invalid extensions content in ${s.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:e.code}),e}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),e=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(s)).value.toString()}catch(h){if((0,a.$ll)(h)===a.FileOperationResult.FILE_NOT_FOUND)return;throw h}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const h=JSON.parse(n);Array.isArray(h)&&h.every(E=>u(E))?r=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$Je.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,a.$ll)(h)===a.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(s)}catch(h){(0,a.$ll)(h)!==a.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}try{await this.m.del(e)}catch(h){(0,a.$ll)(h)!==a.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}return r})()),this.C}F(s){let e=this.h.get(s);return e||(e=new P.$Hh,this.h.set(s,e)),e}};t.$yq=y,t.$yq=y=we([ne(1,a.$7k),ne(2,$.$Gl),ne(3,w.$El),ne(4,g.$6l),ne(5,f.$7j)],y);function u(o){return(0,R.$cg)(o)&&(0,p.$ap)(o.identifier)&&(i(o.location)||(0,R.$ag)(o.location)&&o.location)&&((0,R.$hg)(o.relativeLocation)||(0,R.$ag)(o.relativeLocation))&&o.version&&(0,R.$ag)(o.version)}function i(o){return o?(0,R.$ag)(o.path)&&(0,R.$ag)(o.scheme):!1}}),define(se[54],oe([0,1,20,8,28,14,9,34,86,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u,i,o,s,e,n,r,h,E,N,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fq=t.$Dq=t.$Cq=t.$Bq=t.Translations=void 0,t.$Eq=ce;var C;(function(le){function H(_,B){if(_===B)return!0;const U=Object.keys(_),G=new Set;for(const Z of Object.keys(B))G.add(Z);if(U.length!==G.size)return!1;for(const Z of U){if(_[Z]!==B[Z])return!1;G.delete(Z)}return G.size===0}le.equals=H})(C||(t.Translations=C={})),t.$Bq=(0,s.$Ai)("IExtensionsScannerService");let M=class extends l.$Uc{constructor(H,_,B,U,G,Z,Y,F,z,x,V,b){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=_,this.r=B,this.s=U,this.t=G,this.u=Z,this.w=Y,this.y=F,this.z=z,this.C=x,this.D=V,this.F=b,this.g=this.B(new r.$he),this.onDidChangeCache=this.g.event,this.h=(0,$.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ae,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(u.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(u.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Np)(this.w,this.y)),this.G}async scanAllExtensions(H,_,B){const[U,G]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(_)]),Z=B?await this.scanExtensionsUnderDevelopment(H,[...U,...G]):[];return this.L(U,G,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const _=[];_.push(this.M(!!H.useCache,H.language)),_.push(this.N(H.language,!!H.checkControlFile));const[B,U]=await Promise.all(_);return this.J([...B,...U],u.ExtensionType.System,H,!1)}async scanUserExtensions(H){const _=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!H.profileLocation,u.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),G=H.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let Z;try{Z=await G.scanExtensions(U)}catch(Y){if(Y instanceof E.$wq&&Y.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Z=await G.scanExtensions(U);else throw Y}return Z=await this.J(Z,u.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(H,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===a.Schemas.file).map(async U=>{const G=await this.P(U,!1,u.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(Y=>(Y.type=_.find(F=>(0,y.$Cp)(F.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,G)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,_,B){const U=await this.P(H,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanExtension(U);return!G||!B.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(H,_,B){const U=await this.P(H,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(U);return this.J(G,_,B,!0)}async scanMultipleExtensions(H,_,B){const U=[];return await Promise.all(H.map(async G=>{const Z=await this.scanOneOrMultipleExtensions(G,_,B);U.push(...Z)})),this.J(U,_,B,!0)}async scanMetadata(H){const _=(0,$.$bh)(H,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,_){const B=(0,$.$bh)(H,"package.json"),U=(await this.w.readFile(B)).value.toString(),G=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,G.__metadata={...G.__metadata,..._},await this.w.writeFile((0,$.$bh)(H,"package.json"),k.$Je.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof E.$wq&&H.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Je.fromString(JSON.stringify([])))}catch(_){(0,o.$ll)(_)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$0)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,_,B,U){return B.includeAllVersions||(H=this.L(_===u.ExtensionType.System?H:void 0,_===u.ExtensionType.User?H:void 0,_==="development"?H:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(H=H.filter(G=>G.isValid)),H.sort((G,Z)=>{const Y=c.$nc(G.location.fsPath),F=c.$nc(Z.location.fsPath);return Y<F?-1:Y>F?1:0})}L(H,_,B,U,G){const Z=(F,z,x)=>{if(F.isValid&&!z.isValid)return!1;if(F.isValid===z.isValid){if(G&&w.gt(F.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(w.eq(F.manifest.version,z.manifest.version)){if(F.type===u.ExtensionType.System)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===U)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return x?this.y.warn(`Overwriting user extension ${F.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${F.location.path} with ${z.location.path}.`),!0},Y=new u.$Ym;return H?.forEach(F=>{const z=Y.get(F.identifier.id);(!z||Z(z,F,!1))&&Y.set(F.identifier.id,F)}),_?.forEach(F=>{const z=Y.get(F.identifier.id);if(!z&&H&&F.type===u.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!z||Z(z,F,!1))&&Y.set(F.identifier.id,F)}),B?.forEach(F=>{const z=Y.get(F.identifier.id);(!z||Z(z,F,!0))&&Y.set(F.identifier.id,F),Y.set(F.identifier.id,F)}),[...Y.values()]}async M(H,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,_,!0,void 0,this.R()),G=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",G.length),G}async N(H,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},G=[],Z=g.URI.file(c.$hc(c.$jc(a.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of B){const z=U[F.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":G.push((0,$.$bh)(Z,F.name));break;default:G.push(g.URI.file(z));break}}const Y=await Promise.all(G.map(async F=>this.n.scanExtension(await this.P(F,!1,u.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,P.$Hb)(Y)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,_,B,U,G,Z,Y,F){const z=await this.f(G??f.$w),x=await this.Q(H),V=_&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=V?await this.Q(V):void 0;return new J(H,x,V,b,_,Y,B,U,Z,F.version,F.date,this.C.commit,!this.z.isBuilt,G,z)}async Q(H){try{const _=await this.w.stat(H);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Cq=M,t.$Cq=M=we([ne(4,N.$Gl),ne(5,E.$xq),ne(6,o.$7k),ne(7,e.$7j),ne(8,S.$Hi),ne(9,n.$nk),ne(10,A.$El),ne(11,s.$zi)],M);class J{constructor(H,_,B,U,G,Z,Y,F,z,x,V,b,T,j,q){this.location=H,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=G,this.profileScanOptions=Z,this.type=Y,this.excludeObsolete=F,this.validate=z,this.productVersion=x,this.productDate=V,this.productCommit=b,this.devMode=T,this.language=j,this.translations=q}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,_){return(0,$.$7g)(H.location,_.location)&&H.mtime===_.mtime&&(0,$.$7g)(H.applicationExtensionslocation,_.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&H.profile===_.profile&&v.$ao(H.profileScanOptions,_.profileScanOptions)&&H.type===_.type&&H.excludeObsolete===_.excludeObsolete&&H.validate===_.validate&&H.productVersion===_.productVersion&&H.productDate===_.productDate&&H.productCommit===_.productCommit&&H.devMode===_.devMode&&H.language===_.language&&C.equals(H.translations,_.translations)}}t.$Dq=J;let ae=class extends l.$Uc{constructor(H,_,B,U,G){super(),this.f=H,this.g=_,this.h=B,this.j=U,this.m=G}async scanExtensions(H){const _=H.profile?await this.r(H):await this.n(H);let B={};if(H.excludeObsolete&&H.type===u.ExtensionType.User)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,d.$ng)(B)?_:_.filter(U=>!B[y.$Dp.create(U).toString()])}async n(H){const _=await this.j.resolve(H.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||H.type===u.ExtensionType.User&&(0,$.$$g)(U.resource).indexOf(".")===0)return null;const G=new J(U.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(G)}));return(0,P.$Hb)(B).sort((U,G)=>U.location.path<G.location.path?-1:1)}async r(H){let _=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(H.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,H);_.push(...B)}return _}async s(H,_,B){const U=await this.g.scanProfileExtensions(H,B.profileScanOptions);if(!U.length)return[];const G=await Promise.all(U.map(async Z=>{if(_(Z)){const Y=new J(Z.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Z.metadata)}return null}));return(0,P.$Hb)(G)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,$.$bh)(H.location,"package.json"))){const _=await this.scanExtension(H);return _?[_]:[]}else return await this.scanExtensions(H)}catch(_){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,L.$0)(_)),[]}}async scanExtension(H,_){try{let B=await this.scanExtensionManifest(H.location);if(B){B.publisher||(B.publisher=u.$Sm),_=_??B.__metadata,delete B.__metadata;const U=(0,y.$Hp)(B.publisher,B.name),G=_?.id?{id:U,uuid:_.id}:{id:U},Z=_?.isSystem?u.ExtensionType.System:H.type,Y=Z===u.ExtensionType.System||!!_?.isBuiltin;B=await this.t(H.location,B,J.createNlsConfiguration(H));const F={type:Z,identifier:G,manifest:B,location:H.location,isBuiltin:Y,targetPlatform:_?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return H.validate?this.validate(F,H):F}}catch(B){H.type!==u.ExtensionType.System&&this.m.error(B)}return null}validate(H,_){let B=!0;const U=(0,i.$Sp)(_.productVersion,_.productDate,_.location,H.manifest,H.isBuiltin);for(const[G,Z]of U)G===R.default.Error&&(B=!1,this.m.error(this.z(_.location,Z)));return H.isValid=B,H.validations=U,H}async scanExtensionManifest(H){const _=(0,$.$bh)(H,"package.json");let B;try{B=(await this.j.readFile(_)).value.toString()}catch(G){return(0,o.$ll)(G)!==o.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(H,(0,m.localize)(0,null,_.path,G.message))),null}let U;try{U=JSON.parse(B)}catch{const Z=[];(0,I.$Pn)(B,Z);for(const Y of Z)this.m.error(this.z(H,(0,m.localize)(1,null,_.path,Y.offset,Y.length,(0,p.$zq)(Y.error))));return null}return(0,I.$Yn)(U)!=="object"?(this.m.error(this.z(H,(0,m.localize)(2,null,_.path))),null):U}async t(H,_,B){const U=await this.u(H,_,B);if(U)try{const G=[],Z=await this.w(U.default,G);if(G.length>0)return G.forEach(F=>{this.m.error(this.z(H,(0,m.localize)(3,null,U.default?.path,(0,p.$zq)(F.error))))}),_;if((0,I.$Yn)(U)!=="object")return this.m.error(this.z(H,(0,m.localize)(4,null,U.default?.path))),_;const Y=U.values||Object.create(null);return(0,D.$Aq)(this.m,_,Y,Z)}catch{}return _}async u(H,_,B){const U=(0,$.$bh)(H,"package.nls.json"),G=(z,x)=>{x.forEach(V=>{this.m.error(this.z(H,(0,m.localize)(5,null,z?.path,(0,p.$zq)(V.error))))})},Z=z=>{this.m.error(this.z(H,(0,m.localize)(6,null,z?.path)))},Y=`${_.publisher}.${_.name}`,F=B.translations[Y];if(F)try{const z=g.URI.file(F),x=(await this.j.readFile(z)).value.toString(),V=[],b=(0,I.$Pn)(x,V);return V.length>0?(G(z,V),{values:void 0,default:U}):(0,I.$Yn)(b)!=="object"?(Z(z),{values:void 0,default:U}):{values:b.contents?b.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let x;try{x=await this.y(H,B)}catch{return}if(!x.localized)return{values:void 0,default:x.original};try{const V=(await this.j.readFile(x.localized)).value.toString(),b=[],T=(0,I.$Pn)(V,b);return b.length>0?(G(x.localized,b),{values:void 0,default:x.original}):(0,I.$Yn)(T)!=="object"?(Z(x.localized),{values:void 0,default:x.original}):{values:T,default:x.original}}catch{return{values:void 0,default:x.original}}}}async w(H,_){if(H)try{const B=(await this.j.readFile(H)).value.toString();return(0,I.$Pn)(B,_)}catch{}}y(H,_){return new Promise((B,U)=>{const G=Z=>{const Y=(0,$.$bh)(H,`package.nls.${Z}.json`);this.j.exists(Y).then(F=>{F&&B({localized:Y,original:(0,$.$bh)(H,"package.nls.json")});const z=Z.lastIndexOf("-");z===-1?B({localized:(0,$.$bh)(H,"package.nls.json"),original:null}):(Z=Z.substring(0,z),G(Z))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,$.$bh)(H,"package.nls.json"),original:null});G(_.language)})}z(H,_){return`[${H.path}]: ${_}`}};ae=we([ne(1,E.$xq),ne(2,A.$El),ne(3,o.$7k),ne(4,e.$7j)],ae);let ie=class extends ae{constructor(H,_,B,U,G,Z,Y){super(_,U,G,Z,Y),this.G=H,this.H=B,this.D=this.B(new O.$yh(3e3)),this.F=this.B(new r.$he),this.onDidChangeCache=this.F.event}async scanExtensions(H){const _=this.M(H),B=await this.I(_);if(this.C=H,B&&B.input&&J.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),B.result.map(G=>(G.location=g.URI.revive(G.location),G));const U=await super.scanExtensions(H);return await this.J(_,{input:H,result:U}),U}async I(H){try{const _=await this.j.readFile(H),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,h.$0h)(B.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",H.path,(0,L.$0)(_))}return null}async J(H,_){try{await this.j.writeFile(H,k.$Je.fromString(JSON.stringify(_)))}catch(B){this.m.debug("Error while writing the extension cache file:",H.path,(0,L.$0)(B))}}async L(){if(!this.C)return;const H=this.M(this.C),_=await this.I(H);if(!_)return;const B=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!v.$ao(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(H),this.F.fire()}catch(G){this.m.error(G)}}M(H){const _=this.N(H);return this.h.extUri.joinPath(_.cacheHome,H.type===u.ExtensionType.System?u.$Rm:u.$Qm)}N(H){return H.type===u.ExtensionType.System?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(H.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ie=we([ne(2,N.$Gl),ne(3,E.$xq),ne(4,A.$El),ne(5,o.$7k),ne(6,e.$7j)],ie);function ce(le,H){const _=(0,y.$Fp)(le.manifest.publisher,le.manifest.name);return{id:_,identifier:new u.$Wm(_),isBuiltin:le.type===u.ExtensionType.System,isUserBuiltin:le.type===u.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:H,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ue extends M{constructor(H,_,B,U,G,Z,Y,F,z,x,V,b){super(H,_,(0,$.$bh)(B,".vscode-oss-dev","extensions","control.json"),U,G,Z,Y,F,z,x,V,b),this.S=(async()=>{if(f.$z)try{const T=await this.w.readFile(g.URI.file(f.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}t.$Fq=ue}),define(se[160],oe([0,1,60,8,36,5,2,15,16,25,6,24]),function(Q,t,P,O,v,k,L,I,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=void 0;let f=class extends L.$Uc{constructor(w,R){super(),this.b=w,this.f=R,this.a=new O.$Gh(5)}async postUninstall(w){const R=this.g(w,"uninstall");R&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(d)}}));try{await l.Promises.rm(this.m(w))}catch(d){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(d)}}g(w,R){const d=`vscode:${R}`;if(w.location.scheme===I.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[d]=="string"){const g=w.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${d} should be a node script`),null):{script:(0,p.$jc)(w.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(w,R,d,g,m){return new Promise((S,y)=>{const u=this.j(w,R,d,m);let i;const o=s=>{i&&(clearTimeout(i),i=null),s?y(s):S(void 0)};u.on("error",s=>{o((0,v.$lj)(s)||"Unknown")}),u.on("exit",(s,e)=>{o(s?`post-${R} process exited with code ${s}`:void 0)}),g&&(i=setTimeout(()=>{i=null,u.kill(),y("timed out")},5e3))})}j(w,R,d,g){const m={silent:!0,execArgv:void 0},S=(0,P.fork)(w,[`--type=extension-post-${R}`,...d],m);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const y=k.Event.fromNodeEventEmitter(S.stdout,"data"),u=k.Event.fromNodeEventEmitter(S.stderr,"data");this.B(y(s=>this.f.info(g.identifier.id,g.manifest.version,`post-${R}`,s))),this.B(u(s=>this.f.error(g.identifier.id,g.manifest.version,`post-${R}`,s)));const i=k.Event.any(k.Event.map(y,s=>({data:`%c${s}`,format:[""]}),this.q),k.Event.map(u,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return k.Event.debounce(i,(s,e)=>s?{data:s.data+e.data,format:[...s.format,...e.format]}:{data:e.data,format:e.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(g.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),S}m(w){return(0,p.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};t.$Jq=f,t.$Jq=f=we([ne(0,c.$Gl),ne(1,a.$7j)],f)}),define(se[73],oe([0,1,49,104,53,21]),function(Q,t,P,O,v,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gq=L,t.$Hq=I;function L(p){let l=k.ExtensionManagementErrorCode.Extract;return p instanceof P.$pq&&(p.type==="CorruptZip"?l=k.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(l=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$uq)(p,l)}async function I(p){let l;try{l=await(0,P.$sq)(p,"extension/package.json")}catch(a){throw L(a)}try{return JSON.parse(l.toString("utf8"))}catch{throw new k.$dp((0,O.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(se[161],oe([0,1,8,9,2,15,17,44,3,29,25,49,30,18,53,21,27,73,72,10,6,19]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=void 0;let o=class extends v.$Uc{static{i=this}static{this.c=".sigzip"}constructor(e,n,r,h,E,N,A){super(),this.h=n,this.j=r,this.m=h,this.n=E,this.r=N,this.t=A,this.extensionsDownloadDir=e.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(e,n,r,h){await this.g;const E=await this.w(e,n);let N=!1;if(r&&this.u(e)){let A;try{A=await this.y(e)}catch(D){try{await this.delete(E)}catch(C){this.t.error(C)}throw D}try{N=await this.n.verify(e,E.fsPath,A.fsPath,h)}catch(D){if(N=D.code,N===m.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===m.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(E)}catch(C){this.t.error(C)}throw new R.$dp(c.$oq,R.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(A)}catch(D){this.t.error(D)}}}return{location:E,verificationStatus:N}}u(e){if(!e.isSigned)return this.t.info(`Extension is not signed: ${e.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,p.$gg)(n)?n:!0}async w(e,n){try{const r=(0,L.$bh)(this.extensionsDownloadDir,this.G(e)),h=await this.C(e,"vsix",async()=>{await this.z(e,r,E=>this.j.download(e,E,n));try{await this.D(r.fsPath,"extension/package.json")}catch(E){try{await this.h.del(r)}catch(N){this.t.warn(`Error while deleting: ${r.path}`,(0,O.$0)(N))}throw E}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:e.identifier.id,attempts:h}),r}catch(r){throw(0,w.$uq)(r,R.ExtensionManagementErrorCode.Download)}}async y(e){try{const n=(0,L.$bh)(this.extensionsDownloadDir,`.${(0,l.$Wg)()}`),r=await this.C(e,"sigzip",async()=>{await this.j.downloadSignatureArchive(e,n);try{await this.D(n.fsPath,".signature.p7s")}catch(h){try{await this.h.del(n)}catch(E){this.t.warn(`Error while deleting: ${n.path}`,(0,O.$0)(E))}throw h}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:e.identifier.id,attempts:r}),n}catch(n){throw(0,w.$uq)(n,R.ExtensionManagementErrorCode.DownloadSignature)}}async z(e,n,r){if(await this.h.exists(n))return;if(n.scheme!==k.Schemas.file){await r(n);return}const h=(0,L.$bh)(this.extensionsDownloadDir,`.${(0,l.$Wg)()}`);try{await r(h)}catch(E){try{await this.h.del(h)}catch{}throw E}try{await a.Promises.rename(h.fsPath,n.fsPath,2*60*1e3)}catch(E){try{await this.h.del(h)}catch{}let N=!1;try{N=await this.h.exists(n)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",e.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,O.$0)(E)}. Deleted the file from downloaded location`,h.path),E}}async C(e,n,r,h){let E=1;for(;;)try{return await r(),E}catch(N){if(E++>h)throw N;this.t.warn(`Failed downloading ${n}. ${(0,O.$0)(N)}. Retry again...`,e.identifier.id)}}async D(e,n){try{await(0,c.$sq)(e,n)}catch(r){throw(0,g.$Gq)(r)}}async delete(e){await this.g,await this.h.del(e)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const e=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const n=[],r=[],h=[];for(const A of e.children)if(A.name.endsWith(i.c))h.push(A.resource);else{const D=d.$Dp.parse(A.name);D&&r.push([D,A])}const E=(0,d.$Ip)(r,([A])=>A),N=[];for(const A of E)A.sort((D,C)=>I.rcompare(D[0].version,C[0].version)),n.push(...A.slice(1).map(D=>D[1].resource)),N.push(A[0][1]);N.sort((A,D)=>A.mtime-D.mtime),n.push(...N.slice(0,Math.max(0,N.length-this.f)).map(A=>A.resource)),n.push(...h),await P.Promises.settled(n.map(A=>(this.t.trace("Deleting from cache",A.path),this.h.del(A))))}}catch(e){this.t.error(e)}}G(e){return this.f?d.$Dp.create(e).toString().toLowerCase():(0,l.$Wg)()}};t.$Iq=o,t.$Iq=o=i=we([ne(0,$.$Ii),ne(1,S.$7k),ne(2,R.$bp),ne(3,f.$7i),ne(4,m.$hq),ne(5,u.$6l),ne(6,y.$7j)],o)}),define(se[162],oe([0,1,8,14,22,36,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,62,18,53,21,27,42,54,161,160,73,142,149,26,50,10,11,6,33,19,23,24]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u,i,o,s,e,n,r,h,E,N,A,D,C,M,J,ae,ie,ce,ue,le,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oq=t.$Nq=t.$Mq=void 0,t.$Mq=(0,ae.$Bi)(s.$ep);const _=".vsctmp";let B=class extends o.$tq{constructor(F,z,x,V,b,T,j,q,X,K,re,fe){super(F,z,re,x,K,fe),this.eb=b,this.fb=T,this.gb=j,this.hb=q,this.ib=X,this.db=new Map,this.tb=new a.$Bc;const he=this.B(q.createInstance(E.$Jq));this.ab=this.B(q.createInstance(U,me=>he.postUninstall(me))),this.bb=this.B(new A.$Kq(fe,X,re,this,this.F)),this.cb=this.B(q.createInstance(h.$Iq));const ve=this.B(new D.$Lq(this,this.eb,fe,T,re,X,x));this.B(ve.onDidChangeExtensionsByAnotherSource(me=>this.sb(me))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,e.$Np)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.rb(F),x=await(0,S.zip)((0,$.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)()).fsPath,z);return d.URI.file(x)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:x}=await this.lb(F),V=f.$kc(z.fsPath);try{return await(0,N.$Hq)(V)}finally{await x()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource,x={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,z,x)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:x,cleanup:V}=await this.lb(F);try{const b=await(0,N.$Hq)(f.$kc(x.fsPath)),T=(0,e.$Hp)(b.publisher,b.name);if(b.engines&&b.engines.vscode&&!(0,M.$Up)(b.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,T,this.G.version));const q=(await this.I([{manifest:b,extension:x,options:z}])).find(({identifier:X})=>(0,e.$Cp)(X,{id:T}));if(q?.local)return q.local;throw q?.error?q.error:(0,o.$uq)(new Error(`Unknown error while installing extension ${T}`))}finally{await V()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const x=await this.ab.scanUserExtensionAtLocation(F);if(!x||!x.manifest.name||!x.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.wb([[x,{source:"resource"}]],z),this.F.info("Successfully installed extension",x.identifier.id,z.toString()),x}async installExtensionsFromProfile(F,z,x){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),x.toString());const V=(await this.getInstalled(C.ExtensionType.User,z)).filter(b=>F.some(T=>(0,e.$Cp)(T,b.identifier)));if(V.length){const b=await Promise.all(V.map(T=>this.ab.scanMetadata(T,z)));await this.wb(V.map((T,j)=>[T,b[j]]),x),this.F.info("Successfully installed extensions",V.map(T=>T.identifier.id),x.toString())}return V}async updateMetadata(F,z,x=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),F=await this.ab.updateMetadata(F,z,x),this.bb.invalidate(x),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const z=await this.getTargetPlatform(),[x]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},v.CancellationToken.None);if(!x)throw new Error(y.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(V){throw new Error(y.localize(3,null,(0,k.$lj)(V)))}return this.installFromGallery(x)}$(F,z,x,V){return this.ab.copyExtension(F,z,x,V)}copyExtensions(F,z){return this.ab.copyExtensions(F,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,x){const{location:V}=await this.cb.download(F,z,!x);return V}async lb(F){if(F.scheme===c.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,$.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)());return await this.gb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,z,x){const V=z instanceof d.URI?new e.$Dp({id:(0,e.$Hp)(F.publisher,F.name)},F.version):e.$Dp.create(z);return this.hb.createInstance(G,V,F,z,x,(b,T)=>{if(z instanceof d.URI)return this.qb(V,z,x,T);let j=this.db.get(V.toString());return j||(this.db.set(V.toString(),j=this.pb(V,z,b,x,T)),j.finally(()=>this.db.delete(V.toString()))),j},this.ab)}Z(F,z){return new Z(F,z.profileLocation,this.fb)}async pb(F,z,x,V,b){const{verificationStatus:T,location:j}=await this.cb.download(z,x,!V.donotVerifySignature,V.context?.[s.$7o]);try{if(b.isCancellationRequested)throw new L.$5;return await(0,N.$Hq)(j.fsPath),{local:await this.ab.extractUserExtension(F,j.fsPath,{id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,R.$gg)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||z.properties.isPreReleaseVersion,source:"gallery"},!1,b),verificationStatus:T}}catch(q){try{await this.cb.delete(j)}catch(X){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,L.$0)(X))}throw(0,o.$uq)(q)}}async qb(F,z,x,V){return{local:await this.ab.extractUserExtension(F,f.$kc(z.fsPath),{isApplicationScoped:x.isApplicationScoped,isMachineScoped:x.isMachineScoped,isBuiltin:x.isBuiltin,installedTimestamp:Date.now(),pinned:x.installGivenVersion?!0:!!x.pinned,source:"vsix"},!0,V)}}async rb(F){const z=async V=>{let b=await m.Promises.readdir(V);b=b.map(q=>f.$jc(V,q));const T=await Promise.all(b.map(q=>m.Promises.stat(q)));let j=Promise.resolve([]);return T.forEach((q,X)=>{const K=b[X];q.isFile()&&(j=j.then(re=>[...re,K])),q.isDirectory()&&(j=j.then(re=>z(K).then(fe=>[...re,...fe])))}),j};return(await z(F.location.fsPath)).map(V=>({path:`extension/${f.$lc(F.location.fsPath,V)}`,localPath:V}))}async sb({added:F,removed:z}){if(z){const x=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(V=>F.extensions.every(b=>!(0,e.$Cp)(b,V))):z.extensions;for(const V of x)this.F.info("Extensions removed from another source",V.id,z.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:z.profileLocation})}if(F){const V=(await this.getInstalled(C.ExtensionType.User,F.profileLocation)).filter(b=>F.extensions.some(T=>(0,e.$Cp)(T,b.identifier)));this.s.fire(V.map(b=>(this.F.info("Extensions added from another source",b.identifier.id,F.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:F.profileLocation,operation:s.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(z=>this.tb.add(z)));const F=await this.ib.resolve(this.eb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.tb.add(z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.vb(z)))}async vb(F){if(!F.affects(this.eb.userExtensionsLocation,J.FileChangeType.ADDED))return;const z=[];for(const x of F.rawAdded){if(this.tb.has(x)||!this.D.extUri.isEqual(this.D.extUri.dirname(x),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(x,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(x).startsWith(".")||!(await this.ib.stat(x)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(x);V&&V.installedTimestamp===void 0&&(this.tb.add(x),z.push(V))}z.length&&(await this.wb(z.map(x=>[x,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(x=>x.identifier.id)))}async wb(F,z){const x=F.map(V=>V[0]);await this.xb(x),await this.fb.addExtensionsToProfile(F,z),this.s.fire(x.map(V=>({local:V,identifier:V.identifier,operation:s.InstallOperation.None,profileLocation:z})))}async xb(F){const z=await this.ab.getUninstalledExtensions();for(const x of F){const V=e.$Dp.create(x);z[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};t.$Nq=B,t.$Nq=B=we([ne(0,s.$bp),ne(1,ue.$6l),ne(2,ie.$7j),ne(3,i.$Ii),ne(4,r.$Bq),ne(5,n.$xq),ne(6,u.$Ro),ne(7,ae.$zi),ne(8,J.$7k),ne(9,ce.$nk),ne(10,le.$El),ne(11,H.$Gl)],B);let U=class extends l.$Uc{constructor(F,z,x,V,b,T){super(),this.j=F,this.m=z,this.n=x,this.s=V,this.t=b,this.u=T,this.h=this.B(new I.$he),this.onExtract=this.h.event,this.c=(0,$.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new P.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z,x){try{const V={includeInvalid:!0,profileLocation:z,productVersion:x};let b=[];return F===null||F===C.ExtensionType.System?b.push(...await this.n.scanAllExtensions({includeInvalid:!0},V,!1)):F===C.ExtensionType.User&&b.push(...await this.n.scanUserExtensions(V)),b=F!==null?b.filter(T=>T.type===F):b,await Promise.all(b.map(T=>this.F(T)))}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(z.map(x=>this.F(x)))}catch(z){throw(0,o.$uq)(z,s.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,C.ExtensionType.User,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,x,V,b){const T=F.toString(),j=d.URI.file(f.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,g.$Wg)()}`)),q=d.URI.file(f.$jc(this.n.userExtensionsLocation.fsPath,T));let X=await this.m.exists(q);if(X&&V){try{await this.y(F.id,q,"removeExisting")}catch{throw new s.$dp(y.localize(4,null,q.fsPath,F.id),s.ExtensionManagementErrorCode.Delete)}X=!1}if(X)try{await this.n.updateMetadata(q,x)}catch(K){throw(0,o.$uq)(K,s.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(b.isCancellationRequested)throw new L.$5;try{this.u.trace(`Started extracting the extension from ${z} to ${q.fsPath}`),await(0,S.$rq)(z,j.fsPath,{sourcePath:"extension",overwrite:!0},b),this.u.info(`Extracted extension to ${q}:`,F.id)}catch(K){throw(0,N.$Gq)(K)}try{await this.n.updateMetadata(j,x)}catch(K){throw(0,o.$uq)(K,s.ExtensionManagementErrorCode.UpdateMetadata)}if(b.isCancellationRequested)throw new L.$5;try{this.u.trace(`Started renaming the extension from ${j.fsPath} to ${q.fsPath}`),await this.C(j.fsPath,q.fsPath),this.u.info("Renamed to",q.fsPath)}catch(K){if(K.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,L.$0)(K)}. Deleted from extracted location`,j),K}this.h.fire(q)}catch(K){try{await this.m.del(j,{recursive:!0})}catch{}throw K}return this.D(q,C.ExtensionType.User)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(V=>(0,e.$Cp)(V.identifier,F.identifier))}async updateMetadata(F,z,x){try{x?await this.s.updateMetadata([[F,z]],x):await this.n.updateMetadata(F.location,z)}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.UpdateMetadata)}return this.D(F.location,F.type,x)}async getUninstalledExtensions(){try{return await this.z()}catch(F){throw(0,o.$uq)(F,s.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const z=F.map(x=>e.$Dp.create(x));await this.z(x=>z.forEach(V=>{x[V.toString()]=!0,this.u.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(F){try{await this.z(z=>delete z[F.toString()])}catch(z){throw(0,o.$uq)(z,s.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[e.$Dp.create(F).toString()])}async copyExtension(F,z,x,V){const b=await this.w(F,z),T=await this.w(F,x);if(V={...b?.metadata,...V},T)if(this.t.extUri.isEqual(T.location,F.location))await this.s.updateMetadata([[F,{...T.metadata,...V}]],x);else{const j=await this.D(T.location,F.type,x);await this.s.removeExtensionFromProfile(j,x),await this.s.addExtensionsToProfile([[F,{...T.metadata,...V}]],x)}else await this.s.addExtensionsToProfile([[F,V]],x);return this.D(F.location,F.type,x)}async copyExtensions(F,z,x){const V=await this.scanExtensions(C.ExtensionType.User,F,x),b=await Promise.all(V.filter(T=>!T.isApplicationScoped).map(async T=>[T,await this.scanMetadata(T,F)]));await this.s.addExtensionsToProfile(b,z)}async y(F,z,x){this.u.trace(`Deleting ${x} extension from disk`,F,z.fsPath);const V=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,p.$oj)((0,g.$Wg)()).toString(16)}${_}`);await this.C(z.fsPath,V.fsPath),await this.m.del(V,{recursive:!0}),this.u.info(`Deleted ${x} extension from disk`,F,z.fsPath)}z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,J.$ll)(V)!==J.FileOperationResult.FILE_NOT_FOUND)throw V}let x={};if(z)try{x=JSON.parse(z)}catch{}return F&&(F(x),Object.keys(x).length?await this.m.writeFile(this.c,O.$Je.fromString(JSON.stringify(x))):await this.m.del(this.c)),x})}async C(F,z){try{await m.Promises.rename(F,z,2*60*1e3)}catch(x){throw(0,o.$uq)(x,s.ExtensionManagementErrorCode.Rename)}}async D(F,z,x){try{if(x){const b=(await this.n.scanUserExtensions({profileLocation:x})).find(T=>this.t.extUri.isEqual(T.location,F));if(b)return await this.F(b)}else{const V=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(V)return await this.F(V)}throw new s.$dp(y.localize(5,null,F.path),s.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.ScanningExtension)}}async F(F){const z=await this.m.resolve(F.location);let x,V;return z.children&&(x=z.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,V=z.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:x,changelogUrl:V,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=new Set;for(const b of z)F[e.$Dp.create(b).toString()]||x.add(b.identifier.id.toLowerCase());try{const b=(0,e.$Ip)(z,T=>T.identifier);await P.Promises.settled(b.map(async T=>{const j=T.sort((q,X)=>w.rcompare(q.manifest.version,X.manifest.version))[0];x.has(j.identifier.id.toLowerCase())||await this.j(await this.F(j))}))}catch(b){this.u.error(b)}const V=z.filter(b=>b.metadata&&F[e.$Dp.create(b).toString()]);await Promise.allSettled(V.map(b=>this.removeUninstalledExtension(b)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,J.$ll)(z)!==J.FileOperationResult.FILE_NOT_FOUND&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(_))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(x){(0,J.$ll)(x)!==J.FileOperationResult.FILE_NOT_FOUND&&this.u.error(x)}}}))}catch{}}};t.$Oq=U,t.$Oq=U=we([ne(1,J.$7k),ne(2,r.$Bq),ne(3,n.$xq),ne(4,le.$El),ne(5,ie.$7j)],U);let G=class extends o.$vq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,z,x,V,b,T,j,q,X,K,re,fe){super(),this.l=F,this.manifest=z,this.source=x,this.options=V,this.m=b,this.n=T,this.o=j,this.p=q,this.q=X,this.s=K,this.t=re,this.u=fe,this.j=s.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(z=>(0,e.$Cp)(z.identifier,this.identifier))}async h(F){const z=await this.v();z&&(this.j=s.InstallOperation.Update);const x={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};if(this.source instanceof d.URI)if(z){if(this.l.equals(new e.$Dp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.x(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(x.id=this.source.identifier.uuid,x.publisherId=this.source.publisherId,x.publisherDisplayName=this.source.publisherDisplayName,x.targetPlatform=this.source.properties.targetPlatform,x.updated=!!z,x.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,x.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,x.preRelease=(0,R.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==C.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,x);const j=await this.x(this.l);if(j)return j}if(F.isCancellationRequested)throw(0,o.$uq)(new L.$5);const{local:V,verificationStatus:b}=await this.m(this.operation,F);if(this.k=b,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,o.$uq)(j,s.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,o.$uq)(new L.$5);try{await this.t.addExtensionsToProfile([[V,x]],this.options.profileLocation,!V.isValid)}catch(j){throw(0,o.$uq)(j,s.ExtensionManagementErrorCode.AddToProfile)}const T=await this.v();if(!T)throw new s.$dp("Cannot find the installed extension",s.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.y(V,F),T}async x(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(V=>e.$Dp.create(V).equals(F))):void 0}async y(F,z){try{let[x]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(x||([x]=await this.p.getExtensions([{id:F.identifier.id}],z)),x){const V={id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,V,this.options.profileLocation)}}catch{}}};G=we([ne(6,le.$El),ne(7,s.$bp),ne(8,H.$Gl),ne(9,r.$Bq),ne(10,n.$xq),ne(11,ie.$7j)],G);class Z extends o.$vq{constructor(F,z,x){super(),this.extension=F,this.j=z,this.k=x}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],oe([0,1,6,24,23,19,42,10,18,12]),function(Q,t,P,O,v,k,L,I,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=void 0;let a=class extends L.$yq{constructor(f,$,w,R,d,g){super(l.URI.file(f.extensionsPath),$,w,R,d,g)}};t.$kQ=a,t.$kQ=a=we([ne(0,p.$Ii),ne(1,I.$7k),ne(2,O.$Gl),ne(3,v.$El),ne(4,k.$6l),ne(5,P.$7j)],a)}),define(se[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(Q,t,P,O,v,k,L,I,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iec=void 0;let f=class extends k.$Fq{constructor(w,R,d,g,m,S,y,u){super(P.URI.file(m.builtinExtensionsPath),P.URI.file(m.extensionsPath),m.userHome,w.defaultProfile,w,R,d,g,m,S,y,u)}};t.$Iec=f,t.$Iec=f=we([ne(0,c.$Gl),ne(1,v.$xq),ne(2,L.$7k),ne(3,p.$7j),ne(4,O.$Ii),ne(5,l.$nk),ne(6,a.$El),ne(7,I.$zi)],f)}),define(se[74],oe([0,1,8,5,2,132,3,93,11,24]),function(Q,t,P,O,v,k,L,I,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aq=t.$$p=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$9p=t.$8p=t.$7p=void 0,t.$0p=$,t.$_p=R,t.$bq=g,t.$7p="__$__isNewStorageMarker",t.$8p="__$__targetStorageMarker",t.$9p=(0,p.$Ai)("storageService");var a;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(a||(t.WillSaveStateReason=a={}));var c;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(c||(t.StorageScope=c={}));var f;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(f||(t.StorageTarget=f={}));function $(m){const S=m.get(t.$8p);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}class w extends v.$Uc{static{this.a=60*1e3}constructor(S={flushInterval:w.a}){super(),this.m=S,this.b=this.B(new O.$ke),this.c=this.B(new O.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$he),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(S,y,u){return O.Event.filter(this.b.event,i=>i.scope===S&&(y===void 0||i.key===y),u)}n(){this.j.value=(0,P.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(S,y){const{key:u,external:i}=y;if(u===t.$8p){switch(S){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:u,target:this.J(S)[u],external:i})}w(S){this.f.fire({reason:S})}get(S,y,u){return this.P(y)?.get(S,u)}getBoolean(S,y,u){return this.P(y)?.getBoolean(S,u)}getNumber(S,y,u){return this.P(y)?.getNumber(S,u)}getObject(S,y,u){return this.P(y)?.getObject(S,u)}storeAll(S,y){this.y(()=>{for(const u of S)this.store(u.key,u.value,u.scope,u.target,y)})}store(S,y,u,i,o=!1){if((0,L.$jg)(y)){this.remove(S,u,o);return}this.y(()=>{this.z(S,u,i),this.P(u)?.set(S,y,o)})}remove(S,y,u=!1){this.y(()=>{this.z(S,y,void 0),this.P(y)?.delete(S,u)})}y(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,y){const u=[],i=this.J(S);for(const o of Object.keys(i))i[o]===y&&u.push(o);return u}z(S,y,u,i=!1){const o=this.J(y);typeof u=="number"?o[S]!==u&&(o[S]=u,this.P(y)?.set(t.$8p,JSON.stringify(o),i)):typeof o[S]=="number"&&(delete o[S],this.P(y)?.set(t.$8p,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(S){switch(S){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(S){const y=this.P(S);return y?$(y):Object.create(null)}isNew(S){return this.getBoolean(t.$7p,S)===!0}async flush(S=a.NONE){this.f.fire({reason:S});const y=this.P(c.APPLICATION),u=this.P(c.PROFILE),i=this.P(c.WORKSPACE);switch(S){case a.NONE:await P.Promises.settled([y?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case a.SHUTDOWN:await P.Promises.settled([y?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.P(c.APPLICATION)?.items??new Map,y=this.P(c.PROFILE)?.items??new Map,u=this.P(c.WORKSPACE)?.items??new Map;return g(S,y,u,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(S){return await this.flush(),this.P(S)?.optimize()}async switch(S,y){return this.w(a.NONE),(0,l.$Fl)(S)?this.R(S,y):this.S(S,y)}M(S,y){return!(S.id===y.id||R(y)&&R(S))}N(S,y,u){this.y(()=>{const i=new Set;for(const[o,s]of S)i.add(o),y.get(o)!==s&&this.u(u,{key:o,external:!0});for(const[o]of y.items)i.has(o)||this.u(u,{key:o,external:!0})})}}t.$$p=w;function R(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class d extends w{constructor(){super(),this.U=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$5p(new I.$6p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(S=>this.u(c.WORKSPACE,S))),this.B(this.W.onDidChangeStorage(S=>this.u(c.PROFILE,S))),this.B(this.U.onDidChangeStorage(S=>this.u(c.APPLICATION,S)))}P(S){switch(S){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(S){switch(S){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(S){return!1}}t.$aq=d;async function g(m,S,y,u,i,o){const s=C=>{try{return JSON.parse(C)}catch{return C}},e=new Map,n=new Map;m.forEach((C,M)=>{e.set(M,C),n.set(M,s(C))});const r=new Map,h=new Map;S.forEach((C,M)=>{r.set(M,C),h.set(M,s(C))});const E=new Map,N=new Map;y.forEach((C,M)=>{E.set(M,C),N.set(M,s(C))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const A=[];if(e.forEach((C,M)=>{A.push({key:M,value:C})}),console.table(A),console.groupEnd(),console.log(n),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const C=[];r.forEach((M,J)=>{C.push({key:J,value:M})}),console.table(C),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${o})`);const D=[];E.forEach((C,M)=>{D.push({key:M,value:C})}),console.table(D),console.groupEnd(),console.log(N)}}),define(se[165],oe([0,1,14,29,74]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cq=k;async function k(L,I,p){let l=p&&p.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(l)return l;try{const c=(await I.readFile(L.serviceMachineIdResource)).value.toString();l=(0,O.$Vg)(c)?c:null}catch{l=null}if(!l){l=(0,O.$Wg)();try{await I.writeFile(L.serviceMachineIdResource,P.$Je.fromString(l))}catch{}}return p?.store("storage.serviceMachineId",l,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),l}}),define(se[166],oe([0,1,165,19,41]),function(Q,t,P,O,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dq=k;async function k(L,I,p,l,a,c,f){const $={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,v.$up)(I,p)&&(0,v.$wp)(l)===O.TelemetryLevel.USAGE){const w=await(0,P.$cq)(p,a,c);$["X-Market-User-Id"]=w,$["VSCode-SessionId"]=f.machineId||w}return $}}),define(se[167],oe([0,1,20,22,9,13,37,3,12,30,18,21,27,26,50,10,6,33,45,166,74,19,180]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gq=t.$fq=void 0,t.$eq=Y;const o=k.$o?$.TargetPlatform.WEB:(0,c.$0o)(k.$u,L.$ec),s="X-Market-Search-Activity-Id";var e;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...T){return String(T.reduce((j,q)=>j|q,0))}var r;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},E={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},A={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:e.None,criteria:[],assetTypes:[]};class D{constructor(j=A){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,q=this.d.pageSize){return new D({...this.d,pageNumber:j,pageSize:q})}withFilter(j,...q){const X=[...this.d.criteria,...q.length?q.map(K=>({filterType:j,value:K})):[{filterType:j}]];return new D({...this.d,criteria:X})}withSortBy(j){return new D({...this.d,sortBy:j})}withSortOrder(j){return new D({...this.d,sortOrder:j})}withFlags(...j){return new D({...this.d,flags:j.reduce((q,X)=>q|X,0)})}withAssetTypes(...j){return new D({...this.d,assetTypes:j})}withSource(j){return new D({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:q,pageSize:X,sortBy:K,sortOrder:re,flags:fe,assetTypes:he}=this.d;return{filters:[{criteria:j,pageNumber:q,pageSize:X,sortBy:K,sortOrder:re}],assetTypes:he,flags:fe}}get searchText(){const j=this.d.criteria.filter(q=>q.filterType===r.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(T,j){const q=(T||[]).filter(X=>X.statisticName===j)[0];return q?q.value:0}function M(T){const j="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(X=>X.assetType.indexOf(j)===0).reduce((X,K)=>{const re=ie(T,K.assetType);return re&&X.push([K.assetType.substring(j.length),re]),X},[])}function J(T){if(T.properties){const j=T.properties.filter(K=>K.key===h.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=j.filter(K=>q.test(K.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return ie(T,h.Repository)}function ae(T){return{uri:`${T.fallbackAssetUri}/${h.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${h.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function ie(T,j){return T.files.filter(X=>X.assetType===j)[0]?{uri:`${T.assetUri}/${j}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${j}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function ce(T,j){const q=T.properties?T.properties.filter(K=>K.key===j):[],X=q.length>0&&q[0].value;return X?X.split(",").map(K=>(0,f.$Gp)(K)):[]}function ue(T){const j=T.properties?T.properties.filter(q=>q.key===E.Engine):[];return j.length>0&&j[0].value||""}function le(T){const j=T.properties?T.properties.filter(q=>q.key===E.PreRelease):[];return j.length>0&&j[0].value==="true"}function H(T){const j=T.properties?T.properties.filter(X=>X.key===E.LocalizedLanguages):[],q=j.length>0&&j[0].value||"";return q?q.split(","):[]}function _(T){return T.properties?.find(j=>j.key===E.SponsorLink)?.value}function B(T){return T.properties?.find(j=>j.key===E.SupportLink)?.value}function U(T){return T.indexOf("preview")!==-1}function G(T){return T.targetPlatform?(0,c.$9o)(T.targetPlatform):$.TargetPlatform.UNDEFINED}function Z(T){const j=(0,P.$Mb)(T.versions.map(G)),q=!!T.tags?.includes(c.$3o),X=j.indexOf($.TargetPlatform.WEB);return q?X===-1&&j.push($.TargetPlatform.WEB):X!==-1&&j.splice(X,1),j}function Y(T,j){for(let q=0;q<T.length;q++){const X=T[q];if(X.version===T[q-1]?.version){let K=q;if(G(X)===j)for(;K>0&&T[K-1].version===X.version;)K--;K!==q&&(T.splice(q,1),T.splice(K,0,X))}}return T}function F(T,j,q){T.telemetryData={index:j,querySource:q,queryActivityId:T.queryContext?.[s]}}function z(T,j,q,X){const K=T.versions[0],re={manifest:ie(j,h.Manifest),readme:ie(j,h.Details),changelog:ie(j,h.Changelog),license:ie(j,h.License),repository:J(j),download:ae(j),icon:ie(j,h.Icon),signature:ie(j,h.Signature),coreTranslations:M(j)};return{type:"gallery",identifier:{id:(0,f.$Hp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:j.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(K),description:T.shortDescription??"",installCount:C(T.statistics,"install"),rating:C(T.statistics,"averagerating"),ratingCount:C(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:q,assets:re,properties:{dependencies:ce(j,E.Dependency),extensionPack:ce(j,E.ExtensionPack),engine:ue(j),localizedLanguages:H(j),targetPlatform:G(j),isPreReleaseVersion:le(j)},hasPreReleaseVersion:le(K),hasReleaseVersion:!0,preview:U(T.flags),isSigned:!!re.signature,queryContext:X,supportLink:B(K)}}let x=class{constructor(j,q,X,K,re,fe,he,ve){this.k=q,this.l=X,this.n=K,this.o=re,this.q=fe,this.u=he,this.w=ve;const me=he.extensionsGallery,ge=me?.servicePPEUrl&&ve.getValue("_extensionsGallery.enablePPE");this.d=ge?me.servicePPEUrl:me?.serviceUrl,this.g=ge?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,S.$dq)(he.version,he,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,q,X){const K=O.CancellationToken.isCancellationToken(q)?{}:q,re=O.CancellationToken.isCancellationToken(q)?q:X,fe=[],he=[],ve=[],me=[];let ge=!0;for(const ye of j){ye.uuid?he.push(ye.uuid):fe.push(ye.id);const Ie=!!(ye.version||ye.preRelease);ve.push({id:ye.id,uuid:ye.uuid,includePreRelease:Ie}),ye.version&&me.push({id:ye.id,uuid:ye.uuid,version:ye.version}),ge=ge&&!!ye.hasPreRelease&&!Ie}if(!he.length&&!fe.length)return[];let de=new D().withPage(1,j.length);he.length&&(de=de.withFilter(r.ExtensionId,...he)),fe.length&&(de=de.withFilter(r.ExtensionName,...fe)),(K.queryAllVersions||ge)&&(de=de.withFlags(de.flags,e.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:$e}=await this.z(de,{targetPlatform:K.targetPlatform??o,includePreRelease:ve,versions:me,compatible:!!K.compatible,productVersion:K.productVersion??{version:this.u.version,date:this.u.date}},re);return K.source&&$e.forEach((ye,Ie)=>F(ye,Ie,K.source)),$e}async getCompatibleExtension(j,q,X,K={version:this.u.version,date:this.u.date}){if((0,c.$$o)(j.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(j,q,X))return j;const re=new D().withFlags(e.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,j.identifier.uuid),{extensions:fe}=await this.z(re,{targetPlatform:X,compatible:!0,includePreRelease:q,productVersion:K},O.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(j,q,X,K={version:this.u.version,date:this.u.date}){if(!(0,c.$_o)(j.properties.targetPlatform,j.allTargetPlatforms,X)||!q&&j.properties.isPreReleaseVersion)return!1;let re=j.properties.engine;if(!re){const fe=await this.getManifest(j,O.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");re=fe.engines.vscode}return(0,w.$Up)(re,K.version,K.date)}async y(j,q,X,K,re,fe,he={version:this.u.version,date:this.u.date}){if(!(0,c.$_o)(G(q),re,fe)||X!=="any"&&le(q)!==(X==="prerelease"))return!1;if(K)try{const ve=await this.E(j,q);if(!(0,w.$Up)(ve,he.version,he.date))return!1}catch(ve){return this.l.error(`Error while getting the engine for the version ${q.version}.`,(0,v.$0)(ve)),!1}return!0}async query(j,q){let X=j.text||"";const K=j.pageSize??50;let re=new D().withPage(1,K);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(re=re.withFilter(r.Category,$e||de),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(re=re.withFilter(r.Tag,$e||de),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),re=re.withFilter(r.SearchText,X)),re=re.withSortBy(c.SortBy.NoneOrRelevance)):j.ids?re=re.withFilter(r.ExtensionId,...j.ids):j.names?re=re.withFilter(r.ExtensionName,...j.names):re=re.withSortBy(c.SortBy.InstallCount),typeof j.sortBy=="number"&&(re=re.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(re=re.withSortOrder(j.sortOrder)),j.source&&(re=re.withSource(j.source));const fe=async(ge,de)=>{const{extensions:$e,total:ye}=await this.z(ge,{targetPlatform:o,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},de);return $e.forEach((Ie,W)=>F(Ie,(ge.pageNumber-1)*ge.pageSize+W,j.source)),{extensions:$e,total:ye}},{extensions:he,total:ve}=await fe(re,q),me=async(ge,de)=>{if(de.isCancellationRequested)throw new v.$5;const{extensions:$e}=await fe(re.withPage(ge+1),de);return $e};return{firstPage:he,total:ve,pageSize:re.pageSize,getPage:me}}async z(j,q,X){const K=j.flags;j.flags&e.IncludeLatestVersionOnly&&j.flags&e.IncludeVersions&&(j=j.withFlags(j.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(j.flags&e.IncludeLatestVersionOnly)&&!(j.flags&e.IncludeVersions)&&(j=j.withFlags(j.flags,e.IncludeLatestVersionOnly)),q.versions?.length&&(j=j.withFlags(j.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),j=j.withFlags(j.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:re,total:fe,context:he}=await this.B(j,X);if(!(j.flags&e.IncludeLatestVersionOnly)){const de=[];for(const $e of re){const ye=await this.A($e,q,he);ye&&de.push(ye)}return{extensions:de,total:fe}}const me=[],ge=new Map;for(let de=0;de<re.length;de++){const $e=re[de],ye={id:(0,f.$Hp)($e.publisher.publisherName,$e.extensionName),uuid:$e.extensionId},Ie=(0,I.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ee=>(0,f.$Cp)(ee,ye))?.includePreRelease;if(q.compatible&&(0,c.$$o)(Z($e),q.targetPlatform))continue;const W=await this.A($e,q,he);!W||W.properties.isPreReleaseVersion&&(!Ie||!W.hasReleaseVersion)||!W.properties.isPreReleaseVersion&&W.properties.targetPlatform!==q.targetPlatform&&W.hasPreReleaseVersion?ge.set($e.extensionId,de):me.push([de,W])}if(ge.size){const de=new i.$be,$e=new D().withFlags(K&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,ge.size).withFilter(r.ExtensionId,...ge.keys()),{extensions:ye}=await this.z($e,q,X);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Ie of ye){const W=ge.get(Ie.identifier.uuid);me.push([W,Ie])}}return{extensions:me.sort((de,$e)=>de[0]-$e[0]).map(([,de])=>de),total:fe}}async A(j,q,X){const K={id:(0,f.$Hp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},re=q.versions?.find(me=>(0,f.$Cp)(me,K))?.version,fe=(0,I.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(me=>(0,f.$Cp)(me,K))?.includePreRelease,he=Z(j),ve=Y(j.versions,q.targetPlatform);if(q.compatible&&(0,c.$$o)(he,q.targetPlatform))return null;for(let me=0;me<ve.length;me++){const ge=ve[me];if(!(re&&ge.version!==re)){if(await this.y((0,f.$Hp)(j.publisher.publisherName,j.extensionName),ge,fe?"any":"release",q.compatible,he,q.targetPlatform,q.productVersion))return z(j,ge,he,X);if(re&&ge.version===re)return null}}return re||q.compatible?null:z(j,j.versions[0],he)}async B(j,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,e.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(e.Unpublished));const X=await this.j,K=JSON.stringify(j.raw),re={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},fe=new i.$be;let he,ve,me=0;try{if(he=await this.k.request({type:"POST",url:this.g&&j.criteria.some(de=>de.filterType===r.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:re},q),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:me};const ge=await(0,m.$2p)(he);if(ge){const de=ge.results[0],$e=de.extensions,ye=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return me=ye&&ye.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:$e,total:me,context:{[s]:he.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ge){if((0,v.$4)(ge))throw ve=c.ExtensionGalleryErrorCode.Cancelled,ge;{const de=(0,v.$0)(ge);throw ve=de.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$cp(de,ve)}}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(K.length),duration:fe.elapsed(),success:!!he&&(0,m.$Xp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ve,count:String(me)})}}async reportStatistic(j,q,X,K){if(!this.isEnabled())return;const re=k.$o?this.x(`/itemName/${j}.${q}/version/${X}/statType/${K===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${q}/${X}/stats?statType=${K}`),fe=k.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.j,Accept:fe};try{await this.k.request({type:"POST",url:re,headers:ve},O.CancellationToken.None)}catch{}}async download(j,q,X){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const K=(0,f.$Kp)(j),re=new Date().getTime(),fe=X===c.InstallOperation.Install?"install":X===c.InstallOperation.Update?"update":"",he=fe?{uri:`${j.assets.download.uri}${p.URI.parse(j.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${j.assets.download.fallbackUri}${p.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:j.assets.download,ve=j.queryContext?.[s]?{[s]:j.queryContext[s]}:void 0,me=await this.D(j.identifier.id,he,h.VSIX,ve?{headers:ve}:void 0);try{await this.q.writeFile(q,me.stream)}catch(ge){try{await this.q.del(q)}catch(de){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,v.$0)(de))}throw new c.$cp((0,v.$0)(ge),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...K,duration:new Date().getTime()-re})}async downloadSignatureArchive(j,q){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const X=await this.D(j.identifier.id,j.assets.signature,h.Signature);try{await this.q.writeFile(q,X.stream)}catch(K){try{await this.q.del(q)}catch(re){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,v.$0)(re))}throw new c.$cp((0,v.$0)(K),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,q){if(j.assets.readme){const X=await this.D(j.identifier.id,j.assets.readme,h.Details,{},q);return await(0,m.$1p)(X)||""}return""}async getManifest(j,q){if(j.assets.manifest){const X=await this.D(j.identifier.id,j.assets.manifest,h.Manifest,{},q),K=await(0,m.$1p)(X);return K?JSON.parse(K):null}return null}async C(j,q,X){const K=ie(q,h.Manifest);if(!K)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},fe=await this.D(j,K,h.Manifest,{headers:re});return await(0,m.$2p)(fe)}async getCoreTranslation(j,q){const X=j.assets.coreTranslations.filter(K=>K[0]===q.toUpperCase())[0];if(X){const K=await this.D(j.identifier.id,X[1],X[0]),re=await(0,m.$1p)(K);return re?JSON.parse(re):null}return null}async getChangelog(j,q){if(j.assets.changelog){const X=await this.D(j.identifier.id,j.assets.changelog,h.Changelog,{},q);return await(0,m.$1p)(X)||""}return""}async getAllCompatibleVersions(j,q,X){let K=new D().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?K=K.withFilter(r.ExtensionId,j.identifier.uuid):K=K.withFilter(r.ExtensionName,j.identifier.id);const{galleryExtensions:re}=await this.B(K,O.CancellationToken.None);if(!re.length)return[];const fe=Z(re[0]);if((0,c.$$o)(fe,X))return[];const he=[];await Promise.all(re[0].versions.map(async ge=>{try{await this.y(j.identifier.id,ge,q?"any":"release",!0,fe,X)&&he.push(ge)}catch{}}));const ve=[],me=new Set;for(const ge of Y(he,X))me.has(ge.version)||(me.add(ge.version),ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return ve}async D(j,q,X,K={},re=O.CancellationToken.None){const fe=await this.j,he={type:"GET"},ve={...fe,...K.headers||{}};K={...K,...he,headers:ve};const me=q.uri,ge=q.fallbackUri,de={...K,url:me};try{const $e=await this.k.request(de,re);if($e.res.statusCode===200)return $e;const ye=await(0,m.$1p)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${ye}`)}catch($e){if((0,v.$4)($e))throw $e;const ye=(0,v.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:X,message:ye});const Ie={...K,url:ge};return this.k.request(Ie,re)}}async E(j,q){let X=ue(q);if(!X){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:q.version});const K=await this.C(j,q,O.CancellationToken.None);if(!K)throw new Error("Manifest was not found");X=K.engines.vscode}return X}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,m.$2p)(j),X=[],K={},re=[];if(q){for(const fe of q.malicious)X.push({id:fe});if(q.migrateToPreRelease)for(const[fe,he]of Object.entries(q.migrateToPreRelease))(!he.engine||(0,w.$Up)(he.engine,this.u.version,this.u.date))&&(K[fe.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[fe,he]of Object.entries(q.deprecated))he&&(K[fe.toLowerCase()]=(0,I.$gg)(he)?{}:he);if(q.search)for(const fe of q.search)re.push(fe)}return{malicious:X,deprecated:K,search:re}}};x=we([ne(1,m.$Vp),ne(2,d.$7j),ne(3,a.$Hi),ne(4,u.$6l),ne(5,R.$7k),ne(6,g.$nk),ne(7,l.$7i)],x);let V=class extends x{constructor(j,q,X,K,re,fe,he,ve){super(j,q,X,K,re,fe,he,ve)}};t.$fq=V,t.$fq=V=we([ne(0,y.$9p),ne(1,m.$Vp),ne(2,d.$7j),ne(3,a.$Hi),ne(4,u.$6l),ne(5,R.$7k),ne(6,g.$nk),ne(7,l.$7i)],V);let b=class extends x{constructor(j,q,X,K,re,fe,he){super(void 0,j,q,X,K,re,fe,he)}};t.$gq=b,t.$gq=b=we([ne(0,m.$Vp),ne(1,d.$7j),ne(2,a.$Hi),ne(3,u.$6l),ne(4,R.$7k),ne(5,g.$nk),ne(6,l.$7i)],b)}),define(se[168],oe([0,1,12,18,10,6,147,23,24,3,70]),function(Q,t,P,O,v,k,L,I,p,l,a){"use strict";var c,f;Object.defineProperty(t,"__esModule",{value:!0}),t.$jQ=t.$iQ=t.$hQ=void 0;let $=class extends p.$Jl{static{c=this}static{this.a="profileAssociationsMigration"}constructor(g,m,S,y,u){super(S,y,m,u),this.U=g,this.W=S}O(){return this.U.getItem(c.b,[]).map(m=>({...m,location:(0,l.$ag)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):P.URI.revive(m.location)}))}Q(){const g=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$hQ=$,t.$hQ=$=c=we([ne(0,L.$cQ),ne(1,I.$El),ne(2,O.$Ii),ne(3,v.$7k),ne(4,k.$7j)],$);let w=f=class extends ${constructor(g,m,S,y,u){super(g,m,S,y,u),this.$=g}P(g){g.length?this.$.setItem(f.b,g.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(f.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(f.c,g):this.$.removeItem(f.c)}Q(){const g="workspaceAndProfileInfo",m=this.$.getItem(g,void 0);if(m){this.$.removeItem(g);const y=m.reduce((u,{workspace:i,profile:o})=>(u[P.URI.revive(i).toString()]=P.URI.revive(o).toString(),u),{});this.$.setItem(f.c,{workspaces:y})}const S=super.Q();return this.$.getItem(f.a,!1)||(this.R(S),this.$.setItem(f.a,!0)),S}};t.$iQ=w,t.$iQ=w=f=we([ne(0,L.$dQ),ne(1,I.$El),ne(2,O.$Ii),ne(3,v.$7k),ne(4,k.$7j)],w);let R=class extends w{constructor(g,m,S,y){super(new a.$gQ(a.SaveStrategy.IMMEDIATE,m,y,S),g,m,S,y)}async init(){return await this.$.init(),super.init()}};t.$jQ=R,t.$jQ=R=we([ne(0,I.$El),ne(1,O.$Ii),ne(2,v.$7k),ne(3,k.$7j)],R)}),define(se[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,181]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6r=void 0,t.$7r=d;let w=class extends c.$Wp{constructor(m,S,y,u){super(u),this.m=m,this.n=S,this.r=y,this.s(),this.B(m.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,S){const{f:y,g:u}=this;let i;try{i=await(0,l.$Lm)(this.m,this.r,this.n.args,process.env)}catch(e){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$0)(e)))}const o={...process.env,...i},s=m.agent?m.agent:await(0,f.$5r)(m.url||"",o,{proxyUrl:y,strictSSL:u});return m.agent=s,m.strictSSL=u,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>d(m,S))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((S,y)=>{Q(["@vscode/proxy-agent"],S,y)})).loadSystemCertificates({log:this.r})}};t.$6r=w,t.$6r=w=we([ne(0,I.$7i),ne(1,p.$Ii),ne(2,a.$7j),ne(3,a.$8j)],w);async function R(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((y,u)=>{Q(["https"],y,u)}):await new Promise((y,u)=>{Q(["http"],y,u)})).request}async function d(g,m){return O.Promises.withAsyncBody(async(S,y)=>{const u=(0,P.parse)(g.url),i=g.getRawRequest?g.getRawRequest(g):await R(g),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,L.$gg)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const s=i(o,e=>{const n=(0,L.$eg)(g.followRedirects)?g.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)d({...g,url:e.headers.location,followRedirects:n-1},m).then(S,y);else{let r=e;!g.isChromiumNetwork&&e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,$.createGunzip)())),S({res:e,stream:(0,v.$Ye)(r)})}});s.on("error",y),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),m.onCancellationRequested(()=>{s.abort(),y(new k.$5)})})}}),define(se[182],oe([0,1,35,8,36,9,2,15,16,13,37,12,25,30,141,62,143,18,120,167,21,72,148,42,54,162,164,10,131,133,51,129,65,69,150,6,137,39,138,153,33,45,169,70,71,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,183]),function(Q,t,P,O,v,k,L,I,p,l,a,c,f,$,w,R,d,g,m,S,y,u,i,o,s,e,n,r,h,E,N,A,D,C,M,J,ae,ie,ce,ue,le,H,_,B,U,G,Z,Y,F,z,x,V,b,T,j,q,X,K,re,fe,he){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=me;class ve extends L.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,$e]=await this.f();return de.invokeFunction(async ye=>{const Ie=ye.get(J.$7j),W=ye.get(r.$7k),ee=ye.get(g.$Ii),te=ye.get(b.$Gl);Ie.info("CLI main",this.b),this.h(Ie),await this.j(ee,W,te,de),await Promise.all($e.map(pe=>{(0,O.$rh)(pe.flush(),1e3)}))})}async f(){const de=new D.$yi,$e={_serviceBrand:void 0,...ue.default};de.set(le.$nk,$e);const ye=new m.$bn(this.b,$e);de.set(g.$Ii,ye),await Promise.all([this.g(ye.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.g(ye.extensionsPath)].map(Se=>Se?f.Promises.mkdir(Se,{recursive:!0}):void 0));const Ie=new K.$bQ((0,J.$ik)(ye),ye.logsHome);de.set(J.$8j,Ie);const W=this.B(Ie.createLogger("cli",{name:(0,re.localize)(0,null)})),ee=[];Ie.getLogLevel()===J.LogLevel.Trace&&ee.push(new J.$ck(Ie.getLogLevel()));const te=this.B(new X.$lQ(W,ee));de.set(J.$7j,te);const pe=this.B(new h.$Qq(te));de.set(r.$7k,pe);const be=this.B(new E.$hr(te));pe.registerProvider(I.Schemas.file,be);const Ae=new V.$Is(pe);de.set(x.$El,Ae);const Pe=new B.$fQ(B.SaveStrategy.DELAYED,ye,te,pe),Le=new T.$hQ(Pe,Ae,ye,pe,te);de.set(b.$Gl,Le),pe.registerProvider(I.Schemas.vscodeUserData,new fe.$_ec(I.Schemas.file,be,I.Schemas.vscodeUserData,Le,Ae,te));const Oe=l.$i&&$e.win32RegValueName?this.B(new ce.$0ec(te,$e.win32RegValueName)):ye.policyFile?this.B(new ae.$$ec(ye.policyFile,pe,te)):new ie.$no;de.set(ie.$lo,Oe);const De=this.B(new w.$No(Le.defaultProfile.settingsResource,pe,Oe,te));de.set($.$7i,De),await Promise.all([Pe.init(),De.initialize()]);let Ue;try{Ue=await(0,j.$Lec)(Pe,te)}catch(Se){Se.code!=="ENOENT"&&te.error(Se)}const Ne=await(0,j.$Mec)(Pe,te),Te=await(0,j.$Nec)(Pe,te);Le.init(),de.set(x.$El,new V.$Is(pe));const Ce=new _.$6r(De,ye,te,Ie);de.set(H.$Vp,Ce),de.set(R.$Ro,new N.$xi(d.$AQ,void 0,!0)),de.set(o.$xq,new N.$xi(q.$kQ,void 0,!0)),de.set(s.$Bq,new N.$xi(n.$Iec,void 0,!0)),de.set(u.$hq,new N.$xi(u.$jq,void 0,!0)),de.set(e.$Mq,new N.$xi(e.$Nq,void 0,!0)),de.set(y.$bp,new N.$xi(S.$gq,void 0,!0)),de.set(C.$Zr,new N.$xi(M.$2r,void 0,!1));const Fe=[],Ee=(0,Y.$zp)($e,De);if((0,Y.$up)($e,ye)){$e.aiConfig&&$e.aiConfig.ariaKey&&Fe.push(new F.$_P(Ce,Ee,"monacoworkbench",null,$e.aiConfig.ariaKey));const Se={appenders:Fe,sendErrorTelemetry:!1,commonProperties:(0,U.$lp)((0,P.release)(),(0,P.hostname)(),process.arch,$e.commit,$e.version,Ue,Ne,Te,Ee),piiPaths:(0,Y.$Ap)(ye)};de.set(G.$6l,new N.$xi(Z.$8r,[Se],!1))}else de.set(G.$6l,Y.$pp);return[new A.$kr(de),Fe]}g(de){if(l.$i){const $e=(0,he.getUNCHost)(de);$e&&(0,he.addUNCHostToAllowlist)($e)}return de}h(de){(0,k.setUnexpectedErrorHandler)($e=>{const ye=(0,v.$lj)($e,!0);ye&&de.error(`[uncaught exception in CLI]: ${ye}`)}),process.on("uncaughtException",$e=>{(0,k.$Z)($e)||(0,k.$1)($e)}),process.on("unhandledRejection",$e=>(0,k.$1)($e))}async j(de,$e,ye,Ie){let W;if(de.args.profile&&(W=ye.profiles.find(te=>te.name===de.args.profile),!W))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(W??ye.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,z.$pfc)(de.appRoot,de.extensionsPath))}}m(de){return de.map($e=>/\.vsix$/i.test($e)?c.URI.file((0,p.$ic)($e)?$e:(0,p.$jc)((0,a.cwd)(),$e)):$e)}}async function me(ge){const de=new ve(ge);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fc8762e773c35d4e52e8a7375704af2e24698e5d/core/vs/code/node/cliProcessMain.js.map
