/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],k=0,a=ne.length;k<a;k++)e[k]=le[ne[k]];return e};define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.LoaderEventType=e.$T=void 0,e.$T=!1;var k;(function(T){T[T.LoaderAvailable=1]="LoaderAvailable",T[T.BeginLoadingScript=10]="BeginLoadingScript",T[T.EndLoadingScriptOK=11]="EndLoadingScriptOK",T[T.EndLoadingScriptError=12]="EndLoadingScriptError",T[T.BeginInvokeFactory=21]="BeginInvokeFactory",T[T.EndInvokeFactory=22]="EndInvokeFactory",T[T.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",T[T.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",T[T.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",T[T.NodeEndNativeRequire=34]="NodeEndNativeRequire",T[T.CachedDataFound=60]="CachedDataFound",T[T.CachedDataMissed=61]="CachedDataMissed",T[T.CachedDataRejected=62]="CachedDataRejected",T[T.CachedDataCreated=63]="CachedDataCreated"})(k||(e.LoaderEventType=k={}));class a{static get(){const O=new Map,C=new Map,A=new Map,L=new Map;function y(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function S(l,g){const d=l.get(g.detail);d&&(d>=0||l.set(g.detail,d+g.timestamp))}let $=[];typeof ne=="function"&&typeof ne.getStats=="function"&&($=ne.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of $)switch(l.type){case k.BeginLoadingScript:y(O,l);break;case k.EndLoadingScriptOK:case k.EndLoadingScriptError:S(O,l);break;case k.BeginInvokeFactory:y(C,l);break;case k.EndInvokeFactory:S(C,l);break;case k.NodeBeginNativeRequire:y(A,l);break;case k.NodeEndNativeRequire:S(A,l);break;case k.NodeBeginEvaluatingScript:y(L,l);break;case k.NodeEndEvaluatingScript:S(L,l);break}let h=0;A.forEach(l=>h+=l);function p(l){const g=[];return l.forEach((d,f)=>g.push([f,d])),g}return{amdLoad:p(O),amdInvoke:p(C),nodeRequire:p(A),nodeEval:p(L),nodeRequireTotal:h}}static toMarkdownTable(O,C){let A="";const L=[];return O.forEach((y,S)=>{L[S]=y.length}),C.forEach(y=>{y.forEach((S,$)=>{typeof S>"u"&&(S=y[$]="-");const h=S.toString().length;L[$]=Math.max(h,L[$])})}),O.forEach((y,S)=>{A+=`| ${y+" ".repeat(L[S]-y.toString().length)} `}),A+=`|
`,O.forEach((y,S)=>{A+=`| ${"-".repeat(L[S])} `}),A+=`|
`,C.forEach(y=>{y.forEach((S,$)=>{typeof S<"u"&&(A+=`| ${S+" ".repeat(L[$]-S.toString().length)} `)}),A+=`|
`}),A}}e.$U=a}),define(le[130],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=k,e.$gb=a,e.$hb=T,e.$ib=O,e.$jb=C,e.$kb=A,e.$lb=L,e.$nb=S,e.$ob=$,e.$pb=h,e.$qb=p,e.$rb=l;function k(g,d){const f=a(g,d);if(f!==-1)return g[f]}function a(g,d,f=g.length-1){for(let w=f;w>=0;w--){const E=g[w];if(d(E))return w}return-1}function T(g,d){const f=O(g,d);return f===-1?void 0:g[f]}function O(g,d,f=0,w=g.length){let E=f,u=w;for(;E<u;){const b=Math.floor((E+u)/2);d(g[b])?E=b+1:u=b}return E-1}function C(g,d){const f=A(g,d);return f===g.length?void 0:g[f]}function A(g,d,f=0,w=g.length){let E=f,u=w;for(;E<u;){const b=Math.floor((E+u)/2);d(g[b])?u=b:E=b+1}return E}function L(g,d,f=0,w=g.length){const E=A(g,d,f,w);return E===g.length?-1:E}class y{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(y.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!d(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const f=O(this.e,d,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$mb=y;function S(g,d){if(g.length===0)return;let f=g[0];for(let w=1;w<g.length;w++){const E=g[w];d(E,f)>0&&(f=E)}return f}function $(g,d){if(g.length===0)return;let f=g[0];for(let w=1;w<g.length;w++){const E=g[w];d(E,f)>=0&&(f=E)}return f}function h(g,d){return S(g,(f,w)=>-d(f,w))}function p(g,d){if(g.length===0)return-1;let f=0;for(let w=1;w<g.length;w++){const E=g[w];d(E,g[f])>0&&(f=w)}return f}function l(g,d){for(const f of g){const w=d(f);if(w!==void 0)return w}}}),define(le[39],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var k;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(k||(e.CharCode=k={}))}),define(le[131],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=k,e.$L=a,e.$M=T,e.$N=O;function k(C,A){const L=Object.create(null);for(const y of C){const S=A(y);let $=L[S];$||($=L[S]=[]),$.push(y)}return L}function a(C,A){const L=[],y=[];for(const S of C)A.has(S)||L.push(S);for(const S of A)C.has(S)||y.push(S);return{removed:L,added:y}}function T(C,A){const L=[],y=[];for(const[S,$]of C)A.has(S)||L.push($);for(const[S,$]of A)C.has(S)||y.push($);return{removed:L,added:y}}function O(C,A){const L=new Set;for(const y of A)C.has(y)&&L.add(y);return L}}),define(le[88],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=a,e.$6h=T,e.$7h=O;function k(C){return(A,L,y)=>{let S=null,$=null;if(typeof y.value=="function"?(S="value",$=y.value):typeof y.get=="function"&&(S="get",$=y.get),!$)throw new Error("not supported");y[S]=C($,L)}}function a(C,A,L){let y=null,S=null;if(typeof L.value=="function"?(y="value",S=L.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof L.get=="function"&&(y="get",S=L.get),!S)throw new Error("not supported");const $=`$memoize$${A}`;L[y]=function(...h){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,h)}),this[$]}}function T(C,A,L){return k((y,S)=>{const $=`$debounce$${S}`,h=`$debounce$result$${S}`;return function(...p){this[h]||(this[h]=L?L():void 0),clearTimeout(this[$]),A&&(this[h]=A(this[h],...p),p=[this[h]]),this[$]=setTimeout(()=>{y.apply(this,p),this[h]=L?L():void 0},C)}})}function O(C,A,L){return k((y,S)=>{const $=`$throttle$timer$${S}`,h=`$throttle$result$${S}`,p=`$throttle$lastRun$${S}`,l=`$throttle$pending$${S}`;return function(...g){if(this[h]||(this[h]=L?L():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...g)),this[l])return;const d=this[p]+C;d<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[h]]),this[h]=L?L():void 0):(this[l]=!0,this[$]=setTimeout(()=>{this[l]=!1,this[p]=Date.now(),y.apply(this,[this[h]]),this[h]=L?L():void 0},d-Date.now()))}})}}),define(le[8],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=a,e.$Z=T,e.$1=O,e.$2=C,e.$3=A,e.$4=y,e.$6=$,e.$7=h,e.$8=p,e.$0=g;class k{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?E.isErrorNoTelemetry(t)?new E(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=k,e.$X=new k;function a(b){e.$X.setUnexpectedErrorHandler(b)}function T(b){if(!b||typeof b!="object")return!1;const t=b;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(b){y(b)||e.$X.onUnexpectedError(b)}function C(b){y(b)||e.$X.onUnexpectedExternalError(b)}function A(b){if(b instanceof Error){const{name:t,message:s}=b,o=b.stacktrace||b.stack;return{$isError:!0,name:t,message:s,stack:o,noTelemetry:E.isErrorNoTelemetry(b)}}return b}const L="Canceled";function y(b){return b instanceof S?!0:b instanceof Error&&b.name===L&&b.message===L}class S extends Error{constructor(){super(L),this.name=this.message}}e.$5=S;function $(){const b=new Error(L);return b.name=b.message,b}function h(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}function p(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}class l extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=l;function g(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=d;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=w;class E extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof E)return t;const s=new E;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=E;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(le[19],he([0,1,8,130]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=T,e.$tb=O,e.$ub=C,e.$vb=A,e.$wb=L,e.$xb=y,e.$yb=S,e.$zb=$,e.$Ab=h,e.$Bb=p,e.$Cb=l,e.$Db=g,e.$Eb=d,e.top=f,e.$Gb=w,e.$Hb=u,e.$Ib=b,e.$Jb=t,e.$Kb=s,e.$Lb=o,e.$Mb=i,e.$Nb=n,e.$Ob=r,e.$Pb=c,e.$Qb=m,e.$Rb=v,e.$Sb=P,e.$Tb=R,e.$Ub=I,e.$Vb=N,e.$Wb=U,e.$Xb=j,e.$Yb=F,e.$Zb=X,e.$1b=K,e.$2b=Q,e.$3b=V,e.$4b=ie,e.$5b=H,e.$6b=re,e.$7b=ce,e.$0b=J;function T(M,z=0){return M[M.length-(1+z)]}function O(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}function C(M,z,te=(_,Y)=>_===Y){if(M===z)return!0;if(!M||!z||M.length!==z.length)return!1;for(let _=0,Y=M.length;_<Y;_++)if(!te(M[_],z[_]))return!1;return!0}function A(M,z){const te=M.length-1;z<te&&(M[z]=M[te]),M.pop()}function L(M,z,te){return y(M.length,_=>te(M[_],z))}function y(M,z){let te=0,_=M-1;for(;te<=_;){const Y=(te+_)/2|0,ae=z(Y);if(ae<0)te=Y+1;else if(ae>0)_=Y-1;else return Y}return-(te+1)}function S(M,z,te){if(M=M|0,M>=z.length)throw new TypeError("invalid index");const _=z[Math.floor(z.length*Math.random())],Y=[],ae=[],ue=[];for(const ge of z){const we=te(ge,_);we<0?Y.push(ge):we>0?ae.push(ge):ue.push(ge)}return M<Y.length?S(M,Y,te):M<Y.length+ue.length?ue[0]:S(M-(Y.length+ue.length),ae,te)}function $(M,z){const te=[];let _;for(const Y of M.slice(0).sort(z))!_||z(_[0],Y)!==0?(_=[Y],te.push(_)):_.push(Y);return te}function*h(M,z){let te,_;for(const Y of M)_!==void 0&&z(_,Y)?te.push(Y):(te&&(yield te),te=[Y]),_=Y;te&&(yield te)}function p(M,z){for(let te=0;te<=M.length;te++)z(te===0?void 0:M[te-1],te===M.length?void 0:M[te])}function l(M,z){for(let te=0;te<M.length;te++)z(te===0?void 0:M[te-1],M[te],te+1===M.length?void 0:M[te+1])}function g(M,z,te){const _=[];function Y(ge,we,Ee){if(we===0&&Ee.length===0)return;const pe=_[_.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=we,pe.toInsert.push(...Ee)):_.push({start:ge,deleteCount:we,toInsert:Ee})}let ae=0,ue=0;for(;;){if(ae===M.length){Y(ae,0,z.slice(ue));break}if(ue===z.length){Y(ae,M.length-ae,[]);break}const ge=M[ae],we=z[ue],Ee=te(ge,we);Ee===0?(ae+=1,ue+=1):Ee<0?(Y(ae,1,[]),ae+=1):Ee>0&&(Y(ae,0,[we]),ue+=1)}return _}function d(M,z,te){const _=g(M,z,te),Y=[],ae=[];for(const ue of _)Y.push(...M.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:Y,added:ae}}function f(M,z,te){if(te===0)return[];const _=M.slice(0,te).sort(z);return E(M,z,_,te,M.length),_}function w(M,z,te,_,Y){return te===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const ge=M.length,we=M.slice(0,te).sort(z);for(let Ee=te,pe=Math.min(te+_,ge);Ee<ge;Ee=pe,pe=Math.min(pe+_,ge)){if(Ee>te&&await new Promise(be=>setTimeout(be)),Y&&Y.isCancellationRequested)throw new k.$5;E(M,z,we,Ee,pe)}return we})().then(ae,ue)})}function E(M,z,te,_,Y){for(const ae=te.length;_<Y;_++){const ue=M[_];if(z(ue,te[ae-1])<0){te.pop();const ge=(0,a.$kb)(te,we=>z(ue,we)<0);te.splice(ge,0,ue)}}}function u(M){return M.filter(z=>!!z)}function b(M){let z=0;for(let te=0;te<M.length;te++)M[te]&&(M[z]=M[te],z+=1);M.length=z}function t(M,z,te){M.splice(te,0,M.splice(z,1)[0])}function s(M){return!Array.isArray(M)||M.length===0}function o(M){return Array.isArray(M)&&M.length>0}function i(M,z=te=>te){const te=new Set;return M.filter(_=>{const Y=z(_);return te.has(Y)?!1:(te.add(Y),!0)})}function n(M){const z=new Set;return te=>{const _=M(te);return z.has(_)?!1:(z.add(_),!0)}}function r(M,z){return M.length>0?M[0]:z}function c(M,z){return M.length>0?M[M.length-1]:z}function m(M,z,te=(_,Y)=>_===Y){let _=0;for(let Y=0,ae=Math.min(M.length,z.length);Y<ae&&te(M[Y],z[Y]);Y++)_++;return _}function v(M,z){let te=typeof z=="number"?M:0;typeof z=="number"?te=M:(te=0,z=M);const _=[];if(te<=z)for(let Y=te;Y<z;Y++)_.push(Y);else for(let Y=te;Y>z;Y--)_.push(Y);return _}function P(M,z,te){return M.reduce((_,Y)=>(_[z(Y)]=te?te(Y):Y,_),Object.create(null))}function R(M,z){return M.push(z),()=>I(M,z)}function I(M,z){const te=M.indexOf(z);if(te>-1)return M.splice(te,1),z}function N(M,z,te){const _=M.slice(0,z),Y=M.slice(z);return _.concat(te,Y)}function U(M,z){let te;if(typeof z=="number"){let _=z;te=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else te=Math.random;for(let _=M.length-1;_>0;_-=1){const Y=Math.floor(te()*(_+1)),ae=M[_];M[_]=M[Y],M[Y]=ae}}function j(M,z){const te=M.indexOf(z);te>-1&&(M.splice(te,1),M.unshift(z))}function F(M,z){const te=M.indexOf(z);te>-1&&(M.splice(te,1),M.push(z))}function X(M,z){for(const te of z)M.push(te)}function K(M,z){return Array.isArray(M)?M.map(z):z(M)}function Q(M){return Array.isArray(M)?M:[M]}function V(M){return M[Math.floor(Math.random()*M.length)]}function ie(M,z,te){const _=W(M,z),Y=M.length,ae=te.length;M.length=Y+ae;for(let ue=Y-1;ue>=_;ue--)M[ue+ae]=M[ue];for(let ue=0;ue<ae;ue++)M[ue+_]=te[ue]}function H(M,z,te,_){const Y=W(M,z);let ae=M.splice(Y,te);return ae===void 0&&(ae=[]),ie(M,Y,_),ae}function W(M,z){return z<0?Math.max(z+M.length,0):Math.min(z,M.length)}var ee;(function(M){function z(ae){return ae<0}M.isLessThan=z;function te(ae){return ae<=0}M.isLessThanOrEqual=te;function _(ae){return ae>0}M.isGreaterThan=_;function Y(ae){return ae===0}M.isNeitherLessOrGreaterThan=Y,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function re(M,z){return(te,_)=>z(M(te),M(_))}function ce(...M){return(z,te)=>{for(const _ of M){const Y=_(z,te);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const q=(M,z)=>M-z;e.$8b=q;const x=(M,z)=>(0,e.$8b)(M?1:0,z?1:0);e.$9b=x;function J(M){return(z,te)=>-M(z,te)}class G{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let te=this.c;for(;te<this.g.length&&z(this.g[te]);)te++;const _=te===this.c?null:this.g.slice(this.c,te);return this.c=te,_}takeFromEndWhile(z){let te=this.d;for(;te>=0&&z(this.g[te]);)te--;const _=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const te=this.g.slice(this.c,this.c+z);return this.c+=z,te}}e.$$b=G;class D{static{this.empty=new D(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(te=>(z(te),!0))}toArray(){const z=[];return this.iterate(te=>(z.push(te),!0)),z}filter(z){return new D(te=>this.iterate(_=>z(_)?te(_):!0))}map(z){return new D(te=>this.iterate(_=>te(z(_))))}some(z){let te=!1;return this.iterate(_=>(te=z(_),!te)),te}findFirst(z){let te;return this.iterate(_=>z(_)?(te=_,!1):!0),te}findLast(z){let te;return this.iterate(_=>(z(_)&&(te=_),!0)),te}findLastMaxBy(z){let te,_=!0;return this.iterate(Y=>((_||ee.isGreaterThan(z(Y,te)))&&(_=!1,te=Y),!0)),te}}e.$_b=D;class B{constructor(z){this.c=z}static createSortPermutation(z,te){const _=Array.from(z.keys()).sort((Y,ae)=>te(z[Y],z[ae]));return new B(_)}apply(z){return z.map((te,_)=>z[this.c[_]])}inverse(){const z=this.c.slice();for(let te=0;te<this.c.length;te++)z[this.c[te]]=te;return new B(z)}}e.$ac=B}),define(le[132],he([0,1,8]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$ed=T,e.$fd=O,e.$gd=C,e.$hd=A,e.$id=L;function a(y,S){if(!y)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function T(y,S="Unreachable"){throw new Error(S)}function O(y,S="unexpected state"){if(!y)throw new k.$cb(`Assertion Failed: ${S}`)}function C(y){y||(0,k.$1)(new k.$cb("Soft Assertion Failed"))}function A(y){if(!y()){debugger;y(),(0,k.$1)(new k.$cb("Assertion Failed"))}}function L(y,S){let $=0;for(;$<y.length-1;){const h=y[$],p=y[$+1];if(!S(h,p))return!1;$++}return!0}}),define(le[89],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=k;function k(a,T){const O=this;let C=!1,A;return function(){if(C)return A;if(C=!0,T)try{A=a.apply(O,arguments)}finally{T()}else A=a.apply(O,arguments);return A}}}),define(le[62],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(a){function T(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}a.is=T;const O=Object.freeze([]);function C(){return O}a.empty=C;function*A(t){yield t}a.single=A;function L(t){return T(t)?t:A(t)}a.wrap=L;function y(t){return t||O}a.from=y;function*S(t){for(let s=t.length-1;s>=0;s--)yield t[s]}a.reverse=S;function $(t){return!t||t[Symbol.iterator]().next().done===!0}a.isEmpty=$;function h(t){return t[Symbol.iterator]().next().value}a.first=h;function p(t,s){for(const o of t)if(s(o))return!0;return!1}a.some=p;function l(t,s){for(const o of t)if(s(o))return o}a.find=l;function*g(t,s){for(const o of t)s(o)&&(yield o)}a.filter=g;function*d(t,s){let o=0;for(const i of t)yield s(i,o++)}a.map=d;function*f(...t){for(const s of t)yield*s}a.concat=f;function w(t,s,o){let i=o;for(const n of t)i=s(i,n);return i}a.reduce=w;function*E(t,s,o=t.length){for(s<0&&(s+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);s<o;s++)yield t[s]}a.slice=E;function u(t,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,t];const i=t[Symbol.iterator]();for(let n=0;n<s;n++){const r=i.next();if(r.done)return[o,a.empty()];o.push(r.value)}return[o,{[Symbol.iterator](){return i}}]}a.consume=u;async function b(t){const s=[];for await(const o of t)s.push(o);return Promise.resolve(s)}a.asyncToArray=b})(k||(e.Iterable=k={}))}),define(le[34],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=C,e.$On=$,e.$Pn=h,e.$Qn=p,e.$Rn=l,e.$Sn=g,e.$Tn=d,e.$Un=f,e.$Vn=w,e.$Wn=E,e.$Xn=u,e.$Yn=b;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function C(t,s=!1){let o=0;const i=t.length;let n="",r=0,c=a.Unknown,m=k.None;function v(F){let X=0,K=0;for(;X<F;){const Q=t.charCodeAt(o);if(Q>=S._0&&Q<=S._9)K=K*16+Q-S._0;else if(Q>=S.A&&Q<=S.F)K=K*16+Q-S.A+10;else if(Q>=S.a&&Q<=S.f)K=K*16+Q-S.a+10;else break;o++,X++}return X<F&&(K=-1),K}function P(F){o=F,n="",r=0,c=a.Unknown,m=k.None}function R(){const F=o;if(t.charCodeAt(o)===S._0)o++;else for(o++;o<t.length&&y(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===S.dot)if(o++,o<t.length&&y(t.charCodeAt(o)))for(o++;o<t.length&&y(t.charCodeAt(o));)o++;else return m=k.UnexpectedEndOfNumber,t.substring(F,o);let X=o;if(o<t.length&&(t.charCodeAt(o)===S.E||t.charCodeAt(o)===S.e))if(o++,(o<t.length&&t.charCodeAt(o)===S.plus||t.charCodeAt(o)===S.minus)&&o++,o<t.length&&y(t.charCodeAt(o))){for(o++;o<t.length&&y(t.charCodeAt(o));)o++;X=o}else m=k.UnexpectedEndOfNumber;return t.substring(F,X)}function I(){let F="",X=o;for(;;){if(o>=i){F+=t.substring(X,o),m=k.UnexpectedEndOfString;break}const K=t.charCodeAt(o);if(K===S.doubleQuote){F+=t.substring(X,o),o++;break}if(K===S.backslash){if(F+=t.substring(X,o),o++,o>=i){m=k.UnexpectedEndOfString;break}switch(t.charCodeAt(o++)){case S.doubleQuote:F+='"';break;case S.backslash:F+="\\";break;case S.slash:F+="/";break;case S.b:F+="\b";break;case S.f:F+="\f";break;case S.n:F+=`
`;break;case S.r:F+="\r";break;case S.t:F+="	";break;case S.u:{const V=v(4);V>=0?F+=String.fromCharCode(V):m=k.InvalidUnicode;break}default:m=k.InvalidEscapeCharacter}X=o;continue}if(K>=0&&K<=31)if(L(K)){F+=t.substring(X,o),m=k.UnexpectedEndOfString;break}else m=k.InvalidCharacter;o++}return F}function N(){if(n="",m=k.None,r=o,o>=i)return r=i,c=a.EOF;let F=t.charCodeAt(o);if(A(F)){do o++,n+=String.fromCharCode(F),F=t.charCodeAt(o);while(A(F));return c=a.Trivia}if(L(F))return o++,n+=String.fromCharCode(F),F===S.carriageReturn&&t.charCodeAt(o)===S.lineFeed&&(o++,n+=`
`),c=a.LineBreakTrivia;switch(F){case S.openBrace:return o++,c=a.OpenBraceToken;case S.closeBrace:return o++,c=a.CloseBraceToken;case S.openBracket:return o++,c=a.OpenBracketToken;case S.closeBracket:return o++,c=a.CloseBracketToken;case S.colon:return o++,c=a.ColonToken;case S.comma:return o++,c=a.CommaToken;case S.doubleQuote:return o++,n=I(),c=a.StringLiteral;case S.slash:{const X=o-1;if(t.charCodeAt(o+1)===S.slash){for(o+=2;o<i&&!L(t.charCodeAt(o));)o++;return n=t.substring(X,o),c=a.LineCommentTrivia}if(t.charCodeAt(o+1)===S.asterisk){o+=2;const K=i-1;let Q=!1;for(;o<K;){if(t.charCodeAt(o)===S.asterisk&&t.charCodeAt(o+1)===S.slash){o+=2,Q=!0;break}o++}return Q||(o++,m=k.UnexpectedEndOfComment),n=t.substring(X,o),c=a.BlockCommentTrivia}return n+=String.fromCharCode(F),o++,c=a.Unknown}case S.minus:if(n+=String.fromCharCode(F),o++,o===i||!y(t.charCodeAt(o)))return c=a.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return n+=R(),c=a.NumericLiteral;default:for(;o<i&&U(F);)o++,F=t.charCodeAt(o);if(r!==o){switch(n=t.substring(r,o),n){case"true":return c=a.TrueKeyword;case"false":return c=a.FalseKeyword;case"null":return c=a.NullKeyword}return c=a.Unknown}return n+=String.fromCharCode(F),o++,c=a.Unknown}}function U(F){if(A(F)||L(F))return!1;switch(F){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function j(){let F;do F=N();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:P,getPosition:()=>o,scan:s?j:N,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>m}}function A(t){return t===S.space||t===S.tab||t===S.verticalTab||t===S.formFeed||t===S.nonBreakingSpace||t===S.ogham||t>=S.enQuad&&t<=S.zeroWidthSpace||t===S.narrowNoBreakSpace||t===S.mathematicalSpace||t===S.ideographicSpace||t===S.byteOrderMark}function L(t){return t===S.lineFeed||t===S.carriageReturn||t===S.lineSeparator||t===S.paragraphSeparator}function y(t){return t>=S._0&&t<=S._9}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function $(t,s){const o=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(v,P,R,I){r.value=v,r.offset=P,r.length=R,r.type=I,r.colonOffset=void 0,n=r}try{E(t,{onObjectBegin:(v,P)=>{if(s<=v)throw i;n=void 0,c=s>v,o.push("")},onObjectProperty:(v,P,R)=>{if(s<P||(m(v,P,R,"property"),o[o.length-1]=v,s<=P+R))throw i},onObjectEnd:(v,P)=>{if(s<=v)throw i;n=void 0,o.pop()},onArrayBegin:(v,P)=>{if(s<=v)throw i;n=void 0,o.push(0)},onArrayEnd:(v,P)=>{if(s<=v)throw i;n=void 0,o.pop()},onLiteralValue:(v,P,R)=>{if(s<P||(m(v,P,R,b(v)),s<=P+R))throw i},onSeparator:(v,P,R)=>{if(s<=P)throw i;if(v===":"&&n&&n.type==="property")n.colonOffset=P,c=!1,n=void 0;else if(v===","){const I=o[o.length-1];typeof I=="number"?o[o.length-1]=I+1:(c=!0,o[o.length-1]=""),n=void 0}}})}catch(v){if(v!==i)throw v}return{path:o,previousNode:n,isAtPropertyKey:c,matches:v=>{let P=0;for(let R=0;P<v.length&&R<o.length;R++)if(v[P]===o[R]||v[P]==="*")P++;else if(v[P]!=="**")return!1;return P===v.length}}}function h(t,s=[],o=O.DEFAULT){let i=null,n=[];const r=[];function c(v){Array.isArray(n)?n.push(v):i!==null&&(n[i]=v)}return E(t,{onObjectBegin:()=>{const v={};c(v),r.push(n),n=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const v=[];c(v),r.push(n),n=v,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(v,P,R)=>{s.push({error:v,offset:P,length:R})}},o),n[0]}function p(t,s=[],o=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function r(v){return i.children.push(v),v}E(t,{onObjectBegin:v=>{i=r({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,P,R)=>{i=r({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:P,length:R,parent:i})},onObjectEnd:(v,P)=>{i.length=v+P-i.offset,i=i.parent,n(v+P)},onArrayBegin:(v,P)=>{i=r({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,P)=>{i.length=v+P-i.offset,i=i.parent,n(v+P)},onLiteralValue:(v,P,R)=>{r({type:b(v),offset:P,length:R,parent:i,value:v}),n(P+R)},onSeparator:(v,P,R)=>{i.type==="property"&&(v===":"?i.colonOffset=P:v===","&&n(P))},onError:(v,P,R)=>{s.push({error:v,offset:P,length:R})}},o);const m=i.children[0];return m&&delete m.parent,m}function l(t,s){if(!t)return;let o=t;for(const i of s)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===i){o=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}function g(t){if(!t.parent||!t.parent.children)return[];const s=g(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const s=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(s[o.children[0].value]=d(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}function w(t,s,o=!1){if(f(t,s,o)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const r=w(i[n],s,o);if(r)return r}return t}}function E(t,s,o=O.DEFAULT){const i=C(t,!1);function n(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(ce){return ce?q=>ce(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(s.onObjectBegin),m=r(s.onObjectProperty),v=n(s.onObjectEnd),P=n(s.onArrayBegin),R=n(s.onArrayEnd),I=r(s.onLiteralValue),N=r(s.onSeparator),U=n(s.onComment),j=r(s.onError),F=o&&o.disallowComments,X=o&&o.allowTrailingComma;function K(){for(;;){const ce=i.scan();switch(i.getTokenError()){case k.InvalidUnicode:Q(T.InvalidUnicode);break;case k.InvalidEscapeCharacter:Q(T.InvalidEscapeCharacter);break;case k.UnexpectedEndOfNumber:Q(T.UnexpectedEndOfNumber);break;case k.UnexpectedEndOfComment:F||Q(T.UnexpectedEndOfComment);break;case k.UnexpectedEndOfString:Q(T.UnexpectedEndOfString);break;case k.InvalidCharacter:Q(T.InvalidCharacter);break}switch(ce){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?Q(T.InvalidCommentToken):U();break;case a.Unknown:Q(T.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ce}}}function Q(ce,q=[],x=[]){if(j(ce),q.length+x.length>0){let J=i.getToken();for(;J!==a.EOF;){if(q.indexOf(J)!==-1){K();break}else if(x.indexOf(J)!==-1)break;J=K()}}}function V(ce){const q=i.getTokenValue();return ce?I(q):m(q),K(),!0}function ie(){switch(i.getToken()){case a.NumericLiteral:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(Q(T.InvalidNumberFormat),ce=0)}catch{Q(T.InvalidNumberFormat)}I(ce);break}case a.NullKeyword:I(null);break;case a.TrueKeyword:I(!0);break;case a.FalseKeyword:I(!1);break;default:return!1}return K(),!0}function H(){return i.getToken()!==a.StringLiteral?(Q(T.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(V(!1),i.getToken()===a.ColonToken?(N(":"),K(),re()||Q(T.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):Q(T.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function W(){c(),K();let ce=!1;for(;i.getToken()!==a.CloseBraceToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(T.ValueExpected,[],[]),N(","),K(),i.getToken()===a.CloseBraceToken&&X)break}else ce&&Q(T.CommaExpected,[],[]);H()||Q(T.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ce=!0}return v(),i.getToken()!==a.CloseBraceToken?Q(T.CloseBraceExpected,[a.CloseBraceToken],[]):K(),!0}function ee(){P(),K();let ce=!1;for(;i.getToken()!==a.CloseBracketToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(T.ValueExpected,[],[]),N(","),K(),i.getToken()===a.CloseBracketToken&&X)break}else ce&&Q(T.CommaExpected,[],[]);re()||Q(T.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ce=!0}return R(),i.getToken()!==a.CloseBracketToken?Q(T.CloseBracketExpected,[a.CloseBracketToken],[]):K(),!0}function re(){switch(i.getToken()){case a.OpenBracketToken:return ee();case a.OpenBraceToken:return W();case a.StringLiteral:return V(!0);default:return ie()}}return K(),i.getToken()===a.EOF?o.allowEmptyContent?!0:(Q(T.ValueExpected,[],[]),!1):re()?(i.getToken()!==a.EOF&&Q(T.EndOfFileExpected,[],[]),!0):(Q(T.ValueExpected,[],[]),!1)}function u(t,s){const o=C(t),i=[];let n,r=0,c;do switch(c=o.getPosition(),n=o.scan(),n){case a.LineCommentTrivia:case a.BlockCommentTrivia:case a.EOF:r!==c&&i.push(t.substring(r,c)),s!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,s)),r=o.getPosition();break}while(n!==a.EOF);return i.join("")}function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[46],he([0,1,34]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=a,e.$1n=T,e.$2n=A,e.$3n=L;function a(y,S,$){let h,p,l,g,d;if(S){for(g=S.offset,d=g+S.length,l=g;l>0&&!L(y,l-1);)l--;let c=d;for(;c<y.length&&!L(y,c);)c++;p=y.substring(l,c),h=C(p,$)}else p=y,h=0,l=0,g=0,d=y.length;const f=A($,y);let w=!1,E=0,u;$.insertSpaces?u=O(" ",$.tabSize||4):u="	";const b=(0,k.$Nn)(p,!1);let t=!1;function s(){return f+O(u,h+E)}function o(){let c=b.scan();for(w=!1;c===k.SyntaxKind.Trivia||c===k.SyntaxKind.LineBreakTrivia;)w=w||c===k.SyntaxKind.LineBreakTrivia,c=b.scan();return t=c===k.SyntaxKind.Unknown||b.getTokenError()!==k.ScanError.None,c}const i=[];function n(c,m,v){!t&&m<d&&v>g&&y.substring(m,v)!==c&&i.push({offset:m,length:v-m,content:c})}let r=o();if(r!==k.SyntaxKind.EOF){const c=b.getTokenOffset()+l,m=O(u,h);n(m,l,c)}for(;r!==k.SyntaxKind.EOF;){let c=b.getTokenOffset()+b.getTokenLength()+l,m=o(),v="";for(;!w&&(m===k.SyntaxKind.LineCommentTrivia||m===k.SyntaxKind.BlockCommentTrivia);){const R=b.getTokenOffset()+l;n(" ",c,R),c=b.getTokenOffset()+b.getTokenLength()+l,v=m===k.SyntaxKind.LineCommentTrivia?s():"",m=o()}if(m===k.SyntaxKind.CloseBraceToken)r!==k.SyntaxKind.OpenBraceToken&&(E--,v=s());else if(m===k.SyntaxKind.CloseBracketToken)r!==k.SyntaxKind.OpenBracketToken&&(E--,v=s());else{switch(r){case k.SyntaxKind.OpenBracketToken:case k.SyntaxKind.OpenBraceToken:E++,v=s();break;case k.SyntaxKind.CommaToken:case k.SyntaxKind.LineCommentTrivia:v=s();break;case k.SyntaxKind.BlockCommentTrivia:w?v=s():v=" ";break;case k.SyntaxKind.ColonToken:v=" ";break;case k.SyntaxKind.StringLiteral:if(m===k.SyntaxKind.ColonToken){v="";break}case k.SyntaxKind.NullKeyword:case k.SyntaxKind.TrueKeyword:case k.SyntaxKind.FalseKeyword:case k.SyntaxKind.NumericLiteral:case k.SyntaxKind.CloseBraceToken:case k.SyntaxKind.CloseBracketToken:m===k.SyntaxKind.LineCommentTrivia||m===k.SyntaxKind.BlockCommentTrivia?v=" ":m!==k.SyntaxKind.CommaToken&&m!==k.SyntaxKind.EOF&&(t=!0);break;case k.SyntaxKind.Unknown:t=!0;break}w&&(m===k.SyntaxKind.LineCommentTrivia||m===k.SyntaxKind.BlockCommentTrivia)&&(v=s())}const P=b.getTokenOffset()+l;n(v,c,P),r=m}return i}function T(y,S){const $=JSON.stringify(y,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?$.replace(/\r\n|\r|\n/g,S.eol):$}function O(y,S){let $="";for(let h=0;h<S;h++)$+=y;return $}function C(y,S){let $=0,h=0;const p=S.tabSize||4;for(;$<y.length;){const l=y.charAt($);if(l===" ")h++;else if(l==="	")h+=p;else break;$++}return Math.floor(h/p)}function A(y,S){for(let $=0;$<S.length;$++){const h=S.charAt($);if(h==="\r")return $+1<S.length&&S.charAt($+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return y&&y.eol||`
`}function L(y,S){return`\r
`.indexOf(y.charAt(S))!==-1}}),define(le[63],he([0,1,34,46]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=T,e.$5n=O,e.$6n=C,e.$7n=A,e.$8n=L;function T(y,S,$){return O(y,S,void 0,$)}function O(y,S,$,h,p){const l=S.slice(),g=[],d=(0,k.$Qn)(y,g);let f,w;for(;l.length>0&&(w=l.pop(),f=(0,k.$Rn)(d,l),f===void 0&&$!==void 0);)typeof w=="string"?$={[w]:$}:$=[$];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const E=(0,k.$Rn)(f,[w]);if(E!==void 0)if($===void 0){if(!E.parent)throw new Error("Malformed AST");const u=f.children.indexOf(E.parent);let b,t=E.parent.offset+E.parent.length;if(u>0){const s=f.children[u-1];b=s.offset+s.length}else b=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return C(y,{offset:b,length:t-b,content:""},h)}else return C(y,{offset:E.offset,length:E.length,content:JSON.stringify($)},h);else{if($===void 0)return[];const u=`${JSON.stringify(w)}: ${JSON.stringify($)}`,b=p?p(f.children.map(s=>s.children[0].value)):f.children.length;let t;if(b>0){const s=f.children[b-1];t={offset:s.offset+s.length,length:0,content:","+u}}else f.children.length===0?t={offset:f.offset+1,length:0,content:u}:t={offset:f.offset+1,length:0,content:u+","};return C(y,t,h)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if($!==void 0){const E=`${JSON.stringify($)}`;let u;if(f.children.length===0||w===0)u={offset:f.offset+1,length:0,content:f.children.length===0?E:E+","};else{const b=w===-1||w>f.children.length?f.children.length:w,t=f.children[b-1];u={offset:t.offset+t.length,length:0,content:","+E}}return C(y,u,h)}else{const E=w,u=f.children[E];let b;if(f.children.length===1)b={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===E){const t=f.children[E-1],s=t.offset+t.length,o=f.offset+f.length;b={offset:s,length:o-2-s,content:""}}else b={offset:u.offset,length:f.children[E+1].offset-u.offset,content:""};return C(y,b,h)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else return $===void 0?[]:C(y,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify($)},h)}function C(y,S,$){let h=A(y,S),p=S.offset,l=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;p>0&&!(0,a.$3n)(h,p-1);)p--;for(;l<h.length&&!(0,a.$3n)(h,l);)l++}const g=(0,a.$Zn)(h,{offset:p,length:l-p},$);for(let f=g.length-1;f>=0;f--){const w=g[f];h=A(h,w),p=Math.min(p,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const d=y.length-(h.length-l)-p;return[{offset:p,length:d,content:h.substring(p,l)}]}function A(y,S){return y.substring(0,S.offset)+S.content+y.substring(S.offset+S.length)}function L(y,S){const $=S.slice(0).sort((p,l)=>{const g=p.offset-l.offset;return g===0?p.length-l.length:g});let h=y.length;for(let p=$.length-1;p>=0;p--){const l=$[p];if(l.offset+l.length<=h)y=A(y,l);else throw new Error("Overlapping edit");h=l.offset}return y}}),define(le[54],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class k{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=k}),define(le[90],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class k{static{this.Undefined=new k(void 0)}constructor(O){this.element=O,this.next=k.Undefined,this.prev=k.Undefined}}class a{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let O=this.a;for(;O!==k.Undefined;){const C=O.next;O.prev=k.Undefined,O.next=k.Undefined,O=C}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,C){const A=new k(O);if(this.a===k.Undefined)this.a=A,this.b=A;else if(C){const y=this.b;this.b=A,A.prev=y,y.next=A}else{const y=this.a;this.a=A,A.next=y,y.prev=A}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(A))}}shift(){if(this.a!==k.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==k.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==k.Undefined&&O.next!==k.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===k.Undefined&&O.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):O.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):O.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==k.Undefined;)yield O.element,O=O.next}}e.$5c=a}),define(le[35],he([0,1]),function(ne,e){"use strict";var k,a,T;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=O,e.$yc=C,e.$zc=A,e.$Ic=u;function O(b,t,s){let o=b.get(t);return o===void 0&&(o=s,b.set(t,o)),o}function C(b){const t=[];return b.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${b.size}) {${t.join(", ")}}`}function A(b){const t=[];return b.forEach(s=>{t.push(s)}),`Set(${b.size}) {${t.join(", ")}}`}class L{constructor(t,s){this.uri=t,this.value=s}}function y(b){return Array.isArray(b)}class S{static{this.c=t=>t.toString()}constructor(t,s){if(this[k]="ResourceMap",t instanceof S)this.d=new Map(t.d),this.e=s??S.c;else if(y(t)){this.d=new Map,this.e=s??S.c;for(const[o,i]of t)this.set(o,i)}else this.d=new Map,this.e=t??S.c}set(t,s){return this.d.set(this.e(t),new L(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[o,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=S;class ${constructor(t,s){this[a]="ResourceSet",!t||typeof t=="function"?this.c=new S(t):(this.c=new S(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((o,i)=>t.call(s,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=$;var h;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class p{constructor(){this[T]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=h.None){const o=this.c.get(t);if(o)return s!==h.None&&this.m(o,s),o.value}set(t,s,o=h.None){let i=this.c.get(t);if(i)i.value=s,o!==h.None&&this.m(i,o);else{switch(i={key:t,value:s,next:void 0,previous:void 0},o){case h.None:this.k(i);break;case h.AsOld:this.j(i);break;case h.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const o=this.g;let i=this.d;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this.g;let o=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.key,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this.g;let o=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.value,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this.g;let o=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:[o.key,o.value],done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,o=this.size;for(;s&&o>t;)this.c.delete(s.key),s=s.next,o--;this.d=s,this.f=o,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,o=this.size;for(;s&&o>t;)this.c.delete(s.key),s=s.previous,o--;this.e=s,this.f=o,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(t===this.d)return;const o=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(o.previous=i,i.next=o),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===h.AsNew){if(t===this.e)return;const o=t.next,i=t.previous;t===this.d?(o.previous=void 0,this.d=o):(o.previous=i,i.next=o),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.$Cc=p;class l extends p{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=h.AsNew){return super.get(t,s)}peek(t){return super.get(t,h.None)}set(t,s){return super.set(t,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends l{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Dc=g;class d extends l{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Ec=d;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Fc=f;class w{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,o]of t)this.set(s,o)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((o,i)=>{t.call(s,o,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class E{constructor(){this.c=new Map}add(t,s){let o=this.c.get(t);o||(o=new Set,this.c.set(t,o)),o.add(s)}delete(t,s){const o=this.c.get(t);o&&(o.delete(s),o.size===0&&this.c.delete(t))}forEach(t,s){const o=this.c.get(t);o&&o.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Hc=E;function u(b,t){if(b===t)return!0;if(b.size!==t.size)return!1;for(const[s,o]of b)if(!t.has(s)||t.get(s)!==o)return!1;for(const[s]of t)if(!b.has(s))return!1;return!0}}),define(le[2],he([0,1,19,131,35,89,62]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=S,e.$Lc=$,e.$Mc=h,e.$Nc=g,e.$Oc=d,e.$Pc=f,e.$Qc=w,e.$Rc=E,e.$Sc=u,e.$3c=v;const A=!1;let L=null;class y{constructor(){this.b=new Map}static{this.a=0}c(I){let N=this.b.get(I);return N||(N={parent:null,source:null,isSingleton:!1,value:I,idx:y.a++},this.b.set(I,N)),N}trackDisposable(I){const N=this.c(I);N.source||(N.source=new Error().stack)}setParent(I,N){const U=this.c(I);U.parent=N}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,N){const U=N.get(I);if(U)return U;const j=I.parent?this.f(this.c(I.parent),N):I;return N.set(I,j),j}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,N){let U;if(N)U=N;else{const Q=new Map,V=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,Q).isSingleton);if(V.length===0)return;const ie=new Set(V.map(H=>H.value));if(U=V.filter(H=>!(H.parent&&ie.has(H.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(Q){function V(H,W){for(;H.length>0&&W.some(ee=>typeof ee=="string"?ee===H[0]:H[0].match(ee));)H.shift()}const ie=Q.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return V(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const F=new T.$Hc;for(const Q of U){const V=j(Q);for(let ie=0;ie<=V.length;ie++)F.add(V.slice(0,ie).join(`
`),Q)}U.sort((0,k.$6b)(Q=>Q.idx,k.$8b));let X="",K=0;for(const Q of U.slice(0,I)){K++;const V=j(Q),ie=[];for(let H=0;H<V.length;H++){let W=V[H];W=`(shared with ${F.get(V.slice(0,H+1).join(`
`)).size}/${U.length} leaks) at ${W}`;const re=F.get(V.slice(0,H).join(`
`)),ce=(0,a.$K)([...re].map(q=>j(q)[H]),q=>q);delete ce[V[H]];for(const[q,x]of Object.entries(ce))ie.unshift(`    - stacktraces of ${x.length} other leaks continue with ${q}`);ie.unshift(W)}X+=`


==================== Leaking disposable ${K}/${U.length}: ${Q.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>I&&(X+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:X}}}e.$Jc=y;function S(R){L=R}if(A){const R="__is_disposable_tracked__";S(new class{trackDisposable(I){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[R]||console.log(N)},3e3)}setParent(I,N){if(I&&I!==t.None)try{I[R]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[R]=!0}catch{}}markAsSingleton(I){}})}function $(R){return L?.trackDisposable(R),R}function h(R){L?.markAsDisposed(R)}function p(R,I){L?.setParent(R,I)}function l(R,I){if(L)for(const N of R)L.setParent(N,I)}function g(R){return L?.markAsSingleton(R),R}function d(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function f(R){if(C.Iterable.is(R)){const I=[];for(const N of R)if(N)try{N.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function w(R){for(const I of R)d(I)&&I.dispose();return[]}function E(...R){const I=u(()=>f(R));return l(R,I),I}function u(R){const I=$({dispose:(0,O.$db)(()=>{h(I),R()})});return I}class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return p(I,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),p(I,null))}}e.$Tc=b;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,$(this),p(this.q,this)}dispose(){h(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Uc=t;class s{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&p(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&p(I,null),I}}e.$Vc=s;class o{constructor(I){this.a=new s,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(I){let N=I;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,h(this))},this}}e.$Yc=n;class r{constructor(){this.a=new Map}acquire(I,...N){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...N)},this.a.set(I,U));const{object:j}=U,F=(0,O.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:j,dispose:F}}}e.$Zc=r;class c{constructor(I){this.a=I}async acquire(I,...N){const U=this.a.acquire(I,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.$1c=c;class m{constructor(I){this.object=I}dispose(){}}e.$2c=m;function v(R){const I=new b;try{R(I)}finally{I.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,N,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,N)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}deleteAndLeak(I){const N=this.a.get(I);return this.a.delete(I),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=P}),define(le[64],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var k;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(k||(e.MarshalledId=k={}))}),define(le[91],he([0,1,35]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0,e.$gm=T,e.$hm=C;const a=new k.$Dc(1e4);function T(y){return L(y,"NFC",a)}const O=new k.$Dc(1e4);function C(y){return L(y,"NFD",O)}const A=/[^\u0000-\u0080]/;function L(y,S,$){if(!y)return y;const h=$.get(y);if(h)return h;let p;return A.test(y)?p=y.normalize(S):p=y,$.set(y,p),p}e.$im=function(){const y=/[\u0300-\u036f]/g;return function(S){return C(S).replace(y,"")}}()}),function(){function ne(T){const O=[];typeof T=="number"&&O.push("code/timeOrigin",T);function C(L){O.push(L,Date.now())}function A(){const L=[];for(let y=0;y<O.length;y+=2)L.push({name:O[y],startTime:O[y+1]});return L}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const C of performance.getEntriesByType("mark"))O.push({name:C.name,startTime:Math.round(T+C.startTime)});return O}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=k(a))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var a in k)(typeof exports=="object"?exports:ne)[a]=k[a]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function k(a){if(e[a])return e[a].exports;var T=e[a]={i:a,l:!1,exports:{}};return ne[a].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=ne,k.c=e,k.d=function(a,T,O){k.o(a,T)||Object.defineProperty(a,T,{enumerable:!0,get:O})},k.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},k.t=function(a,T){if(1&T&&(a=k(a)),8&T||4&T&&typeof a=="object"&&a&&a.__esModule)return a;var O=Object.create(null);if(k.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:a}),2&T&&typeof a!="string")for(var C in a)k.d(O,C,function(A){return a[A]}.bind(null,C));return O},k.n=function(a){var T=a&&a.__esModule?function(){return a.default}:function(){return a};return k.d(T,"a",T),T},k.o=function(a,T){return Object.prototype.hasOwnProperty.call(a,T)},k.p="",k(k.s=0)}([function(ne,e,k){(function(a){var T;e=ne.exports=x,T=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],L=e.src=[],y=0,S=y++;L[S]="0|[1-9]\\d*";var $=y++;L[$]="[0-9]+";var h=y++;L[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;L[p]="("+L[S]+")\\.("+L[S]+")\\.("+L[S]+")";var l=y++;L[l]="("+L[$]+")\\.("+L[$]+")\\.("+L[$]+")";var g=y++;L[g]="(?:"+L[S]+"|"+L[h]+")";var d=y++;L[d]="(?:"+L[$]+"|"+L[h]+")";var f=y++;L[f]="(?:-("+L[g]+"(?:\\."+L[g]+")*))";var w=y++;L[w]="(?:-?("+L[d]+"(?:\\."+L[d]+")*))";var E=y++;L[E]="[0-9A-Za-z-]+";var u=y++;L[u]="(?:\\+("+L[E]+"(?:\\."+L[E]+")*))";var b=y++,t="v?"+L[p]+L[f]+"?"+L[u]+"?";L[b]="^"+t+"$";var s="[v=\\s]*"+L[l]+L[w]+"?"+L[u]+"?",o=y++;L[o]="^"+s+"$";var i=y++;L[i]="((?:<|>)?=?)";var n=y++;L[n]=L[$]+"|x|X|\\*";var r=y++;L[r]=L[S]+"|x|X|\\*";var c=y++;L[c]="[v=\\s]*("+L[r]+")(?:\\.("+L[r]+")(?:\\.("+L[r]+")(?:"+L[f]+")?"+L[u]+"?)?)?";var m=y++;L[m]="[v=\\s]*("+L[n]+")(?:\\.("+L[n]+")(?:\\.("+L[n]+")(?:"+L[w]+")?"+L[u]+"?)?)?";var v=y++;L[v]="^"+L[i]+"\\s*"+L[c]+"$";var P=y++;L[P]="^"+L[i]+"\\s*"+L[m]+"$";var R=y++;L[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=y++;L[I]="(?:~>?)";var N=y++;L[N]="(\\s*)"+L[I]+"\\s+",A[N]=new RegExp(L[N],"g");var U=y++;L[U]="^"+L[I]+L[c]+"$";var j=y++;L[j]="^"+L[I]+L[m]+"$";var F=y++;L[F]="(?:\\^)";var X=y++;L[X]="(\\s*)"+L[F]+"\\s+",A[X]=new RegExp(L[X],"g");var K=y++;L[K]="^"+L[F]+L[c]+"$";var Q=y++;L[Q]="^"+L[F]+L[m]+"$";var V=y++;L[V]="^"+L[i]+"\\s*("+s+")$|^$";var ie=y++;L[ie]="^"+L[i]+"\\s*("+t+")$|^$";var H=y++;L[H]="(\\s*)"+L[i]+"\\s*("+s+"|"+L[c]+")",A[H]=new RegExp(L[H],"g");var W=y++;L[W]="^\\s*("+L[c]+")\\s+-\\s+("+L[c]+")\\s*$";var ee=y++;L[ee]="^\\s*("+L[m]+")\\s+-\\s+("+L[m]+")\\s*$";var re=y++;L[re]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)T(ce,L[ce]),A[ce]||(A[ce]=new RegExp(L[ce]));function q(oe,de){if(oe instanceof x)return oe;if(typeof oe!="string"||oe.length>O||!(de?A[o]:A[b]).test(oe))return null;try{return new x(oe,de)}catch{return null}}function x(oe,de){if(oe instanceof x){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof x))return new x(oe,de);T("SemVer",oe,de),this.loose=de;var me=oe.trim().match(de?A[o]:A[b]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var ke=+Pe;if(ke>=0&&ke<C)return ke}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(oe,de){var me=q(oe,de);return me?me.version:null},e.clean=function(oe,de){var me=q(oe.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(oe){return T("SemVer.compare",this.version,this.loose,oe),oe instanceof x||(oe=new x(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},x.prototype.compareMain=function(oe){return oe instanceof x||(oe=new x(oe,this.loose)),G(this.major,oe.major)||G(this.minor,oe.minor)||G(this.patch,oe.patch)},x.prototype.comparePre=function(oe){if(oe instanceof x||(oe=new x(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=oe.prerelease[de];if(T("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return G(me,Pe)}while(++de)},x.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new x(oe,me).inc(de,Pe).version}catch{return null}},e.diff=function(oe,de){if(z(oe,de))return null;var me=q(oe),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return"pre"+ke;return"prerelease"}for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return ke},e.compareIdentifiers=G;var J=/^[0-9]+$/;function G(oe,de){var me=J.test(oe),Pe=J.test(de);return me&&Pe&&(oe=+oe,de=+de),me&&!Pe?-1:Pe&&!me?1:oe<de?-1:oe>de?1:0}function D(oe,de,me){return new x(oe,me).compare(new x(de,me))}function B(oe,de,me){return D(oe,de,me)>0}function M(oe,de,me){return D(oe,de,me)<0}function z(oe,de,me){return D(oe,de,me)===0}function te(oe,de,me){return D(oe,de,me)!==0}function _(oe,de,me){return D(oe,de,me)>=0}function Y(oe,de,me){return D(oe,de,me)<=0}function ae(oe,de,me,Pe){var ke;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),ke=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),ke=oe!==me;break;case"":case"=":case"==":ke=z(oe,me,Pe);break;case"!=":ke=te(oe,me,Pe);break;case">":ke=B(oe,me,Pe);break;case">=":ke=_(oe,me,Pe);break;case"<":ke=M(oe,me,Pe);break;case"<=":ke=Y(oe,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return ke}function ue(oe,de){if(oe instanceof ue){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ue))return new ue(oe,de);T("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(oe,de){return G(de,oe)},e.major=function(oe,de){return new x(oe,de).major},e.minor=function(oe,de){return new x(oe,de).minor},e.patch=function(oe,de){return new x(oe,de).patch},e.compare=D,e.compareLoose=function(oe,de){return D(oe,de,!0)},e.rcompare=function(oe,de,me){return D(de,oe,me)},e.sort=function(oe,de){return oe.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(oe,de){return oe.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=B,e.lt=M,e.eq=z,e.neq=te,e.gte=_,e.lte=Y,e.cmp=ae,e.Comparator=ue;var ge={};function we(oe,de){if(oe instanceof we)return oe.loose===de?oe:new we(oe.raw,de);if(oe instanceof ue)return new we(oe.value,de);if(!(this instanceof we))return new we(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,de,me,Pe,ke,Ue,Ce,Ae,De,Me,He,Fe,qe){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(ke)?">="+me+"."+Pe+".0":">="+de)+" "+(Ae=Ee(De)?"":Ee(Me)?"<"+(+De+1)+".0.0":Ee(He)?"<"+De+"."+(+Me+1)+".0":Fe?"<="+De+"."+Me+"."+He+"-"+Fe:"<="+Ae)).trim()}function be(oe,de){for(var me=0;me<oe.length;me++)if(!oe[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<oe.length;me++)if(T(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Pe=oe[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(oe,de,me){try{de=new we(de,me)}catch{return!1}return de.test(oe)}function Ie(oe,de,me,Pe){var ke,Ue,Ce,Ae,De;switch(oe=new x(oe,Pe),de=new we(de,Pe),me){case">":ke=B,Ue=Y,Ce=M,Ae=">",De=">=";break;case"<":ke=M,Ue=_,Ce=B,Ae="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(oe,de,Pe))return!1;for(var Me=0;Me<de.set.length;++Me){var He=de.set[Me],Fe=null,qe=null;if(He.forEach(function(Be){Be.semver===ge&&(Be=new ue(">=0.0.0")),Fe=Fe||Be,qe=qe||Be,ke(Be.semver,Fe.semver,Pe)?Fe=Be:Ce(Be.semver,qe.semver,Pe)&&(qe=Be)}),Fe.operator===Ae||Fe.operator===De||(!qe.operator||qe.operator===Ae)&&Ue(oe,qe.semver)||qe.operator===De&&Ce(oe,qe.semver))return!1}return!0}ue.prototype.parse=function(oe){var de=this.loose?A[V]:A[ie],me=oe.match(de);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new x(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(oe){return T("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new x(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(oe,de){if(!(oe instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(oe.value,de),Se(this.value,me,de);if(oe.operator==="")return me=new we(this.value,de),Se(oe.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ue=this.semver.version===oe.semver.version,Ce=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Ae=ae(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),De=ae(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Pe||ke||Ue&&Ce||Ae||De},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),T("range",oe,de);var me=de?A[ee]:A[W];oe=oe.replace(me,pe),T("hyphen replace",oe),oe=oe.replace(A[H],"$1$2$3"),T("comparator trim",oe,A[H]),oe=(oe=(oe=oe.replace(A[N],"$1~")).replace(A[X],"$1^")).split(/\s+/).join(" ");var Pe=de?A[V]:A[ie],ke=oe.split(" ").map(function(Ue){return function(Ce,Ae){return T("comp",Ce),Ce=function(De,Me){return De.trim().split(/\s+/).map(function(He){return function(Fe,qe){T("caret",Fe,qe);var Be=qe?A[Q]:A[K];return Fe.replace(Be,function(ze,Le,se,fe,$e){var ye;return T("caret",Fe,ze,Le,se,fe,$e),Ee(Le)?ye="":Ee(se)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(fe)?ye=Le==="0"?">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+".0 <"+(+Le+1)+".0.0":$e?(T("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Le==="0"?se==="0"?">="+Le+"."+se+"."+fe+$e+" <"+Le+"."+se+"."+(+fe+1):">="+Le+"."+se+"."+fe+$e+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+fe+$e+" <"+(+Le+1)+".0.0"):(T("no pr"),ye=Le==="0"?se==="0"?">="+Le+"."+se+"."+fe+" <"+Le+"."+se+"."+(+fe+1):">="+Le+"."+se+"."+fe+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+fe+" <"+(+Le+1)+".0.0"),T("caret return",ye),ye})}(He,Me)}).join(" ")}(Ce,Ae),T("caret",Ce),Ce=function(De,Me){return De.trim().split(/\s+/).map(function(He){return function(Fe,qe){var Be=qe?A[j]:A[U];return Fe.replace(Be,function(ze,Le,se,fe,$e){var ye;return T("tilde",Fe,ze,Le,se,fe,$e),Ee(Le)?ye="":Ee(se)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(fe)?ye=">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":$e?(T("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Le+"."+se+"."+fe+$e+" <"+Le+"."+(+se+1)+".0"):ye=">="+Le+"."+se+"."+fe+" <"+Le+"."+(+se+1)+".0",T("tilde return",ye),ye})}(He,Me)}).join(" ")}(Ce,Ae),T("tildes",Ce),Ce=function(De,Me){return T("replaceXRanges",De,Me),De.split(/\s+/).map(function(He){return function(Fe,qe){Fe=Fe.trim();var Be=qe?A[P]:A[v];return Fe.replace(Be,function(ze,Le,se,fe,$e,ye){T("xRange",Fe,ze,Le,se,fe,$e,ye);var Oe=Ee(se),Te=Oe||Ee(fe),je=Te||Ee($e);return Le==="="&&je&&(Le=""),Oe?ze=Le===">"||Le==="<"?"<0.0.0":"*":Le&&je?(Te&&(fe=0),je&&($e=0),Le===">"?(Le=">=",Te?(se=+se+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Le==="<="&&(Le="<",Te?se=+se+1:fe=+fe+1),ze=Le+se+"."+fe+"."+$e):Te?ze=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(ze=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),T("xRange return",ze),ze})}(He,Me)}).join(" ")}(Ce,Ae),T("xrange",Ce),Ce=function(De,Me){return T("replaceStars",De,Me),De.trim().replace(A[re],"")}(Ce,Ae),T("stars",Ce),Ce}(Ue,de)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(Ue){return!!Ue.match(Pe)})),ke=ke.map(function(Ue){return new ue(Ue,de)})},we.prototype.intersects=function(oe,de){if(!(oe instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return oe.set.some(function(ke){return ke.every(function(Ue){return Pe.intersects(Ue,de)})})})})},e.toComparators=function(oe,de){return new we(oe,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new x(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(oe,de,me){var Pe=null,ke=null;try{var Ue=new we(de,me)}catch{return null}return oe.forEach(function(Ce){Ue.test(Ce)&&(Pe&&ke.compare(Ce)!==-1||(ke=new x(Pe=Ce,me)))}),Pe},e.minSatisfying=function(oe,de,me){var Pe=null,ke=null;try{var Ue=new we(de,me)}catch{return null}return oe.forEach(function(Ce){Ue.test(Ce)&&(Pe&&ke.compare(Ce)!==1||(ke=new x(Pe=Ce,me)))}),Pe},e.validRange=function(oe,de){try{return new we(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,me){return Ie(oe,de,"<",me)},e.gtr=function(oe,de,me){return Ie(oe,de,">",me)},e.outside=Ie,e.prerelease=function(oe,de){var me=q(oe,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,de,me){return oe=new we(oe,me),de=new we(de,me),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof x)return oe;if(typeof oe!="string")return null;var de=oe.match(A[R]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(ne,e){var k,a,T=ne.exports={};function O(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(d){if(k===setTimeout)return setTimeout(d,0);if((k===O||!k)&&setTimeout)return k=setTimeout,setTimeout(d,0);try{return k(d,0)}catch{try{return k.call(null,d,0)}catch{return k.call(this,d,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:O}catch{k=O}try{a=typeof clearTimeout=="function"?clearTimeout:C}catch{a=C}})();var L,y=[],S=!1,$=-1;function h(){S&&L&&(S=!1,L.length?y=L.concat(y):$=-1,y.length&&p())}function p(){if(!S){var d=A(h);S=!0;for(var f=y.length;f;){for(L=y,y=[];++$<f;)L&&L[$].run();$=-1,f=y.length}L=null,S=!1,function(w){if(a===clearTimeout)return clearTimeout(w);if((a===C||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(w);try{a(w)}catch{try{return a.call(null,w)}catch{return a.call(this,w)}}}(d)}}function l(d,f){this.fun=d,this.array=f}function g(){}T.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];y.push(new l(d,f)),y.length!==1||S||A(p)},l.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=g,T.addListener=g,T.once=g,T.off=g,T.removeListener=g,T.removeAllListeners=g,T.emit=g,T.prependListener=g,T.prependOnceListener=g,T.listeners=function(d){return[]},T.binding=function(d){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(d){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(le[133],he([0,1]),function(ne,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class a{constructor(A,L,y){this.level=A,this.key=L,this.value=y,this.forward=[]}}const T=void 0;class O{constructor(A,L=2**16){this.comparator=A,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(L)|0),this.e=new a(this.c,T,T)}get size(){return this.f}clear(){this.e=new a(this.c,T,T),this.f=0}has(A){return!!O.g(this,A,this.comparator)}get(A){return O.g(this,A,this.comparator)?.value}set(A,L){return O.h(this,A,L,this.comparator)&&(this.f+=1),this}delete(A){const L=O.k(this,A,this.comparator);return L&&(this.f-=1),L}forEach(A,L){let y=this.e.forward[0];for(;y;)A.call(L,y.value,y.key,this),y=y.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",L=this.e.forward[0];for(;L;)A+=`node(${L.key}, ${L.value}, lvl:${L.level})`,L=L.forward[0];return A}static g(A,L,y){let S=A.e;for(let $=A.d-1;$>=0;$--)for(;S.forward[$]&&y(S.forward[$].key,L)<0;)S=S.forward[$];if(S=S.forward[0],S&&y(S.key,L)===0)return S}static h(A,L,y,S){const $=[];let h=A.e;for(let p=A.d-1;p>=0;p--){for(;h.forward[p]&&S(h.forward[p].key,L)<0;)h=h.forward[p];$[p]=h}if(h=h.forward[0],h&&S(h.key,L)===0)return h.value=y,!1;{const p=O.j(A);if(p>A.d){for(let l=A.d;l<p;l++)$[l]=A.e;A.d=p}h=new a(p,L,y);for(let l=0;l<p;l++)h.forward[l]=$[l].forward[l],$[l].forward[l]=h;return!0}}static j(A,L=.5){let y=1;for(;Math.random()<L&&y<A.c;)y+=1;return y}static k(A,L,y){const S=[];let $=A.e;for(let h=A.d-1;h>=0;h--){for(;$.forward[h]&&y($.forward[h].key,L)<0;)$=$.forward[h];S[h]=$}if($=$.forward[0],!$||y($.key,L)!==0)return!1;for(let h=0;h<A.d&&S[h].forward[h]===$;h++)S[h].forward[h]=$.forward[h];for(;A.d>0&&A.e.forward[A.d-1]===T;)A.d-=1;return!0}}e.$Hs=O}),define(le[65],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(O){return new a(O)}constructor(O){this.c=k&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=a}),define(le[3],he([0,1,8,89,2,90,65]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=p;const A=!1,L=!1,y=!1;var S;(function(j){j.None=()=>T.$Uc.None;function F(pe){if(y){const{onDidAddListener:be}=pe,Se=g.create();let Ie=0;pe.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function X(pe,be){return q(pe,()=>{},0,void 0,!0,void 0,be)}j.defer=X;function K(pe){return(be,Se=null,Ie)=>{let oe=!1,de;return de=pe(me=>{if(!oe)return de?de.dispose():oe=!0,be.call(Se,me)},null,Ie),oe&&de.dispose(),de}}j.once=K;function Q(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>Ie.call(oe,be(me)),null,de),Se)}j.map=Q;function V(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>{be(me),Ie.call(oe,me)},null,de),Se)}j.forEach=V;function ie(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>be(me)&&Ie.call(oe,me),null,de),Se)}j.filter=ie;function H(pe){return pe}j.signal=H;function W(...pe){return(be,Se=null,Ie)=>{const oe=(0,T.$Rc)(...pe.map(de=>de(me=>be.call(Se,me))));return ce(oe,Ie)}}j.any=W;function ee(pe,be,Se,Ie){let oe=Se;return Q(pe,de=>(oe=be(oe,de),oe),Ie)}j.reduce=ee;function re(pe,be){let Se;const Ie={onWillAddFirstListener(){Se=pe(oe.fire,oe)},onDidRemoveLastListener(){Se?.dispose()}};be||F(Ie);const oe=new s(Ie);return be?.add(oe),oe.event}function ce(pe,be){return be instanceof Array?be.push(pe):be&&be.add(pe),pe}function q(pe,be,Se=100,Ie=!1,oe=!1,de,me){let Pe,ke,Ue,Ce=0,Ae;const De={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Ce++,ke=be(ke,He),Ie&&!Ue&&(Me.fire(ke),ke=void 0),Ae=()=>{const Fe=ke;ke=void 0,Ue=void 0,(!Ie||Ce>1)&&Me.fire(Fe),Ce=0},typeof Se=="number"?(clearTimeout(Ue),Ue=setTimeout(Ae,Se)):Ue===void 0&&(Ue=0,queueMicrotask(Ae))})},onWillRemoveListener(){oe&&Ce>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Pe.dispose()}};me||F(De);const Me=new s(De);return me?.add(Me),Me.event}j.debounce=q;function x(pe,be=0,Se){return j.debounce(pe,(Ie,oe)=>Ie?(Ie.push(oe),Ie):[oe],be,void 0,!0,void 0,Se)}j.accumulate=x;function J(pe,be=(Ie,oe)=>Ie===oe,Se){let Ie=!0,oe;return ie(pe,de=>{const me=Ie||!be(de,oe);return Ie=!1,oe=de,me},Se)}j.latch=J;function G(pe,be,Se){return[j.filter(pe,be,Se),j.filter(pe,Ie=>!be(Ie),Se)]}j.split=G;function D(pe,be=!1,Se=[],Ie){let oe=Se.slice(),de=pe(ke=>{oe?oe.push(ke):Pe.fire(ke)});Ie&&Ie.add(de);const me=()=>{oe?.forEach(ke=>Pe.fire(ke)),oe=null},Pe=new s({onWillAddFirstListener(){de||(de=pe(ke=>Pe.fire(ke)),Ie&&Ie.add(de))},onDidAddFirstListener(){oe&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}j.buffer=D;function B(pe,be){return(Ie,oe,de)=>{const me=be(new z);return pe(function(Pe){const ke=me.evaluate(Pe);ke!==M&&Ie.call(oe,ke)},void 0,de)}}j.chain=B;const M=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:M),this}reduce(be,Se){let Ie=Se;return this.f.push(oe=>(Ie=be(Ie,oe),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(oe=>{const de=Se||!be(oe,Ie);return Se=!1,Ie=oe,de?oe:M}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===M)break;return be}}function te(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.on(be,Ie),de=()=>pe.removeListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}j.fromNodeEventEmitter=te;function _(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.addEventListener(be,Ie),de=()=>pe.removeEventListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}j.fromDOMEventEmitter=_;function Y(pe){return new Promise(be=>K(pe)(be))}j.toPromise=Y;function ae(pe){const be=new s;return pe.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}j.fromPromise=ae;function ue(pe,be,Se){return be(Se),pe(Ie=>be(Ie))}j.runAndSubscribe=ue;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||F(Ie),this.emitter=new s(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(pe,be){return new ge(pe,be).emitter.event}j.fromObservable=we;function Ee(pe){return(be,Se,Ie)=>{let oe=0,de=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Ie instanceof T.$Tc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}j.fromObservableLight=Ee})(S||(e.Event=S={}));class ${static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${$.f++}`,$.all.add(this)}start(F){this.g=new C.$be,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$de=$;let h=-1;function p(j){const F=h;return h=j,{dispose(){h=F}}}class l{constructor(F,X,K=Math.random().toString(18).slice(2,5)){this.h=F,this.threshold=X,this.name=K,this.g=0}dispose(){this.f?.clear()}check(F,X){const K=this.threshold;if(K<=0||X<K)return;this.f||(this.f=new Map);const Q=this.f.get(F.value)||0;if(this.f.set(F.value,Q+1),this.g-=1,this.g<=0){this.g=K*.5;const[V,ie]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${ie}):`;console.warn(H),console.warn(V);const W=new d(H,V);this.h(W)}return()=>{const V=this.f.get(F.value)||0;this.f.set(F.value,V-1)}}getMostFrequentStack(){if(!this.f)return;let F,X=0;for(const[K,Q]of this.f)(!F||X<Q)&&(F=[K,Q],X=Q);return F}}class g{static create(){const F=new Error;return new g(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(F,X){super(F),this.name="ListenerLeakError",this.stack=X}}e.$fe=d;class f extends Error{constructor(F,X){super(F),this.name="ListenerRefusalError",this.stack=X}}e.$ge=f;let w=0;class E{constructor(F){this.value=F,this.id=w++}}const u=2,b=(j,F)=>{if(j instanceof E)F(j);else for(let X=0;X<j.length;X++){const K=j[X];K&&F(K)}},t=A?new FinalizationRegistry(j=>{typeof j=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(j))}):void 0;class s{constructor(F){this.w=0,this.f=F,this.g=h>0||this.f?.leakWarningThreshold?new l(F?.onListenerError??k.$1,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(L){const F=this.t;queueMicrotask(()=>{b(F,X=>X.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,X,K)=>{if(this.g&&this.w>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(W);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${W}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||k.$1)(re),T.$Uc.None}if(this.m)return T.$Uc.None;X&&(F=F.bind(X));const Q=new E(F);let V,ie;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Q.stack=g.create(),V=this.g.check(Q.stack,this.w+1)),L&&(Q.stack=ie??g.create()),this.t?this.t instanceof E?(this.u??=new i,this.t=[this.t,Q]):this.t.push(Q):(this.f?.onWillAddFirstListener?.(this),this.t=Q,this.f?.onDidAddFirstListener?.(this)),this.w++;const H=(0,T.$Sc)(()=>{t?.unregister(H),V?.(),this.x(Q)});if(K instanceof T.$Tc?K.add(H):Array.isArray(K)&&K.push(H),t){const W=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(H,W,H)}return H},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const X=this.t,K=X.indexOf(F);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,X[K]=void 0;const Q=this.u.current===this;if(this.w*u<=X.length){let V=0;for(let ie=0;ie<X.length;ie++)X[ie]?X[V++]=X[ie]:Q&&(this.u.end--,V<this.u.i&&this.u.i--);X.length=V}}y(F,X){if(!F)return;const K=this.f?.onListenerError||k.$1;if(!K){F.value(X);return}try{F.value(X)}catch(Q){K(Q)}}z(F){const X=F.current.t;for(;F.i<F.end;)this.y(X[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof E)this.y(this.t,F);else{const X=this.u;X.enqueue(this,F,this.t.length),this.z(X)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=s;const o=()=>new i;e.$ie=o;class i{constructor(){this.i=-1,this.end=0}enqueue(F,X,K){this.i=0,this.end=K,this.current=F,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends s{async fireAsync(F,X,K){if(this.t)for(this.h||(this.h=new O.$5c),b(this.t,Q=>this.h.push([Q.value,F]));this.h.size>0&&!X.isCancellationRequested;){const[Q,V]=this.h.shift(),ie=[],H={...V,token:X,waitUntil:W=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");K&&(W=K(W,Q)),ie.push(W)}};try{Q(H)}catch(W){(0,k.$1)(W);continue}Object.freeze(ie),await Promise.allSettled(ie).then(W=>{for(const ee of W)ee.status==="rejected"&&(0,k.$1)(ee.reason)})}}}e.$je=n;class r extends s{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new O.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ke=r;class c extends r{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$le=c;class m extends s{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}e.$me=m;class v{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const X={event:F,listener:null};this.h.push(X),this.g&&this.m(X);const K=()=>{this.g&&this.o(X);const Q=this.h.indexOf(X);this.h.splice(Q,1)};return(0,T.$Sc)((0,a.$db)(K))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(X=>this.f.fire(X))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ne=v;class P{constructor(F,X,K,Q){this.f=new T.$Tc;const V=this.f.add(new v),ie=this.f.add(new T.$4c);function H(W){ie.set(W,V.add(Q(W)))}for(const W of F)H(W);this.f.add(X(W=>{H(W)})),this.f.add(K(W=>{ie.deleteAndDispose(W)})),this.event=V.event}dispose(){this.f.dispose()}}e.$oe=P;class R{constructor(){this.f=[]}wrapEvent(F,X,K){return(Q,V,ie)=>F(H=>{const W=this.f[this.f.length-1];if(!X){W?W.buffers.push(()=>Q.call(V,H)):Q.call(V,H);return}const ee=W;if(!ee){Q.call(V,X(K,H));return}ee.items??=[],ee.items.push(H),ee.buffers.length===0&&W.buffers.push(()=>{ee.reducedResult??=K?ee.items.reduce(X,K):ee.items.reduce(X),Q.call(V,ee.reducedResult)})},void 0,ie)}bufferEvents(F){const X={buffers:new Array};this.f.push(X);const K=F();return this.f.pop(),X.buffers.forEach(Q=>Q()),K}}e.$pe=R;class I{constructor(){this.f=!1,this.g=S.None,this.h=T.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=I;class N{static const(F){return new U(F)}constructor(F){this.g=F,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$re=N;class U{constructor(F){this.value=F,this.onDidChange=S.None}}}),define(le[26],he([0,1,3]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=A;const a=Object.freeze(function(L,y){const S=setTimeout(L.bind(y),0);return{dispose(){clearTimeout(S)}}});var T;(function(L){function y(S){return S===L.None||S===L.Cancelled||S instanceof O?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}L.isCancellationToken=y,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(T||(e.CancellationToken=T={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new k.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=T.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=T.None}}e.$se=C;function A(L){const y=new C;return L.add({dispose(){y.cancel()}}),y.token}}),define(le[134],he([0,1,26]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=T;class a{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new k.$se,y=this.b(L.token);return this.a={promise:y,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$5e=a;function T(A){return A}class O{constructor(L,y){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=T):(this.c=y,this.d=L.getCacheKey)}get(L){const y=this.d(L);return this.b!==y&&(this.b=y,this.a=this.c(L)),this.a}}e.$7e=O;class C{get cachedValues(){return this.a}constructor(L,y){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=T):(this.c=y,this.d=L.getCacheKey)}get(L){const y=this.d(L);if(this.b.has(y))return this.b.get(y);const S=this.c(L);return this.a.set(L,S),this.b.set(y,S),S}}e.$8e=C}),define(le[51],he([0,1,8,2]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=T,e.$ve=O,e.$we=C,e.$xe=A,e.$ye=y,e.$ze=S,e.$Ae=$,e.$Be=h,e.$Ce=p,e.$De=l,e.$Ee=g,e.$Fe=d,e.$Ge=f,e.$He=w,e.$Ie=E;function T(u){const b=u;return b?typeof b.read=="function":!1}function O(u){const b=u;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}function C(u){const b=u;return b?O(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}function A(u,b){return new L(u,b)}class L{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,k.$1)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let s;switch(b){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(t);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(u,b){const t=[];let s;for(;(s=u.read())!==null;)t.push(s);return b(t)}function S(u,b,t){const s=[];let o;for(;(o=u.read())!==null&&s.length<t;)s.push(o);return o===null&&s.length>0?b(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return u.read()}}}function $(u,b){return new Promise((t,s)=>{const o=[];h(u,{onData:i=>{b&&o.push(i)},onError:i=>{b?s(i):t(void 0)},onEnd:()=>{t(b?b(o):void 0)}})})}function h(u,b,t){u.on("error",s=>{t?.isCancellationRequested||b.onError(s)}),u.on("end",()=>{t?.isCancellationRequested||b.onEnd()}),u.on("data",s=>{t?.isCancellationRequested||b.onData(s)})}function p(u,b){return new Promise((t,s)=>{const o=new a.$Tc,i=[],n=m=>{if(i.push(m),i.length>b)return o.dispose(),u.pause(),t({stream:u,buffer:i,ended:!1})},r=m=>(o.dispose(),s(m)),c=()=>(o.dispose(),t({stream:u,buffer:i,ended:!0}));o.add((0,a.$Sc)(()=>u.removeListener("error",r))),u.on("error",r),o.add((0,a.$Sc)(()=>u.removeListener("end",c))),u.on("end",c),o.add((0,a.$Sc)(()=>u.removeListener("data",n))),u.on("data",n)})}function l(u,b){const t=A(b);return t.end(u),t}function g(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}function d(u){let b=!1;return{read:()=>b?null:(b=!0,u)}}function f(u,b,t){const s=A(t);return h(u,{onData:o=>s.write(b.data(o)),onError:o=>s.error(b.error?b.error(o):o),onEnd:()=>s.end()}),s}function w(u,b,t){let s=!1;return{read:()=>{const o=b.read();return s?o:(s=!0,o!==null?t([u,o]):u)}}}function E(u,b,t){let s=!1;const o=A(t);return h(b,{onData:i=>s?o.write(i):(s=!0,o.write(t([u,i]))),onError:i=>o.error(i),onEnd:()=>{s||(s=!0,o.write(u)),o.end()}}),o}}),define(le[15],he([0,1,54,51]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=y,e.$Le=S,e.$Me=$,e.$Ne=h,e.$Oe=p,e.$Pe=l,e.$Qe=g,e.$Re=d,e.$Se=f,e.$Te=w,e.$Ue=E,e.$Ve=u,e.$We=b,e.$Xe=t,e.$Ye=s,e.$Ze=o,e.$1e=i,e.$2e=n,e.$3e=r,e.$4e=v;const T=typeof Buffer<"u",O=new k.$V(()=>new Uint8Array(256));let C,A;class L{static alloc(R){return T?new L(Buffer.allocUnsafe(R)):new L(new Uint8Array(R))}static wrap(R){return T&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new L(R)}static fromString(R,I){return!(I?.dontUseNodeBuffer||!1)&&T?new L(Buffer.from(R)):(C||(C=new TextEncoder),new L(C.encode(R)))}static fromByteArray(R){const I=L.alloc(R.length);for(let N=0,U=R.length;N<U;N++)I.buffer[N]=R[N];return I}static concat(R,I){if(typeof I>"u"){I=0;for(let j=0,F=R.length;j<F;j++)I+=R[j].byteLength}const N=L.alloc(I);let U=0;for(let j=0,F=R.length;j<F;j++){const X=R[j];N.set(X,U),U+=X.byteLength}return N}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=L.alloc(this.byteLength);return R.set(this),R}toString(){return T?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(R,I){return new L(this.buffer.subarray(R,I))}set(R,I){if(R instanceof L)this.buffer.set(R.buffer,I);else if(R instanceof Uint8Array)this.buffer.set(R,I);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),I);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return h(this.buffer,R)}writeUInt32BE(R,I){p(this.buffer,R,I)}readUInt32LE(R){return l(this.buffer,R)}writeUInt32LE(R,I){g(this.buffer,R,I)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,I){f(this.buffer,R,I)}indexOf(R,I=0){return y(this.buffer,R instanceof L?R.buffer:R,I)}}e.$Je=L;function y(P,R,I=0){const N=R.byteLength,U=P.byteLength;if(N===0)return 0;if(N===1)return P.indexOf(R[0]);if(N>U-I)return-1;const j=O.value;j.fill(R.length);for(let Q=0;Q<R.length;Q++)j[R[Q]]=R.length-Q-1;let F=I+R.length-1,X=F,K=-1;for(;F<U;)if(P[F]===R[X]){if(X===0){K=F;break}F--,X--}else F+=Math.max(R.length-X,j[P[F]]),X=R.length-1;return K}function S(P,R){return P[R+0]<<0>>>0|P[R+1]<<8>>>0}function $(P,R,I){P[I+0]=R&255,R=R>>>8,P[I+1]=R&255}function h(P,R){return P[R]*2**24+P[R+1]*2**16+P[R+2]*2**8+P[R+3]}function p(P,R,I){P[I+3]=R,R=R>>>8,P[I+2]=R,R=R>>>8,P[I+1]=R,R=R>>>8,P[I]=R}function l(P,R){return P[R+0]<<0>>>0|P[R+1]<<8>>>0|P[R+2]<<16>>>0|P[R+3]<<24>>>0}function g(P,R,I){P[I+0]=R&255,R=R>>>8,P[I+1]=R&255,R=R>>>8,P[I+2]=R&255,R=R>>>8,P[I+3]=R&255}function d(P,R){return P[R]}function f(P,R,I){P[I]=R}function w(P){return a.$ye(P,R=>L.concat(R))}function E(P){return a.$Fe(P)}function u(P){return a.$Ae(P,R=>L.concat(R))}async function b(P){return P.ended?L.concat(P.buffer):L.concat([...P.buffer,await u(P.stream)])}function t(P){return a.$De(P,R=>L.concat(R))}function s(P){return a.$Ge(P,{data:R=>typeof R=="string"?L.fromString(R):L.wrap(R)},R=>L.concat(R))}function o(P){return a.$xe(R=>L.concat(R),P)}function i(P,R){return a.$He(P,R,I=>L.concat(I))}function n(P,R){return a.$Ie(P,R,I=>L.concat(I))}function r(P){let R=0,I=0,N=0;const U=new Uint8Array(Math.floor(P.length/4*3)),j=X=>{switch(I){case 3:U[N++]=R|X,I=0;break;case 2:U[N++]=R|X>>>2,R=X<<6,I=3;break;case 1:U[N++]=R|X>>>4,R=X<<4,I=2;break;default:R=X<<2,I=1}};for(let X=0;X<P.length;X++){const K=P.charCodeAt(X);if(K>=65&&K<=90)j(K-65);else if(K>=97&&K<=122)j(K-97+26);else if(K>=48&&K<=57)j(K-48+52);else if(K===43||K===45)j(62);else if(K===47||K===95)j(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${P[X]}`)}}const F=N;for(;I>0;)j(0);return L.wrap(U).slice(0,F)}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:P},R=!0,I=!1){const N=I?m:c;let U="";const j=P.byteLength%3;let F=0;for(;F<P.byteLength-j;F+=3){const X=P[F+0],K=P[F+1],Q=P[F+2];U+=N[X>>>2],U+=N[(X<<4|K>>>4)&63],U+=N[(K<<2|Q>>>6)&63],U+=N[Q&63]}if(j===1){const X=P[F+0];U+=N[X>>>2],U+=N[X<<4&63],R&&(U+="==")}else if(j===2){const X=P[F+0],K=P[F+1];U+=N[X>>>2],U+=N[(X<<4|K>>>4)&63],U+=N[K<<2&63],R&&(U+="=")}return U}}),define(le[135],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(le[13],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=k,e.$bg=a,e.$cg=T,e.$dg=O,e.$eg=C,e.$fg=A,e.$gg=L,e.$hg=y,e.$ig=S,e.$jg=$,e.$kg=h,e.$lg=p,e.$mg=l,e.$ng=d,e.$og=f,e.$pg=w,e.$qg=E,e.$rg=u;function k(b){return typeof b=="string"}function a(b){return Array.isArray(b)&&b.every(t=>k(t))}function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}function O(b){const t=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof t}function C(b){return typeof b=="number"&&!isNaN(b)}function A(b){return!!b&&typeof b[Symbol.iterator]=="function"}function L(b){return b===!0||b===!1}function y(b){return typeof b>"u"}function S(b){return!$(b)}function $(b){return y(b)||b===null}function h(b,t){if(!b)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function p(b){if($(b))throw new Error("Assertion Failed: argument is undefined or null");return b}function l(...b){const t=[];for(let s=0;s<b.length;s++){const o=b[s];if($(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}const g=Object.prototype.hasOwnProperty;function d(b){if(!T(b))return!1;for(const t in b)if(g.call(b,t))return!1;return!0}function f(b){return typeof b=="function"}function w(...b){return b.length>0&&b.every(f)}function E(b,t){const s=Math.min(b.length,t.length);for(let o=0;o<s;o++)u(b[o],t[o])}function u(b,t){if(k(t)){if(typeof b!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(b instanceof t)return}catch{}if(!$(b)&&b.constructor===t||t.length===1&&t.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=a,e.$0n=T,e.$$n=C,e.$_n=L,e.$ao=y,e.$bo=S,e.$co=$,e.$do=h,e.$eo=p,e.$fo=l,e.$go=g,e.$ho=d,e.$io=f;function a(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const E=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([u,b])=>{E[u]=b&&typeof b=="object"?a(b):b}),E}function T(w){if(!w||typeof w!="object")return w;const E=[w];for(;E.length>0;){const u=E.shift();Object.freeze(u);for(const b in u)if(O.call(u,b)){const t=u[b];typeof t=="object"&&!Object.isFrozen(t)&&!(0,k.$dg)(t)&&E.push(t)}}return w}const O=Object.prototype.hasOwnProperty;function C(w,E){return A(w,E,new Set)}function A(w,E,u){if((0,k.$jg)(w))return w;const b=E(w);if(typeof b<"u")return b;if(Array.isArray(w)){const t=[];for(const s of w)t.push(A(s,E,u));return t}if((0,k.$cg)(w)){if(u.has(w))throw new Error("Cannot clone recursive data-structure");u.add(w);const t={};for(const s in w)O.call(w,s)&&(t[s]=A(w[s],E,u));return u.delete(w),t}return w}function L(w,E,u=!0){return(0,k.$cg)(w)?((0,k.$cg)(E)&&Object.keys(E).forEach(b=>{b in w?u&&((0,k.$cg)(w[b])&&(0,k.$cg)(E[b])?L(w[b],E[b],u):w[b]=E[b]):w[b]=E[b]}),w):E}function y(w,E){if(w===E)return!0;if(w==null||E===null||E===void 0||typeof w!=typeof E||typeof w!="object"||Array.isArray(w)!==Array.isArray(E))return!1;let u,b;if(Array.isArray(w)){if(w.length!==E.length)return!1;for(u=0;u<w.length;u++)if(!y(w[u],E[u]))return!1}else{const t=[];for(b in w)t.push(b);t.sort();const s=[];for(b in E)s.push(b);if(s.sort(),!y(t,s))return!1;for(u=0;u<t.length;u++)if(!y(w[t[u]],E[t[u]]))return!1}return!0}function S(w){const E=new Set;return JSON.stringify(w,(u,b)=>{if((0,k.$cg)(b)||Array.isArray(b)){if(E.has(b))return"[Circular]";E.add(b)}return typeof b=="bigint"?`[BigInt ${b.toString()}]`:b})}function $(w,E){const u=Object.create(null);return!w||!E||Object.keys(E).forEach(t=>{const s=w[t],o=E[t];y(s,o)||(u[t]=o)}),u}function h(w,E){const u=E.toLowerCase(),b=Object.keys(w).find(t=>t.toLowerCase()===u);return b?w[b]:w[E]}function p(w,E){const u=Object.create(null);for(const[b,t]of Object.entries(w))E(b,t)&&(u[b]=t);return u}function l(w){let E=[];for(;Object.prototype!==w;)E=E.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return E}function g(w){const E=[];for(const u of l(w))typeof w[u]=="function"&&E.push(u);return E}function d(w,E){const u=t=>function(){const s=Array.prototype.slice.call(arguments,0);return E(t,s)},b={};for(const t of w)b[t]=u(t);return b}function f(w,E){const u={};for(const[b,t]of Object.entries(w))u[b]=E(t,b);return u}}),define(le[136],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=a,e.$0e=T;var k;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(e.Constants=k={}));function a(O){return O<0?0:O>k.MAX_UINT_8?k.MAX_UINT_8:O|0}function T(O){return O<0?0:O>k.MAX_UINT_32?k.MAX_UINT_32:O|0}}),define(le[27],he([0,1,134,39,54,136]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=C,e.$_e=L,e.$af=S,e.$bf=$,e.$cf=h,e.$df=p,e.$ef=l,e.$ff=g,e.$gf=d,e.$hf=f,e.$if=w,e.$jf=E,e.$kf=u,e.$lf=b,e.$mf=t,e.$nf=s,e.$of=o,e.$pf=i,e.$qf=n,e.$rf=r,e.$sf=c,e.$tf=m,e.$uf=v,e.$vf=P,e.$wf=R,e.$xf=I,e.$yf=N,e.$zf=U,e.$Af=j,e.$Bf=F,e.$Cf=X,e.$Df=K,e.$Ef=Q,e.$Ff=V,e.$Gf=ie,e.$Hf=H,e.$If=W,e.$Lf=q,e.$Mf=x,e.$Nf=J,e.$Of=G,e.$Pf=M,e.$Qf=te,e.$Sf=_,e.$Tf=Y,e.$Uf=ae,e.$Vf=ue,e.$Wf=we,e.$Xf=Ee,e.$Yf=be,e.$1f=Se,e.$2f=Ie,e.$3f=oe,e.$4f=de,e.$5f=me,e.$6f=Pe,e.$7f=ke,e.$8f=Ue,e.$9f=He;function C(se){return!se||typeof se!="string"?!0:se.trim().length===0}const A=/{(\d+)}/g;function L(se,...fe){return fe.length===0?se:se.replace(A,function($e,ye){const Oe=parseInt(ye,10);return isNaN(Oe)||Oe<0||Oe>=fe.length?$e:fe[Oe]})}const y=/{([^}]+)}/g;function S(se,fe){return Object.keys(fe).length===0?se:se.replace(y,($e,ye)=>fe[ye]??$e)}function $(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function h(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function p(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function g(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function d(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Oe=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Oe)}`}function f(se,fe=" "){const $e=w(se,fe);return E($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function E(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Oe=ye,Te=-1;for(;Te=se.lastIndexOf(fe,Oe-1),!(Te===-1||Te+$e!==Oe);){if(Te===0)return"";Oe=Te}return se.substring(0,Oe)}function u(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function b(se){return se.replace(/\*/g,"")}function t(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=p(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function s(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function o(se){return se.split(/\r\n|\r|\n/)}function i(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return fe}return-1}function r(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Oe=se.charCodeAt(ye);if(Oe!==a.CharCode.Space&&Oe!==a.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function c(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function m(se,fe,$e){const ye=[];let Oe=0;for(const Te of se.matchAll(fe)){if(ye.push(se.slice(Oe,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Oe=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Oe)),Promise.all(ye).then(Te=>Te.join(""))}function v(se,fe){return se<fe?-1:se>fe?1:0}function P(se,fe,$e=0,ye=se.length,Oe=0,Te=fe.length){for(;$e<ye&&Oe<Te;$e++,Oe++){const Ke=se.charCodeAt($e),Xe=fe.charCodeAt(Oe);if(Ke<Xe)return-1;if(Ke>Xe)return 1}const je=ye-$e,Ze=Te-Oe;return je<Ze?-1:je>Ze?1:0}function R(se,fe){return I(se,fe,0,se.length,0,fe.length)}function I(se,fe,$e=0,ye=se.length,Oe=0,Te=fe.length){for(;$e<ye&&Oe<Te;$e++,Oe++){let Ke=se.charCodeAt($e),Xe=fe.charCodeAt(Oe);if(Ke===Xe)continue;if(Ke>=128||Xe>=128)return P(se.toLowerCase(),fe.toLowerCase(),$e,ye,Oe,Te);U(Ke)&&(Ke-=32),U(Xe)&&(Xe-=32);const We=Ke-Xe;if(We!==0)return We}const je=ye-$e,Ze=Te-Oe;return je<Ze?-1:je>Ze?1:0}function N(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function j(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function F(se,fe){return se.length===fe.length&&I(se,fe)===0}function X(se,fe){const $e=fe.length;return fe.length>se.length?!1:I(se,fe,0,$e)===0}function K(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function Q(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Oe=se.length-1,Te=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Oe-ye)!==fe.charCodeAt(Te-ye))return ye;return $e}function V(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function H(se,fe){return(se-55296<<10)+(fe-56320)+65536}function W(se,fe,$e){const ye=se.charCodeAt($e);if(V(ye)&&$e+1<fe){const Oe=se.charCodeAt($e+1);if(ie(Oe))return H(ye,Oe)}return ye}function ee(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(V(ye))return H(ye,$e)}return $e}class re{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=W(this.c,this.d,this.e);return this.e+=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Jf=re;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new re(fe,$e)}nextGraphemeLength(){const fe=De.getInstance(),$e=this.c,ye=$e.offset;let Oe=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Ce(Oe,je)){$e.setOffset(Te);break}Oe=je}return $e.offset-ye}prevGraphemeLength(){const fe=De.getInstance(),$e=this.c,ye=$e.offset;let Oe=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Ce(je,Oe)){$e.setOffset(Te);break}Oe=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Kf=ce;function q(se,fe){return new ce(se,fe).nextGraphemeLength()}function x(se,fe){return new ce(se,fe).prevGraphemeLength()}function J(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+q(se,fe);return[$e-x(se,$e),$e]}function G(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(se){return D||(D=B()),D.test(se)}const z=/^[\t\n\r\x20-\x7E]*$/;function te(se){return z.test(se)}e.$Rf=/[\u2028\u2029]/;function _(se){return e.$Rf.test(se)}function Y(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ae(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ue(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Oe=/\b/g;let Te=0;for(;Oe.test(ye)&&!(ye.length-Oe.lastIndex<fe);)Te=Oe.lastIndex,Oe.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const pe=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(pe,"")}e.$Zf=String.fromCharCode(a.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function oe(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Oe=0,Te=-1;for(;Oe<$e;){const je=ye.indexOf(fe[Oe],Te+1);if(je<0)return!1;Te=je,Oe++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function ke(se){const fe=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-fe)}function Ue(se){return De.getInstance().getGraphemeBreakType(se)}function Ce(se,fe){return se===Ae.Other?fe!==Ae.Extend&&fe!==Ae.SpacingMark:se===Ae.CR&&fe===Ae.LF?!1:se===Ae.Control||se===Ae.CR||se===Ae.LF||fe===Ae.Control||fe===Ae.CR||fe===Ae.LF?!0:!(se===Ae.L&&(fe===Ae.L||fe===Ae.V||fe===Ae.LV||fe===Ae.LVT)||(se===Ae.LV||se===Ae.V)&&(fe===Ae.V||fe===Ae.T)||(se===Ae.LVT||se===Ae.T)&&fe===Ae.T||fe===Ae.Extend||fe===Ae.ZWJ||fe===Ae.SpacingMark||se===Ae.Prepend||se===Ae.ZWJ&&fe===Ae.Extended_Pictographic||se===Ae.Regional_Indicator&&fe===Ae.Regional_Indicator)}var Ae;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Me()}getGraphemeBreakType(fe){if(fe<32)return fe===a.CharCode.LineFeed?Ae.LF:fe===a.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(fe<127)return Ae.Other;const $e=this.d,ye=$e.length/3;let Oe=1;for(;Oe<=ye;)if(fe<$e[3*Oe])Oe=2*Oe;else if(fe>$e[3*Oe+1])Oe=2*Oe+1;else return $e[3*Oe+2];return Ae.Other}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=Fe(se,fe);if($e!==void 0)return $e;const ye=new re(fe,se);return ye.prevCodePoint(),ye.offset}function Fe(se,fe){const $e=new re(fe,se);let ye=$e.prevCodePoint();for(;qe(ye)||ye===Be.emojiVariantSelector||ye===Be.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ae(ye))return;let Oe=$e.offset;return Oe>0&&$e.prevCodePoint()===Be.zwj&&(Oe=$e.offset),Oe}function qe(se){return 127995<=se&&se<=127999}var Be;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$0f="\xA0";class ze{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$7e({getCacheKey:JSON.stringify},fe=>{function $e(We){const xe=new Map;for(let Qe=0;Qe<We.length;Qe+=2)xe.set(We[Qe],We[Qe+1]);return xe}function ye(We,xe){const Qe=new Map(We);for(const[tt,rt]of xe)Qe.set(tt,rt);return Qe}function Oe(We,xe){if(!We)return xe;const Qe=new Map;for(const[tt,rt]of We)xe.has(tt)&&Qe.set(tt,rt);return Qe}const Te=this.c.value;let je=fe.filter(We=>!We.startsWith("_")&&We in Te);je.length===0&&(je=["_default"]);let Ze;for(const We of je){const xe=$e(Te[We]);Ze=Oe(Ze,xe)}const Ke=$e(Te._common),Xe=ye(Ke,Ze);return new ze(Xe)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new T.$V(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=ze;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(fe){return Le.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Le.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Le.e()}}e.$_f=Le}),define(le[55],he([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=a,e.$pj=T,e.$qj=O,e.$rj=A,e.$tj=g;function a(f){return T(f,0)}function T(f,w){switch(typeof f){case"object":return f===null?O(349,w):Array.isArray(f)?L(f,w):y(f,w);case"string":return A(f,w);case"boolean":return C(f,w);case"number":return O(f,w);case"undefined":return O(937,w);default:return O(617,w)}}function O(f,w){return(w<<5)-w+f|0}function C(f,w){return O(f?433:863,w)}function A(f,w){w=O(149417,w);for(let E=0,u=f.length;E<u;E++)w=O(f.charCodeAt(E),w);return w}function L(f,w){return w=O(104579,w),f.reduce((E,u)=>T(u,E),w)}function y(f,w){return w=O(181387,w),Object.keys(f).sort().reduce((E,u)=>(E=A(u,E),T(f[u],E)),w)}class S{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=T(w,this.g),this.g}}e.$sj=S;var $;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function h(f,w,E=32){const u=E-w,b=~((1<<u)-1);return(f<<w|(b&f)>>>u)>>>0}function p(f,w=0,E=f.byteLength,u=0){for(let b=0;b<E;b++)f[w+b]=u}function l(f,w,E="0"){for(;f.length<w;)f=E+f;return f}function g(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),w/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const E=w.length;if(E===0)return;const u=this.p;let b=this.r,t=this.u,s,o;for(t!==0?(s=t,o=-1,t=0):(s=w.charCodeAt(0),o=0);;){let i=s;if(k.$Ff(s))if(o+1<E){const n=w.charCodeAt(o+1);k.$Gf(n)?(o++,i=k.$Hf(s,n)):i=$.UNICODE_REPLACEMENT}else{t=s;break}else k.$Gf(s)&&(i=$.UNICODE_REPLACEMENT);if(b=this.w(u,b,i),o++,o<E)s=w.charCodeAt(o);else break}this.r=b,this.u=t}w(w,E,u){return u<128?w[E++]=u:u<2048?(w[E++]=192|(u&1984)>>>6,w[E++]=128|(u&63)>>>0):u<65536?(w[E++]=224|(u&61440)>>>12,w[E++]=128|(u&4032)>>>6,w[E++]=128|(u&63)>>>0):(w[E++]=240|(u&1835008)>>>18,w[E++]=128|(u&258048)>>>12,w[E++]=128|(u&4032)>>>6,w[E++]=128|(u&63)>>>0),E>=$.BLOCK_SIZE&&(this.y(),E-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,w[0]=w[$.BLOCK_SIZE+0],w[1]=w[$.BLOCK_SIZE+1],w[2]=w[$.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=d.g,E=this.q;for(let c=0;c<64;c+=4)w.setUint32(c,E.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,h(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let u=this.h,b=this.l,t=this.m,s=this.n,o=this.o,i,n,r;for(let c=0;c<80;c++)c<20?(i=b&t|~b&s,n=1518500249):c<40?(i=b^t^s,n=1859775393):c<60?(i=b&t|b&s|t&s,n=2400959708):(i=b^t^s,n=3395469782),r=h(u,5)+i+o+n+w.getUint32(c*4,!1)&4294967295,o=s,s=t,t=h(b,30),b=u,u=r;this.h=this.h+u&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}e.$uj=d}),define(le[92],he([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var a;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(a||(a={})),function(T){const O="error",C="warning",A="warn",L="info",y="ignore";function S(h){return h?k.$Bf(O,h)?T.Error:k.$Bf(C,h)||k.$Bf(A,h)?T.Warning:k.$Bf(L,h)?T.Info:T.Ignore:T.Ignore}T.fromValue=S;function $(h){switch(h){case T.Error:return O;case T.Warning:return C;case T.Info:return L;default:return y}}T.toString=$}(a||(a={})),e.default=a}),define(le[52],he([0,1,19,39,27]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class O{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.$Ci=O;class C{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,T.$vf)(l,this.b,0,l.length,this.c,this.d):(0,T.$xf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=C;class A{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===a.CharCode.Slash||this.f&&d===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===a.CharCode.Slash||this.f&&g===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,T.$vf)(l,this.b,0,l.length,this.d,this.e):(0,T.$xf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=A;var L;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(L||(L={}));class y{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(L.Scheme),this.c.authority&&this.d.push(L.Authority),this.c.path&&(this.b=new A(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(L.Path)),this.g(l)||(this.c.query&&this.d.push(L.Query),this.c.fragment&&this.d.push(L.Fragment)),this.e=0,this}next(){return this.d[this.e]===L.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===L.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===L.Scheme)return(0,T.$wf)(l,this.c.scheme);if(this.d[this.e]===L.Authority)return(0,T.$wf)(l,this.c.authority);if(this.d[this.e]===L.Path)return this.b.cmp(l);if(this.d[this.e]===L.Query)return(0,T.$uf)(l,this.c.query);if(this.d[this.e]===L.Fragment)return(0,T.$uf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===L.Scheme)return this.c.scheme;if(this.d[this.e]===L.Authority)return this.c.authority;if(this.d[this.e]===L.Path)return this.b.value();if(this.d[this.e]===L.Query)return this.c.query;if(this.d[this.e]===L.Fragment)return this.c.fragment;throw new Error}}e.$Fi=y;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class h{static forUris(l=()=>!1,g=()=>!1){return new h(new y(l,g))}static forPaths(l=!1){return new h(new A(void 0,!l))}static forStrings(){return new h(new O)}static forConfigKeys(){return new h(new C)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const d=g.slice(0);(0,k.$Wb)(d);for(const f of d)this.set(f,l)}else{const d=l.slice(0);(0,k.$Wb)(d);for(const f of d)this.set(f[0],f[1])}}set(l,g){const d=this.b.reset(l);let f;this.c||(this.c=new S,this.c.segment=d.value());const w=[];for(f=this.c;;){const u=d.cmp(f.segment);if(u>0)f.left||(f.left=new S,f.left.segment=d.value()),w.push([$.Left,f]),f=f.left;else if(u<0)f.right||(f.right=new S,f.right.segment=d.value()),w.push([$.Right,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new S,f.mid.segment=d.value()),w.push([$.Mid,f]),f=f.mid;else break}const E=f.value;f.value=g,f.key=l;for(let u=w.length-1;u>=0;u--){const b=w[u][1];b.updateHeight();const t=b.balanceFactor();if(t<-1||t>1){const s=w[u][0],o=w[u+1][0];if(s===$.Right&&o===$.Right)w[u][1]=b.rotateLeft();else if(s===$.Left&&o===$.Left)w[u][1]=b.rotateRight();else if(s===$.Right&&o===$.Left)b.right=w[u+1][1]=w[u+1][1].rotateRight(),w[u][1]=b.rotateLeft();else if(s===$.Left&&o===$.Right)b.left=w[u+1][1]=w[u+1][1].rotateLeft(),w[u][1]=b.rotateRight();else throw new Error;if(u>0)switch(w[u-1][0]){case $.Left:w[u-1][1].left=w[u][1];break;case $.Right:w[u-1][1].right=w[u][1];break;case $.Mid:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}return E}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let d=this.c;for(;d;){const f=g.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const d=this.b.reset(l),f=[];let w=this.c;for(;w;){const E=d.cmp(w.segment);if(E>0)f.push([$.Left,w]),w=w.left;else if(E<0)f.push([$.Right,w]),w=w.right;else if(d.hasNext())d.next(),f.push([$.Mid,w]),w=w.mid;else break}if(w){if(g?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const E=this.f(w.right);if(E.key){const{key:u,value:b,segment:t}=E;this.e(E.key,!1),w.key=u,w.value=b,w.segment=t}}else{const E=w.left??w.right;if(f.length>0){const[u,b]=f[f.length-1];switch(u){case $.Left:b.left=E;break;case $.Mid:b.mid=E;break;case $.Right:b.right=E;break}}else this.c=E}for(let E=f.length-1;E>=0;E--){const u=f[E][1];u.updateHeight();const b=u.balanceFactor();if(b>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),f[E][1]=u.rotateLeft()):b<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),f[E][1]=u.rotateRight()),E>0)switch(f[E-1][0]){case $.Left:f[E-1][1].left=f[E][1];break;case $.Right:f[E-1][1].right=f[E][1];break;case $.Mid:f[E-1][1].mid=f[E][1];break}else this.c=f[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let d=this.c,f;for(;d;){const w=g.cmp(d.segment);if(w>0)d=d.left;else if(w<0)d=d.right;else if(g.hasNext())g.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(l){return this.g(l,!1)}g(l,g){const d=this.b.reset(l);let f=this.c;for(;f;){const w=d.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this.h(f.mid):g?f.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,d]of this)l(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Gi=h}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=a;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(T){return k.test(T)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let L=0;L<A.length;L++)A[L]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){T(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let L=0,y="";return y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y+="-",y+=C[O[L++]],y+=C[O[L++]],y+="-",y+=C[O[L++]],y+=C[O[L++]],y+="-",y+=C[O[L++]],y+=C[O[L++]],y+="-",y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y+=C[O[L++]],y}}()}),define(le[137],he([0,1,38]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=O;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(C){const A=C.replace(/\-/g,":").toLowerCase();return!a.has(A)}function O(){const C=(0,k.networkInterfaces)();for(const A in C){const L=C[A];if(L){for(const{mac:y}of L)if(T(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],he([0,1,276,15]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mW=void 0;class T extends k.Transform{constructor(C){if(super(),typeof C=="number")this.b=C,this.c=1;else{const A=Buffer.isBuffer(C)?C:Buffer.from(C);this.b=A.length===1?A[0]:A,this.c=A.length}}_transform(C,A,L){this.a?this.a=Buffer.concat([this.a,C]):this.a=C;let y=0;for(;y<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,y):(0,a.$Ke)(this.a,this.b,y);if(S===-1)break;this.push(this.a.slice(y,S+this.c)),y=S+this.c}this.a=y===this.a.length?void 0:this.a.slice(y),L()}_flush(C){this.a&&this.push(this.a),C()}}e.$mW=T}),define(le[139],he([0,1,66]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=a,e.$1g=O;function a(A,L,y,S=1){let $=!1;return new Promise(h=>{const p=setTimeout(()=>{if(!$)return $=!0,h(0)},y);T(A,L,S,l=>{if(!$)return $=!0,clearTimeout(p),h(l)})})}function T(A,L,y,S){if(L===0)return S(0);const $=new k.Socket;$.once("connect",()=>(C($),T(A+y,L-1,y,S))),$.once("data",()=>{}),$.once("error",h=>(C($),h.code!=="ECONNREFUSED"?T(A+y,L-1,y,S):S(A))),$.connect(A,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(A,L,y,S="127.0.0.1"){let $=!1,h,p=1;const l=k.createServer({pauseOnConnect:!0});function g(d,f){$||($=!0,l.removeAllListeners(),l.close(),h&&clearTimeout(h),f(d))}return new Promise(d=>{h=setTimeout(()=>{g(0,d)},y),l.on("listening",()=>{g(A,d)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&p<L?(A++,p++,l.listen(A,S)):g(0,d)}),l.on("close",()=>{g(0,d)}),l.listen(A,S)})}function C(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(L){console.error(L)}}}),define(le[140],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EW=k;function k(a){return!!a.parentPort}}),define(le[141],he([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[67],he([0,1,141]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=y,e.$8m=S,e.$9m=$;const a=60,T=a*60,O=T*24,C=O*7,A=O*30,L=O*365;function y(h,p,l,g){typeof h!="number"&&(h=h.getTime());const d=Math.round((new Date().getTime()-h)/1e3);if(d<-30)return(0,k.localize)(0,null,y(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,k.localize)(1,null);let f;return d<a?(f=d,p?f===1?l?(0,k.localize)(2,null,f):(0,k.localize)(3,null,f):l?(0,k.localize)(4,null,f):(0,k.localize)(5,null,f):f===1?l?(0,k.localize)(6,null,f):(0,k.localize)(7,null,f):l?(0,k.localize)(8,null,f):(0,k.localize)(9,null,f)):d<T?(f=Math.floor(d/a),p?f===1?l?(0,k.localize)(10,null,f):(0,k.localize)(11,null,f):l?(0,k.localize)(12,null,f):(0,k.localize)(13,null,f):f===1?l?(0,k.localize)(14,null,f):(0,k.localize)(15,null,f):l?(0,k.localize)(16,null,f):(0,k.localize)(17,null,f)):d<O?(f=Math.floor(d/T),p?f===1?l?(0,k.localize)(18,null,f):(0,k.localize)(19,null,f):l?(0,k.localize)(20,null,f):(0,k.localize)(21,null,f):f===1?l?(0,k.localize)(22,null,f):(0,k.localize)(23,null,f):l?(0,k.localize)(24,null,f):(0,k.localize)(25,null,f)):d<C?(f=Math.floor(d/O),p?f===1?(0,k.localize)(26,null,f):(0,k.localize)(27,null,f):f===1?(0,k.localize)(28,null,f):(0,k.localize)(29,null,f)):d<A?(f=Math.floor(d/C),p?f===1?l?(0,k.localize)(30,null,f):(0,k.localize)(31,null,f):l?(0,k.localize)(32,null,f):(0,k.localize)(33,null,f):f===1?l?(0,k.localize)(34,null,f):(0,k.localize)(35,null,f):l?(0,k.localize)(36,null,f):(0,k.localize)(37,null,f)):d<L?(f=Math.floor(d/A),p?f===1?l?(0,k.localize)(38,null,f):(0,k.localize)(39,null,f):l?(0,k.localize)(40,null,f):(0,k.localize)(41,null,f):f===1?l?(0,k.localize)(42,null,f):(0,k.localize)(43,null,f):l?(0,k.localize)(44,null,f):(0,k.localize)(45,null,f)):(f=Math.floor(d/L),p?f===1?l?(0,k.localize)(46,null,f):(0,k.localize)(47,null,f):l?(0,k.localize)(48,null,f):(0,k.localize)(49,null,f):f===1?l?(0,k.localize)(50,null,f):(0,k.localize)(51,null,f):l?(0,k.localize)(52,null,f):(0,k.localize)(53,null,f))}function S(h,p){const l=Math.abs(h/1e3);return l<1?p?(0,k.localize)(54,null,h):(0,k.localize)(55,null,h):l<a?p?(0,k.localize)(56,null,Math.round(h)/1e3):(0,k.localize)(57,null,Math.round(h)/1e3):l<T?p?(0,k.localize)(58,null,Math.round(h/(1e3*a))):(0,k.localize)(59,null,Math.round(h/(1e3*a))):l<O?p?(0,k.localize)(60,null,Math.round(h/(1e3*T))):(0,k.localize)(61,null,Math.round(h/(1e3*T))):(0,k.localize)(62,null,Math.round(h/(1e3*O)))}function $(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],he([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[40],he([0,1,19,13,142]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=L,e.$mj=y,e.$nj=S;function O($,h){return h&&($.stack||$.stacktrace)?T.localize(0,null,A($),C($.stack)||C($.stacktrace)):A($)}function C($){return Array.isArray($)?$.join(`
`):$}function A($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?T.localize(1,null,$.message):$.message||T.localize(2,null)}function L($=null,h=!1){if(!$)return T.localize(3,null);if(Array.isArray($)){const p=k.$Hb($),l=L(p[0],h);return p.length>1?T.localize(4,null,l,p.length):l}if(a.$ag($))return $;if($.detail){const p=$.detail;if(p.error)return O(p.error,h);if(p.exception)return O(p.exception,h)}return $.stack?O($,h):$.message?$.message:T.localize(5,null)}function y($){const h=$;return h instanceof Error&&Array.isArray(h.actions)}function S($,h){let p;return typeof $=="string"?p=new Error($):p=$,p.actions=h,p}}),define(le[143],he([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],he([0,1,143,34]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=T;function T(O){switch(O){case a.ParseErrorCode.InvalidSymbol:return(0,k.localize)(0,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,k.localize)(1,null);case a.ParseErrorCode.PropertyNameExpected:return(0,k.localize)(2,null);case a.ParseErrorCode.ValueExpected:return(0,k.localize)(3,null);case a.ParseErrorCode.ColonExpected:return(0,k.localize)(4,null);case a.ParseErrorCode.CommaExpected:return(0,k.localize)(5,null);case a.ParseErrorCode.CloseBraceExpected:return(0,k.localize)(6,null);case a.ParseErrorCode.CloseBracketExpected:return(0,k.localize)(7,null);case a.ParseErrorCode.EndOfFileExpected:return(0,k.localize)(8,null);default:return""}}}),define(le[145],he([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,145]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=m,e.$J=v,e.$g="en";let a=!1,T=!1,O=!1,C=!1,A=!1,L=!1,y=!1,S=!1,$=!1,h=!1,p,l=e.$g,g=e.$g,d,f;const w=globalThis;let E;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?E=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const u=typeof E?.versions?.electron=="string",b=u&&E?.type==="renderer";if(typeof E=="object"){a=E.platform==="win32",T=E.platform==="darwin",O=E.platform==="linux",C=O&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,y=u,$=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$g,l=e.$g;const P=E.env.VSCODE_NLS_CONFIG;if(P)try{const R=JSON.parse(P),I=R.availableLanguages["*"];p=R.locale,g=R.osLocale,l=I||e.$g,d=R._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!b?(f=navigator.userAgent,a=f.indexOf("Windows")>=0,T=f.indexOf("Macintosh")>=0,S=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,h=f?.indexOf("Mobi")>=0,L=!0,p=k.getConfiguredDefaultLocale(k.localize(0,null))||e.$g,l=p,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(P){switch(P){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let o=t.Web;T?o=t.Mac:a?o=t.Windows:O&&(o=t.Linux),e.$i=a,e.$j=T,e.$k=O,e.$l=C,e.$m=A,e.$n=y,e.$o=L,e.$p=L&&typeof w.importScripts=="function",e.$q=e.$p?w.origin:void 0,e.$r=S,e.$s=h,e.$t=$,e.$u=o,e.$v=f,e.$w=l;var i;(function(P){function R(){return e.$w}P.value=R;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}P.isDefaultVariant=I;function N(){return e.$w==="en"}P.isDefault=N})(i||(e.Language=i={})),e.$x=p,e.$y=g,e.$z=d,e.$A=typeof w.postMessage=="function"&&!w.importScripts,e.$B=(()=>{if(e.$A){const P=[];w.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let N=0,U=P.length;N<U;N++){const j=P[N];if(j.id===I.data.vscodeScheduleAsyncWork){P.splice(N,1),j.callback();return}}});let R=0;return I=>{const N=++R;P.push({id:N,callback:I}),w.postMessage({vscodeScheduleAsyncWork:N},"*")}}return P=>setTimeout(P)})();var n;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=T||S?n.Macintosh:a?n.Windows:n.Linux;let r=!0,c=!1;function m(){if(!c){c=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,r=new Uint16Array(P.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(P){return parseFloat(P)>=20}}),define(le[36],he([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let a;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const O=T.process;a={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$dc=a.platform,e.$ec=a.arch}),define(le[146],he([0,1,36]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=C;var a;(function(A){A.UNKNOWN="UNKNOWN",A.CINNAMON="CINNAMON",A.DEEPIN="DEEPIN",A.GNOME="GNOME",A.KDE3="KDE3",A.KDE4="KDE4",A.KDE5="KDE5",A.KDE6="KDE6",A.PANTHEON="PANTHEON",A.UNITY="UNITY",A.XFCE="XFCE",A.UKUI="UKUI",A.LXQT="LXQT"})(a||(a={}));const T="XDG_CURRENT_DESKTOP",O="KDE_SESSION_VERSION";function C(){const A=k.env[T];if(A){const y=A.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of y)switch(S){case"Unity":{const $=k.env.DESKTOP_SESSION;return $&&$.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const $=k.env[O];return $==="5"?a.KDE5:$==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const L=k.env.DESKTOP_SESSION;if(L)switch(L){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return O in k.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in k.env?a.GNOME:"KDE_FULL_SESSION"in k.env?O in k.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(le[14],he([0,1,36]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const a=65,T=97,O=90,C=122,A=46,L=47,y=92,S=58,$=63;class h extends Error{constructor(s,o,i){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const r=s.indexOf(".")!==-1?"property":"argument";let c=`The "${s}" ${r} ${n} of type ${o}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,s){if(t===null||typeof t!="object")throw new h(s,"Object",t)}function l(t,s){if(typeof t!="string")throw new h(s,"string",t)}const g=k.$dc==="win32";function d(t){return t===L||t===y}function f(t){return t===L}function w(t){return t>=a&&t<=O||t>=T&&t<=C}function E(t,s,o,i){let n="",r=0,c=-1,m=0,v=0;for(let P=0;P<=t.length;++P){if(P<t.length)v=t.charCodeAt(P);else{if(i(v))break;v=L}if(i(v)){if(!(c===P-1||m===1))if(m===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const R=n.lastIndexOf(o);R===-1?(n="",r=0):(n=n.slice(0,R),r=n.length-1-n.lastIndexOf(o)),c=P,m=0;continue}else if(n.length!==0){n="",r=0,c=P,m=0;continue}}s&&(n+=n.length>0?`${o}..`:"..",r=2)}else n.length>0?n+=`${o}${t.slice(c+1,P)}`:n=t.slice(c+1,P),r=P-c-1;c=P,m=0}else v===A&&m!==-1?++m:m=-1}return n}function u(t,s){p(s,"pathObject");const o=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${i}`:`${o}${t}${i}`:i}e.$fc={resolve(...t){let s="",o="",i=!1;for(let n=t.length-1;n>=-1;n--){let r;if(n>=0){if(r=t[n],l(r,"path"),r.length===0)continue}else s.length===0?r=k.cwd():(r=k.env[`=${s}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===y)&&(r=`${s}\\`));const c=r.length;let m=0,v="",P=!1;const R=r.charCodeAt(0);if(c===1)d(R)&&(m=1,P=!0);else if(d(R))if(P=!0,d(r.charCodeAt(1))){let I=2,N=I;for(;I<c&&!d(r.charCodeAt(I));)I++;if(I<c&&I!==N){const U=r.slice(N,I);for(N=I;I<c&&d(r.charCodeAt(I));)I++;if(I<c&&I!==N){for(N=I;I<c&&!d(r.charCodeAt(I));)I++;(I===c||I!==N)&&(v=`\\\\${U}\\${r.slice(N,I)}`,m=I)}}}else m=1;else w(R)&&r.charCodeAt(1)===S&&(v=r.slice(0,2),m=2,c>2&&d(r.charCodeAt(2))&&(P=!0,m=3));if(v.length>0)if(s.length>0){if(v.toLowerCase()!==s.toLowerCase())continue}else s=v;if(i){if(s.length>0)break}else if(o=`${r.slice(m)}\\${o}`,i=P,P&&s.length>0)break}return o=E(o,!i,"\\",d),i?`${s}\\${o}`:`${s}${o}`||"."},normalize(t){l(t,"path");const s=t.length;if(s===0)return".";let o=0,i,n=!1;const r=t.charCodeAt(0);if(s===1)return f(r)?"\\":t;if(d(r))if(n=!0,d(t.charCodeAt(1))){let m=2,v=m;for(;m<s&&!d(t.charCodeAt(m));)m++;if(m<s&&m!==v){const P=t.slice(v,m);for(v=m;m<s&&d(t.charCodeAt(m));)m++;if(m<s&&m!==v){for(v=m;m<s&&!d(t.charCodeAt(m));)m++;if(m===s)return`\\\\${P}\\${t.slice(v)}\\`;m!==v&&(i=`\\\\${P}\\${t.slice(v,m)}`,o=m)}}}else o=1;else w(r)&&t.charCodeAt(1)===S&&(i=t.slice(0,2),o=2,s>2&&d(t.charCodeAt(2))&&(n=!0,o=3));let c=o<s?E(t.slice(o),!n,"\\",d):"";return c.length===0&&!n&&(c="."),c.length>0&&d(t.charCodeAt(s-1))&&(c+="\\"),i===void 0?n?`\\${c}`:c:n?`${i}\\${c}`:`${i}${c}`},isAbsolute(t){l(t,"path");const s=t.length;if(s===0)return!1;const o=t.charCodeAt(0);return d(o)||s>2&&w(o)&&t.charCodeAt(1)===S&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,o;for(let r=0;r<t.length;++r){const c=t[r];l(c,"path"),c.length>0&&(s===void 0?s=o=c:s+=`\\${c}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++n;const r=o.length;r>1&&d(o.charCodeAt(1))&&(++n,r>2&&(d(o.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&d(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$fc.normalize(s)},relative(t,s){if(l(t,"from"),l(s,"to"),t===s)return"";const o=e.$fc.resolve(t),i=e.$fc.resolve(s);if(o===i||(t=o.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===y;)n++;let r=t.length;for(;r-1>n&&t.charCodeAt(r-1)===y;)r--;const c=r-n;let m=0;for(;m<s.length&&s.charCodeAt(m)===y;)m++;let v=s.length;for(;v-1>m&&s.charCodeAt(v-1)===y;)v--;const P=v-m,R=c<P?c:P;let I=-1,N=0;for(;N<R;N++){const j=t.charCodeAt(n+N);if(j!==s.charCodeAt(m+N))break;j===y&&(I=N)}if(N!==R){if(I===-1)return i}else{if(P>R){if(s.charCodeAt(m+N)===y)return i.slice(m+N+1);if(N===2)return i.slice(m+N)}c>R&&(t.charCodeAt(n+N)===y?I=N:N===2&&(I=3)),I===-1&&(I=0)}let U="";for(N=n+I+1;N<=r;++N)(N===r||t.charCodeAt(N)===y)&&(U+=U.length===0?"..":"\\..");return m+=I,U.length>0?`${U}${i.slice(m,v)}`:(i.charCodeAt(m)===y&&++m,i.slice(m,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$fc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===y){if(s.charCodeAt(1)===y){const o=s.charCodeAt(2);if(o!==$&&o!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===S&&s.charCodeAt(2)===y)return`\\\\?\\${s}`;return t},dirname(t){l(t,"path");const s=t.length;if(s===0)return".";let o=-1,i=0;const n=t.charCodeAt(0);if(s===1)return d(n)?t:".";if(d(n)){if(o=i=1,d(t.charCodeAt(1))){let m=2,v=m;for(;m<s&&!d(t.charCodeAt(m));)m++;if(m<s&&m!==v){for(v=m;m<s&&d(t.charCodeAt(m));)m++;if(m<s&&m!==v){for(v=m;m<s&&!d(t.charCodeAt(m));)m++;if(m===s)return t;m!==v&&(o=i=m+1)}}}}else w(n)&&t.charCodeAt(1)===S&&(o=s>2&&d(t.charCodeAt(2))?3:2,i=o);let r=-1,c=!0;for(let m=s-1;m>=i;--m)if(d(t.charCodeAt(m))){if(!c){r=m;break}}else c=!1;if(r===-1){if(o===-1)return".";r=o}return t.slice(0,r)},basename(t,s){s!==void 0&&l(s,"ext"),l(t,"path");let o=0,i=-1,n=!0,r;if(t.length>=2&&w(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(o=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,m=-1;for(r=t.length-1;r>=o;--r){const v=t.charCodeAt(r);if(d(v)){if(!n){o=r+1;break}}else m===-1&&(n=!1,m=r+1),c>=0&&(v===s.charCodeAt(c)?--c===-1&&(i=r):(c=-1,i=m))}return o===i?i=m:i===-1&&(i=t.length),t.slice(o,i)}for(r=t.length-1;r>=o;--r)if(d(t.charCodeAt(r))){if(!n){o=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":t.slice(o,i)},extname(t){l(t,"path");let s=0,o=-1,i=0,n=-1,r=!0,c=0;t.length>=2&&t.charCodeAt(1)===S&&w(t.charCodeAt(0))&&(s=i=2);for(let m=t.length-1;m>=s;--m){const v=t.charCodeAt(m);if(d(v)){if(!r){i=m+1;break}continue}n===-1&&(r=!1,n=m+1),v===A?o===-1?o=m:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||n===-1||c===0||c===1&&o===n-1&&o===i+1?"":t.slice(o,n)},format:u.bind(null,"\\"),parse(t){l(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.length;let i=0,n=t.charCodeAt(0);if(o===1)return d(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(d(n)){if(i=1,d(t.charCodeAt(1))){let I=2,N=I;for(;I<o&&!d(t.charCodeAt(I));)I++;if(I<o&&I!==N){for(N=I;I<o&&d(t.charCodeAt(I));)I++;if(I<o&&I!==N){for(N=I;I<o&&!d(t.charCodeAt(I));)I++;I===o?i=I:I!==N&&(i=I+1)}}}}else if(w(n)&&t.charCodeAt(1)===S){if(o<=2)return s.root=s.dir=t,s;if(i=2,d(t.charCodeAt(2))){if(o===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let r=-1,c=i,m=-1,v=!0,P=t.length-1,R=0;for(;P>=i;--P){if(n=t.charCodeAt(P),d(n)){if(!v){c=P+1;break}continue}m===-1&&(v=!1,m=P+1),n===A?r===-1?r=P:R!==1&&(R=1):r!==-1&&(R=-1)}return m!==-1&&(r===-1||R===0||R===1&&r===m-1&&r===c+1?s.base=s.name=t.slice(c,m):(s.name=t.slice(c,r),s.base=t.slice(c,m),s.ext=t.slice(r,m))),c>0&&c!==i?s.dir=t.slice(0,c-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(g){const t=/\\/g;return()=>{const s=k.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>k.cwd()})();e.$gc={resolve(...t){let s="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const n=i>=0?t[i]:b();l(n,"path"),n.length!==0&&(s=`${n}/${s}`,o=n.charCodeAt(0)===L)}return s=E(s,!o,"/",f),o?`/${s}`:s.length>0?s:"."},normalize(t){if(l(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===L,o=t.charCodeAt(t.length-1)===L;return t=E(t,!s,"/",f),t.length===0?s?"/":o?"./":".":(o&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return l(t,"path"),t.length>0&&t.charCodeAt(0)===L},join(...t){if(t.length===0)return".";let s;for(let o=0;o<t.length;++o){const i=t[o];l(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$gc.normalize(s)},relative(t,s){if(l(t,"from"),l(s,"to"),t===s||(t=e.$gc.resolve(t),s=e.$gc.resolve(s),t===s))return"";const o=1,i=t.length,n=i-o,r=1,c=s.length-r,m=n<c?n:c;let v=-1,P=0;for(;P<m;P++){const I=t.charCodeAt(o+P);if(I!==s.charCodeAt(r+P))break;I===L&&(v=P)}if(P===m)if(c>m){if(s.charCodeAt(r+P)===L)return s.slice(r+P+1);if(P===0)return s.slice(r+P)}else n>m&&(t.charCodeAt(o+P)===L?v=P:P===0&&(v=0));let R="";for(P=o+v+1;P<=i;++P)(P===i||t.charCodeAt(P)===L)&&(R+=R.length===0?"..":"/..");return`${R}${s.slice(r+v)}`},toNamespacedPath(t){return t},dirname(t){if(l(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===L;let o=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===L){if(!i){o=n;break}}else i=!1;return o===-1?s?"/":".":s&&o===1?"//":t.slice(0,o)},basename(t,s){s!==void 0&&l(s,"ext"),l(t,"path");let o=0,i=-1,n=!0,r;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,m=-1;for(r=t.length-1;r>=0;--r){const v=t.charCodeAt(r);if(v===L){if(!n){o=r+1;break}}else m===-1&&(n=!1,m=r+1),c>=0&&(v===s.charCodeAt(c)?--c===-1&&(i=r):(c=-1,i=m))}return o===i?i=m:i===-1&&(i=t.length),t.slice(o,i)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===L){if(!n){o=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":t.slice(o,i)},extname(t){l(t,"path");let s=-1,o=0,i=-1,n=!0,r=0;for(let c=t.length-1;c>=0;--c){const m=t.charCodeAt(c);if(m===L){if(!n){o=c+1;break}continue}i===-1&&(n=!1,i=c+1),m===A?s===-1?s=c:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||i===-1||r===0||r===1&&s===i-1&&s===o+1?"":t.slice(s,i)},format:u.bind(null,"/"),parse(t){l(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.charCodeAt(0)===L;let i;o?(s.root="/",i=1):i=0;let n=-1,r=0,c=-1,m=!0,v=t.length-1,P=0;for(;v>=i;--v){const R=t.charCodeAt(v);if(R===L){if(!m){r=v+1;break}continue}c===-1&&(m=!1,c=v+1),R===A?n===-1?n=v:P!==1&&(P=1):n!==-1&&(P=-1)}if(c!==-1){const R=r===0&&o?1:r;n===-1||P===0||P===1&&n===c-1&&n===r+1?s.base=s.name=t.slice(R,c):(s.name=t.slice(R,n),s.base=t.slice(R,c),s.ext=t.slice(n,c))}return r>0?s.dir=t.slice(0,r-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(le[42],he([0,1,39,14,5,27,13]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=A,e.$tg=L,e.$ug=y,e.$vg=S,e.$wg=$,e.$xg=g,e.$yg=d,e.$zg=f,e.$Ag=w,e.$Bg=E,e.$Cg=u,e.$Dg=b,e.$Eg=t,e.$Fg=s,e.$Gg=o,e.$Hg=i,e.$Ig=c;function A(m){return m===k.CharCode.Slash||m===k.CharCode.Backslash}function L(m){return m.replace(/[\\/]/g,a.$gc.sep)}function y(m){return m.indexOf("/")===-1&&(m=L(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}function S(m,v=a.$gc.sep){if(!m)return"";const P=m.length,R=m.charCodeAt(0);if(A(R)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let N=3;const U=N;for(;N<P&&!A(m.charCodeAt(N));N++);if(U!==N&&!A(m.charCodeAt(N+1))){for(N+=1;N<P;N++)if(A(m.charCodeAt(N)))return m.slice(0,N+1).replace(/[\\/]/g,v)}}return v}else if(w(R)&&m.charCodeAt(1)===k.CharCode.Colon)return A(m.charCodeAt(2))?m.slice(0,2)+v:m.slice(0,2);let I=m.indexOf("://");if(I!==-1){for(I+=3;I<P;I++)if(A(m.charCodeAt(I)))return m.slice(0,I+1)}return""}function $(m){if(!T.$i||!m||m.length<5)return!1;let v=m.charCodeAt(0);if(v!==k.CharCode.Backslash||(v=m.charCodeAt(1),v!==k.CharCode.Backslash))return!1;let P=2;const R=P;for(;P<m.length&&(v=m.charCodeAt(P),v!==k.CharCode.Backslash);P++);return!(R===P||(v=m.charCodeAt(P+1),isNaN(v)||v===k.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,p=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(m,v=T.$i){const P=v?h:p;return!(!m||m.length===0||/^\s+$/.test(m)||(P.lastIndex=0,P.test(m))||v&&l.test(m)||m==="."||m===".."||v&&m[m.length-1]==="."||v&&m.length!==m.trim().length||m.length>255)}function d(m,v,P){const R=m===v;return!P||R?R:!m||!v?!1:(0,O.$Bf)(m,v)}function f(m,v,P,R=a.sep){if(m===v)return!0;if(!m||!v||v.length>m.length)return!1;if(P){if(!(0,O.$Cf)(m,v))return!1;if(v.length===m.length)return!0;let N=v.length;return v.charAt(v.length-1)===R&&N--,m.charAt(N)===R}return v.charAt(v.length-1)!==R&&(v+=R),m.indexOf(v)===0}function w(m){return m>=k.CharCode.A&&m<=k.CharCode.Z||m>=k.CharCode.a&&m<=k.CharCode.z}function E(m,v){return T.$i&&m.endsWith(":")&&(m+=a.sep),(0,a.$ic)(m)||(m=(0,a.$jc)(v,m)),m=(0,a.$hc)(m),u(m)}function u(m){return T.$i?(m=(0,O.$jf)(m,a.sep),m.endsWith(":")&&(m+=a.sep)):(m=(0,O.$jf)(m,a.sep),m||(m=a.sep)),m}function b(m){const v=(0,a.$hc)(m);return T.$i?m.length>3?!1:t(v)&&(m.length===2||v.charCodeAt(2)===k.CharCode.Backslash):v===a.$gc.sep}function t(m,v=T.$i){return v?w(m.charCodeAt(0))&&m.charCodeAt(1)===k.CharCode.Colon:!1}function s(m,v=T.$i){return t(m,v)?m[0]:void 0}function o(m,v,P){return v.length>m.length?-1:m===v?0:(P&&(m=m.toLowerCase(),v=v.toLowerCase()),m.indexOf(v))}function i(m){const v=m.split(":");let P,R,I;for(const N of v){const U=Number(N);(0,C.$eg)(U)?R===void 0?R=U:I===void 0&&(I=U):P=P?[P,N].join(":"):N}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:R!==void 0?R:void 0,column:I!==void 0?I:R!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(m,v,P=8){let R="";for(let N=0;N<P;N++){let U;N===0&&T.$i&&!v&&(P===3||P===4)?U=r:U=n,R+=U.charAt(Math.floor(Math.random()*U.length))}let I;return v?I=`${v}-${R}`:I=R,m?(0,a.$jc)(m,I):I}}),define(le[147],he([0,1,14]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Zs=O,e.$1s=C,e.$2s=A,e.$3s=y,e.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(S){const $=(0,k.$oc)(S),h=a[$.toLowerCase()];return h!==void 0?h:C(S)}function C(S){const $=(0,k.$oc)(S);return T[$.toLowerCase()]}function A(S){for(const $ in T)if(T[$]===S)return $}const L=/^(.+)\/(.+?)(;.+)?$/;function y(S,$){const h=L.exec(S);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:$?void 0:S}}),define(le[93],he([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$rm=O,e.$sm=C;var a;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(a||(e.Source=a={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function O(A,...L){const y=L.reduce((h,p)=>(h[p]=!0,h),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(h=>!y[h]).forEach(h=>{for(let p=0;p<S.length;p++)if(h.search(S[p])!==-1){delete A[h];break}})}function C(A){A&&(delete A.DEBUG,k.$j&&delete A.DYLD_LIBRARY_PATH,k.$k&&delete A.LD_PRELOAD)}}),define(le[9],he([0,1,39,64,14,5]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=d,e.$wc=t;const C=/^\w[\w\d+.-]*$/,A=/^\//,L=/^\/\//;function y(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,c){return!r&&!c?"file":r}function $(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==p&&(c=p+c):c=p;break}return c}const h="",p="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(c){return c instanceof g?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,m,v,P,R,I=!1){typeof c=="object"?(this.scheme=c.scheme||h,this.authority=c.authority||h,this.path=c.path||h,this.query=c.query||h,this.fragment=c.fragment||h):(this.scheme=S(c,I),this.authority=m||h,this.path=$(this.scheme,v||h),this.query=P||h,this.fragment=R||h,y(this,I))}get fsPath(){return t(this,!1)}with(c){if(!c)return this;let{scheme:m,authority:v,path:P,query:R,fragment:I}=c;return m===void 0?m=this.scheme:m===null&&(m=h),v===void 0?v=this.authority:v===null&&(v=h),P===void 0?P=this.path:P===null&&(P=h),R===void 0?R=this.query:R===null&&(R=h),I===void 0?I=this.fragment:I===null&&(I=h),m===this.scheme&&v===this.authority&&P===this.path&&R===this.query&&I===this.fragment?this:new w(m,v,P,R,I)}static parse(c,m=!1){const v=l.exec(c);return v?new w(v[2]||h,n(v[4]||h),n(v[5]||h),n(v[7]||h),n(v[9]||h),m):new w(h,h,h,h,h)}static file(c){let m=h;if(O.$i&&(c=c.replace(/\\/g,p)),c[0]===p&&c[1]===p){const v=c.indexOf(p,2);v===-1?(m=c.substring(2),c=p):(m=c.substring(2,v),c=c.substring(v)||p)}return new w("file",m,c,h,h)}static from(c,m){return new w(c.scheme,c.authority,c.path,c.query,c.fragment,m)}static joinPath(c,...m){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return O.$i&&c.scheme==="file"?v=g.file(T.$fc.join(t(c,!0),...m)).path:v=T.$gc.join(c.path,...m),c.with({path:v})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof g)return c;{const m=new w(c);return m._formatted=c.external??null,m._fsPath=c._sep===f?c.fsPath??null:null,m}}else return c}}e.URI=g;function d(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const f=O.$i?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:a.MarshalledId.Uri};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=f),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const E={[k.CharCode.Colon]:"%3A",[k.CharCode.Slash]:"%2F",[k.CharCode.QuestionMark]:"%3F",[k.CharCode.Hash]:"%23",[k.CharCode.OpenSquareBracket]:"%5B",[k.CharCode.CloseSquareBracket]:"%5D",[k.CharCode.AtSign]:"%40",[k.CharCode.ExclamationMark]:"%21",[k.CharCode.DollarSign]:"%24",[k.CharCode.Ampersand]:"%26",[k.CharCode.SingleQuote]:"%27",[k.CharCode.OpenParen]:"%28",[k.CharCode.CloseParen]:"%29",[k.CharCode.Asterisk]:"%2A",[k.CharCode.Plus]:"%2B",[k.CharCode.Comma]:"%2C",[k.CharCode.Semicolon]:"%3B",[k.CharCode.Equals]:"%3D",[k.CharCode.Space]:"%20"};function u(r,c,m){let v,P=-1;for(let R=0;R<r.length;R++){const I=r.charCodeAt(R);if(I>=k.CharCode.a&&I<=k.CharCode.z||I>=k.CharCode.A&&I<=k.CharCode.Z||I>=k.CharCode.Digit0&&I<=k.CharCode.Digit9||I===k.CharCode.Dash||I===k.CharCode.Period||I===k.CharCode.Underline||I===k.CharCode.Tilde||c&&I===k.CharCode.Slash||m&&I===k.CharCode.OpenSquareBracket||m&&I===k.CharCode.CloseSquareBracket||m&&I===k.CharCode.Colon)P!==-1&&(v+=encodeURIComponent(r.substring(P,R)),P=-1),v!==void 0&&(v+=r.charAt(R));else{v===void 0&&(v=r.substr(0,R));const N=E[I];N!==void 0?(P!==-1&&(v+=encodeURIComponent(r.substring(P,R)),P=-1),v+=N):P===-1&&(P=R)}}return P!==-1&&(v+=encodeURIComponent(r.substring(P))),v!==void 0?v:r}function b(r){let c;for(let m=0;m<r.length;m++){const v=r.charCodeAt(m);v===k.CharCode.Hash||v===k.CharCode.QuestionMark?(c===void 0&&(c=r.substr(0,m)),c+=E[v]):c!==void 0&&(c+=r[m])}return c!==void 0?c:r}function t(r,c){let m;return r.authority&&r.path.length>1&&r.scheme==="file"?m=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===k.CharCode.Slash&&(r.path.charCodeAt(1)>=k.CharCode.A&&r.path.charCodeAt(1)<=k.CharCode.Z||r.path.charCodeAt(1)>=k.CharCode.a&&r.path.charCodeAt(1)<=k.CharCode.z)&&r.path.charCodeAt(2)===k.CharCode.Colon?c?m=r.path.substr(1):m=r.path[1].toLowerCase()+r.path.substr(2):m=r.path,O.$i&&(m=m.replace(/\//g,"\\")),m}function s(r,c){const m=c?b:u;let v="",{scheme:P,authority:R,path:I,query:N,fragment:U}=r;if(P&&(v+=P,v+=":"),(R||P==="file")&&(v+=p,v+=p),R){let j=R.indexOf("@");if(j!==-1){const F=R.substr(0,j);R=R.substr(j+1),j=F.lastIndexOf(":"),j===-1?v+=m(F,!1,!1):(v+=m(F.substr(0,j),!1,!1),v+=":",v+=m(F.substr(j+1),!1,!0)),v+="@"}R=R.toLowerCase(),j=R.lastIndexOf(":"),j===-1?v+=m(R,!1,!0):(v+=m(R.substr(0,j),!1,!0),v+=R.substr(j))}if(I){if(I.length>=3&&I.charCodeAt(0)===k.CharCode.Slash&&I.charCodeAt(2)===k.CharCode.Colon){const j=I.charCodeAt(1);j>=k.CharCode.A&&j<=k.CharCode.Z&&(I=`/${String.fromCharCode(j+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===k.CharCode.Colon){const j=I.charCodeAt(0);j>=k.CharCode.A&&j<=k.CharCode.Z&&(I=`${String.fromCharCode(j+32)}:${I.substr(2)}`)}v+=m(I,!0,!1)}return N&&(v+="?",v+=m(N,!1,!1)),U&&(v+="#",v+=c?U:u(U,!1,!1)),v}function o(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+o(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(i)?r.replace(i,c=>o(c)):r}}),define(le[148],he([0,1,9]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=a,e.$5q=T,e.$6q=O,e.log=A;function a(y){const S=y;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function T(y){const S=[];let $;try{const h=JSON.parse(y.arguments),p=h[h.length-1];p&&p.__$stack&&(h.pop(),$=p.__$stack),S.push(...h)}catch{S.push("Unable to log remote console arguments",y.arguments)}return{args:S,stack:$}}function O(y){if(typeof y!="string")return O(T(y).stack);const S=y;if(S){const $=C(S),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(h&&h.length===4)return{uri:k.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function C(y){if(!y)return y;const S=y.indexOf(`
`);return S===-1?y:y.substring(0,S)}function A(y,S){const{args:$,stack:h}=T(y),p=typeof $[0]=="string"&&$.length===1;let l=C(h);l&&(l=`(${l.trim()})`);let g=[];if(typeof $[0]=="string"?l&&p?g=[`%c[${S}] %c${$[0]} %c${l}`,L("blue"),L(""),L("grey")]:g=[`%c[${S}] %c${$[0]}`,L("blue"),L(""),...$.slice(1)]:g=[`%c[${S}]%`,L("blue"),...$],l&&!p&&g.push(l),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}function L(y){return`color: ${y}`}}),define(le[68],he([0,1,15,9,64]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=O,e.$9h=C,e.$0h=L;function O(y){return JSON.stringify(y,A)}function C(y){let S=JSON.parse(y);return S=L(S),S}function A(y,S){return S instanceof RegExp?{$mid:T.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function L(y,S=0){if(!y||S>200)return y;if(typeof y=="object"){switch(y.$mid){case T.MarshalledId.Uri:return a.URI.revive(y);case T.MarshalledId.Regexp:return new RegExp(y.source,y.flags);case T.MarshalledId.Date:return new Date(y.source)}if(y instanceof k.$Je||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let $=0;$<y.length;++$)y[$]=L(y[$],S+1);else for(const $ in y)Object.hasOwnProperty.call(y,$)&&(y[$]=L(y[$],S+1))}return y}}),define(le[23],he([0,1,8,5,27,9,14]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=L,e.$Kg=y,e.$Og=$;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(A||(e.Schemas=A={}));function L(l,g){return O.URI.isUri(l)?(0,T.$Bf)(l.scheme,g):(0,T.$Cf)(l,g+":")}function y(l,...g){return g.some(d=>L(l,d))}e.$Lg="vscode-tkn",e.$Mg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,d){this.f=$(g,d)}getServerRootPath(){return this.f}get g(){return C.$gc.join(this.f,A.vscodeRemoteResource)}set(g,d,f){this.a[g]=d,this.b[g]=f}setConnectionToken(g,d){this.c[g]=d}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(b){return k.$1(b),g}const d=g.authority;let f=this.a[d];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const w=this.b[d],E=this.c[d];let u=`path=${encodeURIComponent(g.path)}`;return typeof E=="string"&&(u+=`&${e.$Mg}=${encodeURIComponent(E)}`),O.URI.from({scheme:a.$o?this.d:A.vscodeRemoteResource,authority:`${f}:${w}`,path:this.g,query:u})}}e.$Ng=new S;function $(l,g){return C.$gc.join(g??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class h{static{this.a=e.$Tg}asBrowserUri(g){const d=this.b(g,ne);return this.uriToBrowserUri(d)}uriToBrowserUri(g){return g.scheme===A.vscodeRemote?e.$Ng.rewrite(g):g.scheme===A.file&&(a.$m||a.$q===`${A.vscodeFileResource}://${h.a}`)?g.with({scheme:A.vscodeFileResource,authority:g.authority||h.a,query:null,fragment:null}):g}asFileUri(g){const d=this.b(g,ne);return this.uriToFileUri(d)}uriToFileUri(g){return g.scheme===A.vscodeFileResource?g.with({scheme:A.file,authority:g.authority!==h.a?g.authority:null,query:null,fragment:null}):g}b(g,d){return O.URI.isUri(g)?g:O.URI.parse(d.toUrl(g))}}e.$Ug=new h;var p;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const d="vscode-coi";function f(E){let u;typeof E=="string"?u=new URL(E).searchParams:E instanceof URL?u=E.searchParams:O.URI.isUri(E)&&(u=new URL(E.toString(!0)).searchParams);const b=u?.get(d);if(b)return g.get(b)}l.getHeadersFromQuery=f;function w(E,u,b){if(!globalThis.crossOriginIsolated)return;const t=u&&b?"3":b?"2":"1";E instanceof URLSearchParams?E.set(d,t):E[d]=t}l.addSearchParam=w})(p||(e.COI=p={}))}),define(le[149],he([0,1,129,23,5,9]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=S;class C{constructor(h,p,l){this.id=h,this.dependencies=p,this.callback=l}}class A{static{this.INSTANCE=new A}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,p,l)=>{typeof h!="string"&&(l=p,p=h,h=null),(typeof p!="object"||!Array.isArray(p))&&(l=p,p=null),this.c.push(new C(h,p,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const p=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!p)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(h){return new Promise((p,l)=>{const g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript");const d=()=>{g.removeEventListener("load",f),g.removeEventListener("error",w)},f=E=>{d(),p(this.c.pop())},w=E=>{d(),l(E)};g.addEventListener("load",f),g.addEventListener("error",w),this.f&&(h=this.f.createScriptURL(h)),g.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(g)})}i(h){return new Promise((p,l)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),p(this.c.pop())}catch(g){l(g)}})}async j(h){try{const p=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,g=globalThis._VSCODE_NODE_MODULES.module,d=O.URI.parse(h).fsPath,f=p.readFileSync(d).toString(),w=g.wrap(f.replace(/^#!.*/,""));return new l.Script(w).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const L=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function S($,h,p){if(k.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[$]&&($=y[$]);const l=`${$}/${h}`;if(L.has(l))return L.get(l);let g;if(/^\w[\w\d+.-]*:\/\//.test(l))g=l;else{const E=`${p&&!T.$o?a.$Rg:a.$Qg}/${l}`;g=a.$Ug.asBrowserUri(E).toString(!0)}const d=A.INSTANCE.load(g);return L.set(l,d),d}else return await new Promise((l,g)=>{ne([$],l,g)})}}),define(le[21],he([0,1,39,42,23,14,5,27,9]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=y,e.$kh=$,e.$lh=p;function y(l){return(0,L.$wc)(l,!0)}class S{constructor(g){this.a=g}compare(g,d,f=!1){return g===d?0:(0,A.$uf)(this.getComparisonKey(g,f),this.getComparisonKey(d,f))}isEqual(g,d,f=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,f)===this.getComparisonKey(d,f)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,f=!1){if(g.scheme===d.scheme){if(g.scheme===T.Schemas.file)return a.$zg(y(g),y(d),this.a(g))&&g.query===d.query&&(f||g.fragment===d.fragment);if((0,e.$gh)(g.authority,d.authority))return a.$zg(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(f||g.fragment===d.fragment)}return!1}joinPath(g,...d){return L.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.$$g)(g)||g.authority}basename(g){return O.$gc.basename(g.path)}extname(g){return O.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===T.Schemas.file?d=L.URI.file(O.$mc(y(g))).path:(d=O.$gc.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==k.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===T.Schemas.file?d=L.URI.file(O.$hc(y(g))).path:d=O.$gc.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.$gh)(g.authority,d.authority))return;if(g.scheme===T.Schemas.file){const E=O.$lc(y(g),y(d));return C.$i?a.$tg(E):E}let f=g.path||"/";const w=d.path||"/";if(this.a(g)){let E=0;for(const u=Math.min(f.length,w.length);E<u&&!(f.charCodeAt(E)!==w.charCodeAt(E)&&f.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);f=w.substr(0,E)+f.substr(E)}return O.$gc.relative(f,w)}resolvePath(g,d){if(g.scheme===T.Schemas.file){const f=L.URI.file(O.$kc(y(g),d));return g.with({authority:f.authority,path:f.path})}return d=a.$ug(d),g.with({path:O.$gc.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,A.$Bf)(g,d)}hasTrailingPathSeparator(g,d=O.sep){if(g.scheme===T.Schemas.file){const f=y(g);return f.length>a.$vg(f).length&&f[f.length-1]===d}else{const f=g.path;return f.length>1&&f.charCodeAt(f.length-1)===k.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=O.sep){return(0,e.$hh)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=O.sep){let f=!1;if(g.scheme===T.Schemas.file){const w=y(g);f=w!==void 0&&w.length===a.$vg(w).length&&w[w.length-1]===d}else{d="/";const w=g.path;f=w.length===1&&w.charCodeAt(w.length-1)===k.CharCode.Slash}return!f&&!(0,e.$hh)(g,d)?g.with({path:g.path+"/"}):g}}e.$3g=S,e.$4g=new S(()=>!1),e.$5g=new S(l=>l.scheme===T.Schemas.file?!C.$k:!0),e.$6g=new S(l=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function $(l,g){const d=[];for(let f=0;f<l.length;f++){const w=g(l[f]);l.some((E,u)=>u===f?!1:(0,e.$8g)(w,g(E)))||d.push(l[f])}return d}var h;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[b,t]=u.split(":");b&&t&&f.set(b,t)});const E=d.path.substring(0,d.path.indexOf(";"));return E&&f.set(l.META_DATA_MIME,E),f}l.parseMetaData=g})(h||(e.DataUri=h={}));function p(l,g,d){if(g){let f=l.path;return f&&f[0]!==O.$gc.sep&&(f=O.$gc.sep+f),l.with({scheme:d,authority:g,path:f})}return l.with({scheme:d})}}),define(le[6],he([0,1,26,8,3,2,21,5,135,54]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=S,e.$nh=$,e.$oh=h,e.$ph=p,e.$qh=l,e.$rh=g,e.$sh=d,e.$th=f,e.$Bh=r,e.$Ch=c,e.$Dh=m,e.$Eh=v,e.$Fh=P,e.$Uh=W,e.$3h=z;function S(_){return!!_&&typeof _.then=="function"}function $(_){const Y=new k.$se,ae=_(Y.token),ue=new Promise((ge,we)=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),we(new a.$5)});Promise.resolve(ae).then(pe=>{Ee.dispose(),Y.dispose(),ge(pe)},pe=>{Ee.dispose(),Y.dispose(),we(pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,we){return ue.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function h(_,Y,ae){return new Promise((ue,ge)=>{const we=Y.onCancellationRequested(()=>{we.dispose(),ue(ae)});_.then(ue,ge).finally(()=>we.dispose())})}function p(_,Y){return new Promise((ae,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new a.$5)});_.then(ae,ue).finally(()=>ge.dispose())})}async function l(_){let Y=-1;const ae=_.map((ue,ge)=>ue.then(we=>(Y=ge,we)));try{return await Promise.race(ae)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function g(_,Y,ae){let ue;const ge=setTimeout(()=>{ue?.(void 0),ae?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(we=>ue=we)])}function d(_){return new Promise((Y,ae)=>{const ue=_();S(ue)?ue.then(Y,ae):Y(ue)})}function f(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ae=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(ae,ae).then(ue)})}return new Promise((ae,ue)=>{this.b.then(ae,ue)})}return this.a=Y(),new Promise((ae,ue)=>{this.a.then(ge=>{this.a=null,ae(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$uh=w;class E{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$vh=E;class u{constructor(){this.a=new Map}queue(Y,ae){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$wh=u;const b=(_,Y)=>{let ae=!0;const ue=setTimeout(()=>{ae=!1,Y()},_);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(ue),ae=!1}}},t=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class s{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ae=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,we)=>{this.d=ge,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=ae===L.$ce?t(ue):b(ae,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=s;class o{constructor(Y){this.a=new s(Y),this.b=new w}trigger(Y,ae){return this.a.trigger(()=>this.b.queue(Y),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=o;class i{constructor(){this.a=!1,this.b=new Promise((Y,ae)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=i;class n extends i{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Ah=n;function r(_,Y){return Y?new Promise((ae,ue)=>{const ge=setTimeout(()=>{we.dispose(),ae()},_),we=Y.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),ue(new a.$5)})}):$(ae=>r(_,ae))}function c(_,Y=0,ae){const ue=setTimeout(()=>{_(),ae&&ge.dispose()},Y),ge=(0,O.$Sc)(()=>{clearTimeout(ue),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function m(_){const Y=[];let ae=0;const ue=_.length;function ge(){return ae<ue?_[ae++]():null}function we(Ee){Ee!=null&&Y.push(Ee);const pe=ge();return pe?pe.then(we):Promise.resolve(Y)}return Promise.resolve(null).then(we)}function v(_,Y=ue=>!!ue,ae=null){let ue=0;const ge=_.length,we=()=>{if(ue>=ge)return Promise.resolve(ae);const Ee=_[ue++];return Promise.resolve(Ee()).then(be=>Y(be)?Promise.resolve(be):we())};return we()}function P(_,Y=ue=>!!ue,ae=null){if(_.length===0)return Promise.resolve(ae);let ue=_.length;const ge=()=>{ue=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ee)=>{for(const pe of _)pe.then(be=>{--ue>=0&&Y(be)?(ge(),we(be)):ue===0&&we(ae)}).catch(be=>{--ue>=0&&(ge(),Ee(be))})})}class R{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new T.$he}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,ue)=>{this.g.push({factory:Y,c:ae,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=R;class I extends R{constructor(){super(1)}}e.$Hh=I;class N{constructor(){this.a=new ee,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Ih=N;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new q;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,ae=C.$4g){const ue=ae.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,ae,ue=C.$4g){const ge=ue.getComparisonKey(Y);let we=this.a.get(ge);if(!we){we=new I;const Ee=this.f++,pe=T.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Ee,pe),this.a.set(ge,we)}return we.queue(ae)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=U;class j{constructor(Y,ae){this.b=!1,this.a=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ae){if(this.b)throw new a.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ae)}setIfNotSet(Y,ae){if(this.b)throw new a.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ae))}}e.$Kh=j;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ae,ue=globalThis){if(this.f)throw new a.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{Y()},ae);this.d=(0,O.$Sc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=F;class X{constructor(Y,ae){this.b=-1,this.a=Y,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=X;class K{constructor(Y,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=K;class Q extends X{constructor(Y,ae){super(Y,ae),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Oh=Q;class V extends O.$Uc{constructor(Y,ae){super(),this.g=Y,this.h=ae,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Y)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(_,Y)=>{(0,A.$B)(()=>{if(ae)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Rh=(_,Y,ae)=>{const ue=_.requestIdleCallback(Y,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Qh=_=>(0,e.$Rh)(globalThis,_)}();class ie{constructor(Y,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Rh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ie;class H extends ie{constructor(Y){super(globalThis,Y)}}e.$Th=H;async function W(_,Y,ae){let ue;for(let ge=0;ge<ae;ge++)try{return await _()}catch(we){ue=we,await r(Y)}throw ue}class ee{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ae,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:ae},ae.then(()=>this.d(Y),()=>this.d(Y)),ae}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:ae,resolve:ue,reject:ge}=f();this.b={run:Y,promise:ae,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=ee;class re{constructor(Y,ae=()=>Date.now()){this.d=Y,this.f=ae,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Wh=re;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class q{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ae)=>{this.a=Y,this.b=ae})}complete(Y){return new Promise(ae=>{this.a(Y),this.d={outcome:ce.Resolved,value:Y},ae()})}error(Y){return new Promise(ae=>{this.b(Y),this.d={outcome:ce.Rejected,value:Y},ae()})}cancel(){return this.error(new a.$5)}}e.$Xh=q;var x;(function(_){async function Y(ue){let ge;const we=await Promise.all(ue.map(Ee=>Ee.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return we}_.settled=Y;function ae(ue){return new Promise(async(ge,we)=>{try{await ue(ge,we)}catch(Ee){we(Ee)}})}_.withAsyncBody=ae})(x||(e.Promises=x={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new a.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=J;class G{constructor(Y){this.b=Y,this.a=new y.$V(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=G;var D;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(D||(D={}));class B{static fromArray(Y){return new B(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new B(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>ae.emitOne(await ue)))})}static merge(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)ae.emitOne(ge)}))})}static{this.EMPTY=B.fromArray([])}constructor(Y,ae){this.a=D.Initial,this.b=[],this.d=null,this.f=ae,this.g=new T.$he,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await T.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,ae){return new B(async ue=>{for await(const ge of Y)ue.emitOne(ae(ge))})}map(Y){return B.map(this,Y)}static filter(Y,ae){return new B(async ue=>{for await(const ge of Y)ae(ge)&&ue.emitOne(ge)})}filter(Y){return B.filter(this,Y)}static coalesce(Y){return B.filter(Y,ae=>!!ae)}coalesce(){return B.coalesce(this)}static async toPromise(Y){const ae=[];for await(const ue of Y)ae.push(ue);return ae}toPromise(){return B.toPromise(this)}h(Y){this.a===D.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===D.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Y){this.a===D.Initial&&(this.a=D.DoneError,this.d=Y,this.g.fire())}}e.$1h=B;class M extends B{constructor(Y,ae){super(ae),this.m=Y}cancel(){this.m.cancel()}}e.$2h=M;function z(_){const Y=new k.$se,ae=_(Y.token);return new M(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new a.$5)});try{for await(const we of ae){if(Y.token.isCancellationRequested)return;ue.emitOne(we)}ge.dispose(),Y.dispose()}catch(we){ge.dispose(),Y.dispose(),ue.reject(we)}})}class te{constructor(Y){this.a=new q,this.b=new B(ge=>{if(ae){ge.reject(ae);return}return ue&&ge.emitMany(ue),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p},Y);let ae,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{ae||(ae=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$4h=te}),define(le[94],he([0,1,19,6,39,42,35,14,5,27]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=S,e.$sk=g,e.$tk=N,e.$uk=U,e.$vk=j,e.$wk=F,e.$xk=X,e.$yk=ie;function S(){return Object.create(null)}e.$qk="**",e.$rk="/";const $="[/\\\\]",h="[^/\\\\]",p=/\//g;function l(H,W){switch(H){case 0:return"";case 1:return`${h}*?`;default:return`(?:${$}|${h}+${$}${W?`|${$}${h}+`:""})*?`}}function g(H,W){if(!H)return[];const ee=[];let re=!1,ce=!1,q="";for(const x of H){switch(x){case W:if(!re&&!ce){ee.push(q),q="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}q+=x}return q&&ee.push(q),ee}function d(H){if(!H)return"";let W="";const ee=g(H,e.$rk);if(ee.every(re=>re===e.$qk))W=".*";else{let re=!1;ee.forEach((ce,q)=>{if(ce===e.$qk){if(re)return;W+=l(2,q===ee.length-1)}else{let x=!1,J="",G=!1,D="";for(const B of ce){if(B!=="}"&&x){J+=B;continue}if(G&&(B!=="]"||!D)){let M;B==="-"?M=B:(B==="^"||B==="!")&&!D?M="^":B===e.$rk?M="":M=(0,y.$df)(B),D+=M;continue}switch(B){case"{":x=!0;continue;case"[":G=!0;continue;case"}":{const z=`(?:${g(J,",").map(te=>d(te)).join("|")})`;W+=z,x=!1,J="";break}case"]":{W+="["+D+"]",G=!1,D="";break}case"?":W+=h;continue;case"*":W+=l(1);continue;default:W+=(0,y.$df)(B)}}q<ee.length-1&&(ee[q+1]!==e.$qk||q+2<ee.length)&&(W+=$)}re=ce===e.$qk})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new C.$Dc(1e4),o=function(){return!1},i=function(){return null};function n(H,W){if(!H)return i;let ee;typeof H!="string"?ee=H.pattern:ee=H,ee=ee.trim();const re=`${ee}_${!!W.trimForExclusions}`;let ce=s.get(re);if(ce)return r(ce,H);let q;return f.test(ee)?ce=m(ee.substr(4),ee):(q=w.exec(c(ee,W)))?ce=v(q[1],ee):(W.trimForExclusions?u:E).test(ee)?ce=P(ee,W):(q=b.exec(c(ee,W)))?ce=R(q[1].substr(1),ee,!0):(q=t.exec(c(ee,W)))?ce=R(q[1],ee,!1):ce=I(ee),s.set(re,ce),r(ce,H)}function r(H,W){if(typeof W=="string")return H;const ee=function(re,ce){return(0,O.$zg)(re,W.base,!L.$k)?H((0,y.$if)(re.substr(W.base.length),A.sep),ce):null};return ee.allBasenames=H.allBasenames,ee.allPaths=H.allPaths,ee.basenames=H.basenames,ee.patterns=H.patterns,ee}function c(H,W){return W.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function m(H,W){return function(ee,re){return typeof ee=="string"&&ee.endsWith(H)?W:null}}function v(H,W){const ee=`/${H}`,re=`\\${H}`,ce=function(x,J){return typeof x!="string"?null:J?J===H?W:null:x===H||x.endsWith(ee)||x.endsWith(re)?W:null},q=[H];return ce.basenames=q,ce.patterns=[W],ce.allBasenames=q,ce}function P(H,W){const ee=V(H.slice(1,-1).split(",").map(J=>n(J,W)).filter(J=>J!==i),H),re=ee.length;if(!re)return i;if(re===1)return ee[0];const ce=function(J,G){for(let D=0,B=ee.length;D<B;D++)if(ee[D](J,G))return H;return null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,G)=>G.allPaths?J.concat(G.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function R(H,W,ee){const re=A.sep===A.$gc.sep,ce=re?H:H.replace(p,A.sep),q=A.sep+ce,x=A.$gc.sep+H;let J;return ee?J=function(G,D){return typeof G=="string"&&(G===ce||G.endsWith(q)||!re&&(G===H||G.endsWith(x)))?W:null}:J=function(G,D){return typeof G=="string"&&(G===ce||!re&&G===H)?W:null},J.allPaths=[(ee?"*/":"./")+H],J}function I(H){try{const W=new RegExp(`^${d(H)}$`);return function(ee){return W.lastIndex=0,typeof ee=="string"&&W.test(ee)?H:null}}catch{return i}}function N(H,W,ee){return!H||typeof W!="string"?!1:U(H)(W,void 0,ee)}function U(H,W={}){if(!H)return o;if(typeof H=="string"||j(H)){const ee=n(H,W);if(ee===i)return o;const re=function(ce,q){return!!ee(ce,q)};return ee.allBasenames&&(re.allBasenames=ee.allBasenames),ee.allPaths&&(re.allPaths=ee.allPaths),re}return K(H,W)}function j(H){const W=H;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(H){return H.allBasenames||[]}function X(H){return H.allPaths||[]}function K(H,W){const ee=V(Object.getOwnPropertyNames(H).map(J=>Q(J,H[J],W)).filter(J=>J!==i)),re=ee.length;if(!re)return i;if(!ee.some(J=>!!J.requiresSiblings)){if(re===1)return ee[0];const J=function(B,M){let z;for(let te=0,_=ee.length;te<_;te++){const Y=ee[te](B,M);if(typeof Y=="string")return Y;(0,a.$mh)(Y)&&(z||(z=[]),z.push(Y))}return z?(async()=>{for(const te of z){const _=await te;if(typeof _=="string")return _}return null})():null},G=ee.find(B=>!!B.allBasenames);G&&(J.allBasenames=G.allBasenames);const D=ee.reduce((B,M)=>M.allPaths?B.concat(M.allPaths):B,[]);return D.length&&(J.allPaths=D),J}const ce=function(J,G,D){let B,M;for(let z=0,te=ee.length;z<te;z++){const _=ee[z];_.requiresSiblings&&D&&(G||(G=(0,A.$nc)(J)),B||(B=G.substr(0,G.length-(0,A.$oc)(J).length)));const Y=_(J,G,B,D);if(typeof Y=="string")return Y;(0,a.$mh)(Y)&&(M||(M=[]),M.push(Y))}return M?(async()=>{for(const z of M){const te=await z;if(typeof te=="string")return te}return null})():null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,G)=>G.allPaths?J.concat(G.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function Q(H,W,ee){if(W===!1)return i;const re=n(H,ee);if(re===i)return i;if(typeof W=="boolean")return re;if(W){const ce=W.when;if(typeof ce=="string"){const q=(x,J,G,D)=>{if(!D||!re(x,J))return null;const B=ce.replace("$(basename)",()=>G),M=D(B);return(0,a.$mh)(M)?M.then(z=>z?H:null):M?H:null};return q.requiresSiblings=!0,q}}return re}function V(H,W){const ee=H.filter(J=>!!J.basenames);if(ee.length<2)return H;const re=ee.reduce((J,G)=>{const D=G.basenames;return D?J.concat(D):J},[]);let ce;if(W){ce=[];for(let J=0,G=re.length;J<G;J++)ce.push(W)}else ce=ee.reduce((J,G)=>{const D=G.patterns;return D?J.concat(D):J},[]);const q=function(J,G){if(typeof J!="string")return null;if(!G){let B;for(B=J.length;B>0;B--){const M=J.charCodeAt(B-1);if(M===T.CharCode.Slash||M===T.CharCode.Backslash)break}G=J.substr(B)}const D=re.indexOf(G);return D!==-1?ce[D]:null};q.basenames=re,q.patterns=ce,q.allBasenames=re;const x=H.filter(J=>!J.basenames);return x.push(q),x}function ie(H,W){return(0,k.$ub)(H,W,(ee,re)=>typeof ee=="string"&&typeof re=="string"?ee===re:typeof ee!="string"&&typeof re!="string"?ee.base===re.base&&ee.pattern===re.pattern:!1)}}),define(le[95],he([0,1,15,64,9]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=L,e.$Gn=S,e.$Hn=$;function O(h){return h.toJSON()}class C{constructor(p){this.a=p}transformIncoming(p){const l=this.a.transformIncoming(p);return l===p?p:O(T.URI.from(l))}transformOutgoing(p){const l=this.a.transformOutgoing(p);return l===p?p:O(T.URI.from(l))}transformOutgoingURI(p){const l=this.a.transformOutgoing(p);return l===p?p:T.URI.from(l)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Dn=C,e.$En=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function A(h,p,l){if(!h||l>200)return null;if(typeof h=="object"){if(h instanceof T.URI)return p.transformOutgoing(h);for(const g in h)if(Object.hasOwnProperty.call(h,g)){const d=A(h[g],p,l+1);d!==null&&(h[g]=d)}}return null}function L(h,p){const l=A(h,p,0);return l===null?h:l}function y(h,p,l,g){if(!h||g>200)return null;if(typeof h=="object"){if(h.$mid===a.MarshalledId.Uri)return l?T.URI.revive(p.transformIncoming(h)):p.transformIncoming(h);if(h instanceof k.$Je)return null;for(const d in h)if(Object.hasOwnProperty.call(h,d)){const f=y(h[d],p,l,g+1);f!==null&&(h[d]=f)}}return null}function S(h,p){const l=y(h,p,!1,0);return l===null?h:l}function $(h,p){const l=y(h,p,!0,0);return l===null?h:l}}),define(le[150],he([0,1,38,52,32,137,5]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Kn=L,e.$Ln=$,e.$Mn=h,e.$Jn=new class{c(p){return this.a||(this.a=a.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,l=0;const g=(0,k.networkInterfaces)();for(const d in g){const f=g[d];if(f)for(const{mac:w,internal:E}of f)E||(l+=1,this.c(w.toUpperCase())&&(p+=1))}this.b=l>0?p/l:0}return this.b}};let A;async function L(p){return A||(A=(async()=>await y(p)||T.$Wg())()),A}async function y(p){try{const l=await new Promise((d,f)=>{ne(["crypto"],d,f)}),g=(0,O.$In)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){p(l);return}}const S="Software\\Microsoft\\SQMClient";async function $(p){if(C.$i){const l=await new Promise((g,d)=>{ne(["@vscode/windows-registry"],g,d)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(g){return p(g),""}}return""}async function h(p){try{return await(await new Promise((d,f)=>{ne(["@vscode/deviceid"],d,f)})).getDeviceId()}catch(l){return p(l),""}}}),define(le[151],he([0,1,43,152,14,36]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nW=S,e.$oW=$;const C="XDG_SESSION_TYPE",A="WAYLAND_DISPLAY",L="XDG_RUNTIME_DIR";var y;(function(h){h.Wayland="wayland",h.XWayland="xwayland",h.X11="x11",h.Unknown="unknown"})(y||(y={}));async function S(h){const p=O.env[C];if(p)return p===y.Wayland||p===y.X11?p:y.Unknown;if(O.env[A]){const g=O.env[L];if(g){const d=(0,T.$jc)(g,"wayland-0");try{return await(0,a.access)(d,k.constants.R_OK),y.Wayland}catch(f){return h(f),y.Unknown}}else return y.Unknown}else return y.X11}function $(h,p){if(p)switch(p){case"auto":return h;case"x11":return h===y.Wayland?y.XWayland:y.X11;case"wayland":return y.Wayland;default:return y.Unknown}else return h===y.Wayland?y.XWayland:y.X11}}),define(le[153],he([0,1,43,152,277,5]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=C;async function C(A){if(O.$j||O.$i)return;let L;for(const y of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{L=await(0,a.open)(y,k.constants.R_OK);break}catch{}if(!L){A("Unable to retrieve release information from known identifier paths.");return}try{const y=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const $ of(0,T.createInterface)({input:L.createReadStream(),crlfDelay:1/0})){if(!$.includes("="))continue;const h=$.split("=")[0].toUpperCase().trim();if(y.has(h)){const p=$.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?S.id=p:h==="ID_LIKE"?S.id_like=p:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(S.version_id=p)}}return S}catch(y){A(y)}}}),define(le[31],he([0,1,43,38,278,6,42,91,14,5,21,9]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=E,e.whenDeleted=t,e.configureFlushOnWrite=r,e.writeFileSync=m;var h;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function p(K,Q=h.UNLINK,V){if((0,C.$Dg)(K))throw new Error("rimraf - will refuse to recursively delete root");return Q===h.UNLINK?g(K):l(K,V)}async function l(K,Q=(0,C.$Ig)((0,a.tmpdir)())){try{try{await k.promises.rename(K,Q)}catch(V){return V.code==="ENOENT"?void 0:g(K)}g(Q).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(K){return(0,T.promisify)(k.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function d(K){if((0,C.$Dg)(K))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function f(K,Q){return u(await(Q?w(K):(0,T.promisify)(k.readdir)(K)))}async function w(K){try{return await(0,T.promisify)(k.readdir)(K,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const Q=[],V=await f(K);for(const ie of V){let H=!1,W=!1,ee=!1;try{const re=await e.Promises.lstat((0,L.$jc)(K,ie));H=re.isFile(),W=re.isDirectory(),ee=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Q.push({name:ie,isFile:()=>H,isDirectory:()=>W,isSymbolicLink:()=>ee})}return Q}function E(K){return u(k.readdirSync(K))}function u(K){return K.map(Q=>typeof Q=="string"?y.$j?(0,A.$gm)(Q):Q:(Q.name=y.$j?(0,A.$gm)(Q.name):Q.name,Q))}async function b(K){const Q=await f(K),V=[];for(const ie of Q)await s.existsDirectory((0,L.$jc)(K,ie))&&V.push(ie);return V}function t(K,Q=1e3){return new Promise(V=>{let ie=!1;const H=setInterval(()=>{ie||(ie=!0,k.access(K,W=>{ie=!1,W&&(clearInterval(H),V(void 0))}))},Q)})}var s;(function(K){async function Q(H){let W;try{if(W=await e.Promises.lstat(H),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(y.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw re}throw ee}}K.stat=Q;async function V(H){try{const{stat:W,symbolicLink:ee}=await K.stat(H);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=V;async function ie(H){try{const{stat:W,symbolicLink:ee}=await K.stat(H);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=ie})(s||(e.SymlinkSupport=s={}));const o=new O.$Jh;function i(K,Q,V){return o.queueFor($.URI.file(K),()=>{const ie=v(V);return new Promise((H,W)=>c(K,Q,ie,ee=>ee?W(ee):H()))},S.$5g)}let n=!0;function r(K){n=K}function c(K,Q,V,ie){if(!n)return k.writeFile(K,Q,{mode:V.mode,flag:V.flag},ie);k.open(K,V.flag,V.mode,(H,W)=>{if(H)return ie(H);k.writeFile(W,Q,ee=>{if(ee)return k.close(W,()=>ie(ee));k.fdatasync(W,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),k.close(W,ce=>ie(ce))))})})}function m(K,Q,V){const ie=v(V);if(!n)return k.writeFileSync(K,Q,{mode:ie.mode,flag:ie.flag});const H=k.openSync(K,ie.flag,ie.mode);try{k.writeFileSync(H,Q);try{k.fdatasyncSync(H)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{k.closeSync(H)}}function v(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function P(K,Q,V=6e4){if(K!==Q)try{y.$i&&typeof V=="number"?await R(K,Q,Date.now(),V):await(0,T.promisify)(k.rename)(K,Q)}catch(ie){if(K.toLowerCase()!==Q.toLowerCase()&&ie.code==="EXDEV"||K.endsWith("."))await I(K,Q,{preserveSymlinks:!1}),await p(K,h.MOVE);else throw ie}}async function R(K,Q,V,ie,H=0){try{return await(0,T.promisify)(k.rename)(K,Q)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-V>=ie)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${W}`),W;if(H===0){let ee=!1;try{const{stat:re}=await s.stat(Q);re.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,O.$Bh)(Math.min(100,H*10)),R(K,Q,V,ie,H+1)}}async function I(K,Q,V){return U(K,Q,{root:{source:K,target:Q},options:V,handledSourcePaths:new Set})}const N=511;async function U(K,Q,V){if(V.handledSourcePaths.has(K))return;V.handledSourcePaths.add(K);const{stat:ie,symbolicLink:H}=await s.stat(K);if(H){if(V.options.preserveSymlinks)try{return await X(K,Q,V)}catch{}if(H.dangling)return}return ie.isDirectory()?j(K,Q,ie.mode&N,V):F(K,Q,ie.mode&N)}async function j(K,Q,V,ie){await e.Promises.mkdir(Q,{recursive:!0,mode:V});const H=await f(K);for(const W of H)await U((0,L.$jc)(K,W),(0,L.$jc)(Q,W),ie)}async function F(K,Q,V){await e.Promises.copyFile(K,Q),await e.Promises.chmod(Q,V)}async function X(K,Q,V){let ie=await e.Promises.readlink(K);(0,C.$zg)(ie,V.root.source,!y.$k)&&(ie=(0,L.$jc)(V.root.target,ie.substr(V.root.source.length+1))),await e.Promises.symlink(ie,Q)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return(K,Q,V,ie,H)=>new Promise((W,ee)=>{k.read(K,Q,V,ie,H,(re,ce,q)=>re?ee(re):W({bytesRead:ce,buffer:q}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return(K,Q,V,ie,H)=>new Promise((W,ee)=>{k.write(K,Q,V,ie,H,(re,ce,q)=>re?ee(re):W({bytesWritten:ce,buffer:q}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return b}get writeFile(){return i}get rm(){return p}get rename(){return P}get copy(){return I}}}),define(le[154],he([0,1,43,14,5,27,31]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=A,e.$ar=L,e.$br=y,e.$cr=S;function A(h){if(T.$k)return h;const p=(0,a.$mc)(h);if(h===p)return h;const l=((0,a.$nc)(h)||h).toLowerCase();try{const d=(0,C.readdirSync)(p).filter(f=>f.toLowerCase()===l);if(d.length===1){const f=A(p);if(f)return(0,a.$jc)(f,d[0])}else if(d.length>1){const f=d.indexOf(l);if(f>=0){const w=A(p);if(w)return(0,a.$jc)(w,d[f])}}}catch{}return null}async function L(h,p){if(T.$k)return h;const l=(0,a.$mc)(h);if(h===l)return h;const g=((0,a.$nc)(h)||h).toLowerCase();try{if(p?.isCancellationRequested)return null;const f=(await C.Promises.readdir(l)).filter(w=>w.toLowerCase()===g);if(f.length===1){const w=await L(l,p);if(w)return(0,a.$jc)(w,f[0])}else if(f.length>1){const w=f.indexOf(g);if(w>=0){const E=await L(l,p);if(E)return(0,a.$jc)(E,f[w])}}}catch{}return null}async function y(h){try{return await C.Promises.realpath(h)}catch{const l=$(h);return await C.Promises.access(l,k.constants.R_OK),l}}function S(h){try{return k.realpathSync(h)}catch{const l=$(h);return k.accessSync(l,k.constants.R_OK),l}}function $(h){return(0,O.$jf)((0,a.$hc)(h),a.sep)}}),define(le[155],he([0,1,14,5,36,93,13,31]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$tm=L,e.$um=y,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function L($=T.env){return $.comspec||"cmd.exe"}function y($){let h=[],p=!1;const l=function(g){if(p){h.push(g);return}(!$.send(g,f=>{if(f&&console.error(f),p=!1,h.length>0){const w=h.slice(0);h=[],w.forEach(E=>l(E))}})||a.$i)&&(p=!0)};return{send:l}}var S;(function($){async function h(p,l,g){if(k.$ic(p))return p;if(l===void 0&&(l=T.cwd()),k.$mc(p)!=="."||(g===void 0&&C.$ag(T.env.PATH)&&(g=T.env.PATH.split(k.$tc)),g===void 0||g.length===0))return k.$jc(l,p);async function f(w){if(await A.Promises.exists(w)){let E;try{E=await A.Promises.stat(w)}catch(u){u.message.startsWith("EACCES")&&(E=await A.Promises.lstat(w))}return E?!E.isDirectory():!1}return!1}for(const w of g){let E;if(k.$ic(w)?E=k.$jc(w,p):E=k.$jc(l,w,p),await f(E))return E;let u=E+".com";if(await f(u)||(u=E+".exe",await f(u)))return u}return k.$jc(l,p)}$.findExecutable=h})(S||(e.win32=S={}))}),define(le[156],he([0,1,69,23]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=T;function T(C){return new Promise((A,L)=>{let y;const S=new Map;function $(p,l,g,d,f){const w=S.get(l);if(p===C||w){const E={name:h(g),cmd:g,pid:p,ppid:l,load:d,mem:f};S.set(p,E),p===C&&(y=E),w&&(w.children||(w.children=[]),w.children.push(E),w.children.length>1&&(w.children=w.children.sort((u,b)=>u.pid-b.pid)))}}function h(p){const l=/--utility-sub-type=network/i,g=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"electron-crash-reporter";if(d.exec(p))return"winpty-agent";if(f.exec(p))return"conpty-agent";let E=w.exec(p);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?l.exec(p)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let b="";do E=u.exec(p),E&&(b+=E+" ");while(E);return b&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${b})`:p}if(process.platform==="win32"){const p=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,g)=>{ne(["@vscode/windows-process-tree"],l,g)}).then(l=>{l.getProcessList(C,g=>{if(!g){L(new Error(`Root process ${C} not found`));return}l.getProcessCpuUsage(g,d=>{const f=new Map;d.forEach(w=>{const E=p(w.commandLine||"");f.set(w.pid,{name:h(E),cmd:E,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),y=f.get(C),y?(f.forEach(w=>{const E=f.get(w.ppid);E&&(E.children||(E.children=[]),E.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((E,u)=>E.pid-u.pid))}),A(y)):L(new Error(`Root process ${C} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let p=function(){let l=[y];const g=[];for(;l.length;){const f=l.shift();f&&(g.push(f.pid),f.children&&(l=l.concat(f.children)))}let d=JSON.stringify(a.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+g.join(" "),(0,k.exec)(d,{},(f,w,E)=>{if(f||E)L(f||new Error(E.toString()));else{const u=w.toString().split(`
`);for(let b=0;b<g.length;b++){const t=S.get(g[b]);t.load=parseFloat(u[b])}if(!y){L(new Error(`Root process ${C} not found`));return}A(y)}})};(0,k.exec)("which ps",{},(l,g,d)=>{if(l||d)if(process.platform!=="linux")L(l||new Error(d.toString()));else{const f=JSON.stringify(a.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(f,{},(w,E,u)=>{w||u?L(w||new Error(u.toString())):(O(E,$),p())})}else{const f=g.toString().trim();(0,k.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,u,b)=>{E||b&&!b.includes("screen size is bogus")?L(E||new Error(b.toString())):(O(u,$),process.platform==="linux"?p():y?A(y):L(new Error(`Root process ${C} not found`)))})}})}})}function O(C,A){const L=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=C.toString().split(`
`);for(const S of y){const $=L.exec(S.trim());$&&$.length===6&&A(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}});var ve=this&&this.__decorate||function(ne,e,k,a){var T=arguments.length,O=T<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,k):a,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ne,e,k,a);else for(var A=ne.length-1;A>=0;A--)(C=ne[A])&&(O=(T<3?C(O):T>3?C(e,k,O):C(e,k))||O);return T>3&&O&&Object.defineProperty(e,k,O),O};define(le[44],he([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=r,e.$bi=c,e.$gi=N,e.$hi=U;var p;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(p||(p={}));function l(H){switch(H){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g||(g={}));function d(H){switch(H){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var f;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(f||(f={}));function w(H){let W=0;for(let ee=0;;ee+=7){const re=H.read(1);if(W|=(re.buffer[0]&127)<<ee,!(re.buffer[0]&128))return W}}const E=o(0);function u(H,W){if(W===0){H.write(E);return}let ee=0;for(let ce=W;ce!==0;ce=ce>>>7)ee++;const re=T.$Je.alloc(ee);for(let ce=0;W!==0;ce++)re.buffer[ce]=W&127,W=W>>>7,W>0&&(re.buffer[ce]|=128);H.write(re)}class b{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$$h=b;class t{constructor(){this.a=[]}get buffer(){return T.$Je.concat(this.a)}write(W){this.a.push(W)}}e.$_h=t;var s;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(s||(s={}));function o(H){const W=T.$Je.alloc(1);return W.writeUInt8(H,0),W}const i={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object),Uint:o(s.Int)},n=typeof Buffer<"u";function r(H,W){if(typeof W>"u")H.write(i.Undefined);else if(typeof W=="string"){const ee=T.$Je.fromString(W);H.write(i.String),u(H,ee.byteLength),H.write(ee)}else if(n&&Buffer.isBuffer(W)){const ee=T.$Je.wrap(W);H.write(i.Buffer),u(H,ee.byteLength),H.write(ee)}else if(W instanceof T.$Je)H.write(i.VSBuffer),u(H,W.byteLength),H.write(W);else if(Array.isArray(W)){H.write(i.Array),u(H,W.length);for(const ee of W)r(H,ee)}else if(typeof W=="number"&&(W|0)===W)H.write(i.Uint),u(H,W);else{const ee=T.$Je.fromString(JSON.stringify(W));H.write(i.Object),u(H,ee.byteLength),H.write(ee)}}function c(H){switch(H.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return H.read(w(H)).toString();case s.Buffer:return H.read(w(H)).buffer;case s.VSBuffer:return H.read(w(H));case s.Array:{const ee=w(H),re=[];for(let ce=0;ce<ee;ce++)re.push(c(H));return re}case s.Object:return JSON.parse(H.read(w(H)).toString());case s.Int:return w(H)}}class m{constructor(W,ee,re=null,ce=1e3){this.h=W,this.j=ee,this.k=re,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:g.Initialize})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case g.Initialize:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,v.OtherSide,d(W.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,v.OtherSide,d(W.type),W.data);return}}}o(W,ee=void 0){const re=new t;return r(re,W),r(re,ee),this.p(re.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new b(W),re=c(ee),ce=c(ee),q=re[0];switch(q){case p.Promise:return this.k?.logIncoming(W.byteLength,re[1],v.OtherSide,`${l(q)}: ${re[2]}.${re[3]}`,ce),this.s({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case p.EventListen:return this.k?.logIncoming(W.byteLength,re[1],v.OtherSide,`${l(q)}: ${re[2]}.${re[3]}`,ce),this.t({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case p.PromiseCancel:return this.k?.logIncoming(W.byteLength,re[1],v.OtherSide,`${l(q)}`),this.u({type:q,id:re[1]});case p.EventDispose:return this.k?.logIncoming(W.byteLength,re[1],v.OtherSide,`${l(q)}`),this.u({type:q,id:re[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const re=new O.$se;let ce;try{ce=ee.call(this.j,W.name,W.arg,re.token)}catch(J){ce=Promise.reject(J)}const q=W.id;ce.then(J=>{this.m({id:q,data:J,type:g.PromiseSuccess})},J=>{J instanceof Error?this.m({id:q,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:g.PromiseError}):this.m({id:q,data:J,type:g.PromiseErrorObj})}).finally(()=>{x.dispose(),this.d.delete(W.id)});const x=(0,y.$Sc)(()=>re.cancel());this.d.set(W.id,x)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const re=W.id,q=ee.listen(this.j,W.name,W.arg)(x=>this.m({id:re,data:x,type:g.EventFire}));this.d.set(W.id,q)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const re=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===p.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);ee.push({request:W,timeoutTimer:re})}w(W){const ee=this.g.get(W);if(ee){for(const re of ee)switch(clearTimeout(re.timeoutTimer),re.request.type){case p.Promise:this.s(re.request);break;case p.EventListen:this.t(re.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Pc)(this.d.values()),this.d.clear()}}e.$ci=m;var v;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class P{constructor(W,ee=null){this.l=W,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new L.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ee}getChannel(W){const ee=this;return{call(re,ce,q){return ee.a?Promise.reject(new A.$5):ee.m(W,re,ce,q)},listen(re,ce){return ee.a?L.Event.None:ee.o(W,re,ce)}}}m(W,ee,re,ce=O.CancellationToken.None){const q=this.g++,x=p.Promise,J={id:q,type:x,channelName:W,name:ee,arg:re};if(ce.isCancellationRequested)return Promise.reject(new A.$5);let G;return new Promise((B,M)=>{if(ce.isCancellationRequested)return M(new A.$5);const z=()=>{const ae=ue=>{switch(ue.type){case g.PromiseSuccess:this.f.delete(q),B(ue.data);break;case g.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,M(ge);break}case g.PromiseErrorObj:this.f.delete(q),M(ue.data);break}};this.f.set(q,ae),this.p(J)};let te=null;this.b===f.Idle?z():(te=(0,a.$nh)(ae=>this.u()),te.then(()=>{te=null,z()}));const _=()=>{te?(te.cancel(),te=null):this.p({id:q,type:p.PromiseCancel}),M(new A.$5)},Y=ce.onCancellationRequested(_);G=(0,y.$Rc)((0,y.$Sc)(_),Y),this.d.add(G)}).finally(()=>{G.dispose(),this.d.delete(G)})}o(W,ee,re){const ce=this.g++,q=p.EventListen,x={id:ce,type:q,channelName:W,name:ee,arg:re};let J=null;const G=new L.$he({onWillAddFirstListener:()=>{J=(0,a.$nh)(B=>this.u()),J.then(()=>{J=null,this.d.add(G),this.p(x)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(G),this.p({id:ce,type:p.EventDispose}))}}),D=B=>G.fire(B.data);return this.f.set(ce,D),G.event}p(W){switch(W.type){case p.Promise:case p.EventListen:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,v.LocalSide,`${l(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case p.PromiseCancel:case p.EventDispose:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,v.LocalSide,l(W.type));return}}}q(W,ee=void 0){const re=new t;return r(re,W),r(re,ee),this.r(re.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new b(W),re=c(ee),ce=c(ee),q=re[0];switch(q){case g.Initialize:return this.j?.logIncoming(W.byteLength,0,v.LocalSide,d(q)),this.t({type:re[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,re[1],v.LocalSide,d(q),ce),this.t({type:re[0],id:re[1],data:ce})}}t(W){if(W.type===g.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return L.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Pc)(this.d.values()),this.d.clear()}}e.$di=P,ve([C.$5h],P.prototype,"onDidInitializePromise",null);class R{get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W,ee,re){this.a=new Map,this.f=new Set,this.g=new L.$he,this.onDidAddConnection=this.g.event,this.h=new L.$he,this.onDidRemoveConnection=this.h.event,this.j=new y.$Tc,this.j.add(W(({protocol:ce,onDidClientDisconnect:q})=>{const x=L.Event.once(ce.onMessage);this.j.add(x(J=>{const G=new b(J),D=c(G),B=new m(ce,D,ee,re),M=new P(ce,ee);this.a.forEach((te,_)=>B.registerChannel(_,te));const z={channelServer:B,channelClient:M,ctx:D};this.f.add(z),this.g.fire(z),this.j.add(q(()=>{B.dispose(),M.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(W,ee){const re=this;return{call(ce,q,x){let J;if((0,h.$og)(ee)){const D=(0,k.$3b)(re.connections.filter(ee));J=D?Promise.resolve(D):L.Event.toPromise(L.Event.filter(re.onDidAddConnection,ee))}else J=ee.routeCall(re,ce,q);const G=J.then(D=>D.channelClient.getChannel(W));return N(G).call(ce,q,x)},listen(ce,q){if((0,h.$og)(ee))return re.k(W,ee,ce,q);const x=ee.routeEvent(re,ce,q).then(J=>J.channelClient.getChannel(W));return N(x).listen(ce,q)}}}k(W,ee,re,ce){const q=this;let x;const J=new L.$he({onWillAddFirstListener:()=>{x=new y.$Tc;const G=new L.$ne,D=new Map,B=z=>{const _=z.channelClient.getChannel(W).listen(re,ce),Y=G.add(_);D.set(z,Y)},M=z=>{const te=D.get(z);te&&(te.dispose(),D.delete(z))};q.connections.filter(ee).forEach(B),L.Event.filter(q.onDidAddConnection,ee)(B,void 0,x),q.onDidRemoveConnection(M,void 0,x),G.event(J.fire,J,x),x.add(G)},onDidRemoveLastListener:()=>{x?.dispose(),x=void 0}});return J.event}registerChannel(W,ee){this.a.set(W,ee);for(const re of this.f)re.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=R;class I{constructor(W,ee,re=null){const ce=new t;r(ce,ee),W.send(ce.buffer),this.a=new P(W,re),this.d=new m(W,ee,re)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=I;function N(H){return{call(W,ee,re){return H.then(ce=>ce.call(W,ee,re))},listen(W,ee){const re=new L.$qe;return H.then(ce=>re.input=ce.listen(W,ee)),re.event}}}function U(H){let W=!1;return{call(ee,re,ce){return W?H.call(ee,re,ce):(0,a.$Bh)(0).then(()=>W=!0).then(()=>H.call(ee,re,ce))},listen(ee,re){if(W)return H.listen(ee,re);const ce=new L.$qe;return(0,a.$Bh)(0).then(()=>W=!0).then(()=>ce.input=H.listen(ee,re)),ce.event}}}class j{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await L.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$ii=j;var F;(function(H){function W(q,x,J){const G=q,D=J&&J.disableMarshalling,B=new Map;for(const M in G)re(M)&&B.set(M,L.Event.buffer(G[M],!0,void 0,x));return new class{listen(M,z,te){const _=B.get(z);if(_)return _;const Y=G[z];if(typeof Y=="function"){if(ce(z))return Y.call(G,te);if(re(z))return B.set(z,L.Event.buffer(G[z],!0,void 0,x)),B.get(z)}throw new A.$bb(`Event not found: ${z}`)}call(M,z,te){const _=G[z];if(typeof _=="function"){if(!D&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,S.$0h)(te[ae]);let Y=_.apply(G,te);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new A.$bb(`Method not found: ${z}`)}}}H.fromService=W;function ee(q,x){const J=x&&x.disableMarshalling;return new Proxy({},{get(G,D){if(typeof D=="string")return x?.properties?.has(D)?x.properties.get(D):ce(D)?function(B){return q.listen(D,B)}:re(D)?q.listen(D):async function(...B){let M;x&&!(0,h.$jg)(x.context)?M=[x.context,...B]:M=B;const z=await q.call(D,M);return J?z:(0,S.$0h)(z)};throw new A.$bb(`Property not found: ${String(D)}`)}})}H.toService=ee;function re(q){return q[0]==="o"&&q[1]==="n"&&$.$Af(q.charCodeAt(2))}function ce(q){return/^onDynamic/.test(q)&&$.$Af(q.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const W=H.toString();if(W!=="[object Object]")return W}return H}function Q(H){return Array.isArray(H)?H.map(K):K(H)}function V(H,W,ee,re,ce,q,x){x=Q(x);const J=X[ce],G=J[re%J.length];let D=[`%c[${H}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(q)?(D=D.concat(x),D.push(")")):D.push(x),console.log.apply(console,D)}class ie{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,re,ce,q){this.b+=W,V(this.d,this.b,W,ee,re,ce,q)}logIncoming(W,ee,re,ce,q){this.a+=W,V(this.f,this.a,W,ee,re,ce,q)}}e.$ji=ie}),define(le[70],he([0,1,15,3,2,44]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var A;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let r=0;function c(v,P){if(!n.has(v)){const R=String(++r);n.set(v,R)}return n.get(v)}function m(v,P,R,I){if(!i.enableDiagnostics)return;const N=c(v,P);if(I instanceof k.$Je||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const U=k.$Je.alloc(I.byteLength);U.set(I),i.records.push({timestamp:Date.now(),id:N,label:P,type:R,buff:U})}else i.records.push({timestamp:Date.now(),id:N,label:P,type:R,data:I})}i.traceSocketEvent=m})(A||(e.SocketDiagnostics=A={}));var L;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(L||(e.SocketCloseEventType=L={}));let y=null;function S(){return y||(y=k.$Je.alloc(0)),y}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const P=this.a[0];return r&&(this.a.shift(),this.b-=n),P}if(this.a[0].byteLength>n){const P=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),P}const c=k.$Je.alloc(n);let m=0,v=0;for(;n>0;){const P=this.a[v];if(P.byteLength>n){const R=P.slice(0,n);c.set(R,m),m+=n,r&&(this.a[v]=P.slice(n),this.b-=n),n-=n}else c.set(P,m),m+=P.byteLength,r?(this.a.shift(),this.b-=P.byteLength):v++,n-=P.byteLength}return c}}e.$ki=$;var h;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(h||(h={}));function p(i){switch(i){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var l;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class g{constructor(n,r,c,m){this.type=n,this.id=r,this.ack=c,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends T.$Uc{constructor(n){super(),this.f=this.B(new a.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:h.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new $,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(C.ProtocolHeaderRead,{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const c=this.g.messageType,m=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(C.ProtocolMessageRead,r),this.f.fire(new g(c,m,v,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.$Je.alloc(l.HeaderLength);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(C.ProtocolHeaderWrite,{messageType:p(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(C.ProtocolMessageWrite,n.data),this.j(r,n.data)}g(n,r){const c=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,c}h(){const n=k.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(C.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class w extends T.$Uc{constructor(n){super(),this.f=new a.$he,this.onMessage=this.f.event,this.g=new a.$he,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(r=>{r.type===h.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new g(h.Regular,0,0,n))}}e.$li=w;class E extends O.$fi{static fromSocket(n,r){return new E(new w(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,c=null){super(n,r,c),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$mi=E;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ni=u;class b{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,c=this.a;for(;c;)n[r++]=c.data,c=c.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new b(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<s.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=s.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+s.a)*1e3;let c=0;for(let m=0;m<s.a;m++)n-this.c[m]<=r&&c++;return 1-c/s.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new T.$Tc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},l.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new g(h.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new g(h.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new g(h.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.r.dispose(),this.r=new T.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new g(h.Ack,0,this.h,S());this.p.write(n);const r=this.b.toArray();for(let c=0,m=r.length;c<m;c++)this.p.write(r[c]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const r=this.b.peek();if(r&&r.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case h.None:break;case h.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new g(h.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case h.Control:{this.u.fire(n.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const r=this.b.toArray();for(let c=0,m=r.length;c<m;c++)this.p.write(r[c]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const r=++this.c;this.h=this.g;const c=new g(h.Regular,r,this.h,n);this.b.push(c),this.a||(this.p.write(c),this.B())}sendControl(n){const r=new g(h.Control,0,0,n);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=l.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},l.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),r=Date.now()-n.writtenTime,c=Date.now()-this.q.lastReadTime,m=Date.now()-this.n;if(r>=l.TimeoutTime&&c>=l.TimeoutTime&&m>=l.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:c});return}const v=Math.max(l.TimeoutTime-r,l.TimeoutTime-c,l.TimeoutTime-m,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new g(h.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new g(h.KeepAlive,0,this.h,S());this.p.write(n)}}e.$oi=o}),define(le[96],he([0,1,69,6,15,26,148,8,3,2,30,155,93,44]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class l extends p.$ci{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:L.Event.fromNodeEventEmitter(process,"message",w=>T.$Je.wrap(Buffer.from(w,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$8q=l;class g{constructor(f,w){this.i=f,this.j=w,this.c=new Set,this.g=new Map,this.h=new L.$he,this.onDidProcessExit=this.h.event;const E=w&&w.timeout?w.timeout:6e4;this.b=new a.$xh(E),this.d=null,this.f=null}getChannel(f){const w=this;return{call(E,u,b){return w.k(f,E,u,b)},listen(E,u){return w.l(f,E,u)}}}k(f,w,E,u=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(A.$6());this.b.cancel();const b=this.n(f),t=(0,a.$nh)(i=>b.call(w,E,i)),s=u.onCancellationRequested(()=>t.cancel()),o=(0,y.$Sc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{s.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,w,E){if(!this.b)return L.Event.None;this.b.cancel();let u;const b=new L.$he({onWillAddFirstListener:()=>{u=this.n(f).listen(w,E)(b.fire,b),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,S.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,h.$sm)(w.env),this.d=(0,k.fork)(this.i,f,w);const E=new L.$he,b=L.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,C.$4q)(r)){(0,C.log)(r,`IPC Library: ${this.j.serverName}`);return}E.fire(T.$Je.wrap(Buffer.from(r,"base64")))}),t=this.j.useQueue?(0,$.$um)(this.d):this.d,s=r=>this.d&&this.d.connected&&t.send(r.buffer.toString("base64")),o=E.event,i={send:s,onMessage:o};this.f=new p.$di(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,c)=>{process.removeListener("exit",n),b.dispose(),this.c.forEach(m=>(0,y.$Pc)(m)),this.c.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:c})})}return this.f}n(f){let w=this.g.get(f);return w||(w=this.m.getChannel(f),this.g.set(f,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9q=g}),define(le[157],he([0,1,140,15,44,3,13,19]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FW=void 0,e.$GW=S;class L{constructor(h){this.a=h,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",p=>p.data?a.$Je.wrap(p.data):a.$Je.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}class y extends T.$ei{static b(h){(0,C.$kg)((0,k.$EW)(process),"Electron Utility Process");const p=new O.$he;return process.parentPort.on("message",l=>{if(h?.handledClientConnection(l))return;const g=(0,A.$Ob)(l.ports);g&&p.fire(g)}),O.Event.map(p.event,l=>({protocol:new L(l),onDidClientDisconnect:O.Event.fromNodeEventEmitter(l,"close")}))}constructor(h){super(y.b(h))}}e.$FW=y;function S($,h,p){const l=g=>{g.data===h&&($.removeListener("message",l),p())};$.on("message",l)}}),define(le[71],he([0,1,6,3,2,68,13]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=L;var A;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function L(h){const p=h;return p?.changed instanceof Map||p?.deleted instanceof Set}var y;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(y||(e.StorageState=y={}));class S extends T.$Uc{static{this.a=100}constructor(p,l=Object.create(null)){super(),this.r=p,this.s=l,this.b=this.B(new a.$ke),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new k.$yh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((l,g)=>this.w(g,l)),p.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(p,l){if(this.c===y.Closed)return;let g=!1;(0,C.$jg)(l)?g=this.f.delete(p):this.f.get(p)!==l&&(this.f.set(p,l),g=!0),g&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,l){const g=this.f.get(p);return(0,C.$jg)(g)?l:g}getBoolean(p,l){const g=this.get(p);return(0,C.$jg)(g)?l:g==="true"}getNumber(p,l){const g=this.get(p);return(0,C.$jg)(g)?l:parseInt(g,10)}getObject(p,l){const g=this.get(p);return(0,C.$jg)(g)?l:(0,O.$9h)(g)}async set(p,l,g=!1){if(this.c===y.Closed)return;if((0,C.$jg)(l))return this.delete(p,g);const d=(0,C.$cg)(l)||Array.isArray(l)?(0,O.$8h)(l):String(l);if(this.f.get(p)!==d)return this.f.set(p,d),this.j.set(p,d),this.h.delete(p),this.b.fire({key:p,external:g}),this.D()}async delete(p,l=!1){if(!(this.c===y.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:l}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===y.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$5p=S;class ${constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((l,g)=>this.a.set(g,l)),p.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$6p=$}),define(le[158],he([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[72],he([0,1,43,6,14,13,31,158]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.zip=d,e.$rq=f,e.$sq=E,e.$oq="end of central directory record signature not found";const L=new RegExp(e.$oq);class y extends Error{constructor(b,t){let s=t.message;switch(b){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=b,this.cause=t}}e.$pq=y;function S(u){const b=u.externalFileAttributes>>16||33188;return[448,56,7].map(t=>b&t).reduce((t,s)=>t+s,b&61440)}function $(u){if(u instanceof y)return u;let b;return L.test(u.message)&&(b="CorruptZip"),new y(b,u)}function h(u,b,t,s,o,i){const n=T.$mc(b),r=T.$jc(s,n);if(!r.startsWith(s))return Promise.reject(new Error(A.localize(0,null,b)));const c=T.$jc(s,b);let m;return i.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(C.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((v,P)=>{if(!i.isCancellationRequested)try{m=(0,k.createWriteStream)(c,{mode:t}),m.once("close",()=>v()),m.once("error",P),u.once("error",P),u.pipe(m)}catch(R){P(R)}}))}function p(u,b,t,s){let o=(0,a.$nh)(()=>Promise.resolve()),i=0;const n=s.onCancellationRequested(()=>{o.cancel(),u.close()});return new Promise((r,c)=>{const m=new a.$vh,v=P=>{P.isCancellationRequested||(i++,u.readEntry())};u.once("error",c),u.once("close",()=>o.then(()=>{s.isCancellationRequested||u.entryCount===i?r():c(new y("Incomplete",new Error(A.localize(1,null,i,u.entryCount))))},c)),u.readEntry(),u.on("entry",P=>{if(s.isCancellationRequested)return;if(!t.sourcePathRegex.test(P.fileName)){v(s);return}const R=P.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(R)){const U=T.$jc(b,R);o=(0,a.$nh)(j=>C.Promises.mkdir(U,{recursive:!0}).then(()=>v(j)).then(void 0,c));return}const I=g(u,P),N=S(P);o=(0,a.$nh)(U=>m.queue(()=>I.then(j=>h(j,R,N,b,t,U).then(()=>v(U)))).then(null,c))})}).finally(()=>n.dispose())}async function l(u,b=!1){const{open:t}=await new Promise((s,o)=>{ne(["yauzl"],s,o)});return new Promise((s,o)=>{t(u,b?{lazyEntries:!0}:void 0,(i,n)=>{i?o($(i)):s((0,O.$lg)(n))})})}function g(u,b){return new Promise((t,s)=>{u.openReadStream(b,(o,i)=>{o?s($(o)):t((0,O.$lg)(i))})})}async function d(u,b){const{ZipFile:t}=await new Promise((s,o)=>{ne(["yazl"],s,o)});return new Promise((s,o)=>{const i=new t;b.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,k.createWriteStream)(u);i.outputStream.pipe(n),i.outputStream.once("error",o),n.once("error",o),n.once("finish",()=>s(u))})}function f(u,b,t={},s){const o=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=l(u,!0);return t.overwrite&&(i=i.then(n=>C.Promises.rm(b).then(()=>n))),i.then(n=>p(n,b,{sourcePathRegex:o},s))}function w(u,b){return l(u).then(t=>new Promise((s,o)=>{t.on("entry",i=>{i.fileName===b&&g(t,i).then(n=>s(n),n=>o(n))}),t.once("close",()=>o(new Error(A.localize(2,null,b))))}))}function E(u,b){return w(u,b).then(t=>new Promise((s,o)=>{const i=[];t.once("error",o),t.on("data",n=>i.push(n)),t.on("end",()=>s(Buffer.concat(i)))}))}}),define(le[159],he([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],he([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],he([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],he([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],he([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],he([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],he([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],he([0,1,39,8,161]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var O;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(O||(e.TokenType=O={}));function C(...S){switch(S.length){case 1:return(0,T.localize)(0,null,S[0]);case 2:return(0,T.localize)(1,null,S[0],S[1]);case 3:return(0,T.localize)(2,null,S[0],S[1],S[2]);default:return}}const A=(0,T.localize)(3,null),L=(0,T.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return $.isTripleEq?"===":"==";case O.NotEq:return $.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return $.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return $.lexeme;case O.QuotedStr:return $.lexeme;case O.Error:return $.lexeme;case O.EOF:return"EOF";default:throw(0,a.$8)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case k.CharCode.OpenParen:this.k(O.LParen);break;case k.CharCode.CloseParen:this.k(O.RParen);break;case k.CharCode.ExclamationMark:if(this.h(k.CharCode.Equals)){const h=this.h(k.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:h})}else this.k(O.Neg);break;case k.CharCode.SingleQuote:this.o();break;case k.CharCode.Slash:this.q();break;case k.CharCode.Equals:if(this.h(k.CharCode.Equals)){const h=this.h(k.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:h})}else this.h(k.CharCode.Tilde)?this.k(O.RegexOp):this.l(C("==","=~"));break;case k.CharCode.LessThan:this.k(this.h(k.CharCode.Equals)?O.LtEq:O.Lt);break;case k.CharCode.GreaterThan:this.k(this.h(k.CharCode.Equals)?O.GtEq:O.Gt);break;case k.CharCode.Ampersand:this.h(k.CharCode.Ampersand)?this.k(O.And):this.l(C("&&"));break;case k.CharCode.Pipe:this.h(k.CharCode.Pipe)?this.k(O.Or):this.l(C("||"));break;case k.CharCode.Space:case k.CharCode.CarriageReturn:case k.CharCode.Tab:case k.CharCode.LineFeed:case k.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?k.CharCode.Null:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const h=this.d,p=this.c.substring(this.d,this.e),l={type:O.Error,offset:this.d,lexeme:p};this.g.push({offset:h,lexeme:p,additionalInfo:$}),this.f.push(l)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const h=this.c.substring(this.d,this.e),p=y.b.get(h);p?this.k(p):this.f.push({type:O.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==k.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,h=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(L);return}const g=this.c.charCodeAt($);if(h)h=!1;else if(g===k.CharCode.Slash&&!p){$++;break}else g===k.CharCode.OpenSquareBracket?p=!0:g===k.CharCode.Backslash?h=!0:g===k.CharCode.CloseSquareBracket&&(p=!1);$++}for(;$<this.c.length&&y.a.has(this.c.charCodeAt($));)$++;this.e=$;const l=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=y}),define(le[191],he([0,1,67,88,23,14,36,21,9]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$_m=S,e.$an=$,e.$0m=/^([^.]+\..+)[:=](.+)$/;class y{get appRoot(){return(0,O.$mc)(T.$Ug.asFileUri("").fsPath)}get userHome(){return L.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return L.URI.file((0,O.$jc)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.b.tmpDir)}get cacheHome(){return L.URI.file(this.userDataPath)}get stateResource(){return(0,A.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,k.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$jc)(this.userDataPath,"logs",p)}return L.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$bh)(L.URI.file((0,O.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=C.env.VSCODE_PORTABLE;return p?L.URI.file((0,O.$jc)(p,"argv.json")):(0,A.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,O.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,O.$kc)(p):(0,O.$hc)((0,O.$jc)(T.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?L.URI.file((0,O.$kc)(p)):L.URI.file((0,O.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,O.$kc)(p);const l=C.env.VSCODE_EXTENSIONS;if(l)return l;const g=C.env.VSCODE_PORTABLE;return g?(0,O.$jc)(g,"extensions"):(0,A.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(l=>/^[^:/?#]+?:\/\//.test(l)?L.URI.parse(l):L.URI.file((0,O.$hc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?L.URI.parse(p):L.URI.file((0,O.$hc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$0m.test(p))}get extensionLogLevel(){const p=[];for(const l of this.args.log||[]){const g=e.$0m.exec(l);g&&g[1]&&g[2]&&p.push([g[1],g[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,A.$bh)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=C.env.VSCODE_PORTABLE;return p?L.URI.file((0,O.$jc)(p,"policy.json")):(0,A.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,l,g){this.a=p,this.b=l,this.c=g,this.editSessionId=this.args.editSessionId}}e.$$m=y,ve([a.$5h],y.prototype,"appRoot",null),ve([a.$5h],y.prototype,"userHome",null),ve([a.$5h],y.prototype,"userDataPath",null),ve([a.$5h],y.prototype,"appSettingsHome",null),ve([a.$5h],y.prototype,"tmpDir",null),ve([a.$5h],y.prototype,"cacheHome",null),ve([a.$5h],y.prototype,"stateResource",null),ve([a.$5h],y.prototype,"userRoamingDataHome",null),ve([a.$5h],y.prototype,"userDataSyncHome",null),ve([a.$5h],y.prototype,"sync",null),ve([a.$5h],y.prototype,"machineSettingsResource",null),ve([a.$5h],y.prototype,"workspaceStorageHome",null),ve([a.$5h],y.prototype,"localHistoryHome",null),ve([a.$5h],y.prototype,"keyboardLayoutResource",null),ve([a.$5h],y.prototype,"argvResource",null),ve([a.$5h],y.prototype,"isExtensionDevelopment",null),ve([a.$5h],y.prototype,"untitledWorkspacesHome",null),ve([a.$5h],y.prototype,"builtinExtensionsPath",null),ve([a.$5h],y.prototype,"extensionsPath",null),ve([a.$5h],y.prototype,"extensionDevelopmentLocationURI",null),ve([a.$5h],y.prototype,"extensionDevelopmentKind",null),ve([a.$5h],y.prototype,"extensionTestsLocationURI",null),ve([a.$5h],y.prototype,"debugExtensionHost",null),ve([a.$5h],y.prototype,"logLevel",null),ve([a.$5h],y.prototype,"extensionLogLevel",null),ve([a.$5h],y.prototype,"serviceMachineIdResource",null),ve([a.$5h],y.prototype,"disableTelemetry",null),ve([a.$5h],y.prototype,"disableWorkspaceTrust",null),ve([a.$5h],y.prototype,"useInMemorySecretStorage",null),ve([a.$5h],y.prototype,"policyFile",null);function S(h,p){return $(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId,h.extensionEnvironment)}function $(h,p,l,g,d,f){const E=Number(p||h)||(g?null:l),u=E?!!p:!1;let b;if(f)try{b=JSON.parse(f)}catch{}return{port:E,break:u,debugId:d,env:b}}}),function(){"use strict";function ne(e,k,a){function T(C,A){const L=O(C,A),y=[L];return e.isAbsolute(L)||y.unshift(a),e.resolve(...y)}function O(C,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const L=process.env.VSCODE_PORTABLE;if(L)return e.join(L,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,A);const S=C["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join($,"AppData","Roaming")}break;case"darwin":y=e.join(k.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,A)}return{getUserDataPath:T}}if(typeof define=="function")define(le[192],he([279,38,36]),function(e,k,a){return ne(e,k,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ne(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],he([0,1,38,191,192]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0,e.$cn=C,e.$dn=A;class O extends a.$$m{constructor(y,S){super(y,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(y,S.nameShort)},S)}}e.$bn=O;function C(L,y){return(0,a.$an)(L["inspect-ptyhost"],L["inspect-brk-ptyhost"],5877,y,L.extensionEnvironment)}function A(L,y){return(0,a.$an)(L["inspect-sharedprocess"],L["inspect-brk-sharedprocess"],5879,y,L.extensionEnvironment)}}),define(le[194],he([0,1,13,164]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=T;function T(C,A,L,y){try{O(C,A,L,y)}catch(S){C.error(S?.message??S)}return A}function O(C,A,L,y){const S=($,h,p)=>{const l=$[h];if((0,k.$ag)(l)){const g=l,d=g.length;if(d>1&&g[0]==="%"&&g[d-1]==="%"){const f=g.substr(1,d-2);let w=L[f];w===void 0&&y&&(w=y[f]);const E=typeof w=="string"?w:w?.message,u=y?.[f],b=typeof u=="string"?u:u?.message;if(!E){b||C.warn(`[${A.name}]: ${(0,a.localize)(0,null,f)}`);return}if(p&&(h==="title"||h==="category")&&b&&b!==E){const t={value:E,original:b};$[h]=t}else $[h]=E}}else if((0,k.$cg)(l))for(const g in l)l.hasOwnProperty(g)&&(g==="commands"?S(l,g,!0):S(l,g,p));else if(Array.isArray(l))for(let g=0;g<l.length;g++)S(l,g,p)};for(const $ in A)A.hasOwnProperty($)&&S(A,$)}}),define(le[195],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class k{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.a.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Wfc=k;class a{constructor(O){this.a=O}listen(O,C){throw new Error(`Event not found: ${C}`)}call(O,C,A){switch(C){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(A[0])}throw new Error(`Call not found: ${C}`)}}e.$Xfc=a}),define(le[73],he([0,1,21,92,168,56]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=L,e.$Pp=y,e.$Qp=S,e.$Rp=$,e.$Sp=h,e.$Tp=p,e.$Up=l;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||C.test(f)}function y(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=f.match(C);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function S(f){if(!f)return null;const w=f.majorBase,E=f.majorMustEqual,u=f.minorBase;let b=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(w===0||(b=!1),s=!1);let o=0;if(f.preRelease){const i=A.exec(f.preRelease);if(i){const[,n,r,c]=i;o=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:w,majorMustEqual:E,minorBase:u,minorMustEqual:b,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:o}}function $(f,w,E){let u;typeof f=="string"?u=S(y(f)):u=f;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let t;if(typeof E=="string"?t=S(y(E)):t=E,!u||!t)return!1;const s=u.majorBase,o=u.minorBase,i=u.patchBase;let n=t.majorBase,r=t.minorBase,c=t.patchBase;const m=t.notBefore;let v=t.majorMustEqual,P=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:o>r?!0:o<r||b&&b<m?!1:i>=c:(s===1&&n===0&&(!v||!P||!R)&&(n=1,r=0,c=0,v=!0,P=!1,R=!1),s<n?!1:s>n?!v:o<r?!1:o>r?!P:i<c?!1:i>c?!R:!(b&&b<m))}function h(f,w,E,u,b){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([a.default.Error,T.localize(0,null)]),t;if(typeof u.name!="string")return t.push([a.default.Error,T.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([a.default.Error,T.localize(2,null,"version")]),t;if(!u.engines)return t.push([a.default.Error,T.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([a.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!d(u.extensionDependencies))return t.push([a.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!d(u.activationEvents))return t.push([a.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([a.default.Error,T.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([a.default.Warning,T.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([a.default.Error,T.localize(9,null,"main")]),t;{const i=(0,k.$bh)(E,u.main);(0,k.$8g)(i,E)||t.push([a.default.Warning,T.localize(10,null,i.path,E.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([a.default.Error,T.localize(11,null,"browser")]),t;{const i=(0,k.$bh)(E,u.browser);(0,k.$8g)(i,E)||t.push([a.default.Warning,T.localize(12,null,i.path,E.path)])}}if(!O.valid(u.version))return t.push([a.default.Error,T.localize(13,null)]),t;const s=[];if(!p(f,w,u,b,s))for(const i of s)t.push([a.default.Error,i]);return t}function p(f,w,E,u,b){return u||typeof E.main>"u"&&typeof E.browser>"u"?!0:g(f,w,E.engines.vscode,b)}function l(f,w,E){return f==="*"||g(w,E,f)}function g(f,w,E,u=[]){const b=S(y(E));if(!b)return u.push(T.localize(14,null,E)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return u.push(T.localize(15,null,E)),!1}else if(!b.majorMustEqual)return u.push(T.localize(16,null,E)),!1;return $(f,w,b)?!0:(u.push(T.localize(17,null,f,E)),!1)}function d(f){if(!Array.isArray(f))return!1;for(let w=0,E=f.length;w<E;w++)if(typeof f[w]!="string")return!1;return!0}}),define(le[74],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class k{constructor(T,O=[],C=!1){this.ctor=T,this.staticArguments=O,this.supportsDelayedInstantiation=C}}e.$xi=k}),define(le[196],he([0,1,74]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=O,e.$Gs=C;const a=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function O(A,L,y){L instanceof k.$xi||(L=new k.$xi(L,[],!!y)),a.push([A,L])}function C(){return a}}),define(le[197],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class k{constructor(O,C){this.key=O,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$ir=k;class a{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const C of this.a.values())C.outgoing.size===0&&O.push(C);return O}insertEdge(O,C){const A=this.lookupOrInsertNode(O),L=this.lookupOrInsertNode(C);A.outgoing.set(L.key,L),L.incoming.set(A.key,A)}removeNode(O){const C=this.b(O);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(O){const C=this.b(O);let A=this.a.get(C);return A||(A=new k(C,O),this.a.set(C,A)),A}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[C,A]of this.a)O.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,C]of this.a){const A=new Set([O]),L=this.c(C,A);if(L)return L}}c(O,C){for(const[A,L]of O.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const y=this.c(L,C);if(y)return y;C.delete(A)}}}e.$jr=a}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=T,e.$Bi=O;var k;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(L){return L[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(k||(e._util=k={})),e.$zi=T("instantiationService");function a(C,A,L){A[k.DI_TARGET]===A?A[k.DI_DEPENDENCIES].push({id:C,index:L}):(A[k.DI_DEPENDENCIES]=[{id:C,index:L}],A[k.DI_TARGET]=A)}function T(C){if(k.serviceIds.has(C))return k.serviceIds.get(C);const A=function(L,y,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(A,L,S)};return A.toString=()=>C,k.serviceIds.set(C,A),A}function O(C){return C}}),define(le[198],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0,e.$wfc=(0,k.$Ai)("checksumService")}),define(le[22],he([0,1,13,9,4]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=O,e.$9i=C,e.$0i=L,e.$$i=y,e.$_i=S,e.$aj=$,e.$bj=h,e.$cj=l,e.$dj=g,e.$ej=d,e.$7i=(0,T.$Ai)("configurationService");function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof a.URI)}function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof a.URI)}var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function L(f){switch(f){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function y(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function S(f,w){const E=Object.create(null);for(const u in f)$(E,u,f[u],w);return E}function $(f,w,E,u){const b=w.split("."),t=b.pop();let s=f;for(let o=0;o<b.length;o++){const i=b[o];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":if(n===null){u(`Ignoring ${w} as ${b.slice(0,o+1).join(".")} is null`);return}break;default:u(`Ignoring ${w} as ${b.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=E}catch{u(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(s)}`)}else u(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(s)}`)}function h(f,w){const E=w.split(".");p(f,E)}function p(f,w){const E=w.shift();if(w.length===0){delete f[E];return}if(Object.keys(f).indexOf(E)!==-1){const u=f[E];typeof u=="object"&&!Array.isArray(u)&&(p(u,w),Object.keys(u).length===0&&delete f[E])}}function l(f,w,E){function u(s,o){let i=s;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const b=w.split("."),t=u(f,b);return typeof t>"u"?E:t}function g(f,w,E){Object.keys(w).forEach(u=>{u!=="__proto__"&&(u in f?k.$cg(f[u])&&k.$cg(w[u])?g(f[u],w[u],E):E&&(f[u]=w[u]):f[u]=w[u])})}function d(f){return f.replace(/[\[\]]/g,"")}}),define(le[97],he([0,1,39,5,27,190,4,160,8]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=S,e.$zj=o,e.$Aj=i,e.$Tj=q;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",a.$j),y.set("isLinux",a.$k),y.set("isWindows",a.$i),y.set("isWeb",a.$o),y.set("isMacNative",a.$j&&!a.$o),y.set("isEdge",a.$H),y.set("isFirefox",a.$F),y.set("isChrome",a.$E),y.set("isSafari",a.$G);function S(G,D){if(y.get(G)!==void 0)throw(0,L.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(G,D)}const $=Object.prototype.hasOwnProperty;var h;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const p={regexParsingWithErrorRecovery:!0},l=(0,A.localize)(0,null),g=(0,A.localize)(1,null),d=(0,A.localize)(2,null),f=(0,A.localize)(3,null),w=(0,A.localize)(4,null),E=(0,A.localize)(5,null),u=(0,A.localize)(6,null),b=(0,A.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=p){this.k=D,this.d=new O.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const M=this.D(),z=M.type===O.TokenType.Str?E:void 0;throw this.h.push({message:w,offset:M.offset,lexeme:O.$vj.getLexeme(M),additionalInfo:z}),t.c}return B}catch(B){if(B!==t.c)throw B;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(O.TokenType.Or);){const B=this.o();D.push(B)}return D.length===1?D[0]:s.or(...D)}o(){const D=[this.s()];for(;this.y(O.TokenType.And);){const B=this.s();D.push(B)}return D.length===1?D[0]:s.and(...D)}s(){if(this.y(O.TokenType.Neg)){const D=this.D();switch(D.type){case O.TokenType.True:return this.z(),r.INSTANCE;case O.TokenType.False:return this.z(),c.INSTANCE;case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B?.negate()}case O.TokenType.Str:return this.z(),N.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case O.TokenType.True:return this.z(),s.true();case O.TokenType.False:return this.z(),s.false();case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B}case O.TokenType.Str:{const B=D.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==O.TokenType.RegexStr)throw this.B("REGEX",z);const te=z.lexeme,_=te.lastIndexOf("/"),Y=_===te.length-1?void 0:this.w(te.substring(_+1));let ae;try{ae=new RegExp(te.substring(1,_),Y)}catch{throw this.B("REGEX",z)}return Q.create(B,ae)}switch(z.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const te=[z.lexeme];this.z();let _=this.D(),Y=0;for(let Ee=0;Ee<z.lexeme.length;Ee++)z.lexeme.charCodeAt(Ee)===k.CharCode.OpenParen?Y++:z.lexeme.charCodeAt(Ee)===k.CharCode.CloseParen&&Y--;for(;!this.E()&&_.type!==O.TokenType.And&&_.type!==O.TokenType.Or;){switch(_.type){case O.TokenType.LParen:Y++;break;case O.TokenType.RParen:Y--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===k.CharCode.OpenParen?Y++:z.lexeme.charCodeAt(Ee)===k.CharCode.CloseParen&&Y--}if(Y<0)break;te.push(O.$vj.getLexeme(_)),this.z(),_=this.D()}const ae=te.join(""),ue=ae.lastIndexOf("/"),ge=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let we;try{we=new RegExp(ae.substring(1,ue),ge)}catch{throw this.B("REGEX",z)}return s.regex(B,we)}case O.TokenType.QuotedStr:{const te=z.lexeme;this.z();let _=null;if(!(0,T.$$e)(te)){const Y=te.indexOf("/"),ae=te.lastIndexOf("/");if(Y!==ae&&Y>=0){const ue=te.slice(Y+1,ae),ge=te[ae+1]==="i"?"i":"";try{_=new RegExp(ue,ge)}catch{throw this.B("REGEX",z)}}}if(_===null)throw this.B("REGEX",z);return Q.create(B,_)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,d);const z=this.u();return s.notIn(B,z)}switch(this.D().type){case O.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.equals(B,z);switch(z){case"true":return s.has(B);case"false":return s.not(B);default:return s.equals(B,z)}}case O.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.notEquals(B,z);switch(z){case"true":return s.not(B);case"false":return s.has(B);default:return s.notEquals(B,z)}}case O.TokenType.Lt:return this.z(),X.create(B,this.u());case O.TokenType.LtEq:return this.z(),K.create(B,this.u());case O.TokenType.Gt:return this.z(),j.create(B,this.u());case O.TokenType.GtEq:return this.z(),F.create(B,this.u());case O.TokenType.In:return this.z(),s.in(B,this.u());default:return s.has(B)}}case O.TokenType.EOF:throw this.h.push({message:u,offset:D.offset,lexeme:"",additionalInfo:b}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),D.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,B){if(this.C(D))return this.z();throw this.B(B,this.D())}B(D,B,M){const z=(0,A.localize)(8,null,D,O.$vj.getLexeme(B)),te=B.offset,_=O.$vj.getLexeme(B);return this.h.push({message:z,offset:te,lexeme:_,additionalInfo:M}),t.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$xj=t;class s{static false(){return r.INSTANCE}static true(){return c.INSTANCE}static has(D){return m.create(D)}static equals(D,B){return v.create(D,B)}static notEquals(D,B){return I.create(D,B)}static regex(D,B){return Q.create(D,B)}static in(D,B){return P.create(D,B)}static notIn(D,B){return R.create(D,B)}static not(D){return N.create(D)}static and(...D){return H.create(D,null,!0)}static or(...D){return W.create(D,null,!0)}static greater(D,B){return j.create(D,B)}static greaterEquals(D,B){return F.create(D,B)}static smaller(D,B){return X.create(D,B)}static smallerEquals(D,B){return K.create(D,B)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$yj=s;function o(G){const D=new t({regexParsingWithErrorRecovery:!1});return G.map(B=>(D.parse(B),D.lexingErrors.length>0?D.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,A.localize)(9,null,M.additionalInfo):(0,A.localize)(10,null),offset:M.offset,length:M.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}function i(G,D){const B=G?G.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!B&&!M?!0:!B||!M?!1:B.equals(M)}function n(G,D){return G.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=h.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return c.INSTANCE}}e.$Bj=r;class c{static{this.INSTANCE=new c}constructor(){this.type=h.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Cj=c;class m{static create(D,B=null){const M=y.get(D);return typeof M=="boolean"?M?c.INSTANCE:r.INSTANCE:new m(D,B)}constructor(D,B){this.key=D,this.c=B,this.type=h.Defined}cmp(D){return D.type!==this.type?this.type-D.type:re(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=y.get(this.key);return typeof D=="boolean"?D?c.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Dj=m;class v{static create(D,B,M=null){if(typeof B=="boolean")return B?m.create(D,M):N.create(D,M);const z=y.get(D);return typeof z=="boolean"?B===(z?"true":"false")?c.INSTANCE:r.INSTANCE:new v(D,B,M)}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?c.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ej=v;class P{static create(D,B){return new P(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.f),M=D.getValue(this.d);return Array.isArray(B)?B.includes(M):typeof M=="string"&&typeof B=="object"&&B!==null?$.call(B,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$Fj=P;class R{static create(D,B){return new R(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.NotIn,this.c=P.create(D,B)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=R;class I{static create(D,B,M=null){if(typeof B=="boolean")return B?N.create(D,M):m.create(D,M);const z=y.get(D);return typeof z=="boolean"?B===(z?"true":"false")?r.INSTANCE:c.INSTANCE:new I(D,B,M)}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?r.INSTANCE:c.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Hj=I;class N{static create(D,B=null){const M=y.get(D);return typeof M=="boolean"?M?r.INSTANCE:c.INSTANCE:new N(D,B)}constructor(D,B){this.c=D,this.d=B,this.type=h.Not}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=y.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:c.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Ij=N;function U(G,D){if(typeof G=="string"){const B=parseFloat(G);isNaN(B)||(G=B)}return typeof G=="string"||typeof G=="number"?D(G):r.INSTANCE}class j{static create(D,B,M=null){return U(B,z=>new j(D,z,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Jj=j;class F{static create(D,B,M=null){return U(B,z=>new F(D,z,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Kj=F;class X{static create(D,B,M=null){return U(B,z=>new X(D,z,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Lj=X;class K{static create(D,B,M=null){return U(B,z=>new K(D,z,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Mj=K;class Q{static create(D,B){return new Q(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const B=this.f?this.f.source:"",M=D.f?D.f.source:"";return B<M?-1:B>M?1:0}equals(D){if(D.type===this.type){const B=this.f?this.f.source:"",M=D.f?D.f.source:"";return this.d===D.d&&B===M}return!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Nj=Q;class V{static create(D){return new V(D)}constructor(D){this.c=D,this.type=h.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new V(this.c.map(D))}negate(){return this.c}}e.$Oj=V;function ie(G){let D=null;for(let B=0,M=G.length;B<M;B++){const z=G[B].substituteConstants();if(G[B]!==z&&D===null){D=[];for(let te=0;te<B;te++)D[te]=G[te]}D!==null&&(D[B]=z)}return D===null?G:D}class H{static create(D,B,M){return H.d(D,B,M)}constructor(D,B){this.expr=D,this.c=B,this.type=h.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const z=n(this.expr[B],D.expr[B]);if(z!==0)return z}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].evaluate(D))return!1;return!0}static d(D,B,M){const z=[];let te=!1;for(const _ of D)if(_){if(_.type===h.True){te=!0;continue}if(_.type===h.False)return r.INSTANCE;if(_.type===h.And){z.push(..._.expr);continue}z.push(_)}if(z.length===0&&te)return c.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(n);for(let _=1;_<z.length;_++)z[_-1].equals(z[_])&&(z.splice(_,1),_--);if(z.length===1)return z[0];for(;z.length>1;){const _=z[z.length-1];if(_.type!==h.Or)break;z.pop();const Y=z.pop(),ae=z.length===0,ue=W.create(_.expr.map(ge=>H.create([ge,Y],null,M)),null,ae);ue&&(z.push(ue),z.sort(n))}if(z.length===1)return z[0];if(M){for(let _=0;_<z.length;_++)for(let Y=_+1;Y<z.length;Y++)if(z[_].negate().equals(z[Y]))return r.INSTANCE;if(z.length===1)return z[0]}return new H(z,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new H(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());this.c=W.create(D,this,!0)}return this.c}}e.$Pj=H;class W{static create(D,B,M){return W.d(D,B,M)}constructor(D,B){this.expr=D,this.c=B,this.type=h.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const z=n(this.expr[B],D.expr[B]);if(z!==0)return z}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let B=0,M=this.expr.length;B<M;B++)if(this.expr[B].evaluate(D))return!0;return!1}static d(D,B,M){let z=[],te=!1;if(D){for(let _=0,Y=D.length;_<Y;_++){const ae=D[_];if(ae){if(ae.type===h.False){te=!0;continue}if(ae.type===h.True)return c.INSTANCE;if(ae.type===h.Or){z=z.concat(ae.expr);continue}z.push(ae)}}if(z.length===0&&te)return r.INSTANCE;z.sort(n)}if(z.length!==0){if(z.length===1)return z[0];for(let _=1;_<z.length;_++)z[_-1].equals(z[_])&&(z.splice(_,1),_--);if(z.length===1)return z[0];if(M){for(let _=0;_<z.length;_++)for(let Y=_+1;Y<z.length;Y++)if(z[_].negate().equals(z[Y]))return c.INSTANCE;if(z.length===1)return z[0]}return new W(z,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new W(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());for(;D.length>1;){const B=D.shift(),M=D.shift(),z=[];for(const te of J(B))for(const _ of J(M))z.push(H.create([te,_],null,!1));D.unshift(W.create(z,null,!1))}this.c=W.create(D,this,!0)}return this.c}}e.$Qj=W;class ee extends m{static{this.d=[]}static all(){return ee.d.values()}constructor(D,B,M){super(D,null),this.f=B,typeof M=="object"?ee.d.push({...M,key:D}):M!==!0&&ee.d.push({key:D,description:M,type:B!=null?typeof B:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return v.create(this.key,D)}notEqualsTo(D){return I.create(this.key,D)}}e.$Rj=ee,e.$Sj=(0,C.$Ai)("contextKeyService");function re(G,D){return G<D?-1:G>D?1:0}function ce(G,D,B,M){return G<B?-1:G>B?1:D<M?-1:D>M?1:0}function q(G,D){if(G.type===h.False||D.type===h.True)return!0;if(G.type===h.Or)return D.type===h.Or?x(G.expr,D.expr):!1;if(D.type===h.Or){for(const B of D.expr)if(q(G,B))return!0;return!1}if(G.type===h.And){if(D.type===h.And)return x(D.expr,G.expr);for(const B of G.expr)if(q(B,D))return!0;return!1}return G.equals(D)}function x(G,D){let B=0,M=0;for(;B<G.length&&M<D.length;){const z=G[B].cmp(D[M]);if(z<0)return!1;z===0&&B++,M++}return B===G.length}function J(G){return G.type===h.Or?G.expr:[G]}}),define(le[98],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$in=e.ID=void 0,e.$jn=a,e.ID="diagnosticsService",e.$in=(0,k.$Ai)(e.ID);function a(O){return!!O.hostName&&!!O.errorMessage}class T{async getPerformanceInfo(C,A){return{}}async getSystemInfo(C,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,A){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$kn=T}),define(le[99],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=void 0,e.$Ro=(0,k.$Ai)("downloadService")}),define(le[16],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,k.$Ai)("environmentService"),e.$Ii=(0,k.$Bi)(e.$Hi)}),define(le[75],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$34b=T;var a;(function(C){C[C.FILE=1]="FILE",C[C.WORKSPACE=2]="WORKSPACE",C[C.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function T(C){switch(C){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var O;(function(C){C.Ignored="ignored",C.Cancelled="cancelled",C.TooMany="toomany",C.IncompatibleWindow="incompatibleWindow",C.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.$44b=(0,k.$Ai)("IExtensionRecommendationNotificationService")}),define(le[7],he([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=h,e.$9k=d,e.$0k=w,e.$$k=E,e.$_k=u,e.$al=b,e.$bl=t,e.$cl=s,e.$dl=o,e.$el=i,e.$fl=n,e.$hl=m,e.$il=v,e.$jl=P,e.$kl=R,e.$ll=I,e.$ol=X,e.$Al=W,e.$Bl=ee,e.$Dl=ce,e.$7k=(0,L.$Ai)("fileService");function h(q){return q.create===!0}var p;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var l;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var g;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function d(q){const x=q;return!!x&&typeof x.onDidChange=="function"}var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(q){return!!(q.capabilities&f.FileReadWrite)}function E(q){return!!(q.capabilities&f.FileFolderCopy)}function u(q){return!!(q.capabilities&f.FileClone)}function b(q){return!!(q.capabilities&f.FileOpenReadWriteClose)}function t(q){return!!(q.capabilities&f.FileReadStream)}function s(q){return w(q)?!!(q.capabilities&f.FileAtomicRead):!1}function o(q){return w(q)?!!(q.capabilities&f.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&f.FileAtomicDelete)}function n(q){return!!(q.capabilities&f.Readonly)}var r;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class c extends Error{static create(x,J){const G=new c(x.toString(),J);return P(G,J),G}constructor(x,J){super(x),this.code=J}}e.$gl=c;function m(q,x){return c.create(q,x)}function v(q){return q||m((0,A.localize)(0,null),r.Unknown)}function P(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}function R(q){if(!q)return r.Unknown;if(q instanceof c)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return r.Unknown;switch(x[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function I(q){if(q instanceof K)return q.fileOperationResult;switch(R(q)){case r.FileNotFound:return ie.FILE_NOT_FOUND;case r.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case r.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case r.NoPermissions:return ie.FILE_PERMISSION_DENIED;case r.FileExists:return ie.FILE_MOVE_CONFLICT;case r.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var N;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class U{constructor(x,J,G){this.resource=x,this.operation=J,this.target=G}isOperation(x){return this.operation===x}}e.$ml=U;var j;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor(x,J){this.c=J,this.b=void 0,this.d=new $.$V(()=>{const G=k.$Gi.forUris(()=>this.c);return G.fill(this.rawAdded.map(D=>[D,!0])),G}),this.f=new $.$V(()=>{const G=k.$Gi.forUris(()=>this.c);return G.fill(this.rawUpdated.map(D=>[D,!0])),G}),this.g=new $.$V(()=>{const G=k.$Gi.forUris(()=>this.c);return G.fill(this.rawDeleted.map(D=>[D,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of x){switch(G.type){case j.ADDED:this.rawAdded.push(G.resource);break;case j.UPDATED:this.rawUpdated.push(G.resource);break;case j.DELETED:this.rawDeleted.push(G.resource);break}this.b!==F.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(x,...J){return this.h(x,{includeChildren:!1},...J)}affects(x,...J){return this.h(x,{includeChildren:!0},...J)}h(x,J,...G){if(!x)return!1;const D=G.length>0;return!!((!D||G.includes(j.ADDED))&&(this.d.value.get(x)||J.includeChildren&&this.d.value.findSuperstr(x))||(!D||G.includes(j.UPDATED))&&(this.f.value.get(x)||J.includeChildren&&this.f.value.findSuperstr(x))||(!D||G.includes(j.DELETED))&&(this.g.value.findSubstr(x)||J.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$nl=F;function X(q,x,J){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==a.sep&&(x+=a.sep),J?(0,T.$Cf)(q,x):q.indexOf(x)===0)}class K extends Error{constructor(x,J,G){super(x),this.fileOperationResult=J,this.options=G}}e.$pl=K;class Q extends K{constructor(x,J,G,D){super(x,J,D),this.fileOperationResult=J,this.size=G}}e.$ql=Q;class V extends K{constructor(x,J,G){super(x,ie.FILE_NOT_MODIFIED_SINCE,G),this.stat=J}}e.$rl=V;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var H;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$zl="";function W(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function ee(q,x){if(!x.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(J=>{const G=x.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===q.scheme&&D.added&&(G.dispose(),J())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(x){return(0,O.$eg)(x)||(x=0),x<re.KB?(0,A.localize)(1,null,x.toFixed(0)):x<re.MB?(0,A.localize)(2,null,(x/re.KB).toFixed(2)):x<re.GB?(0,A.localize)(3,null,(x/re.MB).toFixed(2)):x<re.TB?(0,A.localize)(4,null,(x/re.GB).toFixed(2)):(0,A.localize)(5,null,(x/re.TB).toFixed(2))}}e.$Cl=re;function ce(q){const x=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*re.MB:x?10*re.MB:y.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(k,a){e(k,a,ne)}};define(le[199],he([0,1,76,51,7]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;let O=class{constructor(A){this.a=A}async checksum(A){const L=(await this.a.readFileStream(A)).value;return new Promise((y,S)=>{const $=(0,k.createHash)("sha256");(0,a.$Be)(L,{onData:h=>$.update(h.buffer),onError:h=>S(h),onEnd:()=>y($.digest("base64").replace(/=+$/,""))})})}};e.$xfc=O,e.$xfc=O=ve([Z(0,T.$7k)],O)}),define(le[100],he([0,1,15,8,171,7]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=C;async function C(S,$,h,p,l,g){let d;try{await A(S,$,h,p,l,g)}catch(f){d=f}finally{d&&l.errorTransformer&&(d=l.errorTransformer(d)),typeof d<"u"&&h.error(d),h.end()}}async function A(S,$,h,p,l,g){L(g);const d=await S.open($,{create:!1});try{L(g);let f=0,w=0,E=l&&typeof l.length=="number"?l.length:void 0,u=k.$Je.alloc(Math.min(l.bufferSize,typeof E=="number"?E:l.bufferSize)),b=l&&typeof l.position=="number"?l.position:0,t=0;do w=await S.read(d,b,u.buffer,t,u.byteLength-t),b+=w,t+=w,f+=w,typeof E=="number"&&(E-=w),t===u.byteLength&&(await h.write(p(u)),u=k.$Je.alloc(Math.min(l.bufferSize,typeof E=="number"?E:l.bufferSize)),t=0);while(w>0&&(typeof E!="number"||E>0)&&L(g)&&y(f,l));if(t>0){let s=t;typeof E=="number"&&(s=Math.min(t,E)),h.write(p(u.slice(0,s)))}}catch(f){throw(0,O.$il)(f)}finally{await S.close(d)}}function L(S){if(S.isCancellationRequested)throw(0,a.$6)();return!0}function y(S,$){if(typeof $?.limits?.size=="number"&&S>$.limits.size)throw(0,O.$hl)((0,T.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],he([0,1,94,2,14,5,9,7]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=void 0,e.$Rq=L,e.$Sq=y,e.$Wq=p,e.$Xq=l,e.$Yq=g,e.$Zq=d,e.$1q=w,e.$2q=E;function L(u){return typeof u.correlationId=="number"}function y(u){return u.recursive===!0}class S extends a.$Uc{static{this.a=3}static{this.b=10}constructor(b,t,s,o){super(),this.m=b,this.n=t,this.r=s,this.s=o,this.f=this.B(new a.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const b=new a.$Tc;this.f.value=b,this.c=this.t(b),this.c.setVerboseLogging(this.r),b.add(this.c.onDidChangeFile(t=>this.m(t))),b.add(this.c.onDidLogMessage(t=>this.n(t))),b.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(b,t){if(this.s.restartOnError&&this.g?.length)if(t){const s=this.h.get(t.path)??0;s<S.a?(this.z(`restarting watcher from error in watch request (retrying request): ${b} (${JSON.stringify(t)})`),this.h.set(t.path,s+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${b} (${JSON.stringify(t)})`),this.y(this.g.filter(o=>o.path!==t.path)))}else this.j<S.b?(this.z(`restarting watcher after unknown global error: ${b}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${b}`);else this.z(b)}y(b){this.u(),this.watch(b)}async watch(b){this.g=b,await this.c?.watch(b)}async setVerboseLogging(b){this.r=b,await this.c?.setVerboseLogging(b)}z(b){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${b}`})}C(b){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${b}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Tq=S;class $ extends S{constructor(b,t,s){super(b,t,s,{type:"node.js",restartOnError:!1})}}e.$Uq=$;class h extends S{constructor(b,t,s){super(b,t,s,{type:"universal",restartOnError:!0})}}e.$Vq=h;function p(u){return u.map(b=>({type:b.type,resource:C.URI.revive(b.resource),cId:b.cId}))}function l(u){const b=new f;for(const t of u)b.processEvent(t);return b.coalesce()}function g(u,b){return typeof b=="string"&&!b.startsWith(k.$qk)&&!(0,T.$ic)(b)?{base:u,pattern:b}:b}function d(u,b){const t=[];for(const s of b)t.push((0,k.$uk)(g(u,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(b){return O.$k?b.resource.fsPath:b.resource.fsPath.toLowerCase()}processEvent(b){const t=this.b.get(this.c(b));let s=!1;if(t){const o=t.type,i=b.type;t.resource.fsPath!==b.resource.fsPath&&(b.type===A.FileChangeType.DELETED||b.type===A.FileChangeType.ADDED)?s=!0:o===A.FileChangeType.ADDED&&i===A.FileChangeType.DELETED?(this.b.delete(this.c(b)),this.a.delete(t)):o===A.FileChangeType.DELETED&&i===A.FileChangeType.ADDED?t.type=A.FileChangeType.UPDATED:o===A.FileChangeType.ADDED&&i===A.FileChangeType.UPDATED||(t.type=i)}else s=!0;s&&(this.a.add(b),this.b.set(this.c(b),b))}coalesce(){const b=[],t=[];return Array.from(this.a).filter(s=>s.type!==A.FileChangeType.DELETED?(b.push(s),!1):!0).sort((s,o)=>s.resource.fsPath.length-o.resource.fsPath.length).filter(s=>t.some(o=>(0,A.$ol)(s.resource.fsPath,o,!O.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(b)}}function w(u,b){if(typeof b=="number")switch(u.type){case A.FileChangeType.ADDED:return(b&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(b&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(b&A.FileChangeFilter.UPDATED)===0}return!1}function E(u){if(typeof u=="number"){const b=[];return u&A.FileChangeFilter.ADDED&&b.push("Added"),u&A.FileChangeFilter.DELETED&&b.push("Deleted"),u&A.FileChangeFilter.UPDATED&&b.push("Updated"),b.length===0?"<all>":`[${b.join(", ")}]`}return"<none>"}}),define(le[200],he([0,1,15,40,8,3,2,51,32,7,47]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0,e.$6P="localFilesystem";class $ extends C.$Uc{constructor(p,l){super(),this.a=p,this.b=l,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$he),this.onDidWatchError=this.g.event,this.h=(0,L.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=y.FileSystemProviderCapabilities.FileReadWrite|y.FileSystemProviderCapabilities.FileOpenReadWriteClose|y.FileSystemProviderCapabilities.FileReadStream|y.FileSystemProviderCapabilities.FileFolderCopy|y.FileSystemProviderCapabilities.FileWriteUnlock|y.FileSystemProviderCapabilities.FileAtomicRead|y.FileSystemProviderCapabilities.FileAtomicWrite|y.FileSystemProviderCapabilities.FileAtomicDelete|y.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=y.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=y.FileSystemProviderCapabilities.Trash)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,l){const{buffer:g}=await this.a.call("readFile",[p,l]);return g}readFileStream(p,l,g){const d=(0,A.$xe)(w=>k.$Je.concat(w.map(E=>k.$Je.wrap(E))).buffer),f=new C.$Tc;return f.add(this.a.listen("readFileStream",[p,l])(w=>{if(w instanceof k.$Je)d.write(w.buffer);else{if(w==="end")d.end();else{let E;if(w instanceof Error)E=w;else{const u=w;E=(0,y.$hl)(u.message??(0,a.$lj)(u),u.code??y.FileSystemProviderErrorCode.Unknown)}d.error(E),d.end()}f.dispose()}})),f.add(g.onCancellationRequested(()=>{d.error((0,T.$6)()),d.end(),f.dispose()})),d}writeFile(p,l,g){return this.a.call("writeFile",[p,k.$Je.wrap(l),g])}open(p,l){return this.a.call("open",[p,l])}close(p){return this.a.call("close",[p])}async read(p,l,g,d,f){const[w,E]=await this.a.call("read",[p,l,f]);return g.set(w.buffer.slice(0,E),d),E}write(p,l,g,d,f){return this.a.call("write",[p,l,k.$Je.wrap(g),d,f])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,l){return this.a.call("delete",[p,l])}rename(p,l,g){return this.a.call("rename",[p,l,g])}copy(p,l,g){return this.a.call("copy",[p,l,g])}cloneFile(p,l){return this.a.call("cloneFile",[p,l])}j(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const l=p;this.f.fire((0,S.$Wq)(l))}else{const l=p;this.g.fire(l)}}))}watch(p,l){const g=(0,L.$Wg)();return this.a.call("watch",[this.h,g,p,l]),(0,C.$Sc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$7P=$}),define(le[201],he([0,1,43,2,47,3,7,9,6]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class y extends a.$Uc{constructor(){super(),this.a=this.B(new O.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$4c),this.m=new Set,this.n=5007,this.r=new L.$Xh,this.P=!1,this.B(this.f($=>this.s($)))}s($){this.t($)&&this.w($)}t($){return(0,T.$Rq)($)}async watch($){this.r.isSettled||this.r.complete(),this.r=new L.$Xh;try{this.h.clear(),this.g.clear();for(const h of $)this.t(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))])}isSuspended($){return typeof $.correlationId!="number"?!1:this.m.has($.correlationId)?"polling":this.j.has($.correlationId)}async w($){if(this.j.has($.correlationId))return;const h=new a.$Tc;this.j.set($.correlationId,h),await this.r.p,!h.isDisposed&&(this.z($,h),this.u())}y($){this.j.deleteAndDispose($.correlationId),this.m.delete($.correlationId),this.u()}z($,h){this.C($,h)?(this.N(`reusing an existing recursive watcher to monitor ${$.path}`),this.m.delete($.correlationId)):(this.D($,h),this.m.add($.correlationId))}C($,h){const p=this.M?.subscribe($.path,(l,g)=>{h.isDisposed||(l?this.z($,h):g?.type===C.FileChangeType.ADDED&&this.F($))});return p?(h.add(p),!0):!1}D($,h){let p=!1;const l=(g,d)=>{if(h.isDisposed)return;const f=this.G(g),w=this.G(d),E=p;p=f,!f&&(w||E)&&this.F($)};this.N(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,k.watchFile)($.path,{persistent:!1,interval:this.n},l)}catch(g){this.O(`fs.watchFile() failed with error ${g} on path ${$.path} (correlationId: ${$.correlationId})`)}h.add((0,a.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,k.unwatchFile)($.path,l)}catch(g){this.O(`fs.unwatchFile() failed with error ${g} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}F($){this.N(`detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const h={resource:A.URI.file($.path),type:C.FileChangeType.ADDED,cId:$.correlationId};this.a.fire([h]),this.H(h,$),this.y($)}G($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H($,h){if(this.P){const p=` >> normalized ${$.type===C.FileChangeType.ADDED?"[ADDED]":$.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.I(p,h)}}I($,h){this.P&&this.N(`${$}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}J($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, filter: ${(0,T.$2q)($.filter)}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}async setVerboseLogging($){this.P=$}}e.$$q=y}),define(le[202],he([0,1,43,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,e.$er=f;class d extends C.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(E,u,b,t,s,o){super(),this.s=E,this.t=u,this.u=b,this.w=t,this.y=s,this.z=o,this.c=this.B(new a.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new a.$Oh(i=>this.M(i),d.b)),this.g=(0,g.$Zq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$Zq)(this.s.path,this.s.includes):void 0,this.j=(0,g.$Rq)(this.s)?this.s.filter:void 0,this.m=new T.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const E=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const u=await p.Promises.stat(E);if(this.m.token.isCancellationRequested)return;this.B(await this.G(E,u.isDirectory()))}catch(E){E.code!=="ENOENT"?this.O(E):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${E})`),this.D()}}D(){this.r=!0,this.w?.()}async F(E){let u=E.path;try{u=await p.Promises.realpath(E.path),E.path===u&&(u=await(0,h.$ar)(E.path,this.m.token)??E.path),E.path!==u&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${u})`)}catch{}return u}async G(E,u){const b=new C.$Tc;return this.H(E,u,b)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(E,u,b)),b}H(E,u,b){if(u)return!1;const t=$.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(o,i)=>{if(!b.isDisposed)if(o){const n=await this.G(E,u);b.isDisposed?n.dispose():b.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return s?(b.add(s),!0):!1}async I(E,u,b){if(y.$j&&(0,O.$zg)(E,"/Volumes/",!0)){this.O(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new T.$se(this.m.token);b.add((0,C.$Sc)(()=>t.dispose(!0)));const s=new C.$Tc;b.add(s);try{const o=$.URI.file(this.s.path),i=(0,L.$nc)(E),n=(0,k.watch)(E);s.add((0,C.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${E}'`);const r=new Set;if(u)try{for(const m of await p.Promises.readdir(E))r.add(m)}catch(m){this.O(m)}if(t.token.isCancellationRequested)return;const c=new Map;s.add((0,C.$Sc)(()=>{for(const[,m]of c)m.dispose();c.clear()})),n.on("error",(m,v)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${E} for changes using fs.watch() (${m}, ${v})`),this.D())}),n.on("change",(m,v)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${m}"] ${v}`);let P="";if(v&&(P=v.toString(),y.$j&&(P=(0,A.$gm)(P))),!(!P||m!=="change"&&m!=="rename"))if(u)if(m==="rename"){c.get(P)?.dispose();const R=setTimeout(async()=>{if(c.delete(P),P===i&&!await p.Promises.exists(E)){this.J(o);return}if(t.token.isCancellationRequested)return;const I=await this.N((0,L.$jc)(E,P));if(t.token.isCancellationRequested)return;let N;I?r.has(P)?N=l.FileChangeType.UPDATED:(N=l.FileChangeType.ADDED,r.add(P)):(r.delete(P),N=l.FileChangeType.DELETED),this.L({resource:(0,S.$bh)(o,P),type:N,cId:this.s.correlationId})},d.a);c.set(P,(0,C.$Sc)(()=>clearTimeout(R)))}else{let R;r.has(P)?R=l.FileChangeType.UPDATED:(R=l.FileChangeType.ADDED,r.add(P)),this.L({resource:(0,S.$bh)(o,P),type:R,cId:this.s.correlationId})}else if(m==="rename"||P!==i){const R=setTimeout(async()=>{const I=await p.Promises.exists(E);t.token.isCancellationRequested||(I?(this.L({resource:o,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(E,!1))):this.J(o))},d.a);s.clear(),s.add((0,C.$Sc)(()=>clearTimeout(R)))}else this.L({resource:o,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){t.token.isCancellationRequested||this.O(`Failed to watch ${E} for changes using fs.watch() (${o.toString()})`),this.D()}}J(E){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:E,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(E,u=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${E.type===l.FileChangeType.ADDED?"[ADDED]":E.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`),!u&&this.g.some(b=>b(E.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${E.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(b=>b(E.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${E.resource.fsPath}`):this.f.work(E))}M(E){const u=(0,g.$Xq)(E),b=[];for(const s of u){if((0,g.$1q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}b.push(s)}if(b.length===0)return;if(this.z)for(const s of b)this.R(` >> normalized ${s.type===l.FileChangeType.ADDED?"[ADDED]":s.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(b)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${b[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${b.length}, most recent change: ${b[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(E){if(y.$k)return p.Promises.exists(E);try{const u=(0,L.$nc)(E);return(await p.Promises.readdir((0,L.$mc)(E))).some(t=>t===u)}catch(u){return this.Q(u),!1}}setVerboseLogging(E){this.z=E}O(E){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}P(E){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}Q(E){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}R(E){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${E}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$dr=d;async function f(w,E,u,b,t=512){const s=await p.Promises.open(w,"r"),o=Buffer.allocUnsafe(t),i=new T.$se(b);let n,r=!1;const c={path:w,excludes:[],recursive:!1},m=new d(c,void 0,v=>{(async()=>{for(const{type:P}of v)if(P===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:R}=await p.Promises.read(s,o,0,t,null);if(!R||i.token.isCancellationRequested)break;E(o.slice(0,R))}}catch(R){n=new Error(R),i.dispose(!0)}finally{r=!1}}})()});return await m.ready,u(),new Promise((v,P)=>{i.token.onCancellationRequested(async()=>{m.dispose();try{await p.Promises.close(s)}catch(R){n=new Error(R)}n?P(n):v()})})}}),define(le[203],he([0,1,3,94,201,5,202,42]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class L extends T.$$q{constructor(S){super(),this.M=S,this.onDidError=k.Event.None,this.watchers=new Set}async L(S){S=this.X(S);const $=[],h=new Set(Array.from(this.watchers));for(const p of S){const l=this.S(p);l&&(0,a.$yk)(l.request.excludes,p.excludes)&&(0,a.$yk)(l.request.includes,p.includes)?h.delete(l):$.push(p)}$.length&&this.N(`Request to start watching: ${$.map(p=>this.J(p)).join(",")}`),h.size&&this.N(`Request to stop watching: ${Array.from(h).map(p=>this.J(p.request)).join(",")}`);for(const p of h)this.W(p);for(const p of $)this.U(p)}S(S){for(const $ of this.watchers)if(typeof S.correlationId=="number"||typeof $.request.correlationId=="number"){if($.request.correlationId===S.correlationId)return $}else if((0,A.$yg)($.request.path,S.path,!O.$k))return $}U(S){const $=new C.$dr(S,this.M,p=>this.a.fire(p),()=>this.c.fire(S),p=>this.b.fire(p),this.P),h={request:S,instance:$};this.watchers.add(h)}async stop(){await super.stop();for(const S of this.watchers)this.W(S)}W(S){this.N("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}X(S){const $=new Map;for(const h of S){const p=O.$k?h.path:h.path.toLowerCase();let l=$.get(h.correlationId);l||(l=new Map,$.set(h.correlationId,l)),l.has(p)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(h)}`),l.set(p,h)}return Array.from($.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const $ of this.watchers)$.instance.setVerboseLogging(S)}N(S,$){this.P&&this.b.fire({type:"trace",message:this.$(S,$)})}O(S){this.b.fire({type:"warn",message:this.$(S)})}$(S,$){return $?`[File Watcher (node.js)] ${S} (${this.J($.request)})`:`[File Watcher (node.js)] ${S}`}}e.$fr=L}),define(le[204],he([0,1,47,203]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class T extends k.$Uq{constructor(C,A,L){super(C,A,L),this.u()}t(C){return C.add(new a.$fr(void 0))}}e.$gr=T}),define(le[205],he([0,1,23,44,96,47]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class C extends O.$Vq{constructor(L,y,S){super(L,y,S),this.u()}t(L){const y=L.add(new T.$9q(k.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return L.add(y.onDidProcessExit(({code:S,signal:$})=>this.w(`terminated by itself with code ${S}, signal: ${$} (ETERM)`))),a.ProxyChannel.toService((0,a.$hi)(y.getChannel("watcher")))}}e.$0q=C}),define(le[77],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class k{constructor(...T){this.a=new Map;for(const[O,C]of T)this.set(O,C)}set(T,O){const C=this.a.get(T);return this.a.set(T,O),C}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.$yi=k}),define(le[206],he([0,1,6,8,2,74,197,4,77,90]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const S=!1;class $ extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class h{constructor(d=new L.$yi,f=!1,w,E=S){this.i=d,this.j=f,this.k=w,this.l=E,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$zi,this),this._globalGraph=E?w?._globalGraph??new C.$jr(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,T.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,T.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d,f){this.m();const w=this,E=new class extends h{dispose(){w.h.delete(E),super.dispose()}}(d,this.j,this,this.l);return this.h.add(E),f?.add(E),E}invokeFunction(d,...f){this.m();const w=l.traceInvocation(this.l,d);let E=!1;try{return d({get:b=>{if(E)throw(0,a.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(b,w);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...f)}finally{E=!0,w.stop()}}createInstance(d,...f){this.m();let w,E;return d instanceof O.$xi?(w=l.traceCreation(this.l,d.ctor),E=this.o(d.ctor,d.staticArguments.concat(f),w)):(w=l.traceCreation(this.l,d),E=this.o(d,f,w)),w.stop(),E}o(d,f=[],w){const E=A._util.getServiceDependencies(d).sort((t,s)=>t.index-s.index),u=[];for(const t of E){const s=this.s(t.id,w);s||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(s)}const b=E.length>0?E[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${d.name} at position ${b+1} conflicts with ${f.length} static arguments`);const t=b-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,b)}return Reflect.construct(d,f.concat(u))}q(d,f){if(this.i.get(d)instanceof O.$xi)this.i.set(d,f);else if(this.k)this.k.q(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const f=this.i.get(d);return!f&&this.k?this.k.r(d):f}s(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const w=this.r(d);return w instanceof O.$xi?this.u(d,w,f.branch(d,!0)):(f.branch(d,!1),w)}u(d,f,w){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,f,w)}finally{this.t.delete(d)}}v(d,f,w){const E=new C.$jr(t=>t.id.toString());let u=0;const b=[{id:d,desc:f,_trace:w}];for(;b.length;){const t=b.pop();if(E.lookupOrInsertNode(t),u++>1e3)throw new $(E);for(const s of A._util.getServiceDependencies(t.desc.ctor)){const o=this.r(s.id);if(o||this.y(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),o instanceof O.$xi){const i={id:s.id,desc:o,_trace:t._trace.branch(s.id,!0)};E.insertEdge(t,i),b.push(i)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new $(E);break}for(const{data:s}of t){if(this.r(s.id)instanceof O.$xi){const i=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,i)}E.removeNode(s)}}return this.r(d)}w(d,f,w=[],E,u){if(this.i.get(d)instanceof O.$xi)return this.x(d,f,w,E,u,this.g);if(this.k)return this.k.w(d,f,w,E,u);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(d,f,w=[],E,u,b){if(E){const t=new h(void 0,this.j,this,this.l);t.c=String(d);const s=new Map,o=new k.$Th(()=>{const i=t.o(f,w,u);for(const[n,r]of s){const c=i[n];if(typeof c=="function")for(const m of r)m.disposable=c.apply(i,m.listener)}return s.clear(),b.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let m=s.get(n);return m||(m=new y.$5c,s.set(n,m)),(P,R,I)=>{if(o.isInitialized)return o.value[n](P,R,I);{const N={listener:[P,R,I],disposable:void 0},U=m.push(N);return(0,T.$Sc)(()=>{U(),N.disposable?.dispose()})}}}if(n in i)return i[n];const r=o.value;let c=r[n];return typeof c!="function"||(c=c.bind(r),i[n]=c),c},set(i,n,r){return o.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else{const t=this.o(f,w,u);return b.add(t),t}}y(d,f){if(f&&console.warn(d),this.j)throw new Error(d)}}e.$kr=h;var p;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(p||(p={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(d,f){return d?new l(p.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(d,f){return d?new l(p.Creation,f.name):l.c}static{this.f=0}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const w=new l(p.Branch,d.toString());return this.h.push([d,f,w]),w}stop(){const d=Date.now()-this.g;l.f+=d;let f=!1;function w(u,b){const t=[],s=new Array(u+1).join("	");for(const[o,i,n]of b.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${o}`);const r=w(u+1,n);r&&t.push(r)}else t.push(`${s}uses -> ${o}`);return t.join(`
`)}const E=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(d>2||f)&&l.all.add(E.join(`
`))}}e.$lr=l}),define(le[57],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0,e.$afc=(0,k.$Ai)("mainProcessService");class a{constructor(O,C){this.a=O,this.b=C}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,C){this.a.registerChannel(O,C)}}e.$bfc=a}),define(le[10],he([0,1,174,40,3,55,2,35,5,21,13,9,97,4]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=g,e.log=f,e.$ik=c,e.$jk=m,e.$kk=v,e.$lk=P,e.$7j=(0,p.$Ai)("logService"),e.$8j=(0,p.$Ai)("loggerService");function l(){return new Date().toISOString()}function g(R){return(0,S.$eg)(R)}var d;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$0j=d.Info;function f(R,I,N){switch(I){case d.Trace:R.trace(N);break;case d.Debug:R.debug(N);break;case d.Info:R.info(N);break;case d.Warning:R.warn(N);break;case d.Error:R.error(N);break;case d.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function w(R,I=!1){let N="";for(let U=0;U<R.length;U++){let j=R[U];if(j instanceof Error&&(j=(0,a.$lj)(j,I)),typeof j=="object")try{j=JSON.stringify(j)}catch{}N+=(U>0?" ":"")+j}return N}class E extends C.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new T.$he),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==d.Off&&this.b<=I}}e.$_j=E;class u extends E{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...N){this.f(d.Trace)&&this.g(d.Trace,w([I,...N],!0))}debug(I,...N){this.f(d.Debug)&&this.g(d.Debug,w([I,...N]))}info(I,...N){this.f(d.Info)&&this.g(d.Info,w([I,...N]))}warn(I,...N){this.f(d.Warning)&&this.g(d.Warning,w([I,...N]))}error(I,...N){if(this.f(d.Error))if(I instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=I.stack,this.g(d.Error,w(U))}else this.g(d.Error,w([I,...N]))}flush(){}}e.$ak=u;class b extends E{constructor(I=e.$0j){super(),this.setLevel(I),this.g=!L.$i}trace(I,...N){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,I,...N):console.log(`[main ${l()}]`,I,...N))}debug(I,...N){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,I,...N):console.log(`[main ${l()}]`,I,...N))}info(I,...N){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,I,...N):console.log(`[main ${l()}]`,I,...N))}warn(I,...N){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,I,...N):console.warn(`[main ${l()}]`,I,...N))}error(I,...N){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,I,...N):console.error(`[main ${l()}]`,I,...N))}flush(){}}e.$bk=b;class t extends E{constructor(I=e.$0j,N=!0){super(),this.g=N,this.setLevel(I)}trace(I,...N){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...N):console.log(I,...N))}debug(I,...N){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...N):console.log(I,...N))}info(I,...N){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...N):console.log(I,...N))}warn(I,...N){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...N):console.log(I,...N))}error(I,...N){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...N):console.error(I,...N))}flush(){}}e.$ck=t;class s extends E{constructor(I,N=e.$0j){super(),this.g=I,this.setLevel(N)}trace(I,...N){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(I),...N])}debug(I,...N){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(I),...N])}info(I,...N){this.f(d.Info)&&this.g.log(d.Info,[this.h(I),...N])}warn(I,...N){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(I),...N])}error(I,...N){this.f(d.Error)&&this.g.log(d.Error,[this.h(I),...N])}h(I){return typeof I=="string"?I:(0,a.$lj)(I,this.f(d.Trace))}flush(){}}e.$dk=s;class o extends E{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const N of this.g)N.setLevel(I);super.setLevel(I)}trace(I,...N){for(const U of this.g)U.trace(I,...N)}debug(I,...N){for(const U of this.g)U.debug(I,...N)}info(I,...N){for(const U of this.g)U.info(I,...N)}warn(I,...N){for(const U of this.g)U.warn(I,...N)}error(I,...N){for(const U of this.g)U.error(I,...N)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ek=o;class i extends C.$Uc{constructor(I,N,U){if(super(),this.h=I,this.j=N,this.b=new A.$Ac,this.c=this.B(new T.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$he),this.onDidChangeVisibility=this.g.event,U)for(const j of U)this.b.set(j.resource,{logger:void 0,info:j})}m(I){return(0,S.$ag)(I)?[...this.b.values()].find(N=>N.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,N){const U=this.n(I),j=(0,S.$ag)(I)?I:N?.id??(0,O.$oj)(U.toString()).toString(16);let F=this.b.get(U)?.logger;const X=N?.logLevel==="always"?d.Trace:N?.logLevel;F||(F=this.s(U,X??this.getLogLevel(U)??this.h,{...N,id:j}));const K={logger:F,info:{resource:U,id:j,logLevel:X,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(K.info),this.b.set(U,K),F}n(I){return(0,S.$ag)(I)?(0,y.$bh)(this.j,`${I}.log`):I}setLogLevel(I,N){if($.URI.isUri(I)){const U=I,j=N,F=this.b.get(U);F&&j!==F.info.logLevel&&(F.info.logLevel=j===this.h?void 0:j,F.logger?.setLevel(j),this.b.set(F.info.resource,F),this.f.fire([U,j]))}else{this.h=I;for(const[U,j]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,N){const U=this.m(I);U&&N!==!U.info.hidden&&(U.info.hidden=!N,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,N]))}getLogLevel(I){let N;return I&&(N=this.b.get(I)?.info.logLevel),N??this.h}registerLogger(I){const N=this.b.get(I.resource);N?N.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const N=this.b.get(I);N&&(N.logger&&N.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=i;class n{constructor(){this.onDidChangeLogLevel=new T.$he().event}setLevel(I){}getLevel(){return d.Info}trace(I,...N){}debug(I,...N){}info(I,...N){}warn(I,...N){}error(I,...N){}critical(I,...N){}dispose(){}flush(){}}e.$gk=n;class r extends n{}e.$hk=r;function c(R){if(R.verbose)return d.Trace;if(typeof R.logLevel=="string"){const I=P(R.logLevel.toLowerCase());if(I!==void 0)return I}return e.$0j}function m(R){switch(R){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function v(R){switch(R){case d.Trace:return{original:"Trace",value:k.localize(0,null)};case d.Debug:return{original:"Debug",value:k.localize(1,null)};case d.Info:return{original:"Info",value:k.localize(2,null)};case d.Warning:return{original:"Warning",value:k.localize(3,null)};case d.Error:return{original:"Error",value:k.localize(4,null)};case d.Off:return{original:"Off",value:k.localize(5,null)}}}function P(R){switch(R){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$mk=new h.$Rj("logLevel",m(d.Info))}),define(le[207],he([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;let $=class extends T.$Uc{constructor(p,l){super(),this.a=p,this.b=l,this.B(new k.$Mh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const p=(0,A.$$g)(this.a.logsHome),l=(0,A.$ah)(this.a.logsHome.with({scheme:O.Schemas.file})).fsPath,f=(await L.Promises.readdir(l)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==p),w=f.slice(0,Math.max(0,f.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(E=>L.Promises.rm((0,C.$jc)(l,E)))))}catch(p){(0,a.$1)(p)}}};e.$ufc=$,e.$ufc=$=ve([Z(0,y.$Hi),Z(1,S.$7j)],$)}),define(le[208],he([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class $ extends A.$Uc{constructor(p,l){super(),this.a=p,this.b=l,this.c=this.B(new O.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$yh(0)),this.w=[],this.y=this.B(new a.$yh(0))}watch(p,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(p,l):this.z(p,l)}n(p,l){const g={path:this.J(p),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},d=(0,k.$Tb)(this.j,g);return this.r(),(0,A.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,T.$1)(p))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,y.$Wq)(l)),l=>this.G(l),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const l of this.j)(0,y.$Sq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const l of this.j)(0,y.$Sq)(l)&&p.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,l){const g={path:this.J(p),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},d=(0,k.$Tb)(this.w,g);return this.C(),(0,A.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,T.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,y.$Wq)(p)),p=>this.G(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,L.$hc)(p.fsPath)}J(p){const l=this.I(p);return(0,C.$Cg)(l)}}e.$3q=$}),define(le[209],he([0,1,19,6,15,26,3,55,62,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let b=class extends y.$Uc{static{u=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new C.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$he),this.Y=this.B(new C.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Jh)}registerProvider(s,o){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const i=new y.$Tc;return this.h.set(s,o),this.c.fire({added:!0,scheme:s,provider:o}),i.add(o.onDidChangeFile(n=>{const r=new d.$nl(n,!this.S(o));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:s}))),(0,y.$Sc)(()=>{this.c.fire({added:!1,scheme:s,provider:o}),this.h.delete(s),(0,y.$Pc)(i)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const o=[];this.f.fire({scheme:s,join(i){o.push(i)}}),!this.h.has(s)&&await a.Promises.settled(o)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,o){const i=this.h.get(s.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return L.Iterable.map(this.h,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async j(s){if(!(0,p.$fh)(s))throw new d.$pl((0,g.localize)(0,null,this.sb(s)),d.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const o=this.h.get(s.scheme);if(!o){const i=new E.$bb;throw i.message=(0,g.localize)(1,null,s.toString()),i}return o}async m(s){const o=await this.j(s);if((0,d.$al)(o)||(0,d.$0k)(o)||(0,d.$bl)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const o=await this.j(s);if((0,d.$al)(o)||(0,d.$0k)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.s(s,o)}catch(i){throw(0,d.$kl)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$pl((0,g.localize)(2,null,this.sb(s)),d.FileOperationResult.FILE_NOT_FOUND):(0,d.$il)(i)}}async s(s,o){const i=await this.j(s),n=this.S(i),r=o?.resolveTo,c=o?.resolveSingleChildDescendants,m=o?.resolveMetadata,v=await i.stat(s);let P;return this.t(i,s,v,void 0,!!m,(R,I)=>(P||(P=S.$Gi.forUris(()=>!n),P.set(s,!0),r&&P.fill(!0,r)),P.get(R.resource)||P.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?I===1:!1))}async t(s,o,i,n,r,c){const{providerExtUri:m}=this.R(s),v={resource:o,name:m.basename(o),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(s.capabilities&d.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Al)({mtime:i.mtime,size:i.size}),children:void 0};if(v.isDirectory&&c(v,n)){try{const P=await s.readdir(o),R=await a.Promises.settled(P.map(async([I,N])=>{try{const U=m.joinPath(o,I),j=r?await s.stat(U):{type:N};return await this.t(s,U,j,P.length,r,c)}catch(U){return this.b.trace(U),null}}));v.children=(0,k.$Hb)(R)}catch(P){this.b.trace(P),v.children=[]}return v}return v}async resolveAll(s){return a.Promises.settled(s.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const o=await this.j(s),i=await o.stat(s);return this.t(o,s,i,void 0,!0,()=>!1)}async exists(s){const o=await this.j(s);try{return!!await o.stat(s)}catch{return!1}}async canCreateFile(s,o){try{await this.u(s,o)}catch(i){return i}return!0}async u(s,o){if(!o?.overwrite&&await this.exists(s))throw new d.$pl((0,g.localize)(3,null,this.sb(s)),d.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(s,o=T.$Je.fromString(""),i){await this.u(s,i);const n=await this.writeFile(s,o);return this.r.fire(new d.$ml(s,d.FileOperation.CREATE,n)),n}async writeFile(s,o,i){const n=this.qb(await this.n(s),s),{providerExtUri:r}=this.R(n);let c=i;if((0,d.$dl)(n)&&!c?.atomic){const m=n.enforceAtomicWriteFile?.(s);m&&(c={...i,atomic:m})}try{await this.w(n,s,c)||await this.U(n,r.dirname(s));let v;if((0,d.$0k)(n)&&!(o instanceof T.$Je))if((0,l.$ve)(o)){const P=await(0,l.$Ce)(o,3);P.ended?v=T.$Je.concat(P.buffer):v=P}else v=(0,l.$ze)(o,P=>T.$Je.concat(P),3);else v=o;!(0,d.$al)(n)||(0,d.$0k)(n)&&v instanceof T.$Je||(0,d.$0k)(n)&&(0,d.$dl)(n)&&c?.atomic?await this.hb(n,s,c,v):await this.db(n,s,c,v instanceof T.$Je?(0,T.$Ue)(v):v),this.r.fire(new d.$ml(s,d.FileOperation.WRITE))}catch(m){throw new d.$pl((0,g.localize)(4,null,this.sb(s),(0,d.$il)(m).toString()),(0,d.$ll)(m),c)}return this.resolve(s,{resolveMetadata:!0})}async w(s,o,i){const n=!!i?.unlock;if(n&&!(s.capabilities&d.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(5,null,this.sb(o)));if(!!i?.atomic){if(!(s.capabilities&d.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(6,null,this.sb(o)));if(!(s.capabilities&d.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(7,null,this.sb(o)));if(n)throw new Error((0,g.localize)(8,null,this.sb(o)))}let c;try{c=await s.stat(o)}catch{return}if(c.type&d.FileType.Directory)throw new d.$pl((0,g.localize)(9,null,this.sb(o)),d.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(o,c),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$zl&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==(0,d.$Al)({mtime:i.mtime,size:c.size}))throw new d.$pl((0,g.localize)(10,null),d.FileOperationResult.FILE_MODIFIED_SINCE,i);return c}async readFile(s,o,i){const n=await this.m(s);return o?.atomic?this.z(n,s,o,i):this.C(n,s,o,i)}async z(s,o,i,n){return new Promise((r,c)=>{this.cb.queueFor(o,async()=>{try{const m=await this.C(s,o,i,n);r(m)}catch(m){c(m)}},this.R(s).providerExtUri)})}async C(s,o,i,n){const r=await this.D(s,o,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,T.$Ve)(r.value)}}async readFileStream(s,o,i){const n=await this.m(s);return this.D(n,s,o,i)}async D(s,o,i,n){const r=new O.$se(n);let c=i;(0,d.$cl)(s)&&s.enforceAtomicReadFile?.(o)&&(c={...i,atomic:!0});const m=this.J(o,c).then(P=>P,P=>{throw r.dispose(!0),P});let v;try{return typeof c?.etag=="string"&&c.etag!==d.$zl&&await m,c?.atomic&&(0,d.$cl)(s)||!((0,d.$al)(s)||(0,d.$bl)(s))||(0,d.$0k)(s)&&c?.preferUnbuffered?v=this.I(s,o,c):(0,d.$bl)(s)?v=this.G(s,o,r.token,c):v=this.H(s,o,r.token,c),v.on("end",()=>r.dispose()),v.on("error",()=>r.dispose()),{...await m,value:v}}catch(P){throw v&&await(0,l.$Ae)(v),this.F(P,o,c)}}F(s,o,i){const n=(0,g.localize)(11,null,this.sb(o),(0,d.$il)(s).toString());return s instanceof d.$rl?new d.$rl(n,s.stat,i):s instanceof d.$ql?new d.$ql(n,s.fileOperationResult,s.size,s.options):new d.$pl(n,(0,d.$ll)(s),i)}G(s,o,i,n=Object.create(null)){const r=s.readFileStream(o,n,i);return(0,l.$Ge)(r,{data:c=>c instanceof T.$Je?c:T.$Je.wrap(c),error:c=>this.F(c,o,n)},c=>T.$Je.concat(c))}H(s,o,i,n=Object.create(null)){const r=(0,T.$Ze)();return(0,f.$Pq)(s,o,r,c=>c,{...n,bufferSize:this.a,errorTransformer:c=>this.F(c,o,n)},i),r}I(s,o,i){const n=(0,l.$xe)(r=>T.$Je.concat(r));return(async()=>{try{let r;i?.atomic&&(0,d.$cl)(s)?r=await s.readFile(o,{atomic:!0}):r=await s.readFile(o),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(o,r.byteLength,i),n.end(T.$Je.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(s,o){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new d.$pl((0,g.localize)(12,null,this.sb(s)),d.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==d.$zl&&o.etag===i.etag)throw new d.$rl((0,g.localize)(13,null),i,o);return this.L(s,i.size,o),i}L(s,o,i){if(typeof i?.limits?.size=="number"&&o>i.limits.size)throw new d.$ql((0,g.localize)(14,null,this.sb(s)),d.FileOperationResult.FILE_TOO_LARGE,o,i)}async canMove(s,o,i){return this.M(s,o,"move",i)}async canCopy(s,o,i){return this.M(s,o,"copy",i)}async M(s,o,i,n){if(s.toString()!==o.toString())try{const r=i==="move"?this.qb(await this.n(s),s):await this.m(s),c=this.qb(await this.n(o),o);await this.Q(r,s,c,o,i,n)}catch(r){return r}return!0}async move(s,o,i){const n=this.qb(await this.n(s),s),r=this.qb(await this.n(o),o),c=await this.N(n,s,r,o,"move",!!i),m=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$ml(s,c==="move"?d.FileOperation.MOVE:d.FileOperation.COPY,m)),m}async copy(s,o,i){const n=await this.m(s),r=this.qb(await this.n(o),o),c=await this.N(n,s,r,o,"copy",!!i),m=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$ml(s,c==="copy"?d.FileOperation.COPY:d.FileOperation.MOVE,m)),m}async N(s,o,i,n,r,c){if(o.toString()===n.toString())return r;const{exists:m,isSameResourceWithDifferentPathCase:v}=await this.Q(s,o,i,n,r,c);if(m&&!v&&c&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(s===i&&(0,d.$$k)(s))await s.copy(o,n,{overwrite:c});else{const P=await this.resolve(o);P.isDirectory?await this.P(s,P,i,n):await this.O(s,o,i,n)}return r}else return s===i?(await s.rename(o,n,{overwrite:c}),r):(await this.N(s,o,i,n,"copy",c),await this.del(o,{recursive:!0}),"copy")}async O(s,o,i,n){if((0,d.$al)(s)&&(0,d.$al)(i))return this.jb(s,o,i,n);if((0,d.$al)(s)&&(0,d.$0k)(i))return this.pb(s,o,i,n);if((0,d.$0k)(s)&&(0,d.$al)(i))return this.nb(s,o,i,n);if((0,d.$0k)(s)&&(0,d.$0k)(i))return this.lb(s,o,i,n)}async P(s,o,i,n){await i.mkdir(n),Array.isArray(o.children)&&await a.Promises.settled(o.children.map(async r=>{const c=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(s,await this.resolve(r.resource),i,c):this.O(s,r.resource,i,c)}))}async Q(s,o,i,n,r,c){let m=!1;if(s===i){const{providerExtUri:P,isPathCaseSensitive:R}=this.R(s);if(R||(m=P.isEqual(o,n)),m&&r==="copy")throw new Error((0,g.localize)(15,null,this.sb(o),this.sb(n)));if(!m&&P.isEqualOrParent(n,o))throw new Error((0,g.localize)(16,null,this.sb(o),this.sb(n)))}const v=await this.exists(n);if(v&&!m){if(!c)throw new d.$pl((0,g.localize)(17,null,this.sb(o),this.sb(n)),d.FileOperationResult.FILE_MOVE_CONFLICT);if(s===i){const{providerExtUri:P}=this.R(s);if(P.isEqualOrParent(o,n))throw new Error((0,g.localize)(18,null,this.sb(o),this.sb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:m}}R(s){const o=this.S(s);return{providerExtUri:o?p.$4g:p.$6g,isPathCaseSensitive:o}}S(s){return!!(s.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const o=this.qb(await this.j(s),s);await this.U(o,s);const i=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new d.$ml(s,d.FileOperation.CREATE,i)),i}async U(s,o){const i=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await s.stat(o)).type&d.FileType.Directory))throw new Error((0,g.localize)(19,null,this.sb(o)));break}catch(r){if((0,d.$kl)(r)!==d.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(o)),o=n.dirname(o)}for(let r=i.length-1;r>=0;r--){o=n.joinPath(o,i[r]);try{await s.mkdir(o)}catch(c){if((0,d.$kl)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(s,o){try{await this.W(s,o)}catch(i){return i}return!0}async W(s,o){const i=this.qb(await this.j(s),s),n=!!o?.useTrash;if(n&&!(i.capabilities&d.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(20,null,this.sb(s)));const r=o?.atomic;if(r&&!(i.capabilities&d.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(21,null,this.sb(s)));if(n&&r)throw new Error((0,g.localize)(22,null,this.sb(s)));let c;try{c=await i.stat(s)}catch{}if(c)this.rb(s,c);else throw new d.$pl((0,g.localize)(23,null,this.sb(s)),d.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const v=await this.resolve(s);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,g.localize)(24,null,this.sb(s)))}return i}async del(s,o){const i=await this.W(s,o);let n=o;if((0,d.$el)(i)&&!n?.atomic){const v=i.enforceAtomicDelete?.(s);v&&(n={...o,atomic:v})}const r=!!n?.useTrash,c=!!n?.recursive,m=n?.atomic??!1;await i.delete(s,{recursive:c,useTrash:r,atomic:m}),this.r.fire(new d.$ml(s,d.FileOperation.DELETE))}async cloneFile(s,o){const i=await this.j(s),n=this.qb(await this.n(o),o);if(!(i===n&&this.R(i).providerExtUri.isEqual(s,o)))return i===n&&(0,d.$_k)(i)?i.cloneFile(s,o):(await this.U(n,this.R(n).providerExtUri.dirname(o)),i===n&&(0,d.$$k)(i)?this.cb.queueFor(s,()=>i.copy(s,o,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(s,()=>this.O(i,s,n,o),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(s,o){return this.watch(s,{...o,correlationId:u.ab++})}watch(s,o={recursive:!1,excludes:[]}){const i=new y.$Tc;let n=!1,r=()=>{n=!0};i.add((0,y.$Sc)(()=>r())),(async()=>{try{const m=await this.bb(s,o);n?(0,y.$Pc)(m):r=()=>(0,y.$Pc)(m)}catch(m){this.b.error(m)}})();const c=o.correlationId;if(typeof c=="number"){const m=i.add(new C.$he);return i.add(this.X.event(P=>{P.correlates(c)&&m.fire(P)})),{onDidChange:m.event,dispose:()=>i.dispose()}}return i}async bb(s,o){const i=await this.j(s),n=(0,A.$oj)([this.R(i).providerExtUri.getComparisonKey(s),o]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(s,o)},this.$.set(n,r)),r.count+=1,(0,y.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,y.$Pc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,y.$Pc)(s.disposable);this.$.clear()}async db(s,o,i,n){return this.cb.queueFor(o,async()=>{const r=await s.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,l.$ve)(n)||(0,l.$we)(n)?await this.eb(s,r,n):await this.fb(s,r,n)}catch(c){throw(0,d.$il)(c)}finally{await s.close(r)}},this.R(s).providerExtUri)}async eb(s,o,i){let n=0,r;if((0,l.$we)(i)){if(i.buffer.length>0){const c=T.$Je.concat(i.buffer);await this.gb(s,o,c,c.byteLength,n,0),n+=c.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((c,m)=>{(0,l.$Be)(r,{onData:async v=>{r.pause();try{await this.gb(s,o,v,v.byteLength,n,0)}catch(P){return m(P)}n+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>m(v),onEnd:()=>c()})})}async fb(s,o,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(s,o,r,r.byteLength,n,0),n+=r.byteLength}async gb(s,o,i,n,r,c){let m=0;for(;m<n;){const v=await s.write(o,r+m,i.buffer,c+m,n-m);m+=v}}async hb(s,o,i,n){return this.cb.queueFor(o,()=>this.ib(s,o,i,n),this.R(s).providerExtUri)}async ib(s,o,i,n){let r;n instanceof T.$Je?r=n:(0,l.$ve)(n)?r=await(0,T.$Ve)(n):(0,l.$we)(n)?r=await(0,T.$We)(n):r=(0,T.$Te)(n),await s.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(s,o,i,n){return this.cb.queueFor(n,()=>this.kb(s,o,i,n),this.R(i).providerExtUri)}async kb(s,o,i,n){let r,c;try{r=await s.open(o,{create:!1}),c=await i.open(n,{create:!0,unlock:!1});const m=T.$Je.alloc(this.a);let v=0,P=0,R=0;do R=await s.read(r,v,m.buffer,P,m.byteLength-P),await this.gb(i,c,m,R,v,P),v+=R,P+=R,P===m.byteLength&&(P=0);while(R>0)}catch(m){throw(0,d.$il)(m)}finally{await a.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof c=="number"?i.close(c):Promise.resolve()])}}async lb(s,o,i,n){return this.cb.queueFor(n,()=>this.mb(s,o,i,n),this.R(i).providerExtUri)}async mb(s,o,i,n){return i.writeFile(n,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,o,i,n){return this.cb.queueFor(n,()=>this.ob(s,o,i,n),this.R(i).providerExtUri)}async ob(s,o,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const c=await s.readFile(o);await this.gb(i,r,T.$Je.wrap(c),c.byteLength,0,0)}catch(c){throw(0,d.$il)(c)}finally{await i.close(r)}}async pb(s,o,i,n){const r=await(0,T.$Ve)(this.H(s,o,O.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(s,o){if(s.capabilities&d.FileSystemProviderCapabilities.Readonly)throw new d.$pl((0,g.localize)(25,null,this.sb(o)),d.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,o){if((o.permissions??0)&d.FilePermission.Readonly)throw new d.$pl((0,g.localize)(26,null,this.sb(s)),d.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===$.Schemas.file?s.fsPath:s.toString(!0)}};e.$Qq=b,e.$Qq=b=u=ve([Z(0,w.$7j)],b)}),define(le[210],he([0,1,43,280,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,40,205,204]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0,(()=>{try{(0,a.gracefulify)(k)}catch(s){console.error(`Error enabling graceful-fs: ${(0,E.$lj)(s)}`)}})();class t extends w.$3q{static{this.L=!1}constructor(o,i){super(o,i),this.onDidChangeCapabilities=A.Event.None,this.P=new O.$Ac(n=>h.$5g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,$.$k&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:i,symbolicLink:n}=await l.SymlinkSupport.stat(this.I(o));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await l.Promises.readdir(this.I(o),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,h.$bh)(o,r.name))).type:c=this.O(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(i){throw this.hb(i)}}O(o,i){let n;return i?.dangling?n=d.FileType.Unknown:o.isFile()?n=d.FileType.File:o.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async Q(o){const i=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new T.$zh;return this.P.set(o,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,y.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(o)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(o,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),n=await this.Q(o));const r=this.I(o);return await l.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(o){t.L&&this.a.trace(o)}readFileStream(o,i,n){const r=(0,p.$xe)(c=>C.$Je.concat(c.map(m=>C.$Je.wrap(m))).buffer);return(0,f.$Pq)(this,o,r,c=>c.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(o,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(o)?this.U(o,(0,h.$bh)((0,h.$ah)(o),`${(0,h.$$g)(o)}${n.atomic.postfix}`),i,n):this.W(o,i,n)}async S(o){try{const i=this.I(o),{symbolicLink:n}=await l.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(o,i,n,r){const c=new y.$Tc;try{c.add(await this.Q(o)),c.add(await this.Q(i)),await this.W(i,n,r,!0);try{await this.rename(i,o,{overwrite:!0})}catch(m){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw m}}finally{c.dispose()}}async W(o,i,n,r){let c;try{const m=this.I(o);if(!n.create||!n.overwrite){if(await l.Promises.exists(m)){if(!n.overwrite)throw(0,d.$hl)((0,g.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$hl)((0,g.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(o,{create:!0,unlock:n.unlock},r),await this.write(c,0,i,0,i.byteLength)}catch(m){throw await this.ib(o,m)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(o){t.$=o}async open(o,i,n){const r=this.I(o);let c;(0,d.$8k)(i)&&!n&&(c=await this.Q(o));let m;try{if((0,d.$8k)(i)&&i.unlock)try{const{stat:P}=await l.SymlinkSupport.stat(r);P.mode&128||await l.Promises.chmod(r,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let v;if((0,d.$8k)(i)){if($.$i)try{await l.Promises.truncate(r,0),v="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}v||(v="w")}else v="r";m=await l.Promises.open(r,v)}catch(v){throw c?.dispose(),(0,d.$8k)(i)?await this.ib(o,v):this.hb(v)}if(this.X.set(m,0),(0,d.$8k)(i)&&this.Z.set(m,o),c){const v=this.Y.get(m);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${r})`),this.Y.set(m,c),v&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${r})`),v.dispose())}return m}async close(o){const i=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&t.$)try{await l.Promises.fdatasync(o)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await l.Promises.close(o)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(o)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,n,r,c){const m=this.ab(o,i);let v=null;try{v=(await l.Promises.read(o,n,r,c,m)).bytesRead}catch(P){throw this.hb(P)}finally{this.bb(o,m,v)}return v}ab(o,i){return i===this.X.get(o)?null:i}bb(o,i,n){const r=this.X.get(o);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(o,r+n):this.X.delete(o)))}async write(o,i,n,r,c){return(0,T.$Uh)(()=>this.cb(o,i,n,r,c),100,3)}async cb(o,i,n,r,c){const m=this.ab(o,i);let v=null;try{v=(await l.Promises.write(o,n,r,c,m)).bytesWritten}catch(P){throw await this.ib(this.Z.get(o),P)}finally{this.bb(o,m,v)}return v}async mkdir(o){try{await l.Promises.mkdir(this.I(o))}catch(i){throw this.hb(i)}}async delete(o,i){try{const n=this.I(o);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,S.$jc)((0,S.$mc)(n),`${(0,S.$nc)(n)}${i.atomic.postfix}`)),await l.Promises.rm(n,l.RimRafMode.MOVE,r)}else try{await l.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:m,symbolicLink:v}=await l.SymlinkSupport.stat(n);c=m.isDirectory()&&!v}catch{}if(c)await l.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(o,i,n){const r=this.I(o),c=this.I(i);if(r!==c)try{await this.db(o,i,"move",n.overwrite),await l.Promises.rename(r,c)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(2,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(c)),m.toString()))),this.hb(m)}}async copy(o,i,n){const r=this.I(o),c=this.I(i);if(r!==c)try{await this.db(o,i,"copy",n.overwrite),await l.Promises.copy(r,c,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(3,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(c)),m.toString()))),this.hb(m)}}async db(o,i,n,r){const c=this.I(o),m=this.I(i);let v=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(v=(0,L.$yg)(c,m,!0)),v){if(n==="copy")throw(0,d.$hl)((0,g.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.N(o);if(!R)throw(0,d.$hl)((0,g.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const I=await this.N(i);if(I){if(!r)throw(0,d.$hl)((0,g.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&I.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.eb(o,i,!1)}async eb(o,i,n){const r=this.I(o),c=this.I(i),m=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.$yg)(r,c,!m))return;const v=new y.$Tc;try{v.add(await this.Q(o)),v.add(await this.Q(i)),n&&await l.Promises.mkdir((0,S.$mc)(c),{recursive:!0}),await l.Promises.copyFile(r,c)}catch(P){if(P.code==="ENOENT"&&!n)return this.eb(o,i,!0);throw this.hb(P)}finally{v.dispose()}}t(o,i,n){return new u.$0q(r=>o(r),r=>i(r),n)}F(o,i,n){return new b.$gr(r=>o(r),r=>i(r),n)}hb(o){if(o instanceof d.$gl)return o;let i=o,n;switch(o.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$hl)(i,n)}async ib(o,i){let n=this.hb(i);if(o&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await l.SymlinkSupport.stat(this.I(o));r.mode&128||(n=(0,d.$hl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$hr=t}),define(le[102],he([0,1,3,2,4,10]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,T.$Ai)("sharedProcessLifecycleService");let C=class extends a.$Uc{constructor(L){super(),this.b=L,this.a=this.B(new k.$he),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Ufc=C,e.$Ufc=C=ve([Z(0,O.$7j)],C)}),define(le[211],he([0,1,9,3,10,2]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=void 0;class C extends T.$fk{constructor($,h,p,l,g){super(h,p,l),this.r=$,this.t=g,this.B(g.listen("onDidChangeLogLevel",$)(d=>{(0,T.$9j)(d)?super.setLogLevel(d):super.setLogLevel(k.URI.revive(d[0]),d[1])})),this.B(g.listen("onDidChangeVisibility",$)(([d,f])=>super.setVisibility(k.URI.revive(d),f))),this.B(g.listen("onDidChangeLoggers",$)(({added:d,removed:f})=>{for(const w of d)super.registerLogger({...w,resource:k.URI.revive(w.resource)});for(const w of f)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new T.$dk({log:($,h)=>{this.t.call("consoleLog",[$,h])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,h){super.setLogLevel($,h),this.t.call("setLogLevel",[$,h])}setVisibility($,h){super.setVisibility($,h),this.t.call("setVisibility",[this.n($),h])}s($,h,p){return new A(this.t,$,h,p,this.r)}static setLogLevel($,h,p){return $.call("setLogLevel",[h,p])}}e.$hs=C;class A extends T.$ak{constructor($,h,p,l,g){super(l?.logLevel==="always"),this.r=$,this.s=h,this.m=!1,this.n=[],this.setLevel(p),this.r.call("createLogger",[h,l,g]).then(()=>{this.u(this.n),this.m=!0})}g($,h){const p=[[$,h]];this.m?this.u(p):this.n.push(...p)}u($){this.r.call("log",[this.s,$])}}class L{constructor($,h){this.a=$,this.b=h}listen($,h){const p=this.b($);switch(h){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(g=>this.c(g,p)),removed:[...l.removed].map(g=>this.c(g,p))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[p.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,T.$9j)(l)?l:[p.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${h}`)}async call($,h,p){const l=this.b($);switch(h){case"setLogLevel":return(0,T.$9j)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(k.URI.revive(l.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,l)))}throw new Error(`Call not found: ${h}`)}c($,h){return{...$,resource:h.transformOutgoingURI($.resource)}}}e.$is=L;class y extends O.$Uc{constructor($,h){super(),h.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(p=>h.call("setLogLevel",[p]))),h.call("getRegisteredLoggers").then(p=>{for(const l of p)$.registerLogger({...l,resource:k.URI.revive(l.resource)})}),this.B(h.listen("onDidChangeVisibility")(([p,l])=>$.setVisibility(k.URI.revive(p),l))),this.B(h.listen("onDidChangeLoggers")(({added:p,removed:l})=>{for(const g of p)$.registerLogger({...g,resource:k.URI.revive(g.resource)});for(const g of l)$.deregisterLogger(g.resource)}))}}e.$js=y}),define(le[212],he([0,1,2,10]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;class T extends k.$Uc{constructor(C,A=[]){super(),this.a=new a.$ek([C,...A]),this.B(C.onDidChangeLogLevel(L=>this.setLevel(L)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...A){this.a.trace(C,...A)}debug(C,...A){this.a.debug(C,...A)}info(C,...A){this.a.info(C,...A)}warn(C,...A){this.a.warn(C,...A)}error(C,...A){this.a.error(C,...A)}flush(){this.a.flush()}}e.$lQ=T}),define(le[58],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0,e.$Vdc=(0,k.$Ai)("nativeHostService")}),define(le[213],he([0,1,44,57]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let T=class{constructor(C,A){return this.windowId=C,k.ProxyChannel.toService(A.getChannel("nativeHost"),{context:C,properties:(()=>{const L=new Map;return L.set("windowId",C),L})()})}};e.$dfc=T,e.$dfc=T=ve([Z(1,a.$afc)],T)}),define(le[59],he([0,1,3,62,2,4]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=void 0,e.$lo=(0,O.$Ai)("policy");class C extends T.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const S=Object.keys(this.f).length;return this.f={...y,...this.f},S!==Object.keys(this.f).length&&await this.j(y),a.Iterable.reduce(this.g.entries(),($,[h,p])=>({...$,[h]:p}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(y,[S,$])=>({...y,[S]:{definition:$,value:this.g.get(S)}}),{})}}e.$mo=C;class A{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$no=A}),define(le[214],he([0,1,3,2,59]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0;class O{constructor(L){this.b=L,this.a=new a.$Tc}listen(L,y){switch(y){case"onDidChange":return k.Event.map(this.b.onDidChange,S=>S.reduce(($,h)=>({...$,[h]:this.b.getPolicyValue(h)??null}),{}),this.a)}throw new Error(`Event not found: ${y}`)}call(L,y,S){switch(y){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${y}`)}dispose(){this.a.dispose()}}e.$Gec=O;class C extends T.$mo{constructor(L,y){super(),this.a=y;for(const S in L){const{definition:$,value:h}=L[S];this.f[S]=$,h!==void 0&&this.g.set(S,h)}this.a.listen("onDidChange")(S=>{for(const $ in S){const h=S[$];h===null?this.g.delete($):this.g.set($,h)}this.h.fire(Object.keys(S))})}async j(L){const y=await this.a.call("updatePolicyDefinitions",L);for(const S in y)this.g.set(S,y[S])}}e.$Hec=C}),define(le[103],he([0,1,36]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.context<"u"){const O=T.context.configuration();if(O)a=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,k.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:O.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(le[24],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,k.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(le[215],he([0,1,6,8,2,14,31,10,24]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;let y=class extends T.$Uc{constructor($,h,p){super(),this.b=h,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,$&&this.B(new k.$Mh(()=>{this.f($)},3e4)).schedule()}async f($){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),p=(0,O.$mc)($),l=(0,O.$nc)($),g=await C.Promises.readdir(p);await Promise.all(g.map(async d=>{if(d===l)return;const f=(0,O.$jc)(p,d),w=await C.Promises.stat(f);if(w.isDirectory()&&h-w.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),C.Promises.rm(f)}))}catch(h){(0,a.$1)(h)}}};e.$rfc=y,e.$rfc=y=ve([Z(1,L.$nk),Z(2,A.$7j)],y)}),define(le[216],he([0,1,6,8,2,14,31,16,10,24]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;let S=class extends T.$Uc{constructor(h,p,l){super(),this.b=h,this.c=p,this.f=l,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.$Mh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),p=JSON.parse(await C.Promises.readFile((0,O.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const w of Object.keys(p)){const E=p[w];h[`${E.hash}.${w}`]=!0}const l=(0,O.$jc)(this.b.userDataPath,"clp");if(!await C.Promises.exists(l))return;const d=await C.Promises.readdir(l);for(const w of d){if(h[w]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await C.Promises.rm((0,O.$jc)(l,w))}const f=Date.now();for(const w of Object.keys(h)){const E=(0,O.$jc)(l,w),u=await C.Promises.readdir(E);for(const b of u){if(b==="tcf.json")continue;const t=(0,O.$jc)(E,b),s=await C.Promises.stat(t);s.isDirectory()&&f-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.$jc)(w,b)}`),await C.Promises.rm(t))}}}catch(h){(0,a.$1)(h)}}};e.$sfc=S,e.$sfc=S=ve([Z(0,A.$Ii),Z(1,L.$7j),Z(2,y.$nk)],S)}),define(le[217],he([0,1,14,4]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$zG=void 0,e.$zG=(0,a.$Ai)("IV8InspectProfilingService");var T;(function(O){function C(L){return!!(L.samples&&L.timeDeltas)}O.isValidProfile=C;function A(L,y="noAbsolutePaths"){for(const S of L.nodes)S.callFrame&&S.callFrame.url&&((0,k.$ic)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,k.$jc)(y,(0,k.$nc)(S.callFrame.url)));return L}O.rewriteAbsolutePaths=A})(T||(e.Utils=T={}))}),define(le[218],he([0,1,32]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class a{constructor(){this.a=new Map}async startProfiling(O){const A=await(await new Promise((y,S)=>{ne(["v8-inspect-profiler"],y,S)})).startProfiling({host:O.host,port:O.port,checkForPaused:!0}),L=(0,k.$Wg)();return this.a.set(L,A),L}async stopProfiling(O){const C=this.a.get(O);if(!C)throw new Error(`UNKNOWN session '${O}'`);const A=await C.stop();return this.a.delete(O),A.profile}}e.$Jfc=a}),define(le[45],he([0,1,132,13]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class T{constructor(){this.a=new Map}add(C,A){k.ok(a.$ag(C)),k.ok(a.$cg(A)),k.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$jo=new T}),define(le[104],he([0,1,3,45]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class O{constructor(){this.b=new k.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(L,y){this.a[T(L)]=y,this.b.fire(L)}notifySchemaChanged(L){this.b.fire(L)}getSchemaContributions(){return{schemas:this.a}}}const C=new O;a.$jo.add(e.$ko.JSONContribution,C)}),define(le[48],he([0,1,19,3,13,159,22,104,45]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=g,e.$Ao=d,e.$Bo=f,e.$Co=E,e.$Do=u;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$oo={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const $=L.$jo.as(A.$ko.JSONContribution);class h{constructor(){this.h=new Set,this.i=new a.$he,this.onDidSchemaChange=this.i.event,this.j=new a.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},$.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const o=new Set;this.n(t,s,o),$.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const s=new Set;this.o(t,s),$.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const o=new Set;this.o(s,o),this.n(t,!1,o),$.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const o=[];for(const{overrides:i,source:n}of t)for(const r in i)if(s.add(r),e.$yo.test(r)){const c=this.a.get(r),m=c?.valuesSources??new Map;if(n)for(const I of Object.keys(i[r]))m.set(I,n);const v={...c?.value||{},...i[r]};this.a.set(r,{source:n,value:v,valuesSources:m});const P=(0,C.$ej)(r),R={type:"object",default:v,description:O.localize(1,null,P),$ref:e.$vo,defaultDefaultValue:v,source:T.$ag(n)?void 0:n,defaultValueSource:n};o.push(...g(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:i[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(o)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:o,source:i}of t)for(const n in o){const r=this.a.get(n),c=T.$ag(i)?i:i?.id,m=T.$ag(r?.source)?r?.source:r?.source?.id;if(c===m)if(s.add(n),this.a.delete(n),e.$yo.test(n))delete this.d[n],delete this.b.properties[n];else{const v=this.d[n];v&&(this.w(n,v),this.r(n,v))}}this.u()}deltaConfiguration(t){let s=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,o){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,s){const o=i=>{if(i.properties)for(const n in i.properties){s.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>o(n))};for(const i of t){o(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,o,i,n=S.WINDOW,r){n=T.$jg(t.scope)?n:t.scope;const c=t.properties;if(c)for(const v in c){const P=c[v];if(s&&E(v,P)){delete c[v];continue}if(P.source=o,P.defaultDefaultValue=c[v].default,this.w(v,P),e.$yo.test(v)?P.scope=void 0:(P.scope=T.$jg(P.scope)?n:P.scope,P.restricted=T.$jg(P.restricted)?!!i?.includes(v):P.restricted),c[v].hasOwnProperty("included")&&!c[v].included){this.f[v]=c[v],delete c[v];continue}else this.d[v]=c[v],c[v].policy?.name&&this.e.set(c[v].policy.name,v);!c[v].deprecationMessage&&c[v].markdownDeprecationMessage&&(c[v].deprecationMessage=c[v].markdownDeprecationMessage),r.add(v)}const m=t.allOf;if(m)for(const v of m)this.p(v,s,o,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=o=>{const i=o.properties;if(i)for(const r in i)this.r(r,i[r]);o.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$po.properties[t]=s,s.scope){case S.APPLICATION:e.$qo.properties[t]=s;break;case S.MACHINE:e.$ro.properties[t]=s;break;case S.MACHINE_OVERRIDABLE:e.$so.properties[t]=s;break;case S.WINDOW:e.$to.properties[t]=s;break;case S.RESOURCE:e.$uo.properties[t]=s;break;case S.LANGUAGE_OVERRIDABLE:e.$uo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$po.properties[t],s.scope){case S.APPLICATION:delete e.$qo.properties[t];break;case S.MACHINE:delete e.$ro.properties[t];break;case S.MACHINE_OVERRIDABLE:delete e.$so.properties[t];break;case S.WINDOW:delete e.$to.properties[t];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,o={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$vo};this.w(s,o),e.$po.properties[s]=o,e.$qo.properties[s]=o,e.$ro.properties[s]=o,e.$so.properties[s]=o,e.$to.properties[s]=o,e.$uo.properties[s]=o}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=t,e.$qo.patternProperties[e.$xo]=t,e.$ro.patternProperties[e.$xo]=t,e.$so.patternProperties[e.$xo]=t,e.$to.patternProperties[e.$xo]=t,e.$uo.patternProperties[e.$xo]=t,this.i.fire()}w(t,s){const o=this.a.get(t);let i=o?.value,n=o?.source;T.$hg(i)&&(i=s.defaultDefaultValue,n=void 0),T.$hg(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const p="\\[([^\\]]+)\\]",l=new RegExp(p,"g");e.$xo=`^(${p})+$`,e.$yo=new RegExp(e.$xo);function g(b){const t=[];if(e.$yo.test(b)){let s=l.exec(b);for(;s?.length;){const o=s[1].trim();o&&t.push(o),s=l.exec(b)}}return(0,k.$Mb)(t)}function d(b){return b.reduce((t,s)=>`${t}[${s}]`,"")}function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new h;L.$jo.add(e.$oo.Configuration,w);function E(b,t){return b.trim()?e.$yo.test(b)?O.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?O.localize(8,null,b):t.policy?.name&&w.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,b,t.policy?.name,w.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function u(){const b=[],t=w.getConfigurationProperties();for(const s of Object.keys(t))b.push([s,t[s].scope]);return b.push(["launch",S.RESOURCE]),b.push(["task",S.RESOURCE]),b}}),define(le[78],he([0,1,19,3,34,2,35,30,13,9,22,48,7,45]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=u;function l(o){return Object.isFrozen(o)?o:A.$0n(o)}class g{static createEmptyModel(i){return new g({},[],[],void 0,i)}constructor(i,n,r,c,m){this.b=i,this.c=n,this.d=r,this.raw=c,this.f=m,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof g)return n;const r=new d("",this.f);return r.parseRaw(n),r.configurationModel});this.g=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$cj)(this.contents,i):this.contents}inspect(i,n){const r=this;return{get value(){return l(r.rawConfiguration.getValue(i))},get override(){return n?l(r.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return l(n?r.rawConfiguration.override(n).getValue(i):r.rawConfiguration.getValue(i))},get overrides(){const c=[];for(const{contents:m,identifiers:v,keys:P}of r.rawConfiguration.overrides){const R=new g(m,P,[],void 0,r.f).getValue(i);R!==void 0&&c.push({identifiers:v,value:R})}return c.length?l(c):void 0}}}getOverrideValue(i,n){const r=this.j(n);return r?i?(0,S.$cj)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return k.$Mb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return k.$Mb(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=A.$9n(this.contents),r=A.$9n(this.overrides),c=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const v of i)if(m.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(n,v.contents);for(const P of v.overrides){const[R]=r.filter(I=>k.$ub(I.identifiers,P.identifiers));R?(this.i(R.contents,P.contents),R.keys.push(...P.keys),R.keys=k.$Mb(R.keys)):r.push(A.$9n(P))}for(const P of v.keys)c.indexOf(P)===-1&&c.push(P)}return new g(n,c,r,m.every(v=>v instanceof g)?void 0:m,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const c of k.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let m=this.contents[c];const v=n[c];v&&(typeof m=="object"&&typeof v=="object"?(m=A.$9n(m),this.i(m,v)):m=v),r[c]=m}return new g(r,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const r of Object.keys(n)){if(r in i&&L.$cg(i[r])&&L.$cg(n[r])){this.i(i[r],n[r]);continue}i[r]=A.$9n(n[r])}}j(i){let n=null,r=null;const c=m=>{m&&(r?this.i(r,m):r=A.$9n(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===i?n=m.contents:m.identifiers.includes(i)&&c(m.contents);return c(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$bj)(this.contents,i),$.$yo.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>k.$ub(r.identifiers,(0,$.$zo)(i))),1))}k(i,n,r){(0,S.$aj)(this.contents,i,n,c=>this.f.error(c)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),$.$yo.test(i)&&this.overrides.push({identifiers:(0,$.$zo)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$_i)(this.contents[i],c=>this.f.error(c))})}}e.$Eo=g;class d{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!L.$jg(i)){const r=this.h(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:c,overrides:m,restricted:v,hasExcludedProperties:P}=this.i(i,n);this.b=new g(r,c,m,P?[i]:void 0,this.g),this.c=v||[]}h(i){let n={},r=null,c=[];const m=[],v=[];function P(I){Array.isArray(c)?c.push(I):r!==null&&(c[r]=I)}const R={onObjectBegin:()=>{const I={};P(I),m.push(c),c=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const I=[];P(I),m.push(c),c=I,r=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:P,onError:(I,N,U)=>{v.push({error:I,offset:N,length:U})}};if(i)try{T.$Wn(i,R),n=c[0]||{}}catch(I){this.g.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return n}i(i,n){const r=p.$jo.as($.$oo.Configuration).getConfigurationProperties(),c=this.j(i,r,!0,n);i=c.raw;const m=(0,S.$_i)(i,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`)),v=Object.keys(i),P=this.l(i,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:m,keys:v,overrides:P,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(i,n,r,c){let m=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:m};const v={},P=[];for(const R in i)if($.$yo.test(R)&&r){const I=this.j(i[R],n,!1,c);v[R]=I.raw,m=m||I.hasExcludedProperties,P.push(...I.restricted)}else{const I=n[R],N=I?typeof I.scope<"u"?I.scope:$.ConfigurationScope.WINDOW:void 0;I?.restricted&&P.push(R),!c.exclude?.includes(R)&&(c.include?.includes(R)||(N===void 0||c.scopes===void 0||c.scopes.includes(N))&&!(c.skipRestricted&&I?.restricted))?v[R]=i[R]:m=!0}return{raw:v,restricted:P,hasExcludedProperties:m}}l(i,n){const r=[];for(const c of Object.keys(i))if($.$yo.test(c)){const m={};for(const v in i[c])m[v]=i[c][v];r.push({identifiers:(0,$.$zo)(c),keys:Object.keys(m),contents:(0,S.$_i)(m,n)})}return r}}e.$Fo=d;class f extends O.$Uc{constructor(i,n,r,c,m){super(),this.c=i,this.f=n,this.g=c,this.h=m,this.b=this.B(new a.$he),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),m),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(h.FileOperation.CREATE)||v.isOperation(h.FileOperation.COPY)||v.isOperation(h.FileOperation.DELETE)||v.isOperation(h.FileOperation.WRITE))&&r.isEqual(v.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=f;class w{constructor(i,n,r,c,m,v,P,R,I,N,U,j,F){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=c,this.d=m,this.f=v,this.g=P,this.h=R,this.i=I,this.j=N,this.k=U,this.l=j,this.m=F}get value(){return l(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class E{constructor(i,n,r,c,m,v,P,R,I,N){this.j=i,this.l=n,this.m=r,this.n=c,this.p=m,this.q=v,this.r=P,this.s=R,this.t=I,this.u=N,this.h=null,this.i=new C.$Ac,this.v=null}getValue(i,n,r){return this.w(i,n,r).getValue(i)}updateValue(i,n,r={}){let c;r.resource?(c=this.t.get(r.resource),c||(c=g.createEmptyModel(this.u),this.t.set(r.resource,c))):c=this.s,n===void 0?c.removeValue(i):c.setValue(i,n),r.resource||(this.h=null)}inspect(i,n,r){const c=this.w(i,n,r),m=this.A(n.resource,r),v=n.resource?this.t.get(n.resource)||this.s:this.s,P=new Set;for(const R of c.overrides)for(const I of R.identifiers)c.getOverrideValue(i,I)!==void 0&&P.add(I);return new w(i,n,c.getValue(i),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,m||void 0,v)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:c,updated:m,removed:v}=t(this.j,i);n=[...c,...m,...v]}for(const c of n)for(const m of(0,$.$zo)(c)){const v=this.j.getKeysForOverrideIdentifier(m),P=i.getKeysForOverrideIdentifier(m),R=[...P.filter(I=>v.indexOf(I)===-1),...v.filter(I=>P.indexOf(I)===-1),...v.filter(I=>!A.$ao(this.j.override(m).getValue(I),i.override(m).getValue(I)))];r.push([m,R])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:c}=t(this.l,i),m=[...n,...r,...c];return m.length&&this.updatePolicyConfiguration(i),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:c,overrides:m}=t(this.applicationConfiguration,i),v=[...n,...r,...c];return v.length&&this.updateApplicationConfiguration(i),{keys:v,overrides:m}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:c,overrides:m}=t(this.localUserConfiguration,i),v=[...n,...r,...c];return v.length&&this.updateLocalUserConfiguration(i),{keys:v,overrides:m}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:c,overrides:m}=t(this.remoteUserConfiguration,i),v=[...n,...r,...c];return v.length&&this.updateRemoteUserConfiguration(i),{keys:v,overrides:m}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:c,overrides:m}=t(this.workspaceConfiguration,i),v=[...n,...r,...c];return v.length&&this.updateWorkspaceConfiguration(i),{keys:v,overrides:m}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:c,updated:m,removed:v,overrides:P}=t(r,n),R=[...c,...m,...v];return(R.length||!r)&&this.updateFolderConfiguration(i,n),{keys:R,overrides:P}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:c,removed:m,overrides:v}=t(n,void 0);return{keys:[...r,...c,...m],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,r){let c=this.x(n,r);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(c=c.merge(this.l)),c}x({resource:i},n){let r=this.y();if(n&&i){const c=n.getFolder(i);c&&(r=this.z(c.uri)||r);const m=this.t.get(i);m&&(r=r.merge(m))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const r=this.y(),c=this.r.get(i);c?(n=r.merge(c),this.i.set(i,n)):n=r}return n}A(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:r,overrides:c,keys:m}=this.r.get(n);return i.push([n,{contents:r,overrides:c,keys:m}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(c=>n.add(c))),[...n.values()]}static parse(i,n){const r=this.E(i.defaults,n),c=this.E(i.policy,n),m=this.E(i.application,n),v=this.E(i.user,n),P=this.E(i.workspace,n),R=i.folders.reduce((I,N)=>(I.set(y.URI.revive(N[0]),this.E(N[1],n)),I),new C.$Ac);return new E(r,c,m,v,g.createEmptyModel(n),P,R,g.createEmptyModel(n),new C.$Ac,n)}static E(i,n){return new g(i.contents,i.keys,i.overrides,void 0,n)}}e.$Ho=E;function u(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,n=new Map;for(const c of o)c.keys.forEach(m=>i.add(m)),c.overrides.forEach(([m,v])=>{const P=(0,C.$xc)(n,m,new Set);v.forEach(R=>P.add(R))});const r=[];return n.forEach((c,m)=>r.push([m,[...c.values()]])),{keys:[...i.values()],overrides:r}}class b{constructor(i,n,r,c,m){this.change=i,this.f=n,this.g=r,this.h=c,this.i=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of i.keys)this.affectedKeys.add(v);for(const[,v]of i.overrides)for(const P of v)this.affectedKeys.add(P);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=E.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const r=this.a+i,c=this.d.indexOf(r);if(c<0)return!1;const m=c+r.length;if(m>=this.d.length)return!1;const v=this.d.charCodeAt(m);if(v!==this.b&&v!==this.c)return!1;if(n){const P=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,R=this.g.getValue(i,n,this.h);return!A.$ao(P,R)}return!0}}e.$Jo=b;function t(o,i){const{added:n,removed:r,updated:c}=s(i?.rawConfiguration,o?.rawConfiguration),m=[],v=o?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const R=P.filter(I=>!v.includes(I));for(const I of R)m.push([I,i.getKeysForOverrideIdentifier(I)])}if(o){const R=v.filter(I=>!P.includes(I));for(const I of R)m.push([I,o.getKeysForOverrideIdentifier(I)])}if(i&&o){for(const R of v)if(P.includes(R)){const I=s({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});m.push([R,[...I.added,...I.removed,...I.updated]])}}return{added:n,removed:r,updated:c,overrides:m}}function s(o,i){const n=o?i?o.keys.filter(m=>i.keys.indexOf(m)===-1):[...o.keys]:[],r=i?o?i.keys.filter(m=>o.keys.indexOf(m)===-1):[...i.keys]:[],c=[];if(o&&i){for(const m of i.keys)if(o.keys.indexOf(m)!==-1){const v=(0,S.$cj)(i.contents,m),P=(0,S.$cj)(o.contents,m);A.$ao(v,P)||c.push(m)}}return{added:n,removed:r,updated:c}}}),define(le[219],he([0,1,19,3,2,30,13,78,48,10,59,45]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=void 0;class h extends T.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new a.$he),this.onDidChangeConfiguration=this.a.event,this.b=A.$Eo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B($.$jo.as(L.$oo.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:f})=>this.f(Array.from(d),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,f){this.j(d,$.$jo.as(L.$oo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=A.$Eo.createEmptyModel(this.c);const d=$.$jo.as(L.$oo.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,f){const w=this.g();for(const E of d){const u=w[E],b=f[E];u!==void 0?this.b.addValue(E,u):b?this.b.addValue(E,b.default):this.b.removeValue(E)}}}e.$Ko=h;class p{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=A.$Eo.createEmptyModel(new y.$hk)}async initialize(){return this.configurationModel}}e.$Lo=p;let l=class extends T.$Uc{get configurationModel(){return this.b}constructor(d,f,w){super(),this.c=d,this.f=f,this.g=w,this.a=this.B(new a.$he),this.onDidChangeConfiguration=this.a.event,this.b=A.$Eo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const f={},w=[],E=$.$jo.as(L.$oo.Configuration).getConfigurationProperties();for(const u of d){const b=E[u];if(!b){w.push(u);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}w.push(u),f[b.policy.name]={type:b.type}}}return(0,C.$ng)(f)||await this.f.updatePolicyDefinitions(f),w}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const f=$.$jo.as(L.$oo.Configuration).getPolicyConfigurations(),w=(0,k.$Hb)(d.map(E=>f.get(E)));this.m(w,!0)}m(d,f){this.g.trace("PolicyConfiguration#update",d);const w=$.$jo.as(L.$oo.Configuration).getConfigurationProperties(),E=[],u=this.b.isEmpty();for(const b of d){const t=w[b]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(u?s!==void 0:!(0,O.$ao)(this.b.getValue(b),s))&&E.push([b,s])}else this.b.getValue(b)!==void 0&&E.push([b,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const b=this.b;this.b=A.$Eo.createEmptyModel(this.g);for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,s]of E)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$Mo=l,e.$Mo=l=ve([Z(1,S.$lo),Z(2,y.$7j)],l)}),define(le[220],he([0,1,19,6,15,3,34,63,2,35,30,5,21,22,78,48,219,7,59]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;class E extends L.$Uc{constructor(t,s,o,i){super(),this.m=t,this.n=i,this.h=this.B(new O.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Ko(i)),this.c=o instanceof w.$no?new d.$Lo:this.B(new d.$Mo(this.b,o,i)),this.f=this.B(new l.$Go(this.m,{},h.$5g,s,i)),this.a=new l.$Ho(this.b.configurationModel,this.c.configurationModel,l.$Eo.createEmptyModel(i),l.$Eo.createEmptyModel(i),l.$Eo.createEmptyModel(i),l.$Eo.createEmptyModel(i),new y.$Ac,l.$Eo.createEmptyModel(i),new y.$Ac,i),this.j=new u(t,s,this),this.g=this.B(new a.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,s,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Ho(t,s,l.$Eo.createEmptyModel(this.n),o,l.$Eo.createEmptyModel(this.n),l.$Eo.createEmptyModel(this.n),new y.$Ac,l.$Eo.createEmptyModel(this.n),new y.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,s){const o=typeof t=="string"?t:void 0,i=(0,p.$8i)(t)?t:(0,p.$8i)(s)?s:{};return this.a.getValue(o,i,void 0)}async updateValue(t,s,o,i,n){const r=(0,p.$9i)(o)?o:(0,p.$8i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,c=r?i:o;if(c!==void 0&&c!==p.ConfigurationTarget.USER_LOCAL&&c!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${c}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,k.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const m=this.inspect(t,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(m.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,S.$ao)(s,m.defaultValue)&&(s=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const P=r.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(I=>(0,k.$ub)([...I.identifiers].sort(),P));R&&(r.overrideIdentifiers=R.identifiers)}const v=r?.overrideIdentifiers?.length?[(0,g.$Ao)(r.overrideIdentifiers),t]:[t];await this.j.write(v,s),await this.reloadConfiguration()}inspect(t,s={}){return this.a.inspect(t,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const s=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(o,s,p.ConfigurationTarget.USER)}s(t,s){const o=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,s);this.u(i,o,p.ConfigurationTarget.DEFAULT)}t(t){const s=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(t);this.u(o,s,p.ConfigurationTarget.DEFAULT)}u(t,s,o){const i=new l.$Jo(t,{data:s},this.a,void 0,this.n);i.source=o,this.h.fire(i)}}e.$No=E;class u{constructor(t,s,o){this.b=t,this.c=s,this.d=o,this.a=new a.$Hh}write(t,s){return this.a.queue(()=>this.e(t,s))}async e(t,s){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw r}const i=[];if((0,C.$Pn)(o,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(o,t,s);o=(0,A.$8n)(o,n),await this.c.writeFile(this.b,T.$Je.fromString(o))}f(t,s,o){const{tabSize:i,insertSpaces:n,eol:r}=this.h;if(!s.length){const c=JSON.stringify(o,null,n?" ".repeat(i):"	");return[{content:c,length:c.length,offset:0}]}return(0,A.$5n)(t,s,o,{tabSize:i,insertSpaces:n,eol:r})}get h(){if(!this.g){let t=$.OS===$.OperatingSystem.Linux||$.OS===$.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(t=s),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[221],he([0,1,15,3,2,70]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dvb=e.$Bvb=e.$Avb=void 0,e.$Cvb=A;const C=(y,S,$)=>{const h=new Uint8Array(16);for(let g=0;g<16;g++)h[g]=Math.round(Math.random()*256);const p=(0,k.$4e)(k.$Je.wrap(h));return[`GET ws://localhost${y}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`].join(`\r
`)+`\r
\r
`};e.$Avb=C,e.$Bvb=k.$Je.fromString(`\r
\r
`);async function A(y,S,$,h,p){y.write(k.$Je.fromString((0,e.$Avb)(S,$,h)));const l=new T.$Tc;try{return await new Promise((g,d)=>{let f;l.add(y.onData(w=>{f?f=k.$Je.concat([f,w],f.byteLength+w.byteLength):f=w;const E=f.indexOf(e.$Bvb);if(E===-1)return;g(y),y.pauseData();const u=f.slice(E+e.$Bvb.byteLength);u.byteLength&&p.onData.fire(u)})),l.add(y.onClose(w=>d(w??new Error("socket closed")))),l.add(y.onEnd(()=>d(new Error("socket ended"))))})}catch(g){throw y.dispose(),g}finally{l.dispose()}}class L extends T.$Uc{constructor(S,$){super(),this.g=S,this.a=this.B(new a.$ke),this.onData=(...h)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...h)),this.b=this.B(new a.$he),this.onDidDispose=this.b.event,this.f=!1,this.B($.onData),this.B($.onData.event(h=>this.a.fire(h))),this.onClose=this.B($.onClose).event,this.onEnd=this.B($.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,$){O.SocketDiagnostics.traceSocketEvent(this,this.g,S,$)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Dvb=L}),define(le[105],he([0,1,8,4]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=y,e.$Ll=(0,a.$Ai)("remoteAuthorityResolverService");var T;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class O{constructor($){this.id=$,this.type=T.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=O;class C{constructor($,h){this.host=$,this.port=h,this.type=T.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=C;var A;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class L extends k.$bb{static isNotAvailable($){return $ instanceof L&&$._code===A.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof L&&$._code===A.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof L&&$._code===A.NoResolverFound}static isInvalidAuthority($){return $ instanceof L&&$._code===A.InvalidAuthority}static isHandled($){return $ instanceof L&&$.isHandled}constructor($,h=A.Unknown,p){super($),this._message=$,this._code=h,this._detail=p,this.isHandled=h===A.NotAvailable&&p===!0,Object.setPrototypeOf(this,L.prototype)}}e.$Ol=L;function y(S){const $=S.indexOf("+");return $===-1?S:S.substring(0,$)}}),define(le[222],he([0,1,6,15,26,8,3,2,23,101,65,32,70,105]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=m,e.$Vl=v,e.$Wl=R;const l=30*1e3;var g;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function d(J){switch(J){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function f(J){const G=new T.$se;return setTimeout(()=>G.cancel(),J),G.token}function w(J,G){if(J.isCancellationRequested||G.isCancellationRequested)return T.CancellationToken.Cancelled;const D=new T.$se;return J.onCancellationRequested(()=>D.cancel()),G.onCancellationRequested(()=>D.cancel()),D.token}class E{get didTimeout(){return this.c==="timedout"}constructor(G){this.c="pending",this.d=new A.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,k.$th)(),G.isCancellationRequested?this.h():this.d.add(G.onCancellationRequested(()=>this.h()))}registerDisposable(G){this.c==="pending"?this.d.add(G):G.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(G))}reject(G){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(G))}}function u(J,G){const D=new E(G);return D.registerDisposable(J.onControlMessage(B=>{const M=JSON.parse(B.toString()),z=W(M);z?D.reject(z):D.resolve(M)})),D.promise}function b(J,G,D,B,M,z,te,_){const Y=new E(_),ae=S.$be.create(!1);return J.info(`Creating a socket (${te})...`),y.mark(`code/willCreateSocket/${z}`),G.connect(D,B,M,te).then(ue=>{Y.didTimeout?(y.mark(`code/didCreateSocketError/${z}`),J.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(y.mark(`code/didCreateSocketOK/${z}`),J.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Y.resolve(ue))},ue=>{y.mark(`code/didCreateSocketError/${z}`),J.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),J.error(ue),Y.reject(ue)}),Y.promise}function t(J,G){const D=new E(G);return J.then(B=>{D.didTimeout||D.resolve(B)},B=>{D.didTimeout||D.reject(B)}),D.promise}async function s(J,G,D,B){const M=q(J,G);J.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let z;try{z=await b(J.logService,J.remoteSocketFactoryService,J.connectTo,L.$Ng.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,d(G),`renderer-${d(G)}-${J.reconnectionToken}`,B)}catch(ue){throw J.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let te,_;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(z,null),te=J.reconnectionProtocol,_=!1):(te=new h.$oi({socket:z}),_=!0),J.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const Y=await t(J.signService.createNewMessage((0,$.$Wg)()),B),ae={type:"auth",auth:J.connectionToken||"00000000000000000000",data:Y.data};te.sendControl(a.$Je.fromString(JSON.stringify(ae)));try{const ue=await u(te,w(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(J.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(J.signService.validate(Y,ue.signedData),B)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const we=await t(J.signService.sign(ue.data),B),Ee={type:"connectionType",commit:J.commit,signedData:we,desiredConnectionType:G};return D&&(Ee.args=D),J.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(a.$Je.fromString(JSON.stringify(Ee))),{protocol:te,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${M} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${M} received error control message when negotiating connection. Error:`),J.logService.error(ue)),_&&H(te),ue}}async function o(J,G,D,B){const M=Date.now(),z=q(J,G),{protocol:te,ownsProtocol:_}=await s(J,G,D,B),Y=new E(B);return Y.registerDisposable(te.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),ge=W(ue);ge?(J.logService.error(`${z} received error control message when negotiating connection. Error:`),J.logService.error(ge),_&&H(te),Y.reject(ge)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${x(M)}!`),Y.resolve({protocol:te,firstMessage:ue}))})),Y.promise}async function i(J,G){const{protocol:D}=await o(J,g.Management,void 0,G);return{protocol:D}}async function n(J,G,D){const{protocol:B,firstMessage:M}=await o(J,g.ExtensionHost,G,D),z=M&&M.debugPort;return{protocol:B,debugPort:z}}async function r(J,G,D){const B=Date.now(),M=q(J,g.Tunnel),{protocol:z}=await s(J,g.Tunnel,G,D);return J.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${x(B)}!`),z}async function c(J,G,D){const{connectTo:B,connectionToken:M}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:B,connectionToken:M,reconnectionToken:G,reconnectionProtocol:D,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function m(J,G,D){return P(J,async B=>{const{protocol:M}=await i(B,T.CancellationToken.None);return new V(J,G,D,B.reconnectionToken,M)})}async function v(J,G){return P(J,async D=>{const{protocol:B,debugPort:M}=await n(D,G,T.CancellationToken.None);return new ie(J,G,D.reconnectionToken,B,M)})}async function P(J,G){for(let B=1;;B++)try{const M=(0,$.$Wg)(),z=await c(J,M,null);return await G(z)}catch(M){if(B<5)J.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(M);else throw J.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(M),Q.triggerPermanentFailure(0,0,p.$Ol.isHandled(M)),M}}async function R(J,G,D){const B=await c(J,(0,$.$Wg)(),null);return await r(B,{host:G,port:D},T.CancellationToken.None)}function I(J){return(0,k.$nh)(G=>new Promise((D,B)=>{const M=setTimeout(D,J*1e3);G.onCancellationRequested(()=>{clearTimeout(M),D()})}))}var N;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(G,D){this.reconnectionToken=G,this.millisSinceLastIncomingData=D,this.type=N.ConnectionLost}}e.$Xl=U;class j{constructor(G,D,B,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=D,this.durationSeconds=B,this.c=M,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=j;class F{constructor(G,D,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=N.ReconnectionRunning}}e.$Zl=F;class X{constructor(G,D,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=N.ConnectionGain}}e.$1l=X;class K{constructor(G,D,B,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=D,this.attempt=B,this.handled=M,this.type=N.ReconnectionPermanentFailure}}e.$2l=K;class Q extends A.$Uc{static triggerPermanentFailure(G,D,B){this._permanentFailure=!0,this.f=G,this.g=D,this.h=B,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(G=>G.y())}static debugPauseSocketWriting(){this.j.forEach(G=>G.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(G,D,B,M,z){super(),this.t=G,this.u=D,this.reconnectionToken=B,this.protocol=M,this.w=z,this.m=this.B(new C.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(M.onSocketClose(te=>{const _=ce(this.t,this.reconnectionToken,!0);te?te.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(te=>{const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,A.$Sc)(()=>{const te=Q.j.indexOf(this);te>=0&&Q.j.splice(te,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const G=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const M=B<D.length?D[B]:D[D.length-1];try{if(M>0){const te=I(M);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,te)),this.u.logService.info(`${G} waiting for ${M} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${G} resolving connection...`);const z=await c(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${G} connecting to ${z.connectTo}...`),await this.G(z,f(l)),this.u.logService.info(`${G} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(p.$Ol.isTemporarilyNotAvailable(z)){this.u.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,O.$4)(z)){this.u.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof p.$Ol){this.u.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,p.$Ol.isHandled(z));break}this.u.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(G,D,B){this.w?Q.triggerPermanentFailure(G,D,B):this.D(G,D,B)}D(G,D,B){this.m.fire(new K(this.reconnectionToken,G,D,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=Q;class V extends Q{constructor(G,D,B,M,z){super(g.Management,G,M,z,!0),this.client=this.B(new h.$mi(z,{remoteAuthority:D,clientId:B},G.ipcLogger))}async G(G,D){await i(G,D)}}e.$4l=V;class ie extends Q{constructor(G,D,B,M,z){super(g.ExtensionHost,G,B,M,!1),this.H=D,this.debugPort=z}async G(G,D){await n(G,this.H,D)}}e.$5l=ie;function H(J){try{J.acceptDisconnect();const G=J.getSocket();J.dispose(),G.dispose()}catch(G){(0,O.$1)(G)}}function W(J){if(J&&J.type==="error"){const G=new Error(`Connection error: ${J.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function ee(J,G){for(;J.length<G;)J+=" ";return J}function re(J,G){return`[remote-connection][${ee(d(J),13)}][${G.substr(0,5)}\u2026]`}function ce(J,G,D){return`${re(J,G)}[${D?"reconnect":"initial"}]`}function q(J,G){return`${ce(G,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function x(J){return`${Date.now()-J} ms`}}),define(le[106],he([0,1,23]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=a,e.$Nm=T,e.$Om=O,e.$Pm=C;function a(L){return L.scheme===k.Schemas.vscodeRemote?L.authority:void 0}function T(L){if(!L)return;const y=L.indexOf("+");return y<0?L:L.substr(0,y)}function O(L){const{host:y,port:S}=A(L);if(typeof S>"u")throw new Error(`Invalid remote authority: ${L}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:S}}function C(L,y){let{host:S,port:$}=A(L);return typeof $>"u"&&($=y),{host:S,port:$}}function A(L){const y=L.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const S=L.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const $=L.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:L,port:void 0}}}),define(le[37],he([0,1,27,4,106]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=O,e.$Zm=$,e.$1m=h,e.$2m=p,e.$3m=l,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function O(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(C||(e.ExtensionType=C={}));var A;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class L{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,f){if(typeof d>"u"||d===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof d=="string"||typeof f=="string"){const w=typeof d=="string"?d:d.value,E=typeof f=="string"?f:f.value;return k.$Bf(w,E)}return d._lower===f._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Wm=L;class y{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const f of d)this.add(f)}add(d){this.c.add(L.toKey(d))}delete(d){return this.c.delete(L.toKey(d))}has(d){return this.c.has(L.toKey(d))}}e.$Xm=y;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(L.toKey(d))}get(d){return this.c.get(L.toKey(d))}has(d){return this.c.has(L.toKey(d))}set(d,f){this.c.set(L.toKey(d),f)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=S;function $(g){return h(g)}function h(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function p(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function l(g,d){if(d){const f=`onResolveRemoteAuthority:${(0,T.$Nm)(d)}`;return!!g.activationEvents?.includes(f)}return!1}e.$4m=(0,a.$Ai)("IBuiltinExtensionsScannerService")}),define(le[28],he([0,1,5,163,37,4]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=A,e.$9o=L,e.$0o=y,e.$$o=S,e.$_o=$,e.$ap=h,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var C;(function(b){b.COMMAND="command",b.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function A(b){switch(b){case T.TargetPlatform.WIN32_X64:return"Windows 64 bit";case T.TargetPlatform.WIN32_ARM64:return"Windows ARM";case T.TargetPlatform.LINUX_X64:return"Linux 64 bit";case T.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case T.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case T.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case T.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case T.TargetPlatform.DARWIN_X64:return"Mac";case T.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case T.TargetPlatform.WEB:return"Web";case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;case T.TargetPlatform.UNKNOWN:return T.TargetPlatform.UNKNOWN;case T.TargetPlatform.UNDEFINED:return T.TargetPlatform.UNDEFINED}}function L(b){switch(b){case T.TargetPlatform.WIN32_X64:return T.TargetPlatform.WIN32_X64;case T.TargetPlatform.WIN32_ARM64:return T.TargetPlatform.WIN32_ARM64;case T.TargetPlatform.LINUX_X64:return T.TargetPlatform.LINUX_X64;case T.TargetPlatform.LINUX_ARM64:return T.TargetPlatform.LINUX_ARM64;case T.TargetPlatform.LINUX_ARMHF:return T.TargetPlatform.LINUX_ARMHF;case T.TargetPlatform.ALPINE_X64:return T.TargetPlatform.ALPINE_X64;case T.TargetPlatform.ALPINE_ARM64:return T.TargetPlatform.ALPINE_ARM64;case T.TargetPlatform.DARWIN_X64:return T.TargetPlatform.DARWIN_X64;case T.TargetPlatform.DARWIN_ARM64:return T.TargetPlatform.DARWIN_ARM64;case T.TargetPlatform.WEB:return T.TargetPlatform.WEB;case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;default:return T.TargetPlatform.UNKNOWN}}function y(b,t){switch(b){case k.Platform.Windows:return t==="x64"?T.TargetPlatform.WIN32_X64:t==="arm64"?T.TargetPlatform.WIN32_ARM64:T.TargetPlatform.UNKNOWN;case k.Platform.Linux:return t==="x64"?T.TargetPlatform.LINUX_X64:t==="arm64"?T.TargetPlatform.LINUX_ARM64:t==="arm"?T.TargetPlatform.LINUX_ARMHF:T.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?T.TargetPlatform.ALPINE_X64:t==="arm64"?T.TargetPlatform.ALPINE_ARM64:T.TargetPlatform.UNKNOWN;case k.Platform.Mac:return t==="x64"?T.TargetPlatform.DARWIN_X64:t==="arm64"?T.TargetPlatform.DARWIN_ARM64:T.TargetPlatform.UNKNOWN;case k.Platform.Web:return T.TargetPlatform.WEB}}function S(b,t){return t===T.TargetPlatform.WEB&&!b.includes(T.TargetPlatform.WEB)}function $(b,t,s){return S(t,s)?!1:b===T.TargetPlatform.UNDEFINED||b===T.TargetPlatform.UNIVERSAL?!0:b===T.TargetPlatform.UNKNOWN?!1:b===s}function h(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}var p;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=10]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var l;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var g;(function(b){b.Install="install",b.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var d;(function(b){b[b.None=1]="None",b[b.Install=2]="Install",b[b.Update=3]="Update",b[b.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$bp=(0,O.$Ai)("extensionGalleryService");var f;(function(b){b.Timeout="Timeout",b.Cancelled="Cancelled",b.Failed="Failed",b.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class w extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$cp=w;var E;(function(b){b.Unsupported="Unsupported",b.Deprecated="Deprecated",b.Malicious="Malicious",b.Incompatible="Incompatible",b.IncompatibleTargetPlatform="IncompatibleTargetPlatform",b.ReleaseVersionNotFound="ReleaseVersionNotFound",b.Invalid="Invalid",b.Download="Download",b.DownloadSignature="DownloadSignature",b.DownloadFailedWriting="DownloadFailedWriting",b.UpdateMetadata="UpdateMetadata",b.Extract="Extract",b.Scanning="Scanning",b.ScanningExtension="ScanningExtension",b.ReadUninstalled="ReadUninstalled",b.UnsetUninstalled="UnsetUninstalled",b.Delete="Delete",b.Rename="Rename",b.IntializeDefaultProfile="IntializeDefaultProfile",b.AddToProfile="AddToProfile",b.InstalledExtensionNotFound="InstalledExtensionNotFound",b.PostInstall="PostInstall",b.CorruptZip="CorruptZip",b.IncompleteZip="IncompleteZip",b.Signature="Signature",b.NotAllowed="NotAllowed",b.Gallery="Gallery",b.Cancelled="Cancelled",b.Unknown="Unknown",b.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class u extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$dp=u,e.$ep=(0,O.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,O.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,O.$Ai)("IExtensionTipsService"),e.$jp=(0,a.localize2)(0,"Extensions"),e.$kp=(0,a.localize2)(1,"Preferences")}),define(le[223],he([0,1,3,2,30,9,95,28]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=void 0;function L(d,f){return d?O.URI.revive(f?f.transformIncoming(d):d):void 0}function y(d,f){return f?f.transformOutgoingURI(d):d}function S(d,f){f=f||C.$En;const w=d.manifest;return{...(0,C.$Hn)({...d,manifest:void 0},f),manifest:w}}function $(d,f){return d?.profileLocation?(0,C.$Hn)(d,f??C.$En):d}function h(d,f){return f?(0,T.$$n)(d,w=>w instanceof O.URI?f.transformOutgoingURI(w):void 0):d}class p{constructor(f,w){this.a=f,this.b=w,this.onInstallExtension=k.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,w){const E=this.b(f);switch(w){case"onInstallExtension":return k.Event.map(this.onInstallExtension,u=>({...u,profileLocation:u.profileLocation?y(u.profileLocation,E):u.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,u=>u.map(b=>({...b,local:b.local?h(b.local,E):b.local,profileLocation:b.profileLocation?y(b.profileLocation,E):b.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,u=>({...u,profileLocation:u.profileLocation?y(u.profileLocation,E):u.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,u=>({...u,profileLocation:u.profileLocation?y(u.profileLocation,E):u.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,u=>h(u,E))}throw new Error("Invalid listen")}async call(f,w,E){const u=this.b(f);switch(w){case"zip":{const b=S(E[0],u),t=await this.a.zip(b);return y(t,u)}case"unzip":return this.a.unzip(L(E[0],u));case"install":return this.a.install(L(E[0],u),$(E[1],u));case"installFromLocation":return this.a.installFromLocation(L(E[0],u),L(E[1],u));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(E[0],L(E[1],u),L(E[2],u));case"getManifest":return this.a.getManifest(L(E[0],u));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(E[0]);case"installFromGallery":return this.a.installFromGallery(E[0],$(E[1],u));case"installGalleryExtensions":{const b=E[0];return this.a.installGalleryExtensions(b.map(({extension:t,options:s})=>({extension:t,options:$(s,u)??{}})))}case"uninstall":return this.a.uninstall(S(E[0],u),$(E[1],u));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(E[0],u));case"getInstalled":return(await this.a.getInstalled(E[0],L(E[1],u),E[2])).map(t=>h(t,u));case"toggleAppliationScope":{const b=await this.a.toggleAppliationScope(S(E[0],u),L(E[1],u));return h(b,u)}case"copyExtensions":return this.a.copyExtensions(L(E[0],u),L(E[1],u));case"updateMetadata":{const b=await this.a.updateMetadata(S(E[0],u),E[1],L(E[2],u));return h(b,u)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(E[0],E[1],E[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$lq=p;class l extends a.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new k.$he),this.f=this.B(new k.$he),this.g=this.B(new k.$he),this.h=this.B(new k.$he),this.j=this.B(new k.$he),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?O.URI.revive(w.source):w.source,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(E=>({...E,local:E.local?S(E.local,null):E.local,source:this.r(E.source)?O.URI.revive(E.source):E.source,profileLocation:O.URI.revive(E.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.j.fire(S(w,null))))}n(f,w){f.fire(w)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(E=>(0,A.$_o)(E,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(w=>O.URI.revive(w)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,w){return Promise.resolve(this.m.call("install",[f,w])).then(E=>S(E,null))}installFromLocation(f,w){return Promise.resolve(this.m.call("installFromLocation",[f,w])).then(E=>S(E,null))}async installExtensionsFromProfile(f,w,E){return(await this.m.call("installExtensionsFromProfile",[f,w,E])).map(b=>S(b,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.m.call("installFromGallery",[f,w])).then(E=>S(E,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(E=>({...E,local:E.local?S(E.local,null):E.local,source:this.r(E.source)?O.URI.revive(E.source):E.source,profileLocation:O.URI.revive(E.profileLocation)}))}uninstall(f,w){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,w]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(w=>S(w,null))}getInstalled(f=null,w,E){return Promise.resolve(this.m.call("getInstalled",[f,w,E])).then(u=>u.map(b=>S(b,null)))}updateMetadata(f,w,E){return Promise.resolve(this.m.call("updateMetadata",[f,w,E])).then(u=>S(u,null))}toggleAppliationScope(f,w){return this.m.call("toggleAppliationScope",[f,w]).then(E=>S(E,null))}copyExtensions(f,w){return this.m.call("copyExtensions",[f,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,w,E){const u=await this.m.call("download",[f,w,E]);return O.URI.revive(u)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$mq=l;class g{constructor(f){this.a=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,E){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$nq=g}),define(le[224],he([0,1,2,37,7]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class O extends k.$Uc{constructor(A,L,y,S,$){super(),this.a=A,this.b=L,this.c=y,this.f=$,this.B(S.onDidInstallExtensions(h=>this.g(h))),this.B(S.onDidUninstallExtension(h=>this.h(h)))}g(A){for(const L of A)L.local&&this.invalidate(L.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const L of this.a.profiles)this.c.extUri.isEqual(L.extensionsResource,A)&&await this.j(L);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,a.$Qm))}catch(L){(0,T.$ll)(L)!==T.FileOperationResult.FILE_NOT_FOUND&&this.f.error(L)}}}e.$Kq=O}),define(le[79],he([0,1,26,2,5,173,28,4]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=void 0,e.$Yr=L;function L(S){return S.tags.find($=>$.startsWith("lp-"))?.split("lp-")[1]}e.$Zr=(0,A.$Ai)("languagePackService");let y=class extends a.$Uc{constructor($){super(),this.c=$}async getAvailableLanguages(){const $=new k.$se;setTimeout(()=>$.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},$.token)}catch{return[]}const l=h.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(d=>d.startsWith("lp-"))).map(g=>{const d=g.properties.localizedLanguages?.[0],f=L(g);return{...this.f(f,d,g),extensionId:g.identifier.id,galleryExtension:g}});return l.push(this.f("en","English")),l}f($,h,p){const l=h??$;let g;if(l!==$&&(g=`(${$})`),$.toLowerCase()===T.$w.toLowerCase()&&(g??="",g+=(0,O.localize)(0,null)),p?.installCount){g??="";const d=p.installCount;let f;d>1e6?f=`${Math.floor(d/1e5)/10}M`:d>1e3?f=`${Math.floor(d/1e3)}K`:f=String(d),g+=` $(cloud-download) ${f}`}return{id:$,label:l,description:g}}};e.$1r=y,e.$1r=y=ve([Z(0,C.$bp)],y)}),define(le[225],he([0,1,2,79]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;let T=class extends k.$Uc{constructor(C){super(),this.a=C,this.b()}b(){this.a.update()}};e.$tfc=T,e.$tfc=T=ve([Z(0,a.$Zr)],T)}),define(le[107],he([0,1,2,4]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,a.$Ai)("remoteSocketFactoryService");class T{constructor(){this.a={}}register(C,A){return this.a[C]??=[],this.a[C].push(A),(0,k.$Sc)(()=>{const L=this.a[C]?.indexOf(A);typeof L=="number"&&L>=0&&this.a[C]?.splice(L,1)})}b(C){return(this.a[C.type]||[]).find(L=>L.supports(C))}connect(C,A,L,y){const S=this.b(C);if(!S)throw new Error(`No socket factory found for ${C}`);return S.connect(C,A,L,y)}}e.$Rl=T}),define(le[226],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,k.$Ai)("sharedProcessTunnelService"),e.$Hfc="sharedProcessTunnel"}),define(le[108],he([0,1,4,175]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=e.$Pfc=e.$Ofc=e.$Nfc=e.TunnelStates=e.$Mfc=e.$Lfc=void 0,e.$Lfc=(0,k.$Ai)("IRemoteTunnelService"),e.$Mfc={active:!1};var T;(function(O){O.disconnected=C=>({type:"disconnected",onTokenFailed:C}),O.connected=(C,A)=>({type:"connected",info:C,serviceInstallFailed:A}),O.connecting=C=>({type:"connecting",progress:C}),O.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.$Nfc="remote.tunnels.access",e.$Ofc=e.$Nfc+".hostNameOverride",e.$Pfc=e.$Nfc+".preventSleep",e.$Qfc="remoteTunnelService",e.$Rfc=(0,a.localize)(0,null)}),define(le[60],he([0,1,15,8,2,177,48,4,10,45]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=h,e.$Yp=p,e.$Zp=l,e.$1p=g,e.$2p=d,e.$3p=f,e.$Vp=(0,A.$Ai)("requestService");class S{constructor(b){this.b=b}toJSON(){if(!this.a){const b=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.b[t];this.a=b}return this.a}}class $ extends T.$Uc{constructor(b){super(),this.b=0,this.a=b.createLogger("network",{name:(0,O.localize)(0,null),when:L.$mk.isEqualTo((0,L.$jk)(L.LogLevel.Trace)).serialize()})}async c(b,t,s){const o=`${b} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new S(t.headers??{}));try{const i=await s();return this.a.trace(`${o} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${o} - error`,t.type,(0,a.$0)(i)),i}}}e.$Wp=$;function h(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}function p(u){return u.res.statusCode===204}async function l(u){return p(u)?null:(await(0,k.$Ve)(u.stream)).toString()}async function g(u){if(!h(u))throw new Error("Server returned "+u.res.statusCode);return l(u)}async function d(u){if(!h(u))throw new Error("Server returned "+u.res.statusCode);if(p(u))return null;const t=(await(0,k.$Ve)(u.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(u){E(u)}let w;function E(u){const b=y.$jo.as(C.$oo.Configuration),t=w;w={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},b.updateConfigurations({add:[w],remove:t?[t]:[]})}E(C.ConfigurationScope.APPLICATION)}),define(le[227],he([0,1,26,23,7,60]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;let C=class{constructor(L,y){this.a=L,this.b=y}async download(L,y,S=k.CancellationToken.None){if(L.scheme===a.Schemas.file||L.scheme===a.Schemas.vscodeRemote){await this.b.copy(L,y);return}const $={type:"GET",url:L.toString(!0)},h=await this.a.request($,S);if(h.res.statusCode===200)await this.b.writeFile(y,h.stream);else{const p=await(0,O.$1p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${p}`)}}};e.$AQ=C,e.$AQ=C=ve([Z(0,O.$Vp),Z(1,T.$7k)],C)}),define(le[228],he([0,1,15,26]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0;class T{constructor(A){this.a=A}listen(A,L){throw new Error("Invalid listen")}call(A,L,y,S=a.CancellationToken.None){switch(L){case"request":return this.a.request(y[0],S).then(async({res:$,stream:h})=>{const p=await(0,k.$Ve)(h);return[{statusCode:$.statusCode,headers:$.headers},p]});case"resolveProxy":return this.a.resolveProxy(y[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$3r=T;class O{constructor(A){this.a=A}async request(A,L){const[y,S]=await this.a.call("request",[A],L);return{res:y,stream:(0,k.$Xe)(S)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$4r=O}),define(le[229],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=void 0,e.$eec={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$fec={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$gec={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[230],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=void 0;class k{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(T){try{const O=await this.c();if(O){const C=String(k.a++);return this.b.set(C,O),{id:C,data:O.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,O){if(!T.id)return!0;const C=this.b.get(T.id);if(!C)return!1;this.b.delete(T.id);try{return C.validate(O)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(T){try{return await this.d(T)}catch{}return T}}e.$4_b=k}),define(le[109],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,k.$Ai)(e.$Sl)}),define(le[231],he([0,1,230]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class a extends k.$4_b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(C=>new C.signer().sign(O))}h(){return new Promise((O,C)=>ne(["vsda"],O,C))}}e.$9ec=a}),define(le[80],he([0,1,3,2]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qLb=e.$pLb=e.$oLb=e.$nLb=void 0;class T extends a.$Uc{constructor($,h,p){super(),this.a=$,this.b=h,this.c=p}async getItems(){const $={profile:this.b,workspace:this.c},h=await this.a.call("getItems",$);return new Map(h)}updateItems($){const h={profile:this.b,workspace:this.c};return $.insert&&(h.insert=Array.from($.insert.entries())),$.delete&&(h.delete=Array.from($.delete.values())),this.a.call("updateItems",h)}optimize(){const $={profile:this.b,workspace:this.c};return this.a.call("optimize",$)}}class O extends T{constructor($,h){super($,h,void 0),this.f=this.B(new k.$he),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})($=>this.h($)))}h($){(Array.isArray($.changed)||Array.isArray($.deleted))&&this.f.fire({changed:$.changed?new Map($.changed):void 0,deleted:$.deleted?new Set($.deleted):void 0})}}class C extends O{constructor($){super($,void 0)}async close(){this.dispose()}}e.$nLb=C;class A extends O{constructor($,h){super($,h)}async close(){this.dispose()}}e.$oLb=A;class L extends T{constructor($,h){super($,void 0,h),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.$pLb=L;class y{constructor($){this.a=$}isUsed($){const h={payload:$,profile:void 0,workspace:void 0};return this.a.call("isUsed",h)}}e.$qLb=y}),define(le[110],he([0,1,5,36,32]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=C,e.$mp=A;function O(L){if(k.$u===k.Platform.Linux&&/^penguin(\.|$)/i.test(L))return"chromebook"}function C(L,y,S,$,h,p,l,g,d,f){const w=Object.create(null);w["common.machineId"]=p,w["common.sqmId"]=l,w["common.devDeviceId"]=g,w.sessionID=(0,T.$Wg)()+Date.now(),w.commitHash=$,w.version=h,w["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,k.$h)(k.$u),w["common.nodePlatform"]=a.$dc,w["common.nodeArch"]=S,w["common.product"]=f||"desktop",d&&(w["common.msftInternal"]=d);let E=0;const u=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),k.$l&&(w["common.snap"]="true");const b=O(y);return b&&(w["common.platformDetail"]=b),w}function A(L){const y=a.env.USERDNSDOMAIN;if(!y)return!1;const S=y.toLowerCase();return L.some($=>S===$)}}),define(le[18],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,k.$Ai)("telemetryService"),e.$7l=(0,k.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var a;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var T;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(le[232],he([0,1,38,6,34,23,14,5,9,150,31,156,98,7,24,18]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Ms=f,e.$Ns=E,e.$Os=u;const d=new Map;async function f(t,s){const o=`${t}::${s.join(":")}`,i=d.get(o);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,c=new Map,m=2e4;function v(R,I,N,U){const j=I.substring(R.length+1);return a.Promises.withAsyncBody(async F=>{let X;try{X=await S.Promises.readdir(I,{withFileTypes:!0})}catch{F();return}if(U.count>=m){U.count+=X.length,U.maxReached=!0,F();return}let K=X.length;if(K===0){F();return}let Q=X;U.count+X.length>m&&(U.maxReached=!0,K=m-U.count,Q=X.slice(0,K)),U.count+=X.length;for(const V of Q)if(V.isDirectory()){if(N.includes(V.name)||await v(R,(0,C.$jc)(I,V.name),N,U),--K===0){F();return}}else{const ie=V.name.lastIndexOf(".");if(ie>=0){const H=V.name.substring(ie+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(j)!==!1&&H.filePattern.test(V.name)&&c.set(H.tag,(c.get(H.tag)??0)+1);if(--K===0){F();return}}})}const P=a.Promises.withAsyncBody(async R=>{const I={count:0,maxReached:!1};await v(t,t,s,I);const N=await u(t);R({configFiles:w(c),fileTypes:w(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:N})});return d.set(o,P),P}function w(t){return Array.from(t.entries(),([s,o])=>({name:s,count:o})).sort((s,o)=>o.count-s.count)}function E(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/p.$Cl.GB).toFixed(2)}GB (${(k.freemem()/p.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.$Jn.value()*100)}%`},s=k.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}async function u(t){try{const s=new Map,o=(0,C.$jc)(t,".vscode","launch.json"),i=await S.Promises.readFile(o),n=[],r=(0,T.$Pn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,T.$Yn)(r)==="object"&&r.configurations)for(const c of r.configurations){const m=c.type;m&&(s.has(m)?s.set(m,s.get(m)+1):s.set(m,1))}return w(s)}catch{return[]}}let b=class{constructor(s,o){this.c=s,this.d=o}f(s){const o=[];return o.push(`OS Version:       ${s.os}`),o.push(`CPUs:             ${s.cpus}`),o.push(`Memory (System):  ${s.memory}`),o.push(`VM:               ${s.vmHint}`),o.join(`
`)}g(s){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const i=k.cpus();return i&&i.length>0&&o.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),o.push(`Memory (System):  ${(k.totalmem()/p.$Cl.GB).toFixed(2)}GB (${(k.freemem()/p.$Cl.GB).toFixed(2)}GB free)`),A.$i||o.push(`Load (avg):       ${k.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(y.$Jn.value()*100)}%`),o.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${s.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(s,o){return Promise.all([(0,$.$Ls)(s.mainPID),this.k(s)]).then(async i=>{let[n,r]=i,c=this.m(s,n);return o.forEach(m=>{if((0,h.$jn)(m))c+=`
${m.errorMessage}`,r+=`
${m.errorMessage}`;else if(c+=`

Remote: ${m.hostName}`,m.processes&&(c+=`
${this.m(s,m.processes)}`),m.workspaceMetadata){r+=`
|  Remote: ${m.hostName}`;for(const v of Object.keys(m.workspaceMetadata)){const P=m.workspaceMetadata[v];let R=`${P.fileCount} files`;P.maxFilesReached&&(R=`more than ${R}`),r+=`|    Folder (${v}): ${R}`,r+=this.h(P)}}}),{processInfo:c,workspaceInfo:r}})}async getSystemInfo(s,o){const{memory:i,vmHint:n,os:r,cpus:c}=E(),m={os:r,memory:i,cpus:c,vmHint:n,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:o};return A.$i||(m.load=`${k.loadavg().map(v=>Math.round(v)).join(", ")}`),A.$k&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(s,o){const i=[];return(0,$.$Ls)(s.mainPID).then(async n=>(i.push(""),i.push(this.g(s)),i.push(""),i.push(this.m(s,n)),s.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(s))),o.forEach(r=>{if((0,h.$jn)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(s,r.processes)),r.workspaceMetadata)for(const c of Object.keys(r.workspaceMetadata)){const m=r.workspaceMetadata[c];let v=`${m.fileCount} files`;m.maxFilesReached&&(v=`more than ${v}`),i.push(`Folder (${c}): ${v}`),i.push(this.h(m))}}),i.push(""),i.push(""),i.join(`
`)))}h(s){const o=[];let n=0;const r=(P,R)=>{const I=` ${P}(${R})`;n+I.length>60?(o.push(c),c="|                 ",n=c.length):n+=I.length,c+=I};let c="|      File types:";const m=10,v=s.fileTypes.length>m?m:s.fileTypes.length;for(let P=0;P<v;P++){const R=s.fileTypes[P];r(R.name,R.count)}if(o.push(c),s.configFiles.length>=0&&(c="|      Conf files:",n=0,s.configFiles.forEach(P=>{r(P.name,P.count)}),o.push(c)),s.launchConfigFiles.length>0){let P="|      Launch Configs:";s.launchConfigFiles.forEach(R=>{const I=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;P+=I}),o.push(P)}return o.join(`
`)}j(s){const o=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(o-i.length)}  ${s[i]}`).join(`
                  `)}k(s){const o=[],i=[];return s.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(r=>{const c=L.URI.revive(r);if(c.scheme===O.Schemas.file){const m=c.fsPath;i.push(f(m,["node_modules",".git"]).then(v=>{let P=`${v.fileCount} files`;v.maxFilesReached&&(P=`more than ${P}`),o.push(`|    Folder (${(0,C.$nc)(m)}): ${P}`),o.push(this.h(v))}).catch(v=>{o.push(`|      Error: Unable to collect workspace stats for folder ${m} (${v.toString()})`)}))}else o.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(s,o){const i=new Map;s.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),s.pidToNames.forEach(({pid:r,name:c})=>i.set(r,c));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(s.mainPID,i,n,o,0),n.join(`
`)}n(s,o,i,n,r){const c=r===0;let m;c?m=n.pid===s?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?m=o.get(n.pid):m=`${"  ".repeat(r)} ${n.name}`;const v=process.platform==="win32"?n.mem:k.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(v/p.$Cl.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(n.children)&&n.children.forEach(P=>this.n(s,o,i,P,r+1))}async getWorkspaceFileExtensions(s){const o=new Set;for(const{uri:i}of s.folders){const n=L.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const r=n.fsPath;try{(await f(r,["node_modules",".git"])).fileTypes.forEach(m=>o.add(m.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(s){for(const{uri:o}of s.folders){const i=L.URI.revive(o);if(i.scheme!==O.Schemas.file)continue;const n=i.fsPath;try{const r=await f(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),r.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})}),r.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})}),r.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.$Ps=b,e.$Ps=b=ve([Z(0,g.$6l),Z(1,l.$nk)],b)}),define(le[111],he([0,1,8,4,10,18]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.ExtensionSignatureVerificationCode=e.$hq=void 0,e.$hq=(0,a.$Ai)("IExtensionSignatureVerificationService");var C;(function(y){y.None="None",y.RequiredArgumentMissing="RequiredArgumentMissing",y.InvalidArgument="InvalidArgument",y.PackageIsUnreadable="PackageIsUnreadable",y.UnhandledException="UnhandledException",y.SignatureManifestIsMissing="SignatureManifestIsMissing",y.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",y.SignatureIsMissing="SignatureIsMissing",y.SignatureIsUnreadable="SignatureIsUnreadable",y.CertificateIsUnreadable="CertificateIsUnreadable",y.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",y.FileAlreadyExists="FileAlreadyExists",y.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",y.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",y.Success="Success",y.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",y.SignatureIsInvalid="SignatureIsInvalid",y.SignatureManifestIsInvalid="SignatureManifestIsInvalid",y.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",y.EntryIsMissing="EntryIsMissing",y.EntryIsTampered="EntryIsTampered",y.Untrusted="Untrusted",y.CertificateRevoked="CertificateRevoked",y.SignatureIsNotValid="SignatureIsNotValid",y.UnknownError="UnknownError",y.PackageIsInvalidZip="PackageIsInvalidZip",y.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(C||(e.ExtensionSignatureVerificationCode=C={}));class A extends Error{constructor(S){super(S),this.code=S}}e.$iq=A;let L=class{constructor(S,$){this.b=S,this.c=$}d(){return this.a||(this.a=new Promise((S,$)=>ne(["@vscode/vsce-sign"],async h=>S(h),$))),this.a}async verify(S,$,h,p){let l;const g=S.identifier.id;try{l=await this.d()}catch(E){return this.b.error("Could not load vsce-sign module",(0,k.$0)(E)),this.b.info(`Extension signature verification is not done: ${g}`),!1}const d=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${g}...`),f=await l.verify($,h,this.b.getLevel()===T.LogLevel.Trace)}catch(E){f={code:C.UnknownError,didExecute:!1,output:(0,k.$0)(E)}}const w=new Date().getTime()-d;if(this.b.info(`Extension signature verification result for ${g}: ${f.code}. Executed: ${f.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${g}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:g,extensionVersion:S.version,code:f.code,internalCode:f.internalCode,duration:w,didExecute:f.didExecute,clientTargetPlatform:p}),f.code===C.Success)return!0;throw new A(f.code)}};e.$jq=L,e.$jq=L=ve([Z(0,T.$7j),Z(1,O.$6l)],L)}),define(le[112],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0;class k{constructor(O){this.b=O}listen(O,C){throw new Error(`Event not found: ${C}`)}call(O,C,{eventName:A,data:L}){return this.b.forEach(y=>y.log(A,L)),Promise.resolve(null)}}e.$jec=k;class a{constructor(O){this.b=O}log(O,C){return this.b.call("log",{eventName:O,data:C}).then(void 0,A=>`Failed to log telemetry: ${console.warn(A)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$kec=a}),define(le[49],he([0,1,30,13,106,110,18]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=S,e.$vp=$,e.$wp=h,e.$xp=p,e.$yp=g,e.$zp=f,e.$Ap=w,e.$Bp=b;class A{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$np=A;class L{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=L,e.$pp=new L;class y{async publicLog(s,o,i){}async publicLogError(s,o,i){}}e.$qp=y,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function S(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function $(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const s=t.getValue(C.$cm),o=t.getValue(C.$dm);if(t.getValue(C.$em)===!1||o===!1)return C.TelemetryLevel.NONE;switch(s??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function p(t){const s={},o={},i={};d(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const r=i[n];typeof r=="number"?o[n]=r:typeof r=="boolean"?o[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),s[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(s[n]=r)}return{properties:s,measurements:o}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(t){if(!t)return"none";const s=(0,T.$Nm)(t);return l.has(s)?s:"other"}function d(t,s,o=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const r=t[n],c=i?i+n:n;Array.isArray(r)?s[c]=(0,k.$bo)(r):r instanceof Date?s[c]=r.toISOString():(0,a.$cg)(r)?o<2?d(r,s,o+1,c+"."):s[c]=(0,k.$bo)(r):s[c]=r}}function f(t,s){const o=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,O.$mp)(o)||i}function w(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function E(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const i=[];for(const m of s)for(;;){const v=m.exec(t);if(!v)break;i.push([v.index,m.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(o="";;){const m=r.exec(t);if(!m)break;const v=i.some(([P,R])=>m.index<R&&P<r.lastIndex);!n.test(m[0])&&!v&&(o+=t.substring(c,m.index)+"<REDACTED: user-file-path>",c=r.lastIndex)}return c<t.length&&(o+=t.substr(c)),o}function u(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function b(t,s){return(0,k.$$n)(t,o=>{if(o instanceof A||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let i=o.replaceAll("%20"," ");i=E(i,s);for(const n of s)i=i.replace(n,"");return i=u(i),i}})}}),define(le[33],he([0,1,27,28,37,5,9,8,36,49]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=S,e.$Ep=l,e.$Fp=g,e.$Gp=d,e.$Hp=f,e.$Ip=w,e.$Jp=E,e.$Kp=u,e.$Mp=b,e.$Np=s;function S(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,k.$wf)(o.id,i.id)===0}const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,n,r)}static parse(i){const n=$.exec(i);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r=T.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==T.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Dp=h;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(o){const i=p.exec(o);return i&&i[1]?[d(i[1]),i[2]]:[d(o),void 0]}function g(o,i){return`${o}.${i}`}function d(o){return o.toLowerCase()}function f(o,i){return d(g(o??T.$Sm,i))}function w(o,i){const n=[],r=c=>{for(const m of n)if(m.some(v=>S(i(v),i(c))))return m;return null};for(const c of o){const m=r(c);m?m.push(c):n.push([c])}return n}function E(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function u(o){return{id:new y.$np(o.identifier.id),name:new y.$np(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Lp=new T.$Wm("pprice.better-merge");function b(o,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(m=>!S(m.identifier,{id:c}))){const m=o.filter(v=>S(v.identifier,{id:c}));m.length===1&&(n.push(m[0]),r.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(o,i){if(!O.$k)return!1;let n;try{n=(await o.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,A.$0)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(o,i){const n=await t(o,i),r=(0,a.$0o)(n?"alpine":O.$u,L.$ec);return i.debug("ComputeTargetPlatform:",r),r}}),define(le[233],he([0,1,26,28,33,37]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=C;async function C(A,L,y,S,$){try{const h=await A.getExtensionsControlManifest();if(!h.deprecated)return;const p=await A.getInstalled(O.ExtensionType.User);for(const[l,g]of Object.entries(h.deprecated)){if(!g?.extension)continue;const{id:d,autoMigrate:f,preRelease:w}=g.extension;if(!f)continue;const E=p.find(b=>(0,T.$Cp)(b.identifier,{id:l}));if(!E)continue;const u=(await L.getExtensions([{id:d,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!u){$.info(`Skipping migrating '${E.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{$.info(`Migrating '${E.identifier.id}' extension to '${d}' extension...`);const b=!S.getDisabledExtensions().some(s=>(0,T.$Cp)(s,E.identifier));await A.uninstall(E),$.info(`Uninstalled the unsupported extension '${E.identifier.id}'`);let t=p.find(s=>(0,T.$Cp)(s.identifier,{id:d}));(!t||!t.isPreReleaseVersion&&b)&&(t=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:E.isMachineScoped,operation:a.InstallOperation.Migrate}),$.info(`Installed the pre-release extension '${t.identifier.id}'`),b||(await S.disableExtension(t.identifier),$.info(`Disabled the pre-release extension '${t.identifier.id}' because the unsupported extension '${E.identifier.id}' is disabled`)),f.storage&&(y.addToMigrationList((0,T.$Fp)(E.manifest.publisher,E.manifest.name),(0,T.$Fp)(t.manifest.publisher,t.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${E.identifier.id}' extension to '${d}' extension.`)}catch(b){$.error(b)}}}catch(h){$.error(h)}}}),define(le[234],he([0,1,3,2,35,33,37,7]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class L extends a.$Uc{constructor(S,$,h,p,l,g,d){super(),this.f=S,this.g=$,this.h=h,this.j=p,this.m=l,this.n=g,this.r=d,this.a=this.B(new k.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new a.$4c),this.s().then(null,f=>d.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map($=>(this.c.set($.id,(0,a.$Rc)(this.n.watch(this.m.extUri.dirname($.extensionsResource)),this.n.watch($.extensionsResource))),this.G($.extensionsResource))))}catch($){throw this.r.error($),$}}async w(S){for(const $ of S.extensions)this.I(this.L($.identifier,$.version),S.profileLocation)}async y(S){for(const $ of S.extensions){const h=this.L($.identifier,$.version);S.error?this.J(h,S.profileLocation):this.I(h,S.profileLocation)}}async z(S){for(const $ of S.extensions)this.J(this.L($.identifier,$.version),S.profileLocation)}async C(S){const $=[],h=[];for(const p of S.extensions){const l=this.L(p.identifier,p.version);S.error?this.I(l,S.profileLocation):(this.J(l,S.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),h.push(this.f.scanInstalledExtensionAtLocation(p.location).then(g=>{g?$.push(g):this.r.info("Extension not found at the location",p.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(h),$.length&&await this.H($)}catch(p){this.r.error(p)}}D(S){for(const $ of this.h.profiles)S.contains($.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F($.extensionsResource)}async F(S){const $=[],h=[],p=await this.j.scanProfileExtensions(S),l=new Set,g=new Set;for(const[d,f]of this.b)f.has(S)&&g.add(d);for(const d of p){const f=this.L(d.identifier,d.version);l.add(f),g.has(f)||($.push(d.identifier),this.I(f,S))}for(const d of g)if(!l.has(d)){const f=this.M(d);f&&(h.push(f.identifier),this.J(d,S))}($.length||h.length)&&this.a.fire({added:$.length?{extensions:$,profileLocation:S}:void 0,removed:h.length?{extensions:h,profileLocation:S}:void 0})}async G(S){const $=await this.j.scanProfileExtensions(S);for(const h of $)this.I(this.L(h.identifier,h.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,$){let h=this.b.get(S);h||this.b.set(S,h=new T.$Bc(p=>this.m.extUri.getComparisonKey(p))),h.add($)}J(S,$){const h=this.b.get(S);h&&h.delete($),h?.size||this.b.delete(S)}L(S,$){return`${C.$Wm.toKey(S.id)}@${$}`}M(S){const[$,h]=(0,O.$Ep)(S);return h?{identifier:{id:$},version:h}:void 0}}e.$Lq=L}),define(le[235],he([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;let g=class extends p.$1r{constructor(E,u,b,t){super(b),this.h=E,this.j=t,this.g=this.B(new d(u,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(E,u){const t=(await this.g.getLanguagePacks())[u];if(!t){this.j.warn(`No language pack found for ${u}`);return}const s=t.translations[E];return s?l.URI.file(s):void 0}async getInstalledLanguages(){const E=await this.g.getLanguagePacks(),u=Object.keys(E).map(b=>{const t=E[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((b,t)=>b.label.localeCompare(t.label)),u}async m(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",E.identifier.id),await this.update())}async n(E){const u=await this.g.getLanguagePacks();Object.keys(u).some(b=>u[b]&&u[b].extensions.some(t=>(0,$.$Cp)(t.extensionIdentifier,E.identifier)))&&(this.j.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(u);return!(0,a.$ub)(Object.keys(E),Object.keys(b))}};e.$2r=g,e.$2r=g=ve([Z(0,S.$ep),Z(1,y.$Ii),Z(2,S.$bp),Z(3,h.$7j)],g);let d=class extends O.$Uc{constructor(E,u){super(),this.j=u,this.c={},this.f=(0,A.$jc)(E.userDataPath,"languagepacks.json"),this.g=new T.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(E){return this.s(u=>{Object.keys(u).forEach(b=>delete u[b]),this.m(u,...E)}).then(()=>this.c)}m(E,...u){for(const b of u)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.n(E,b);Object.keys(E).forEach(b=>this.r(E[b]))}n(E,u){const b=u.identifier,t=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of t)if(u.location.scheme===C.Schemas.file&&f(s)){let o=E[s.languageId];o||(o={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},E[s.languageId]=o);const i=o.extensions.filter(n=>(0,$.$Cp)(n.extensionIdentifier,b))[0];i?i.version=u.manifest.version:o.extensions.push({extensionIdentifier:b,version:u.manifest.version});for(const n of s.translations)o.translations[n.id]=(0,A.$jc)(u.location.fsPath,n.path)}}r(E){if(E){const u=(0,k.createHash)("md5");for(const b of E.extensions)u.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);E.hash=u.digest("hex")}}s(E=()=>null){return this.g.queue(()=>{let u=null;return L.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(u=E(b),b)).then(b=>{for(const s of Object.keys(b))b[s]||delete b[s];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),L.Promises.writeFile(this.f,t)}).then(()=>u,b=>this.j.error(b))})}};d=ve([Z(0,y.$Ii),Z(1,h.$7j)],d);function f(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const E of w.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(le[236],he([0,1,149,8,30,49]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function L(S,$,h){const p=await(0,k.$gE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,k.$gE)("@microsoft/1ds-post-js","dist/ms.post.js"),g=new p.AppInsightsCore,d=new l.PostChannel,f={instrumentationKey:S,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(h){f.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[d.identifier]=w}return g.initialize(f,[]),g.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),g}class y{constructor($,h,p,l,g){this.e=$,this.f=h,this.g=p,this.h=g,this.c=C,this.d=A,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=L(this.a,this.e,this.h)),this.b.then(h=>{$(h)},h=>{(0,a.$1)(h),console.error(h)})}}log($,h){if(!this.a)return;h=(0,T.$_n)(h,this.g),h=(0,O.$xp)(h);const p=this.f+"/"+$;try{this.i(l=>{l.pluginVersionString=h?.properties.version??"Unknown",l.track({name:p,baseData:{name:p,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$$P=y}),define(le[113],he([0,1,2,178,16,10,24,49]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;let L=class extends k.$Uc{constructor(S,$,h,p,l=""){super(),this.b=l;const g=$.getLogger(A.$rp);if(g)this.a=this.B(g);else{const f=(0,A.$vp)(p,h)?" (Not Sent)":"",w=()=>(0,A.$up)(p,h)&&S.getLevel()===O.LogLevel.Trace;this.a=this.B($.createLogger(A.$rp,{name:(0,a.localize)(0,null,f),hidden:!w()})),this.B(S.onDidChangeLogLevel(()=>$.setVisibility(A.$rp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,$){this.a.trace(`${this.b}telemetry/${S}`,(0,A.$xp)($))}};e.$Abc=L,e.$Abc=L=ve([Z(0,O.$7j),Z(1,O.$8j),Z(2,T.$Hi),Z(3,C.$nk)],L)}),define(le[114],he([0,1,2,30,5,27,179,22,48,103,24,45,18,49]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,w,E){this.k=w,this.l=E,this.d={},this.i=new k.$Tc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,O.$df)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$df)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(h.$cm)||u.affectsConfiguration(h.$em)||u.affectsConfiguration(h.$dm))&&this.m()}))}setExperimentProperty(f,w){this.d[f]=w}m(){let f=(0,p.$wp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const E=w.usage?h.TelemetryLevel.USAGE:w.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,E)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,w,E){this.g<w||(E=(0,a.$_n)(E,this.d),E=(0,p.$Bp)(E,this.j),E=(0,a.$_n)(E,this.c),this.b.forEach(u=>u.log(f,E)))}publicLog(f,w){this.n(f,h.TelemetryLevel.USAGE,w)}publicLog2(f,w){this.publicLog(f,w)}publicLogError(f,w){this.h&&this.n(f,h.TelemetryLevel.ERROR,w)}publicLogError2(f,w){this.publicLogError(f,w)}};e.$8r=l,e.$8r=l=ve([Z(1,A.$7i),Z(2,S.$nk)],l);function g(){const d=(0,C.localize)(0,null,y.default.nameLong),f=y.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=T.$o?"":(0,C.localize)(3,null),E=(0,C.localize)(4,null),u=(0,C.localize)(5,null),b=(0,C.localize)(6,null),t=(0,C.localize)(7,null),s=`
|       | ${E} | ${u} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${d} ${f} ${w}

&nbsp;

${t}
${s}

&nbsp;

${o}
`}$.$jo.as(L.$oo.Configuration).registerConfiguration({id:h.$bm,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[h.$cm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:g(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:L.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),$.$jo.as(L.$oo.Configuration).registerConfiguration({id:h.$bm,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[h.$em]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,C.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,C.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${h.$cm}#\``),scope:L.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[237],he([0,1,15,26,281,236]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;async function C(S,$){const h=await $.request(S,a.CancellationToken.None),p=(await(0,k.$Ve)(h.stream)).toString(),l=h.res.statusCode??200;return{headers:h.res.headers,statusCode:l,responseData:p}}async function A(S){const $={method:S.type,headers:S.headers};return new Promise((p,l)=>{const g=T.request(S.url??"",$,d=>{d.on("data",function(f){p({headers:d.headers,statusCode:d.statusCode??200,responseData:f.toString()})}),d.on("error",function(f){l(f)})});g.write(S.data,d=>{d&&l(d)}),g.end()})}async function L(S,$,h){const p=typeof $.data=="string"?$.data:new TextDecoder().decode($.data),l={type:"POST",headers:{...$.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength($.data).toString()},url:$.urlString,data:p};try{const g=S?await C(l,S):await A(l);h(g.statusCode,g.headers,g.responseData)}catch{h(0,{})}}class y extends O.$$P{constructor($,h,p,l,g){const d={sendPOST:(f,w)=>{L($,f,w)}};super(h,p,l,g,d)}}e.$_P=y}),define(le[238],he([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;let h=class{constructor(l,g,d,f,w,E){this.b=l,this.c=g,this.d=d,this.e=f,this.f=w,this.g=E,this.a=new Map}h(l){if(!this.a.has(l.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.c.machineId,g["common.vscodesessionid"]=this.c.sessionId;const d=[l.id,JSON.stringify(g),l.aiKey],w=new a.$9q(k.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=[new y.$kec(w),new S.$Abc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new $.$8r({appenders:E,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,g,d){this.h(l).publicLog(g,d)}publicLogError(l,g,d){this.h(l).publicLogError(g,d)}};e.$yfc=h,e.$yfc=h=ve([Z(0,T.$7i),Z(1,L.$6l),Z(2,C.$7j),Z(3,C.$8j),Z(4,O.$Hi),Z(5,A.$nk)],h)}),define(le[81],he([0,1,3,5,9,22,4,10]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$yw=e.$ww=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$sw=e.$rw=void 0,e.$tw=S,e.$uw=h,e.$vw=p,e.$xw=l,e.$zw=g,e.$Aw=d,e.$rw=(0,C.$Ai)("tunnelService"),e.$sw=(0,C.$Ai)("sharedTunnelsService");var L;(function(E){E.Http="http",E.Https="https"})(L||(e.TunnelProtocol=L={}));var y;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(y||(e.TunnelPrivacyId=y={}));function S(E){return!!E.forwardPort}var $;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function h(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(u)return{address:u[1],port:+u[2]}}function p(E){if(E.scheme!=="http"&&E.scheme!=="https"||!E.query)return;const u=E.query.split("&");for(const b of u){const t=b.split("=")[1];if(/^https?:/.exec(t)){const s=h(T.URI.parse(t));if(s)return s}}}e.$ww=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(E){return e.$ww.indexOf(E)>=0}e.$yw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(E){return e.$yw.indexOf(E)>=0}function d(E,u,b,t){if(b===a.OperatingSystem.Windows)return!1;if(b===a.OperatingSystem.Macintosh&&g(u)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(s?.length===4&&parseInt(s[1])>=18)return!1}return E<1024}class f{constructor(u,b,t){this.remoteAddress=u,this.localAddress=b,this.b=t,this.a=new k.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Bw=f;let w=class{constructor(u,b){this.k=u,this.l=b,this.a=new k.$he,this.onTunnelOpened=this.a.event,this.b=new k.$he,this.onTunnelClosed=this.b.event,this.c=new k.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],b=Array.from(this.e.values());for(const t of b){const s=Array.from(t.values());for(const o of s){const i=await o.value;i&&typeof i!="string"&&u.push(i)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:b}of u.values())await b.then(t=>typeof t!="string"?t?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,b,t,s,o){this.q(u,b,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:b,localAddress:t,privacy:s,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,b){(g(u)||l(u))&&(u=e.$ww[0]);const t=this.s(u,b);if(t)return++t.refcount,t.value}openTunnel(u,b,t,s,o,i=!1,n,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${t} on local port ${o}.`);const c=this.f??u;if(!c)return;if(b||(b="localhost"),s||(s=this.m),this.f&&this.j.has(t)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(c,b,t,s,o,i,n,r);return m?m.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(b,t),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(b,t);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const P=this.o(v);return(v.tunnelRemoteHost!==b||v.tunnelRemotePort!==t)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&v.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(P),P}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const b=this.e.get(u.tunnelRemoteHost);if(b){const t=b.get(u.tunnelRemotePort);t&&(t.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,t))}}}}async p(u,b,t){if(t.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${b}.`);const s=t.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(b),s}}async closeTunnel(u,b){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${b} `);const t=this.e.get(u);if(t&&t.has(b)){const s=t.get(b);s.refcount=0,await this.p(u,b,s)}}q(u,b,t){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(b,{refcount:1,value:t})}async r(u,b){const t=this.e.get(u);if(t){const s=t.get(b),o=s?await s.value:void 0;(!o||typeof o=="string")&&t.delete(b),t.size===0&&this.e.delete(u)}}s(u,b){const t=[u];l(u)?(t.push(...e.$ww),t.push(...e.$yw)):g(u)&&t.push(...e.$yw);const s=t.map(o=>this.e.get(o));for(const o of s){const i=o?.get(b);if(i)return i}}canTunnel(u){return!!h(u)}u(u,b,t,s,o,i,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${t} on local port ${s}.`);const r=t;this.j.add(r);const c=s===void 0?t:s,m={elevationRequired:o?this.isPortPrivileged(c):!1},v={remoteAddress:{host:b,port:t},localAddressPort:s,privacy:i,public:i?i!==y.Private:void 0,protocol:n},P=u.forwardPort(v,m);return P?(this.q(b,t,P),P.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),P}};e.$Cw=w,e.$Cw=w=ve([Z(0,A.$7j),Z(1,O.$7i)],w)}),define(le[239],he([0,1,10,81,2,8,6]),function(ne,e,k,a,T,O,C){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;class L extends T.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new C.$Xh),this.b.p)}setAddress($){this.a=$,this.b&&(this.b.complete($),this.b=null)}setTunnel($){this.B($)}}let y=class extends T.$Uc{static{A=this}static{this.a=0}constructor($,h){super(),this.f=$,this.g=h,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach($=>$.dispose())}async createTunnel(){return{id:String(++A.a)}}async startTunnel($,h,p,l,g,d,f){const w=new L,E=await Promise.resolve(this.f.openTunnel($,w,p,l,g,d,f));if(!E||typeof E=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(h))throw this.c.delete(h),w.dispose(),await E.dispose(),(0,O.$6)();return w.setTunnel(E),this.b.set(h,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${E.localAddress} (local) to ${p}:${l} (remote).`),{tunnelLocalPort:E.tunnelLocalPort,localAddress:E.localAddress}}async setAddress($,h){const p=this.b.get($);p&&p.setAddress(h)}async destroyTunnel($){const h=this.b.get($);if(h){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${$}.`),this.b.delete($),await h.dispose();return}this.c.add($)}};e.$Ifc=y,e.$Ifc=y=A=ve([Z(0,a.$sw),Z(1,k.$7j)],y)}),define(le[29],he([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,k.$Ai)("IUriIdentityService")}),define(le[240],he([0,1,29,196,7,21,133,3,2]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class y{static{this._clock=0}constructor(h){this.uri=h,this.time=y._clock++}touch(){return this.time=y._clock++,this}}let S=class{constructor(h){this.g=h,this.c=new L.$Tc,this.f=2**16;const p=new Map,l=g=>{let d=p.get(g.scheme);return d===void 0&&(d=h.hasProvider(g)&&!this.g.hasCapability(g,T.FileSystemProviderCapabilities.PathCaseSensitive),p.set(g.scheme,d)),d};this.c.add(A.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new O.$3g(l),this.d=new C.$Hs((g,d)=>this.extUri.compare(g,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,O.$ch)(h));const p=this.d.get(h);return p?p.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new y(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((l,g)=>l[1].time<g[1].time?1:l[1].time>g[1].time?-1:0);y._clock=0,this.d.clear();const p=this.f*.5;for(let l=0;l<p;l++)this.d.set(h[l][0],h[l][1].touch())}};e.$Is=S,e.$Is=S=ve([Z(0,T.$7k)],S),(0,a.$Fs)(k.$El,S,a.InstantiationType.Delayed)}),define(le[241],he([0,1,3,2,7,52,35]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class A extends a.$Uc{constructor(y,S,$,h,p,l){super(),this.f=y,this.g=S,this.h=$,this.j=h,this.m=p,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new k.$he),this.onDidChangeFile=this.a.event,this.b=O.$Gi.forUris(()=>!(this.capabilities&T.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new C.$Bc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const y of this.j.profiles)this.c.add(y.settingsResource),this.c.add(y.keybindingsResource),this.c.add(y.tasksResource),this.c.add(y.extensionsResource)}open(y,S){return this.g.open(this.t(y),S)}close(y){return this.g.close(y)}read(y,S,$,h,p){return this.g.read(y,S,$,h,p)}write(y,S,$,h,p){return this.g.write(y,S,$,h,p)}watch(y,S){this.b.set(y,y);const $=this.g.watch(this.t(y),S);return(0,a.$Sc)(()=>{this.b.delete(y),$.dispose()})}stat(y){return this.g.stat(this.t(y))}mkdir(y){return this.g.mkdir(this.t(y))}rename(y,S,$){return this.g.rename(this.t(y),this.t(S),$)}readFile(y,S){return this.g.readFile(this.t(y),S)}readFileStream(y,S,$){return this.g.readFileStream(this.t(y),S,$)}readdir(y){return this.g.readdir(this.t(y))}enforceAtomicReadFile(y){return this.c.has(y)}writeFile(y,S,$){return this.g.writeFile(this.t(y),S,$)}enforceAtomicWriteFile(y){return this.c.has(y)?{postfix:".vsctmp"}:!1}delete(y,S){return this.g.delete(this.t(y),S)}copy(y,S,$){if((0,T.$$k)(this.g))return this.g.copy(this.t(y),this.t(S),$);throw new Error("copy not supported")}cloneFile(y,S){if((0,T.$_k)(this.g))return this.g.cloneFile(this.t(y),this.t(S));throw new Error("clone not supported")}s(y){const S=[];for(const $ of y){if($.resource.scheme!==this.f)continue;const h=this.u($.resource);this.b.findSubstr(h)&&S.push({resource:h,type:$.type,cId:$.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(y){return y.with({scheme:this.f})}u(y){return y.with({scheme:this.h})}}e.$_ec=A}),define(le[82],he([0,1,63]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$6Kb=T,e.$7Kb=O;function a(C,A,L,y){const S=(0,k.$5n)(C,A,L,y)[0];return S&&(C=C.substring(0,S.offset)+S.content+C.substring(S.offset+S.length)),C}function T(C,A,L){let y=L;for(;y>=0;){if(C.charAt(y)===A.charAt(A.length-1)&&A.length===1)return y+1;if(y--,A.length===2&&y>=0&&C.charAt(y)===A.charAt(0))return y+2}return 0}function O(C,A,L){let y=L;for(;y>=0;)if(C.charAt(y)===A.charAt(A.length-1)&&A.length===1||(y++,A.length===2&&y>=0&&C.charAt(y)===A.charAt(1)))return y;return C.length-1}}),define(le[242],he([0,1,30,56,13]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=O;function O(p,l,g,d,f,w){const E=[],u=[],b=[];if(!l){const F=p.filter(({identifier:X})=>f.every(K=>K.toLowerCase()!==X.id.toLowerCase()));return{local:{added:E,removed:u,updated:b},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}p=p.map($),l=l.map($),g=g?g.map($):null;const t=new Map,s=F=>{F.uuid&&t.set(F.id.toLowerCase(),F.uuid)};p.forEach(({identifier:F})=>s(F)),l.forEach(({identifier:F})=>s(F)),g?.forEach(({identifier:F})=>s(F)),d?.forEach(({identifier:F})=>s(F)),w?.forEach(F=>s(F));const o=F=>{const X=F.identifier.uuid||t.get(F.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${F.identifier.id.toLowerCase()}`},i=(F,X)=>(F.set(o(X),X),F),n=p.reduce(i,new Map),r=l.reduce(i,new Map),c=l.reduce((F,X)=>i(F,(0,k.$9n)(X)),new Map),m=g?g.reduce(i,new Map):null,v=d.reduce(i,new Map),P=f.reduce((F,X)=>{const K=t.get(X.toLowerCase());return F.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)},new Set),R=w?w.reduce((F,{id:X,uuid:K})=>(K=K??t.get(X.toLowerCase()),F.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)),new Set):null,I=C(n,r,P,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const F=C(m,n,P,!1),X=C(m,r,P,!0),K=(Q,V,ie,H)=>{let W,ee,re;return V.installed?(W=H.pinned,re=H.preRelease,W&&(ee=H.version)):(W=ie.pinned,re=ie.preRelease,W&&(ee=ie.version)),W===void 0&&(W=V.pinned,W&&(ee=V.version)),re===void 0&&(re=V.preRelease),{...H,installed:V.installed||ie.installed,pinned:W,preRelease:re,version:ee??(ie.version&&(!V.installed||a.gt(ie.version,V.version))?ie.version:V.version),state:L(V,ie,m?.get(Q))}};for(const Q of X.removed.values()){const V=n.get(Q);if(!V)continue;const ie=(0,T.$lg)(m?.get(Q)),H=R&&!R.has(Q)&&ie.installed;V.installed&&H?u.push(V.identifier):c.set(Q,V)}for(const Q of X.added.values()){const V=(0,T.$lg)(r.get(Q)),ie=n.get(Q);if(ie){if(I.updated.has(Q)){const H=K(Q,ie,V,V);A(ie,V,!1,!1)||b.push(h(H,Q)),c.set(Q,H)}}else V.installed&&E.push(h(V,Q))}for(const Q of X.updated.values()){const V=(0,T.$lg)(r.get(Q)),ie=(0,T.$lg)(m?.get(Q)),H=n.get(Q);if(H)if(R&&!R.has(Q)&&ie.installed&&H.installed&&!V.installed)u.push(H.identifier);else{const ee=K(Q,H,V,V);b.push(h(ee,Q)),c.set(Q,ee)}else V.installed&&E.push(h(V,Q))}for(const Q of F.added.values())X.added.has(Q)||c.set(Q,(0,T.$lg)(n.get(Q)));for(const Q of F.updated.values()){if(X.removed.has(Q)||X.updated.has(Q))continue;const V=(0,T.$lg)(n.get(Q)),ie=(0,T.$lg)(r.get(Q));c.set(Q,K(Q,V,ie,V))}for(const Q of F.removed.values())X.updated.has(Q)||X.removed.has(Q)||v.has(Q)||(0,T.$lg)(r.get(Q)).installed&&R&&(R.has(Q)||!(0,T.$lg)(m?.get(Q)).installed||c.delete(Q))}const N=[],U=C(r,c,new Set,!0),j=U.added.size>0||U.updated.size>0||U.removed.size>0;return j&&c.forEach((F,X)=>N.push(h(F,X))),{local:{added:E,removed:u,updated:b},remote:j?{added:[...U.added].map(F=>c.get(F)),updated:[...U.updated].map(F=>c.get(F)),removed:[...U.removed].map(F=>r.get(F)),all:N}:null}}function C(p,l,g,d){const f=p?[...p.keys()].filter(t=>!g.has(t)):[],w=[...l.keys()].filter(t=>!g.has(t)),E=w.filter(t=>!f.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),u=f.filter(t=>!w.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),b=new Set;for(const t of f){if(u.has(t))continue;const s=p.get(t),o=l.get(t);(!o||!A(s,o,d,!0))&&b.add(t)}return{added:E,removed:u,updated:b}}function A(p,l,g,d){return!(p.disabled!==l.disabled||!!p.isApplicationScoped!=!!l.isApplicationScoped||d&&p.installed!==l.installed||p.installed&&l.installed&&(p.preRelease!==l.preRelease||p.pinned!==l.pinned||l.pinned&&p.version!==l.version)||!S(p.state,l.state)||g&&p.version!==l.version)}function L(p,l,g){const d=p.state,f=l.state,w=g?.state;if(!l.version||d&&a.gt(p.version,l.version))return d;if(f&&a.gt(l.version,p.version)||!d)return f;if(!f)return d;const E=(0,k.$9n)(d),u=w?y(w,f):{added:Object.keys(f).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set},b=w?y(w,d):{added:Object.keys(d).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set};for(const t of[...u.added.values(),...u.updated.values()])E[t]=f[t];for(const t of u.removed.values())b.updated.has(t)||delete E[t];return E}function y(p,l){const g=Object.keys(p),d=Object.keys(l),f=d.filter(u=>!g.includes(u)).reduce((u,b)=>(u.add(b),u),new Set),w=g.filter(u=>!d.includes(u)).reduce((u,b)=>(u.add(b),u),new Set),E=new Set;for(const u of g){if(w.has(u))continue;const b=p[u],t=l[u];(0,k.$ao)(b,t)||E.add(u)}return{added:f,removed:w,updated:E}}function S(p={},l={}){const{added:g,removed:d,updated:f}=y(p,l);return g.size===0&&d.size===0&&f.size===0}function $(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function h(p,l){const g={...p,identifier:{id:p.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!p.preRelease,pinned:!!p.pinned};return p.disabled||delete g.disabled,p.installed||delete g.installed,p.state||delete g.state,p.isApplicationScoped||delete g.isApplicationScoped,g}}),define(le[115],he([0,1,19,22,4]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kNb=e.$jNb=void 0,e.$jNb=(0,T.$Ai)("IIgnoredExtensionsManagementService");let O=class{constructor(A){this.a=A}hasToNeverSyncExtension(A){return this.b().includes(A.toLowerCase())}hasToAlwaysSyncExtension(A){return this.b().includes(`-${A.toLowerCase()}`)}updateIgnoredExtensions(A,L){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return y=y.filter(S=>S!==A&&S!==`-${A}`),L&&y.push(A.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(A,L){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return y=y.filter(S=>S!==A&&S!==`-${A}`),L&&y.push(`-${A.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(A){const L=A.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),y=this.b().map(h=>h.toLowerCase()),S=[],$=[];if(Array.isArray(y))for(const h of y)h.startsWith("-")?$.push(h.substring(1)):S.push(h);return(0,k.$Mb)([...L,...S].filter(h=>!$.includes(h)))}b(){let A=this.a.inspect("settingsSync.ignoredExtensions").userValue;return A!==void 0||(A=this.a.inspect("sync.ignoredExtensions").userValue,A!==void 0)?A:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(L=>L.toLowerCase())}};e.$kNb=O,e.$kNb=O=ve([Z(0,a.$7i)],O)}),define(le[243],he([0,1,19,34,30,97,82]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=L;function A(u){return(0,a.$Pn)(u)||[]}async function L(u,b,t,s,o){const i=A(u),n=A(b),r=t?A(t):null,c=[...i,...n,...r||[]].map(K=>K.key),m=await o.resolveUserBindings(c),v=S(i,n,r,m);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};const P=h(i),R=h(n),I=r?h(r):null,N=l(P,R,m),U=I?l(I,P,m):{added:[...P.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},j=I?l(I,R,m):{added:[...R.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},F=y(N,U,j);let X=u;for(const K of F.removed.values())F.conflicts.has(K)||(X=w(X,K,s));for(const K of F.added.values()){if(F.conflicts.has(K))continue;const Q=R.get(K);if(Q.some(V=>V.command!==`-${K}`&&v.conflicts.has(m[V.key]))){F.conflicts.add(K);continue}X=f(X,Q,s)}for(const K of F.updated.values()){if(F.conflicts.has(K))continue;const Q=R.get(K);if(Q.some(V=>V.command!==`-${K}`&&v.conflicts.has(m[V.key]))){F.conflicts.add(K);continue}X=E(X,K,Q,s)}return{mergeContent:X,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function y(u,b,t){const s=new Set,o=new Set,i=new Set,n=new Set;for(const r of b.removed.values())t.updated.has(r)&&n.add(r);for(const r of t.removed.values())n.has(r)||(b.updated.has(r)?n.add(r):o.add(r));for(const r of b.added.values())n.has(r)||t.added.has(r)&&u.updated.has(r)&&n.add(r);for(const r of t.added.values())n.has(r)||(b.added.has(r)?u.updated.has(r)&&n.add(r):s.add(r));for(const r of b.updated.values())n.has(r)||t.updated.has(r)&&u.updated.has(r)&&n.add(r);for(const r of t.updated.values())n.has(r)||(b.updated.has(r)?u.updated.has(r)&&n.add(r):i.add(r));return{added:s,removed:o,updated:i,conflicts:n}}function S(u,b,t,s){const o=new Set,i=$(u,s),n=$(b,s),r=t?$(t,s):null,c=p(i,n);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:o,removed:o,updated:o,conflicts:o};const m=r?p(r,i):{added:[...i.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:o,removed:o,updated:o,conflicts:o};const v=r?p(r,n):{added:[...n.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:o,removed:o,updated:o,conflicts:o};const{added:P,removed:R,updated:I,conflicts:N}=y(c,m,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:R,updated:I,conflicts:N}}function $(u,b){const t=new Map;for(const s of u){const o=b[s.key];let i=t.get(o);i||(i=[],t.set(o,i)),i.push(s)}return t}function h(u){const b=new Map;for(const t of u){const s=t.command[0]==="-"?t.command.substring(1):t.command;let o=b.get(s);o||(o=[],b.set(s,o)),o.push(t)}return b}function p(u,b){const t=[...u.keys()],s=[...b.keys()],o=s.filter(r=>!t.includes(r)).reduce((r,c)=>(r.add(c),r),new Set),i=t.filter(r=>!s.includes(r)).reduce((r,c)=>(r.add(c),r),new Set),n=new Set;for(const r of t){if(i.has(r))continue;const c=u.get(r).map(v=>({...v,key:r})),m=b.get(r).map(v=>({...v,key:r}));(0,k.$ub)(c,m,(v,P)=>d(v,P))||n.add(r)}return{added:o,removed:i,updated:n}}function l(u,b,t){const s=[...u.keys()],o=[...b.keys()],i=o.filter(c=>!s.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),n=s.filter(c=>!o.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),r=new Set;for(const c of s){if(n.has(c))continue;const m=u.get(c).map(P=>({...P,key:t[P.key]})),v=b.get(c).map(P=>({...P,key:t[P.key]}));g(m,v)||r.add(c)}return{added:i,removed:n,updated:r}}function g(u,b){return!(!(0,k.$ub)(u.filter(({command:t})=>t[0]!=="-"),b.filter(({command:t})=>t[0]!=="-"),(t,s)=>d(t,s))||!(0,k.$ub)(u.filter(({command:t})=>t[0]==="-"),b.filter(({command:t})=>t[0]==="-"),(t,s)=>d(t,s)))}function d(u,b){if(u.command!==b.command||u.key!==b.key)return!1;const t=O.$yj.deserialize(u.when),s=O.$yj.deserialize(b.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!T.$ao(u.args,b.args))}function f(u,b,t){for(const s of b)u=C.edit(u,[-1],s,t);return u}function w(u,b,t){const s=A(u);for(let o=s.length-1;o>=0;o--)(s[o].command===b||s[o].command===`-${b}`)&&(u=C.edit(u,[o],void 0,t));return u}function E(u,b,t,s){const o=A(u),i=o.findIndex(n=>n.command===b||n.command===`-${b}`);for(let n=o.length-1;n>=0;n--)(o[n].command===b||o[n].command===`-${b}`)&&(u=C.edit(u,[n],void 0,s));for(let n=t.length-1;n>=0;n--)u=C.edit(u,[i],t[n],s);return u}}),define(le[244],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=k,e.$sac=T;function k(O,C,A){const L={},y={},S=new Set;if(!C)return{local:{added:L,updated:y,removed:[...S.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const $=a(O,C);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{local:{added:L,updated:y,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=a(A,O),p=a(A,C),l={},g={},d=new Set,f=new Set;for(const w of h.removed.values())p.updated.has(w)?L[w]=C[w]:d.add(w);for(const w of p.removed.values())f.has(w)||(h.updated.has(w)?f.add(w):S.add(w));for(const w of h.updated.values())f.has(w)||(p.updated.has(w)?$.updated.has(w)&&f.add(w):g[w]=O[w]);for(const w of p.updated.values())f.has(w)||(h.updated.has(w)?$.updated.has(w)&&f.add(w):O[w]!==void 0&&(y[w]=C[w]));for(const w of h.added.values())f.has(w)||(p.added.has(w)?$.updated.has(w)&&f.add(w):l[w]=O[w]);for(const w of p.added.values())f.has(w)||(h.added.has(w)?$.updated.has(w)&&f.add(w):L[w]=C[w]);return{local:{added:L,removed:[...S.values()],updated:y},remote:{added:l,removed:[...d.values()],updated:g},conflicts:[...f.values()]}}function a(O,C){const A=O?Object.keys(O):[],L=C?Object.keys(C):[],y=L.filter(h=>!A.includes(h)).reduce((h,p)=>(h.add(p),h),new Set),S=A.filter(h=>!L.includes(h)).reduce((h,p)=>(h.add(p),h),new Set),$=new Set;for(const h of A){if(S.has(h))continue;const p=O[h],l=C[h];p!==l&&$.add(h)}return{added:y,removed:S,updated:$}}function T(O,C){const{added:A,removed:L,updated:y}=a(O,C);return A.size===0&&L.size===0&&y.size===0}}),define(le[245],he([0,1,30]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=a;function a(O,C,A,L){const y={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!C){const h=O.filter(({id:p})=>!L.includes(p));return h.length?S.added=h:S=null,{local:y,remote:S}}const $=T(O,C,L);if($.added.length>0||$.removed.length>0||$.updated.length>0){const h=T(A,O,L),p=T(A,C,L);for(const l of p.removed){const g=O.find(d=>d.id===l);g&&y.removed.push(g)}for(const l of p.added){const g=C.find(d=>d.id===l);h.added.includes(l)?$.updated.includes(l)&&y.updated.push(g):y.added.push(g)}for(const l of p.updated)y.updated.push(C.find(g=>g.id===l));for(const l of h.added)p.added.includes(l)||S.added.push(O.find(g=>g.id===l));for(const l of h.updated)p.removed.includes(l)||p.updated.includes(l)||S.updated.push(O.find(g=>g.id===l));for(const l of h.removed){const g=C.find(d=>d.id===l);g&&S.removed.push(g)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:y,remote:S}}function T(O,C,A){O=O?O.filter(({id:p})=>!A.includes(p)):[],C=C.filter(({id:p})=>!A.includes(p));const L=O.map(({id:p})=>p),y=C.map(({id:p})=>p),S=y.filter(p=>!L.includes(p)),$=L.filter(p=>!y.includes(p)),h=[];for(const{id:p,name:l,shortName:g,icon:d,useDefaultFlags:f}of O){if($.includes(p))continue;const w=C.find(E=>E.id===p);(!w||w.name!==l||w.shortName!==g||w.icon!==d||!(0,k.$ao)(w.useDefaultFlags,f))&&h.push(p)}return{added:S,removed:$,updated:h}}}),define(le[25],he([0,1,19,13,185,48,28,4,104,45]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmb=e.$lmb=e.$kmb=e.$jmb=e.$imb=e.$hmb=e.$gmb=e.$fmb=e.$emb=e.$cmb=e.MergeState=e.Change=e.SyncStatus=e.$bmb=e.$amb=e.$_lb=e.UserDataSyncErrorCode=e.$0lb=e.$9lb=e.$8lb=e.$7lb=e.$6lb=e.$3lb=e.SyncResource=e.$Zlb=e.$Ylb=void 0,e.$Wlb=S,e.$Xlb=$,e.$1lb=h,e.$2lb=p,e.$4lb=g,e.$5lb=d,e.$$lb=f,e.$dmb=i;function S(){const n=y.$jo.as(O.$oo.Configuration).getConfigurationProperties();return Object.keys(n).filter(r=>!!n[r].disallowSyncIgnore)}function $(){const n=y.$jo.as(O.$oo.Configuration).getConfigurationProperties(),r=Object.keys(n).filter(v=>!!n[v].ignoreSync),c=Object.keys(n).filter(v=>n[v].scope===O.ConfigurationScope.MACHINE||n[v].scope===O.ConfigurationScope.MACHINE_OVERRIDABLE),m=S();return(0,k.$Mb)([...r,...c,...m])}e.$Ylb="settingsSync",e.$Zlb="settingsSync.keybindingsPerPlatform";function h(){const n="vscode://schemas/ignoredSettings",r=y.$jo.as(O.$oo.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{[e.$Zlb]:{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:O.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:C.$1o,errorMessage:(0,T.localize)(3,null)}],default:[],scope:O.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:O.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=y.$jo.as(L.$ko.JSONContribution),m=()=>{const v=S(),P=$(),R=Object.keys(O.$po.properties).filter(U=>!P.includes(U)),I=P.filter(U=>!v.includes(U)),N={items:{type:"string",enum:[...R,...I.map(U=>`-${U}`)]}};c.registerSchema(n,N)};return r.onDidUpdateConfiguration(()=>m())}function p(n){return n&&(0,a.$cg)(n)&&(0,a.$ag)(n.id)&&Array.isArray(n.scopes)}var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(l||(e.SyncResource=l={})),e.$3lb=[l.Settings,l.Keybindings,l.Snippets,l.Tasks,l.Extensions,l.GlobalState,l.Profiles];function g(n,...r){return n?[n,...r]:r}function d(n,r,c,m){return m.joinPath(c.userDataSyncHome,...g(n,r,`lastSync${r}.json`))}e.$6lb=(0,A.$Ai)("IUserDataSyncStoreManagementService"),e.$7lb=(0,A.$Ai)("IUserDataSyncStoreService"),e.$8lb=(0,A.$Ai)("IUserDataSyncLocalStoreService"),e.$9lb="x-operation-id",e.$0lb="X-Execution-Id";function f(n){const r={};return r[e.$0lb]=n,r}var w;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(w||(e.UserDataSyncErrorCode=w={}));class E extends Error{constructor(r,c,m,v){super(r),this.code=c,this.resource=m,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$_lb=E;class u extends E{constructor(r,c,m,v,P){super(r,m,void 0,P),this.url=c,this.serverCode=v}}e.$amb=u;class b extends E{constructor(r,c){super(r,c)}}e.$bmb=b,function(n){function r(c){if(c instanceof n)return c;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(m&&m[1]){const v=m[2]==="unknown"?void 0:m[2],P=m[3]==="unknown"?void 0:m[3];return new n(c.message,m[1],v,P)}return new n(c.message,w.Unknown)}n.toUserDataSyncError=r}(E||(e.$_lb=E={}));var t;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var s;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(s||(e.Change=s={}));var o;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(o||(e.MergeState=o={})),e.$cmb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$emb=(0,A.$Ai)("IUserDataSyncEnablementService"),e.$fmb=(0,A.$Ai)("IUserDataSyncService"),e.$gmb=(0,A.$Ai)("IUserDataSyncResourceProviderService"),e.$hmb=(0,A.$Ai)("IUserDataAutoSyncService"),e.$imb=(0,A.$Ai)("IUserDataSyncUtilService"),e.$jmb=(0,A.$Ai)("IUserDataSyncLogService"),e.$kmb="userDataSync",e.$lmb="vscode-userdata-sync",e.$mmb="preview"}),define(le[246],he([0,1,30,25]),function(ne,e,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BMb=T;function T(C,A,L,y,S){if(!A)return{remote:{added:Object.keys(C),removed:[],updated:[],all:Object.keys(C).length>0?C:null},local:{added:{},removed:[],updated:{}}};const $=O(C,A);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const h=L?O(L,A):{added:Object.keys(A).reduce((w,E)=>(w.add(E),w),new Set),removed:new Set,updated:new Set},p=L?O(L,C):{added:Object.keys(C).reduce((w,E)=>(w.add(E),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},g=k.$9n(A),d=!L;for(const w of p.added.values())w!==a.$cmb&&d&&h.added.has(w)||(g[w]=C[w]);for(const w of p.updated.values())g[w]=C[w];for(const w of p.removed.values())y.unregistered.includes(w)||delete g[w];for(const w of h.added.values()){const E=A[w];if(y.machine.includes(w)){S.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(L&&p.added.has(w))continue;const u=C[w];u&&u.value===E.value||w===a.$cmb&&d&&p.added.has(w)||(u?l.updated[w]=E:l.added[w]=E)}for(const w of h.updated.values()){const E=A[w];if(y.machine.includes(w)){S.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(w)||p.removed.has(w))continue;const u=C[w];u&&u.value===E.value||(l.updated[w]=E)}for(const w of h.removed.values()){if(y.machine.includes(w)){S.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}p.updated.has(w)||p.removed.has(w)||l.removed.push(w)}const f=O(A,g);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:g}}}function O(C,A){const L=Object.keys(C),y=Object.keys(A),S=y.filter(p=>!L.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),$=L.filter(p=>!y.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),h=new Set;for(const p of L){if($.has(p))continue;const l=C[p],g=A[p];k.$ao(l,g)||h.add(p)}return{added:S,removed:$,updated:h}}}),define(le[247],he([0,1,19,34,63,46,30,82,25]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Kb=y,e.$9Kb=h,e.$0Kb=p,e.$$Kb=l,e.$_Kb=d,e.$aLb=w;function y(c,m,v){let P=[];v?P=$(v):P=S(m);const R=[],I=[...(0,L.$Wlb)()];if(Array.isArray(P))for(const N of P)N.startsWith("-")?I.push(N.substring(1)):R.push(N);return(0,k.$Mb)([...c,...R].filter(N=>!I.includes(N)))}function S(c){let m=c.inspect("settingsSync.ignoredSettings").userValue;return m!==void 0||(m=c.inspect("sync.ignoredSettings").userValue,m!==void 0)?m:c.getValue("settingsSync.ignoredSettings")||[]}function $(c){const m=(0,a.$Pn)(c);return m?m["settingsSync.ignoredSettings"]||m["sync.ignoredSettings"]||[]:[]}function h(c,m){const v=(0,a.$Pn)(c)||{};let P="{}";for(const R of Object.keys(v)){const I=(0,T.$5n)(P,[R],v[R],m);P=(0,T.$8n)(P,I)}return P}function p(c,m,v,P){if(v.length){const R=r(m),I=(0,a.$Pn)(m)||{},N=(0,a.$Pn)(c);if(!N)return c;const U=[];for(const j of v){const F=I[j],X=N[j];F===void 0?c=A.edit(c,[j],void 0,P):X!==void 0?c=A.edit(c,[j],F,P):U.push(t(j,R))}U.sort((j,F)=>j.startOffset-F.startOffset),U.forEach(j=>c=w(j.setting.key,m,c,P))}return c}function l(c,m,v,P,R,I){const N=p(c,m,P,I),U=v!==N,j=v!==m;if(!U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(j&&!U)return{conflictsSettings:[],localContent:p(m,c,P,I),remoteContent:null,hasConflicts:!1};if(v===null&&d(c)){const D=g(c,m,P)?null:p(m,c,P,I);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let F=c,X=m;const K=(0,a.$Pn)(c),Q=(0,a.$Pn)(m),V=v?(0,a.$Pn)(v):null,ie=P.reduce((D,B)=>(D.add(B),D),new Set),H=f(K,Q,ie),W=f(V,K,ie),ee=f(V,Q,ie),re=new Map,ce=new Set,q=D=>{ce.add(D);const B=R.filter(({key:M})=>M===D)[0];B?(F=A.edit(F,[D],B.value,I),X=A.edit(X,[D],B.value,I)):re.set(D,{key:D,localValue:K[D],remoteValue:Q[D]})};for(const D of W.removed.values())ee.updated.has(D)?q(D):X=A.edit(X,[D],void 0,I);for(const D of ee.removed.values())ce.has(D)||(W.updated.has(D)?q(D):F=A.edit(F,[D],void 0,I));for(const D of W.updated.values())ce.has(D)||(ee.updated.has(D)?H.updated.has(D)&&q(D):X=A.edit(X,[D],K[D],I));for(const D of ee.updated.values())ce.has(D)||(W.updated.has(D)?H.updated.has(D)&&q(D):F=A.edit(F,[D],Q[D],I));for(const D of W.added.values())ce.has(D)||(ee.added.has(D)?H.updated.has(D)&&q(D):X=w(D,F,X,I));for(const D of ee.added.values())ce.has(D)||(W.added.has(D)?H.updated.has(D)&&q(D):F=w(D,X,F,I));const x=re.size>0||!g(F,X,P),J=x||!g(F,c,[]),G=x||!g(X,m,[]);return{localContent:J?F:null,remoteContent:G?X:null,conflictsSettings:[...re.values()],hasConflicts:x}}function g(c,m,v){if(c===m)return!0;const P=(0,a.$Pn)(c),R=(0,a.$Pn)(m),I=v.reduce((j,F)=>(j.add(F),j),new Set),N=r(c).filter(j=>!(j.setting&&I.has(j.setting.key))),U=r(m).filter(j=>!(j.setting&&I.has(j.setting.key)));if(N.length!==U.length)return!1;for(let j=0;j<N.length;j++){const F=N[j],X=U[j];if(F.setting&&X.setting){if(F.setting.key!==X.setting.key||!C.$ao(P[F.setting.key],R[F.setting.key]))return!1}else if(!F.setting&&!X.setting){if(F.value!==X.value)return!1}else return!1}return!0}function d(c){return c?r(c).length===0:!0}function f(c,m,v){const P=c?Object.keys(c).filter(j=>!v.has(j)):[],R=Object.keys(m).filter(j=>!v.has(j)),I=R.filter(j=>!P.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),N=P.filter(j=>!R.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),U=new Set;if(c)for(const j of P){if(N.has(j))continue;const F=c[j],X=m[j];C.$ao(F,X)||U.add(j)}return{added:I,removed:N,updated:U}}function w(c,m,v,P){const R=(0,a.$Pn)(m),I=r(m),N=r(v),U=E(c,I,N);return u(v,c,R[c],U,N,P)}function E(c,m,v){const P=m.findIndex(I=>I.setting?.key===c),R=m[P-1];if(R){if(R.setting){const N=t(R.setting.key,v);if(N)return{index:v.indexOf(N),insertAfter:!0}}else{const N=s(P,m);if(N){const U=t(N.setting.key,v);if(U){const j=o(v.indexOf(U),v),F=i(m,N,m[P]);if(j){const X=i(v,U,j),K=n(F,X);return K?{index:v.indexOf(K),insertAfter:!0}:{index:v.indexOf(j),insertAfter:!1}}else{const X=i(v,U,v[v.length-1]),K=n(F,X);return K?{index:v.indexOf(K),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const I=m[P+1];if(I)if(I.setting){const N=t(I.setting.key,v);if(N)return{index:v.indexOf(N),insertAfter:!1}}else{const N=o(P,m);if(N){const U=t(N.setting.key,v);if(U){const j=s(v.indexOf(U),v),F=i(m,m[P],N);if(j){const X=i(v,j,U),K=n(F.reverse(),X.reverse());return K?{index:v.indexOf(K),insertAfter:!1}:{index:v.indexOf(j),insertAfter:!0}}else{const X=i(v,v[0],U),K=n(F.reverse(),X.reverse());return K?{index:v.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function u(c,m,v,P,R,I){let N;return P.index===-1?N=(0,T.$5n)(c,[m],v,I):N=b(c,m,v,P,R,I).map(U=>(0,T.$6n)(c,U,I)[0]),(0,T.$8n)(c,N)}function b(c,m,v,P,R,I){const N=`${JSON.stringify(m)}: ${JSON.stringify(v)}`,U=(0,O.$2n)(I,c),j=R[P.index];if(P.insertAfter){const F=[];if(j.setting)F.push({offset:j.endOffset,length:0,content:","+N});else{const X=o(P.index,R),K=s(P.index,R),Q=K?.setting?.commaOffset;K&&Q===void 0&&F.push({offset:K.endOffset,length:0,content:","});const V=Q!==void 0&&Q>j.endOffset;F.push({offset:V?Q+1:j.endOffset,length:0,content:X?U+N+",":U+N})}return F}else{if(j.setting)return[{offset:j.startOffset,length:0,content:N+","}];const F=(R[P.index-1]&&!R[P.index-1].setting?U:"")+N+(o(P.index,R)?",":"")+U;return[{offset:j.startOffset,length:0,content:F}]}}function t(c,m){return m.filter(v=>v.setting?.key===c)[0]}function s(c,m){for(let v=c-1;v>=0;v--)if(m[v].setting)return m[v]}function o(c,m){for(let v=c+1;v<m.length;v++)if(m[v].setting)return m[v]}function i(c,m,v){const P=c.indexOf(m),R=c.indexOf(v);return c.filter((I,N)=>P<N&&N<R)}function n(c,m){if(c.length&&m.length){let v=0;for(;v<m.length&&v<c.length;v++)if(c[v].value!==m[v].value)return m[v-1];return m[v-1]}}function r(c){const m=[];let v=-1,P,R;const I={onObjectBegin:N=>{v++},onObjectProperty:(N,U,j)=>{v===0&&(P=U,R=N)},onObjectEnd:(N,U)=>{v--,v===0&&m.push({startOffset:P,endOffset:N+U,value:c.substring(P,N+U),setting:{key:R,commaOffset:void 0}})},onArrayBegin:(N,U)=>{v++},onArrayEnd:(N,U)=>{v--,v===0&&m.push({startOffset:P,endOffset:N+U,value:c.substring(P,N+U),setting:{key:R,commaOffset:void 0}})},onLiteralValue:(N,U,j)=>{v===0&&m.push({startOffset:P,endOffset:U+j,value:c.substring(P,U+j),setting:{key:R,commaOffset:void 0}})},onSeparator:(N,U,j)=>{if(v===0&&N===","){let F=m.length-1;for(;F>=0&&!m[F].setting;F--);const X=m[F];X&&m.splice(F,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:U}})}},onComment:(N,U)=>{v===0&&m.push({startOffset:N,endOffset:N+U,value:c.substring(N,N+U)})}};return(0,a.$Wn)(c,I),m}}),define(le[83],he([0,1,3,2,4,25]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SKb=e.$RKb=void 0,e.$RKb=(0,T.$Ai)("IUserDataSyncAccountService");let C=class extends a.$Uc{get account(){return this.a}constructor(L,y){super(),this.g=L,this.h=y,this.b=this.B(new k.$he),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.$he),this.onTokenFailed=this.c.event,this.f=!1,this.B(L.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===O.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(L.onTokenSucceed(()=>this.f=!1))}async updateAccount(L){(L&&this.a?L.token!==this.a.token||L.authenticationProviderId!==this.a.authenticationProviderId:L!==this.a)&&(this.a=L,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(L))}};e.$SKb=C,e.$SKb=C=ve([Z(0,O.$7lb),Z(1,O.$jmb)],C)}),define(le[248],he([0,1,21,186,16,10,25]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lNb=void 0;let A=class extends O.$_j{constructor(y,S){super(),this.g=this.B(y.createLogger((0,k.$bh)(S.logsHome,`${C.$kmb}.log`),{id:C.$kmb,name:(0,a.localize)(0,null)}))}trace(y,...S){this.g.trace(y,...S)}debug(y,...S){this.g.debug(y,...S)}info(y,...S){this.g.info(y,...S)}warn(y,...S){this.g.warn(y,...S)}error(y,...S){this.g.error(y,...S)}flush(){this.g.flush()}};e.$lNb=A,e.$lNb=A=ve([Z(0,O.$8j),Z(1,T.$Hi)],A)}),define(le[249],he([0,1,6,3,2]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class O extends T.$Uc{constructor({onDidOpenMainWindow:A,onDidFocusMainWindow:L,getActiveWindowId:y}){super(),this.a=this.B(new T.$Tc),a.Event.latch(a.Event.any(A,L))(this.f,this,this.a),this.b=(0,k.$nh)(()=>y()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(A){this.b&&(this.b.cancel(),this.b=void 0),this.c=A}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Eec=O}),define(le[116],he([0,1,189,14,52,21,9,4,23]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=y,e.$Li=S,e.$Oi=$,e.$Pi=h,e.$Qi=p,e.$Ri=g,e.$Si=d,e.$Vi=E,e.$1i=u,e.$2i=b,e.$4i=t,e.$5i=s,e.$6i=o,e.$Ji=(0,A.$Ai)("contextService");function y(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!y(i)&&!h(i)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function $(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,a.$nc)(i)}:n?e.$Mi:e.$Ni;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function h(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}function p(i){const n=i;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}var l;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function d(i){const n=i;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,r,c,m,v){this.h=n,this.j=c,this.k=m,this.l=v,this.c=T.$Gi.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=T.$Gi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=f;class w{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$bh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=w;function E(i){return new w({uri:i,index:0,name:(0,O.$0g)(i)},{uri:i.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,k.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function u(i,n){return O.$5g.isEqualOrParent(i,n.untitledWorkspacesHome)}function b(i){let n;return C.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===L.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3i}function s(i,n){return!u(i,n)&&!b(i)}function o(i){return(typeof i=="string"?(0,a.$oc)(i):(0,O.$_g)(i))===e.$Xi}}),define(le[20],he([0,1,55,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=u,e.$Hl=b,e.$Il=t;var E;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(E||(e.ProfileResourceType=E={}));function u(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Gl=(0,S.$Ai)("IUserDataProfilesService");function b(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:n}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,r,c,m,v){return{id:i,name:n,location:r,isDefault:!1,shortName:m?.shortName,icon:m?.icon,globalStorageHome:v&&m?.useDefaultFlags?.globalState?v.globalStorageHome:(0,O.$bh)(r,"globalStorage"),settingsResource:v&&m?.useDefaultFlags?.settings?v.settingsResource:(0,O.$bh)(r,"settings.json"),keybindingsResource:v&&m?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,O.$bh)(r,"keybindings.json"),tasksResource:v&&m?.useDefaultFlags?.tasks?v.tasksResource:(0,O.$bh)(r,"tasks.json"),snippetsHome:v&&m?.useDefaultFlags?.snippets?v.snippetsHome:(0,O.$bh)(r,"snippets"),extensionsResource:v&&m?.useDefaultFlags?.extensions?v.extensionsResource:(0,O.$bh)(r,"extensions.json"),cacheHome:(0,O.$bh)(c,i),useDefaultFlags:m?.useDefaultFlags,isTransient:m?.transient}}let s=class extends T.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,c,m){super(),this.t=n,this.u=r,this.w=c,this.y=m,this.f=!0,this.h=this.B(new a.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,w.$ag)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}r.push(t((0,O.$$g)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},n))}}catch(v){this.y.error(v)}const c=new p.$Ac,m=new Map;if(r.length)try{const v=this.Q();if(v.workspaces)for(const[P,R]of Object.entries(v.workspaces)){const I=C.URI.parse(P),N=r.find(U=>U.id===R);N&&c.set(I,N)}if(v.emptyWindows)for(const[P,R]of Object.entries(v.emptyWindows)){const I=r.find(N=>N.id===R);I&&m.set(P,I)}}catch(v){this.y.error(v)}this.z={profiles:r,workspaces:c,emptyWindows:m}}return this.z}D(){const n=t("__default__profile__",(0,A.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,f.$df)(r)}\\s(\\d+)`);let m=0;for(const P of this.profiles){const R=c.exec(P.name),I=R?parseInt(R[1]):0;m=I>m?I:m}const v=`${r} ${m+1}`;return this.createProfile((0,k.$oj)((0,d.$Wg)()).toString(16),v,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,k.$oj)((0,d.$Wg)()).toString(16),n,r,c)}async createProfile(n,r,c,m){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(n,r,c);return m&&await this.setProfileForWorkspace(m,v),v}async F(n,r,c){if(!(0,w.$ag)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let m=this.r.get(r);return m||(m=(async()=>{try{if(this.profiles.find(I=>I.name===r||I.id===n))throw new Error(`Profile with ${r} name already exists`);const P=t(n,r,(0,O.$bh)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.u.createFolder(P.location);const R=[];return this.j.fire({profile:P,join(I){R.push(I)}}),await g.Promises.settled(R),this.I([P],[],[]),P}finally{this.r.delete(r)}})(),this.r.set(r,m)),m}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(m=>m.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,icon:r.icon===null?void 0:r.icon??c.icon,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(m=>m.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.m.fire({profile:r,join(m){c.push(m)}});try{await Promise.allSettled(c)}catch(m){this.y.error(m)}for(const m of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(m)?.id&&this.C.emptyWindows.delete(m);for(const m of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(m)?.id&&this.C.workspaces.delete(m);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(m){(0,y.$ll)(m)!==y.FileOperationResult.FILE_NOT_FOUND&&this.y.error(m)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(m=>m.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return C.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,h.$Ki)(n)?n.uri:(0,h.$Pi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,c){const m=[...this.profiles,...n],v=[];this.s.profiles=[];for(let P of m)P.isDefault||r.some(R=>P.id===R.id)||(P=c.find(R=>P.id===R.id)??P,P.isTransient?this.s.profiles.push(P):v.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.P(v),this.z=void 0,this.J(n,r,c)}J(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}L(n,r,c){c=r?.isTransient?!0:c,c||this.L(n,void 0,!0);const m=this.G(n),v=c?this.s:this.C;C.URI.isUri(m)?(v.workspaces.delete(m),r&&v.workspaces.set(m,r)):(v.emptyWindows.delete(m),r&&v.emptyWindows.set(m,r)),c||this.M()}M(){const n={};for(const[c,m]of this.C.workspaces.entries())n[c.toString()]=m.id;const r={};for(const[c,m]of this.C.emptyWindows.entries())r[c.toString()]=m.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},c=this.D();if(n.workspaces)for(const[v,P]of Object.entries(n.workspaces)){const R=C.URI.parse(P);r[v]=this.w.extUri.isEqual(R,c.location)?c.id:this.w.extUri.basename(R)}const m={};if(n.emptyWindows)for(const[v,P]of Object.entries(n.emptyWindows)){const R=C.URI.parse(P);m[v]=this.w.extUri.isEqual(R,c.location)?c.id:this.w.extUri.basename(R)}return{workspaces:r,emptyWindows:m}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Jl=s,e.$Jl=s=ve([Z(0,L.$Hi),Z(1,y.$7k),Z(2,l.$El),Z(3,$.$7j)],s);class o extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Kl=o}),define(le[250],he([0,1,6,2,20]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let O=class extends a.$Uc{constructor(A){super(),this.B(new k.$Mh(()=>{A.cleanUp()},10*1e3)).schedule()}};e.$Kfc=O,e.$Kfc=O=ve([Z(0,T.$Gl)],O)}),define(le[84],he([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$tq=void 0,e.$uq=b;let u=class extends A.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,r,c,m,v){super(),this.z=i,this.C=n,this.D=r,this.F=c,this.G=m,this.H=v,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$he),this.s=this.B(new C.$he),this.t=this.B(new C.$he),this.u=this.B(new C.$he),this.w=this.B(new C.$he),this.y=[],this.B((0,A.$Sc)(()=>{this.j.forEach(({task:P})=>P.cancel()),this.m.forEach(P=>P.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(r=>(0,h.$_o)(r,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const c=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:m})=>(0,p.$Cp)(m,i.identifier));if(c?.local)return c?.local;throw c?.error?c.error:new h.$dp(`Unknown error while installing extension ${i.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(r){throw b(r)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new h.$dp($.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],r=[];return await Promise.allSettled(i.map(async({extension:c,options:m})=>{try{const v=await this.N(c,!!m?.installGivenVersion,!!m?.installPreReleaseVersion,m.productVersion??{version:this.G.version,date:this.G.date});r.push({...v,options:m})}catch(v){n.push({identifier:c.identifier,operation:h.InstallOperation.Install,source:c,error:v})}})),r.length&&n.push(...await this.I(r)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,l.$Zm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let r=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(r=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const c of this.H.profiles){const m=(await this.getInstalled(l.ExtensionType.User,c.extensionsResource)).find(v=>(0,p.$Cp)(v.identifier,i.identifier));m?this.w.fire(m):this.u.fire({identifier:i.identifier,profileLocation:c.extensionsResource})}return r}else{const r=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:r.identifier,operation:h.InstallOperation.Install,local:r,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),r}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,r=new Map,c=[],m=(P,R)=>`${p.$Dp.create(P).toString()}-${R.toString()}`,v=(P,R,I,N)=>{const U=this.Y(P,R,I),j=`${(0,p.$Hp)(P.publisher,P.name)}-${I.profileLocation.toString()}`;r.set(j,{task:U,root:N}),this.n.fire({identifier:U.identifier,source:R,profileLocation:I.profileLocation}),this.F.info("Installing extension:",U.identifier.id,I.profileLocation.toString()),S.URI.isUri(R)||this.j.set(m(R,I.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:P,extension:R,options:I}of i){const N=I.isApplicationScoped||I.isBuiltin||(0,l.$Zm)(P),U={...I,installOnlyNewlyAddedFromExtensionPack:I.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(R),isApplicationScoped:N,profileLocation:N?this.H.defaultProfile.extensionsResource:I.profileLocation??this.X(),productVersion:I.productVersion??{version:this.G.version,date:this.G.date}},j=S.URI.isUri(R)?void 0:this.j.get(m(R,U.profileLocation));j?(this.F.info("Extension is already requested to install",j.task.identifier.id,U.profileLocation.toString()),c.push(j.task.waitUntilTaskIsFinished())):v(P,R,U,void 0)}return await Promise.all([...r.values()].map(async({task:P})=>{if(P.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const R=await this.M(P.identifier,P.manifest,!!P.options.installOnlyNewlyAddedFromExtensionPack,!!P.options.installPreReleaseVersion,P.options.profileLocation,P.options.productVersion),I=await this.getInstalled(void 0,P.options.profileLocation,P.options.productVersion),N={...P.options,context:{...P.options.context,[h.$6o]:!0}};for(const{gallery:U,manifest:j}of(0,k.$Mb)(R,({gallery:F})=>F.identifier.id)){if(r.has(`${U.identifier.id.toLowerCase()}-${N.profileLocation.toString()}`))continue;const F=this.j.get(m(U,N.profileLocation));if(F){if(this.J(P,F.task)){const X=F.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,P.identifier.id,N.profileLocation.toString()),F.waitingTasks.push(P),c.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,K=>K.some(Q=>(0,p.$Cp)(Q.identifier,X)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,P.identifier.id,N.profileLocation.toString()),!K.find(V=>(0,p.$Cp)(V.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else I.some(({identifier:X})=>(0,p.$Cp)(X,U.identifier))||v(j,U,N,P)}}catch(R){if(S.URI.isUri(P.source))(0,k.$Lb)(P.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",P.identifier.id,R.message),(0,k.$Lb)(P.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",P.identifier.id,R.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),R}})),await this.L([...r.entries()].map(async([P,{task:R}])=>{const I=new Date().getTime();let N;try{N=await R.run(),await this.L(this.y.map(U=>U.postInstall(N,R.source,R.options,T.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(U){const j=b(U);throw S.URI.isUri(R.source)||t(this.C,R.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Kp)(R.source),error:j,source:R.options.context?.[h.$5o]}),n.set(P,{error:j,identifier:R.identifier,operation:R.operation,source:R.source,context:R.options.context,profileLocation:R.options.profileLocation,applicationScoped:R.options.isApplicationScoped}),this.F.error("Error while installing the extension",R.identifier.id,(0,O.$0)(j),R.options.profileLocation.toString()),j}if(!S.URI.isUri(R.source)){const U=R.operation===h.InstallOperation.Update,j=U?void 0:(new Date().getTime()-R.source.lastUpdated)/1e3;if(t(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Kp)(R.source),verificationStatus:R.verificationStatus,duration:new Date().getTime()-I,durationSinceUpdate:j,source:R.options.context?.[h.$5o]}),L.$o&&R.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,h.StatisticType.Install)}catch{}}n.set(P,{local:N,identifier:R.identifier,operation:R.operation,source:R.source,context:R.options.context,profileLocation:R.options.profileLocation,applicationScoped:N.isApplicationScoped})})),c.length&&await this.L(c),[...n.values()]}catch(P){const R=(U,j,F)=>{const X=[];U.manifest.extensionDependencies?.length&&X.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&X.push(...U.manifest.extensionPack);for(const K of X){if(F.includes(K.toLowerCase()))continue;F.push(K.toLowerCase());const Q=n.get(`${K.toLowerCase()}-${j.toString()}`);Q?.local&&(F=R(Q.local,j,F))}return F},I=U=>({identifier:U.identifier,operation:h.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:P}),N=[];for(const[U,{task:j,root:F}]of r){const X=n.get(U);X?X.local&&F&&!n.get(`${F.identifier.id.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local&&(N.push(this.Z(X.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),n.set(U,I(j))):(j.cancel(),n.set(U,I(j)))}for(const[U,{task:j}]of r){const F=n.get(U);if(!F?.local||j.options.donotIncludePackAndDependencies)continue;R(F.local,j.options.profileLocation,[F.local.identifier.id.toLowerCase()]).slice(1).some(K=>r.has(`${K.toLowerCase()}-${j.options.profileLocation.toString()}`)&&!n.get(`${K.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local)&&(N.push(this.Z(F.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),n.set(U,I(j)))}throw N.length&&await Promise.allSettled(N.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(j){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,O.$0)(j))}})),P}finally{for(const{task:P}of r.values())P.source&&!S.URI.isUri(P.source)&&this.j.delete(m(P.source,P.options.profileLocation));if(n.size){const P=[...n.values()];for(const R of P)R.local&&this.F.info("Extension installed successfully:",R.identifier.id,R.profileLocation.toString());this.s.fire(P)}}}J(i,n){for(const[,{task:r,waitingTasks:c}]of this.j.entries())if(r===i&&(c.includes(n)||c.some(m=>this.J(m,n)))||r===n&&c[0]&&!this.J(i,c[0]))return!1;return!0}async L(i,n){const r=[],c=[],m=await Promise.allSettled(i);for(const P of m)P.status==="fulfilled"?r.push(P.value):c.push(b(P.reason,n));if(!c.length)return r;if(c.length===1)throw c[0];let v=new h.$dp("",h.ExtensionManagementErrorCode.Unknown);for(const P of c)v=new h.$dp(v.message?`${v.message}, ${P.message}`:P.message,P.code!==h.ExtensionManagementErrorCode.Unknown&&P.code!==h.ExtensionManagementErrorCode.Internal?P.code:v.code);throw v}async M(i,n,r,c,m,v){if(!this.z.isEnabled())return[];const P=await this.getInstalled(void 0,m,v),R=[],I=[],N=async(U,j)=>{R.push(U);const F=j.extensionDependencies||[],X=[...F];if(j.extensionPack){const K=r?P.find(Q=>(0,p.$Cp)(Q.identifier,U)):void 0;for(const Q of j.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(V=>(0,p.$Cp)({id:V},{id:Q}))||X.every(V=>!(0,p.$Cp)({id:V},{id:Q}))&&X.push(Q)}if(X.length){const K=X.filter(Q=>R.every(V=>!(0,p.$Cp)(V,{id:Q})));if(K.length){const Q=await this.z.getExtensions(K.map(V=>({id:V,preRelease:c})),T.CancellationToken.None);for(const V of Q){if(R.find(W=>(0,p.$Cp)(W,V.identifier)))continue;const ie=F.some(W=>(0,p.$Cp)({id:W},V.identifier));let H;try{H=await this.N(V,!1,c,v)}catch(W){if(ie)throw W;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,O.$0)(W));continue}I.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(i,n),I}async N(i,n,r,c){let m;const v=await this.getExtensionsControlManifest();if(v.malicious.some(I=>(0,p.$Cp)(i.identifier,I)))throw new h.$dp($.localize(1,null,i.identifier.id),h.ExtensionManagementErrorCode.Malicious);const P=v.deprecated[i.identifier.id.toLowerCase()];if(P?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${P.extension.id}' extension instead.`),m=(await this.z.getExtensions([{id:P.extension.id,preRelease:P.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:c},T.CancellationToken.None))[0],!m)throw new h.$dp($.localize(2,null,i.identifier.id,P.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const I=await this.getTargetPlatform();throw new h.$dp($.localize(3,null,i.identifier.id,this.G.nameLong,(0,h.$8o)(I)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(m=await this.O(i,n,r,c),!m)throw!r&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],T.CancellationToken.None))[0]?new h.$dp($.localize(4,null,i.displayName??i.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$dp($.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",m.identifier.id);const R=await this.z.getManifest(m,T.CancellationToken.None);if(R===null)throw new h.$dp(`Missing manifest for extension ${m.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(R.version!==m.version)throw new h.$dp(`Cannot install '${m.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:m,manifest:R}}async O(i,n,r,c){const m=await this.getTargetPlatform();let v=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==r&&(v=(await this.z.getExtensions([{...i.identifier,preRelease:r}],{targetPlatform:m,compatible:!0,productVersion:c},T.CancellationToken.None))[0]||null),!v&&await this.z.isExtensionCompatible(i,r,m,c)&&(v=i),v||(n?v=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:m,compatible:!0,productVersion:c},T.CancellationToken.None))[0]||null:v=await this.z.getCompatibleExtension(i,r,m,c)),v}async P(i,n){const r={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},c=N=>`${N.id.toLowerCase()}${r.versionOnly?`-${i.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,m=this.m.get(c(i.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const v=N=>{const U=this.Z(N,r);return this.m.set(c(U.extension.identifier),U),r.profileLocation?this.F.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString()):this.F.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this.t.fire({identifier:N.identifier,profileLocation:r.profileLocation,applicationScoped:N.isApplicationScoped}),U},P=(N,U)=>{U?r.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,U.message):r.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Jp)(N),error:U}),this.u.fire({identifier:N.identifier,error:U?.code,profileLocation:r.profileLocation,applicationScoped:N.isApplicationScoped})},R=[],I=[];try{R.push(v(i));const N=await this.getInstalled(l.ExtensionType.User,r.profileLocation);if(r.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.S(i,N);for(const j of U)this.m.has(c(j.identifier))?this.F.info("Extensions is already requested to uninstall",j.identifier.id):R.push(v(j))}r.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(R.map(U=>U.extension),N,i),await this.L(R.map(async U=>{try{if(await U.run(),await this.L(this.y.map(j=>j.postUninstall(U.extension,r,T.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,h.StatisticType.Uninstall)}catch{}P(U.extension)}catch(j){const F=b(j);throw P(U.extension,F),F}finally{I.push(U)}}))}catch(N){const U=b(N);for(const j of R){try{j.cancel()}catch{}I.includes(j)||P(j.extension,U)}throw U}finally{for(const N of R)this.m.delete(c(N.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}Q(i,n,r){for(const c of i){const m=this.U(c,n);if(m.length){const v=m.filter(P=>!i.some(R=>(0,p.$Cp)(R.identifier,P.identifier)));if(v.length)throw new Error(this.R(c,v,r))}}}R(i,n,r){return r===i?n.length===1?$.localize(6,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?$.localize(7,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):$.localize(8,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?$.localize(9,null,r.manifest.displayName||r.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?$.localize(10,null,r.manifest.displayName||r.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):$.localize(11,null,r.manifest.displayName||r.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,r=[]){if(r.indexOf(i)!==-1)return[];r.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const m=n.filter(P=>!P.isBuiltin&&c.some(R=>(0,p.$Cp)({id:R},P.identifier))),v=[];for(const P of m)v.push(...this.S(P,n,r));return[...m,...v]}return[]}U(i,n){return n.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(c=>(0,p.$Cp)({id:c},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$tq=u,e.$tq=u=ve([Z(0,h.$bp),Z(1,f.$6l),Z(2,w.$El),Z(3,g.$7j),Z(4,d.$nk),Z(5,E.$Gl)],u);function b(o,i){if(o instanceof h.$dp)return o;let n;return o instanceof h.$cp?n=new h.$dp(o.message,o.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$dp(o.message,(0,O.$4)(o)?h.ExtensionManagementErrorCode.Cancelled:i??h.ExtensionManagementErrorCode.Internal),n.stack=o.stack,n}function t(o,i,{extensionData:n,verificationStatus:r,duration:c,error:m,source:v,durationSinceUpdate:P}){let R,I;(0,y.$ig)(r)&&(r===!0?r="Verified":(r===!1||(R=h.ExtensionManagementErrorCode.Signature,I=r),r="Unverified")),m&&(R=m.code,m.code===h.ExtensionManagementErrorCode.Signature&&(I=m.message)),o.publicLog(i,{...n,verificationStatus:r,success:!m,duration:c,errorcode:R,errorcodeDetail:I,durationSinceUpdate:P,source:v})}class s{constructor(){this.d=new a.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$nh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$nh)(i=>new Promise((n,r)=>{const c=i.onCancellationRequested(()=>{c.dispose(),r(new O.$5)})})),this.d.open()),this.g.cancel()}}e.$vq=s}),define(le[53],he([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class E extends Error{constructor(o,i){super(o),this.code=i}}e.$wq=E,e.$xq=(0,$.$Ai)("IExtensionsProfileScannerService");let u=class extends T.$Uc{constructor(o,i,n,r,c,m){super(),this.j=o,this.m=i,this.n=n,this.r=r,this.s=c,this.t=m,this.b=this.B(new O.$he),this.onAddExtensions=this.b.event,this.c=this.B(new O.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$he),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(o,i){return this.u(o,void 0,i)}async addExtensionsToProfile(o,i,n){const r=[],c=[];try{return await this.u(i,m=>{const v=[];if(n)v.push(...m);else for(const P of m)o.some(([R])=>(0,y.$Cp)(R.identifier,P.identifier)&&R.manifest.version!==P.version)?r.push(P):v.push(P);for(const[P,R]of o){const I=v.findIndex(U=>(0,y.$Cp)(U.identifier,P.identifier)&&U.version===P.manifest.version),N={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:R};I===-1?(c.push(N),v.push(N)):v.splice(I,1,N)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),v}),c.length&&this.c.fire({extensions:c,profileLocation:i}),r.length&&this.g.fire({extensions:r,profileLocation:i}),c}catch(m){throw c.length&&this.c.fire({extensions:c,error:m,profileLocation:i}),r.length&&this.g.fire({extensions:r,error:m,profileLocation:i}),m}}async updateMetadata(o,i){const n=[];return await this.u(i,r=>{const c=[];for(const m of r){const v=o.find(([P])=>(0,y.$Cp)(P.identifier,m.identifier)&&P.manifest.version===m.version);v&&(m.metadata={...m.metadata,...v[1]},n.push(m)),c.push(m)}return c}),n}async removeExtensionFromProfile(o,i){const n=[];try{await this.u(i,r=>{const c=[];for(const m of r)(0,y.$Cp)(m.identifier,o.identifier)?n.push(m):c.push(m);return n.length&&this.f.fire({extensions:n,profileLocation:i}),c}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(o,i,n){return this.F(o).queue(async()=>{let r=[],c;try{const m=await this.m.readFile(o);c=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,S.$ll)(m)!==S.FileOperationResult.FILE_NOT_FOUND)throw m;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&n?.bailOutWhenFileNotFound)throw new E((0,d.$0)(m),w.ERROR_PROFILE_NOT_FOUND)}if(c){Array.isArray(c)||this.w(o);let m=!1;for(const v of c){b(v)||this.w(o);let P;if((0,g.$ag)(v.relativeLocation)&&v.relativeLocation)P=this.z(v.relativeLocation);else if((0,g.$ag)(v.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${v.location}`);continue}else{P=A.URI.revive(v.location);const R=this.y(P);R&&(m=!0,v.relativeLocation=R)}(0,g.$hg)(v.metadata?.hasPreReleaseVersion)&&v.metadata?.preRelease&&(m=!0,v.metadata.hasPreReleaseVersion=!0),r.push({identifier:v.identifier,location:P,version:v.version,metadata:v.metadata})}m&&await this.m.writeFile(o,a.$Je.fromString(JSON.stringify(c)))}if(i){r=i(r);const m=r.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(o,a.$Je.fromString(JSON.stringify(m)))}return r})}w(o){const i=new E(`Invalid extensions content in ${o.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(c){if((0,S.$ll)(c)===S.FileOperationResult.FILE_NOT_FOUND)return;throw c}this.t.info("Migrating extensions from old default profile location",o.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(m=>b(m))?r=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Je.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,S.$ll)(c)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(o)}catch(c){(0,S.$ll)(c)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}try{await this.m.del(i)}catch(c){(0,S.$ll)(c)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}return r})()),this.C}F(o){let i=this.h.get(o);return i||(i=new k.$Hh,this.h.set(o,i)),i}};e.$yq=u,e.$yq=u=ve([Z(1,S.$7k),Z(2,p.$Gl),Z(3,l.$El),Z(4,f.$6l),Z(5,h.$7j)],u);function b(s){return(0,g.$cg)(s)&&(0,L.$ap)(s.identifier)&&(t(s.location)||(0,g.$ag)(s.location)&&s.location)&&((0,g.$hg)(s.relativeLocation)||(0,g.$ag)(s.relativeLocation))&&s.version&&(0,g.$ag)(s.version)}function t(s){return s?(0,g.$ag)(s.path)&&(0,g.$ag)(s.scheme):!1}}),define(le[85],he([0,1,19,6,30,15,8,34,144,2,23,14,5,21,56,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s,o,i,n,r,c,m,v,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=e.$Cq=e.$Bq=e.Translations=void 0,e.$Eq=X;var I;(function(Q){function V(ie,H){if(ie===H)return!0;const W=Object.keys(ie),ee=new Set;for(const re of Object.keys(H))ee.add(re);if(W.length!==ee.size)return!1;for(const re of W){if(ie[re]!==H[re])return!1;ee.delete(re)}return ee.size===0}Q.equals=V})(I||(e.Translations=I={})),e.$Bq=(0,o.$Ai)("IExtensionsScannerService");let N=class extends y.$Uc{constructor(V,ie,H,W,ee,re,ce,q,x,J,G,D){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=ie,this.r=H,this.s=W,this.t=ee,this.u=re,this.w=ce,this.y=q,this.z=x,this.C=J,this.D=G,this.F=D,this.g=this.B(new r.$he),this.onDidChangeCache=this.g.event,this.h=(0,p.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(j,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(b.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(b.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,u.$Np)(this.w,this.y)),this.G}async scanAllExtensions(V,ie,H){const[W,ee]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(ie)]),re=H?await this.scanExtensionsUnderDevelopment(V,[...W,...ee]):[];return this.L(W,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const ie=[];ie.push(this.M(!!V.useCache,V.language)),ie.push(this.N(V.language,!!V.checkControlFile));const[H,W]=await Promise.all(ie);return this.J([...H,...W],b.ExtensionType.System,V,!1)}async scanUserExtensions(V){const ie=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const H=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(ie,!!V.profileLocation,b.ExtensionType.User,!V.includeUninstalled,V.language,!0,H,V.productVersion??this.R()),ee=V.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let re;try{re=await ee.scanExtensions(W)}catch(ce){if(ce instanceof m.$wq&&ce.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),re=await ee.scanExtensions(W);else throw ce}return re=await this.J(re,b.ExtensionType.User,V,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(V,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===S.Schemas.file).map(async W=>{const ee=await this.P(W,!1,b.ExtensionType.User,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(q=>(0,u.$Cp)(q.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,ee)))}))).flat();return this.J(H,"development",V,!0)}return[]}async scanExistingExtension(V,ie,H){const W=await this.P(V,!1,ie,!0,H.language,!0,void 0,H.productVersion??this.R()),ee=await this.n.scanExtension(W);return!ee||!H.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(V,ie,H){const W=await this.P(V,!1,ie,!0,H.language,!0,void 0,H.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,ie,H,!0)}async scanMultipleExtensions(V,ie,H){const W=[];return await Promise.all(V.map(async ee=>{const re=await this.scanOneOrMultipleExtensions(ee,ie,H);W.push(...re)})),this.J(W,ie,H,!0)}async scanMetadata(V){const ie=(0,p.$bh)(V,"package.json"),H=(await this.w.readFile(ie)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(V,ie){const H=(0,p.$bh)(V,"package.json"),W=(await this.w.readFile(H)).value.toString(),ee=JSON.parse(W);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,p.$bh)(V,"package.json"),O.$Je.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof m.$wq&&V.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Je.fromString(JSON.stringify([])))}catch(ie){(0,s.$ll)(ie)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,ie,H,W){return H.includeAllVersions||(V=this.L(ie===b.ExtensionType.System?V:void 0,ie===b.ExtensionType.User?V:void 0,ie==="development"?V:void 0,await this.getTargetPlatform(),W)),H.includeInvalid||(V=V.filter(ee=>ee.isValid)),V.sort((ee,re)=>{const ce=$.$nc(ee.location.fsPath),q=$.$nc(re.location.fsPath);return ce<q?-1:ce>q?1:0})}L(V,ie,H,W,ee){const re=(q,x,J)=>{if(q.isValid&&!x.isValid)return!1;if(q.isValid===x.isValid){if(ee&&l.gt(q.manifest.version,x.manifest.version))return this.y.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(l.eq(q.manifest.version,x.manifest.version)){if(q.type===b.ExtensionType.System)return this.y.debug(`Skipping extension ${x.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===W)return this.y.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${q.location.path} with ${x.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${x.location.path}.`),!0},ce=new b.$Ym;return V?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),ie?.forEach(q=>{const x=ce.get(q.identifier.id);if(!x&&V&&q.type===b.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),H?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!0))&&ce.set(q.identifier.id,q),ce.set(q.identifier.id,q)}),[...ce.values()]}async M(V,ie){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,b.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(V&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(V,ie){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const W=ie?await this.O():{},ee=[],re=f.URI.file($.$hc($.$jc(S.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of H){const x=W[q.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ee.push((0,p.$bh)(re,q.name));break;default:ee.push(f.URI.file(x));break}}const ce=await Promise.all(ee.map(async q=>this.n.scanExtension(await this.P(q,!1,b.ExtensionType.System,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,k.$Hb)(ce)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,ie,H,W,ee,re,ce,q){const x=await this.f(ee??h.$w),J=await this.Q(V),G=ie&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=G?await this.Q(G):void 0;return new U(V,J,G,D,ie,ce,H,W,re,q.version,q.date,this.C.commit,!this.z.isBuilt,ee,x)}async Q(V){try{const ie=await this.w.stat(V);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Cq=N,e.$Cq=N=ve([Z(4,v.$Gl),Z(5,m.$xq),Z(6,s.$7k),Z(7,i.$7j),Z(8,E.$Hi),Z(9,n.$nk),Z(10,P.$El),Z(11,o.$zi)],N);class U{constructor(V,ie,H,W,ee,re,ce,q,x,J,G,D,B,M,z){this.location=V,this.mtime=ie,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=re,this.type=ce,this.excludeObsolete=q,this.validate=x,this.productVersion=J,this.productDate=G,this.productCommit=D,this.devMode=B,this.language=M,this.translations=z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,ie){return(0,p.$7g)(V.location,ie.location)&&V.mtime===ie.mtime&&(0,p.$7g)(V.applicationExtensionslocation,ie.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&V.profile===ie.profile&&T.$ao(V.profileScanOptions,ie.profileScanOptions)&&V.type===ie.type&&V.excludeObsolete===ie.excludeObsolete&&V.validate===ie.validate&&V.productVersion===ie.productVersion&&V.productDate===ie.productDate&&V.productCommit===ie.productCommit&&V.devMode===ie.devMode&&V.language===ie.language&&I.equals(V.translations,ie.translations)}}e.$Dq=U;let j=class extends y.$Uc{constructor(V,ie,H,W,ee){super(),this.f=V,this.g=ie,this.h=H,this.j=W,this.m=ee}async scanExtensions(V){const ie=V.profile?await this.r(V):await this.n(V);let H={};if(V.excludeObsolete&&V.type===b.ExtensionType.User)try{const W=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(W)}catch{}return(0,d.$ng)(H)?ie:ie.filter(W=>!H[u.$Dp.create(W).toString()])}async n(V){const ie=await this.j.resolve(V.location);if(!ie.children?.length)return[];const H=await Promise.all(ie.children.map(async W=>{if(!W.isDirectory||V.type===b.ExtensionType.User&&(0,p.$$g)(W.resource).indexOf(".")===0)return null;const ee=new U(W.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ee)}));return(0,k.$Hb)(H).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(V){let ie=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){ie=ie.filter(W=>!W.metadata?.isApplicationScoped);const H=await this.s(V.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,V);ie.push(...H)}return ie}async s(V,ie,H){const W=await this.g.scanProfileExtensions(V,H.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async re=>{if(ie(re)){const ce=new U(re.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ce,re.metadata)}return null}));return(0,k.$Hb)(ee)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,p.$bh)(V.location,"package.json"))){const ie=await this.scanExtension(V);return ie?[ie]:[]}else return await this.scanExtensions(V)}catch(ie){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,C.$0)(ie)),[]}}async scanExtension(V,ie){try{let H=await this.scanExtensionManifest(V.location);if(H){H.publisher||(H.publisher=b.$Sm),ie=ie??H.__metadata,delete H.__metadata;const W=(0,u.$Hp)(H.publisher,H.name),ee=ie?.id?{id:W,uuid:ie.id}:{id:W},re=ie?.isSystem?b.ExtensionType.System:V.type,ce=re===b.ExtensionType.System||!!ie?.isBuiltin;H=await this.t(V.location,H,U.createNlsConfiguration(V));const q={type:re,identifier:ee,manifest:H,location:V.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??b.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return V.validate?this.validate(q,V):q}}catch(H){V.type!==b.ExtensionType.System&&this.m.error(H)}return null}validate(V,ie){let H=!0;const W=(0,t.$Sp)(ie.productVersion,ie.productDate,ie.location,V.manifest,V.isBuiltin);for(const[ee,re]of W)ee===g.default.Error&&(H=!1,this.m.error(this.z(ie.location,re)));return V.isValid=H,V.validations=W,V}async scanExtensionManifest(V){const ie=(0,p.$bh)(V,"package.json");let H;try{H=(await this.j.readFile(ie)).value.toString()}catch(ee){return(0,s.$ll)(ee)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(V,(0,w.localize)(0,null,ie.path,ee.message))),null}let W;try{W=JSON.parse(H)}catch{const re=[];(0,A.$Pn)(H,re);for(const ce of re)this.m.error(this.z(V,(0,w.localize)(1,null,ie.path,ce.offset,ce.length,(0,L.$zq)(ce.error))));return null}return(0,A.$Yn)(W)!=="object"?(this.m.error(this.z(V,(0,w.localize)(2,null,ie.path))),null):W}async t(V,ie,H){const W=await this.u(V,ie,H);if(W)try{const ee=[],re=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(q=>{this.m.error(this.z(V,(0,w.localize)(3,null,W.default?.path,(0,L.$zq)(q.error))))}),ie;if((0,A.$Yn)(W)!=="object")return this.m.error(this.z(V,(0,w.localize)(4,null,W.default?.path))),ie;const ce=W.values||Object.create(null);return(0,R.$Aq)(this.m,ie,ce,re)}catch{}return ie}async u(V,ie,H){const W=(0,p.$bh)(V,"package.nls.json"),ee=(x,J)=>{J.forEach(G=>{this.m.error(this.z(V,(0,w.localize)(5,null,x?.path,(0,L.$zq)(G.error))))})},re=x=>{this.m.error(this.z(V,(0,w.localize)(6,null,x?.path)))},ce=`${ie.publisher}.${ie.name}`,q=H.translations[ce];if(q)try{const x=f.URI.file(q),J=(await this.j.readFile(x)).value.toString(),G=[],D=(0,A.$Pn)(J,G);return G.length>0?(ee(x,G),{values:void 0,default:W}):(0,A.$Yn)(D)!=="object"?(re(x),{values:void 0,default:W}):{values:D.contents?D.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let J;try{J=await this.y(V,H)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const G=(await this.j.readFile(J.localized)).value.toString(),D=[],B=(0,A.$Pn)(G,D);return D.length>0?(ee(J.localized,D),{values:void 0,default:J.original}):(0,A.$Yn)(B)!=="object"?(re(J.localized),{values:void 0,default:J.original}):{values:B,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(V,ie){if(V)try{const H=(await this.j.readFile(V)).value.toString();return(0,A.$Pn)(H,ie)}catch{}}y(V,ie){return new Promise((H,W)=>{const ee=re=>{const ce=(0,p.$bh)(V,`package.nls.${re}.json`);this.j.exists(ce).then(q=>{q&&H({localized:ce,original:(0,p.$bh)(V,"package.nls.json")});const x=re.lastIndexOf("-");x===-1?H({localized:(0,p.$bh)(V,"package.nls.json"),original:null}):(re=re.substring(0,x),ee(re))})};if(ie.devMode||ie.pseudo||!ie.language)return H({localized:(0,p.$bh)(V,"package.nls.json"),original:null});ee(ie.language)})}z(V,ie){return`[${V.path}]: ${ie}`}};j=ve([Z(1,m.$xq),Z(2,P.$El),Z(3,s.$7k),Z(4,i.$7j)],j);let F=class extends j{constructor(V,ie,H,W,ee,re,ce){super(ie,W,ee,re,ce),this.G=V,this.H=H,this.D=this.B(new a.$yh(3e3)),this.F=this.B(new r.$he),this.onDidChangeCache=this.F.event}async scanExtensions(V){const ie=this.M(V),H=await this.I(ie);if(this.C=V,H&&H.input&&U.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),H.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const W=await super.scanExtensions(V);return await this.J(ie,{input:V,result:W}),W}async I(V){try{const ie=await this.j.readFile(V),H=JSON.parse(ie.value.toString());return{result:H.result,input:(0,c.$0h)(H.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",V.path,(0,C.$0)(ie))}return null}async J(V,ie){try{await this.j.writeFile(V,O.$Je.fromString(JSON.stringify(ie)))}catch(H){this.m.debug("Error while writing the extension cache file:",V.path,(0,C.$0)(H))}}async L(){if(!this.C)return;const V=this.M(this.C),ie=await this.I(V);if(!ie)return;const H=ie.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!T.$ao(W,H))try{this.m.info("Invalidating Cache",H,W),await this.j.del(V),this.F.fire()}catch(ee){this.m.error(ee)}}M(V){const ie=this.N(V);return this.h.extUri.joinPath(ie.cacheHome,V.type===b.ExtensionType.System?b.$Rm:b.$Qm)}N(V){return V.type===b.ExtensionType.System?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(V.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};F=ve([Z(2,v.$Gl),Z(3,m.$xq),Z(4,P.$El),Z(5,s.$7k),Z(6,i.$7j)],F);function X(Q,V){const ie=(0,u.$Fp)(Q.manifest.publisher,Q.manifest.name);return{id:ie,identifier:new b.$Wm(ie),isBuiltin:Q.type===b.ExtensionType.System,isUserBuiltin:Q.type===b.ExtensionType.User&&Q.isBuiltin,isUnderDevelopment:V,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class K extends N{constructor(V,ie,H,W,ee,re,ce,q,x,J,G,D){super(V,ie,(0,p.$bh)(H,".vscode-oss-dev","extensions","control.json"),W,ee,re,ce,q,x,J,G,D),this.S=(async()=>{if(h.$z)try{const B=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$Fq=K}),define(le[251],he([0,1,69,6,40,3,2,23,14,31,10,20]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;let h=class extends C.$Uc{constructor(l,g){super(),this.b=l,this.f=g,this.a=new a.$Gh(5)}async postUninstall(l){const g=this.g(l,"uninstall");g&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(g.script,"uninstall",g.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(d)}}));try{await y.Promises.rm(this.m(l))}catch(d){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(d)}}g(l,g){const d=`vscode:${g}`;if(l.location.scheme===A.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[d]=="string"){const f=l.manifest.scripts[d].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${d} should be a node script`),null):{script:(0,L.$jc)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(l,g,d,f,w){return new Promise((E,u)=>{const b=this.j(l,g,d,w);let t;const s=o=>{t&&(clearTimeout(t),t=null),o?u(o):E(void 0)};b.on("error",o=>{s((0,T.$lj)(o)||"Unknown")}),b.on("exit",(o,i)=>{s(o?`post-${g} process exited with code ${o}`:void 0)}),f&&(t=setTimeout(()=>{t=null,b.kill(),u("timed out")},5e3))})}j(l,g,d,f){const w={silent:!0,execArgv:void 0},E=(0,k.fork)(l,[`--type=extension-post-${g}`,...d],w);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const u=O.Event.fromNodeEventEmitter(E.stdout,"data"),b=O.Event.fromNodeEventEmitter(E.stderr,"data");this.B(u(o=>this.f.info(f.identifier.id,f.manifest.version,`post-${g}`,o))),this.B(b(o=>this.f.error(f.identifier.id,f.manifest.version,`post-${g}`,o)));const t=O.Event.any(O.Event.map(u,o=>({data:`%c${o}`,format:[""]}),this.q),O.Event.map(b,o=>({data:`%c${o}`,format:["color: red"]}),this.q));return O.Event.debounce(t,(o,i)=>o?{data:o.data+i.data,format:[...o.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(o=>{console.group(f.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),E}m(l){return(0,L.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Jq=h,e.$Jq=h=ve([Z(0,$.$Gl),Z(1,S.$7j)],h)}),define(le[117],he([0,1,72,167,84,28]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=C,e.$Hq=A;function C(L){let y=O.ExtensionManagementErrorCode.Extract;return L instanceof k.$pq&&(L.type==="CorruptZip"?y=O.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(y=O.ExtensionManagementErrorCode.IncompleteZip)),(0,T.$uq)(L,y)}async function A(L){let y;try{y=await(0,k.$sq)(L,"extension/package.json")}catch(S){throw C(S)}try{return JSON.parse(y.toString("utf8"))}catch{throw new O.$dp((0,a.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(le[252],he([0,1,6,8,2,23,21,56,13,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let s=class extends T.$Uc{static{t=this}static{this.c=".sigzip"}constructor(i,n,r,c,m,v,P){super(),this.h=n,this.j=r,this.m=c,this.n=m,this.r=v,this.t=P,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,r,c){await this.g;const m=await this.w(i,n);let v=!1;if(r&&this.u(i)){let P;try{P=await this.y(i)}catch(R){try{await this.delete(m)}catch(I){this.t.error(I)}throw R}try{v=await this.n.verify(i,m.fsPath,P.fsPath,c)}catch(R){if(v=R.code,v===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||v===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(m)}catch(I){this.t.error(I)}throw new g.$dp($.$oq,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(P)}catch(R){this.t.error(R)}}}return{location:m,verificationStatus:v}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,L.$gg)(n)?n:!0}async w(i,n){try{const r=(0,C.$bh)(this.extensionsDownloadDir,this.G(i)),c=await this.C(i,"vsix",async()=>{await this.z(i,r,m=>this.j.download(i,m,n));try{await this.D(r.fsPath,"extension/package.json")}catch(m){try{await this.h.del(r)}catch(v){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$0)(v))}throw m}},2);return c>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:c}),r}catch(r){throw(0,l.$uq)(r,g.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,C.$bh)(this.extensionsDownloadDir,`.${(0,y.$Wg)()}`),r=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(c){try{await this.h.del(n)}catch(m){this.t.warn(`Error while deleting: ${n.path}`,(0,a.$0)(m))}throw c}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:r}),n}catch(n){throw(0,l.$uq)(n,g.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,r){if(await this.h.exists(n))return;if(n.scheme!==O.Schemas.file){await r(n);return}const c=(0,C.$bh)(this.extensionsDownloadDir,`.${(0,y.$Wg)()}`);try{await r(c)}catch(m){try{await this.h.del(c)}catch{}throw m}try{await S.Promises.rename(c.fsPath,n.fsPath,2*60*1e3)}catch(m){try{await this.h.del(c)}catch{}let v=!1;try{v=await this.h.exists(n)}catch{}if(v)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,a.$0)(m)}. Deleted the file from downloaded location`,c.path),m}}async C(i,n,r,c){let m=1;for(;;)try{return await r(),m}catch(v){if(m++>c)throw v;this.t.warn(`Failed downloading ${n}. ${(0,a.$0)(v)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,$.$sq)(i,n)}catch(r){throw(0,f.$Gq)(r)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],r=[],c=[];for(const P of i.children)if(P.name.endsWith(t.c))c.push(P.resource);else{const R=d.$Dp.parse(P.name);R&&r.push([R,P])}const m=(0,d.$Ip)(r,([P])=>P),v=[];for(const P of m)P.sort((R,I)=>A.rcompare(R[0].version,I[0].version)),n.push(...P.slice(1).map(R=>R[1].resource)),v.push(P[0][1]);v.sort((P,R)=>P.mtime-R.mtime),n.push(...v.slice(0,Math.max(0,v.length-this.f)).map(P=>P.resource)),n.push(...c),await k.Promises.settled(n.map(P=>(this.t.trace("Deleting from cache",P.path),this.h.del(P))))}}catch(i){this.t.error(i)}}G(i){return this.f?d.$Dp.create(i).toString().toLowerCase():(0,y.$Wg)()}};e.$Iq=s,e.$Iq=s=t=ve([Z(0,p.$Ii),Z(1,E.$7k),Z(2,g.$bp),Z(3,h.$7i),Z(4,w.$hq),Z(5,b.$6l),Z(6,u.$7j)],s)}),define(le[118],he([0,1,6,15,26,40,8,3,55,2,35,23,14,21,56,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s,o,i,n,r,c,m,v,P,R,I,N,U,j,F,X,K,Q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=e.$Mq=void 0,e.$Mq=(0,j.$Bi)(o.$ep);const ie=".vsctmp";let H=class extends s.$tq{constructor(q,x,J,G,D,B,M,z,te,_,Y,ae){super(q,x,Y,J,_,ae),this.eb=D,this.fb=B,this.gb=M,this.hb=z,this.ib=te,this.db=new Map,this.tb=new S.$Bc;const ue=this.B(z.createInstance(m.$Jq));this.ab=this.B(z.createInstance(W,we=>ue.postUninstall(we))),this.bb=this.B(new P.$Kq(ae,te,Y,this,this.F)),this.cb=this.B(z.createInstance(c.$Iq));const ge=this.B(new R.$Lq(this,this.eb,ae,B,Y,te,J));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Np)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.rb(q),J=await(0,E.zip)((0,p.$bh)(this.cb.extensionsDownloadDir,(0,f.$Wg)()).fsPath,x);return d.URI.file(J)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:x,cleanup:J}=await this.lb(q),G=h.$kc(x.fsPath);try{return await(0,v.$Hq)(G)}finally{await J()}}getInstalled(q,x=this.H.defaultProfile.extensionsResource,J={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,x,J)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,x={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:J,cleanup:G}=await this.lb(q);try{const D=await(0,v.$Hq)(h.$kc(J.fsPath)),B=(0,i.$Hp)(D.publisher,D.name);if(D.engines&&D.engines.vscode&&!(0,N.$Up)(D.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,B,this.G.version));const z=(await this.I([{manifest:D,extension:J,options:x}])).find(({identifier:te})=>(0,i.$Cp)(te,{id:B}));if(z?.local)return z.local;throw z?.error?z.error:(0,s.$uq)(new Error(`Unknown error while installing extension ${B}`))}finally{await G()}}async installFromLocation(q,x){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const J=await this.ab.scanUserExtensionAtLocation(q);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[J,{source:"resource"}]],x),this.F.info("Successfully installed extension",J.identifier.id,x.toString()),J}async installExtensionsFromProfile(q,x,J){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,x.toString(),J.toString());const G=(await this.getInstalled(I.ExtensionType.User,x)).filter(D=>q.some(B=>(0,i.$Cp)(B,D.identifier)));if(G.length){const D=await Promise.all(G.map(B=>this.ab.scanMetadata(B,x)));await this.wb(G.map((B,M)=>[B,D[M]]),J),this.F.info("Successfully installed extensions",G.map(B=>B.identifier.id),J.toString())}return G}async updateMetadata(q,x,J=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0,x.hasPreReleaseVersion=!0),x.isMachineScoped===!1&&(x.isMachineScoped=void 0),x.isBuiltin===!1&&(x.isBuiltin=void 0),x.pinned===!1&&(x.pinned=void 0),q=await this.ab.updateMetadata(q,x,J),this.bb.invalidate(J),this.w.fire(q),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const x=await this.getTargetPlatform(),[J]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:x,compatible:!0},T.CancellationToken.None);if(!J)throw new Error(u.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(G){throw new Error(u.localize(3,null,(0,O.$lj)(G)))}return this.installFromGallery(J)}$(q,x,J,G){return this.ab.copyExtension(q,x,J,G)}copyExtensions(q,x){return this.ab.copyExtensions(q,x,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,x,J){const{location:G}=await this.cb.download(q,x,!J);return G}async lb(q){if(q.scheme===$.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const x=(0,p.$bh)(this.cb.extensionsDownloadDir,(0,f.$Wg)());return await this.gb.download(q,x),this.F.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.ib.del(x)}catch(G){this.F.error(G)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,x,J){const G=x instanceof d.URI?new i.$Dp({id:(0,i.$Hp)(q.publisher,q.name)},q.version):i.$Dp.create(x);return this.hb.createInstance(ee,G,q,x,J,(D,B)=>{if(x instanceof d.URI)return this.qb(G,x,J,B);let M=this.db.get(G.toString());return M||(this.db.set(G.toString(),M=this.pb(G,x,D,J,B)),M.finally(()=>this.db.delete(G.toString()))),M},this.ab)}Z(q,x){return new re(q,x.profileLocation,this.fb)}async pb(q,x,J,G,D){const{verificationStatus:B,location:M}=await this.cb.download(x,J,!G.donotVerifySignature,G.context?.[o.$7o]);try{if(D.isCancellationRequested)throw new C.$5;return await(0,v.$Hq)(M.fsPath),{local:await this.ab.extractUserExtension(q,M.fsPath,{id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform,isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,preRelease:(0,g.$gg)(G.preRelease)?G.preRelease:G.installPreReleaseVersion||x.properties.isPreReleaseVersion,source:"gallery"},!1,D),verificationStatus:B}}catch(z){try{await this.cb.delete(M)}catch(te){this.F.warn("Error while deleting the downloaded file",M.toString(),(0,C.$0)(te))}throw(0,s.$uq)(z)}}async qb(q,x,J,G){return{local:await this.ab.extractUserExtension(q,h.$kc(x.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,G)}}async rb(q){const x=async G=>{let D=await w.Promises.readdir(G);D=D.map(z=>h.$jc(G,z));const B=await Promise.all(D.map(z=>w.Promises.stat(z)));let M=Promise.resolve([]);return B.forEach((z,te)=>{const _=D[te];z.isFile()&&(M=M.then(Y=>[...Y,_])),z.isDirectory()&&(M=M.then(Y=>x(_).then(ae=>[...Y,...ae])))}),M};return(await x(q.location.fsPath)).map(G=>({path:`extension/${h.$lc(q.location.fsPath,G)}`,localPath:G}))}async sb({added:q,removed:x}){if(x){const J=q&&this.D.extUri.isEqual(x.profileLocation,q.profileLocation)?x.extensions.filter(G=>q.extensions.every(D=>!(0,i.$Cp)(D,G))):x.extensions;for(const G of J)this.F.info("Extensions removed from another source",G.id,x.profileLocation.toString()),this.u.fire({identifier:G,profileLocation:x.profileLocation})}if(q){const G=(await this.getInstalled(I.ExtensionType.User,q.profileLocation)).filter(D=>q.extensions.some(B=>(0,i.$Cp)(B,D.identifier)));this.s.fire(G.map(D=>(this.F.info("Extensions added from another source",D.identifier.id,q.profileLocation.toString()),{identifier:D.identifier,local:D,profileLocation:q.profileLocation,operation:o.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(x=>this.tb.add(x)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const x of q.children??[])x.isDirectory&&this.tb.add(x.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(x=>this.vb(x)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const x=[];for(const J of q.rawAdded){if(this.tb.has(J)||!this.D.extUri.isEqual(this.D.extUri.dirname(J),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(J,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(J).startsWith(".")||!(await this.ib.stat(J)).isDirectory)continue;const G=await this.ab.scanUserExtensionAtLocation(J);G&&G.installedTimestamp===void 0&&(this.tb.add(J),x.push(G))}x.length&&(await this.wb(x.map(J=>[J,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",x.map(J=>J.identifier.id)))}async wb(q,x){const J=q.map(G=>G[0]);await this.xb(J),await this.fb.addExtensionsToProfile(q,x),this.s.fire(J.map(G=>({local:G,identifier:G.identifier,operation:o.InstallOperation.None,profileLocation:x})))}async xb(q){const x=await this.ab.getUninstalledExtensions();for(const J of q){const G=i.$Dp.create(J);x[G.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",G.id),await this.ab.setInstalled(G),this.F.info("Removed the extension from uninstalled list:",G.id))}}};e.$Nq=H,e.$Nq=H=ve([Z(0,o.$bp),Z(1,K.$6l),Z(2,F.$7j),Z(3,t.$Ii),Z(4,r.$Bq),Z(5,n.$xq),Z(6,b.$Ro),Z(7,j.$zi),Z(8,U.$7k),Z(9,X.$nk),Z(10,Q.$El),Z(11,V.$Gl)],H);let W=class extends y.$Uc{constructor(q,x,J,G,D,B){super(),this.j=q,this.m=x,this.n=J,this.s=G,this.t=D,this.u=B,this.h=this.B(new A.$he),this.onExtract=this.h.event,this.c=(0,p.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new k.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(q,x,J){try{const G={includeInvalid:!0,profileLocation:x,productVersion:J};let D=[];return q===null||q===I.ExtensionType.System?D.push(...await this.n.scanAllExtensions({includeInvalid:!0},G,!1)):q===I.ExtensionType.User&&D.push(...await this.n.scanUserExtensions(G)),D=q!==null?D.filter(B=>B.type===q):D,await Promise.all(D.map(B=>this.F(B)))}catch(G){throw(0,s.$uq)(G,o.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const x=await this.n.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(x.map(J=>this.F(J)))}catch(x){throw(0,s.$uq)(x,o.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const x=await this.n.scanExistingExtension(q,I.ExtensionType.User,{includeInvalid:!0});if(x)return await this.F(x)}catch(x){this.u.error(x)}return null}async extractUserExtension(q,x,J,G,D){const B=q.toString(),M=d.URI.file(h.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$Wg)()}`)),z=d.URI.file(h.$jc(this.n.userExtensionsLocation.fsPath,B));let te=await this.m.exists(z);if(te&&G){try{await this.y(q.id,z,"removeExisting")}catch{throw new o.$dp(u.localize(4,null,z.fsPath,q.id),o.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.n.updateMetadata(z,J)}catch(_){throw(0,s.$uq)(_,o.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(D.isCancellationRequested)throw new C.$5;try{this.u.trace(`Started extracting the extension from ${x} to ${z.fsPath}`),await(0,E.$rq)(x,M.fsPath,{sourcePath:"extension",overwrite:!0},D),this.u.info(`Extracted extension to ${z}:`,q.id)}catch(_){throw(0,v.$Gq)(_)}try{await this.n.updateMetadata(M,J)}catch(_){throw(0,s.$uq)(_,o.ExtensionManagementErrorCode.UpdateMetadata)}if(D.isCancellationRequested)throw new C.$5;try{this.u.trace(`Started renaming the extension from ${M.fsPath} to ${z.fsPath}`),await this.C(M.fsPath,z.fsPath),this.u.info("Renamed to",z.fsPath)}catch(_){if(_.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.u.info(`Rename failed because of ${(0,C.$0)(_)}. Deleted from extracted location`,M),_}this.h.fire(z)}catch(_){try{await this.m.del(M,{recursive:!0})}catch{}throw _}return this.D(z,I.ExtensionType.User)}async scanMetadata(q,x){return x?(await this.w(q,x))?.metadata:this.n.scanMetadata(q.location)}async w(q,x){return(await this.s.scanProfileExtensions(x)).find(G=>(0,i.$Cp)(G.identifier,q.identifier))}async updateMetadata(q,x,J){try{J?await this.s.updateMetadata([[q,x]],J):await this.n.updateMetadata(q.location,x)}catch(G){throw(0,s.$uq)(G,o.ExtensionManagementErrorCode.UpdateMetadata)}return this.D(q.location,q.type,J)}async getUninstalledExtensions(){try{return await this.z()}catch(q){throw(0,s.$uq)(q,o.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const x=q.map(J=>i.$Dp.create(J));await this.z(J=>x.forEach(G=>{J[G.toString()]=!0,this.u.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(q){try{await this.z(x=>delete x[q.toString()])}catch(x){throw(0,s.$uq)(x,o.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,x){if(this.t.extUri.isEqualOrParent(q.location,this.n.userExtensionsLocation))return this.y(q.identifier.id,q.location,x)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.z(x=>delete x[i.$Dp.create(q).toString()])}async copyExtension(q,x,J,G){const D=await this.w(q,x),B=await this.w(q,J);if(G={...D?.metadata,...G},B)if(this.t.extUri.isEqual(B.location,q.location))await this.s.updateMetadata([[q,{...B.metadata,...G}]],J);else{const M=await this.D(B.location,q.type,J);await this.s.removeExtensionFromProfile(M,J),await this.s.addExtensionsToProfile([[q,{...B.metadata,...G}]],J)}else await this.s.addExtensionsToProfile([[q,G]],J);return this.D(q.location,q.type,J)}async copyExtensions(q,x,J){const G=await this.scanExtensions(I.ExtensionType.User,q,J),D=await Promise.all(G.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,q)]));await this.s.addExtensionsToProfile(D,x)}async y(q,x,J){this.u.trace(`Deleting ${J} extension from disk`,q,x.fsPath);const G=this.t.extUri.joinPath(this.t.extUri.dirname(x),`${this.t.extUri.basename(x)}.${(0,L.$oj)((0,f.$Wg)()).toString(16)}${ie}`);await this.C(x.fsPath,G.fsPath),await this.m.del(G,{recursive:!0}),this.u.info(`Deleted ${J} extension from disk`,q,x.fsPath)}z(q){return this.g.queue(async()=>{let x;try{x=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(G){if((0,U.$ll)(G)!==U.FileOperationResult.FILE_NOT_FOUND)throw G}let J={};if(x)try{J=JSON.parse(x)}catch{}return q&&(q(J),Object.keys(J).length?await this.m.writeFile(this.c,a.$Je.fromString(JSON.stringify(J))):await this.m.del(this.c)),J})}async C(q,x){try{await w.Promises.rename(q,x,2*60*1e3)}catch(J){throw(0,s.$uq)(J,o.ExtensionManagementErrorCode.Rename)}}async D(q,x,J){try{if(J){const D=(await this.n.scanUserExtensions({profileLocation:J})).find(B=>this.t.extUri.isEqual(B.location,q));if(D)return await this.F(D)}else{const G=await this.n.scanExistingExtension(q,x,{includeInvalid:!0});if(G)return await this.F(G)}throw new o.$dp(u.localize(5,null,q.path),o.ExtensionManagementErrorCode.ScanningExtension)}catch(G){throw(0,s.$uq)(G,o.ExtensionManagementErrorCode.ScanningExtension)}}async F(q){const x=await this.m.resolve(q.location);let J,G;return x.children&&(J=x.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,G=x.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:J,changelogUrl:G,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async G(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(q));const x=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const D of x)q[i.$Dp.create(D).toString()]||J.add(D.identifier.id.toLowerCase());try{const D=(0,i.$Ip)(x,B=>B.identifier);await k.Promises.settled(D.map(async B=>{const M=B.sort((z,te)=>l.rcompare(z.manifest.version,te.manifest.version))[0];J.has(M.identifier.id.toLowerCase())||await this.j(await this.F(M))}))}catch(D){this.u.error(D)}const G=x.filter(D=>D.metadata&&q[i.$Dp.create(D).toString()]);await Promise.allSettled(G.map(D=>this.removeUninstalledExtension(D)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.m.resolve(this.n.userExtensionsLocation)}catch(x){(0,U.$ll)(x)!==U.FileOperationResult.FILE_NOT_FOUND&&this.u.error(x);return}if(q?.children)try{await Promise.allSettled(q.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(ie))){this.u.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.m.del(x.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(J){(0,U.$ll)(J)!==U.FileOperationResult.FILE_NOT_FOUND&&this.u.error(J)}}}))}catch{}}};e.$Oq=W,e.$Oq=W=ve([Z(1,U.$7k),Z(2,r.$Bq),Z(3,n.$xq),Z(4,Q.$El),Z(5,F.$7j)],W);let ee=class extends s.$vq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,x,J,G,D,B,M,z,te,_,Y,ae){super(),this.l=q,this.manifest=x,this.source=J,this.options=G,this.m=D,this.n=B,this.o=M,this.p=z,this.q=te,this.s=_,this.t=Y,this.u=ae,this.j=o.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(x=>(0,i.$Cp)(x.identifier,this.identifier))}async h(q){const x=await this.v();x&&(this.j=o.InstallOperation.Update);const J={isApplicationScoped:this.options.isApplicationScoped||x?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||x?.isMachineScoped,isBuiltin:this.options.isBuiltin||x?.isBuiltin,isSystem:x?.type===I.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??x?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};if(this.source instanceof d.URI)if(x){if(this.l.equals(new i.$Dp(x.identifier,x.manifest.version)))try{await this.n.removeExtension(x,"existing")}catch{throw new Error(u.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const M=await this.x(this.l);if(M)try{await this.n.removeExtension(M,"existing")}catch{throw new Error(u.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(J.id=this.source.identifier.uuid,J.publisherId=this.source.publisherId,J.publisherDisplayName=this.source.publisherDisplayName,J.targetPlatform=this.source.properties.targetPlatform,J.updated=!!x,J.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,J.hasPreReleaseVersion=x?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,J.preRelease=(0,g.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||x?.preRelease,x&&x.type!==I.ExtensionType.System&&x.manifest.version===this.source.version)return this.n.updateMetadata(x,J);const M=await this.x(this.l);if(M)return M}if(q.isCancellationRequested)throw(0,s.$uq)(new C.$5);const{local:G,verificationStatus:D}=await this.m(this.operation,q);if(this.k=D,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(M){throw(0,s.$uq)(M,o.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,s.$uq)(new C.$5);try{await this.t.addExtensionsToProfile([[G,J]],this.options.profileLocation,!G.isValid)}catch(M){throw(0,s.$uq)(M,o.ExtensionManagementErrorCode.AddToProfile)}const B=await this.v();if(!B)throw new o.$dp("Cannot find the installed extension",o.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.y(G,q),B}async x(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(G=>i.$Dp.create(G).equals(q))):void 0}async y(q,x){try{let[J]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],x);if(J||([J]=await this.p.getExtensions([{id:q.identifier.id}],x)),J){const G={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,G,this.options.profileLocation)}}catch{}}};ee=ve([Z(6,Q.$El),Z(7,o.$bp),Z(8,V.$Gl),Z(9,r.$Bq),Z(10,n.$xq),Z(11,F.$7j)],ee);class re extends s.$vq{constructor(q,x,J){super(),this.extension=q,this.j=x,this.k=J}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[253],he([0,1,10,20,29,18,53,7,16,9]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=void 0;let S=class extends C.$yq{constructor(h,p,l,g,d,f){super(y.URI.file(h.extensionsPath),p,l,g,d,f)}};e.$kQ=S,e.$kQ=S=ve([Z(0,L.$Ii),Z(1,A.$7k),Z(2,a.$Gl),Z(3,T.$El),Z(4,O.$6l),Z(5,k.$7j)],S)}),define(le[254],he([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let h=class extends O.$Fq{constructor(l,g,d,f,w,E,u,b){super(k.URI.file(w.builtinExtensionsPath),k.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,g,d,f,w,E,u,b)}};e.$Iec=h,e.$Iec=h=ve([Z(0,$.$Gl),Z(1,T.$xq),Z(2,C.$7k),Z(3,L.$7j),Z(4,a.$Ii),Z(5,y.$nk),Z(6,S.$El),Z(7,A.$zi)],h)}),define(le[17],he([0,1,6,3,2,101,13,71,4,20]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=p,e.$_p=g,e.$bq=f,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,L.$Ai)("storageService");var S;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var $;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var h;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function p(w){const E=w.get(e.$8p);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}class l extends T.$Uc{static{this.a=60*1e3}constructor(E={flushInterval:l.a}){super(),this.m=E,this.b=this.B(new a.$ke),this.c=this.B(new a.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$he),this.onWillSaveState=this.f.event,this.h=this.B(new k.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new T.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(E,u,b){return a.Event.filter(this.b.event,t=>t.scope===E&&(u===void 0||t.key===u),b)}n(){this.j.value=(0,k.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,T.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(E,u){const{key:b,external:t}=u;if(b===e.$8p){switch(E){case $.APPLICATION:this.H=void 0;break;case $.PROFILE:this.F=void 0;break;case $.WORKSPACE:this.C=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:b,target:this.J(E)[b],external:t})}w(E){this.f.fire({reason:E})}get(E,u,b){return this.P(u)?.get(E,b)}getBoolean(E,u,b){return this.P(u)?.getBoolean(E,b)}getNumber(E,u,b){return this.P(u)?.getNumber(E,b)}getObject(E,u,b){return this.P(u)?.getObject(E,b)}storeAll(E,u){this.y(()=>{for(const b of E)this.store(b.key,b.value,b.scope,b.target,u)})}store(E,u,b,t,s=!1){if((0,C.$jg)(u)){this.remove(E,b,s);return}this.y(()=>{this.z(E,b,t),this.P(b)?.set(E,u,s)})}remove(E,u,b=!1){this.y(()=>{this.z(E,u,void 0),this.P(u)?.delete(E,b)})}y(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,u){const b=[],t=this.J(E);for(const s of Object.keys(t))t[s]===u&&b.push(s);return b}z(E,u,b,t=!1){const s=this.J(u);typeof b=="number"?s[E]!==b&&(s[E]=b,this.P(u)?.set(e.$8p,JSON.stringify(s),t)):typeof s[E]=="number"&&(delete s[E],this.P(u)?.set(e.$8p,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L($.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L($.PROFILE)),this.F}get I(){return this.H||(this.H=this.L($.APPLICATION)),this.H}J(E){switch(E){case $.APPLICATION:return this.I;case $.PROFILE:return this.G;default:return this.D}}L(E){const u=this.P(E);return u?p(u):Object.create(null)}isNew(E){return this.getBoolean(e.$7p,E)===!0}async flush(E=S.NONE){this.f.fire({reason:E});const u=this.P($.APPLICATION),b=this.P($.PROFILE),t=this.P($.WORKSPACE);switch(E){case S.NONE:await k.Promises.settled([u?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await k.Promises.settled([u?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.P($.APPLICATION)?.items??new Map,u=this.P($.PROFILE)?.items??new Map,b=this.P($.WORKSPACE)?.items??new Map;return f(E,u,b,this.Q($.APPLICATION)??"",this.Q($.PROFILE)??"",this.Q($.WORKSPACE)??"")}async optimize(E){return await this.flush(),this.P(E)?.optimize()}async switch(E,u){return this.w(S.NONE),(0,y.$Fl)(E)?this.R(E,u):this.S(E,u)}M(E,u){return!(E.id===u.id||g(u)&&g(E))}N(E,u,b){this.y(()=>{const t=new Set;for(const[s,o]of E)t.add(s),u.get(s)!==o&&this.u(b,{key:s,external:!0});for(const[s]of u.items)t.has(s)||this.u(b,{key:s,external:!0})})}}e.$$p=l;function g(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class d extends l{constructor(){super(),this.U=this.B(new A.$5p(new A.$6p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$5p(new A.$6p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$5p(new A.$6p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(E=>this.u($.WORKSPACE,E))),this.B(this.W.onDidChangeStorage(E=>this.u($.PROFILE,E))),this.B(this.U.onDidChangeStorage(E=>this.u($.APPLICATION,E)))}P(E){switch(E){case $.APPLICATION:return this.U;case $.PROFILE:return this.W;default:return this.X}}Q(E){switch(E){case $.APPLICATION:return"inMemory (application)";case $.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(E){return!1}}e.$aq=d;async function f(w,E,u,b,t,s){const o=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,n=new Map;w.forEach((I,N)=>{i.set(N,I),n.set(N,o(I))});const r=new Map,c=new Map;E.forEach((I,N)=>{r.set(N,I),c.set(N,o(I))});const m=new Map,v=new Map;u.forEach((I,N)=>{m.set(N,I),v.set(N,o(I))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const P=[];if(i.forEach((I,N)=>{P.push({key:N,value:I})}),console.table(P),console.groupEnd(),console.log(n),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];r.forEach((N,U)=>{I.push({key:U,value:N})}),console.table(I),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const R=[];m.forEach((I,N)=>{R.push({key:N,value:I})}),console.table(R),console.groupEnd(),console.log(v)}}),define(le[119],he([0,1,3,2,13,28,33,17]),function(ne,e,k,a,T,O,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QKb=e.$PKb=void 0;let L=class extends a.$Uc{constructor($,h){super(),this.a=new k.$he,this.onDidChangeEnablement=this.a.event,this.b=this.B(new y($)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(h.onDidInstallExtensions(p=>p.forEach(({local:l,operation:g})=>{l&&g===O.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension($,h){return this.f($)?(this.a.fire({extensions:[$],source:h}),!0):!1}async disableExtension($,h){return this.c($)?(this.a.fire({extensions:[$],source:h}),!0):!1}getDisabledExtensions(){return this.h(O.$fp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c($){const h=this.getDisabledExtensions();return h.every(p=>!(0,C.$Cp)(p,$))?(h.push($),this.g(h),!0):!1}f($){const h=this.getDisabledExtensions();for(let p=0;p<h.length;p++){const l=h[p];if((0,C.$Cp)(l,$))return h.splice(p,1),this.g(h),!0}return!1}g($){this.j(O.$fp,$)}h($){return this.b.get($,A.StorageScope.PROFILE)}j($,h){this.b.set($,h,A.StorageScope.PROFILE)}};e.$PKb=L,e.$PKb=L=ve([Z(0,A.$9p),Z(1,O.$ep)],L);class y extends a.$Uc{constructor($){super(),this.c=$,this.a=Object.create(null),this.b=this.B(new k.$he),this.onDidChange=this.b.event,this.B($.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new a.$Tc))(h=>this.f(h)))}get($,h){let p;return h===A.StorageScope.PROFILE?((0,T.$jg)(this.a[$])&&(this.a[$]=this.g($,h)),p=this.a[$]):p=this.g($,h),JSON.parse(p)}set($,h,p){const l=JSON.stringify(h.map(({id:d,uuid:f})=>({id:d,uuid:f})));this.g($,p)!==l&&(p===A.StorageScope.PROFILE&&(h.length?this.a[$]=l:delete this.a[$]),this.h($,h.length?l:void 0,p))}f($){if(!(0,T.$jg)(this.a[$.key])&&this.g($.key,$.scope)!==this.a[$.key]){const p=this.get($.key,$.scope);delete this.a[$.key];const l=this.get($.key,$.scope),g=p.filter(f=>!l.some(w=>(0,C.$Cp)(f,w))),d=l.filter(f=>!p.some(w=>(0,C.$Cp)(w,f)));(g.length||d.length)&&this.b.fire([...g,...d])}}g($,h){return this.c.get($,h,"[]")}h($,h,p){h?this.c.store($,h,p,A.StorageTarget.MACHINE):this.c.remove($,p)}}e.$QKb=y}),define(le[86],he([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=void 0,e.$dw=(0,k.$Ai)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class extends T.$Uc{static{$=this}static{this.a=512*1024}static b(g){return`extensionKeys/${(0,C.$Gp)(g.id)}@${g.version}`}static c(g){const d=h.exec(g);if(d&&d[1])return{id:d[1],version:d[2]}}static async removeOutdatedExtensionVersions(g,d){const f=await g.getInstalled(),w=[];for(const[E,u]of $.f(d)){const b=f.find(t=>(0,C.$Cp)(t.identifier,{id:E}))?.manifest.version;for(const t of u)b!==t&&w.push($.b({id:E,version:t}))}for(const E of w)d.remove(E,O.StorageScope.PROFILE)}static f(g){const d=new Map,f=g.keys(O.StorageScope.PROFILE,O.StorageTarget.MACHINE);for(const w of f){const E=$.c(w);if(E){let u=d.get(E.id.toLowerCase());u||d.set(E.id.toLowerCase(),u=[]),u.push(E.version)}}return d}constructor(g,d,f){super(),this.j=g,this.m=d,this.n=f,this.g=this.B(new a.$he),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=$.f(g),this.B(this.j.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new T.$Tc))(w=>this.r(w)))}r(g){if(this.h.has(g.key.toLowerCase())){this.g.fire();return}const d=$.c(g.key);if(d){if(this.j.get(g.key,O.StorageScope.PROFILE)===void 0)this.h.delete(d.id.toLowerCase());else{let f=this.h.get(d.id.toLowerCase());f||this.h.set(d.id.toLowerCase(),f=[]),f.push(d.version),this.g.fire()}return}}s(g){if((0,S.$ag)(g))return g;const d=g.manifest?g.manifest.publisher:g.publisher,f=g.manifest?g.manifest.name:g.name;return(0,C.$Fp)(d,f)}getExtensionState(g,d){const f=this.s(g),w=this.getExtensionStateRaw(g,d);if(w)try{return JSON.parse(w)}catch(E){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${d}): ${E}`)}}getExtensionStateRaw(g,d){const f=this.s(g),w=this.j.get(f,d?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE);return w&&w?.length>$.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${d}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(g,d,f){const w=this.s(g);d===void 0?this.j.remove(w,f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(d),f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE,O.StorageTarget.MACHINE)}setKeysForSync(g,d){this.j.store($.b(g),JSON.stringify(d),O.StorageScope.PROFILE,O.StorageTarget.MACHINE)}getKeysForSync(g){const d=this.m.extensionSyncedKeys?.[g.id.toLowerCase()],f=this.j.get($.b(g),O.StorageScope.PROFILE),w=f?JSON.parse(f):void 0;return w&&d?(0,L.$Mb)([...w,...d]):w||d}addToMigrationList(g,d){if(g!==d){const f=this.t.filter(w=>!w.includes(g)&&!w.includes(d));f.push([g,d]),this.t=f}}getSourceExtensionToMigrate(g){const d=this.t.find(([,f])=>g===f);return d?d[0]:void 0}get t(){const g=this.j.get("extensionStorage.migrationList",O.StorageScope.APPLICATION,"[]");try{const d=JSON.parse(g);if(Array.isArray(d))return d}catch{}return[]}set t(g){g.length?this.j.store("extensionStorage.migrationList",JSON.stringify(g),O.StorageScope.APPLICATION,O.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",O.StorageScope.APPLICATION)}};e.$ew=p,e.$ew=p=$=ve([Z(0,O.$9p),Z(1,A.$nk),Z(2,y.$7j)],p)}),define(le[255],he([0,1,2,28,86,233,118,10,17]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;let y=class extends k.$Uc{constructor($,h,p,l,g,d){super(),$.cleanUp(),(0,O.$j5b)($,h,p,l,d),T.$ew.removeOutdatedExtensionVersions($,g)}};e.$Sfc=y,e.$Sfc=y=ve([Z(0,C.$Mq),Z(1,a.$bp),Z(2,T.$dw),Z(3,a.$hp),Z(4,L.$9p),Z(5,A.$7j)],y)}),define(le[256],he([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;let f=class extends a.$Uc{constructor(t,s){super(),this.b=t,this.c=s,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,o])=>this.a.set(o.configPath,o))}getConfigBasedTips(t){return this.f(t)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(t){const s=[];for(const[o,i]of this.a)if(!(i.configScheme&&i.configScheme!==t.scheme))try{const n=(await this.b.readFile((0,T.$bh)(t,o))).value.toString();for(const[r,c]of Object.entries(i.recommendations))(!c.contentPattern||new RegExp(c.contentPattern,"mig").test(n))&&s.push({extensionId:r,extensionName:c.name,configName:i.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})}catch{}return s}};e.$acc=f,e.$acc=f=ve([Z(0,C.$7k),Z(1,A.$nk)],f);const w="extensionTips/promptedExecutableTips",E="extensionTips/lastPromptedMediumImpExeTime";class u extends f{constructor(t,s,o,i,n,r,c,m){super(c,m),this.r=t,this.s=s,this.t=o,this.u=i,this.w=n,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,m.exeBasedExtensionTips&&Object.entries(m.exeBasedExtensionTips).forEach(([v,P])=>{const R=[],I=[],N=[];Object.entries(P.recommendations).forEach(([U,j])=>{j.important?P.important?R.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):I.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):N.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),R.length&&this.g.set(v,{exeFriendlyName:P.friendlyName,windowsPath:P.windowsPath,recommendations:R}),I.length&&this.h.set(v,{exeFriendlyName:P.friendlyName,windowsPath:P.windowsPath,recommendations:I}),N.length&&this.j.set(v,{exeFriendlyName:P.friendlyName,windowsPath:P.windowsPath,recommendations:N})}),(0,L.$Ch)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const t=await this.O(this.g),s=await this.O(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const t=await this.O(this.g),s=await this.O(this.h),o=await this.u.getInstalled();this.m=this.D(t,o),this.n=this.D(s,o)}D(t,s){const o=new Map;t.forEach(m=>o.set(m.extensionId.toLowerCase(),m));const{installed:i,uninstalled:n}=this.N([...o.keys()],s);for(const m of i){const v=o.get(m);v&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:m,exeName:v.exeName})}for(const m of n){const v=o.get(m);v&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:m,exeName:v.exeName})}const r=this.L(),c=new Map;for(const m of n){const v=o.get(m);if(v&&(!r[v.exeName]||!r[v.exeName].includes(v.extensionId))){let P=c.get(v.exeName);P||(P=[],c.set(v.exeName,P)),P.push(v)}}return c}F(){if(this.m.size===0)return;const[t,s]=[...this.m.entries()][0];this.H(s).then(o=>{switch(o){case l.RecommendationsNotificationResult.Accepted:this.M(s[0].exeName,s);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(t);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const i=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const i=this.B(new a.$Vc);i.value=(0,L.$Ch)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const t=this.I(),s=Date.now()-t,o=7*24*60*60*1e3;if(s<o){const r=this.B(new a.$Vc);r.value=(0,L.$Ch)(()=>{r.dispose(),this.G()},o-s);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const c=this.B(new a.$Vc);c.value=(0,L.$Ch)(()=>{c.dispose(),this.G()},o);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const c=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(c(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const c=this.B(new a.$Vc);c.value=(0,L.$Ch)(()=>{c.dispose(),this.G()},60*60*1e3);break}}})}async H(t){const s=await this.u.getInstalled(g.ExtensionType.User),o=t.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>s.every(r=>!(0,p.$Cp)(r.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:o,source:l.RecommendationSource.EXE,name:t[0].exeFriendlyName,searchValue:`@exe:"${t[0].exeName}"`})}I(){let t=this.w.getNumber(E,d.StorageScope.APPLICATION);return t||(t=Date.now(),this.J(t)),t}J(t){this.w.store(E,t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,d.StorageScope.APPLICATION,"{}"))}M(t,s){const o=this.L();o[t]=s.map(({extensionId:i})=>i.toLowerCase()),this.w.store(w,JSON.stringify(o),d.StorageScope.APPLICATION,d.StorageTarget.USER)}N(t,s){const o=[],i=[],n=s.reduce((r,c)=>(r.add(c.identifier.id.toLowerCase()),r),new Set);return t.forEach(r=>{n.has(r.toLowerCase())?o.push(r):i.push(r)}),{installed:o,uninstalled:i}}async O(t){const s=[],o=new Map;for(const i of t.keys()){const n=t.get(i);if(!n||!(0,k.$Lb)(n.recommendations))continue;const r=[];$.$i?n.windowsPath&&r.push(n.windowsPath.replace("%USERPROFILE%",()=>h.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>h.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>h.env.ProgramFiles).replace("%APPDATA%",()=>h.env.APPDATA).replace("%WINDIR%",()=>h.env.WINDIR)):(r.push((0,S.$jc)("/usr/local/bin",i)),r.push((0,S.$jc)("/usr/bin",i)),r.push((0,S.$jc)(this.r.fsPath,i)));for(const c of r){let m=o.get(c);if(m===void 0&&(m=await this.b.exists(O.URI.file(c)),o.set(c,m)),m)for(const{extensionId:v,extensionName:P,isExtensionPack:R,whenNotInstalled:I}of n.recommendations)s.push({extensionId:v,extensionName:P,isExtensionPack:R,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:I})}}return s}}e.$bcc=u}),define(le[257],he([0,1,28,7,24,16,75,58,17,18,256]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let $=class extends S.$bcc{constructor(p,l,g,d,f,w,E,u){super(p.userHome,f,l,g,d,w,E,u)}};e.$Zfc=$,e.$Zfc=$=ve([Z(0,O.$Ii),Z(1,y.$6l),Z(2,k.$ep),Z(3,L.$9p),Z(4,A.$Vdc),Z(5,C.$44b),Z(6,a.$7k),Z(7,T.$nk)],$)}),define(le[50],he([0,1,15,32,17]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=O;async function O(C,A,L){let y=L&&L.get("storage.serviceMachineId",T.StorageScope.APPLICATION)||null;if(y)return y;try{const $=(await A.readFile(C.serviceMachineIdResource)).value.toString();y=(0,a.$Vg)($)?$:null}catch{y=null}if(!y){y=(0,a.$Wg)();try{await A.writeFile(C.serviceMachineIdResource,k.$Je.fromString(y))}catch{}}return L?.store("storage.serviceMachineId",y,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE),y}}),define(le[258],he([0,1,50,18,49]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=O;async function O(C,A,L,y,S,$,h){const p={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${A.nameShort})`};if((0,T.$up)(A,L)&&(0,T.$wp)(y)===a.TelemetryLevel.USAGE){const l=await(0,k.$cq)(L,S,$);p["X-Market-User-Id"]=l,p["VSCode-SessionId"]=h.machineId||l}return p}}),define(le[259],he([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,60,258,17,18,65]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0,e.$eq=ce;const s=O.$o?p.TargetPlatform.WEB:(0,$.$0o)(O.$u,C.$ec),o="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((M,z)=>M|z,0))}var r;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},P={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class R{constructor(M=P){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,z=this.d.pageSize){return new R({...this.d,pageNumber:M,pageSize:z})}withFilter(M,...z){const te=[...this.d.criteria,...z.length?z.map(_=>({filterType:M,value:_})):[{filterType:M}]];return new R({...this.d,criteria:te})}withSortBy(M){return new R({...this.d,sortBy:M})}withSortOrder(M){return new R({...this.d,sortOrder:M})}withFlags(...M){return new R({...this.d,flags:M.reduce((z,te)=>z|te,0)})}withAssetTypes(...M){return new R({...this.d,assetTypes:M})}withSource(M){return new R({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:z,pageSize:te,sortBy:_,sortOrder:Y,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:M,pageNumber:z,pageSize:te,sortBy:_,sortOrder:Y}],assetTypes:ue,flags:ae}}get searchText(){const M=this.d.criteria.filter(z=>z.filterType===r.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function I(B,M){const z=(B||[]).filter(te=>te.statisticName===M)[0];return z?z.value:0}function N(B){const M="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(te=>te.assetType.indexOf(M)===0).reduce((te,_)=>{const Y=F(B,_.assetType);return Y&&te.push([_.assetType.substring(M.length),Y]),te},[])}function U(B){if(B.properties){const M=B.properties.filter(_=>_.key===c.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=M.filter(_=>z.test(_.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return F(B,c.Repository)}function j(B){return{uri:`${B.fallbackAssetUri}/${c.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${c.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function F(B,M){return B.files.filter(te=>te.assetType===M)[0]?{uri:`${B.assetUri}/${M}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${M}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function X(B,M){const z=B.properties?B.properties.filter(_=>_.key===M):[],te=z.length>0&&z[0].value;return te?te.split(",").map(_=>(0,h.$Gp)(_)):[]}function K(B){const M=B.properties?B.properties.filter(z=>z.key===m.Engine):[];return M.length>0&&M[0].value||""}function Q(B){const M=B.properties?B.properties.filter(z=>z.key===m.PreRelease):[];return M.length>0&&M[0].value==="true"}function V(B){const M=B.properties?B.properties.filter(te=>te.key===m.LocalizedLanguages):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function ie(B){return B.properties?.find(M=>M.key===m.SponsorLink)?.value}function H(B){return B.properties?.find(M=>M.key===m.SupportLink)?.value}function W(B){return B.indexOf("preview")!==-1}function ee(B){return B.targetPlatform?(0,$.$9o)(B.targetPlatform):p.TargetPlatform.UNDEFINED}function re(B){const M=(0,k.$Mb)(B.versions.map(ee)),z=!!B.tags?.includes($.$3o),te=M.indexOf(p.TargetPlatform.WEB);return z?te===-1&&M.push(p.TargetPlatform.WEB):te!==-1&&M.splice(te,1),M}function ce(B,M){for(let z=0;z<B.length;z++){const te=B[z];if(te.version===B[z-1]?.version){let _=z;if(ee(te)===M)for(;_>0&&B[_-1].version===te.version;)_--;_!==z&&(B.splice(z,1),B.splice(_,0,te))}}return B}function q(B,M,z){B.telemetryData={index:M,querySource:z,queryActivityId:B.queryContext?.[o]}}function x(B,M,z,te){const _=B.versions[0],Y={manifest:F(M,c.Manifest),readme:F(M,c.Details),changelog:F(M,c.Changelog),license:F(M,c.License),repository:U(M),download:j(M),icon:F(M,c.Icon),signature:F(M,c.Signature),coreTranslations:N(M)};return{type:"gallery",identifier:{id:(0,h.$Hp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:M.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(_),description:B.shortDescription??"",installCount:I(B.statistics,"install"),rating:I(B.statistics,"averagerating"),ratingCount:I(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:z,assets:Y,properties:{dependencies:X(M,m.Dependency),extensionPack:X(M,m.ExtensionPack),engine:K(M),localizedLanguages:V(M),targetPlatform:ee(M),isPreReleaseVersion:Q(M)},hasPreReleaseVersion:Q(_),hasReleaseVersion:!0,preview:W(B.flags),isSigned:!!Y.signature,queryContext:te,supportLink:H(_)}}let J=class{constructor(M,z,te,_,Y,ae,ue,ge){this.k=z,this.l=te,this.n=_,this.o=Y,this.q=ae,this.u=ue,this.w=ge;const we=ue.extensionsGallery,Ee=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=Ee?we.servicePPEUrl:we?.serviceUrl,this.g=Ee?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,E.$dq)(ue.version,ue,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,z,te){const _=a.CancellationToken.isCancellationToken(z)?{}:z,Y=a.CancellationToken.isCancellationToken(z)?z:te,ae=[],ue=[],ge=[],we=[];let Ee=!0;for(const Se of M){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Ie=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),Ee=Ee&&!!Se.hasPreRelease&&!Ie}if(!ue.length&&!ae.length)return[];let pe=new R().withPage(1,M.length);ue.length&&(pe=pe.withFilter(r.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(r.ExtensionName,...ae)),(_.queryAllVersions||Ee)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:be}=await this.z(pe,{targetPlatform:_.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},Y);return _.source&&be.forEach((Se,Ie)=>q(Se,Ie,_.source)),be}async getCompatibleExtension(M,z,te,_={version:this.u.version,date:this.u.date}){if((0,$.$$o)(M.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(M,z,te))return M;const Y=new R().withFlags(i.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,M.identifier.uuid),{extensions:ae}=await this.z(Y,{targetPlatform:te,compatible:!0,includePreRelease:z,productVersion:_},a.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(M,z,te,_={version:this.u.version,date:this.u.date}){if(!(0,$.$_o)(M.properties.targetPlatform,M.allTargetPlatforms,te)||!z&&M.properties.isPreReleaseVersion)return!1;let Y=M.properties.engine;if(!Y){const ae=await this.getManifest(M,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return(0,l.$Up)(Y,_.version,_.date)}async y(M,z,te,_,Y,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,$.$_o)(ee(z),Y,ae)||te!=="any"&&Q(z)!==(te==="prerelease"))return!1;if(_)try{const ge=await this.E(M,z);if(!(0,l.$Up)(ge,ue.version,ue.date))return!1}catch(ge){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,T.$0)(ge)),!1}return!0}async query(M,z){let te=M.text||"";const _=M.pageSize??50;let Y=new R().withPage(1,_);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(r.Category,be||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(r.Tag,be||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(r.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Y=Y.withFilter(r.SearchText,te)),Y=Y.withSortBy($.SortBy.NoneOrRelevance)):M.ids?Y=Y.withFilter(r.ExtensionId,...M.ids):M.names?Y=Y.withFilter(r.ExtensionName,...M.names):Y=Y.withSortBy($.SortBy.InstallCount),typeof M.sortBy=="number"&&(Y=Y.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(Y=Y.withSortOrder(M.sortOrder)),M.source&&(Y=Y.withSource(M.source));const ae=async(Ee,pe)=>{const{extensions:be,total:Se}=await this.z(Ee,{targetPlatform:s,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.u.version,date:this.u.date}},pe);return be.forEach((Ie,oe)=>q(Ie,(Ee.pageNumber-1)*Ee.pageSize+oe,M.source)),{extensions:be,total:Se}},{extensions:ue,total:ge}=await ae(Y,z),we=async(Ee,pe)=>{if(pe.isCancellationRequested)throw new T.$5;const{extensions:be}=await ae(Y.withPage(Ee+1),pe);return be};return{firstPage:ue,total:ge,pageSize:Y.pageSize,getPage:we}}async z(M,z,te){const _=M.flags;M.flags&i.IncludeLatestVersionOnly&&M.flags&i.IncludeVersions&&(M=M.withFlags(M.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(M.flags&i.IncludeLatestVersionOnly)&&!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags,i.IncludeLatestVersionOnly)),z.versions?.length&&(M=M.withFlags(M.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),M=M.withFlags(M.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:ue}=await this.B(M,te);if(!(M.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const be of Y){const Se=await this.A(be,z,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const we=[],Ee=new Map;for(let pe=0;pe<Y.length;pe++){const be=Y[pe],Se={id:(0,h.$Hp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ie=(0,A.$gg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,h.$Cp)(de,Se))?.includePreRelease;if(z.compatible&&(0,$.$$o)(re(be),z.targetPlatform))continue;const oe=await this.A(be,z,ue);!oe||oe.properties.isPreReleaseVersion&&(!Ie||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==z.targetPlatform&&oe.hasPreReleaseVersion?Ee.set(be.extensionId,pe):we.push([pe,oe])}if(Ee.size){const pe=new t.$be,be=new R().withFlags(_&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(r.ExtensionId,...Ee.keys()),{extensions:Se}=await this.z(be,z,te);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ee.size});for(const Ie of Se){const oe=Ee.get(Ie.identifier.uuid);we.push([oe,Ie])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:ae}}async A(M,z,te){const _={id:(0,h.$Hp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Y=z.versions?.find(we=>(0,h.$Cp)(we,_))?.version,ae=(0,A.$gg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(we=>(0,h.$Cp)(we,_))?.includePreRelease,ue=re(M),ge=ce(M.versions,z.targetPlatform);if(z.compatible&&(0,$.$$o)(ue,z.targetPlatform))return null;for(let we=0;we<ge.length;we++){const Ee=ge[we];if(!(Y&&Ee.version!==Y)){if(await this.y((0,h.$Hp)(M.publisher.publisherName,M.extensionName),Ee,ae?"any":"release",z.compatible,ue,z.targetPlatform,z.productVersion))return x(M,Ee,ue,te);if(Y&&Ee.version===Y)return null}}return Y||z.compatible?null:x(M,M.versions[0],ue)}async B(M,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,i.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(i.Unpublished));const te=await this.j,_=JSON.stringify(M.raw),Y={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new t.$be;let ue,ge,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&M.criteria.some(pe=>pe.filterType===r.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:Y},z),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const Ee=await(0,w.$2p)(ue);if(Ee){const pe=Ee.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[o]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(Ee){if((0,T.$4)(Ee))throw ge=$.ExtensionGalleryErrorCode.Cancelled,Ee;{const pe=(0,T.$0)(Ee);throw ge=pe.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$cp(pe,ge)}}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(_.length),duration:ae.elapsed(),success:!!ue&&(0,w.$Xp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(M,z,te,_){if(!this.isEnabled())return;const Y=O.$o?this.x(`/itemName/${M}.${z}/version/${te}/statType/${_===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${z}/${te}/stats?statType=${_}`),ae=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:Y,headers:ge},a.CancellationToken.None)}catch{}}async download(M,z,te){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const _=(0,h.$Kp)(M),Y=new Date().getTime(),ae=te===$.InstallOperation.Install?"install":te===$.InstallOperation.Update?"update":"",ue=ae?{uri:`${M.assets.download.uri}${L.URI.parse(M.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${M.assets.download.fallbackUri}${L.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:M.assets.download,ge=M.queryContext?.[o]?{[o]:M.queryContext[o]}:void 0,we=await this.D(M.identifier.id,ue,c.VSIX,ge?{headers:ge}:void 0);try{await this.q.writeFile(z,we.stream)}catch(Ee){try{await this.q.del(z)}catch(pe){this.l.warn(`Error while deleting the file ${z.toString()}`,(0,T.$0)(pe))}throw new $.$cp((0,T.$0)(Ee),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{..._,duration:new Date().getTime()-Y})}async downloadSignatureArchive(M,z){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const te=await this.D(M.identifier.id,M.assets.signature,c.Signature);try{await this.q.writeFile(z,te.stream)}catch(_){try{await this.q.del(z)}catch(Y){this.l.warn(`Error while deleting the file ${z.toString()}`,(0,T.$0)(Y))}throw new $.$cp((0,T.$0)(_),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,z){if(M.assets.readme){const te=await this.D(M.identifier.id,M.assets.readme,c.Details,{},z);return await(0,w.$1p)(te)||""}return""}async getManifest(M,z){if(M.assets.manifest){const te=await this.D(M.identifier.id,M.assets.manifest,c.Manifest,{},z),_=await(0,w.$1p)(te);return _?JSON.parse(_):null}return null}async C(M,z,te){const _=F(z,c.Manifest);if(!_)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.D(M,_,c.Manifest,{headers:Y});return await(0,w.$2p)(ae)}async getCoreTranslation(M,z){const te=M.assets.coreTranslations.filter(_=>_[0]===z.toUpperCase())[0];if(te){const _=await this.D(M.identifier.id,te[1],te[0]),Y=await(0,w.$1p)(_);return Y?JSON.parse(Y):null}return null}async getChangelog(M,z){if(M.assets.changelog){const te=await this.D(M.identifier.id,M.assets.changelog,c.Changelog,{},z);return await(0,w.$1p)(te)||""}return""}async getAllCompatibleVersions(M,z,te){let _=new R().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?_=_.withFilter(r.ExtensionId,M.identifier.uuid):_=_.withFilter(r.ExtensionName,M.identifier.id);const{galleryExtensions:Y}=await this.B(_,a.CancellationToken.None);if(!Y.length)return[];const ae=re(Y[0]);if((0,$.$$o)(ae,te))return[];const ue=[];await Promise.all(Y[0].versions.map(async Ee=>{try{await this.y(M.identifier.id,Ee,z?"any":"release",!0,ae,te)&&ue.push(Ee)}catch{}}));const ge=[],we=new Set;for(const Ee of ce(ue,te))we.has(Ee.version)||(we.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:Q(Ee)}));return ge}async D(M,z,te,_={},Y=a.CancellationToken.None){const ae=await this.j,ue={type:"GET"},ge={...ae,..._.headers||{}};_={..._,...ue,headers:ge};const we=z.uri,Ee=z.fallbackUri,pe={..._,url:we};try{const be=await this.k.request(pe,Y);if(be.res.statusCode===200)return be;const Se=await(0,w.$1p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,T.$4)(be))throw be;const Se=(0,T.$0)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:M,assetType:te,message:Se});const Ie={..._,url:Ee};return this.k.request(Ie,Y)}}async E(M,z){let te=K(z);if(!te){this.o.publicLog2("galleryService:engineFallback",{extension:M,version:z.version});const _=await this.C(M,z,a.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.k.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,w.$2p)(M),te=[],_={},Y=[];if(z){for(const ae of z.malicious)te.push({id:ae});if(z.migrateToPreRelease)for(const[ae,ue]of Object.entries(z.migrateToPreRelease))(!ue.engine||(0,l.$Up)(ue.engine,this.u.version,this.u.date))&&(_[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[ae,ue]of Object.entries(z.deprecated))ue&&(_[ae.toLowerCase()]=(0,A.$gg)(ue)?{}:ue);if(z.search)for(const ae of z.search)Y.push(ae)}return{malicious:te,deprecated:_,search:Y}}};J=ve([Z(1,w.$Vp),Z(2,d.$7j),Z(3,S.$Hi),Z(4,b.$6l),Z(5,g.$7k),Z(6,f.$nk),Z(7,y.$7i)],J);let G=class extends J{constructor(M,z,te,_,Y,ae,ue,ge){super(M,z,te,_,Y,ae,ue,ge)}};e.$fq=G,e.$fq=G=ve([Z(0,u.$9p),Z(1,w.$Vp),Z(2,d.$7j),Z(3,S.$Hi),Z(4,b.$6l),Z(5,g.$7k),Z(6,f.$nk),Z(7,y.$7i)],G);let D=class extends J{constructor(M,z,te,_,Y,ae,ue){super(void 0,M,z,te,_,Y,ae,ue)}};e.$gq=D,e.$gq=D=ve([Z(0,w.$Vp),Z(1,d.$7j),Z(2,S.$Hi),Z(3,b.$6l),Z(4,g.$7k),Z(5,f.$nk),Z(6,y.$7i)],D)}),define(le[260],he([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;const b=[k.$Ofc,k.$Pfc],t="remoteTunnelSession",s="remoteTunnelIsService";let o=class extends C.$Uc{constructor(c,m,v,P,R,I,N){super(),this.y=c,this.z=m,this.C=v,this.D=I,this.F=N,this.f=new a.$he,this.onDidTokenFailed=this.f.event,this.g=new a.$he,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$he,this.onDidChangeMode=this.h.event,this.n=k.$Mfc,this.w=!1,this.I=(U,j)=>{j?this.j.error(U):this.j.info(U)},this.j=this.B(P.createLogger((0,u.$bh)(v.logsHome,`${k.$Qfc}.log`),{id:k.$Qfc,name:k.$Rfc})),this.t=new h.$xh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,A.$jk)(U)))),this.B(R.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(U=>{b.some(j=>U.affectsConfiguration(j))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=k.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(c){this.s=c,this.g.fire(c)}H(c){n(this.n,c)||(this.n=c,this.S(c),this.h.fire(this.n),c.active?(this.j.info(`Session updated: ${c.session.accountLabel} (${c.session.providerId}) (service=${c.asService})`),c.session.token&&this.j.info(`Session token updated: ${c.session.accountLabel} (${c.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(c){if(this.w)return this.s;this.w=!0,this.H(c);try{await this.t.trigger(()=>this.L())}catch(m){this.j.error(m)}return this.s}J(){if(!this.u){let c;$.$j?c=this.C.appRoot:c=(0,L.$mc)((0,L.$mc)(this.C.appRoot)),this.u=(0,L.$jc)(c,"bin",`${this.z.tunnelApplicationName}${$.$i?".exe":""}`)}return this.u}async startTunnel(c){if(n(this.n,c)&&this.s.type!=="disconnected")return this.s;this.H(c);try{await this.t.trigger(()=>this.L())}catch(m){this.j.error(m)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const c=this.n.asService;this.H(k.$Mfc);try{c&&this.O("uninstallService",["service","uninstall"])}catch(m){this.j.error(m)}}try{await this.O("stop",["kill"])}catch(c){this.j.error(c)}this.G(k.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let c="",m=!1;const v=(j,F)=>{F?this.j.error(j):c+=j,!this.C.isBuilt&&j.startsWith("   Compiling")&&this.G(k.TunnelStates.connecting((0,g.localize)(0,null)))},P=this.O("status",["status"],v);this.r=P;try{if(await P,this.r!==P)return;let j;try{j=JSON.parse(c.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(c.trim())}`),this.G(k.TunnelStates.disconnected());return}if(m=j.service_installed,this.j.info(j.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!j.tunnel&&!this.n.active){this.G(k.TunnelStates.disconnected());return}}catch(j){this.j.error(j),this.G(k.TunnelStates.disconnected());return}finally{this.r===P&&(this.r=void 0)}const R=this.n.active?this.n.session:void 0;if(R&&R.token){const j=R.token;this.G(k.TunnelStates.connecting((0,g.localize)(1,null,R.accountLabel,R.providerId)));const F=(K,Q)=>{K=K.replaceAll(j,"*".repeat(4)),v(K,Q)},X=this.O("login",["user","login","--provider",R.providerId,"--log",(0,A.$jk)(this.j.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:j});this.r=X;try{if(await X,this.r!==X)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(R),this.G(k.TunnelStates.disconnected(R));return}}const I=this.Q();I?this.G(k.TunnelStates.connecting((0,g.localize)(2,null,I))):this.G(k.TunnelStates.connecting((0,g.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,A.$jk)(this.j.getLevel())];I?N.push("--name",I):N.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!m&&(U=await this.M(N)===!1),this.N(R,N,U)}async M(c){let m;try{m=await this.O("serviceInstall",["service","install",...c])}catch(v){this.j.error(v),m=1}if(m!==0){const v=(0,g.localize)(4,null);return this.j.warn(v),this.G(k.TunnelStates.connecting(v)),!1}return!0}async N(c,m,v){m.push("--parent-process-id",String(process.pid)),this.P()&&m.push("--no-sleep");let P=!1;const R=this.O("tunnel",m,(I,N)=>{N?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(P=!0);const U=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const j={link:U[1],domain:U[2],tunnelName:U[4],isAttached:P};this.G(k.TunnelStates.connected(j,v))}else I.match(/error refreshing token/)&&(R.cancel(),this.f.fire(c),this.G(k.TunnelStates.disconnected(c)))});this.r=R,R.finally(()=>{R===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=k.$Mfc,this.G(k.TunnelStates.disconnected()))})}O(c,m,v=this.I,P){return(0,h.$nh)(R=>new Promise((I,N)=>{R.isCancellationRequested&&I(-1);let U;const j=["ignore","pipe","pipe"];if(R.onCancellationRequested(()=>{U&&(this.j.info(`${c} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${c} Spawning: cargo run -- tunnel ${m.join(" ")}
`,!1),U=(0,y.spawn)("cargo",["run","--","tunnel",...m],{cwd:(0,L.$jc)(this.C.appRoot,"cli"),stdio:j,env:{...process.env,RUST_BACKTRACE:"1",...P}});else{v(`Running tunnel CLI
`,!1);const F=this.J();v(`${c} Spawning: ${F} tunnel ${m.join(" ")}
`,!1),U=(0,y.spawn)(F,["tunnel",...m],{cwd:(0,d.homedir)(),stdio:j,env:{...process.env,...P}})}U.stdout.pipe(new E.$mW(`
`)).on("data",F=>{if(U){const X=F.toString();v(X,!1)}}),U.stderr.pipe(new E.$mW(`
`)).on("data",F=>{if(U){const X=F.toString();v(X,!0)}}),U.on("exit",F=>{U&&(v(`${c} exit(${U.pid}): + ${F} `,!1),U=void 0,I(F||0))}),U.on("error",F=>{U&&(v(`${c} error(${U.pid}): + ${F} `,!0),U=void 0,N())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(k.$Pfc)}Q(){let c=this.D.getValue(k.$Ofc)||(0,d.hostname)();return c=c.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),c||void 0}R(){try{const c=this.F.get(t,f.StorageScope.APPLICATION),m=this.F.getBoolean(s,f.StorageScope.APPLICATION,!1);if(c){const v=JSON.parse(c);if(v&&(0,w.$ag)(v.accountLabel)&&(0,w.$ag)(v.sessionId)&&(0,w.$ag)(v.providerId))return{active:!0,session:v,asService:m};this.j.error("Problems restoring session from storage, invalid format",v)}}catch(c){this.j.error("Problems restoring session from storage",c)}return k.$Mfc}S(c){if(c.active){const m={providerId:c.session.providerId,sessionId:c.session.sessionId,accountLabel:c.session.accountLabel};this.F.store(t,JSON.stringify(m),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(s,c.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(t,f.StorageScope.APPLICATION),this.F.remove(s,f.StorageScope.APPLICATION)}};e.$Vfc=o,e.$Vfc=o=ve([Z(0,T.$6l),Z(1,S.$nk),Z(2,O.$Ii),Z(3,A.$8j),Z(4,p.$Tfc),Z(5,l.$7i),Z(6,f.$9p)],o);function i(r,c){return r&&c?r.sessionId===c.sessionId&&r.providerId===c.providerId&&r.token===c.token:r===c}const n=(r,c)=>r.active!==c.active?!1:r.active&&c.active?r.asService===c.asService&&i(r.session,c.session):!0}),define(le[261],he([0,1,6,2,23,21,71,17,80,20]),function(ne,e,k,a,T,O,C,A,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class S extends A.$$p{constructor(h,p,l,g){super(),this.bb=h,this.cb=p,this.db=l,this.eb=g,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Tc),this.ab=this.hb(this.bb)}fb(){const h=this.B(new L.$nLb(this.db.getChannel("storage"))),p=this.B(new C.$5p(h));return this.B(p.onDidChangeStorage(l=>this.u(A.StorageScope.APPLICATION,l))),p}gb(h){this.X.clear(),this.W=h;let p;if((0,A.$_p)(h))p=this.U;else{const l=this.X.add(new L.$oLb(this.db.getChannel("storage"),h));p=this.X.add(new C.$5p(l))}return this.X.add(p.onDidChangeStorage(l=>this.u(A.StorageScope.PROFILE,l))),p}hb(h){this.$.clear(),this.Z=h?.id;let p;if(h){const l=this.$.add(new L.$pLb(this.db.getChannel("storage"),h));p=this.$.add(new C.$5p(l)),this.$.add(p.onDidChangeStorage(g=>this.u(A.StorageScope.WORKSPACE,g)))}return p}async O(){await k.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(h){switch(h){case A.StorageScope.APPLICATION:return this.U;case A.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(h){switch(h){case A.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;case A.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;default:return this.Z?`${(0,O.$bh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:T.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(h){if(!this.M(this.W,h))return;const p=this.Y,l=p.items;p!==this.U&&await p.close(),this.Y=this.gb(h),await this.Y.init(),this.N(l,this.Y,A.StorageScope.PROFILE)}async S(h,p){const l=this.ab,g=l?.items??new Map;await l?.close(),this.ab=this.hb(h),await this.ab.init(),this.N(g,this.ab,A.StorageScope.WORKSPACE)}hasScope(h){return(0,y.$Fl)(h)?this.W.id===h.id:this.Z===h.id}}e.$1fc=S}),define(le[262],he([0,1,3,2,20,95]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0;class C{constructor(y,S){this.a=y,this.b=S}listen(y,S){const $=this.b(y);switch(S){case"onDidChangeProfiles":return k.Event.map(this.a.onDidChangeProfiles,h=>({all:h.all.map(p=>(0,O.$Fn)({...p},$)),added:h.added.map(p=>(0,O.$Fn)({...p},$)),removed:h.removed.map(p=>(0,O.$Fn)({...p},$)),updated:h.updated.map(p=>(0,O.$Fn)({...p},$))}))}throw new Error(`Invalid listen ${S}`)}async call(y,S,$){const h=this.b(y);switch(S){case"createProfile":{const p=await this.a.createProfile($[0],$[1],$[2]);return(0,O.$Fn)({...p},h)}case"updateProfile":{let p=(0,T.$Hl)((0,O.$Gn)($[0],h),this.a.profilesHome.scheme);return p=await this.a.updateProfile(p,$[1]),(0,O.$Fn)({...p},h)}case"removeProfile":{const p=(0,T.$Hl)((0,O.$Gn)($[0],h),this.a.profilesHome.scheme);return this.a.removeProfile(p)}}throw new Error(`Invalid call ${S}`)}}e.$rQ=C;class A extends a.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(y,S,$){super(),this.profilesHome=S,this.f=$,this.a=[],this.b=this.B(new k.$he),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=y.map(h=>(0,T.$Hl)(h,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(h=>{const p=h.added.map(d=>(0,T.$Hl)(d,this.profilesHome.scheme)),l=h.removed.map(d=>(0,T.$Hl)(d,this.profilesHome.scheme)),g=h.updated.map(d=>(0,T.$Hl)(d,this.profilesHome.scheme));this.a=h.all.map(d=>(0,T.$Hl)(d,this.profilesHome.scheme)),this.b.fire({added:p,removed:l,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(y){this.c=y}isEnabled(){return this.c}async createNamedProfile(y,S,$){const h=await this.f.call("createNamedProfile",[y,S,$]);return(0,T.$Hl)(h,this.profilesHome.scheme)}async createProfile(y,S,$,h){const p=await this.f.call("createProfile",[y,S,$,h]);return(0,T.$Hl)(p,this.profilesHome.scheme)}async createTransientProfile(y){const S=await this.f.call("createTransientProfile",[y]);return(0,T.$Hl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(y,S){await this.f.call("setProfileForWorkspace",[y,S])}removeProfile(y){return this.f.call("removeProfile",[y])}async updateProfile(y,S){const $=await this.f.call("updateProfile",[y,S]);return(0,T.$Hl)($,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$sQ=A}),define(le[61],he([0,1,2,71,4,17,3,80,20]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tLb=e.$sLb=e.$rLb=void 0,e.$rLb=(0,T.$Ai)("IUserDataProfileStorageService");let y=class extends k.$Uc{constructor(p){super(),this.a=p}async readStorageData(p){return this.withProfileScopedStorageService(p,async l=>this.b(l))}async updateStorageData(p,l,g){return this.withProfileScopedStorageService(p,async d=>this.c(d,l,g))}async withProfileScopedStorageService(p,l){if(this.a.hasScope(p))return l(this.a);const g=await this.g(p),d=new $(g);try{await d.initialize();const f=await l(d);return await d.flush(),f}finally{d.dispose(),await this.f(g)}}b(p){const l=new Map,g=d=>{for(const f of p.keys(O.StorageScope.PROFILE,d))l.set(f,{value:p.get(f,O.StorageScope.PROFILE),target:d})};return g(O.StorageTarget.USER),g(O.StorageTarget.MACHINE),l}c(p,l,g){p.storeAll(Array.from(l.entries()).map(([d,f])=>({key:d,value:f,scope:O.StorageScope.PROFILE,target:g})),!0)}async f(p){try{await p.close()}finally{(0,k.$Oc)(p)&&p.dispose()}}};e.$sLb=y,e.$sLb=y=ve([Z(0,O.$9p)],y);class S extends y{constructor(p,l,g,d){super(g),this.j=p;const f=p.getChannel("profileStorageListener"),w=this.B(new k.$Vc);this.h=this.B(new C.$he({onWillAddFirstListener:()=>{w.value=f.listen("onDidChange")(E=>{d.trace("profile storage changes",E),this.h.fire({targetChanges:E.targetChanges.map(u=>(0,L.$Hl)(u,l.profilesHome.scheme)),valueChanges:E.valueChanges.map(u=>({...u,profile:(0,L.$Hl)(u.profile,l.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>w.value=void 0})),this.onDidChange=this.h.event}async g(p){const l=this.j.getChannel("storage");return(0,O.$_p)(p)?new A.$nLb(l):new A.$oLb(l,p)}}e.$tLb=S;class $ extends O.$$p{constructor(p){super({flushInterval:100}),this.s=this.B(new a.$5p(p))}O(){return this.s.init()}P(p){return p===O.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[263],he([0,1,17,10,20,57,61]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let A=class extends C.$tLb{constructor(y,S,$,h){super(y,S,$,h)}};e.$Ffc=A,e.$Ffc=A=ve([Z(0,O.$afc),Z(1,T.$Gl),Z(2,k.$9p),Z(3,a.$7j)],A)}),define(le[41],he([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AMb=e.$zMb=e.$yMb=e.$xMb=void 0,e.$uMb=t,e.$vMb=s,e.$wMb=o;function t(m){return!!(m&&m.ref!==void 0&&typeof m.ref=="string"&&m.ref!==""&&m.syncData!==void 0&&(m.syncData===null||s(m.syncData)))}function s(m){return!!(m&&m.version!==void 0&&typeof m.version=="number"&&m.content!==void 0&&typeof m.content=="string"&&(Object.keys(m).length===2||Object.keys(m).length===3&&m.machineId!==void 0&&typeof m.machineId=="string"))}function o(m,v){return`${(0,y.$5f)(m)}${v.isDefault?"":` (${v.name})`}`}let i=class extends L.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(v,P,R,I,N,U,j,F,X,K,Q,V){super(),this.syncResource=v,this.collection=P,this.G=R,this.H=I,this.I=N,this.J=U,this.L=j,this.M=F,this.N=X,this.O=K,this.P=Q,this.c=null,this.m=u.SyncStatus.Idle,this.n=this.B(new C.$he),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new C.$he),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$yh(50)),this.w=this.B(new C.$he),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=o(v.syncResource,v.profile),this.h=V.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,u.$4lb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,u.$mmb),this.y=(0,u.$5lb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,I,this.h),this.j=(0,d.$cq)(I,R,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===u.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const P=await this.Y(v.remoteUserData,v.lastSyncUserData,!0,this.ob());this.S(P)}else{this.O.trace(`${this.D}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.ub(v):!0)&&this.w.fire()}}S(v){this.m!==v&&(this.m=v,this.n.fire(v))}async sync(v,P={}){await this.U(v,!0,this.ob(),P)}async preview(v,P,R={}){return this.U(v,!1,P,R)}async apply(v,P={}){try{this.F={...P};const R=await this.ab(v);return this.S(R),this.c}finally{this.F={}}}async U(v,P,R,I){try{if(this.F={...I},this.status===u.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===u.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(u.SyncStatus.Syncing);let N=u.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),j=await this.X(v,U);return N=await this.Y(j,U,P,R),N===u.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N===u.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(v){const P=this.kb(v);if(!P)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(u.SyncStatus.Syncing);const R=await this.getLastSyncUserData(),I=await this.X(null,R),N=await this.W(I),U=await this.qb({ref:I.ref,syncData:P},R,N,this.ob(),O.CancellationToken.None),j=[];for(const F of U){const X=await this.sb(F,F.remoteResource,void 0,O.CancellationToken.None),{remoteChange:K}=await this.sb(F,F.previewResource,F.remoteContent,O.CancellationToken.None);j.push([F,{...X,remoteChange:K!==u.Change.None?K:u.Change.Modified}])}await this.tb(I,R,j,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(u.SyncStatus.Idle)}return!0}async W(v){const P=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===P}async X(v,P){if(P){const R=v?v[this.resource]:void 0;if(P.ref===R||R===void 0&&P.syncData===null)return P}return this.getRemoteUserData(P)}async Y(v,P,R,I){if(v.syncData&&v.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new u.$_lb((0,$.localize)(0,null,this.resource,this.pb,v.syncData.version),u.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(v,P,R,I)}catch(N){if(N instanceof u.$_lb)switch(N.code){case u.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(v,P,R,I);case u.UserDataSyncErrorCode.Conflict:case u.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),P=await this.getLastSyncUserData(),this.Y(v,P,R,I)}throw N}}async Z(v,P,R,I){try{const N=await this.W(v),U=!N&&P===null&&this.gb()!==void 0,j=R&&!U;this.c||(this.c=(0,a.$nh)(X=>this.eb(v,P,N,j,I,X)));let F=await this.c;if(R&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of F.resourcePreviews)F=await this.accept(X.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:X})=>X===u.MergeState.Conflict)?u.SyncStatus.HasConflicts:R?await this.ab(!1):u.SyncStatus.Syncing}catch(N){throw this.c=null,N}}async merge(v){return await this.$(v,async P=>{const R=await this.rb(P,O.CancellationToken.None);await this.G.writeFile(P.previewResource,T.$Je.fromString(R?.content||""));const I=R&&!R.hasConflicts?await this.sb(P,P.previewResource,void 0,O.CancellationToken.None):void 0;return P.acceptResult=I,P.mergeState=R.hasConflicts?u.MergeState.Conflict:I?u.MergeState.Accepted:u.MergeState.Preview,P.localChange=I?I.localChange:R.localChange,P.remoteChange=I?I.remoteChange:R.remoteChange,P}),this.c}async accept(v,P){return await this.$(v,async R=>{const I=await this.sb(R,v,P,O.CancellationToken.None);return R.acceptResult=I,R.mergeState=u.MergeState.Accepted,R.localChange=I.localChange,R.remoteChange=I.remoteChange,R}),this.c}async discard(v){return await this.$(v,async P=>{const R=await this.rb(P,O.CancellationToken.None);return await this.G.writeFile(P.previewResource,T.$Je.fromString(R.content||"")),P.acceptResult=void 0,P.mergeState=u.MergeState.Preview,P.localChange=R.localChange,P.remoteChange=R.remoteChange,P}),this.c}async $(v,P){if(!this.c)return;let R=await this.c;const I=R.resourcePreviews.findIndex(({localResource:N,remoteResource:U,previewResource:j})=>this.h.isEqual(N,v)||this.h.isEqual(U,v)||this.h.isEqual(j,v));I!==-1&&(this.c=(0,a.$nh)(async N=>{const U=[...R.resourcePreviews];return U[I]=await P(U[I]),{...R,resourcePreviews:U}}),R=await this.c,this.cb(R.resourcePreviews),R.resourcePreviews.some(({mergeState:N})=>N===u.MergeState.Conflict)?this.S(u.SyncStatus.HasConflicts):this.S(u.SyncStatus.Syncing))}async ab(v){if(!this.c)return u.SyncStatus.Idle;const P=await this.c;return P.resourcePreviews.some(({mergeState:R})=>R===u.MergeState.Conflict)?u.SyncStatus.HasConflicts:P.resourcePreviews.some(({mergeState:R})=>R!==u.MergeState.Accepted)?u.SyncStatus.Syncing:(await this.tb(P.remoteUserData,P.lastSyncUserData,P.resourcePreviews.map(R=>[R,R.acceptResult]),v),this.c=null,await this.bb(),u.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(v){const P=v.filter(({mergeState:R})=>R===u.MergeState.Conflict);(0,k.$ub)(this.s,P,(R,I)=>this.h.isEqual(R.previewResource,I.previewResource))||(this.s=P,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async db(v){const P=this.c?await this.c:null;if(P)for(const R of P.resourcePreviews){if(this.h.isEqual(R.acceptedResource,v))return R.acceptResult?R.acceptResult.content:null;if(this.h.isEqual(R.remoteResource,v))return R.remoteContent;if(this.h.isEqual(R.localResource,v))return R.localContent;if(this.h.isEqual(R.baseResource,v))return R.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(v){(0,l.$ll)(v)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(v)}}async eb(v,P,R,I,N,U){const j=await this.qb(v,P,R,N,U),F=[];for(const X of j){const K=X.previewResource.with({scheme:u.$lmb,authority:"accepted"});if(X.localChange===u.Change.None&&X.remoteChange===u.Change.None)F.push({...X,acceptedResource:K,acceptResult:{content:null,localChange:u.Change.None,remoteChange:u.Change.None},mergeState:u.MergeState.Accepted});else{const Q=I?await this.rb(X,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(X.previewResource,T.$Je.fromString(Q?.content||""));const V=Q&&!Q.hasConflicts?await this.sb(X,X.previewResource,void 0,U):void 0;F.push({...X,acceptResult:V,mergeState:Q?.hasConflicts?u.MergeState.Conflict:V?u.MergeState.Accepted:u.MergeState.Preview,localChange:V?V.localChange:Q?Q.localChange:X.localChange,remoteChange:V?V.remoteChange:Q?Q.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:P,resourcePreviews:F,isLastSyncFromCurrentMachine:R}}async getLastSyncUserData(){let v=this.gb();if(v||(v=await this.jb()),!v)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const P=JSON.parse(v),R=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!P.version&&!!R&&P.version!==R,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${P.version} is not compatible with current sync state version ${R}.`),await this.resetLocal(),null;let I,N=1;for(;I===void 0&&N++<6;)try{const U=await this.hb();U&&(U.ref===P.ref?I=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$pl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof u.$_lb)throw U;this.O.error(U,N)}}if(I===void 0)try{const U=await this.J.resolveResourceContent(this.resource,P.ref,this.collection,this.F);I=U===null?null:this.kb(U),await this.ib({ref:P.ref,syncData:I})}catch(U){if(U instanceof u.$_lb&&U.code===u.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return I===void 0?null:{...P,syncData:I}}async fb(v,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const R=this.M.getResourceSyncStateVersion(this.resource),I={ref:v.ref,version:R,...P};this.I.store(this.z,JSON.stringify(I),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(v)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const v=(await this.G.readFile(this.y)).value.toString();try{const P=v?JSON.parse(v):void 0;if(t(P))return P}catch(P){this.O.error(P)}}async ib(v){await this.G.writeFile(this.y,T.$Je.fromString(JSON.stringify(v)))}async jb(){try{const v=await this.G.readFile(this.y),P=JSON.parse(v.value.toString());await this.G.del(this.y),P.ref&&P.content!==void 0?(this.I.store(this.z,JSON.stringify({...P,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:P.ref,syncData:P.content===null?null:JSON.parse(P.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,P)}catch(v){v instanceof l.$pl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(v)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(v){const{ref:P,content:R}=await this.lb(v);let I=null;return R!==null&&(I=this.kb(R)),{ref:P,syncData:I}}kb(v){try{const P=JSON.parse(v);if(s(P))return P}catch(P){this.O.error(P)}throw new u.$_lb((0,$.localize)(1,null),u.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(v){const P=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.J.readResource(this.resource,P,this.collection,this.F)}async mb(v,P){const R=await this.j,I={version:this.pb,machineId:R,content:v};try{return P=await this.J.writeResource(this.resource,JSON.stringify(I),P,this.collection,this.F),{ref:P,syncData:I}}catch(N){throw N instanceof u.$_lb&&N.code===u.UserDataSyncErrorCode.TooLarge&&(N=new u.$_lb(N.message,N.code,this.resource)),N}}async nb(v){const P={version:this.pb,content:v};return this.L.writeResource(this.resource,JSON.stringify(P),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==u.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(u.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(u.$Ylb)}};e.$xMb=i,e.$xMb=i=ve([Z(2,l.$7k),Z(3,p.$Hi),Z(4,f.$9p),Z(5,u.$7lb),Z(6,u.$8lb),Z(7,u.$emb),Z(8,w.$6l),Z(9,u.$jmb),Z(10,h.$7i),Z(11,E.$El)],i);let n=class extends i{constructor(v,P,R,I,N,U,j,F,X,K,Q,V,ie){super(P,R,I,N,U,j,F,X,K,Q,V,ie),this.r=v,this.B(this.G.watch(this.h.dirname(v))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(v,P,R){try{P?await this.G.writeFile(this.r,T.$Je.fromString(v),R?void 0:P):await this.G.createFile(this.r,T.$Je.fromString(v),{overwrite:R})}catch(I){throw I instanceof l.$pl&&I.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||I instanceof l.$pl&&I.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new u.$_lb(I.message,u.UserDataSyncErrorCode.LocalPreconditionFailed):I}}async xb(){try{await this.G.del(this.r)}catch(v){if(!(v instanceof l.$pl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw v}}yb(v){v.contains(this.r)&&this.Q()}};e.$yMb=n,e.$yMb=n=ve([Z(3,l.$7k),Z(4,p.$Hi),Z(5,f.$9p),Z(6,u.$7lb),Z(7,u.$8lb),Z(8,u.$emb),Z(9,w.$6l),Z(10,u.$jmb),Z(11,h.$7i),Z(12,E.$El)],n);let r=class extends n{constructor(v,P,R,I,N,U,j,F,X,K,Q,V,ie,H){super(v,P,R,I,N,U,j,F,X,K,Q,ie,H),this.zb=V,this.Bb=void 0}Ab(v,P){const R=[],I=(0,A.$Pn)(v,R,{allowEmptyContent:!0,allowTrailingComma:!0});return R.length>0||!(0,S.$hg)(I)&&P!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$zMb=r,e.$zMb=r=ve([Z(3,l.$7k),Z(4,p.$Hi),Z(5,f.$9p),Z(6,u.$7lb),Z(7,u.$8lb),Z(8,u.$emb),Z(9,w.$6l),Z(10,u.$jmb),Z(11,u.$imb),Z(12,h.$7i),Z(13,E.$El)],r);let c=class{constructor(v,P,R,I,N,U,j){this.resource=v,this.g=P,this.h=R,this.j=I,this.k=N,this.l=U,this.d=j.extUri,this.f=(0,u.$5lb)(void 0,this.resource,R,this.d)}async initialize({ref:v,content:P}){if(!P){this.j.info("Remote content does not exist.",this.resource);return}const R=this.m(P);if(R)try{await this.o({ref:v,syncData:R})}catch(I){this.j.error(I)}}m(v){try{const P=JSON.parse(v);if(s(P))return P}catch(P){this.j.error(P)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const R={ref:v.ref,version:void 0,...P};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(R),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,T.$Je.fromString(JSON.stringify(v)))}};e.$AMb=c,e.$AMb=c=ve([Z(1,b.$Gl),Z(2,p.$Hi),Z(3,g.$7j),Z(4,l.$7k),Z(5,f.$9p),Z(6,E.$El)],c)}),define(le[120],he([0,1,6,26,8,3,46,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,41,242,115,25,61]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s,o,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=e.$iac=e.$hac=void 0,e.$fac=v,e.$gac=P;async function m(U,j){const F=JSON.parse(U.content);if(U.version===1||U.version===2){const X=(await j.getInstalled(g.ExtensionType.System)).filter(K=>K.isBuiltin);for(const K of F)U.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),U.version===2&&X.every(Q=>!(0,p.$Cp)(Q.identifier,K.identifier))&&(K.installed=!0)}return F}function v(U){return JSON.parse(U.content)}function P(U,j){return U.sort((F,X)=>!F.identifier.uuid&&X.identifier.uuid?-1:F.identifier.uuid&&!X.identifier.uuid?1:(0,L.$uf)(F.identifier.id,X.identifier.id)),j?(0,C.$1n)(U,{}):JSON.stringify(U)}let R=class extends o.$xMb{constructor(j,F,X,K,Q,V,ie,H,W,ee,re,ce,q,x,J,G,D){super({syncResource:r.SyncResource.Extensions,profile:j},F,K,X,Q,V,ie,ce,q,ee,re,J),this.Cb=H,this.Db=W,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$lmb,authority:"base"}),this.yb=this.wb.with({scheme:r.$lmb,authority:"local"}),this.zb=this.wb.with({scheme:r.$lmb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$lmb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(O.Event.any(O.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:M})=>!!M)),O.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),O.Event.filter(G.onDidChange,B=>B.valueChanges.some(({profile:M,changes:z})=>this.syncResource.profile.id===M.id&&z.some(te=>te.key===h.$fp))),x.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(j,F){const X=j.syncData?await m(j.syncData,this.Cb):null,K=F?.skippedExtensions??[],Q=F?.builtinExtensions??null,V=F?.syncData?await m(F.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$eac)(ie,X,V,K,H,Q),re={local:W,remote:ee,content:this.Hb(ie,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ee!==null?r.Change.Modified:r.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:K,builtinExtensions:Q,baseResource:this.xb,baseContent:V?this.Ob(V,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(j){const F=j.syncData?await m(j.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,i.$eac)(X,F,F,j.skippedExtensions||[],K,j.builtinExtensions||[]);return Q!==null}Hb(j,F,X,K){const Q=[...F,...X],V=new Set,ie=H=>{V.add(H.id.toLowerCase()),H.uuid&&V.add(H.uuid)};Q.forEach(({identifier:H})=>ie(H)),K.forEach(ie);for(const H of j)V.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&V.has(H.identifier.uuid)||Q.push(H);return this.Ob(Q,!1)}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,X,K){if(this.h.isEqual(F,this.yb))return this.Kb(j);if(this.h.isEqual(F,this.zb))return this.Lb(j);if(this.h.isEqual(F,this.wb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(F),K=(0,i.$eac)(j.localExtensions,null,null,j.skippedExtensions,X,j.builtinExtensions),{local:Q,remote:V}=K;return{content:j.localContent,local:Q,remote:V,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:V!==null?r.Change.Modified:r.Change.None}}async Lb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(F),K=j.remoteContent?JSON.parse(j.remoteContent):null;if(K!==null){const Q=(0,i.$eac)(j.localExtensions,K,j.localExtensions,[],X,j.builtinExtensions),{local:V,remote:ie}=Q;return{content:j.remoteContent,local:V,remote:ie,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ie!==null?r.Change.Modified:r.Change.None}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(j,F,X,K){let{skippedExtensions:Q,builtinExtensions:V,localExtensions:ie}=X[0][0];const{local:H,remote:W,localChange:ee,remoteChange:re}=X[0][1];if(ee===r.Change.None&&re===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==r.Change.None&&(await this.nb(JSON.stringify(ie)),Q=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,Q,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(W.all);j=await this.mb(ce,K?null:j.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(q=>q.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(q=>q.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(q=>q.identifier.id))}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(ie,V),await this.fb(j,{skippedExtensions:Q,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ce=>ce.identifier.id))}.`:""}`))}Nb(j,F){const X=new Set,K=[];for(const Q of j)X.add(Q.identifier.id.toLowerCase()),Q.installed||K.push(Q.identifier);if(F)for(const Q of F)X.has(Q.id.toLowerCase())||K.push(Q);return K}async resolveContent(j){if(this.h.isEqual(this.zb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.yb,j)||this.h.isEqual(this.Ab,j)){const F=await this.db(j);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(j,F){return P(j,F)}async hasLocalData(){try{const{localExtensions:j}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(j.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$hac=R,e.$hac=R=ve([Z(2,S.$Hi),Z(3,d.$7k),Z(4,u.$9p),Z(5,r.$7lb),Z(6,r.$8lb),Z(7,h.$ep),Z(8,n.$jNb),Z(9,r.$jmb),Z(10,y.$7i),Z(11,r.$emb),Z(12,b.$6l),Z(13,l.$dw),Z(14,t.$El),Z(15,c.$rLb),Z(16,f.$zi)],R);let I=class{constructor(j,F,X,K,Q,V){this.a=j,this.b=F,this.c=X,this.d=K,this.f=Q,this.g=V}async getLocalExtensions(j){const F=await this.a.getInstalled(void 0,j.extensionsResource),X=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(j,async(Q,V)=>{const ie=Q.getDisabledExtensions();return F.map(H=>{const{identifier:W,isBuiltin:ee,manifest:re,preRelease:ce,pinned:q,isApplicationScoped:x}=H,J={identifier:W,preRelease:ce,version:re.version,pinned:!!q};x&&!(0,g.$Zm)(re)&&(J.isApplicationScoped=x),ie.some(G=>(0,p.$Cp)(G,W))&&(J.disabled=!0),ee||(J.installed=!0);try{const G=V.getKeysForSync({id:W.id,version:re.version});if(G){const D=V.getExtensionState(H,!0)||{};J.state=Object.keys(D).reduce((B,M)=>(G.includes(M)&&(B[M]=D[M]),B),{})}}catch(G){this.g.info(`${(0,o.$wMb)(r.SyncResource.Extensions,j)}: Error while parsing extension state`,(0,T.$0)(G))}return J})}),ignoredExtensions:X}}async updateLocalExtensions(j,F,X,K,Q){const V=(0,o.$wMb)(r.SyncResource.Extensions,Q),ie=[],H=new Map,W=[],ee=[],re=await this.a.getInstalled(void 0,Q.extensionsResource);if((j.length||X.length)&&await this.j(Q,async(x,J)=>{await k.Promises.settled([...j,...X].map(async G=>{const D=re.find(z=>(0,p.$Cp)(z.identifier,G.identifier));if(D&&D.isBuiltin){G.state&&D.manifest.version===G.version&&this.h(G.state,D,D.manifest.version,J),x.getDisabledExtensions().some(te=>(0,p.$Cp)(te,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${V}: Disabling extension...`,G.identifier.id),await x.disableExtension(G.identifier),this.g.info(`${V}: Disabled extension`,G.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,G.identifier.id),await x.enableExtension(G.identifier),this.g.info(`${V}: Enabled extension`,G.identifier.id))),W.push(G.identifier);return}const B=G.pinned?G.version:void 0,M=(await this.c.getExtensions([{...G.identifier,version:B,preRelease:B?void 0:G.preRelease}],a.CancellationToken.None))[0];if(G.state&&(D?D.manifest.version===G.version:M)&&this.h(G.state,D||M,D?.manifest.version,J),M)try{x.getDisabledExtensions().some(te=>(0,p.$Cp)(te,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${V}: Disabling extension...`,G.identifier.id,M.version),await x.disableExtension(M.identifier),this.g.info(`${V}: Disabled extension`,G.identifier.id,M.version)):(this.g.trace(`${V}: Enabling extension...`,G.identifier.id,M.version),await x.enableExtension(M.identifier),this.g.info(`${V}: Enabled extension`,G.identifier.id,M.version))),(!D||D.preRelease!==G.preRelease||D.pinned!==G.pinned||B&&D.manifest.version!==B)&&(await this.a.canInstall(M)?(ie.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:G.pinned&&!!G.version,pinned:G.pinned,installPreReleaseVersion:G.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:G.isApplicationScoped,context:{[h.$4o]:!0,[h.$5o]:h.ExtensionInstallSource.SETTINGS_SYNC}}}),H.set(M.identifier.id.toLowerCase(),G)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),ee.push(G)))}catch(z){ee.push(G),this.g.error(z),this.g.info(`${V}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else ee.push(G),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,G.identifier.id)}))}),F.length){const x=re.filter(({identifier:J,isBuiltin:G})=>!G&&F.some(D=>(0,p.$Cp)(J,D)));await k.Promises.settled(x.map(async J=>{this.g.trace(`${V}: Uninstalling local extension...`,J.identifier.id),await this.a.uninstall(J,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,J.identifier.id),W.push(J.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:x,local:J,error:G,source:D}of ce){const B=D;if(J)this.g.info(`${V}: Installed extension.`,x.id,B.version),W.push(x);else{const M=H.get(x.id.toLowerCase());M&&(ee.push(M),this.g.info(`${V}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),G instanceof h.$dp&&[h.ExtensionManagementErrorCode.Incompatible,h.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(G.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):G&&this.g.error(G)}}const q=[];for(const x of K)W.some(J=>(0,p.$Cp)(J,x.identifier))||q.push(x);for(const x of ee)q.some(J=>(0,p.$Cp)(J.identifier,x.identifier))||q.push(x);return q}h(j,F,X,K){const Q=K.getExtensionState(F,!0)||{},V=X?K.getKeysForSync({id:F.identifier.id,version:X}):void 0;V?V.forEach(ie=>{Q[ie]=j[ie]}):Object.keys(j).forEach(ie=>Q[ie]=j[ie]),K.setExtensionState(F,Q,!0)}async j(j,F){return this.b.withProfileScopedStorageService(j,async X=>{const K=new A.$Tc,Q=K.add(this.f.createChild(new w.$yi([u.$9p,X]))),V=K.add(Q.createInstance($.$PKb)),ie=K.add(Q.createInstance(l.$ew));try{return await F(V,ie)}finally{K.dispose()}})}};e.$iac=I,e.$iac=I=ve([Z(0,h.$ep),Z(1,c.$rLb),Z(2,h.$bp),Z(3,n.$jNb),Z(4,f.$zi),Z(5,r.$jmb)],I);let N=class extends o.$AMb{constructor(j,F,X,K,Q,V,ie,H){super(r.SyncResource.Extensions,K,Q,V,X,ie,H),this.p=j,this.q=F}async t(j){return j.syncData?await m(j.syncData,this.p):null}u(j,F){const X=[],K=[],Q=[];for(const V of j){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const ie=F.find(H=>(0,p.$Cp)(H.identifier,V.identifier));ie?(X.push(ie),V.disabled&&Q.push(V.identifier)):V.installed&&(K.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&Q.push(V.identifier))}return{installedExtensions:X,newExtensions:K,disabledExtensions:Q,remoteExtensions:j}}};e.$jac=N,e.$jac=N=ve([Z(0,h.$ep),Z(1,n.$jNb),Z(2,d.$7k),Z(3,s.$Gl),Z(4,S.$Hi),Z(5,E.$7j),Z(6,u.$9p),Z(7,t.$El)],N)}),define(le[121],he([0,1,15,8,3,34,46,5,32,22,16,7,10,50,17,18,29,41,82,246,25,20,61,4]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GMb=e.$FMb=e.$EMb=e.$DMb=void 0,e.$CMb=n;const o="globalState.argv.",i=["locale"];function n(R,I){const N=R.storage?Object.keys(R.storage).sort():[],U={};return N.forEach(j=>U[j]=R.storage[j]),R.storage=U,I?(0,C.$1n)(R,{}):JSON.stringify(R)}const r=1;let c=class extends f.$xMb{constructor(I,N,U,j,F,X,K,Q,V,ie,H,W,ee,re){super({syncResource:u.SyncResource.GlobalState,profile:I},N,j,Q,W,F,X,V,ie,K,H,ee),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:u.$lmb,authority:"base"}),this.xb=this.vb.with({scheme:u.$lmb,authority:"local"}),this.yb=this.vb.with({scheme:u.$lmb,authority:"remote"}),this.zb=this.vb.with({scheme:u.$lmb,authority:"accepted"}),this.Ab=re.createInstance(m),this.B(j.watch(this.h.dirname(this.H.argvResource))),this.B(T.Event.any(T.Event.filter(j.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),T.Event.filter(U.onDidChange,ce=>!!(ce.targetChanges.some(q=>this.syncResource.profile.id===q.id)||ce.valueChanges.some(({profile:q,changes:x})=>this.syncResource.profile.id===q.id&&x.some(J=>J.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(I,N,U){const j=I.syncData?JSON.parse(I.syncData.content):null;N=N===null&&U?I:N;const F=N&&N.syncData?JSON.parse(N.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);j?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(F),{local:Q,remote:V}=(0,E.$BMb)(X.storage,j?j.storage:null,F?F.storage:null,K,this.O),ie={content:null,local:Q,remote:V,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?u.Change.Modified:u.Change.None,remoteChange:V.all!==null?u.Change.Modified:u.Change.None},H=n(X,!1);return[{baseResource:this.wb,baseContent:F?n(F,!1):H,localResource:this.xb,localContent:H,localUserData:X,remoteResource:this.yb,remoteContent:j?n(j,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(I){const N=I.syncData?JSON.parse(I.syncData.content):null;if(N===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),j=await this.Jb(N),{remote:F}=(0,E.$BMb)(U.storage,N.storage,N.storage,j,this.O);return F.all!==null}async rb(I,N){return{...I.previewResult,hasConflicts:!1}}async sb(I,N,U,j){if(this.h.isEqual(N,this.xb))return this.Gb(I);if(this.h.isEqual(N,this.yb))return this.Hb(I);if(this.h.isEqual(N,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:u.Change.None,remoteChange:u.Change.Modified}}async Hb(I){if(I.remoteContent!==null){const N=JSON.parse(I.remoteContent),{local:U,remote:j}=(0,E.$BMb)(I.localUserData.storage,N.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:U,remote:j,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?u.Change.Modified:u.Change.None,remoteChange:j!==null?u.Change.Modified:u.Change.None}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:u.Change.None,remoteChange:u.Change.None}}async tb(I,N,U,j){const{localUserData:F}=U[0][0],{local:X,remote:K,localChange:Q,remoteChange:V}=U[0][1];if(Q===u.Change.None&&V===u.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==u.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==u.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:K.all});I=await this.mb(ie,j?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}N?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const N=await this.db(I);return N&&n(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${o}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const N=await this.Bb.readStorageData(this.syncResource.profile),U=[],j=[];for(const[K,Q]of N)Q.target===l.StorageTarget.USER?U.push(K):Q.target===l.StorageTarget.MACHINE&&j.push(K);const F=[...U,...j],X=I?.storage?Object.keys(I.storage).filter(K=>!K.startsWith(o)&&!F.includes(K)&&N.get(K)!==void 0):[];if(!A.$o){const K=[...u.$3lb.map(Q=>(0,u.$dmb)(Q)),u.$cmb];X.push(...K),j.push(...K)}return{user:U,machine:j,unregistered:X}}};e.$DMb=c,e.$DMb=c=ve([Z(2,t.$rLb),Z(3,$.$7k),Z(4,u.$7lb),Z(5,u.$8lb),Z(6,u.$jmb),Z(7,S.$Hi),Z(8,u.$emb),Z(9,g.$6l),Z(10,y.$7i),Z(11,l.$9p),Z(12,d.$El),Z(13,s.$zi)],c);let m=class{constructor(I,N,U,j){this.a=I,this.b=N,this.c=U,this.d=j}async getLocalGlobalState(I){const N={};if(I.isDefault){const j=await this.f(),F=(0,O.$Pn)(j);for(const X of i)F[X]!==void 0&&(N[`${o}${X}`]={version:1,value:F[X]})}const U=await this.c.readStorageData(I);for(const[j,F]of U)F.value&&F.target===l.StorageTarget.USER&&(N[j]={version:1,value:F.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,a.$0)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:N,updated:U},j){const F=(0,f.$wMb)(u.SyncResource.GlobalState,j),X={},K=new Map,Q=await this.c.readStorageData(j),V=(ie,H)=>{for(const W of ie){if(W.startsWith(o)){X[W.substring(o.length)]=H?H[W].value:void 0;continue}if(H){const ee=H[W];ee.value!==Q.get(W)?.value&&K.set(W,ee.value)}else Q.get(W)!==void 0&&K.set(W,void 0)}};if(V(Object.keys(I),I),V(Object.keys(U),U),V(N),Object.keys(X).length){this.d.trace(`${F}: Updating locale...`);const ie=await this.f();let H=ie;for(const W of Object.keys(X))H=(0,w.edit)(H,[W],X[W],{});ie!==H&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.$Je.fromString(H)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}K.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(j,K,l.StorageTarget.USER),this.d.info(`${F}: Updated global state`,[...K.keys()]))}};e.$EMb=m,e.$EMb=m=ve([Z(0,$.$7k),Z(1,S.$Hi),Z(2,t.$rLb),Z(3,u.$jmb)],m);let v=class extends f.$AMb{constructor(I,N,U,j,F,X){super(u.SyncResource.GlobalState,U,j,F,N,I,X)}async o(I){const N=I.syncData?JSON.parse(I.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},j={};for(const F of Object.keys(N.storage))F.startsWith(o)?U[F.substring(o.length)]=N.storage[F].value:this.l.get(F,l.StorageScope.PROFILE)===void 0&&(j[F]=N.storage[F].value);if(Object.keys(U).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(U))F=(0,w.edit)(F,[X],U[X],{});await this.k.writeFile(this.h.argvResource,k.$Je.fromString(F))}if(Object.keys(j).length){const F=[];for(const X of Object.keys(j))F.push({key:X,value:j[X],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(F,!0)}}};e.$FMb=v,e.$FMb=v=ve([Z(0,l.$9p),Z(1,$.$7k),Z(2,b.$Gl),Z(3,S.$Hi),Z(4,u.$jmb),Z(5,d.$El)],v);let P=class{constructor(I,N,U,j,F){this.a=I,this.b=N,this.c=U,this.d=j,this.f=F}getSyncStoreType(I){return this.h(I)?.storage[u.$cmb]?.value}async sync(I){const N=(0,u.$$lb)((0,L.$Wg)());try{return await this.g(I,N)}catch(U){if(U instanceof u.$_lb)switch(U.code){case u.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,N)}throw U}}async g(I,N){const U=await this.a.readResource(u.SyncResource.GlobalState,null,void 0,N),j=this.h(U)||{storage:{}};j.storage[u.$cmb]={value:I,version:r};const F=await(0,p.$cq)(this.c,this.d,this.b),X={version:r,machineId:F,content:n(j,!1)};await this.a.writeResource(u.SyncResource.GlobalState,JSON.stringify(X),U.ref,void 0,N)}h({content:I}){if(!I)return null;const N=JSON.parse(I);if((0,f.$vMb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$GMb=P,e.$GMb=P=ve([Z(1,l.$9p),Z(2,S.$Hi),Z(3,$.$7k),Z(4,h.$7j)],P)}),define(le[122],he([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,41,243,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=void 0,e.$lac=E;function E(t,s,o){try{const i=JSON.parse(t);if(!s)return(0,A.$hg)(i.all)?null:i.all;switch(C.OS){case C.OperatingSystem.Macintosh:return(0,A.$hg)(i.mac)?null:i.mac;case C.OperatingSystem.Linux:return(0,A.$hg)(i.linux)?null:i.linux;case C.OperatingSystem.Windows:return(0,A.$hg)(i.windows)?null:i.windows}}catch(i){return o.error(i),null}}let u=class extends d.$zMb{constructor(s,o,i,n,r,c,m,v,P,R,I,N,U){super(s.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:s},o,v,P,R,i,n,m,N,r,I,c,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$lmb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$lmb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$lmb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$lmb,authority:"accepted"}),this.B(T.Event.filter(c.onDidChangeConfiguration,j=>j.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(s,o,i,n){const r=s.syncData?E(s.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;o=o===null&&i?s:o;const c=o?this.Ob(o):null,m=await this.vb(),v=await this.Cb();let P=null,R=!1,I=!1,N=!1;if(r){let F=m?m.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new w.$_lb((0,L.localize)(0,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!c||c!==F||c!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,f.$kac)(F,r,c,v,this.zb);X.hasChanges&&(P=X.mergeContent,N=X.hasConflicts,R=N||X.mergeContent!==F,I=N||X.mergeContent!==r)}}else m&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),P=m.value.toString(),I=!0);const U={content:N?c:P,localChange:R?m?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:I?w.Change.Modified:w.Change.None,hasConflicts:N},j=m?m.value.toString():null;return[{fileContent:m,baseResource:this.Fb,baseContent:c,localResource:this.Gb,localContent:j,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(s){const o=this.Ob(s);if(o===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",r=await this.Cb(),c=await(0,f.$kac)(n||"[]",o,o,r,this.zb);return c.hasConflicts||c.mergeContent!==o}async rb(s,o){return s.previewResult}async sb(s,o,i,n){if(this.h.isEqual(o,this.Gb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(o,this.Hb))return{content:s.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(o,this.Eb))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,i,n){const{fileContent:r}=i[0][0];let{content:c,localChange:m,remoteChange:v}=i[0][1];if(m===w.Change.None&&v===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.Ab(c,!0)))throw new w.$_lb((0,L.localize)(1,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(m!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(c||"[]",r,n),this.O.info(`${this.D}: Updated local keybindings`)),v!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const P=this.Pb(c||"[]",s.syncData?.content);s=await this.mb(P,n?null:s.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(s,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.vb();if(s){const o=(0,O.$Pn)(s.value.toString());if((0,k.$Lb)(o))return!0}}catch(s){if(s.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Hb,s)||this.h.isEqual(this.Fb,s)||this.h.isEqual(this.Gb,s)||this.h.isEqual(this.Ib,s)?this.db(s):null}Ob(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Qb()?null:E(s.syncData.content,this.Qb(),this.O)}Pb(s,o){let i={};try{i=JSON.parse(o||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=s,C.OS){case C.OperatingSystem.Macintosh:i.mac=s;break;case C.OperatingSystem.Linux:i.linux=s;break;case C.OperatingSystem.Windows:i.windows=s;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(w.$Zlb)}};e.$mac=u,e.$mac=u=ve([Z(2,w.$7lb),Z(3,w.$8lb),Z(4,w.$jmb),Z(5,y.$7i),Z(6,w.$emb),Z(7,$.$7k),Z(8,S.$Hi),Z(9,h.$9p),Z(10,w.$imb),Z(11,p.$6l),Z(12,l.$El)],u);let b=class extends d.$AMb{constructor(s,o,i,n,r,c){super(w.SyncResource.Keybindings,o,i,n,s,r,c)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Je.fromString(o)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),o=(0,O.$Pn)(s.value.toString());return!(0,k.$Lb)(o)}catch(s){return s.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return E(s,!0,this.j)}catch(o){return this.j.error(o),null}}};e.$nac=b,e.$nac=b=ve([Z(0,$.$7k),Z(1,g.$Gl),Z(2,S.$Hi),Z(3,w.$jmb),Z(4,h.$9p),Z(5,l.$El)],b)}),define(le[123],he([0,1,15,3,183,22,78,16,28,7,17,18,29,20,41,247,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0,e.$oac=w;function f(b){return b&&b.settings&&typeof b.settings=="string"&&Object.keys(b).length===1}function w(b){const t=JSON.parse(b);return f(t)?t:{settings:b}}let E=class extends l.$zMb{constructor(t,s,o,i,n,r,c,m,v,P,R,I,N,U){super(t.settingsResource,{syncResource:d.SyncResource.Settings,profile:t},s,o,i,n,r,c,R,I,m,v,P,U),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.$lmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$lmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$lmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$lmb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),o=await this.X(t,s),i=this.Lb(o),n=new C.$Fo(d.$Ylb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(d.$Ylb)||{}}async qb(t,s,o){const i=await this.vb(),n=await this.Cb(),r=this.Lb(t);s=s===null&&o?t:s;const c=s?this.Lb(s):null,m=await this.Pb();let v=null,P=!1,R=!1,I=!1;if(r){let F=i?i.value.toString().trim():"{}";F=F||"{}",this.Qb(F),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,g.$$Kb)(F,r.settings,c?c.settings:null,m,[],n);v=X.localContent||X.remoteContent,P=X.localContent!==null,R=X.remoteContent!==null,I=X.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),v=i.value.toString().trim()||"{}",this.Qb(v),R=!0);const N=i?i.value.toString():null,U=c?.settings??null,j={content:I?U:v,localChange:P?d.Change.Modified:d.Change.None,remoteChange:R?d.Change.Modified:d.Change.None,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:N,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async ub(t){const s=this.Lb(t);if(s===null)return!0;const o=await this.vb(),i=o?o.value.toString().trim():"",n=await this.Pb(),r=await this.Cb();return(0,g.$$Kb)(i||"{}",s.settings,s.settings,n,[],r).remoteContent!==null}async rb(t,s){const o=await this.Cb(),i=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,g.$0Kb)(t.previewResult.content,"{}",i,o):null}}async sb(t,s,o,i){const n=await this.Cb(),r=await this.Pb();if(this.h.isEqual(s,this.localResource))return{content:t.fileContent?(0,g.$0Kb)(t.fileContent.value.toString(),"{}",r,n):null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,g.$0Kb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,n):null,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(s,this.previewResource))return o===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:o!==null?(0,g.$0Kb)(o,t.fileContent?t.fileContent.value.toString():"{}",r,n):null,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(t,s,o,i){const{fileContent:n}=o[0][0];let{content:r,localChange:c,remoteChange:m}=o[0][1];if(c===d.Change.None&&m===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),c!==d.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(r,n,i),await this.P.reloadConfiguration(O.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),m!==d.Change.None){const v=await this.Cb(),P=this.Lb(t),R=await this.Pb(r);r=(0,g.$0Kb)(r,P?P.settings:"{}",R,v),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(r)),i?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}s?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,g.$_Kb)(t.value.toString())}catch(t){if(t.fileOperationResult!==y.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let s=await super.db(t);if(s){const o=await this.Cb(),i=await this.Pb();s=(0,g.$0Kb)(s,"{}",i,o)}return s}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return w(t)}catch(s){this.O.error(s)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const o=this.B(a.Event.any(a.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),a.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{o.dispose(),this.Ob=void 0}))}const s=await this.Ob;return(0,g.$8Kb)(s,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new d.$_lb((0,T.localize)(0,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$pac=E,e.$pac=E=ve([Z(2,y.$7k),Z(3,A.$Hi),Z(4,S.$9p),Z(5,d.$7lb),Z(6,d.$8lb),Z(7,d.$jmb),Z(8,d.$imb),Z(9,O.$7i),Z(10,d.$emb),Z(11,$.$6l),Z(12,L.$ep),Z(13,h.$El)],E);let u=class extends l.$AMb{constructor(t,s,o,i,n,r){super(d.SyncResource.Settings,s,o,i,t,n,r)}async o(t){const s=t.syncData?this.p(t.syncData.content):null;if(!s){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.$Je.fromString(s.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,g.$_Kb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return w(t)}catch(s){this.j.error(s)}return null}};e.$qac=u,e.$qac=u=ve([Z(0,y.$7k),Z(1,p.$Gl),Z(2,A.$Hi),Z(3,d.$jmb),Z(4,S.$9p),Z(5,h.$El)],u)}),define(le[124],he([0,1,15,3,30,22,16,7,17,18,29,20,41,244,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=e.$uac=void 0,e.$tac=g;function g(w){return JSON.parse(w.content)}let d=class extends h.$xMb{constructor(E,u,b,t,s,o,i,n,r,c,m,v){super({syncResource:l.SyncResource.Snippets,profile:E},u,t,b,s,o,i,c,m,n,r,v),this.pb=1,this.vb=E.snippetsHome,this.B(this.G.watch(b.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,P=>P.affects(this.vb))(()=>this.Q()))}async qb(E,u,b){const t=await this.Hb(),s=this.Gb(t),o=E.syncData?this.Fb(E.syncData):null;u=u===null&&b?E:u;const i=u&&u.syncData?this.Fb(u.syncData):null;o?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,p.$rac)(s,o,i);return this.Bb(n,t,o||{},i||{})}async ub(E){const u=E.syncData?this.Fb(E.syncData):null;if(u===null)return!0;const b=await this.Hb(),t=this.Gb(b),s=(0,p.$rac)(t,u,u);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async rb(E,u){return E.previewResult}async sb(E,u,b,t){if(this.h.isEqualOrParent(u,this.g.with({scheme:l.$lmb,authority:"local"})))return{content:E.fileContent?E.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:E.fileContent?E.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(u,this.g.with({scheme:l.$lmb,authority:"remote"})))return{content:E.remoteContent,localChange:E.remoteContent!==null?E.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(u,this.g))return b===void 0?{content:E.previewResult.content,localChange:E.previewResult.localChange,remoteChange:E.previewResult.remoteChange}:{content:b,localChange:b===null?E.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:b===null?E.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(E,u,b,t){const s=b.map(([o,i])=>({...o,acceptResult:i}));s.every(({localChange:o,remoteChange:i})=>o===l.Change.None&&i===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),s.some(({localChange:o})=>o!==l.Change.None)&&(await this.Cb(s),await this.Db(s,t)),s.some(({remoteChange:o})=>o!==l.Change.None)&&(E=await this.Eb(s,E,t)),u?.ref!==E.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(E),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:o}of s)try{await this.G.del(o)}catch{}}Bb(E,u,b,t){const s=new Map;for(const o of Object.keys(E.local.added)){const i={content:E.local.added[o],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o],previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of Object.keys(E.local.updated)){const i={content:E.local.updated[o],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o],localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o],previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of E.local.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o],localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of Object.keys(E.remote.added)){const i={content:E.remote.added[o],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o],localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of Object.keys(E.remote.updated)){const i={content:E.remote.updated[o],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o],localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o],previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of E.remote.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o],previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of E.conflicts){const i={content:t[o]??null,hasConflicts:!0,localChange:u[o]?l.Change.Modified:l.Change.Added,remoteChange:b[o]?l.Change.Modified:l.Change.Added},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o]||null,localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o]||null,previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}for(const o of Object.keys(u))if(!s.has(o)){const i={content:u[o]?u[o].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=u[o]?u[o].value.toString():null;s.set(o,{baseResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"base"}),baseContent:t[o]??null,localResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"local"}),fileContent:u[o]||null,localContent:n,remoteResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"remote"}),remoteContent:b[o]||null,previewResource:this.h.joinPath(this.g,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,o).with({scheme:l.$lmb,authority:"accepted"})})}return[...s.values()]}async resolveContent(E){return this.h.isEqualOrParent(E,this.g.with({scheme:l.$lmb,authority:"remote"}))||this.h.isEqualOrParent(E,this.g.with({scheme:l.$lmb,authority:"local"}))||this.h.isEqualOrParent(E,this.g.with({scheme:l.$lmb,authority:"base"}))||this.h.isEqualOrParent(E,this.g.with({scheme:l.$lmb,authority:"accepted"}))?this.db(E):null}async hasLocalData(){try{const E=await this.Hb();if(Object.keys(E).length)return!0}catch{}return!1}async Cb(E){const u={};for(const b of E)b.fileContent&&(u[this.h.basename(b.localResource)]=b.fileContent);await this.nb(JSON.stringify(this.Gb(u)))}async Db(E,u){for(const{fileContent:b,acceptResult:t,localResource:s,remoteResource:o,localChange:i}of E)if(i!==l.Change.None){const n=o?this.h.basename(o):this.h.basename(s),r=this.h.joinPath(this.vb,n);i===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,k.$Je.fromString(t.content),{overwrite:u}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,k.$Je.fromString(t.content),u?void 0:b),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(E,u,b){const t=u.syncData?this.Fb(u.syncData):{},s=(0,T.$9n)(t);for(const{acceptResult:o,localResource:i,remoteResource:n,remoteChange:r}of E)if(r!==l.Change.None){const c=i?this.h.basename(i):this.h.basename(n);r===l.Change.Deleted?delete s[c]:s[c]=o.content}return(0,p.$sac)(t,s)||(this.O.trace(`${this.D}: Updating remote snippets...`),u=await this.mb(JSON.stringify(s),b?null:u.ref),this.O.info(`${this.D}: Updated remote snippets`)),u}Fb(E){return g(E)}Gb(E){const u={};for(const b of Object.keys(E))u[b]=E[b].value.toString();return u}async Hb(){const E={};let u;try{u=await this.G.resolve(this.vb)}catch(b){if(b instanceof A.$pl&&b.fileOperationResult===A.FileOperationResult.FILE_NOT_FOUND)return E;throw b}for(const b of u.children||[]){const t=b.resource,s=this.h.extname(t);if(s===".json"||s===".code-snippets"){const o=this.h.relativePath(this.vb,t),i=await this.G.readFile(t);E[o]=i}}return E}};e.$uac=d,e.$uac=d=ve([Z(2,C.$Hi),Z(3,A.$7k),Z(4,L.$9p),Z(5,l.$7lb),Z(6,l.$8lb),Z(7,l.$jmb),Z(8,O.$7i),Z(9,l.$emb),Z(10,y.$6l),Z(11,S.$El)],d);let f=class extends h.$AMb{constructor(E,u,b,t,s,o){super(l.SyncResource.Snippets,u,b,t,E,s,o)}async o(E){const u=E.syncData?JSON.parse(E.syncData.content):null;if(!u){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(u)){const s=u[t];if(s){const o=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(o,k.$Je.fromString(s)),this.j.info("Created snippet",this.d.basename(o))}}await this.n(E)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(E){return E.fileOperationResult===A.FileOperationResult.FILE_NOT_FOUND}}};e.$vac=f,e.$vac=f=ve([Z(0,A.$7k),Z(1,$.$Gl),Z(2,C.$Hi),Z(3,l.$jmb),Z(4,L.$9p),Z(5,S.$El)],f)}),define(le[125],he([0,1,15,22,16,7,17,18,29,20,41,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=void 0,e.$wac=h;function h(d,f){try{return JSON.parse(d).tasks??null}catch(w){return f.error(w),null}}let p=class extends S.$yMb{constructor(f,w,E,u,b,t,s,o,i,n,r,c){super(f.tasksResource,{syncResource:$.SyncResource.Tasks,profile:f},w,o,i,n,E,u,s,r,b,t,c),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:$.$lmb,authority:"base"}),this.Cb=this.Ab.with({scheme:$.$lmb,authority:"local"}),this.Db=this.Ab.with({scheme:$.$lmb,authority:"remote"}),this.Eb=this.Ab.with({scheme:$.$lmb,authority:"accepted"})}async qb(f,w,E,u){const b=f.syncData?h(f.syncData.content,this.O):null;w=w===null&&E?f:w;const t=w?.syncData?h(w.syncData.content,this.O):null,s=await this.vb();let o=null,i=!1,n=!1,r=!1;if(f.syncData){const v=s?s.value.toString():null;if(!t||t!==v||t!==b){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const P=g(v,b,t);o=P.content,r=P.hasConflicts,i=P.hasLocalChanged,n=P.hasRemoteChanged}}else s&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),o=s.value.toString(),n=!0);const c={content:r?t:o,localChange:i?s?$.Change.Modified:$.Change.Added:$.Change.None,remoteChange:n?$.Change.Modified:$.Change.None,hasConflicts:r},m=s?s.value.toString():null;return[{fileContent:s,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:m,localChange:c.localChange,remoteResource:this.Db,remoteContent:b,remoteChange:c.remoteChange,previewResource:this.Ab,previewResult:c,acceptedResource:this.Eb}]}async ub(f){const w=f?.syncData?h(f.syncData.content,this.O):null;if(w===null)return!0;const E=await this.vb(),u=E?E.value.toString():null,b=g(u,w,w);return b.hasLocalChanged||b.hasRemoteChanged}async rb(f,w){return f.previewResult}async sb(f,w,E,u){if(this.h.isEqual(w,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:$.Change.None,remoteChange:$.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:f.remoteContent,localChange:$.Change.Modified,remoteChange:$.Change.None};if(this.h.isEqual(w,this.Ab))return E===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:E,localChange:$.Change.Modified,remoteChange:$.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(f,w,E,u){const{fileContent:b}=E[0][0],{content:t,localChange:s,remoteChange:o}=E[0][1];if(s===$.Change.None&&o===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),s!==$.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),b&&await this.nb(JSON.stringify(this.Kb(b.value.toString()))),t?await this.wb(t,b,u):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),o!==$.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(t));f=await this.mb(i,u?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$xac=p,e.$xac=p=ve([Z(2,$.$7lb),Z(3,$.$8lb),Z(4,$.$jmb),Z(5,a.$7i),Z(6,$.$emb),Z(7,O.$7k),Z(8,T.$Hi),Z(9,C.$9p),Z(10,A.$6l),Z(11,L.$El)],p);let l=class extends S.$AMb{constructor(f,w,E,u,b,t){super($.SyncResource.Tasks,w,E,u,f,b,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const w=f.syncData?h(f.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.$Je.fromString(w)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$yac=l,e.$yac=l=ve([Z(0,O.$7k),Z(1,y.$Gl),Z(2,T.$Hi),Z(3,$.$jmb),Z(4,C.$9p),Z(5,L.$El)],l);function g(d,f,w){if(d===null&&f===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(d===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const E=w!==d,u=w!==f;return!E&&!u?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:E&&!u?{content:d,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:u&&!E?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:d,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],he([0,1,46,22,16,7,17,18,29,20,41,245,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0,e.$gcc=l,e.$hcc=g;let p=class extends S.$xMb{constructor(f,w,E,u,b,t,s,o,i,n,r,c,m){super({syncResource:h.SyncResource.Profiles,profile:f},w,u,b,t,s,o,r,c,i,n,m),this.vb=E,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:h.$lmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.$lmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.$lmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.$lmb,authority:"accepted"}),this.B(E.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?g(f.syncData):null}async getRemoteSyncedProfiles(f){const w=await this.getLastSyncUserData(),E=await this.X(f,w);return E?.syncData?g(E.syncData):null}async qb(f,w,E){if(!this.vb.isEnabled())throw new h.$_lb("Cannot sync profiles because they are disabled",h.UserDataSyncErrorCode.LocalError);const u=f.syncData?g(f.syncData):null,b=w?.syncData?g(w.syncData):null,t=this.Db(),{local:s,remote:o}=(0,$.$ecc)(t,u,b,[]),i={local:s,remote:o,content:b?this.Eb(b):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:o!==null?h.Change.Modified:h.Change.None},n=l(t,!1);return[{baseResource:this.baseResource,baseContent:b?this.Eb(b):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:u?this.Eb(u):null,remoteProfiles:u,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const w=f?.syncData?g(f.syncData):null,E=this.Db(),{remote:u}=(0,$.$ecc)(E,w,w,[]);return!!u?.added.length||!!u?.removed.length||!!u?.updated.length}async rb(f,w){return{...f.previewResult,hasConflicts:!1}}async sb(f,w,E,u){if(this.h.isEqual(w,this.localResource))return this.Ab(f);if(this.h.isEqual(w,this.remoteResource))return this.Bb(f);if(this.h.isEqual(w,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(f){const w=this.Db(),E=(0,$.$ecc)(w,null,null,[]),{local:u,remote:b}=E;return{content:f.localContent,local:u,remote:b,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:b!==null?h.Change.Modified:h.Change.None}}async Bb(f){const w=f.remoteContent?JSON.parse(f.remoteContent):null,E=[],u=[];for(const b of this.Db()){const t=w?.find(s=>s.id===b.id);t&&(E.push({id:b.id,name:b.name,collection:t.collection}),u.push(b))}if(w!==null){const b=(0,$.$ecc)(u,w,E,[]),{local:t,remote:s}=b;return{content:f.remoteContent,local:t,remote:s,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:s!==null?h.Change.Modified:h.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:h.Change.None,remoteChange:h.Change.None}}async tb(f,w,E,u){const{local:b,remote:t,localChange:s,remoteChange:o}=E[0][1];s===h.Change.None&&o===h.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=E[0][0].remoteProfiles||[];if(i.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new h.$_lb("Too many profiles to sync. Please remove some profiles and try again.",h.UserDataSyncErrorCode.LocalTooManyProfiles);if(s!==h.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(b.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(b.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(b.updated.map(async n=>{const r=this.vb.profiles.find(c=>c.id===n.id);r?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(r,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),o!==h.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],r=i.length+(t?.added.length??0)<=20;if(r)for(const c of t?.added||[]){const m=await this.J.createCollection(this.F);n.push(m),i.push({id:c.id,name:c.name,collection:m,shortName:c.shortName,icon:c.icon,useDefaultFlags:c.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const c of t?.removed||[])i.splice(i.findIndex(({id:m})=>c.id===m),1);for(const c of t?.updated||[]){const m=i.find(({id:v})=>c.id===v);m&&i.splice(i.indexOf(m),1,{...m,id:c.id,name:c.name,shortName:c.shortName,icon:c.icon,useDefaultFlags:c.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,u?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(c=>c.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(c=>c.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(c=>c.name))}.`:""}`)}catch(c){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const m of n)await this.J.deleteCollection(m,this.F)}throw c}for(const c of t?.removed||[])await this.J.deleteCollection(c.collection,this.F)}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,w){return this.mb(this.Eb(f),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const w=await this.db(f);return w&&(0,k.$1n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((w,E)=>w.name.localeCompare(E.name)))}};e.$fcc=p,e.$fcc=p=ve([Z(2,y.$Gl),Z(3,O.$7k),Z(4,T.$Hi),Z(5,C.$9p),Z(6,h.$7lb),Z(7,h.$8lb),Z(8,h.$jmb),Z(9,a.$7i),Z(10,h.$emb),Z(11,A.$6l),Z(12,L.$El)],p);function l(d,f){const w=[...d].sort((E,u)=>E.name.localeCompare(u.name)).map(E=>({id:E.id,name:E.name}));return f?(0,k.$1n)(w,{}):JSON.stringify(w)}function g(d){return JSON.parse(d.content)}}),define(le[264],he([0,1,3,2,5,16,17,18,25]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;const y="sync.enable";let S=class extends a.$Uc{constructor(h,p,l,g){super(),this.c=h,this.f=p,this.g=l,this.h=g,this.a=new k.$he,this.onDidChangeEnablement=this.a.event,this.b=new k.$he,this.onDidChangeResourceEnablement=this.b.event,this.B(h.onDidChangeValue(C.StorageScope.APPLICATION,void 0,this.B(new a.$Tc))(d=>this.m(d)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(y,C.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.f.publicLog2(y,{enabled:h}),this.c.store(y,h,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE))}isResourceEnabled(h){return this.c.getBoolean((0,L.$dmb)(h),C.StorageScope.APPLICATION,!0)}setResourceEnablement(h,p){if(this.isResourceEnabled(h)!==p){const l=(0,L.$dmb)(h);this.j(l,p)}}getResourceSyncStateVersion(h){}j(h,p){this.c.store(h,p,C.StorageScope.APPLICATION,T.$o?C.StorageTarget.USER:C.StorageTarget.MACHINE)}m(h){if(y===h.key){this.a.fire(this.isEnabled());return}const p=L.$3lb.filter(l=>(0,L.$dmb)(l)===h.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};e.$5bc=S,e.$5bc=S=ve([Z(0,C.$9p),Z(1,A.$6l),Z(2,O.$Hi),Z(3,L.$6lb)],S)}),define(le[265],he([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;let h=class extends O.$Uc{constructor(l,g,d,f,w){super(),this.a=l,this.b=g,this.c=d,this.f=f,this.g=w,this.h()}async h(){for(const g of this.g.profiles)for(const d of $.$3lb)try{await this.m(this.j(d,g.isDefault?void 0:g.id))}catch(f){this.f.error(f)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(g){(0,y.$ll)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g);return}if(l.children){for(const g of l.children)if(g.isDirectory&&!this.g.profiles.some(d=>d.id===g.name))try{this.f.info("Deleting non existing profile from backup",g.resource.path),await this.b.del(g.resource,{recursive:!0})}catch(d){this.f.error(d)}}}async getAllResourceRefs(l,g,d){const f=this.j(l,g,d);try{const w=await this.b.resolve(f);if(w.children)return w.children.filter(u=>u.isFile&&!u.name.startsWith("lastSync")).sort().reverse().map(u=>({ref:u.name,created:this.n(u)}))}catch(w){if((0,y.$ll)(w)!==y.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,g,d,f){const w=this.j(l,d,f),E=(0,C.$bh)(w,g);try{return(await this.b.readFile(E)).value.toString()}catch(u){return this.f.error(u),null}}async writeResource(l,g,d,f,w){const E=this.j(l,f,w),u=(0,C.$bh)(E,`${(0,T.$9m)(d).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,a.$Je.fromString(g))}catch(b){this.f.error(b)}}j(l,g,d=this.a.userDataSyncHome){return(0,C.$bh)(d,...g?[g,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const g=await this.b.resolve(l);if(g.children){const d=g.children.filter(u=>u.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(u.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=d.filter(u=>Date.now()-this.n(u)>f);const E=d.length-w.length;E<10&&(w=w.slice(10-E)),await k.Promises.settled(w.map(async u=>{this.f.info("Deleting from backup",u.resource.path),await this.b.del(u.resource)}))}}catch(g){this.f.error(g)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$dcc=h,e.$dcc=h=ve([Z(0,L.$Hi),Z(1,y.$7k),Z(2,A.$7i),Z(3,$.$jmb),Z(4,S.$Gl)],h)}),define(le[87],he([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlb=e.$Tlb=void 0,e.$Ulb=b,e.$Tlb=(0,y.$Ai)("IUserDataSyncMachinesService");const g="sync.currentMachineName",d="Safari",f="Chrome",w="Edge",E="Firefox",u="Android";function b(o){switch(o){case d:case f:case w:case E:case u:case(0,T.$h)(T.Platform.Web):return!0}return!1}function t(){return T.$G?d:T.$E?f:T.$H?w:T.$F?E:T.$I?u:(0,T.$h)(T.$o?T.Platform.Web:T.$u)}let s=class extends a.$Uc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(i,n,r,c,m,v){super(),this.h=r,this.j=c,this.m=m,this.n=v,this.c=this.B(new k.$he),this.onDidChange=this.c.event,this.g=null,this.f=(0,$.$cq)(i,n,r)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(c=>({...c,isCurrent:c.id===n}))}async addCurrentMachine(i){const n=await this.f,r=await this.s(i);r.machines.some(({id:c})=>c===n)||(r.machines.push({id:n,name:this.r(r.machines),platform:t()}),await this.t(r))}async removeCurrentMachine(i){const n=await this.f,r=await this.s(i),c=r.machines.filter(({id:m})=>m!==n);c.length!==r.machines.length&&(r.machines=c,await this.t(r))}async renameMachine(i,n,r){const c=await this.s(r),m=c.machines.find(({id:v})=>v===i);if(m){m.name=n,await this.t(c);const v=await this.f;i===v&&this.h.store(g,n,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[r,c]of i){const m=n.machines.find(v=>v.id===r);m&&(m.disabled=c?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(g,h.StorageScope.APPLICATION);if(n)return n;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,c=new RegExp(`${(0,O.$df)(r)}\\s#(\\d+)`);let m=0;for(const v of i){const P=c.exec(v.name),R=P?parseInt(P[1]):0;m=R>m?R:m}return`${r} #${m+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==l.a)throw new Error((0,C.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),r=await this.j.writeResource(l.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[l.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:l.a,machines:[]}}};e.$Vlb=s,e.$Vlb=s=l=ve([Z(0,A.$Hi),Z(1,L.$7k),Z(2,h.$9p),Z(3,p.$7lb),Z(4,p.$jmb),Z(5,S.$nk)],s)}),define(le[266],he([0,1,6,67,40,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;const w="sync.disableMachineEventually",E="sync.sessionId",u="sync.storeUrl",b="sync.productQuality";let t=class extends A.$Uc{get n(){const i=this.H.get(u,p.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(u,i.toString(),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.H.remove(u,p.StorageScope.APPLICATION)}get s(){return this.H.get(b,p.StorageScope.APPLICATION)}set s(i){i?this.H.store(b,i,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.H.remove(b,p.StorageScope.APPLICATION)}constructor(i,n,r,c,m,v,P,R,I,N){super(),this.u=n,this.w=r,this.y=c,this.z=m,this.C=v,this.D=P,this.F=R,this.G=I,this.H=N,this.a=this.B(new A.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new C.$he),this.onError=this.h.event,this.S=[],this.f=this.B(new k.$yh(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,y.$7g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(P.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(m.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(C.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new s(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$9m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(E,p.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(c){if(this.C.error(c),n)this.M(!1);else throw c}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=g.$_lb.toUserDataSyncError(i);n instanceof g.$bmb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===g.UserDataSyncErrorCode.UpgradeRequired||n.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===g.UserDataSyncErrorCode.ServiceChanged||n.code===g.UserDataSyncErrorCode.DefaultServiceChanged?L.$o&&n.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(w,!0,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),await(0,k.$Bh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,p.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,p.StorageScope.APPLICATION)}async triggerSync(i,n,r){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const c=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:c}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$jcc=t,e.$jcc=t=ve([Z(0,h.$nk),Z(1,g.$6lb),Z(2,g.$7lb),Z(3,g.$emb),Z(4,g.$fmb),Z(5,g.$jmb),Z(6,d.$RKb),Z(7,l.$6l),Z(8,f.$Tlb),Z(9,p.$9p)],t);class s extends A.$Uc{static{this.a="Interval"}constructor(i,n,r,c,m,v,P,R,I){super(),this.m=i,this.n=n,this.r=r,this.s=c,this.u=m,this.w=v,this.y=P,this.z=R,this.C=I,this.b=this.B(new A.$Vc),this.c=this.B(new C.$he),this.onDidStartSync=this.c.event,this.f=this.B(new C.$he),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,A.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}D(){this.b.value=(0,k.$Ch)(()=>{this.sync(s.a,!1),this.b.value=void 0},this.n)}sync(i,n){const r=(0,k.$nh)(async c=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(m){if((0,O.$4)(m))return}return this.H(i,n,c)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,y.$7g)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,y.$7g)(n.defaultUrl,i.defaultUrl)||!(0,y.$7g)(n.insidersUrl,i.insidersUrl)||!(0,y.$7g)(n.stableUrl,i.stableUrl))}async H(i,n,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let c;try{await this.I(n,r)}catch(m){if(this.y.error(m),c=m,g.$_lb.toUserDataSyncError(m).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,r),c=void 0}catch(v){this.y.error(v),c=v}}this.f.fire(c)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new g.$bmb((0,$.localize)(0,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$bmb((0,$.localize)(1,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$bmb((0,$.localize)(2,null),g.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(E,p.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new g.$bmb((0,$.localize)(3,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$bmb((0,$.localize)(4,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$bmb((0,$.localize)(5,null),g.UserDataSyncErrorCode.SessionExpired);const c=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const m=c.find(P=>P.isCurrent);if(m?.disabled)throw new g.$bmb((0,$.localize)(6,null),g.UserDataSyncErrorCode.TurnedOff);const v=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-v}),this.g===null)try{this.g=await this.s.manifest(null)}catch(P){throw new g.$bmb((0,T.$lj)(P),P instanceof g.$_lb?P.code:g.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(E,this.g.session,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),!n.isCancellationRequested&&(m||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[267],he([0,1,9,188,16,7,50,17,29,25,20,41,124,123,122,22,125,120,121,4,126,46,27]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;let o=class{static{s=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,r,c,m,v,P,R,I,N,U){this.e=n,this.f=r,this.g=c,this.h=v,this.i=P,this.j=R,this.k=I,this.l=N,this.n=U,this.d=m.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(y.SyncResource.Profiles,null,void 0);if(n.content){const r=this.L(n.content,y.SyncResource.Profiles);return(0,u.$hcc)(r)}return[]}async getLocalSyncedProfiles(n){const r=await this.f.getAllResourceRefs(y.SyncResource.Profiles,void 0,n);if(r.length){const c=await this.f.resolveResourceContent(y.SyncResource.Profiles,r[0].ref,void 0,n);if(c){const m=this.L(c,y.SyncResource.Profiles);return(0,u.$hcc)(m)}}return[]}async getLocalSyncedMachines(n){const r=await this.f.getAllResourceRefs("machines",void 0,n);if(r.length){const c=await this.f.resolveResourceContent("machines",r[0].ref,void 0,n);if(c)return JSON.parse(c).machines.map(v=>({...v,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,r){return(await this.e.getAllResourceRefs(n,r?.collection)).map(({created:m,ref:v})=>({created:m,uri:this.J({remote:!0,syncResource:n,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(n,r,c){return(await this.f.getAllResourceRefs(n,r?.collection,c)).map(({created:v,ref:P})=>({created:v,uri:this.J({remote:!1,syncResource:n,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:P,node:void 0,location:c})}))}resolveUserDataSyncResource({uri:n}){const r=this.K(n),c=r?this.k.profiles.find(m=>m.id===r.profile):void 0;return r&&c?{profile:c,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:n}){const r=this.K(n);if(!r)return[];const c=this.k.profiles.find(m=>m.id===r.profile);switch(r.syncResource){case y.SyncResource.Settings:return this.s(n,c);case y.SyncResource.Keybindings:return this.u(n,c);case y.SyncResource.Tasks:return this.w(n,c);case y.SyncResource.Snippets:return this.y(n,c);case y.SyncResource.GlobalState:return this.D(n,c);case y.SyncResource.Extensions:return this.A(n,c);case y.SyncResource.Profiles:return this.G(n,c);case y.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const r=this.K(n);if(r){if(r.remote){if(r.ref){const{content:c}=await this.M(r.syncResource,r.ref,r.collection);if(c)return this.L(c,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const c=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(c)return this.L(c,r.syncResource)?.machineId}return}return(0,C.$cq)(this.h,this.j,this.i)}}async resolveContent(n){const r=this.K(n);if(!r||r.node===s.a)return null;if(r.ref){const c=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&c?this.q(r.syncResource,c,r.node):c}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(n,r,c,m,v){if(n){const{content:P}=await this.M(r,m,c);return P}return this.f.resolveResourceContent(r,m,c,v)}q(n,r,c){const m=this.L(r,n);switch(n){case y.SyncResource.Settings:return this.t(m,c);case y.SyncResource.Keybindings:return this.v(m,c);case y.SyncResource.Tasks:return this.x(m,c);case y.SyncResource.Snippets:return this.z(m,c);case y.SyncResource.GlobalState:return this.E(m,c);case y.SyncResource.Extensions:return this.B(m,c);case y.SyncResource.Profiles:return this.H(m,c);case y.SyncResource.WorkspaceState:return null}}async r(n,r){const c=this.k.profiles.find(m=>m.id===r);if(!c)return null;switch(n){case y.SyncResource.GlobalState:return this.F(c);case y.SyncResource.Extensions:return this.C(c);case y.SyncResource.Profiles:return this.I(c);case y.SyncResource.Settings:return null;case y.SyncResource.Keybindings:return null;case y.SyncResource.Tasks:return null;case y.SyncResource.Snippets:return null;case y.SyncResource.WorkspaceState:return null}}s(n,r){const c=this.d.joinPath(n,"settings.json"),m=r?r.settingsResource:this.d.joinPath(n,s.a);return[{resource:c,comparableResource:m}]}t(n,r){switch(r){case"settings.json":return(0,p.$oac)(n.content).settings}return null}u(n,r){const c=this.d.joinPath(n,"keybindings.json"),m=r?r.keybindingsResource:this.d.joinPath(n,s.a);return[{resource:c,comparableResource:m}]}v(n,r){switch(r){case"keybindings.json":return(0,l.$lac)(n.content,!!this.l.getValue(y.$Zlb),this.g)}return null}w(n,r){const c=this.d.joinPath(n,"tasks.json"),m=r?r.tasksResource:this.d.joinPath(n,s.a);return[{resource:c,comparableResource:m}]}x(n,r){switch(r){case"tasks.json":return(0,d.$wac)(n.content,this.g)}return null}async y(n,r){const c=await this.resolveContent(n);if(c){const m=this.L(c,y.SyncResource.Snippets);if(m){const v=(0,h.$tac)(m),P=[];for(const R of Object.keys(v)){const I=this.d.joinPath(n,R),N=r?this.d.joinPath(r.snippetsHome,R):this.d.joinPath(n,s.a);P.push({resource:I,comparableResource:N})}return P}}return[]}z(n,r){return(0,h.$tac)(n)[r]||null}A(n,r){const c=this.d.joinPath(n,"extensions.json"),m=r?this.J({remote:!1,syncResource:y.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:c,comparableResource:m}]}B(n,r){switch(r){case"extensions.json":return(0,f.$gac)((0,f.$fac)(n),!0)}return null}async C(n){const{localExtensions:r}=await this.n.createInstance(f.$iac).getLocalExtensions(n);return(0,f.$gac)(r,!0)}D(n,r){const c=this.d.joinPath(n,"globalState.json"),m=r?this.J({remote:!1,syncResource:y.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:c,comparableResource:m}]}E(n,r){switch(r){case"globalState.json":return(0,w.$CMb)(JSON.parse(n.content),!0)}return null}async F(n){const r=await this.n.createInstance(w.$EMb).getLocalGlobalState(n);return(0,w.$CMb)(r,!0)}G(n,r){const c=this.d.joinPath(n,"profiles.json"),m=this.J({remote:!1,syncResource:y.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:c,comparableResource:m}]}H(n,r){switch(r){case"profiles.json":return(0,b.$1n)(JSON.parse(n.content),{})}return null}async I(n){return(0,u.$gcc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(n){const r=n.remote?s.b:s.c,c=[];return n.location&&(c.push(`scheme:${n.location.scheme}`),c.push(`authority:${n.location.authority}`),c.push((0,t.$hf)(n.location.path,"/"))),c.push(`syncResource:${n.syncResource}`),c.push(`profile:${n.profile}`),n.collection&&c.push(`collection:${n.collection}`),n.ref&&c.push(`ref:${n.ref}`),n.node&&c.push(n.node),this.d.joinPath(k.URI.from({scheme:y.$lmb,authority:r,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...c)}K(n){if(n.scheme!==y.$lmb)return;const r=[];for(;n.path!=="/";)r.unshift(this.d.basename(n)),n=this.d.dirname(n);if(r.length<2)return;const c=n.authority===s.b;let m,v;const P=[];let R,I,N,U,j;for(;r.length;){const F=r.shift();F.startsWith("scheme:")?m=F.substring(7):F.startsWith("authority:")?v=F.substring(10):F.startsWith("syncResource:")?R=F.substring(13):F.startsWith("profile:")?I=F.substring(8):F.startsWith("collection:")?N=F.substring(11):F.startsWith("ref:")?U=F.substring(4):R?j=F:P.push(F)}return{remote:c,syncResource:R,profile:I,collection:N,ref:U,node:j,location:m&&v!==void 0?this.d.joinPath(k.URI.from({scheme:m,authority:v,query:n.query,fragment:n.fragment,path:"/"}),...P):void 0}}L(n,r){try{const c=JSON.parse(n);if((0,$.$vMb)(c))return c}catch(c){this.g.error(c)}throw new y.$_lb((0,a.localize)(0,null),y.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(n,r,c){const m=await this.e.resolveResourceContent(n,r,c);return{ref:r,content:m}}};e.$Ycc=o,e.$Ycc=o=s=ve([Z(0,y.$7lb),Z(1,y.$8lb),Z(2,y.$jmb),Z(3,L.$El),Z(4,T.$Hi),Z(5,A.$9p),Z(6,O.$7k),Z(7,S.$Gl),Z(8,g.$7i),Z(9,E.$zi)],o)}),define(le[268],he([0,1,19,6,26,40,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;const n="sync.lastSyncTime";let r=class extends A.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(R,I,N,U,j,F,X,K,Q,V,ie){super(),this.C=R,this.D=I,this.F=N,this.G=U,this.H=j,this.I=F,this.J=X,this.L=K,this.M=Q,this.N=V,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new C.$he),this.onDidChangeStatus=this.g.event,this.h=this.B(new C.$he),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new C.$he),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new C.$he),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new C.$he),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new C.$he),this.onDidResetLocal=this.w.event,this.y=this.B(new C.$he),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,g.StorageScope.APPLICATION,void 0),this.B((0,A.$Sc)(()=>this.cb())),this.B(new a.$Mh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(R,I){this.db(),this.H.info("Sync started.");const N=new Date().getTime(),U=(0,S.$Wg)();try{const K=(0,i.$$lb)(U);I&&(K["Cache-Control"]="no-cache"),R=await this.D.manifest(R,K)}catch(K){const Q=i.$_lb.toUserDataSyncError(K);throw v(Q,U,this.F,this.I),Q}const j=!1,F=this;let X;return{manifest:R,async run(){if(j)throw new Error("Can run a task only once");X=(0,a.$nh)(K=>F.P(R,!1,U,K)),await X.finally(()=>X=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),F.ab()},stop(){return X?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$_lb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const R=new Date().getTime(),I=(0,S.$Wg)(),N=(0,i.$$lb)(I);let U;try{U=await this.D.manifest(null,N)}catch(X){const K=i.$_lb.toUserDataSyncError(X);throw v(K,I,this.F,this.I),K}await this.resetLocal();const j=this,F=new T.$se;return{id:I,async merge(){return j.P(U,!0,I,F.token)},async apply(){try{try{await j.R(U,I,F.token)}catch(X){if(i.$_lb.toUserDataSyncError(X).code===i.UserDataSyncErrorCode.MethodNotFound)j.H.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.H.info("Applying manual sync again..."),await j.R(U,I,F.token);else throw X}}catch(X){throw j.H.error(X),X}j.H.info(`Sync done. Took ${new Date().getTime()-R}ms`),j.ab()},async stop(){F.cancel(),await j.U(),await j.resetLocal()}}}async P(R,I,N,U){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const j=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(j,R,I,N,U));const F=j.enabled.find(X=>X.resource===i.SyncResource.Profiles);if(F){const X=await F.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(X,R,I,N,U)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(R,I,N,U,j){for(const F of R){if(j.isCancellationRequested)return;const X=this.M.profiles.find(Q=>Q.id===F.id);if(!X){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const K=this.getOrCreateActiveProfileSynchronizer(X,F);this.n.push(...await this.S(K,I,N,U,j))}for(const[F,X]of this.z.entries())this.M.profiles.some(K=>K.id===X[0].profile.id)||(await X[0].resetLocal(),X[1].dispose(),this.z.delete(F))}async R(R,I,N){const U=this.bb();for(const Q of U){if(N.isCancellationRequested)return;await Q.apply(I,N)}const j=U.find(Q=>Q.profile.isDefault);if(!j)return;const F=j.enabled.find(Q=>Q.resource===i.SyncResource.Profiles);if(!F)return;const K=(await F.getRemoteSyncedProfiles(R?.latest??null)||[]).filter(Q=>U.every(V=>V.profile.id!==Q.id));K.length&&await this.Q(K,R,!1,I,N)}async S(R,I,N,U,j){return(await R.sync(I,N,U,j)).map(([X,K])=>({profile:R.profile,syncResource:X,error:K}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(R=>R.stop()))}async resolveContent(R){const I=await this.N.resolveContent(R);if(I)return I;for(const N of this.bb())for(const U of N.enabled){const j=await U.resolveContent(R);if(j)return j}return null}async replace(R){this.db();const I=this.N.resolveUserDataSyncResource(R);if(!I)return;const N=await this.resolveContent(R.uri);N&&await this.X(I.profile,async U=>{if(I.syncResource===U.resource)return await U.replace(N),!0})}async accept(R,I,N,U){this.db(),await this.X(R.profile,async j=>{if(R.syncResource===j.resource)return await j.accept(I,N),U&&await j.apply((0,y.$gg)(U)?!1:U.force,(0,i.$$lb)((0,S.$Wg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async I=>{if(I.resource!==i.SyncResource.GlobalState&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(R){this.H.error(R)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,g.StorageScope.APPLICATION);for(const[R]of this.z.values())try{await R.resetLocal()}catch(I){this.H.error(I)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const R=this.J.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),I=[];for(const U of R){if(!U.endsWith(".lastSyncUserData"))continue;const j=U.split(".");j.length===3&&I.push([U,j[0]])}if(!I.length)return;const N=new A.$Tc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=N.add(this.G.createInstance(c,this.M.defaultProfile,void 0)));const j=U.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(!j)return;const X=(await j.getLastSyncedProfiles())?.map(K=>K.collection)??[];for(const[K,Q]of I)X.includes(Q)||(this.H.info(`Removing last sync state for stale profile: ${Q}`),this.J.remove(K,g.StorageScope.APPLICATION))}finally{N.dispose()}}async cleanUpRemoteData(){const R=await this.N.getRemoteSyncedProfiles(),I=R.map(F=>F.collection),N=await this.D.getAllCollections(),U=N.filter(F=>!I.includes(F));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const j=R.filter(F=>N.includes(F.collection));if(j.length!==R.length){const F=this.G.createInstance(o.$fcc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(j,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(R){this.db();const I=await this.D.getActivityData();await this.C.writeFile(R,I)}async extractActivityData(R,I){const N=(await this.C.readFile(R)).value.toString(),U=JSON.parse(N);if(U.resources)for(const j in U.resources)for(const F of U.resources[j])await this.O.writeResource(j,F.content,new Date(F.created*1e3),void 0,I);if(U.collections)for(const j in U.collections)for(const F in U.collections[j].resources)for(const X of U.collections[j].resources?.[F]??[])await this.O.writeResource(F,X.content,new Date(X.created*1e3),j,I)}async X(R,I){const N=new A.$Tc;try{const U=this.z.get(R.id);if(U){const Q=await this.Y(U[0],I,N);return(0,y.$hg)(Q)?null:Q}if(R.isDefault){const Q=N.add(this.G.createInstance(c,R,void 0)),V=await this.Y(Q,I,N);return(0,y.$hg)(V)?null:V}if(this.M.isEnabled())return null;const j=N.add(this.G.createInstance(o.$fcc,R,void 0)),F=await this.D.manifest(null),K=(await j.getRemoteSyncedProfiles(F?.latest??null)||[]).find(Q=>Q.id===R.id);if(K){const Q=N.add(this.G.createInstance(c,R,K.collection)),V=await this.Y(Q,I,N);return(0,y.$hg)(V)?null:V}return null}finally{N.dispose()}}async Y(R,I,N){const U=[...R.enabled,...R.disabled.reduce((j,F)=>(F!==i.SyncResource.WorkspaceState&&j.push(N.add(R.createSynchronizer(F))),j),[])];for(const j of U){const F=await I(j);if(!(0,y.$hg)(F))return F}}Z(R){const I=this.f;this.f!==R&&(this.f=R,this.g.fire(R),I===i.SyncStatus.HasConflicts&&this.ab())}$(){const R=this.bb().map(I=>I.conflicts).flat();(0,k.$ub)(this.j,R,(I,N)=>I.profile.id===N.profile.id&&I.syncResource===N.syncResource&&(0,k.$ub)(I.conflicts,N.conflicts,(U,j)=>(0,L.$7g)(U.previewResource,j.previewResource)))||(this.j=R,this.m.fire(R))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(R,I){let N=this.z.get(R.id);if(N&&N[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(R.id)),!N){const U=new A.$Tc,j=U.add(this.G.createInstance(c,R,I?.collection));U.add(j.onDidChangeStatus(F=>this.Z(F))),U.add(j.onDidChangeConflicts(F=>this.$())),U.add(j.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(R.id,N=[j,U])}return N[0]}bb(){const R=[];for(const[I]of this.z.values())R.push(I);return R}cb(){this.z.forEach(([,R])=>R.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$icc=r,e.$icc=r=ve([Z(0,p.$7k),Z(1,i.$7lb),Z(2,i.$6lb),Z(3,l.$zi),Z(4,i.$jmb),Z(5,d.$6l),Z(6,g.$9p),Z(7,i.$emb),Z(8,f.$Gl),Z(9,i.$gmb),Z(10,i.$8lb)],r);let c=class extends A.$Uc{get enabled(){return this.f.sort((R,I)=>R[1]-I[1]).map(([R])=>R)}get disabled(){return i.$3lb.filter(R=>!this.r.isResourceEnabled(R))}get status(){return this.g}get conflicts(){return this.m}constructor(R,I,N,U,j,F,X,K,Q,V){super(),this.profile=R,this.collection=I,this.r=N,this.t=U,this.u=j,this.w=F,this.y=X,this.z=K,this.C=Q,this.D=V,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new C.$he),this.onDidChangeStatus=this.h.event,this.j=this.B(new C.$he),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new C.$he),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([ie,H])=>this.F(ie,H))),this.B((0,A.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$3lb)N.isResourceEnabled(ie)&&this.G(ie)}F(R,I){I?this.G(R):this.H(R)}G(R){if(this.f.some(([j])=>j.resource===R))return;if(R===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(R===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||R===i.SyncResource.WorkspaceState)return;if(R!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[R]){this.z.debug(`Skipping syncing ${R} in ${this.profile.name} because it is already synced by default profile`);return}const I=new A.$Tc,N=I.add(this.createSynchronizer(R));I.add(N.onDidChangeStatus(()=>this.L())),I.add(N.onDidChangeConflicts(()=>this.M())),I.add(N.onDidChangeLocal(()=>this.j.fire(R)));const U=this.N(R);this.f.push([N,U,I])}H(R){const I=this.f.findIndex(([N])=>N.resource===R);if(I!==-1){const[[N,,U]]=this.f.splice(I,1);U.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,j=>this.z.error(j))}}createSynchronizer(R){switch(R){case i.SyncResource.Settings:return this.t.createInstance(b.$pac,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(u.$mac,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(t.$uac,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(s.$xac,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(E.$DMb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(w.$hac,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(o.$fcc,this.profile,this.collection)}}async sync(R,I,N,U){if(U.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const F=[],X=(0,i.$$lb)(N),K=(this.collection?R?.collections?.[this.collection]?.latest:R?.latest)??null,Q=I?await this.I(K):{};for(const V of j){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(I){const ie=await V.preview(K,Q,X);if(ie)for(const H of ie.resourcePreviews)(H.localChange!==i.Change.None||H.remoteChange!==i.Change.None)&&H.mergeState===i.MergeState.Preview&&await V.merge(H.previewResource)}else await V.sync(K,X)}catch(ie){const H=i.$_lb.toUserDataSyncError(ie);if(v(H,N,this.w,this.y),m(ie))throw H;this.z.error(ie),this.z.error(`${V.resource}: ${(0,O.$lj)(ie)}`),F.push([V.resource,H])}}return F}finally{this.L()}}async apply(R,I){const N=(0,i.$$lb)(R);for(const U of this.enabled){if(I.isCancellationRequested)return;try{await U.apply(!1,N)}catch(j){const F=i.$_lb.toUserDataSyncError(j);if(v(F,R,this.w,this.y),m(j))throw F;this.z.error(j),this.z.error(`${U.resource}: ${(0,O.$lj)(j)}`)}}}async stop(){for(const R of this.enabled)try{R.status!==i.SyncStatus.Idle&&await R.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const R of this.enabled)try{await R.resetLocal()}catch(I){this.z.error(`${R.resource}: ${(0,O.$lj)(I)}`),this.z.error(I)}}async I(R){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$Ylb),N=this.enabled.find(U=>U instanceof b.$pac);if(N){const U=await N.getRemoteUserDataSyncConfiguration(R);return{...I,...U}}return I}J(R){this.g!==R&&(this.g=R,this.h.fire(R))}L(){return this.M(),this.enabled.some(R=>R.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(R=>R.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const R=this.enabled.filter(I=>I.status===i.SyncStatus.HasConflicts).filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,k.$ub)(this.m,R,(I,N)=>I.syncResource===N.syncResource&&(0,k.$ub)(I.conflicts,N.conflicts,(U,j)=>(0,L.$7g)(U.previewResource,j.previewResource)))||(this.m=R,this.n.fire(R))}N(R){switch(R){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};c=ve([Z(2,i.$emb),Z(3,l.$zi),Z(4,h.$bp),Z(5,i.$6lb),Z(6,d.$6l),Z(7,i.$jmb),Z(8,f.$Gl),Z(9,$.$7i)],c);function m(P){if(P instanceof i.$_lb)switch(P.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function v(P,R,I,N){N.publicLog2("sync/error",{code:P.code,serverCode:P instanceof i.$amb?String(P.serverCode):void 0,url:P instanceof i.$amb?P.url:void 0,resource:P.resource,executionId:R,service:I.userDataSyncStore.url.toString()})}}),define(le[269],he([0,1,3,2,9,20,25]),function(ne,e,k,a,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;function A(h,p){return{...h,profile:(0,O.$Hl)(h.profile,p.profilesHome.scheme)}}function L(h){return{created:h.created,uri:T.URI.revive(h.uri)}}class y{constructor(p,l,g){this.c=p,this.d=l,this.f=g,this.a=new Map,this.b=new k.$he}listen(p,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(p,l,g){try{return await this.g(p,l,g)}catch(d){throw this.f.error(d),d}}async g(p,l,g){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(T.URI.revive(g[0]));case"accept":return this.c.accept(A(g[0],this.d),T.URI.revive(g[1]),g[2],g[3]);case"replace":return this.c.replace(L(g[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(T.URI.revive(g[0]));case"extractActivityData":return this.c.extractActivityData(T.URI.revive(g[0]),T.URI.revive(g[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const d=l.substring(11),f=g[0],w=this.h(f);switch(g=g.slice(1),d){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h(p){const l=this.a.get(this.j(p));if(!l)throw new Error(`Manual sync taks not found: ${p}`);return l}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.$Dfc=y;let S=class extends a.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,l){super(),this.n=l,this.b=C.SyncStatus.Uninitialized,this.c=this.B(new k.$he),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.$he),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new k.$he),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new k.$he),this.onSyncErrors=this.m.event,this.a={call(g,d,f){return p.call(g,d,f).then(null,w=>{throw C.$_lb.toUserDataSyncError(w)})},listen(g,d){return p.listen(g,d)}},this.a.call("_getInitialData").then(([g,d,f])=>{this.s(g),this.t(d),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.t(g))),this.B(this.a.listen("onSyncErrors")(g=>this.m.fire(g.map(d=>({...d,error:C.$_lb.toUserDataSyncError(d.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),l=this;return new $(p,{async call(d,f,w){return l.a.call(`manualSync/${d}`,[p,...Array.isArray(f)?f:[f]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,l,g,d){return this.a.call("accept",[p,l,g,d])}resolveContent(p){return this.a.call("resolveContent",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}saveRemoteActivityData(p){return this.a.call("getRemoteActivityData",[p])}extractActivityData(p,l){return this.a.call("extractActivityData",[p,l])}async s(p){this.b=p,this.c.fire(p)}async t(p){this.f=p.map(l=>({syncResource:l.syncResource,profile:(0,O.$Hl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(g=>({...g,baseResource:T.URI.revive(g.baseResource),localResource:T.URI.revive(g.localResource),remoteResource:T.URI.revive(g.remoteResource),previewResource:T.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}u(p){this.h!==p&&(this.h=p,this.j.fire(p))}};e.$Efc=S,e.$Efc=S=ve([Z(1,O.$Gl)],S);class $ extends a.$Uc{constructor(p,l){super(),this.id=p,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[127],he([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,60,50,17,25]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tMb=e.$sMb=e.$rMb=e.$qMb=e.$pMb=void 0;const b="configurationSync.store",t="sync.previous.store",s="sync.donot-make-requests-until",o="sync.user-session-id",i="sync.machine-session-id",n=100,r=1e3*60*5;let c=class extends C.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(u.$cmb,E.StorageScope.APPLICATION)}set c(N){this.h.store(u.$cmb,N,E.StorageScope.APPLICATION,L.$o?E.StorageTarget.USER:E.StorageTarget.MACHINE)}constructor(N,U,j){super(),this.f=N,this.g=U,this.h=j,this.a=this.B(new O.$he),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new C.$Tc);this.B(O.Event.filter(j.onDidChangeValue(E.StorageScope.APPLICATION,u.$cmb,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[b]),this.a.fire()}m(N){if(N&&(N=L.$o&&N.web?{...N,...N.web}:N,(0,S.$ag)(N.url)&&(0,S.$cg)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(U=>Array.isArray(N.authenticationProviders[U].scopes)))){const U=N,j=!!U.canSwitch,F=U.url===U.insidersUrl?"insiders":"stable",X=(j?this.c:void 0)||F,K=X==="insiders"?U.insidersUrl:X==="stable"?U.stableUrl:U.url;return{url:$.URI.parse(K),type:X,defaultType:F,defaultUrl:$.URI.parse(U.url),stableUrl:$.URI.parse(U.stableUrl),insidersUrl:$.URI.parse(U.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(U.authenticationProviders).reduce((Q,V)=>(Q.push({id:V,scopes:U.authenticationProviders[V].scopes}),Q),[])}}}};e.$pMb=c,e.$pMb=c=ve([Z(0,d.$nk),Z(1,p.$7i),Z(2,E.$9p)],c);let m=class extends c{constructor(N,U,j){super(N,U,j);const F=this.h.get(t,E.StorageScope.APPLICATION);F&&(this.n=JSON.parse(F));const X=this.f[b];X?this.h.store(t,JSON.stringify(X),E.StorageScope.APPLICATION,E.StorageTarget.MACHINE):this.h.remove(t,E.StorageScope.APPLICATION)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$qMb=m,e.$qMb=m=ve([Z(0,d.$nk),Z(1,p.$7i),Z(2,E.$9p)],m);let v=class extends C.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(N,U,j,F,X,K,Q){super(),this.n=j,this.r=F,this.s=Q,this.g=this.B(new O.$he),this.onTokenFailed=this.g.event,this.h=this.B(new O.$he),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new O.$he),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,w.$cq)(X,K,Q).then(V=>{const ie={"X-Client-Name":`${U.applicationName}${L.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new R(n,r,this.n,this.r),this.u(),this.B((0,C.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,U){this.b={token:N,type:U}}t(N){this.a=N?(0,y.$bh)(N,"v1"):void 0}u(){const N=this.s.getNumber(s,E.StorageScope.APPLICATION);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(s,this.j.getTime(),E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),this.w=(0,k.$nh)(U=>(0,k.$Bh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(s,E.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$bh)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const j=await this.D(U,{type:"GET",headers:N},[],a.CancellationToken.None);return(await(0,f.$2p)(j))?.map(({id:F})=>F)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$bh)(this.a,"collection").toString();N={...N},N["Content-Type"]=A.$Ys.text;const j=await this.D(U,{type:"POST",headers:N},[],a.CancellationToken.None),F=await(0,f.$1p)(j);if(!F)throw new u.$amb("Server did not return the collection id",U,u.UserDataSyncErrorCode.NoCollection,j.res.statusCode,j.res.headers[u.$9lb]);return F}async deleteCollection(N,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=N?(0,y.$bh)(this.a,"collection",N).toString():(0,y.$bh)(this.a,"collection").toString();U={...U},await this.D(j,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(N,U){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.z(this.a,U,N),F={},X=await this.D(j.toString(),{type:"GET",headers:F},[],a.CancellationToken.None);return(await(0,f.$2p)(X)||[]).map(({url:Q,created:V})=>({ref:(0,y.$dh)(j,j.with({path:Q})),created:V*1e3}))}async resolveResourceContent(N,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,y.$bh)(this.z(this.a,j,N),U).toString();F={...F},F["Cache-Control"]="no-cache";const K=await this.D(X,{type:"GET",headers:F},[],a.CancellationToken.None);return await(0,f.$1p)(K)}async deleteResource(N,U,j){if(!this.a)throw new Error("No settings sync store url configured.");const F=U!==null?(0,y.$bh)(this.z(this.a,j,N),U).toString():this.z(this.a,j,N).toString(),X={};await this.D(F,{type:"DELETE",headers:X},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,y.$bh)(this.a,"resource").toString(),U={"Content-Type":A.$Ys.text};await this.D(N,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(N,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,y.$bh)(this.z(this.a,j,N),"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const K=await this.D(X,{type:"GET",headers:F},[304],a.CancellationToken.None);let Q=null;if(K.res.statusCode===304&&(Q=U),Q===null){const V=K.res.headers.etag;if(!V)throw new u.$amb("Server did not return the ref",X,u.UserDataSyncErrorCode.NoRef,K.res.statusCode,K.res.headers[u.$9lb]);const ie=await(0,f.$1p)(K);if(!ie&&K.res.statusCode===304)throw new u.$amb("Empty response",X,u.UserDataSyncErrorCode.EmptyResponse,K.res.statusCode,K.res.headers[u.$9lb]);Q={ref:V,content:ie}}return Q}async writeResource(N,U,j,F,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,F,N).toString();X={...X},X["Content-Type"]=A.$Ys.text,j&&(X["If-Match"]=j);const Q=await this.D(K,{type:"POST",data:U,headers:X},[],a.CancellationToken.None),V=Q.res.headers.etag;if(!V)throw new u.$amb("Server did not return the ref",K,u.UserDataSyncErrorCode.NoRef,Q.res.statusCode,Q.res.headers[u.$9lb]);return V}async manifest(N,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,y.$bh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",N&&(U["If-None-Match"]=N.ref);const F=await this.D(j,{type:"GET",headers:U},[304],a.CancellationToken.None);let X=null;if(F.res.statusCode===304&&(X=N),!X){const Q=F.res.headers.etag;if(!Q)throw new u.$amb("Server did not return the ref",j,u.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[u.$9lb]);const V=await(0,f.$1p)(F);if(!V&&F.res.statusCode===304)throw new u.$amb("Empty response",j,u.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[u.$9lb]);V&&(X={...JSON.parse(V),ref:Q})}const K=this.s.get(o,E.StorageScope.APPLICATION);return K&&X&&K!==X.session&&this.C(),X===null&&K&&this.C(),X&&this.s.store(o,X.session,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,y.$bh)(this.a,"download").toString(),U={},j=await this.D(N,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,f.$Xp)(j))throw new u.$amb("Server returned "+j.res.statusCode,N,u.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[u.$9lb]);if((0,f.$Yp)(j))throw new u.$amb("Empty response",N,u.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[u.$9lb]);return j.stream}z(N,U,j){return U?(0,y.$bh)(N,"collection",U,"resource",j):(0,y.$bh)(N,"resource",j)}C(){this.s.remove(o,E.StorageScope.APPLICATION),this.s.remove(i,E.StorageScope.APPLICATION)}async D(N,U,j,F){if(!this.b)throw new u.$amb("No Auth Token Available",N,u.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new u.$amb(`${U.type} request '${N}' failed because of too many requests (429).`,N,u.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const X=await this.c;U.headers={...U.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:N,type:U.type,headers:{...U.headers,authorization:void 0}});let K;try{K=await this.f.request(N,U,F)}catch(W){if(!(W instanceof u.$amb)){let ee=u.UserDataSyncErrorCode.RequestFailed;const re=(0,T.$0)(W).toLowerCase();re.includes("xhr timeout")?ee=u.UserDataSyncErrorCode.RequestTimeout:re.includes("protocol")&&re.includes("not supported")?ee=u.UserDataSyncErrorCode.RequestProtocolNotSupported:re.includes("request path contains unescaped characters")?ee=u.UserDataSyncErrorCode.RequestPathNotEscaped:re.includes("headers must be an object")?ee=u.UserDataSyncErrorCode.RequestHeadersNotObject:(0,T.$4)(W)&&(ee=u.UserDataSyncErrorCode.RequestCanceled),W=new u.$amb(`Connection refused for the request '${N}'.`,N,ee,void 0,void 0)}throw this.r.info("Request failed",N),W}const Q=K.res.headers[u.$9lb],V={url:N,status:K.res.statusCode,"execution-id":U.headers[u.$0lb],"operation-id":Q},ie=(0,f.$Xp)(K)||K.res.statusCode&&j.includes(K.res.statusCode);let H="";if(ie?this.r.trace("Request succeeded",V):(H=await(0,f.$Zp)(K)||"",this.r.info("Request failed",V,H)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire(u.UserDataSyncErrorCode.Unauthorized),new u.$amb(`${U.type} request '${N}' failed because of Unauthorized (401).`,N,u.UserDataSyncErrorCode.Unauthorized,K.res.statusCode,Q);if(K.res.statusCode===403)throw this.g.fire(u.UserDataSyncErrorCode.Forbidden),new u.$amb(`${U.type} request '${N}' failed because the access is forbidden (403).`,N,u.UserDataSyncErrorCode.Forbidden,K.res.statusCode,Q)}if(this.h.fire(),K.res.statusCode===404)throw new u.$amb(`${U.type} request '${N}' failed because the requested resource is not found (404).`,N,u.UserDataSyncErrorCode.NotFound,K.res.statusCode,Q);if(K.res.statusCode===405)throw new u.$amb(`${U.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,u.UserDataSyncErrorCode.MethodNotFound,K.res.statusCode,Q);if(K.res.statusCode===409)throw new u.$amb(`${U.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,u.UserDataSyncErrorCode.Conflict,K.res.statusCode,Q);if(K.res.statusCode===410)throw new u.$amb(`${U.type} request '${N}' failed because the requested resource is not longer available (410).`,N,u.UserDataSyncErrorCode.Gone,K.res.statusCode,Q);if(K.res.statusCode===412)throw new u.$amb(`${U.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,u.UserDataSyncErrorCode.PreconditionFailed,K.res.statusCode,Q);if(K.res.statusCode===413)throw new u.$amb(`${U.type} request '${N}' failed because of too large payload (413).`,N,u.UserDataSyncErrorCode.TooLarge,K.res.statusCode,Q);if(K.res.statusCode===426)throw new u.$amb(`${U.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,u.UserDataSyncErrorCode.UpgradeRequired,K.res.statusCode,Q);if(K.res.statusCode===429){const W=K.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new u.$amb(`${U.type} request '${N}' failed because of too many requests (429).`,N,u.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,K.res.statusCode,Q)):new u.$amb(`${U.type} request '${N}' failed because of too many requests (429).`,N,u.UserDataSyncErrorCode.TooManyRequests,K.res.statusCode,Q)}if(!ie)throw new u.$amb("Server returned "+K.res.statusCode,N,u.UserDataSyncErrorCode.Unknown,K.res.statusCode,Q);return K}F(N){let U=this.s.get(i,E.StorageScope.APPLICATION);U===void 0&&(U=(0,h.$Wg)(),this.s.store(i,U,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)),N["X-Machine-Session-Id"]=U;const j=this.s.get(o,E.StorageScope.APPLICATION);j!==void 0&&(N["X-User-Session-Id"]=j)}};e.$rMb=v,e.$rMb=v=ve([Z(1,d.$nk),Z(2,f.$Vp),Z(3,u.$jmb),Z(4,l.$Hi),Z(5,g.$7k),Z(6,E.$9p)],v);let P=class extends v{constructor(N,U,j,F,X,K,Q){super(N.userDataSyncStore?.url,U,j,F,X,K,Q),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$sMb=P,e.$sMb=P=ve([Z(0,u.$6lb),Z(1,d.$nk),Z(2,f.$Vp),Z(3,u.$jmb),Z(4,l.$Hi),Z(5,g.$7k),Z(6,E.$9p)],P);class R{constructor(N,U,j,F){this.c=N,this.d=U,this.f=j,this.g=F,this.a=[],this.b=void 0}request(N,U,j){if(this.h()&&this.i(),U.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new u.$amb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,u.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(U,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$tMb=R}),define(le[270],he([0,1,3,2,9,22,24,17,127]),function(ne,e,k,a,T,O,C,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=e.$Afc=e.$zfc=void 0;class y{constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(l,g,d){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$zfc=y;class S extends a.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new k.$he),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(g=>{this.a=g,this.B(this.c.listen("onDidChangeAccount")(d=>{this.a=d,this.b.fire(d)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Afc=S;class ${constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(l,g,d){switch(g){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Bfc=$;let h=class extends L.$pMb{constructor(l,g,d,f){super(g,d,f),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:T.URI.revive(l.url),type:l.type,defaultUrl:T.URI.revive(l.defaultUrl),insidersUrl:T.URI.revive(l.insidersUrl),stableUrl:T.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Cfc=h,e.$Cfc=h=ve([Z(1,C.$nk),Z(2,O.$7i),Z(3,A.$9p)],h)}),define(le[271],he([0,1,3,58,24,17,18,266,25,83,87]),function(ne,e,k,a,T,O,C,A,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;let $=class extends A.$jcc{constructor(p,l,g,d,f,w,E,u,b,t,s){super(p,l,g,d,f,E,u,b,t,s),this.B(k.Event.debounce(k.Event.any(k.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),k.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(o,i)=>o?[...o,i]:[i],1e3)(o=>this.triggerSync(o,!0,!1)))}};e.$Yfc=$,e.$Yfc=$=ve([Z(0,T.$nk),Z(1,L.$6lb),Z(2,L.$7lb),Z(3,L.$emb),Z(4,L.$fmb),Z(5,a.$Vdc),Z(6,L.$jmb),Z(7,y.$RKb),Z(8,C.$6l),Z(9,S.$Tlb),Z(10,O.$9p)],$)}),define(le[272],he([0,1,76,23,5,21]),function(ne,e,k,a,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0,e.$kdc=C,e.$ldc=A,e.$mdc=L,e.$jdc=128/4;function C(y){function S(){let $=y.scheme===a.Schemas.file?(0,O.$2g)(y):y.toString();return T.$k||($=$.toLowerCase()),(0,k.createHash)("md5").update($).digest("hex")}return{id:S(),configPath:y}}function A(y,S){function $(){if(y.scheme!==a.Schemas.file)return(0,k.createHash)("md5").update(y.toString()).digest("hex");if(!S)return;let p;return T.$k?p=S.ino:T.$j?p=S.birthtime.getTime():T.$i&&(typeof S.birthtimeMs=="number"?p=Math.floor(S.birthtimeMs):p=S.birthtime.getTime()),(0,k.createHash)("md5").update(y.fsPath).update(p?String(p):"").digest("hex")}const h=$();if(typeof h=="string")return{id:h,uri:y}}function L(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[273],he([0,1,6,8,2,14,31,16,10,80,116,272,58,57,23]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;let g=class extends T.$Uc{constructor(f,w,E,u){super(),this.a=f,this.b=w,this.c=E,this.f=u,this.B(new k.$Mh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await C.Promises.readdir(f),E=new y.$qLb(this.f.getChannel("storage"));await Promise.all(w.map(async u=>{const b=(0,O.$jc)(f,u);u.length===$.$jdc||u===S.$Mi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(o=>o.workspace?.id===u)||await E.isUsed(b)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await C.Promises.rm(b))}))}catch(f){(0,a.$1)(f)}}};e.$vfc=g,e.$vfc=g=ve([Z(0,A.$Ii),Z(1,L.$7j),Z(2,h.$Vdc),Z(3,p.$afc)],g)}),define(le[128],he([0,1,76,66,38,282,15,8,3,2,14,5,32,44,70]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=o,e.$ti=i,e.$vi=c,e.$wi=m;class g{traceSocketEvent(P,R){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,R)}constructor(P,R=""){this.f=!0,this.debugLabel=R,this.socket=P,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,A.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(P){const R=I=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,I),P(C.$Je.wrap(I))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(P){const R=I=>{P({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:I,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(P){const R=()=>{P()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(P){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,P),this.socket.write(P.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,A.$1)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,A.$1)(R)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((P,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),P();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),P()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$pi=g;var d;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var f;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(f||(f={}));class w extends y.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(P,R){this.socket.traceSocketEvent(P,R)}constructor(P,R,I,N){super(),this.f=this.B(new L.$he),this.g=this.B(new L.$he),this.h=!1,this.j={state:f.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:I?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new E(this,R,I,N,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,A.$1)(U),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new l.$ki,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await L.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this.f.event(P)}onClose(P){return this.g.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let R=0;for(;R<P.byteLength;)this.a.writeMessage(P.slice(R,Math.min(R+d.MaxWebSocketMessageLength,P.byteLength)),{compressed:!0,opcode:2}),R+=d.MaxWebSocketMessageLength}m(P,{compressed:R,opcode:I}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,P);let N=d.MinHeaderByteSize;P.byteLength<126?N+=0:P.byteLength<2**16?N+=2:N+=8;const U=C.$Je.alloc(N),j=R?64:0,F=I&15;if(U.writeUInt8(128|j|F,0),P.byteLength<126)U.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){U.writeUInt8(126,1);let X=1;U.writeUInt8(P.byteLength>>>8&255,++X),U.writeUInt8(P.byteLength>>>0&255,++X)}else{U.writeUInt8(127,1);let X=1;U.writeUInt8(0,++X),U.writeUInt8(0,++X),U.writeUInt8(0,++X),U.writeUInt8(0,++X),U.writeUInt8(P.byteLength>>>24&255,++X),U.writeUInt8(P.byteLength>>>16&255,++X),U.writeUInt8(P.byteLength>>>8&255,++X),U.writeUInt8(P.byteLength>>>0&255,++X)}this.socket.write(C.$Je.concat([U,P]))}end(){this.h=!0,this.socket.end()}n(P){if(P.byteLength!==0){for(this.b.acceptChunk(P);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const R=this.b.peek(this.j.readLen),I=R.readUInt8(0),N=(I&128)>>>7,U=(I&64)>>>6,j=I&15,F=R.readUInt8(1),X=(F&128)>>>7,K=F&127;this.j.state=f.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(X?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const R=this.b.read(this.j.readLen),I=R.readUInt8(1),N=(I&128)>>>7;let U=I&127,j=1;U===126?U=R.readUInt8(++j)*2**8+R.readUInt8(++j):U===127&&(U=R.readUInt8(++j)*0+R.readUInt8(++j)*0+R.readUInt8(++j)*0+R.readUInt8(++j)*0+R.readUInt8(++j)*2**24+R.readUInt8(++j)*2**16+R.readUInt8(++j)*2**8+R.readUInt8(++j));let F=0;N&&(F=R.readUInt8(++j)*2**24+R.readUInt8(++j)*2**16+R.readUInt8(++j)*2**8+R.readUInt8(++j)),this.j.state=f.ReadBody,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const R=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,R),t(R,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,R),this.j.state=f.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await L.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=w;class E extends y.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$Je.alloc(0)}constructor(P,R,I,N,U,j){super(),this.n=P,this.r=U,this.s=j,this.a=this.B(new L.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new L.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new L.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new u(this.n,N,I,{windowBits:15})),this.f=this.B(new b(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(P,R){this.g.push({data:P,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:P,options:R}=this.g.shift();if(this.f&&R.compressed){const I=await this.w(this.f,P);this.s(I,R)}else this.s(P,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(P,R){return new Promise((I,N)=>{P.write(R),P.flush(U=>I(U))})}acceptFrame(P,R,I){this.h.push({data:P,isCompressed:R,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const P=this.h.shift();if(this.b&&P.isCompressed){const R=await this.C(this.b,P.data,P.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(P.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(P,R,I){return new Promise((N,U)=>{P.write(R),I&&P.write(C.$Je.fromByteArray([0,0,255,255])),P.flush(j=>N(j))})}}class u extends y.$Uc{get recordedInflateBytes(){return this.j?C.$Je.concat(this.f):C.$Je.alloc(0)}constructor(P,R,I,N){super(),this.h=P,this.j=R,this.a=this.B(new L.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(C.$Je.wrap(U))}),I&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(P){this.j&&this.f.push(P.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,P),this.b.write(P.buffer)}flush(P){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const R=C.$Je.concat(this.g);this.g.length=0,P(R)})}}class b extends y.$Uc{constructor(P,R){super(),this.g=P,this.a=this.B(new L.$he),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,I),this.f.push(C.$Je.wrap(I))})}write(P){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,P.buffer),this.b.write(P.buffer)}flush(P){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let R=C.$Je.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),P(R)})}}function t(v,P){if(P===0)return;const R=v.byteLength>>>2;for(let X=0;X<R;X++){const K=v.readUInt32BE(X*4);v.writeUInt32BE(K^P,X*4)}const I=R*4,N=v.byteLength-I,U=P>>>24&255,j=P>>>16&255,F=P>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(I)^U,I),N>=2&&v.writeUInt8(v.readUInt8(I+1)^j,I+1),N>=3&&v.writeUInt8(v.readUInt8(I+2)^F,I+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const s={[$.Platform.Linux]:107,[$.Platform.Mac]:103};function o(){const v=(0,h.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const P=process.platform!=="darwin"&&e.$ri?e.$ri:(0,T.tmpdir)(),R=(0,S.$jc)(P,`vscode-ipc-${v}.sock`);return n(R),R}function i(v,P,R){const N=(0,k.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${R}-${P}-sock`;const U=R.substr(0,4),j=P.substr(0,6);let F;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?F=(0,S.$jc)(e.$ri,`vscode-${N}-${U}-${j}.sock`):F=(0,S.$jc)(v,`${U}-${j}.sock`),n(F),F}function n(v){const P=s[$.$u];typeof P=="number"&&v.length>=P&&console.warn(`WARNING: IPC handle "${v}" is longer than ${P} chars, try a shorter --user-data-dir`)}class r extends p.$ei{static b(P){const R=L.Event.fromNodeEventEmitter(P,"connection");return L.Event.map(R,I=>({protocol:new l.$li(new g(I,"ipc-server-connection")),onDidClientDisconnect:L.Event.once(L.Event.fromNodeEventEmitter(I,"close"))}))}constructor(P){super(r.b(P)),this.d=P}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=r;function c(v){return new Promise((P,R)=>{const I=(0,a.createServer)();I.on("error",R),I.listen(v,()=>{I.removeListener("error",R),P(new r(I))})})}function m(v,P){return new Promise((R,I)=>{const N=(0,a.createConnection)(v,()=>{N.removeListener("error",I),R(l.$mi.fromSocket(new g(N,`ipc-client${P}`),P))});N.once("error",I)})}}),define(le[274],he([0,1,66,128,221]),function(ne,e,k,a,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0,e.$2fc=new class{supports(O){return!0}connect({host:O,port:C},A,L,y){return new Promise((S,$)=>{const h=k.createConnection({host:O,port:C},()=>{h.removeListener("error",$),h.write((0,T.$Avb)(A,L,y));const p=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(h.off("data",p),S(new a.$pi(h,y)))};h.on("data",p)});h.setNoDelay(!0),h.once("error",$)})}}}),define(le[275],he([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=e.$4ec=void 0;async function f(t,s,o,i,n){let r;for(let c=3;c&&(r?.dispose(),r=await new w(t,s,o,i,n).waitForReady(),!(n&&T.$Zg[n]||!T.$Zg[r.tunnelLocalPort]));c--);return r}class w extends A.$Uc{constructor(s,o,i,n,r){super(),this.m=o,this.n=r,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=k.createServer(),this.c=new C.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=c=>this.r(c),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,o=(0,g.$zw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,T.$1g)(s,2,1e3,o),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(s){s.pause();const o=(0,g.$xw)(this.tunnelRemoteHost)||(0,g.$zw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,h.$Wl)(this.a,o,this.tunnelRemotePort),n=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&s.write(r.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),n.end()}),s.on("close",()=>n.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),n instanceof O.$pi?n.socket.destroy():n.end()}),n instanceof O.$pi?this.t(s,n):this.s(s,n),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),n.end()})}s(s,o){o.onClose(()=>s.destroy()),o.onEnd(()=>s.end()),o.onData(i=>s.write(i.buffer)),s.on("data",i=>o.write(d.$Je.wrap(i))),s.resume()}t(s,o){const i=o.socket;i.on("end",()=>s.end()),i.on("close",()=>s.end()),i.on("error",()=>{s.destroy()}),i.pipe(s),s.pipe(i)}}e.$4ec=w;let E=class extends g.$Cw{constructor(s,o,i,n,r){super(o,r),this.v=s,this.w=i,this.y=n}isPortPrivileged(s){return(0,g.$Aw)(s,this.m,L.OS,a.release())}t(s,o,i,n,r,c,m,v){const P=this.s(o,i);if(P)return++P.refcount,P.value;if((0,g.$tw)(s))return this.u(s,o,i,r,c,m,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${i} on local port ${r}.`);const R={commit:this.y.commit,quality:this.y.quality,addressProvider:s,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},I=f(R,n,o,i,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(o,i,I),I}}};e.$5ec=E,e.$5ec=E=ve([Z(0,p.$Ql),Z(1,S.$7j),Z(2,l.$Tl),Z(3,$.$nk),Z(4,y.$7i)],E);let u=class extends E{constructor(s,o,i,n,r){super(s,o,i,n,r)}};e.$6ec=u,e.$6ec=u=ve([Z(0,p.$Ql),Z(1,S.$7j),Z(2,l.$Tl),Z(3,$.$nk),Z(4,y.$7i)],u);let b=class extends A.$Uc{constructor(s,o,i,n,r){super(),this.b=s,this.c=o,this.f=i,this.g=n,this.h=r,this.a=new Map}async openTunnel(s,o,i,n,r,c,m,v,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${c}.`),!this.a.has(s)){const R=new u(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(s,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(o,i,n,r,c,m,v,P)}};e.$7ec=b,e.$7ec=b=ve([Z(0,p.$Ql),Z(1,S.$7j),Z(2,$.$nk),Z(3,l.$Tl),Z(4,y.$7i)],b)}),define(le[283],he([0,1,38,40,8,2,23,9,19,3,44,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,60,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,61,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,59,262,237,250,108,267,255,11,212,102,260,253,228,195,58,213,271,257,57,261,107,105,274,193,229,153,146,151]),function(ne,e,k,a,T,O,C,A,L,y,S,$,h,p,l,g,d,f,w,E,u,b,t,s,o,i,n,r,c,m,v,P,R,I,N,U,j,F,X,K,Q,V,ie,H,W,ee,re,ce,q,x,J,G,D,B,M,z,te,_,Y,ae,ue,ge,we,Ee,pe,be,Se,Ie,oe,de,me,Pe,ke,Ue,Ce,Ae,De,Me,He,Fe,qe,Be,ze,Le,se,fe,$e,ye,Oe,Te,je,Ze,Ke,Xe,We,xe,Qe,tt,rt,Pt,kt,Ot,At,Lt,Tt,Ct,wt,Nt,bt,Dt,Ut,Ft,ct,jt,Mt,yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=vt;class qt extends O.$Uc{constructor(Re){super(),this.f=Re,this.a=this.B(new $.$FW(this)),this.b=void 0,this.c=this.B(new y.$he),this.g()}g(){let Re=!1;const Ne=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,$.$GW)(process.parentPort,ct.$eec.exit,Ne)}async init(){const Re=await this.h();(0,_.$1lb)(),Re.invokeFunction(Ne=>{const Ge=Ne.get(ie.$7j),Ve=Ne.get(x.$6l),_e=Ne.get(fe.$Gl);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ne),this.m(Ge),this.n(Ve,_e),this.B(_e.onDidChangeProfiles(()=>this.n(Ve,_e))),this.r(Ve,Ge)}),this.B((0,O.$Rc)(Re.createInstance(h.$rfc,this.f.codeCachePath),Re.createInstance(p.$sfc),Re.createInstance(d.$vfc),Re.createInstance(g.$ufc),Re.createInstance(l.$tfc),Re.createInstance(We.$Sfc),Re.createInstance(Ze.$Kfc)))}async h(){const Re=new K.$yi,Ne={_serviceBrand:void 0,...W.default};Re.set(ee.$nk,Ne);const Ge=new S.$ii(Ye=>Ye==="main"),Ve=new wt.$bfc(this.a,Ge);Re.set(wt.$afc,Ve);const _e=this.f.policiesData?new ye.$Hec(this.f.policiesData,Ve.getChannel("policy")):new Oe.$no;Re.set(Oe.$lo,_e);const Je=new Ft.$bn(this.f.args,Ne);Re.set(i.$Ii,Je);const st=new H.$hs(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ye=>({...Ye,resource:A.URI.revive(Ye.resource)})),Ve.getChannel("logger"));Re.set(ie.$8j,st);const ht=this.B(st.createLogger("sharedprocess",{name:(0,xe.localize)(0,null)})),gt=this.B(new ie.$ck(ht.getLevel())),et=this.B(new Qe.$lQ(ht,[gt]));Re.set(ie.$7j,et),this.b=this.B(new tt.$Ufc(et)),Re.set(tt.$Tfc,this.b);const it=this.B(new N.$Qq(et));Re.set(I.$7k,it);const mt=this.B(new U.$hr(et));it.registerProvider(C.Schemas.file,mt);const ut=new Me.$Is(it);Re.set(De.$El,ut);const nt=this.B(new Te.$sQ(this.f.profiles.all,A.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Re.set(fe.$Gl,nt);const $t=this.B(new Fe.$_ec(C.Schemas.file,this.B(new qe.$7P(Ve.getChannel(qe.$6P),{pathCaseSensitive:He.$k})),C.Schemas.vscodeUserData,nt,ut,et));it.registerProvider(C.Schemas.vscodeUserData,$t);const ot=this.B(new u.$No(nt.defaultProfile.settingsResource,it,_e,et));Re.set(E.$7i,ot);const pt=new Nt.$1fc(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Ve,Je);Re.set(ce.$9p,pt),this.B((0,O.$Sc)(()=>pt.flush())),await Promise.all([ot.initialize(),pt.initialize()]);const Et=new kt.$4r(Ve.getChannel("request"));Re.set(re.$Vp,Et),Re.set(f.$wfc,new j.$xi(w.$xfc,void 0,!1)),Re.set(ze.$zG,new j.$xi(Be.$Jfc,void 0,!1));const St=new Lt.$dfc(-1,Ve);Re.set(At.$Vdc,St),Re.set(s.$Ro,new j.$xi(o.$AQ,void 0,!0));const zt=this.B(new de.$Eec(St)),Wt=new S.$ii(Ye=>zt.getActiveClientId().then(dt=>Ye===dt));Re.set(R.$44b,new Ot.$Wfc(this.a.getChannel("extensionRecommendationNotification",Wt)));let ft;const at=[],It=(0,B.$zp)(Ne,ot);if((0,B.$up)(Ne,Je)){const Ye=new G.$Abc(et,st,Je,Ne);if(at.push(Ye),!(0,B.$vp)(Ne,Je)&&Ne.aiConfig?.ariaKey){const dt=new je.$_P(Et,It,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,O.$Sc)(()=>dt.flush())),at.push(dt)}ft=new D.$8r({appenders:at,commonProperties:(0,q.$lp)((0,k.release)(),(0,k.hostname)(),process.arch,Ne.commit,Ne.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,It),sendErrorTelemetry:!0,piiPaths:(0,B.$Ap)(Je)},ot,Ne)}else{ft=B.$pp;const Ye=B.$tp;at.push(Ye)}this.a.registerChannel("telemetryAppender",new J.$jec(at)),Re.set(x.$6l,ft);const Ht=new M.$yfc(ot,ft,et,st,Je,Ne);Re.set(x.$7l,Ht),Re.set($e.$xq,new j.$xi(Pt.$kQ,void 0,!0)),Re.set(Le.$Bq,new j.$xi(se.$Iec,void 0,!0)),Re.set(m.$hq,new j.$xi(m.$jq,void 0,!0)),Re.set(P.$Mq,new j.$xi(P.$Nq,void 0,!0)),Re.set(c.$bp,new j.$xi(r.$fq,void 0,!0)),Re.set(c.$ip,new j.$xi(Ct.$Zfc,void 0,!1)),Re.set(Q.$Zr,new j.$xi(V.$2r,void 0,!1)),Re.set(b.$in,new j.$xi(t.$Ps,void 0,!1)),Re.set(Y.$RKb,new j.$xi(Y.$SKb,void 0,!0)),Re.set(_.$jmb,new j.$xi(ge.$lNb,void 0,!0)),Re.set(_.$imb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),Re.set(c.$hp,new j.$xi(n.$PKb,void 0,!1)),Re.set(te.$jNb,new j.$xi(te.$kNb,void 0,!0)),Re.set(z.$dw,new j.$xi(z.$ew)),Re.set(_.$6lb,new j.$xi(Se.$qMb,void 0,!0)),Re.set(_.$7lb,new j.$xi(Se.$sMb,void 0,!0)),Re.set(we.$Tlb,new j.$xi(we.$Vlb,void 0,!0)),Re.set(_.$8lb,new j.$xi(ae.$dcc,void 0,!1)),Re.set(_.$emb,new j.$xi(Ee.$5bc,void 0,!0)),Re.set(_.$fmb,new j.$xi(pe.$icc,void 0,!1)),Re.set(Ie.$rLb,new j.$xi(oe.$Ffc,void 0,!0)),Re.set(_.$gmb,new j.$xi(Xe.$Ycc,void 0,!0)),Re.set(me.$Tl,new j.$xi(Pe.$9ec,void 0,!1));const Rt=new bt.$Rl;return Re.set(bt.$Ql,Rt),Rt.register(Dt.RemoteConnectionType.WebSocket,Ut.$2fc),Re.set(ke.$sw,new j.$xi(Ue.$7ec)),Re.set(Ce.$Gfc,new j.$xi(Ae.$Ifc)),Re.set(Ke.$Lfc,new j.$xi(rt.$Vfc)),new X.$kr(Re)}j(Re){const Ne=new v.$lq(Re.get(c.$ep),()=>null);this.a.registerChannel("extensions",Ne);const Ge=S.ProxyChannel.fromService(Re.get(Q.$Zr),this.q);this.a.registerChannel("languagePacks",Ge);const Ve=S.ProxyChannel.fromService(Re.get(b.$in),this.q);this.a.registerChannel("diagnostics",Ve);const _e=new v.$nq(Re.get(c.$ip));this.a.registerChannel("extensionTipsService",_e);const Je=S.ProxyChannel.fromService(Re.get(f.$wfc),this.q);this.a.registerChannel("checksum",Je);const st=S.ProxyChannel.fromService(Re.get(ze.$zG),this.q);this.a.registerChannel("v8InspectProfiling",st);const ht=S.ProxyChannel.fromService(Re.get(we.$Tlb),this.q);this.a.registerChannel("userDataSyncMachines",ht);const gt=S.ProxyChannel.fromService(Re.get(x.$7l),this.q);this.a.registerChannel("customEndpointTelemetry",gt);const et=new ue.$zfc(Re.get(Y.$RKb));this.a.registerChannel("userDataSyncAccount",et);const it=new ue.$Bfc(Re.get(_.$6lb));this.a.registerChannel("userDataSyncStoreManagement",it);const mt=new be.$Dfc(Re.get(_.$fmb),Re.get(fe.$Gl),Re.get(ie.$7j));this.a.registerChannel("userDataSync",mt);const ut=this.B(Re.get(F.$zi).createInstance(Tt.$Yfc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(ut,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Re.get(_.$gmb),this.q));const nt=S.ProxyChannel.fromService(Re.get(Ce.$Gfc),this.q);this.a.registerChannel(Ce.$Hfc,nt);const $t=S.ProxyChannel.fromService(Re.get(Ke.$Lfc),this.q);this.a.registerChannel("remoteTunnel",$t)}m(Re){process.on("uncaughtException",Ne=>(0,T.$1)(Ne)),process.on("unhandledRejection",Ne=>(0,T.$1)(Ne)),(0,T.setUnexpectedErrorHandler)(Ne=>{const Ge=(0,a.$lj)(Ne,!0);Ge&&Re.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}n(Re,Ne){Re.publicLog2("profilesInfo",{count:Ne.profiles.length})}async r(Re,Ne){if(He.$k){const[Ge,Ve]=await Promise.all([(0,jt.$Xg)(Ne.error.bind(Ne)),(0,yt.$nW)(Ne.error.bind(Ne))]),_e=(0,Mt.$6V)(),Je=(0,yt.$oW)(Ve,this.f.args["ozone-platform"]);Ge&&Re.publicLog2("clientPlatformInfo",{platformId:Ge.id,platformVersionId:Ge.version_id,platformIdLike:Ge.id_like,desktopEnvironment:_e,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(Re){if(Re.data!==ct.$gec.response)return!1;const Ne=(0,L.$Ob)(Re.ports);return Ne?(this.c.fire(Ne),!0):!1}}async function vt(lt){try{const Re=new qt(lt);process.parentPort.postMessage(ct.$eec.ipcReady),await Re.init(),process.parentPort.postMessage(ct.$eec.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Bt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",lt=>{clearTimeout(Bt),vt(lt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fc8762e773c35d4e52e8a7375704af2e24698e5d/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
