/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(de){for(var e=[],E=0,R=de.length;E<R;E++)e[E]=ke[de[E]];return e};define(ke[72],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=R,e.$6h=P,e.$7h=O;function E(A){return(T,$,c)=>{let C=null,w=null;if(typeof c.value=="function"?(C="value",w=c.value):typeof c.get=="function"&&(C="get",w=c.get),!w)throw new Error("not supported");c[C]=A(w,$)}}function R(A,T,$){let c=null,C=null;if(typeof $.value=="function"?(c="value",C=$.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(c="get",C=$.get),!C)throw new Error("not supported");const w=`$memoize$${T}`;$[c]=function(...l){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,l)}),this[w]}}function P(A,T,$){return E((c,C)=>{const w=`$debounce$${C}`,l=`$debounce$result$${C}`;return function(...S){this[l]||(this[l]=$?$():void 0),clearTimeout(this[w]),T&&(this[l]=T(this[l],...S),S=[this[l]]),this[w]=setTimeout(()=>{c.apply(this,S),this[l]=$?$():void 0},A)}})}function O(A,T,$){return E((c,C)=>{const w=`$throttle$timer$${C}`,l=`$throttle$result$${C}`,S=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...r){if(this[l]||(this[l]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[l]=T(this[l],...r)),this[d])return;const o=this[S]+A;o<=Date.now()?(this[S]=Date.now(),c.apply(this,[this[l]]),this[l]=$?$():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),c.apply(this,[this[l]]),this[l]=$?$():void 0},o-Date.now()))}})}}),define(ke[133],Ie([1,0,18]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=O,e.$9c=A,e.$0c=T,e.$$c=$,e.$_c=c;const R=(S,d)=>S===d;e.$6c=R;function P(S=e.$6c){return(d,r)=>E.$ub(d,r,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function A(){return(S,d)=>S.equals(d)}function T(S,d,r){return!S||!d?S===d:r(S,d)}function $(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let r=0;r<S.length;r++)if(!$(S[r],d[r]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=S,o=d,a=Object.keys(r),h=Object.keys(o),t=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!t.has(s)||!$(r[s],o[s]))return!1;return!0}return!1}function c(S){return JSON.stringify(l(S))}let C=0;const w=new WeakMap;function l(S){if(Array.isArray(S))return S.map(l);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=l(d[o]);return r}else{let d=w.get(S);return d===void 0&&(d=C++,w.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(ke[96],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$3O=E,e.$4O=new E("id#")}),define(ke[134],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=A,e.$On=w,e.$Pn=l,e.$Qn=S,e.$Rn=d,e.$Sn=r,e.$Tn=o,e.$Un=a,e.$Vn=h,e.$Wn=t,e.$Xn=s,e.$Yn=n;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(i,g=!1){let f=0;const u=i.length;let b="",I=0,D=R.Unknown,y=E.None;function p(q){let V=0,N=0;for(;V<q;){const L=i.charCodeAt(f);if(L>=C._0&&L<=C._9)N=N*16+L-C._0;else if(L>=C.A&&L<=C.F)N=N*16+L-C.A+10;else if(L>=C.a&&L<=C.f)N=N*16+L-C.a+10;else break;f++,V++}return V<q&&(N=-1),N}function k(q){f=q,b="",I=0,D=R.Unknown,y=E.None}function m(){const q=f;if(i.charCodeAt(f)===C._0)f++;else for(f++;f<i.length&&c(i.charCodeAt(f));)f++;if(f<i.length&&i.charCodeAt(f)===C.dot)if(f++,f<i.length&&c(i.charCodeAt(f)))for(f++;f<i.length&&c(i.charCodeAt(f));)f++;else return y=E.UnexpectedEndOfNumber,i.substring(q,f);let V=f;if(f<i.length&&(i.charCodeAt(f)===C.E||i.charCodeAt(f)===C.e))if(f++,(f<i.length&&i.charCodeAt(f)===C.plus||i.charCodeAt(f)===C.minus)&&f++,f<i.length&&c(i.charCodeAt(f))){for(f++;f<i.length&&c(i.charCodeAt(f));)f++;V=f}else y=E.UnexpectedEndOfNumber;return i.substring(q,V)}function v(){let q="",V=f;for(;;){if(f>=u){q+=i.substring(V,f),y=E.UnexpectedEndOfString;break}const N=i.charCodeAt(f);if(N===C.doubleQuote){q+=i.substring(V,f),f++;break}if(N===C.backslash){if(q+=i.substring(V,f),f++,f>=u){y=E.UnexpectedEndOfString;break}switch(i.charCodeAt(f++)){case C.doubleQuote:q+='"';break;case C.backslash:q+="\\";break;case C.slash:q+="/";break;case C.b:q+="\b";break;case C.f:q+="\f";break;case C.n:q+=`
`;break;case C.r:q+="\r";break;case C.t:q+="	";break;case C.u:{const Z=p(4);Z>=0?q+=String.fromCharCode(Z):y=E.InvalidUnicode;break}default:y=E.InvalidEscapeCharacter}V=f;continue}if(N>=0&&N<=31)if($(N)){q+=i.substring(V,f),y=E.UnexpectedEndOfString;break}else y=E.InvalidCharacter;f++}return q}function F(){if(b="",y=E.None,I=f,f>=u)return I=u,D=R.EOF;let q=i.charCodeAt(f);if(T(q)){do f++,b+=String.fromCharCode(q),q=i.charCodeAt(f);while(T(q));return D=R.Trivia}if($(q))return f++,b+=String.fromCharCode(q),q===C.carriageReturn&&i.charCodeAt(f)===C.lineFeed&&(f++,b+=`
`),D=R.LineBreakTrivia;switch(q){case C.openBrace:return f++,D=R.OpenBraceToken;case C.closeBrace:return f++,D=R.CloseBraceToken;case C.openBracket:return f++,D=R.OpenBracketToken;case C.closeBracket:return f++,D=R.CloseBracketToken;case C.colon:return f++,D=R.ColonToken;case C.comma:return f++,D=R.CommaToken;case C.doubleQuote:return f++,b=v(),D=R.StringLiteral;case C.slash:{const V=f-1;if(i.charCodeAt(f+1)===C.slash){for(f+=2;f<u&&!$(i.charCodeAt(f));)f++;return b=i.substring(V,f),D=R.LineCommentTrivia}if(i.charCodeAt(f+1)===C.asterisk){f+=2;const N=u-1;let L=!1;for(;f<N;){if(i.charCodeAt(f)===C.asterisk&&i.charCodeAt(f+1)===C.slash){f+=2,L=!0;break}f++}return L||(f++,y=E.UnexpectedEndOfComment),b=i.substring(V,f),D=R.BlockCommentTrivia}return b+=String.fromCharCode(q),f++,D=R.Unknown}case C.minus:if(b+=String.fromCharCode(q),f++,f===u||!c(i.charCodeAt(f)))return D=R.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return b+=m(),D=R.NumericLiteral;default:for(;f<u&&M(q);)f++,q=i.charCodeAt(f);if(I!==f){switch(b=i.substring(I,f),b){case"true":return D=R.TrueKeyword;case"false":return D=R.FalseKeyword;case"null":return D=R.NullKeyword}return D=R.Unknown}return b+=String.fromCharCode(q),f++,D=R.Unknown}}function M(q){if(T(q)||$(q))return!1;switch(q){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function G(){let q;do q=F();while(q>=R.LineCommentTrivia&&q<=R.Trivia);return q}return{setPosition:k,getPosition:()=>f,scan:g?G:F,getToken:()=>D,getTokenValue:()=>b,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>y}}function T(i){return i===C.space||i===C.tab||i===C.verticalTab||i===C.formFeed||i===C.nonBreakingSpace||i===C.ogham||i>=C.enQuad&&i<=C.zeroWidthSpace||i===C.narrowNoBreakSpace||i===C.mathematicalSpace||i===C.ideographicSpace||i===C.byteOrderMark}function $(i){return i===C.lineFeed||i===C.carriageReturn||i===C.lineSeparator||i===C.paragraphSeparator}function c(i){return i>=C._0&&i<=C._9}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function w(i,g){const f=[],u=new Object;let b;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function y(p,k,m,v){I.value=p,I.offset=k,I.length=m,I.type=v,I.colonOffset=void 0,b=I}try{t(i,{onObjectBegin:(p,k)=>{if(g<=p)throw u;b=void 0,D=g>p,f.push("")},onObjectProperty:(p,k,m)=>{if(g<k||(y(p,k,m,"property"),f[f.length-1]=p,g<=k+m))throw u},onObjectEnd:(p,k)=>{if(g<=p)throw u;b=void 0,f.pop()},onArrayBegin:(p,k)=>{if(g<=p)throw u;b=void 0,f.push(0)},onArrayEnd:(p,k)=>{if(g<=p)throw u;b=void 0,f.pop()},onLiteralValue:(p,k,m)=>{if(g<k||(y(p,k,m,n(p)),g<=k+m))throw u},onSeparator:(p,k,m)=>{if(g<=k)throw u;if(p===":"&&b&&b.type==="property")b.colonOffset=k,D=!1,b=void 0;else if(p===","){const v=f[f.length-1];typeof v=="number"?f[f.length-1]=v+1:(D=!0,f[f.length-1]=""),b=void 0}}})}catch(p){if(p!==u)throw p}return{path:f,previousNode:b,isAtPropertyKey:D,matches:p=>{let k=0;for(let m=0;k<p.length&&m<f.length;m++)if(p[k]===f[m]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}function l(i,g=[],f=O.DEFAULT){let u=null,b=[];const I=[];function D(p){Array.isArray(b)?b.push(p):u!==null&&(b[u]=p)}return t(i,{onObjectBegin:()=>{const p={};D(p),I.push(b),b=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{b=I.pop()},onArrayBegin:()=>{const p=[];D(p),I.push(b),b=p,u=null},onArrayEnd:()=>{b=I.pop()},onLiteralValue:D,onError:(p,k,m)=>{g.push({error:p,offset:k,length:m})}},f),b[0]}function S(i,g=[],f=O.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function I(p){return u.children.push(p),p}t(i,{onObjectBegin:p=>{u=I({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,k,m)=>{u=I({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:k,length:m,parent:u})},onObjectEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,b(p+k)},onArrayBegin:(p,k)=>{u=I({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,b(p+k)},onLiteralValue:(p,k,m)=>{I({type:n(p),offset:k,length:m,parent:u,value:p}),b(k+m)},onSeparator:(p,k,m)=>{u.type==="property"&&(p===":"?u.colonOffset=k:p===","&&b(k))},onError:(p,k,m)=>{g.push({error:p,offset:k,length:m})}},f);const y=u.children[0];return y&&delete y.parent,y}function d(i,g){if(!i)return;let f=i;for(const u of g)if(typeof u=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let b=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===u){f=I.children[1],b=!0;break}if(!b)return}else{const b=u;if(f.type!=="array"||b<0||!Array.isArray(f.children)||b>=f.children.length)return;f=f.children[b]}return f}function r(i){if(!i.parent||!i.parent.children)return[];const g=r(i.parent);if(i.parent.type==="property"){const f=i.parent.children[0].value;g.push(f)}else if(i.parent.type==="array"){const f=i.parent.children.indexOf(i);f!==-1&&g.push(f)}return g}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const g=Object.create(null);for(const f of i.children){const u=f.children[1];u&&(g[f.children[0].value]=o(u))}return g}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function a(i,g,f=!1){return g>=i.offset&&g<i.offset+i.length||f&&g===i.offset+i.length}function h(i,g,f=!1){if(a(i,g,f)){const u=i.children;if(Array.isArray(u))for(let b=0;b<u.length&&u[b].offset<=g;b++){const I=h(u[b],g,f);if(I)return I}return i}}function t(i,g,f=O.DEFAULT){const u=A(i,!1);function b($e){return $e?()=>$e(u.getTokenOffset(),u.getTokenLength()):()=>!0}function I($e){return $e?se=>$e(se,u.getTokenOffset(),u.getTokenLength()):()=>!0}const D=b(g.onObjectBegin),y=I(g.onObjectProperty),p=b(g.onObjectEnd),k=b(g.onArrayBegin),m=b(g.onArrayEnd),v=I(g.onLiteralValue),F=I(g.onSeparator),M=b(g.onComment),G=I(g.onError),q=f&&f.disallowComments,V=f&&f.allowTrailingComma;function N(){for(;;){const $e=u.scan();switch(u.getTokenError()){case E.InvalidUnicode:L(P.InvalidUnicode);break;case E.InvalidEscapeCharacter:L(P.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:L(P.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:q||L(P.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:L(P.UnexpectedEndOfString);break;case E.InvalidCharacter:L(P.InvalidCharacter);break}switch($e){case R.LineCommentTrivia:case R.BlockCommentTrivia:q?L(P.InvalidCommentToken):M();break;case R.Unknown:L(P.InvalidSymbol);break;case R.Trivia:case R.LineBreakTrivia:break;default:return $e}}}function L($e,se=[],Ce=[]){if(G($e),se.length+Ce.length>0){let Fe=u.getToken();for(;Fe!==R.EOF;){if(se.indexOf(Fe)!==-1){N();break}else if(Ce.indexOf(Fe)!==-1)break;Fe=N()}}}function Z($e){const se=u.getTokenValue();return $e?v(se):y(se),N(),!0}function re(){switch(u.getToken()){case R.NumericLiteral:{let $e=0;try{$e=JSON.parse(u.getTokenValue()),typeof $e!="number"&&(L(P.InvalidNumberFormat),$e=0)}catch{L(P.InvalidNumberFormat)}v($e);break}case R.NullKeyword:v(null);break;case R.TrueKeyword:v(!0);break;case R.FalseKeyword:v(!1);break;default:return!1}return N(),!0}function fe(){return u.getToken()!==R.StringLiteral?(L(P.PropertyNameExpected,[],[R.CloseBraceToken,R.CommaToken]),!1):(Z(!1),u.getToken()===R.ColonToken?(F(":"),N(),pe()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken])):L(P.ColonExpected,[],[R.CloseBraceToken,R.CommaToken]),!0)}function be(){D(),N();let $e=!1;for(;u.getToken()!==R.CloseBraceToken&&u.getToken()!==R.EOF;){if(u.getToken()===R.CommaToken){if($e||L(P.ValueExpected,[],[]),F(","),N(),u.getToken()===R.CloseBraceToken&&V)break}else $e&&L(P.CommaExpected,[],[]);fe()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken]),$e=!0}return p(),u.getToken()!==R.CloseBraceToken?L(P.CloseBraceExpected,[R.CloseBraceToken],[]):N(),!0}function oe(){k(),N();let $e=!1;for(;u.getToken()!==R.CloseBracketToken&&u.getToken()!==R.EOF;){if(u.getToken()===R.CommaToken){if($e||L(P.ValueExpected,[],[]),F(","),N(),u.getToken()===R.CloseBracketToken&&V)break}else $e&&L(P.CommaExpected,[],[]);pe()||L(P.ValueExpected,[],[R.CloseBracketToken,R.CommaToken]),$e=!0}return m(),u.getToken()!==R.CloseBracketToken?L(P.CloseBracketExpected,[R.CloseBracketToken],[]):N(),!0}function pe(){switch(u.getToken()){case R.OpenBracketToken:return oe();case R.OpenBraceToken:return be();case R.StringLiteral:return Z(!0);default:return re()}}return N(),u.getToken()===R.EOF?f.allowEmptyContent?!0:(L(P.ValueExpected,[],[]),!1):pe()?(u.getToken()!==R.EOF&&L(P.EndOfFileExpected,[],[]),!0):(L(P.ValueExpected,[],[]),!1)}function s(i,g){const f=A(i),u=[];let b,I=0,D;do switch(D=f.getPosition(),b=f.scan(),b){case R.LineCommentTrivia:case R.BlockCommentTrivia:case R.EOF:I!==D&&u.push(i.substring(I,D)),g!==void 0&&u.push(f.getTokenValue().replace(/[^\r\n]/g,g)),I=f.getPosition();break}while(b!==R.EOF);return u.join("")}function n(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(de,e){typeof define=="function"&&define.amd?define(ke[135],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(he,ve){for(var ae=0;ae<ve.length;ae++){var X=ve[ae];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(he,X.key,X)}}function E(he,ve,ae){return ve&&e(he.prototype,ve),ae&&e(he,ae),Object.defineProperty(he,"prototype",{writable:!1}),he}function R(he,ve){if(he){if(typeof he=="string")return P(he,ve);var ae=Object.prototype.toString.call(he).slice(8,-1);if(ae==="Object"&&he.constructor&&(ae=he.constructor.name),ae==="Map"||ae==="Set")return Array.from(he);if(ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ae))return P(he,ve)}}function P(he,ve){(ve==null||ve>he.length)&&(ve=he.length);for(var ae=0,X=new Array(ve);ae<ve;ae++)X[ae]=he[ae];return X}function O(he,ve){var ae=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(ae)return(ae=ae.call(he)).next.bind(ae);if(Array.isArray(he)||(ae=R(he))||ve&&he&&typeof he.length=="number"){ae&&(he=ae);var X=0;return function(){return X>=he.length?{done:!0}:{done:!1,value:he[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=A();function T(he){de.defaults=he}var $=/[&<>"']/,c=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ve){return l[ve]};function d(he,ve){if(ve){if($.test(he))return he.replace(c,S)}else if(C.test(he))return he.replace(w,S);return he}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(he){return he.replace(r,function(ve,ae){return ae=ae.toLowerCase(),ae==="colon"?":":ae.charAt(0)==="#"?ae.charAt(1)==="x"?String.fromCharCode(parseInt(ae.substring(2),16)):String.fromCharCode(+ae.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(he,ve){he=typeof he=="string"?he:he.source,ve=ve||"";var ae={replace:function(x,me){return me=me.source||me,me=me.replace(a,"$1"),he=he.replace(x,me),ae},getRegex:function(){return new RegExp(he,ve)}};return ae}var t=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(he,ve,ae){if(he){var X;try{X=decodeURIComponent(o(ae)).replace(t,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ve&&!s.test(ae)&&(ae=b(ve,ae));try{ae=encodeURI(ae).replace(/%25/g,"%")}catch{return null}return ae}var i={},g=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(he,ve){i[" "+he]||(g.test(he)?i[" "+he]=he+"/":i[" "+he]=p(he,"/",!0)),he=i[" "+he];var ae=he.indexOf(":")===-1;return ve.substring(0,2)==="//"?ae?ve:he.replace(f,"$1")+ve:ve.charAt(0)==="/"?ae?ve:he.replace(u,"$1")+ve:he+ve}var I={exec:function(){}};function D(he){for(var ve=1,ae,X;ve<arguments.length;ve++){ae=arguments[ve];for(X in ae)Object.prototype.hasOwnProperty.call(ae,X)&&(he[X]=ae[X])}return he}function y(he,ve){var ae=he.replace(/\|/g,function(me,ge,Me){for(var Be=!1,Ee=ge;--Ee>=0&&Me[Ee]==="\\";)Be=!Be;return Be?"|":" |"}),X=ae.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>ve)X.splice(ve);else for(;X.length<ve;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function p(he,ve,ae){var X=he.length;if(X===0)return"";for(var x=0;x<X;){var me=he.charAt(X-x-1);if(me===ve&&!ae)x++;else if(me!==ve&&ae)x++;else break}return he.slice(0,X-x)}function k(he,ve){if(he.indexOf(ve[1])===-1)return-1;for(var ae=he.length,X=0,x=0;x<ae;x++)if(he[x]==="\\")x++;else if(he[x]===ve[0])X++;else if(he[x]===ve[1]&&(X--,X<0))return x;return-1}function m(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(he,ve){if(ve<1)return"";for(var ae="";ve>1;)ve&1&&(ae+=he),ve>>=1,he+=he;return ae+he}function F(he,ve,ae,X){var x=ve.href,me=ve.title?d(ve.title):null,ge=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){X.state.inLink=!0;var Me={type:"link",raw:ae,href:x,title:me,text:ge,tokens:X.inlineTokens(ge)};return X.state.inLink=!1,Me}return{type:"image",raw:ae,href:x,title:me,text:d(ge)}}function M(he,ve){var ae=he.match(/^(\s+)(?:```)/);if(ae===null)return ve;var X=ae[1];return ve.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var ge=me[0];return ge.length>=X.length?x.slice(X.length):x}).join(`
`)}var G=function(){function he(ae){this.options=ae||de.defaults}var ve=he.prototype;return ve.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},ve.code=function(X){var x=this.rules.block.code.exec(X);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:p(me,`
`)}}},ve.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var me=x[0],ge=M(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:ge}}},ve.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var me=x[2].trim();if(/#$/.test(me)){var ge=p(me,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(me=ge.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},ve.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},ve.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ve.list=function(X){var x=this.rules.block.list.exec(X);if(x){var me,ge,Me,Be,Ee,Re,Oe,j,U,K,J,te,ue=x[1].trim(),Ae=ue.length>1,je={type:"list",raw:"",ordered:Ae,start:Ae?+ue.slice(0,-1):"",loose:!1,items:[]};ue=Ae?"\\d{1,9}\\"+ue.slice(-1):"\\"+ue,this.options.pedantic&&(ue=Ae?ue:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(te=!1,!(!(x=Ge.exec(X))||this.rules.block.hr.test(X)));){if(me=x[0],X=X.substring(me.length),j=x[2].split(`
`,1)[0],U=X.split(`
`,1)[0],this.options.pedantic?(Be=2,J=j.trimLeft()):(Be=x[2].search(/[^ ]/),Be=Be>4?1:Be,J=j.slice(Be),Be+=x[1].length),Re=!1,!j&&/^ *$/.test(U)&&(me+=U+`
`,X=X.substring(U.length+1),te=!0),!te)for(var Ze=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");X&&(K=X.split(`
`,1)[0],j=K,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(j)||it.test(j)||Ze.test(j)||tt.test(X)));){if(j.search(/[^ ]/)>=Be||!j.trim())J+=`
`+j.slice(Be);else if(!Re)J+=`
`+j;else break;!Re&&!j.trim()&&(Re=!0),me+=K+`
`,X=X.substring(K.length+1)}je.loose||(Oe?je.loose=!0:/\n *\n *$/.test(me)&&(Oe=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(J),ge&&(Me=ge[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:me,task:!!ge,checked:Me,loose:!1,text:J}),je.raw+=me}je.items[je.items.length-1].raw=me.trimRight(),je.items[je.items.length-1].text=J.trimRight(),je.raw=je.raw.trimRight();var nt=je.items.length;for(Ee=0;Ee<nt;Ee++){this.lexer.state.top=!1,je.items[Ee].tokens=this.lexer.blockTokens(je.items[Ee].text,[]);var mt=je.items[Ee].tokens.filter(function(rt){return rt.type==="space"}),ut=mt.every(function(rt){for(var at=rt.raw.split(""),dt=0,We=O(at),Ue;!(Ue=We()).done;){var _=Ue.value;if(_===`
`&&(dt+=1),dt>1)return!0}return!1});!je.loose&&mt.length&&ut&&(je.loose=!0,je.items[Ee].loose=!0)}return je}},ve.html=function(X){var x=this.rules.block.html.exec(X);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var ge=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);me.type="paragraph",me.text=ge,me.tokens=this.lexer.inline(ge)}return me}},ve.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},ve.table=function(X){var x=this.rules.block.table.exec(X);if(x){var me={type:"table",header:y(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var ge=me.align.length,Me,Be,Ee,Re;for(Me=0;Me<ge;Me++)/^ *-+: *$/.test(me.align[Me])?me.align[Me]="right":/^ *:-+: *$/.test(me.align[Me])?me.align[Me]="center":/^ *:-+ *$/.test(me.align[Me])?me.align[Me]="left":me.align[Me]=null;for(ge=me.rows.length,Me=0;Me<ge;Me++)me.rows[Me]=y(me.rows[Me],me.header.length).map(function(Oe){return{text:Oe}});for(ge=me.header.length,Be=0;Be<ge;Be++)me.header[Be].tokens=this.lexer.inline(me.header[Be].text);for(ge=me.rows.length,Be=0;Be<ge;Be++)for(Re=me.rows[Be],Ee=0;Ee<Re.length;Ee++)Re[Ee].tokens=this.lexer.inline(Re[Ee].text);return me}}},ve.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},ve.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},ve.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},ve.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},ve.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},ve.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ge=p(me.slice(0,-1),"\\");if((me.length-ge.length)%2===0)return}else{var Me=k(x[2],"()");if(Me>-1){var Be=x[0].indexOf("!")===0?5:4,Ee=Be+x[1].length+Me;x[2]=x[2].substring(0,Me),x[0]=x[0].substring(0,Ee).trim(),x[3]=""}}var Re=x[2],Oe="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);j&&(Re=j[1],Oe=j[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(me)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(x,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},ve.reflink=function(X,x){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var ge=(me[2]||me[1]).replace(/\s+/g," ");if(ge=x[ge.toLowerCase()],!ge||!ge.href){var Me=me[0].charAt(0);return{type:"text",raw:Me,text:Me}}return F(me,ge,me[0],this.lexer)}},ve.emStrong=function(X,x,me){me===void 0&&(me="");var ge=this.rules.inline.emStrong.lDelim.exec(X);if(ge&&!(ge[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ge[1]||ge[2]||"";if(!Me||Me&&(me===""||this.rules.inline.punctuation.exec(me))){var Be=ge[0].length-1,Ee,Re,Oe=Be,j=0,U=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,x=x.slice(-1*X.length+Be);(ge=U.exec(x))!=null;)if(Ee=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Ee){if(Re=Ee.length,ge[3]||ge[4]){Oe+=Re;continue}else if((ge[5]||ge[6])&&Be%3&&!((Be+Re)%3)){j+=Re;continue}if(Oe-=Re,!(Oe>0)){if(Re=Math.min(Re,Re+Oe+j),Math.min(Be,Re)%2){var K=X.slice(1,Be+ge.index+Re);return{type:"em",raw:X.slice(0,Be+ge.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var J=X.slice(2,Be+ge.index+Re-1);return{type:"strong",raw:X.slice(0,Be+ge.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ve.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var me=x[2].replace(/\n/g," "),ge=/[^ ]/.test(me),Me=/^ /.test(me)&&/ $/.test(me);return ge&&Me&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:x[0],text:me}}},ve.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},ve.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},ve.autolink=function(X,x){var me=this.rules.inline.autolink.exec(X);if(me){var ge,Me;return me[2]==="@"?(ge=d(this.options.mangle?x(me[1]):me[1]),Me="mailto:"+ge):(ge=d(me[1]),Me=ge),{type:"link",raw:me[0],text:ge,href:Me,tokens:[{type:"text",raw:ge,text:ge}]}}},ve.url=function(X,x){var me;if(me=this.rules.inline.url.exec(X)){var ge,Me;if(me[2]==="@")ge=d(this.options.mangle?x(me[0]):me[0]),Me="mailto:"+ge;else{var Be;do Be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Be!==me[0]);ge=d(me[0]),me[1]==="www."?Me="http://"+ge:Me=ge}return{type:"link",raw:me[0],text:ge,href:Me,tokens:[{type:"text",raw:ge,text:ge}]}}},ve.inlineText=function(X,x){var me=this.rules.inline.text.exec(X);if(me){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:ge=d(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:ge}}},he}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=h(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=h(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=h(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=h(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=h(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=D({},q),q.gfm=D({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=h(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=D({},q.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=h(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=h(q._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=h(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=h(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=h(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=h(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=h(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=h(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=h(V.reflink).replace("label",V._label).replace("ref",q._label).getRegex(),V.nolink=h(V.nolink).replace("ref",q._label).getRegex(),V.reflinkSearch=h(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=D({},V),V.pedantic=D({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=D({},V.normal,{escape:h(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=h(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=D({},V.gfm,{br:h(V.br).replace("{2,}","*").getRegex(),text:h(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function L(he){var ve="",ae,X,x=he.length;for(ae=0;ae<x;ae++)X=he.charCodeAt(ae),Math.random()>.5&&(X="x"+X.toString(16)),ve+="&#"+X+";";return ve}var Z=function(){function he(ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=ae||de.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:q.normal,inline:V.normal};this.options.pedantic?(X.block=q.pedantic,X.inline=V.pedantic):this.options.gfm&&(X.block=q.gfm,this.options.breaks?X.inline=V.breaks:X.inline=V.gfm),this.tokenizer.rules=X}he.lex=function(X,x){var me=new he(x);return me.lex(X)},he.lexInline=function(X,x){var me=new he(x);return me.inlineTokens(X)};var ve=he.prototype;return ve.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},ve.blockTokens=function(X,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,j,U){return j+"    ".repeat(U.length)});for(var ge,Me,Be,Ee;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(ge=Oe.call({lexer:me},X,x))?(X=X.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.space(X)){X=X.substring(ge.raw.length),ge.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(ge);continue}if(ge=this.tokenizer.code(X)){X=X.substring(ge.raw.length),Me=x[x.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ge.raw,Me.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(ge);continue}if(ge=this.tokenizer.fences(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.heading(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.hr(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.blockquote(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.list(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.html(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.def(X)){X=X.substring(ge.raw.length),Me=x[x.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ge.raw,Me.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.lheading(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(Be=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,j=X.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(K){U=K.call({lexer:this},j),typeof U=="number"&&U>=0&&(Oe=Math.min(Oe,U))}),Oe<1/0&&Oe>=0&&(Be=X.substring(0,Oe+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(Be))){Me=x[x.length-1],Ee&&Me.type==="paragraph"?(Me.raw+=`
`+ge.raw,Me.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(ge),Ee=Be.length!==X.length,X=X.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(X)){X=X.substring(ge.raw.length),Me=x[x.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ge.raw,Me.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(ge);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,x},ve.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},ve.inlineTokens=function(X,x){var me=this;x===void 0&&(x=[]);var ge,Me,Be,Ee=X,Re,Oe,j;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)U.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Re.index)+"["+v("a",Re[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Re.index)+"["+v("a",Re[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Re.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(j=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(ge=J.call({lexer:me},X,x))?(X=X.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.tag(X)){X=X.substring(ge.raw.length),Me=x[x.length-1],Me&&ge.type==="text"&&Me.type==="text"?(Me.raw+=ge.raw,Me.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.link(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(ge.raw.length),Me=x[x.length-1],Me&&ge.type==="text"&&Me.type==="text"?(Me.raw+=ge.raw,Me.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.emStrong(X,Ee,j)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.codespan(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.br(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.del(X)){X=X.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.autolink(X,L)){X=X.substring(ge.raw.length),x.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(X,L))){X=X.substring(ge.raw.length),x.push(ge);continue}if(Be=X,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,te=X.slice(1),ue=void 0;me.options.extensions.startInline.forEach(function(Ae){ue=Ae.call({lexer:this},te),typeof ue=="number"&&ue>=0&&(J=Math.min(J,ue))}),J<1/0&&J>=0&&(Be=X.substring(0,J+1))}(),ge=this.tokenizer.inlineText(Be,N)){X=X.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(j=ge.raw.slice(-1)),Oe=!0,Me=x[x.length-1],Me&&Me.type==="text"?(Me.raw+=ge.raw,Me.text+=ge.text):x.push(ge);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},E(he,null,[{key:"rules",get:function(){return{block:q,inline:V}}}]),he}(),re=function(){function he(ae){this.options=ae||de.defaults}var ve=he.prototype;return ve.code=function(X,x,me){var ge=(x||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(X,ge);Me!=null&&Me!==X&&(me=!0,X=Me)}return X=X.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+d(ge,!0)+'">'+(me?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:d(X,!0))+`</code></pre>
`},ve.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ve.html=function(X){return X},ve.heading=function(X,x,me,ge){if(this.options.headerIds){var Me=this.options.headerPrefix+ge.slug(me);return"<h"+x+' id="'+Me+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(X,x,me){var ge=x?"ol":"ul",Me=x&&me!==1?' start="'+me+'"':"";return"<"+ge+Me+`>
`+X+"</"+ge+`>
`},ve.listitem=function(X){return"<li>"+X+`</li>
`},ve.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(X){return"<p>"+X+`</p>
`},ve.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},ve.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ve.tablecell=function(X,x){var me=x.header?"th":"td",ge=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return ge+X+("</"+me+`>
`)},ve.strong=function(X){return"<strong>"+X+"</strong>"},ve.em=function(X){return"<em>"+X+"</em>"},ve.codespan=function(X){return"<code>"+X+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(X){return"<del>"+X+"</del>"},ve.link=function(X,x,me){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var ge='<a href="'+d(X)+'"';return x&&(ge+=' title="'+x+'"'),ge+=">"+me+"</a>",ge},ve.image=function(X,x,me){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var ge='<img src="'+X+'" alt="'+me+'"';return x&&(ge+=' title="'+x+'"'),ge+=this.options.xhtml?"/>":">",ge},ve.text=function(X){return X},he}(),fe=function(){function he(){}var ve=he.prototype;return ve.strong=function(X){return X},ve.em=function(X){return X},ve.codespan=function(X){return X},ve.del=function(X){return X},ve.html=function(X){return X},ve.text=function(X){return X},ve.link=function(X,x,me){return""+me},ve.image=function(X,x,me){return""+me},ve.br=function(){return""},he}(),be=function(){function he(){this.seen={}}var ve=he.prototype;return ve.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(X,x){var me=X,ge=0;if(this.seen.hasOwnProperty(me)){ge=this.seen[X];do ge++,me=X+"-"+ge;while(this.seen.hasOwnProperty(me))}return x||(this.seen[X]=ge,this.seen[me]=0),me},ve.slug=function(X,x){x===void 0&&(x={});var me=this.serialize(X);return this.getNextSafeSlug(me,x.dryrun)},he}(),oe=function(){function he(ae){this.options=ae||de.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new be}he.parse=function(X,x){var me=new he(x);return me.parse(X)},he.parseInline=function(X,x){var me=new he(x);return me.parseInline(X)};var ve=he.prototype;return ve.parse=function(X,x){x===void 0&&(x=!0);var me="",ge,Me,Be,Ee,Re,Oe,j,U,K,J,te,ue,Ae,je,Ge,Ze,tt,_e,it,nt=X.length;for(ge=0;ge<nt;ge++){if(J=X[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(it=this.options.extensions.renderers[J.type].call({parser:this},J),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){me+=it||"";continue}switch(J.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(J.tokens),J.depth,o(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(U="",j="",Ee=J.header.length,Me=0;Me<Ee;Me++)j+=this.renderer.tablecell(this.parseInline(J.header[Me].tokens),{header:!0,align:J.align[Me]});for(U+=this.renderer.tablerow(j),K="",Ee=J.rows.length,Me=0;Me<Ee;Me++){for(Oe=J.rows[Me],j="",Re=Oe.length,Be=0;Be<Re;Be++)j+=this.renderer.tablecell(this.parseInline(Oe[Be].tokens),{header:!1,align:J.align[Be]});K+=this.renderer.tablerow(j)}me+=this.renderer.table(U,K);continue}case"blockquote":{K=this.parse(J.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(te=J.ordered,ue=J.start,Ae=J.loose,Ee=J.items.length,K="",Me=0;Me<Ee;Me++)Ge=J.items[Me],Ze=Ge.checked,tt=Ge.task,je="",Ge.task&&(_e=this.renderer.checkbox(Ze),Ae?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=_e+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=_e+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:_e}):je+=_e),je+=this.parse(Ge.tokens,Ae),K+=this.renderer.listitem(je,tt,Ze);me+=this.renderer.list(K,te,ue);continue}case"html":{me+=this.renderer.html(J.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(K=J.tokens?this.parseInline(J.tokens):J.text;ge+1<nt&&X[ge+1].type==="text";)J=X[++ge],K+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);me+=x?this.renderer.paragraph(K):K;continue}default:{var mt='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},ve.parseInline=function(X,x){x=x||this.renderer;var me="",ge,Me,Be,Ee=X.length;for(ge=0;ge<Ee;ge++){if(Me=X[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Be=this.options.extensions.renderers[Me.type].call({parser:this},Me),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){me+=Be||"";continue}switch(Me.type){case"escape":{me+=x.text(Me.text);break}case"html":{me+=x.html(Me.text);break}case"link":{me+=x.link(Me.href,Me.title,this.parseInline(Me.tokens,x));break}case"image":{me+=x.image(Me.href,Me.title,Me.text);break}case"strong":{me+=x.strong(this.parseInline(Me.tokens,x));break}case"em":{me+=x.em(this.parseInline(Me.tokens,x));break}case"codespan":{me+=x.codespan(Me.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Me.tokens,x));break}case"text":{me+=x.text(Me.text);break}default:{var Re='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return me},he}();function pe(he,ve,ae){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof ve=="function"&&(ae=ve,ve=null),ve=D({},pe.defaults,ve||{}),m(ve),ae){var X=ve.highlight,x;try{x=Z.lex(he,ve)}catch(Ee){return ae(Ee)}var me=function(Re){var Oe;if(!Re)try{ve.walkTokens&&pe.walkTokens(x,ve.walkTokens),Oe=oe.parse(x,ve)}catch(j){Re=j}return ve.highlight=X,Re?ae(Re):ae(null,Oe)};if(!X||X.length<3||(delete ve.highlight,!x.length))return me();var ge=0;pe.walkTokens(x,function(Ee){Ee.type==="code"&&(ge++,setTimeout(function(){X(Ee.text,Ee.lang,function(Re,Oe){if(Re)return me(Re);Oe!=null&&Oe!==Ee.text&&(Ee.text=Oe,Ee.escaped=!0),ge--,ge===0&&me()})},0))}),ge===0&&me();return}function Me(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(Ee.message+"",!0)+"</pre>";throw Ee}try{var Be=Z.lex(he,ve);if(ve.walkTokens){if(ve.async)return Promise.all(pe.walkTokens(Be,ve.walkTokens)).then(function(){return oe.parse(Be,ve)}).catch(Me);pe.walkTokens(Be,ve.walkTokens)}return oe.parse(Be,ve)}catch(Ee){Me(Ee)}}pe.options=pe.setOptions=function(he){return D(pe.defaults,he),T(pe.defaults),pe},pe.getDefaults=A,pe.defaults=de.defaults,pe.use=function(){for(var he=arguments.length,ve=new Array(he),ae=0;ae<he;ae++)ve[ae]=arguments[ae];var X=D.apply(void 0,[{}].concat(ve)),x=pe.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(ge){if(ge.extensions&&(me=!0,ge.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var Ee=x.renderers?x.renderers[Be.name]:null;Ee?x.renderers[Be.name]=function(){for(var Re=arguments.length,Oe=new Array(Re),j=0;j<Re;j++)Oe[j]=arguments[j];var U=Be.renderer.apply(this,Oe);return U===!1&&(U=Ee.apply(this,Oe)),U}:x.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Be.level]?x[Be.level].unshift(Be.tokenizer):x[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?x.startBlock?x.startBlock.push(Be.start):x.startBlock=[Be.start]:Be.level==="inline"&&(x.startInline?x.startInline.push(Be.start):x.startInline=[Be.start]))}Be.childTokens&&(x.childTokens[Be.name]=Be.childTokens)})),ge.renderer&&function(){var Be=pe.defaults.renderer||new re,Ee=function(j){var U=Be[j];Be[j]=function(){for(var K=arguments.length,J=new Array(K),te=0;te<K;te++)J[te]=arguments[te];var ue=ge.renderer[j].apply(Be,J);return ue===!1&&(ue=U.apply(Be,J)),ue}};for(var Re in ge.renderer)Ee(Re);X.renderer=Be}(),ge.tokenizer&&function(){var Be=pe.defaults.tokenizer||new G,Ee=function(j){var U=Be[j];Be[j]=function(){for(var K=arguments.length,J=new Array(K),te=0;te<K;te++)J[te]=arguments[te];var ue=ge.tokenizer[j].apply(Be,J);return ue===!1&&(ue=U.apply(Be,J)),ue}};for(var Re in ge.tokenizer)Ee(Re);X.tokenizer=Be}(),ge.walkTokens){var Me=pe.defaults.walkTokens;X.walkTokens=function(Be){var Ee=[];return Ee.push(ge.walkTokens.call(this,Be)),Me&&(Ee=Ee.concat(Me.call(this,Be))),Ee}}me&&(X.extensions=x),pe.setOptions(X)})},pe.walkTokens=function(he,ve){for(var ae=[],X=function(){var Me=me.value;switch(ae=ae.concat(ve.call(pe,Me)),Me.type){case"table":{for(var Be=O(Me.header),Ee;!(Ee=Be()).done;){var Re=Ee.value;ae=ae.concat(pe.walkTokens(Re.tokens,ve))}for(var Oe=O(Me.rows),j;!(j=Oe()).done;)for(var U=j.value,K=O(U),J;!(J=K()).done;){var te=J.value;ae=ae.concat(pe.walkTokens(te.tokens,ve))}break}case"list":{ae=ae.concat(pe.walkTokens(Me.items,ve));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Me.type]?pe.defaults.extensions.childTokens[Me.type].forEach(function(ue){ae=ae.concat(pe.walkTokens(Me[ue],ve))}):Me.tokens&&(ae=ae.concat(pe.walkTokens(Me.tokens,ve)))}},x=O(he),me;!(me=x()).done;)X();return ae},pe.parseInline=function(he,ve){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");ve=D({},pe.defaults,ve||{}),m(ve);try{var ae=Z.lexInline(he,ve);return ve.walkTokens&&pe.walkTokens(ae,ve.walkTokens),oe.parseInline(ae,ve)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},pe.Parser=oe,pe.parser=oe.parse,pe.Renderer=re,pe.TextRenderer=fe,pe.Lexer=Z,pe.lexer=Z.lex,pe.Tokenizer=G,pe.Slugger=be,pe.parse=pe;var $e=pe.options,se=pe.setOptions,Ce=pe.use,Fe=pe.walkTokens,Y=pe.parseInline,W=pe,ie=oe.parse,De=Z.lex;de.Lexer=Z,de.Parser=oe,de.Renderer=re,de.Slugger=be,de.TextRenderer=fe,de.Tokenizer=G,de.getDefaults=A,de.lexer=De,de.marked=pe,de.options=$e,de.parse=W,de.parseInline=Y,de.parser=ie,de.setOptions=se,de.use=Ce,de.walkTokens=Fe,Object.defineProperty(de,"__esModule",{value:!0})}),define(ke[136],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=E;function E(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let R=0;const P=new Uint32Array(10);function O(r){if(R=0,A(r,w,$.InitialConsonant),R>0||(A(r,l,$.Vowel),R>0)||(A(r,S,$.FinalConsonant),R>0)||(A(r,d,$.CompatibilityJamo),R))return P.subarray(0,R);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),t=Math.floor(a/28),s=a%28-1;if(h<w.length?A(h,w,0):$.InitialConsonant+h-$.CompatibilityJamo<d.length&&A($.InitialConsonant+h,d,$.CompatibilityJamo),t<l.length?A(t,l,0):$.Vowel+t-$.CompatibilityJamo<d.length&&A($.Vowel+t-$.CompatibilityJamo,d,$.CompatibilityJamo),s>=0&&(s<S.length?A(s,S,0):$.FinalConsonant+s-$.CompatibilityJamo<d.length&&A($.FinalConsonant+s-$.CompatibilityJamo,d,$.CompatibilityJamo)),R>0)return P.subarray(0,R)}}function A(r,o,a){r>=a&&r<a+o.length&&T(o[r-a])}function T(r){r!==c.NUL&&(P[R++]=r&255,r>>8&&(P[R++]=r>>8&255),r>>16&&(P[R++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var C;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(C||(C={}));const w=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),l=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l]),S=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,C.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.E,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,c.Q,C.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l])}),define(ke[137],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=void 0,e.$Gm=E,e.rot=R;function E(T,$,c){return Math.min(Math.max(T,$),c)}function R(T,$){return($+T%$)%$}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Im=P;class O{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jm=O;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const c=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Km=A}),define(ke[138],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=O,e.$cd=l;class E{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$ad=E;const R=new Map,P=new WeakMap;function O(S,d){const r=P.get(S);if(r)return r;const o=A(S,d);if(o){let a=R.get(o)??0;a++,R.set(o,a);const h=a===1?o:`${o}#${a}`;return P.set(S,h),h}}function A(S,d){const r=P.get(S);if(r)return r;const o=d.owner?C(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const t=d.referenceFn;if(t!==void 0&&(a=l(t),a!==void 0))return o+a;if(d.owner!==void 0){const s=T(d.owner,S);if(s!==void 0)return o+s}}function T(S,d){for(const r in S)if(S[r]===d)return r}const $=new Map,c=new WeakMap;function C(S){const d=c.get(S);if(d)return d;const r=w(S);let o=$.get(r)??0;o++,$.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(S,a),a}function w(S){const d=S.constructor;return d?d.name:"Object"}function l(S){const d=S.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(ke[139],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=R,e.$Id=P;let E;function R(r){E=r}function P(){return E}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([T(S("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),c(C(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),c(C(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),c(C(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([$("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([$("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([$("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([$("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([$("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=O;function A(r){const o=new Array,a=[];let h="";function t(n){if("length"in n)for(const i of n)i&&t(i);else"text"in n?(h+=`%c${n.text}`,o.push(n.style),n.data&&a.push(...n.data)):"data"in n&&a.push(...n.data)}t(r);const s=[h,...o];return s.push(...a),s}function T(r){return c(r,{color:"black"})}function $(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(t){return Object.entries(t).reduce((s,[n,i])=>`${s}${n}:${i};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function C(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?w(r,o):l(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function w(r,o){let a="[ ",h=!0;for(const t of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${C(t,o-a.length)}`}return a+=" ]",a}function l(r,o){let a="{ ",h=!0;for(const[t,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${t}: ${C(s,o-a.length)}`}return a+=" }",a}function S(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(ke[140],Ie([1,0,133,138,139]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=$,e.$Ud=C,e.$Xd=S,e.$Yd=r,e.$Zd=o,e.$1d=a,e.$3d=t,e.$4d=s,e.$6d=i;let O;function A(f){O=f}let T;function $(f){T=f}let c;function C(f){c=f}class w{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u,b){const I=b===void 0?void 0:u,D=b===void 0?u:b;return c({owner:I,debugName:()=>{const y=(0,R.$cd)(D);if(y!==void 0)return y;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(D.toString());if(k)return`${this.debugName}.${k[2]}`;if(!I)return`${this.debugName} (mapped)`},debugReferenceFn:D},y=>D(this.read(y),y))}recomputeInitiallyAndOnChange(u,b){return u.add(O(this,b)),this}keepObserved(u){return u.add(T(this)),this}get a(){return this.get()}}e.$Vd=w;class l extends w{constructor(){super(...arguments),this.b=new Set}addObserver(u){const b=this.b.size;this.b.add(u),b===0&&this.c()}removeObserver(u){this.b.delete(u)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=l;function S(f,u){const b=new h(f,u);try{f(b)}finally{b.finish()}}let d;function r(f){if(d)f(d);else{const u=new h(f,void 0);d=u;try{f(u)}finally{u.finish(),d=void 0}}}async function o(f,u){const b=new h(f,u);try{await f(b)}finally{b.finish()}}function a(f,u,b){f?u(f):S(u,b)}class h{constructor(u,b){this._fn=u,this.b=b,this.a=[],(0,P.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,R.$cd)(this._fn)}updateObserver(u,b){this.a.push({observer:u,observable:b}),u.beginUpdate(b)}finish(){const u=this.a;for(let b=0;b<u.length;b++){const{observer:I,observable:D}=u[b];I.endUpdate(D)}this.a=null,(0,P.$Id)()?.handleEndTransaction()}}e.$2d=h;function t(f,u){let b;return typeof f=="string"?b=new R.$ad(void 0,f,void 0):b=new R.$ad(f,void 0,void 0),new n(b,u,E.$6c)}function s(f,u){return new n(new R.$ad(f.owner,f.debugName,void 0),u,f.equalsFn??E.$6c)}class n extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(u,b,I){super(),this.e=u,this.g=I,this.d=b}get(){return this.d}set(u,b,I){if(I===void 0&&this.g(this.d,u))return;let D;b||(b=D=new h(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(u),(0,P.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:u,change:I,didChange:!0,hadValue:!0});for(const p of this.b)b.updateObserver(p,this),p.handleChange(this,I)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(u){this.d=u}}e.$5d=n;function i(f,u){let b;return typeof f=="string"?b=new R.$ad(void 0,f,void 0):b=new R.$ad(f,void 0,void 0),new g(b,u,E.$6c)}class g extends n{h(u){this.d!==u&&(this.d&&this.d.dispose(),this.d=u)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function de(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A($){O.push($,Date.now())}function T(){const $=[];for(let c=0;c<O.length;c+=2)$.push({name:O[c],startTime:O[c+1]});return $}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=E(R))}(),define(ke[141],Ie([1,0,40]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=void 0;const R=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||E.Iterable.empty()}insert($,c,C){this.d($,w=>w._value=c,C)}mutate($,c){this.d($,C=>C._value=c(C._value===R?void 0:C._value))}mutatePath($,c){this.d($,()=>{},C=>c(C))}delete($){const c=this.c($);if(!c)return;let C=c.length-1;const w=c[C].node._value;if(w!==R){for(this.b--,c[C].node._value=R;C>0;C--){const{node:l,part:S}=c[C];if(l.children?.size||l._value!==R)break;c[C-1].node.children.delete(S)}return w}}*deleteRecursive($){const c=this.c($);if(!c)return;const C=c[c.length-1].node;for(let w=c.length-1;w>0;w--){const l=c[w-1];if(l.node.children.delete(c[w].part),l.node.children.size>0||l.node._value!==R)break}for(const w of O(C))w._value!==R&&(this.b--,yield w._value)}find($){let c=this.a;for(const C of $){const w=c.children?.get(C);if(!w)return;c=w}return c._value===R?void 0:c._value}hasKeyOrParent($){let c=this.a;for(const C of $){const w=c.children?.get(C);if(!w)return!1;if(w._value!==R)return!0;c=w}return!1}hasKeyOrChildren($){let c=this.a;for(const C of $){const w=c.children?.get(C);if(!w)return!1;c=w}return!0}hasKey($){let c=this.a;for(const C of $){const w=c.children?.get(C);if(!w)return!1;c=w}return c._value!==R}c($){const c=[{part:"",node:this.a}];let C=0;for(const w of $){const l=c[C].node.children?.get(w);if(!l)return;c.push({part:w,node:l}),C++}return c}d($,c,C){let w=this.a;for(const d of $){if(w.children)if(w.children.has(d))w=w.children.get(d);else{const r=new A;w.children.set(d,r),w=r}else{const r=new A;w.children=new Map([[d,r]]),w=r}C?.(w)}const l=w._value===R?0:1;c(w);const S=w._value===R?0:1;this.b+=S-l}*values(){for(const{_value:$}of O(this.a))$!==R&&(yield $)}}e.$MO=P;function*O(T){const $=[T];for(;$.length>0;){const c=$.pop();if(yield c,c.children)for(const C of c.children.values())$.push(C)}}class A{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value($){this._value=$===void 0?R:$}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var R in E)(typeof exports=="object"?exports:de)[R]=E[R]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function E(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return de[R].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=de,E.c=e,E.d=function(R,P,O){E.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},E.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},E.t=function(R,P){if(1&P&&(R=E(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var A in R)E.d(O,A,function(T){return R[T]}.bind(null,A));return O},E.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return E.d(P,"a",P),P},E.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},E.p="",E(E.s=0)}([function(de,e,E){(function(R){var P;e=de.exports=Ce,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],c=0,C=c++;$[C]="0|[1-9]\\d*";var w=c++;$[w]="[0-9]+";var l=c++;$[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=c++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var d=c++;$[d]="("+$[w]+")\\.("+$[w]+")\\.("+$[w]+")";var r=c++;$[r]="(?:"+$[C]+"|"+$[l]+")";var o=c++;$[o]="(?:"+$[w]+"|"+$[l]+")";var a=c++;$[a]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var h=c++;$[h]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var t=c++;$[t]="[0-9A-Za-z-]+";var s=c++;$[s]="(?:\\+("+$[t]+"(?:\\."+$[t]+")*))";var n=c++,i="v?"+$[S]+$[a]+"?"+$[s]+"?";$[n]="^"+i+"$";var g="[v=\\s]*"+$[d]+$[h]+"?"+$[s]+"?",f=c++;$[f]="^"+g+"$";var u=c++;$[u]="((?:<|>)?=?)";var b=c++;$[b]=$[w]+"|x|X|\\*";var I=c++;$[I]=$[C]+"|x|X|\\*";var D=c++;$[D]="[v=\\s]*("+$[I]+")(?:\\.("+$[I]+")(?:\\.("+$[I]+")(?:"+$[a]+")?"+$[s]+"?)?)?";var y=c++;$[y]="[v=\\s]*("+$[b]+")(?:\\.("+$[b]+")(?:\\.("+$[b]+")(?:"+$[h]+")?"+$[s]+"?)?)?";var p=c++;$[p]="^"+$[u]+"\\s*"+$[D]+"$";var k=c++;$[k]="^"+$[u]+"\\s*"+$[y]+"$";var m=c++;$[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;$[v]="(?:~>?)";var F=c++;$[F]="(\\s*)"+$[v]+"\\s+",T[F]=new RegExp($[F],"g");var M=c++;$[M]="^"+$[v]+$[D]+"$";var G=c++;$[G]="^"+$[v]+$[y]+"$";var q=c++;$[q]="(?:\\^)";var V=c++;$[V]="(\\s*)"+$[q]+"\\s+",T[V]=new RegExp($[V],"g");var N=c++;$[N]="^"+$[q]+$[D]+"$";var L=c++;$[L]="^"+$[q]+$[y]+"$";var Z=c++;$[Z]="^"+$[u]+"\\s*("+g+")$|^$";var re=c++;$[re]="^"+$[u]+"\\s*("+i+")$|^$";var fe=c++;$[fe]="(\\s*)"+$[u]+"\\s*("+g+"|"+$[D]+")",T[fe]=new RegExp($[fe],"g");var be=c++;$[be]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var oe=c++;$[oe]="^\\s*("+$[y]+")\\s+-\\s+("+$[y]+")\\s*$";var pe=c++;$[pe]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)P($e,$[$e]),T[$e]||(T[$e]=new RegExp($[$e]));function se(U,K){if(U instanceof Ce)return U;if(typeof U!="string"||U.length>O||!(K?T[f]:T[n]).test(U))return null;try{return new Ce(U,K)}catch{return null}}function Ce(U,K){if(U instanceof Ce){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ce))return new Ce(U,K);P("SemVer",U,K),this.loose=K;var J=U.trim().match(K?T[f]:T[n]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var ue=+te;if(ue>=0&&ue<A)return ue}return te}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=se,e.valid=function(U,K){var J=se(U,K);return J?J.version:null},e.clean=function(U,K){var J=se(U.trim().replace(/^[=v]+/,""),K);return J?J.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(U){return P("SemVer.compare",this.version,this.loose,U),U instanceof Ce||(U=new Ce(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Ce.prototype.compareMain=function(U){return U instanceof Ce||(U=new Ce(U,this.loose)),Y(this.major,U.major)||Y(this.minor,U.minor)||Y(this.patch,U.patch)},Ce.prototype.comparePre=function(U){if(U instanceof Ce||(U=new Ce(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],te=U.prerelease[K];if(P("prerelease compare",K,J,te),J===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(J===void 0)return-1;if(J!==te)return Y(J,te)}while(++K)},Ce.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,J,te){typeof J=="string"&&(te=J,J=void 0);try{return new Ce(U,J).inc(K,te).version}catch{return null}},e.diff=function(U,K){if(he(U,K))return null;var J=se(U),te=se(K);if(J.prerelease.length||te.prerelease.length){for(var ue in J)if((ue==="major"||ue==="minor"||ue==="patch")&&J[ue]!==te[ue])return"pre"+ue;return"prerelease"}for(var ue in J)if((ue==="major"||ue==="minor"||ue==="patch")&&J[ue]!==te[ue])return ue},e.compareIdentifiers=Y;var Fe=/^[0-9]+$/;function Y(U,K){var J=Fe.test(U),te=Fe.test(K);return J&&te&&(U=+U,K=+K),J&&!te?-1:te&&!J?1:U<K?-1:U>K?1:0}function W(U,K,J){return new Ce(U,J).compare(new Ce(K,J))}function ie(U,K,J){return W(U,K,J)>0}function De(U,K,J){return W(U,K,J)<0}function he(U,K,J){return W(U,K,J)===0}function ve(U,K,J){return W(U,K,J)!==0}function ae(U,K,J){return W(U,K,J)>=0}function X(U,K,J){return W(U,K,J)<=0}function x(U,K,J,te){var ue;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ue=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ue=U!==J;break;case"":case"=":case"==":ue=he(U,J,te);break;case"!=":ue=ve(U,J,te);break;case">":ue=ie(U,J,te);break;case">=":ue=ae(U,J,te);break;case"<":ue=De(U,J,te);break;case"<=":ue=X(U,J,te);break;default:throw new TypeError("Invalid operator: "+K)}return ue}function me(U,K){if(U instanceof me){if(U.loose===K)return U;U=U.value}if(!(this instanceof me))return new me(U,K);P("comparator",U,K),this.loose=K,this.parse(U),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(U,K){return Y(K,U)},e.major=function(U,K){return new Ce(U,K).major},e.minor=function(U,K){return new Ce(U,K).minor},e.patch=function(U,K){return new Ce(U,K).patch},e.compare=W,e.compareLoose=function(U,K){return W(U,K,!0)},e.rcompare=function(U,K,J){return W(K,U,J)},e.sort=function(U,K){return U.sort(function(J,te){return e.compare(J,te,K)})},e.rsort=function(U,K){return U.sort(function(J,te){return e.rcompare(J,te,K)})},e.gt=ie,e.lt=De,e.eq=he,e.neq=ve,e.gte=ae,e.lte=X,e.cmp=x,e.Comparator=me;var ge={};function Me(U,K){if(U instanceof Me)return U.loose===K?U:new Me(U.raw,K);if(U instanceof me)return new Me(U.value,K);if(!(this instanceof Me))return new Me(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function Be(U){return!U||U.toLowerCase()==="x"||U==="*"}function Ee(U,K,J,te,ue,Ae,je,Ge,Ze,tt,_e,it,nt){return((K=Be(J)?"":Be(te)?">="+J+".0.0":Be(ue)?">="+J+"."+te+".0":">="+K)+" "+(Ge=Be(Ze)?"":Be(tt)?"<"+(+Ze+1)+".0.0":Be(_e)?"<"+Ze+"."+(+tt+1)+".0":it?"<="+Ze+"."+tt+"."+_e+"-"+it:"<="+Ge)).trim()}function Re(U,K){for(var J=0;J<U.length;J++)if(!U[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<U.length;J++)if(P(U[J].semver),U[J].semver!==ge&&U[J].semver.prerelease.length>0){var te=U[J].semver;if(te.major===K.major&&te.minor===K.minor&&te.patch===K.patch)return!0}return!1}return!0}function Oe(U,K,J){try{K=new Me(K,J)}catch{return!1}return K.test(U)}function j(U,K,J,te){var ue,Ae,je,Ge,Ze;switch(U=new Ce(U,te),K=new Me(K,te),J){case">":ue=ie,Ae=X,je=De,Ge=">",Ze=">=";break;case"<":ue=De,Ae=ae,je=ie,Ge="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(U,K,te))return!1;for(var tt=0;tt<K.set.length;++tt){var _e=K.set[tt],it=null,nt=null;if(_e.forEach(function(mt){mt.semver===ge&&(mt=new me(">=0.0.0")),it=it||mt,nt=nt||mt,ue(mt.semver,it.semver,te)?it=mt:je(mt.semver,nt.semver,te)&&(nt=mt)}),it.operator===Ge||it.operator===Ze||(!nt.operator||nt.operator===Ge)&&Ae(U,nt.semver)||nt.operator===Ze&&je(U,nt.semver))return!1}return!0}me.prototype.parse=function(U){var K=this.loose?T[Z]:T[re],J=U.match(K);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Ce(J[2],this.loose):this.semver=ge},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return P("Comparator.test",U,this.loose),this.semver===ge||(typeof U=="string"&&(U=new Ce(U,this.loose)),x(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,K){if(!(U instanceof me))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Me(U.value,K),Oe(this.value,J,K);if(U.operator==="")return J=new Me(this.value,K),Oe(U.semver,J,K);var te=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Ae=this.semver.version===U.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ge=x(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Ze=x(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return te||ue||Ae&&je||Ge||Ze},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),P("range",U,K);var J=K?T[oe]:T[be];U=U.replace(J,Ee),P("hyphen replace",U),U=U.replace(T[fe],"$1$2$3"),P("comparator trim",U,T[fe]),U=(U=(U=U.replace(T[F],"$1~")).replace(T[V],"$1^")).split(/\s+/).join(" ");var te=K?T[Z]:T[re],ue=U.split(" ").map(function(Ae){return function(je,Ge){return P("comp",je),je=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(_e){return function(it,nt){P("caret",it,nt);var mt=nt?T[L]:T[N];return it.replace(mt,function(ut,rt,at,dt,We){var Ue;return P("caret",it,ut,rt,at,dt,We),Be(rt)?Ue="":Be(at)?Ue=">="+rt+".0.0 <"+(+rt+1)+".0.0":Be(dt)?Ue=rt==="0"?">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+".0 <"+(+rt+1)+".0.0":We?(P("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ue=rt==="0"?at==="0"?">="+rt+"."+at+"."+dt+We+" <"+rt+"."+at+"."+(+dt+1):">="+rt+"."+at+"."+dt+We+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+dt+We+" <"+(+rt+1)+".0.0"):(P("no pr"),Ue=rt==="0"?at==="0"?">="+rt+"."+at+"."+dt+" <"+rt+"."+at+"."+(+dt+1):">="+rt+"."+at+"."+dt+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+dt+" <"+(+rt+1)+".0.0"),P("caret return",Ue),Ue})}(_e,tt)}).join(" ")}(je,Ge),P("caret",je),je=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(_e){return function(it,nt){var mt=nt?T[G]:T[M];return it.replace(mt,function(ut,rt,at,dt,We){var Ue;return P("tilde",it,ut,rt,at,dt,We),Be(rt)?Ue="":Be(at)?Ue=">="+rt+".0.0 <"+(+rt+1)+".0.0":Be(dt)?Ue=">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":We?(P("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ue=">="+rt+"."+at+"."+dt+We+" <"+rt+"."+(+at+1)+".0"):Ue=">="+rt+"."+at+"."+dt+" <"+rt+"."+(+at+1)+".0",P("tilde return",Ue),Ue})}(_e,tt)}).join(" ")}(je,Ge),P("tildes",je),je=function(Ze,tt){return P("replaceXRanges",Ze,tt),Ze.split(/\s+/).map(function(_e){return function(it,nt){it=it.trim();var mt=nt?T[k]:T[p];return it.replace(mt,function(ut,rt,at,dt,We,Ue){P("xRange",it,ut,rt,at,dt,We,Ue);var _=Be(at),H=_||Be(dt),ye=H||Be(We);return rt==="="&&ye&&(rt=""),_?ut=rt===">"||rt==="<"?"<0.0.0":"*":rt&&ye?(H&&(dt=0),ye&&(We=0),rt===">"?(rt=">=",H?(at=+at+1,dt=0,We=0):ye&&(dt=+dt+1,We=0)):rt==="<="&&(rt="<",H?at=+at+1:dt=+dt+1),ut=rt+at+"."+dt+"."+We):H?ut=">="+at+".0.0 <"+(+at+1)+".0.0":ye&&(ut=">="+at+"."+dt+".0 <"+at+"."+(+dt+1)+".0"),P("xRange return",ut),ut})}(_e,tt)}).join(" ")}(je,Ge),P("xrange",je),je=function(Ze,tt){return P("replaceStars",Ze,tt),Ze.trim().replace(T[pe],"")}(je,Ge),P("stars",je),je}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(Ae){return!!Ae.match(te)})),ue=ue.map(function(Ae){return new me(Ae,K)})},Me.prototype.intersects=function(U,K){if(!(U instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(te){return U.set.some(function(ue){return ue.every(function(Ae){return te.intersects(Ae,K)})})})})},e.toComparators=function(U,K){return new Me(U,K).set.map(function(J){return J.map(function(te){return te.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Ce(U,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],U))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(U,K,J){var te=null,ue=null;try{var Ae=new Me(K,J)}catch{return null}return U.forEach(function(je){Ae.test(je)&&(te&&ue.compare(je)!==-1||(ue=new Ce(te=je,J)))}),te},e.minSatisfying=function(U,K,J){var te=null,ue=null;try{var Ae=new Me(K,J)}catch{return null}return U.forEach(function(je){Ae.test(je)&&(te&&ue.compare(je)!==1||(ue=new Ce(te=je,J)))}),te},e.validRange=function(U,K){try{return new Me(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,J){return j(U,K,"<",J)},e.gtr=function(U,K,J){return j(U,K,">",J)},e.outside=j,e.prerelease=function(U,K){var J=se(U,K);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,K,J){return U=new Me(U,J),K=new Me(K,J),U.intersects(K)},e.coerce=function(U){if(U instanceof Ce)return U;if(typeof U!="string")return null;var K=U.match(T[m]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,E(1))},function(de,e){var E,R,P=de.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(o){if(E===setTimeout)return setTimeout(o,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var $,c=[],C=!1,w=-1;function l(){C&&$&&(C=!1,$.length?c=$.concat(c):w=-1,c.length&&S())}function S(){if(!C){var o=T(l);C=!0;for(var a=c.length;a;){for($=c,c=[];++w<a;)$&&$[w].run();w=-1,a=c.length}$=null,C=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||C||T(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ke[142],Ie([1,0,4,6]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.$hu=e.$gu=e.$fu=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,o,a,h,t,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,t=t|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>t&&(s=t-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=t,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,t=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,n=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:t,scrollHeightChanged:s,scrollTopChanged:n}}}e.$fu=O;class A extends R.$Uc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new E.$he),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new C(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=C.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$gu=A;class T{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$hu=T;function $(S,d){const r=d-S;return function(o){return S+r*l(o)}}function c(S,d,r){return function(o){return o<r?S(o/r):d((o-r)/(1-r))}}class C{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,t;return d<r?(h=d+.75*o,t=r-.75*o):(h=d-.75*o,t=r+.75*o),c($(d,h),$(t,r),.33)}return $(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new T(o,a,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return C.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new C(d,r,a,o)}}e.$iu=C;function w(S){return Math.pow(S,3)}function l(S){return 1-w(1-S)}}),define(ke[143],Ie([1,0,14,6]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=P,e.$ve=O,e.$we=A,e.$xe=T,e.$ye=c,e.$ze=C,e.$Ae=w,e.$Be=l,e.$Ce=S,e.$De=d,e.$Ee=r,e.$Fe=o,e.$Ge=a,e.$He=h,e.$Ie=t;function P(s){const n=s;return n?typeof n.read=="function":!1}function O(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(i=>typeof i=="function"):!1}function A(s){const n=s;return n?O(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function T(s,n){return new $(s,n)}class ${constructor(n,i){this.e=n,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(i=>i(n))}h(n){this.c.error.length===0?(0,E.$1)(n):this.c.error.slice(0).forEach(i=>i(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,i){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(n,i){if(this.a.destroyed)return;let g;switch(n){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const f=g.indexOf(i);f>=0&&g.splice(f,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,n){const i=[];let g;for(;(g=s.read())!==null;)i.push(g);return n(i)}function C(s,n,i){const g=[];let f;for(;(f=s.read())!==null&&g.length<i;)g.push(f);return f===null&&g.length>0?n(g):{read:()=>{if(g.length>0)return g.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return s.read()}}}function w(s,n){return new Promise((i,g)=>{const f=[];l(s,{onData:u=>{n&&f.push(u)},onError:u=>{n?g(u):i(void 0)},onEnd:()=>{i(n?n(f):void 0)}})})}function l(s,n,i){s.on("error",g=>{i?.isCancellationRequested||n.onError(g)}),s.on("end",()=>{i?.isCancellationRequested||n.onEnd()}),s.on("data",g=>{i?.isCancellationRequested||n.onData(g)})}function S(s,n){return new Promise((i,g)=>{const f=new R.$Tc,u=[],b=y=>{if(u.push(y),u.length>n)return f.dispose(),s.pause(),i({stream:s,buffer:u,ended:!1})},I=y=>(f.dispose(),g(y)),D=()=>(f.dispose(),i({stream:s,buffer:u,ended:!0}));f.add((0,R.$Sc)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,R.$Sc)(()=>s.removeListener("end",D))),s.on("end",D),f.add((0,R.$Sc)(()=>s.removeListener("data",b))),s.on("data",b)})}function d(s,n){const i=T(n);return i.end(s),i}function r(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}function a(s,n,i){const g=T(i);return l(s,{onData:f=>g.write(n.data(f)),onError:f=>g.error(n.error?n.error(f):f),onEnd:()=>g.end()}),g}function h(s,n,i){let g=!1;return{read:()=>{const f=n.read();return g?f:(g=!0,f!==null?i([s,f]):s)}}}function t(s,n,i){let g=!1;const f=T(i);return l(n,{onData:u=>g?f.write(u):(g=!0,f.write(i([s,u]))),onError:u=>f.error(u),onEnd:()=>{g||(g=!0,f.write(s)),f.end()}}),f}}),define(ke[23],Ie([1,0,47,143]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=c,e.$Le=C,e.$Me=w,e.$Ne=l,e.$Oe=S,e.$Pe=d,e.$Qe=r,e.$Re=o,e.$Se=a,e.$Te=h,e.$Ue=t,e.$Ve=s,e.$We=n,e.$Xe=i,e.$Ye=g,e.$Ze=f,e.$1e=u,e.$2e=b,e.$3e=I,e.$4e=p;const P=typeof Buffer<"u",O=new E.$V(()=>new Uint8Array(256));let A,T;class ${static alloc(m){return P?new $(Buffer.allocUnsafe(m)):new $(new Uint8Array(m))}static wrap(m){return P&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new $(m)}static fromString(m,v){return!(v?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(m)):(A||(A=new TextEncoder),new $(A.encode(m)))}static fromByteArray(m){const v=$.alloc(m.length);for(let F=0,M=m.length;F<M;F++)v.buffer[F]=m[F];return v}static concat(m,v){if(typeof v>"u"){v=0;for(let G=0,q=m.length;G<q;G++)v+=m[G].byteLength}const F=$.alloc(v);let M=0;for(let G=0,q=m.length;G<q;G++){const V=m[G];F.set(V,M),M+=V.byteLength}return F}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=$.alloc(this.byteLength);return m.set(this),m}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(m,v){return new $(this.buffer.subarray(m,v))}set(m,v){if(m instanceof $)this.buffer.set(m.buffer,v);else if(m instanceof Uint8Array)this.buffer.set(m,v);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),v);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return l(this.buffer,m)}writeUInt32BE(m,v){S(this.buffer,m,v)}readUInt32LE(m){return d(this.buffer,m)}writeUInt32LE(m,v){r(this.buffer,m,v)}readUInt8(m){return o(this.buffer,m)}writeUInt8(m,v){a(this.buffer,m,v)}indexOf(m,v=0){return c(this.buffer,m instanceof $?m.buffer:m,v)}}e.$Je=$;function c(k,m,v=0){const F=m.byteLength,M=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(m[0]);if(F>M-v)return-1;const G=O.value;G.fill(m.length);for(let L=0;L<m.length;L++)G[m[L]]=m.length-L-1;let q=v+m.length-1,V=q,N=-1;for(;q<M;)if(k[q]===m[V]){if(V===0){N=q;break}q--,V--}else q+=Math.max(m.length-V,G[k[q]]),V=m.length-1;return N}function C(k,m){return k[m+0]<<0>>>0|k[m+1]<<8>>>0}function w(k,m,v){k[v+0]=m&255,m=m>>>8,k[v+1]=m&255}function l(k,m){return k[m]*2**24+k[m+1]*2**16+k[m+2]*2**8+k[m+3]}function S(k,m,v){k[v+3]=m,m=m>>>8,k[v+2]=m,m=m>>>8,k[v+1]=m,m=m>>>8,k[v]=m}function d(k,m){return k[m+0]<<0>>>0|k[m+1]<<8>>>0|k[m+2]<<16>>>0|k[m+3]<<24>>>0}function r(k,m,v){k[v+0]=m&255,m=m>>>8,k[v+1]=m&255,m=m>>>8,k[v+2]=m&255,m=m>>>8,k[v+3]=m&255}function o(k,m){return k[m]}function a(k,m,v){k[v]=m}function h(k){return R.$ye(k,m=>$.concat(m))}function t(k){return R.$Fe(k)}function s(k){return R.$Ae(k,m=>$.concat(m))}async function n(k){return k.ended?$.concat(k.buffer):$.concat([...k.buffer,await s(k.stream)])}function i(k){return R.$De(k,m=>$.concat(m))}function g(k){return R.$Ge(k,{data:m=>typeof m=="string"?$.fromString(m):$.wrap(m)},m=>$.concat(m))}function f(k){return R.$xe(m=>$.concat(m),k)}function u(k,m){return R.$He(k,m,v=>$.concat(v))}function b(k,m){return R.$Ie(k,m,v=>$.concat(v))}function I(k){let m=0,v=0,F=0;const M=new Uint8Array(Math.floor(k.length/4*3)),G=V=>{switch(v){case 3:M[F++]=m|V,v=0;break;case 2:M[F++]=m|V>>>2,m=V<<6,v=3;break;case 1:M[F++]=m|V>>>4,m=V<<4,v=2;break;default:m=V<<2,v=1}};for(let V=0;V<k.length;V++){const N=k.charCodeAt(V);if(N>=65&&N<=90)G(N-65);else if(N>=97&&N<=122)G(N-97+26);else if(N>=48&&N<=57)G(N-48+52);else if(N===43||N===45)G(62);else if(N===47||N===95)G(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${k[V]}`)}}const q=F;for(;v>0;)G(0);return $.wrap(M).slice(0,q)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:k},m=!0,v=!1){const F=v?y:D;let M="";const G=k.byteLength%3;let q=0;for(;q<k.byteLength-G;q+=3){const V=k[q+0],N=k[q+1],L=k[q+2];M+=F[V>>>2],M+=F[(V<<4|N>>>4)&63],M+=F[(N<<2|L>>>6)&63],M+=F[L&63]}if(G===1){const V=k[q+0];M+=F[V>>>2],M+=F[V<<4&63],m&&(M+="==")}else if(G===2){const V=k[q+0],N=k[q+1];M+=F[V>>>2],M+=F[(V<<4|N>>>4)&63],M+=F[N<<2&63],m&&(M+="=")}return M}}),define(ke[144],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[34],Ie([1,0,97]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=P;var R;(function(A){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=T})(R||(e.ThemeColor=R={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(h){const t=T.exec(h.id);if(!t)return $(E.$Zj.error);const[,s,n]=t,i=["codicon","codicon-"+s];return n&&i.push("codicon-modifier-"+n.substring(1)),i}A.asClassNameArray=$;function c(h){return $(h).join(" ")}A.asClassName=c;function C(h){return"."+$(h).join(".")}A.asCSSSelector=C;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}A.isThemeIcon=w;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(h){const t=l.exec(h);if(!t)return;const[,s]=t;return{id:s}}A.fromString=S;function d(h){return{id:h}}A.fromId=d;function r(h,t){let s=h.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),t&&(s=`${s}~${t}`),{id:s}}A.modify=r;function o(h){const t=h.id.lastIndexOf("~");if(t!==-1)return h.id.substring(t+1)}A.getModifier=o;function a(h,t){return h.id===t.id&&h.color?.id===t.color?.id}A.isEqual=a})(O||(e.ThemeIcon=O={}))}),define(ke[145],Ie([1,0,28,29,136,13]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=A,e.$Dk=$,e.$Ek=c,e.$Fk=l,e.$Gk=D,e.$Hk=y,e.$Ik=M,e.$Jk=G,e.$Kk=q,e.$Lk=V,e.$Mk=ie,e.$Ok=ae,e.$Pk=me,e.$Qk=ge;function A(...Ee){return function(Re,Oe){for(let j=0,U=Ee.length;j<U;j++){const K=Ee[j](Re,Oe);if(K)return K}return null}}e.$Bk=T.bind(void 0,!1),e.$Ck=T.bind(void 0,!0);function T(Ee,Re,Oe){if(!Oe||Oe.length<Re.length)return null;let j;return Ee?j=O.$Cf(Oe,Re):j=Oe.indexOf(Re)===0,j?Re.length>0?[{start:0,end:Re.length}]:[]:null}function $(Ee,Re){const Oe=Re.toLowerCase().indexOf(Ee.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Ee.length}]}function c(Ee,Re){return C(Ee.toLowerCase(),Re.toLowerCase(),0,0)}function C(Ee,Re,Oe,j){if(Oe===Ee.length)return[];if(j===Re.length)return null;if(Ee[Oe]===Re[j]){let U=null;return(U=C(Ee,Re,Oe+1,j+1))?n({start:j,end:j+1},U):null}return C(Ee,Re,Oe,j+1)}function w(Ee){return E.CharCode.a<=Ee&&Ee<=E.CharCode.z}function l(Ee){return E.CharCode.A<=Ee&&Ee<=E.CharCode.Z}function S(Ee){return E.CharCode.Digit0<=Ee&&Ee<=E.CharCode.Digit9}function d(Ee){return Ee===E.CharCode.Space||Ee===E.CharCode.Tab||Ee===E.CharCode.LineFeed||Ee===E.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ee=>r.add(Ee.charCodeAt(0)));function o(Ee){return d(Ee)||r.has(Ee)}function a(Ee,Re){return Ee===Re||o(Ee)&&o(Re)}const h=new Map;function t(Ee){if(h.has(Ee))return h.get(Ee);let Re;const Oe=(0,P.$zk)(Ee);return Oe&&(Re=Oe),h.set(Ee,Re),Re}function s(Ee){return w(Ee)||l(Ee)||S(Ee)}function n(Ee,Re){return Re.length===0?Re=[Ee]:Ee.end===Re[0].start?Re[0].start=Ee.start:Re.unshift(Ee),Re}function i(Ee,Re){for(let Oe=Re;Oe<Ee.length;Oe++){const j=Ee.charCodeAt(Oe);if(l(j)||S(j)||Oe>0&&!s(Ee.charCodeAt(Oe-1)))return Oe}return Ee.length}function g(Ee,Re,Oe,j){if(Oe===Ee.length)return[];if(j===Re.length)return null;if(Ee[Oe]!==Re[j].toLowerCase())return null;{let U=null,K=j+1;for(U=g(Ee,Re,Oe+1,j+1);!U&&(K=i(Re,K))<Re.length;)U=g(Ee,Re,Oe+1,K),K++;return U===null?null:n({start:j,end:j+1},U)}}function f(Ee){let Re=0,Oe=0,j=0,U=0,K=0;for(let je=0;je<Ee.length;je++)K=Ee.charCodeAt(je),l(K)&&Re++,w(K)&&Oe++,s(K)&&j++,S(K)&&U++;const J=Re/Ee.length,te=Oe/Ee.length,ue=j/Ee.length,Ae=U/Ee.length;return{upperPercent:J,lowerPercent:te,alphaPercent:ue,numericPercent:Ae}}function u(Ee){const{upperPercent:Re,lowerPercent:Oe}=Ee;return Oe===0&&Re>.6}function b(Ee){const{upperPercent:Re,lowerPercent:Oe,alphaPercent:j,numericPercent:U}=Ee;return Oe>.2&&Re<.8&&j>.6&&U<.2}function I(Ee){let Re=0,Oe=0,j=0,U=0;for(let K=0;K<Ee.length;K++)j=Ee.charCodeAt(K),l(j)&&Re++,w(j)&&Oe++,d(j)&&U++;return(Re===0||Oe===0)&&U===0?Ee.length<=30:Re<=5}function D(Ee,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(Ee))return null;Re.length>60&&(Re=Re.substring(0,60));const Oe=f(Re);if(!b(Oe)){if(!u(Oe))return null;Re=Re.toLowerCase()}let j=null,U=0;for(Ee=Ee.toLowerCase();U<Re.length&&(j=g(Ee,Re,0,U))===null;)U=i(Re,U+1);return j}function y(Ee,Re,Oe=!1){if(!Re||Re.length===0)return null;let j=null,U=0;for(Ee=Ee.toLowerCase(),Re=Re.toLowerCase();U<Re.length&&(j=p(Ee,Re,0,U,Oe),j===null);)U=k(Re,U+1);return j}function p(Ee,Re,Oe,j,U){let K=0;if(Oe===Ee.length)return[];if(j===Re.length)return null;if(!a(Ee.charCodeAt(Oe),Re.charCodeAt(j))){const ue=t(Ee.charCodeAt(Oe));if(!ue)return null;for(let Ae=0;Ae<ue.length;Ae++)if(!a(ue[Ae],Re.charCodeAt(j+Ae)))return null;K+=ue.length-1}let J=null,te=j+K+1;if(J=p(Ee,Re,Oe+1,te,U),!U)for(;!J&&(te=k(Re,te))<Re.length;)J=p(Ee,Re,Oe+1,te,U),te++;if(!J)return null;if(Ee.charCodeAt(Oe)!==Re.charCodeAt(j)){const ue=t(Ee.charCodeAt(Oe));if(!ue)return J;for(let Ae=0;Ae<ue.length;Ae++)if(ue[Ae]!==Re.charCodeAt(j+Ae))return J}return n({start:j,end:j+K+1},J)}function k(Ee,Re){for(let Oe=Re;Oe<Ee.length;Oe++)if(o(Ee.charCodeAt(Oe))||Oe>0&&o(Ee.charCodeAt(Oe-1)))return Oe;return Ee.length}const m=A(e.$Ck,D,$),v=A(e.$Ck,D,c),F=new R.$Dc(1e4);function M(Ee,Re,Oe=!1){if(typeof Ee!="string"||typeof Re!="string")return null;let j=F.get(Ee);j||(j=new RegExp(O.$kf(Ee),"i"),F.set(Ee,j));const U=j.exec(Re);return U?[{start:U.index,end:U.index+U[0].length}]:Oe?v(Ee,Re):m(Ee,Re)}function G(Ee,Re){const Oe=ae(Ee,Ee.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?V(Oe):null}function q(Ee,Re,Oe,j,U,K){const J=Math.min(13,Ee.length);for(;Oe<J;Oe++){const te=ae(Ee,Re,Oe,j,U,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(te)return te}return[0,K]}function V(Ee){if(typeof Ee>"u")return[];const Re=[],Oe=Ee[1];for(let j=Ee.length-1;j>1;j--){const U=Ee[j]+Oe,K=Re[Re.length-1];K&&K.end===U?K.end=U+1:Re.push({start:U,end:U+1})}return Re}const N=128;function L(){const Ee=[],Re=[];for(let Oe=0;Oe<=N;Oe++)Re[Oe]=0;for(let Oe=0;Oe<=N;Oe++)Ee.push(Re.slice(0));return Ee}function Z(Ee){const Re=[];for(let Oe=0;Oe<=Ee;Oe++)Re[Oe]=0;return Re}const re=Z(2*N),fe=Z(2*N),be=L(),oe=L(),pe=L(),$e=!1;function se(Ee,Re,Oe,j,U){function K(te,ue,Ae=" "){for(;te.length<ue;)te=Ae+te;return te}let J=` |   |${j.split("").map(te=>K(te,3)).join("|")}
`;for(let te=0;te<=Oe;te++)te===0?J+=" |":J+=`${Re[te-1]}|`,J+=Ee[te].slice(0,U+1).map(ue=>K(ue.toString(),3)).join("|")+`
`;return J}function Ce(Ee,Re,Oe,j){Ee=Ee.substr(Re),Oe=Oe.substr(j),console.log(se(oe,Ee,Ee.length,Oe,Oe.length)),console.log(se(pe,Ee,Ee.length,Oe,Oe.length)),console.log(se(be,Ee,Ee.length,Oe,Oe.length))}function Fe(Ee,Re){if(Re<0||Re>=Ee.length)return!1;const Oe=Ee.codePointAt(Re);switch(Oe){case E.CharCode.Underline:case E.CharCode.Dash:case E.CharCode.Period:case E.CharCode.Space:case E.CharCode.Slash:case E.CharCode.Backslash:case E.CharCode.SingleQuote:case E.CharCode.DoubleQuote:case E.CharCode.Colon:case E.CharCode.DollarSign:case E.CharCode.LessThan:case E.CharCode.GreaterThan:case E.CharCode.OpenParen:case E.CharCode.CloseParen:case E.CharCode.OpenSquareBracket:case E.CharCode.CloseSquareBracket:case E.CharCode.OpenCurlyBrace:case E.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Uf(Oe)}}function Y(Ee,Re){if(Re<0||Re>=Ee.length)return!1;switch(Ee.charCodeAt(Re)){case E.CharCode.Space:case E.CharCode.Tab:return!0;default:return!1}}function W(Ee,Re,Oe){return Re[Ee]!==Oe[Ee]}function ie(Ee,Re,Oe,j,U,K,J=!1){for(;Re<Oe&&U<K;)Ee[Re]===j[U]&&(J&&(re[Re]=U),Re+=1),U+=1;return Re===Oe}var De;(function(Ee){Ee[Ee.Diag=1]="Diag",Ee[Ee.Left=2]="Left",Ee[Ee.LeftLeft=3]="LeftLeft"})(De||(De={}));var he;(function(Ee){Ee.Default=[-100,0];function Re(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Ee.isDefault=Re})(he||(e.FuzzyScore=he={}));class ve{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Oe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Oe}}e.$Nk=ve;function ae(Ee,Re,Oe,j,U,K,J=ve.default){const te=Ee.length>N?N:Ee.length,ue=j.length>N?N:j.length;if(Oe>=te||K>=ue||te-Oe>ue-K||!ie(Re,Oe,te,U,K,ue,!0))return;X(te,ue,Oe,K,Re,U);let Ae=1,je=1,Ge=Oe,Ze=K;const tt=[!1];for(Ae=1,Ge=Oe;Ge<te;Ae++,Ge++){const ut=re[Ge],rt=fe[Ge],at=Ge+1<te?fe[Ge+1]:ue;for(je=ut-K+1,Ze=ut;Ze<at;je++,Ze++){let dt=Number.MIN_SAFE_INTEGER,We=!1;Ze<=rt&&(dt=x(Ee,Re,Ge,Oe,j,U,Ze,ue,K,be[Ae-1][je-1]===0,tt));let Ue=0;dt!==Number.MAX_SAFE_INTEGER&&(We=!0,Ue=dt+oe[Ae-1][je-1]);const _=Ze>ut,H=_?oe[Ae][je-1]+(be[Ae][je-1]>0?-5:0):0,ye=Ze>ut+1&&be[Ae][je-1]>0,Ke=ye?oe[Ae][je-2]+(be[Ae][je-2]>0?-5:0):0;if(ye&&(!_||Ke>=H)&&(!We||Ke>=Ue))oe[Ae][je]=Ke,pe[Ae][je]=De.LeftLeft,be[Ae][je]=0;else if(_&&(!We||H>=Ue))oe[Ae][je]=H,pe[Ae][je]=De.Left,be[Ae][je]=0;else if(We)oe[Ae][je]=Ue,pe[Ae][je]=De.Diag,be[Ae][je]=be[Ae-1][je-1]+1;else throw new Error("not possible")}}if($e&&Ce(Ee,Oe,j,K),!tt[0]&&!J.firstMatchCanBeWeak)return;Ae--,je--;const _e=[oe[Ae][je],K];let it=0,nt=0;for(;Ae>=1;){let ut=je;do{const rt=pe[Ae][ut];if(rt===De.LeftLeft)ut=ut-2;else if(rt===De.Left)ut=ut-1;else break}while(ut>=1);it>1&&Re[Oe+Ae-1]===U[K+je-1]&&!W(ut+K-1,j,U)&&it+1>be[Ae][ut]&&(ut=je),ut===je?it++:it=1,nt||(nt=ut),Ae--,je=ut-1,_e.push(je)}ue-K===te&&J.boostFullMatch&&(_e[0]+=2);const mt=nt-te;return _e[0]-=mt,_e}function X(Ee,Re,Oe,j,U,K){let J=Ee-1,te=Re-1;for(;J>=Oe&&te>=j;)U[J]===K[te]&&(fe[J]=te,J--),te--}function x(Ee,Re,Oe,j,U,K,J,te,ue,Ae,je){if(Re[Oe]!==K[J])return Number.MIN_SAFE_INTEGER;let Ge=1,Ze=!1;return J===Oe-j?Ge=Ee[Oe]===U[J]?7:5:W(J,U,K)&&(J===0||!W(J-1,U,K))?(Ge=Ee[Oe]===U[J]?7:5,Ze=!0):Fe(K,J)&&(J===0||!Fe(K,J-1))?Ge=5:(Fe(K,J-1)||Y(K,J-1))&&(Ge=5,Ze=!0),Ge>1&&Oe===j&&(je[0]=!0),Ze||(Ze=W(J,U,K)||Fe(K,J-1)||Y(K,J-1)),Oe===j?J>ue&&(Ge-=Ze?3:5):Ae?Ge+=Ze?2:0:Ge+=Ze?0:1,J+1===te&&(Ge-=Ze?3:5),Ge}function me(Ee,Re,Oe,j,U,K,J){return Me(Ee,Re,Oe,j,U,K,!0,J)}function ge(Ee,Re,Oe,j,U,K,J){return Me(Ee,Re,Oe,j,U,K,!1,J)}function Me(Ee,Re,Oe,j,U,K,J,te){let ue=ae(Ee,Re,Oe,j,U,K,te);if(ue&&!J)return ue;if(Ee.length>=3){const Ae=Math.min(7,Ee.length-1);for(let je=Oe+1;je<Ae;je++){const Ge=Be(Ee,je);if(Ge){const Ze=ae(Ge,Ge.toLowerCase(),Oe,j,U,K,te);Ze&&(Ze[0]-=3,(!ue||Ze[0]>ue[0])&&(ue=Ze))}}}return ue}function Be(Ee,Re){if(Re+1>=Ee.length)return;const Oe=Ee[Re],j=Ee[Re+1];if(Oe!==j)return Ee.slice(0,Re)+j+Oe+Ee.slice(Re+2)}}),define(ke[98],Ie([1,0,145,13,34]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=$,e.$Sk=C,e.$Tk=l,e.$Uk=S,e.$Vk=r,e.$Wk=o;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(T,(h,t)=>t?h:`\\${h}`)}const c=new RegExp(`\\\\${A.source}`,"g");function C(a){return a.replace(c,h=>`\\${h}`)}const w=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(a){return a.indexOf(O)===-1?a:a.replace(w,(h,t,s,n)=>s?h:t||n||"")}function S(a){return a?a.replace(/\$\((.*?)\)/g,(h,t)=>` ${t} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const t=[];let s=0;for(;;){const n=d.lastIndex,i=d.exec(a),g=a.substring(n,i?.index);if(g.length>0){h+=g;for(let f=0;f<g.length;f++)t.push(s)}if(!i)break;s+=i[0].length}return{text:h,iconOffsets:t}}function o(a,h,t=!1){const{text:s,iconOffsets:n}=h;if(!n||n.length===0)return(0,E.$Ik)(a,s,t);const i=(0,R.$if)(s," "),g=s.length-i.length,f=(0,E.$Ik)(a,i,t);if(f)for(const u of f){const b=n[u.start+g]+g;u.start+=b,u.end+=b}return f}}),define(ke[35],Ie([1,0,13]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",A="warning",T="warn",$="info",c="ignore";function C(l){return l?E.$Bf(O,l)?P.Error:E.$Bf(A,l)||E.$Bf(T,l)?P.Warning:E.$Bf($,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=C;function w(l){switch(l){case P.Error:return O;case P.Warning:return A;case P.Info:return $;default:return c}}P.toString=w}(R||(R={})),e.default=R}),define(ke[58],Ie([1,0,18,28,13]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Ci=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===R.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$vf)(d,this.b,0,d.length,this.c,this.d):(0,P.$xf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=A;class T{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===R.CharCode.Slash||this.f&&o===R.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===R.CharCode.Slash||this.f&&r===R.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$vf)(d,this.b,0,d.length,this.d,this.e):(0,P.$xf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=T;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,P.$wf)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$wf)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,P.$uf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$uf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Fi=c;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(w||(w={}));class l{static forUris(d=()=>!1,r=()=>!1){return new l(new c(d,r))}static forPaths(d=!1){return new l(new T(void 0,!d))}static forStrings(){return new l(new O)}static forConfigKeys(){return new l(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,E.$Wb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,E.$Wb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new C,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new C,a.left.segment=o.value()),h.push([w.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new C,a.right.segment=o.value()),h.push([w.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new C,a.mid.segment=o.value()),h.push([w.Mid,a]),a=a.mid;else break}const t=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const n=h[s][1];n.updateHeight();const i=n.balanceFactor();if(i<-1||i>1){const g=h[s][0],f=h[s+1][0];if(g===w.Right&&f===w.Right)h[s][1]=n.rotateLeft();else if(g===w.Left&&f===w.Left)h[s][1]=n.rotateRight();else if(g===w.Right&&f===w.Left)n.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=n.rotateLeft();else if(g===w.Left&&f===w.Right)n.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case w.Left:h[s-1][1].left=h[s][1];break;case w.Right:h[s-1][1].right=h[s][1];break;case w.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return t}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const t=o.cmp(h.segment);if(t>0)a.push([w.Left,h]),h=h.left;else if(t<0)a.push([w.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([w.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const t=this.f(h.right);if(t.key){const{key:s,value:n,segment:i}=t;this.e(t.key,!1),h.key=s,h.value=n,h.segment=i}}else{const t=h.left??h.right;if(a.length>0){const[s,n]=a[a.length-1];switch(s){case w.Left:n.left=t;break;case w.Mid:n.mid=t;break;case w.Right:n.right=t;break}}else this.c=t}for(let t=a.length-1;t>=0;t--){const s=a[t][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[t][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[t][1]=s.rotateRight()),t>0)switch(a[t-1][0]){case w.Left:a[t-1][1].left=a[t][1];break;case w.Right:a[t-1][1].right=a[t][1];break;case w.Mid:a[t-1][1].mid=a[t][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Gi=l}),define(ke[36],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=R;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return E.test(P)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,c="";return c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c}}()}),define(ke[146],Ie([1,0,18,40,36]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$0s=void 0,e.$8s=O,e.$9s=A,e.$$s=c;function O(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function A(w,l,S){const d={id:(0,P.$Wg)(),name:w,uri:l,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let l=0;for(const S of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const S=[...this.a.keys()];return R.Iterable.some(this,([d,r])=>r.asFile())&&S.push("files"),C($(l),S)}get(l){return this.a.get(this.b(l))?.[0]}append(l,S){const d=this.a.get(l);d?d.push(S):this.a.set(this.b(l),[S])}replace(l,S){this.a.set(this.b(l),[S])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,S]of this.a)for(const d of S)yield[l,d]}b(l){return $(l)}}e.$0s=T;function $(w){return w.toLowerCase()}function c(w,l){return C($(w),l.map($))}function C(w,l){if(w==="*/*")return l.length>0;if(l.includes(w))return!0;const S=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,r,o]=S;return o==="*"?l.some(a=>a.startsWith(r+"/")):!1}e.$_s=Object.freeze({create:w=>(0,E.$Mb)(w.map(l=>l.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.$_s.split(w).filter(l=>!l.startsWith("#"))})}),define(ke[147],Ie([1,0,28]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$jv=P;var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(R||(e.StringEOL=R={}));function P(O){let A=0,T=0,$=0,c=R.Unknown;for(let C=0,w=O.length;C<w;C++){const l=O.charCodeAt(C);l===E.CharCode.CarriageReturn?(A===0&&(T=C),A++,C+1<w&&O.charCodeAt(C+1)===E.CharCode.LineFeed?(c|=R.CRLF,C++):c|=R.Invalid,$=C+1):l===E.CharCode.LineFeed&&(c|=R.LF,A===0&&(T=C),A++,$=C+1)}return A===0&&(T=O.length),[A,T,O.length-$,c]}}),define(ke[148],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$nu={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[149],Ie([1,0,28,150]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let C=0,w=c.notIn.length;C<w;C++)switch(c.notIn[C]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case R.StandardTokenType.Other:return!0;case R.StandardTokenType.Comment:return this.c;case R.StandardTokenType.String:return this.b;case R.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,C){if(c.getTokenCount()===0)return!0;const w=c.findTokenIndexAtOffset(C-2),l=c.getStandardTokenType(w);return this.isOK(l)}g(c,C){for(let w=c;w<=C;w++){const l=String.fromCharCode(w);if(!this.open.includes(l)&&!this.close.includes(l))return l}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(E.CharCode.Digit0,E.CharCode.Digit9)),this.e||(this.e=this.g(E.CharCode.a,E.CharCode.z)),this.e||(this.e=this.g(E.CharCode.A,E.CharCode.Z))),this.e}}e.$Ct=O;class A{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of c)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.$Dt=A;function T($,c,C){$.has(c)?$.get(c).push(C):$.set(c,[C])}}),define(ke[151],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.NodeColor=e.$QC=void 0,e.$SC=P,e.$TC=O,e.$UC=c,e.$VC=C,e.$WC=w,e.$XC=l,e.$YC=S,e.$ZC=d;class E{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$RC)return P(this.right);let o=this;for(;o.parent!==e.$RC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$RC?e.$RC:o.parent}prev(){if(this.left!==e.$RC)return O(this.left);let o=this;for(;o.parent!==e.$RC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$RC?e.$RC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$QC=E;var R;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$RC=new E(null,R.Black),e.$RC.parent=e.$RC,e.$RC.left=e.$RC,e.$RC.right=e.$RC,e.$RC.color=R.Black;function P(r){for(;r.left!==e.$RC;)r=r.left;return r}function O(r){for(;r.right!==e.$RC;)r=r.right;return r}function A(r){return r===e.$RC?0:r.size_left+r.piece.length+A(r.right)}function T(r){return r===e.$RC?0:r.lf_left+r.piece.lineFeedCnt+T(r.right)}function $(){e.$RC.parent=e.$RC}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$RC&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$RC?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function C(r,o){const a=o.left;o.left=a.right,a.right!==e.$RC&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$RC?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function w(r,o){let a,h;if(o.left===e.$RC?(h=o,a=h.right):o.right===e.$RC?(h=o,a=h.left):(h=P(o.right),a=h.right),h===r.root){r.root=a,a.color=R.Black,o.detach(),$(),r.root.parent=e.$RC;return}const t=h.color===R.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$RC&&(h.left.parent=h),h.right!==e.$RC&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const n=A(a),i=T(a);if(n!==a.parent.size_left||i!==a.parent.lf_left){const g=n-a.parent.size_left,f=i-a.parent.lf_left;a.parent.size_left=n,a.parent.lf_left=i,S(r,a.parent,g,f)}}if(d(r,a.parent),t){$();return}let s;for(;a!==r.root&&a.color===R.Black;)a===a.parent.left?(s=a.parent.right,s.color===R.Red&&(s.color=R.Black,a.parent.color=R.Red,c(r,a.parent),s=a.parent.right),s.left.color===R.Black&&s.right.color===R.Black?(s.color=R.Red,a=a.parent):(s.right.color===R.Black&&(s.left.color=R.Black,s.color=R.Red,C(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=R.Black,s.right.color=R.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===R.Red&&(s.color=R.Black,a.parent.color=R.Red,C(r,a.parent),s=a.parent.left),s.left.color===R.Black&&s.right.color===R.Black?(s.color=R.Red,a=a.parent):(s.left.color===R.Black&&(s.right.color=R.Black,s.color=R.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=R.Black,s.left.color=R.Black,C(r,a.parent),a=r.root));a.color=R.Black,$()}function l(r,o){for(d(r,o);o!==r.root&&o.parent.color===R.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===R.Red?(o.parent.color=R.Black,a.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,C(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===R.Red?(o.parent.color=R.Black,a.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,C(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,c(r,o.parent.parent))}r.root.color=R.Black}function S(r,o,a,h){for(;o!==r.root&&o!==e.$RC;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,h=T(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(ke[99],Ie([1,0,28,100,33,52,151,101]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=void 0,e.$7C=w,e.$8C=l;const $=65535;function c(h){let t;return h[h.length-1]<65536?t=new Uint16Array(h.length):t=new Uint32Array(h.length),t.set(h,0),t}class C{constructor(t,s,n,i,g){this.lineStarts=t,this.cr=s,this.lf=n,this.crlf=i,this.isBasicASCII=g}}function w(h,t=!0){const s=[0];let n=1;for(let i=0,g=h.length;i<g;i++){const f=h.charCodeAt(i);f===E.CharCode.CarriageReturn?i+1<g&&h.charCodeAt(i+1)===E.CharCode.LineFeed?(s[n++]=i+2,i++):s[n++]=i+1:f===E.CharCode.LineFeed&&(s[n++]=i+1)}return t?c(s):s}function l(h,t){h.length=0,h[0]=0;let s=1,n=0,i=0,g=0,f=!0;for(let b=0,I=t.length;b<I;b++){const D=t.charCodeAt(b);D===E.CharCode.CarriageReturn?b+1<I&&t.charCodeAt(b+1)===E.CharCode.LineFeed?(g++,h[s++]=b+2,b++):(n++,h[s++]=b+1):D===E.CharCode.LineFeed?(i++,h[s++]=b+1):f&&D!==E.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const u=new C(c(h),n,i,g,f);return h.length=0,u}class S{constructor(t,s,n,i,g){this.bufferIndex=t,this.start=s,this.end=n,this.lineFeedCnt=i,this.length=g}}e.$9C=S;class d{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.$0C=d;class r{constructor(t,s){this.a=[],this.c=t,this.d=s,this.b=0,t.root!==A.$RC&&t.iterate(t.root,n=>(n!==A.$RC&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(t){this.a=t,this.b=[]}get(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartOffset<=t&&n.nodeStartOffset+n.node.piece.length>=t)return n}return null}get2(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<t&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=t)return n}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let s=!1;const n=this.b;for(let i=0;i<n.length;i++){const g=n[i];if(g.node.parent===null||g.nodeStartOffset>=t){n[i]=null,s=!0;continue}}if(s){const i=[];for(const g of n)g!==null&&i.push(g);this.b=i}}}class a{constructor(t,s,n){this.create(t,s,n)}create(t,s,n){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$RC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=n;let i=null;for(let g=0,f=t.length;g<f;g++)if(t[g].buffer.length>0){t[g].lineStarts||(t[g].lineStarts=w(t[g].buffer));const u=new S(g+1,{line:0,column:0},{line:t[g].lineStarts.length-1,column:t[g].buffer.length-t[g].lineStarts[t[g].lineStarts.length-1]},t[g].lineStarts.length-1,t[g].buffer.length);this.a.push(t[g]),i=this.S(i,u)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const s=$,n=s-Math.floor(s/3),i=n*2;let g="",f=0;const u=[];if(this.iterate(this.root,b=>{const I=this.R(b),D=I.length;if(f<=n||f+D<i)return g+=I,f+=D,!0;const y=g.replace(/\r\n|\r|\n/g,t);return u.push(new d(y,w(y))),g=I,f=D,!0}),f>0){const b=g.replace(/\r\n|\r|\n/g,t);u.push(new d(b,w(b)))}this.create(u,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new r(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,i=>{if(i===A.$RC)return!0;const g=this.R(i),f=g.length,u=t.G(s),b=t.G(s+f),I=t.getValueInRange2(u,b);return s+=f,g===I})}getOffsetAt(t,s){let n=0,i=this.root;for(;i!==A.$RC;)if(i.left!==A.$RC&&i.lf_left+1>=t)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=t){n+=i.size_left;const g=this.B(i,t-i.lf_left-2);return n+=g+s-1}else t-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;return n}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,n=0;const i=t;for(;s!==A.$RC;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const g=this.A(s,t-s.size_left);if(n+=s.lf_left+g.index,g.index===0){const f=this.getOffsetAt(n+1,1),u=i-f;return new R.$bt(n+1,u+1)}return new R.$bt(n+1,g.remainder+1)}else if(t-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$RC){const g=this.getOffsetAt(n+1,1),f=i-t-g;return new R.$bt(n+1,f+1)}else s=s.right;return new R.$bt(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const n=this.H(t.startLineNumber,t.startColumn),i=this.H(t.endLineNumber,t.endColumn),g=this.getValueInRange2(n,i);return s?s!==this.d||!this.f?g.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?g:g.replace(/\r\n|\r|\n/g,s):g}getValueInRange2(t,s){if(t.node===s.node){const u=t.node,b=this.a[u.piece.bufferIndex].buffer,I=this.u(u.piece.bufferIndex,u.piece.start);return b.substring(I+t.remainder,I+s.remainder)}let n=t.node;const i=this.a[n.piece.bufferIndex].buffer,g=this.u(n.piece.bufferIndex,n.piece.start);let f=i.substring(g+t.remainder,g+n.piece.length);for(n=n.next();n!==A.$RC;){const u=this.a[n.piece.bufferIndex].buffer,b=this.u(n.piece.bufferIndex,n.piece.start);if(n===s.node){f+=u.substring(b,b+s.remainder);break}else f+=u.substr(b,n.piece.length);n=n.next()}return f}getLinesContent(){const t=[];let s=0,n="",i=!1;return this.iterate(this.root,g=>{if(g===A.$RC)return!0;const f=g.piece;let u=f.length;if(u===0)return!0;const b=this.a[f.bufferIndex].buffer,I=this.a[f.bufferIndex].lineStarts,D=f.start.line,y=f.end.line;let p=I[D]+f.start.column;if(i&&(b.charCodeAt(p)===E.CharCode.LineFeed&&(p++,u--),t[s++]=n,n="",i=!1,u===0))return!0;if(D===y)return!this.f&&b.charCodeAt(p+u-1)===E.CharCode.CarriageReturn?(i=!0,n+=b.substr(p,u-1)):n+=b.substr(p,u),!0;n+=this.f?b.substring(p,Math.max(p,I[D+1]-this.e)):b.substring(p,I[D+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;for(let k=D+1;k<y;k++)n=this.f?b.substring(I[k],I[k+1]-this.e):b.substring(I[k],I[k+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;return!this.f&&b.charCodeAt(I[y]+f.end.column-1)===E.CharCode.CarriageReturn?(i=!0,f.end.column===0?s--:n=b.substr(I[y],f.end.column-1)):n=b.substr(I[y],f.end.column),!0}),i&&(t[s++]=n,n=""),t[s++]=n,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const n=this.a[s.piece.bufferIndex],i=this.u(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(i)}else{const s=this.a[t.node.piece.bufferIndex],i=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(i)}}getLineCharCode(t,s){const n=this.H(t,s+1);return this.l(n)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const s=this.G(t);return this.l(s)}findMatchesInNode(t,s,n,i,g,f,u,b,I,D,y){const p=this.a[t.piece.bufferIndex],k=this.u(t.piece.bufferIndex,t.piece.start),m=this.u(t.piece.bufferIndex,g),v=this.u(t.piece.bufferIndex,f);let F;const M={line:0,column:0};let G,q;s._wordSeparators?(G=p.buffer.substring(m,v),q=V=>V+m,s.reset(0)):(G=p.buffer,q=V=>V,s.reset(m));do if(F=s.next(G),F){if(q(F.index)>=v)return D;this.s(t,q(F.index)-k,M);const V=this.t(t.piece.bufferIndex,g,M),N=M.line===g.line?M.column-g.column+i:M.column+1,L=N+F[0].length;if(y[D++]=(0,T.$3C)(new P.$ct(n+V,N,n+V,L),F,b),q(F.index)+F[0].length>=v||D>=I)return D}while(F);return D}findMatchesLineByLine(t,s,n,i){const g=[];let f=0;const u=new T.$6C(s.wordSeparators,s.regex);let b=this.H(t.startLineNumber,t.startColumn);if(b===null)return[];const I=this.H(t.endLineNumber,t.endColumn);if(I===null)return[];let D=this.s(b.node,b.remainder);const y=this.s(I.node,I.remainder);if(b.node===I.node)return this.findMatchesInNode(b.node,u,t.startLineNumber,t.startColumn,D,y,s,n,i,f,g),g;let p=t.startLineNumber,k=b.node;for(;k!==I.node;){const v=this.t(k.piece.bufferIndex,D,k.piece.end);if(v>=1){const M=this.a[k.piece.bufferIndex].lineStarts,G=this.u(k.piece.bufferIndex,k.piece.start),q=M[D.line+v],V=p===t.startLineNumber?t.startColumn:1;if(f=this.findMatchesInNode(k,u,p,V,D,this.s(k,q-G),s,n,i,f,g),f>=i)return g;p+=v}const F=p===t.startLineNumber?t.startColumn-1:0;if(p===t.endLineNumber){const M=this.getLineContent(p).substring(F,t.endColumn-1);return f=this.n(s,u,M,t.endLineNumber,F,f,g,n,i),g}if(f=this.n(s,u,this.getLineContent(p).substr(F),p,F,f,g,n,i),f>=i)return g;p++,b=this.H(p,1),k=b.node,D=this.s(b.node,b.remainder)}if(p===t.endLineNumber){const v=p===t.startLineNumber?t.startColumn-1:0,F=this.getLineContent(p).substring(v,t.endColumn-1);return f=this.n(s,u,F,t.endLineNumber,v,f,g,n,i),g}const m=p===t.startLineNumber?t.startColumn:1;return f=this.findMatchesInNode(I.node,u,p,m,D,y,s,n,i,f,g),g}n(t,s,n,i,g,f,u,b,I){const D=t.wordSeparators;if(!b&&t.simpleSearch){const p=t.simpleSearch,k=p.length,m=n.length;let v=-k;for(;(v=n.indexOf(p,v+k))!==-1;)if((!D||(0,T.$5C)(D,n,m,v,k))&&(u[f++]=new O.$rv(new P.$ct(i,v+1+g,i,v+1+k+g),null),f>=I))return f;return f}let y;s.reset(0);do if(y=s.next(n),y&&(u[f++]=(0,T.$3C)(new P.$ct(i,y.index+1+g,i,y.index+1+y[0].length+g),y,b),f>=I))return f;while(y);return f}insert(t,s,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==A.$RC){const{node:i,remainder:g,nodeStartOffset:f}=this.G(t),u=i.piece,b=u.bufferIndex,I=this.s(i,g);if(i.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&f+u.length===t&&s.length<$){this.F(i,s),this.y();return}if(f===t)this.o(s,i),this.h.validate(t);else if(f+i.piece.length>t){const D=[];let y=new S(u.bufferIndex,I,u.end,this.t(u.bufferIndex,I,u.end),this.u(b,u.end)-this.u(b,I));if(this.K()&&this.M(s)&&this.I(i,g)===10){const v={line:y.start.line+1,column:0};y=new S(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(i,g-1)===13){const v=this.s(i,g-1);this.C(i,v),s="\r"+s,i.piece.length===0&&D.push(i)}else this.C(i,I);else this.C(i,I);const p=this.w(s);y.length>0&&this.S(i,y);let k=i;for(let m=0;m<p.length;m++)k=this.S(k,p[m]);this.v(D)}else this.q(s,i)}else{const i=this.w(s);let g=this.T(null,i[0]);for(let f=1;f<i.length;f++)g=this.S(g,i[f])}this.y()}delete(t,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$RC)return;const n=this.G(t),i=this.G(t+s),g=n.node,f=i.node;if(g===f){const p=this.s(g,n.remainder),k=this.s(g,i.remainder);if(n.nodeStartOffset===t){if(s===g.piece.length){const m=g.next();(0,A.$WC)(this,g),this.N(m),this.y();return}this.D(g,k),this.h.validate(t),this.N(g),this.y();return}if(n.nodeStartOffset+g.piece.length===t+s){this.C(g,p),this.O(g),this.y();return}this.E(g,p,k),this.y();return}const u=[],b=this.s(g,n.remainder);this.C(g,b),this.h.validate(t),g.piece.length===0&&u.push(g);const I=this.s(f,i.remainder);this.D(f,I),f.piece.length===0&&u.push(f);const D=g.next();for(let p=D;p!==A.$RC&&p!==f;p=p.next())u.push(p);const y=g.piece.length===0?g.prev():g;this.v(u),this.O(y),this.y()}o(t,s){const n=[];if(this.K()&&this.M(t)&&this.L(s)){const f=s.piece,u={line:f.start.line+1,column:0},b=new S(f.bufferIndex,u,f.end,this.t(f.bufferIndex,u,f.end),f.length-1);s.piece=b,t+=`
`,(0,A.$YC)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const i=this.w(t);let g=this.T(s,i[i.length-1]);for(let f=i.length-2;f>=0;f--)g=this.T(g,i[f]);this.N(g),this.v(n)}q(t,s){this.Q(t,s)&&(t+=`
`);const n=this.w(t),i=this.S(s,n[0]);let g=i;for(let f=1;f<n.length;f++)g=this.S(g,n[f]);this.N(i)}s(t,s,n){const i=t.piece,g=t.piece.bufferIndex,f=this.a[g].lineStarts,b=f[i.start.line]+i.start.column+s;let I=i.start.line,D=i.end.line,y=0,p=0,k=0;for(;I<=D&&(y=I+(D-I)/2|0,k=f[y],y!==D);)if(p=f[y+1],b<k)D=y-1;else if(b>=p)I=y+1;else break;return n?(n.line=y,n.column=b-k,null):{line:y,column:b-k}}t(t,s,n){if(n.column===0)return n.line-s.line;const i=this.a[t].lineStarts;if(n.line===i.length-1)return n.line-s.line;const g=i[n.line+1],f=i[n.line]+n.column;if(g>f+1)return n.line-s.line;const u=f-1;return this.a[t].buffer.charCodeAt(u)===13?n.line-s.line+1:n.line-s.line}u(t,s){return this.a[t].lineStarts[s.line]+s.column}v(t){for(let s=0;s<t.length;s++)(0,A.$WC)(this,t[s])}w(t){if(t.length>$){const D=[];for(;t.length>$;){const p=t.charCodeAt($-1);let k;p===E.CharCode.CarriageReturn||p>=55296&&p<=56319?(k=t.substring(0,$-1),t=t.substring($-1)):(k=t.substring(0,$),t=t.substring($));const m=w(k);D.push(new S(this.a.length,{line:0,column:0},{line:m.length-1,column:k.length-m[m.length-1]},m.length-1,k.length)),this.a.push(new d(k,m))}const y=w(t);return D.push(new S(this.a.length,{line:0,column:0},{line:y.length-1,column:t.length-y[y.length-1]},y.length-1,t.length)),this.a.push(new d(t,y)),D}let s=this.a[0].buffer.length;const n=w(t,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let D=0;D<n.length;D++)n[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let D=0;D<n.length;D++)n[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=t}const g=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,u=g-this.a[0].lineStarts[f],b={line:f,column:u},I=new S(0,i,b,this.t(0,i,b),g-s);return this.g=b,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,s=0){let n=this.root,i="";const g=this.h.get2(t);if(g){n=g.node;const f=this.B(n,t-g.nodeStartLineNumber-1),u=this.a[n.piece.bufferIndex].buffer,b=this.u(n.piece.bufferIndex,n.piece.start);if(g.nodeStartLineNumber+n.piece.lineFeedCnt===t)i=u.substring(b+f,b+n.piece.length);else{const I=this.B(n,t-g.nodeStartLineNumber);return u.substring(b+f,b+I-s)}}else{let f=0;const u=t;for(;n!==A.$RC;)if(n.left!==A.$RC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const b=this.B(n,t-n.lf_left-2),I=this.B(n,t-n.lf_left-1),D=this.a[n.piece.bufferIndex].buffer,y=this.u(n.piece.bufferIndex,n.piece.start);return f+=n.size_left,this.h.set({node:n,nodeStartOffset:f,nodeStartLineNumber:u-(t-1-n.lf_left)}),D.substring(y+b,y+I-s)}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const b=this.B(n,t-n.lf_left-2),I=this.a[n.piece.bufferIndex].buffer,D=this.u(n.piece.bufferIndex,n.piece.start);i=I.substring(D+b,D+n.piece.length);break}else t-=n.lf_left+n.piece.lineFeedCnt,f+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==A.$RC;){const f=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const u=this.B(n,0),b=this.u(n.piece.bufferIndex,n.piece.start);return i+=f.substring(b,b+u-s),i}else{const u=this.u(n.piece.bufferIndex,n.piece.start);i+=f.substr(u,n.piece.length)}n=n.next()}return i}y(){let t=this.root,s=1,n=0;for(;t!==A.$RC;)s+=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;this.b=s,this.c=n,this.h.validate(this.c)}A(t,s){const n=t.piece,i=this.s(t,s),g=i.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===s){const f=this.t(t.piece.bufferIndex,n.start,i);if(f!==g)return{index:f,remainder:0}}return{index:g,remainder:i.column}}B(t,s){if(s<0)return 0;const n=t.piece,i=this.a[n.bufferIndex].lineStarts,g=n.start.line+s+1;return g>n.end.line?i[n.end.line]+n.end.column-i[n.start.line]-n.start.column:i[g]-i[n.start.line]-n.start.column}C(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.end),f=s,u=this.u(n.bufferIndex,f),b=this.t(n.bufferIndex,n.start,f),I=b-i,D=u-g,y=n.length+D;t.piece=new S(n.bufferIndex,n.start,f,b,y),(0,A.$YC)(this,t,D,I)}D(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.start),f=s,u=this.t(n.bufferIndex,f,n.end),b=this.u(n.bufferIndex,f),I=u-i,D=g-b,y=n.length+D;t.piece=new S(n.bufferIndex,f,n.end,u,y),(0,A.$YC)(this,t,D,I)}E(t,s,n){const i=t.piece,g=i.start,f=i.end,u=i.length,b=i.lineFeedCnt,I=s,D=this.t(i.bufferIndex,i.start,I),y=this.u(i.bufferIndex,s)-this.u(i.bufferIndex,g);t.piece=new S(i.bufferIndex,i.start,I,D,y),(0,A.$YC)(this,t,y-u,D-b);const p=new S(i.bufferIndex,n,f,this.t(i.bufferIndex,n,f),this.u(i.bufferIndex,f)-this.u(i.bufferIndex,n)),k=this.S(t,p);this.N(k)}F(t,s){this.Q(s,t)&&(s+=`
`);const n=this.K()&&this.L(s)&&this.M(t),i=this.a[0].buffer.length;this.a[0].buffer+=s;const g=w(s,!1);for(let k=0;k<g.length;k++)g[k]+=i;if(n){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(g.slice(1));const f=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[f],b={line:f,column:u},I=t.piece.length+s.length,D=t.piece.lineFeedCnt,y=this.t(0,t.piece.start,b),p=y-D;t.piece=new S(t.piece.bufferIndex,t.piece.start,b,y,I),this.g=b,(0,A.$YC)(this,t,s.length,p)}G(t){let s=this.root;const n=this.h.get(t);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:t-n.nodeStartOffset};let i=0;for(;s!==A.$RC;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){i+=s.size_left;const g={node:s,remainder:t-s.size_left,nodeStartOffset:i};return this.h.set(g),g}else t-=s.size_left+s.piece.length,i+=s.size_left+s.piece.length,s=s.right;return null}H(t,s){let n=this.root,i=0;for(;n!==A.$RC;)if(n.left!==A.$RC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const g=this.B(n,t-n.lf_left-2),f=this.B(n,t-n.lf_left-1);return i+=n.size_left,{node:n,remainder:Math.min(g+s-1,f),nodeStartOffset:i}}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const g=this.B(n,t-n.lf_left-2);if(g+s-1<=n.piece.length)return{node:n,remainder:g+s-1,nodeStartOffset:i};s-=n.piece.length-g;break}else t-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==A.$RC;){if(n.piece.lineFeedCnt>0){const g=this.B(n,0),f=this.J(n);return{node:n,remainder:Math.min(s-1,g),nodeStartOffset:f}}else if(n.piece.length>=s-1){const g=this.J(n);return{node:n,remainder:s-1,nodeStartOffset:g}}else s-=n.piece.length;n=n.next()}return null}I(t,s){if(t.piece.lineFeedCnt<1)return-1;const n=this.a[t.piece.bufferIndex],i=this.u(t.piece.bufferIndex,t.piece.start)+s;return n.buffer.charCodeAt(i)}J(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===A.$RC||t.piece.lineFeedCnt===0)return!1;const s=t.piece,n=this.a[s.bufferIndex].lineStarts,i=s.start.line,g=n[i]+s.start.column;return i===n.length-1||n[i+1]>g+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(g)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===A.$RC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const s=t.prev();this.M(s)&&this.P(s,t)}}O(t){if(this.K()&&this.M(t)){const s=t.next();this.L(s)&&this.P(t,s)}}P(t,s){const n=[],i=this.a[t.piece.bufferIndex].lineStarts;let g;t.piece.end.column===0?g={line:t.piece.end.line-1,column:i[t.piece.end.line]-i[t.piece.end.line-1]-1}:g={line:t.piece.end.line,column:t.piece.end.column-1};const f=t.piece.length-1,u=t.piece.lineFeedCnt-1;t.piece=new S(t.piece.bufferIndex,t.piece.start,g,u,f),(0,A.$YC)(this,t,-1,-1),t.piece.length===0&&n.push(t);const b={line:s.piece.start.line+1,column:0},I=s.piece.length-1,D=this.t(s.piece.bufferIndex,b,s.piece.end);s.piece=new S(s.piece.bufferIndex,b,s.piece.end,D,I),(0,A.$YC)(this,s,-1,-1),s.piece.length===0&&n.push(s);const y=this.w(`\r
`);this.S(t,y[0]);for(let p=0;p<n.length;p++)(0,A.$WC)(this,n[p])}Q(t,s){if(this.K()&&this.M(t)){const n=s.next();if(this.L(n)){if(t+=`
`,n.piece.length===1)(0,A.$WC)(this,n);else{const i=n.piece,g={line:i.start.line+1,column:0},f=i.length-1,u=this.t(i.bufferIndex,g,i.end);n.piece=new S(i.bufferIndex,g,i.end,u,f),(0,A.$YC)(this,n,-1,-1)}return!0}}return!1}iterate(t,s){if(t===A.$RC)return s(A.$RC);const n=this.iterate(t.left,s);return n&&s(t)&&this.iterate(t.right,s)}R(t){if(t===A.$RC)return"";const s=this.a[t.piece.bufferIndex],n=t.piece,i=this.u(n.bufferIndex,n.start),g=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,g)}getPieceContent(t){const s=this.a[t.bufferIndex],n=this.u(t.bufferIndex,t.start),i=this.u(t.bufferIndex,t.end);return s.buffer.substring(n,i)}S(t,s){const n=new A.$QC(s,A.NodeColor.Red);if(n.left=A.$RC,n.right=A.$RC,n.parent=A.$RC,n.size_left=0,n.lf_left=0,this.root===A.$RC)this.root=n,n.color=A.NodeColor.Black;else if(t.right===A.$RC)t.right=n,n.parent=t;else{const g=(0,A.$SC)(t.right);g.left=n,n.parent=g}return(0,A.$XC)(this,n),n}T(t,s){const n=new A.$QC(s,A.NodeColor.Red);if(n.left=A.$RC,n.right=A.$RC,n.parent=A.$RC,n.size_left=0,n.lf_left=0,this.root===A.$RC)this.root=n,n.color=A.NodeColor.Black;else if(t.left===A.$RC)t.left=n,n.parent=t;else{const i=(0,A.$TC)(t.left);i.right=n,n.parent=i}return(0,A.$XC)(this,n),n}U(t){let s="";return this.iterate(t,n=>(s+=this.R(n),!0)),s}}e.$$C=a}),define(ke[152],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20=e.$10=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$10=E;class R{constructor(O){this.identifier=O}}e.$20=R}),define(ke[153],Ie([8,9]),function(de,e){return de.create("vs/base/common/actions",e)}),define(ke[154],Ie([1,0,4,6,153]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=C;class O extends R.$Uc{constructor(l,S="",d="",r=!0,o){super(),this.j=this.B(new E.$he),this.onDidChange=this.j.event,this.z=!0,this.m=l,this.n=S,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.j.fire({label:l}))}get tooltip(){return this.u||""}set tooltip(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.j.fire({tooltip:l}))}get class(){return this.w}set class(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.j.fire({class:l}))}get enabled(){return this.z}set enabled(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.j.fire({enabled:l}))}get checked(){return this.C}set checked(l){this.J(l)}J(l){this.C!==l&&(this.C=l,this.j.fire({checked:l}))}async run(l,S){this.D&&await this.D(l)}}e.$fj=O;class A extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new E.$he),this.onWillRun=this.f.event,this.m=this.B(new E.$he),this.onDidRun=this.m.event}async run(l,S){if(!l.enabled)return;this.f.fire({action:l});let d;try{await this.u(l,S)}catch(r){d=r}this.m.fire({action:l,error:d})}async u(l,S){await l.run(S)}}e.$gj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let S=[];for(const d of l)d.length&&(S.length?S=[...S,new T,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=T;class ${get actions(){return this.a}constructor(l,S,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=S,this.class=r,this.a=d}async run(){}}e.$ij=$;class c extends O{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$jj=c;function C(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...l)=>w.run(...l)}}}),define(ke[155],Ie([8,9]),function(de,e){return de.create("vs/base/common/date",e)}),define(ke[156],Ie([1,0,155]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=c,e.$8m=C,e.$9m=w;const R=60,P=R*60,O=P*24,A=O*7,T=O*30,$=O*365;function c(l,S,d,r){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,E.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,E.localize)(1,null);let a;return o<R?(a=o,S?a===1?d?(0,E.localize)(2,null,a):(0,E.localize)(3,null,a):d?(0,E.localize)(4,null,a):(0,E.localize)(5,null,a):a===1?d?(0,E.localize)(6,null,a):(0,E.localize)(7,null,a):d?(0,E.localize)(8,null,a):(0,E.localize)(9,null,a)):o<P?(a=Math.floor(o/R),S?a===1?d?(0,E.localize)(10,null,a):(0,E.localize)(11,null,a):d?(0,E.localize)(12,null,a):(0,E.localize)(13,null,a):a===1?d?(0,E.localize)(14,null,a):(0,E.localize)(15,null,a):d?(0,E.localize)(16,null,a):(0,E.localize)(17,null,a)):o<O?(a=Math.floor(o/P),S?a===1?d?(0,E.localize)(18,null,a):(0,E.localize)(19,null,a):d?(0,E.localize)(20,null,a):(0,E.localize)(21,null,a):a===1?d?(0,E.localize)(22,null,a):(0,E.localize)(23,null,a):d?(0,E.localize)(24,null,a):(0,E.localize)(25,null,a)):o<A?(a=Math.floor(o/O),S?a===1?(0,E.localize)(26,null,a):(0,E.localize)(27,null,a):a===1?(0,E.localize)(28,null,a):(0,E.localize)(29,null,a)):o<T?(a=Math.floor(o/A),S?a===1?d?(0,E.localize)(30,null,a):(0,E.localize)(31,null,a):d?(0,E.localize)(32,null,a):(0,E.localize)(33,null,a):a===1?d?(0,E.localize)(34,null,a):(0,E.localize)(35,null,a):d?(0,E.localize)(36,null,a):(0,E.localize)(37,null,a)):o<$?(a=Math.floor(o/T),S?a===1?d?(0,E.localize)(38,null,a):(0,E.localize)(39,null,a):d?(0,E.localize)(40,null,a):(0,E.localize)(41,null,a):a===1?d?(0,E.localize)(42,null,a):(0,E.localize)(43,null,a):d?(0,E.localize)(44,null,a):(0,E.localize)(45,null,a)):(a=Math.floor(o/$),S?a===1?d?(0,E.localize)(46,null,a):(0,E.localize)(47,null,a):d?(0,E.localize)(48,null,a):(0,E.localize)(49,null,a):a===1?d?(0,E.localize)(50,null,a):(0,E.localize)(51,null,a):d?(0,E.localize)(52,null,a):(0,E.localize)(53,null,a))}function C(l,S){const d=Math.abs(l/1e3);return d<1?S?(0,E.localize)(54,null,l):(0,E.localize)(55,null,l):d<R?S?(0,E.localize)(56,null,Math.round(l)/1e3):(0,E.localize)(57,null,Math.round(l)/1e3):d<P?S?(0,E.localize)(58,null,Math.round(l/(1e3*R))):(0,E.localize)(59,null,Math.round(l/(1e3*R))):d<O?S?(0,E.localize)(60,null,Math.round(l/(1e3*P))):(0,E.localize)(61,null,Math.round(l/(1e3*P))):(0,E.localize)(62,null,Math.round(l/(1e3*O)))}function w(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[157],Ie([8,9]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(ke[48],Ie([1,0,18,15,157]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=$,e.$mj=c,e.$nj=C;function O(w,l){return l&&(w.stack||w.stacktrace)?P.localize(0,null,T(w),A(w.stack)||A(w.stacktrace)):T(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function T(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(1,null,w.message):w.message||P.localize(2,null)}function $(w=null,l=!1){if(!w)return P.localize(3,null);if(Array.isArray(w)){const S=E.$Hb(w),d=$(S[0],l);return S.length>1?P.localize(4,null,d,S.length):d}if(R.$ag(w))return w;if(w.detail){const S=w.detail;if(S.error)return O(S.error,l);if(S.exception)return O(S.exception,l)}return w.stack?O(w,l):w.message?w.message:P.localize(5,null)}function c(w){const l=w;return l instanceof Error&&Array.isArray(l.actions)}function C(w,l){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=l,S}}),define(ke[158],Ie([1,0,47,20]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=T,e.$pr=$,e.$qr=c,e.$rr=C,e.$sr=w,e.$tr=l,e.$ur=S,e.$vr=d,e.$wr=r,e.$xr=o,e.$yr=b,e.$zr=I,e.$Ar=D;const P=new E.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),O=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,p,k=!1){const m=y||"",v=p||"",F=P.value.collator.compare(m,v);return P.value.collatorIsNumeric&&F===0&&m!==v?m<v?-1:1:F}function $(y,p){const k=O.value.collator;return y=y||"",p=p||"",s(k,y,p)}function c(y,p){const k=O.value.collator;return y=y||"",p=p||"",f(y,p)||s(k,y,p)}function C(y,p){const k=O.value.collator;return y=y||"",p=p||"",g(y,p)||s(k,y,p)}function w(y,p){return y=y||"",p=p||"",y===p?0:y<p?-1:1}function l(y,p){const[k,m]=h(y),[v,F]=h(p);let M=P.value.collator.compare(m,F);if(M===0){if(P.value.collatorIsNumeric&&m!==F)return m<F?-1:1;if(M=P.value.collator.compare(k,v),P.value.collatorIsNumeric&&M===0&&k!==v)return k<v?-1:1}return M}function S(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),v=O.value.collator,F=A.value.collator;return s(F,k,m)||s(v,y,p)}function d(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),v=O.value.collator,F=A.value.collator;return s(F,k,m)||f(y,p)||s(v,y,p)}function r(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),v=O.value.collator,F=A.value.collator;return s(F,k,m)||g(y,p)||s(v,y,p)}function o(y,p){y=y||"",p=p||"";const k=t(y).toLowerCase(),m=t(p).toLowerCase();return k!==m?k<m?-1:1:y!==p?y<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(y,p=!1){const k=y?a.exec(y):[];let m=[k&&k[1]||"",k&&k[3]||""];return p&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function t(y){const p=y?a.exec(y):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function s(y,p,k){const m=y.compare(p,k);return m!==0?m:p.length!==k.length?p.length<k.length?-1:1:0}function n(y){const p=y.charAt(0);return p.toLocaleUpperCase()!==p}function i(y){const p=y.charAt(0);return p.toLocaleLowerCase()!==p}function g(y,p){return n(y)&&i(p)?-1:i(y)&&n(p)?1:0}function f(y,p){return i(y)&&n(p)?-1:n(y)&&i(p)?1:0}function u(y,p,k=!1){return k||(y=y&&y.toLowerCase(),p=p&&p.toLowerCase()),y===p?0:y<p?-1:1}function b(y,p,k=!1){const m=y.split(R.sep),v=p.split(R.sep),F=m.length-1,M=v.length-1;let G,q;for(let V=0;;V++){if(G=F===V,q=M===V,G&&q)return T(m[V],v[V],k);if(G)return-1;if(q)return 1;const N=u(m[V],v[V],k);if(N!==0)return N}}function I(y,p,k){const m=y.toLowerCase(),v=p.toLowerCase(),F=D(y,p,k);if(F)return F;const M=m.endsWith(k),G=v.endsWith(k);if(M!==G)return M?-1:1;const q=T(m,v);return q!==0?q:m.localeCompare(v)}function D(y,p,k){const m=y.toLowerCase(),v=p.toLowerCase(),F=m.startsWith(k),M=v.startsWith(k);if(F!==M)return F?-1:1;if(F&&M){if(m.length<v.length)return-1;if(m.length>v.length)return 1}return 0}}),define(ke[53],Ie([1,0,28,20,21,13,15]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=T,e.$tg=$,e.$ug=c,e.$vg=C,e.$wg=w,e.$xg=r,e.$yg=o,e.$zg=a,e.$Ag=h,e.$Bg=t,e.$Cg=s,e.$Dg=n,e.$Eg=i,e.$Fg=g,e.$Gg=f,e.$Hg=u,e.$Ig=D;function T(y){return y===E.CharCode.Slash||y===E.CharCode.Backslash}function $(y){return y.replace(/[\\/]/g,R.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=$(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function C(y,p=R.$gc.sep){if(!y)return"";const k=y.length,m=y.charCodeAt(0);if(T(m)){if(T(y.charCodeAt(1))&&!T(y.charCodeAt(2))){let F=3;const M=F;for(;F<k&&!T(y.charCodeAt(F));F++);if(M!==F&&!T(y.charCodeAt(F+1))){for(F+=1;F<k;F++)if(T(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,p)}}return p}else if(h(m)&&y.charCodeAt(1)===E.CharCode.Colon)return T(y.charCodeAt(2))?y.slice(0,2)+p:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<k;v++)if(T(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function w(y){if(!P.$i||!y||y.length<5)return!1;let p=y.charCodeAt(0);if(p!==E.CharCode.Backslash||(p=y.charCodeAt(1),p!==E.CharCode.Backslash))return!1;let k=2;const m=k;for(;k<y.length&&(p=y.charCodeAt(k),p!==E.CharCode.Backslash);k++);return!(m===k||(p=y.charCodeAt(k+1),isNaN(p)||p===E.CharCode.Backslash))}const l=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(y,p=P.$i){const k=p?l:S;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||p&&d.test(y)||y==="."||y===".."||p&&y[y.length-1]==="."||p&&y.length!==y.trim().length||y.length>255)}function o(y,p,k){const m=y===p;return!k||m?m:!y||!p?!1:(0,O.$Bf)(y,p)}function a(y,p,k,m=R.sep){if(y===p)return!0;if(!y||!p||p.length>y.length)return!1;if(k){if(!(0,O.$Cf)(y,p))return!1;if(p.length===y.length)return!0;let F=p.length;return p.charAt(p.length-1)===m&&F--,y.charAt(F)===m}return p.charAt(p.length-1)!==m&&(p+=m),y.indexOf(p)===0}function h(y){return y>=E.CharCode.A&&y<=E.CharCode.Z||y>=E.CharCode.a&&y<=E.CharCode.z}function t(y,p){return P.$i&&y.endsWith(":")&&(y+=R.sep),(0,R.$ic)(y)||(y=(0,R.$jc)(p,y)),y=(0,R.$hc)(y),s(y)}function s(y){return P.$i?(y=(0,O.$jf)(y,R.sep),y.endsWith(":")&&(y+=R.sep)):(y=(0,O.$jf)(y,R.sep),y||(y=R.sep)),y}function n(y){const p=(0,R.$hc)(y);return P.$i?y.length>3?!1:i(p)&&(y.length===2||p.charCodeAt(2)===E.CharCode.Backslash):p===R.$gc.sep}function i(y,p=P.$i){return p?h(y.charCodeAt(0))&&y.charCodeAt(1)===E.CharCode.Colon:!1}function g(y,p=P.$i){return i(y,p)?y[0]:void 0}function f(y,p,k){return p.length>y.length?-1:y===p?0:(k&&(y=y.toLowerCase(),p=p.toLowerCase()),y.indexOf(p))}function u(y){const p=y.split(":");let k,m,v;for(const F of p){const M=Number(F);(0,A.$eg)(M)?m===void 0?m=M:v===void 0&&(v=M):k=k?[k,F].join(":"):F}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:m!==void 0?m:void 0,column:v!==void 0?v:m!==void 0?1:void 0}}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,p,k=8){let m="";for(let F=0;F<k;F++){let M;F===0&&P.$i&&!p&&(k===3||k===4)?M=I:M=b,m+=M.charAt(Math.floor(Math.random()*M.length))}let v;return p?v=`${p}-${m}`:v=m,y?(0,R.$jc)(y,v):v}}),define(ke[73],Ie([1,0,20]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Zs=O,e.$1s=A,e.$2s=T,e.$3s=c,e.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(C){const w=(0,E.$oc)(C),l=R[w.toLowerCase()];return l!==void 0?l:A(C)}function A(C){const w=(0,E.$oc)(C);return P[w.toLowerCase()]}function T(C){for(const w in P)if(P[w]===C)return w}const $=/^(.+)\/(.+?)(;.+)?$/;function c(C,w){const l=$.exec(C);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:w?void 0:C}}),define(ke[49],Ie([1,0,23,2,37]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=O,e.$9h=A,e.$0h=$;function O(c){return JSON.stringify(c,T)}function A(c){let C=JSON.parse(c);return C=$(C),C}function T(c,C){return C instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function $(c,C=0){if(!c||C>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return R.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof E.$Je||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let w=0;w<c.length;++w)c[w]=$(c[w],C+1);else for(const w in c)Object.hasOwnProperty.call(c,w)&&(c[w]=$(c[w],C+1))}return c}}),define(ke[16],Ie([1,0,14,21,13,2,20]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=$,e.$Kg=c,e.$Og=w;var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(d,r){return O.URI.isUri(d)?(0,P.$Bf)(d.scheme,r):(0,P.$Cf)(d,r+":")}function c(d,...r){return r.some(o=>$(d,o))}e.$Lg="vscode-tkn",e.$Mg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=w(r,o)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,T.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(n){return E.$1(n),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],t=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof t=="string"&&(s+=`&${e.$Mg}=${encodeURIComponent(t)}`),O.URI.from({scheme:R.$o?this.d:T.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Ng=new C;function w(d,r){return A.$gc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class l{static{this.a=e.$Tg}asBrowserUri(r){const o=this.b(r,de);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===T.vscodeRemote?e.$Ng.rewrite(r):r.scheme===T.file&&(R.$m||R.$q===`${T.vscodeFileResource}://${l.a}`)?r.with({scheme:T.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,de);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===T.vscodeFileResource?r.with({scheme:T.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Ug=new l;var S;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(t){let s;typeof t=="string"?s=new URL(t).searchParams:t instanceof URL?s=t.searchParams:O.URI.isUri(t)&&(s=new URL(t.toString(!0)).searchParams);const n=s?.get(o);if(n)return r.get(n)}d.getHeadersFromQuery=a;function h(t,s,n){if(!globalThis.crossOriginIsolated)return;const i=s&&n?"3":n?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}d.addSearchParam=h})(S||(e.COI=S={}))}),define(ke[24],Ie([1,0,28,53,16,20,21,13,2]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=c,e.$kh=w,e.$lh=S;function c(d){return(0,$.$wc)(d,!0)}class C{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,T.$uf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return R.$zg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$gh)(r.authority,o.authority))return R.$zg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return $.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$$g)(r)||r.authority}basename(r){return O.$gc.basename(r.path)}extname(r){return O.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$mc(c(r))).path:(o=O.$gc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==E.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$hc(c(r))).path:o=O.$gc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$gh)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const t=O.$lc(c(r),c(o));return A.$i?R.$tg(t):t}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let t=0;for(const s=Math.min(a.length,h.length);t<s&&!(a.charCodeAt(t)!==h.charCodeAt(t)&&a.charAt(t).toLowerCase()!==h.charAt(t).toLowerCase());t++);a=h.substr(0,t)+a.substr(t)}return O.$gc.relative(a,h)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=$.URI.file(O.$kc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=R.$ug(o),r.with({path:O.$gc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,T.$Bf)(r,o)}hasTrailingPathSeparator(r,o=O.sep){if(r.scheme===P.Schemas.file){const a=c(r);return a.length>R.$vg(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===E.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=O.sep){return(0,e.$hh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=O.sep){let a=!1;if(r.scheme===P.Schemas.file){const h=c(r);a=h!==void 0&&h.length===R.$vg(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===E.CharCode.Slash}return!a&&!(0,e.$hh)(r,o)?r.with({path:r.path+"/"}):r}}e.$3g=C,e.$4g=new C(()=>!1),e.$5g=new C(d=>d.scheme===P.Schemas.file?!A.$k:!0),e.$6g=new C(d=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function w(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((t,s)=>s===a?!1:(0,e.$8g)(h,r(t)))||o.push(d[a])}return o}var l;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,i]=s.split(":");n&&i&&a.set(n,i)});const t=o.path.substring(0,o.path.indexOf(";"));return t&&a.set(d.META_DATA_MIME,t),a}d.parseMetaData=r})(l||(e.DataUri=l={}));function S(d,r,o){if(r){let a=d.path;return a&&a[0]!==O.$gc.sep&&(a=O.$gc.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(ke[11],Ie([1,0,22,14,4,6,24,21,144,47]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=C,e.$nh=w,e.$oh=l,e.$ph=S,e.$qh=d,e.$rh=r,e.$sh=o,e.$th=a,e.$Bh=I,e.$Ch=D,e.$Dh=y,e.$Eh=p,e.$Fh=k,e.$Uh=be,e.$3h=he;function C(ae){return!!ae&&typeof ae.then=="function"}function w(ae){const X=new E.$se,x=ae(X.token),me=new Promise((ge,Me)=>{const Be=X.token.onCancellationRequested(()=>{Be.dispose(),Me(new R.$5)});Promise.resolve(x).then(Ee=>{Be.dispose(),X.dispose(),ge(Ee)},Ee=>{Be.dispose(),X.dispose(),Me(Ee)})});return new class{cancel(){X.cancel(),X.dispose()}then(ge,Me){return me.then(ge,Me)}catch(ge){return this.then(void 0,ge)}finally(ge){return me.finally(ge)}}}function l(ae,X,x){return new Promise((me,ge)=>{const Me=X.onCancellationRequested(()=>{Me.dispose(),me(x)});ae.then(me,ge).finally(()=>Me.dispose())})}function S(ae,X){return new Promise((x,me)=>{const ge=X.onCancellationRequested(()=>{ge.dispose(),me(new R.$5)});ae.then(x,me).finally(()=>ge.dispose())})}async function d(ae){let X=-1;const x=ae.map((me,ge)=>me.then(Me=>(X=ge,Me)));try{return await Promise.race(x)}finally{ae.forEach((me,ge)=>{ge!==X&&me.cancel()})}}function r(ae,X,x){let me;const ge=setTimeout(()=>{me?.(void 0),x?.()},X);return Promise.race([ae.finally(()=>clearTimeout(ge)),new Promise(Me=>me=Me)])}function o(ae){return new Promise((X,x)=>{const me=ae();C(me)?me.then(X,x):X(me)})}function a(){let ae,X;return{promise:new Promise((me,ge)=>{ae=me,X=ge}),resolve:ae,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=X(),new Promise((x,me)=>{this.a.then(ge=>{this.a=null,x(ge)},ge=>{this.a=null,me(ge)})})}dispose(){this.f=!0}}e.$uh=h;class t{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$vh=t;class s{constructor(){this.a=new Map}queue(X,x){const ge=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===ge&&this.a.delete(X)});return this.a.set(X,ge),ge}}e.$wh=s;const n=(ae,X)=>{let x=!0;const me=setTimeout(()=>{x=!1,X()},ae);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},i=ae=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ae())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class g{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ge,Me)=>{this.d=ge,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ce?i(me):n(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=g;class f{constructor(X){this.a=new g(X),this.b=new h}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=f;class u{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=u;class b extends u{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ah=b;function I(ae,X){return X?new Promise((x,me)=>{const ge=setTimeout(()=>{Me.dispose(),x()},ae),Me=X.onCancellationRequested(()=>{clearTimeout(ge),Me.dispose(),me(new R.$5)})}):w(x=>I(ae,x))}function D(ae,X=0,x){const me=setTimeout(()=>{ae(),x&&ge.dispose()},X),ge=(0,O.$Sc)(()=>{clearTimeout(me),x?.deleteAndLeak(ge)});return x?.add(ge),ge}function y(ae){const X=[];let x=0;const me=ae.length;function ge(){return x<me?ae[x++]():null}function Me(Be){Be!=null&&X.push(Be);const Ee=ge();return Ee?Ee.then(Me):Promise.resolve(X)}return Promise.resolve(null).then(Me)}function p(ae,X=me=>!!me,x=null){let me=0;const ge=ae.length,Me=()=>{if(me>=ge)return Promise.resolve(x);const Be=ae[me++];return Promise.resolve(Be()).then(Re=>X(Re)?Promise.resolve(Re):Me())};return Me()}function k(ae,X=me=>!!me,x=null){if(ae.length===0)return Promise.resolve(x);let me=ae.length;const ge=()=>{me=-1;for(const Me of ae)Me.cancel?.()};return new Promise((Me,Be)=>{for(const Ee of ae)Ee.then(Re=>{--me>=0&&X(Re)?(ge(),Me(Re)):me===0&&Me(x)}).catch(Re=>{--me>=0&&(ge(),Be(Re))})})}class m{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$he}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:X,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=m;class v extends m{constructor(){super(1)}}e.$Hh=v;class F{constructor(){this.a=new oe,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Ih=F;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new se;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=A.$4g){const me=x.getComparisonKey(X);return this.a.get(me)?.size??0}queueFor(X,x,me=A.$4g){const ge=me.getComparisonKey(X);let Me=this.a.get(ge);if(!Me){Me=new v;const Be=this.f++,Ee=P.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Be,Ee),this.a.set(ge,Me)}return Me.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=M;class G{constructor(X,x){this.b=!1,this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){if(this.b)throw new R.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){if(this.b)throw new R.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$Kh=G;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,me=globalThis){if(this.f)throw new R.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=me.setInterval(()=>{X()},x);this.d=(0,O.$Sc)(()=>{me.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=q;class V{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=V;class N{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=N;class L extends V{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Oh=L;class Z extends O.$Uc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ae,X)=>{(0,T.$B)(()=>{if(x)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Rh=(ae,X,x)=>{const me=ae.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ae.cancelIdleCallback(me))}}},e.$Qh=ae=>(0,e.$Rh)(globalThis,ae)}();class re{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Rh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=re;class fe extends re{constructor(X){super(globalThis,X)}}e.$Th=fe;async function be(ae,X,x){let me;for(let ge=0;ge<x;ge++)try{return await ae()}catch(Me){me=Me,await I(X)}throw me}class oe{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,me){return this.a={taskId:X,cancel:()=>me?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:me,reject:ge}=a();this.b={run:X,promise:x,promiseResolve:me,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=oe;class pe{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Wh=pe;var $e;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})($e||($e={}));class se{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:$e.Resolved,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:$e.Rejected,value:X},x()})}cancel(){return this.error(new R.$5)}}e.$Xh=se;var Ce;(function(ae){async function X(me){let ge;const Me=await Promise.all(me.map(Be=>Be.then(Ee=>Ee,Ee=>{ge||(ge=Ee)})));if(typeof ge<"u")throw ge;return Me}ae.settled=X;function x(me){return new Promise(async(ge,Me)=>{try{await me(ge,Me)}catch(Be){Me(Be)}})}ae.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Fe;class Y{constructor(X){this.b=X,this.a=new c.$V(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=Y;var W;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(W||(W={}));class ie{static fromArray(X){return new ie(x=>{x.emitMany(X)})}static fromPromise(X){return new ie(async x=>{x.emitMany(await X)})}static fromPromises(X){return new ie(async x=>{await Promise.all(X.map(async me=>x.emitOne(await me)))})}static merge(X){return new ie(async x=>{await Promise.all(X.map(async me=>{for await(const ge of me)x.emitOne(ge)}))})}static{this.EMPTY=ie.fromArray([])}constructor(X,x){this.a=W.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$he,queueMicrotask(async()=>{const me={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(X(me)),this.k()}catch(ge){this.l(ge)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,x){return new ie(async me=>{for await(const ge of X)me.emitOne(x(ge))})}map(X){return ie.map(this,X)}static filter(X,x){return new ie(async me=>{for await(const ge of X)x(ge)&&me.emitOne(ge)})}filter(X){return ie.filter(this,X)}static coalesce(X){return ie.filter(X,x=>!!x)}coalesce(){return ie.coalesce(this)}static async toPromise(X){const x=[];for await(const me of X)x.push(me);return x}toPromise(){return ie.toPromise(this)}h(X){this.a===W.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===W.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(X){this.a===W.Initial&&(this.a=W.DoneError,this.d=X,this.g.fire())}}e.$1h=ie;class De extends ie{constructor(X,x){super(x),this.m=X}cancel(){this.m.cancel()}}e.$2h=De;function he(ae){const X=new E.$se,x=ae(X.token);return new De(X,async me=>{const ge=X.token.onCancellationRequested(()=>{ge.dispose(),X.dispose(),me.reject(new R.$5)});try{for await(const Me of x){if(X.token.isCancellationRequested)return;me.emitOne(Me)}ge.dispose(),X.dispose()}catch(Me){ge.dispose(),X.dispose(),me.reject(Me)}})}class ve{constructor(X){this.a=new se,this.b=new ie(ge=>{if(x){ge.reject(x);return}return me&&ge.emitMany(me),this.d=Me=>ge.reject(Me),this.f=Me=>ge.emitOne(Me),this.a.p},X);let x,me;this.f=ge=>{me||(me=[]),me.push(ge)},this.d=ge=>{x||(x=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$4h=ve}),define(ke[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=C,e.$sk=r,e.$tk=F,e.$uk=M,e.$vk=G,e.$wk=q,e.$xk=V,e.$yk=re;function C(){return Object.create(null)}e.$qk="**",e.$rk="/";const w="[/\\\\]",l="[^/\\\\]",S=/\//g;function d(fe,be){switch(fe){case 0:return"";case 1:return`${l}*?`;default:return`(?:${w}|${l}+${w}${be?`|${w}${l}+`:""})*?`}}function r(fe,be){if(!fe)return[];const oe=[];let pe=!1,$e=!1,se="";for(const Ce of fe){switch(Ce){case be:if(!pe&&!$e){oe.push(se),se="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}se+=Ce}return se&&oe.push(se),oe}function o(fe){if(!fe)return"";let be="";const oe=r(fe,e.$rk);if(oe.every(pe=>pe===e.$qk))be=".*";else{let pe=!1;oe.forEach(($e,se)=>{if($e===e.$qk){if(pe)return;be+=d(2,se===oe.length-1)}else{let Ce=!1,Fe="",Y=!1,W="";for(const ie of $e){if(ie!=="}"&&Ce){Fe+=ie;continue}if(Y&&(ie!=="]"||!W)){let De;ie==="-"?De=ie:(ie==="^"||ie==="!")&&!W?De="^":ie===e.$rk?De="":De=(0,c.$df)(ie),W+=De;continue}switch(ie){case"{":Ce=!0;continue;case"[":Y=!0;continue;case"}":{const he=`(?:${r(Fe,",").map(ve=>o(ve)).join("|")})`;be+=he,Ce=!1,Fe="";break}case"]":{be+="["+W+"]",Y=!1,W="";break}case"?":be+=l;continue;case"*":be+=d(1);continue;default:be+=(0,c.$df)(ie)}}se<oe.length-1&&(oe[se+1]!==e.$qk||se+2<oe.length)&&(be+=w)}pe=$e===e.$qk})}return be}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new A.$Dc(1e4),f=function(){return!1},u=function(){return null};function b(fe,be){if(!fe)return u;let oe;typeof fe!="string"?oe=fe.pattern:oe=fe,oe=oe.trim();const pe=`${oe}_${!!be.trimForExclusions}`;let $e=g.get(pe);if($e)return I($e,fe);let se;return a.test(oe)?$e=y(oe.substr(4),oe):(se=h.exec(D(oe,be)))?$e=p(se[1],oe):(be.trimForExclusions?s:t).test(oe)?$e=k(oe,be):(se=n.exec(D(oe,be)))?$e=m(se[1].substr(1),oe,!0):(se=i.exec(D(oe,be)))?$e=m(se[1],oe,!1):$e=v(oe),g.set(pe,$e),I($e,fe)}function I(fe,be){if(typeof be=="string")return fe;const oe=function(pe,$e){return(0,O.$zg)(pe,be.base,!$.$k)?fe((0,c.$if)(pe.substr(be.base.length),T.sep),$e):null};return oe.allBasenames=fe.allBasenames,oe.allPaths=fe.allPaths,oe.basenames=fe.basenames,oe.patterns=fe.patterns,oe}function D(fe,be){return be.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function y(fe,be){return function(oe,pe){return typeof oe=="string"&&oe.endsWith(fe)?be:null}}function p(fe,be){const oe=`/${fe}`,pe=`\\${fe}`,$e=function(Ce,Fe){return typeof Ce!="string"?null:Fe?Fe===fe?be:null:Ce===fe||Ce.endsWith(oe)||Ce.endsWith(pe)?be:null},se=[fe];return $e.basenames=se,$e.patterns=[be],$e.allBasenames=se,$e}function k(fe,be){const oe=Z(fe.slice(1,-1).split(",").map(Fe=>b(Fe,be)).filter(Fe=>Fe!==u),fe),pe=oe.length;if(!pe)return u;if(pe===1)return oe[0];const $e=function(Fe,Y){for(let W=0,ie=oe.length;W<ie;W++)if(oe[W](Fe,Y))return fe;return null},se=oe.find(Fe=>!!Fe.allBasenames);se&&($e.allBasenames=se.allBasenames);const Ce=oe.reduce((Fe,Y)=>Y.allPaths?Fe.concat(Y.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function m(fe,be,oe){const pe=T.sep===T.$gc.sep,$e=pe?fe:fe.replace(S,T.sep),se=T.sep+$e,Ce=T.$gc.sep+fe;let Fe;return oe?Fe=function(Y,W){return typeof Y=="string"&&(Y===$e||Y.endsWith(se)||!pe&&(Y===fe||Y.endsWith(Ce)))?be:null}:Fe=function(Y,W){return typeof Y=="string"&&(Y===$e||!pe&&Y===fe)?be:null},Fe.allPaths=[(oe?"*/":"./")+fe],Fe}function v(fe){try{const be=new RegExp(`^${o(fe)}$`);return function(oe){return be.lastIndex=0,typeof oe=="string"&&be.test(oe)?fe:null}}catch{return u}}function F(fe,be,oe){return!fe||typeof be!="string"?!1:M(fe)(be,void 0,oe)}function M(fe,be={}){if(!fe)return f;if(typeof fe=="string"||G(fe)){const oe=b(fe,be);if(oe===u)return f;const pe=function($e,se){return!!oe($e,se)};return oe.allBasenames&&(pe.allBasenames=oe.allBasenames),oe.allPaths&&(pe.allPaths=oe.allPaths),pe}return N(fe,be)}function G(fe){const be=fe;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}function q(fe){return fe.allBasenames||[]}function V(fe){return fe.allPaths||[]}function N(fe,be){const oe=Z(Object.getOwnPropertyNames(fe).map(Fe=>L(Fe,fe[Fe],be)).filter(Fe=>Fe!==u)),pe=oe.length;if(!pe)return u;if(!oe.some(Fe=>!!Fe.requiresSiblings)){if(pe===1)return oe[0];const Fe=function(ie,De){let he;for(let ve=0,ae=oe.length;ve<ae;ve++){const X=oe[ve](ie,De);if(typeof X=="string")return X;(0,R.$mh)(X)&&(he||(he=[]),he.push(X))}return he?(async()=>{for(const ve of he){const ae=await ve;if(typeof ae=="string")return ae}return null})():null},Y=oe.find(ie=>!!ie.allBasenames);Y&&(Fe.allBasenames=Y.allBasenames);const W=oe.reduce((ie,De)=>De.allPaths?ie.concat(De.allPaths):ie,[]);return W.length&&(Fe.allPaths=W),Fe}const $e=function(Fe,Y,W){let ie,De;for(let he=0,ve=oe.length;he<ve;he++){const ae=oe[he];ae.requiresSiblings&&W&&(Y||(Y=(0,T.$nc)(Fe)),ie||(ie=Y.substr(0,Y.length-(0,T.$oc)(Fe).length)));const X=ae(Fe,Y,ie,W);if(typeof X=="string")return X;(0,R.$mh)(X)&&(De||(De=[]),De.push(X))}return De?(async()=>{for(const he of De){const ve=await he;if(typeof ve=="string")return ve}return null})():null},se=oe.find(Fe=>!!Fe.allBasenames);se&&($e.allBasenames=se.allBasenames);const Ce=oe.reduce((Fe,Y)=>Y.allPaths?Fe.concat(Y.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function L(fe,be,oe){if(be===!1)return u;const pe=b(fe,oe);if(pe===u)return u;if(typeof be=="boolean")return pe;if(be){const $e=be.when;if(typeof $e=="string"){const se=(Ce,Fe,Y,W)=>{if(!W||!pe(Ce,Fe))return null;const ie=$e.replace("$(basename)",()=>Y),De=W(ie);return(0,R.$mh)(De)?De.then(he=>he?fe:null):De?fe:null};return se.requiresSiblings=!0,se}}return pe}function Z(fe,be){const oe=fe.filter(Fe=>!!Fe.basenames);if(oe.length<2)return fe;const pe=oe.reduce((Fe,Y)=>{const W=Y.basenames;return W?Fe.concat(W):Fe},[]);let $e;if(be){$e=[];for(let Fe=0,Y=pe.length;Fe<Y;Fe++)$e.push(be)}else $e=oe.reduce((Fe,Y)=>{const W=Y.patterns;return W?Fe.concat(W):Fe},[]);const se=function(Fe,Y){if(typeof Fe!="string")return null;if(!Y){let ie;for(ie=Fe.length;ie>0;ie--){const De=Fe.charCodeAt(ie-1);if(De===P.CharCode.Slash||De===P.CharCode.Backslash)break}Y=Fe.substr(ie)}const W=pe.indexOf(Y);return W!==-1?$e[W]:null};se.basenames=pe,se.patterns=$e,se.allBasenames=pe;const Ce=fe.filter(Fe=>!Fe.basenames);return Ce.push(se),Ce}function re(fe,be){return(0,E.$ub)(fe,be,(oe,pe)=>typeof oe=="string"&&typeof pe=="string"?oe===pe:typeof oe!="string"&&typeof pe!="string"?oe.base===pe.base&&oe.pattern===pe.pattern:!1)}}),define(ke[59],Ie([1,0,14,98,24,13,2]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=c,e.$Zk=C,e.$1k=w,e.$2k=l,e.$3k=S,e.$4k=d,e.$5k=r,e.$6k=o;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(h="",t=!1){if(this.value=h,typeof this.value!="string")throw(0,E.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(h,t=T.Paragraph){return this.value+=l(this.supportThemeIcons?(0,R.$Rk)(h):h).replace(/([ \t]+)/g,(s,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===T.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,t){return this.value+=`
${S(t,h)}
`,this}appendLink(h,t,s){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,t){const s=new RegExp((0,O.$df)(t),"g");return h.replace(s,(n,i)=>h.charAt(i-1)!=="\\"?`\\${n}`:n)}}e.$Xk=$;function c(a){return C(a)?!a.value:Array.isArray(a)?a.every(c):!0}function C(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function w(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,P.$7g)(A.URI.from(a.baseUri),A.URI.from(h.baseUri)))}function l(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(a,h){const t=a.match(/^`+/gm)?.reduce((n,i)=>n.length>i.length?n:i).length??0,s=t>=3?t+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],t=a.split("|").map(n=>n.trim());a=t[0];const s=t[1];if(s){const n=/height=(\d+)/.exec(s),i=/width=(\d+)/.exec(s),g=n?n[1]:"",f=i?i[1]:"",u=isFinite(parseInt(f)),b=isFinite(parseInt(g));u&&h.push(`width="${f}"`),b&&h.push(`height="${g}"`)}return{href:a,dimensions:h}}}),define(ke[102],Ie([1,0,18,53,20,21,24,13]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=$,e.$Nw=C,e.$Ow=l,e.$Pw=S,e.$Qw=a,e.$Rw=t,e.$Sw=s,e.$Tw=n,e.$Uw=i,e.$Vw=g;function $(u,b){const{os:I,tildify:D,relative:y}=b;if(y){const m=c(u,y,I);if(typeof m=="string")return m}let p=u.fsPath;if(I===O.OperatingSystem.Windows&&!O.$i?p=p.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.$i&&(p=p.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&D?.userHome){const m=D.userHome.fsPath;let v;u.scheme!==D.userHome.scheme&&u.path[0]===P.$gc.sep&&u.path[1]!==P.$gc.sep?v=D.userHome.with({path:u.path}).fsPath:v=p,p=l(v,m,I)}return(I===O.OperatingSystem.Windows?P.$fc:P.$gc).normalize(C(p,I===O.OperatingSystem.Windows))}function c(u,b,I){const D=I===O.OperatingSystem.Windows?P.$fc:P.$gc,y=I===O.OperatingSystem.Linux?A.$4g:A.$6g,p=b.getWorkspace(),k=(0,E.$Ob)(p.folders);if(!k)return;u.scheme!==k.uri.scheme&&u.path[0]===P.$gc.sep&&u.path[1]!==P.$gc.sep&&(u=k.uri.with({path:u.path}));const m=b.getWorkspaceFolder(u);if(!m)return;let v;if(y.isEqual(m.uri,u)?v="":v=y.relativePath(m.uri,u)??"",v&&(v=D.normalize(v)),p.folders.length>1&&!b.noPrefix){const F=m.name?m.name:y.basenameOrAuthority(m.uri);v=v?`${F} \u2022 ${v}`:F}return v}function C(u,b=O.$i){return(0,R.$Eg)(u,b)?u.charAt(0).toUpperCase()+u.slice(1):u}let w=Object.create(null);function l(u,b,I=O.OS){if(I===O.OperatingSystem.Windows||!u||!b)return u;let D=w.original===b?w.normalized:void 0;D||(D=b,O.$i&&(D=(0,R.$tg)(D)),D=`${(0,T.$jf)(D,P.$gc.sep)}${P.$gc.sep}`,w={original:b,normalized:D});let y=u;return O.$i&&(y=(0,R.$tg)(y)),(I===O.OperatingSystem.Linux?y.startsWith(D):(0,T.$Cf)(y,D))?`~/${y.substr(D.length)}`:u}function S(u,b){return u.replace(/^~($|\/|\\)/,`${b}$1`)}const d="\u2026",r="\\\\",o="~";function a(u,b=P.sep){const I=new Array(u.length);let D=!1;for(let y=0;y<u.length;y++){const p=u[y];if(p===""){I[y]=`.${b}`;continue}if(!p){I[y]=p;continue}D=!0;let k="",m=p;m.indexOf(r)===0?(k=m.substr(0,m.indexOf(r)+r.length),m=m.substr(m.indexOf(r)+r.length)):m.indexOf(b)===0?(k=m.substr(0,m.indexOf(b)+b.length),m=m.substr(m.indexOf(b)+b.length)):m.indexOf(o)===0&&(k=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length));const v=m.split(b);for(let F=1;D&&F<=v.length;F++)for(let M=v.length-F;D&&M>=0;M--){D=!1;let G=v.slice(M,M+F).join(b);for(let q=0;!D&&q<u.length;q++)if(q!==y&&u[q]&&u[q].indexOf(G)>-1){const V=M+F===v.length,N=M>0&&u[q].indexOf(b)>-1?b+G:G,L=u[q].endsWith(N);D=!V||L}if(!D){let q="";(v[0].endsWith(":")||k!=="")&&(M===1&&(M=0,F++,G=v[0]+b+G),M>0&&(q=v[0]+b),q=k+q),M>0&&(q=q+d+b),q=q+G,M+F<v.length&&(q=q+b+d),I[y]=q}}D&&(I[y]=p)}return I}var h;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function t(u,b=Object.create(null)){const I=[];let D=!1,y="";for(const p of u)if(p==="$"||D&&p==="{")y&&I.push({value:y,type:h.TEXT}),y="",D=!0;else if(p==="}"&&D){const k=b[y];if(typeof k=="string")k.length&&I.push({value:k,type:h.VARIABLE});else if(k){const m=I[I.length-1];(!m||m.type!==h.SEPARATOR)&&I.push({value:k.label,type:h.SEPARATOR})}y="",D=!1}else y+=p;return y&&!D&&I.push({value:y,type:h.TEXT}),I.filter((p,k)=>{if(p.type===h.SEPARATOR){const m=I[k-1],v=I[k+1];return[m,v].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(p=>p.value).join("")}function s(u,b){return O.$j||b?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):u.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function n(u,b){return O.$j||b?u.replace(/\(&&\w\)|&&/g,""):O.$i?u.replace(/&&|&/g,I=>I==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function g(u){if(u.endsWith("]")){const b=u.lastIndexOf(" [",u.length-2);if(b!==-1){const I=f(u.substring(0,b)),D=u.substring(b);return{name:I.name+D,parentPath:I.parentPath}}}return f(u)}function f(u){const b=u.indexOf("/")!==-1?P.$gc:P.$fc,I=b.basename(u),D=b.dirname(u);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(ke[159],Ie([1,0,23,37,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=$,e.$Gn=C,e.$Hn=w;function O(l){return l.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Dn=A,e.$En=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function T(l,S,d){if(!l||d>200)return null;if(typeof l=="object"){if(l instanceof P.URI)return S.transformOutgoing(l);for(const r in l)if(Object.hasOwnProperty.call(l,r)){const o=T(l[r],S,d+1);o!==null&&(l[r]=o)}}return null}function $(l,S){const d=T(l,S,0);return d===null?l:d}function c(l,S,d,r){if(!l||r>200)return null;if(typeof l=="object"){if(l.$mid===R.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(l)):S.transformIncoming(l);if(l instanceof E.$Je)return null;for(const o in l)if(Object.hasOwnProperty.call(l,o)){const a=c(l[o],S,d,r+1);a!==null&&(l[o]=a)}}return null}function C(l,S){const d=c(l,S,!1,0);return d===null?l:d}function w(l,S){const d=c(l,S,!0,0);return d===null?l:d}}),define(ke[160],Ie([1,0,11,4,6,49,15]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=$;var T;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(l){const S=l;return S?.changed instanceof Map||S?.deleted instanceof Set}var c;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(c||(e.StorageState=c={}));class C extends P.$Uc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new R.$ke),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new E.$yh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,r)=>this.w(r,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===c.Closed)return;let r=!1;(0,A.$jg)(d)?r=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),r=!0),r&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const r=this.f.get(S);return(0,A.$jg)(r)?d:r}getBoolean(S,d){const r=this.get(S);return(0,A.$jg)(r)?d:r==="true"}getNumber(S,d){const r=this.get(S);return(0,A.$jg)(r)?d:parseInt(r,10)}getObject(S,d){const r=this.get(S);return(0,A.$jg)(r)?d:(0,O.$9h)(r)}async set(S,d,r=!1){if(this.c===c.Closed)return;if((0,A.$jg)(d))return this.delete(S,r);const o=(0,A.$cg)(d)||Array.isArray(d)?(0,O.$8h)(d):String(d);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:r}),this.D()}async delete(S,d=!1){if(!(this.c===c.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===c.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$5p=C;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,r)=>this.a.set(r,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$6p=w}),define(ke[161],Ie([1,0,13,21,23]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$it=C,e.$jt=w;let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let c;function C(){return c||(c=R.$D()?A():$()),c}function w(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?l(d,r,o):A().decode(a)}function l(d,r,o){const a=[];let h=0;for(let t=0;t<o;t++){const s=P.$Le(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class S{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return C().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$Ff(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$kt=S}),define(ke[162],Ie([1,0,23,161]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$mt=A;function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,C,w,l){this.oldPosition=c,this.oldText=C,this.newPosition=w,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,C,w){const l=C.length;E.$Oe(c,l,w),w+=4;for(let S=0;S<l;S++)E.$Me(c,C.charCodeAt(S),w),w+=2;return w}static d(c,C){const w=E.$Ne(c,C);return C+=4,(0,R.$jt)(c,C,w)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(c,C){return E.$Oe(c,this.oldPosition,C),C+=4,E.$Oe(c,this.newPosition,C),C+=4,C=O.c(c,this.oldText,C),C=O.c(c,this.newText,C),C}static read(c,C,w){const l=E.$Ne(c,C);C+=4;const S=E.$Ne(c,C);C+=4;const d=O.d(c,C);C+=O.a(d);const r=O.d(c,C);return C+=O.a(r),w.push(new O(l,d,S,r)),C}}e.$lt=O;function A($,c){return $===null||$.length===0?c:new T($,c).compress()}class T{constructor(c,C){this.a=c,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,C=0,w=this.n(c),l=this.l(C);for(;c<this.f||C<this.h;){if(w===null){this.k(l),l=this.l(++C);continue}if(l===null){this.m(w),w=this.n(++c);continue}if(l.oldEnd<=w.newPosition){this.k(l),l=this.l(++C);continue}if(w.newEnd<=l.oldPosition){this.m(w),w=this.n(++c);continue}if(l.oldPosition<w.newPosition){const[a,h]=T.r(l,w.newPosition-l.oldPosition);this.k(a),l=h;continue}if(w.newPosition<l.oldPosition){const[a,h]=T.q(w,l.oldPosition-w.newPosition);this.m(a),w=h;continue}let r,o;if(l.oldEnd===w.newEnd)r=w,o=l,w=this.n(++c),l=this.l(++C);else if(l.oldEnd<w.newEnd){const[a,h]=T.q(w,l.oldLength);r=a,o=l,w=h,l=this.l(++C)}else{const[a,h]=T.r(l,w.newLength);r=w,o=a,w=this.n(++c),l=h}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const S=T.s(this.d);return T.t(S)}k(c){this.d[this.e++]=T.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=T.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,C){return new O(C.oldPosition-c,C.oldText,C.newPosition,C.newText)}static p(c,C){return new O(C.oldPosition,C.oldText,C.newPosition+c,C.newText)}static q(c,C){const w=c.newText.substr(0,C),l=c.newText.substr(C);return[new O(c.oldPosition,c.oldText,c.newPosition,w),new O(c.oldEnd,"",c.newPosition+C,l)]}static r(c,C){const w=c.oldText.substr(0,C),l=c.oldText.substr(C);return[new O(c.oldPosition,w,c.newPosition,c.newText),new O(c.oldPosition+C,l,c.newEnd,"")]}static s(c){if(c.length===0)return c;const C=[];let w=0,l=c[0];for(let S=1;S<c.length;S++){const d=c[S];l.oldEnd===d.oldPosition?l=new O(l.oldPosition,l.oldText+d.oldText,l.newPosition,l.newText+d.newText):(C[w++]=l,l=d)}return C[w++]=l,C}static t(c){if(c.length===0)return c;const C=[];let w=0;for(let l=0;l<c.length;l++){const S=c[l];S.oldText!==S.newText&&(C[w++]=S)}return C}}}),define(ke[163],Ie([1,0,41,20]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=P,e.$ht=O;function P(A,T,$,c,C,w){if(Array.isArray(A)){let l=0;for(const S of A){const d=P(S,T,$,c,C,w);if(d===10)return d;d>l&&(l=d)}return l}else{if(typeof A=="string")return c?A==="*"?5:A===$?10:0:0;if(A){const{language:l,pattern:S,scheme:d,hasAccessToAllModels:r,notebookType:o}=A;if(!c&&!r)return 0;o&&C&&(T=C);let a=0;if(d)if(d===T.scheme)a=10;else if(d==="*")a=5;else return 0;if(l)if(l===$)a=10;else if(l==="*")a=Math.max(a,5);else return 0;if(o)if(o===w)a=10;else if(o==="*"&&w!==void 0)a=Math.max(a,5);else return 0;if(S){let h;if(typeof S=="string"?h=S:h={...S,base:(0,R.$hc)(S.base)},h===T.fsPath||(0,E.$tk)(h,T.fsPath))a=10;else return 0}return a}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(ke[164],Ie([1,0,4,13,33,52,99,147,162,6]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=void 0;class C extends c.$Uc{constructor(l,S,d,r,o,a,h){super(),this.m=this.B(new E.$he),this.onDidChangeContent=this.m.event,this.f=S,this.j=!a,this.g=r,this.h=o,this.c=new A.$$C(l,d,h)}equals(l){return!(l instanceof C)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,S){return this.c.getOffsetAt(l,S)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,S){const d=l+S,r=this.getPositionAt(l),o=this.getPositionAt(d);return new P.$ct(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,S=O.EndOfLinePreference.TextDefined){if(l.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(l,d)}getValueLengthInRange(l,S=O.EndOfLinePreference.TextDefined){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const d=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const a=this.n(S),h=this.getEOL();if(a.length!==h.length){const t=a.length-h.length,s=l.endLineNumber-l.startLineNumber;o=t*s}return r-d+o}getCharacterCountInRange(l,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=l.startLineNumber,o=l.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),t=a===r?l.startColumn-1:0,s=a===o?l.endColumn-1:h.length;for(let n=t;n<s;n++)R.$Ff(h.charCodeAt(n))?(d=d+1,n=n+1):d=d+1}return d+=this.n(S).length*(o-r),d}return this.getValueLengthInRange(l,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,S){return this.c.getLineCharCode(l,S)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const S=R.$qf(this.getLineContent(l));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(l){const S=R.$sf(this.getLineContent(l));return S===-1?0:S+2}n(l){switch(l){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,S,d){let r=this.g,o=this.h,a=this.j,h=!0,t=[];for(let b=0;b<l.length;b++){const I=l[b];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let v=!0;a||(v=!R.$Qf(I.text),a=v),!r&&v&&(r=R.$Pf(I.text)),!o&&v&&(o=R.$Sf(I.text))}let y="",p=0,k=0,m=0;if(I.text){let v;[p,k,m,v]=(0,T.$jv)(I.text);const F=this.getEOL(),M=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===M?y=I.text:y=I.text.replace(/\r\n|\r|\n/g,F)}t[b]={sortIndex:b,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:p,firstLineLength:k,lastLineLength:m,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}t.sort(C.u);let s=!1;for(let b=0,I=t.length-1;b<I;b++){const D=t[b].range.getEndPosition(),y=t[b+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(t=this.s(t));const n=d||S?C._getInverseEditRanges(t):[],i=[];if(S)for(let b=0;b<t.length;b++){const I=t[b],D=n[b];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let p="";y===D.startLineNumber&&(p=this.getLineContent(I.range.startLineNumber),R.$qf(p)!==-1)||i.push({lineNumber:y,oldContent:p})}}let g=null;if(d){let b=0;g=[];for(let I=0;I<t.length;I++){const D=t[I],y=n[I],p=this.getValueInRange(D.range),k=D.rangeOffset+b;b+=D.text.length-p.length,g[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:p,textChange:new $.$lt(D.rangeOffset,p,k,D.text)}}s||g.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(t);let u=null;if(S&&i.length>0){i.sort((b,I)=>I.lineNumber-b.lineNumber),u=[];for(let b=0,I=i.length;b<I;b++){const D=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===D)continue;const y=i[b].oldContent,p=this.getLineContent(D);p.length===0||p===y||R.$qf(p)!==-1||u.push(D)}}return this.m.fire(),new O.$vv(g,f,u)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let S=!1;const d=l[0].range,r=l[l.length-1].range,o=new P.$ct(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const t=[];for(let f=0,u=l.length;f<u;f++){const b=l[f],I=b.range;S=S||b.forceMoveMarkers,t.push(this.getValueInRange(new P.$ct(a,h,I.startLineNumber,I.startColumn))),b.text.length>0&&t.push(b.text),a=I.endLineNumber,h=I.endColumn}const s=t.join(""),[n,i,g]=(0,T.$jv)(s);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:s,eolCount:n,firstLineLength:i,lastLineLength:g,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(l){l.sort(C.w);const S=[];for(let d=0;d<l.length;d++){const r=l[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,t=r.range.endColumn;if(o===h&&a===t&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new P.$ct(o,a,h,t);S.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return S}findMatchesLineByLine(l,S,d,r){return this.c.findMatchesLineByLine(l,S,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,S){const d=l.startLineNumber,r=l.startColumn,[o,a,h]=(0,T.$jv)(S);let t;if(S.length>0){const s=o+1;s===1?t=new P.$ct(d,r,d,r+a):t=new P.$ct(d,r,d+s-1,h+1)}else t=new P.$ct(d,r,d,r);return t}static _getInverseEditRanges(l){const S=[];let d=0,r=0,o=null;for(let a=0,h=l.length;a<h;a++){const t=l[a];let s,n;o?o.range.endLineNumber===t.range.startLineNumber?(s=d,n=r+(t.range.startColumn-o.range.endColumn)):(s=d+(t.range.startLineNumber-o.range.endLineNumber),n=t.range.startColumn):(s=t.range.startLineNumber,n=t.range.startColumn);let i;if(t.text.length>0){const g=t.eolCount+1;g===1?i=new P.$ct(s,n,s,n+t.firstLineLength):i=new P.$ct(s,n,s+g-1,t.lastLineLength+1)}else i=new P.$ct(s,n,s,n);d=i.endLineNumber,r=i.endColumn,S.push(i),o=t}return S}static u(l,S){const d=P.$ct.compareRangesUsingEnds(l.range,S.range);return d===0?l.sortIndex-S.sortIndex:d}static w(l,S){const d=P.$ct.compareRangesUsingEnds(l.range,S.range);return d===0?S.sortIndex-l.sortIndex:-d}}e.$_C=C}),define(ke[165],Ie([1,0,28,13,52,99,164]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class T{constructor(C,w,l,S,d,r,o,a,h){this.a=C,this.b=w,this.c=l,this.d=S,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(C){const w=this.c+this.d+this.e,l=this.c+this.e;return w===0?C===P.DefaultEndOfLine.LF?`
`:`\r
`:l>w/2?`\r
`:`
`}create(C){const w=this.k(C),l=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let d=0,r=l.length;d<r;d++){const o=l[d].buffer.replace(/\r\n|\r|\n/g,w),a=(0,O.$7C)(o);l[d]=new O.$0C(o,a)}const S=new A.$_C(l,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(C){return this.a[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(C){if(C.length===0)return;this.a.length===0&&R.$1f(C)&&(this.b=R.$Zf,C=C.substr(1));const w=C.charCodeAt(C.length-1);w===E.CharCode.CarriageReturn||w>=55296&&w<=56319?(this.m(C.substr(0,C.length-1),!1),this.c=!0,this.d=w):(this.m(C,!1),this.c=!1,this.d=w)}m(C,w){!w&&C.length===0||(this.c?this.n(String.fromCharCode(this.d)+C):this.n(C))}n(C){const w=(0,O.$8C)(this.e,C);this.a.push(new O.$0C(C,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=R.$Pf(C)),this.k||(this.k=R.$Sf(C)))}finish(C=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,C)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const C=this.a[this.a.length-1];C.buffer+=String.fromCharCode(this.d);const w=(0,O.$7C)(C.buffer);C.lineStarts=w,this.d===E.CharCode.CarriageReturn&&this.f++}}}e.$aD=$}),define(ke[103],Ie([1,0,23,21]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbb=$,e.$Wbb=C;var P;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(P||(P={}));function O(w){for(let l=0,S=w.length;l<S;l+=4){const d=w[l+0],r=w[l+1],o=w[l+2],a=w[l+3];w[l+0]=a,w[l+1]=o,w[l+2]=r,w[l+3]=d}}function A(w){const l=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return R.$D()||O(l),E.$Je.wrap(l)}function T(w){const l=w.buffer;if(R.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const S=new Uint8Array(l.byteLength);return S.set(l),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(w){const l=new Uint32Array(c(w));let S=0;if(l[S++]=w.id,w.type==="full")l[S++]=P.Full,l[S++]=w.data.length,l.set(w.data,S),S+=w.data.length;else{l[S++]=P.Delta,l[S++]=w.deltas.length;for(const d of w.deltas)l[S++]=d.start,l[S++]=d.deleteCount,d.data?(l[S++]=d.data.length,l.set(d.data,S),S+=d.data.length):l[S++]=0}return A(l)}function c(w){let l=0;if(l+=2,w.type==="full")l+=1+w.data.length;else{l+=1,l+=3*w.deltas.length;for(const S of w.deltas)S.data&&(l+=S.data.length)}return l}function C(w){const l=T(w);let S=0;const d=l[S++];if(l[S++]===P.Full){const h=l[S++],t=l.subarray(S,S+h);return S+=h,{id:d,type:"full",data:t}}const o=l[S++],a=[];for(let h=0;h<o;h++){const t=l[S++],s=l[S++],n=l[S++];let i;n>0&&(i=l.subarray(S,S+n),S+=n),a[h]={start:t,deleteCount:s,data:i}}return{id:d,type:"delta",deltas:a}}}),define(ke[166],Ie([8,9]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(ke[167],Ie([8,9]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[168],Ie([8,9]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[169],Ie([8,9]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(ke[170],Ie([8,9]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[171],Ie([8,9]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[172],Ie([8,9]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(ke[173],Ie([8,9]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(ke[174],Ie([8,9]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(ke[175],Ie([8,9]),function(de,e){return de.create("vs/platform/request/common/request",e)}),define(ke[176],Ie([8,9]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[177],Ie([8,9]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[178],Ie([8,9]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(ke[179],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[180],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[181],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[182],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[183],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[184],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[185],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[186],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[187],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[188],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[189],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[190],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[191],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(ke[192],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(ke[193],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(ke[194],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[195],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ke[196],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[197],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[198],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[199],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[200],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/testing/common/constants",e)}),define(ke[201],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[202],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[203],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[204],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[205],Ie([1,0,28,14,169]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var O;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...C){switch(C.length){case 1:return(0,P.localize)(0,null,C[0]);case 2:return(0,P.localize)(1,null,C[0],C[1]);case 3:return(0,P.localize)(2,null,C[0],C[1],C[2]);default:return}}const T=(0,P.localize)(3,null),$=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return w.isTripleEq?"===":"==";case O.NotEq:return w.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return w.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return w.lexeme;case O.QuotedStr:return w.lexeme;case O.Error:return w.lexeme;case O.EOF:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(O.LParen);break;case E.CharCode.CloseParen:this.k(O.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const l=this.h(E.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:l})}else this.k(O.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const l=this.h(E.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:l})}else this.h(E.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?O.LtEq:O.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?O.GtEq:O.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const l=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:l,lexeme:S,additionalInfo:w}),this.f.push(d)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const l=this.c.substring(this.d,this.e),S=c.b.get(l);S?this.k(S):this.f.push({type:O.Str,lexeme:l,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,l=!1,S=!1;for(;;){if(w>=this.c.length){this.e=w,this.l($);return}const r=this.c.charCodeAt(w);if(l)l=!1;else if(r===E.CharCode.Slash&&!S){w++;break}else r===E.CharCode.OpenSquareBracket?S=!0:r===E.CharCode.Backslash?l=!0:r===E.CharCode.CloseSquareBracket&&(S=!1);w++}for(;w<this.c.length&&c.a.has(this.c.charCodeAt(w));)w++;this.e=w;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=c}),define(ke[206],Ie([1,0,24,35,171,321]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=$,e.$Pp=c,e.$Qp=C,e.$Rp=w,e.$Sp=l,e.$Tp=S,e.$Up=d;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}function c(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function C(a){if(!a)return null;const h=a.majorBase,t=a.majorMustEqual,s=a.minorBase;let n=a.minorMustEqual;const i=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(h===0||(n=!1),g=!1);let f=0;if(a.preRelease){const u=T.exec(a.preRelease);if(u){const[,b,I,D]=u;f=Date.UTC(Number(b),Number(I)-1,Number(D))}}return{majorBase:h,majorMustEqual:t,minorBase:s,minorMustEqual:n,patchBase:i,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:f}}function w(a,h,t){let s;typeof a=="string"?s=C(c(a)):s=a;let n;h instanceof Date?n=h.getTime():typeof h=="string"&&(n=new Date(h).getTime());let i;if(typeof t=="string"?i=C(c(t)):i=t,!s||!i)return!1;const g=s.majorBase,f=s.minorBase,u=s.patchBase;let b=i.majorBase,I=i.minorBase,D=i.patchBase;const y=i.notBefore;let p=i.majorMustEqual,k=i.minorMustEqual,m=i.patchMustEqual;return i.isMinimum?g>b?!0:g<b?!1:f>I?!0:f<I||n&&n<y?!1:u>=D:(g===1&&b===0&&(!p||!k||!m)&&(b=1,I=0,D=0,p=!0,k=!1,m=!1),g<b?!1:g>b?!p:f<I?!1:f>I?!k:u<D?!1:u>D?!m:!(n&&n<y))}function l(a,h,t,s,n){const i=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return i.push([R.default.Error,P.localize(0,null)]),i;if(typeof s.name!="string")return i.push([R.default.Error,P.localize(1,null,"name")]),i;if(typeof s.version!="string")return i.push([R.default.Error,P.localize(2,null,"version")]),i;if(!s.engines)return i.push([R.default.Error,P.localize(3,null,"engines")]),i;if(typeof s.engines.vscode!="string")return i.push([R.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return i.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return i.push([R.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof s.main>"u"&&typeof s.browser>"u")return i.push([R.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&i.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return i.push([R.default.Error,P.localize(9,null,"main")]),i;{const u=(0,E.$bh)(t,s.main);(0,E.$8g)(u,t)||i.push([R.default.Warning,P.localize(10,null,u.path,t.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return i.push([R.default.Error,P.localize(11,null,"browser")]),i;{const u=(0,E.$bh)(t,s.browser);(0,E.$8g)(u,t)||i.push([R.default.Warning,P.localize(12,null,u.path,t.path)])}}if(!O.valid(s.version))return i.push([R.default.Error,P.localize(13,null)]),i;const g=[];if(!S(a,h,s,n,g))for(const u of g)i.push([R.default.Error,u]);return i}function S(a,h,t,s,n){return s||typeof t.main>"u"&&typeof t.browser>"u"?!0:r(a,h,t.engines.vscode,n)}function d(a,h,t){return a==="*"||r(h,t,a)}function r(a,h,t,s=[]){const n=C(c(t));if(!n)return s.push(P.localize(14,null,t)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return s.push(P.localize(15,null,t)),!1}else if(!n.majorMustEqual)return s.push(P.localize(16,null,t)),!1;return w(a,h,n)?!0:(s.push(P.localize(17,null,a,t)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,t=a.length;h<t;h++)if(typeof a[h]!="string")return!1;return!0}}),define(ke[74],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class E{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$xi=E}),define(ke[60],Ie([1,0,74]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=O,e.$Gs=A;const R=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(T,$,c){$ instanceof E.$xi||($=new E.$xi($,[],!!c)),R.push([T,$])}function A(){return R}}),define(ke[207],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class E{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ir=E;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(A);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new E(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),$=this.c(A,T);if($)return $}}c(O,A){for(const[T,$]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const c=this.c($,A);if(c)return c;A.delete(T)}}}e.$jr=R}),define(ke[3],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=P,e.$Bi=O;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(E||(e._util=E={})),e.$zi=P("instantiationService");function R(A,T,$){T[E.DI_TARGET]===T?T[E.DI_DEPENDENCIES].push({id:A,index:$}):(T[E.DI_DEPENDENCIES]=[{id:A,index:$}],T[E.DI_TARGET]=T)}function P(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const T=function($,c,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(T,$,C)};return T.toString=()=>A,E.serviceIds.set(A,T),T}function O(A){return A}}),define(ke[42],Ie([1,0,15,2,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=O,e.$9i=A,e.$0i=$,e.$$i=c,e.$_i=C,e.$aj=w,e.$bj=l,e.$cj=d,e.$dj=r,e.$ej=o,e.$7i=(0,P.$Ai)("configurationService");function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}var T;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(a){switch(a){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function C(a,h){const t=Object.create(null);for(const s in a)w(t,s,a[s],h);return t}function w(a,h,t,s){const n=h.split("."),i=n.pop();let g=a;for(let f=0;f<n.length;f++){const u=n[f];let b=g[u];switch(typeof b){case"undefined":b=g[u]=Object.create(null);break;case"object":if(b===null){s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is ${JSON.stringify(b)}`);return}g=b}if(typeof g=="object"&&g!==null)try{g[i]=t}catch{s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(g)}`)}function l(a,h){const t=h.split(".");S(a,t)}function S(a,h){const t=h.shift();if(h.length===0){delete a[t];return}if(Object.keys(a).indexOf(t)!==-1){const s=a[t];typeof s=="object"&&!Array.isArray(s)&&(S(s,h),Object.keys(s).length===0&&delete a[t])}}function d(a,h,t){function s(g,f){let u=g;for(const b of f){if(typeof u!="object"||u===null)return;u=u[b]}return u}const n=h.split("."),i=s(a,n);return typeof i>"u"?t:i}function r(a,h,t){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?E.$cg(a[s])&&E.$cg(h[s])?r(a[s],h[s],t):t&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(ke[32],Ie([1,0,28,21,13,205,3,168,14]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=C,e.$zj=f,e.$Aj=u,e.$Tj=se;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",R.$j),c.set("isLinux",R.$k),c.set("isWindows",R.$i),c.set("isWeb",R.$o),c.set("isMacNative",R.$j&&!R.$o),c.set("isEdge",R.$H),c.set("isFirefox",R.$F),c.set("isChrome",R.$E),c.set("isSafari",R.$G);function C(Y,W){if(c.get(Y)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,W)}const w=Object.prototype.hasOwnProperty;var l;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const S={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),r=(0,T.localize)(1,null),o=(0,T.localize)(2,null),a=(0,T.localize)(3,null),h=(0,T.localize)(4,null),t=(0,T.localize)(5,null),s=(0,T.localize)(6,null),n=(0,T.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=S){this.k=W,this.d=new O.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const De=this.D(),he=De.type===O.TokenType.Str?t:void 0;throw this.h.push({message:h,offset:De.offset,lexeme:O.$vj.getLexeme(De),additionalInfo:he}),i.c}return ie}catch(ie){if(ie!==i.c)throw ie;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(O.TokenType.Or);){const ie=this.o();W.push(ie)}return W.length===1?W[0]:g.or(...W)}o(){const W=[this.s()];for(;this.y(O.TokenType.And);){const ie=this.s();W.push(ie)}return W.length===1?W[0]:g.and(...W)}s(){if(this.y(O.TokenType.Neg)){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),I.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ie=this.l();return this.A(O.TokenType.RParen,a),ie?.negate()}case O.TokenType.Str:return this.z(),F.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),g.true();case O.TokenType.False:return this.z(),g.false();case O.TokenType.LParen:{this.z();const ie=this.l();return this.A(O.TokenType.RParen,a),ie}case O.TokenType.Str:{const ie=W.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==O.TokenType.RegexStr)throw this.B("REGEX",he);const ve=he.lexeme,ae=ve.lastIndexOf("/"),X=ae===ve.length-1?void 0:this.w(ve.substring(ae+1));let x;try{x=new RegExp(ve.substring(1,ae),X)}catch{throw this.B("REGEX",he)}return L.create(ie,x)}switch(he.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const ve=[he.lexeme];this.z();let ae=this.D(),X=0;for(let Be=0;Be<he.lexeme.length;Be++)he.lexeme.charCodeAt(Be)===E.CharCode.OpenParen?X++:he.lexeme.charCodeAt(Be)===E.CharCode.CloseParen&&X--;for(;!this.E()&&ae.type!==O.TokenType.And&&ae.type!==O.TokenType.Or;){switch(ae.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Be=0;Be<ae.lexeme.length;Be++)ae.lexeme.charCodeAt(Be)===E.CharCode.OpenParen?X++:he.lexeme.charCodeAt(Be)===E.CharCode.CloseParen&&X--}if(X<0)break;ve.push(O.$vj.getLexeme(ae)),this.z(),ae=this.D()}const x=ve.join(""),me=x.lastIndexOf("/"),ge=me===x.length-1?void 0:this.w(x.substring(me+1));let Me;try{Me=new RegExp(x.substring(1,me),ge)}catch{throw this.B("REGEX",he)}return g.regex(ie,Me)}case O.TokenType.QuotedStr:{const ve=he.lexeme;this.z();let ae=null;if(!(0,P.$$e)(ve)){const X=ve.indexOf("/"),x=ve.lastIndexOf("/");if(X!==x&&X>=0){const me=ve.slice(X+1,x),ge=ve[x+1]==="i"?"i":"";try{ae=new RegExp(me,ge)}catch{throw this.B("REGEX",he)}}}if(ae===null)throw this.B("REGEX",he);return L.create(ie,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const he=this.u();return g.notIn(ie,he)}switch(this.D().type){case O.TokenType.Eq:{this.z();const he=this.u();if(this.x().type===O.TokenType.QuotedStr)return g.equals(ie,he);switch(he){case"true":return g.has(ie);case"false":return g.not(ie);default:return g.equals(ie,he)}}case O.TokenType.NotEq:{this.z();const he=this.u();if(this.x().type===O.TokenType.QuotedStr)return g.notEquals(ie,he);switch(he){case"true":return g.not(ie);case"false":return g.has(ie);default:return g.notEquals(ie,he)}}case O.TokenType.Lt:return this.z(),V.create(ie,this.u());case O.TokenType.LtEq:return this.z(),N.create(ie,this.u());case O.TokenType.Gt:return this.z(),G.create(ie,this.u());case O.TokenType.GtEq:return this.z(),q.create(ie,this.u());case O.TokenType.In:return this.z(),g.in(ie,this.u());default:return g.has(ie)}}case O.TokenType.EOF:throw this.h.push({message:s,offset:W.offset,lexeme:"",additionalInfo:n}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),W.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ie){if(this.C(W))return this.z();throw this.B(ie,this.D())}B(W,ie,De){const he=(0,T.localize)(8,null,W,O.$vj.getLexeme(ie)),ve=ie.offset,ae=O.$vj.getLexeme(ie);return this.h.push({message:he,offset:ve,lexeme:ae,additionalInfo:De}),i.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$xj=i;class g{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(W){return y.create(W)}static equals(W,ie){return p.create(W,ie)}static notEquals(W,ie){return v.create(W,ie)}static regex(W,ie){return L.create(W,ie)}static in(W,ie){return k.create(W,ie)}static notIn(W,ie){return m.create(W,ie)}static not(W){return F.create(W)}static and(...W){return fe.create(W,null,!0)}static or(...W){return be.create(W,null,!0)}static greater(W,ie){return G.create(W,ie)}static greaterEquals(W,ie){return q.create(W,ie)}static smaller(W,ie){return V.create(W,ie)}static smallerEquals(W,ie){return N.create(W,ie)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$yj=g;function f(Y){const W=new i({regexParsingWithErrorRecovery:!1});return Y.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(De=>({errorMessage:De.additionalInfo?(0,T.localize)(9,null,De.additionalInfo):(0,T.localize)(10,null),offset:De.offset,length:De.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(De=>({errorMessage:De.additionalInfo?`${De.message}. ${De.additionalInfo}`:De.message,offset:De.offset,length:De.lexeme.length})):[]))}function u(Y,W){const ie=Y?Y.substituteConstants():void 0,De=W?W.substituteConstants():void 0;return!ie&&!De?!0:!ie||!De?!1:ie.equals(De)}function b(Y,W){return Y.cmp(W)}class I{static{this.INSTANCE=new I}constructor(){this.type=l.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.$Bj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=l.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return I.INSTANCE}}e.$Cj=D;class y{static create(W,ie=null){const De=c.get(W);return typeof De=="boolean"?De?D.INSTANCE:I.INSTANCE:new y(W,ie)}constructor(W,ie){this.key=W,this.c=ie,this.type=l.Defined}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:I.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Dj=y;class p{static create(W,ie,De=null){if(typeof ie=="boolean")return ie?y.create(W,De):F.create(W,De);const he=c.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?D.INSTANCE:I.INSTANCE:new p(W,ie,De)}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.Equals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?D.INSTANCE:I.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ej=p;class k{static create(W,ie){return new k(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=l.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.f),De=W.getValue(this.d);return Array.isArray(ie)?ie.includes(De):typeof De=="string"&&typeof ie=="object"&&ie!==null?w.call(ie,De):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Fj=k;class m{static create(W,ie){return new m(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=l.NotIn,this.c=k.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=m;class v{static create(W,ie,De=null){if(typeof ie=="boolean")return ie?F.create(W,De):y.create(W,De);const he=c.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?I.INSTANCE:D.INSTANCE:new v(W,ie,De)}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?I.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Hj=v;class F{static create(W,ie=null){const De=c.get(W);return typeof De=="boolean"?De?I.INSTANCE:D.INSTANCE:new F(W,ie)}constructor(W,ie){this.c=W,this.d=ie,this.type=l.Not}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=c.get(this.c);return typeof W=="boolean"?W?I.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Ij=F;function M(Y,W){if(typeof Y=="string"){const ie=parseFloat(Y);isNaN(ie)||(Y=ie)}return typeof Y=="string"||typeof Y=="number"?W(Y):I.INSTANCE}class G{static create(W,ie,De=null){return M(ie,he=>new G(W,he,De))}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.Greater}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=G;class q{static create(W,ie,De=null){return M(ie,he=>new q(W,he,De))}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=q;class V{static create(W,ie,De=null){return M(ie,he=>new V(W,he,De))}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Lj=V;class N{static create(W,ie,De=null){return M(ie,he=>new N(W,he,De))}constructor(W,ie,De){this.c=W,this.d=ie,this.f=De,this.type=l.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Mj=N;class L{static create(W,ie){return new L(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=l.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ie=this.f?this.f.source:"",De=W.f?W.f.source:"";return ie<De?-1:ie>De?1:0}equals(W){if(W.type===this.type){const ie=this.f?this.f.source:"",De=W.f?W.f.source:"";return this.d===W.d&&ie===De}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Nj=L;class Z{static create(W){return new Z(W)}constructor(W){this.c=W,this.type=l.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new Z(this.c.map(W))}negate(){return this.c}}e.$Oj=Z;function re(Y){let W=null;for(let ie=0,De=Y.length;ie<De;ie++){const he=Y[ie].substituteConstants();if(Y[ie]!==he&&W===null){W=[];for(let ve=0;ve<ie;ve++)W[ve]=Y[ve]}W!==null&&(W[ie]=he)}return W===null?Y:W}class fe{static create(W,ie,De){return fe.d(W,ie,De)}constructor(W,ie){this.expr=W,this.c=ie,this.type=l.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,De=this.expr.length;ie<De;ie++){const he=b(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,De=this.expr.length;ie<De;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:fe.create(W,this.c,!1)}evaluate(W){for(let ie=0,De=this.expr.length;ie<De;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static d(W,ie,De){const he=[];let ve=!1;for(const ae of W)if(ae){if(ae.type===l.True){ve=!0;continue}if(ae.type===l.False)return I.INSTANCE;if(ae.type===l.And){he.push(...ae.expr);continue}he.push(ae)}if(he.length===0&&ve)return D.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(b);for(let ae=1;ae<he.length;ae++)he[ae-1].equals(he[ae])&&(he.splice(ae,1),ae--);if(he.length===1)return he[0];for(;he.length>1;){const ae=he[he.length-1];if(ae.type!==l.Or)break;he.pop();const X=he.pop(),x=he.length===0,me=be.create(ae.expr.map(ge=>fe.create([ge,X],null,De)),null,x);me&&(he.push(me),he.sort(b))}if(he.length===1)return he[0];if(De){for(let ae=0;ae<he.length;ae++)for(let X=ae+1;X<he.length;X++)if(he[ae].negate().equals(he[X]))return I.INSTANCE;if(he.length===1)return he[0]}return new fe(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new fe(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());this.c=be.create(W,this,!0)}return this.c}}e.$Pj=fe;class be{static create(W,ie,De){return be.d(W,ie,De)}constructor(W,ie){this.expr=W,this.c=ie,this.type=l.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,De=this.expr.length;ie<De;ie++){const he=b(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,De=this.expr.length;ie<De;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:be.create(W,this.c,!1)}evaluate(W){for(let ie=0,De=this.expr.length;ie<De;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static d(W,ie,De){let he=[],ve=!1;if(W){for(let ae=0,X=W.length;ae<X;ae++){const x=W[ae];if(x){if(x.type===l.False){ve=!0;continue}if(x.type===l.True)return D.INSTANCE;if(x.type===l.Or){he=he.concat(x.expr);continue}he.push(x)}}if(he.length===0&&ve)return I.INSTANCE;he.sort(b)}if(he.length!==0){if(he.length===1)return he[0];for(let ae=1;ae<he.length;ae++)he[ae-1].equals(he[ae])&&(he.splice(ae,1),ae--);if(he.length===1)return he[0];if(De){for(let ae=0;ae<he.length;ae++)for(let X=ae+1;X<he.length;X++)if(he[ae].negate().equals(he[X]))return D.INSTANCE;if(he.length===1)return he[0]}return new be(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new be(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),De=W.shift(),he=[];for(const ve of Fe(ie))for(const ae of Fe(De))he.push(fe.create([ve,ae],null,!1));W.unshift(be.create(he,null,!1))}this.c=be.create(W,this,!0)}return this.c}}e.$Qj=be;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(W,ie,De){super(W,null),this.f=ie,typeof De=="object"?oe.d.push({...De,key:W}):De!==!0&&oe.d.push({key:W,description:De,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return p.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Rj=oe,e.$Sj=(0,A.$Ai)("contextKeyService");function pe(Y,W){return Y<W?-1:Y>W?1:0}function $e(Y,W,ie,De){return Y<ie?-1:Y>ie?1:W<De?-1:W>De?1:0}function se(Y,W){if(Y.type===l.False||W.type===l.True)return!0;if(Y.type===l.Or)return W.type===l.Or?Ce(Y.expr,W.expr):!1;if(W.type===l.Or){for(const ie of W.expr)if(se(Y,ie))return!0;return!1}if(Y.type===l.And){if(W.type===l.And)return Ce(W.expr,Y.expr);for(const ie of Y.expr)if(se(ie,W))return!0;return!1}return Y.equals(W)}function Ce(Y,W){let ie=0,De=0;for(;ie<Y.length&&De<W.length;){const he=Y[ie].cmp(W[De]);if(he<0)return!1;he===0&&ie++,De++}return ie===Y.length}function Fe(Y){return Y.type===l.Or?Y.expr:[Y]}}),define(ke[208],Ie([1,0,32,3]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=e.AccessibilitySupport=e.$ou=void 0,e.$qu=O,e.$ou=(0,R.$Ai)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$pu=new E.$Rj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$ru="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[104],Ie([1,0,18,26,21,142,322,148,209,166,208]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=t,e.clampedInt=n,e.clampedFloat=g,e.stringSet=b,e.cursorStyleToString=M,e.filterValidationDecorations=Ee;var w;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class l{constructor(H){this.c=H}hasChanged(H){return this.c[H]}}e.ConfigurationChangedEvent=l;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(H,ye,Ke,xe){this.id=H,this.name=ye,this.defaultValue=Ke,this.schema=xe}applyUpdate(H,ye){return o(H,ye)}compute(H,ye,Ke){return Ke}}class r{constructor(H,ye){this.newValue=H,this.didChange=ye}}e.ApplyUpdateResult=r;function o(_,H){if(typeof _!="object"||typeof H!="object"||!_||!H)return new r(H,_!==H);if(Array.isArray(_)||Array.isArray(H)){const Ke=Array.isArray(_)&&Array.isArray(H)&&E.$ub(_,H);return new r(H,!Ke)}let ye=!1;for(const Ke in H)if(H.hasOwnProperty(Ke)){const xe=o(_[Ke],H[Ke]);xe.didChange&&(_[Ke]=xe.newValue,ye=!0)}return new r(_,ye)}class a{constructor(H){this.schema=void 0,this.id=H,this.name="_never_",this.defaultValue=void 0}applyUpdate(H,ye){return o(H,ye)}validate(H){return this.defaultValue}}class h{constructor(H,ye,Ke,xe){this.id=H,this.name=ye,this.defaultValue=Ke,this.schema=xe}applyUpdate(H,ye){return o(H,ye)}validate(H){return typeof H>"u"?this.defaultValue:H}compute(H,ye,Ke){return Ke}}function t(_,H){return typeof _>"u"?H:_==="false"?!1:!!_}class s extends h{constructor(H,ye,Ke,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ke),super(H,ye,Ke,xe)}validate(H){return t(H,this.defaultValue)}}function n(_,H,ye,Ke){if(typeof _>"u")return H;let xe=parseInt(_,10);return isNaN(xe)?H:(xe=Math.max(ye,xe),xe=Math.min(Ke,xe),xe|0)}class i extends h{static clampedInt(H,ye,Ke,xe){return n(H,ye,Ke,xe)}constructor(H,ye,Ke,xe,ct,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Ke,gt.minimum=xe,gt.maximum=ct),super(H,ye,Ke,gt),this.minimum=xe,this.maximum=ct}validate(H){return i.clampedInt(H,this.defaultValue,this.minimum,this.maximum)}}function g(_,H,ye,Ke){if(typeof _>"u")return H;const xe=f.float(_,H);return f.clamp(xe,ye,Ke)}class f extends h{static clamp(H,ye,Ke){return H<ye?ye:H>Ke?Ke:H}static float(H,ye){if(typeof H=="number")return H;if(typeof H>"u")return ye;const Ke=parseFloat(H);return isNaN(Ke)?ye:Ke}constructor(H,ye,Ke,xe,ct){typeof ct<"u"&&(ct.type="number",ct.default=Ke),super(H,ye,Ke,ct),this.validationFn=xe}validate(H){return this.validationFn(f.float(H,this.defaultValue))}}class u extends h{static string(H,ye){return typeof H!="string"?ye:H}constructor(H,ye,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ke),super(H,ye,Ke,xe)}validate(H){return u.string(H,this.defaultValue)}}function b(_,H,ye,Ke){return typeof _!="string"?H:Ke&&_ in Ke?Ke[_]:ye.indexOf(_)===-1?H:_}class I extends h{constructor(H,ye,Ke,xe,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=xe,ct.default=Ke),super(H,ye,Ke,ct),this.c=xe}validate(H){return b(H,this.defaultValue,this.c)}}class D extends d{constructor(H,ye,Ke,xe,ct,gt,Tt=void 0){typeof Tt<"u"&&(Tt.type="string",Tt.enum=ct,Tt.default=xe),super(H,ye,Ke,Tt),this.c=ct,this.d=gt}validate(H){return typeof H!="string"?this.defaultValue:this.c.indexOf(H)===-1?this.defaultValue:this.d(H)}}function y(_){switch(_){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class p extends d{constructor(){super(Ue.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(H){switch(H){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(H,ye,Ke){return Ke===C.AccessibilitySupport.Unknown?H.accessibilitySupport:Ke}}class k extends d{constructor(){const H={insertSpace:!0,ignoreEmptyLines:!0};super(Ue.comments,"comments",H,{"editor.comments.insertSpace":{type:"boolean",default:H.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:H.ignoreEmptyLines,description:c.localize(5,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{insertSpace:t(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(m||(e.TextEditorCursorBlinkingStyle=m={}));function v(_){switch(_){case"blink":return m.Blink;case"smooth":return m.Smooth;case"phase":return m.Phase;case"expand":return m.Expand;case"solid":return m.Solid}}var F;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function M(_){switch(_){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function G(_){switch(_){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class q extends a{constructor(){super(Ue.editorClassName)}compute(H,ye,Ke){const xe=["monaco-editor"];return ye.get(Ue.extraEditorClassName)&&xe.push(ye.get(Ue.extraEditorClassName)),H.extraEditorClassName&&xe.push(H.extraEditorClassName),ye.get(Ue.mouseStyle)==="default"?xe.push("mouse-default"):ye.get(Ue.mouseStyle)==="copy"&&xe.push("mouse-copy"),ye.get(Ue.showUnused)&&xe.push("showUnused"),ye.get(Ue.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class V extends s{constructor(){super(Ue.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(H,ye,Ke){return Ke&&H.emptySelectionClipboard}}class N extends d{constructor(){const H={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ue.find,"find",H,{"editor.find.cursorMoveOnType":{type:"boolean",default:H.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:H.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:H.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:H.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:H.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:H.loop,description:c.localize(18,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{cursorMoveOnType:t(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof H.seedSearchStringFromSelection=="boolean"?H.seedSearchStringFromSelection?"always":"never":b(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof H.autoFindInSelection=="boolean"?H.autoFindInSelection?"always":"never":b(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ye.loop,this.defaultValue.loop)}}}class L extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ue.fontLigatures,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(H){return typeof H>"u"?this.defaultValue:typeof H=="string"?H==="false"||H.length===0?L.OFF:H==="true"?L.ON:H:H?L.ON:L.OFF}}e.EditorFontLigatures=L;class Z extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ue.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(H){return typeof H>"u"?this.defaultValue:typeof H=="string"?H==="false"?Z.OFF:H==="true"?Z.TRANSLATE:H:H?Z.TRANSLATE:Z.OFF}compute(H,ye,Ke){return H.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class re extends a{constructor(){super(Ue.fontInfo)}compute(H,ye,Ke){return H.fontInfo}}class fe extends h{constructor(){super(Ue.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(H){const ye=f.float(H,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ye,6,100)}compute(H,ye,Ke){return H.fontInfo.fontSize}}class be extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ue.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:be.d,maximum:be.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:be.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(H){return H==="normal"||H==="bold"?H:String(i.clampedInt(H,e.EDITOR_FONT_DEFAULTS.fontWeight,be.d,be.e))}}class oe extends d{constructor(){const H={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:H.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ue.gotoLocation,"gotoLocation",H,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:H.alternativeDefinitionCommand,enum:Ke,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:H.alternativeTypeDefinitionCommand,enum:Ke,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:H.alternativeDeclarationCommand,enum:Ke,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:H.alternativeImplementationCommand,enum:Ke,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:H.alternativeReferenceCommand,enum:Ke,description:c.localize(41,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{multiple:b(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??b(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??b(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??b(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??b(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??b(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends d{constructor(){const H={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ue.hover,"hover",H,{"editor.hover.enabled":{type:"boolean",default:H.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:H.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:H.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:H.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:H.above,description:c.localize(46,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),delay:i.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:t(ye.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ye.above,this.defaultValue.above)}}}var $e;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class se extends a{constructor(){super(Ue.layoutInfo)}compute(H,ye,Ke){return se.computeLayout(ye,{memory:H.memory,outerWidth:H.outerWidth,outerHeight:H.outerHeight,isDominatedByLongLines:H.isDominatedByLongLines,lineHeight:H.fontInfo.lineHeight,viewLineCount:H.viewLineCount,lineNumbersDigitCount:H.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:H.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:H.fontInfo.maxDigitWidth,pixelRatio:H.pixelRatio,glyphMarginDecorationLaneCount:H.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(H){const ye=H.height/H.lineHeight,Ke=Math.floor(H.paddingTop/H.lineHeight);let xe=Math.floor(H.paddingBottom/H.lineHeight);H.scrollBeyondLastLine&&(xe=Math.max(xe,ye-1));const ct=(Ke+H.viewLineCount+xe)/(H.pixelRatio*H.height),gt=Math.floor(H.viewLineCount/ct);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:xe,desiredRatio:ct,minimapLineCount:gt}}static c(H,ye){const Ke=H.outerWidth,xe=H.outerHeight,ct=H.pixelRatio;if(!H.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const gt=ye.stableMinimapLayoutInput,Tt=gt&&H.outerHeight===gt.outerHeight&&H.lineHeight===gt.lineHeight&&H.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&H.pixelRatio===gt.pixelRatio&&H.scrollBeyondLastLine===gt.scrollBeyondLastLine&&H.paddingTop===gt.paddingTop&&H.paddingBottom===gt.paddingBottom&&H.minimap.enabled===gt.minimap.enabled&&H.minimap.side===gt.minimap.side&&H.minimap.size===gt.minimap.size&&H.minimap.showSlider===gt.minimap.showSlider&&H.minimap.renderCharacters===gt.minimap.renderCharacters&&H.minimap.maxColumn===gt.minimap.maxColumn&&H.minimap.scale===gt.minimap.scale&&H.verticalScrollbarWidth===gt.verticalScrollbarWidth&&H.isViewportWrapping===gt.isViewportWrapping,Qt=H.lineHeight,zt=H.typicalHalfwidthCharacterWidth,ui=H.scrollBeyondLastLine,xt=H.minimap.renderCharacters;let Xe=ct>=2?Math.round(H.minimap.scale*2):H.minimap.scale;const Wt=H.minimap.maxColumn,Ut=H.minimap.size,ft=H.minimap.side,pt=H.verticalScrollbarWidth,_t=H.viewLineCount,Xt=H.remainingWidth,jt=H.isViewportWrapping,bt=xt?2:3;let Ot=Math.floor(ct*xe);const Gt=Ot/ct;let Bt=!1,Qe=!1,ei=bt*Xe,ti=Xe/ct,ci=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Yt,desiredRatio:si,minimapLineCount:Ct}=se.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:ui,paddingTop:H.paddingTop,paddingBottom:H.paddingBottom,height:xe,lineHeight:Qt,pixelRatio:ct});if(_t/Ct>1)Bt=!0,Qe=!0,Xe=1,ei=1,ti=Xe/ct;else{let $t=!1,qt=Xe+1;if(Ut==="fit"){const St=Math.ceil((Lt+_t+Yt)*ei);jt&&Tt&&Xt<=ye.stableFitRemainingWidth?($t=!0,qt=ye.stableFitMaxMinimapScale):$t=St>Ot}if(Ut==="fill"||$t){Bt=!0;const St=Xe;ei=Math.min(Qt*ct,Math.max(1,Math.floor(1/si))),jt&&Tt&&Xt<=ye.stableFitRemainingWidth&&(qt=ye.stableFitMaxMinimapScale),Xe=Math.min(qt,Math.max(1,Math.floor(ei/bt))),Xe>St&&(ci=Math.min(2,Xe/St)),ti=Xe/ct/ci,Ot=Math.ceil(Math.max(ri,Lt+_t+Yt)*ei),jt?(ye.stableMinimapLayoutInput=H,ye.stableFitRemainingWidth=Xt,ye.stableFitMaxMinimapScale=Xe):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Wt*ti),Mt=Math.min(Dt,Math.max(0,Math.floor((Xt-pt-2)*ti/(zt+ti)))+e.MINIMAP_GUTTER_WIDTH);let Pt=Math.floor(ct*Mt);const Nt=Pt/ct;Pt=Math.floor(Pt*ci);const li=xt?$e.Text:$e.Blocks,Vt=ft==="left"?0:Ke-Mt-pt;return{renderMinimap:li,minimapLeft:Vt,minimapWidth:Mt,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qe,minimapScale:Xe,minimapLineHeight:ei,minimapCanvasInnerWidth:Pt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Gt}}static computeLayout(H,ye){const Ke=ye.outerWidth|0,xe=ye.outerHeight|0,ct=ye.lineHeight|0,gt=ye.lineNumbersDigitCount|0,Tt=ye.typicalHalfwidthCharacterWidth,Qt=ye.maxDigitWidth,zt=ye.pixelRatio,ui=ye.viewLineCount,xt=H.get(Ue.wordWrapOverride2),Xe=xt==="inherit"?H.get(Ue.wordWrapOverride1):xt,Wt=Xe==="inherit"?H.get(Ue.wordWrap):Xe,Ut=H.get(Ue.wordWrapColumn),ft=ye.isDominatedByLongLines,pt=H.get(Ue.glyphMargin),_t=H.get(Ue.lineNumbers).renderType!==Me.Off,Xt=H.get(Ue.lineNumbersMinChars),jt=H.get(Ue.scrollBeyondLastLine),bt=H.get(Ue.padding),Ot=H.get(Ue.minimap),Gt=H.get(Ue.scrollbar),Bt=Gt.verticalScrollbarSize,Qe=Gt.verticalHasArrows,ei=Gt.arrowSize,ti=Gt.horizontalScrollbarSize,ci=H.get(Ue.folding),Dt=H.get(Ue.showFoldingControls)!=="never";let Mt=H.get(Ue.lineDecorationsWidth);ci&&Dt&&(Mt+=16);let Pt=0;if(_t){const Kt=Math.max(gt,Xt);Pt=Math.round(Kt*Qt)}let Nt=0;pt&&(Nt=ct*ye.glyphMarginDecorationLaneCount);let li=0,Vt=li+Nt,ri=Vt+Pt,Lt=ri+Mt;const Yt=Ke-Nt-Pt-Mt;let si=!1,Ct=!1,vt=-1;Xe==="inherit"&&ft?(si=!0,Ct=!0):Wt==="on"||Wt==="bounded"?Ct=!0:Wt==="wordWrapColumn"&&(vt=Ut);const $t=se.c({outerWidth:Ke,outerHeight:xe,lineHeight:ct,typicalHalfwidthCharacterWidth:Tt,pixelRatio:zt,scrollBeyondLastLine:jt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Ot,verticalScrollbarWidth:Bt,viewLineCount:ui,remainingWidth:Yt,isViewportWrapping:Ct},ye.memory||new S);$t.renderMinimap!==$e.None&&$t.minimapLeft===0&&(li+=$t.minimapWidth,Vt+=$t.minimapWidth,ri+=$t.minimapWidth,Lt+=$t.minimapWidth);const qt=Yt-$t.minimapWidth,St=Math.max(1,Math.floor((qt-Bt-2)/Tt)),oi=Qe?ei:0;return Ct&&(vt=Math.max(1,St),Wt==="bounded"&&(vt=Math.min(vt,Ut))),{width:Ke,height:xe,glyphMarginLeft:li,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:Vt,lineNumbersWidth:Pt,decorationsLeft:ri,decorationsWidth:Mt,contentLeft:Lt,contentWidth:qt,minimap:$t,viewportColumn:St,isWordWrapMinified:si,isViewportWrapping:Ct,wrappingColumn:vt,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ti,overviewRuler:{top:oi,width:Bt,height:xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=se;class Ce extends d{constructor(){super(Ue.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(H){return b(H,"simple",["simple","advanced"])}compute(H,ye,Ke){return ye.get(Ue.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":Ke}}var Fe;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class Y extends d{constructor(){const H={enabled:Fe.On};super(Ue.lightbulb,"lightbulb",H,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:H.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(H){return!H||typeof H!="object"?this.defaultValue:{enabled:b(H.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class W extends d{constructor(){const H={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ue.stickyScroll,"stickyScroll",H,{"editor.stickyScroll.enabled":{type:"boolean",default:H.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:H.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:H.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:H.scrollWithEditor,description:c.localize(57,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends d{constructor(){const H={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ue.inlayHints,"inlayHints",H,{"editor.inlayHints.enabled":{type:"string",default:H.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:H.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:H.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:H.padding,description:c.localize(65,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:b(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(ye.fontFamily,this.defaultValue.fontFamily),padding:t(ye.padding,this.defaultValue.padding)}}}class De extends d{constructor(){super(Ue.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(H){return typeof H=="string"&&/^\d+(\.\d+)?ch$/.test(H)?-parseFloat(H.substring(0,H.length-2)):i.clampedInt(H,this.defaultValue,0,1e3)}compute(H,ye,Ke){return Ke<0?i.clampedInt(-Ke*H.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class he extends f{constructor(){super(Ue.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,H=>f.clamp(H,0,150),{markdownDescription:c.localize(66,null)})}compute(H,ye,Ke){return H.fontInfo.lineHeight}}class ve extends d{constructor(){const H={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ue.minimap,"minimap",H,{"editor.minimap.enabled":{type:"boolean",default:H.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:H.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:H.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:H.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:H.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:H.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:H.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:H.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:H.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:H.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:H.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:H.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),autohide:t(ye.autohide,this.defaultValue.autohide),size:b(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ye.side,this.defaultValue.side,["right","left"]),showSlider:b(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ye.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ye.scale,1,1,3),maxColumn:i.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:t(ye.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:t(ye.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(ye.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(ye.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ae(_){return _==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(Ue.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{top:i.clampedInt(ye.top,0,0,1e3),bottom:i.clampedInt(ye.bottom,0,0,1e3)}}}class x extends d{constructor(){const H={enabled:!0,cycle:!0};super(Ue.parameterHints,"parameterHints",H,{"editor.parameterHints.enabled":{type:"boolean",default:H.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:H.cycle,description:c.localize(85,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),cycle:t(ye.cycle,this.defaultValue.cycle)}}}class me extends a{constructor(){super(Ue.pixelRatio)}compute(H,ye,Ke){return H.pixelRatio}}class ge extends d{constructor(){const H={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(Ue.quickSuggestions,"quickSuggestions",H,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:H.strings,description:c.localize(89,null)},comments:{anyOf:ye,default:H.comments,description:c.localize(90,null)},other:{anyOf:ye,default:H.other,description:c.localize(91,null)}},default:H,markdownDescription:c.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=H}validate(H){if(typeof H=="boolean"){const zt=H?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!H||typeof H!="object")return this.defaultValue;const{other:ye,comments:Ke,strings:xe}=H,ct=["on","inline","off"];let gt,Tt,Qt;return typeof ye=="boolean"?gt=ye?"on":"off":gt=b(ye,this.defaultValue.other,ct),typeof Ke=="boolean"?Tt=Ke?"on":"off":Tt=b(Ke,this.defaultValue.comments,ct),typeof xe=="boolean"?Qt=xe?"on":"off":Qt=b(xe,this.defaultValue.strings,ct),{other:gt,comments:Tt,strings:Qt}}}var Me;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Me||(e.RenderLineNumbersType=Me={}));class Be extends d{constructor(){super(Ue.lineNumbers,"lineNumbers",{renderType:Me.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(H){let ye=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof H<"u"&&(typeof H=="function"?(ye=Me.Custom,Ke=H):H==="interval"?ye=Me.Interval:H==="relative"?ye=Me.Relative:H==="on"?ye=Me.On:ye=Me.Off),{renderType:ye,renderFn:Ke}}}function Ee(_){const H=_.get(Ue.renderValidationDecorations);return H==="editable"?_.get(Ue.readOnly):H!=="on"}class Re extends d{constructor(){const H=[],ye={type:"number",description:c.localize(98,null)};super(Ue.rulers,"rulers",H,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:H,description:c.localize(100,null)})}validate(H){if(Array.isArray(H)){const ye=[];for(const Ke of H)if(typeof Ke=="number")ye.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const xe=Ke;ye.push({column:i.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ye.sort((Ke,xe)=>Ke.column-xe.column),ye}return this.defaultValue}}class Oe extends d{constructor(){super(Ue.readOnlyMessage,"readOnlyMessage",void 0)}validate(H){return!H||typeof H!="object"?this.defaultValue:H}}function j(_,H){if(typeof _!="string")return H;switch(_){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class U extends d{constructor(){const H={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ue.scrollbar,"scrollbar",H,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:H.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:H.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:H.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:H.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H,Ke=i.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=i.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(ye.vertical,this.defaultValue.vertical),horizontal:j(ye.horizontal,this.defaultValue.horizontal),useShadows:t(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(ye.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:i.clampedInt(ye.verticalSliderSize,xe,0,1e3),scrollByPage:t(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends d{constructor(){const H={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ue.unicodeHighlighting,"unicodeHighlight",H,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:H.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:H.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:H.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:H.allowedLocales,description:c.localize(119,null)}})}applyUpdate(H,ye){let Ke=!1;ye.allowedCharacters&&H&&(R.$ao(H.allowedCharacters,ye.allowedCharacters)||(H={...H,allowedCharacters:ye.allowedCharacters},Ke=!0)),ye.allowedLocales&&H&&(R.$ao(H.allowedLocales,ye.allowedLocales)||(H={...H,allowedLocales:ye.allowedLocales},Ke=!0));const xe=super.applyUpdate(H,ye);return Ke?new r(xe.newValue,!0):xe}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{nonBasicASCII:je(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:je(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:je(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(H.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(H.allowedLocales,this.defaultValue.allowedLocales)}}c(H,ye){if(typeof H!="object"||!H)return ye;const Ke={};for(const[xe,ct]of Object.entries(H))ct===!0&&(Ke[xe]=!0);return Ke}}class J extends d{constructor(){const H={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ue.inlineSuggest,"inlineSuggest",H,{"editor.inlineSuggest.enabled":{type:"boolean",default:H.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:H.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:H.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:H.fontFamily,description:c.localize(126,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),mode:b(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(ye.fontFamily,this.defaultValue.fontFamily)}}}class te extends d{constructor(){const H={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ue.inlineEdit,"experimentalInlineEdit",H,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:H.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:H.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:H.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:H.backgroundColoring,description:c.localize(133,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showToolbar:b(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(ye.fontFamily,this.defaultValue.fontFamily),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:t(ye.backgroundColoring,this.defaultValue.backgroundColoring)}}}class ue extends d{constructor(){const H={enabled:T.$nu.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$nu.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ue.bracketPairColorization,"bracketPairColorization",H,{"editor.bracketPairColorization.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:H.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ae extends d{constructor(){const H={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ue.guides,"guides",H,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:H.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:H.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:H.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:H.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:H.highlightActiveIndentation,description:c.localize(149,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{bracketPairs:je(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:je(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:je(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function je(_,H,ye){const Ke=ye.indexOf(_);return Ke===-1?H:ye[Ke]}class Ge extends d{constructor(){const H={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ue.suggest,"suggest",H,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:H.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:H.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:H.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:H.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:H.selectionMode,markdownDescription:c.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:H.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:H.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:H.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:H.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:H.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{insertMode:b(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ye.showIcons,this.defaultValue.showIcons),showStatusBar:t(ye.showStatusBar,this.defaultValue.showStatusBar),preview:t(ye.preview,this.defaultValue.preview),previewMode:b(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ye.showMethods,this.defaultValue.showMethods),showFunctions:t(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ye.showFields,this.defaultValue.showFields),showVariables:t(ye.showVariables,this.defaultValue.showVariables),showClasses:t(ye.showClasses,this.defaultValue.showClasses),showStructs:t(ye.showStructs,this.defaultValue.showStructs),showInterfaces:t(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ye.showModules,this.defaultValue.showModules),showProperties:t(ye.showProperties,this.defaultValue.showProperties),showEvents:t(ye.showEvents,this.defaultValue.showEvents),showOperators:t(ye.showOperators,this.defaultValue.showOperators),showUnits:t(ye.showUnits,this.defaultValue.showUnits),showValues:t(ye.showValues,this.defaultValue.showValues),showConstants:t(ye.showConstants,this.defaultValue.showConstants),showEnums:t(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ye.showKeywords,this.defaultValue.showKeywords),showWords:t(ye.showWords,this.defaultValue.showWords),showColors:t(ye.showColors,this.defaultValue.showColors),showFiles:t(ye.showFiles,this.defaultValue.showFiles),showReferences:t(ye.showReferences,this.defaultValue.showReferences),showFolders:t(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ye.showSnippets,this.defaultValue.showSnippets),showUsers:t(ye.showUsers,this.defaultValue.showUsers),showIssues:t(ye.showIssues,this.defaultValue.showIssues)}}}class Ze extends d{constructor(){super(Ue.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(H){return!H||typeof H!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(H.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(H.selectSubwords,this.defaultValue.selectSubwords)}}}class tt extends d{constructor(){const H=[];super(Ue.wordSegmenterLocales,"wordSegmenterLocales",H,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(H){if(typeof H=="string"&&(H=[H]),Array.isArray(H)){const ye=[];for(const Ke of H)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&ye.push(Ke)}catch{}return ye}return this.defaultValue}}var _e;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(_e||(e.WrappingIndent=_e={}));class it extends d{constructor(){super(Ue.wrappingIndent,"wrappingIndent",_e.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(H){switch(H){case"none":return _e.None;case"same":return _e.Same;case"indent":return _e.Indent;case"deepIndent":return _e.DeepIndent}return _e.Same}compute(H,ye,Ke){return ye.get(Ue.accessibilitySupport)===C.AccessibilitySupport.Enabled?_e.None:Ke}}class nt extends a{constructor(){super(Ue.wrappingInfo)}compute(H,ye,Ke){const xe=ye.get(Ue.layoutInfo);return{isDominatedByLongLines:H.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class mt extends d{constructor(){const H={enabled:!0,showDropSelector:"afterDrop"};super(Ue.dropIntoEditor,"dropIntoEditor",H,{"editor.dropIntoEditor.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showDropSelector:b(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends d{constructor(){const H={enabled:!0,showPasteSelector:"afterPaste"};super(Ue.pasteAs,"pasteAs",H,{"editor.pasteAs.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showPasteSelector:b(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?at:P.$k?dt:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(_){return e.editorOptionsRegistry[_.id]=_,_}var Ue;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.inlineEdit=63]="inlineEdit",_[_.letterSpacing=64]="letterSpacing",_[_.lightbulb=65]="lightbulb",_[_.lineDecorationsWidth=66]="lineDecorationsWidth",_[_.lineHeight=67]="lineHeight",_[_.lineNumbers=68]="lineNumbers",_[_.lineNumbersMinChars=69]="lineNumbersMinChars",_[_.linkedEditing=70]="linkedEditing",_[_.links=71]="links",_[_.matchBrackets=72]="matchBrackets",_[_.minimap=73]="minimap",_[_.mouseStyle=74]="mouseStyle",_[_.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=76]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",_[_.multiCursorModifier=78]="multiCursorModifier",_[_.multiCursorPaste=79]="multiCursorPaste",_[_.multiCursorLimit=80]="multiCursorLimit",_[_.occurrencesHighlight=81]="occurrencesHighlight",_[_.overviewRulerBorder=82]="overviewRulerBorder",_[_.overviewRulerLanes=83]="overviewRulerLanes",_[_.padding=84]="padding",_[_.pasteAs=85]="pasteAs",_[_.parameterHints=86]="parameterHints",_[_.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",_[_.quickSuggestions=89]="quickSuggestions",_[_.quickSuggestionsDelay=90]="quickSuggestionsDelay",_[_.readOnly=91]="readOnly",_[_.readOnlyMessage=92]="readOnlyMessage",_[_.renameOnType=93]="renameOnType",_[_.renderControlCharacters=94]="renderControlCharacters",_[_.renderFinalNewline=95]="renderFinalNewline",_[_.renderLineHighlight=96]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=98]="renderValidationDecorations",_[_.renderWhitespace=99]="renderWhitespace",_[_.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",_[_.roundedSelection=101]="roundedSelection",_[_.rulers=102]="rulers",_[_.scrollbar=103]="scrollbar",_[_.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=105]="scrollBeyondLastLine",_[_.scrollPredominantAxis=106]="scrollPredominantAxis",_[_.selectionClipboard=107]="selectionClipboard",_[_.selectionHighlight=108]="selectionHighlight",_[_.selectOnLineNumbers=109]="selectOnLineNumbers",_[_.showFoldingControls=110]="showFoldingControls",_[_.showUnused=111]="showUnused",_[_.snippetSuggestions=112]="snippetSuggestions",_[_.smartSelect=113]="smartSelect",_[_.smoothScrolling=114]="smoothScrolling",_[_.stickyScroll=115]="stickyScroll",_[_.stickyTabStops=116]="stickyTabStops",_[_.stopRenderingLineAfter=117]="stopRenderingLineAfter",_[_.suggest=118]="suggest",_[_.suggestFontSize=119]="suggestFontSize",_[_.suggestLineHeight=120]="suggestLineHeight",_[_.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",_[_.suggestSelection=122]="suggestSelection",_[_.tabCompletion=123]="tabCompletion",_[_.tabIndex=124]="tabIndex",_[_.unicodeHighlighting=125]="unicodeHighlighting",_[_.unusualLineTerminators=126]="unusualLineTerminators",_[_.useShadowDOM=127]="useShadowDOM",_[_.useTabStops=128]="useTabStops",_[_.wordBreak=129]="wordBreak",_[_.wordSegmenterLocales=130]="wordSegmenterLocales",_[_.wordSeparators=131]="wordSeparators",_[_.wordWrap=132]="wordWrap",_[_.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=135]="wordWrapColumn",_[_.wordWrapOverride1=136]="wordWrapOverride1",_[_.wordWrapOverride2=137]="wordWrapOverride2",_[_.wrappingIndent=138]="wrappingIndent",_[_.wrappingStrategy=139]="wrappingStrategy",_[_.showDeprecated=140]="showDeprecated",_[_.inlayHints=141]="inlayHints",_[_.editorClassName=142]="editorClassName",_[_.pixelRatio=143]="pixelRatio",_[_.tabFocusMode=144]="tabFocusMode",_[_.layoutInfo=145]="layoutInfo",_[_.wrappingInfo=146]="wrappingInfo",_[_.defaultColorDecorators=147]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ue||(e.EditorOption=Ue={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new s(Ue.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:We(new I(Ue.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:We(new p),accessibilityPageSize:We(new i(Ue.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:We(new u(Ue.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:We(new s(Ue.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new s(Ue.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:We(new I(Ue.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:We(new I(Ue.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:We(new I(Ue.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:We(new I(Ue.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:We(new I(Ue.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:We(new D(Ue.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:We(new s(Ue.automaticLayout,"automaticLayout",!1)),autoSurround:We(new I(Ue.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:We(new ue),bracketPairGuides:We(new Ae),stickyTabStops:We(new s(Ue.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:We(new s(Ue.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:We(new u(Ue.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:We(new i(Ue.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:We(new s(Ue.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:We(new I(Ue.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:We(new i(Ue.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:We(new s(Ue.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:We(new k),contextmenu:We(new s(Ue.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new s(Ue.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:We(new D(Ue.cursorBlinking,"cursorBlinking",m.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:We(new I(Ue.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:We(new D(Ue.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],G,{description:c.localize(261,null)})),cursorSurroundingLines:We(new i(Ue.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:We(new I(Ue.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:We(new i(Ue.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:We(new s(Ue.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new s(Ue.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new s(Ue.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new s(Ue.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:We(new V),dropIntoEditor:We(new mt),stickyScroll:We(new W),experimentalWhitespaceRendering:We(new I(Ue.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:We(new u(Ue.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new f(Ue.fastScrollSensitivity,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:c.localize(272,null)})),find:We(new N),fixedOverflowWidgets:We(new s(Ue.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new s(Ue.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:We(new I(Ue.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:We(new s(Ue.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:We(new s(Ue.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:We(new i(Ue.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:We(new s(Ue.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:We(new u(Ue.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:We(new re),fontLigatures2:We(new L),fontSize:We(new fe),fontWeight:We(new be),fontVariations:We(new Z),formatOnPaste:We(new s(Ue.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:We(new s(Ue.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:We(new s(Ue.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:We(new oe),hideCursorInOverviewRuler:We(new s(Ue.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:We(new pe),inDiffEditor:We(new s(Ue.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new f(Ue.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>f.clamp(_,-5,20),{description:c.localize(286,null)})),lightbulb:We(new Y),lineDecorationsWidth:We(new De),lineHeight:We(new he),lineNumbers:We(new Be),lineNumbersMinChars:We(new i(Ue.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new s(Ue.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:We(new s(Ue.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:We(new I(Ue.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:We(new ve),mouseStyle:We(new I(Ue.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new f(Ue.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:We(new s(Ue.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:We(new s(Ue.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:We(new D(Ue.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:We(new I(Ue.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:We(new i(Ue.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:We(new I(Ue.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:We(new s(Ue.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:We(new i(Ue.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new X),pasteAs:We(new ut),parameterHints:We(new x),peekWidgetDefaultFocus:We(new I(Ue.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),definitionLinkOpensInPeek:We(new s(Ue.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:We(new ge),quickSuggestionsDelay:We(new i(Ue.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:We(new s(Ue.readOnly,"readOnly",!1)),readOnlyMessage:We(new Oe),renameOnType:We(new s(Ue.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:We(new s(Ue.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:We(new I(Ue.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:We(new I(Ue.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:We(new s(Ue.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:We(new I(Ue.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new I(Ue.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:We(new i(Ue.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new s(Ue.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:We(new Re),scrollbar:We(new U),scrollBeyondLastColumn:We(new i(Ue.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:We(new s(Ue.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:We(new s(Ue.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:We(new s(Ue.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:We(new s(Ue.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:We(new s(Ue.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new I(Ue.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:We(new s(Ue.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:We(new s(Ue.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:We(new ie),snippetSuggestions:We(new I(Ue.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:We(new Ze),smoothScrolling:We(new s(Ue.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:We(new i(Ue.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new Ge),inlineSuggest:We(new J),inlineEdit:We(new te),inlineCompletionsAccessibilityVerbose:We(new s(Ue.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:We(new i(Ue.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new i(Ue.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new s(Ue.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:We(new I(Ue.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:We(new I(Ue.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:We(new i(Ue.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new K),unusualLineTerminators:We(new I(Ue.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:We(new s(Ue.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new s(Ue.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:We(new I(Ue.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:We(new tt),wordSeparators:We(new u(Ue.wordSeparators,"wordSeparators",$.$rt,{description:c.localize(360,null)})),wordWrap:We(new I(Ue.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:We(new u(Ue.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new u(Ue.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new i(Ue.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:We(new I(Ue.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new I(Ue.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new q),defaultColorDecorators:We(new s(Ue.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:We(new me),tabFocusMode:We(new s(Ue.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:We(new se),wrappingInfo:We(new nt),wrappingIndent:We(new it),wrappingStrategy:We(new Ce)}}),define(ke[105],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,E.$Ai)("environmentService"),e.$Ii=(0,E.$Bi)(e.$Hi)}),define(ke[30],Ie([1,0,58,20,13,15,2,172,3,21,16,47]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=l,e.$9k=o,e.$0k=h,e.$$k=t,e.$_k=s,e.$al=n,e.$bl=i,e.$cl=g,e.$dl=f,e.$el=u,e.$fl=b,e.$hl=y,e.$il=p,e.$jl=k,e.$kl=m,e.$ll=v,e.$ol=V,e.$Al=be,e.$Bl=oe,e.$Dl=$e,e.$7k=(0,$.$Ai)("fileService");function l(se){return se.create===!0}var S;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(se){const Ce=se;return!!Ce&&typeof Ce.onDidChange=="function"}var a;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(se){return!!(se.capabilities&a.FileReadWrite)}function t(se){return!!(se.capabilities&a.FileFolderCopy)}function s(se){return!!(se.capabilities&a.FileClone)}function n(se){return!!(se.capabilities&a.FileOpenReadWriteClose)}function i(se){return!!(se.capabilities&a.FileReadStream)}function g(se){return h(se)?!!(se.capabilities&a.FileAtomicRead):!1}function f(se){return h(se)?!!(se.capabilities&a.FileAtomicWrite):!1}function u(se){return!!(se.capabilities&a.FileAtomicDelete)}function b(se){return!!(se.capabilities&a.Readonly)}var I;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Ce,Fe){const Y=new D(Ce.toString(),Fe);return k(Y,Fe),Y}constructor(Ce,Fe){super(Ce),this.code=Fe}}e.$gl=D;function y(se,Ce){return D.create(se,Ce)}function p(se){return se||y((0,T.localize)(0,null),I.Unknown)}function k(se,Ce){return se.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",se}function m(se){if(!se)return I.Unknown;if(se instanceof D)return se.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Ce)return I.Unknown;switch(Ce[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function v(se){if(se instanceof N)return se.fileOperationResult;switch(m(se)){case I.FileNotFound:return re.FILE_NOT_FOUND;case I.FileIsADirectory:return re.FILE_IS_DIRECTORY;case I.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return re.FILE_WRITE_LOCKED;case I.NoPermissions:return re.FILE_PERMISSION_DENIED;case I.FileExists:return re.FILE_MOVE_CONFLICT;case I.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var F;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class M{constructor(Ce,Fe,Y){this.resource=Ce,this.operation=Fe,this.target=Y}isOperation(Ce){return this.operation===Ce}}e.$ml=M;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor(Ce,Fe){this.c=Fe,this.b=void 0,this.d=new w.$V(()=>{const Y=E.$Gi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(W=>[W,!0])),Y}),this.f=new w.$V(()=>{const Y=E.$Gi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(W=>[W,!0])),Y}),this.g=new w.$V(()=>{const Y=E.$Gi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(W=>[W,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Ce){switch(Y.type){case G.ADDED:this.rawAdded.push(Y.resource);break;case G.UPDATED:this.rawUpdated.push(Y.resource);break;case G.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==q.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ce,...Fe){return this.h(Ce,{includeChildren:!1},...Fe)}affects(Ce,...Fe){return this.h(Ce,{includeChildren:!0},...Fe)}h(Ce,Fe,...Y){if(!Ce)return!1;const W=Y.length>0;return!!((!W||Y.includes(G.ADDED))&&(this.d.value.get(Ce)||Fe.includeChildren&&this.d.value.findSuperstr(Ce))||(!W||Y.includes(G.UPDATED))&&(this.f.value.get(Ce)||Fe.includeChildren&&this.f.value.findSuperstr(Ce))||(!W||Y.includes(G.DELETED))&&(this.g.value.findSubstr(Ce)||Fe.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$nl=q;function V(se,Ce,Fe){return!se||!Ce||se===Ce||Ce.length>se.length?!1:(Ce.charAt(Ce.length-1)!==R.sep&&(Ce+=R.sep),Fe?(0,P.$Cf)(se,Ce):se.indexOf(Ce)===0)}class N extends Error{constructor(Ce,Fe,Y){super(Ce),this.fileOperationResult=Fe,this.options=Y}}e.$pl=N;class L extends N{constructor(Ce,Fe,Y,W){super(Ce,Fe,W),this.fileOperationResult=Fe,this.size=Y}}e.$ql=L;class Z extends N{constructor(Ce,Fe,Y){super(Ce,re.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Fe}}e.$rl=Z;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var fe;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$zl="";function be(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function oe(se,Ce){if(!Ce.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(Fe=>{const Y=Ce.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===se.scheme&&W.added&&(Y.dispose(),Fe())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Ce){return(0,O.$eg)(Ce)||(Ce=0),Ce<pe.KB?(0,T.localize)(1,null,Ce.toFixed(0)):Ce<pe.MB?(0,T.localize)(2,null,(Ce/pe.KB).toFixed(2)):Ce<pe.GB?(0,T.localize)(3,null,(Ce/pe.MB).toFixed(2)):Ce<pe.TB?(0,T.localize)(4,null,(Ce/pe.GB).toFixed(2)):(0,T.localize)(5,null,(Ce/pe.TB).toFixed(2))}}e.$Cl=pe;function $e(se){const Ce=typeof se=="string"||se?.scheme===C.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===C.Schemas.file?1024*pe.MB:Ce?10*pe.MB:c.$o?50*pe.MB:1024*pe.MB}}),define(ke[75],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class E{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$yi=E}),define(ke[210],Ie([1,0,11,14,6,74,207,3,75,211]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const C=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new $.$yi,a=!1,h,t=C){this.i=o,this.j=a,this.k=h,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$zi,this),this._globalGraph=t?h?._globalGraph??new A.$jr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,t=new class extends l{dispose(){h.h.delete(t),super.dispose()}}(o,this.j,this,this.l);return this.h.add(t),a?.add(t),t}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let t=!1;try{return o({get:n=>{if(t)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(n,h);if(!i)throw new Error(`[invokeFunction] unknown service '${n}'`);return i}},...a)}finally{t=!0,h.stop()}}createInstance(o,...a){this.m();let h,t;return o instanceof O.$xi?(h=d.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),t=this.o(o,a,h)),h.stop(),t}o(o,a=[],h){const t=T._util.getServiceDependencies(o).sort((i,g)=>i.index-g.index),s=[];for(const i of t){const g=this.s(i.id,h);g||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),s.push(g)}const n=t.length>0?t[0].index:a.length;if(a.length!==n){console.trace(`[createInstance] First service dependency of ${o.name} at position ${n+1} conflicts with ${a.length} static arguments`);const i=n-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,n)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof O.$xi)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof O.$xi?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const t=new A.$jr(i=>i.id.toString());let s=0;const n=[{id:o,desc:a,_trace:h}];for(;n.length;){const i=n.pop();if(t.lookupOrInsertNode(i),s++>1e3)throw new w(t);for(const g of T._util.getServiceDependencies(i.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${o} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(g.id)),f instanceof O.$xi){const u={id:g.id,desc:f,_trace:i._trace.branch(g.id,!0)};t.insertEdge(i,u),n.push(u)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new w(t);break}for(const{data:g}of i){if(this.r(g.id)instanceof O.$xi){const u=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,u)}t.removeNode(g)}}return this.r(o)}w(o,a,h=[],t,s){if(this.i.get(o)instanceof O.$xi)return this.x(o,a,h,t,s,this.g);if(this.k)return this.k.w(o,a,h,t,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],t,s,n){if(t){const i=new l(void 0,this.j,this,this.l);i.c=String(o);const g=new Map,f=new E.$Th(()=>{const u=i.o(a,h,s);for(const[b,I]of g){const D=u[b];if(typeof D=="function")for(const y of I)y.disposable=D.apply(u,y.listener)}return g.clear(),n.add(u),u});return new Proxy(Object.create(null),{get(u,b){if(!f.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let y=g.get(b);return y||(y=new c.$5c,g.set(b,y)),(k,m,v)=>{if(f.isInitialized)return f.value[b](k,m,v);{const F={listener:[k,m,v],disposable:void 0},M=y.push(F);return(0,P.$Sc)(()=>{M(),F.disposable?.dispose()})}}}if(b in u)return u[b];const I=f.value;let D=I[b];return typeof D!="function"||(D=D.bind(I),u[b]=D),D},set(u,b,I){return f.value[b]=I,!0},getPrototypeOf(u){return a.prototype}})}else{const i=this.o(a,h,s);return n.add(i),i}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$kr=l;var S;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(S.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(S.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(S.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,n){const i=[],g=new Array(s+1).join("	");for(const[f,u,b]of n.h)if(u&&b){a=!0,i.push(`${g}CREATES -> ${f}`);const I=h(s+1,b);I&&i.push(I)}else i.push(`${g}uses -> ${f}`);return i.join(`
`)}const t=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(t.join(`
`))}}e.$lr=d}),define(ke[12],Ie([1,0,173,48,4,76,6,29,21,24,15,2,32,3]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=r,e.log=a,e.$ik=D,e.$jk=y,e.$kk=p,e.$lk=k,e.$7j=(0,S.$Ai)("logService"),e.$8j=(0,S.$Ai)("loggerService");function d(){return new Date().toISOString()}function r(m){return(0,C.$eg)(m)}var o;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$0j=o.Info;function a(m,v,F){switch(v){case o.Trace:m.trace(F);break;case o.Debug:m.debug(F);break;case o.Info:m.info(F);break;case o.Warning:m.warn(F);break;case o.Error:m.error(F);break;case o.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function h(m,v=!1){let F="";for(let M=0;M<m.length;M++){let G=m[M];if(G instanceof Error&&(G=(0,R.$lj)(G,v)),typeof G=="object")try{G=JSON.stringify(G)}catch{}F+=(M>0?" ":"")+G}return F}class t extends A.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new P.$he),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==o.Off&&this.b<=v}}e.$_j=t;class s extends t{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(o.Trace)&&this.g(o.Trace,h([v,...F],!0))}debug(v,...F){this.f(o.Debug)&&this.g(o.Debug,h([v,...F]))}info(v,...F){this.f(o.Info)&&this.g(o.Info,h([v,...F]))}warn(v,...F){this.f(o.Warning)&&this.g(o.Warning,h([v,...F]))}error(v,...F){if(this.f(o.Error))if(v instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=v.stack,this.g(o.Error,h(M))}else this.g(o.Error,h([v,...F]))}flush(){}}e.$ak=s;class n extends t{constructor(v=e.$0j){super(),this.setLevel(v),this.g=!$.$i}trace(v,...F){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...F):console.log(`[main ${d()}]`,v,...F))}debug(v,...F){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...F):console.log(`[main ${d()}]`,v,...F))}info(v,...F){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...F):console.log(`[main ${d()}]`,v,...F))}warn(v,...F){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,v,...F):console.warn(`[main ${d()}]`,v,...F))}error(v,...F){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,v,...F):console.error(`[main ${d()}]`,v,...F))}flush(){}}e.$bk=n;class i extends t{constructor(v=e.$0j,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$ck=i;class g extends t{constructor(v,F=e.$0j){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(v),...F])}debug(v,...F){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(v),...F])}info(v,...F){this.f(o.Info)&&this.g.log(o.Info,[this.h(v),...F])}warn(v,...F){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(v),...F])}error(v,...F){this.f(o.Error)&&this.g.log(o.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,R.$lj)(v,this.f(o.Trace))}flush(){}}e.$dk=g;class f extends t{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const M of this.g)M.trace(v,...F)}debug(v,...F){for(const M of this.g)M.debug(v,...F)}info(v,...F){for(const M of this.g)M.info(v,...F)}warn(v,...F){for(const M of this.g)M.warn(v,...F)}error(v,...F){for(const M of this.g)M.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$ek=f;class u extends A.$Uc{constructor(v,F,M){if(super(),this.h=v,this.j=F,this.b=new T.$Ac,this.c=this.B(new P.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$he),this.onDidChangeVisibility=this.g.event,M)for(const G of M)this.b.set(G.resource,{logger:void 0,info:G})}m(v){return(0,C.$ag)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const M=this.n(v),G=(0,C.$ag)(v)?v:F?.id??(0,O.$oj)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const V=F?.logLevel==="always"?o.Trace:F?.logLevel;q||(q=this.s(M,V??this.getLogLevel(M)??this.h,{...F,id:G}));const N={logger:q,info:{resource:M,id:G,logLevel:V,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(N.info),this.b.set(M,N),q}n(v){return(0,C.$ag)(v)?(0,c.$bh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(w.URI.isUri(v)){const M=v,G=F,q=this.b.get(M);q&&G!==q.info.logLevel&&(q.info.logLevel=G===this.h?void 0:G,q.logger?.setLevel(G),this.b.set(q.info.resource,q),this.f.fire([M,G]))}else{this.h=v;for(const[M,G]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&G.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const M=this.m(v);M&&F!==!M.info.hidden&&(M.info.hidden=!F,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=u;class b{constructor(){this.onDidChangeLogLevel=new P.$he().event}setLevel(v){}getLevel(){return o.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$gk=b;class I extends b{}e.$hk=I;function D(m){if(m.verbose)return o.Trace;if(typeof m.logLevel=="string"){const v=k(m.logLevel.toLowerCase());if(v!==void 0)return v}return e.$0j}function y(m){switch(m){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function p(m){switch(m){case o.Trace:return{original:"Trace",value:E.localize(0,null)};case o.Debug:return{original:"Debug",value:E.localize(1,null)};case o.Info:return{original:"Info",value:E.localize(2,null)};case o.Warning:return{original:"Warning",value:E.localize(3,null)};case o.Error:return{original:"Error",value:E.localize(4,null)};case o.Off:return{original:"Off",value:E.localize(5,null)}}}function k(m){switch(m){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$mk=new l.$Rj("logLevel",y(o.Info))}),define(ke[212],Ie([1,0,6,12]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;class P extends E.$Uc{constructor(A,T=[]){super(),this.a=new R.$ek([A,...T]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$lQ=P}),define(ke[106],Ie([1,0,35,174,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function c(d,r){return r-d}$.compare=c;const C=Object.create(null);C[$.Error]=(0,R.localize)(0,null),C[$.Warning]=(0,R.localize)(1,null),C[$.Info]=(0,R.localize)(2,null);function w(d){return C[d]||""}$.toString=w;function l(d){switch(d){case E.default.Error:return $.Error;case E.default.Warning:return $.Warning;case E.default.Info:return $.Info;case E.default.Ignore:return $.Hint}}$.fromSeverity=l;function S(d){switch(d){case $.Error:return E.default.Error;case $.Warning:return E.default.Warning;case $.Info:return E.default.Info;case $.Hint:return E.default.Ignore}}$.toSeverity=S}(A||(e.MarkerSeverity=A={}));var T;(function($){const c="";function C(l){return w(l,!0)}$.makeKey=C;function w(l,S){const d=[c];return l.source?d.push(l.source.replace("\xA6","\\\xA6")):d.push(c),l.code?typeof l.code=="string"?d.push(l.code.replace("\xA6","\\\xA6")):d.push(l.code.value.replace("\xA6","\\\xA6")):d.push(c),l.severity!==void 0&&l.severity!==null?d.push(A.toString(l.severity)):d.push(c),l.message&&S?d.push(l.message.replace("\xA6","\\\xA6")):d.push(c),l.startLineNumber!==void 0&&l.startLineNumber!==null?d.push(l.startLineNumber.toString()):d.push(c),l.startColumn!==void 0&&l.startColumn!==null?d.push(l.startColumn.toString()):d.push(c),l.endLineNumber!==void 0&&l.endLineNumber!==null?d.push(l.endLineNumber.toString()):d.push(c),l.endColumn!==void 0&&l.endColumn!==null?d.push(l.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}$.makeKeyOptionalMessage=w})(T||(e.IMarkerData=T={})),e.$Gv=(0,P.$Ai)("markerService")}),define(ke[213],Ie([1,0,4,35,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$gw=e.Severity=void 0,e.$hw=T,e.Severity=R.default,e.$gw=(0,P.$Ai)("notificationService");var O;(function(w){w[w.DEFAULT=0]="DEFAULT",w[w.SILENT=1]="SILENT",w[w.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.PROFILE=1]="PROFILE",w[w.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(w){if(w){const l=w;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var $;(function(w){w[w.OFF=0]="OFF",w[w.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class c{constructor(){this.progress=new C,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$iw=c;class C{infinite(){}done(){}total(l){}worked(l){}}e.$jw=C}),define(ke[107],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,E.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(de,e,E,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,E):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(de,e,E,R);else for(var T=de.length-1;T>=0;T--)(A=de[T])&&(O=(P<3?A(O):P>3?A(e,E,O):A(e,E))||O);return P>3&&O&&Object.defineProperty(e,E,O),O},Ve=this&&this.__param||function(de,e){return function(E,R){e(E,R,de)}};define(ke[77],Ie([1,0,11,22,6,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.ProgressLocation=e.$kw=void 0,e.$kw=(0,O.$Ai)("progressService");var A;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$lw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$mw=T;class ${get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const S=this.d;this.d=()=>{S?.(),l()}}):Promise.resolve()}}e.$nw=$;let c=class extends P.$Uc{constructor(l,S){super(),this.a=new E.$Xh,S.withProgress(l,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$ow=c,e.$ow=c=He([Ve(1,e.$kw)],c);class C extends P.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Tc)}start(l){this.stop();const S=++this.a,d=new R.$se;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>d.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$pw=C,e.$qw=(0,O.$Ai)("editorProgressService")}),define(ke[31],Ie([1,0,61,15]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class P{constructor(){this.a=new Map}add(A,T){E.ok(R.$ag(A)),E.ok(R.$cg(T)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$jo=new P}),define(ke[78],Ie([1,0,4,31]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function P(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class O{constructor(){this.b=new E.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,c){this.a[P($)]=c,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;R.$jo.add(e.$ko.JSONContribution,A)}),define(ke[54],Ie([1,0,18,4,15,167,42,78,31]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=r,e.$Ao=o,e.$Bo=a,e.$Co=t,e.$Do=s;var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$oo={Configuration:"base.contributions.configuration"};var C;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const w=$.$jo.as(T.$ko.JSONContribution);class l{constructor(){this.h=new Set,this.i=new R.$he,this.onDidSchemaChange=this.i.event,this.j=new R.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(i,g=!0){this.registerConfigurations([i],g)}registerConfigurations(i,g=!0){const f=new Set;this.n(i,g,f),w.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(i){const g=new Set;this.o(i,g),w.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:i,remove:g}){const f=new Set;this.o(g,f),this.n(i,!1,f),w.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(i){const g=new Set;this.k(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(i,g){const f=[];for(const{overrides:u,source:b}of i)for(const I in u)if(g.add(I),e.$yo.test(I)){const D=this.a.get(I),y=D?.valuesSources??new Map;if(b)for(const v of Object.keys(u[I]))y.set(v,b);const p={...D?.value||{},...u[I]};this.a.set(I,{source:b,value:p,valuesSources:y});const k=(0,A.$ej)(I),m={type:"object",default:p,description:O.localize(1,null,k),$ref:e.$vo,defaultDefaultValue:p,source:P.$ag(b)?void 0:b,defaultValueSource:b};f.push(...r(I)),this.d[I]=m,this.b.properties[I]=m}else{this.a.set(I,{value:u[I],source:b});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(f)}deregisterDefaultConfigurations(i){const g=new Set;this.l(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(i,g){for(const{overrides:f,source:u}of i)for(const b in f){const I=this.a.get(b),D=P.$ag(u)?u:u?.id,y=P.$ag(I?.source)?I?.source:I?.source?.id;if(D===y)if(g.add(b),this.a.delete(b),e.$yo.test(b))delete this.d[b],delete this.b.properties[b];else{const p=this.d[b];p&&(this.w(b,p),this.r(b,p))}}this.u()}deltaConfiguration(i){let g=!1;const f=new Set;i.removedDefaults&&(this.l(i.removedDefaults,f),g=!0),i.addedDefaults&&(this.k(i.addedDefaults,f),g=!0),i.removedConfigurations&&this.o(i.removedConfigurations,f),i.addedConfigurations&&this.n(i.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const g of i)this.h.add(g);this.u()}n(i,g,f){i.forEach(u=>{this.p(u,g,u.extensionInfo,u.restrictedProperties,void 0,f),this.c.push(u),this.q(u)})}o(i,g){const f=u=>{if(u.properties)for(const b in u.properties){g.add(b);const I=this.d[b];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[b],this.s(b,u.properties[b])}u.allOf?.forEach(b=>f(b))};for(const u of i){f(u);const b=this.c.indexOf(u);b!==-1&&this.c.splice(b,1)}}p(i,g=!0,f,u,b=C.WINDOW,I){b=P.$jg(i.scope)?b:i.scope;const D=i.properties;if(D)for(const p in D){const k=D[p];if(g&&t(p,k)){delete D[p];continue}if(k.source=f,k.defaultDefaultValue=D[p].default,this.w(p,k),e.$yo.test(p)?k.scope=void 0:(k.scope=P.$jg(k.scope)?b:k.scope,k.restricted=P.$jg(k.restricted)?!!u?.includes(p):k.restricted),D[p].hasOwnProperty("included")&&!D[p].included){this.f[p]=D[p],delete D[p];continue}else this.d[p]=D[p],D[p].policy?.name&&this.e.set(D[p].policy.name,p);!D[p].deprecationMessage&&D[p].markdownDeprecationMessage&&(D[p].deprecationMessage=D[p].markdownDeprecationMessage),I.add(p)}const y=i.allOf;if(y)for(const p of y)this.p(p,g,f,u,b,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const g=f=>{const u=f.properties;if(u)for(const I in u)this.r(I,u[I]);f.allOf?.forEach(g)};g(i)}r(i,g){switch(e.$po.properties[i]=g,g.scope){case C.APPLICATION:e.$qo.properties[i]=g;break;case C.MACHINE:e.$ro.properties[i]=g;break;case C.MACHINE_OVERRIDABLE:e.$so.properties[i]=g;break;case C.WINDOW:e.$to.properties[i]=g;break;case C.RESOURCE:e.$uo.properties[i]=g;break;case C.LANGUAGE_OVERRIDABLE:e.$uo.properties[i]=g,this.g.properties[i]=g;break}}s(i,g){switch(delete e.$po.properties[i],g.scope){case C.APPLICATION:delete e.$qo.properties[i];break;case C.MACHINE:delete e.$ro.properties[i];break;case C.MACHINE_OVERRIDABLE:delete e.$so.properties[i];break;case C.WINDOW:delete e.$to.properties[i];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const g=`[${i}]`,f={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$vo};this.w(g,f),e.$po.properties[g]=f,e.$qo.properties[g]=f,e.$ro.properties[g]=f,e.$so.properties[g]=f,e.$to.properties[g]=f,e.$uo.properties[g]=f}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=i,e.$qo.patternProperties[e.$xo]=i,e.$ro.patternProperties[e.$xo]=i,e.$so.patternProperties[e.$xo]=i,e.$to.patternProperties[e.$xo]=i,e.$uo.patternProperties[e.$xo]=i,this.i.fire()}w(i,g){const f=this.a.get(i);let u=f?.value,b=f?.source;P.$hg(u)&&(u=g.defaultDefaultValue,b=void 0),P.$hg(u)&&(u=a(g.type)),g.default=u,g.defaultValueSource=b}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$xo=`^(${S})+$`,e.$yo=new RegExp(e.$xo);function r(n){const i=[];if(e.$yo.test(n)){let g=d.exec(n);for(;g?.length;){const f=g[1].trim();f&&i.push(f),g=d.exec(n)}}return(0,E.$Mb)(i)}function o(n){return n.reduce((i,g)=>`${i}[${g}]`,"")}function a(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new l;$.$jo.add(e.$oo.Configuration,h);function t(n,i){return n.trim()?e.$yo.test(n)?O.localize(7,null,n):h.getConfigurationProperties()[n]!==void 0?O.localize(8,null,n):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,n,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function s(){const n=[],i=h.getConfigurationProperties();for(const g of Object.keys(i))n.push([g,i[g].scope]);return n.push(["launch",C.RESOURCE]),n.push(["task",C.RESOURCE]),n}}),define(ke[214],Ie([1,0,18,4,134,6,29,26,15,2,42,54,30,31]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=s;function d(f){return Object.isFrozen(f)?f:T.$0n(f)}class r{static createEmptyModel(u){return new r({},[],[],void 0,u)}constructor(u,b,I,D,y){this.b=u,this.c=b,this.d=I,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const u=this.raw.map(b=>{if(b instanceof r)return b;const I=new o("",this.f);return I.parseRaw(b),I.configurationModel});this.g=u.reduce((b,I)=>I===b?I:b.merge(I),u[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,C.$cj)(this.contents,u):this.contents}inspect(u,b){const I=this;return{get value(){return d(I.rawConfiguration.getValue(u))},get override(){return b?d(I.rawConfiguration.getOverrideValue(u,b)):void 0},get merged(){return d(b?I.rawConfiguration.override(b).getValue(u):I.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:y,identifiers:p,keys:k}of I.rawConfiguration.overrides){const m=new r(y,k,[],void 0,I.f).getValue(u);m!==void 0&&D.push({identifiers:p,value:m})}return D.length?d(D):void 0}}}getOverrideValue(u,b){const I=this.j(b);return I?u?(0,C.$cj)(I,u):I:void 0}getKeysForOverrideIdentifier(u){const b=[];for(const I of this.overrides)I.identifiers.includes(u)&&b.push(...I.keys);return E.$Mb(b)}getAllOverrideIdentifiers(){const u=[];for(const b of this.overrides)u.push(...b.identifiers);return E.$Mb(u)}override(u){let b=this.a.get(u);return b||(b=this.h(u),this.a.set(u,b)),b}merge(...u){const b=T.$9n(this.contents),I=T.$9n(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const p of u)if(y.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.i(b,p.contents);for(const k of p.overrides){const[m]=I.filter(v=>E.$ub(v.identifiers,k.identifiers));m?(this.i(m.contents,k.contents),m.keys.push(...k.keys),m.keys=E.$Mb(m.keys)):I.push(T.$9n(k))}for(const k of p.keys)D.indexOf(k)===-1&&D.push(k)}return new r(b,D,I,y.every(p=>p instanceof r)?void 0:y,this.f)}h(u){const b=this.j(u);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const I={};for(const D of E.$Mb([...Object.keys(this.contents),...Object.keys(b)])){let y=this.contents[D];const p=b[D];p&&(typeof y=="object"&&typeof p=="object"?(y=T.$9n(y),this.i(y,p)):y=p),I[D]=y}return new r(I,this.keys,this.overrides,void 0,this.f)}i(u,b){for(const I of Object.keys(b)){if(I in u&&$.$cg(u[I])&&$.$cg(b[I])){this.i(u[I],b[I]);continue}u[I]=T.$9n(b[I])}}j(u){let b=null,I=null;const D=y=>{y&&(I?this.i(I,y):I=T.$9n(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===u?b=y.contents:y.identifiers.includes(u)&&D(y.contents);return D(b),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,b){this.k(u,b,!0)}setValue(u,b){this.k(u,b,!1)}removeValue(u){const b=this.keys.indexOf(u);b!==-1&&(this.keys.splice(b,1),(0,C.$bj)(this.contents,u),w.$yo.test(u)&&this.overrides.splice(this.overrides.findIndex(I=>E.$ub(I.identifiers,(0,w.$zo)(u))),1))}k(u,b,I){(0,C.$aj)(this.contents,u,b,D=>this.f.error(D)),I=I||this.keys.indexOf(u)===-1,I&&this.keys.push(u),w.$yo.test(u)&&this.overrides.push({identifiers:(0,w.$zo)(u),keys:Object.keys(this.contents[u]),contents:(0,C.$_i)(this.contents[u],D=>this.f.error(D))})}}e.$Eo=r;class o{constructor(u,b){this.f=u,this.g=b,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,b){if(!$.$jg(u)){const I=this.h(u);this.parseRaw(I,b)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,b){this.a=u;const{contents:I,keys:D,overrides:y,restricted:p,hasExcludedProperties:k}=this.i(u,b);this.b=new r(I,D,y,k?[u]:void 0,this.g),this.c=p||[]}h(u){let b={},I=null,D=[];const y=[],p=[];function k(v){Array.isArray(D)?D.push(v):I!==null&&(D[I]=v)}const m={onObjectBegin:()=>{const v={};k(v),y.push(D),D=v,I=null},onObjectProperty:v=>{I=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];k(v),y.push(D),D=v,I=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:k,onError:(v,F,M)=>{p.push({error:v,offset:F,length:M})}};if(u)try{P.$Wn(u,m),b=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return b}i(u,b){const I=S.$jo.as(w.$oo.Configuration).getConfigurationProperties(),D=this.j(u,I,!0,b);u=D.raw;const y=(0,C.$_i)(u,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`)),p=Object.keys(u),k=this.l(u,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:y,keys:p,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(u,b,I,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:y};const p={},k=[];for(const m in u)if(w.$yo.test(m)&&I){const v=this.j(u[m],b,!1,D);p[m]=v.raw,y=y||v.hasExcludedProperties,k.push(...v.restricted)}else{const v=b[m],F=v?typeof v.scope<"u"?v.scope:w.ConfigurationScope.WINDOW:void 0;v?.restricted&&k.push(m),!D.exclude?.includes(m)&&(D.include?.includes(m)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&v?.restricted))?p[m]=u[m]:y=!0}return{raw:p,restricted:k,hasExcludedProperties:y}}l(u,b){const I=[];for(const D of Object.keys(u))if(w.$yo.test(D)){const y={};for(const p in u[D])y[p]=u[D][p];I.push({identifiers:(0,w.$zo)(D),keys:Object.keys(y),contents:(0,C.$_i)(y,b)})}return I}}e.$Fo=o;class a extends O.$Uc{constructor(u,b,I,D,y){super(),this.c=u,this.f=b,this.g=D,this.h=y,this.b=this.B(new R.$he),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),y),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(l.FileOperation.CREATE)||p.isOperation(l.FileOperation.COPY)||p.isOperation(l.FileOperation.DELETE)||p.isOperation(l.FileOperation.WRITE))&&I.isEqual(p.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=a;class h{constructor(u,b,I,D,y,p,k,m,v,F,M,G,q){this.a=u,this.b=b,this.c=I,this.overrideIdentifiers=D,this.d=y,this.f=p,this.g=k,this.h=m,this.i=v,this.j=F,this.k=M,this.l=G,this.m=q}get value(){return d(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(u,b,I,D,y,p,k,m,v,F){this.j=u,this.l=b,this.m=I,this.n=D,this.p=y,this.q=p,this.r=k,this.s=m,this.t=v,this.u=F,this.h=null,this.i=new A.$Ac,this.v=null}getValue(u,b,I){return this.w(u,b,I).getValue(u)}updateValue(u,b,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=r.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,b===void 0?D.removeValue(u):D.setValue(u,b),I.resource||(this.h=null)}inspect(u,b,I){const D=this.w(u,b,I),y=this.A(b.resource,I),p=b.resource?this.t.get(b.resource)||this.s:this.s,k=new Set;for(const m of D.overrides)for(const v of m.identifiers)D.getOverrideValue(u,v)!==void 0&&k.add(v);return new h(u,b,D.getValue(u),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,y||void 0,p)}keys(u){const b=this.A(void 0,u);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(u){this.j=u,this.h=null,this.i.clear()}updatePolicyConfiguration(u){this.l=u}updateApplicationConfiguration(u){this.m=u,this.h=null,this.i.clear()}updateLocalUserConfiguration(u){this.n=u,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(u){this.p=u,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(u){this.q=u,this.h=null,this.i.clear()}updateFolderConfiguration(u,b){this.r.set(u,b),this.i.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.i.delete(u)}compareAndUpdateDefaultConfiguration(u,b){const I=[];if(!b){const{added:D,updated:y,removed:p}=i(this.j,u);b=[...D,...y,...p]}for(const D of b)for(const y of(0,w.$zo)(D)){const p=this.j.getKeysForOverrideIdentifier(y),k=u.getKeysForOverrideIdentifier(y),m=[...k.filter(v=>p.indexOf(v)===-1),...p.filter(v=>k.indexOf(v)===-1),...p.filter(v=>!T.$ao(this.j.override(y).getValue(v),u.override(y).getValue(v)))];I.push([y,m])}return this.updateDefaultConfiguration(u),{keys:b,overrides:I}}compareAndUpdatePolicyConfiguration(u){const{added:b,updated:I,removed:D}=i(this.l,u),y=[...b,...I,...D];return y.length&&this.updatePolicyConfiguration(u),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:b,updated:I,removed:D,overrides:y}=i(this.applicationConfiguration,u),p=[...b,...I,...D];return p.length&&this.updateApplicationConfiguration(u),{keys:p,overrides:y}}compareAndUpdateLocalUserConfiguration(u){const{added:b,updated:I,removed:D,overrides:y}=i(this.localUserConfiguration,u),p=[...b,...I,...D];return p.length&&this.updateLocalUserConfiguration(u),{keys:p,overrides:y}}compareAndUpdateRemoteUserConfiguration(u){const{added:b,updated:I,removed:D,overrides:y}=i(this.remoteUserConfiguration,u),p=[...b,...I,...D];return p.length&&this.updateRemoteUserConfiguration(u),{keys:p,overrides:y}}compareAndUpdateWorkspaceConfiguration(u){const{added:b,updated:I,removed:D,overrides:y}=i(this.workspaceConfiguration,u),p=[...b,...I,...D];return p.length&&this.updateWorkspaceConfiguration(u),{keys:p,overrides:y}}compareAndUpdateFolderConfiguration(u,b){const I=this.folderConfigurations.get(u),{added:D,updated:y,removed:p,overrides:k}=i(I,b),m=[...D,...y,...p];return(m.length||!I)&&this.updateFolderConfiguration(u,b),{keys:m,overrides:k}}compareAndDeleteFolderConfiguration(u){const b=this.folderConfigurations.get(u);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:I,updated:D,removed:y,overrides:p}=i(b,void 0);return{keys:[...I,...D,...y],overrides:p}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(u,b,I){let D=this.x(b,I);return b.overrideIdentifier&&(D=D.override(b.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(u)!==void 0&&(D=D.merge(this.l)),D}x({resource:u},b){let I=this.y();if(b&&u){const D=b.getFolder(u);D&&(I=this.z(D.uri)||I);const y=this.t.get(u);y&&(I=I.merge(y))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(u){let b=this.i.get(u);if(!b){const I=this.y(),D=this.r.get(u);D?(b=I.merge(D),this.i.set(u,b)):b=I}return b}A(u,b){if(b&&u){const I=b.getFolder(u);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((u,b)=>{const{contents:I,overrides:D,keys:y}=this.r.get(b);return u.push([b,{contents:I,overrides:D,keys:y}]),u},[])}}allKeys(){const u=new Set;return this.j.keys.forEach(b=>u.add(b)),this.userConfiguration.keys.forEach(b=>u.add(b)),this.q.keys.forEach(b=>u.add(b)),this.r.forEach(b=>b.keys.forEach(I=>u.add(I))),[...u.values()]}B(){const u=new Set;return this.j.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.q.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.r.forEach(b=>b.getAllOverrideIdentifiers().forEach(I=>u.add(I))),[...u.values()]}D(u){const b=new Set;return this.j.getKeysForOverrideIdentifier(u).forEach(I=>b.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(I=>b.add(I)),this.q.getKeysForOverrideIdentifier(u).forEach(I=>b.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(u).forEach(D=>b.add(D))),[...b.values()]}static parse(u,b){const I=this.E(u.defaults,b),D=this.E(u.policy,b),y=this.E(u.application,b),p=this.E(u.user,b),k=this.E(u.workspace,b),m=u.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],b)),v),new A.$Ac);return new t(I,D,y,p,r.createEmptyModel(b),k,m,r.createEmptyModel(b),new A.$Ac,b)}static E(u,b){return new r(u.contents,u.keys,u.overrides,void 0,b)}}e.$Ho=t;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,b=new Map;for(const D of f)D.keys.forEach(y=>u.add(y)),D.overrides.forEach(([y,p])=>{const k=(0,A.$xc)(b,y,new Set);p.forEach(m=>k.add(m))});const I=[];return b.forEach((D,y)=>I.push([y,[...D.values()]])),{keys:[...u.values()],overrides:I}}class n{constructor(u,b,I,D,y){this.change=u,this.f=b,this.g=I,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const p of u.keys)this.affectedKeys.add(p);for(const[,p]of u.overrides)for(const k of p)this.affectedKeys.add(k);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(u,b){const I=this.a+u,D=this.d.indexOf(I);if(D<0)return!1;const y=D+I.length;if(y>=this.d.length)return!1;const p=this.d.charCodeAt(y);if(p!==this.b&&p!==this.c)return!1;if(b){const k=this.previousConfiguration?this.previousConfiguration.getValue(u,b,this.f?.workspace):void 0,m=this.g.getValue(u,b,this.h);return!T.$ao(k,m)}return!0}}e.$Jo=n;function i(f,u){const{added:b,removed:I,updated:D}=g(u?.rawConfiguration,f?.rawConfiguration),y=[],p=f?.getAllOverrideIdentifiers()||[],k=u?.getAllOverrideIdentifiers()||[];if(u){const m=k.filter(v=>!p.includes(v));for(const v of m)y.push([v,u.getKeysForOverrideIdentifier(v)])}if(f){const m=p.filter(v=>!k.includes(v));for(const v of m)y.push([v,f.getKeysForOverrideIdentifier(v)])}if(u&&f){for(const m of p)if(k.includes(m)){const v=g({contents:f.getOverrideValue(void 0,m)||{},keys:f.getKeysForOverrideIdentifier(m)},{contents:u.getOverrideValue(void 0,m)||{},keys:u.getKeysForOverrideIdentifier(m)});y.push([m,[...v.added,...v.removed,...v.updated]])}}return{added:b,removed:I,updated:D,overrides:y}}function g(f,u){const b=f?u?f.keys.filter(y=>u.keys.indexOf(y)===-1):[...f.keys]:[],I=u?f?u.keys.filter(y=>f.keys.indexOf(y)===-1):[...u.keys]:[],D=[];if(f&&u){for(const y of u.keys)if(f.keys.indexOf(y)!==-1){const p=(0,C.$cj)(u.contents,y),k=(0,C.$cj)(f.contents,y);T.$ao(p,k)||D.push(y)}}return{added:b,removed:I,updated:D}}}),define(ke[108],Ie([1,0,14,3]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=c,e.$Ll=(0,R.$Ai)("remoteAuthorityResolverService");var P;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(w){this.id=w,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=O;class A{constructor(w,l){this.host=w,this.port=l,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=A;var T;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends E.$bb{static isNotAvailable(w){return w instanceof $&&w._code===T.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof $&&w._code===T.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof $&&w._code===T.NoResolverFound}static isInvalidAuthority(w){return w instanceof $&&w._code===T.InvalidAuthority}static isHandled(w){return w instanceof $&&w.isHandled}constructor(w,l=T.Unknown,S){super(w),this._message=w,this._code=l,this._detail=S,this.isHandled=l===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ol=$;function c(C){const w=C.indexOf("+");return w===-1?C:C.substring(0,w)}}),define(ke[62],Ie([1,0,16]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=R,e.$Nm=P,e.$Om=O,e.$Pm=A;function R($){return $.scheme===E.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const c=$.indexOf("+");return c<0?$:$.substr(0,c)}function O($){const{host:c,port:C}=T($);if(typeof C>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:C}}function A($,c){let{host:C,port:w}=T($);return typeof w>"u"&&(w=c),{host:C,port:w}}function T($){const c=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const C=$.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const w=$.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:$,port:void 0}}}),define(ke[19],Ie([1,0,13,3,62]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=O,e.$Zm=w,e.$1m=l,e.$2m=S,e.$3m=d,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,t=typeof a=="string"?a:a.value;return E.$Bf(h,t)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Wm=$;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add($.toKey(o))}delete(o){return this.c.delete($.toKey(o))}has(o){return this.c.has($.toKey(o))}}e.$Xm=c;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete($.toKey(o))}get(o){return this.c.get($.toKey(o))}has(o){return this.c.has($.toKey(o))}set(o,a){this.c.set($.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=C;function w(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function S(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.$Nm)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$4m=(0,R.$Ai)("IBuiltinExtensionsScannerService")}),define(ke[109],Ie([1,0,21,170,19,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=T,e.$9o=$,e.$0o=c,e.$$o=C,e.$_o=w,e.$ap=l,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var A;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(n){switch(n){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(n){switch(n){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(n,i){switch(n){case E.Platform.Windows:return i==="x64"?P.TargetPlatform.WIN32_X64:i==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Linux:return i==="x64"?P.TargetPlatform.LINUX_X64:i==="arm64"?P.TargetPlatform.LINUX_ARM64:i==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?P.TargetPlatform.ALPINE_X64:i==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Mac:return i==="x64"?P.TargetPlatform.DARWIN_X64:i==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Web:return P.TargetPlatform.WEB}}function C(n,i){return i===P.TargetPlatform.WEB&&!n.includes(P.TargetPlatform.WEB)}function w(n,i,g){return C(i,g)?!1:n===P.TargetPlatform.UNDEFINED||n===P.TargetPlatform.UNIVERSAL?!0:n===P.TargetPlatform.UNKNOWN?!1:n===g}function l(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var S;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(n){n.Install="install",n.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$bp=(0,O.$Ai)("extensionGalleryService");var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$cp=h;var t;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(t||(e.ExtensionManagementErrorCode=t={}));class s extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$dp=s,e.$ep=(0,O.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,O.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,O.$Ai)("IExtensionTipsService"),e.$jp=(0,R.localize2)(0,"Extensions"),e.$kp=(0,R.localize2)(1,"Preferences")}),define(ke[110],Ie([1,0,14,19]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yG=e.$xG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const $ of A){const c=this.readActivationEvents($);c.length>0&&(T[R.$Wm.toKey($.identifier)]=c)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${R.$Wm.toKey(A.identifier)}`);if(!A.contributes)return T;for(const $ in A.contributes){const c=this.a.get($);if(!c)continue;const C=A.contributes[$],w=Array.isArray(C)?C:[C];try{c(w,T)}catch(l){(0,E.$1)(l)}}return T}}e.$xG=P,e.$yG=new P}),define(ke[215],Ie([1,0,23,14,6,175,54,3,12,31]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=l,e.$Yp=S,e.$Zp=d,e.$1p=r,e.$2p=o,e.$3p=a,e.$Vp=(0,T.$Ai)("requestService");class C{constructor(n){this.b=n}toJSON(){if(!this.a){const n=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?n[i]="*****":n[i]=this.b[i];this.a=n}return this.a}}class w extends P.$Uc{constructor(n){super(),this.b=0,this.a=n.createLogger("network",{name:(0,O.localize)(0,null),when:$.$mk.isEqualTo((0,$.$jk)($.LogLevel.Trace)).serialize()})}async c(n,i,g){const f=`${n} #${++this.b}: ${i.url}`;this.a.trace(`${f} - begin`,i.type,new C(i.headers??{}));try{const u=await g();return this.a.trace(`${f} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.a.error(`${f} - error`,i.type,(0,R.$0)(u)),u}}}e.$Wp=w;function l(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function S(s){return s.res.statusCode===204}async function d(s){return S(s)?null:(await(0,E.$Ve)(s.stream)).toString()}async function r(s){if(!l(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!l(s))throw new Error("Server returned "+s.res.statusCode);if(S(s))return null;const i=(await(0,E.$Ve)(s.stream)).toString();try{return JSON.parse(i)}catch(g){throw g.message+=`:
`+i,g}}function a(s){t(s)}let h;function t(s){const n=c.$jo.as(A.$oo.Configuration),i=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[h],remove:i?[i]:[]})}t(A.ConfigurationScope.APPLICATION)}),define(ke[216],Ie([1,0,21,79,36]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=A,e.$mp=T;function O($){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,c,C,w,l,S,d,r,o,a){const h=Object.create(null);h["common.machineId"]=S,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,P.$Wg)()+Date.now(),h.commitHash=w,h.version=l,h["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,E.$h)(E.$u),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=C,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let t=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),E.$l&&(h["common.snap"]="true");const n=O(c);return n&&(h["common.platformDetail"]=n),h}function T($){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const C=c.toLowerCase();return $.some(w=>C===w)}}),define(ke[111],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,E.$Ai)("telemetryService"),e.$7l=(0,E.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ke[63],Ie([1,0,26,15,62,216,111]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=C,e.$vp=w,e.$wp=l,e.$xp=S,e.$yp=r,e.$zp=a,e.$Ap=h,e.$Bp=n;class T{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$np=T;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=$,e.$pp=new $;class c{async publicLog(g,f,u){}async publicLogError(g,f,u){}}e.$qp=c,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!i.enableTelemetry)}function w(i,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const g=i.getValue(A.$cm),f=i.getValue(A.$dm);if(i.getValue(A.$em)===!1||f===!1)return A.TelemetryLevel.NONE;switch(g??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(i){const g={},f={},u={};o(i,u);for(let b in u){b=b.length>150?b.substr(b.length-149):b;const I=u[b];typeof I=="number"?f[b]=I:typeof I=="boolean"?f[b]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${I.length}`),g[b]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(g[b]=I)}return{properties:g,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const g=(0,P.$Nm)(i);return d.has(g)?g:"other"}function o(i,g,f=0,u){if(i)for(const b of Object.getOwnPropertyNames(i)){const I=i[b],D=u?u+b:b;Array.isArray(I)?g[D]=(0,E.$bo)(I):I instanceof Date?g[D]=I.toISOString():(0,R.$cg)(I)?f<2?o(I,g,f+1,D+"."):g[D]=(0,E.$bo)(I):g[D]=I}}function a(i,g){const f=i.msftInternalDomains||[],u=g.getValue("telemetry.internalTesting");return(0,O.$mp)(f)||u}function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,g){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const u=[];for(const y of g)for(;;){const p=y.exec(i);if(!p)break;u.push([p.index,y.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const y=I.exec(i);if(!y)break;const p=u.some(([k,m])=>y.index<m&&k<I.lastIndex);!b.test(y[0])&&!p&&(f+=i.substring(D,y.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<i.length&&(f+=i.substr(D)),f}function s(i){if(!i)return i;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of g)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function n(i,g){return(0,E.$$n)(i,f=>{if(f instanceof T||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=t(u,g);for(const b of g)u=u.replace(b,"");return u=s(u),u}})}}),define(ke[217],Ie([1,0,13,109,19,21,2,14,79,63]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=C,e.$Ep=d,e.$Fp=r,e.$Gp=o,e.$Hp=a,e.$Ip=h,e.$Jp=t,e.$Kp=s,e.$Mp=n,e.$Np=g;function C(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,E.$wf)(f.id,u.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(u){const b=u.manifest?u.manifest.version:u.version,I=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new l(u.identifier,b,I)}static parse(u){const b=w.exec(u);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(u,b,I=P.TargetPlatform.UNDEFINED){this.identifier=u,this.version=b,this.targetPlatform=I,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof l?C(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Dp=l;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const u=S.exec(f);return u&&u[1]?[o(u[1]),u[2]]:[o(f),void 0]}function r(f,u){return`${f}.${u}`}function o(f){return f.toLowerCase()}function a(f,u){return o(r(f??P.$Sm,u))}function h(f,u){const b=[],I=D=>{for(const y of b)if(y.some(p=>C(u(p),u(D))))return y;return null};for(const D of f){const y=I(D);y?y.push(D):b.push([D])}return b}function t(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$np(f.identifier.id),name:new c.$np(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Lp=new P.$Wm("pprice.better-merge");function n(f,u){const b=[],I=u.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&b.every(y=>!C(y.identifier,{id:D}))){const y=f.filter(p=>C(p.identifier,{id:D}));y.length===1&&(b.push(y[0]),I.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function i(f,u){if(!O.$k)return!1;let b;try{b=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,T.$0)(D))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(f,u){const b=await i(f,u),I=(0,R.$0o)(b?"alpine":O.$u,$.$ec);return u.debug("ComputeTargetPlatform:",I),I}}),define(ke[218],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=E,e.$us=R,e.$vs=P,e.$ws=O,e.$xs=A,e.$ys=T;function E($){return[...$.entries()]}function R($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function A($){return Array.from($.entries()).map(c=>[c[0],E(c[1].map),R(c[1].descriptionMap)])}function T($){return new Map($.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}}),define(ke[219],Ie([1,0,3,32,31]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ds=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$cs=void 0,e.$cs=new R.$Rj("terminalTabFocusMode",!1,!0);var O;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})($||(e.WindowsShellType=$={}));var c;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var C;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var w;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$ds=(0,E.$Ai)("ptyService");var l;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var S;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(n){n.TerminalView="view",n.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var t;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(t||(e.TerminalExitReason=t={})),e.$es={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const g=this.b(i.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}P.$jo.add(e.$es.Backend,new s),e.$fs=(0,E.$Ai)("localPtyService"),e.$gs=(0,E.$Ai)("terminalLogService")}),define(ke[220],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vvb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const T=O($=>{const c=typeof $=="string"?$:$.data;let C=this.a.get(P);if(C){C.data.push(c);return}const w=setTimeout(()=>this.flushBuffer(P),A);C={data:[c],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(P),T.dispose()}},this.a.set(P,C)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Vvb=E}),define(ke[221],Ie([1,0,11,97,323,34,4,15,2,176,78,31]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vx=e.$ux=e.$tx=e.$sx=e.$rx=e.$qx=e.IconFontDefinition=e.IconContribution=e.$nx=void 0,e.$ox=o,e.$px=a,e.$nx={IconContribution:"base.contributions.icons"};var l;(function(n){function i(g,f){let u=g.defaults;for(;O.ThemeIcon.isThemeIcon(u);){const b=r.getIcon(u.id);if(!b)return;u=b.defaults}return u}n.getDefinition=i})(l||(e.IconContribution=l={}));var S;(function(n){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}n.toJSONObject=i;function g(f){const u=b=>(0,T.$ag)(b)?b:void 0;if(f&&Array.isArray(f.src)&&f.src.every(b=>(0,T.$ag)(b.format)&&(0,T.$ag)(b.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map(b=>({format:b.format,location:$.URI.parse(b.location)}))}}n.fromJSONObject=g})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new A.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,g,f,u){const b=this.b[i];if(b){if(f&&!b.description){b.description=f,this.d.properties[i].markdownDescription=`${f} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return b}const I={id:i,description:f,defaults:g,deprecationMessage:u};this.b[i]=I;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),f&&(D.markdownDescription=`${f}: $(${i})`),this.d.properties[i]=D,this.e.enum.push(i),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const g=this.e.enum.indexOf(i);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,g){const f=this.f[i];return f||(this.f[i]=g,this.a.fire(),g)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(b,I)=>b.id.localeCompare(I.id),g=b=>{for(;O.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(b=>this.b[b]);for(const b of u.filter(I=>!!I.description).sort(i))f.push(`|<i class="${g(b)}"></i>|${b.id}|${O.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const b of u.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(i))f.push(`|<i class="${g(b)}"></i>|${b.id}|`);return f.join(`
`)}}const r=new d;w.$jo.add(e.$nx.IconContribution,r);function o(n,i,g,f){return r.registerIcon(n,i,g,f)}function a(){return r}function h(){const n=(0,P.$Vj)();for(const i in n){const g="\\"+n[i].toString(16);r.registerIcon(i,{fontCharacter:g})}}h(),e.$qx="vscode://schemas/icons";const t=w.$jo.as(C.$ko.JSONContribution);t.registerSchema(e.$qx,r.getIconSchema());const s=new E.$Mh(()=>t.notifySchemaChanged(e.$qx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$rx=o("widget-close",R.$Zj.close,(0,c.localize)(2,null)),e.$sx=o("goto-previous-location",R.$Zj.arrowUp,(0,c.localize)(3,null)),e.$tx=o("goto-next-location",R.$Zj.arrowDown,(0,c.localize)(4,null)),e.$ux=O.ThemeIcon.modify(R.$Zj.sync,"spin"),e.$vx=O.ThemeIcon.modify(R.$Zj.loading,"spin")}),define(ke[222],Ie([1,0,4,21,2,42,3,12]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$yw=e.$ww=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$sw=e.$rw=void 0,e.$tw=C,e.$uw=l,e.$vw=S,e.$xw=d,e.$zw=r,e.$Aw=o,e.$rw=(0,A.$Ai)("tunnelService"),e.$sw=(0,A.$Ai)("sharedTunnelsService");var $;(function(t){t.Http="http",t.Https="https"})($||(e.TunnelProtocol=$={}));var c;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(c||(e.TunnelPrivacyId=c={}));function C(t){return!!t.forwardPort}var w;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function l(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(s)return{address:s[1],port:+s[2]}}function S(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const s=t.query.split("&");for(const n of s){const i=n.split("=")[1];if(/^https?:/.exec(i)){const g=l(P.URI.parse(i));if(g)return g}}}e.$ww=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(t){return e.$ww.indexOf(t)>=0}e.$yw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(t){return e.$yw.indexOf(t)>=0}function o(t,s,n,i){if(n===R.OperatingSystem.Windows)return!1;if(n===R.OperatingSystem.Macintosh&&r(s)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(g?.length===4&&parseInt(g[1])>=18)return!1}return t<1024}class a{constructor(s,n,i){this.remoteAddress=s,this.localAddress=n,this.b=i,this.a=new E.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Bw=a;let h=class{constructor(s,n){this.k=s,this.l=n,this.a=new E.$he,this.onTunnelOpened=this.a.event,this.b=new E.$he,this.onTunnelClosed=this.b.event,this.c=new E.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],n=Array.from(this.e.values());for(const i of n){const g=Array.from(i.values());for(const f of g){const u=await f.value;u&&typeof u!="string"&&s.push(u)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(i=>typeof i!="string"?i?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,i,g,f){this.q(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:i,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(r(s)||d(s))&&(s=e.$ww[0]);const i=this.s(s,n);if(i)return++i.refcount,i.value}openTunnel(s,n,i,g,f,u=!1,b,I){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${i} on local port ${f}.`);const D=this.f??s;if(!D)return;if(n||(n="localhost"),g||(g=this.m),this.f&&this.j.has(i)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.t(D,n,i,g,f,u,b,I);return y?y.then(p=>{if(p){if(typeof p=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,i),p}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,i);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(p);return(p.tunnelRemoteHost!==n||p.tunnelRemotePort!==i)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),b&&p.privacy!==b&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const i=n.get(s.tunnelRemotePort);i&&(i.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,i))}}}}async p(s,n,i){if(i.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const g=i.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),g}}async closeTunnel(s,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const i=this.e.get(s);if(i&&i.has(n)){const g=i.get(n);g.refcount=0,await this.p(s,n,g)}}q(s,n,i){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:i})}async r(s,n){const i=this.e.get(s);if(i){const g=i.get(n),f=g?await g.value:void 0;(!f||typeof f=="string")&&i.delete(n),i.size===0&&this.e.delete(s)}}s(s,n){const i=[s];d(s)?(i.push(...e.$ww),i.push(...e.$yw)):r(s)&&i.push(...e.$yw);const g=i.map(f=>this.e.get(f));for(const f of g){const u=f?.get(n);if(u)return u}}canTunnel(s){return!!l(s)}u(s,n,i,g,f,u,b){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${i} on local port ${g}.`);const I=i;this.j.add(I);const D=g===void 0?i:g,y={elevationRequired:f?this.isPortPrivileged(D):!1},p={remoteAddress:{host:n,port:i},localAddressPort:g,privacy:u,public:u?u!==c.Private:void 0,protocol:b},k=s.forwardPort(p,y);return k?(this.q(n,i,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(I)})):this.j.delete(I),k}};e.$Cw=h,e.$Cw=h=He([Ve(0,T.$7j),Ve(1,O.$7i)],h)}),define(ke[223],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,E.$Ai)("IUriIdentityService")}),define(ke[224],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Dw=void 0,e.$Dw=(0,E.$Ai)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(ke[225],Ie([1,0,16]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=R,e.$4L=P,e.$5L=O,e.$6L=A,e.$7L=T;function R($){return $.scheme!==E.Schemas.file&&$.scheme!==E.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(c=>R(c.uri))?$.folders[0].uri:void 0;if($.configuration&&R($.configuration))return $.configuration}function O($){return P($)?.scheme}function A($){return P($)?.authority}function T($){return P($)!==void 0}}),define(ke[50],Ie([1,0,178,20,58,24,2,3,16]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=c,e.$Li=C,e.$Oi=w,e.$Pi=l,e.$Qi=S,e.$Ri=r,e.$Si=o,e.$Vi=t,e.$1i=s,e.$2i=n,e.$4i=i,e.$5i=g,e.$6i=f,e.$Ji=(0,T.$Ai)("contextService");function c(u){const b=u;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}function C(u){return typeof u?.id=="string"&&!c(u)&&!l(u)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function w(u,b){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,R.$nc)(u)}:b?e.$Mi:e.$Ni;const I=u;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function l(u){const b=u;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}function S(u){const b=u;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const I=u;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(u?.id)return{id:u.id}}var d;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(u){const b=u;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function o(u){const b=u;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class a{constructor(b,I,D,y,p){this.h=b,this.j=D,this.k=y,this.l=p,this.c=P.$Gi.forUris(this.l,()=>!0),this.folders=I}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=P.$Gi.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=a;class h{constructor(b,I){this.raw=I,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,O.$bh)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=h;function t(u){return new h({uri:u,index:0,name:(0,O.$0g)(u)},{uri:u.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,E.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function s(u,b){return O.$5g.isEqualOrParent(u,b.untitledWorkspacesHome)}function n(u){let b;return A.URI.isUri(u)?b=u:b=u.configuration,b?.scheme===$.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.$3i}function g(u,b){return!s(u,b)&&!n(u)}function f(u){return(typeof u=="string"?(0,R.$oc)(u):(0,O.$_g)(u))===e.$Xi}}),define(ke[112],Ie([1,0,76,4,6,24,2,177,105,30,3,12,50,29,223,11,36,13,15]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=s,e.$Hl=n,e.$Il=i;var t;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function s(u){const b=u;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&typeof b.isDefault=="boolean"&&typeof b.name=="string"&&A.URI.isUri(b.location)&&A.URI.isUri(b.globalStorageHome)&&A.URI.isUri(b.settingsResource)&&A.URI.isUri(b.keybindingsResource)&&A.URI.isUri(b.tasksResource)&&A.URI.isUri(b.snippetsHome)&&A.URI.isUri(b.extensionsResource))}e.$Gl=(0,C.$Ai)("IUserDataProfilesService");function n(u,b){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:A.URI.revive(u.location).with({scheme:b}),globalStorageHome:A.URI.revive(u.globalStorageHome).with({scheme:b}),settingsResource:A.URI.revive(u.settingsResource).with({scheme:b}),keybindingsResource:A.URI.revive(u.keybindingsResource).with({scheme:b}),tasksResource:A.URI.revive(u.tasksResource).with({scheme:b}),snippetsHome:A.URI.revive(u.snippetsHome).with({scheme:b}),extensionsResource:A.URI.revive(u.extensionsResource).with({scheme:b}),cacheHome:A.URI.revive(u.cacheHome).with({scheme:b}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,b,I,D,y,p){return{id:u,name:b,location:I,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:p&&y?.useDefaultFlags?.globalState?p.globalStorageHome:(0,O.$bh)(I,"globalStorage"),settingsResource:p&&y?.useDefaultFlags?.settings?p.settingsResource:(0,O.$bh)(I,"settings.json"),keybindingsResource:p&&y?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,O.$bh)(I,"keybindings.json"),tasksResource:p&&y?.useDefaultFlags?.tasks?p.tasksResource:(0,O.$bh)(I,"tasks.json"),snippetsHome:p&&y?.useDefaultFlags?.snippets?p.snippetsHome:(0,O.$bh)(I,"snippets"),extensionsResource:p&&y?.useDefaultFlags?.extensions?p.extensionsResource:(0,O.$bh)(I,"extensions.json"),cacheHome:(0,O.$bh)(D,u),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let g=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(b,I,D,y){super(),this.t=b,this.u=I,this.w=D,this.y=y,this.f=!0,this.h=this.B(new R.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(b){this.f!==b&&(this.z=void 0,this.f=b)}isEnabled(){return this.f}get C(){if(!this.z){const b=this.D(),I=[b];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,h.$ag)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}I.push(i((0,O.$$g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},b))}}catch(p){this.y.error(p)}const D=new S.$Ac,y=new Map;if(I.length)try{const p=this.Q();if(p.workspaces)for(const[k,m]of Object.entries(p.workspaces)){const v=A.URI.parse(k),F=I.find(M=>M.id===m);F&&D.set(v,F)}if(p.emptyWindows)for(const[k,m]of Object.entries(p.emptyWindows)){const v=I.find(F=>F.id===m);v&&y.set(k,v)}}catch(p){this.y.error(p)}this.z={profiles:I,workspaces:D,emptyWindows:y}}return this.z}D(){const b=i("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...b,extensionsResource:this.S()??b.extensionsResource,isDefault:!0}}async createTransientProfile(b){const I="Temp",D=new RegExp(`${(0,a.$df)(I)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const m=D.exec(k.name),v=m?parseInt(m[1]):0;y=v>y?v:y}const p=`${I} ${y+1}`;return this.createProfile((0,E.$oj)((0,o.$Wg)()).toString(16),p,{transient:!0},b)}async createNamedProfile(b,I,D){return this.createProfile((0,E.$oj)((0,o.$Wg)()).toString(16),b,I,D)}async createProfile(b,I,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(b,I,D);return y&&await this.setProfileForWorkspace(y,p),p}async F(b,I,D){if(!(0,h.$ag)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(I);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===I||v.id===b))throw new Error(`Profile with ${I} name already exists`);const k=i(b,I,(0,O.$bh)(this.profilesHome,b),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const m=[];return this.j.fire({profile:k,join(v){m.push(v)}}),await r.Promises.settled(m),this.I([k],[],[]),k}finally{this.r.delete(I)}})(),this.r.set(I,y)),y}async updateProfile(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===b.id);if(!D)throw new Error(`Profile '${b.name}' does not exist`);return D=i(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(b.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(y=>y.id===b.id);if(!I)throw new Error(`Profile '${b.name}' does not exist`);const D=[];this.m.fire({profile:I,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(y){(0,c.$ll)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L(b,D)}unsetWorkspace(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(b,void 0,I)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const b=await this.u.resolve(this.profilesHome);await Promise.all((b.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const b=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled(b.map(I=>this.removeProfile(I)))}getProfileForWorkspace(b){const I=this.G(b);return A.URI.isUri(I)?this.s.workspaces.get(I)??this.C.workspaces.get(I):this.s.emptyWindows.get(I)??this.C.emptyWindows.get(I)}G(b){return(0,l.$Ki)(b)?b.uri:(0,l.$Pi)(b)?b.configPath:b.id}H(b){return!!([...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,b.location)))}I(b,I,D){const y=[...this.profiles,...b],p=[];this.s.profiles=[];for(let k of y)k.isDefault||I.some(m=>k.id===m.id)||(k=D.find(m=>k.id===m.id)??k,k.isTransient?this.s.profiles.push(k):p.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(p),this.z=void 0,this.J(b,I,D)}J(b,I,D){this.h.fire({added:b,removed:I,updated:D,all:this.profiles})}L(b,I,D){D=I?.isTransient?!0:D,D||this.L(b,void 0,!0);const y=this.G(b),p=D?this.s:this.C;A.URI.isUri(y)?(p.workspaces.delete(y),I&&p.workspaces.set(y,I)):(p.emptyWindows.delete(y),I&&p.emptyWindows.set(y,I)),D||this.M()}M(){const b={};for(const[D,y]of this.C.workspaces.entries())b[D.toString()]=y.id;const I={};for(const[D,y]of this.C.emptyWindows.entries())I[D.toString()]=y.id;this.R({workspaces:b,emptyWindows:I}),this.z=void 0}N(b){const I={},D=this.D();if(b.workspaces)for(const[p,k]of Object.entries(b.workspaces)){const m=A.URI.parse(k);I[p]=this.w.extUri.isEqual(m,D.location)?D.id:this.w.extUri.basename(m)}const y={};if(b.emptyWindows)for(const[p,k]of Object.entries(b.emptyWindows)){const m=A.URI.parse(k);y[p]=this.w.extUri.isEqual(m,D.location)?D.id:this.w.extUri.basename(m)}return{workspaces:I,emptyWindows:y}}O(){return[]}P(b){throw new Error("not implemented")}Q(){return{}}R(b){throw new Error("not implemented")}S(){}};e.$Jl=g,e.$Jl=g=He([Ve(0,$.$Hi),Ve(1,c.$7k),Ve(2,d.$El),Ve(3,w.$7j)],g);class f extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(b){this.a=b}Q(){return this.X}R(b){this.X=b}}e.$Kl=f}),define(ke[226],Ie([1,0,11,4,6,64,15,160,3,112]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=S,e.$_p=r,e.$bq=a,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,$.$Ai)("storageService");var C;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var w;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var l;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function S(h){const t=h.get(e.$8p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class d extends P.$Uc{static{this.a=60*1e3}constructor(t={flushInterval:d.a}){super(),this.m=t,this.b=this.B(new R.$ke),this.c=this.B(new R.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$he),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,s,n){return R.Event.filter(this.b.event,i=>i.scope===t&&(s===void 0||i.key===s),n)}n(){this.j.value=(0,E.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,s){const{key:n,external:i}=s;if(n===e.$8p){switch(t){case w.APPLICATION:this.H=void 0;break;case w.PROFILE:this.F=void 0;break;case w.WORKSPACE:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:n,target:this.J(t)[n],external:i})}w(t){this.f.fire({reason:t})}get(t,s,n){return this.P(s)?.get(t,n)}getBoolean(t,s,n){return this.P(s)?.getBoolean(t,n)}getNumber(t,s,n){return this.P(s)?.getNumber(t,n)}getObject(t,s,n){return this.P(s)?.getObject(t,n)}storeAll(t,s){this.y(()=>{for(const n of t)this.store(n.key,n.value,n.scope,n.target,s)})}store(t,s,n,i,g=!1){if((0,A.$jg)(s)){this.remove(t,n,g);return}this.y(()=>{this.z(t,n,i),this.P(n)?.set(t,s,g)})}remove(t,s,n=!1){this.y(()=>{this.z(t,s,void 0),this.P(s)?.delete(t,n)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,s){const n=[],i=this.J(t);for(const g of Object.keys(i))i[g]===s&&n.push(g);return n}z(t,s,n,i=!1){const g=this.J(s);typeof n=="number"?g[t]!==n&&(g[t]=n,this.P(s)?.set(e.$8p,JSON.stringify(g),i)):typeof g[t]=="number"&&(delete g[t],this.P(s)?.set(e.$8p,JSON.stringify(g),i))}get D(){return this.C||(this.C=this.L(w.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(w.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(w.APPLICATION)),this.H}J(t){switch(t){case w.APPLICATION:return this.I;case w.PROFILE:return this.G;default:return this.D}}L(t){const s=this.P(t);return s?S(s):Object.create(null)}isNew(t){return this.getBoolean(e.$7p,t)===!0}async flush(t=C.NONE){this.f.fire({reason:t});const s=this.P(w.APPLICATION),n=this.P(w.PROFILE),i=this.P(w.WORKSPACE);switch(t){case C.NONE:await E.Promises.settled([s?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await E.Promises.settled([s?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(w.APPLICATION)?.items??new Map,s=this.P(w.PROFILE)?.items??new Map,n=this.P(w.WORKSPACE)?.items??new Map;return a(t,s,n,this.Q(w.APPLICATION)??"",this.Q(w.PROFILE)??"",this.Q(w.WORKSPACE)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,s){return this.w(C.NONE),(0,c.$Fl)(t)?this.R(t,s):this.S(t,s)}M(t,s){return!(t.id===s.id||r(s)&&r(t))}N(t,s,n){this.y(()=>{const i=new Set;for(const[g,f]of t)i.add(g),s.get(g)!==f&&this.u(n,{key:g,external:!0});for(const[g]of s.items)i.has(g)||this.u(n,{key:g,external:!0})})}}e.$$p=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(w.WORKSPACE,t))),this.B(this.W.onDidChangeStorage(t=>this.u(w.PROFILE,t))),this.B(this.U.onDidChangeStorage(t=>this.u(w.APPLICATION,t)))}P(t){switch(t){case w.APPLICATION:return this.U;case w.PROFILE:return this.W;default:return this.X}}Q(t){switch(t){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$aq=o;async function a(h,t,s,n,i,g){const f=v=>{try{return JSON.parse(v)}catch{return v}},u=new Map,b=new Map;h.forEach((v,F)=>{u.set(F,v),b.set(F,f(v))});const I=new Map,D=new Map;t.forEach((v,F)=>{I.set(F,v),D.set(F,f(v))});const y=new Map,p=new Map;s.forEach((v,F)=>{y.set(F,v),p.set(F,f(v))}),console.group(n!==i?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const k=[];if(u.forEach((v,F)=>{k.push({key:F,value:v})}),console.table(k),console.groupEnd(),console.log(b),n!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const v=[];I.forEach((F,M)=>{v.push({key:M,value:F})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${g})`);const m=[];y.forEach((v,F)=>{m.push({key:F,value:v})}),console.table(m),console.groupEnd(),console.log(p)}}),define(ke[80],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$ymc=E}),define(ke[51],Ie([1,0,16,24,30,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=void 0;class A{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new R.$3g($=>{const c=this.b.get($.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,c){c===null?this.b.delete($.scheme):this.b.set($.scheme,c)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Dmc=A,e.$Emc=(0,O.$Ai)("IExtHostFileSystemInfo")}),define(ke[27],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=void 0,e.$bP=(0,E.$Ai)("IExtHostInitDataService")}),define(ke[227],Ie([1,0,183,12,212,27]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0;let A=class extends P.$lQ{constructor($,c,C){const w=C.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",l=C.remote.isRemote?(0,E.localize)(0,null):$?(0,E.localize)(1,null):(0,E.localize)(2,null);super(c.createLogger(w,{name:l}))}};e.$Koc=A,e.$Koc=A=He([Ve(1,R.$8j),Ve(2,O.$bP)],A)}),define(ke[228],Ie([1,0,11]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0;class R{constructor(A,T,$){this.h=new Map,this.a=A,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new E.$Mh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of c.values())C.complete()}catch(C){for(const w of c.values())w.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let $=this.f[A];return typeof $>"u"&&($=T),$}update(A,T){this.f[A]=T;const $=this.h.get(A);if($!==void 0)return $.p;const c=new E.$Xh;return this.h.set(A,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$jnc=R;class P extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$knc=P}),define(ke[229],Ie([1,0,4,2]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class P{constructor(A){this.c=A,this.a=new E.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,$,c){const w=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(T.value,$,c);this.b.fire(w)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$$nc=P}),define(ke[17],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=void 0,e.$XO=(0,E.$Ai)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$YO=R}),define(ke[230],Ie([1,0,19,4]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class P{#e;constructor(A,T){this.b=new R.$he,this.onDidChange=this.b.event,this.a=E.$Wm.toKey(A.identifier),this.#e=T,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,T){return this.#e.store(this.a,A,T)}delete(A){return this.#e.delete(this.a,A)}}e.$tnc=P}),define(ke[65],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=void 0,e.$Tmc=(0,E.$Ai)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Umc=R}),define(ke[113],Ie([1,0,192,15,2,6,3,31,30,16,48,154,35]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$4F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$TF=e.EditorInputCapabilities=e.$SF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$JF=r,e.$KF=o,e.$LF=a,e.$MF=h,e.$NF=t,e.$OF=s,e.$PF=n,e.$QF=i,e.$RF=g,e.$UF=y,e.$VF=k,e.$WF=m,e.$XF=v,e.$YF=F,e.$ZF=M,e.$1F=G,e.$2F=q,e.$3F=fe,e.$5F=pe,e.$6F=se,e.$7F=Ce,e.$8F=Fe,e.$EF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$FF={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$GF="workbench.editor.sidebysideEditor",e.$HF="workbench.editors.textDiffEditor",e.$IF="workbench.editors.binaryResourceDiffEditor";var S;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Y){const W=Y;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function o(Y){const W=Y;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function a(Y,W,ie){for(const De of ie.visibleEditorPanes)if(De.group.id===W&&Y.matches(De.input))return De.getViewState()}function h(Y){if(y(Y))return!1;const W=Y;return P.URI.isUri(W?.resource)}function t(Y){if(y(Y))return!1;const W=Y;return W?.original!==void 0&&W.modified!==void 0}function s(Y){if(y(Y))return!1;const W=Y;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function n(Y){if(y(Y)||t(Y))return!1;const W=Y;return W?.primary!==void 0&&W.secondary!==void 0}function i(Y){if(y(Y))return!1;const W=Y;return W?W.resource===void 0||W.resource.scheme===c.Schemas.untitled||W.forceUntitled===!0:!1}function g(Y){if(y(Y))return!1;const W=Y;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var f;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class b{constructor(){this.a=new Map}registerSource(W,ie){let De=this.a.get(W);return De||(De={source:W,label:ie},this.a.set(W,De)),De.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$SF=new b;var I;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends O.$Uc{}e.$TF=D;function y(Y){return Y instanceof D}function p(Y){const W=Y;return P.URI.isUri(W?.preferredResource)}function k(Y){const W=Y;return y(W?.primary)&&y(W?.secondary)}function m(Y){const W=Y;return y(W?.modified)&&y(W?.original)}function v(Y,W,ie,De,he){return Fe(De,[(0,w.$kj)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const ve={...ie,limits:{size:Number.MAX_VALUE}};Y.openEditor(W,ve)}}),(0,w.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>he.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function F(Y){return y(Y?.editor)}function M(Y){const W=Y;return F(Y)&&W?.group!==void 0}function G(Y){const W=Y;return typeof W?.groupId=="number"&&y(W.editor)}function q(Y){return typeof Y?.groupId=="number"}var V;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var N;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var L;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class Z{getOriginalUri(W,ie){if(!W)return;if(g(W))return e.$4F.getOriginalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:he,secondary:ve}=this.a(W);if(he&&ve){if(ie?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===L.ANY)return this.getOriginalUri(he,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===L.PRIMARY?he:ve}}if(t(W)||s(W)||n(W)||g(W))return;const De=p(W)?W.preferredResource:W.resource;return!De||!ie||!ie.filterByScheme?De:this.b(De,ie.filterByScheme)}a(W){return k(W)||n(W)?{primary:W.primary,secondary:W.secondary}:m(W)||t(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,ie){if(!W)return;if(g(W))return e.$4F.getCanonicalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:he,secondary:ve}=this.a(W);if(he&&ve){if(ie?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===L.ANY)return this.getCanonicalUri(he,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===L.PRIMARY?he:ve}}if(t(W)||s(W)||n(W)||g(W))return;const De=W.resource;return!De||!ie||!ie.filterByScheme?De:this.b(De,ie.filterByScheme)}b(W,ie){if(Array.isArray(ie)){if(ie.some(De=>W.scheme===De))return W}else if(ie===W.scheme)return W}}var re;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function fe(Y,W,ie,De){if(!Y.isSticky(W))return!1;switch(De.preventPinnedEditorClose){case"keyboardAndMouse":return ie===re.MOUSE||ie===re.KEYBOARD;case"mouse":return ie===re.MOUSE;case"keyboard":return ie===re.KEYBOARD}return!1}e.$4F=new Z;var be;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(be||(e.CloseDirection=be={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(W){const ie=this.a=W.get(A.$zi);for(const[De,he]of this.c)this.e(De,he,ie);this.c.clear()}e(W,ie,De){const he=De.createInstance(ie);this.d.set(W,he)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,R.$lg)(this.b)}registerEditorSerializer(W,ie){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,ie,this.a):this.c.set(W,ie),(0,O.$Sc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}T.$jo.add(e.$EF.EditorFactory,new oe);async function pe(Y,W,ie){return!Y||!Y.length?[]:await Promise.all(Y.map(async De=>{const he=P.URI.revive(De.fileUri);if(!he){ie.info("Cannot resolve the path because it is not valid.",De);return}if(!await W.canHandleResource(he)){ie.info("Cannot resolve the path because it cannot be handled",De);return}let ae=De.exists,X=De.type;if(typeof ae!="boolean"||typeof X!="number")try{X=(await W.stat(he)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ae=!0}catch(me){ie.error(me),ae=!1}if(!ae&&De.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",De);return}if(X===$.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",De);return}const x={...De.options,pinned:!0};return ae?{resource:he,options:x}:{resource:he,options:x,forceUntitled:!0}}))}var $e;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function se(Y){const W=Y;if(!W)return!1;const ie=W;if(ie.modified)return se(ie.modified);const De=W;return!!(De.contributionsState&&De.viewState&&Array.isArray(De.cursorState))}function Ce(Y){return(0,C.$mj)(Y)}function Fe(Y,W,ie){const De=(0,C.$nj)(Y,W);return De.forceMessage=ie?.forceMessage,De.forceSeverity=ie?.forceSeverity,De.allowDialog=ie?.allowDialog,De}}),define(ke[231],Ie([1,0,4,193,3,6,29,31,26,97,221]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$bG=e.ViewContentGroups=e.$_F=e.ViewContainerLocation=e.Extensions=e.$$F=e.$0F=e.$9F=void 0,e.$aG=S,e.$9F="views",e.$0F=(0,R.localize)(0,null),e.$$F=(0,C.$ox)("default-view-icon",c.$Zj.window,(0,R.localize)(1,null));var w;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var l;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$_F=[l.Sidebar,l.Panel,l.AuxiliaryBar];function S(i){switch(i){case l.Sidebar:return"sidebar";case l.Panel:return"panel";case l.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new E.$he),this.onDidRegister=this.c.event,this.f=this.B(new E.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,f,u){const b=this.get(g.id);if(b)return b;const I=g;return I.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,f,[]).push(I),u?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(g){for(const f of this.g.keys()){const u=this.g.get(f),b=u?.indexOf(g);if(b!==-1){u?.splice(b,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:g,viewContainerLocation:f});return}}}get(g){return this.all.filter(f=>f.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(f=>this.getViewContainerLocation(f)===g)}}T.$jo.add(w.ViewContainersRegistry,new d);var r;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(i,g){const f=i.group??r.More,u=g.group??r.More;return f!==u?f.localeCompare(u):(i.order??5)-(g.order??5)}class a extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new E.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(g,f){this.registerViews2([{views:g,viewContainer:f}])}registerViews2(g){g.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(g)}deregisterViews(g,f){const u=this.s(g,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(g,f){for(const u of this.m.keys())if(u!==f){const b=this.s(g,u);b.length&&(this.r(b,f),this.g.fire({views:b,from:u,to:f}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const f of this.j){const u=(this.m.get(f)||[]).filter(b=>b.id===g)[0];if(u)return u}return null}getViewContainer(g){for(const f of this.j)if((this.m.get(f)||[]).filter(b=>b.id===g)[0])return f;return null}registerViewWelcomeContent(g,f){return this.n.add(g,f),this.h.fire(g),(0,O.$Sc)(()=>{this.n.delete(g,f),this.h.fire(g)})}registerViewWelcomeContent2(g,f){const u=new Map;for(const[b,I]of f)this.n.add(g,I),u.set(b,(0,O.$Sc)(()=>{this.n.delete(g,I),this.h.fire(g)}));return this.h.fire(g),u}getViewWelcomeContent(g){const f=[];return this.n.forEach(g,u=>f.push(u)),f.sort(o)}r(g,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const b of g){if(this.getView(b.id)!==null)throw new Error((0,R.localize)(2,null,b.id));u.push(b)}}s(g,f){const u=this.m.get(f);if(!u)return[];const b=[],I=[];for(const D of u)g.includes(D)?b.push(D):I.push(D);return b.length&&(I.length?this.m.set(f,I):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),b}}T.$jo.add(w.ViewsRegistry,new a),e.$bG=(0,P.$Ai)("viewDescriptorService");var h;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class s{constructor(g,f){this.c=!1,this.d=!1,(0,$.$_n)(this,g),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const b=await f(u);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$cG=s;class n extends Error{constructor(g){super((0,R.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$dG=n}),define(ke[232],Ie([1,0,194,32]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG=new R.$Rj("chatSessionResponseVote","",{type:"string",description:(0,E.localize)(0,null)}),e.$iG=new R.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,E.localize)(1,null)}),e.$jG=new R.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,E.localize)(2,null)}),e.$kG=new R.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,E.localize)(3,null)}),e.$lG=new R.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,E.localize)(4,null)}),e.$mG=new R.$Rj("chatResponse",!1,{type:"boolean",description:(0,E.localize)(5,null)}),e.$nG=new R.$Rj("chatRequest",!1,{type:"boolean",description:(0,E.localize)(6,null)}),e.$oG=new R.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,E.localize)(7,null)}),e.$pG=new R.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,E.localize)(8,null)}),e.$qG=new R.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,E.localize)(9,null)}),e.$rG=new R.$Rj("inChatInput",!1,{type:"boolean",description:(0,E.localize)(10,null)}),e.$sG=new R.$Rj("inChat",!1,{type:"boolean",description:(0,E.localize)(11,null)}),e.$tG=new R.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,E.localize)(12,null)}),e.$uG=new R.$Rj("chatCursorAtTop",!1),e.$vG=new R.$Rj("chatInputHasAgent",!1),e.$wG=new R.$Rj("chatLocation",void 0)}),define(ke[233],Ie([1,0,324,11,22,4,40,6,49,140,13,32,19,3,12,107,215,226,232]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.ChatAgentLocation=void 0,e.$BH=f,e.$CH=u;var s;(function(b){b.Panel="panel",b.Terminal="terminal",b.Notebook="notebook",b.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(b){function I(D){switch(D){case"panel":return b.Panel;case"terminal":return b.Terminal;case"notebook":return b.Notebook;case"editor":return b.Editor}return b.Panel}b.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.$wH=(0,S.$Ai)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new O.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$tG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const p=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(v=>!v.when||p.f.contextMatchesRules(w.$yj.deserialize(v.when)))}};const m={data:D};return this.b.set(I,m),(0,T.$Sc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const y=this.b.get(I);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new i(y.data,D)),(0,T.$Sc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const y={data:I,impl:D};return this.b.set(I.id,y),this.d.fire(new i(I,D)),(0,T.$Sc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,y){return await this.g.get(I)?.(D,y)??[]}updateAgent(I,D){const y=this.b.get(I);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new i(y.data,y.impl))}getDefaultAgent(I){return(0,E.$fb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(w.$yj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),y=>f(y.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new i(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}async invokeAgent(I,D,y,p,k){const m=this.b.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return await m.impl.invoke(D,y,p,k)}async getFollowups(I,D,y,p,k){const m=this.b.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return m.impl?.provideFollowups?m.impl.provideFollowups(D,y,p,k):[]}};e.$xH=n,e.$xH=n=He([Ve(0,w.$Sj)],n);class i{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,y,p){return this.d.invoke(I,D,y,p)}async provideFollowups(I,D,y,p){return this.d.provideFollowups?this.d.provideFollowups(I,D,y,p):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$yH=i,e.$zH=(0,S.$Ai)("chatAgentNameService");let g=class{static{t=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,y,p){if(this.g=D,this.h=y,this.i=p,this.e=(0,c.$3d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const k=p.get(t.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{p.remove(t.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,R.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$2p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(t.b,JSON.stringify(y),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),y=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&y}l(I,D){return this.e.map(p=>p[I.toLowerCase()]).map(p=>p?p.some(k=>(0,C.$Bf)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$AH=g,e.$AH=g=t=He([Ve(0,r.$nk),Ve(1,o.$Vp),Ve(2,d.$7j),Ve(3,a.$9p)],g);function f(b){return`${b.extensionId.value}.${b.id}`}function u(b){const I="name"in b?b:{...b,name:b.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new l.$Wm("")),(0,$.$0h)(I)}}),define(ke[234],Ie([1,0,2,33,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8G=e.$7G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$5G=O,e.$6G=A;function O(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof E.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(R.$ct.isIRange)}function A(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(O)}var T;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$7G=(0,P.$Ai)("IChatService"),e.$8G="accessibility.voice.keywordActivation"}),define(ke[235],Ie([1,0,4,11,196]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new E.$he,this.o=new E.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,c,C){const w={command:T};if($&&Object.keys($).length>0&&(w.arguments=$),this.u("request",w),typeof C=="number"){const l=setTimeout(()=>{clearTimeout(l);const S=this.f.get(w.seq);if(S){this.f.delete(w.seq);const d={type:"response",seq:0,request_seq:w.seq,success:!1,command:T,message:(0,P.localize)(0,null,C,T)};S(d)}},C)}return c&&this.f.set(w.seq,c),w.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,R.$Bh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,c=this.f.get($.request_seq);c&&(this.f.delete($.request_seq),c($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,c)=>T.set(c,$)),await(0,R.$Bh)(500),T.forEach(($,c)=>{$({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$9rb=O}),define(ke[81],Ie([1,0,2,197,32,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$SJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$QJ=e.MemoryRangeType=e.State=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=void 0,e.$PJ=$,e.$RJ=C,e.$DI="workbench.view.debug",e.$EI="workbench.debug.variablesView",e.$FI="workbench.debug.watchExpressionsView",e.$GI="workbench.debug.callStackView",e.$HI="workbench.debug.loadedScriptsView",e.$II="workbench.debug.breakPointsView",e.$JI="workbench.debug.disassemblyView",e.$KI="workbench.panel.repl",e.$LI="workbench.panel.repl.view",e.$MI=new P.$Rj("debugType",void 0,{type:"string",description:R.localize(0,null)}),e.$NI=new P.$Rj("debugConfigurationType",void 0,{type:"string",description:R.localize(1,null)}),e.$OI=new P.$Rj("debugState","inactive",{type:"string",description:R.localize(2,null)}),e.$PI="debugUx",e.$QI=new P.$Rj(e.$PI,"default",{type:"string",description:R.localize(3,null)}),e.$RI=new P.$Rj("hasDebugged",!1,{type:"boolean",description:R.localize(4,null)}),e.$SI=new P.$Rj("inDebugMode",!1,{type:"boolean",description:R.localize(5,null)}),e.$TI=new P.$Rj("inDebugRepl",!1,{type:"boolean",description:R.localize(6,null)}),e.$UI=new P.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7,null)}),e.$VI=new P.$Rj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(8,null)}),e.$WI=new P.$Rj("breakpointsFocused",!0,{type:"boolean",description:R.localize(9,null)}),e.$XI=new P.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(10,null)}),e.$YI=new P.$Rj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(11,null)}),e.$ZI=new P.$Rj("variablesFocused",!0,{type:"boolean",description:R.localize(12,null)}),e.$1I=new P.$Rj("expressionSelected",!1,{type:"boolean",description:R.localize(13,null)}),e.$2I=new P.$Rj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(14,null)}),e.$3I=new P.$Rj("callStackItemType",void 0,{type:"string",description:R.localize(15,null)}),e.$4I=new P.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(16,null)}),e.$5I=new P.$Rj("callStackItemStopped",!1,{type:"boolean",description:R.localize(17,null)}),e.$6I=new P.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(18,null)}),e.$7I=new P.$Rj("watchItemType",void 0,{type:"string",description:R.localize(19,null)}),e.$8I=new P.$Rj("canViewMemory",void 0,{type:"boolean",description:R.localize(20,null)}),e.$9I=new P.$Rj("breakpointItemType",void 0,{type:"string",description:R.localize(21,null)}),e.$0I=new P.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(22,null)}),e.$$I=new P.$Rj("breakpointHasModes",!1,{type:"boolean",description:R.localize(23,null)}),e.$_I=new P.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(24,null)}),e.$aJ=new P.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(25,null)}),e.$bJ=new P.$Rj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(26,null)}),e.$cJ=new P.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(27,null)}),e.$dJ=new P.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(28,null)}),e.$eJ=new P.$Rj("stepBackSupported",!1,{type:"boolean",description:R.localize(29,null)}),e.$fJ=new P.$Rj("restartFrameSupported",!1,{type:"boolean",description:R.localize(30,null)}),e.$gJ=new P.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(31,null)}),e.$hJ=new P.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(32,null)}),e.$iJ=new P.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(33,null)}),e.$jJ=new P.$Rj("breakpointsExist",!1,{type:"boolean",description:R.localize(34,null)}),e.$kJ=new P.$Rj("debuggersAvailable",!1,{type:"boolean",description:R.localize(35,null)}),e.$lJ=new P.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(36,null)}),e.$mJ=new P.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(37,null)}),e.$nJ=new P.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(38,null)}),e.$oJ=new P.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(39,null)}),e.$pJ=new P.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(40,null)}),e.$qJ=new P.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(41,null)}),e.$rJ=new P.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(42,null)}),e.$sJ=new P.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(43,null)}),e.$tJ=new P.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(44,null)}),e.$uJ=new P.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(45,null)}),e.$vJ=new P.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(46,null)}),e.$wJ=new P.$Rj("variableIsReadonly",!1,{type:"boolean",description:R.localize(47,null)}),e.$xJ=new P.$Rj("variableValue",!1,{type:"string",description:R.localize(48,null)}),e.$yJ=new P.$Rj("variableType",!1,{type:"string",description:R.localize(49,null)}),e.$zJ=new P.$Rj("variableInterfaces",!1,{type:"array",description:R.localize(50,null)}),e.$AJ=new P.$Rj("variableName",!1,{type:"string",description:R.localize(51,null)}),e.$BJ=new P.$Rj("variableLanguage",!1,{type:"string",description:R.localize(52,null)}),e.$CJ=new P.$Rj("variableExtensionId",!1,{type:"string",description:R.localize(53,null)}),e.$DJ=new P.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(54,null)}),e.$EJ=new P.$Rj("multiSessionRepl",!1,{type:"boolean",description:R.localize(55,null)}),e.$FJ=new P.$Rj("multiSessionDebug",!1,{type:"boolean",description:R.localize(56,null)}),e.$GJ=new P.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(57,null)}),e.$HJ=new P.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(58,null)}),e.$IJ=new P.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(59,null)}),e.$JJ=new P.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(60,null)});const A=t=>R.localize(61,null,t);e.$KJ=A,e.$LJ="editor.contrib.debug",e.$MJ="editor.contrib.breakpoint",e.$NJ="debug",e.$OJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(62,null)};var T;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(T||(e.State=T={}));function $(t){switch(t){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var c;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$QJ="vscode-debug-memory";function C(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var w;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var l;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var S;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$SJ=(0,O.$Ai)("debugService");var d;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(t){t.deserialize=s=>s,t.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(t){t.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:E.URI.revive(s.iconPath.light),dark:E.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),t.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(ke[236],Ie([1,0,13,2,20,26,16,33,22,18]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RH=void 0,e.$FH=w,e.$GH=l,e.$HH=S,e.$IH=d,e.$JH=r,e.$KH=o,e.$LH=a,e.$MH=t,e.$NH=i,e.$OH=g,e.$PH=u,e.$QH=I;const C=/{([^}]+)}/g;function w(y,p,k){return y.replace(C,function(m,v){return p&&v.length>0&&v[0]!=="_"?m:k&&k.hasOwnProperty(v)?k[v]:m})}function l(y){const p={};for(const k of Object.keys(y))k.startsWith("!")||(p[k]=y[k]);return p}function S(y){return y.configuration.request==="attach"&&!d(y)&&(!y.parentSession||S(y.parentSession))}function d(y){let p=y.configuration.type;if(p)return p==="vslsShare"&&(p=y.configuration.adapterProxy.configuration.type),(0,E.$Bf)(p,"extensionhost")||(0,E.$Bf)(p,"pwa-extensionhost")?y:y.parentSession?d(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function o(y,p,k){let m,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=F.exec(y);){const G=M.index+1,q=G+M[0].length;if(G<=p&&q>=k){m=M[0],v=G;break}}if(m){const G=/\w+/g;let q=null;for(;(q=G.exec(m))&&!(q.index+1+v+q[0].length>=k););q&&(m=m.substring(0,G.lastIndex))}return m?{start:v,end:v+m.length-1}:{start:0,end:0}}async function a(y,p,k,m){if(y.evaluatableExpressionProvider.has(p)){const v=y.evaluatableExpressionProvider.ordered(p),F=(0,c.$Hb)(await Promise.all(v.map(async M=>{try{return await M.provideEvaluatableExpression(p,k,m??$.CancellationToken.None)}catch{return}})));if(F.length>0){let M=F[0].expression;const G=F[0].range;return M||(M=p.getLineContent(k.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:M}}}else{const v=p.getLineContent(k.lineNumber),{start:F,end:M}=o(v,k.column,k.column),G=v.substring(F-1,M);return{matchingExpression:G,range:new T.$ct(k.lineNumber,F,k.lineNumber,F+G.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(y){return!!(y&&y.match(h))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(t(y.path))return R.URI.parse(y.path);if((0,P.$ic)(y.path))return R.URI.file(y.path)}return y.path}function n(y){if(typeof y.path=="object"){const p=R.URI.revive(y.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return y.path}function i(y,p){const k=p?s:n,m=(0,O.$9n)(y);return f(m,(v,F)=>{v&&F&&(F.path=k(F))}),m}function g(y,p){const k=p?s:n,m=(0,O.$9n)(y);return f(m,(v,F)=>{!v&&F&&(F.path=k(F))}),m}function f(y,p){switch(y.type){case"event":{const k=y;switch(k.event){case"output":p(!1,k.body.source);break;case"loadedSource":p(!1,k.body.source);break;case"breakpoint":p(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=y;switch(k.command){case"setBreakpoints":p(!0,k.arguments.source);break;case"breakpointLocations":p(!0,k.arguments.source);break;case"source":p(!0,k.arguments.source);break;case"gotoTargets":p(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(m=>p(!1,m));break;default:break}break}case"response":{const k=y;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(m=>p(!1,m.source));break;case"loadedSources":k.body.sources.forEach(m=>p(!1,m));break;case"scopes":k.body.scopes.forEach(m=>p(!1,m.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(m=>p(!1,m.source));break;case"setBreakpoints":k.body.breakpoints.forEach(m=>p(!1,m.source));break;case"disassemble":k.body?.instructions.forEach(v=>p(!1,v.location));break;default:break}break}}}function u(y){return y.filter(p=>!p.presentation?.hidden).sort((p,k)=>p.presentation?k.presentation?p.presentation.group?k.presentation.group?p.presentation.group!==k.presentation.group?p.presentation.group.localeCompare(k.presentation.group):b(p.presentation.order,k.presentation.order):-1:k.presentation.group?1:b(p.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function b(y,p){return typeof y!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:y-p}async function I(y,p){const k=y.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(k!=="none"&&(await p.saveAll(),k==="allEditorsInActiveGroup")){const m=p.activeEditorPane;m&&m.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:m.input,groupId:m.group.id})}await y.reloadConfiguration()}const D=(y,p)=>!y||!p?y===p:y.name===p.name&&y.path===p.path&&y.sourceReference===p.sourceReference;e.$RH=D}),define(ke[237],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$$J=(0,E.$Ai)("INotebookExecutionService")}),define(ke[238],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljb=e.$kjb=e.ProxyKernelState=e.$jjb=void 0,e.$jjb=100;var R;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$kjb=(0,E.$Ai)("INotebookKernelService"),e.$ljb=(0,E.$Ai)("INotebookKernelHistoryService")}),define(ke[239],Ie([1,0,6,33,52,165,101]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZXb=void 0;class T extends E.$Uc{constructor(c,C,w){super(),this._source=c,this.b=C,this.c=w,this.a=void 0}f(c){const C=c.getLineCount();return new R.$ct(1,1,C,this.g(c,C))}g(c,C){if(C<1||C>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(C)+1}get inputTextBuffer(){if(!this.b){const c=new O.$aD;c.acceptChunk(this._source);const C=c.finish(!0),{textBuffer:w,disposable:l}=C.create(P.DefaultEndOfLine.LF);this.b=w,this.B(l)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const C=new O.$aD;C.acceptChunk(c);const w=C.finish(!0),{textBuffer:l,disposable:S}=w.create(P.DefaultEndOfLine.LF);return this.B(S),l})),this.a}findInInputs(c){const w=new A.$1C(c,!1,!1,null).parseSearchRequest();if(!w)return[];const l=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(l,w,!0,5e3)}findInOutputs(c){const w=new A.$1C(c,!1,!1,null).parseSearchRequest();return w?this.outputTextBuffers.map(l=>{const S=l.findMatchesLineByLine(this.f(l),w,!0,5e3);if(S.length!==0)return{textBuffer:l,matches:S}}).filter(l=>!!l):[]}}e.$ZXb=T}),define(ke[55],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(O){O.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(A,T,$=A.parent){if(A._isRoot)return new P([T]);const c=[A.id];for(let C=$;C&&C.id!==T;C=C.parent)c.push(C.id);return c.push(T),new P(c.reverse())}static isRoot(A){return!A.includes(E.Delimiter)}static root(A){const T=A.indexOf(E.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new P(A.split(E.Delimiter))}static join(A,T){return new P([...A.path,T])}static joinToString(A,T){return A.toString()+E.Delimiter+T}static parentId(A){const T=A.lastIndexOf(E.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(E.Delimiter);return T===-1?A:A.slice(T+E.Delimiter.length)}static isChild(A,T){return T.startsWith(A)&&T[A.length]===E.Delimiter}static compare(A,T){return A===T?R.IsSame:P.isChild(A,T)?R.IsChild:P.isChild(T,A)?R.IsParent:R.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let $=0;for(;$<A-1;){for(let c=1;c<A;c++){const C=T(c-1),w=T(c);if(C.path[$]!==w.path[$])return $}$++}return $}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return R.Disconnected;return A.d>this.d?R.IsChild:A.d<this.d?R.IsParent:R.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=E.Delimiter,this.c+=this.path[A]}return this.c}}e.$fL=P}),define(ke[56],Ie([1,0,2,100,33,55]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$nL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$mL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$lL=e.$kL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$jL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$iL=e.$hL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$gL=e.TestResultState=void 0;var A;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$gL={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$hL=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const c=V=>"runId"in V;e.$iL=c;var C;(function(V){V.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),V.deserialize=(N,L)=>({range:P.$ct.lift(L.range),uri:N.asCanonicalUri(E.URI.revive(L.uri))})})(C||(e.IRichLocation=C={}));var w;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(w||(e.TestMessageType=w={}));var l;(function(V){V.serialize=N=>({message:N.message,type:w.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&C.serialize(N.location)}),V.deserialize=(N,L)=>({message:L.message,type:w.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&C.deserialize(N,L.location)})})(l||(e.ITestErrorMessage=l={}));const S=(V,N)=>`${N?"s":"e"}${V}`;e.$jL=S;var d;(function(V){V.serialize=N=>({message:N.message,type:w.Output,offset:N.offset,length:N.length,location:N.location&&C.serialize(N.location)}),V.deserialize=(N,L)=>({message:L.message,type:w.Output,offset:L.offset,length:L.length,location:L.location&&C.deserialize(N,L.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(V){V.serialize=N=>N.type===w.Error?l.serialize(N):d.serialize(N),V.deserialize=(N,L)=>L.type===w.Error?l.deserialize(N,L):d.deserialize(N,L)})(r||(e.ITestMessage=r={}));var o;(function(V){V.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),V.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),V.deserialize=(N,L)=>({state:L.state,duration:L.duration,messages:L.messages.map(Z=>r.deserialize(N,Z))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(V,N)=>V+a+N;e.$kL=h;const t=V=>{const N=V.indexOf(a);return{ctrlId:V.slice(0,N),tagId:V.slice(N+1)}};e.$lL=t;var s;(function(V){V.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),V.deserialize=(N,L)=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?N.asCanonicalUri(E.URI.revive(L.uri)):void 0,range:L.range?P.$ct.lift(L.range):null,description:L.description,error:L.error,sortText:L.sortText})})(s||(e.ITestItem=s={}));var n;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var i;(function(V){V.serialize=N=>({expand:N.expand,item:s.serialize(N.item)}),V.deserialize=(N,L)=>({controllerId:O.$fL.root(L.item.extId),expand:L.expand,item:s.deserialize(N,L.item)})})(i||(e.InternalTestItem=i={}));var g;(function(V){V.serialize=N=>{let L;return N.item&&(L={},N.item.label!==void 0&&(L.label=N.item.label),N.item.tags!==void 0&&(L.tags=N.item.tags),N.item.busy!==void 0&&(L.busy=N.item.busy),N.item.uri!==void 0&&(L.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(L.range=N.item.range?.toJSON()),N.item.description!==void 0&&(L.description=N.item.description),N.item.error!==void 0&&(L.error=N.item.error),N.item.sortText!==void 0&&(L.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:L}},V.deserialize=N=>{let L;return N.item&&(L={},N.item.label!==void 0&&(L.label=N.item.label),N.item.tags!==void 0&&(L.tags=N.item.tags),N.item.busy!==void 0&&(L.busy=N.item.busy),N.item.range!==void 0&&(L.range=N.item.range?P.$ct.lift(N.item.range):null),N.item.description!==void 0&&(L.description=N.item.description),N.item.error!==void 0&&(L.error=N.item.error),N.item.sortText!==void 0&&(L.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:L}}})(g||(e.ITestItemUpdate=g={}));const f=(V,N)=>{N.expand!==void 0&&(V.expand=N.expand),N.item!==void 0&&(V.item=V.item?Object.assign(V.item,N.item):N.item)};e.$mL=f;var u;(function(V){V.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serializeWithoutMessages)}),V.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serialize)}),V.deserialize=(N,L)=>({...i.deserialize(N,L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(Z=>o.deserialize(N,Z)),retired:!0})})(u||(e.TestResultItem=u={}));var b;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(N,L)=>{N.covered+=L.covered,N.total+=L.total}})(b||(e.ICoverageCount=b={}));var I;(function(V){V.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),V.deserialize=(N,L)=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testId:L.testId?O.$fL.fromString(L.testId):void 0,uri:N.asCanonicalUri(E.URI.revive(L.uri))}),V.empty=(N,L)=>({id:N,uri:L,testId:void 0,statement:b.empty()})})(I||(e.IFileCoverage=I={}));function D(V){return{...V,location:V.location?.toJSON()}}function y(V){return V.location=V.location?R.$bt.isIPosition(V.location)?R.$bt.lift(V.location):P.$ct.lift(V.location):void 0,V}e.$nL=3;var p;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})(p||(e.DetailType=p={}));var k;(function(V){V.serialize=N=>N.type===p.Declaration?v.serialize(N):F.serialize(N),V.deserialize=N=>N.type===p.Declaration?v.deserialize(N):F.deserialize(N)})(k||(e.CoverageDetails=k={}));var m;(function(V){V.serialize=D,V.deserialize=y})(m||(e.IBranchCoverage=m={}));var v;(function(V){V.serialize=D,V.deserialize=y})(v||(e.IDeclarationCoverage=v={}));var F;(function(V){V.serialize=N=>({...D(N),branches:N.branches?.map(m.serialize)}),V.deserialize=N=>({...y(N),branches:N.branches?.map(m.deserialize)})})(F||(e.IStatementCoverage=F={}));var M;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(M||(e.TestDiffOpType=M={}));var G;(function(V){V.deserialize=(N,L)=>L.op===M.Add?{op:L.op,item:i.deserialize(N,L.item)}:L.op===M.Update?{op:L.op,item:g.deserialize(L.item)}:L.op===M.DocumentSynced?{op:L.op,uri:N.asCanonicalUri(E.URI.revive(L.uri)),docv:L.docv}:L,V.serialize=N=>N.op===M.Add?{op:N.op,item:i.serialize(N.item)}:N.op===M.Update?{op:N.op,item:g.serialize(N.item)}:N})(G||(e.TestsDiffOp=G={}));class q{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const L=this.w();for(const Z of N)switch(Z.op){case M.Add:this.l(i.deserialize(this.k,Z.item),L);break;case M.Update:this.p(g.deserialize(Z.item),L);break;case M.Remove:this.q(Z.itemId,L);break;case M.Retire:this.v(Z.itemId);break;case M.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case M.AddTag:this.c.set(Z.tag.id,Z.tag);break;case M.RemoveTag:this.c.delete(Z.id);break}L.complete?.()}l(N,L){const Z=O.$fL.parentId(N.item.extId)?.toString();let re;if(!Z)re=this.x(N),this.g.add(re),this.f.set(N.item.extId,re);else if(this.f.has(Z)){const fe=this.f.get(Z);fe.children.add(N.item.extId),re=this.x(N,fe),this.f.set(N.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return L.add?.(re),N.expand===n.BusyExpanding&&this.h++,re}p(N,L){const Z=this.f.get(N.extId);if(Z)return N.expand!==void 0&&(Z.expand===n.BusyExpanding&&this.h--,N.expand===n.BusyExpanding&&this.h++),(0,e.$mL)(Z,N),L.update?.(Z),Z}q(N,L){const Z=this.f.get(N);if(!Z)return;const re=O.$fL.parentId(Z.item.extId)?.toString();re?this.f.get(re).children.delete(Z.item.extId):this.g.delete(Z);const fe=[[N]];for(;fe.length;)for(const be of fe.pop()){const oe=this.f.get(be);oe&&(fe.push(oe.children),this.f.delete(be),L.remove?.(oe,oe!==Z),oe.expand===n.BusyExpanding&&this.h--)}}v(N){}updatePendingRoots(N){this.j+=N}w(){return{}}}e.$oL=q}),define(ke[240],Ie([1,0,98,200,56]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$3Eb=e.$2Eb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(w){w.ViewletId="workbench.view.extension.test",w.ExplorerViewId="workbench.view.testing",w.OutputPeekContributionId="editor.contrib.testingOutputPeek",w.DecorationsContributionId="editor.contrib.testingDecorations",w.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",w.CoverageViewId="workbench.view.testCoverage",w.ResultsPanelId="workbench.panel.testResults",w.ResultsViewId="workbench.panel.testResults.view",w.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(w){w.List="list",w.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(w){w.ByLocation="location",w.ByStatus="status",w.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[P.TestResultState.Errored]:(0,R.localize)(0,null),[P.TestResultState.Failed]:(0,R.localize)(1,null),[P.TestResultState.Passed]:(0,R.localize)(2,null),[P.TestResultState.Queued]:(0,R.localize)(3,null),[P.TestResultState.Running]:(0,R.localize)(4,null),[P.TestResultState.Skipped]:(0,R.localize)(5,null),[P.TestResultState.Unset]:(0,R.localize)(6,null)},c=(w,l)=>(0,R.localize)(7,null,(0,E.$Tk)(w),$[l]);e.$2Eb=c,e.$3Eb={[P.TestRunProfileBitset.Debug]:(0,R.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,R.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,R.localize)(10,null)};var C;(function(w){w.CancelTestRefreshAction="testing.cancelTestRefresh",w.CancelTestRunAction="testing.cancelRun",w.ClearTestResultsAction="testing.clearTestResults",w.CollapseAllAction="testing.collapseAll",w.ConfigureTestProfilesAction="testing.configureProfile",w.ContinousRunUsingForTest="testing.continuousRunUsingForTest",w.CoverageAtCursor="testing.coverageAtCursor",w.CoverageByUri="testing.coverage.uri",w.CoverageClear="testing.coverage.close",w.CoverageCurrentFile="testing.coverageCurrentFile",w.CoverageFilterToTest="testing.coverageFilterToTest",w.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",w.CoverageLastRun="testing.coverageLastRun",w.CoverageSelectedAction="testing.coverageSelected",w.CoverageToggleToolbar="testing.coverageToggleToolbar",w.CoverageViewChangeSorting="testing.coverageViewChangeSorting",w.DebugAction="testing.debug",w.DebugAllAction="testing.debugAll",w.DebugAtCursor="testing.debugAtCursor",w.DebugByUri="testing.debug.uri",w.DebugCurrentFile="testing.debugCurrentFile",w.DebugFailedTests="testing.debugFailTests",w.DebugLastRun="testing.debugLastRun",w.DebugSelectedAction="testing.debugSelected",w.FilterAction="workbench.actions.treeView.testExplorer.filter",w.GetExplorerSelection="_testing.getExplorerSelection",w.GetSelectedProfiles="testing.getSelectedProfiles",w.GoToTest="testing.editFocusedTest",w.HideTestAction="testing.hideTest",w.OpenCoverage="testing.openCoverage",w.OpenOutputPeek="testing.openOutputPeek",w.RefreshTestsAction="testing.refreshTests",w.ReRunFailedTests="testing.reRunFailTests",w.ReRunLastRun="testing.reRunLastRun",w.RunAction="testing.run",w.RunAllAction="testing.runAll",w.RunAllWithCoverageAction="testing.coverageAll",w.RunAtCursor="testing.runAtCursor",w.RunByUri="testing.run.uri",w.RunCurrentFile="testing.runCurrentFile",w.RunSelectedAction="testing.runSelected",w.RunUsingProfileAction="testing.runUsing",w.RunWithCoverageAction="testing.coverage",w.SearchForTestExtension="testing.searchForTestExtension",w.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",w.ShowMostRecentOutputAction="testing.showMostRecentOutput",w.StartContinousRun="testing.startContinuousRun",w.StopContinousRun="testing.stopContinuousRun",w.TestingSortByDurationAction="testing.sortByDuration",w.TestingSortByLocationAction="testing.sortByLocation",w.TestingSortByStatusAction="testing.sortByStatus",w.TestingViewAsListAction="testing.viewAsList",w.TestingViewAsTreeAction="testing.viewAsTree",w.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",w.ToggleInlineTestOutput="testing.toggleInlineTestOutput",w.UnhideAllTestsAction="testing.unhideAllTests",w.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(ke[82],Ie([1,0,11,4,6,61,56,55]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.TestItemEventOp=void 0;var $;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const c=(h,t)=>h===t,w=Object.entries({range:(h,t)=>h===t?!0:!h||!t?!1:h.equalsRange(t),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,t)=>!(h.length!==t.length||h.some(s=>!t.includes(s)))}),l=(h,t)=>{let s;for(const[n,i]of w)i(h[n],t[n])||(s?s[n]=t[n]:s={[n]:t[n]});return s};class S extends P.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new E.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new R.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===t.uri){s.docv=t.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===t.item.extId){(0,A.$mL)(s.item,t.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===t.item.extId){(0,A.$mL)(s.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,s){const n=this.tree.get(t);if(n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===A.TestItemExpandState.Expandable){const i=this.M(n);return i.isOpen()?this.L(n,s-1):i.wait().then(()=>this.L(n,s-1))}else if(n.expand===A.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.L(n,s-1)):this.L(n,s-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,s){switch(s.op){case $.RemoveChild:this.O(T.$fL.joinToString(t.fullId,s.id));break;case $.Upsert:this.z(s.item,t);break;case $.Bulk:for(const n of s.ops)this.w(t,n);break;case $.SetTags:this.C(s.new,s.old,t.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(t);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),item:s.update}});break;case $.DocumentSynced:this.y(t.actual.uri);break;default:(0,O.$ed)(s)}}y(t){t&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,s){const n=T.$fL.fromExtHostTestItem(t,this.root.id,s?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==s?.actual&&this.s.getChildren(i.parent).delete(t.id);let g=this.tree.get(n.toString());if(!g){g={fullId:n,actual:t,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},t.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(t,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(t)}}),this.I(t,g,s);return}if(g.actual===t){this.H(t,g,s);return}if(g.actual.uri?.toString()!==t.uri?.toString())return this.O(n.toString()),this.z(t,s);const f=this.s.getChildren(g.actual),u=g.actual,b=l(this.s.toITestItem(u),this.s.toITestItem(t));this.s.getApiFor(u).listener=void 0,g.actual=t,g.resolveBarrier=void 0,g.expand=A.TestItemExpandState.NotExpandable,b&&(b.hasOwnProperty("tags")&&(this.C(t.tags,u.tags,n.toString()),delete b.tags),this.w(g,{op:$.SetProp,update:b})),this.I(t,g,s);for(const[D,y]of f)this.s.getChildren(t).get(y.id)||this.O(T.$fL.joinToString(n,y.id));const I=g.expandLevels;I!==void 0&&queueMicrotask(()=>{g.expand===A.TestItemExpandState.Expandable&&(g.expandLevels=void 0,this.expand(n.toString(),I))}),this.y(g.actual.uri)}C(t,s,n){const i=new Set(s.map(g=>g.id));for(const g of t)i.delete(g.id)||this.D(g);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n,item:{tags:t.map(g=>(0,A.$kL)(this.s.controllerId,g.id))}}}),i.forEach(this.F,this)}D(t){const s=this.j.get(t.id);s?s.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$kL)(this.s.controllerId,t.id)}}))}F(t){const s=this.j.get(t);s&&!--s.refCount&&(this.j.delete(t),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$kL)(this.s.controllerId,t)}))}G(t,s){this.s.getApiFor(t).parent=s&&s.actual!==this.root?s.actual:void 0}H(t,s,n){this.G(t,n);const i=this.s.getApiFor(t);i.parent=n?.actual,i.listener=g=>this.w(s,g),this.J(s)}I(t,s,n){this.H(t,s,n);for(const[i,g]of this.s.getChildren(t))this.z(g,s)}J(t){let s;this.h?t.resolveBarrier?s=t.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=t.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==t.expand&&(t.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&t.expandLevels!==void 0&&this.M(t))}L(t,s){if(s<0)return;const n=[];for(const[i,g]of this.s.getChildren(t.actual)){const f=this.expand(T.$fL.joinToString(t.fullId,g.id),s);(0,E.$mh)(f)&&n.push(f)}if(n.length)return Promise.all(n).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const g=new E.$zh;return g.open(),g}t.expand=A.TestItemExpandState.BusyExpanding,this.N(t);const s=t.resolveBarrier=new E.$zh,n=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(g){n(g)}return(0,E.$mh)(i)?i.catch(n).then(()=>{s.open(),this.J(t)}):(s.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const s=this.tree.get(t);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:t});const n=[s];for(;n.length;){const i=n.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const g of i.actual.tags)this.F(g.id);this.tree.delete(i.fullId.toString());for(const[g,f]of this.s.getChildren(i.actual))n.push(this.tree.get(T.$fL.joinToString(i.fullId,f.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$NO=S;class d extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$OO=d;class r extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$PO=r;class o extends Error{constructor(t,s,n){super(`TestItem with ID "${t}" is from controller "${s}" and cannot be added as a child of an item from controller "${n}".`)}}e.$QO=o;const a=(h,t,s)=>{let n=new Map;return{get size(){return n.size},forEach(i,g){for(const f of n.values())i.call(g,f,this)},[Symbol.iterator](){return n.entries()},replace(i){const g=new Map,f=new Set(n.keys()),u={op:$.Bulk,ops:[]};for(const b of i){if(!(b instanceof s))throw new r(b.id);const I=t(b).controllerId;if(I!==h.controllerId)throw new o(b.id,I,h.controllerId);if(g.has(b.id))throw new d(b.id);g.set(b.id,b),f.delete(b.id),u.ops.push({op:$.Upsert,item:b})}for(const b of f.keys())u.ops.push({op:$.RemoveChild,id:b});h.listener?.(u),n=g},add(i){if(!(i instanceof s))throw new r(i.id);n.set(i.id,i),h.listener?.({op:$.Upsert,item:i})},delete(i){n.delete(i)&&h.listener?.({op:$.RemoveChild,id:i})},get(i){return n.get(i)},toJSON(){return Array.from(n.values())}}};e.$RO=a}),define(ke[114],Ie([1,0,82]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=void 0;const R=new WeakMap,P=(A,T)=>{const $={controllerId:T};return R.set(A,$),$};e.$SO=P;const O=A=>{const T=R.get(A);if(!T)throw new E.$PO(A?.id||"<unknown>");return T};e.$TO=O}),define(ke[83],Ie([1,0,28,16,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wBb=e.$vBb=e.$uBb=void 0,e.$xBb=O,e.$yBb=T,e.$uBb="vscode-cdn.net",e.$vBb=`vscode-resource.${e.$uBb}`,e.$wBb=`'self' https://*.${e.$uBb}`;function O($,c){return $.scheme===R.Schemas.http||$.scheme===R.Schemas.https?$:(c&&c.authority&&c.isRemote&&$.scheme===R.Schemas.file&&($=P.URI.from({scheme:R.Schemas.vscodeRemote,authority:c.authority,path:$.path})),P.URI.from({scheme:R.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$vBb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,c=>{const C=c.charCodeAt(0);return C>=E.CharCode.a&&C<=E.CharCode.z||C>=E.CharCode.A&&C<=E.CharCode.Z||C>=E.CharCode.Digit0&&C<=E.CharCode.Digit9?c:"-"+C.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(c,C)=>String.fromCharCode(parseInt(C,16)))}}),define(ke[241],Ie([1,0,4,6,83]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class O{constructor(T,$,c){this.d=T,this.e=$,this.f=c,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const C=$.getVisibleTextEditors();for(const w of this.c.values())C.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,c,C,w){let l;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===T){l=t;break}if(!l)throw new Error("not a visible editor");const S=this,d=this.a++,r=new E.$he,o=new E.$he,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,P.$xBb)(t,S.f)}get cspSource(){return P.$wBb}set options(t){this.b=t,S.d.$setOptions(d,t)}get options(){return this.b}set html(t){this.a=t,S.d.$setHtml(d,t)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(t){return S.d.$postMessage(d,t)}},h=new class{constructor(){this.editor=T,this.line=$,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,l.id,l.value.document.uri,$+1,c,C||{},w.identifier,w.extensionLocation),this.c.set(d,{editor:T,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$Rmc=O}),define(ke[115],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$wL=e.$vL=void 0,e.$vL="__",e.$wL=(0,E.$Ai)("IAuthenticationService"),e.$xL=(0,E.$Ai)("IAuthenticationExtensionsService")}),define(ke[242],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.VariableKind=e.$LP=void 0,e.$LP=(0,E.$Ai)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class P extends Error{constructor(A,T){super(T),this.variable=A}}e.$MP=P}),define(ke[243],Ie([1,0,20,79,15,26,21,102,201,242,13]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,r,o){this.h=new Map,this.a=S,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(S){if(A.$i){const d=Object.create(null);return Object.keys(S).forEach(r=>{d[r.toLowerCase()]=S[r]}),d}return S}resolveWithEnvironment(S,d,r){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(S,d){const r={env:await this.c,userHome:await this.g};return this.l(r,S?S.uri:void 0,d)}async j(S,d,r,o){const a=O.$9n(d);A.$i&&a.windows?Object.keys(a.windows).forEach(t=>a[t]=a.windows[t]):A.$j&&a.osx?Object.keys(a.osx).forEach(t=>a[t]=a.osx[t]):A.$k&&a.linux&&Object.keys(a.linux).forEach(t=>a[t]=a.linux[t]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,S?S.uri:void 0,a,r,o)}async resolveAnyAsync(S,d,r){return this.j(S,d,r)}async resolveAnyMap(S,d,r){const o=new Map;return{newConfig:await this.j(S,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(S,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,r,o,a){if(P.$ag(r))return this.m(S,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(S,d,h,o,a)));if(P.$cg(r)){const h=Object.create(null),t=await Promise.all(Object.keys(r).map(async s=>[await this.m(S,d,s,o,a),await this.l(S,d,r[s],o,a)]));for(const[s,n]of t)h[s]=n;return h}return r}m(S,d,r,o,a){return(0,C.$tf)(r,w.VARIABLE_REGEXP,async(h,t)=>{if(t.includes(w.VARIABLE_LHS))return h;let s=await this.o(S,h,t,d,o);return a?.set(t,s),s!==h&&P.$ag(s)&&s.match(w.VARIABLE_REGEXP)&&(s=await this.m(S,d,s,o,a)),s})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,r,o,a){let h;const t=r.split(":");t.length>1&&(r=t[0],h=t[1]);const s=g=>{const f=this.a.getFilePath();if(f)return(0,T.$Nw)(f);throw new c.$MP(g,(0,$.localize)(0,null,d))},n=g=>{const f=s(g);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,T.$Nw)(u)}throw new c.$MP(g,(0,$.localize)(1,null,d,E.$nc(f)))},i=g=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$MP(g,(0,$.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$MP(g,(0,$.localize)(3,null,d)):new c.$MP(g,(0,$.localize)(4,null,d))};switch(r){case"env":if(h){if(S.env){const g=S.env[A.$i?h.toLowerCase():h];if(P.$ag(g))return g}return""}throw new c.$MP(c.VariableKind.Env,(0,$.localize)(5,null,d));case"config":if(h){const g=this.a.getConfigurationValue(o,h);if(P.$jg(g))throw new c.$MP(c.VariableKind.Config,(0,$.localize)(6,null,d,h));if(P.$cg(g))throw new c.$MP(c.VariableKind.Config,(0,$.localize)(7,null,d,h));return g}throw new c.$MP(c.VariableKind.Config,(0,$.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const g=await this.a.getExtension(h);if(!g)throw new c.$MP(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,d,h));return this.n(g.extensionLocation)}throw new c.$MP(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,T.$Nw)(this.n(i(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,T.$Nw)(this.n(i(c.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Nw)(E.$nc(this.n(i(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new c.$MP(c.VariableKind.UserHome,(0,$.localize)(11,null,d))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new c.$MP(c.VariableKind.LineNumber,(0,$.localize)(12,null,d))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new c.$MP(c.VariableKind.SelectedText,(0,$.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return n(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(n(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?E.$lc(this.n(i(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const g=E.$mc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=E.$lc(this.n(i(c.VariableKind.RelativeFileDirname)),g);return f.length===0?".":f}return g}case"fileDirname":return E.$mc(s(c.VariableKind.FileDirname));case"fileExtname":return E.$oc(s(c.VariableKind.FileExtname));case"fileBasename":return E.$nc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=E.$nc(s(c.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-E.$oc(g).length)}case"fileDirnameBasename":return E.$nc(E.$mc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||d}case"execInstallFolder":{const g=this.a.getAppRoot();return g||d}case"pathSeparator":case"/":return E.sep;default:try{const g=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,g,a,void 0)}catch{return d}}}}p(S,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$MP(S,(0,$.localize)(14,null,d))}return d}}e.$2P=w}),define(ke[116],Ie([1,0,3,113]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0D=void 0,e.$$D=c,e.$_D=l,e.$aE=S,e.$0D=(0,E.$Ai)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function c(d){const r=d;return(0,R.$UF)(r?.editor)&&(0,R.$UF)(r?.replacement)}var C;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var w;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function l(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(ke[244],Ie([1,0,3,116]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$dE=e.$cE=e.$bE=void 0,e.$fE=P,e.$bE=(0,E.$Ai)("editorService"),e.$cE=-1,e.$dE=-2,e.$eE=-3;function P(O){const A=O;return typeof O=="number"||(0,R.$_D)(A)}}),define(ke[245],Ie([1,0,3,105]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=void 0,e.$QL=(0,E.$Bi)(R.$Hi)}),define(ke[117],Ie([1,0,19,4,20,6,11]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=e.$6ac=e.$5ac=e.$4ac=e.$3ac=void 0;class T{constructor(h,t){this.versionId=h,this.removedDueToLooping=t}}e.$3ac=T;class ${static isHostExtension(h,t,s){if(t.getExtensionDescription(h))return!1;const n=s.getExtensionDescription(h);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(h,t){this.j=h,this.c=new R.$he,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(r),this.f=new E.$Ym,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const t=this.j.readActivationEvents(h);for(const s of t)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,t){this.e=o(this.e,t),this.e=this.e.concat(h);const s=$.l(this.e);return this.e=o(this.e,s.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,s)}static l(h){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this.c.has(f)?this.c.get(f).push(u):this.c.set(f,[u])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,u){const b=t.getArcs(f);for(let I=0;I<b.length;I++)if(!u.has(b[I]))return!1;return!0}getNodes(){return this.e}},s=new E.$Ym;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)t.addArc(E.$Wm.toKey(f.identifier),E.$Wm.toKey(u));const n=new Set;t.getNodes().filter(f=>t.getArcs(f).length===0).forEach(f=>n.add(f));const i=t.getNodes().filter(f=>!n.has(f));let g;do{g=!1;for(let f=0;f<i.length;f++){const u=i[f];t.hasOnlyGoodArcs(u,n)&&(i.splice(f,1),f--,n.add(u),g=!0)}}while(g);return i.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const t=this.h.get(h);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const t=this.f.get(h);return t||void 0}getExtensionDescriptionByUUID(h){for(const t of this.g)if(t.uuid===h)return t}getExtensionDescriptionByIdOrUUID(h,t){return this.getExtensionDescription(h)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$4ac=$;class c{constructor(h,t){this.versionId=h,this.extensions=t}}e.$5ac=c;class C{constructor(h){this.d=new S,this.c=new $(h,[])}async acquireLock(h){const t=await this.d.acquire(h);return new w(this,t)}deltaExtensions(h,t,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,t){return this.c.getExtensionDescriptionByIdOrUUID(h,t)}}e.$6ac=C;class w extends O.$Uc{constructor(h,t){super(),this.f=h,this.c=!1,this.B(t)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$7ac=w;class l{constructor(h){this.name=h;const t=(0,A.$th)();this.promise=t.promise,this.c=t.resolve}resolve(h){this.c(h)}}class S{constructor(){this.c=[],this.d=!1}async acquire(h){const t=new l(h);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let t=!0;const s=setTimeout(()=>{t&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{t&&(clearTimeout(s),t=!1,this.d=!1,this.e())};h.resolve((0,O.$Sc)(n))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const t=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(t!==s)return t-s;const n=P.$gc.basename(a.extensionLocation.path),i=P.$gc.basename(h.extensionLocation.path);return n<i?-1:n>i?1:0}function o(a,h){const t=new E.$Xm(h);return a.filter(s=>!t.has(s.identifier))}}),define(ke[84],Ie([1,0,23]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$5m=A,e.$6m=T;var R;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(c){const C=E.$Je.alloc(1);switch(c){case O.Initialized:C.writeUInt8(1,0);break;case O.Ready:C.writeUInt8(2,0);break;case O.Terminate:C.writeUInt8(3,0);break}return C}function T(c,C){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return C===O.Initialized;case 2:return C===O.Ready;case 3:return C===O.Terminate;default:return!1}}var $;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[66],Ie([1,0,3,4,111,12,27,84,62,63,26,2,6,186]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$dP=e.$cP=void 0,e.$eP=o;let d=class extends l.$Uc{constructor(h,t){super(),this.s=h,this.t=t,this.a=this.B(new R.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=w.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:c.$sp,name:(0,S.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(s=>{(0,O.$9j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,t,s){const n=this.getTelemetryDetails(),i=new r(t,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),g=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...g,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(h,t,s){this.f=h,this.g=t,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const t=Object.create(null);switch(t["common.extname"]=`${h.publisher}.${h.name}`,t["common.extversion"]=h.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:t["common.uikind"]="web";break;case T.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,$.$Nm)((0,c.$yp)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const t=this.getTelemetryDetails();this.r.forEach((s,n)=>{const i=s.filter(g=>!g.isDisposed);i.length===0?this.r.delete(n):this.r.set(n,i)}),this.r.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,t){const n=this.r.get(h.value)?.filter(g=>!g.isDisposed);if(!n)return this.r.delete(h.value),!1;let i=!1;for(const g of n)g.ignoreUnhandledExtHostErrors||(g.logError(t),i=!0);return i}};e.$cP=d,e.$cP=d=He([Ve(0,A.$bP),Ve(1,O.$8j)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,t,s,n,i,g,f){this.g=s,this.h=n,this.i=i,this.j=g,this.a=new R.$he,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,t){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let t="properties"in h?h.properties??{}:h;return t=(0,c.$Bp)(t,[]),this.c&&(t=(0,C.$_n)(t,this.c)),this.b||(t=(0,C.$_n)(t,this.j)),"properties"in h?h.properties=t:h=t,h}k(h,t){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(h,t),this.h.trace(h,t))}logUsage(h,t){this.d.isUsageEnabled&&this.k(h,t)}logError(h,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,t);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},n=(0,c.$Bp)(s,[]),i=new Error(n.message,{cause:n.cause});i.stack=n.stack,i.name=n.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(i,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const h=this,t={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$dP=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$fP=(0,E.$Ai)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,217,110,19,3]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.ActivationKind=e.$VG=e.$UG=e.$RG=e.ExtensionHostStartup=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$SG=l,e.$TG=S,e.$WG=a,e.$XG=h,e.$NG=Object.freeze({identifier:new A.$Wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$OG="extensions.webWorker",e.$PG=(0,T.$Ai)("extensionService");class ${constructor(n){this.dependency=n}}e.$QG=$;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(n,i,g){this.c=n,this.d=i.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$yG.createActivationEventsMap(this.d)}}set(n,i,g){if(this.c>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this.c})`);const f=[],u=[],b=[],I=[],D=w(this.d),y=w(i),p=(M,G)=>M.extensionLocation.toString()===G.extensionLocation.toString()||M.isBuiltin===G.isBuiltin||M.isUserBuiltin===G.isUserBuiltin||M.isUnderDevelopment===G.isUnderDevelopment;for(const M of this.d){const G=y.get(M.identifier);if(!G){f.push(M.identifier),D.delete(M.identifier);continue}if(!p(M,G)){f.push(M.identifier),D.delete(M.identifier);continue}}for(const M of i){const G=D.get(M.identifier);if(!G){u.push(M);continue}if(!p(G,M)){f.push(G.identifier),D.delete(G.identifier);continue}}const k=new A.$Xm(this.e),m=new A.$Xm(g);for(const M of this.e)m.has(M)||b.push(M);for(const M of g)k.has(M)||I.push(M);const v=O.$yG.createActivationEventsMap(u),F={versionId:n,toRemove:f,toAdd:u,addActivationEvents:v,myToRemove:b,myToAdd:I};return this.delta(F),F}delta(n){if(this.c>=n.versionId)return null;const{toRemove:i,toAdd:g,myToRemove:f,myToAdd:u}=n,b=new A.$Xm(i),I=new A.$Xm(f);for(let D=0;D<this.d.length;D++)b.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of g)this.d.push(D);for(const D of u)this.e.push(D);return this.f=null,n}containsExtension(n){for(const i of this.e)if(A.$Wm.equals(i,n))return!0;return!1}containsActivationEvent(n){return this.f||(this.f=this.g()),this.f.has(n)}g(){const n=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const g=O.$yG.readActivationEvents(i);for(const f of g)n.add(f)}return n}}e.$RG=C;function w(s){const n=new A.$Ym;for(const i of s)n.set(i.identifier,i);return n}function l(s,n){return s.enabledApiProposals?s.enabledApiProposals.includes(n):!1}function S(s,n){if(!l(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(n,i,g,f){this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=f}}e.$UG=d;class r{constructor(n,i){this.description=n,this.value=i}}e.$VG=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.$Hp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,n){return{identifier:new A.$Wm((0,P.$Fp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,i){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$YG=t}),define(ke[246],Ie([1,0,14,117,19,25,12,11]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=e.$enc=e.$dnc=e.$cnc=e.$bnc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,h,t,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=s}}e.$bnc=$;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$cnc=c;class C{constructor(a,h,t,s,n,i){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=t,this.module=s,this.exports=n,this.subscriptions=i}}e.$dnc=C;class w extends C{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$enc=w;class l extends C{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$fnc=l;class S extends C{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,t,s){this.g=s,this.a=a,this.b=h,this.c=t,this.d=new P.$Ym,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,t]of this.d)a.push(t.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const t=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(t.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const t=this.a.getExtensionDescription(a);if(!t)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:t.identifier,reason:h}])}async h(a){const h=a.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(h.map(t=>t.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const n=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new S(n));return this.c.onExtensionActivationError(a.id,n,new O.$QG(a.id.value)),i}const t=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const n of s){if(this.m(n))continue;const i=this.d.get(n);if(i){t.push(i);continue}if(this.l(n)){t.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(n);if(g){if(!g.main&&!g.browser)continue;t.push(this.j({id:g.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${n}'`),b=this.k(a,h.displayName,[],new S(u));return this.c.onExtensionActivationError(h.identifier,u,new O.$QG(n)),b}return this.k(a,h.displayName,t,null)}k(a,h,t,s){const n=new r(a.id,h,a.reason,t,s,this.c,this.g);return this.d.set(a.id,n),n}l(a){return R.$4ac.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$gnc=d,e.$gnc=d=He([Ve(3,A.$7j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,t,s,n,i,g){this.c=a,this.d=h,this.f=t,this.g=s,this.h=n,this.j=i,this.k=g,this.a=new T.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);t.detail=h.value.activationFailedError,this.h=new S(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new S(h),this.b&&E.$4(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=He([Ve(6,A.$7j)],r)}),define(ke[247],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[118],Ie([1,0,203,14,35,109,78,31,19,247,107,110]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=void 0;const l=T.$jo.as(A.$ko.JSONContribution);class S{constructor(n,i,g){this.a=n,this.b=i,this.c=g}d(n,i){this.a({type:n,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(n){this.d(P.default.Error,n)}warn(n){this.d(P.default.Warning,n)}info(n){this.d(P.default.Info,n)}}e.$HG=S;class d{static a(n){const i=new $.$Xm;for(let g=0,f=n.length;g<f;g++)i.add(n[g].description.identifier);return i}static compute(n,i){if(!n||!n.length)return new d(i,[]);if(!i||!i.length)return new d([],n);const g=this.a(n),f=this.a(i),u=i.filter(I=>!g.has(I.description.identifier)),b=n.filter(I=>!f.has(I.description.identifier));return new d(u,b)}constructor(n,i){this.added=n,this.removed=i}}e.$IG=d;class r{constructor(n,i){this.name=n,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(n){if(this.a!==null)throw new Error("Handler already set!");this.a=n,this.d()}acceptUsers(n){this.c=d.compute(this.b,n),this.b=n,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(n){(0,R.$1)(n)}}}e.$JG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$KG={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Vm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$1o}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$1o}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(n){if(this.a.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const i=new r(n.extensionPoint,n.defaultExtensionKind);return this.a.set(n.extensionPoint,i),n.activationEventsGenerator&&w.$yG.register(n.extensionPoint,n.activationEventsGenerator),e.$KG.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,l.registerSchema(a,e.$KG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$LG=h;const t={ExtensionsRegistry:"ExtensionsRegistry"};T.$jo.add(t.ExtensionsRegistry,new h),e.$MG=T.$jo.as(t.ExtensionsRegistry),l.registerSchema(a,e.$KG),l.registerSchema(C.$ok,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(ke[248],Ie([1,0,4,40,6,13,195,19,3,12,25,118]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=e.$ZG=e.ChatMessageRole=void 0;var l;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(l||(e.ChatMessageRole=l={})),e.$ZG=(0,$.$Ai)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$1G=w.$MG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.d=o,this.e=a,this.a=new Map,this.b=new Set,this.c=new E.$he,this.onDidChangeLanguageModels=this.c.event,e.$1G.setHandler(h=>{this.b.clear();for(const s of h){if(!(0,C.$SG)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const n of R.Iterable.wrap(s.value)){if(this.b.has(n.vendor)){s.collector.error((0,A.localize)(3,null,n.vendor));continue}if((0,O.$$e)(n.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){s.collector.error((0,A.localize)(5,null));continue}this.b.add(n.vendor)}}const t=[];for(const[s,n]of this.a)this.b.has(n.metadata.vendor)||(this.a.delete(s),t.push(s));t.length>0&&this.c.fire({removed:t})})}dispose(){this.c.dispose(),this.a.clear()}getLanguageModelIds(){return Array.from(this.a.keys())}lookupLanguageModel(o){return this.a.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.d.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.b).map(t=>this.d.activateByEvent(`onLanguageModelChat:${t}`));await Promise.all(h)}const a=[];for(const[h,t]of this.a)(o.vendor!==void 0&&t.metadata.vendor===o.vendor||o.family!==void 0&&t.metadata.family===o.family||o.version!==void 0&&t.metadata.version===o.version||o.identifier!==void 0&&t.metadata.id===o.identifier||o.extension!==void 0&&t.metadata.targetExtensions?.some(s=>T.$Wm.equals(s,o.extension))||!o||o.vendor===void 0&&o.family===void 0&&o.version===void 0&&o.identifier===void 0)&&a.push(h);return this.e.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.e.trace("[LM] registering language model chat",o,a.metadata),!this.b.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.a.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.a.set(o,a),this.c.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.$Sc)(()=>{this.a.delete(o)&&(this.c.fire({removed:[o]}),this.e.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,t,s,n){const i=this.a.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideChatResponse(h,a,t,s,n)}computeTokenLength(o,a,h){const t=this.a.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideTokenCount(a,h)}};e.$2G=d,e.$2G=d=He([Ve(0,C.$PG),Ve(1,c.$7j)],d)}),define(ke[249],Ie([1,0,198,15,26,118,32,4]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var c;(function(l){function S(d,r,o){if(!d)return;const a=R.$ag(d.type)?d.type:void 0;if(!a||a.length===0){o.error(E.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const t of d.required)R.$ag(t)&&h.push(t);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?P.$9n(d.properties):{},when:d.when?A.$yj.deserialize(d.when):void 0}}l.from=S})(c||(c={}));const C=O.$MG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,S)=>{for(const d of l)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:$}});class w{constructor(){this.d=new T.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{C.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const t of h)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const a of o.added){const h=a.value;for(const t of h){const s=c.from(t,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$9n(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},S.push(r)}this.c={oneOf:S}}return this.c}}e.$sI=new w}),define(ke[250],Ie([1,0,199,15,24,26,32,249,42]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$CI=e.JsonSchemaVersion=e.ExecutionEngine=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$wI=e.ShellQuoting=e.$vI=e.$uI=e.$tI=void 0,e.$tI="settings",e.$uI=new A.$Rj("taskRunning",!1,E.localize(0,null)),e.$vI=E.localize2(2,"Tasks");var c;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$wI="$customized",function(N){function L(Z){if(!Z)return N.Strong;switch(Z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=L}(c||(e.ShellQuoting=c={}));var C;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var w;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(w||(e.RevealKind=w={})),function(N){function L(Z){switch(Z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=L}(w||(e.RevealKind=w={}));var l;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(l||(e.RevealProblemKind=l={})),function(N){function L(Z){switch(Z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=L}(l||(e.RevealProblemKind=l={}));var S;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(S||(e.PanelKind=S={})),function(N){function L(Z){switch(Z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=L}(S||(e.PanelKind=S={}));var d;(function(N){N.defaults={echo:!0,reveal:w.Always,revealProblems:l.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(N){function L(re){switch(re.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=L;function Z(re){switch(re){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=Z}(r||(e.RuntimeType=r={}));var o;(function(N){function L(Z){return R.$ag(Z)?Z:Z.value}N.value=L})(o||(e.CommandString=o={}));var a;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function L(re){return re===N.Clean._id||re===N.Build._id||re===N.Rebuild._id||re===N.Test._id}N.is=L;function Z(re){if(re!==void 0)return R.$ag(re)?L(re)?{_id:re,isDefault:!1}:void 0:re}N.from=Z})(a||(e.TaskGroup=a={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var t;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function L(Z){switch(Z){case N.User:return $.ConfigurationTarget.USER;case N.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=L})(t||(e.TaskSourceKind=t={}));var s;(function(N){N.parallel="parallel",N.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var i;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class g{constructor(L,Z,re,fe,be,oe){this._label="",this._id=L,Z&&(this._label=Z),re&&(this.type=re),this.runOptions=fe,this.configurationProperties=be,this._source=oe}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,Z=!1){if(L===void 0)return!1;if(R.$ag(L))return L===this._label||L===this.configurationProperties.identifier||Z&&L===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$xI=g;class f extends g{constructor(L,Z,re,fe,be,oe,pe,$e){super(L,re,void 0,pe,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=oe,be&&(this.command=be)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case r.Shell:Z="shell";break;case r.Process:Z="process";break;case r.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(L){return L instanceof f}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$tI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let Z=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Z+=this._source.kind);const re={type:e.$wI,folder:L,id:Z};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new f(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$yI=f;class u extends g{constructor(L,Z,re,fe,be,oe,pe){super(L,re,fe,oe,pe,Z),this._source=Z,this.configures=be}static is(L){return L instanceof u}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$tI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let Z=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Z+=this._source.kind);const re={type:e.$wI,folder:L,id:Z};return JSON.stringify(re)}}e.$zI=u;class b extends g{constructor(L,Z,re,fe,be,oe,pe,$e,se){super(L,re,fe,$e,se,Z),this.defines=be,this.hasDefinedMatchers=pe,this.command=oe,this.icon=se.icon,this.hide=se.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof b}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new b(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$AI=b;class I extends g{constructor(L,Z,re,fe,be,oe){super(L,re,fe,be,oe,Z),this._source=Z}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new I(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$BI=I;var D;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(N){N._default=N.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class p{constructor(L){this.c=new Map;for(let Z=0;Z<L.length;Z++)this.c.set(L[Z].uri.toString(),Z)}compare(L,Z){const re=L.getWorkspaceFolder(),fe=Z.getWorkspaceFolder();if(re&&fe){let be=this.c.get(re.uri.toString());be=be===void 0?0:be+1;let oe=this.c.get(fe.uri.toString());return oe=oe===void 0?0:oe+1,be===oe?L._label.localeCompare(Z._label):be-oe}else return!re&&fe?-1:re&&!fe?1:0}}e.$CI=p;var k;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(k||(e.TaskEventKind=k={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var v;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(N){function L($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?m.Background:m.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Z($e,se,Ce){return{...L($e),kind:k.Start,terminalId:se,resolvedVariables:Ce}}N.start=Z;function re($e,se,Ce){return{...L($e),kind:k.ProcessStarted,terminalId:se,processId:Ce}}N.processStarted=re;function fe($e,se,Ce){return{...L($e),kind:k.ProcessEnded,terminalId:se,exitCode:Ce}}N.processEnded=fe;function be($e,se,Ce){return{...L($e),kind:k.Terminated,exitReason:Ce,terminalId:se}}N.terminated=be;function oe($e,se,Ce){return{...L(se),kind:$e,terminalId:Ce}}N.general=oe;function pe(){return{kind:k.Changed}}N.changed=pe})(F||(e.TaskEvent=F={}));var M;(function(N){function L(re){const fe=Object.keys(re).sort();let be="";for(const oe of fe){let pe=re[oe];pe instanceof Object?pe=L(pe):typeof pe=="string"&&(pe=pe.replace(/,/g,",,")),be+=oe+","+pe+","}return be}function Z(re){const be={_key:L(re),type:re.taskType};return Object.assign(be,re),be}N.create=Z})(M||(e.KeyedTaskIdentifier=M={}));var G;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var V;(function(N){function L(Z,re){const fe=T.$sI.get(Z.type);if(fe===void 0){const $e=O.$9n(Z);return delete $e._key,M.create($e)}const be=Object.create(null);be.type=fe.taskType;const oe=new Set;fe.required.forEach($e=>oe.add($e));const pe=fe.properties;for(const $e of Object.keys(pe)){const se=Z[$e];if(se!=null)be[$e]=se;else if(oe.has($e)){const Ce=pe[$e];if(Ce.default!==void 0)be[$e]=O.$9n(Ce.default);else switch(Ce.type){case"boolean":be[$e]=!1;break;case"number":case"integer":be[$e]=0;break;case"string":be[$e]="";break;default:re.error(E.localize(1,null,JSON.stringify(Z,void 0,0),$e));return}}}return M.create(be)}N.createTaskIdentifier=L})(V||(e.TaskDefinition=V={}))}),define(ke[251],Ie([1,0,14]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,E.$1)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$8ac=R;class P extends R{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$9ac=P}),define(ke[38],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Hw=void 0,e.$Iw=P,e.$Jw=O;class E{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++E.count}}e.$Hw=E;const R=[];function P(T){const $=new E(T);return R[$.nid]=$,$}function O(T){return R[T].sid}class A{constructor($){this.value=$}}e.$Kw=A}),define(ke[5],Ie([1,0,38]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$sM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var C;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class w{static{this.a=0}static mixin(o){return o._id=w.a++,o}}e.$sM=w;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var S;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$tM={MainThreadAuthentication:(0,E.$Iw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Iw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,E.$Iw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,E.$Iw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,E.$Iw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Iw)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Iw)("MainThreadClipboard"),MainThreadCommands:(0,E.$Iw)("MainThreadCommands"),MainThreadComments:(0,E.$Iw)("MainThreadComments"),MainThreadConfiguration:(0,E.$Iw)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Iw)("MainThreadConsole"),MainThreadDebugService:(0,E.$Iw)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Iw)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Iw)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Iw)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Iw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Iw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Iw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Iw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Iw)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Iw)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Iw)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Iw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Iw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Iw)("MainThreadLanguages"),MainThreadLogger:(0,E.$Iw)("MainThreadLogger"),MainThreadMessageService:(0,E.$Iw)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Iw)("MainThreadOutputService"),MainThreadProgress:(0,E.$Iw)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Iw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Iw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Iw)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Iw)("MainThreadSecretState"),MainThreadStorage:(0,E.$Iw)("MainThreadStorage"),MainThreadSpeech:(0,E.$Iw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Iw)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Iw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,E.$Iw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,E.$Iw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Iw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Iw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Iw)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Iw)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Iw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Iw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Iw)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Iw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Iw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Iw)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Iw)("MainThreadSCM"),MainThreadSearch:(0,E.$Iw)("MainThreadSearch"),MainThreadShare:(0,E.$Iw)("MainThreadShare"),MainThreadTask:(0,E.$Iw)("MainThreadTask"),MainThreadWindow:(0,E.$Iw)("MainThreadWindow"),MainThreadLabelService:(0,E.$Iw)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Iw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Iw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Iw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Iw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Iw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Iw)("MainThreadInteractive"),MainThreadTheming:(0,E.$Iw)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Iw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Iw)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Iw)("MainThreadTimeline"),MainThreadTesting:(0,E.$Iw)("MainThreadTesting"),MainThreadLocalization:(0,E.$Iw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Iw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Iw)("MainThreadAiEmbeddingVector")},e.$uM={ExtHostCommands:(0,E.$Iw)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Iw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Iw)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Iw)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Iw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Iw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Iw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Iw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Iw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Iw)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Iw)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Iw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Iw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Iw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Iw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Iw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Iw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Iw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Iw)("ExtHostStatusBar"),ExtHostShare:(0,E.$Iw)("ExtHostShare"),ExtHostExtensionService:(0,E.$Iw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Iw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Iw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,E.$Iw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,E.$Iw)("ExtHostSCM"),ExtHostSearch:(0,E.$Iw)("ExtHostSearch"),ExtHostTask:(0,E.$Iw)("ExtHostTask"),ExtHostWorkspace:(0,E.$Iw)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Iw)("ExtHostWindow"),ExtHostWebviews:(0,E.$Iw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Iw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Iw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Iw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Iw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Iw)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Iw)("ExtHostProgress"),ExtHostComments:(0,E.$Iw)("ExtHostComments"),ExtHostSecretState:(0,E.$Iw)("ExtHostSecretState"),ExtHostStorage:(0,E.$Iw)("ExtHostStorage"),ExtHostUrls:(0,E.$Iw)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Iw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Iw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Iw)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Iw)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Iw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Iw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Iw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Iw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Iw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Iw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Iw)("ExtHostInteractive"),ExtHostChatAgents2:(0,E.$Iw)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Iw)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Iw)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Iw)("ExtHostSpeech"),ExtHostEmbeddings:(0,E.$Iw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,E.$Iw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Iw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Iw)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Iw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Iw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Iw)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Iw)("ExtHostTimeline"),ExtHostTesting:(0,E.$Iw)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Iw)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Iw)("ExtHostLocalization")}}),define(ke[85],Ie([1,0,3,12,5,17]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=e.$Amc=void 0,e.$Amc=(0,E.$Ai)("IExtHostApiDeprecationService");let A=class{constructor($,c){this.c=c,this.a=new Set,this.b=$.getProxy(P.$tM.MainThreadTelemetry)}report($,c,C){const w=this.d($,c);this.a.has(w)||(this.a.add(w),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:$}))}d($,c){return`${$}-${c.identifier.value}`}};e.$Bmc=A,e.$Bmc=A=He([Ve(0,O.$XO),Ve(1,R.$7j)],A),e.$Cmc=Object.freeze(new class{report(T,$,c){}})}),define(ke[252],Ie([1,0,5]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class R{constructor(O){const A=O.getProxy(E.$tM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Pmc=R}),define(ke[253],Ie([1,0,26,5,27,17]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;let A=class{constructor(C,w){this.a=C.getProxy(R.$tM.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(C,w){const l=this,S=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){l.e(C,w,S,arguments)}})}e(C,w,l,S){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:$(S,this.b)}),this.c&&this.f(C,l,S)}};e.$Joc=A,e.$Joc=A=He([Ve(0,O.$XO),Ve(1,P.$bP)],A);const T=1e5;function $(c,C){const w=[];if(c.length)for(let l=0;l<c.length;l++){let S=c[l];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}w.push(S)}if(C){const l=new Error().stack;l&&w.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$bo)(w);return l.length>T?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(ke[254],Ie([1,0,2,5,25]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class O{constructor(T){this.a=T.getProxy(R.$tM.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,P.$TG)(T,"showLocal"),this.a.$showOpenDialog($).then(c=>c?c.map(C=>E.URI.revive(C)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?E.URI.revive($):void 0)}}e.$Mnc=O}),define(ke[255],Ie([1,0,22,4,6,5]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class A{constructor($){this.b=new Map,this.c=new R.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$tM.MainThreadEmbeddings)}registerEmbeddingsProvider($,c,C){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const w=this.e++;return this.a.$registerEmbeddingProvider(w,c),this.b.set(w,{id:c,provider:C}),(0,P.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(w),this.b.delete(w)})}async computeEmbeddings($,c,C){C??=E.CancellationToken.None;let w=!1;typeof c=="string"&&(c=[c],w=!0);const l=await this.a.$computeEmbeddings($,c,C);if(l.length!==c.length)throw new Error;if(w){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings($,c,C){const w=this.b.get($);if(!w)return[];const l=await w.provider.provideEmbeddings(c,C);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Pnc=A}),define(ke[256],Ie([1,0,6,5]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(R.$tM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,E.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$7nc=P}),define(ke[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=e.$unc=void 0;let C=class{constructor(l,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(T.$tM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,S){const{message:d,args:r,comment:o}=S;if(this.c)return(0,R.$af)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(l)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,R.$af)(h??d,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let S;const d=await this.g(l);if(!d){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);S=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${d}: ${r.message}`);return}S&&this.d.set(l.identifier.value,{contents:S,uri:d})}async g(l){if(l.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(S)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$unc=C,e.$unc=C=He([Ve(0,$.$bP),Ve(1,c.$XO),Ve(2,A.$7j)],C),e.$vnc=(0,O.$Ai)("IExtHostLocalizationService")}),define(ke[257],Ie([1,0,12,5,27,17,2,49]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;let $=class extends E.$fk{constructor(w,l){super(l.logLevel,l.logsLocation,l.loggers.map(S=>(0,T.$0h)(S))),this.r=w.getProxy(R.$tM.MainThreadLogger)}$setLogLevel(w,l){l?this.setLogLevel(A.URI.revive(l),w):this.setLogLevel(w)}setVisibility(w,l){super.setVisibility(w,l),this.r.$setVisibility(w,l)}s(w,l,S){return new c(this.r,w,l,S)}};e.$Ioc=$,e.$Ioc=$=He([Ve(0,O.$XO),Ve(1,P.$bP)],$);class c extends E.$ak{constructor(w,l,S,d){super(d?.logLevel==="always"),this.r=w,this.s=l,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(l,d).then(()=>{this.u(this.n),this.m=!0})}g(w,l){const S=[[w,l]];this.m?this.u(S):this.n.push(...S)}u(w){this.r.$log(this.s,w)}flush(){this.r.$flush(this.s)}}}),define(ke[87],Ie([1,0,5,3,6,17,23]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0,e.$wnc=(0,R.$Ai)("IExtHostManagedSockets");let T=class{constructor(w){this.b=0,this.c=null,this.d=new Map,this.a=w.getProxy(E.$tM.MainThreadManagedSockets)}setFactory(w,l){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(w,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(w){if(!this.c||this.c.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const l=++this.b,S=await this.c.makeConnection(),d=new P.$Tc;return this.d.set(l,new c(l,S,d)),d.add((0,P.$Sc)(()=>this.d.delete(l))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),d.dispose()})),d.add(S.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),d.dispose()})),d.add(S.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,A.$Je.wrap(r)))),l}$remoteSocketWrite(w,l){this.d.get(w)?.actual.send(l.buffer)}$remoteSocketEnd(w){const l=this.d.get(w);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(w){await this.d.get(w)?.actual.drain?.()}};e.$xnc=T,e.$xnc=T=He([Ve(0,O.$XO)],T);class ${constructor(w,l){this.socketFactoryId=w,this.makeConnection=l}}class c extends P.$Uc{constructor(w,l,S){super(),this.socketId=w,this.actual=l,this.B(S)}}}),define(ke[258],Ie([1,0,5,12,25]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;function O(T){return T&&T.title}let A=class{constructor($,c){this.b=c,this.a=$.getProxy(E.$tM.MainThreadMessageService)}showMessage($,c,C,w,l){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof w=="string"||O(w)?d=[w,...l]:(S.modal=w?.modal,S.useCustom=w?.useCustom,S.detail=w?.detail,d=l),S.useCustom&&(0,P.$TG)($,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:t,isCloseAffordance:s}=h;r.push({title:t,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,C,S,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$9nc=A,e.$9nc=A=He([Ve(1,R.$7j)],A)}),define(ke[259],Ie([1,0,6,15,2,25,5]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;class T{constructor(c){this.b=new Map,this.a=c.getProxy(A.$tM.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,C,w){if((0,O.$TG)(c,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,w),this.a.$registerProfileContentHandler(C,w.name,w.description,c.identifier.value),(0,E.$Sc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(c,C,w,l){const S=this.b.get(c);if(!S)throw new Error(`Unknown handler with id: ${c}`);return S.saveProfile(C,w,l)}async $readProfile(c,C,w){const l=this.b.get(c);if(!l)throw new Error(`Unknown handler with id: ${c}`);return l.readProfile((0,R.$ag)(C)?C:P.URI.revive(C),w)}}e.$foc=T}),define(ke[88],Ie([1,0,5,4,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0;class O{constructor(T){this.b=new R.$he,this.onDidChangePassword=this.b.event,this.a=T.getProxy(E.$tM.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,c){return this.a.$setPassword(T,$,c)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$rnc=O,e.$snc=(0,P.$Ai)("IExtHostSecretState")}),define(ke[260],Ie([1,0,22,6,5]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$tM.MainThreadSpeech)}async $createSpeechToTextSession(T,$,c){const C=this.c.get(T);if(!C)return;const w=new R.$Tc,l=new E.$se;this.d.set($,l);const S=await C.provideSpeechToTextSession(l.token,c?{language:c}:void 0);S&&(w.add(S.onDidChange(d=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),w.add(l.token.onCancellationRequested(()=>w.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,c){const C=this.c.get(T);if(!C)return;const w=new R.$Tc,l=new E.$se;this.d.set($,l);const S=await C.provideTextToSpeechSession(l.token,c?{language:c}:void 0);S&&(this.f.set($,S),w.add(S.onDidChange(d=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),w.add(l.token.onCancellationRequested(()=>w.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const c=this.c.get(T);if(!c)return;const C=new R.$Tc,w=new E.$se;this.d.set($,w);const l=await c.provideKeywordRecognitionSession(w.token);l&&(C.add(l.onDidChange(S=>{w.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),C.add(w.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,c){const C=O.a++;return this.c.set(C,c),this.b.$registerProvider(C,$,{extension:T,displayName:T.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$moc=O}),define(ke[89],Ie([1,0,5,4,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=e.$hnc=void 0;class O{constructor(T,$){this.c=$,this.b=new R.$he,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(E.$tM.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,c){const C=await this.a.$initializeExtensionStorage(T,$);let w;return C&&(w=this.d(T,$,C)),w||c}setValue(T,$,c){return this.a.$setValue(T,$,c)}$acceptValue(T,$,c){const C=this.d(T,$,c);C&&this.b.fire({shared:T,key:$,value:C})}d(T,$,c){try{return JSON.parse(c)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${C}`)}}}e.$hnc=O,e.$inc=(0,P.$Ai)("IExtHostStorage")}),define(ke[261],Ie([1,0,6,16,2,5]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$tM.MainThreadUriOpeners)}registerExternalUriOpener($,c,C,w){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const l=w.schemes.find(S=>!A.a.has(S));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(c,C),this.b.$registerUriOpener(c,w.schemes,$,w.label),(0,E.$Sc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri($,c,C){const w=this.c.get($);if(!w)throw new Error(`Unknown opener with id: ${$}`);const l=P.URI.revive(c);return w.canOpenExternalUri(l,C)}async $openUri($,c,C){const w=this.c.get($);if(!w)throw new Error(`Unknown opener id: '${$}'`);return w.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},C)}}e.$Coc=A}),define(ke[262],Ie([1,0,5,2,6,14,19]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;class T{static{this.a=0}constructor(c){this.c=new A.$Xm,this.d=new Map,this.b=c.getProxy(E.$tM.MainThreadUrls)}registerUriHandler(c,C){const w=c.identifier;if(this.c.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const l=T.a++;return this.c.add(w),this.d.set(l,C),this.b.$registerUriHandler(l,w,c.displayName||c.name),(0,P.$Sc)(()=>{this.c.delete(w),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(c,C){const w=this.d.get(c);if(!w)return Promise.resolve(void 0);try{w.handleUri(R.URI.revive(C))}catch(l){(0,O.$1)(l)}return Promise.resolve(void 0)}async createAppUri(c){return R.URI.revive(await this.b.$createAppUri(c))}}e.$Doc=T}),define(ke[263],Ie([1,0,23,5]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrb=O,e.$Wrb=T;class P{constructor(){this.buffers=[]}add(c){let C=this.buffers.indexOf(c);return C<0&&(C=this.buffers.length,this.buffers.push(c)),C}}function O($,c){if(c.serializeBuffersForPostMessage){const C=new P,l=JSON.stringify($,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:C.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),S=C.buffers.map(d=>{const r=new Uint8Array(d);return E.$Je.wrap(r)});return{message:l,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return R.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return R.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return R.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return R.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return R.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return R.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return R.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return R.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return R.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return R.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return R.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,c){const C=c.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),w=c.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=C[o];if(r.view)switch(r.view.type){case R.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse($,w),arrayBuffers:C}}}),define(ke[67],Ie([1,0,4,6,16,26,2,206,263,83,5]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$5mc=void 0,e.$6mc=l,e.$8mc=r,e.$9mc=o;class w{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,n,i,g,f,u,b){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new E.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$he,this._onDidDispose=this.#h.event,this.#e=s,this.#t=n,this.#o=i,this.#n=g,this.#s=f,this.#r=u,this.#u=l(u),this.#d=S(u),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$xBb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let n=s.toString();return n.endsWith("/")||(n+="/"),n+" "+c.$wBb}return c.$wBb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),O.$ao(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const n=(0,$.$Vrb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,n.message,...n.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const n=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,u,b,I,D)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(I)}),p=(0,c.$xBb)(y,{isRemote:n,authority:i}).toString();return`${f}${p}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,u,b,I,D)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(I)}),p=(0,c.$xBb)(y,{isRemote:n,authority:i}).toString();return`${f}${p}${D}`})}}e.$5mc=w;function l(t){try{const s=(0,T.$Qp)((0,T.$Pp)(t.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function S(t){try{const s=(0,T.$Qp)((0,T.$Pp)(t.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends R.$Uc{constructor(s,n,i,g,f){super(),this.c=n,this.f=i,this.g=g,this.h=f,this.b=new Map,this.a=s.getProxy(C.$tM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,n,i){const g=this.j(s);if(g){const{message:f}=(0,$.$Wrb)(n,i.value);g._onMessageEmitter.fire(f)}}$onMissingCsp(s,n){this.g.warn(`${n} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,n,i){const g=new w(s,this.a,a(n),this.c,this.f,i,this.h);this.b.set(s,g);const f=g._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return g}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$7mc=d;function r(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,s,n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots||h(t,s)}}function a(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(s=>A.URI.from(s))}}function h(t,s){return[...(s?.getWorkspaceFolders()||[]).map(n=>n.uri),t.extensionLocation]}}),define(ke[119],Ie([1,0,4,16,13,2,3,17,5]),function(de,e,E,R,P,O,A,T,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=e.$Foc=void 0;let C=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new E.$he,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=l.getProxy($.$tM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,S){S!==this.d[l]&&(this.d={...this.d,[l]:S},this.c.fire(this.d))}openUri(l,S){let d;if(typeof l=="string"){d=l;try{l=O.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,P.$$e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,d,S)}async asExternalUri(l,S){if((0,P.$$e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(l,S);return O.URI.from(d)}};e.$Foc=C,e.$Foc=C=c=He([Ve(0,T.$XO)],C),e.$Goc=(0,A.$Ai)("IExtHostWindow")}),define(ke[264],Ie([1,0,253,27,17]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0;let O=class extends E.$Joc{constructor(T,$){super(T,$)}f(T,$,c){$.apply(console,c)}};e.$Tqc=O,e.$Tqc=O=He([Ve(0,P.$XO),Ve(1,R.$bP)],O)}),define(ke[265],Ie([1,0,11,23,22,28,14,4,6,37,159,251,38]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.ResponsiveState=e.RequestInitiator=void 0,e.$0ac=h,e.$$ac=t;function d(F,M){try{return JSON.stringify(F,M)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(M,G){this.jsonString=M,this.referencedBuffers=G}}function h(F,M=null,G=!1){const q=[];return{jsonString:(G?d:JSON.stringify)(F,(N,L)=>{if(typeof L>"u")return o;if(typeof L=="object"){if(L instanceof R.$Je){const Z=q.push(L)-1;return{[r]:Z}}if(M)return M(N,L)}return L}),referencedBuffers:q}}function t(F,M,G){return JSON.parse(F,(q,V)=>{if(V){const N=V[r];if(typeof N=="number")return M[N];if(G&&V.$mid===c.MarshalledId.Uri)return G.transformIncoming(V)}return V})}function s(F,M){return JSON.stringify(F,M)}function n(F){return F?(M,G)=>G&&G.$mid===c.MarshalledId.Uri?F.transformOutgoing(G):G:null}var i;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var g;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const f=()=>{},u=Symbol.for("rpcProtocol"),b=Symbol.for("rpcProxy");class I extends $.$Uc{static{S=u}static{this.a=3*1e3}constructor(M,G=null,q=null){super(),this[S]=!0,this.b=this.B(new T.$he),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=G,this.g=q,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,N=l.$Hw.count;V<N;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=g.Responsive,this.z=0,this.C=0,this.D=this.B(new E.$Mh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const G=this.w[M];delete this.w[M],G.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(g.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(g.Unresponsive):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,C.$Gn)(M,this.g):M}getProxy(M){const{nid:G,sid:q}=M;return this.s[G]||(this.s[G]=this.J(G,q)),this.s[G]}J(M,G){const q={get:(V,N)=>(typeof N=="string"&&!V[N]&&N.charCodeAt(0)===O.CharCode.DollarSign&&(V[N]=(...L)=>this.U(M,N,L)),N===b?G:V[N])};return new Proxy(Object.create(null),q)}set(M,G){return this.m[M.nid]=G,G}assertRegistered(M){for(let G=0,q=M.length;G<q;G++){const V=M[G];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(M){if(this.j)return;const G=M.byteLength,q=y.read(M,0),V=q.readUInt8(),N=q.readUInt32();switch(V){case m.RequestJSONArgs:case m.RequestJSONArgsWithCancellation:{let{rpcId:L,method:Z,args:re}=k.deserializeRequestJSONArgs(q);this.g&&(re=(0,C.$Gn)(re,this.g)),this.M(G,N,L,Z,re,V===m.RequestJSONArgsWithCancellation);break}case m.RequestMixedArgs:case m.RequestMixedArgsWithCancellation:{let{rpcId:L,method:Z,args:re}=k.deserializeRequestMixedArgs(q);this.g&&(re=(0,C.$Gn)(re,this.g)),this.M(G,N,L,Z,re,V===m.RequestMixedArgsWithCancellation);break}case m.Acknowledged:{this.f?.logIncoming(G,N,i.LocalSide,"ack"),this.G(N);break}case m.Cancel:{this.N(G,N);break}case m.ReplyOKEmpty:{this.O(G,N,void 0);break}case m.ReplyOKJSON:{let L=k.deserializeReplyOKJSON(q);this.g&&(L=(0,C.$Gn)(L,this.g)),this.O(G,N,L);break}case m.ReplyOKJSONWithBuffers:{const L=k.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(G,N,L);break}case m.ReplyOKVSBuffer:{const L=k.deserializeReplyOKVSBuffer(q);this.O(G,N,L);break}case m.ReplyErrError:{let L=k.deserializeReplyErrError(q);this.g&&(L=(0,C.$Gn)(L,this.g)),this.P(G,N,L);break}case m.ReplyErrEmpty:{this.P(G,N,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,G,q,V,N,L){this.f?.logIncoming(M,G,i.OtherSide,`receiveRequest ${(0,l.$Jw)(q)}.${V}(`,N);const Z=String(G);let re,fe;if(L){const oe=new P.$se;N.push(oe.token),re=this.Q(q,V,N),fe=()=>oe.cancel()}else re=this.Q(q,V,N),fe=f;this.u[Z]=fe;const be=k.serializeAcknowledged(G);this.f?.logOutgoing(be.byteLength,G,i.OtherSide,"ack"),this.c.send(be),re.then(oe=>{delete this.u[Z];const pe=k.serializeReplyOK(G,oe,this.h);this.f?.logOutgoing(pe.byteLength,G,i.OtherSide,"reply:",oe),this.c.send(pe)},oe=>{delete this.u[Z];const pe=k.serializeReplyErr(G,oe);this.f?.logOutgoing(pe.byteLength,G,i.OtherSide,"replyErr:",oe),this.c.send(pe)})}N(M,G){this.f?.logIncoming(M,G,i.OtherSide,"receiveCancel");const q=String(G);this.u[q]?.()}O(M,G,q){this.f?.logIncoming(M,G,i.LocalSide,"receiveReply:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V],N.resolveOk(q)}P(M,G,q){this.f?.logIncoming(M,G,i.LocalSide,"receiveReplyErr:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V];let L;q&&(q.$isError?(L=new Error,L.name=q.name,L.message=q.message,L.stack=q.stack):L=q),N.resolveErr(L)}Q(M,G,q){try{return Promise.resolve(this.S(M,G,q))}catch(V){return Promise.reject(V)}}S(M,G,q){const V=this.m[M];if(!V)throw new Error("Unknown actor "+(0,l.$Jw)(M));const N=V[G];if(typeof N!="function")throw new Error("Unknown method "+G+" on actor "+(0,l.$Jw)(M));return N.apply(V,q)}U(M,G,q){if(this.j)return new w.$9ac;let V=null;if(q.length>0&&P.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(A.$6());const N=k.serializeRequestArguments(q,this.h),L=++this.t,Z=String(L),re=new w.$8ac,fe=new $.$Tc;V&&fe.add(V.onCancellationRequested(()=>{const oe=k.serializeCancel(L);this.f?.logOutgoing(oe.byteLength,L,i.LocalSide,"cancel"),this.c.send(k.serializeCancel(L))})),this.w[Z]=new D(re,fe),this.F(L);const be=k.serializeRequest(L,M,G,N,!!V);return this.f?.logOutgoing(be.byteLength,L,i.LocalSide,`request: ${(0,l.$Jw)(M)}.${G}(`,q),this.c.send(be),re}}e.$_ac=I;class D{constructor(M,G){this.a=M,this.b=G}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class y{static alloc(M,G,q){const V=new y(R.$Je.alloc(q+1+4),0);return V.writeUInt8(M),V.writeUInt32(G),V}static read(M,G){return new y(M,G)}get buffer(){return this.a}constructor(M,G){this.a=M,this.b=G}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+M).toString();return this.b+=M,q}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+M).toString();return this.b+=M,q}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+M);return this.b+=M,G}static sizeMixedArray(M){let G=0;G+=1;for(let q=0,V=M.length;q<V;q++){const N=M[q];switch(G+=1,N.type){case v.String:G+=this.sizeLongString(N.value);break;case v.VSBuffer:G+=this.sizeVSBuffer(N.value);break;case v.SerializedObjectWithBuffers:G+=this.sizeUInt32,G+=this.sizeLongString(N.value);for(let L=0;L<N.buffers.length;++L)G+=this.sizeVSBuffer(N.buffers[L]);break;case v.Undefined:break}}return G}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let G=0,q=M.length;G<q;G++){const V=M[G];switch(V.type){case v.String:this.writeUInt8(v.String),this.writeLongString(V.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(V.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let N=0;N<V.buffers.length;++N)this.writeBuffer(V.buffers[N]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const G=new Array(M);for(let q=0;q<M;q++)switch(this.readUInt8()){case v.String:G[q]=this.readLongString();break;case v.VSBuffer:G[q]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const N=this.readUInt32(),L=this.readLongString(),Z=[];for(let re=0;re<N;++re)Z.push(this.readVSBuffer());G[q]=new l.$Kw(t(L,Z,null));break}case v.Undefined:G[q]=void 0;break}return G}}var p;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(p||(p={}));class k{static a(M){for(let G=0,q=M.length;G<q;G++)if(M[G]instanceof R.$Je||M[G]instanceof l.$Kw||typeof M[G]>"u")return!0;return!1}static serializeRequestArguments(M,G){if(this.a(M)){const q=[];for(let V=0,N=M.length;V<N;V++){const L=M[V];if(L instanceof R.$Je)q[V]={type:v.VSBuffer,value:L};else if(typeof L>"u")q[V]={type:v.Undefined};else if(L instanceof l.$Kw){const{jsonString:Z,referencedBuffers:re}=h(L.value,G);q[V]={type:v.SerializedObjectWithBuffers,value:R.$Je.fromString(Z),buffers:re}}else q[V]={type:v.String,value:R.$Je.fromString(s(L,G))}}return{type:p.Mixed,args:q}}return{type:p.Simple,args:s(M,G)}}static serializeRequest(M,G,q,V,N){switch(V.type){case p.Simple:return this.b(M,G,q,V.args,N);case p.Mixed:return this.c(M,G,q,V.args,N)}}static b(M,G,q,V,N){const L=R.$Je.fromString(q),Z=R.$Je.fromString(V);let re=0;re+=y.sizeUInt8(),re+=y.sizeShortString(L),re+=y.sizeLongString(Z);const fe=y.alloc(N?m.RequestJSONArgsWithCancellation:m.RequestJSONArgs,M,re);return fe.writeUInt8(G),fe.writeShortString(L),fe.writeLongString(Z),fe.buffer}static deserializeRequestJSONArgs(M){const G=M.readUInt8(),q=M.readShortString(),V=M.readLongString();return{rpcId:G,method:q,args:JSON.parse(V)}}static c(M,G,q,V,N){const L=R.$Je.fromString(q);let Z=0;Z+=y.sizeUInt8(),Z+=y.sizeShortString(L),Z+=y.sizeMixedArray(V);const re=y.alloc(N?m.RequestMixedArgsWithCancellation:m.RequestMixedArgs,M,Z);return re.writeUInt8(G),re.writeShortString(L),re.writeMixedArray(V),re.buffer}static deserializeRequestMixedArgs(M){const G=M.readUInt8(),q=M.readShortString(),V=M.readMixedArray(),N=new Array(V.length);for(let L=0,Z=V.length;L<Z;L++){const re=V[L];typeof re=="string"?N[L]=JSON.parse(re):N[L]=re}return{rpcId:G,method:q,args:N}}static serializeAcknowledged(M){return y.alloc(m.Acknowledged,M,0).buffer}static serializeCancel(M){return y.alloc(m.Cancel,M,0).buffer}static serializeReplyOK(M,G,q){if(typeof G>"u")return this.d(M);if(G instanceof R.$Je)return this.e(M,G);if(G instanceof l.$Kw){const{jsonString:V,referencedBuffers:N}=h(G.value,q,!0);return this.g(M,V,N)}else return this.f(M,d(G,q))}static d(M){return y.alloc(m.ReplyOKEmpty,M,0).buffer}static e(M,G){let q=0;q+=y.sizeVSBuffer(G);const V=y.alloc(m.ReplyOKVSBuffer,M,q);return V.writeVSBuffer(G),V.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,G){const q=R.$Je.fromString(G);let V=0;V+=y.sizeLongString(q);const N=y.alloc(m.ReplyOKJSON,M,V);return N.writeLongString(q),N.buffer}static g(M,G,q){const V=R.$Je.fromString(G);let N=0;N+=y.sizeUInt32,N+=y.sizeLongString(V);for(const Z of q)N+=y.sizeVSBuffer(Z);const L=y.alloc(m.ReplyOKJSONWithBuffers,M,N);L.writeUInt32(q.length),L.writeLongString(V);for(const Z of q)L.writeBuffer(Z);return L.buffer}static deserializeReplyOKJSON(M){const G=M.readLongString();return JSON.parse(G)}static deserializeReplyOKJSONWithBuffers(M,G){const q=M.readUInt32(),V=M.readLongString(),N=[];for(let L=0;L<q;++L)N.push(M.readVSBuffer());return new l.$Kw(t(V,N,G))}static serializeReplyErr(M,G){const q=G?d(A.$3(G),null):void 0;if(typeof q!="string")return this.h(M);const V=R.$Je.fromString(q);let N=0;N+=y.sizeLongString(V);const L=y.alloc(m.ReplyErrError,M,N);return L.writeLongString(V),L.buffer}static deserializeReplyErrError(M){const G=M.readLongString();return JSON.parse(G)}static h(M){return y.alloc(m.ReplyErrEmpty,M,0).buffer}}var m;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[266],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=void 0;const E=function(O){const A=T=>{globalThis.removeEventListener("message",A);const $=T.data;Object.defineProperties(globalThis,{postMessage:{value(c,C){$.postMessage(c,C)}},onmessage:{get(){return $.onmessage},set(c){$.onmessage=c}}}),$.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${E})('${A}'))`,c=new Blob([$],{type:"application/javascript"}),C=URL.createObjectURL(c),w=new MessageChannel,l=C,S={type:"_newWorker",id:l,port:w.port2,url:C,options:T};O(S,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{O({type:"_terminateWorker",id:l}),URL.revokeObjectURL(C),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(d){w.port1.onmessage=d}},onmessageerror:{get(){return w.port1.onmessageerror},set(d){w.port1.onmessageerror=d}}}),w.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),w.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),w.port1.start()}}e.$Vqc=R}),define(ke[267],Ie([1,0,23,29,16,60,3]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$7J=void 0,e.$8J=C,e.$9J=w,e.$7J=(0,A.$Ai)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),c=7;function C(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const r=parseInt(S.fragment.substring(0,d).replace($,""),c),o=(0,E.$3e)(S.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:S.with({scheme:o,fragment:null})}}function w(S,d){const r=d.toString(c),a=`${r.length<T.length?T[r.length-1]:"z"}${r}s${(0,E.$4e)(E.$Je.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class l{constructor(){this.a=new R.$Ac}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=C(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$0J=l,(0,O.$Fs)(e.$7J,l,O.InstantiationType.Delayed)}),define(ke[90],Ie([1,0,23,41,40,73,16,20,21,32,267]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=e.CellStatusbarAlignment=e.$nK=e.NotebookEditorPriority=e.$kK=e.$jK=e.$hK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gK=e.$fK=e.$eK=e.$dK=e.CellKind=e.$cK=e.$bK=e.$aK=void 0,e.$iK=g,e.$lK=u,e.$mK=b,e.$pK=y,e.$qK=k,e.$aK="workbench.editor.notebook",e.$bK="workbench.editor.notebookTextDiffEditor",e.$cK="workbench.editor.interactive";var w;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(w||(e.CellKind=w={})),e.$dK=["application/json","application/javascript","text/html","image/svg+xml",O.$Ys.latex,O.$Ys.markdown,"image/png","image/jpeg",O.$Ys.text],e.$eK=[O.$Ys.latex,O.$Ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ys.text],e.$fK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gK="_notAvailable";var l;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var S;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var t;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var s;(function(L){L.scheme=A.Schemas.vscodeNotebookCell;function Z($e,se){return(0,C.$9J)($e,se)}L.generate=Z;function re($e){return(0,C.$8J)($e)}L.parse=re;function fe($e,se){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}L.generateCellOutputUri=fe;function be($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!se)return;const Ce=se[1]&&se[1]!==""?se[1]:void 0,Fe=se[2];return{outputId:Ce,notebook:$e.with({scheme:Fe||A.Schemas.file,fragment:null})}}L.parseCellOutputUri=be;function oe($e,se,Ce){return L.generate($e,se).with({scheme:Ce})}L.generateCellPropertyUri=oe;function pe($e,se){if($e.scheme===se)return L.parse($e.with({scheme:L.scheme}))}L.parseCellPropertyUri=pe})(s||(e.CellUri=s={}));const n=L=>$.$i?L.replace(/\//g,"\\"):L;class i{constructor(Z=[],re=e.$dK){this.e=re,this.d=[...new Set(Z)].map(fe=>({pattern:fe,matches:R.$uk(n(fe))}))}sort(Z){const re=new Map(P.Iterable.map(Z,be=>[be,n(be)]));let fe=[];for(const{matches:be}of this.d)for(const[oe,pe]of re)if(be(pe)){fe.push(oe),re.delete(oe);break}return re.size&&(fe=fe.concat([...re.keys()].sort((be,oe)=>this.e.indexOf(be)-this.e.indexOf(oe)))),fe}prioritize(Z,re){const fe=this.f(Z);if(fe===-1){this.d.unshift({pattern:Z,matches:R.$uk(n(Z))});return}const be=new Set(re.map(pe=>this.f(pe,fe)));be.delete(-1);const oe=Array.from(be).sort();this.d.splice(fe+1,0,...oe.map(pe=>this.d[pe]));for(let pe=oe.length-1;pe>=0;pe--)this.d.splice(oe[pe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,re=this.d.length){const fe=n(Z);for(let be=0;be<re;be++)if(this.d[be].matches(fe))return be;return-1}}e.$hK=i;function g(L,Z,re,fe=(be,oe)=>be===oe){const be=[];function oe(se,Ce,Fe){if(Ce===0&&Fe.length===0)return;const Y=be[be.length-1];Y&&Y.start+Y.deleteCount===se?(Y.deleteCount+=Ce,Y.toInsert.push(...Fe)):be.push({start:se,deleteCount:Ce,toInsert:Fe})}let pe=0,$e=0;for(;;){if(pe===L.length){oe(pe,0,Z.slice($e));break}if($e===Z.length){oe(pe,L.length-pe,[]);break}const se=L[pe],Ce=Z[$e];if(fe(se,Ce)){pe+=1,$e+=1;continue}re(Ce)?(oe(pe,1,[]),pe+=1):(oe(pe,0,[Ce]),$e+=1)}return be}e.$jK=new c.$Rj("notebookEditorCursorAtBoundary","none"),e.$kK=new c.$Rj("notebookEditorCursorAtLineBoundary","none");var f;(function(L){L.default="default",L.option="option"})(f||(e.NotebookEditorPriority=f={}));function u(L){const Z=L;return!!((typeof Z.include=="string"||R.$vk(Z.include))&&(typeof Z.exclude=="string"||R.$vk(Z.exclude)))}function b(L,Z,re){if(Array.isArray(L.viewType)&&L.viewType.indexOf(Z)>=0||L.viewType===Z)return!0;if(L.filenamePattern){const fe=u(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,be=u(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(R.$tk(fe,(0,T.$nc)(re.fsPath).toLowerCase()))return!(be&&R.$tk(be,(0,T.$nc)(re.fsPath).toLowerCase()))}return!1}e.$nK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(Z){return`${D.d}${Z}`}static parse(Z){if(Z.startsWith(D.d))return Z.substring(D.d.length)}}e.$oK=D;function y(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}const p=new TextDecoder;function k(L){const Z=[];let re=!1;for(const pe of L)(Z.length===0||re)&&(Z.push(pe),re=!0);let fe=F(Z);const be=E.$Je.concat(Z.map(pe=>E.$Je.wrap(pe))),oe=N(be);return fe=fe||oe.byteLength!==be.byteLength,{data:oe,didCompression:fe}}e.$rK="\x1B[A";const m=e.$rK.split("").map(L=>L.charCodeAt(0)),v=10;function F(L){let Z=!1;return L.forEach((re,fe)=>{if(fe===0||re.length<e.$rK.length)return;const be=L[fe-1],oe=re.subarray(0,e.$rK.length);if(oe[0]===m[0]&&oe[1]===m[1]&&oe[2]===m[2]){const pe=be.lastIndexOf(v);if(pe===-1)return;Z=!0,L[fe-1]=be.subarray(0,pe),L[fe]=re.subarray(e.$rK.length)}}),Z}function M(L){let Z=L;do L=Z,Z=L.replace(/[^\n]\x08/gm,"");while(Z.length<L.length);return L}function G(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const Z=L.match(/^(.*)\r+/m)[1];let re=L.match(/\r+(.*)$/m)[1];re=re+Z.slice(re.length,Z.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return L}const q=8,V=13;function N(L){return!L.buffer.includes(q)&&!L.buffer.includes(V)?L:E.$Je.fromString(G(M(p.decode(L.buffer))))}}),define(ke[7],Ie([1,0,18,14,59,29,73,13,15,2,36,19,30,108,90]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d){"use strict";var r,o,a,h,t,s,n,i,g,f,u,b,I,D,y,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$LO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$rO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eO=e.$dO=e.$cO=e.$bO=e.$_N=e.$$N=e.$0N=e.$9N=e.TestRunProfileKind=e.TestResultState=e.$8N=e.$7N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6N=e.NotebookVariablesRequestKind=e.$5N=e.$4N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.ColorThemeKind=e.$WN=e.$VN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UN=e.$TN=e.DebugConsoleMode=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$NN=e.$MN=e.FileChangeType=e.$LN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$KN=e.$JN=e.$IN=e.$HN=e.InlineCompletionTriggerKind=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$uN=e.ConfigurationTarget=e.$tN=e.$sN=e.$rN=e.$qN=e.DocumentPasteTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$jN=e.ViewBadge=e.ProgressLocation=e.$iN=e.$hN=e.TaskScope=e.ShellQuoting=e.$gN=e.$fN=e.$eN=e.TaskPanelKind=e.TaskRevealKind=e.$dN=e.TerminalLocation=e.$cN=e.$bN=e.$aN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$_M=e.$$M=e.$0M=e.$9M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$7M=e.$6M=e.$5M=e.$4M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$3M=e.$2M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.LanguageStatusSeverity=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.CodeActionTriggerKind=e.$PM=e.$OM=e.SymbolTag=e.SymbolKind=e.$NM=e.$MM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.DiagnosticSeverity=e.DiagnosticTag=e.$GM=e.$FM=e.FileEditType=e.$EM=e.$DM=e.$CM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$8M=ct,e.$vN=Ri,e.$aO=En;function m(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(B,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[Se,...Je]=ne;return Reflect.construct(B,Je,Se.constructor)}}})}var v;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let M=r=class{static from(...z){let ne=z;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$vM=M,e.$vM=M=r=He([m],M);let G=o=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,R.$7)("line must be non-negative");if(ne<0)throw(0,R.$7)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,R.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new o(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,R.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new o(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$wM=G,e.$wM=G=o=He([m],G);let q=a=class{static isRange(z){return z instanceof a?!0:z?G.isPosition(z.start)&&G.isPosition(z.end):!1}static of(z){if(z instanceof a)return z;if(this.isRange(z))return new a(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,Je){let et,ht;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new G(z,ne),ht=new G(Se,Je)):G.isPosition(z)&&G.isPosition(ne)&&(et=G.of(z),ht=G.of(ne)),!et||!ht)throw new Error("Invalid arguments");et.isBefore(ht)?(this.c=et,this.e=ht):(this.c=ht,this.e=et)}contains(z){return a.isRange(z)?this.contains(z.start)&&this.contains(z.end):G.isPosition(z)?!(G.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=G.Max(z.start,this.c),Se=G.Min(z.end,this.e);if(!ne.isAfter(Se))return new a(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=G.Min(z.start,this.c),Se=G.Max(z.end,this.end);return new a(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,R.$7)();let Se;return z?G.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new a(Se,ne)}toJSON(){return[this.start,this.end]}};e.$xM=q,e.$xM=q=a=He([m],q);let V=h=class extends q{static isSelection(z){return z instanceof h?!0:z?q.isRange(z)&&G.isPosition(z.anchor)&&G.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,Je){let et,ht;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new G(z,ne),ht=new G(Se,Je)):G.isPosition(z)&&G.isPosition(ne)&&(et=G.of(z),ht=G.of(ne)),!et||!ht)throw new Error("Invalid arguments");super(et,ht),this.f=et,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$yM=V,e.$yM=V=h=He([m],V);const N=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,R.$7)("connectionToken")};class L{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,R.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.$7)("port");typeof Se<"u"&&N(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$zM=L;class Z{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&N(ne)}}e.$AM=Z;class re extends Error{static NotAvailable(z,ne){return new re(z,S.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new re(z,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,re.prototype)}}e.$BM=re;var fe;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var be;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(be||(e.EnvironmentVariableMutatorType=be={}));let oe=t=class{static isTextEdit(z){return z instanceof t?!0:z?q.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new t(z,ne)}static insert(z,ne){return t.replace(new q(z,z),ne)}static delete(z){return t.replace(z,"")}static setEndOfLine(z){const ne=new t(new q(new G(0,0),new G(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!q.isRange(z))throw(0,R.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,R.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,R.$7)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$CM=oe,e.$CM=oe=t=He([m],oe);let pe=s=class{static isNotebookCellEdit(z){return z instanceof s?!0:z?bi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new s(z,ne)}static insertCells(z,ne){return new s(new bi(z,z),ne)}static deleteCells(z){return new s(z,[])}static updateCellMetadata(z,ne){const Se=new s(new bi(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new s(new bi(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$DM=pe,e.$DM=pe=s=He([m],pe);class $e{static isSnippetTextEdit(z){return z instanceof $e?!0:z?q.isRange(z.range)&&Fe.isSnippetString(z.snippet):!1}static replace(z,ne){return new $e(z,ne)}static insert(z,ne){return $e.replace(new q(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$EM=$e;var se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,Je){this.c.push({_type:se.File,from:z,to:ne,options:Se,metadata:Je})}createFile(z,ne,Se){this.c.push({_type:se.File,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:se.File,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:se.Cell,metadata:Se,uri:z,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,Je){const et=ne.start,ht=ne.end;(et!==ht||Se.length>0)&&this.c.push({_type:se.CellReplace,uri:z,index:et,count:ht-et,cells:Se,metadata:Je})}g(z,ne,Se,Je){this.c.push({_type:se.Cell,metadata:Je,uri:z,edit:{editType:d.CellEditType.Metadata,index:ne,metadata:Se}})}replace(z,ne,Se,Je){this.c.push({_type:se.Text,uri:z,edit:new oe(ne,Se),metadata:Je})}insert(z,ne,Se,Je){this.replace(z,new q(ne,ne),Se,Je)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===se.Text&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,et;Array.isArray(Se)?(Je=Se[0],et=Se[1]):Je=Se,pe.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,et):this.f(z,Je.range,Je.newCells,et):$e.isSnippetTextEdit(Je)?this.c.push({_type:se.Snippet,uri:z,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:se.Text,uri:z,edit:Je,metadata:et})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case se.Text:case se.Snippet:case se.Cell:case se.CellReplace:Je.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,E.$Ib)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===se.Text&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new O.$Ac;for(const ne of this.c)if(ne._type===se.Text){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$FM=Ce,e.$FM=Ce=He([m],Ce);let Fe=n=class{static isSnippetString(z){return z instanceof n?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=n.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new n;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=n.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new n;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$GM=Fe,e.$GM=Fe=n=He([m],Fe);var Y;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var W;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let ie=i=class{static isLocation(z){return z instanceof i?!0:z?q.isRange(z.range)&&c.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(q.isRange(ne))this.range=q.of(ne);else if(G.isPosition(ne))this.range=new q(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$HM=ie,e.$HM=ie=i=He([m],ie);let De=class{static is(z){return z?typeof z.message=="string"&&z.location&&q.isRange(z.location.range)&&c.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$IM=De,e.$IM=De=He([m],De);let he=class{constructor(z,ne,Se=W.Error){if(!q.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,E.$ub)(z.tags,ne.tags)&&(0,E.$ub)(z.relatedInformation,ne.relatedInformation,De.isEqual)}};e.$JM=he,e.$JM=he=He([m],he);let ve=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$KM=ve,e.$KM=ve=He([m],ve);let ae=class extends ve{constructor(z,ne,Se,Je){super(z,ne),this.canIncreaseHover=Se,this.canDecreaseHover=Je}};e.$LM=ae,e.$LM=ae=He([m],ae);var X;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let me=class{constructor(z,ne=x.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$MM=me,e.$MM=me=He([m],me);let ge=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$NM=ge,e.$NM=ge=He([m],ge);var Me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var Be;(function(B){B[B.Deprecated=1]="Deprecated"})(Be||(e.SymbolTag=Be={}));let Ee=g=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,Je,et){this.name=z,this.kind=ne,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),Je instanceof ie?this.location=Je:Se instanceof q&&(this.location=new ie(Je,Se)),g.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$OM=Ee,e.$OM=Ee=g=He([m],Ee);let Re=f=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(f.validate)}constructor(z,ne,Se,Je,et){this.name=z,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=et,this.children=[],f.validate(this)}};e.$PM=Re,e.$PM=Re=f=He([m],Re);var Oe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let j=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$QM=j,e.$QM=j=He([m],j);let U=class{static{u=this}static{this.c="."}constructor(z){this.value=z}append(z){return new u(this.value?this.value+u.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+u.c)}};e.$RM=U,e.$RM=U=u=He([m],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let K=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$SM=K,e.$SM=K=He([m],K);class J{constructor(z,ne,Se,Je,et,ht){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ht}}e.$TM=J;class te{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$UM=te;class ue{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$VM=ue;var Ae;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let je=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$WM=je,e.$WM=je=He([m],je);let Ge=b=class{#e;static isMarkdownString(z){return z instanceof b?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){this.#e=new P.$Xk(z,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ne){return this.#e.appendCodeblock(ne??"",z),this}};e.$XM=Ge,e.$XM=Ge=b=He([m],Ge);let Ze=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$YM=Ze,e.$YM=Ze=He([m],Ze);let tt=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$ZM=tt,e.$ZM=tt=He([m],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$1M=_e,e.$1M=_e=He([m],_e);var it;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var nt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let mt=class{constructor(z){this.value=z}};e.$2M=mt,e.$2M=mt=He([m],mt);let ut=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$3M=ut,e.$3M=ut=He([m],ut);var rt;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var at;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(at||(e.CompletionItemKind=at={}));var dt;(function(B){B[B.Deprecated=1]="Deprecated"})(dt||(e.CompletionItemTag=dt={}));let We=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$4M=We,e.$4M=We=He([m],We);let Ue=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$5M=Ue,e.$5M=Ue=He([m],Ue);let _=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$6M=_,e.$6M=_=He([m],_);let H=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$7M=H,e.$7M=H=He([m],H);var ye;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ye||(e.PartialAcceptTriggerKind=ye={}));var Ke;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ke||(e.ViewColumn=Ke={}));var xe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function ct(B,z){return`${w.$Wm.toKey(B)}.${z}`}var gt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Qt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Qt||(e.TextEditorRevealType=Qt={}));var zt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var ui;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ui||(e.TextDocumentChangeReason=ui={}));var xt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(B){function z(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Xe;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Xe||(e.SyntaxTokenType=Xe={})),function(B){function z(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Xe||(e.SyntaxTokenType=Xe={}));let Wt=class{constructor(z,ne){if(ne&&!c.URI.isUri(ne))throw(0,R.$7)("target");if(!q.isRange(z)||z.isEmpty)throw(0,R.$7)("range");this.range=z,this.target=ne}};e.$9M=Wt,e.$9M=Wt=He([m],Wt);let Ut=class{constructor(z,ne,Se,Je){this.red=z,this.green=ne,this.blue=Se,this.alpha=Je}};e.$0M=Ut,e.$0M=Ut=He([m],Ut);let ft=class{constructor(z,ne){if(ne&&!(ne instanceof Ut))throw(0,R.$7)("color");if(!q.isRange(z)||z.isEmpty)throw(0,R.$7)("range");this.range=z,this.color=ne}};e.$$M=ft,e.$$M=ft=He([m],ft);let pt=class{constructor(z){if(!z||typeof z!="string")throw(0,R.$7)("label");this.label=z}};e.$_M=pt,e.$_M=pt=He([m],pt);var _t;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Xt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Xt||(e.SourceControlInputBoxValidationType=Xt={}));var jt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var bt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(bt||(e.TerminalShellExecutionCommandLineConfidence=bt={}));class Ot{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,R.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,R.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$7)("tooltip")}}e.$aN=Ot;class Gt{constructor(z){this.uri=z}}e.$bN=Gt;class Bt{constructor(z){this.terminalCommand=z}}e.$cN=Bt;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ei{constructor(z){if(this.options=z,typeof z!="object")throw(0,R.$7)("options")}}e.$dN=ei;var ti;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var ci;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ci||(e.TaskPanelKind=ci={}));let Dt=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(z){switch(z){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,R.$7)("name");this.c=z}get id(){return this.c}};e.$eN=Dt,e.$eN=Dt=I=He([m],Dt);function Mt(B){let z="";for(let ne=0;ne<B.length;ne++)z+=B[ne].replace(/,/g,",,")+",";return z}let Pt=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,R.$7)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,R.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return Mt(z)}};e.$fN=Pt,e.$fN=Pt=He([m],Pt);let Nt=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,R.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,R.$7)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,R.$7)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,R.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,R.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return Mt(z)}};e.$gN=Nt,e.$gN=Nt=He([m],Nt);var li;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(li||(e.ShellQuoting=li={}));var Vt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class ri{constructor(z){this.c=z}computeId(){return"customExecution"+(0,C.$Wg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$hN=ri;let Lt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ne,Se,Je,et,ht){this.k=!1,this.l=this.definition=z;let wt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Je,wt=et,this.k=!0):ne===Vt.Global||ne===Vt.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,wt=ht):(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,wt=ht),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Pt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof ri?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,C.$Wg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,R.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,R.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(D.g===ne||D.e===ne||D.f===ne||D.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,R.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$iN=Lt,e.$iN=Lt=D=He([m],Lt);var Yt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Yt||(e.ProgressLocation=Yt={}));var si;(function(B){function z(ne){const Se=ne;return(0,$.$eg)(Se.value)?Se.tooltip&&!(0,$.$ag)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(si||(e.ViewBadge=si={}));let Ct=y=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const Je=(0,$.$eg)(Se.checkboxState)?Se.checkboxState:(0,$.$cg)(Se.checkboxState)&&(0,$.$eg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,et=!(0,$.$eg)(Se.checkboxState)&&(0,$.$cg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==$t.Checked&&Je!==$t.Unchecked||et!==void 0&&!(0,$.$ag)(et))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof y)return!0;if(Se.label!==void 0&&!(0,$.$ag)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,$.$ag)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,$.$ag)(Se.iconPath)&&!c.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,$.$ag)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,$.$ag)(Je.light)&&!c.URI.isUri(Je.light)&&!(0,$.$ag)(Je.dark)&&!c.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,$.$ag)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!c.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,$.$ag)(Se.tooltip)&&!(Se.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,$.$ag)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=vt.None){this.collapsibleState=ne,c.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$jN=Ct,e.$jN=Ct=y=He([m],Ct);var vt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var $t;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$kN=qt,e.$kN=qt=He([m],qt);class St extends qt{}e.$lN=St;class oi extends St{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$mN=oi;class Kt{constructor(z,ne,Se,Je){this.name=z,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$nN=Kt;let pi=class{#e=new Map;constructor(z){for(const[ne,Se]of z??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ne){this.#e.set(this.#t(z),[ne])}forEach(z,ne){for(const[Se,Je]of this.#e)for(const et of Je)z.call(ne,et,Se,this)}*[Symbol.iterator](){for(const[z,ne]of this.#e)for(const Se of ne)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$oN=pi,e.$oN=pi=He([m],pi);let di=class{constructor(z,ne,Se){this.insertText=z,this.title=ne,this.kind=Se}};e.$pN=di,e.$pN=di=He([m],di);var ki;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(ki||(e.DocumentPasteTriggerKind=ki={}));class Rt{static{this.c="."}constructor(z){this.value=z}append(...z){return new Rt((this.value?[this.value,...z]:z).join(Rt.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+Rt.c)}}e.$qN=Rt,Rt.Empty=new Rt("");class Pi{constructor(z,ne,Se){this.title=ne,this.insertText=z,this.kind=Se}}e.$rN=Pi;let ai=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$sN=ai,e.$sN=ai=He([m],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let It=class{constructor(z){this.id=z}};e.$tN=It,e.$tN=It=He([m],It);var Ii;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ii||(e.ConfigurationTarget=Ii={}));let vi=class{get base(){return this.c}set base(z){this.c=z,this.e=c.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!c.URI.isUri(z)&&!c.URI.isUri(z.uri)))throw(0,R.$7)("base");if(typeof ne!="string")throw(0,R.$7)("pattern");typeof z=="string"?this.baseUri=c.URI.file(z):c.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$uN=vi,e.$uN=vi=He([m],vi);const $i=new WeakMap;function Ri(B,z){$i.set(B,z)}let fi=class{constructor(z,ne,Se,Je,et){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=$i.get(this)??(0,C.$Wg)()),this.c}};e.$wN=fi,e.$wN=fi=He([m],fi);let we=class extends fi{constructor(z,ne,Se,Je,et,ht){if(super(ne,Se,Je,et,ht),z===null)throw(0,R.$7)("location");this.location=z}};e.$xN=we,e.$xN=we=He([m],we);let Te=class extends fi{constructor(z,ne,Se,Je,et,ht){super(ne,Se,Je,et,ht),this.functionName=z}};e.$yN=Te,e.$yN=Te=He([m],Te);let le=class extends fi{constructor(z,ne,Se,Je,et,ht,wt,Jt){if(super(Je,et,ht,wt,Jt),!ne)throw(0,R.$7)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$zN=le,e.$zN=le=He([m],le);let Q=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$AN=Q,e.$AN=Q=He([m],Q);let Pe=class{constructor(z,ne){this.port=z,this.host=ne}};e.$BN=Pe,e.$BN=Pe=He([m],Pe);let ze=class{constructor(z){this.path=z}};e.$CN=ze,e.$CN=ze=He([m],ze);let Ye=class{constructor(z){this.implementation=z}};e.$DN=Ye,e.$DN=Ye=He([m],Ye);class qe{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}}e.$EN=qe;class lt{constructor(z,ne){this.session=z,this.threadId=ne}}e.$FN=lt;let kt=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$GN=kt,e.$GN=kt=He([m],kt);var Zt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Zt||(e.InlineCompletionTriggerKind=Zt={}));let ii=class{constructor(z,ne){this.range=z,this.text=ne}};e.$HN=ii,e.$HN=ii=He([m],ii);let Ft=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$IN=Ft,e.$IN=Ft=He([m],Ft);let Ht=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$JN=Ht,e.$JN=Ht=He([m],Ht);let Li=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$KN=Li,e.$KN=Li=He([m],Li);var zi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(zi||(e.NewSymbolNameTag=zi={}));var Yi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Yi||(e.NewSymbolNameTriggerKind=Yi={}));class Ui{constructor(z,ne){this.newSymbolName=z,this.tags=ne}}e.$LN=Ui;var Ti;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ti||(e.FileChangeType=Ti={}));let ji=p=class extends Error{static FileExists(z){return new p(z,l.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(z){return new p(z,l.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(z){return new p(z,l.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(z){return new p(z,l.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(z,ne=l.FileSystemProviderErrorCode.Unknown,Se){super(c.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$jl)(this,ne),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$MN=ji,e.$MN=ji=p=He([m],ji);let Bi=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$NN=Bi,e.$NN=Bi=He([m],Bi);var yi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(yi||(e.FoldingRangeKind=yi={}));var Zi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Zi||(e.CommentThreadCollapsibleState=Zi={}));var xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Mi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var Wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));var Vi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));class gn{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$ON=gn;function _i(B){return typeof B>"u"||(0,$.$bg)(B)}class qi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,Je,et){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(z,ne,Se,Je,et);if(q.isRange(z)&&typeof ne=="string"&&_i(Se))return this.o(z,ne,Se);throw(0,R.$7)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,et=z.start.character,ht=z.end.character-z.start.character,wt=this.k.get(ne);let Jt=0;if(Se)for(const hi of Se){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const mi=this.l.get(hi);Jt|=1<<mi>>>0}this.q(Je,et,ht,wt,Jt)}q(z,ne,Se,Je,et){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hi=0,mi=0;for(let wi=0;wi<Jt;wi++){let Di=this.g[5*wi],Qi=this.g[5*wi+1];Di===0?(Di=hi,Qi+=mi):Di+=hi,this.g[5*wi]=Di,this.g[5*wi+1]=Qi,hi=Di,mi=Qi}}let ht=z,wt=ne;this.f&&this.j>0&&(ht-=this.c,ht===0&&(wt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=wt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let wt=0;wt<Se;wt++)ne[wt]=wt;ne.sort((wt,Jt)=>{const hi=z[5*wt],mi=z[5*Jt];if(hi===mi){const wi=z[5*wt+1],Di=z[5*Jt+1];return wi-Di}return hi-mi});const Je=new Uint32Array(z.length);let et=0,ht=0;for(let wt=0;wt<Se;wt++){const Jt=5*ne[wt],hi=z[Jt+0],mi=z[Jt+1],wi=z[Jt+2],Di=z[Jt+3],Qi=z[Jt+4],zn=hi-et,br=zn===0?mi-ht:mi,Xi=5*wt;Je[Xi+0]=zn,Je[Xi+1]=br,Je[Xi+2]=wi,Je[Xi+3]=Di,Je[Xi+4]=Qi,et=hi,ht=mi}return Je}build(z){return this.f?new Ei(new Uint32Array(this.g),z):new Ei(qi.r(this.g),z)}}e.$PN=qi;class Ei{constructor(z,ne){this.resultId=ne,this.data=z}}e.$QN=Ei;class mn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$RN=mn;class pn{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$SN=pn;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class Gi{constructor(z){this.name=z}}e.$TN=Gi;let Oi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$UN=Oi,e.$UN=Oi=He([m],Oi);var Le;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Le||(e.QuickPickItemKind=Le={}));var gi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var Ki;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ki||(e.ExtensionKind=Ki={}));class st{static validate(z){if(typeof z.badge=="string"){let ne=(0,T.$Lf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,T.$Lf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$VN=st;let yt=class{constructor(z){this.kind=z}};e.$WN=yt,e.$WN=yt=He([m],yt);var tn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class bi{static isNotebookRange(z){return z instanceof bi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,R.$7)("start must be positive");if(ne<0)throw(0,R.$7)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new bi(ne,Se)}}e.$XN=bi;class Ai{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Ai.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,Je,et,ht,wt){this.kind=z,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=et??[],this.metadata=ht,this.executionSummary=wt,Ai.validate(this)}}e.$YN=Ai;class $n{constructor(z){this.cells=z}}e.$ZN=$n;class ni{static isNotebookCellOutputItem(z){return z instanceof ni?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return ni.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return ni.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ni.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new ni(z,ne)}static#e=new TextEncoder;static text(z,ne=A.$Ys.text){const Se=ni.#e.encode(String(z));return new ni(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return ni.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,A.$3s)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$1N=ni;class Ni{static isNotebookCellOutput(z){return z instanceof Ni?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,Je=new Set;for(let et=0;et<z.length;et++){const ht=z[et],wt=(0,A.$3s)(ht.mime);if(!Se.has(wt)||(0,d.$pK)(wt)){Se.add(wt);continue}Je.add(et),ne&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?z:z.filter((et,ht)=>!Je.has(ht))}constructor(z,ne,Se){this.items=Ni.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,C.$Wg)(),this.metadata=ne??Se)}}e.$2N=Ni;var nn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(nn||(e.NotebookCellKind=nn={}));var rn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(rn||(e.NotebookCellExecutionState=rn={}));var Hi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Hi||(e.NotebookCellStatusBarAlignment=Hi={}));var sn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class bn{constructor(z,ne){this.text=z,this.alignment=ne}}e.$3N=bn;var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var an;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class wn{constructor(z,ne=[]){this.uri=z,this.provides=(0,E.$2b)(ne)}}e.$4N=wn;class vn{constructor(z){this.label=z}}e.$5N=vn;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ji=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$6N=Ji,e.$6N=Ji=He([m],Ji);var ln;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(ln||(e.ExtensionMode=ln={}));var un;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class ee{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$7N=ee;class ce{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$8N=ce;var Ne;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Ne||(e.TestResultState=Ne={}));var ot;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let Et=class{constructor(z=void 0,ne=void 0,Se=void 0,Je=!1,et=!0){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=Je,this.preserveFocus=et}};e.$9N=Et,e.$9N=Et=He([m],Et);let At=k=class{static diff(z,ne,Se){const Je=new k(z);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(z){this.message=z}};e.$0N=At,e.$0N=At=k=He([m],At);let Si=class{constructor(z){this.id=z}};e.$$N=Si,e.$$N=Si=He([m],Si);class Fi{constructor(z,ne){this.covered=z,this.total=ne,En(this)}}e.$_N=Fi;function En(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class yn{static fromDetails(z,ne){const Se=new Fi(0,0),Je=new Fi(0,0),et=new Fi(0,0);for(const wt of ne)if("branches"in wt){Se.total+=1,Se.covered+=wt.executed?1:0;for(const Jt of wt.branches)Je.total+=1,Je.covered+=Jt.executed?1:0}else et.total+=1,et.covered+=wt.executed?1:0;const ht=new yn(z,Se,Je.total>0?Je:void 0,et.total>0?et:void 0);return ht.detailedCoverage=ne,ht}constructor(z,ne,Se,Je,et){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Je,this.testItem=et}}e.$bO=yn;class Un{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$cO=Un;class jn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$dO=jn;class Bn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$eO=Bn;var Sn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Sn||(e.ExternalUriOpenerPriority=Sn={}));var Dn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Dn||(e.WorkspaceTrustState=Dn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Wn{constructor(z,ne,Se,Je,et,ht){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ht}}e.$fO=Wn;class Vn{constructor(z){this.uri=z}}e.$gO=Vn;class qn{constructor(z,ne){this.original=z,this.modified=ne}}e.$hO=qn;class Gn{constructor(z,ne,Se,Je){this.base=z,this.input1=ne,this.input2=Se,this.result=Je}}e.$iO=Gn;class Kn{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$jO=Kn;class Hn{constructor(z){this.viewType=z}}e.$kO=Hn;class Jn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$lO=Jn;class Qn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$mO=Qn;class Xn{constructor(){}}e.$nO=Xn;class Yn{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$oO=Yn;class Zn{constructor(){}}e.$pO=Zn;class xn{constructor(z){this.textDiffs=z}}e.$qO=xn;var In;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Pn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class _n{constructor(z,ne,Se){this.id=z,this.label=ne,this.values=Se}}e.$rO=_n;var Rn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Rn||(e.InteractiveEditorResponseFeedbackKind=Rn={}));var An;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class er{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ge(z):z}}e.$sO=er;class tr{constructor(z,ne){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ge(z):z,this.vulnerabilities=ne}}e.$tO=tr;class ir{constructor(z,ne){this.participant=z,this.command=ne}}e.$uO=ir;class nr{constructor(z,ne,Se){this.title=z,this.message=ne,this.data=Se}}e.$vO=nr;class rr{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$wO=rr;class sr{constructor(z,ne){this.value=z,this.title=ne}}e.$xO=sr;class or{constructor(z){this.value=z}}e.$yO=or;class ar{constructor(z,ne){this.value=z,this.task=ne}}e.$zO=ar;class cr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ge(z):z}}e.$AO=cr;class lr{constructor(z){this.value=z}}e.$BO=lr;class ur{constructor(z,ne){this.value=z,this.iconPath=ne}}e.$CO=ur;class hr{constructor(z,ne){this.uri=z,this.edits=Array.isArray(ne)?ne:[ne]}}e.$DO=hr;class dr{constructor(z,ne,Se,Je){this.prompt=z,this.command=ne,this.references=Se,this.participant=Je}}e.$EO=dr;class fr{constructor(z,ne,Se,Je){this.response=z,this.result=ne,this.participant=Se,this.command=Je}}e.$FO=fr;var Tn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));var dn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(z,ne){return new fn(dn.User,z,ne)}static Assistant(z,ne){return new fn(dn.Assistant,z,ne)}constructor(z,ne,Se){this.role=z,this.content=ne,this.name=Se}}e.$GO=fn;class gr{constructor(z){this.content=z}}e.$HO=gr;class mr{constructor(z,ne){this.content=z,this.name=ne}}e.$IO=mr;class pr{constructor(z,ne){this.content=z,this.name=ne}}e.$JO=pr;class Ci extends Error{static NotFound(z){return new Ci(z,Ci.NotFound.name)}static NoPermissions(z){return new Ci(z,Ci.NoPermissions.name)}static Blocked(z){return new Ci(z,Ci.Blocked.name)}constructor(z,ne,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$KO=Ci;var Mn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var On;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Fn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Fn||(e.KeywordRecognitionStatus=Fn={}));class $r{constructor(z,ne){this.text=z,this.range=ne}}e.$LO=$r;var Ln;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(ke[268],Ie([1,0,5,7]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$tM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(A);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(T,$)??[]}getRelatedInformation(A,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(A,T,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiRelatedInformationProvider(c,T),new R.$vM(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$zmc=P}),define(ke[91],Ie([1,0,4,5,7,19,115,3,17]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,T.$Ai)("IExtHostAuthentication");let c=class{constructor(l){this.b=new Map,this.c=new E.$he,this.onDidChangeSessions=this.c.event,this.d=new C,this.f=new C,this.a=l.getProxy(R.$tM.MainThreadAuthentication)}async getSession(l,S,d,r={}){const o=O.$Wm.toKey(l.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${S} ${a}`,async()=>{await this.a.$ensureProvider(S);const h=l.displayName||l.name;return this.a.$getSession(S,d,o,h,r)})}async getSessions(l,S,d){const r=O.$Wm.toKey(l.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(S);const a=l.displayName||l.name;return this.a.$getSessions(S,d,r,a)})}async removeSession(l,S){const d=this.b.get(l);return d?d.provider.removeSession(S):this.a.$removeSession(l,S)}registerAuthenticationProvider(l,S,d,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:S,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(l,a));return this.a.$registerAuthenticationProvider(l,S,r?.supportsMultipleAccounts??!1),new P.$vM(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,S,d){const r=this.b.get(l);if(r)return await r.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,S){const d=this.b.get(l);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,S){const d=this.b.get(l);if(d)return await d.provider.getSessions(S);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,S){return l.startsWith(A.$vL)||this.c.fire({provider:{id:l,label:S}}),Promise.resolve()}};e.$Lmc=c,e.$Lmc=c=He([Ve(0,$.$XO)],c);class C{constructor(){this.a=new Map}getOrCreate(l,S){const d=this.a.get(l);if(d)return d;const r=S().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(ke[120],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=void 0;let S=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(R.$tM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=l.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(a,null);return}const s=(0,$.$2b)(t);if(s.length<=l.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const n=s.map(f=>({uri:f,rank:(0,c.$ef)(f.path,"/")})),i=(0,$.$zb)(n,(f,u)=>f.rank-u.rank||(0,c.$uf)(f.uri.path,u.uri.path)),g=[];e:for(const f of i){let u;for(const b of f){const I=(0,C.$mc)(b.uri.path);if(u!==I&&(u=I,g.push(b.uri)>=l.d))break e}}this.g.$onDidChange(a,g)});return new P.$vM(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:t,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async n=>{try{const{uri:i,id:g}=n,f=await Promise.resolve(t.provideFileDecoration(E.URI.revive(i),a));if(!f)return;try{P.$VN.validate(f),f.badge&&typeof f.badge!="string"&&(0,w.$TG)(s,"codiconDecoration"),h[g]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${u}`)}}catch(i){this.h.error(i)}})),h}};e.$Knc=S,e.$Knc=S=l=He([Ve(0,A.$XO),Ve(1,T.$7j)],S),e.$Lnc=(0,O.$Ai)("IExtHostDecorations")}),define(ke[269],Ie([1,0,14,2,7,5,16,22,13]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;class c{static{this.a=0}constructor(w,l,S){this.d=l,this.e=S,this.b=new Map,this.c=w.getProxy(O.$tM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,l){if(Object.keys(A.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const S=c.a++;this.b.set(S,l),this.c.$registerTextContentProvider(S,w);let d;if(typeof l.onDidChange=="function"){let r;d=l.onDidChange(async o=>{if(o.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(S,o).then(async h=>{if(!h&&typeof h!="string")return;const t=this.d.getDocument(o);if(!t)return;const s=(0,$.$of)(h);if(!t.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(E.$1).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.$vM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(w,l){const S=this.b.get(w);return S?Promise.resolve(S.provideTextDocumentContent(R.URI.revive(l),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Nnc=c}),define(ke[121],Ie([1,0,61,16,13,325,209,7,18]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$1O=void 0,e.$ZO=C;const c=new Map;function C(d,r){r?c.set(d,r):c.delete(d)}function w(d){return c.get(d)}class l extends O.$cw{constructor(r,o,a,h,t,s,n){super(o,a,h,t),this.c=r,this.m=s,this.q=n,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===R.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,t=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let n=h+1;n<t;n++)s.push(this.f[n]);return s.push(this.f[t].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof T.$wM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new T.$wM(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof T.$xM))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new T.$xM(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof T.$wM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const t=this.f[o].length;a<0?(a=0,h=!0):a>t&&(a=t,h=!0)}return h?new T.$wM(o,a):r}y(r,o){const a=this.x(r);if(!o)o=w(this.m);else if((0,P.$nf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,A.$vt)(a.character+1,(0,A.$tt)(o),this.f[a.line],0);if(h)return new T.$xM(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$1O=l;class S{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$xM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$xM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$2O=S}),define(ke[270],Ie([1,0,5,7]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$tM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(A);if(!c)throw new Error("Embedding vector provider not found");const C=await c.provideEmbeddingVector(T,$);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(A,T,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiEmbeddingVectorProvider(T,c),new R.$vM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Qnc=P}),define(ke[68],Ie([1,0,5,30,7,23,3,17,51,6,11,24,16]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=e.$1mc=void 0;let d=S=class{constructor(o,a){this.b=new Map,this.c=new C.$Jh,this.a=o.getProxy(E.$tM.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(t){try{let s;const n=h.b.get(t.scheme);return n?(await h.a.$ensureActivation(t.scheme),s=await n.impl.stat(t)):s=await h.a.$stat(t),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===R.FilePermission.Readonly?1:void 0}}catch(s){S.e(s)}},async readDirectory(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readDirectory(t)).slice()):await h.a.$readdir(t)}catch(s){return S.e(s)}},async createDirectory(t){try{const s=h.b.get(t.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(s.impl,s.extUri,t)):await h.a.$mkdir(t)}catch(s){return S.e(s)}},async readFile(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readFile(t)).slice()):(await h.a.$readFile(t)).buffer}catch(s){return S.e(s)}},async writeFile(t,s){try{const n=h.b.get(t.scheme);return n&&!n.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(n.impl,n.extUri,n.extUri.dirname(t)),await h.c.queueFor(t,()=>Promise.resolve(n.impl.writeFile(t,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(t,O.$Je.wrap(s))}catch(n){return S.e(n)}},async delete(t,s){try{const n=h.b.get(t.scheme);return n&&!n.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(t.scheme),await n.impl.delete(t,{recursive:!1,...s})):await h.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(n){return S.e(n)}},async rename(t,s,n){try{return await h.a.$rename(t,s,{overwrite:!1,...n})}catch(i){return S.e(i)}},async copy(t,s,n){try{return await h.a.$copy(t,s,{overwrite:!1,...n})}catch(i){return S.e(i)}},isWritableFileSystem(t){const s=a.getCapabilities(t);if(typeof s=="number")return!(s&R.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const t=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&R.FileType.Directory))throw P.$MN.FileExists(`Unable to create folder '${h.scheme===l.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(R.$kl(s)!==R.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(a.basename(h)),h=a.dirname(h)}for(let s=t.length-1;s>=0;s--){h=a.joinPath(h,t[s]);try{await o.createDirectory(h)}catch(n){if(R.$kl(n)!==R.FileSystemProviderErrorCode.FileExists)throw n}}}static e(o){if(o instanceof P.$MN)throw o;if(o instanceof R.$gl)switch(o.code){case R.FileSystemProviderErrorCode.FileExists:throw P.$MN.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$MN.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$MN.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$MN.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$MN.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$MN.Unavailable(o.message);default:throw new P.$MN(o.message,o.name)}if(!(o instanceof Error))throw new P.$MN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$MN.Unavailable(o.message);switch(o.name){case R.FileSystemProviderErrorCode.FileExists:throw P.$MN.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$MN.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$MN.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$MN.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$MN.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$MN.Unavailable(o.message);default:throw new P.$MN(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?w.$4g:w.$6g,isReadonly:!!h?.isReadonly}),(0,c.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??w.$4g}};e.$1mc=d,e.$1mc=d=S=He([Ve(0,T.$XO),Ve(1,$.$Emc)],d),e.$2mc=(0,A.$Ai)("IExtHostConsumerFileSystem")}),define(ke[92],Ie([1,0,3,27,12,68,2]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0,e.$3mc=(0,E.$Ai)("IExtensionStoragePaths");let T=class{constructor(c,C,w){this.d=C,this.f=w,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(c){return A.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,C=await this.g(c);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(A.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(c){if(this.c)return A.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return A.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4mc=T,e.$4mc=T=He([Ve(0,R.$bP),Ve(1,P.$7j),Ve(2,O.$2mc)],T)}),define(ke[271],Ie([1,0,7,17,4]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;let O=class{constructor(T){this.a=new E.$WN(E.ColorThemeKind.Dark),this.b=new P.$he}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=E.ColorThemeKind.Light;break;case"hcDark":$=E.ColorThemeKind.HighContrast;break;case"hcLight":$=E.ColorThemeKind.HighContrastLight;break;default:$=E.ColorThemeKind.Dark}this.a=new E.$WN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$yoc=O,e.$yoc=O=He([Ve(0,R.$XO)],O)}),define(ke[93],Ie([1,0,22,4,6,189,3,12,222,5,27,17,7]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fEb=e.$eEb=e.TunnelDtoConverter=void 0;class S extends $.$Bw{}var d;(function(o){function a(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=a;function h(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==$.TunnelPrivacyId.ConstantPrivate&&t.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$eEb=(0,A.$Ai)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(a,h,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$tM.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const t=await this.a.$openTunnel(h,a.displayName);if(t){const s=new S(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,t),new l.$vM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(a,h,t,s,n){const i=[];for(const f of a){const u=this.r.get(f);if(!u)return[];i.push(...await Promise.all(h.map(async b=>{let I;try{I=await u.provider.providePortAttributes({port:b,pid:t,commandLine:s},n)}catch{I=await u.provider.providePortAttributes(b,t,s,n)}return{providedAttributes:I,port:b}})))}const g=i.filter(f=>!!f.providedAttributes);return g.length>0?g.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,n)=>await a.provideTunnel(s,n,E.CancellationToken.None)??void 0;const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const t=a.tunnelFactory??(h?this.w(h):void 0);if(t){this.b=t;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const n=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(n)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const t=this.g.get(a.host);t.has(a.port)&&(h&&t.get(a.port).disposeListener.dispose(),await t.get(a.port).tunnel.dispose(),t.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const s=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const n=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:n}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),t=a.filter((s,n)=>h[n]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${t.map(s=>s.port).join(", ")}`),t}};e.$fEb=r,e.$fEb=r=He([Ve(0,w.$XO),Ve(1,C.$bP),Ve(2,T.$7j)],r)}),define(ke[10],Ie([1,0,18,23,146,272,59,29,135,49,73,26,141,24,34,15,2,104,33,150,94,52,106,77,114,113,233,248,81,90,55,56,244,7]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u,b,I,D,y,p,k,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$UO=pe,e.$VO=se,e.$WO=Ce;var F;(function(we){function Te(Q){const{selectionStartLineNumber:Pe,selectionStartColumn:ze,positionLineNumber:Ye,positionColumn:qe}=Q,lt=new v.$wM(Pe-1,ze-1),kt=new v.$wM(Ye-1,qe-1);return new v.$yM(lt,kt)}we.to=Te;function le(Q){const{anchor:Pe,active:ze}=Q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}we.from=le})(F||(e.Selection=F={}));var M;(function(we){function Te(Q){if(!Q)return;const{start:Pe,end:ze}=Q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}we.from=Te;function le(Q){if(!Q)return;const{startLineNumber:Pe,startColumn:ze,endLineNumber:Ye,endColumn:qe}=Q;return new v.$xM(Pe-1,ze-1,Ye-1,qe-1)}we.to=le})(M||(e.Range=M={}));var G;(function(we){function Te(Q){return{uri:Q.uri,range:M.from(Q.range)}}we.from=Te;function le(Q){return new v.$HM(o.URI.revive(Q.uri),M.to(Q.range))}we.to=le})(G||(e.Location=G={}));var q;(function(we){function Te(le){switch(le){case t.StandardTokenType.Comment:return v.StandardTokenType.Comment;case t.StandardTokenType.Other:return v.StandardTokenType.Other;case t.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case t.StandardTokenType.String:return v.StandardTokenType.String}}we.to=Te})(q||(e.TokenType=q={}));var V;(function(we){function Te(Q){return new v.$wM(Q.lineNumber-1,Q.column-1)}we.to=Te;function le(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=le})(V||(e.Position=V={}));var N;(function(we){function Te(Pe,ze,Ye){return(0,E.$Hb)((0,E.$2b)(Pe).map(qe=>le(qe,ze,Ye)))}we.from=Te;function le(Pe,ze,Ye){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ye?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Q(Pe.scheme,ze),pattern:ct.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(Pe,ze){return ze&&typeof Pe=="string"?ze.transformOutgoingScheme(Pe):Pe}})(N||(e.DocumentSelector=N={}));var L;(function(we){function Te(Q){switch(Q){case v.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}we.from=Te;function le(Q){switch(Q){case i.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}we.to=le})(L||(e.DiagnosticTag=L={}));var Z;(function(we){function Te(Q){let Pe;return Q.code&&((0,r.$ag)(Q.code)||(0,r.$eg)(Q.code)?Pe=String(Q.code):Pe={value:String(Q.code.value),target:Q.code.target}),{...M.from(Q.range),message:Q.message,source:Q.source,code:Pe,severity:fe.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(re.from),tags:Array.isArray(Q.tags)?(0,E.$Hb)(Q.tags.map(L.from)):void 0}}we.from=Te;function le(Q){const Pe=new v.$JM(M.to(Q),Q.message,fe.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,r.$ag)(Q.code)?Q.code:Q.code?.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(re.to),Pe.tags=Q.tags&&(0,E.$Hb)(Q.tags.map(L.to)),Pe}we.to=le})(Z||(e.Diagnostic=Z={}));var re;(function(we){function Te(Q){return{...M.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Te;function le(Q){return new v.$IM(new v.$HM(Q.resource,M.to(Q)),Q.message)}we.to=le})(re||(e.DiagnosticRelatedInformation=re={}));var fe;(function(we){function Te(Q){switch(Q){case v.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}we.from=Te;function le(Q){switch(Q){case i.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}we.to=le})(fe||(e.DiagnosticSeverity=fe={}));var be;(function(we){function Te(Q){return typeof Q=="number"&&Q>=v.ViewColumn.One?Q-1:Q===v.ViewColumn.Beside?m.$dE:m.$cE}we.from=Te;function le(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=le})(be||(e.ViewColumn=be={}));function oe(we){return typeof we.range<"u"}function pe(we){return we.length===0?!0:!!oe(we[0])}var $e;(function(we){function Te(qe){return qe.map(we.from)}we.fromMany=Te;function le(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let lt;if(le(qe)){const{language:Ft,value:Ht}=qe;lt={value:"```"+Ft+`
`+Ht+"\n```\n"}}else v.$XM.isMarkdownString(qe)?lt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?lt={value:qe}:lt={value:""};const kt=Object.create(null);lt.uris=kt;const Zt=Ft=>{try{let Ht=o.URI.parse(Ft,!0);Ht=Ht.with({query:Pe(Ht.query,kt)}),kt[Ft]=Ht}catch{}return""},ii=new $.marked.Renderer;return ii.link=Zt,ii.image=Ft=>typeof Ft=="string"?Zt(A.$6k(Ft).href):"",(0,$.marked)(lt.value,{renderer:ii}),lt}we.from=Q;function Pe(qe,lt){if(!qe)return qe;let kt;try{kt=(0,c.$9h)(qe)}catch{}if(!kt)return qe;let Zt=!1;return kt=(0,w.$$n)(kt,ii=>{if(o.URI.isUri(ii)){const Ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Ft]=ii,Zt=!0,Ft}else return}),Zt?JSON.stringify(kt):qe}function ze(qe){const lt=new v.$XM(qe.value,qe.supportThemeIcons);return lt.isTrusted=qe.isTrusted,lt.supportHtml=qe.supportHtml,lt.baseUri=qe.baseUri?o.URI.from(qe.baseUri):void 0,lt}we.to=ze;function Ye(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ye})($e||(e.MarkdownString=$e={}));function se(we){return pe(we)?we.map(Te=>({range:M.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?$e.fromMany(Te.hoverMessage):Te.hoverMessage?$e.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):we.map(Te=>({range:M.from(Te)}))}function Ce(we){return typeof we>"u"?we:typeof we=="string"?o.URI.file(we):we}var Fe;(function(we){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Ce(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}we.from=Te})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var Y;(function(we){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}we.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var W;(function(we){function Te(le){if(typeof le>"u")return le;switch(le){case v.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}we.from=Te})(W||(e.DecorationRangeBehavior=W={}));var ie;(function(we){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?W.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?Y.from(le.light):void 0,dark:le.dark?Y.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}we.from=Te})(ie||(e.DecorationRenderOptions=ie={}));var De;(function(we){function Te(Q){return{text:Q.newText,eol:Q.newEol&&_.from(Q.newEol),range:M.from(Q.range)}}we.from=Te;function le(Q){const Pe=new v.$CM(M.to(Q.range),Q.text);return Pe.newEol=typeof Q.eol>"u"?void 0:_.to(Q.eol),Pe}we.to=le})(De||(e.TextEdit=De={}));var he;(function(we){function Te(Q,Pe){const ze={edits:[]};if(Q instanceof v.$FM){const Ye=new T.$Bc;for(const qe of Q._allEntries())qe._type===v.FileEditType.File&&o.URI.isUri(qe.to)&&qe.from===void 0&&Ye.add(qe.to);for(const qe of Q._allEntries())if(qe._type===v.FileEditType.File){let lt;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?lt={type:"base64",value:(0,R.$4e)(R.$Je.wrap(qe.options.contents))}:lt={type:"dataTransferItem",id:qe.options.contents._itemId}),ze.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:lt},metadata:qe.metadata})}else qe._type===v.FileEditType.Text?ze.edits.push({resource:qe.uri,textEdit:De.from(qe.edit),versionId:Ye.has(qe.uri)?void 0:Pe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===v.FileEditType.Snippet?ze.edits.push({resource:qe.uri,textEdit:{range:M.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ye.has(qe.uri)?void 0:Pe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===v.FileEditType.Cell?ze.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(qe.uri)}):qe._type===v.FileEditType.CellReplace&&ze.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:y.CellEditType.Replace,index:qe.index,count:qe.count,cells:qe.cells.map(Wt.from)}})}return ze}we.from=Te;function le(Q){const Pe=new v.$FM,ze=new T.$Ac;for(const Ye of Q.edits)if(Ye.textEdit){const qe=Ye,lt=o.URI.revive(qe.resource),kt=M.to(qe.textEdit.range),Zt=qe.textEdit.text,ii=qe.textEdit.insertAsSnippet;let Ft;ii?Ft=v.$EM.replace(kt,new v.$GM(Zt)):Ft=v.$CM.replace(kt,Zt);const Ht=ze.get(lt);Ht?Ht.push(Ft):ze.set(lt,[Ft])}else Pe.renameFile(o.URI.revive(Ye.oldResource),o.URI.revive(Ye.newResource),Ye.options);for(const[Ye,qe]of ze)Pe.set(Ye,qe);return Pe}we.to=le})(he||(e.WorkspaceEdit=he={}));var ve;(function(we){const Te=Object.create(null);Te[v.SymbolKind.File]=s.SymbolKind.File,Te[v.SymbolKind.Module]=s.SymbolKind.Module,Te[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Te[v.SymbolKind.Package]=s.SymbolKind.Package,Te[v.SymbolKind.Class]=s.SymbolKind.Class,Te[v.SymbolKind.Method]=s.SymbolKind.Method,Te[v.SymbolKind.Property]=s.SymbolKind.Property,Te[v.SymbolKind.Field]=s.SymbolKind.Field,Te[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Te[v.SymbolKind.Enum]=s.SymbolKind.Enum,Te[v.SymbolKind.Interface]=s.SymbolKind.Interface,Te[v.SymbolKind.Function]=s.SymbolKind.Function,Te[v.SymbolKind.Variable]=s.SymbolKind.Variable,Te[v.SymbolKind.Constant]=s.SymbolKind.Constant,Te[v.SymbolKind.String]=s.SymbolKind.String,Te[v.SymbolKind.Number]=s.SymbolKind.Number,Te[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Te[v.SymbolKind.Array]=s.SymbolKind.Array,Te[v.SymbolKind.Object]=s.SymbolKind.Object,Te[v.SymbolKind.Key]=s.SymbolKind.Key,Te[v.SymbolKind.Null]=s.SymbolKind.Null,Te[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Te[v.SymbolKind.Struct]=s.SymbolKind.Struct,Te[v.SymbolKind.Event]=s.SymbolKind.Event,Te[v.SymbolKind.Operator]=s.SymbolKind.Operator,Te[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function le(Pe){return typeof Te[Pe]=="number"?Te[Pe]:s.SymbolKind.Property}we.from=le;function Q(Pe){for(const ze in Te)if(Te[ze]===Pe)return Number(ze);return v.SymbolKind.Property}we.to=Q})(ve||(e.SymbolKind=ve={}));var ae;(function(we){function Te(Q){switch(Q){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}we.from=Te;function le(Q){switch(Q){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}we.to=le})(ae||(e.SymbolTag=ae={}));var X;(function(we){function Te(Q){return{name:Q.name,kind:ve.from(Q.kind),tags:Q.tags&&Q.tags.map(ae.from),containerName:Q.containerName,location:Be.from(Q.location)}}we.from=Te;function le(Q){const Pe=new v.$OM(Q.name,ve.to(Q.kind),Q.containerName,Be.to(Q.location));return Pe.tags=Q.tags&&Q.tags.map(ae.to),Pe}we.to=le})(X||(e.WorkspaceSymbol=X={}));var x;(function(we){function Te(Q){const Pe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:M.from(Q.range),selectionRange:M.from(Q.selectionRange),kind:ve.from(Q.kind),tags:Q.tags?.map(ae.from)??[]};return Q.children&&(Pe.children=Q.children.map(Te)),Pe}we.from=Te;function le(Q){const Pe=new v.$PM(Q.name,Q.detail,ve.to(Q.kind),M.to(Q.range),M.to(Q.selectionRange));return(0,E.$Lb)(Q.tags)&&(Pe.tags=Q.tags.map(ae.to)),Q.children&&(Pe.children=Q.children.map(le)),Pe}we.to=le})(x||(e.DocumentSymbol=x={}));var me;(function(we){function Te(Q){const Pe=new v.$TM(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),M.to(Q.range),M.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}we.to=Te;function le(Q,Pe,ze){if(Pe=Pe??Q._sessionId,ze=ze??Q._itemId,Pe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:ze,name:Q.name,detail:Q.detail,kind:ve.from(Q.kind),uri:Q.uri,range:M.from(Q.range),selectionRange:M.from(Q.selectionRange),tags:Q.tags?.map(ae.from)}}we.from=le})(me||(e.CallHierarchyItem=me={}));var ge;(function(we){function Te(le){return new v.$UM(me.to(le.from),le.fromRanges.map(Q=>M.to(Q)))}we.to=Te})(ge||(e.CallHierarchyIncomingCall=ge={}));var Me;(function(we){function Te(le){return new v.$VM(me.to(le.to),le.fromRanges.map(Q=>M.to(Q)))}we.to=Te})(Me||(e.CallHierarchyOutgoingCall=Me={}));var Be;(function(we){function Te(Q){return{range:Q.range&&M.from(Q.range),uri:Q.uri}}we.from=Te;function le(Q){return new v.$HM(o.URI.revive(Q.uri),M.to(Q.range))}we.to=le})(Be||(e.location=Be={}));var Ee;(function(we){function Te(Q){const Pe=Q,ze=Q;return{originSelectionRange:Pe.originSelectionRange?M.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:ze.uri,range:M.from(Pe.targetRange?Pe.targetRange:ze.range),targetSelectionRange:Pe.targetSelectionRange?M.from(Pe.targetSelectionRange):void 0}}we.from=Te;function le(Q){return{targetUri:o.URI.revive(Q.uri),targetRange:M.to(Q.range),targetSelectionRange:Q.targetSelectionRange?M.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?M.to(Q.originSelectionRange):void 0}}we.to=le})(Ee||(e.DefinitionLink=Ee={}));var Re;(function(we){function Te(Q){return{range:M.from(Q.range),contents:$e.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}we.from=Te;function le(Q){const Pe=Q.contents.map($e.to),ze=M.to(Q.range),Ye=Q.canIncreaseVerbosity,qe=Q.canDecreaseVerbosity;return new v.$LM(Pe,ze,Ye,qe)}we.to=le})(Re||(e.Hover=Re={}));var Oe;(function(we){function Te(Q){return{range:M.from(Q.range),expression:Q.expression}}we.from=Te;function le(Q){return new v.$GN(M.to(Q.range),Q.expression)}we.to=le})(Oe||(e.EvaluatableExpression=Oe={}));var j;(function(we){function Te(Q){if(Q instanceof v.$HN)return{type:"text",range:M.from(Q.range),text:Q.text};if(Q instanceof v.$IN)return{type:"variable",range:M.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof v.$JN)return{type:"expression",range:M.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Te;function le(Q){switch(Q.type){case"text":return{range:M.to(Q.range),text:Q.text};case"variable":return{range:M.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:M.to(Q.range),expression:Q.expression}}}we.to=le})(j||(e.InlineValue=j={}));var U;(function(we){function Te(Q){return{frameId:Q.frameId,stoppedLocation:M.from(Q.stoppedLocation)}}we.from=Te;function le(Q){return new v.$KN(Q.frameId,M.to(Q.stoppedLocation))}we.to=le})(U||(e.InlineValueContext=U={}));var K;(function(we){function Te(Q){return{range:M.from(Q.range),kind:Q.kind}}we.from=Te;function le(Q){return new v.$MM(M.to(Q.range),Q.kind)}we.to=le})(K||(e.DocumentHighlight=K={}));var J;(function(we){function Te(Q){return{uri:Q.uri,highlights:Q.highlights.map(K.from)}}we.from=Te;function le(Q){return new v.$NM(o.URI.revive(Q.uri),Q.highlights.map(K.to))}we.to=le})(J||(e.MultiDocumentHighlight=J={}));var te;(function(we){function Te(le){switch(le){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}we.to=Te})(te||(e.CompletionTriggerKind=te={}));var ue;(function(we){function Te(le){return{triggerKind:te.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}we.to=Te})(ue||(e.CompletionContext=ue={}));var Ae;(function(we){function Te(Q){switch(Q){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}we.from=Te;function le(Q){switch(Q){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}we.to=le})(Ae||(e.CompletionItemTag=Ae={}));var je;(function(we){const Te=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function le(ze){return Te.get(ze)??s.CompletionItemKind.Property}we.from=le;const Q=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Pe(ze){return Q.get(ze)??v.CompletionItemKind.Property}we.to=Pe})(je||(e.CompletionItemKind=je={}));var Ge;(function(we){function Te(le,Q){const Pe=new v.$4M(le.label);return Pe.insertText=le.insertText,Pe.kind=je.to(le.kind),Pe.tags=le.tags?.map(Ae.to),Pe.detail=le.detail,Pe.documentation=A.$Zk(le.documentation)?$e.to(le.documentation):le.documentation,Pe.sortText=le.sortText,Pe.filterText=le.filterText,Pe.preselect=le.preselect,Pe.commitCharacters=le.commitCharacters,h.$ct.isIRange(le.range)?Pe.range=M.to(le.range):typeof le.range=="object"&&(Pe.range={inserting:M.to(le.range.insert),replacing:M.to(le.range.replace)}),Pe.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new v.$GM(le.insertText):(Pe.insertText=le.insertText,Pe.textEdit=Pe.range instanceof v.$xM?new v.$CM(Pe.range,Pe.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Pe.additionalTextEdits=le.additionalTextEdits.map(ze=>De.to(ze))),Pe.command=Q&&le.command?Q.fromInternal(le.command):void 0,Pe}we.to=Te})(Ge||(e.CompletionItem=Ge={}));var Ze;(function(we){function Te(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:$e.fromStrict(Q.documentation)}}we.from=Te;function le(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?$e.to(Q.documentation):Q.documentation}}we.to=le})(Ze||(e.ParameterInformation=Ze={}));var tt;(function(we){function Te(Q){return{label:Q.label,documentation:$e.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.from):[],activeParameter:Q.activeParameter}}we.from=Te;function le(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?$e.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.to):[],activeParameter:Q.activeParameter}}we.to=le})(tt||(e.SignatureInformation=tt={}));var _e;(function(we){function Te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.from):[]}}we.from=Te;function le(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.to):[]}}we.to=le})(_e||(e.SignatureHelp=_e={}));var it;(function(we){function Te(le,Q){const Pe=new v.$3M(V.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(nt.to.bind(void 0,le)),Q.kind&&mt.to(Q.kind));return Pe.textEdits=Q.textEdits&&Q.textEdits.map(De.to),Pe.tooltip=A.$Zk(Q.tooltip)?$e.to(Q.tooltip):Q.tooltip,Pe.paddingLeft=Q.paddingLeft,Pe.paddingRight=Q.paddingRight,Pe}we.to=Te})(it||(e.InlayHint=it={}));var nt;(function(we){function Te(le,Q){const Pe=new v.$2M(Q.label);return Pe.tooltip=A.$Zk(Q.tooltip)?$e.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Pe.command=le.fromInternal(Q.command)),Q.location&&(Pe.location=Be.to(Q.location)),Pe}we.to=Te})(nt||(e.InlayHintLabelPart=nt={}));var mt;(function(we){function Te(Q){return Q}we.from=Te;function le(Q){return Q}we.to=le})(mt||(e.InlayHintKind=mt={}));var ut;(function(we){function Te(Q){return{range:M.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Te;function le(Q){let Pe;if(Q.url)try{Pe=typeof Q.url=="string"?o.URI.parse(Q.url,!0):o.URI.revive(Q.url)}catch{}return new v.$9M(M.to(Q.range),Pe)}we.to=le})(ut||(e.DocumentLink=ut={}));var rt;(function(we){function Te(Q){const Pe=new v.$_M(Q.label);return Q.textEdit&&(Pe.textEdit=De.to(Q.textEdit)),Q.additionalTextEdits&&(Pe.additionalTextEdits=Q.additionalTextEdits.map(ze=>De.to(ze))),Pe}we.to=Te;function le(Q){return{label:Q.label,textEdit:Q.textEdit?De.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Pe=>De.from(Pe)):void 0}}we.from=le})(rt||(e.ColorPresentation=rt={}));var at;(function(we){function Te(Q){return new v.$0M(Q[0],Q[1],Q[2],Q[3])}we.to=Te;function le(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=le})(at||(e.Color=at={}));var dt;(function(we){function Te(Q){return{range:M.from(Q.range)}}we.from=Te;function le(Q){return new v.$SM(M.to(Q.range))}we.to=le})(dt||(e.SelectionRange=dt={}));var We;(function(we){function Te(le){switch(le){case u.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}we.to=Te})(We||(e.TextDocumentSaveReason=We={}));var Ue;(function(we){function Te(Q){switch(Q){case v.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}we.from=Te;function le(Q){switch(Q){case a.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}we.to=le})(Ue||(e.TextEditorLineNumbersStyle=Ue={}));var _;(function(we){function Te(Q){if(Q===v.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(Q===v.EndOfLine.LF)return n.EndOfLineSequence.LF}we.from=Te;function le(Q){if(Q===n.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(Q===n.EndOfLineSequence.LF)return v.EndOfLine.LF}we.to=le})(_||(e.EndOfLine=_={}));var H;(function(we){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case v.ProgressLocation.SourceControl:return g.ProgressLocation.Scm;case v.ProgressLocation.Window:return g.ProgressLocation.Window;case v.ProgressLocation.Notification:return g.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}we.from=Te})(H||(e.ProgressLocation=H={}));var ye;(function(we){function Te(Q){const Pe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Pe.kind=Ke.from(Q.kind)),Pe}we.from=Te;function le(Q){const Pe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Pe.kind=Ke.to(Q.kind)),Pe}we.to=le})(ye||(e.FoldingRange=ye={}));var Ke;(function(we){function Te(Q){if(Q)switch(Q){case v.FoldingRangeKind.Comment:return s.$Pv.Comment;case v.FoldingRangeKind.Imports:return s.$Pv.Imports;case v.FoldingRangeKind.Region:return s.$Pv.Region}}we.from=Te;function le(Q){if(Q)switch(Q.value){case s.$Pv.Comment.value:return v.FoldingRangeKind.Comment;case s.$Pv.Imports.value:return v.FoldingRangeKind.Imports;case s.$Pv.Region.value:return v.FoldingRangeKind.Region}}we.to=le})(Ke||(e.FoldingRangeKind=Ke={}));var xe;(function(we){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?M.from(le.selection):void 0,override:typeof le.override=="boolean"?u.$FF.id:void 0}}we.from=Te})(xe||(e.TextEditorOpenOptions=xe={}));var ct;(function(we){function Te(ze){return ze instanceof v.$uN?ze.toJSON():typeof ze=="string"?ze:le(ze)||Q(ze)?new v.$uN(ze.baseUri??ze.base,ze.pattern).toJSON():ze}we.from=Te;function le(ze){const Ye=ze;return Ye?o.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(ze){const Ye=ze;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Pe(ze){return typeof ze=="string"?ze:new v.$uN(o.URI.revive(ze.baseUri),ze.pattern)}we.to=Pe})(ct||(e.GlobPattern=ct={}));var gt;(function(we){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const Q=le;return{language:Q.language,scheme:Q.scheme,pattern:ct.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Te})(gt||(e.LanguageSelector=gt={}));var Tt;(function(we){function Te(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&o.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Ye=>Ye instanceof v.$xM)))}we.is=Te;function le(Q){return{documents:Q.documents.map(Pe=>Pe.map(ze=>({uri:o.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Ye=>M.from(Ye))})))}}we.from=le})(Tt||(e.MappedEditsContext=Tt={}));var Qt;(function(we){function Te(Q){return{start:Q.start,end:Q.end}}we.from=Te;function le(Q){return new v.$XN(Q.start,Q.end)}we.to=le})(Qt||(e.NotebookRange=Qt={}));var zt;(function(we){function Te(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Te;function le(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=le})(zt||(e.NotebookCellExecutionSummary=zt={}));var ui;(function(we){function Te(le){if(le===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(le===y.NotebookCellExecutionState.Pending)return;if(le===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}we.to=Te})(ui||(e.NotebookCellExecutionState=ui={}));var xt;(function(we){function Te(Q){switch(Q){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}we.from=Te;function le(Q){switch(Q){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}we.to=le})(xt||(e.NotebookCellKind=xt={}));var Xe;(function(we){function Te(Q){const Pe={metadata:Q.metadata??Object.create(null),cells:[]};for(const ze of Q.cells)v.$YN.validate(ze),Pe.cells.push(Wt.from(ze));return Pe}we.from=Te;function le(Q){const Pe=new v.$ZN(Q.cells.map(Wt.to));return(0,r.$ng)(Q.metadata)||(Pe.metadata=Q.metadata),Pe}we.to=le})(Xe||(e.NotebookData=Xe={}));var Wt;(function(we){function Te(Q){return{cellKind:xt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:zt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(ft.from):[]}}we.from=Te;function le(Q){return new v.$YN(xt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ft.to):void 0,Q.metadata,Q.internalMetadata?zt.to(Q.internalMetadata):void 0)}we.to=le})(Wt||(e.NotebookCellData=Wt={}));var Ut;(function(we){function Te(Q){return{mime:Q.mime,valueBytes:R.$Je.wrap(Q.data)}}we.from=Te;function le(Q){return new v.$1N(Q.valueBytes.buffer,Q.mime)}we.to=le})(Ut||(e.NotebookCellOutputItem=Ut={}));var ft;(function(we){function Te(Q){return{outputId:Q.id,items:Q.items.map(Ut.from),metadata:Q.metadata}}we.from=Te;function le(Q){const Pe=Q.items.map(Ut.to);return new v.$2N(Pe,Q.outputId,Q.metadata)}we.to=le})(ft||(e.NotebookCellOutput=ft={}));var pt;(function(we){function Te(Pe){return Q(Pe)?{include:ct.from(Pe.include)??void 0,exclude:ct.from(Pe.exclude)??void 0}:ct.from(Pe)??void 0}we.from=Te;function le(Pe){return Q(Pe)?{include:ct.to(Pe.include),exclude:ct.to(Pe.exclude)}:ct.to(Pe)}we.to=le;function Q(Pe){const ze=Pe;return ze?!(0,r.$jg)(ze.include)&&!(0,r.$jg)(ze.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var _t;(function(we){function Te(le,Q,Pe){const ze=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:Q.toInternal(ze,Pe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}we.from=Te})(_t||(e.NotebookStatusBarItem=_t={}));var Xt;(function(we){function Te(le,Q,Pe){const ze=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:Q.toInternal(ze,Pe),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}we.from=Te})(Xt||(e.NotebookKernelSourceAction=Xt={}));var jt;(function(we){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}we.from=Te})(jt||(e.NotebookDocumentContentOptions=jt={}));var bt;(function(we){function Te(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Te;function le(Q){return new v.$4N(o.URI.revive(Q.uri),Q.provides)}we.to=le})(bt||(e.NotebookRendererScript=bt={}));var Ot;(function(we){function Te(Q){return{message:$e.fromStrict(Q.message)||"",type:k.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:M.from(Q.location.range),uri:Q.location.uri}}}we.from=Te;function le(Q){const Pe=new v.$0N(typeof Q.message=="string"?Q.message:$e.to(Q.message));return Pe.actualOutput=Q.actual,Pe.expectedOutput=Q.expected,Pe.contextValue=Q.contextValue,Pe.location=Q.location?Be.to(Q.location):void 0,Pe}we.to=le})(Ot||(e.TestMessage=Ot={}));var Gt;(function(we){we.namespace=k.$kL,we.denamespace=k.$lL})(Gt||(e.TestTag=Gt={}));var Bt;(function(we){function Te(Q){const Pe=(0,f.$TO)(Q).controllerId;return{extId:p.$fL.fromExtHostTestItem(Q,Pe).toString(),label:Q.label,uri:o.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(ze=>Gt.namespace(Pe,ze.id)),range:h.$ct.lift(M.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&$e.fromStrict(Q.error)||null}}we.from=Te;function le(Q){return{parent:void 0,error:void 0,id:p.$fL.fromString(Q.extId).localId,label:Q.label,uri:o.URI.revive(Q.uri),tags:(Q.tags||[]).map(Pe=>{const{tagId:ze}=Gt.denamespace(Pe);return new v.$$N(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:M.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=le})(Bt||(e.TestItem=Bt={})),function(we){function Te(Q){return{id:Q.id}}we.from=Te;function le(Q){return new v.$$N(Q.id)}we.to=le}(Gt||(e.TestTag=Gt={}));var Qe;(function(we){const Te=(Q,Pe)=>{const ze=Q.value;if(!ze)return;const Ye={...Bt.toPlain(ze.item),parent:Pe,taskStates:ze.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(lt=>lt.type===k.TestMessageType.Error).map(Ot.to)})),children:[]};if(Q.children)for(const qe of Q.children.values()){const lt=Te(qe,Ye);lt&&Ye.children.push(lt)}return Ye};function le(Q){const Pe=new l.$MO;for(const qe of Q.items)Pe.insert(p.$fL.fromString(qe.item.extId).path,qe);const ze=[Pe.nodes],Ye=[];for(;ze.length;)for(const qe of ze.pop())qe.value?Ye.push(qe):qe.children&&ze.push(qe.children.values());return{completedAt:Q.completedAt,results:Ye.map(qe=>Te(qe)).filter(r.$ig)}}we.to=le})(Qe||(e.TestResults=Qe={}));var ei;(function(we){function Te(ze){return{covered:ze.covered,total:ze.total}}function le(ze){return"line"in ze?V.from(ze):M.from(ze)}function Q(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:le(ze.location),type:k.DetailType.Statement,branches:ze.branches.length?ze.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&le(Ye.location),label:Ye.label})):void 0}:{type:k.DetailType.Declaration,name:ze.name,count:ze.executed,location:le(ze.location)}}we.fromDetails=Q;function Pe(ze,Ye,qe){return v.$aO(qe.statementCoverage),v.$aO(qe.branchCoverage),v.$aO(qe.declarationCoverage),{id:Ye,uri:qe.uri,statement:Te(qe.statementCoverage),branch:qe.branchCoverage&&Te(qe.branchCoverage),declaration:qe.declarationCoverage&&Te(qe.declarationCoverage),testId:qe instanceof v.$bO&&qe.testItem?p.$fL.fromExtHostTestItem(qe.testItem,ze).toString():void 0}}we.fromFile=Pe})(ei||(e.TestCoverage=ei={}));var ti;(function(we){function Te(le){switch(le){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}we.to=Te})(ti||(e.CodeActionTriggerKind=ti={}));var ci;(function(we){function Te(Q){const Pe=new v.$fO(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),M.to(Q.range),M.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}we.to=Te;function le(Q,Pe,ze){if(Pe=Pe??Q._sessionId,ze=ze??Q._itemId,Pe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:ze,kind:ve.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:M.from(Q.range),selectionRange:M.from(Q.selectionRange),tags:Q.tags?.map(ae.from)}}we.from=le})(ci||(e.TypeHierarchyItem=ci={}));var Dt;(function(we){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}we.from=Te})(Dt||(e.ViewBadge=Dt={}));var Mt;(function(we){function Te(ze,Ye,qe){const lt=Ye.fileData;return lt?new v.$mN(new v.$nN(lt.name,o.URI.revive(lt.uri),lt.id,(0,O.$db)(()=>qe(lt.id)))):ze===C.$Ys.uriList&&Ye.uriListData?new v.$lN(Pe(Ye.uriListData)):new v.$lN(Ye.asString)}we.to=Te;async function le(ze,Ye){const qe=await Ye.asString();if(ze===C.$Ys.uriList)return{asString:qe,fileData:void 0,uriListData:Q(qe)};const lt=Ye.asFile();return{asString:qe,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}we.from=le;function Q(ze){return P.$_s.split(ze).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return o.URI.parse(Ye)}catch{}return Ye})}function Pe(ze){return P.$_s.create(ze.map(Ye=>typeof Ye=="string"?Ye:o.URI.revive(Ye)))}})(Mt||(e.DataTransferItem=Mt={}));var Pt;(function(we){function Te(Q,Pe){const ze=Q.items.map(([Ye,qe])=>[Ye,Mt.to(Ye,qe,Pe)]);return new v.$oN(ze)}we.toDataTransfer=Te;async function le(Q){const Pe={items:[]},ze=[];for(const[Ye,qe]of Q)ze.push((async()=>{Pe.items.push([Ye,await Mt.from(Ye,qe)])})());return await Promise.all(ze),Pe}we.from=le})(Pt||(e.DataTransfer=Pt={}));var Nt;(function(we){function Te(Q,Pe){return{kind:"reply",agentId:Q.participant??Pe?.agentId??"",subCommand:Q.command??Pe?.command,message:Q.prompt,title:Q.label}}we.from=Te;function le(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=le})(Nt||(e.ChatFollowup=Nt={}));var li;(function(we){function Te(Q){switch(Q.role){case I.ChatMessageRole.System:return new v.$GO(v.LanguageModelChatMessageRole.System,Q.content);case I.ChatMessageRole.User:return new v.$GO(v.LanguageModelChatMessageRole.User,Q.content);case I.ChatMessageRole.Assistant:return new v.$GO(v.LanguageModelChatMessageRole.Assistant,Q.content)}}we.to=Te;function le(Q){switch(Q.role){case v.LanguageModelChatMessageRole.System:return{role:I.ChatMessageRole.System,content:Q.content};case v.LanguageModelChatMessageRole.User:return{role:I.ChatMessageRole.User,content:Q.content};case v.LanguageModelChatMessageRole.Assistant:return{role:I.ChatMessageRole.Assistant,content:Q.content}}}we.from=le})(li||(e.LanguageModelChatMessage=li={}));var Vt;(function(we){function Te(Q){return{kind:"markdownContent",content:$e.from(Q.value)}}we.from=Te;function le(Q){return new v.$sO($e.to(Q.content))}we.to=le})(Vt||(e.ChatResponseMarkdownPart=Vt={}));var ri;(function(we){function Te(Q){return{kind:"markdownVuln",content:$e.from(Q.value),vulnerabilities:Q.vulnerabilities}}we.from=Te;function le(Q){return new v.$tO($e.to(Q.content),Q.vulnerabilities)}we.to=le})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Lt;(function(we){function Te(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}we.from=Te;function le(Q){return new v.$uO(Q.agentId,Q.command)}we.to=le})(Lt||(e.ChatResponseDetectedParticipantPart=Lt={}));var Yt;(function(we){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}we.from=Te})(Yt||(e.ChatResponseConfirmationPart=Yt={}));var si;(function(we){function Te(Q){const{value:Pe,baseUri:ze}=Q;function Ye(qe,lt){return qe.map(kt=>{const Zt=o.URI.joinPath(lt,kt.name);return{label:kt.name,uri:Zt,children:kt.children&&Ye(kt.children,Zt)}})}return{kind:"treeData",treeData:{label:(0,S.$$g)(ze),uri:ze,children:Ye(Pe,ze)}}}we.from=Te;function le(Q){const Pe=(0,c.$0h)(Q.treeData);function ze(lt){return lt.map(kt=>({name:kt.label,children:kt.children&&ze(kt.children)}))}const Ye=Pe.uri,qe=Pe.children?ze(Pe.children):[];return new v.$wO(qe,Ye)}we.to=le})(si||(e.ChatResponseFilesPart=si={}));var Ct;(function(we){function Te(Q){const Pe=ze=>o.URI.isUri(ze);return{kind:"inlineReference",name:Q.title,inlineReference:Pe(Q.value)?Q.value:G.from(Q.value)}}we.from=Te;function le(Q){const Pe=(0,c.$0h)(Q);return new v.$xO(o.URI.isUri(Pe.inlineReference)?Pe.inlineReference:G.to(Pe.inlineReference),Q.name)}we.to=le})(Ct||(e.ChatResponseAnchorPart=Ct={}));var vt;(function(we){function Te(Q){return{kind:"progressMessage",content:$e.from(Q.value)}}we.from=Te;function le(Q){return new v.$yO(Q.content.value)}we.to=le})(vt||(e.ChatResponseProgressPart=vt={}));var $t;(function(we){function Te(Q){return{kind:"warning",content:$e.from(Q.value)}}we.from=Te;function le(Q){return new v.$AO(Q.content.value)}we.to=le})($t||(e.ChatResponseWarningPart=$t={}));var qt;(function(we){function Te(le){return{kind:"progressTask",content:$e.from(le.value)}}we.from=Te})(qt||(e.ChatTask=qt={}));var St;(function(we){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?$e.from(le):void 0}}we.from=Te})(St||(e.ChatTaskResult=St={}));var oi;(function(we){function Te(Q,Pe,ze){return{kind:"command",command:Pe.toInternal(Q.value,ze)??{command:Q.value.command,title:Q.value.title}}}we.from=Te;function le(Q,Pe){return new v.$BO(Pe.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.to=le})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Kt;(function(we){function Te(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Pe=>De.from(Pe))}}we.from=Te;function le(Q){return new v.$DO(o.URI.revive(Q.uri),Q.edits.map(Pe=>De.to(Pe)))}we.to=le})(Kt||(e.ChatResponseTextEditPart=Kt={}));var pi;(function(we){function Te(Q){const Pe=d.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:o.URI.isUri(Q.iconPath)?{light:o.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&o.URI.isUri(Q.iconPath.light)&&o.URI.isUri(Q.iconPath.dark)?{light:o.URI.revive(Q.iconPath.light),dark:o.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:o.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:G.from(Q.value.value)},iconPath:Pe}:{kind:"reference",reference:o.URI.isUri(Q.value)?Q.value:G.from(Q.value),iconPath:Pe}}we.from=Te;function le(Q){const Pe=(0,c.$0h)(Q),ze=Ye=>o.URI.isUri(Ye)?Ye:G.to(Ye);return new v.$CO("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&ze(Pe.reference.value)}:ze(Pe.reference))}we.to=le})(pi||(e.ChatResponseReferencePart=pi={}));var di;(function(we){function Te(Pe,ze,Ye){return Pe instanceof v.$sO?Vt.from(Pe):Pe instanceof v.$xO?Ct.from(Pe):Pe instanceof v.$CO?pi.from(Pe):Pe instanceof v.$yO?vt.from(Pe):Pe instanceof v.$wO?si.from(Pe):Pe instanceof v.$BO?oi.from(Pe,ze,Ye):Pe instanceof v.$DO?Kt.from(Pe):Pe instanceof v.$tO?ri.from(Pe):Pe instanceof v.$uO?Lt.from(Pe):Pe instanceof v.$AO?$t.from(Pe):{kind:"markdownContent",content:$e.from("")}}we.from=Te;function le(Pe,ze){switch(Pe.kind){case"reference":return pi.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Pe,ze)}}we.to=le;function Q(Pe,ze){switch(Pe.kind){case"markdownContent":return Vt.to(Pe);case"inlineReference":return Ct.to(Pe);case"progressMessage":return;case"treeData":return si.to(Pe);case"command":return oi.to(Pe,ze)}}we.toContent=Q})(di||(e.ChatResponsePart=di={}));var ki;(function(we){function Te(le){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(Pi.to),location:Rt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData}}we.to=Te})(ki||(e.ChatAgentRequest=ki={}));var Rt;(function(we){function Te(Q){switch(Q){case b.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case b.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case b.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case b.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}we.to=Te;function le(Q){switch(Q){case v.ChatLocation.Notebook:return b.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return b.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return b.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return b.ChatAgentLocation.Editor}}we.from=le})(Rt||(e.ChatLocation=Rt={}));var Pi;(function(we){function Te(le){const Q=le.value;if(!Q)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,o.$vc)(Q)?o.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,o.$vc)(Q.uri)?G.to((0,c.$0h)(Q)):Q,modelDescription:le.modelDescription}}we.to=Te})(Pi||(e.ChatAgentValueReference=Pi={}));var ai;(function(we){function Te(le,Q,Pe){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:Q.toInternal(le.command,Pe)}}we.from=Te})(ai||(e.ChatAgentCompletionItem=ai={}));var It;(function(we){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}we.to=Te})(It||(e.ChatAgentResult=It={}));var Ii;(function(we){function Te(le,Q,Pe){if(Q.action.kind==="vote")return;const ze=It.to(le);if(Q.action.kind==="command"){const Ye=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:ze}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(Q.action.followup)},result:ze}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:ze}:{action:Q.action,result:ze}}we.to=Te})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var vi;(function(we){function Te(le,Q,Pe){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:Q.toInternal(le,Pe)}we.from=Te})(vi||(e.TerminalQuickFix=vi={}));var $i;(function(we){function Te(le){return{kind:Ri.to(le.kind)}}we.to=Te})($i||(e.PartialAcceptInfo=$i={}));var Ri;(function(we){function Te(le){switch(le){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}we.to=Te})(Ri||(e.PartialAcceptTriggerKind=Ri={}));var fi;(function(we){function Te(le,Q){return{id:Q,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}we.from=Te})(fi||(e.DebugTreeItem=fi={}))}),define(ke[273],Ie([1,0,5,17,10,38]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;let A=class{constructor($,c){this.a=$.getProxy(E.$tM.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>c.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,c,C){const w=new O.$Kw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(w,void 0,C?.isRefactoring??!1)}};e.$Mmc=A,e.$Mmc=A=He([Ve(0,R.$XO)],A)}),define(ke[274],Ie([1,0,18,11,48,4,40,6,69,15,2,19,5,10,7,234,25]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class a{constructor(n,i,g,f,u){this.j=n,this.k=i,this.l=g,this.m=f,this.n=u,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(f){if(n.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const n=this;this.b.reset();const g=(f,u)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),u){const b=this.l.$handleProgressChunk(this.k.requestId,f),I={report:D=>{b?.then(y=>{y&&(d.$XM.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,S.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,S.ChatResponseReferencePart.from(D),y))})}};Promise.all([b,u?.(I)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,S.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){i(this.markdown);const u=new d.$sO(f),b=S.ChatResponseMarkdownPart.from(u);return g(b),this},markdownWithVulnerabilities(f,u){i(this.markdown),u&&(0,o.$TG)(n.j,"chatParticipantAdditions");const b=new d.$tO(f,u),I=S.ChatResponseMarkdownWithVulnerabilitiesPart.from(b);return g(I),this},filetree(f,u){i(this.filetree);const b=new d.$wO(f,u),I=S.ChatResponseFilesPart.from(b);return g(I),this},anchor(f,u){i(this.anchor);const b=new d.$xO(f,u),I=S.ChatResponseAnchorPart.from(b);return g(I),this},button(f){i(this.anchor);const u=new d.$BO(f),b=S.ChatResponseCommandButtonPart.from(u,n.m,n.n);return g(b),this},progress(f,u){i(this.progress);const b=new d.$zO(f,u),I=u?S.ChatTask.from(b):S.ChatResponseProgressPart.from(b);return g(I,u),this},warning(f){i(this.progress),(0,o.$TG)(n.j,"chatParticipantAdditions");const u=new d.$AO(f),b=S.ChatResponseWarningPart.from(u);return g(b),this},reference(f,u){if(i(this.reference),"variableName"in f&&(0,o.$TG)(n.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const b=n.k.variables.variables.find(I=>I.name===f.variableName);if(b){let I;if(b.references?.length)I=b.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new d.$CO(f,u);I=[S.ChatResponseReferencePart.from(D)]}return I.forEach(D=>g(D)),this}}else{const b=new d.$CO(f,u),I=S.ChatResponseReferencePart.from(b);g(I)}return this},textEdit(f,u){i(this.textEdit),(0,o.$TG)(n.j,"chatParticipantAdditions");const b=new d.$DO(f,u),I=S.ChatResponseTextEditPart.from(b);return g(I),this},detectedParticipant(f,u){i(this.detectedParticipant),(0,o.$TG)(n.j,"chatParticipantAdditions");const b=new d.$uO(f,u),I=S.ChatResponseDetectedParticipantPart.from(b);return g(I),this},confirmation(f,u,b){i(this.confirmation),(0,o.$TG)(n.j,"chatParticipantAdditions");const I=new d.$vO(f,u,b),D=S.ChatResponseConfirmationPart.from(I);return g(D),this},push(f){if(i(this.push),(f instanceof d.$DO||f instanceof d.$tO||f instanceof d.$uO||f instanceof d.$AO||f instanceof d.$vO)&&(0,o.$TG)(n.j,"chatParticipantAdditions"),f instanceof d.$CO)this.reference(f.value,f.iconPath);else{const u=S.ChatResponsePart.from(f,n.m,n.n);g(u)}return this}}}return this.g}}class h extends T.$Uc{static{this.b=0}constructor(n,i,g,f){super(),this.n=i,this.s=g,this.t=f,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=n.getProxy(l.$tM.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,i,g){const f=h.b++,u=new t(n,this.t,i,this.g,f,g);return this.c.set(f,u),u.isAgentEnabled()&&this.g.$registerAgent(f,n.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(n,i,g,f){const u=h.b++,b=new t(n,this.t,i,this.g,u,f);return this.c.set(u,b),this.g.$registerAgent(u,n.identifier,i,{isSticky:!0},g),b.apiAgent}async $invokeAgent(n,i,g,f){const u=this.c.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let b=this.j.get(i.sessionId);b||(b=new T.$Tc,this.j.set(i.sessionId,b));const I=new a(u.extension,i,this.g,this.s.converter,b);try{const D=await this.u(i.agentId,g),y=u.invoke(S.ChatAgentRequest.to(i),{history:D},I.apiObject,f);return await(0,R.$oh)(Promise.resolve(y).then(p=>{if(p?.metadata)try{JSON.stringify(p.metadata)}catch(m){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${m.message}`;return this.n.error(`[${u.extension.identifier.value}] [@${u.id}] ${v}`,u.extension),{errorDetails:{message:v},timings:I.timings}}let k;return p?.errorDetails&&(k={...p.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,o.$TG)(u.extension,"chatParticipantPrivate"),{errorDetails:k,timings:I.timings,metadata:p?.metadata}}),f)}catch(D){return this.n.error(D,u.extension),{errorDetails:{message:(0,P.$lj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(n,i){const g=[];for(const f of i.history){const u=S.ChatAgentResult.to(f.result),b=n===f.request.agentId?u:{...u,metadata:void 0};g.push(new d.$EO(f.request.message,f.request.command,f.request.variables.variables.map(S.ChatAgentValueReference.to),f.request.agentId));const I=(0,E.$Hb)(f.response.map(D=>S.ChatResponsePart.toContent(D,this.s.converter)));g.push(new d.$FO(I,b,f.request.agentId,f.request.command))}return g}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,i,g,f,u){const b=this.c.get(i);if(!b)return Promise.resolve([]);const I=await this.u(b.id,f),D=S.ChatAgentResult.to(g);return(await b.provideFollowups(D,{history:I},u)).filter(y=>{const p=!y.participant||A.Iterable.some(this.c.values(),k=>k.id===y.participant&&w.$Wm.equals(k.extension.identifier,b.extension.identifier));return p||this.n.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),p}).map(y=>S.ChatFollowup.from(y,n))}$acceptFeedback(n,i,g,f){const u=this.c.get(n);if(!u)return;const b=S.ChatAgentResult.to(i);let I;switch(g){case r.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:b,kind:I,reportIssue:f}:{result:b,kind:I}))}$acceptAction(n,i,g){const f=this.c.get(n);if(!f||g.action.kind==="vote")return;const u=S.ChatAgentUserActionEvent.to(i,g,this.s.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(n,i,g){const f=this.c.get(n);if(!f)return[];let u=this.m.get(n);return u?u.clear():(u=new T.$Tc,this.m.set(n,u)),(await f.invokeCompletionProvider(i,g)).map(I=>S.ChatAgentCompletionItem.from(I,this.s.converter,u))}async $provideWelcomeMessage(n,i,g){const f=this.c.get(n);if(f)return await f.provideWelcomeMessage(S.ChatLocation.to(i),g)}async $provideSampleQuestions(n,i,g){const f=this.c.get(n);if(f)return(await f.provideSampleQuestions(S.ChatLocation.to(i),g)).map(u=>S.ChatFollowup.from(u,void 0))}}e.$Nmc=h;class t{constructor(n,i,g,f,u,b){this.extension=n,this.w=i,this.id=g,this.x=f,this.y=u,this.z=b,this.m=new O.$he,this.n=new O.$he}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,i){return this.q?await this.q.provider.provideCompletionItems(n,i)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$SG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,i,g){if(!this.b)return[];const f=await this.b.provideFollowups(n,i,g);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(n,i){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(n,i);return g?g.map(f=>typeof f=="string"?f:S.MarkdownString.from(f)):[]}async provideSampleQuestions(n,i){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(n,i);return g||[]}get apiAgent(){let n=!1,i=!1;const g=()=>{n||i||(i=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof C.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$sN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:S.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:S.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:S.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(u){f.c=u,g()},get requestHandler(){return f.z},set requestHandler(u){(0,c.$kg)(typeof u=="function","Invalid request handler"),f.z=u},get followupProvider(){return f.b},set followupProvider(u){f.b=u,g()},get isDefault(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.d},set isDefault(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.d=u,g()},get helpTextPrefix(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.g=u,g()},get helpTextVariablesPrefix(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.j=u,g()},get helpTextPostfix(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.k=u,g()},get isSecondary(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.l=u,g()},get supportIssueReporting(){return(0,o.$TG)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(u){(0,o.$TG)(f.extension,"chatParticipantPrivate"),f.o=u,g()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(u){if((0,o.$TG)(f.extension,"chatParticipantAdditions"),f.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,u.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$TG)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(u){(0,o.$TG)(f.extension,"defaultChatParticipant"),f.s=u,g()},get welcomeMessageProvider(){return(0,o.$TG)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$SG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(u){f.t=u,g()},get requester(){return f.t},set supportsSlowReferences(u){(0,o.$TG)(f.extension,"chatParticipantPrivate"),f.u=u,g()},get supportsSlowReferences(){return(0,o.$TG)(f.extension,"chatParticipantPrivate"),f.u},dispose(){n=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(n,i,g,f){return this.z(n,i,g,f)}}}),define(ke[275],Ie([1,0,14,6,34,5,10,7,25]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class c{static{this.a=0}constructor(l){this.b=new Map,this.c=l.getProxy(O.$tM.MainThreadChatVariables)}async $resolveVariable(l,S,d,r){const o=this.b.get(l);if(o)try{if(o.resolver.resolve2){(0,$.$TG)(o.extension,"chatParticipantAdditions");const a=new C(S,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,E.$2)(a)}}registerVariableResolver(l,S,d,r,o,a,h,t,s){const n=c.a++,i=s?P.ThemeIcon.fromId(s):void 0;return this.b.set(n,{extension:l,data:{id:S,name:d,description:r,modelDescription:o,icon:i},resolver:h}),this.c.$registerVariable(n,{id:S,name:d,description:r,modelDescription:o,isSlow:a,fullName:t,icon:i}),(0,R.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}attachContext(l,S,d){this.c.$attachContext(l,T.$HM.isLocation(S)?A.Location.from(S):S,A.ChatLocation.from(d))}}e.$Omc=c;class C{constructor(l,S){this.c=l,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(r){if(l.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const l=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){S(this.progress);const o=new T.$yO(r),a=A.ChatResponseProgressPart.from(o);return d(a),this},reference(r){S(this.reference);const o=new T.$CO(r),a=A.ChatResponseReferencePart.from(o);return d(a),this},push(r){return S(this.push),r instanceof T.$CO?d(A.ChatResponseReferencePart.from(r)):r instanceof T.$yO&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(ke[276],Ie([1,0,11,72,4,6,37,2,94,19,10,7,5,25]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=d;function d(r,o,a){const h=r.getProxy(l.$tM.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$Ym,o.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===A.MarshalledId.CommentController){const p=this.b.get(y.handle);return p?p.value:y}else if(y&&y.$mid===A.MarshalledId.CommentThread){const p=y,k=this.b.get(p.commentControlHandle);if(!k)return p;const m=k.getCommentThread(p.commentThreadHandle);return m?m.value:p}else if(y&&(y.$mid===A.MarshalledId.CommentThreadReply||y.$mid===A.MarshalledId.CommentThreadInstance)){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);return k?y.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:y.text}:y}else if(y&&y.$mid===A.MarshalledId.CommentNode){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const m=y.commentUniqueId,v=k.getCommentByUniqueId(m);return v||y}else if(y&&y.$mid===A.MarshalledId.CommentThreadNode){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const m=y.text,v=y.commentUniqueId,F=k.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=m:F.body=new w.$XM(m),F):y}return y}})}createCommentController(y,p,k){const m=t.a++,v=new n(y,m,p,k);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,p,k,m){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(p,k,m)}async $setActiveComment(y,p){const k=this.b.get(y);k&&k.$setActiveComment(p??void 0)}async $updateCommentThreadTemplate(y,p,k){const m=this.b.get(y);m&&m.$updateCommentThreadTemplate(p,k)}$deleteCommentThread(y,p){this.b.get(y)?.$deleteCommentThread(p)}async $provideCommentingRanges(y,p,k){const m=this.b.get(y);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const v=await a.ensureDocumentData(T.URI.revive(p));return(0,E.$sh)(async()=>{const F=await m.commentingRangeProvider.provideCommentingRanges(v.document,k);let M;return Array.isArray(F)?M={ranges:F,fileComments:!1}:F?M={ranges:F.ranges||[],fileComments:F.fileComments||!1}:M=F??void 0,M}).then(F=>{let M;return F&&(M={ranges:F.ranges.map(G=>C.Range.from(G)),fileComments:F.fileComments}),M})}$toggleReaction(y,p,k,m,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,E.$sh)(()=>{const M=F.getCommentThread(p);if(M){const G=M.getCommentByUniqueId(m.uniqueIdInThread);if(F!==void 0&&G&&F.reactionHandler)return F.reactionHandler(G,f(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,S.$TG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,p,k,m,v,F,M,G,q){this.m=p,this.n=k,this.o=m,this.p=v,this.q=F,this.extensionDescription=M,this.r=G,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${y}.${this.handle}`),h.$createCommentThread(p,this.handle,this.n,this.o,C.Range.from(this.p),M.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{h.$deleteCommentThread(p,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(N){V.range=N},get comments(){return V.comments},set comments(N){V.comments=N},get collapsibleState(){return V.collapsibleState},set collapsibleState(N){V.collapsibleState=N},get canReply(){return V.canReply},set canReply(N){V.canReply=N},get contextValue(){return V.contextValue},set contextValue(N){V.contextValue=N},get label(){return V.label},set label(N){V.label=N},get state(){return V.state},set state(N){V.state=N},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const y=k=>Object.prototype.hasOwnProperty.call(this.b,k),p={};y("range")&&(p.range=C.Range.from(this.p)),y("label")&&(p.label=this.label),y("contextValue")&&(p.contextValue=this.contextValue??null),y("comments")&&(p.comments=this.q.map(k=>i(this,k,this.k,this.extensionDescription))),y("collapsibleState")&&(p.collapseState=u(this.g)),y("canReply")&&(p.canReply=this.canReply),y("state")&&(p.state=b(this.h)),y("applicability")&&(p.applicability=I(this.h)),y("isTemplate")&&(p.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(y){for(const p of this.k){const k=p[0],m=p[1];if(y===m)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}He([(0,R.$6h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,S.$TG)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$TG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$TG)(this.h,"activeComment"),this.f}constructor(y,p,k,m){this.h=y,this.i=p,this.j=k,this.k=m,this.a=new Map,h.$registerCommentController(this.handle,k,m,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,M,G){return v.createCommentThread(F,M,G).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(y,p,k){p===void 0&&(0,S.$TG)(this.h,"fileComments");const m=new s(this.id,this.handle,void 0,y,p,k,this.h,!1);return this.a.set(m.handle,m),m}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const p=this.a.get(y.commentThreadHandle);p&&(this.e=y.uniqueIdInThread?p.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=p)}$createCommentThreadTemplate(y,p,k){const m=new s(this.id,this.handle,void 0,T.URI.revive(y),C.Range.to(p),[],this.h,!0,k);return m.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(y,p){const k=this.a.get(y);k&&(k.range=C.Range.to(p))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function i(D,y,p,k){let m=p.get(y);return m||(m=++D.commentHandle,p.set(y,m)),y.state!==void 0&&(0,S.$TG)(k,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,S.$TG)(k,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:m,body:typeof y.body=="string"?y.body:C.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>g(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function g(D){return{label:D.label,iconPath:D.iconPath?C.$WO(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function u(D){if(D!==void 0)switch(D){case w.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case w.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function b(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case w.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case w.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function I(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case w.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case w.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new t}}),define(ke[277],Ie([1,0,22,76,6,16,24,2,10,67,80,5,7]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class S{constructor(g,f){this.document=g,this.b=f,this.a=1,this.c=new C.$ymc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,f){await this.f(g).undo(),f||this.disposeBackup()}async redo(g,f){await this.f(g).redo(),f||this.disposeBackup()}disposeEdits(g){for(const f of g)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=n(this.document.uri)+this.a++;return(0,A.$bh)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const f=this.c.get(g,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(g,f){return this.a.get(this.b(g,f))}add(g,f,u){const b=this.b(g,f.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${g} resource:${f.uri}`);const I=new S(f,u);return this.a.set(b,I),I}delete(g,f){const u=this.b(g,f.uri);this.a.delete(u)}b(g,f){return`${g}@@@${f}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(g,f,u){return this.b(g,{type:r.Text,extension:f,provider:u})}addCustomProvider(g,f,u){return this.b(g,{type:r.Custom,extension:f,provider:u})}get(g){return this.a.get(g)}b(g,f){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,f),new l.$vM(()=>this.a.delete(g))}}class a{constructor(g,f,u,b,I){this.d=f,this.f=u,this.g=b,this.h=I,this.b=new o,this.c=new d,this.a=g.getProxy(w.$tM.MainThreadCustomEditors)}registerCustomEditorProvider(g,f,u,b){const I=new P.$Tc;return t(u)?(I.add(this.b.addTextProvider(f,g,u)),this.a.$registerTextEditorProvider((0,c.$8mc)(g),f,b.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,c.$6mc)(g))):(I.add(this.b.addCustomProvider(f,g,u)),h(u)&&I.add(u.onDidChangeCustomDocument(D=>{const y=this.i(f,D.document.uri);if(s(D)){const p=y.addEdit(D);this.a.$onDidEdit(D.document.uri,f,p,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$8mc)(g),f,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,c.$6mc)(g))),l.$vM.from(I,new l.$vM(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(g,f,u,b,I){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=T.URI.revive(g),p=await D.provider.openCustomDocument(y,{backupId:u,untitledDocumentData:b?.buffer},I);let k;return h(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,p,k),{editable:h(D.provider)}}async $disposeCustomDocument(g,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const b=T.URI.revive(g),{document:I}=this.i(f,b);this.c.delete(f,I),I.dispose()}async $resolveCustomEditor(g,f,u,b,I,D){const y=this.b.get(u);if(!y)throw new Error(`No provider found for '${u}'`);const p=$.ViewColumn.to(I),k=this.g.createNewWebview(f,b.contentOptions,y.extension),m=this.h.createNewWebviewPanel(f,u,b.title,p,b.options,k,b.active),v=T.URI.revive(g);switch(y.type){case r.Custom:{const{document:F}=this.i(u,v);return y.provider.resolveCustomEditor(F,m,D)}case r.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,m,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,f,u){this.i(f,g).disposeEdits(u)}async $onMoveCustomEditor(g,f,u){const b=this.b.get(u);if(!b)throw new Error(`No provider found for '${u}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const I=this.h.getWebviewPanel(g);if(!I)throw new Error("No webview found");const D=T.URI.revive(f),y=this.d.getDocument(D);await b.provider.moveCustomTextEditor(y,I,E.CancellationToken.None)}async $undo(g,f,u,b){return this.i(f,g).undo(u,b)}async $redo(g,f,u,b){return this.i(f,g).redo(u,b)}async $revert(g,f,u){const b=this.i(f,g);await this.j(f).revertCustomDocument(b.document,u),b.disposeBackup()}async $onSave(g,f,u){const b=this.i(f,g);await this.j(f).saveCustomDocument(b.document,u),b.disposeBackup()}async $onSaveAs(g,f,u,b){const I=this.i(f,g);return this.j(f).saveCustomDocumentAs(I.document,T.URI.revive(u),b)}async $backup(g,f,u){const b=this.i(f,g),D=await this.j(f).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},u);return b.updateBackup(D),D.id}i(g,f){const u=this.c.get(g,T.URI.revive(f));if(!u)throw new Error("No custom document found");return u}j(g){const u=this.b.get(g)?.provider;if(!u||!h(u))throw new Error("Custom document is not editable");return u}}e.$$mc=a;function h(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function s(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function n(i){const g=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,R.$oj)(g)+""}}),define(ke[278],Ie([1,0,179,106,2,5,7,10,4,12,29,51]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;class S{#e;#t;#i;constructor(o,a,h,t,s,n,i,g){this.d=o,this.e=a,this.f=h,this.g=t,this.h=s,this.c=!1,this.f=Math.max(t,h),this.#i=new C.$Ac(f=>n.getComparisonKey(f)),this.#e=i,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let n;o=[...o].sort(S.k);for(const i of o){const[g,f]=i;if((!n||g.toString()!==n.toString())&&(n&&this.#i.get(n).length===0&&this.#i.delete(n),n=g,h.push(g),this.#i.set(g,[])),f)this.#i.get(g)?.push(...f);else{const u=this.#i.get(g);u&&(u.length=0)}}}if(this.#t.fire(h),!this.#e)return;const t=[];let s=0;for(const n of h){let i=[];const g=this.#i.get(n);if(g)if(g.length>this.g){i=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const b of g)if(b.severity===f[u]&&i.push({...T.Diagnostic.from(b),modelVersionId:this.h(n)})===this.g)break e;i.push({severity:R.MarkerSeverity.Info,message:(0,E.localize)(0,null,g.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=g.map(f=>({...T.Diagnostic.from(f),modelVersionId:this.h(n)}));if(t.push([n,i]),s+=i.length,s>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,t]of this)o.call(a,h,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$Fmc=S;let d=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const a=new C.$Ac;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,t){this.j=a,this.k=h,this.l=t,this.g=new Map,this.h=new $.$le({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,l._mapper),this.f=o.getProxy(O.$tM.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:t,h:s,j:n,k:i,l:g}=this,f=new class{$changeMany(I,D){t.$changeMany(I,D),n.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,D.length===0?"CLEARING":D)}$clear(I){t.$clear(I),n.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){t.dispose()}};let u;if(!a)a="_generated_diagnostic_collection_name_#"+l.c++,u=a;else if(!h.has(a))u=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do u=a+l.c++;while(h.has(u))}return new class extends S{constructor(){super(a,u,l.e,l.d,I=>g.getDocument(I)?.version,i.extUri,f,s),h.set(u,this)}dispose(){super.dispose(),h.delete(u)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const t of this.g.values())t.forEach((s,n)=>{let i=a.get(s.toString());typeof i>"u"&&(i=h.length,a.set(s.toString(),i),h.push([s,[]])),h[i][1]=h[i][1].concat(...n)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new S(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(P.URI.revive(a),h.map(T.Diagnostic.to))}};e.$Gmc=d,e.$Gmc=d=l=He([Ve(1,c.$7j),Ve(2,w.$Emc)],d)}),define(ke[279],Ie([1,0,2,14,7,10,211,38]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class ${constructor(C,w,l,S={timeout:1500,errors:3}){this.c=C,this.d=w,this.f=l,this.g=S,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(w,l,S)=>{const r={dispose:this.a.push([w,l,C])};return Array.isArray(S)&&S.push(r),r}}async $participateInSave(C,w){const l=E.URI.revive(C);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(S)break;const a=this.d.getDocument(l),h=await this.h(o,{document:a,reason:O.TextDocumentSaveReason.to(w)});r.push(h)}}finally{clearTimeout(d)}return r}h([C,w,l],S){const d=this.b.get(C);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(l,C,w,S).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(C);this.b.set(C,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,w,l,S){const d=[],r=Date.now(),{document:o,reason:a}=S,{version:h}=o,t=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,R.$8)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{w.apply(l,[t])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,n)=>{const i=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(d).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(i),s(g)}).catch(g=>{clearTimeout(i),n(g)})}).then(s=>{const n={edits:[]};for(const i of s)if(Array.isArray(i)&&i.every(g=>g instanceof P.$CM))for(const{newText:g,newEol:f,range:u}of i)n.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:u&&O.Range.from(u),text:g,eol:f&&O.EndOfLine.from(f)}});if(n.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new T.$Kw(n)):Promise.reject(new Error("concurrent_edits"))})}}e.$Onc=$}),define(ke[280],Ie([1,0,4,6,2,5,121,10,15,26,7]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class w{constructor(S,d){this.a=new E.$he,this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=S.getProxy(O.$tM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const a=P.URI.revive(o);return(0,$.$lg)(this.g.getDocument(a))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const r=P.URI.revive(S),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(S){const d=P.URI.revive(S),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,d){const r=P.URI.revive(S),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,r){const o=P.URI.revive(S),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=C.TextDocumentChangeReason.Undo:d.isRedoing&&(h=C.TextDocumentChangeReason.Redo),this.c.fire((0,c.$0n)({document:a.document,contentChanges:d.changes.map(t=>({range:T.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:h}))}setWordDefinitionFor(S,d){(0,A.$ZO)(S,d)}}e.$Hmc=w}),define(ke[70],Ie([1,0,281,4,15,2,3,5,17,10,7]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,A.$Ai)("IExtHostEditorTabs");class w{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new C.$gO(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new C.$hO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new C.$iO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new C.$jO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new C.$kO(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new C.$lO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new C.$mO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new C.$nO;case T.TabInputKind.InteractiveEditorInput:return new C.$oO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new C.$pO;case T.TabInputKind.MultiDiffEditorInput:return new C.$qO(this.b.input.diffEditors.map(o=>new C.$hO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class l{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new w(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===T.TabModelOperationKind.TAB_OPEN){const h=new w(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===T.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===T.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new R.$he,this.c=new R.$he,this.e=[],this.a=o.getProxy(T.$tM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,P.$lg)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,t)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,t):this.i(s,t):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),t=(0,E.$L)(a,h),s=this.e.filter(f=>t.removed.includes(f.groupId)).map(f=>f.apiObject),n=[],i=[];this.e=o.map(f=>{const u=new l(f,()=>this.d);return t.added.includes(u.groupId)?n.push(u.apiObject):i.push(u.apiObject),u});const g=(0,P.$lg)(o.find(f=>f.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:n,closed:s,changed:i}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(t=>t.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const t of o){const s=this.g(t);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const t of o){const s=this.h(t);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$anc=S,e.$anc=S=He([Ve(0,$.$XO)],S);function d(r){return r.tabs!==void 0}}),define(ke[282],Ie([1,0,2,5,30,6,7,10,326,13,28,23,25,59]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let t,s,n=$.State.LastKnownState,i=$.State.LastKnownState;for(const g of a){let f=t?(0,c.$Df)(t,g):0;for(f===0?s=$.State.Start:s=i;f<g.length;f++)f+1===g.length?(n=i,i=$.State.BeforeColon):i+=1,h.push([s,g.toUpperCase().charCodeAt(f),i]),h.push([s,g.toLowerCase().charCodeAt(f),i]),s=i;t=g,i=n}h.push([$.State.BeforeColon,C.CharCode.Colon,$.State.AfterColon]),h.push([$.State.AfterColon,C.CharCode.Slash,$.State.End]),this.b=new $.$W2(h)}}provideDocumentLinks(a){this.c();const h=[],t=$.$X2.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of t){const n=T.DocumentLink.to(s);n.target&&h.push(n)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(R.$tM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,t,s={}){if(r.j(t),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const n=this.h++;this.b.add(h),this.d.add(h),this.c.set(n,t);let i=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(i+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(i+=P.FileSystemProviderCapabilities.Readonly),typeof t.copy=="function"&&(i+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,l.$TG)(a,"fsChunks"),i+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let g;s.isReadonly&&(0,S.$Zk)(s.isReadonly)&&s.isReadonly.value!==""&&(g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(n,h,i,g).catch(u=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(u)});const f=t.onDidChangeFile(u=>{const b=[];for(const I of u){const{uri:D,type:y}=I;if(D.scheme!==h)continue;let p;switch(y){case A.FileChangeType.Changed:p=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:p=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:p=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:D,type:p})}this.a.$onFileSystemChange(n,b)});return(0,O.$Sc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:t,mtime:s,size:n,permissions:i}=a;return{type:h,ctime:t,mtime:s,size:n,permissions:i}}$stat(a,h){return Promise.resolve(this.l(a).stat(E.URI.revive(h))).then(t=>r.k(t))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(E.URI.revive(h))).then(t=>w.$Je.wrap(t))}$writeFile(a,h,t,s){return Promise.resolve(this.l(a).writeFile(E.URI.revive(h),t.buffer,s))}$delete(a,h,t){return Promise.resolve(this.l(a).delete(E.URI.revive(h),t))}$rename(a,h,t,s){return Promise.resolve(this.l(a).rename(E.URI.revive(h),E.URI.revive(t),s))}$copy(a,h,t,s){const n=this.l(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(E.URI.revive(h),E.URI.revive(t),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(h)))}$watch(a,h,t,s){const n=this.l(a).watch(E.URI.revive(t),s);this.f.set(h,n)}$unwatch(a,h){const t=this.f.get(h);t&&(t.dispose(),this.f.delete(h))}$open(a,h,t){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(E.URI.revive(h),t))}$close(a,h){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(h))}$read(a,h,t,s){const n=this.l(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const i=w.$Je.alloc(s);return Promise.resolve(n.read(h,t,i.buffer,0,s)).then(g=>i.slice(0,g))}$write(a,h,t,s){const n=this.l(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(h,t,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return h}}e.$Rnc=r}),define(ke[283],Ie([1,0,4,41,2,5,10,7,30,47]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class C{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,t){this.a=Math.random(),this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const s=(0,R.$uk)(h),n=typeof h=="string",i=t?.correlate,g=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(i&&typeof f.session>"u")){if(!t?.ignoreCreateEvents)for(const u of f.created){const b=P.URI.revive(u);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.b.fire(b)}if(!t?.ignoreChangeEvents)for(const u of f.changed){const b=P.URI.revive(u);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.c.fire(b)}if(!t?.ignoreDeleteEvents)for(const u of f.deleted){const b=P.URI.revive(u);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=T.$vM.from(this.i(d,o,h,t,t?.correlate),this.b,this.c,this.d,g)}i(d,r,o,a,h){const t=T.$vM.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return t;const s=d.getProxy(O.$tM.MainThreadFileSystemEventService);let n=!1;(o.pattern.includes(R.$qk)||o.pattern.includes(R.$rk))&&(n=!0);let i;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:n,excludes:a?.excludes??[],filter:i},!!h),T.$vM.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class w{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$V(()=>this.a.created.map(P.URI.revive)),this.c=new c.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class l{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new E.$he,this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.g=new E.$je,this.h=new E.$je,this.i=new E.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new C(this.j,d,r,this.a.event,A.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new w(d))}$onDidRunFileOperation(d,r){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const t=function(n){o.call(a,n)};return t.extension=d,r.event(t,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},o,a);case $.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},o,a);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,t=[];if(await d.fireAsync(r,a,async(n,i)=>{const g=Date.now(),f=await Promise.resolve(n);f instanceof T.$FM&&(t.push([i.extension,f]),h.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-g>o&&this.k.warn("SLOW file-participant",i.extension.identifier)}),a.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,n]of t){const{edits:i}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(i)}return{edit:s,extensionNames:Array.from(h)}}}e.$Snc=l}),define(ke[284],Ie([1,0,18,11,22,14,96,6,26,69,13,15,2,33,327,94,103,181,19,10,7,25,80,5]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class f{constructor(j,U){this.d=j,this.e=U}async provideDocumentSymbols(j,U){const K=this.d.getDocument(j),J=await this.e.provideDocumentSymbols(K,U);if(!(0,E.$Kb)(J))return J[0]instanceof s.$PM?J.map(t.DocumentSymbol.from):f.f(J)}static f(j){j=j.slice(0).sort((J,te)=>{let ue=J.location.range.start.compareTo(te.location.range.start);return ue===0&&(ue=te.location.range.end.compareTo(J.location.range.end)),ue});const U=[],K=[];for(const J of j){const te={name:J.name||"!!MISSING: name!!",kind:t.SymbolKind.from(J.kind),tags:J.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:t.Range.from(J.location.range),selectionRange:t.Range.from(J.location.range),children:[]};for(;;){if(K.length===0){K.push(te),U.push(te);break}const ue=K[K.length-1];if(S.$ct.containsRange(ue.range,te.range)&&!S.$ct.equalsRange(ue.range,te.range)){ue.children?.push(te),K.push(te);break}K.pop()}}return U}}class u{constructor(j,U,K,J,te,ue){this.f=j,this.g=U,this.h=K,this.j=J,this.k=te,this.l=ue,this.d=new i.$ymc("CodeLens"),this.e=new Map}async provideCodeLenses(j,U){const K=this.f.getDocument(j),J=await this.h.provideCodeLenses(K,U);if(!J||U.isCancellationRequested)return;const te=this.d.add(J),ue=new T.$Tc;this.e.set(te,ue);const Ae={cacheId:te,lenses:[]};for(let je=0;je<J.length;je++)Ae.lenses.push({cacheId:[te,je],range:t.Range.from(J[je].range),command:this.g.toInternal(J[je].command,ue)});return Ae}async resolveCodeLens(j,U){const K=j.cacheId&&this.d.get(...j.cacheId);if(!K)return;let J;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?J=K:J=await this.h.resolveCodeLens(K,U),J||(J=K),U.isCancellationRequested)return;const te=j.cacheId&&this.e.get(j.cacheId[0]);if(te){if(!J.command){const ue=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ue),this.l.error(ue);return}return j.command=this.g.toInternal(J.command,te),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function b(Oe){return Array.isArray(Oe)?Oe.map(t.DefinitionLink.from):Oe?[t.DefinitionLink.from(Oe)]:[]}class I{constructor(j,U){this.d=j,this.e=U}async provideDefinition(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideDefinition(J,te,K);return b(ue)}}class D{constructor(j,U){this.d=j,this.e=U}async provideDeclaration(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideDeclaration(J,te,K);return b(ue)}}class y{constructor(j,U){this.d=j,this.e=U}async provideImplementation(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideImplementation(J,te,K);return b(ue)}}class p{constructor(j,U){this.d=j,this.e=U}async provideTypeDefinition(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideTypeDefinition(J,te,K);return b(ue)}}class k{static{this.f=10}constructor(j,U){this.g=j,this.h=U,this.d=0,this.e=new Map}async provideHover(j,U,K,J){const te=this.g.getDocument(j),ue=t.Position.to(U);let Ae;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,_e=this.e.get(tt);if(!_e)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:_e};Ae=await this.h.provideHover(te,ue,J,it)}else Ae=await this.h.provideHover(te,ue,J);if(!Ae||(0,E.$Kb)(Ae.contents))return;Ae.range||(Ae.range=te.getWordRangeAtPosition(ue)),Ae.range||(Ae.range=new s.$xM(ue,ue));const je=t.Hover.from(Ae),Ge=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ge,Ae),this.d+=1,{...je,id:Ge}}releaseHover(j){this.e.delete(j)}}class m{constructor(j,U){this.d=j,this.e=U}async provideEvaluatableExpression(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideEvaluatableExpression(J,te,K);if(ue)return t.EvaluatableExpression.from(ue)}}class v{constructor(j,U){this.d=j,this.e=U}async provideInlineValues(j,U,K,J){const te=this.d.getDocument(j),ue=await this.e.provideInlineValues(te,t.Range.to(U),t.InlineValueContext.to(K),J);if(Array.isArray(ue))return ue.map(Ae=>t.InlineValue.from(Ae))}}class F{constructor(j,U){this.d=j,this.e=U}async provideDocumentHighlights(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideDocumentHighlights(J,te,K);if(Array.isArray(ue))return ue.map(t.DocumentHighlight.from)}}class M{constructor(j,U){this.d=j,this.e=U}async provideMultiDocumentHighlights(j,U,K,J){const te=this.d.getDocument(j),ue=K.map(Ge=>this.d.getDocument(Ge)),Ae=t.Position.to(U),je=await this.e.provideMultiDocumentHighlights(te,Ae,ue,J);if(Array.isArray(je))return je.map(t.MultiDocumentHighlight.from)}}class G{constructor(j,U){this.d=j,this.e=U}async provideLinkedEditingRanges(j,U,K){const J=this.d.getDocument(j),te=t.Position.to(U),ue=await this.e.provideLinkedEditingRanges(J,te,K);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,E.$Hb)(ue.ranges.map(t.Range.from)),wordPattern:ue.wordPattern}}}class q{constructor(j,U){this.d=j,this.e=U}async provideReferences(j,U,K,J){const te=this.d.getDocument(j),ue=t.Position.to(U),Ae=await this.e.provideReferences(te,ue,K,J);if(Array.isArray(Ae))return Ae.map(t.location.from)}}class V{static{this.d=1e3}constructor(j,U,K,J,te,ue,Ae){this.g=j,this.h=U,this.j=K,this.k=J,this.l=te,this.m=ue,this.n=Ae,this.e=new i.$ymc("CodeAction"),this.f=new Map}async provideCodeActions(j,U,K,J){const te=this.g.getDocument(j),ue=d.$et.isISelection(U)?t.Selection.to(U):t.Range.to(U),Ae=[];for(const it of this.j.getDiagnostics(j))if(ue.intersection(it.range)&&Ae.push(it)>V.d)break;const je={diagnostics:Ae,only:K.only?new s.$RM(K.only):void 0,triggerKind:t.CodeActionTriggerKind.to(K.trigger)},Ge=await this.k.provideCodeActions(te,ue,je,J);if(!(0,E.$Lb)(Ge)||J.isCancellationRequested)return;const Ze=this.e.add(Ge),tt=new T.$Tc;this.f.set(Ze,tt);const _e=[];for(let it=0;it<Ge.length;it++){const nt=Ge[it];if(nt)if(V.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,tt)});else{je.only&&(nt.kind?je.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=nt.ranges??[];_e.push({cacheId:[Ze,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,tt),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,n.$SG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,n.$SG)(this.m,"codeActionRanges")?(0,E.$Hb)(mt.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:Ze,actions:_e}}async resolveCodeAction(j,U){const[K,J]=j,te=this.e.get(K,J);if(!te||V.o(te))return{};if(!this.k.resolveCodeAction)return{};const ue=await this.k.resolveCodeAction(te,U)??te;let Ae;ue.edit&&(Ae=t.WorkspaceEdit.from(ue.edit,void 0));let je;if(ue.command){const Ge=this.f.get(K);Ge&&(je=this.h.toInternal(ue.command,Ge))}return{edit:Ae,command:je}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class N{constructor(j,U,K,J,te){this.e=j,this.f=U,this.g=K,this.h=J,this.j=te,this.d=new i.$ymc("DocumentPasteEdit")}async prepareDocumentPaste(j,U,K,J){if(!this.g.prepareDocumentPaste)return;const te=this.f.getDocument(j),ue=U.map(Ge=>t.Range.to(Ge)),Ae=t.DataTransfer.toDataTransfer(K,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(te,ue,Ae,J),J.isCancellationRequested)return;const je=Array.from(Ae).filter(([,Ge])=>!(Ge instanceof s.$lN));return t.DataTransfer.from(je)}async providePasteEdits(j,U,K,J,te,ue){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(U),je=K.map(_e=>t.Range.to(_e)),Ge=t.DataTransfer.toDataTransfer(J,async _e=>(await this.e.$resolvePasteFileData(this.h,j,_e)).buffer),Ze=await this.g.provideDocumentPasteEdits(Ae,je,Ge,{only:te.only?new s.$qN(te.only):void 0,triggerKind:te.triggerKind},ue);if(!Ze||ue.isCancellationRequested)return[];const tt=this.d.add(Ze);return Ze.map((_e,it)=>({_cacheId:[tt,it],title:_e.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:_e.kind,yieldTo:_e.yieldTo?.map(nt=>nt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?t.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,U){const[K,J]=j,te=this.d.get(K,J);if(!te||!this.g.resolveDocumentPasteEdit)return{};const ue=await this.g.resolveDocumentPasteEdit(te,U)??te;return{additionalEdit:ue.additionalEdit?t.WorkspaceEdit.from(ue.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class L{constructor(j,U){this.d=j,this.e=U}async provideDocumentFormattingEdits(j,U,K){const J=this.d.getDocument(j),te=await this.e.provideDocumentFormattingEdits(J,U,K);if(Array.isArray(te))return te.map(t.TextEdit.from)}}class Z{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeFormattingEdits(j,U,K,J){const te=this.d.getDocument(j),ue=t.Range.to(U),Ae=await this.e.provideDocumentRangeFormattingEdits(te,ue,K,J);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,U,K,J){(0,w.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(j),ue=U.map(t.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(te,ue,K,J);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}}class re{constructor(j,U){this.d=j,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,U,K,J,te){const ue=this.d.getDocument(j),Ae=t.Position.to(U),je=await this.e.provideOnTypeFormattingEdits(ue,Ae,K,J,te);if(Array.isArray(je))return je.map(t.TextEdit.from)}}class fe{constructor(j,U){this.e=j,this.f=U,this.d=new i.$ymc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,U){const K=await this.e.provideWorkspaceSymbols(j,U);if(!(0,E.$Lb)(K))return{symbols:[]};const J=this.d.add(K),te={cacheId:J,symbols:[]};for(let ue=0;ue<K.length;ue++){const Ae=K[ue];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}te.symbols.push({...t.WorkspaceSymbol.from(Ae),cacheId:[J,ue]})}return te}async resolveWorkspaceSymbol(j,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const K=this.d.get(...j.cacheId);if(K){const J=await this.e.resolveWorkspaceSymbol(K,U);return J&&(0,$.$_n)(j,t.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class be{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideRenameEdits(j,U,K,J){const te=this.d.getDocument(j),ue=t.Position.to(U);try{const Ae=await this.e.provideRenameEdits(te,ue,K,J);return Ae?t.WorkspaceEdit.from(Ae):void 0}catch(Ae){const je=be.g(Ae);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(j,U,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(j),te=t.Position.to(U);try{const ue=await this.e.prepareRename(J,te,K);let Ae,je;if(s.$xM.isRange(ue)?(Ae=ue,je=J.getText(ue)):(0,w.$cg)(ue)&&(Ae=ue.range,je=ue.placeholder),!Ae||!je)return;if(Ae.start.line>te.line||Ae.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Ae),text:je}}catch(ue){const Ae=be.g(ue);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(ue)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(j,U,K){this.e=j,this.f=U,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,U,K,J){const te=this.e.getDocument(j),ue=t.Range.to(U);try{const Ae=oe.d[K],je=await this.f.provideNewSymbolNames(te,ue,Ae,J);return je?je.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Ae){this.g.error(oe.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class pe{constructor(j,U){this.resultId=j,this.tokens=U}}class $e{constructor(j,U){this.f=j,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,U,K){const J=this.f.getDocument(j),te=U!==0?this.d.get(U):null;let ue=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,te.resultId,K):await this.g.provideDocumentSemanticTokens(J,K);return te&&this.d.delete(U),ue?(ue=$e.h(ue),this.o($e.n(te,ue),ue)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return $e.j(j)?$e.k(j)?j:new s.$QN(new Uint32Array(j.data),j.resultId):$e.l(j)?$e.m(j)?j:new s.$SN(j.edits.map(U=>new s.$RN(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const U of j.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(j,U){if(!$e.j(U)||!j||!j.tokens)return U;const K=j.tokens,J=K.length,te=U.data,ue=te.length;let Ae=0;const je=Math.min(J,ue);for(;Ae<je&&K[Ae]===te[Ae];)Ae++;if(Ae===J&&Ae===ue)return new s.$SN([],U.resultId);let Ge=0;const Ze=je-Ae;for(;Ge<Ze&&K[J-Ge-1]===te[ue-Ge-1];)Ge++;return new s.$SN([{start:Ae,deleteCount:J-Ae-Ge,data:te.subarray(Ae,ue-Ge)}],U.resultId)}o(j,U){if($e.j(j)){const K=this.e++;return this.d.set(K,new pe(j.resultId,j.data)),(0,o.$Vbb)({id:K,type:"full",data:j.data})}if($e.l(j)){const K=this.e++;return $e.j(U)?this.d.set(K,new pe(U.resultId,U.data)):this.d.set(K,new pe(j.resultId)),(0,o.$Vbb)({id:K,type:"delta",deltas:(j.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class se{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeSemanticTokens(j,U,K){const J=this.d.getDocument(j),te=await this.e.provideDocumentRangeSemanticTokens(J,t.Range.to(U),K);return te?this.f(te):null}f(j){return(0,o.$Vbb)({id:0,type:"full",data:j.data})}}class Ce{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,U,K,J,te){this.f=j,this.g=U,this.h=K,this.j=J,this.k=te,this.d=new i.$ymc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,U,K,J){const te=this.f.getDocument(j),ue=t.Position.to(U),Ae=te.getWordRangeAtPosition(ue)||new s.$xM(ue,ue),je=Ae.with({end:ue}),Ge=new c.$be,Ze=await this.h.provideCompletionItems(te,ue,J,t.CompletionContext.to(K));if(!Ze||J.isCancellationRequested)return;const tt=Array.isArray(Ze)?new s.$5M(Ze):Ze,_e=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new T.$Tc;this.e.set(_e,it);const nt=[],mt={x:_e,[g.ISuggestResultDtoField.completions]:nt,[g.ISuggestResultDtoField.defaultRanges]:{replace:t.Range.from(Ae),insert:t.Range.from(je)},[g.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[g.ISuggestResultDtoField.duration]:Ge.elapsed()};for(let ut=0;ut<tt.items.length;ut++){const rt=tt.items[ut],at=this.l(rt,[_e,ut],je,Ae);nt.push(at)}return mt}async resolveCompletionItem(j,U){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...j);if(!K)return;const J=this.l(K,j),te=await this.h.resolveCompletionItem(K,U);if(!te)return;const ue=this.l(te,j);return(J[g.ISuggestDataDtoField.insertText]!==ue[g.ISuggestDataDtoField.insertText]||J[g.ISuggestDataDtoField.insertTextRules]!==ue[g.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[g.ISuggestDataDtoField.commandIdent]!==ue[g.ISuggestDataDtoField.commandIdent]||J[g.ISuggestDataDtoField.commandId]!==ue[g.ISuggestDataDtoField.commandId]||!(0,$.$ao)(J[g.ISuggestDataDtoField.commandArguments],ue[g.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[g.ISuggestDataDtoField.documentation]:ue[g.ISuggestDataDtoField.documentation],[g.ISuggestDataDtoField.detail]:ue[g.ISuggestDataDtoField.detail],[g.ISuggestDataDtoField.additionalTextEdits]:ue[g.ISuggestDataDtoField.additionalTextEdits],[g.ISuggestDataDtoField.insertText]:ue[g.ISuggestDataDtoField.insertText],[g.ISuggestDataDtoField.insertTextRules]:ue[g.ISuggestDataDtoField.insertTextRules],[g.ISuggestDataDtoField.commandIdent]:ue[g.ISuggestDataDtoField.commandIdent],[g.ISuggestDataDtoField.commandId]:ue[g.ISuggestDataDtoField.commandId],[g.ISuggestDataDtoField.commandArguments]:ue[g.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U,K,J){const te=this.e.get(U[0]);if(!te)throw Error("DisposableStore is missing...");const ue=this.g.toInternal(j.command,te),Ae={x:U,[g.ISuggestDataDtoField.label]:j.label,[g.ISuggestDataDtoField.kind]:j.kind!==void 0?t.CompletionItemKind.from(j.kind):void 0,[g.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(t.CompletionItemTag.from),[g.ISuggestDataDtoField.detail]:j.detail,[g.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:t.MarkdownString.fromStrict(j.documentation),[g.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[g.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[g.ISuggestDataDtoField.preselect]:j.preselect||void 0,[g.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[g.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[g.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(t.TextEdit.from),[g.ISuggestDataDtoField.commandIdent]:ue?.$ident,[g.ISuggestDataDtoField.commandId]:ue?.id,[g.ISuggestDataDtoField.commandArguments]:ue?.$ident?void 0:ue?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[g.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Ae[g.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof s.$GM&&(Ae[g.ISuggestDataDtoField.insertText]=j.insertText.value,Ae[g.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let je;return j.textEdit?je=j.textEdit.range:j.range&&(je=j.range),s.$xM.isRange(je)?Ae[g.ISuggestDataDtoField.range]=t.Range.from(je):je&&(!K?.isEqual(je.inserting)||!J?.isEqual(je.replacing))&&(Ae[g.ISuggestDataDtoField.range]={insert:t.Range.from(je.inserting),replace:t.Range.from(je.replacing)}),Ae}}class Fe{async provideInlineCompletions(j,U,K,J){}disposeCompletions(j){}handleDidShowCompletionItem(j,U,K){}handlePartialAccept(j,U,K,J){}}class Y extends Fe{constructor(j,U,K,J){super(),this.f=j,this.g=U,this.h=K,this.j=J,this.d=new ie,this.e=(0,n.$SG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$SG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,U,K,J){const te=this.g.getDocument(j),ue=t.Position.to(U),Ae=await this.h.provideInlineCompletionItems(te,ue,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:t.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const je=Array.isArray(Ae)?Ae:Ae.items,Ge=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],Ze=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((it,nt)=>{let mt;it.command&&(tt||(tt=new T.$Tc),mt=this.j.toInternal(it.command,tt));const ut=it.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:mt,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ge.map(it=>(tt||(tt=new T.$Tc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,U,K){const J=this.d.get(j)?.items[U];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,K)}handlePartialAccept(j,U,K,J){const te=this.d.get(j)?.items[U];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(te,K),this.h.handleDidPartiallyAcceptCompletionItem(te,t.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(j,U,K){const J=this.f.getDocument(j),te=await this.g.provideInlineEdit(J,{triggerKind:this.e[U.triggerKind]},K);if(!te||K.isCancellationRequested)return;let ue;const Ae=this.d.createReferenceId({dispose(){ue?.dispose()},item:te});let je;te.accepted&&(ue||(ue=new T.$Tc),je=this.h.toInternal(te.accepted,ue));let Ge;return te.rejected&&(ue||(ue=new T.$Tc),Ge=this.h.toInternal(te.rejected,ue)),{pid:Ae,text:te.text,range:t.Range.from(te.range),accepted:je,rejected:Ge}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,U,K,J){this.f=U,this.g=K,this.h=J,this.d=new ie,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const U=this.e++;return this.d.set(U,j),U}disposeReferenceId(j){const U=this.d.get(j);return this.d.delete(j),U}get(j){return this.d.get(j)}}class De{constructor(j,U){this.e=j,this.f=U,this.d=new i.$ymc("SignatureHelp")}async provideSignatureHelp(j,U,K,J){const te=this.e.getDocument(j),ue=t.Position.to(U),Ae=this.g(K),je=await this.f.provideSignatureHelp(te,ue,J,Ae);if(je){const Ge=this.d.add([je]);return{...t.SignatureHelp.from(je),id:Ge}}}g(j){let U;if(j.activeSignatureHelp){const K=t.SignatureHelp.to(j.activeSignatureHelp),J=this.d.get(j.activeSignatureHelp.id,0);J?(U=J,U.activeSignature=K.activeSignature,U.activeParameter=K.activeParameter):U=K}return{...j,activeSignatureHelp:U}}releaseSignatureHelp(j){this.d.delete(j)}}class he{constructor(j,U,K,J,te){this.f=j,this.g=U,this.h=K,this.j=J,this.k=te,this.d=new i.$ymc("InlayHints"),this.e=new Map}async provideInlayHints(j,U,K){const J=this.f.getDocument(j),te=t.Range.to(U),ue=await this.h.provideInlayHints(J,te,K);if(!Array.isArray(ue)||ue.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(ue);this.e.set(Ae,new T.$Tc);const je={hints:[],cacheId:Ae};for(let Ge=0;Ge<ue.length;Ge++)this.l(ue[Ge],te)&&je.hints.push(this.m(ue[Ge],[Ae,Ge]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),je}async resolveInlayHint(j,U){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...j);if(!K)return;const J=await this.h.resolveInlayHint(K,U);if(J&&this.l(J))return this.m(J,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U){return j.label.length===0||Array.isArray(j.label)&&j.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(U&&!U.contains(j.position))}m(j,U){const K=this.e.get(U[0]);if(!K)throw Error("DisposableStore is missing...");const J={label:"",cacheId:U,tooltip:t.MarkdownString.fromStrict(j.tooltip),position:t.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(t.TextEdit.from),kind:j.kind&&t.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")J.label=j.label;else{const te=[];J.label=te;for(const ue of j.label){if(!ue.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:ue.value,tooltip:t.MarkdownString.fromStrict(ue.tooltip)};s.$HM.isLocation(ue.location)&&(Ae.location=t.location.from(ue.location)),ue.command&&(Ae.command=this.g.toInternal(ue.command,K)),te.push(Ae)}}return J}}class ve{constructor(j,U){this.e=j,this.f=U,this.d=new i.$ymc("DocumentLink")}async provideLinks(j,U){const K=this.e.getDocument(j),J=await this.f.provideDocumentLinks(K,U);if(!(!Array.isArray(J)||J.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ve.g).map(t.DocumentLink.from)};{const te=this.d.add(J),ue={links:[],cacheId:te};for(let Ae=0;Ae<J.length;Ae++){if(!ve.g(J[Ae]))continue;const je=t.DocumentLink.from(J[Ae]);je.cacheId=[te,Ae],ue.links.push(je)}return ue}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,U){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...j);if(!K)return;const J=await this.f.resolveDocumentLink(K,U);if(!(!J||!ve.g(J)))return t.DocumentLink.from(J)}releaseLinks(j){this.d.delete(j)}}class ae{constructor(j,U){this.d=j,this.e=U}async provideColors(j,U){const K=this.d.getDocument(j),J=await this.e.provideDocumentColors(K,U);return Array.isArray(J)?J.map(ue=>({color:t.Color.from(ue.color),range:t.Range.from(ue.range)})):[]}async provideColorPresentations(j,U,K){const J=this.d.getDocument(j),te=t.Range.to(U.range),ue=t.Color.to(U.color),Ae=await this.e.provideColorPresentations(ue,{document:J,range:te},K);if(Array.isArray(Ae))return Ae.map(t.ColorPresentation.from)}}class X{constructor(j,U){this.d=j,this.e=U}async provideFoldingRanges(j,U,K){const J=this.d.getDocument(j),te=await this.e.provideFoldingRanges(J,U,K);if(Array.isArray(te))return te.map(t.FoldingRange.from)}}class x{constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideSelectionRanges(j,U,K){const J=this.d.getDocument(j),te=U.map(t.Position.to),ue=await this.e.provideSelectionRanges(J,te,K);if(!(0,E.$Lb)(ue))return[];if(ue.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let je=0;je<te.length;je++){const Ge=[];Ae.push(Ge);let Ze=te[je],tt=ue[je];for(;;){if(!tt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(t.SelectionRange.from(tt)),!tt.parent)break;Ze=tt.range,tt=tt.parent}}return Ae}}class me{constructor(j,U){this.f=j,this.g=U,this.d=new A.$3O(""),this.e=new Map}async prepareSession(j,U,K){const J=this.f.getDocument(j),te=t.Position.to(U),ue=await this.g.prepareCallHierarchy(J,te,K);if(!ue)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ue)?ue.map(je=>this.h(Ae,je)):[this.h(Ae,ue)]}async provideCallsTo(j,U,K){const J=this.j(j,U);if(!J)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(J,K);if(te)return te.map(ue=>({from:this.h(j,ue.from),fromRanges:ue.fromRanges.map(Ae=>t.Range.from(Ae))}))}async provideCallsFrom(j,U,K){const J=this.j(j,U);if(!J)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(J,K);if(te)return te.map(ue=>({to:this.h(j,ue.to),fromRanges:ue.fromRanges.map(Ae=>t.Range.from(Ae))}))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),J=t.CallHierarchyItem.from(U,j,K.size.toString(36));return K.set(J._itemId,U),J}j(j,U){return this.e.get(j)?.get(U)}}class ge{constructor(j,U){this.f=j,this.g=U,this.d=new A.$3O(""),this.e=new Map}async prepareSession(j,U,K){const J=this.f.getDocument(j),te=t.Position.to(U),ue=await this.g.prepareTypeHierarchy(J,te,K);if(!ue)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ue)?ue.map(je=>this.h(Ae,je)):[this.h(Ae,ue)]}async provideSupertypes(j,U,K){const J=this.j(j,U);if(!J)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(J,K);if(te)return te.map(ue=>this.h(j,ue))}async provideSubtypes(j,U,K){const J=this.j(j,U);if(!J)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(J,K);if(te)return te.map(ue=>this.h(j,ue))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),J=t.TypeHierarchyItem.from(U,j,K.size.toString(36));return K.set(J._itemId,U),J}j(j,U){return this.e.get(j)?.get(U)}}class Me{constructor(j,U,K,J,te){this.e=j,this.f=U,this.g=K,this.h=J,this.j=te,this.d=new i.$ymc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,U,K,J,te){const ue=this.f.getDocument(U),Ae=t.Position.to(K),je=t.DataTransfer.toDataTransfer(J,async _e=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,_e)).buffer),Ge=await this.g.provideDocumentDropEdits(ue,Ae,je,te);if(!Ge)return;const Ze=(0,E.$2b)(Ge),tt=this.d.add(Ze);return Ze.map((_e,it)=>({_cacheId:[tt,it],title:_e.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:_e.kind?.value,yieldTo:_e.yieldTo?.map(nt=>nt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?t.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,U){const[K,J]=j,te=this.d.get(K,J);if(!te||!this.g.resolveDocumentDropEdit)return{};const ue=await this.g.resolveDocumentDropEdit(te,U)??te;return{additionalEdit:ue.additionalEdit?t.WorkspaceEdit.from(ue.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class Be{constructor(j,U){this.d=j,this.e=U}async provideMappedEdits(j,U,K,J){const te=l.URI.revive(j),ue=this.d.getDocument(te),Ae=K.documents.map(Ze=>Ze.map(tt=>({uri:l.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(_e=>t.Range.to(_e))}))),je={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(ue,U,je,J);return Ge?t.WorkspaceEdit.from(Ge):null}}class Ee{constructor(j,U){this.adapter=j,this.extension=U}}class Re{static{this.d=0}constructor(j,U,K,J,te,ue,Ae,je){this.g=U,this.h=K,this.j=J,this.k=te,this.l=ue,this.m=Ae,this.n=je,this.f=new Map,this.e=j.getProxy(g.$tM.MainThreadLanguageFeatures)}o(j,U){return t.DocumentSelector.from(j,this.g,U)}p(j){return new s.$vM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Re.d++}async s(j,U,K,J,te,ue=!1){const Ae=this.f.get(j);if(!Ae||!(Ae.adapter instanceof U))return J;const je=Date.now();ue||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ge=K(Ae.adapter,Ae.extension);return Promise.resolve(Ge).catch(Ze=>{(0,O.$4)(Ze)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Ae.extension.identifier,Ze))}).finally(()=>{ue||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,R.$ph)(Ge,te):Ge}t(j,U){const K=this.q();return this.f.set(K,new Ee(j,U)),K}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,U,K,J){const te=this.t(new f(this.h,K),j),ue=J&&J.label||Re.u(j);return this.e.$registerDocumentSymbolProvider(te,this.o(U,j),ue),this.p(te)}$provideDocumentSymbols(j,U,K){return this.s(j,f,J=>J.provideDocumentSymbols(l.URI.revive(U),K),void 0,K)}registerCodeLensProvider(j,U,K){const J=this.q(),te=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ee(new u(this.h,this.j.converter,K,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(J,this.o(U,j),te);let ue=this.p(J);if(te!==void 0){const Ae=K.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(te));ue=s.$vM.from(ue,Ae)}return ue}$provideCodeLenses(j,U,K){return this.s(j,u,J=>J.provideCodeLenses(l.URI.revive(U),K),void 0,K)}$resolveCodeLens(j,U,K){return this.s(j,u,J=>J.resolveCodeLens(U,K),void 0,void 0)}$releaseCodeLenses(j,U){this.s(j,u,K=>Promise.resolve(K.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(j,U,K){const J=this.t(new I(this.h,K),j);return this.e.$registerDefinitionSupport(J,this.o(U,j)),this.p(J)}$provideDefinition(j,U,K,J){return this.s(j,I,te=>te.provideDefinition(l.URI.revive(U),K,J),[],J)}registerDeclarationProvider(j,U,K){const J=this.t(new D(this.h,K),j);return this.e.$registerDeclarationSupport(J,this.o(U,j)),this.p(J)}$provideDeclaration(j,U,K,J){return this.s(j,D,te=>te.provideDeclaration(l.URI.revive(U),K,J),[],J)}registerImplementationProvider(j,U,K){const J=this.t(new y(this.h,K),j);return this.e.$registerImplementationSupport(J,this.o(U,j)),this.p(J)}$provideImplementation(j,U,K,J){return this.s(j,y,te=>te.provideImplementation(l.URI.revive(U),K,J),[],J)}registerTypeDefinitionProvider(j,U,K){const J=this.t(new p(this.h,K),j);return this.e.$registerTypeDefinitionSupport(J,this.o(U,j)),this.p(J)}$provideTypeDefinition(j,U,K,J){return this.s(j,p,te=>te.provideTypeDefinition(l.URI.revive(U),K,J),[],J)}registerHoverProvider(j,U,K,J){const te=this.t(new k(this.h,K),j);return this.e.$registerHoverProvider(te,this.o(U,j)),this.p(te)}$provideHover(j,U,K,J,te){return this.s(j,k,ue=>ue.provideHover(l.URI.revive(U),K,J,te),void 0,te)}$releaseHover(j,U){this.s(j,k,K=>Promise.resolve(K.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(j,U,K,J){const te=this.t(new m(this.h,K),j);return this.e.$registerEvaluatableExpressionProvider(te,this.o(U,j)),this.p(te)}$provideEvaluatableExpression(j,U,K,J){return this.s(j,m,te=>te.provideEvaluatableExpression(l.URI.revive(U),K,J),void 0,J)}registerInlineValuesProvider(j,U,K,J){const te=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,ue=this.t(new v(this.h,K),j);this.e.$registerInlineValuesProvider(ue,this.o(U,j),te);let Ae=this.p(ue);if(te!==void 0){const je=K.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(te));Ae=s.$vM.from(Ae,je)}return Ae}$provideInlineValues(j,U,K,J,te){return this.s(j,v,ue=>ue.provideInlineValues(l.URI.revive(U),K,J,te),void 0,te)}registerDocumentHighlightProvider(j,U,K){const J=this.t(new F(this.h,K),j);return this.e.$registerDocumentHighlightProvider(J,this.o(U,j)),this.p(J)}registerMultiDocumentHighlightProvider(j,U,K){const J=this.t(new M(this.h,K),j);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(U,j)),this.p(J)}$provideDocumentHighlights(j,U,K,J){return this.s(j,F,te=>te.provideDocumentHighlights(l.URI.revive(U),K,J),void 0,J)}$provideMultiDocumentHighlights(j,U,K,J,te){return this.s(j,M,ue=>ue.provideMultiDocumentHighlights(l.URI.revive(U),K,J.map(Ae=>l.URI.revive(Ae)),te),void 0,te)}registerLinkedEditingRangeProvider(j,U,K){const J=this.t(new G(this.h,K),j);return this.e.$registerLinkedEditingRangeProvider(J,this.o(U,j)),this.p(J)}$provideLinkedEditingRanges(j,U,K,J){return this.s(j,G,async te=>{const ue=await te.provideLinkedEditingRanges(l.URI.revive(U),K,J);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?Re.y(ue.wordPattern):void 0}},void 0,J)}registerReferenceProvider(j,U,K){const J=this.t(new q(this.h,K),j);return this.e.$registerReferenceSupport(J,this.o(U,j)),this.p(J)}$provideReferences(j,U,K,J,te){return this.s(j,q,ue=>ue.provideReferences(l.URI.revive(U),K,J,te),void 0,te)}registerCodeActionProvider(j,U,K,J){const te=new T.$Tc,ue=this.t(new V(this.h,this.j.converter,this.k,K,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(ue,this.o(U,j),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,te)}))},Re.u(j),Re.w(j),!!K.resolveCodeAction),te.add(this.p(ue)),te}$provideCodeActions(j,U,K,J,te){return this.s(j,V,ue=>ue.provideCodeActions(l.URI.revive(U),K,J,te),void 0,te)}$resolveCodeAction(j,U,K){return this.s(j,V,J=>J.resolveCodeAction(U,K),{},void 0)}$releaseCodeActions(j,U){this.s(j,V,K=>Promise.resolve(K.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(j,U,K){const J=this.t(new L(this.h,K),j);return this.e.$registerDocumentFormattingSupport(J,this.o(U,j),j.identifier,j.displayName||j.name),this.p(J)}$provideDocumentFormattingEdits(j,U,K,J){return this.s(j,L,te=>te.provideDocumentFormattingEdits(l.URI.revive(U),K,J),void 0,J)}registerDocumentRangeFormattingEditProvider(j,U,K){const J=typeof K.provideDocumentRangesFormattingEdits=="function",te=this.t(new Z(this.h,K),j);return this.e.$registerRangeFormattingSupport(te,this.o(U,j),j.identifier,j.displayName||j.name,J),this.p(te)}$provideDocumentRangeFormattingEdits(j,U,K,J,te){return this.s(j,Z,ue=>ue.provideDocumentRangeFormattingEdits(l.URI.revive(U),K,J,te),void 0,te)}$provideDocumentRangesFormattingEdits(j,U,K,J,te){return this.s(j,Z,ue=>ue.provideDocumentRangesFormattingEdits(l.URI.revive(U),K,J,te),void 0,te)}registerOnTypeFormattingEditProvider(j,U,K,J){const te=this.t(new re(this.h,K),j);return this.e.$registerOnTypeFormattingSupport(te,this.o(U,j),J,j.identifier),this.p(te)}$provideOnTypeFormattingEdits(j,U,K,J,te,ue){return this.s(j,re,Ae=>Ae.provideOnTypeFormattingEdits(l.URI.revive(U),K,J,te,ue),void 0,ue)}registerWorkspaceSymbolProvider(j,U){const K=this.t(new fe(U,this.l),j);return this.e.$registerNavigateTypeSupport(K,typeof U.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(j,U,K){return this.s(j,fe,J=>J.provideWorkspaceSymbols(U,K),{symbols:[]},K)}$resolveWorkspaceSymbol(j,U,K){return this.s(j,fe,J=>J.resolveWorkspaceSymbol(U,K),void 0,void 0)}$releaseWorkspaceSymbols(j,U){this.s(j,fe,K=>K.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(j,U,K){const J=this.t(new be(this.h,K,this.l),j);return this.e.$registerRenameSupport(J,this.o(U,j),be.supportsResolving(K)),this.p(J)}$provideRenameEdits(j,U,K,J,te){return this.s(j,be,ue=>ue.provideRenameEdits(l.URI.revive(U),K,J,te),void 0,te)}$resolveRenameLocation(j,U,K,J){return this.s(j,be,te=>te.resolveRenameLocation(l.URI.revive(U),K,J),void 0,J)}registerNewSymbolNamesProvider(j,U,K){const J=this.t(new oe(this.h,K,this.l),j);return this.e.$registerNewSymbolNamesProvider(J,this.o(U,j)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,oe,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,U,K,J,te){return this.s(j,oe,ue=>ue.provideNewSymbolNames(l.URI.revive(U),K,J,te),void 0,te)}registerDocumentSemanticTokensProvider(j,U,K,J){const te=this.t(new $e(this.h,K),j),ue=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(U,j),J,ue);let Ae=this.p(te);if(ue){const je=K.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(ue));Ae=s.$vM.from(Ae,je)}return Ae}$provideDocumentSemanticTokens(j,U,K,J){return this.s(j,$e,te=>te.provideDocumentSemanticTokens(l.URI.revive(U),K,J),null,J)}$releaseDocumentSemanticTokens(j,U){this.s(j,$e,K=>K.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,U,K,J){const te=this.t(new se(this.h,K),j);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(U,j),J),this.p(te)}$provideDocumentRangeSemanticTokens(j,U,K,J){return this.s(j,se,te=>te.provideDocumentRangeSemanticTokens(l.URI.revive(U),K,J),null,J)}registerCompletionItemProvider(j,U,K,J){const te=this.t(new Ce(this.h,this.j.converter,K,this.m,j),j);return this.e.$registerCompletionsProvider(te,this.o(U,j),J,Ce.supportsResolving(K),j.identifier),this.p(te)}$provideCompletionItems(j,U,K,J,te){return this.s(j,Ce,ue=>ue.provideCompletionItems(l.URI.revive(U),K,J,te),void 0,te)}$resolveCompletionItem(j,U,K){return this.s(j,Ce,J=>J.resolveCompletionItem(U,K),void 0,K)}$releaseCompletionItems(j,U){this.s(j,Ce,K=>K.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(j,U,K,J){const te=new Y(j,this.h,K,this.j.converter),ue=this.t(te,j);return this.e.$registerInlineCompletionsSupport(ue,this.o(U,j),te.supportsHandleEvents,h.$Wm.toKey(j.identifier.value),J?.yieldTo?.map(Ae=>h.$Wm.toKey(Ae))||[]),this.p(ue)}$provideInlineCompletions(j,U,K,J,te){return this.s(j,Fe,ue=>ue.provideInlineCompletions(l.URI.revive(U),K,J,te),void 0,te)}$handleInlineCompletionDidShow(j,U,K,J){this.s(j,Fe,async te=>{te.handleDidShowCompletionItem(U,K,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,U,K,J,te){this.s(j,Fe,async ue=>{ue.handlePartialAccept(U,K,J,te)},void 0,void 0)}$freeInlineCompletionsList(j,U){this.s(j,Fe,async K=>{K.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(j,U,K){const J=new W(j,this.h,K,this.j.converter),te=this.t(J,j);return this.e.$registerInlineEditProvider(te,this.o(U,j),j.identifier),this.p(te)}$provideInlineEdit(j,U,K,J){return this.s(j,W,te=>te.provideInlineEdits(l.URI.revive(U),K,J),void 0,J)}$freeInlineEdit(j,U){this.s(j,W,async K=>{K.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(j,U,K,J){const te=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,ue=this.t(new De(this.h,K),j);return this.e.$registerSignatureHelpProvider(ue,this.o(U,j),te),this.p(ue)}$provideSignatureHelp(j,U,K,J,te){return this.s(j,De,ue=>ue.provideSignatureHelp(l.URI.revive(U),K,J,te),void 0,te)}$releaseSignatureHelp(j,U){this.s(j,De,K=>K.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(j,U,K){const J=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new he(this.h,this.j.converter,K,this.l,j),j);this.e.$registerInlayHintsProvider(te,this.o(U,j),typeof K.resolveInlayHint=="function",J,Re.u(j));let ue=this.p(te);if(J!==void 0){const Ae=K.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(J));ue=s.$vM.from(ue,Ae)}return ue}$provideInlayHints(j,U,K,J){return this.s(j,he,te=>te.provideInlayHints(l.URI.revive(U),K,J),void 0,J)}$resolveInlayHint(j,U,K){return this.s(j,he,J=>J.resolveInlayHint(U,K),void 0,K)}$releaseInlayHints(j,U){this.s(j,he,K=>K.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(j,U,K){const J=this.t(new ve(this.h,K),j);return this.e.$registerDocumentLinkProvider(J,this.o(U,j),typeof K.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(j,U,K){return this.s(j,ve,J=>J.provideLinks(l.URI.revive(U),K),void 0,K,U.scheme==="output")}$resolveDocumentLink(j,U,K){return this.s(j,ve,J=>J.resolveLink(U,K),void 0,void 0,!0)}$releaseDocumentLinks(j,U){this.s(j,ve,K=>K.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(j,U,K){const J=this.t(new ae(this.h,K),j);return this.e.$registerDocumentColorProvider(J,this.o(U,j)),this.p(J)}$provideDocumentColors(j,U,K){return this.s(j,ae,J=>J.provideColors(l.URI.revive(U),K),[],K)}$provideColorPresentations(j,U,K,J){return this.s(j,ae,te=>te.provideColorPresentations(l.URI.revive(U),K,J),void 0,J)}registerFoldingRangeProvider(j,U,K){const J=this.q(),te=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ee(new X(this.h,K),j)),this.e.$registerFoldingRangeProvider(J,this.o(U,j),j.identifier,te);let ue=this.p(J);if(te!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));ue=s.$vM.from(ue,Ae)}return ue}$provideFoldingRanges(j,U,K,J){return this.s(j,X,te=>te.provideFoldingRanges(l.URI.revive(U),K,J),void 0,J)}registerSelectionRangeProvider(j,U,K){const J=this.t(new x(this.h,K,this.l),j);return this.e.$registerSelectionRangeProvider(J,this.o(U,j)),this.p(J)}$provideSelectionRanges(j,U,K,J){return this.s(j,x,te=>te.provideSelectionRanges(l.URI.revive(U),K,J),[],J)}registerCallHierarchyProvider(j,U,K){const J=this.t(new me(this.h,K),j);return this.e.$registerCallHierarchyProvider(J,this.o(U,j)),this.p(J)}$prepareCallHierarchy(j,U,K,J){return this.s(j,me,te=>Promise.resolve(te.prepareSession(l.URI.revive(U),K,J)),void 0,J)}$provideCallHierarchyIncomingCalls(j,U,K,J){return this.s(j,me,te=>te.provideCallsTo(U,K,J),void 0,J)}$provideCallHierarchyOutgoingCalls(j,U,K,J){return this.s(j,me,te=>te.provideCallsFrom(U,K,J),void 0,J)}$releaseCallHierarchy(j,U){this.s(j,me,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(j,U,K){const J=this.t(new ge(this.h,K),j);return this.e.$registerTypeHierarchyProvider(J,this.o(U,j)),this.p(J)}$prepareTypeHierarchy(j,U,K,J){return this.s(j,ge,te=>Promise.resolve(te.prepareSession(l.URI.revive(U),K,J)),void 0,J)}$provideTypeHierarchySupertypes(j,U,K,J){return this.s(j,ge,te=>te.provideSupertypes(U,K,J),void 0,J)}$provideTypeHierarchySubtypes(j,U,K,J){return this.s(j,ge,te=>te.provideSubtypes(U,K,J),void 0,J)}$releaseTypeHierarchy(j,U){this.s(j,ge,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(j,U,K,J){const te=this.q();return this.f.set(te,new Ee(new Me(this.e,this.h,K,te,j),j)),this.e.$registerDocumentOnDropEditProvider(te,this.o(U,j),(0,n.$SG)(j,"documentPaste")&&J?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(te)}$provideDocumentOnDropEdits(j,U,K,J,te,ue){return this.s(j,Me,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(U,l.URI.revive(K),J,te,ue)),void 0,void 0)}$resolveDropEdit(j,U,K){return this.s(j,Me,J=>J.resolveDropEdit(U,K),{},void 0)}$releaseDropEdits(j,U){this.s(j,Me,K=>Promise.resolve(K.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(j,U,K){const J=this.t(new Be(this.h,K),j);return this.e.$registerMappedEditsProvider(J,this.o(U,j)),this.p(J)}$provideMappedEdits(j,U,K,J,te){return this.s(j,Be,ue=>Promise.resolve(ue.provideMappedEdits(U,K,J,te)),null,te)}registerDocumentPasteEditProvider(j,U,K,J){const te=this.q();return this.f.set(te,new Ee(new N(this.e,this.h,K,te,j),j)),this.e.$registerPasteEditProvider(te,this.o(U,j),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(ue=>ue.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(j,U,K,J,te){return this.s(j,N,ue=>ue.prepareDocumentPaste(l.URI.revive(U),K,J,te),void 0,te)}$providePasteEdits(j,U,K,J,te,ue,Ae){return this.s(j,N,je=>je.providePasteEdits(U,l.URI.revive(K),J,te,ue,Ae),void 0,Ae)}$resolvePasteEdit(j,U,K){return this.s(j,N,J=>J.resolvePasteEdit(U,K),{},void 0)}$releasePasteEdits(j,U){this.s(j,N,K=>Promise.resolve(K.releasePasteEdits(U)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Re.y(j.decreaseIndentPattern),increaseIndentPattern:Re.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Re.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Re.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Re.y(j.beforeText),afterText:j.afterText?Re.y(j.afterText):void 0,previousLineText:j.previousLineText?Re.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Re.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(U=>s.SyntaxTokenType.toString(U)):void 0}}static E(j){return j.map(Re.D)}setLanguageConfiguration(j,U,K){const{wordPattern:J}=K;if(J&&(0,C.$nf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(U,J):this.h.setWordDefinitionFor(U,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const te=this.q(),ue={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,U,ue),this.p(te)}$setWordDefinitions(j){for(const U of j)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$Imc=Re}),define(ke[95],Ie([1,0,11,22,14,4,40,6,182,19,3,12,77,5,91,17,10,7,115,25]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=void 0,e.$pnc=(0,C.$Ai)("IExtHostLanguageModels");class n{constructor(u,b){this.option=u,this.stream=new E.$4h,this.stream=b??new E.$4h}}class i{constructor(){this.a=new Map,this.b=new E.$4h,this.c=!1,this.d=!1;const u=this;this.apiObject={text:u.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,u]of this.a)yield u.stream;else yield this.b}handleFragment(u){if(this.c)return;this.d=!0;let b=this.a.get(u.index);b||(this.a.size===0?b=new n(u.index,this.b):b=new n(u.index),this.a.set(u.index,b)),b.stream.emitOne(u.part)}get isStreaming(){return this.d}reject(u){this.c=!0;for(const b of this.f())b.reject(u)}resolve(){this.c=!0;for(const u of this.f())u.resolve()}}let g=class{static{s=this}static{this.a=1}constructor(u,b,I){this.j=b,this.k=I,this.c=new O.$he,this.d=new O.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$Ym,this.i=new Map,this.r=new Set,this.b=u.getProxy(S.$tM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(u,b,I,D){const y=s.a++;this.f.set(y,{extension:u.identifier,provider:I,languageModelId:b});let p;D.auth&&(p={providerLabel:u.displayName||u.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$Wm.toKey(u.identifier)}/${y}/${b}`,{extension:u.identifier,id:b,vendor:D.vendor??c.$Wm.toKey(u.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:p,targetExtensions:D.extensions});const k=I.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:v,tokenCount:F})=>{this.b.$whenLanguageModelChatRequestMade(b,new c.$Wm(m),v,F)});return(0,T.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),k?.dispose()})}async $provideLanguageModelResponse(u,b,I,D,y,p){const k=this.f.get(u);if(!k)return;const m=new l.$mw(async v=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(b,{index:v.index,part:v.part})});return k.provider.provideLanguageModelResponse(D.map(o.LanguageModelChatMessage.to),y,c.$Wm.toKey(I),m,p)}$provideTokenLength(u,b,I){const D=this.f.get(u);return D?Promise.resolve(D.provider.provideTokenCount(b,I)):Promise.resolve(0)}$acceptChatModelMetadata(u){if(u.added)for(const{identifier:b,metadata:I}of u.added)this.g.set(b,{metadata:I,apiObjects:new c.$Ym});if(u.removed)for(const b of u.removed){this.g.delete(b);for(const[I,D]of this.i)D.languageModelId===b&&(D.res.reject(new P.$5),this.i.delete(I))}u.added?.forEach(b=>this.p(b.metadata)),this.d.fire(void 0)}async selectLanguageModels(u,b){const I=await this.b.$selectChatModels({...b,extension:u.identifier}),D=[],y=this;for(const p of I){const k=this.g.get(p);if(!k)continue;let m=k.apiObjects.get(u.identifier);m||(m={id:p,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(v,F){if(!y.g.has(p))throw a.$KO.NotFound(p);return y.q(p,v,F??R.CancellationToken.None)},sendRequest(v,F,M){if(!y.g.has(p))throw a.$KO.NotFound(p);return y.l(u,p,v,F??{},M??R.CancellationToken.None)}},Object.freeze(m),k.apiObjects.set(u.identifier,m)),D.push(m)}return D}async l(u,b,I,D,y){const p=this.m(u,I),k=u.identifier,m=this.g.get(b)?.metadata;if(!m||!this.g.has(b))throw a.$KO.NotFound(`Language model '${b}' is unknown.`);if(this.o(k,m)&&(!await this.n(u,{identifier:m.extension,displayName:m.auth.providerLabel},D.justification,!1)||!this.h.get(k)?.has(m.extension)))throw a.$KO.NoPermissions(`Language model '${b}' cannot be used by '${k.value}'.`);const v=Math.random()*1e6|0,F=this.b.$fetchResponse(k,b,v,p,D.modelOptions??{},y),M=new E.$zh,G=new i;this.i.set(v,{languageModelId:b,res:G});let q;if(F.catch(V=>{M.isOpen()?G.reject(V):q=V}).finally(()=>{this.i.delete(v),G.resolve(),M.open()}),await M.wait(),q)throw q.name===a.$KO.name?q:new a.$KO(`Language model '${b}' errored, check cause for more details`,"Unknown",q);return G.apiObject}m(u,b){const I=[];for(const D of b)D.role===a.LanguageModelChatMessageRole.System&&(0,t.$TG)(u,"languageModelSystem"),I.push(o.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(u,b){const I=this.i.get(u);I&&I.res.handleFragment(b)}async n(u,b,I,D){const y=h.$vL+b.identifier.value;if(await this.k.getSession(u,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:b.identifier,enabled:!0}]),!0;if(D)return!1;try{const k=I?(0,$.localize)(0,null,b.displayName,I):void 0;return await this.k.getSession(u,y,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:u.identifier,to:b.identifier,enabled:!0}]),!0}catch{return!1}}o(u,b){return!!b.auth&&!c.$Wm.equals(b.extension,u)}async p(u){for(const b of this.r)try{await this.n(b,{identifier:u.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(u,b,I){if(!this.g.get(u))throw a.$KO.NotFound(`Language model '${u}' is unknown.`);const y=A.Iterable.find(this.f.values(),p=>p.languageModelId===u);return y?y.provider.provideTokenCount(b,I):this.b.$countTokens(u,typeof b=="string"?b:o.LanguageModelChatMessage.from(b),I)}$updateModelAccesslist(u){const b=new Array;for(const{from:I,to:D,enabled:y}of u){const p=this.h.get(I)??new c.$Xm;if(p.has(D)!==y){y?p.add(D):p.delete(D),this.h.set(I,p);const m={from:I,to:D};b.push(m),this.c.fire(m)}}}createLanguageModelAccessInformation(u){this.r.add(u);const b=this,I=O.Event.signal(O.Event.filter(this.c.event,y=>c.$Wm.equals(y.from,u.identifier))),D=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(I,D)},canSendRequest(y){let p;e:for(const[m,v]of b.g)for(const F of v.apiObjects.values())if(F===y){p=v.metadata;break e}if(!p)return;if(!b.o(u.identifier,p))return!0;const k=b.h.get(u.identifier);if(k)return k.has(p.extension)}}}};e.$qnc=g,e.$qnc=g=s=He([Ve(0,r.$XO),Ve(1,w.$7j),Ve(2,d.$Kmc)],g)}),define(ke[285],Ie([1,0,5,10,7,35,11,6,25]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class c{constructor(w,l,S,d){this.c=l,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=w.getProxy(E.$tM.MainThreadLanguages)}$acceptLanguageIds(w){this.b=w}async getLanguages(){return this.b.slice(0)}async changeLanguage(w,l){await this.a.$changeLanguage(w,l);const S=this.c.getDocumentData(w);if(!S)throw new Error(`document '${w.toString()}' NOT found`);return S.document}async tokenAtPosition(w,l){const S=w.version,d=R.Position.from(l),r=await this.a.$tokensAtPosition(w.uri,d),o={type:P.StandardTokenType.Other,range:w.getWordRangeAtPosition(l)??new P.$xM(l.line,l.character,l.line,l.character)};if(!r)return o;const a={range:R.Range.to(r.range),type:R.TokenType.to(r.type)};return!a.range.contains(l)||S!==w.version?o:a}createLanguageStatusItem(w,l,S){const d=this.f++,r=this.a,o=this.g,a=`${w.identifier.value}/${l}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(a);const h={selector:S,id:l,name:w.displayName??w.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const s=new T.$Tc,n=()=>{if(t?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${l}) from ${w.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,A.$Ch)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??w.displayName??w.name,source:w.displayName??w.name,selector:R.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?O.default.Error:h.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},i={dispose(){s.dispose(),t?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(g){h.name=g,n()},get selector(){return h.selector},set selector(g){h.selector=g,n()},get text(){return h.text},set text(g){h.text=g,n()},set text2(g){(0,$.$TG)(w,"languageStatusText"),h.text=g,n()},get text2(){return(0,$.$TG)(w,"languageStatusText"),h.text},get detail(){return h.detail},set detail(g){h.detail=g,n()},get severity(){return h.severity},set severity(g){h.severity=g,n()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(g){h.accessibilityInformation=g,n()},get command(){return h.command},set command(g){h.command=g,n()},get busy(){return h.busy},set busy(g){h.busy=g,n()}};return n(),i}}e.$8nc=c}),define(ke[286],Ie([1,0,16,2,10,7,90]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;class T{constructor(w,l,S,d){this.start=w,this.deletedCount=l,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$XN(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1}}constructor(w,l,S){this.notebook=w,this.h=l,this.j=S,this.handle=S.handle,this.uri=R.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return w.g},set mime(d){w.g=d},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(S)}return this.f}setOutputs(w){this.a=w.map(P.NotebookCellOutput.to)}setOutputItems(w,l,S){const d=S.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===w);if(r&&(l||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>A.$pK(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let t;o.has(h.mime)?t=o.get(h.mime):(t=[],o.set(h.mime,t),a.push(h.mime)),t.push(h.data)}),r.items.length=0,a.forEach(h=>{const t=A.$qK(o.get(h));r.items.push({mime:h,data:t.data.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.$Tnc=$;class c{static{this.a=0}constructor(w,l,S,d,r){this.k=w,this.l=l,this.m=S,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const w=this,l={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===E.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(S){return S=w.n(S),w.b[S].apiCell},getCells(S){return(S?w.p(S):w.b).map(r=>r.apiCell)},save(){return w.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,l,S){this.g=w.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},r=[];for(const a of w.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],t=o.get(h.cell);if(t===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[t]={...d.cellChanges[t],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let l=w.start|0,S=w.end|0;return l<0&&(l=0),S>this.b.length&&(S=this.b.length),w.with({start:l,end:S})}p(w){w=this.o(w);const l=[];for(let S=w.start;S<w.end;S++)l.push(this.b[S]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,l,S){if(this.j)return;const d=[],r=[],o=[];if(w.reverse().forEach(a=>{const t=a[2].map(i=>{const g=new $(this,this.l,i);return l||r.push($.asModelAddData(i)),g}),s=new T(a[0],a[1],[],t),n=this.b.splice(a[0],a[1],...t);for(const i of n)o.push(i.uri),s.deletedItems.push(i.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),S)for(const a of d)S.push(a.asApiEvent())}s(w,l,S,d){const r=this.b.splice(w,l);this.b.splice(S,0,...r);const o=[new T(w,l,r.map(a=>a.apiCell),[]),new T(S,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(w,l){this.b[w].setOutputs(l)}u(w,l,S,d){this.b[w].setOutputItems(l,S,d)}v(w,l){const S=this.b[w];S.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(S.uri,l)}w(w,l){const S=this.b[w];S.apiCell.mime=l}x(w,l){this.b[w].setMetadata(l)}y(w,l){this.b[w].setInternalMetadata(l)}getCellFromApiCell(w){return this.b.find(l=>l.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(l=>l.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.$Unc=c}),define(ke[287],Ie([1,0,4,2,10,7,38]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;class T{constructor(c,C,w,l={timeout:1500,errors:3}){this.b=c,this.c=C,this.d=w,this.f=l,this.a=new E.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(C,w,l)=>{const S=function(r){C.call(w,r)};return S.extension=c,this.a.event(S,void 0,l)}}async $participateInSave(c,C,w){const l=R.URI.revive(c),S=this.c.getNotebookDocument(l);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(C)},w,async(o,a)=>{const h=Date.now(),t=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!w.isCancellationRequested&&t&&(t instanceof O.$FM?d.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),w.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new A.$Kw(r))}}e.$0nc=T}),define(ke[122],Ie([1,0,14,10,7]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,c,C,w,l){this.id=T,this.f=$,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=C,this.c=l}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(P.$XN.isNotebookRange))throw(0,E.$7)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,c){T.f.$tryRevealRange(T.id,R.NotebookRange.from($),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(R.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Vnc=O}),define(ke[288],Ie([1,0,4,12,10]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;let O=class{constructor(T,$){this.c=T,this.d=$,this.a=new E.$he,this.b=new E.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const c=this.d.getEditorById(T);$.visibleRanges&&c._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&c._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(T[$]))}};e.$_nc=O,e.$_nc=O=He([Ve(0,R.$7j)],O)}),define(ke[289],Ie([1,0,4,5,122]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class O{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(R.$tM.MainThreadNotebookRenderers)}$postRendererMessage(T,$,c){const C=this.c.getEditorById(T);this.a.get($)?.fire({editor:C.apiEditor,message:c})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(C=>C.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(C,w,l)=>this.d($).event(C,w,l),postMessage:(C,w)=>{P.$Vnc.apiEditorsToExtHost.has(C)&&([C,w]=[w,C]);const l=w&&P.$Vnc.apiEditorsToExtHost.get(w);return this.b.$postMessage(l?.id,$,C)}}}d(T){let $=this.a.get(T);return $||($=new E.$he({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$coc=O}),define(ke[290],Ie([1,0,10,77,22,72,14]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;class T{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,l,S){const d=this.b++,{title:r,location:o,cancellable:a}=l,h={label:w.displayName||w.name,id:w.identifier.value};return this.a.$startProgress(d,{location:E.ProgressLocation.from(o),title:r,source:h,cancellable:a},w.isUnderDevelopment?void 0:w.identifier.value).catch(A.$2),this.d(d,S,!!a)}d(w,l,S){let d;S&&(d=new P.$se,this.c.set(w,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=l(new c(this.a,w),S&&d?d.token:P.CancellationToken.None)}catch(a){throw r(w),a}return o.then(a=>r(w),a=>r(w)),o}$acceptProgressCanceled(w){const l=this.c.get(w);l&&(l.cancel(),this.c.delete(w))}}e.$goc=T;function $(C,w){return C.message=w.message,typeof w.increment=="number"&&(typeof C.increment=="number"?C.increment+=w.increment:C.increment=w.increment),C}class c extends R.$mw{constructor(w,l){super(S=>this.throttledReport(S)),this.c=w,this.d=l}throttledReport(w){this.c.$progressReport(this.d,w)}}He([(0,O.$7h)(100,(C,w)=>$(C,w),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[291],Ie([1,0,2,5,11,10]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class A{static{this.a=0}constructor($,c){this.d=c,this.c=new Map,this.b=$.getProxy(R.$tM.MainThreadQuickDiff)}$provideOriginalResource($,c,C){const w=E.URI.revive(c),l=this.c.get($);return l?(0,P.$sh)(()=>l.provideOriginalResource(w,C)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,c,C,w){const l=A.a++;return this.c.set(l,c),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from($,this.d),C,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$hoc=A}),define(ke[292],Ie([1,0,22,4,6,5,2,7,14,18,35,34,25,10]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=d;function d(r,o,a){const h=r.getProxy(O.$tM.MainThreadQuickOpen);class t{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,p,k=E.CancellationToken.None){this.c=void 0;const m=Promise.resolve(y),v=++this.f,F=h.$show(v,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},k),M={},G=F.then(()=>M);return Promise.race([G,m]).then(q=>{if(q===M)return;const V=(0,l.$SG)(D,"quickPickItemTooltip");return m.then(N=>{const L=[];for(let Z=0;Z<N.length;Z++){const re=N[Z];if(typeof re=="string")L.push({label:re,handle:Z});else if(re.kind===T.QuickPickItemKind.Separator)L.push({type:"separator",label:re.label});else{re.tooltip&&!V&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const fe=re.iconPath?f(re.iconPath):void 0;L.push({label:re.label,iconPath:fe?.iconPath,iconClass:fe?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:V?S.MarkdownString.fromStrict(re.tooltip):void 0,handle:Z})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=Z=>{p.onDidSelectItem(N[Z])}),h.$setItems(v,L),F.then(Z=>{if(typeof Z=="number")return N[Z];if(Array.isArray(Z))return Z.map(re=>N[re])})})}).then(void 0,q=>{if(!(0,$.$4)(q))return h.$setError(v,q),Promise.reject(q)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=E.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",y).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let p;switch(y.severity){case T.InputBoxValidationSeverity.Info:p=C.default.Info;break;case T.InputBoxValidationSeverity.Warning:p=C.default.Warning;break;case T.InputBoxValidationSeverity.Error:p=C.default.Error;break;default:p=y.message?C.default.Error:C.default.Ignore;break}return{content:y.message,severity:p}}async showWorkspaceFolderPick(D,y=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!p)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(m=>m.uri.toString()===p.uri.toString())}createQuickPick(D){const y=new u(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new b(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const p=this.e.get(D);p instanceof u&&p._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const p=this.e.get(D);p instanceof u&&p._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,p){const k=this.e.get(D);k instanceof u&&k._fireDidTriggerItemButton(y,p)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$he,this.q=new R.$he,this.r=new R.$he,this.s=new R.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,p)=>{const k=y===T.$UN.Back?-1:p;this.o.set(k,y)}),this.z({buttons:D.map((y,p)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===T.$UN.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const p=D[y];this.u[y]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function n(I){if(I instanceof T.$sN)return{id:I.id};const D=g(I),y=i(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof y=="string"?A.URI.file(y):y}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function g(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const D=n(I);let y,p;return"id"in D?p=w.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:p}}class u extends s{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$he,this.L=[],this.M=new R.$he,this.N=new R.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,m)=>{this.C.set(m,k),this.D.set(k,m)});const y=(0,l.$SG)(this.O,"quickPickItemTooltip"),p=[];for(let k=0;k<D.length;k++){const m=D[k];if(m.kind===T.QuickPickItemKind.Separator)p.push({type:"separator",label:m.label});else{m.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=m.iconPath?f(m.iconPath):void 0;p.push({handle:k,label:m.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:y?S.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((F,M)=>({...f(F.iconPath),tooltip:F.tooltip,handle:M}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Hb)(D.map(p=>this.C.get(p)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Hb)(D.map(p=>this.C.get(p)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const p=this.C.get(D);if(!p||!p.buttons||!p.buttons.length)return;const k=p.buttons[y];k&&this.N.fire({button:k,item:p})}}class b extends s{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:C.default.Error}):this.z({validationMessage:D.message,severity:D.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new t(o,a)}}),define(ke[293],Ie([1,0,2,4,72,6,11,5,18,158,12,19,37,34,10,25,16,21]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=void 0;function t(F){return F instanceof E.URI}function s(F,M){return F.scheme===o.Schemas.file&&M.scheme===o.Schemas.file&&a.$k?F.toString()===M.toString():F.toString().toLowerCase()===M.toString().toLowerCase()}function n(F){if(F)return typeof F.iconPath=="string"?E.URI.file(F.iconPath):E.URI.isUri(F.iconPath)||S.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function i(F){if(F.icon){if(E.URI.isUri(F.icon))return F.icon;if(S.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const M=F.icon;return{light:M.light,dark:M.dark}}}else return}function g(F,M){if(!F.iconPath&&!M.iconPath)return 0;if(F.iconPath){if(!M.iconPath)return 1}else return-1;const G=typeof F.iconPath=="string"?F.iconPath:E.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,q=typeof M.iconPath=="string"?M.iconPath:E.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,c.$yr)(G,q)}function f(F,M){let G=0;if(F.strikeThrough!==M.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==M.faded)return F.faded?1:-1;if(F.tooltip!==M.tooltip)return(F.tooltip||"").localeCompare(M.tooltip||"");if(G=g(F,M),G!==0)return G;if(F.light&&M.light)G=g(F.light,M.light);else{if(F.light)return 1;if(M.light)return-1}if(G!==0)return G;if(F.dark&&M.dark)G=g(F.dark,M.dark);else{if(F.dark)return 1;if(M.dark)return-1}return G}function u(F,M){if(F.command!==M.command)return F.command<M.command?-1:1;if(F.title!==M.title)return F.title<M.title?-1:1;if(F.tooltip!==M.tooltip){if(F.tooltip!==void 0&&M.tooltip!==void 0)return F.tooltip<M.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(F.arguments===M.arguments)return 0;if(F.arguments)if(M.arguments){if(F.arguments.length!==M.arguments.length)return F.arguments.length-M.arguments.length}else return 1;else return-1;for(let G=0;G<F.arguments.length;G++){const q=F.arguments[G],V=M.arguments[G];if(q!==V&&!(t(q)&&t(V)&&s(q,V)))return q<V?-1:1}return 0}function b(F,M){let G=(0,c.$yr)(F.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(G!==0)return G;if(F.command&&M.command)G=u(F.command,M.command);else{if(F.command)return 1;if(M.command)return-1}if(G!==0)return G;if(F.decorations&&M.decorations)G=f(F.decorations,M.decorations);else{if(F.decorations)return 1;if(M.decorations)return-1}if(F.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)G=(0,c.$yr)(F.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(F.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(F.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)G=(0,c.$yr)(F.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(F.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return G}function I(F,M){for(let G=0;G<F.length;G++)if(F[G]!==M[G])return!1;return!0}function D(F,M){return F.command===M.command&&F.title===M.title&&F.tooltip===M.tooltip&&(F.arguments&&M.arguments?I(F.arguments,M.arguments):F.arguments===M.arguments)}function y(F,M){return(0,$.$ub)(F,M,D)}class p{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.l,M),this.n(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.l,M),this.f=M}get validateInput(){return(0,r.$TG)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,r.$TG)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.l,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.l,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.l,M))}get document(){return(0,r.$TG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(M,G,q,V,N){this.k=M,this.l=V,this.m=N,this.d="",this.e=new R.$he,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(M,G){(0,r.$TG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,M,G)}$onInputBoxValueChange(M){this.n(M)}n(M){this.d=M,this.e.fire(M)}}e.$joc=p;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(M){this.v=M,this.q.$updateGroupLabel(this.t,this.handle,M)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(M){this.p=M,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,G,q,V,N,L,Z){this.q=M,this.s=G,this.t=q,this.u=V,this.v=N,this.multiDiffEditorEnableViewChanges=L,this.w=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,G){const q=this.h.get(M);return q?(0,A.$sh)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(b),q=(0,$.$Db)(this.o,M,b).map(L=>{const Z=L.toInsert.map(re=>{const fe=this.e++;this.g.set(fe,re);const be=re.resourceUri;let oe;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const X=new O.$Tc;oe=this.s.converter.toInternal(re.command,X),this.j.set(fe,X)}else this.h.set(fe,re.command);const pe=(0,r.$SG)(this.w,"scmMultiDiffEditor"),$e=pe?re.multiDiffEditorOriginalUri:void 0,se=pe?re.multiFileDiffEditorModifiedUri:void 0,Ce=n(re.decorations),Fe=re.decorations&&n(re.decorations.light)||Ce,Y=re.decorations&&n(re.decorations.dark)||Ce,W=[Fe,Y],ie=re.decorations&&re.decorations.tooltip||"",De=re.decorations&&!!re.decorations.strikeThrough,he=re.decorations&&!!re.decorations.faded,ve=re.contextValue||"";return{rawResource:[fe,be,W,ie,De,he,ve,oe,$e,se],handle:fe}});return{start:L.start,deleteCount:L.deleteCount,toInsert:Z}}),V=q.map(({start:L,deleteCount:Z,toInsert:re})=>[L,Z,re.map(fe=>fe.rawResource)]),N=q.reverse();for(const{start:L,deleteCount:Z,toInsert:re}of N){const fe=re.map(oe=>oe.handle),be=this.n.splice(L,Z,...fe);for(const oe of be)this.g.delete(oe),this.h.delete(oe),this.j.get(oe)?.dispose(),this.j.delete(oe)}return this.o=M,V}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.w,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let G;(0,r.$SG)(this.x,"quickDiffProvider")&&(G=M?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!M,quickDiffLabel:G})}get historyProvider(){return(0,r.$TG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(M){(0,r.$TG)(this.x,"scmHistoryProvider"),this.j=M,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!M}),M&&this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.l=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(M){M!==this.m&&(this.m=M,this.#e.$updateSourceControl(this.w,{commitTemplate:M}))}get acceptInputCommand(){return this.o}set acceptInputCommand(M){this.n.value=new O.$Tc,this.o=M;const G=this.y.converter.toInternal(M,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,r.$TG)(this.x,"scmActionButton"),this.q}set actionButton(M){(0,r.$TG)(this.x,"scmActionButton"),this.p.value=new O.$Tc,this.q=M;const G=M!==void 0?{command:this.y.converter.toInternal(M.command,this.p.value),secondaryCommands:M.secondaryCommands?.map(q=>q.map(V=>this.y.converter.toInternal(V,this.p.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(M){if(this.t&&M&&y(this.t,M))return;this.s.value=new O.$Tc,this.t=M;const G=(M||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(M,G,q,V,N,L,Z){this.x=M,this.y=V,this.z=N,this.A=L,this.B=Z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.m=void 0,this.n=new O.$Vc,this.o=void 0,this.p=new O.$Vc,this.s=new O.$Vc,this.t=void 0,this.u=!1,this.v=new R.$he,this.onDidChangeSelection=this.v.event,this.w=m.d++,this.C=new Map,this.D=new Set,this.#e=q;const re=E.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new p(M,G,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,N,L,Z,re)}createResourceGroup(M,G,q){const V=(0,r.$SG)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,N=new k(this.#e,this.y,this.w,M,G,V,this.x),L=R.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,L),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const M=[],G=[];for(const[q,V]of this.C){V.dispose();const N=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});R.Event.once(q.onDidDispose)(()=>{this.D.delete(q),N.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),M.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const L=q._takeResourceStateSnapshot();L.length>0&&G.push([q.handle,L]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,M,G),this.C.clear()}eventuallyUpdateResourceStates(){const M=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&M.push([G.handle,q])}),M.length>0&&this.#e.$spliceResourceStates(this.w,M),this.D.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.u=M,this.v.fire(M)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.w)}}He([(0,P.$6h)(100)],m.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$6h)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(M,G,q,V){this.l=G,this.m=q,this.n=V,this.g=new Map,this.h=new w.$Ym,this.j=new R.$he,this.e=M.getProxy(T.$tM.MainThreadSCM),this.f=M.getProxy(T.$tM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===l.MarshalledId.ScmResource){const L=this.g.get(N.sourceControlHandle);if(!L)return N;const Z=L.getResourceGroup(N.groupHandle);return Z?Z.getResourceState(N.handle):N}else if(N&&N.$mid===l.MarshalledId.ScmResourceGroup){const L=this.g.get(N.sourceControlHandle);return L?L.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===l.MarshalledId.ScmProvider){const L=this.g.get(N.handle);return L||N}return N}})}createSourceControl(M,G,q,V){this.n.trace("ExtHostSCM#createSourceControl",M.identifier.value,G,q,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const N=h.d++,L=new m(M,this.m,this.e,this.l,G,q,V);this.g.set(N,L);const Z=this.h.get(M.identifier)||[];return Z.push(L),this.h.set(M.identifier,Z),L}getLastInputBox(M){this.n.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const G=this.h.get(M.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(M,G,q){const V=E.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",M,V.toString());const N=this.g.get(M);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$sh)(()=>N.quickDiffProvider.provideOriginalResource(V,q)).then(L=>L||null)}$onInputBoxValueChange(M,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",M);const q=this.g.get(M);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(M,G,q,V){this.n.trace("ExtHostSCM#$executeResourceCommand",M,G,q);const N=this.g.get(M);if(!N)return Promise.resolve(void 0);const L=N.getResourceGroup(G);return L?L.$executeResourceCommand(q,V):Promise.resolve(void 0)}$validateInput(M,G,q){this.n.trace("ExtHostSCM#$validateInput",M);const V=this.g.get(M);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$sh)(()=>V.inputBox.validateInput(G,q)).then(N=>{if(!N)return Promise.resolve(void 0);const L=d.MarkdownString.fromStrict(N.message);return L?Promise.resolve([L,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,G,q,V){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,V)??void 0}async $provideHistoryItems(M,G,q,V){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(G,q,V))?.map(Z=>({...Z,icon:i(Z)}))??void 0}async $provideHistoryItemSummary(M,G,q,V){const N=this.g.get(M)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const L=await N.provideHistoryItemSummary(G,q,V);return L?{...L,icon:i(L)}:void 0}async $provideHistoryItemChanges(M,G,q,V){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(G,q,V)??void 0}};e.$koc=v,e.$koc=v=h=He([Ve(3,C.$7j)],v)}),define(ke[294],Ie([1,0,5,10,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class O{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(E.$tM.MainThreadShare)}async $provideShare(T,$,c){return await this.c.get(T)?.provideShare({selection:R.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},c)??void 0}registerShareProvider(T,$){const c=O.a++;return this.c.set(c,$),this.b.$registerShareProvider(c,R.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$loc=O}),define(ke[295],Ie([1,0,7,5,185,6,10,15]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$tN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$tN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,S,d,r,o,a=E.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=l,this.#t=S,o&&r){this.c=(0,E.$8M)(r.identifier,o);const t=d.get(this.c);t&&(a=t.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,h=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String($.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(l){if((0,T.$eg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!$.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let S;this.m?S=this.m:S=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,S,this.k,r,this.r?.internal,d,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$noc=$;class c{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const S={message:l};return this.b.unshift(S),this.c(),new E.$vM(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(l,S){this.e=new Map,this.a=l.getProxy(R.$tM.MainThreadStatusBar),this.b=S,this.c=new c(this)}$acceptStaticEntries(l){for(const S of l)this.e.set(S.entryId,S)}createStatusBarEntry(l,S,d,r){return new $(this.a,this.b,this.e,l,S,d,r)}setStatusBarMessage(l,S){const d=this.c.setMessage(l);let r;return typeof S=="number"?r=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new E.$vM(()=>{d.dispose(),clearTimeout(r)})}}e.$ooc=C}),define(ke[123],Ie([1,0,33,114,55,82,56,10,2]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aP=e.$_O=e.$$O=e.$0O=void 0;const c=(t,s,n,i)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(f){if(!n(g,f)){const u=g;g=f,t.listener?.(i(f,u))}}}},C=(t,s)=>t===s,w={range:(t,s)=>t===s?!0:!t||!s?!1:t.isEqual(s),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(t,s)=>!(t.length!==s.length||t.some(n=>!s.find(i=>n.id===i.id)))},l=t=>s=>({op:O.TestItemEventOp.SetProp,update:t(s)}),S=(t,s)=>({range:(()=>{let n;const i=l(g=>({range:E.$ct.lift(T.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return n},set(g){t.listener?.({op:O.TestItemEventOp.DocumentSynced}),w.range(n,g)||(n=g,t.listener?.(i(g)))}}})(),label:c(t,s,w.label,l(n=>({label:n}))),description:c(t,void 0,w.description,l(n=>({description:n}))),sortText:c(t,void 0,w.sortText,l(n=>({sortText:n}))),canResolveChildren:c(t,!1,w.canResolveChildren,n=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:c(t,!1,w.busy,l(n=>({busy:n}))),error:c(t,void 0,w.error,l(n=>({error:T.MarkdownString.fromStrict(n)||null}))),tags:c(t,[],w.tags,(n,i)=>({op:O.TestItemEventOp.SetTags,new:n.map(T.TestTag.from),old:i.map(T.TestTag.from)}))}),d=t=>{const s=P.$fL.fromString(t.extId),n=new o(s.controllerId,s.localId,t.label,$.URI.revive(t.uri)||void 0);return n.range=T.Range.to(t.range||void 0),n.description=t.description||void 0,n.sortText=t.sortText||void 0,n.tags=t.tags.map(i=>T.TestTag.to({id:(0,A.$lL)(i).tagId})),n},r=t=>{let s;for(const n of t.tests){const i=d(n.item);(0,R.$TO)(i).parent=s,s=i}return s};e.$0O=r;class o{constructor(s,n,i,g){if(n.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const f=(0,R.$SO)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,O.$RO)(f,R.$TO,o),enumerable:!0,writable:!1},...S(f,i)})}}e.$$O=o;class a extends o{constructor(s,n){super(s,s,n,void 0),this._isRoot=!0}}e.$_O=a;class h extends O.$NO{constructor(s,n,i){super({controllerId:s,getDocumentVersion:g=>g&&i.getDocument(g)?.version,getApiFor:R.$TO,getChildren:g=>g.children,root:new a(s,n),toITestItem:T.TestItem.from})}}e.$aP=h}),define(ke[39],Ie([1,0,15,7,10,26,5,18,12,49,33,100,2,6,3,17,123,23,38,48,69,63,66,36]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=void 0;let f=class{#e;#t;#i;constructor(p,k,m){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$tM.MainThreadCommands),this.d=k,this.#i=m,this.#t=p.getProxy(A.$tM.MainThreadTelemetry),this.converter=new u(this,v=>{const F=this.c.get(v);return F?.result===I.Void?F:void 0},k),this.f=[{processArgument(v){return(0,c.$0h)(v)}},{processArgument(v){return(0,O.$$n)(v,function(F){if(C.$ct.isIRange(F))return P.Range.to(F);if(w.$bt.isIPosition(F))return P.Position.to(F);if(C.$ct.isIRange(F.range)&&l.URI.isUri(F.uri))return P.location.to(F);if(F instanceof a.$Je)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const k=this.registerCommand(!1,p.id,async(...m)=>{const v=p.args.map((M,G)=>{if(!M.validate(m[G]))throw new Error(`Invalid argument '${M.name}' when running '${p.id}', received: ${typeof m[G]=="object"?JSON.stringify(m[G],null,"	"):m[G]} `);return M.convert(m[G])}),F=await this.executeCommand(p.internalId,...v);return p.result.convert(F,m,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new R.$vM(()=>{k.dispose(),this.c.delete(p.id)})}registerCommand(p,k,m,v,F,M){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:m,thisArg:v,metadata:F,extension:M}),p&&this.#e.$registerCommand(k),new R.$vM(()=>{this.b.delete(k)&&p&&this.#e.$unregisterCommand(k)})}executeCommand(p,...k){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,k,!0)}async g(p,k,m){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,k,!1);{let v=!1;const F=(0,O.$$n)(k,function(M){if(M instanceof R.$wM)return P.Position.from(M);if(M instanceof R.$xM)return P.Range.from(M);if(M instanceof R.$HM)return P.location.from(M);if(R.$XN.isNotebookRange(M))return P.NotebookRange.from(M);if(M instanceof ArrayBuffer)return v=!0,a.$Je.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return v=!0,a.$Je.wrap(M);if(M instanceof a.$Je)return v=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(p,v?new h.$Kw(F):F,m);return(0,c.$0h)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this.g(p,k,!1);throw M}}}async h(p,k,m){const v=this.b.get(p);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:M,metadata:G}=v;if(G?.args)for(let V=0;V<G.args.length;V++)try{(0,E.$rg)(k[V],G.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${G.args[V].name}' - ${G.args[V].description}`)}const q=s.$be.create();try{return await F.apply(M,k)}catch(V){if(p===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...k);N&&(p=N.command)}if(this.d.error(V,p,v.extension?.identifier),!m)throw V;if(v.extension?.identifier){const N=this.#i.onExtensionError(v.extension.identifier,V);this.d.trace("forwarded error to extension?",N,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$lj)(V)),this.id=p,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,p,q.elapsed())}}j(p,k,m){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new n.$np(k),duration:m})}$executeContributedCommand(p,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const m=this.b.get(p);return m?(k=k.map(v=>this.f.reduce((F,M)=>M.processArgument(F,m.extension?.identifier),v)),this.h(p,k,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(k=>(p&&(k=k.filter(m=>m[0]!=="_")),k))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[k,m]of this.b){const{metadata:v}=m;v&&(p[k]=v)}return Promise.resolve(p)}};e.$gP=f,e.$gP=f=He([Ve(0,r.$XO),Ve(1,$.$7j),Ve(2,i.$fP)],f),e.$hP=(0,d.$Ai)("IExtHostCommands");class u{constructor(p,k,m){this.d=p,this.f=k,this.g=m,this.delegatingCommandId=`__vsc${(0,g.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,k){if(!p)return;const m={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return m;const v=this.f(p.command);if(v)m.id=v.internalId,m.arguments=v.args.map((F,M)=>F.convert(p.arguments&&p.arguments[M]));else if((0,T.$Lb)(p.arguments)){const F=`${p.command} /${++this.c}`;this.b.set(F,p),k.add((0,S.$Sc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),m.$ident=F,m.id=this.delegatingCommandId,m.arguments=[F],this.g.trace("CommandsConverter#CREATE",p.command,F)}return m}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const k=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$iP=u;class b{static{this.Uri=new b("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p)}static{this.Position=new b("position","A position in a text document",p=>R.$wM.isPosition(p),P.Position.from)}static{this.Range=new b("range","A range in a text document",p=>R.$xM.isRange(p),P.Range.from)}static{this.Selection=new b("selection","A selection in a text document",p=>R.$yM.isSelection(p),P.Selection.from)}static{this.Number=new b("number","",p=>typeof p=="number",p=>p)}static{this.String=new b("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=b.Arr(b.String)}static Arr(p){return new b(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,k=>Array.isArray(k)&&k.every(m=>p.validate(m)),k=>k.map(m=>p.convert(m)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof R.$TM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof R.$fO,P.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof o.$$O,P.TestItem.from)}constructor(p,k,m,v){this.name=p,this.description=k,this.validate=m,this.convert=v}optional(){return new b(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,k){return new b(p??this.name,k??this.description,this.validate,this.convert)}}e.$jP=b;class I{static{this.Void=new I("no result",p=>p)}constructor(p,k){this.description=p,this.convert=k}}e.$kP=I;class D{constructor(p,k,m,v,F){this.id=p,this.internalId=k,this.description=m,this.args=v,this.result=F}}e.$lP=D}),define(ke[296],Ie([1,0,18,16,2,94,103,32,39,10,7]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;const w=[new $.$lP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of DocumentHighlight-instances.",S(c.DocumentHighlight.to))),new $.$lP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$jP.Uri],new $.$kP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class a extends C.$OM{static to(t){const s=new a(t.name,c.SymbolKind.to(t.kind),t.containerName||"",new C.$HM(o[0],c.Range.to(t.range)));return s.detail=t.detail,s.range=s.location.range,s.selectionRange=c.Range.to(t.selectionRange),s.children=t.children?t.children.map(a.to):[],s}}return r.map(a.to)})),new $.$lP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$jP.Uri,new $.$jP("options","Formatting options",r=>!0,r=>r)],new $.$kP("A promise that resolves to an array of TextEdits.",S(c.TextEdit.to))),new $.$lP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$jP.Uri,$.$jP.Range,new $.$jP("options","Formatting options",r=>!0,r=>r)],new $.$kP("A promise that resolves to an array of TextEdits.",S(c.TextEdit.to))),new $.$lP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$jP.Uri,$.$jP.Position,new $.$jP("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$jP("options","Formatting options",r=>!0,r=>r)],new $.$kP("A promise that resolves to an array of TextEdits.",S(c.TextEdit.to))),new $.$lP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$lP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$lP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$lP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$lP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Location-instances.",S(c.location.to))),new $.$lP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of Hover-instances.",S(c.Hover.to))),new $.$lP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$jP.Uri,new $.$jP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>C.$wM.isPosition(o)),r=>r.map(c.Position.from))],new $.$kP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new C.$SM(c.Range.to(h),a);return a}))),new $.$lP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$jP.String.with("query","Search string")],new $.$kP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new $.$lP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new $.$lP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$jP.CallHierarchyItem],new $.$kP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new $.$lP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$jP.CallHierarchyItem],new $.$kP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new $.$lP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new $.$lP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$jP.Uri,$.$jP.Position,$.$jP.String.with("newName","The new symbol name")],new $.$kP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new $.$lP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$jP.Uri,$.$jP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$kP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new $.$lP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$jP.Uri],new $.$kP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new C.$ON(r.tokenTypes,r.tokenModifiers)})),new $.$lP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$jP.Uri],new $.$kP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Wbb)(r);if(o.type==="full")return new C.$QN(o.data,void 0)})),new $.$lP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$jP.Uri,$.$jP.Range.optional()],new $.$kP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new C.$ON(r.tokenTypes,r.tokenModifiers)})),new $.$lP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$jP.Uri,$.$jP.Range],new $.$kP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Wbb)(r);if(o.type==="full")return new C.$QN(o.data,void 0)})),new $.$lP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$jP.Uri,$.$jP.Position,$.$jP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$jP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$kP("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new C.$5M([]);const h=r.suggestions.map(t=>c.CompletionItem.to(t,a));return new C.$5M(h,r.incomplete)})),new $.$lP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$jP.Uri,$.$jP.Position,$.$jP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$kP("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new $.$lP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$jP.Uri,$.$jP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$kP("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>S(h=>new C.$WM(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new $.$lP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$jP.Uri,new $.$jP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>C.$xM.isRange(r),r=>C.$yM.isSelection(r)?c.Selection.from(r):c.Range.from(r)),$.$jP.String.with("kind","Code action kind to return code actions for").optional(),$.$jP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$kP("A promise that resolves to an array of Command-instances.",(r,o,a)=>S(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const t=new C.$QM(h.title,h.kind?new C.$RM(h.kind):void 0);return h.edit&&(t.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(t.command=a.fromInternal(h.command)),t.isPreferred=h.isPreferred,t}})(r))),new $.$lP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$jP.Uri],new $.$kP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new C.$$M(c.Range.to(o.range),c.Color.to(o.color))):[])),new $.$lP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$jP("color","The color to show and insert",r=>r instanceof C.$0M,c.Color.from),new $.$jP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new $.$kP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new $.$lP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$jP.Uri,$.$jP.Range],new $.$kP("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new $.$lP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$jP.Uri],new $.$kP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new $.$lP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$kP("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new $.$lP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$jP.Uri,$.$jP.Range,new $.$jP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof C.$xM,r=>c.InlineValueContext.from(r))],new $.$kP("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new $.$lP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$jP("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,R.$Kg)(r,R.Schemas.http,R.Schemas.https),r=>r),new $.$jP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),$.$jP.String.with("label","").optional()],$.$kP.Void),new $.$lP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$jP.Uri.with("resource","Resource to open"),$.$jP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$jP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],$.$kP.Void),new $.$lP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$jP.Uri.with("left","Left-hand side resource of the diff editor"),$.$jP.Uri.with("right","Right-hand side resource of the diff editor"),$.$jP.String.with("title","Human readable title for the diff editor").optional(),new $.$jP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],$.$kP.Void),new $.$lP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$jP.String.with("title","Human readable title for the changes editor"),new $.$jP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,t]=o;if(!P.URI.isUri(a)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},r=>r)],$.$kP.Void),new $.$lP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$jP.Uri,$.$jP.Position],new $.$kP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$lP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$jP.TypeHierarchyItem],new $.$kP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$lP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$jP.TypeHierarchyItem],new $.$kP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$lP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$jP.TestItem],$.$kP.Void),new $.$lP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$jP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$kP.Void),new $.$lP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$jP.String.with("name","The context key name"),new $.$jP("value","The context key value",()=>!0,r=>r)],$.$kP.Void),new $.$lP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$jP.Uri,$.$jP.StringArray,new $.$jP("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new $.$kP("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new $.$lP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$jP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:C.$yM.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],$.$kP.Void)];class l{static register(o){w.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",T.$zj)}}e.$Jmc=l;function S(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)O.$Lv(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(ke[297],Ie([1,0,2,39]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class P{constructor(A,T,$,c,C){this.a=T,this.b=$,this.c=c;const w=new R.$lP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$jP("showOptions","Show Options",l=>!0,l=>l),new R.$jP("resource","Interactive resource Uri",l=>!0,l=>l),new R.$jP("controllerId","Notebook controller Id",l=>!0,l=>l),new R.$jP("title","Interactive editor title",l=>!0,l=>l)],new R.$kP("Notebook and input URI",l=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const S=this.a.getEditorById(l.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:S.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(A,T,$,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$6nc=P}),define(ke[298],Ie([1,0,18,11,22,4,6,29,2,19,12,5,39,10,7,83,237,25,38,238]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=void 0,e.$boc=b;let s=class{constructor(D,y,p,k,m){this.m=y,this.n=p,this.o=k,this.q=m,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(w.$tM.MainThreadNotebookKernels);const v=new l.$lP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$jP("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const G=this.n.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:G}}else if(M&&"notebookEditor"in M){const G=this.n.getIdByEditor(M.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return M})],l.$kP.Void),F=new l.$lP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$jP.Uri],new l.$kP("A promise that resolves to an array of variables",(M,G)=>M.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(D,y,p,k,m,v){for(const se of this.j.values())if(se.controller.id===y&&c.$Wm.equals(D.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,M=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const G=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${D.identifier}'`);let q=!1;const V=new O.$he,N=new O.$he,L={id:b(D.identifier,y),notebookType:p,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:v?v.map(S.NotebookRendererScript.from):[]};let Z=m??G,re,fe;this.a.$addKernel(F,L).catch(se=>{console.log(se),q=!0});let be=0;const oe=()=>{if(q)return;const se=++be;Promise.resolve().then(()=>{se===be&&this.a.$updateKernel(F,L)})},pe=new T.$Ac,$e={get id(){return y},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return L.label},set label(se){L.label=se??D.displayName??D.name,oe()},get detail(){return L.detail??""},set detail(se){L.detail=se,oe()},get description(){return L.description??""},set description(se){L.description=se,oe()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(se){L.supportedLanguages=se,oe()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(se){L.supportsExecutionOrder=se,oe()},get rendererScripts(){return L.preloads?L.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(se){Z=se??G},get interruptHandler(){return re},set interruptHandler(se){re=se,L.supportsInterrupt=!!se,oe()},set variableProvider(se){(0,a.$TG)(D,"notebookVariableProvider"),fe=se,L.hasVariableProvider=!!se,se?.onDidChangeVariables(Ce=>M.a.$variablesUpdated(Ce.uri)),oe()},get variableProvider(){return fe},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.notebook.uri))throw M.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return M._createNotebookCellExecution(se,b(D.identifier,this.id))},createNotebookExecution(se){if((0,a.$TG)(D,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.uri))throw M.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return M._createNotebookExecution(se,b(D.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${F}], DISPOSED`),q=!0,this.j.delete(F),V.dispose(),N.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(se,Ce){Ce===d.NotebookControllerAffinity2.Hidden&&(0,a.$TG)(D,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(F,se.uri,Ce)},onDidReceiveMessage:N.event,postMessage(se,Ce){return(0,a.$TG)(D,"notebookMessaging"),M.a.$postMessage(F,Ce&&M.n.getIdByEditor(Ce),se)},asWebviewUri(se){return(0,a.$TG)(D,"notebookMessaging"),(0,r.$xBb)(se,M.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:$e,onDidReceiveMessage:N,onDidChangeSelection:V,associatedNotebooks:pe}),$e}getIdByController(D){for(const[y,p]of this.j)if(p.controller===D)return b(p.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const p=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(p,y);const m={dispose:()=>{this.f.delete(p),k.a.$removeKernelDetectionTask(p)}};return this.f.set(p,m),m}registerKernelSourceActionProvider(D,y,p){const k=this.i++,m=typeof p.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,v=this;this.h.set(k,p),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,y);let F;return m!==void 0&&(F=p.onDidChangeNotebookKernelSourceActions(M=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.h.delete(k),v.a.$removeKernelSourceActionProvider(k,k),F?.dispose()}}}async $provideKernelSourceActions(D,y){const p=this.h.get(D);if(p){const k=new A.$Tc;return(await p.provideNotebookKernelSourceActions(y)??[]).map(v=>S.NotebookKernelSourceAction.from(v,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,y,p){const k=this.j.get(D);if(k){const m=this.n.getNotebookDocument($.URI.revive(y));p?k.associatedNotebooks.set(m.uri,!0):k.associatedNotebooks.delete(m.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,m.uri.toString(),p),k.onDidChangeSelection.fire({selected:p,notebook:m.apiNotebook})}}async $executeCells(D,y,p){const k=this.j.get(D);if(!k)return;const m=this.n.getNotebookDocument($.URI.revive(y)),v=[];for(const F of p){const M=m.getCell(F);M&&v.push(M.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,m.uri.toString(),v.length),await k.controller.executeHandler.call(k.controller,v,m.apiNotebook,k.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,p){const k=this.j.get(D);if(!k)return;const m=this.n.getNotebookDocument($.URI.revive(y));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,m.apiNotebook);else for(const v of p){const F=m.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(k.controller.interruptHandler){const v=this.c.get(m.uri);this.c.delete(m.uri),p.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(D,y,p,k,m,v,F){const M=this.j.get(D);if(!M)return;const G=this.n.getNotebookDocument($.URI.revive(p)),q=M.controller.variableProvider;if(!q)return;let V;if(k!==void 0){if(V=this.s[k],!V)return}else this.s={};const N=m==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,L=q.provideVariables(G.apiNotebook,V,N,v,F);let Z=0;for await(const re of L){if(F.isCancellationRequested)return;const fe={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:M.extensionId.value};if(this.s[fe.id]=re.variable,this.a.$receiveVariable(y,fe),Z++>=t.$jjb)return}}$acceptKernelMessageFromRenderer(D,y,p){const k=this.j.get(D);if(!k)return;const m=this.n.getEditorById(y);k.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:p}))}$cellExecutionChanged(D,y,p){const m=this.n.getNotebookDocument($.URI.revive(D)).getCell(y);if(m){const v=p?S.NotebookCellExecutionState.to(p):d.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:m.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const m=new i(y,k,this.a);this.b.set(k.uri,m);const v=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),v.dispose(),this.b.delete(k.uri))});return m.asApiObject()}_createNotebookExecution(D,y){const p=this.n.getNotebookDocument(D.uri),k=D.getCells().find(F=>{const M=p.getCellFromApiCell(F);return M&&this.b.has(M.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const m=new f(y,p,this.a),v=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),v.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[m,v]),m.asApiObject()}};e.$aoc=s,e.$aoc=s=He([Ve(4,C.$7j)],s);var n;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(n||(n={}));class i extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,p){super(),this.m=y,this.n=p,this.b=i.a++,this.c=new O.$he,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$se),this.h=new u(10,k=>this.s(k)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Kw(y))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const p=d.$2N.ensureUniqueMimeTypes(y.items,!0);return p===y.items?S.NotebookCellOutput.from(y):S.NotebookCellOutput.from({items:p,id:y.id,metadata:y.metadata})})}async z(D,y,p){const k=this.w(y),m=this.y((0,E.$2b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:p,outputs:m})}async C(D,y,p){return D=d.$2N.ensureUniqueMimeTypes((0,E.$2b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:y.id,append:p})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(p){D.j=p,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(p){if(D.f===n.Resolved||D.f===n.Started)throw new Error("Cannot call start again");D.f=n.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,k,m){if(D.f===n.Resolved)throw new Error("Cannot call resolve twice");D.f=n.Resolved,D.c.fire(),D.h.flush();const v=m?{message:m.message,stack:m.stack,location:m?.location?{startLineNumber:m.location.start.line,startColumn:m.location.start.character,endLineNumber:m.location.end.line,endColumn:m.location.end.character}:void 0,uri:m.uri}:void 0;D.n.$completeExecution(D.b,new h.$Kw({runEndTime:k,lastRunSuccess:p,error:v}))},clearOutput(p){return D.t(),D.z([],p,!1)},appendOutput(p,k){return D.t(),D.z(p,k,!0)},replaceOutput(p,k){return D.t(),D.z(p,k,!1)},appendOutputItems(p,k){return D.t(),D.C(p,k,!0)},replaceOutputItems(p,k){return D.t(),D.C(p,k,!1)}})}}var g;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(g||(g={}));class f extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,p){super(),this.h=y,this.j=p,this.b=f.a++,this.c=new O.$he,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new P.$se),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new R.$Xh,this.b=Date.now(),(0,R.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function b(I,D){return`${I.value}/${D}`}}),define(ke[57],Ie([1,0,4,5,3,2,17,6,7,187,14,218,22,36,219,220,34,11,10,39,37]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=e.$nnc=e.$mnc=e.$lnc=void 0,e.$lnc=(0,P.$Ai)("IExtHostTerminalService");class n extends T.$Uc{constructor(m,v,F,M){super(),this.u=m,this._id=v,this.w=F,this.y=M,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new E.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const G=this;this.value={get name(){return G.y||""},get processId(){return G.b},get creationOptions(){return G.w},get exitStatus(){return G.j},get state(){return G.m},get selection(){return G.n},get shellIntegration(){return G.shellIntegration},sendText(q,V=!0){G.C(),G.u.$sendText(G._id,q,V)},show(q){G.C(),G.u.$show(G._id,q)},hide(){G.C(),G.u.$hide(G._id)},dispose(){G.a||(G.a=!0,G.u.$dispose(G._id))},get dimensions(){if(!(G.f===void 0||G.h===void 0))return{columns:G.f,rows:G.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??v?.cwd??void 0,env:m.env??void 0,icon:D(m.iconPath)??void 0,color:o.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(m.location,v?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,v,F,M,G){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:M,color:o.ThemeColor.isThemeColor(G)?G.id:void 0,location:v?.location||this.z(m,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,v){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in m?{viewColumn:h.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,v){this.j=Object.freeze({code:m,reason:v})}setDimensions(m,v){return m===this.f&&v===this.h||m===0||v===0?!1:(this.f=m,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(v=>{v!==m&&(this.b=Promise.resolve(m))})}}e.$mnc=n;class i{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new E.$he,this.onProcessData=this.a.event,this.b=new E.$he,this.d=new E.$he,this.onDidChangeProperty=this.d.event,this.f=new E.$he,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,v){this.g.setDimensions?.({columns:m,rows:v})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:d.ProcessPropertyType.Title,value:v})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,f=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$he,this.onDidCloseTerminal=this.H.event,this.I=new E.$he,this.onDidOpenTerminal=this.I.event,this.J=new E.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$he,this.onDidChangeTerminalState=this.M.event,this.N=new E.$he,this.onDidChangeShell=this.N.event,this.O=new E.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(R.$tM.MainThreadTerminalService),this.y=new r.$Vvb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:M=>{const G=q=>{const V=q;return this.getTerminalById(V.instanceId)?.value};switch(M?.$mid){case s.MarshalledId.TerminalContext:return G(M);default:{if(Array.isArray(M))for(let q=0;q<M.length&&M[q].$mid===s.MarshalledId.TerminalContext;q++)M[q]=G(M[q]);return M}}}}),this.B({dispose:()=>{for(const[M,G]of this.g)G.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,v){const F=new n(this.a,(0,S.$Wg)(),m,m.name),M=new i(m.pty);return F.createExtensionTerminal(m.location,v,this.R(m,v).resolvedExtHostIdentifier,D(m.iconPath),y(m.color)).then(G=>{const q=this.S(G,M);this.h[G]=q}),this.f.push(F),F.value}R(m,v){if(v=v||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const F=m.location.parentTerminal;if(F){const M=this.f.find(G=>G.value===F);M&&(v.resolvedExtHostIdentifier=M._id)}}else m.location&&typeof m.location!="object"?v.location=m.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(m,v){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const M=new i(v),G=this.S(m,M);this.h[m]=G}async $acceptActiveTerminalChanged(m){const v=this.b;if(m===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(m);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,v){const F=this.getTerminalById(m);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(m,v,F){const M=this.getTerminalById(m);M&&M.setDimensions(v,F)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(m,v){const F=this.getTerminalById(m);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(m,v,F){this.g.get(m)?.resize(v,F)}async $acceptTerminalTitleChange(m,v){const F=this.getTerminalById(m);F&&(F.name=v)}async $acceptTerminalClosed(m,v,F){const M=this.X(this.f,m);if(M!==null){const G=this.f.splice(M,1)[0];G.setExitStatus(v,F),this.H.fire(G.value)}}$acceptTerminalOpened(m,v,F,M){if(v){const V=this.X(this.f,v);if(V!==null){this.f[V]._id=m,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const G={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:O.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},q=new n(this.a,m,G,F);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(m,v){this.getTerminalById(m)?._setProcessId(v)}async $startExtensionTerminal(m,v){const F=this.getTerminalById(m);if(!F)return{message:(0,c.localize)(0,null,m)};F.isOpen||await new Promise(G=>{const q=this.onDidOpenTerminal(async V=>{V===F.value&&(q.dispose(),G())})});const M=this.g.get(m);M?M.startSendingEvents(v):this.j[m]={initialDimensions:v}}S(m,v){const F=new T.$Tc;F.add(v.onProcessReady(G=>this.a.$sendProcessReady(m,G.pid,G.cwd,G.windowsPty))),F.add(v.onDidChangeProperty(G=>this.a.$sendProcessProperty(m,G))),this.y.startBuffering(m,v.onProcessData),F.add(v.onProcessExit(G=>this.U(m,G))),this.g.set(m,v);const M=this.j[m];return M&&v instanceof i&&(v.startSendingEvents(M.initialDimensions),delete this.j[m]),F}$acceptProcessAckDataEvent(m,v){this.g.get(m)?.acknowledgeDataEvent(v)}$acceptProcessInput(m,v){this.g.get(m)?.input(v)}$acceptTerminalInteraction(m){const v=this.getTerminalById(m);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(m,v){this.getTerminalById(m)?.setSelection(v)}$acceptProcessResize(m,v,F){try{this.g.get(m)?.resize(v,F)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(m,v){this.g.get(m)?.shutdown(v)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(v=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$vM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,m.identifier.value),new $.$vM(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(m,v,F){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,F),this.a.$registerQuickFixProvider(m,v),new $.$vM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,v){const F=new l.$se().token;if(F.isCancellationRequested)return;const M=this.D.get(m);if(!M)return;const G=await M.provideTerminalQuickFixes(v,F);if(G===null||Array.isArray(G)&&G.length===0)return;const q=new T.$Tc;if(this.w.value=q,!Array.isArray(G))return G?h.TerminalQuickFix.from(G,this.Q.converter,q):void 0;const V=[];for(const N of G){const L=h.TerminalQuickFix.from(N,this.Q.converter,q);L&&V.push(L)}return V}async $createContributedProfileTerminal(m,v){const F=new l.$se().token;let M=await this.C.get(m)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,v);return}this.createTerminalFromOptions(M.options,v)}}async $provideLinks(m,v){const F=this.getTerminalById(m);if(!F)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const G=new l.$se;this.G.set(m,G);const q=[],V={terminal:F.value,line:v},N=[];for(const re of this.z)N.push(a.Promises.withAsyncBody(async fe=>{G.token.onCancellationRequested(()=>fe({provider:re,links:[]}));const be=await re.provideTerminalLinks(V,G.token)||[];G.token.isCancellationRequested||fe({provider:re,links:be})}));const L=await Promise.all(N);if(G.token.isCancellationRequested)return[];const Z=new Map;for(const re of L)re&&re.links.length>0&&q.push(...re.links.map(fe=>{const be={id:g++,startIndex:fe.startIndex,length:fe.length,label:fe.tooltip};return Z.set(be.id,{provider:re.provider,link:fe}),be}));return this.F.set(m,Z),q}$activateLink(m,v){const F=this.F.get(m)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(m,v){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const F=this.h[m];F&&(F.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,v)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const v=this.f.findIndex(F=>F.value===m);return v>=0?v:null}W(m,v){const F=this.X(m,v);return F!==null?m[F]:null}X(m,v){const F=m.findIndex(M=>M._id===v);return F>=0?F:null}getEnvironmentVariableCollection(m){let v=this.n.get(m.identifier.value);return v||(v=new u,this.Z(m.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(m,v){const F=(0,w.$ts)(v.map),M=(0,w.$us)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(m,v.persistent,F.length===0?void 0:F,M)}$initEnvironmentVariableCollections(m){m.forEach(v=>{const F=v[0],M=new u(v[1]);this.Z(F,M)})}$acceptDefaultProfile(m,v){const F=this.s;this.s=m,this.u=v,F?.path!==m.path&&this.N.fire(m.path)}Z(m,v){this.n.set(m,v),v.onDidChangeCollection(()=>{this.Y(m,v)})}};e.$nnc=f,e.$nnc=f=He([Ve(1,t.$hP),Ve(2,A.$XO)],f);class u{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$he,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const v=this.h(m);let F=this.a.get(v);return F||(F=new b(this,m),this.a.set(v,F),F.onDidChangeCollection(()=>this.d.fire())),F}replace(m,v,F,M){this.f(m,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:M})}append(m,v,F,M){this.f(m,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:M})}prepend(m,v,F,M){this.f(m,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:M})}f(m,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.g(m,v.scope),M=this.map.get(F),G=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==v.value||M.type!==v.type||M.options?.applyAtProcessCreation!==G.applyAtProcessCreation||M.options?.applyAtShellIntegration!==G.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const q=this.g(m,v.scope),V={variable:m,...v,options:G};this.map.set(q,V),this.d.fire()}}get(m,v){const F=this.g(m,v),M=this.map.get(F);return M?p(M):void 0}g(m,v){const F=this.h(v);return F.length?`${m}:::${F}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const v=new Map;for(const[F,M]of this.map)this.h(M.scope)===this.h(m)&&v.set(M.variable,p(M));return v}delete(m,v){const F=this.g(m,v);this.map.delete(F),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(v);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,v){const F=this.h(v),M=this.descriptionMap.get(F);if(!M||M.description!==m){let G;typeof m=="string"?G=m:G=m?.value.split(`

`)[0];const q={description:G,scope:v};this.descriptionMap.set(F,q),this.d.fire()}}getDescription(m){const v=this.h(m);return this.descriptionMap.get(v)?.description}k(m){const v=this.h(m);this.descriptionMap.delete(v)}}class b{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,v){this.b=m,this.d=v,this.a=new E.$he}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,v,F){this.b.replace(m,v,F,this.d)}append(m,v,F){this.b.append(m,v,F,this.d)}prepend(m,v,F){this.b.prepend(m,v,F,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,v){this.b.getVariableMap(this.d).forEach((F,M)=>m.call(v,M,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends f{constructor(m,v){super(!1,m,v)}createTerminal(m,v,F){throw new C.$_}createTerminalFromOptions(m,v){throw new C.$_}};e.$onc=I,e.$onc=I=He([Ve(0,t.$hP),Ve(1,A.$XO)],I);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function y(k){return o.ThemeColor.isThemeColor(k)?k:void 0}function p(k){const m={...k};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[124],Ie([1,0,7,6,3,5,17,57,4,2,11]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0,e.$soc=(0,P.$Ai)("IExtHostTerminalShellIntegration");let w=class extends R.$Uc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new $.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$tM.MainThreadTerminalShellIntegration),this.B((0,R.$Sc)(()=>{for(const[h,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let t=this.b.get(o);t||(t=new l(a.value,this.f),this.b.set(o,t),t.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),t.store.add(t.onDidRequestEndExecution(s=>this.g.fire(s))),t.store.add(t.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=t.value),this.c.fire({terminal:h,shellIntegration:t.value})}$shellExecutionStart(o,a,h,t,s){this.b.has(o)||this.$shellIntegrationChange(o);const n={value:a,confidence:h,isTrusted:t};this.b.get(o)?.startShellExecution(n,s)}$shellExecutionEnd(o,a,h,t,s){const n={value:a,confidence:h,isTrusted:t};this.b.get(o)?.endShellExecution(n,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$vc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$toc=w,e.$toc=w=He([Ve(0,A.$XO),Ve(1,T.$lnc)],w);class l extends R.$Uc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new R.$Tc),this.f=this.B(new $.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$he),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(t,s){let n=t;s&&(n+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(n);const i={value:n,confidence:E.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=h.startShellExecution(i,h.c,!0).value;return h.b=!0,g}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new S(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return C.$1h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends R.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new C.$zh);const o=this.a;return new C.$1h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[299],Ie([1,0,11,23,22,4,272,76,6,37,15,36,12,5,17,123,10,7,240,55,82,56,25]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=e.$voc=e.$uoc=void 0;let g=0;const f=new WeakMap;let u=class extends $.$Uc{constructor(L,Z,re,fe){super(),this.C=Z,this.D=re,this.F=fe,this.f=this.B(new O.$he),this.g=new Map,this.w=this.B(new O.$he),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=L.getProxy(S.$tM.MainThreadTesting),this.m=new F(this.h),this.j=new y(this.h,Z),re.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case c.MarshalledId.TestItemContext:{const oe=be,pe=oe.tests[oe.tests.length-1].item.extId;return this.g.get(t.$fL.root(pe))?.collection.tree.get(pe)?.actual??(0,r.$0O)(be)}case c.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:pe}=be,$e=oe.item.extId;return{test:this.g.get(t.$fL.root($e))?.collection.tree.get($e)?.actual??(0,r.$0O)({$mid:c.MarshalledId.TestItemContext,tests:[oe]}),message:o.TestMessage.to(pe)}}default:return be}}}),re.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await re.executeCommand(h.TestCommandId.GetExplorerSelection),oe=pe=>{const $e=this.g.get(t.$fL.root(pe));if($e)return t.$fL.isRoot(pe)?$e.controller:$e.collection.tree.get(pe)?.actual};return{include:be?.include.map(oe).filter(C.$ig)||[],exclude:be?.exclude.map(oe).filter(C.$ig)||[]}})}createTestController(L,Z,re,fe){if(this.g.has(Z))throw new Error(`Attempt to insert a duplicate controller with ID "${Z}"`);const be=new $.$Tc,oe=be.add(new r.$aP(Z,re,this.F));oe.root.label=re;const pe=new Map,$e=new Set,se=this.h,Ce={items:oe.root.children,get label(){return re},set label(Y){re=Y,oe.root.label=Y,se.$updateController(Z,{label:re})},get refreshHandler(){return fe},set refreshHandler(Y){fe=Y,se.$updateController(Z,{canRefresh:!!Y})},get id(){return Z},createRunProfile:(Y,W,ie,De,he,ve)=>{let ae=(0,T.$oj)(Y);for(;pe.has(ae);)ae++;return new G(this.h,pe,$e,this.w.event,Z,ae,Y,W,ie,De,he,ve)},createTestItem(Y,W,ie){return new r.$$O(Z,Y,W,ie)},createTestRun:(Y,W,ie=!0)=>this.j.createTestRun(L,Z,oe,Y,W,ie),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const W=Y instanceof Array?Y:[Y];this.h.$markTestRetired(W.map(ie=>t.$fL.fromExtHostTestItem(ie,Z).toString()))}},set resolveHandler(Y){oe.resolveHandler=Y},get resolveHandler(){return oe.resolveHandler},dispose:()=>{be.dispose()}};se.$registerTestController(Z,re,!!fe),be.add((0,$.$Sc)(()=>se.$unregisterTestController(Z)));const Fe={controller:Ce,collection:oe,profiles:pe,extension:L,activeProfiles:$e};return this.g.set(Z,Fe),be.add((0,$.$Sc)(()=>this.g.delete(Z))),be.add(oe.onDidGenerateDiff(Y=>se.$publishDiff(Z,Y.map(n.TestsDiffOp.serialize)))),Ce}createTestObserver(){return this.m.checkout()}async runTests(L,Z=P.CancellationToken.None){const re=p(L);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const fe=this.g.get(re.controllerId);if(!fe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:L.preserveFocus??!0,targets:[{testIds:L.include?.map(be=>t.$fL.fromExtHostTestItem(be,fe.collection.root.id).toString())??[fe.collection.root.id],profileGroup:q[re.kind],profileId:re.profileId,controllerId:re.controllerId}],exclude:L.exclude?.map(be=>be.id)},Z)}registerTestFollowupProvider(L){return this.y.add(L),{dispose:()=>{this.y.delete(L)}}}$syncTests(){for(const{collection:L}of this.g.values())L.flushDiff();return Promise.resolve()}async $getCoverageDetails(L,Z){return(await this.j.getCoverageDetails(L,Z))?.map(o.TestCoverage.fromDetails)}async $disposeRun(L){this.j.disposeTestRun(L)}$configureRunProfile(L,Z){this.g.get(L)?.profiles.get(Z)?.configureHandler?.()}$setDefaultRunProfiles(L){const Z=new Map;for(const[re,fe]of Object.entries(L)){const be=this.g.get(re);if(!be)continue;const oe=new Map,pe=fe.filter(se=>!be.activeProfiles.has(se)),$e=[...be.activeProfiles].filter(se=>!fe.includes(se));for(const se of pe)oe.set(se,!0),be.activeProfiles.add(se);for(const se of $e)oe.set(se,!1),be.activeProfiles.delete(se);oe.size&&Z.set(re,oe)}this.w.fire(Z)}async $refreshTests(L,Z){await this.g.get(L)?.controller.refreshHandler?.(Z)}$publishTestResults(L){this.results=Object.freeze(L.map(Z=>{const re=o.TestResults.to(Z);return f.set(re,Z.id),re}).concat(this.results).sort((Z,re)=>re.completedAt-Z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(L,Z){const re=this.g.get(t.$fL.fromString(L).controllerId)?.collection;re&&(await re.expand(L,Z<0?1/0:Z),re.flushDiff())}$acceptDiff(L){this.m.applyDiff(L.map(Z=>n.TestsDiffOp.deserialize({asCanonicalUri:re=>re},Z)))}async $runControllerTests(L,Z){return Promise.all(L.map(re=>this.G(re,!1,Z)))}async $startContinuousRun(L,Z){const re=new P.$se(Z),fe=await Promise.all(L.map(be=>this.G(be,!0,re.token)));return!Z.isCancellationRequested&&!fe.some(be=>be.error)&&await new Promise(be=>Z.onCancellationRequested(be)),re.dispose(!0),fe}async $provideTestFollowups(L,Z){const re=this.results.find(oe=>f.get(oe)===L.resultId),fe=re&&V(t.$fL.fromString(L.extId),re?.results);if(!fe)return[];let be=[];return await Promise.all([...this.y].map(async oe=>{try{const pe=await oe.provideFollowup(re,fe,L.taskIndex,L.messageIndex,Z);pe&&(be=be.concat(pe))}catch(pe){this.C.error("Error thrown while providing followup for test message",pe)}})),Z.isCancellationRequested?[]:be.map(oe=>{const pe=g++;return this.z.set(pe,oe),{title:oe.title,id:pe}})}$disposeTestFollowups(L){for(const Z of L)this.z.delete(Z)}$executeTestFollowup(L){const Z=this.z.get(L);return Z?this.D.executeCommand(Z.command,...Z.arguments||[]):Promise.resolve()}async G(L,Z,re){const fe=this.g.get(L.controllerId);if(!fe)return{};const{collection:be,profiles:oe,extension:pe}=fe,$e=oe.get(L.profileId);if(!$e)return{};const se=L.testIds.map(W=>be.tree.get(W)).filter(C.$ig),Ce=L.excludeExtIds.map(W=>fe.collection.tree.get(W)).filter(C.$ig).filter(W=>se.some(ie=>ie.fullId.compare(W.fullId)===t.TestPosition.IsChild));if(!se.length)return{};const Fe=new a.$9N(se.some(W=>W.actual instanceof r.$_O)?void 0:se.map(W=>W.actual),Ce.map(W=>W.actual),$e,Z),Y=(0,n.$iL)(L)&&this.j.prepareForMainThreadTestRun(pe,Fe,k.fromInternal(L,fe.collection),$e,re);try{return await $e.runHandler(Fe,re),{}}catch(W){return{error:String(W)}}finally{Y&&Y.hasRunningTasks&&!re.isCancellationRequested&&await O.Event.toPromise(Y.onEnd)}}$cancelExtensionTestRun(L){L===void 0?this.j.cancelAllRuns():this.j.cancelRunById(L)}};e.$uoc=u,e.$uoc=u=He([Ve(0,d.$XO),Ve(1,l.$7j)],u);const b=1e4;var I;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(I||(I={}));class D extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(L,Z,re,fe,be,oe){super(),this.z=L,this.C=Z,this.D=re,this.F=fe,this.G=be,this.c=I.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$he),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$se(oe));const pe=this.B(new E.$Mh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>pe.schedule()));const $e=new O.$he;this.w=$e.event,this.B((0,$.$Sc)(()=>{$e.fire(),$e.dispose()}))}cancel(){this.c===I.Running?(this.j.cancel(),this.c=I.Cancelling):this.c===I.Cancelling&&this.H()}getCoverageDetails(L,Z){const[,re]=t.$fL.fromString(L).path,fe=this.y.get(L);if(!fe)return[];const be=this.g.get(re);if(!be)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(be.run,fe,Z)??[]}createRun(L){const Z=this.z.id,re=this.z.controllerId,fe=(0,w.$Wg)(),be=Ce=>(Fe,...Y)=>{if(pe){this.D.warn(`Setting the state of test "${Fe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(Fe)&&(this.J(Fe),Ce(Fe,...Y))},oe=(Ce,Fe)=>{const Y=Fe instanceof Array?Fe.map(o.TestMessage.from):[o.TestMessage.from(Fe)];if(Ce.uri&&Ce.range){const W={range:o.Range.from(Ce.range),uri:Ce.uri};for(const ie of Y)ie.location=ie.location||W}this.C.$appendTestMessagesInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),Y)};let pe=!1;const $e=new Map,se={isPersisted:this.z.isPersisted,token:this.j.token,name:L,onDidDispose:this.w,addCoverage:Ce=>{if(pe)return;const Fe=Ce instanceof a.$bO?Ce.testItem:void 0;let Y;if(Fe){if((0,i.$TG)(this.G,"attributableCoverage"),!this.z.isIncluded(Fe))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.J(Fe),Y=$e.get(Fe),Y===void 0&&(Y=$e.size,$e.set(Fe,Y))}const W=Ce.uri.toString(),ie=new t.$fL(Y!==void 0?[Z,fe,W,String(Y)]:[Z,fe,W]).toString();this.y.set(ie,Ce),this.C.$appendCoverage(Z,fe,o.TestCoverage.fromFile(re,ie,Ce))},enqueued:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Queued)}),skipped:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Skipped)}),started:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Running)}),errored:be((Ce,Fe,Y)=>{oe(Ce,Fe),this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Errored,Y)}),failed:be((Ce,Fe,Y)=>{oe(Ce,Fe),this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Failed,Y)}),passed:be((Ce,Fe)=>{this.C.$updateTestStateInRun(Z,fe,t.$fL.fromExtHostTestItem(Ce,this.z.controllerId).toString(),n.TestResultState.Passed,Fe)}),appendOutput:(Ce,Fe,Y)=>{pe||(Y&&(this.z.isIncluded(Y)?this.J(Y):Y=void 0),this.C.$appendOutputToRun(Z,fe,R.$Je.fromString(Ce),Fe&&o.location.from(Fe),Y&&t.$fL.fromExtHostTestItem(Y,re).toString()))},end:()=>{pe||(pe=!0,$e.clear(),this.C.$finishedTestRunTask(Z,fe),--this.f||this.I())}};return this.f++,this.g.set(fe,{run:se}),this.C.$startedTestRunTask(Z,{id:fe,name:L,running:!0}),se}H(){for(const{run:L}of this.g.values())L.end()}I(){this.c!==I.Ended&&(this.c=I.Ended,this.m.fire())}J(L){if(!(L instanceof r.$$O))throw new s.$PO(L.id);if(this.h.has(t.$fL.fromExtHostTestItem(L,this.z.controllerId).toString()))return;const Z=[],re=this.z.colllection.root;for(;;){const fe=o.TestItem.from(L);if(Z.unshift(fe),this.h.has(fe.extId)||(this.h.add(fe.extId),L===re))break;L=L.parent||re}this.C.$addTestsToRun(this.z.controllerId,this.z.id,Z)}dispose(){this.I(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(L,Z){this.g=L,this.h=Z,this.c=new Map,this.f=new Map}getCoverageDetails(L,Z){const re=t.$fL.root(L);return this.f.get(re)?.getCoverageDetails(L,Z)||[]}disposeTestRun(L){this.f.get(L)?.dispose(),this.f.delete(L);for(const[Z,{id:re}]of this.c)re===L&&this.c.delete(Z)}prepareForMainThreadTestRun(L,Z,re,fe,be){return this.j(Z,re,fe,L,be)}cancelRunById(L){this.f.get(L)?.cancel()}cancelAllRuns(){for(const L of this.c.values())L.cancel()}createTestRun(L,Z,re,fe,be,oe){const pe=this.c.get(fe);if(pe)return pe.createRun(be);const $e=k.fromPublic(Z,re,fe,oe),se=p(fe);this.g.$startedExtensionTestRun({controllerId:Z,continuous:!!fe.continuous,profile:se&&{group:q[se.kind],id:se.profileId},exclude:fe.exclude?.map(Fe=>t.$fL.fromExtHostTestItem(Fe,re.root.id).toString())??[],id:$e.id,include:fe.include?.map(Fe=>t.$fL.fromExtHostTestItem(Fe,re.root.id).toString())??[re.root.id],preserveFocus:fe.preserveFocus??!0,persist:oe});const Ce=this.j(fe,$e,fe.profile,L);return O.Event.once(Ce.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),Ce.createRun(be)}j(L,Z,re,fe,be){const oe=new D(Z,this.g,this.h,re,fe,be);return this.c.set(L,oe),this.f.set(oe.id,oe),oe}}e.$voc=y;const p=N=>{if(N.profile){if(!(N.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class k{static fromPublic(L,Z,re,fe){return new k(L,(0,w.$Wg)(),re.include?.map(be=>t.$fL.fromExtHostTestItem(be,L).toString())??[L],re.exclude?.map(be=>t.$fL.fromExtHostTestItem(be,L).toString())??[],fe,Z)}static fromInternal(L,Z){return new k(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,Z)}constructor(L,Z,re,fe,be,oe){this.controllerId=L,this.id=Z,this.isPersisted=be,this.colllection=oe,this.c=re.map(pe=>pe+t.TestIdPathParts.Delimiter),this.f=fe.map(pe=>pe+t.TestIdPathParts.Delimiter)}isIncluded(L){const Z=t.$fL.fromExtHostTestItem(L,this.controllerId).toString()+t.TestIdPathParts.Delimiter;for(const re of this.f)if(Z===re||Z.startsWith(re))return!1;for(const re of this.c)if(Z===re||Z.startsWith(re))return!0;return!1}}e.$woc=k;class m{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(L){this.j=L,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(L){this.c.add(L)}update(L){Object.assign(L.revived,o.TestItem.toPlain(L.item)),this.c.has(L)||this.f.add(L)}remove(L){if(this.c.has(L)){this.c.delete(L);return}this.f.delete(L);const Z=t.$fL.parentId(L.item.extId);if(Z&&this.h.has(Z.toString())){this.h.add(L.item.extId);return}this.g.add(L)}getChangeEvent(){const{c:L,f:Z,g:re}=this;return{get added(){return[...L].map(fe=>fe.revived)},get updated(){return[...Z].map(fe=>fe.revived)},get removed(){return[...re].map(fe=>fe.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends n.$oL{constructor(){super(...arguments),this.y=new O.$he,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(L){return this.f.get(L)}getMirroredTestDataByReference(L){return this.f.get(L.id)}x(L,Z){return{...L,revived:o.TestItem.toPlain(L.item),depth:Z?Z.depth+1:0,children:new Set}}w(){return new m(this.y)}}class F{constructor(L){this.f=L}checkout(){this.c||(this.c=this.g());const L=this.c;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(Z=>Z.revived)},dispose:(0,A.$db)(()=>{--L.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(L){return this.c?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.c?.tests.apply(L)}g(){const L=new v({asCanonicalUri:Z=>Z});return this.f.$subscribeToDiffs(),{observers:0,tests:L}}}const M=(N,L,Z,re)=>{Z?Object.assign(Z,re):L.$updateTestRunConfig(N.controllerId,N.profileId,re)};class G{#e;#t;#i;#n;#s;get label(){return this.f}set label(L){L!==this.f&&(this.f=L,M(this,this.#e,this.#n,{label:L}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(L){L!==this.g&&(this.g=L,M(this,this.#e,this.#n,{supportsContinuousRun:L}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(L){L!==this.isDefault&&(L?this.#t.add(this.profileId):this.#t.delete(this.profileId),M(this,this.#e,this.#n,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,M(this,this.#e,this.#n,{tag:L?o.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.c}set configureHandler(L){L!==this.c&&(this.c=L,M(this,this.#e,this.#n,{hasConfigurationHandler:!!L}))}get onDidChangeDefault(){return O.Event.chain(this.#i,L=>L.map(Z=>Z.get(this.controllerId)?.get(this.profileId)).filter(C.$ig))}constructor(L,Z,re,fe,be,oe,pe,$e,se,Ce=!1,Fe=void 0,Y=!1){this.controllerId=be,this.profileId=oe,this.f=pe,this.kind=$e,this.runHandler=se,this._tag=Fe,this.g=Y,this.#e=L,this.#s=Z,this.#t=re,this.#i=fe,Z.set(oe,this);const W=q[$e];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);Ce&&re.add(oe),this.#n={profileId:oe,controllerId:be,tag:Fe?o.TestTag.namespace(this.controllerId,Fe.id):null,label:pe,group:W,isDefault:Ce,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$xoc=G;const q={[a.TestRunProfileKind.Coverage]:n.TestRunProfileBitset.Coverage,[a.TestRunProfileKind.Debug]:n.TestRunProfileBitset.Debug,[a.TestRunProfileKind.Run]:n.TestRunProfileBitset.Run};function V(N,L){for(let Z=0;Z<N.path.length;Z++){const re=L.find(fe=>fe.id===N.path[Z]);if(!re)return;if(Z===N.path.length-1)return re;L=re.children}}}),define(ke[125],Ie([1,0,61,14,96,10,7]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=void 0;class T{static{this.c=new P.$3O("TextEditorDecorationType")}constructor(l,S,d){const r=T.c.nextId();l.$registerTextEditorDecorationType(S.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$5O=T;class ${constructor(l,S){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,S){this.k();let d=null;if(l instanceof A.$wM)d=new A.$xM(l,l);else if(l instanceof A.$xM)d=l;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(l,S){this.k(),this.l(new A.$xM(l,l),S,!0)}delete(l){this.k();let S=null;if(l instanceof A.$xM)S=l;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(l,S,d){const r=this.c.validateRange(l);this.g.push({range:r,text:S,forceMoveMarkers:d})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,R.$7)("endOfLine");this.h=l}}class c{constructor(l,S,d,r){this.c=l,this.d=S,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const S=Math.floor(l);return S>0?S:null}if(typeof l=="string"){const S=parseInt(l,10);return isNaN(S)?null:S>0?S:null}return null}n(l){const S=this.m(l);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const S=Math.floor(l);return S>0?S:null}if(typeof l=="string"){const S=parseInt(l,10);return isNaN(S)?null:S>0?S:null}return null}p(l){const S=this.o(l);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const S=this.q(l);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const S={};let d=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(d=!0,S.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,S.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(d=!0,S.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,S.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(d=!0,S.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,S.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,d=!0,S.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(l,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(d)})}}e.$6O=c;class C{constructor(l,S,d,r,o,a,h,t){this.id=l,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=t;const s=this;this.value=Object.freeze({get document(){return r.value},set document(n){throw new R.$9("document")},get selection(){return s.c&&s.c[0]},set selection(n){if(!(n instanceof A.$yM))throw(0,R.$7)("selection");s.c=[n],s.l()},get selections(){return s.c},set selections(n){if(!Array.isArray(n)||n.some(i=>!(i instanceof A.$yM)))throw(0,R.$7)("selections");s.c=n,s.l()},get visibleRanges(){return s.e},set visibleRanges(n){throw new R.$9("visibleRanges")},get options(){return s.d.value},set options(n){s.g||s.d.assign(n)},get viewColumn(){return s.f},set viewColumn(n){throw new R.$9("viewColumn")},edit(n,i={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(r.value,i);return n(g),s.m(g)},insertSnippet(n,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=s.c.map(u=>O.Range.from(u));else if(i instanceof A.$wM){const{lineNumber:u,column:b}=O.Position.from(i);f=[{startLineNumber:u,startColumn:b,endLineNumber:u,endColumn:b}]}else if(i instanceof A.$xM)f=[O.Range.from(i)];else{f=[];for(const u of i)if(u instanceof A.$xM)f.push(O.Range.from(u));else{const{lineNumber:b,column:I}=O.Position.from(u);f.push({startLineNumber:b,startColumn:I,endLineNumber:b,endColumn:I})}}return S.$tryInsertSnippet(l,r.value.version,n.value,f,g)},setDecorations(n,i){const g=i.length===0;g&&!s.h.has(n.key)||(g?s.h.delete(n.key):s.h.add(n.key),s.n(()=>{if(O.$UO(i))return S.$trySetDecorations(l,n.key,O.$VO(i));{const f=new Array(4*i.length);for(let u=0,b=i.length;u<b;u++){const I=i[u];f[4*u]=I.start.line+1,f[4*u+1]=I.start.character+1,f[4*u+2]=I.end.line+1,f[4*u+3]=I.end.character+1}return S.$trySetDecorationsFast(l,n.key,f)}}))},revealRange(n,i){s.n(()=>S.$tryRevealRange(l,O.Range.from(n),i||A.TextEditorRevealType.Default))},show(n){S.$tryShowEditor(l,O.ViewColumn.from(n))},hide(){S.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const S=l.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=S.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,r,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$7O=C}),define(ke[71],Ie([1,0,61,4,6,2,3,5,121,17,125,10,12,29,16,40,47]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,n){this.h=s,this.i=n,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new R.$he,this.e=new R.$he,this.f=new R.$he,this.g=new R.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const n=[],i=[],g=[];if(s.removedDocuments)for(const f of s.removedDocuments){const u=O.URI.revive(f),b=this.c.get(u);b?.unref()&&(this.c.delete(u),n.push(b.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const u=O.URI.revive(f.uri);let b=this.c.get(u);if(b&&u.scheme!==d.Schemas.vscodeNotebookCell&&u.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);b||(b=new a(new $.$1O(this.h.getProxy(T.$tM.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(u,b),i.push(b.value)),b.ref()}if(s.removedEditors)for(const f of s.removedEditors){const u=this.b.get(f);this.b.delete(f),u&&g.push(u)}if(s.addedEditors)for(const f of s.addedEditors){const u=O.URI.revive(f.documentUri);E.ok(this.c.has(u),`document '${u}' does not exist`),E.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const b=this.c.get(u).value,I=new C.$7O(f.id,this.h.getProxy(T.$tM.MainThreadTextEditors),this.i,new o.$V(()=>b.document),f.selections.map(w.Selection.to),f.options,f.visibleRanges.map(D=>w.Range.to(D)),typeof f.editorPosition=="number"?w.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,I)}s.newActiveEditor!==void 0&&(E.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,P.$Pc)(n),(0,P.$Pc)(g),s.removedDocuments&&this.e.fire(n),s.addedDocuments&&this.d.fire(i),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const n=this.b.get(this.a);return s?n:n?.value}allEditors(){return[...this.b.values()]}};e.$8O=h,e.$8O=h=He([Ve(0,c.$XO),Ve(1,l.$7j)],h),e.$9O=(0,A.$Ai)("IExtHostDocumentsAndEditors")}),define(ke[300],Ie([1,0,18,4,5,125,10,7]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class ${constructor(C,w){this.i=w,this.a=new R.$he,this.b=new R.$he,this.c=new R.$he,this.d=new R.$he,this.f=new R.$he,this.g=new R.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(P.$tM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const w=this.i.allEditors();return C?w:w.map(l=>l.value)}async showTextDocument(C,w,l){let S;typeof w=="number"?S={position:A.ViewColumn.from(w),preserveFocus:l}:typeof w=="object"?S={position:A.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?A.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:S={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(C.uri,S),r=d&&this.i.getEditor(d);if(r)return r.value;throw d?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,w){return new O.$5O(this.h,C,w).value}$acceptEditorPropertiesChanged(C,w){const l=this.i.getEditor(C);if(!l)throw new Error("unknown text editor");if(w.options&&l._acceptOptions(w.options),w.selections){const S=w.selections.selections.map(A.Selection.to);l._acceptSelections(S)}if(w.visibleRanges){const S=E.$Hb(w.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(S)}if(w.options&&this.b.fire({textEditor:l.value,options:{...w.options,lineNumbers:A.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const S=T.TextEditorSelectionChangeKind.fromValue(w.selections.source),d=w.selections.selections.map(A.Selection.to);this.a.fire({textEditor:l.value,selections:d,kind:S})}if(w.visibleRanges){const S=E.$Hb(w.visibleRanges.map(A.Range.to));this.c.fire({textEditor:l.value,visibleRanges:S})}}$acceptEditorPositionData(C){for(const w in C){const l=this.i.getEditor(w);if(!l)throw new Error("Unknown text editor");const S=A.ViewColumn.to(C[w]);l.value.viewColumn!==S&&(l._acceptViewColumn(S),this.d.fire({textEditor:l.value,viewColumn:S}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$Qmc=$}),define(ke[301],Ie([1,0,2,3,5,6,7,10,19,37,15]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=e.$zoc=void 0,e.$zoc=(0,R.$Ai)("IExtHostTimeline");class w{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$tM.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$Wm.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:E.URI.revive(o.uri);return this.c.get(o.source)?.get(l(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(E.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new O.$Tc,t=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:r.id}),this));const n=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(i,g,f){g?.resetCache&&(h.clear(),n.get(r.id)?.clear());const u=await r.provideTimeline(i,g,f);if(u==null)return;const b=t(i,g);return{...u,source:r.id,items:u.items.map(b)}},dispose(){for(const i of n.values())i.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let t;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const n=l(a);t=s.get(n),t===void 0&&(t=new Map,s.set(n,t))}return s=>{const{iconPath:n,...i}=s,g=`${d}|${s.id??s.timestamp}`;t?.set(g,s);let f,u,b;s.iconPath&&(n instanceof A.$sN?b={id:n.id,color:n.color}:E.URI.isUri(n)?(f=n,u=n):{light:f,dark:u}=n);let I;return A.$XM.isMarkdownString(i.tooltip)?I=T.MarkdownString.from(i.tooltip):(0,C.$ag)(i.tooltip)?I=i.tooltip:A.$XM.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=T.MarkdownString.from(i.detail)):(0,C.$ag)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=i.detail),{...i,id:i.id??void 0,handle:g,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:u,themeIcon:b,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Sc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Aoc=w;function l(S){return S?.toString()}}),define(ke[302],Ie([1,0,188,24,2,4,6,231,11,7,15,18,10,59,22,152,25]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0;function a(s,n){if((0,C.$ag)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let i;return Array.isArray(s.highlights)&&(i=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),i=i.length?i:void 0),{label:s.label,highlights:i}}}class h extends A.$Uc{constructor(n,i,g){super(),this.f=n,this.g=i,this.h=g,this.a=new Map,this.b=new r.$10;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>f(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(b=>f(b)?this.r(b):b):u})}registerTreeDataProvider(n,i,g){const f=this.createTreeView(n,{treeDataProvider:i},g);return{dispose:()=>f.dispose()}}createTreeView(n,i,g){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,D=this.m(n,i,g),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:b,hasHandleDrop:I,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(n,y),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$TG)(g,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$TG)(g,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(m){(0,S.$Zk)(m)&&(0,o.$TG)(g,"treeViewMarkdownMessage"),D.message=m},get title(){return D.title},set title(m){D.title=m},get description(){return D.description},set description(m){D.description=m},get badge(){return D.badge},set badge(m){m!==void 0&&c.ViewBadge.isViewBadge(m)?D.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(D.badge=void 0)},reveal:(m,v)=>D.reveal(m,v),dispose:async()=>{await p,this.a.delete(n),D.dispose()}};return this.B(k),k}$getChildren(n,i){const g=this.a.get(n);return g?g.getChildren(i):Promise.reject(new T.$dG(n))}async $handleDrop(n,i,g,f,u,b,I,D){const y=this.a.get(n);if(!y)return Promise.reject(new T.$dG(n));const p=l.DataTransfer.toDataTransfer(g,async k=>(await this.f.$resolveDropFileData(n,i,k)).buffer);return I===n&&D&&await this.j(p,y,D,u,b),y.onDrop(p,f,u)}async j(n,i,g,f,u){const b=this.b.removeDragOperationTransfer(u);if(b)(await b)?.forEach((I,D)=>{I&&n.set(D,I)});else if(u&&i.handleDrag){const I=i.handleDrag(g,n,f);this.b.addDragOperationTransfer(u,I),await I}return n}async $handleDrag(n,i,g,f){const u=this.a.get(n);if(!u)return Promise.reject(new T.$dG(n));const b=await this.j(new c.$oN,u,i,f,g);if(!(!b||f.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(n){const i=this.a.get(n);if(!i)throw new T.$dG(n);return i.hasResolve}$resolve(n,i,g){const f=this.a.get(n);if(!f)throw new T.$dG(n);return f.resolveTreeItem(i,g)}$setExpanded(n,i,g){const f=this.a.get(n);if(!f)throw new T.$dG(n);f.setExpanded(i,g)}$setSelectionAndFocus(n,i,g){const f=this.a.get(n);if(!f)throw new T.$dG(n);f.setSelectionAndFocus(i,g)}$setVisible(n,i){const g=this.a.get(n);if(!g){if(!i)return;throw new T.$dG(n)}g.setVisible(i)}$changeCheckboxState(n,i){const g=this.a.get(n);if(!g)throw new T.$dG(n);g.setCheckboxState(i)}m(n,i,g){const f=this.B(new t(n,i,this.f,this.g.converter,this.h,g));return this.a.set(n,f),f}r(n){const i=this.a.get(n.$treeViewId);return i&&"$treeItemHandle"in n?i.getExtensionElement(n.$treeItemHandle):i&&"$focusedTreeItem"in n&&n.$focusedTreeItem?i.focusedElement:null}}e.$Boc=h;class t extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(n=>this.getExtensionElement(n)).filter(n=>!(0,C.$jg)(n))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(n,i,g,f,u,b){if(super(),this.I=n,this.J=g,this.L=f,this.M=u,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$se,b.contributes&&b.contributes.views)for(const p in b.contributes.views)for(const k of b.contributes.views[p])k.id===n&&(this.P=k.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>{Array.isArray(p)&&p.length===0||this.F.fire({message:!1,element:p})}));let I,D;const y=O.Event.debounce(this.F.event,(p,k)=>(p||(p={message:!1,elements:[]}),k.element!==!1&&(I||(I=new Promise(m=>D=m),this.G=this.G.then(()=>I)),Array.isArray(k.element)?p.elements.push(...k.element):p.elements.push(k.element)),k.message&&(p.message=!0),p),200,!0);this.B(y(({message:p,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const m=D;return I=null,this.$(k).then(()=>m())})),p&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(n){const i=n?this.getExtensionElement(n):void 0;if(n&&!i)return this.M.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let g=this.X(n);return g||(g=await this.Y(i)),g?g.map(f=>f.item):void 0}getExtensionElement(n){return this.j.get(n)}reveal(n,i){i=i||{select:!0,focus:!1};const g=(0,C.$jg)(i.select)?!0:i.select,f=(0,C.$jg)(i.focus)?!1:i.focus,u=(0,C.$jg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.G.then(()=>this.S(n)).then(b=>this.W(n,b[b.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:b.map(D=>D.item)},{select:g,focus:f,expand:u})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:g,focus:f,expand:u})}get message(){return this.O}set message(n){this.O=n,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(n){this.P=n,this.J.$setTitle(this.I,n,this.Q)}get description(){return this.Q}set description(n){this.Q=n,this.J.$setTitle(this.I,this.P,n)}get badge(){return this.R}set badge(n){this.R?.value===n?.value&&this.R?.tooltip===n?.tooltip||(this.R=l.ViewBadge.from(n),this.J.$setBadge(this.I,n))}setExpanded(n,i){const g=this.getExtensionElement(n);g&&(i?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(n,i){const g=!(0,w.$ub)(this.s,n);this.s=n;const f=this.t!==i;this.t=i,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.r&&(this.r=n,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(n){const i=(await Promise.all(n.map(async g=>{const f=this.getExtensionElement(g.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);i.forEach(g=>{g.treeItem.checkboxState=g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(g=>[g.extensionItem,g.newState])})}async handleDrag(n,i,g){const f=[];for(const u of n){const b=this.getExtensionElement(u);b&&f.push(b)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,i,g),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,i,g){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.g?.handleDrop))return(0,$.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(f,n,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,i){if(!this.f.resolveTreeItem)return;const g=this.j.get(n);if(g){const f=this.m.get(g);if(f){const u=await this.f.resolveTreeItem(f.extensionItem,g,i)??f.extensionItem;return this.hb(u),f.item.tooltip=this.eb(u.tooltip),f.item.command=this.fb(f.disposableStore,u.command),f.item}}}S(n){return this.U(n).then(i=>i?this.S(i).then(g=>this.W(i,g[g.length-1]).then(f=>(g.push(f),g))):Promise.resolve([]))}U(n){const i=this.m.get(n);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$sh)(()=>this.f.getParent(n))}W(n,i){const g=this.m.get(n);return g?Promise.resolve(g):(0,$.$sh)(()=>this.f.getTreeItem(n)).then(f=>this.kb(n,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const b=this.m.get(u);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(n){if(n){let i;if(typeof n=="string"){const g=this.getExtensionElement(n);i=g?this.m.get(g):void 0}else i=n;return i&&i.children||void 0}return this.h}async Y(n){this.rb(n);const i=new d.$se(this.Z.token);try{const g=n?this.m.get(n):void 0,f=await this.f.getChildren(n);if(i.token.isCancellationRequested)return;const u=(0,w.$Hb)(f||[]),b=await Promise.all((0,w.$Hb)(u).map(D=>this.f.getTreeItem(D)));if(i.token.isCancellationRequested)return;const I=b.map((D,y)=>D?this.db(u[y],D,g):null);return(0,w.$Hb)(I)}finally{i.dispose()}}$(n){if(n.some(g=>!g))return this.Z.dispose(!0),this.Z=new d.$se,this.tb(),this.J.$refresh(this.I);{const g=this.ab(n);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(n){const i=new Set,g=n.map(u=>this.m.get(u));for(const u of g)if(u&&!i.has(u.item.handle)){let b=u;for(;b&&b.parent&&g.findIndex(I=>b&&b.parent&&I&&I.item.handle===b.parent.item.handle)===-1;){const I=this.j.get(b.parent.item.handle);b=I?this.m.get(I):void 0}b&&!b.parent&&i.add(u.item.handle)}const f=[];return i.forEach(u=>{const b=this.j.get(u);if(b){const I=this.m.get(b);I&&(!I.parent||!i.has(I.parent.item.handle))&&f.push(u)}}),f}bb(n){const i={};return Promise.all(n.map(g=>this.cb(g).then(f=>{f&&(i[g]=f.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(n){const i=this.getExtensionElement(n);if(i){const g=this.m.get(i);if(g)return this.rb(i),(0,$.$sh)(()=>this.f.getTreeItem(i)).then(f=>{if(f){const u=this.ib(i,f,g.parent);return this.pb(i,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}db(n,i,g){const f=this.ib(n,i,g);if(i.id&&this.j.has(f.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(n,f),this.qb(f,g),f}eb(n){return c.$XM.isMarkdownString(n)?l.MarkdownString.from(n):n}fb(n,i){return i?{...this.L.toInternal(i,n),originalId:i.command}:void 0}gb(n){if(n.checkboxState===void 0)return;let i,g,f;return typeof n.checkboxState=="number"?i=n.checkboxState:(i=n.checkboxState.state,g=n.checkboxState.tooltip,f=n.checkboxState.accessibilityInformation),{isChecked:i===c.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:f}}hb(n){if(!c.$jN.isTreeItem(n,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(n,i,g){this.hb(i);const f=this.B(new A.$Tc),u=this.kb(n,i,g),b=this.lb(i);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:a(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(f,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,C.$jg)(i.collapsibleState)?c.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:g,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(n){return n.iconPath instanceof c.$sN?n.iconPath:void 0}kb(n,{id:i,label:g,resourceUri:f},u,b){if(i)return`${t.b}/${i}`;const I=a(g,this.N),D=u?u.item.handle:t.a;let y=I?I.label:f?(0,R.$$g)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const p=this.m.has(n)?this.m.get(n).item.handle:void 0,k=this.X(u)||[];let m,v=0;do{if(m=`${D}/${v}:${y}`,b||!this.j.has(m)||p===m)break;v++}while(v<=k.length);return m}lb(n){if(n.iconPath&&!(n.iconPath instanceof c.$sN))return typeof n.iconPath=="string"||P.URI.isUri(n.iconPath)?this.nb(n.iconPath):this.nb(n.iconPath.light)}mb(n){if(n.iconPath&&!(n.iconPath instanceof c.$sN)&&n.iconPath.dark)return this.nb(n.iconPath.dark)}nb(n){return P.URI.isUri(n)?n:P.URI.file(n)}ob(n,i){this.j.set(i.item.handle,n),this.m.set(n,i)}pb(n,i,g,f){this.j.delete(i.item.handle),this.m.delete(n),i.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(n,i);const u=this.X(f)||[],b=u.filter(I=>I.item.handle===g.item.handle)[0];b&&u.splice(u.indexOf(b),1,i)}qb(n,i){i?(i.children||(i.children=[]),i.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}rb(n){if(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}i.children=void 0}}else this.tb()}sb(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}this.m.delete(n),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(n=>n.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[303],Ie([1,0,4,6,2,36,10,67,5,7]),function(de,e,E,R,P,O,A,T,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class C extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new E.$he),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$he),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#l=a.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class w extends R.$Uc{static c(){return(0,O.$Wg)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$tM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const t=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(t),preserveFocus:typeof a=="object"&&!!a.preserveFocus},n=(0,T.$6mc)(d),i=w.c();this.f.$createWebviewPanel((0,T.$8mc)(d),i,r,{title:o,panelOptions:l(h),webviewOptions:(0,T.$9mc)(d,this.m,h),serializeBuffersForPostMessage:n},s);const g=this.j.createNewWebview(i,h,d);return this.createNewWebviewPanel(i,r,o,t,h,g,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],t=d[a];return h.active?1:t.active?-1:+h.visible-+t.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,T.$6mc)(d)}),new c.$vM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:t,extension:s}=h,n=this.j.createNewWebview(d,o.webviewOptions,s),i=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,n,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(d,r,o,a,h,t,s){const n=new C(d,this.f,t,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,n),n}getWebviewPanel(d){return this.g.get(d)}}e.$0mc=w;function l(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[304],Ie([1,0,4,6,67,10,5,7]),function(de,e,E,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class $ extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(w,l,S,d,r,o){super(),this.#s=!1,this.#l=this.B(new E.$he),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new E.$he),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=w,this.#t=l,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(w){this.a(),this.#a!==w&&(this.#a=w,this.#t.$setWebviewViewTitle(this.#e,w))}get description(){return this.a(),this.#o}set description(w){this.a(),this.#o!==w&&(this.#o=w,this.#t.$setWebviewViewDescription(this.#e,w))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(w){w===this.#r||this.#s||(this.#r=w,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(w){this.a(),!(w?.value===this.#c?.value&&w?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(w),this.#t.$setWebviewViewBadge(this.#e,w))}show(w){this.a(),this.#t.$show(this.#e,!!w)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(w,l){this.d=l,this.b=new Map,this.c=new Map,this.a=w.getProxy(A.$tM.MainThreadWebviewViews)}registerWebviewViewProvider(w,l,S,d){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:S,extension:w}),this.a.$registerWebviewViewProvider((0,P.$8mc)(w),l,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$6mc)(w)}),new T.$vM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(w,l,S,d,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:a,extension:h}=o,t=this.d.createNewWebview(w,{},h),s=new $(w,this.a,l,S,t,!0);this.c.set(w,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(w,l){this.e(w)._setVisible(l)}async $disposeWebviewView(w){const l=this.e(w);this.c.delete(w),l.dispose(),this.d.deleteWebview(w)}e(w){const l=this.c.get(w);if(!l)throw new Error("No webview found");return l}}e.$Eoc=c}),define(ke[305],Ie([1,0,4,31,32,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.$OL=e.OutputChannelUpdateMode=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=void 0,e.$BL="text/x-code-output",e.$CL="output",e.$DL="Log",e.$EL="text/x-code-log-output",e.$FL="log",e.$GL="workbench.panel.output",e.$HL=new P.$Rj("inOutput",!1),e.$IL=new P.$Rj("activeLogOutput",!1),e.$JL=new P.$Rj("activeLogOutput.levelSettable",!1),e.$KL=new P.$Rj("activeLogOutput.level",""),e.$LL=new P.$Rj("activeLogOutput.levelIsDefault",!1),e.$ML=new P.$Rj("outputView.scrollLock",!1),e.$NL=(0,O.$Ai)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$OL={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new E.$he,this.onDidRegisterChannel=this.b.event,this.c=new E.$he,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(C=>c.push(C)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}R.$jo.add(e.$OL.OutputChannels,new T),e.$PL=new P.$Rj("activeOutputChannel","")}),define(ke[126],Ie([1,0,5,3,17,19,12,305,68,27,51,156,23,15,30,4,6]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=e.$doc=void 0;class a extends A.$ak{get disposed(){return this.n}constructor(n,i,g,f,u){super(),this.id=n,this.name=i,this.r=g,this.s=f,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,n)}replace(n){const i=this.m;this.info(n),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(n,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof n=="boolean"?n:i))}hide(){this.s.$close(this.id)}g(n,i){this.m+=l.$Je.fromString(i).byteLength,(0,A.log)(this.r,n,i),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(n){this.append(n)}}let t=class{constructor(n,i,g,f,u,b){this.i=i,this.j=g,this.k=f,this.l=u,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=n.getProxy(E.$tM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,w.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.h=n;for(const[i,g]of this.g)g.visible=i===this.h}createOutputChannel(n,i,g){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,u=(0,S.$ag)(i)?i:void 0;if((0,S.$ag)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const I=this.i.environment.extensionLogLevel?.find(([y])=>O.$Wm.equals(g.identifier,y))?.[1];I&&(b=(0,A.$lk)(I));const D=f?this.o(n,b,g):this.n(n,u,g);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(n,b??this.m.getLevel(),D):this.q(n,D)}async n(n,i,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,u=this.k.extUri.joinPath(f,`${this.f++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(n,u,i,g.identifier.value);return new a(I,n,b,this.a,g)}async o(n,i,g){const f=await this.p(g),u=n.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(f,`${u}.log`),I=`${g.identifier.value}.${u}`,D=this.l.createLogger(b,{id:I,name:n,logLevel:i,extensionId:g.identifier.value});return new h(I,n,D,this.a,g)}p(n){let i=this.d.get(n.identifier.value);if(!i){const g=this.k.extUri.joinPath(this.i.logsLocation,n.identifier.value);this.d.set(n.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(g)}catch(f){if((0,d.$kl)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return g})())}return i}q(n,i){let g=!1;const f=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return n},append(u){f(),i.then(b=>b.append(u))},appendLine(u){f(),i.then(b=>b.appendLine(u))},clear(){f(),i.then(u=>u.clear())},replace(u){f(),i.then(b=>b.replace(u))},show(u,b){f(),i.then(I=>I.show(u,b))},hide(){f(),i.then(u=>u.hide())},dispose(){g=!0,i.then(u=>u.dispose())}}}r(n,i,g){const f=new o.$Tc,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},b=f.add(new r.$he);function I(D){i=D,b.fire(D)}return g.then(D=>{f.add(D),D.logLevel!==i&&I(D.logLevel),f.add(D.onDidChangeLogLevel(y=>I(y)))}),{...this.q(n,g),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(D,...y){u(),g.then(p=>p.trace(D,...y))},debug(D,...y){u(),g.then(p=>p.debug(D,...y))},info(D,...y){u(),g.then(p=>p.info(D,...y))},warn(D,...y){u(),g.then(p=>p.warn(D,...y))},error(D,...y){u(),g.then(p=>p.error(D,...y))},dispose(){f.dispose()}}}};e.$doc=t,e.$doc=t=He([Ve(0,P.$XO),Ve(1,c.$bP),Ve(2,$.$2mc),Ve(3,C.$Emc),Ve(4,A.$8j),Ve(5,A.$7j)],t),e.$eoc=(0,R.$Ai)("IExtHostOutputService")}),define(ke[127],Ie([1,0,3,11]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$ln=(0,E.$Ai)("remoteAgentService"),e.$mn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,R.$Bh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[306],Ie([1,0,191,54,31,50,42,6,4,127,21,26,11,112]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhb=e.$ehb=e.$dhb=e.$chb=e.$bhb=e.$ahb=e.$_gb=e.$$gb=e.$0gb=void 0,e.$0gb=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$$gb=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$_gb=Object.freeze({id:"security",scope:R.ConfigurationScope.APPLICATION,title:(0,E.localize)(2,null),type:"object",order:7}),e.$ahb=Object.freeze({id:"problems",title:(0,E.localize)(3,null),type:"object",order:101}),e.$bhb=Object.freeze({id:"window",order:8,title:(0,E.localize)(4,null),type:"object"}),e.$chb={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;P.$jo.add(e.$chb.ConfigurationMigration,r);let o=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const f of g.added)await this.f(f,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(g=>this.g(g,n?.uri))])}async g(n,i){const g=this.a.inspect(n.key,{resource:i}),f=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[u,b]of f){const I=g[u];if(!I)continue;const D=[];if(I.value!==void 0){const y=await this.h(n,u,I.value,i,void 0);for(const p of y??[])D.push([p,[]])}for(const{identifiers:y,value:p}of I.overrides??[])if(p!==void 0){const k=await this.h(n,u,p,i,y);for(const m of k??[])D.push([m,y])}D.length&&await Promise.allSettled(D.map(async([[y,p],k])=>this.a.updateValue(y,p.value,{resource:i,overrideIdentifiers:k},b)))}}async h(n,i,g,f,u){const b=D=>{const p=this.a.inspect(D,{resource:f})[i];if(p)return u?p.overrides?.find(({identifiers:k})=>(0,w.$ao)(k,u))?.value:p.value},I=await n.migrateFn(g,b);return Array.isArray(I)?I:[[n.key,I]]}};e.$dhb=o,e.$dhb=o=He([Ve(0,A.$7i),Ve(1,O.$Ji)],o);let a=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!C.$i&&(await this.b.getEnvironment())?.os!==C.OperatingSystem.Windows)return;P.$jo.as(R.$oo.Configuration).registerConfiguration({...e.$_gb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(5,null)},default:[],markdownDescription:(0,E.localize)(6,null),scope:R.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(7,null),scope:R.ConfigurationScope.MACHINE}}})}};e.$ehb=a,e.$ehb=a=He([Ve(0,c.$ln)],a);const h="window.newWindowProfile";let t=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,i){super(),this.c=n,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(h)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$jo.as(R.$oo.Configuration),i={...e.$bhb,properties:{[h]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,E.localize)(8,null)],description:(0,E.localize)(9,null),scope:R.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[i],remove:[this.a]}):n.registerConfiguration(i),this.a=i}h(){const n=this.f.getValue(h);this.b=n?this.c.profiles.find(i=>i.name===n):void 0}j(){const n=this.f.getValue(h);if(!n)return;const i=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==i?.name&&this.f.updateValue(h,i?.name)}};e.$fhb=t,e.$fhb=t=He([Ve(0,S.$Gl),Ve(1,A.$7i)],t)}),define(ke[307],Ie([1,0,41,16,20,24,202,306,54,3,31]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$hhb=e.$ghb=void 0,e.$ihb=r,e.$jhb=o,e.$ghb=(0,c.$Ai)("editorResolverService"),e.$hhb="workbench.editorAssociations";const w=C.$jo.as($.$oo.Configuration),l={...T.$$gb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};w.registerConfiguration(l);var S;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function o(a,h){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(h.scheme))return!1;const n=typeof a=="string"&&a.indexOf(P.$gc.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$$g)(h);return E.$tk(typeof a=="string"?a.toLowerCase():a,n.toLowerCase())}}),define(ke[308],Ie([1,0,53,16,20,21,24,2,3,225,50,245,127]),function(de,e,E,R,P,O,A,T,$,c,C,w,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0,e.$8L=(0,$.$Ai)("pathService");let d=S=class{constructor(o,a,h,t){this.d=o,this.e=a,this.f=h,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(t=>this.h(o,t,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===R.Schemas.file||o.scheme===R.Schemas.vscodeRemote?(0,E.$xg)(h??(0,A.$$g)(o),a===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return R.Schemas.vscodeRemote;const h=(0,c.$5L)(a.getWorkspace());if(h)return h;const t=a.getWorkspace().folders[0];if(t)return t.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:R.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(o){let a="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(a=o.substring(2),o="/"):(a=o.substring(2,t),o=o.substring(t)||"/")}return T.URI.from({scheme:R.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$9L=d,e.$9L=d=S=He([Ve(1,l.$ln),Ve(2,w.$QL),Ve(3,C.$Ji)],d)}),define(ke[128],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AK=e.$zK=void 0;class E{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new E(0,0)}with(A){return new E(0,0)}}e.$zK=E;class R{constructor(A,T,$,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(A,T),this.end=new E($,c)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.$AK=R;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(ke[43],Ie([1,0,18,41,26,53,13,3,20,14,128,11]),function(de,e,E,R,P,O,A,T,$,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$XK=e.$QK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$NK=e.$MK=e.$LK=e.$KK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TextSearchCompleteMessageType=void 0,e.$HK=a,e.$IK=h,e.$JK=t,e.$OK=D,e.$PK=y,e.$RK=m,e.$SK=v,e.$TK=F,e.$UK=M,e.$VK=G,e.$WK=q,e.$YK=N,e.$1K=re,e.$2K=fe,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$BK="workbench.view.search",e.$CK="workbench.panel.search",e.$DK="workbench.view.search",e.$EK="search-result",e.$FK="search.exclude";const l="\u27EA ",S=" characters skipped \u27EB",d=(l.length+S.length+5)*2;e.$GK=(0,T.$Ai)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(oe){return!!oe.preview}function h(oe){return!!oe.resource}function t(oe){return!!oe.message}var s;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class n{constructor(pe){this.resource=pe,this.results=[]}}e.$KK=n;class i{constructor(pe,$e,se,Ce){this.ranges=$e,this.webviewIndex=Ce;const Fe=Array.isArray($e)?$e:[$e];if(se&&se.matchLines===1&&g(Fe)){pe=(0,A.$6f)(pe,se.matchLines);let Y="",W=0,ie=0;const De=Math.floor(se.charsPerLine/5),he=[];for(const ve of Fe){const ae=Math.max(ve.startColumn-De,0),X=ve.startColumn+se.charsPerLine;if(ae>ie+De+d){const x=l+(ae-ie)+S;Y+=x+pe.slice(ae,X),W+=ae-(ie+x.length)}else Y+=pe.slice(ie,X);he.push(new u(0,ve.startColumn-W,ve.endColumn-W)),ie=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?he:he[0]}}else{const Y=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:pe,matches:(0,E.$1b)($e,W=>new f(W.startLineNumber-Y,W.startColumn,W.endLineNumber-Y,W.endColumn))}}}}e.$LK=i;function g(oe){const pe=oe[0].startLineNumber;for(const $e of oe)if($e.startLineNumber!==pe||$e.endLineNumber!==pe)return!1;return!0}class f{constructor(pe,$e,se,Ce){this.startLineNumber=pe,this.startColumn=$e,this.endLineNumber=se,this.endColumn=Ce}}e.$MK=f;class u extends f{constructor(pe,$e,se){super(pe,$e,pe,se)}}e.$NK=u;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var I;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(oe,pe=!0){const $e=oe&&oe.files&&oe.files.exclude,se=pe&&oe&&oe.search&&oe.search.exclude;if(!$e&&!se)return;if(!$e||!se)return $e||se;let Ce=Object.create(null);return Ce=P.$_n(Ce,P.$9n($e)),Ce=P.$_n(Ce,P.$9n(se),!0),Ce}function y(oe,pe){return oe.excludePattern&&R.$tk(oe.excludePattern,pe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&R.$tk(oe.includePattern,pe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some($e=>{const se=$e.folder.fsPath;if(O.$zg(pe,se)){const Ce=$.$lc(se,pe);return!$e.includePattern||!!R.$tk($e.includePattern,Ce)}else return!1}):!1:!0}var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class k extends Error{constructor(pe,$e){super(pe),this.code=$e}}e.$QK=k;function m(oe){const pe=oe.message;if((0,c.$4)(oe))return new k(pe,p.canceled);try{const $e=JSON.parse(pe);return new k($e.message,$e.code)}catch{return new k(pe,p.other)}}function v(oe){const pe={message:oe.message,code:oe.code};return new Error(JSON.stringify(pe))}function F(oe){return oe.type==="error"?!0:oe.type==="success"}function M(oe){return oe.type==="success"}function G(oe){return!!oe.path}function q(oe,pe,$e=!0){const se=oe.searchPath?oe.searchPath:oe.relativePath;return $e?(0,A.$3f)(se,pe):R.$tk(pe,se)}class V{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XK=V;function N(oe,pe){const $e={...oe||{},...pe||{}};return Object.keys($e).filter(se=>{const Ce=$e[se];return typeof Ce=="boolean"&&Ce})}class L{constructor(pe,$e){this.c=null,this.a={...pe.excludePattern||{},...$e.excludePattern||{}},this.b=R.$uk(this.a);let se=pe.includePattern;$e.includePattern&&(se?se={...se,...$e.includePattern}:se=$e.includePattern),se&&(this.c=R.$uk(se))}matchesExcludesSync(pe,$e,se){return!!(this.b&&this.b(pe,$e,se))}includedInQuerySync(pe,$e,se){return!(this.b&&this.b(pe,$e,se)||this.c&&!this.c(pe,$e,se))}includedInQuery(pe,$e,se){const Ce=this.b(pe,$e,se),Fe=()=>this.c?!!this.c(pe,$e,se):!0;return(0,w.$mh)(Ce)?Ce.then(Y=>Y?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$ZK=L;function Z(oe){for(const pe in oe)if(typeof oe[pe]!="boolean")return!0;return!1}function re(oe){if(!oe)return;let pe;return $e=>(pe||(pe=(oe()||Promise.resolve([])).then(se=>se?be(se):{})),pe.then(se=>!!se[$e]))}function fe(oe){if(!oe)return;let pe;return $e=>{if(!pe){const se=oe();pe=se?be(se):{}}return!!pe[$e]}}function be(oe){const pe={};for(const $e of oe)pe[$e]=!0;return pe}}),define(ke[44],Ie([1,0,18,11,22,4,6,58,16,137,24,13,2,190,30,3,12,213,50,51,27,17,10,7,65,43,5,49]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0;function D(G,q,V){return new C.$3g(N=>m(N,V)).isEqual(G,q)}function y(G,q,V){return D(G.uri,q.uri,V)?0:(0,w.$uf)(G.uri.toString(),q.uri.toString())}function p(G,q,V){return G.index!==q.index?G.index<q.index?-1:1:D(G.uri,q.uri,V)?(0,w.$uf)(G.name,q.name):(0,w.$uf)(G.uri.toString(),q.uri.toString())}function k(G,q,V,N){const L=G.slice(0).sort((re,fe)=>V(re,fe,N)),Z=q.slice(0).sort((re,fe)=>V(re,fe,N));return(0,E.$Eb)(L,Z,(re,fe)=>V(re,fe,N))}function m(G,q){const V=q.getCapabilities(G.scheme);return!(V&&V&d.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends h.$Ti{static toExtHostWorkspace(q,V,N,L){if(!q)return{workspace:null,added:[],removed:[]};const{id:Z,name:re,folders:fe,configuration:be,transient:oe,isUntitled:pe}=q,$e=[],se=V;V?fe.forEach((W,ie)=>{const De=l.URI.revive(W.uri),he=v.o(N||V,De,L);he?(he.name=W.name,he.index=W.index,$e.push(he)):$e.push({uri:De,name:W.name,index:ie})}):$e.push(...fe.map(({uri:W,name:ie,index:De})=>({uri:l.URI.revive(W),name:ie,index:De}))),$e.sort((W,ie)=>W.index<ie.index?-1:1);const Ce=new v(Z,re,$e,!!oe,be?l.URI.revive(be):null,!!pe,W=>m(W,L)),{added:Fe,removed:Y}=k(se?se.workspaceFolders:[],Ce.workspaceFolders,y,L);return{workspace:Ce,added:Fe,removed:Y}}static o(q,V,N){for(let L=0;L<q.folders.length;L++){const Z=q.workspaceFolders[L];if(D(Z.uri,V,N))return Z}}constructor(q,V,N,L,Z,re,fe){super(q,N.map(be=>new h.$Ui(be)),L,Z,fe),this.t=V,this.u=re,this.q=[],this.s=T.$Gi.forUris(fe),N.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,V){return V&&this.s.get(q)&&(q=(0,C.$ah)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let F=class{constructor(q,V,N,L,Z){this.c=new O.$he,this.onDidChangeWorkspace=this.c.event,this.g=new O.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$je,this.C=new Map,this.h=L,this.s=N,this.t=Z,this.j=new c.$Im,this.k=new R.$zh,this.o=q.getProxy(b.$tM.MainThreadWorkspace),this.q=q.getProxy(b.$tM.MainThreadMessageService);const re=V.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,fe=>m(fe,N)):void 0}$initializeWorkspace(q,V){this.v=V,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:$.Schemas.untitled,path:(0,C.$$g)((0,C.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,V,N,...L){const Z=[];if(Array.isArray(L)&&L.forEach(pe=>{l.URI.isUri(pe.uri)&&!Z.some($e=>D($e.uri,pe.uri,this.s))&&Z.push({uri:pe.uri,name:pe.name||(0,C.$0g)(pe.uri)})}),this.n||[V,N].some(pe=>typeof pe!="number"||pe<0)||N===0&&Z.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(V+N>re.length)return!1;const fe=re.slice(0);fe.splice(V,N,...Z.map(pe=>({uri:pe.uri,name:pe.name||(0,C.$0g)(pe.uri),index:void 0})));for(let pe=0;pe<fe.length;pe++){const $e=fe[pe];if(fe.some((se,Ce)=>Ce!==pe&&D($e.uri,se.uri,this.s)))return!1}fe.forEach((pe,$e)=>pe.index=$e);const{added:be,removed:oe}=k(re,fe,p,this.s);if(be.length===0&&oe.length===0)return!1;if(this.o){const pe=q.displayName||q.name;this.o.$updateWorkspaceFolders(pe,V,N,Z).then(void 0,$e=>{this.n=void 0;const se={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,S.localize)(0,null,pe,$e.toString()),se,[])})}return this.y(fe),!0}getWorkspaceFolder(q,V){if(this.x)return this.x.getWorkspaceFolder(q,V)}async getWorkspaceFolder2(q,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,V)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,V){let N,L="";if(typeof q=="string"?(N=l.URI.file(q),L=q):typeof q<"u"&&(N=q,L=q.fsPath),!N)return L;const Z=this.getWorkspaceFolder(N,!0);if(!Z)return L;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let re=(0,C.$dh)(Z.uri,N);return V&&Z.name&&(re=`${Z.name}/${re}`),re}y(q){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:V,added:N,removed:L}=v.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:L}))}findFiles(q,V,N,L,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let re="",fe=!0;return V===null?fe=!1:V!==void 0&&(typeof V=="string"?re=V:re=V.pattern),this.z(q,void 0,{exclude:re,maxResults:N,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(q,V={},N,L=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,q,V,L)}async z(q,V,N,L=P.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const Z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,re={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:Z,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let fe;if(q){const{includePattern:be,folder:oe}=M(i.GlobPattern.from(q));fe=oe,re.includePattern=be}else{const{includePattern:be,folder:oe}=M(i.GlobPattern.from(V));fe=oe,re.filePattern=be}return this.o.$startFileSearch(fe??null,re,L).then(be=>Array.isArray(be)?be.map(oe=>l.URI.revive(oe)):[])}async findTextInFiles(q,V,N,L,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),fe=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:be,folder:oe}=M(i.GlobPattern.from(V.include)),pe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,$e={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:fe,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:be,excludePattern:pe},se=!1;if(this.u[re]=Ce=>{if(se)return;const Fe=l.URI.revive(Ce.resource);Ce.results.forEach(Y=>{const W=(0,I.$0h)(Y);(0,u.$HK)(W)?N({uri:Fe,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,ie=>new g.$xM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,E.$1b)(W.ranges,ie=>new g.$xM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):N({uri:Fe,text:W.text,lineNumber:W.lineNumber})})},Z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(q,oe??null,$e,re,Z);return delete this.u[re],Ce||{}}catch(Ce){throw delete this.u[re],Ce}}$handleTextSearchResult(q,V){this.u[V]?.(q)}async save(q){const V=await this.o.$save(q,{saveAs:!1});return l.URI.revive(V)}async saveAs(q){const V=await this.o.$save(q,{saveAs:!0});return l.URI.revive(V)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,V){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,V);const N=this.t.transformOutgoingScheme(q),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,N),(0,A.$Sc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(q,V){this.h.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const L=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!L),!L)return;const Z=await L.provideEditSessionIdentity(N,V);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(q,V,N,L){this.h.info("Getting edit session identifier for workspaceFolder",q);const Z=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const re=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!re),!re)return;const fe=await re.provideEditSessionIdentityMatch?.(V,N,L);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(q){return(V,N,L)=>{const Z=function(fe){V.call(N,fe)};return Z.extension=q,this.B.event(Z,void 0,L)}}async $onWillCreateEditSessionIdentity(q,V,N){const L=await this.resolveWorkspaceFolder(l.URI.revive(q));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},V,async(Z,re)=>{const fe=Date.now();await Promise.resolve(Z),Date.now()-fe>N&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(q,V){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,V);const N=this.t.transformOutgoingScheme(q),L=this.A++;return this.o.$registerCanonicalUriProvider(L,N),(0,A.$Sc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(q,V,N){const L=this.C.get(q.scheme);if(!L)return;const Z=await L.provideCanonicalUri?.(l.URI.revive(q),V,N);if(Z)return Z}async $provideCanonicalUri(q,V,N){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:V},N)}};e.$Vmc=F,e.$Vmc=F=He([Ve(0,n.$XO),Ve(1,s.$bP),Ve(2,t.$Emc),Ve(3,o.$7j),Ve(4,f.$Tmc)],F),e.$Wmc=(0,r.$Ai)("IExtHostWorkspace");function M(G){let q,V;return G&&(typeof G=="string"?q=G:(q=G.pattern,V=l.URI.revive(G.baseUri))),{includePattern:q,folder:V}}}),define(ke[45],Ie([1,0,26,4,44,5,7,42,214,54,15,11,3,17,12,2]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=e.$Xmc=void 0;function o(f,u){if(u){const b=u.split(".");let I=f;for(let D=0;I&&D<b.length;D++)I=I[b[D]];return I}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function t(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function n(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(t(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(u,b,I){this.a=u.getProxy(O.$tM.MainThreadConfiguration),this.c=b,this.b=I,this.d=new w.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new g(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,b){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(u,b))}};e.$Xmc=i,e.$Xmc=i=He([Ve(0,S.$XO),Ve(1,P.$Wmc),Ve(2,d.$7j)],i);class g{constructor(u,b,I,D){this.a=new R.$he,this.b=u,this.f=D,this.c=b,this.e=$.$Ho.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,b){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ho.parse(u,this.f),this.d=this.k(u.configurationScopes),this.a.fire(this.j(b,I))}getConfiguration(u,b,I){const D=n(b)||{},y=this.g(u?o(this.e.getValue(void 0,D,this.c.workspace),u):this.e.getValue(void 0,D,this.c.workspace));u&&this.h(u,D,I?.identifier);function p(m){if(m==null)return null;if(typeof m=="boolean")return m?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(m){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(m){return typeof o(y,m)<"u"},get:(m,v)=>{this.h(u?`${u}.${m}`:m,D,I?.identifier);let F=o(y,m);if(typeof F>"u")F=v;else{let M;const G=(q,V)=>{if((0,C.$cg)(q)){let N;const L=()=>{M=M||(0,E.$9n)(y),N=N||o(M,V)};return new Proxy(q,{get:(Z,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return L(),()=>N;if(M)return N=N||o(M,V),N[re];const fe=Z[re];return typeof re=="string"?G(fe,`${V}.${re}`):fe},set:(Z,re,fe)=>(L(),N&&(N[re]=fe),!0),deleteProperty:(Z,re)=>(L(),N&&delete N[re],!0),defineProperty:(Z,re,fe)=>(L(),N&&Object.defineProperty(N,re,fe),!0)})}return Array.isArray(q)?(0,E.$9n)(q):q};F=G(F,m)}return F},update:(m,v,F,M)=>{m=u?`${u}.${m}`:m;const G=p(F);return v!==void 0?this.b.$updateConfigurationOption(G,m,v,D,M):this.b.$removeConfigurationOption(G,m,D,M)},inspect:m=>{m=u?`${u}.${m}`:m;const v=this.e.inspect(m,D,this.c.workspace);if(v)return{key:m,defaultValue:(0,E.$9n)(v.policy?.value??v.default?.value),globalValue:(0,E.$9n)(v.user?.value??v.application?.value),workspaceValue:(0,E.$9n)(v.workspace?.value),workspaceFolderValue:(0,E.$9n)(v.workspaceFolder?.value),defaultLanguageValue:(0,E.$9n)(v.default?.override),globalLanguageValue:(0,E.$9n)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,E.$9n)(v.workspace?.override),workspaceFolderLanguageValue:(0,E.$9n)(v.workspaceFolder?.override),languageIds:(0,E.$9n)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,E.$_n)(k,y,!1),Object.freeze(k)}g(u){const b=I=>(0,C.$cg)(I)?new Proxy(I,{get:(D,y)=>b(D[y]),set:(D,y,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return b(u)}h(u,b,I){const D=c.$yo.test(u)?c.ConfigurationScope.RESOURCE:this.d.get(u),y=I?`[${I.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof b?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){b?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,b){const I=new $.$Jo(u,b,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>I.affectsConfiguration(D,n(y))})}k(u){return u.reduce((b,I)=>(b.set(I[0],I[1]),b),new Map)}}e.$Ymc=g,e.$Zmc=(0,l.$Ai)("IExtHostConfiguration")}),define(ke[129],Ie([1,0,2,11,4,5,7,44,71,45,22,57,17,27,3,16,21,12,85,250,14]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=e.$qoc=e.$poc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(M){function G(V){if(V!=null)return V}M.from=G;function q(V){if(V!=null)return V}M.to=q})(n||(n={}));var i;(function(M){function G(V){if(V!=null)return V}M.from=G;function q(V){if(V!=null)return V}M.to=q})(i||(i={}));var g;(function(M){function G(V){if(V!=null)return V}M.from=G;function q(V){if(V!=null)return V}M.to=q})(g||(g={}));var f;(function(M){function G(N){if(N){const L=N;return L&&!!L.process}else return!1}M.is=G;function q(N){if(N==null)return;const L={process:N.process,args:N.args};return N.options&&(L.options=g.from(N.options)),L}M.from=q;function V(N){if(N!=null)return new A.$fN(N.process,N.args,N.options)}M.to=V})(f||(f={}));var u;(function(M){function G(V){if(V!=null)return V}M.from=G;function q(V){if(V!=null)return V}M.to=q})(u||(u={}));var b;(function(M){function G(N){if(N){const L=N;return L&&(!!L.commandLine||!!L.command)}else return!1}M.is=G;function q(N){if(N==null)return;const L={};return N.commandLine!==void 0?L.commandLine=N.commandLine:(L.command=N.command,L.args=N.args),N.options&&(L.options=u.from(N.options)),L}M.from=q;function V(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$gN(N.commandLine,N.options):new A.$gN(N.command,N.args?N.args:[],N.options)}M.to=V})(b||(b={}));var I;(function(M){function G(N){if(N){const L=N;return L&&L.customExecution==="customExecution"}else return!1}M.is=G;function q(N){return{customExecution:"customExecution"}}M.from=q;function V(N,L){return L.get(N)}M.to=V})(I||(e.CustomExecutionDTO=I={}));var D;(function(M){function G(q,V){let N;return q.scope!==void 0&&typeof q.scope!="number"?N=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&V&&V.workspaceFile?N=V.workspaceFile:N=t.$tI),{id:q._id,workspaceFolder:N}}M.from=G})(D||(e.TaskHandleDTO=D={}));var y;(function(M){function G(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}M.from=G})(y||(y={}));var p;(function(M){function G(N,L){if(N==null)return[];const Z=[];for(const re of N){const fe=q(re,L);fe&&Z.push(fe)}return Z}M.fromMany=G;function q(N,L){if(N==null)return;let Z;N.execution instanceof A.$fN?Z=f.from(N.execution):N.execution instanceof A.$gN?Z=b.from(N.execution):N.execution&&N.execution instanceof A.$hN&&(Z=I.from(N.execution));const re=n.from(N.definition);let fe;return N.scope?typeof N.scope=="number"?fe=N.scope:fe=N.scope.uri:fe=A.TaskScope.Workspace,!re||!fe?void 0:{_id:N._id,definition:re,name:N.name,source:{extensionId:L.identifier.value,label:N.source,scope:fe},execution:Z,isBackground:N.isBackground,group:y.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}M.from=q;async function V(N,L,Z){if(N==null)return;let re;f.is(N.execution)?re=f.to(N.execution):b.is(N.execution)?re=b.to(N.execution):I.is(N.execution)&&(re=I.to(N._id,Z));const fe=n.to(N.definition);let be;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?be=N.source.scope:be=await L.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):be=A.TaskScope.Workspace),!fe||!be)return;const oe=new A.$iN(fe,be,N.name,N.source.label,re,N.problemMatchers);return N.isBackground!==void 0&&(oe.isBackground=N.isBackground),N.group!==void 0&&(oe.group=A.$eN.from(N.group._id),oe.group&&N.group.isDefault&&(oe.group=new A.$eN(oe.group.id,oe.group.label),N.group.isDefault===!0&&(oe.group.isDefault=N.group.isDefault))),N.presentationOptions&&(oe.presentationOptions=i.to(N.presentationOptions)),N._id&&(oe._id=N._id),N.detail&&(oe.detail=N.detail),oe}M.to=V})(p||(e.TaskDTO=p={}));var k;(function(M){function G(V){return V}M.from=G;function q(V){if(V)return Object.assign(Object.create(null),V)}M.to=q})(k||(k={}));class m{#e;constructor(G,q,V){this._id=q,this.a=V,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let v=class{constructor(G,q,V,N,L,Z,re,fe){this.q=new P.$he,this.r=new P.$he,this.s=new P.$he,this.u=new P.$he,this.a=G.getProxy(O.$tM.MainThreadTask),this.b=V,this.c=N,this.d=L,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,q,V){if(!V)return new A.$vM(()=>{});const N=this.x();return this.j.set(N,{type:q,provider:V,extension:G}),this.a.$registerTaskProvider(N,q),new A.$vM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(G,q){this.a.$registerTaskSystem(G,q)}fetchTasks(G){return this.a.$fetchTasks(k.from(G)).then(async q=>{const V=[];for(const N of q){const L=await p.to(N,this.b,this.m);L&&V.push(L)}return V})}get taskExecutions(){const G=[];return this.k.forEach(q=>G.push(q)),G}terminateTask(G){if(!(G instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,q,V){const N=this.m.get(G.id);N&&(this.o.set(G.id,N),this.e.attachPtyToTerminal(q,await N.callback(V))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const q=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const q=await this.z(G.id);this.s.fire({execution:q,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const q=await this.z(G.id);this.u.fire({execution:q,exitCode:G.exitCode})}$provideTasks(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));const N=[],L=(0,R.$sh)(()=>V.provider.provideTasks(C.CancellationToken.None)).then(Z=>this.v(q,N,V,Z));return new Promise(Z=>{L.then(re=>{Promise.all(N).then(()=>{Z(re)})})})}async $resolveTask(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));if(q.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${V.type}].`);const N=await p.to(q,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const L=await V.provider.resolveTask(N,C.CancellationToken.None);if(!L)return;this.A(L,V);const Z=p.from(L,V.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(Z.execution)&&await this.y(Z,L,!0),await this.w(Z)}x(){return this.h++}async y(G,q,V){const N=await this.a.$createTaskId(G);!V&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,q.execution)),this.m.set(N,q.execution)}async z(G,q){if(typeof G=="string"){const L=this.l.get(G);if(!L)throw new s.$bb("Unexpected: The specified task is missing an execution");return L}const V=this.l.get(G.id);if(V)return V;let N;return q?N=Promise.resolve(new m(this,G.id,q)):N=p.to(G.task,this.b,this.m).then(L=>{if(!L)throw new s.$bb("Unexpected: Task does not exist.");return new m(this,G.id,L)}),this.l.set(G.id,N),N.then(L=>(this.k.set(G.id,L),L))}A(G,q){G._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const V=this.n.values();let N=V.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=V.next()}};e.$poc=v,e.$poc=v=He([Ve(0,l.$XO),Ve(1,S.$bP),Ve(2,T.$Wmc),Ve(3,$.$9O),Ve(4,c.$Zmc),Ve(5,w.$lnc),Ve(6,a.$7j),Ve(7,h.$Amc)],v);let F=class extends v{constructor(G,q,V,N,L,Z,re,fe){super(G,q,V,N,L,Z,re,fe),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(G,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const V=p.from(q,G);if(V===void 0)throw new Error("Task is not valid");if(I.is(V.execution))await this.y(V,q,!1);else throw new s.$_;const N=await this.z(await this.a.$getTaskExecution(V),q);return this.a.$executeTask(V).catch(L=>{throw new Error(L)}),N}v(G,q,V,N){const L=[];if(N)for(const Z of N){if(this.A(Z,V),!Z.definition||!G[Z.definition.type]){const fe=Z.source?Z.source:"No task source";this.f.warn(`The task [${fe}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=p.from(Z,V.extension);re&&I.is(re.execution)?(L.push(re),q.push(this.y(re,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:L,extension:V.extension}}async w(G){if(I.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,q,V){}};e.$qoc=F,e.$qoc=F=He([Ve(0,l.$XO),Ve(1,S.$bP),Ve(2,T.$Wmc),Ve(3,$.$9O),Ve(4,c.$Zmc),Ve(5,w.$lnc),Ve(6,a.$7j),Ve(7,h.$Amc)],F),e.$roc=(0,d.$Ai)("IExtHostTask")}),define(ke[309],Ie([1,0,43,33]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=void 0,e.$8K=P,e.$0K=O;function P(A){return"cellResults"in A}e.$9K="rawCell#";function O(A,T){let $=-1;const c=[];let C=[];return A.forEach(l=>{l.range.startLineNumber!==$&&C.length>0&&(c.push([...C]),C=[]),C.push(l),$=l.range.endLineNumber}),C.length>0&&c.push([...C]),c.map(l=>{const S=[],d=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=d;o<=r;o++)S.push(T.getLineContent(o));return new E.$LK(S.join(`
`)+`
`,l.map(o=>new R.$ct(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(ke[310],Ie([1,0,184,23,4,6,29,37,13,15,2,30,80,5,39,10,7,38,286,122,26,16,43,239,309,307]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class b{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,p,k,m,v,F){this.q=p,this.r=k,this.s=m,this.t=v,this.u=F,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new P.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new l.$ymc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$tM.MainThreadNotebook),this.c=D.getProxy(S.$tM.MainThreadNotebookDocuments),this.d=D.getProxy(S.$tM.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===T.MarshalledId.NotebookCellActionContext){const G=M.notebookEditor?.notebookUri,q=M.cell.handle,N=this.g.get(G)?.getCell(q);if(N)return N.apiCell}if(M&&M.$mid===T.MarshalledId.NotebookActionContext){const G=M.uri,q=this.g.get(G);if(q)return q.apiNotebook}return M}}),b.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,p]of this.h)if(p.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const p=this.g.get(D);if(!p&&!y)throw new Error(`NO notebook document for '${D}'`);return p}static w(D,y){if(!y)return;const p=y.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(y.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:p,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,y,p){const k=b.a++,m=typeof p.onDidChangeCellStatusBarItems=="function"?b.a++:void 0;this.f.set(k,p),this.b.$registerNotebookCellStatusBarItemProvider(k,m,y);let v;return m!==void 0&&(v=p.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(m))),new o.$vM(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,m),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return C.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const p=await this.c.$tryOpenNotebook(D),k=this.g.get(C.URI.revive(p));return(0,c.$lg)(k?.apiNotebook)}async showNotebookDocument(D,y){C.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let p;typeof y=="object"?p={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:p={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,p),m=k&&this.h.get(k)?.apiEditor;if(m)return m;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,p,k){const m=this.f.get(D),v=C.URI.revive(y),F=this.g.get(v);if(!F||!m)return;const M=F.getCellFromIndex(p);if(!M)return;const G=await m.provideCellStatusBarItems(M.apiCell,k);if(!G)return;const q=new O.$Tc,V=this.p.add([q]),L=(Array.isArray(G)?G:[G]).map(Z=>r.NotebookStatusBarItem.from(Z,this.i,q));return{cacheId:V,items:L}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,p,k,m){if((0,$.$$e)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:p,options:k}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,r.NotebookDocumentContentOptions.from(k),b.w(D,m)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,p){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const m=await k.serializer.deserializeNotebook(y.buffer,p);return new a.$Kw(r.NotebookData.from(m))}async $notebookToData(D,y,p){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const m=await k.serializer.serializeNotebook(r.NotebookData.to(y.value),p);return R.$Je.wrap(m)}async $saveNotebook(D,y,p,k,m){const v=C.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${p}, ${v.toString()})`),!F)throw new Error("NO serializer found");const M=this.g.get(v);if(!M)throw new Error("Document NOT found");if(M.versionId!==p)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new w.$pl((0,E.localize)(0,null,this.A(v)),w.FileOperationResult.FILE_PERMISSION_DENIED);const G={metadata:(0,s.$eo)(M.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of M.apiNotebook.getCells()){const re=new o.$YN(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);re.metadata=(0,s.$eo)(Z.metadata,fe=>!(F.options?.transientCellMetadata??{})[fe]),G.cells.push(re)}if(await this.z(v,k),m.isCancellationRequested)throw new Error("canceled");const q=await F.serializer.serializeNotebook(G,m);if(m.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${p} ${v.toString()}`),await this.s.value.writeFile(v,q),this.D(`Finished write versionId: ${p} ${v.toString()}`);const V=this.s.getFileSystemProviderExtUri(v.scheme),N=await this.s.value.stat(v),L={name:V.basename(v),isFile:(N.type&w.FileType.File)!==0,isDirectory:(N.type&w.FileType.Directory)!==0,isSymbolicLink:(N.type&w.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&w.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((N.permissions??0)&w.FilePermission.Locked),etag:w.$Al({mtime:N.mtime,size:N.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${p}, ${v.toString()})`),L}async $searchInNotebooks(D,y,p,k,m){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new A.$Bc;await(async(N,L,Z)=>{await Promise.all(N.map(async re=>await Promise.all(re.filenamePatterns.map(fe=>{const be={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:i.QueryType.File,filePattern:fe};return this.t.doInternalFileSearchWithCustomCallback(be,L,oe=>{oe.forEach(pe=>{F.has(pe)||k.some(se=>re.isFromSettings&&!se.isFromSettings?!1:se.filenamePatterns.some(Ce=>(0,u.$jhb)(Ce,pe)))||F.add(pe)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(p,m,y);const G=new A.$Ac;let q=!1;const V=Array.from(F).map(async N=>{const L=[];try{if(m.isCancellationRequested)return;if(y.maxResults&&[...G.values()].reduce((be,oe)=>be+oe.cellResults.length,0)>y.maxResults){q=!0;return}const Z=[],re=this.g.get(N);if(re)re.apiNotebook.getCells().forEach(oe=>Z.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(pe=>pe.items.map($e=>$e.data.toString()))}));else{const be=await this.s.value.readFile(N),oe=R.$Je.fromString(be.toString()),pe=await v.deserializeNotebook(oe.buffer,m);if(m.isCancellationRequested)return;r.NotebookData.from(pe).cells.forEach(se=>Z.push({input:se.source,outputs:se.outputs.flatMap(Ce=>Ce.items.map(Fe=>Fe.valueBytes.toString()))}))}if(m.isCancellationRequested)return;Z.forEach((be,oe)=>{const pe=y.contentPattern.pattern,$e=new g.$ZXb(be.input,void 0,be.outputs),se=$e.findInInputs(pe),Ce=$e.findInOutputs(pe),Fe=Ce.flatMap(Y=>(0,f.$0K)(Y.matches,Y.textBuffer)).map((Y,W)=>(Y.webviewIndex=W,Y));if(se.length>0||Ce.length>0){const Y={index:oe,contentResults:(0,f.$0K)(se,$e.inputTextBuffer),webviewResults:Fe};L.push(Y)}});const fe={resource:N,cellResults:L};G.set(N,fe);return}catch{return}});return await Promise.all(V),{limitHit:q,results:[...G.values()]}}async z(D,y){const p=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==w.$zl&&typeof p.mtime=="number"&&typeof p.size=="number"&&y.mtime<p.mtime&&y.etag!==w.$Al({mtime:y.mtime,size:p.size}))throw new w.$pl((0,E.localize)(1,null),w.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===n.Schemas.file?D.fsPath:D.toString()}B(D,y,p){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const k=new t.$Vnc(y,this.d,D,p.visibleRanges.map(r.NotebookRange.to),p.selections.map(r.NotebookRange.to),typeof p.viewColumn=="number"?r.ViewColumn.to(p.viewColumn):void 0);this.h.set(y,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const p of D.value.removedDocuments){const k=C.URI.revive(p),m=this.g.get(k);m&&(m.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(m.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===k.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const p=[];for(const k of D.value.addedDocuments){const m=C.URI.revive(k.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const v=new h.$Unc(this.c,this.q,this.r,m,k);p.push(...k.cells.map(F=>h.$Tnc.asModelAddData(F))),this.g.get(m)?.dispose(),this.g.set(m,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const p of D.value.addedEditors){if(this.h.has(p.id))return;const k=C.URI.revive(p.documentUri),m=this.g.get(k);m&&this.B(m,p.id,p)}const y=[];if(D.value.removedEditors)for(const p of D.value.removedEditors){const k=this.h.get(p);k&&(this.h.delete(p),this.k?.id===k.id&&(this.k=void 0),y.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const p=new Set;this.l.forEach(k=>p.add(k.id));for(const k of this.h.values()){const m=p.has(k.id);k._acceptVisibility(m)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=d.$jP.String.with("notebookType","A notebook type"),p=new d.$lP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new d.$jP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>R.$Je.wrap(m))],new d.$kP("Notebook Data",m=>r.NotebookData.to(m.value))),k=new d.$lP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new d.$jP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new a.$Kw(r.NotebookData.from(m)))],new d.$kP("Bytes",m=>m.buffer));D.registerApiCommand(p),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$5nc=b}),define(ke[311],Ie([1,0,20,22,48,41,24,69,43]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class c{constructor(l,S,d){this.k=l,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$uk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$uk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const S=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,l(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),t=E.$nc(h);this.j&&this.j(h,t)||this.v(o,{base:a,basename:t})}),Promise.all(S.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,P.$lj)(a)))})})}async p(l,S){const d=new R.$se,r=this.q(l),o=this.r(),a=new $.$ZK(this.k,l),h=!a.hasSiblingExcludeClauses();let t;try{this.h.add(d),t=T.$be.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),n=t.elapsed(),i=T.$be.create();return this.g&&!this.e||(s&&s.forEach(g=>{const f=E.$gc.relative(l.folder.path,g.path);if(h){const u=E.$nc(g.path);this.v(S,{base:l.folder,relativePath:f,basename:u});return}this.s(o,l.folder,f,S)}),this.g&&!this.e)?null:(this.u(o,a,S),{providerTime:n,postProcessTime:i.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(l){const S=(0,$.$YK)(this.k.includePattern,l.includePattern),d=(0,$.$YK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:d,includes:S,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},S,d,r){if(d===this.a){const a=E.$nc(this.a);this.v(r,{base:S,relativePath:this.a,basename:a})}function o(a){const h=E.$nc(a),t=E.$mc(a);let s=l[t];s||(s=l[t]=[],o(t)),s.push({base:S,relativePath:a,basename:h})}o(d)}u({rootEntries:l,pathToEntries:S},d,r){const o=this,a=this.a;function h(t){const s=(0,$.$2K)(()=>t.map(n=>n.basename));for(let n=0,i=t.length;n<i;n++){const g=t[n],{relativePath:f,basename:u}=g;if(d.matchesExcludesSync(f,u,a!==u?s:void 0))continue;const b=S[f];if(b)h(b);else{if(f===a)continue;o.v(r,g)}if(o.e)break}}h(l)}v(l,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(S))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,S,d,r){const o=this.c(l.cacheKey),a=new c(l,S,o&&o.token);let h=0;const t=s=>{h+=s.length,d(s.map(n=>this.d(n)))};return this.e(a,C.a,t,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new R.$se),this.b.get(l)}d(l){return l.relativePath?{resource:A.$bh(l.base,l.relativePath)}:{resource:l.base}}e(l,S,d,r){const o=r.onCancellationRequested(()=>{l.cancel()}),a=t=>{t&&(h.push(t),S>0&&h.length>=S&&(d(h),h=[]))};let h=[];return l.search(a).then(t=>(h.length&&d(h),o.dispose(),t),t=>(h.length&&d(h),o.dispose(),Promise.reject(t)))}}e.$Wnc=C}),define(ke[312],Ie([1,0,18,281,41,102,29,16,20,24,13,15,2,101,204,42,12,50,116,308,43]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=void 0,e.$$L=y;let n=class{constructor(k,m,v,F,M){this.a=k,this.b=m,this.c=v,this.d=F,this.e=M}text(k,m,v={}){k=this.f(k,v);const F=this.a.getValue(),M=m&&m.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(m?.map(a.$Vi),v),type:s.QueryType.Text,contentPattern:k,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||M||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(k,m){const v=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const F={...k,wordSeparators:v.editor.wordSeparators};return this.j(k,m)&&(F.isCaseSensitive=!0),this.k(k)&&(F.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),F}file(k,m={}){return{...this.h(k,m),type:s.QueryType.File,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey,shouldGlobMatchFilePattern:m.shouldGlobSearch}}g(k,m){return k?(k=Array.isArray(k)?k.map(b):b(k),m?this.parseSearchPaths(k):{pattern:g(...Array.isArray(k)?k:[k])}):{}}h(k=[],m={}){const v=this.g(m.includePattern,m.expandPatterns),F=this.g(m.excludePattern,m.expandPatterns),M=k.length>1,G=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(N=>this.q(N,m,F)):k.map(N=>this.r(N,m,F,M))).filter(N=>!!N),q={_reason:m._reason,folderQueries:G,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const N=E.$Hb(this.c.groups.flatMap(re=>re.editors.map(fe=>fe.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const L=N.filter(re=>(0,s.$PK)(q,re.fsPath)),Z=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...q,...Z}}const V=m.extraFileResources&&m.extraFileResources.filter(N=>(0,s.$PK)(q,N.fsPath));return q.extraFileResources=V&&V.length?V:void 0,q}i(k){const m=[],v=new A.$Ac,F={};let M=!1;return k.forEach(G=>{if(G.scheme===T.Schemas.walkThrough)return;if((0,c.$fh)(G)){const V=this.b.getWorkspaceFolder(G)?.uri??G.with({path:$.$mc(G.fsPath)});let N=v.get(V);N||(M=!0,N={folder:V,includePattern:{}},m.push(N),v.set(V,N));const L=$.$lc(V.fsPath,G.fsPath);(0,w.$lg)(N.includePattern)[L.replace(/\\/g,"/")]=!0}else G.fsPath&&(M=!0,F[G.fsPath]=!0)}),{folderQueries:m,includePattern:F,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}j(k,m){if(m.isSmartCase){if(k.isRegExp){if(C.$4f(k.pattern,!0))return!0}else if(C.$4f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,S.$2C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const m=Z=>$.$ic(Z)||/^\.\.?([\/\\]|$)/.test(Z),F=(Array.isArray(k)?k:f(k)).map(Z=>{const re=this.e.resolvedUserHome;return re?(0,O.$Pw)(Z,re.scheme===T.Schemas.file?re.fsPath:re.path):Z}),M=R.$K(F,Z=>m(Z)?"searchPaths":"exprSegments"),G=(M.exprSegments||[]).map(Z=>C.$jf(Z,"/")).map(Z=>C.$jf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),u(Z))),q={},V=this.m(M.searchPaths||[]);V&&V.length&&(q.searchPaths=V);const N=G.flat(),L=g(...N);return L&&(q.pattern=L),q}l(k,m){return m.disregardExcludeSettings?void 0:(0,s.$OK)(k,!m.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const m=k.flatMap(F=>{let{pathPortion:M,globPortion:G}=i(F);return G&&(G=I(G)),this.n(M).flatMap(V=>this.o(V,G))}),v=new Map;return m.forEach(F=>{const M=F.searchPath.toString(),G=v.get(M);G?F.pattern&&(G.pattern=G.pattern||{},G.pattern[F.pattern]=!0):v.set(M,{searchPath:F.searchPath,pattern:F.pattern?g(F.pattern):void 0})}),Array.from(v.values())}n(k){if($.$ic(k)){const m=this.b.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==T.Schemas.file?[{searchPath:m[0].uri.with({path:k})}]:[{searchPath:l.URI.file($.$hc(k))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const m=this.b.getWorkspace().folders[0].uri;if(k=b(k),k.startsWith("../")||k===".."){const F=$.$gc.resolve(m.path,k);return[{searchPath:m.with({path:F})}]}const v=I(k);return[{searchPath:m,pattern:v}]}else{if(k==="./"||k===".\\")return[];{const m=k.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(M=>{const G=m.match(new RegExp(`^${C.$df(M.name)}(?:/(.*)|$)`));return G?{match:G,folder:M}:null}).filter(w.$ig);if(F.length)return F.map(M=>{const G=M.match[1];return{searchPath:M.folder.uri,pattern:G&&I(G)}});{const M=k.match(/\.[\/\\](.+)[\/\\]?/),G=M?M[1]:k,q=d.localize(0,null,G);throw new Error(q)}}}}o(k,m){const v=k.pattern&&m?`${k.pattern}/${m}`:k.pattern||m,F=[{searchPath:k.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:k.searchPath,pattern:v+"/**"}),F}q(k,m,v){const F=this.r((0,a.$Vi)(k.searchPath),m,v,!1);return F?{...F,includePattern:k.pattern}:null}r(k,m,v,F){let M;const G=l.URI.isUri(k)?k:k.uri;if(v.searchPaths){const Z=v.searchPaths.filter(re=>(0,c.$7g)(re.searchPath,G))[0];if(Z&&!Z.pattern)return null;Z&&(M=Z.pattern)}const q=this.a.getValue({resource:G}),N={...this.l(q,m)||{},...M||{}},L=l.URI.isUri(k)?(0,c.$$g)(k):k.name;return{folder:G,folderName:F?L:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!q.search.followSymlinks}}};e.$0L=n,e.$0L=n=He([Ve(0,r.$7i),Ve(1,a.$Ji),Ve(2,h.$0D),Ve(3,o.$7j),Ve(4,t.$8L)],n);function i(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const m=k.index,v=p.substr(0,m).match(/[/|\\][^/\\]*$/);if(v){let F=p.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:p.substr((v.index||0)+1)}}}return{pathPortion:p}}function g(...p){return p.length?p.reduce((k,m)=>(k[m]=!0,k),Object.create(null)):void 0}function f(p){return P.$sk(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function u(p){return[`**/${p}/**`,`**/${p}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function b(p){return p.replace(/\\/g,"/")}function I(p){return b(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(p){return p.replace(/([?*[\]])/g,"[$1]")}function y(p,k){p=E.$Mb(p,F=>F.toString());const m=[],v=k.getWorkspace();return p&&p.forEach(F=>{let M;if(k.getWorkbenchState()===a.WorkbenchState.FOLDER)M=(0,c.$dh)(v.folders[0].uri,F),M&&M!=="."&&(M="./"+M);else{const G=k.getWorkspaceFolder(F);if(G){const q=G.name;if(v.folders.filter(N=>N.name===q).length===1){const N=(0,c.$dh)(G.uri,F);N===""?M=`./${G.name}`:M=`./${G.name}/${N}`}else M=F.fsPath}}M&&m.push(D(M))}),m}}),define(ke[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bwb=l,e.$Cwb=r;const w=7e3;function l(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const t=[],s=[];for(const b of h)if(/^workspaceContains:/.test(b)){const I=b.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):t.push(I)}if(t.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:n,resolve:i}=(0,C.$th)(),g=b=>i({activationEvent:b}),f=Promise.all(t.map(b=>S(o,b,g))).then(()=>{}),u=d(o,a.identifier,s,g);return Promise.all([f,u]).then(()=>{i(void 0)}),n}async function S(o,a,h){for(const t of o.folders)if(await o.exists(E.$bh(R.URI.revive(t),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,t){if(h.length===0)return Promise.resolve(void 0);const s=new P.$se,n=o.checkExists(o.folders,h,s.token),i=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},w);let g=!1;try{g=await n}catch(f){O.$4(f)||O.$1(f)}s.dispose(),clearTimeout(i),g&&t(`workspaceContains:${h.join(",")}`)}function r(o,a,h,t){const s=o.get(A.$zi),n=o.get($.$GK),g=s.createInstance(T.$0L).file(a.map(f=>(0,c.$Vi)(R.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return n.fileSearch(g,t).then(f=>!!f.limitHit,f=>O.$4(f)?!1:Promise.reject(f))}}),define(ke[46],Ie([1,0,180,20,64,24,11,6,58,2,12,5,45,246,89,44,25,117,14,19,23,228,7,108,3,27,92,17,75,93,57,95,4,313,88,230,16,86,69,21,87]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u,b,I,D,y,p,k,m,v,F,M,G,q,V,N,L){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=e.$Anc=e.$znc=e.$ync=void 0,e.$ync=(0,f.$Ai)("IHostUtils");let re=Z=class extends T.$Uc{constructor(Y,W,ie,De,he,ve,ae,X,x,me,ge,Me,Be){super(),this.Y=Me,this.Z=Be,this.a=this.B(new m.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=ie,this.f=ae,this.j=De,this.m=he,this.s=ve,this.t=x,this.u=me,this.w=ge,this.y=this.g.getProxy(w.$tM.MainThreadWorkspace),this.z=this.g.getProxy(w.$tM.MainThreadTelemetry),this.C=this.g.getProxy(w.$tM.MainThreadExtensionService),this.D=new A.$zh,this.F=new A.$zh,this.G=new A.$zh,this.H=new A.$zh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new a.$4ac(this.I,this.f.extensions.allExtensions);const Ee=new t.$Xm(this.f.extensions.myExtensions);this.J=new a.$4ac(this.I,$e(this.L,Ee)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new d.$hnc(this.g,this.s),this.N=new F.$rnc(this.g),this.O=X,this.h=Y.createChild(new D.$yi([d.$inc,this.M],[F.$snc,this.N])),this.P=this.B(new S.$gnc(this.J,this.L,{onExtensionActivationError:(Re,Oe,j)=>{this.C.$onExtensionActivationError(Re,h.$3(Oe),j)},actualActivateExtension:async(Re,Oe)=>{if(a.$4ac.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Oe),new S.$fnc;const j=this.J.getExtensionDescription(Re);return this.fb(j,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$1(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.eb(he))}catch{}await Promise.all(Y)}terminate(Y,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(De=>{this.s.error(De)}),this.g.dispose();const ie=this.$();Promise.race([(0,A.$Bh)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const W=await this.C.$getExtension(Y);return W&&{...W,identifier:new t.$Wm(W.identifier.value),extensionLocation:c.URI.revive(W.extensionLocation)}}ab(Y,W){return this.P.activateByEvent(Y,W)}bb(Y,W){return this.P.activateById(Y,W)}activateByIdWithErrors(Y,W){return this.bb(Y,W).then(()=>{const ie=this.P.getActivatedExtension(Y);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===G.Schemas.file&&this.c.fsRealpath){const W=Y.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const ie=await this.R.get(W);return c.URI.file(ie)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new se(Y))),this.Q}async db(Y){const W=$.$Gi.forUris(ie=>O.$5g.ignorePathCasing(ie));return await Promise.all(Y.map(async ie=>{if(this.wb(ie)){const De=await this.cb(ie.extensionLocation);W.set(De,ie)}})),W}eb(Y){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return W;const ie=this.P.getActivatedExtension(Y);if(!ie)return W;try{typeof ie.module.deactivate=="function"&&(W=Promise.resolve(ie.module.deactivate()).then(void 0,De=>(this.s.error(De),Promise.resolve(void 0))))}catch(De){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(De)}try{(0,T.$Pc)(ie.subscriptions)}catch(De){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(De)}return W}async fb(Y,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,W).then(ie=>{const De=ie.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,W),this.gb(Y,W,"success",De),ie},ie=>{throw this.gb(Y,W,"failure"),ie})}gb(Y,W,ie,De){const he=be(Y,W);this.z.$publicLog2("extensionActivationTimes",{...he,...De||{},outcome:ie})}hb(Y,W){const ie=be(Y,W);this.z.$publicLog2("activatePlugin",ie);const De=this.wb(Y);if(!De)return Promise.resolve(new S.$enc(S.$bnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${Y.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const he=new S.$cnc(W.startup);return Promise.all([this.xb(Y,(0,O.$bh)(Y.extensionLocation,De),he),this.ib(Y)]).then(ve=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Z.jb(this.s,Y.identifier,ve[0],ve[1],he))).then(ve=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),ve))}ib(Y){const W=this.Z.createLanguageModelAccessInformation(Y),ie=new n.$knc(Y,this.M),De=new n.$jnc(Y.identifier.value,!1,this.M),he=new M.$tnc(Y,this.N),ve=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ae=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ie.whenReady,De.whenReady,this.O.whenReady]).then(()=>{const X=this;let x,me;const ge=(0,o.$SG)(Y,"ipc")?this.f.messagePorts?.get(t.$Wm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:De,secrets:he,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Me){return R.$jc(Y.extensionLocation.fsPath,Me)},get storagePath(){return X.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return X.O.globalValue(Y).fsPath},get logPath(){return R.$jc(X.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(X.f.logsLocation,Y.identifier.value)},get storageUri(){return X.O.workspaceValue(Y)},get globalStorageUri(){return X.O.globalValue(Y)},get extensionMode(){return ve},get extension(){return x===void 0&&(x=new pe(X,Y.identifier,Y,ae,!1)),x},get extensionRuntime(){return(0,o.$TG)(Y,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!me){if(!ge)return;const Me=m.Event.buffer(m.Event.fromDOMEventEmitter(ge,"message",Be=>Be.data));ge.start(),me={onDidReceiveMessage:Me,postMessage:ge.postMessage.bind(ge)}}return me}})})}static jb(Y,W,ie,De,he){return ie=ie||{activate:void 0,deactivate:void 0},this.kb(Y,W,ie,De,he).then(ve=>new S.$dnc(!1,null,he.build(),ie,ve,De.subscriptions))}static kb(Y,W,ie,De,he){if(typeof ie.activate=="function")try{he.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ve=typeof global=="object"?global:self,ae=ie.activate.apply(ve,[De]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ae).then(X=>(he.activateResolveStop(),X))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(ie)}lb(Y,W){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:W}).then(void 0,ie=>{this.s.error(ie)})}mb(Y,W=0){const De=Date.now();(0,N.$B)(()=>{for(let he=W;he<Y.length;he+=1){const ve=Y[he];for(const ae of ve.activationEvents??[])if(ae==="onStartupFinished")if(Date.now()-De>50){this.mb(Y,he);break}else this.lb(ve,ae)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const W=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(W)this.mb(ie);else for(const De of ie)if(De.activationEvents)for(const he of De.activationEvents)he==="onStartupFinished"&&this.lb(De,he)})}ob(){const Y=this.ab("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.pb(ve.added)));const W=this.j.workspace?this.j.workspace.folders:[],ie=this.pb(W),De=this.rb(),he=Promise.all([De,Y,ie]).then(()=>{});return Promise.race([he,(0,A.$Bh)(1e4)]).then(()=>{this.nb()}),he}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(Y,W))).then(()=>{})}async qb(Y,W){if(this.isActivated(W.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,De={logService:this.s,folders:Y.map(ve=>ve.uri),forceUsingSearch:ie||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,ae,X)=>this.y.$checkExists(ve,ae,X)},he=await(0,v.$Bwb)(De,W);if(he)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,ve=>this.s.error(ve))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:W}=this.f.environment;if(!Y||!W)throw new Error(E.localize(0,null));const ie=await this.xb(null,W,new S.$cnc(!1));if(!ie||typeof ie.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((De,he)=>{const ve=(x,me)=>{x?(N.$t&&this.s.error("Test runner called back with error",x),he(x)):(N.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),De(typeof me=="number"&&me>0?1:0))},ae=(0,O.$2g)(W),X=ie.run(ae,ve);X&&X.then&&X.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),De(0)}).catch(x=>{N.$t&&this.s.error("Test runner finished with error",x),he(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,W){return this.S[Y]=W,(0,T.$Sc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:W}=await this.ub(Y);return W?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const W=Y.indexOf("+");if(W===-1)throw new i.$BM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Y.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.S[ie]}}async $resolveAuthority(Y,W){const ie=V.$be.create(!1),De=()=>`[resolveAuthority(${(0,g.$Pl)(Y)},${W})][${ie.elapsed()}ms] `,he=U=>this.s.info(`${De()}${U}`),ve=U=>this.s.warn(`${De()}${U}`),ae=(U,K=void 0)=>this.s.error(`${De()}${U}`,K),X=U=>{if(U instanceof i.$BM)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},x=async U=>{he(`activating resolver for ${U}...`);const{resolver:K,authorityPrefix:J}=await this.ub(U);if(!K)throw ae(`no resolver for ${J}`),new i.$BM(`No remote extension installed to resolve ${J}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:J,remoteAuthority:U}},me=Y.split(/@|%40/g).reverse();he(`activating remote resolvers ${me.join(" -> ")}`);let ge;try{ge=await Promise.all(me.map(x)).catch(async U=>{if(!(U instanceof i.$BM)||U._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return ve(`resolving nested authorities failed: ${U.message}`),[await x(Y)]})}catch(U){return X(U)}const Me=new A.$Lh;Me.cancelAndSet(()=>he("waiting..."),1e3);let Be,Ee;for(const[U,{authorityPrefix:K,resolver:J,remoteAuthority:te}]of ge.entries())try{if(U===ge.length-1)he("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),Be=await J.resolve(te,{resolveAttempt:W,execServer:Ee}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,i.$AM.isManagedResolvedAuthority(Be)?Be:void 0));else{if(he(`invoking resolveExecServer() for ${te}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ee=await J.resolveExecServer?.(te,{resolveAttempt:W,execServer:Ee}),!Ee)throw new i.$BM(`Exec server was not available for ${te}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(ue){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),ae("returned an error",ue),Me.dispose(),X(ue)}Me.dispose();const Re={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${i.$AM.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let j;if(i.$AM.isManagedResolvedAuthority(Be)){const U=W;this.Y.setFactory(U,Be.makeConnection),j={authority:Y,connectTo:new g.$Ml(U),connectionToken:Be.connectionToken}}else j={authority:Y,connectTo:new g.$Nl(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:j,options:Oe,tunnelInformation:Re}}}async $getCanonicalURI(Y,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Pl)(Y)})`);const{resolver:ie}=await this.ub(Y);if(!ie)return null;const De=c.URI.revive(W);if(typeof ie.getCanonicalURI>"u")return De;const he=await(0,A.$sh)(()=>ie.getCanonicalURI(De));return he||De}async $startExtensionHost(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this.I,this.L,this.J,Y),De=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(Y,W){return W===o.ActivationKind.Immediate?this.D.wait().then(ie=>this.ab(Y,!1)):this.G.wait().then(ie=>this.ab(Y,!1))}async $activate(Y,W){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,W),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this.I,this.L,this.J,Y),De=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const W=s.$Je.alloc(Y),ie=Math.random()%256;for(let De=0;De<Y;De++)W.writeUInt8(ie,De);return W}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$znc=re,e.$znc=re=Z=He([Ve(0,f.$zi),Ve(1,e.$ync),Ve(2,I.$XO),Ve(3,r.$Wmc),Ve(4,l.$Zmc),Ve(5,C.$7j),Ve(6,u.$bP),Ve(7,b.$3mc),Ve(8,y.$eEb),Ve(9,p.$lnc),Ve(10,q.$vnc),Ve(11,L.$wnc),Ve(12,k.$pnc)],re);function fe(Fe,Y,W,ie){Fe.addActivationEvents(ie.addActivationEvents);const De=new a.$4ac(Fe,Y.getAllExtensionDescriptions());De.deltaExtensions(ie.toAdd,ie.toRemove);const he=new t.$Xm(W.getAllExtensionDescriptions().map(ae=>ae.identifier));for(const ae of ie.myToRemove)he.delete(ae);for(const ae of ie.myToAdd)he.add(ae);const ve=$e(De,he);return{globalRegistry:De,myExtensions:ve}}function be(Fe,Y){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function oe(Fe){return Fe.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Anc=(0,f.$Ai)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(Y,W,ie,De,he){this.#e=Y,this.#t=W,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=R.$hc((0,O.$2g)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=De,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Bnc=pe;function $e(Fe,Y){return Fe.getAllExtensionDescriptions().filter(W=>Y.has(W.identifier))}class se{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Cnc=se;class Ce{constructor(Y){this.a=new t.$Ym,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const W of Object.keys(Y))this.a.set(W,Y[W])}}}),define(ke[314],Ie([1,0,64,2,5,45,25,19,17,27,3,46,12,13]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;let r=class{constructor(s,n,i,g,f,u,b){this.c=s,this.d=n,this.e=i,this.f=g,this.g=f,this.h=u,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new a(this.c,n,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,n,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const n of s.nodeModuleName)this.a.set(n,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(n=>s.alternativeModuleName(n))}};e.$Loc=r,e.$Loc=r=He([Ve(2,C.$zi),Ve(3,O.$Zmc),Ve(4,w.$Anc),Ve(5,c.$bP),Ve(6,l.$7j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const n=(0,S.$df)(this.c(s.environment.appRoot.fsPath)),i="[a-z0-9_.-]",g=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${f}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const n=this.b.exec(this.c(s));if(!n)return;const[,i,g,f]=n,u=d.a.get(g);if(u!==void 0)return console.warn(`${g} as been renamed to ${u}, please update your imports`),i+u+f}c(s){return s.replace(/\\/g,"/")}};o=d=He([Ve(0,c.$bP)],o);class a{constructor(s,n,i,g,f){this.c=s,this.d=n,this.e=i,this.f=g,this.g=f,this.nodeModuleName="vscode",this.a=new T.$Ym}load(s,n){const i=this.d.findSubstr(n);if(i){let g=this.a.get(i.identifier);return g||(g=this.c(i,this.e,this.f),this.a.set(i.identifier,g)),g}if(!this.b){let g="";this.d.forEach((f,u)=>g+=`	${u} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${g}`),this.b=this.c(A.$NG,this.e,this.f)}return this.b}}let h=class{constructor(s,n,i){this.e=s,this.f=n,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$tM.MainThreadTelemetry);const g=i.getProxy(P.$tM.MainThreadWindow);this.c=(f,u)=>{const b=R.URI.parse(f);return u?this.g(f,u):b.scheme==="http"||b.scheme==="https"?g.$openUri(b,f,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?g.$openUri(b,f,{}):this.g(f,u)}}load(s,n,i){const g=this.e.findSubstr(n);return g&&(this.a=g.identifier.value,this.h()),this.b=i(s),this.c}g(s,n){return this.i(),this.b(s,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([Ve(2,$.$XO)],h)}),define(ke[130],Ie([1,0,47,6,20,79,3,71,70,46,7,44,243,45]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Dnc=void 0,e.$Dnc=(0,A.$Ai)("IExtHostVariableResolverProvider");class d extends l.$2P{constructor(a,h,t,s,n,i,g){function f(){if(t){const u=t.activeEditor();if(u)return u.document.uri;const b=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof C.$hO||b.input instanceof C.$mO)return b.input.modified;if(b.input instanceof C.$gO||b.input instanceof C.$lO||b.input instanceof C.$jO)return b.input.uri}}}super({getFolderUri:u=>{const b=i.folders.filter(I=>I.name===u);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,b)=>n.getConfiguration(void 0,u).get(b),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return P.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const u=f();if(u){const b=h.getWorkspaceFolder(u);if(b)return P.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(t){const u=t.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(t){const u=t.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>a.getExtension(u)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(O.env))}}let r=class extends R.$Uc{constructor(a,h,t,s,n){super(),this.b=a,this.c=h,this.g=t,this.h=s,this.j=n,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,i,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$Enc=r,e.$Enc=r=He([Ve(0,c.$Anc),Ve(1,w.$Wmc),Ve(2,T.$9O),Ve(3,S.$Zmc),Ve(4,$.$_mc)],r)}),define(ke[131],Ie([1,0,11,4,2,19,3,5,70,46,17,7,44,235,81,236,45,130,6,34,39,10,18]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=e.$Inc=e.$Hnc=e.$Gnc=e.$Fnc=void 0,e.$Fnc=(0,A.$Ai)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(p,k,m,v,F,M,G){this.N=k,this.O=m,this.P=v,this.Q=F,this.R=M,this.S=G,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new R.$he,this.o=new R.$he,this.q=new R.$he,this.w=new R.$he,this.l=p.getProxy(T.$tM.MainThreadDebugService),this.A=new R.$he,this.C=new R.$he,this.y=new u(this.l),this.z=new Map,this.O.getExtensionRegistry().then(q=>{q.onDidChange(V=>{this.V(q)}),this.V(q)})}async $getVisualizerTreeItem(p,k){const m=this.W(k);if(!m)return;const v=await this.H.get(p)?.getTreeItem?.(m);return v?this.U(p,v):void 0}registerDebugVisualizationTree(p,k,m){const v=O.$Wm.toKey(p.identifier),F=this.jb(v,k);if(this.G.has(F))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.H.set(F,m),this.l.$registerDebugVisualizerTree(F,!!m.editItem),(0,h.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(F),this.H.delete(k)})}async $getVisualizerTreeItemChildren(p,k){const m=this.J.get(k)?.item;return m?(await this.H.get(p)?.getChildren?.(m))?.map(F=>this.U(p,F))||[]:[]}async $editVisualizerTreeItem(p,k){const m=this.J.get(p);if(!m)return;const v=await this.H.get(m.provider)?.editItem?.(m.item,k);return this.U(m.provider,v||m.item)}$disposeVisualizedTree(p){const k=this.J.get(p);if(!k)return;const m=[k.children];for(const v of m)if(v)for(const F of v)m.push(this.J.get(F)?.children),this.J.delete(F)}U(p,k){let m=this.I.get(k);return m||(m=this.F++,this.I.set(k,m),this.J.set(m,{provider:p,item:k})),n.DebugTreeItem.from(k,m)}asDebugSourceUri(p,k){const m=p;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let v=`debug:${encodeURIComponent(m.path||"")}`,F="?";return k&&(v+=`${F}session=${encodeURIComponent(k.id)}`,F="&"),v+=`${F}ref=${m.sourceReference}`,P.URI.parse(v)}else{if(m.path)return P.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(p){const k=[];for(const m of p.getAllExtensionDescriptions())if(m.contributes){const v=m.contributes.debuggers;if(v&&v.length>0)for(const F of v)(0,r.$JH)(F)&&k.push(F.type)}this.l.$registerDebugTypes(k)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const p=[];return this.z.forEach(k=>p.push(k)),p}async $resolveDebugVisualizer(p,k){const m=this.L.get(p);if(!m)throw new Error(`No debug visualizer found with id '${p}'`);let{v,provider:F,extensionId:M}=m;if(v.visualization||(v=await F.resolveDebugVisualization?.(v,k)||v,m.v=v),!v.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${F}'`);return this.kb(M,v.visualization)}async $executeDebugVisualizerCommand(p){const k=this.L.get(p);if(!k)throw new Error(`No debug visualizer found with id '${p}'`);const m=k.v.visualization;m&&"command"in m&&this.S.executeCommand(m.command,...m.arguments||[])}W(p){const k=this.m.get(p.sessionId);return k&&{session:k.api,variable:p.variable,containerId:p.containerId,frameId:p.frameId,threadId:p.threadId}}async $provideDebugVisualizers(p,k,m,v){const F=this.W(m),M=this.jb(p,k),G=this.G.get(M);if(!F||!G)return[];const q=await G.provideDebugVisualization(F,v);return q?q.map(V=>{const N=++this.M;this.L.set(N,{v:V,provider:G,extensionId:p});const L=V.iconPath?this.lb(V.iconPath):void 0;return{id:N,name:V.name,iconClass:L?.iconClass,iconPath:L?.iconPath,visualization:this.kb(p,V.visualization)}}):[]}$disposeDebugVisualizers(p){for(const k of p)this.L.delete(k)}registerDebugVisualizationProvider(p,k,m){if(!p.contributes?.debugVisualizers?.some(M=>M.id===k))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${k})`);const v=O.$Wm.toKey(p.identifier),F=this.jb(v,k);if(this.G.has(F))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.G.set(F,m),this.l.$registerDebugVisualizer(v,k),(0,h.$Sc)(()=>{this.l.$unregisterDebugVisualizer(v,k),this.G.delete(k)})}addBreakpoints(p){const k=p.filter(F=>{const M=F.id;return this.z.has(M)?!1:(this.z.set(M,F),!0)});this.gb(k,[],[]);const m=[],v=new Map;for(const F of k)if(F instanceof w.$xN){let M=v.get(F.location.uri.toString());M||(M={type:"sourceMulti",uri:F.location.uri,lines:[]},v.set(F.location.uri.toString(),M),m.push(M)),M.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character,mode:F.mode})}else F instanceof w.$yN&&m.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName,mode:F.mode});return this.l.$registerBreakpoints(m)}removeBreakpoints(p){const k=p.filter(M=>this.z.delete(M.id));this.gb([],k,[]);const m=k.filter(M=>M instanceof w.$xN).map(M=>M.id),v=k.filter(M=>M instanceof w.$yN).map(M=>M.id),F=k.filter(M=>M instanceof w.$zN).map(M=>M.id);return this.l.$unregisterBreakpoints(m,v,F)}startDebugging(p,k,m){return this.l.$startDebugging(p?p.uri:void 0,k,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(p){return this.l.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,k,m){if(!k)return new w.$vM(()=>{});const v=this.d++;return this.f.push({type:p,handle:v,provider:k}),this.l.$registerDebugConfigurationProvider(p,m,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,v),new w.$vM(()=>{this.f=this.f.filter(F=>F.provider!==k),this.l.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(p,k,m){if(!m)return new w.$vM(()=>{});if(!this.cb(p,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.$(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:k,handle:v,factory:m}),this.l.$registerDebugAdapterDescriptorFactory(k,v),new w.$vM(()=>{this.h=this.h.filter(F=>F.factory!==m),this.l.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(p,k){if(!k)return new w.$vM(()=>{});const m=this.j++;return this.k.push({type:p,handle:m,factory:k}),new w.$vM(()=>{this.k=this.k.filter(v=>v.factory!==k)})}async $runInTerminal(p,k){return Promise.resolve(void 0)}async $substituteVariables(p,k){let m;const v=await this.ib(p);return v&&(m={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(m,k)}X(p,k){if(p.type==="implementation")return new I(p.implementation)}Y(){}async $startDASession(p,k){const m=this,v=await this.hb(k);return this.eb(this.$(v.type),v).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const M=this.Z(F),G=this.X(M,v);if(!G)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const q=G;return this.D.set(p,q),this.db(v).then(V=>(V&&this.E.set(p,V),q.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const L=N,Z={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const re=await this.K.sign(L.arguments.value);Z.body={signature:re},q.sendResponse(Z)}else throw new Error("no signer")}catch(re){Z.success=!1,Z.message=re.message,q.sendResponse(Z)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(N),N=(0,r.$OH)(N,!0),m.l.$acceptDAMessage(p,N)}),q.onError(N=>{V&&V.onError&&V.onError(N),this.l.$acceptDAError(p,N.name,N.message,N.stack)}),q.onExit(N=>{V&&V.onExit&&V.onExit(N??void 0,void 0),this.l.$acceptDAExit(p,N??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),q.startSession()))})}$sendDAMessage(p,k){k=(0,r.$NH)(k,!1);const m=this.E.get(p);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(k),this.D.get(p)?.sendMessage(k)}$stopDASession(p){const k=this.E.get(p);this.E.delete(p),k&&k.onWillStopSession&&k.onWillStopSession();const m=this.D.get(p);return this.D.delete(p),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const k=[],m=[],v=[];if(p.added)for(const F of p.added){const M=F.id;if(M&&!this.z.has(M)){let G;if(F.type==="function")G=new w.$yN(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode);else if(F.type==="data")G=new w.$zN(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage,F.mode);else{const q=P.URI.revive(F.uri);G=new w.$xN(new w.$HM(q,new w.$wM(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode)}(0,w.$vN)(G,M),this.z.set(M,G),k.push(G)}}if(p.removed)for(const F of p.removed){const M=this.z.get(F);M&&(this.z.delete(F),m.push(M))}if(p.changed){for(const F of p.changed)if(F.id){const M=this.z.get(F.id);if(M){if(M instanceof w.$yN&&F.type==="function"){const G=M;G.enabled=F.enabled,G.condition=F.condition,G.hitCondition=F.hitCondition,G.logMessage=F.logMessage,G.functionName=F.functionName}else if(M instanceof w.$xN&&F.type==="source"){const G=M;G.enabled=F.enabled,G.condition=F.condition,G.hitCondition=F.hitCondition,G.logMessage=F.logMessage,G.location=new w.$HM(P.URI.revive(F.uri),new w.$wM(F.line,F.character))}v.push(M)}}}this.gb(k,m,v)}async $acceptStackFrameFocus(p){let k;if(p){const m=await this.hb(p.sessionId);p.kind==="thread"?k=new w.$FN(m.api,p.threadId):k=new w.$EN(m.api,p.threadId,p.frameId)}this.B=k,this.C.fire(this.B)}$provideDebugConfigurations(p,k,m){return(0,E.$sh)(async()=>{const v=this.bb(p);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.ib(k);return v.provideDebugConfigurations(F,m)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(p,k,m,v){return(0,E.$sh)(async()=>{const F=this.bb(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.ib(k);return F.resolveDebugConfiguration(M,m,v)})}$resolveDebugConfigurationWithSubstitutedVariables(p,k,m,v){return(0,E.$sh)(async()=>{const F=this.bb(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.ib(k);return F.resolveDebugConfigurationWithSubstitutedVariables(M,m,v)})}async $provideDebugAdapter(p,k){const m=this.ab(p);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.hb(k);return this.eb(m,v).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.Z(F)})}async $acceptDebugSessionStarted(p){const k=await this.hb(p);this.n.fire(k.api)}async $acceptDebugSessionTerminated(p){const k=await this.hb(p);k&&(this.o.fire(k.api),this.m.delete(k.id))}async $acceptDebugSessionActiveChanged(p){this.u=p?await this.hb(p):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(p,k){(await this.hb(p))?._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(p,k){const v={session:(await this.hb(p)).api,event:k.event,body:k.body};this.w.fire(v)}Z(p){if(p instanceof w.$AN)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof w.$BN)return{type:"server",port:p.port,host:p.host};if(p instanceof w.$CN)return{type:"pipeServer",path:p.path};if(p instanceof w.$DN)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}$(p){const k=this.h.filter(m=>m.type===p);if(k.length>0)return k[0].factory}ab(p){const k=this.h.filter(m=>m.handle===p);if(k.length>0)return k[0].factory}bb(p){const k=this.f.filter(m=>m.handle===p);if(k.length>0)return k[0].provider}cb(p,k){if(p.contributes){const m=p.contributes.debuggers;if(m&&m.length>0){for(const v of m)if(v.label&&v.type&&v.type===k)return!0}}return!1}db(p){const m=p.configuration.type,v=this.k.filter(F=>F.type===m||F.type==="*").map(F=>(0,E.$sh)(()=>F.factory.createDebugAdapterTracker(p.api)).then(M=>M,M=>null));return Promise.race([Promise.all(v).then(F=>{const M=(0,i.$Hb)(F);if(M.length>0)return new b(M)}),new Promise(F=>setTimeout(()=>F(void 0),1e3))]).catch(F=>{})}async eb(p,k){const m=k.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new w.$BN(m));if(p){const F=await this.O.getExtensionRegistry();return(0,E.$sh)(()=>p.createDebugAdapterDescriptor(k.api,this.fb(k,F))).then(M=>{if(M)return M})}const v=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(k,v))}fb(p,k){}gb(p,k,m){(p.length>0||k.length>0||m.length>0)&&this.A.fire(Object.freeze({added:p,removed:k,changed:m}))}async hb(p){if(p)if(typeof p=="string"){const k=this.m.get(p);if(k)return k}else{let k=this.m.get(p.id);if(!k){const m=await this.ib(p.folderUri),v=p.parent?this.m.get(p.parent):void 0;k=new f(this.l,p.id,p.type,p.name,m,p.configuration,v?.api),this.m.set(k.id,k),this.l.$sessionCached(k.id)}return k}throw new Error("cannot find session")}ib(p){if(p){const k=P.URI.revive(p);return this.N.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}jb(p,k){return`${p}\0${k}`}kb(p,k){if(k){if("title"in k&&"command"in k)return{type:d.DebugVisualizationType.Command};if("treeId"in k)return{type:d.DebugVisualizationType.Tree,id:`${p}\0${k.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(p){const k=this.mb(p);let m,v;return"id"in k?v=t.ThemeIcon.asClassName(k):m=k,{iconPath:m,iconClass:v}}mb(p){if(p instanceof w.$sN)return{id:p.id};const k=typeof p=="object"&&"dark"in p?p.dark:p,m=typeof p=="object"&&"light"in p?p.light:p;return{dark:typeof k=="string"?P.URI.file(k):k,light:typeof m=="string"?P.URI.file(m):m}}};e.$Gnc=g,e.$Gnc=g=He([Ve(0,C.$XO),Ve(1,l.$Wmc),Ve(2,c.$Anc),Ve(3,o.$Zmc),Ve(4,$.$_mc),Ve(5,a.$Dnc),Ve(6,s.$hP)],g);class f{constructor(p,k,m,v,F,M,G){this.f=p,this.g=k,this.h=m,this.j=v,this.k=F,this.l=M,this.m=G}get api(){const p=this;return this.d??=Object.freeze({id:p.g,type:p.h,get name(){return p.j},set name(k){p.j=k,p.f.$setDebugSessionName(p.g,k)},parentSession:p.m,workspaceFolder:p.k,configuration:p.l,customRequest(k,m){return p.f.$customDebugAdapterRequest(p.g,k,m)},getDebugProtocolBreakpoint(k){return p.f.$getDebugProtocolBreakpoint(p.g,k.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(p){this.j=p}get configuration(){return this.l}}e.$Hnc=f;class u{constructor(p){this.value=Object.freeze({append(k){p.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.$Inc=u;class b{constructor(p){this.d=p}onWillStartSession(){this.d.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.d.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.d.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(p):void 0)}onWillStopSession(){this.d.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.d.forEach(k=>k.onError?k.onError(p):void 0)}onExit(p,k){this.d.forEach(m=>m.onExit?m.onExit(p,k):void 0)}}class I extends S.$9rb{constructor(p){super(),this.h=p,p.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.h.handleMessage(p)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let D=class extends g{constructor(p,k,m,v,F,M,G){super(p,k,m,v,F,M,G)}};e.$Jnc=D,e.$Jnc=D=He([Ve(0,C.$XO),Ve(1,l.$Wmc),Ve(2,c.$Anc),Ve(3,o.$Zmc),Ve(4,$.$_mc),Ve(5,a.$Dnc),Ve(6,s.$hP)],D)}),define(ke[315],Ie([1,0,14,64,2,5,265,12,60,75,27,210,17,65,46,66]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=e.$Moc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const s=t.get(T.$7j),i=t.get(l.$XO).getProxy(O.$tM.MainThreadErrors);E.setUnexpectedErrorHandler(g=>{s.error(g);const f=E.$3(g);i.$onUnexpectedError(f)})}static async installFullHandler(t){const s=t.get(T.$7j),n=t.get(l.$XO),i=t.get(d.$Anc),g=t.get(r.$fP),f=n.getProxy(O.$tM.MainThreadExtensionService),u=n.getProxy(O.$tM.MainThreadErrors),b=await i.getExtensionPathIndex(),I=new WeakMap;function D(k,m){if(I.has(k))return I.get(k).stack;let v="",F,M;for(const q of m)v+=`
	at ${q.toString()}`,M=q.getFileName(),!F&&M&&(F=b.findSubstr(P.URI.file(M)));const G=`${k.name||"Error"}: ${k.message||""}${v}`;return I.set(k,{extensionIdentifier:F?.identifier,stack:G}),G}const y=Symbol("prepareStackTrace wrapped");let p=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(k){if(k===D||!k||k[y]){p=k||D;return}p=function(m,v){return D(m,v),k.call(Error,m,v)},Object.assign(p,{[y]:!0})}}),E.setUnexpectedErrorHandler(k=>{s.error(k);const m=E.$3(k),v=I.get(k);if(!v?.extensionIdentifier){u.$onUnexpectedError(m);return}f.$onExtensionRuntimeError(v.extensionIdentifier,m);const F=g.onExtensionError(v.extensionIdentifier,k);s.trace("forwarded error to extension?",F,v)})}}e.$Moc=o;class a{constructor(t,s,n,i,g){this.a=n,this.b=new A.$_ac(t,null,i),s=a.e(s,this.b);const f=new c.$yi(...(0,$.$Gs)());f.set(C.$bP,{_serviceBrand:void 0,...s,messagePorts:g}),f.set(l.$XO,new l.$YO(this.b)),f.set(S.$Tmc,new S.$Umc(i)),f.set(d.$ync,n);const u=new w.$kr(f,!0);u.invokeFunction(o.installEarlyHandler),this.d=u.invokeFunction(b=>b.get(T.$7j)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=u.invokeFunction(b=>b.get(d.$Anc)),this.c.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const s=this.b.getProxy(O.$tM.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,s){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(s.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=P.URI.revive(s.transformIncomingURIs(t.environment.appRoot));const n=t.environment.extensionDevelopmentLocationURI;return n&&(t.environment.extensionDevelopmentLocationURI=n.map(i=>P.URI.revive(s.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=P.URI.revive(s.transformIncomingURIs(t.logsLocation)),t.workspace=s.transformIncomingURIs(t.workspace),t}}e.$Noc=a}),define(ke[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Ync=e.$Xnc=void 0,e.$Znc=r;class w{constructor(h,t,s){this.d=h,this.e=t,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,t){const s=this.g.folderQueries||[],n=new P.$se(t);return new Promise((i,g)=>{this.a=new S(h);let f=!1;const u=(b,I)=>{if(!f&&!this.b){const D=this.h(b);r(b)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,n.cancel(),b=this.j(b,this.g.maxResults-this.c));const y=this.h(b);this.c+=y,(y>0||!r(b))&&this.a.add(b,I)}};Promise.all(s.map((b,I)=>this.k(b,D=>u(D,I),n.token))).then(b=>{n.dispose(),this.a.flush();const I=b.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||I,messages:b.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},b=>{n.dispose();const I=(0,O.$lj)(b);g(new Error(I))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,t){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],n=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,t),preview:{matches:n.slice(0,t),text:h.preview.text},uri:h.uri}}async k(h,t,s){const n=new C.$ZK(this.g,h),i=[],g={report:b=>{if(!this.l(b))return;const I=h.folder.scheme===A.Schemas.file?(0,C.$1K)(()=>this.e.readdir($.$ah(b.uri))):void 0,D=$.$dh(h.folder,b.uri);if(D){const y=n.includedInQuery(D,T.$nc(D),I);(0,R.$mh)(y)?i.push(y.then(p=>{p&&t(b)})):y&&t(b)}}},f=this.n(h);let u;return this.d.query.type===C.QueryType.aiText?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,g,s):u=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),f,g,s),i.length&&await Promise.all(i),u}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const t=(0,C.$YK)(this.g.includePattern,h.includePattern),s=(0,C.$YK)(this.g.excludePattern,h.excludePattern),n={folder:c.URI.from(h.folder),excludes:s,includes:t,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(n.usePCRE2=this.g.usePCRE2),n}}e.$Xnc=w;function l(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class S{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(h,t){this.d&&(this.b!==t||!$.$7g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Ync=S;function d(a){return r(a)?{preview:{matches:(0,E.$1b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,E.$1b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,t){this.g=h,this.h=t,this.c=0,this.d=[],this.e=0}addItem(h,t){h&&this.j(h,t)}addItems(h,t){h&&this.k(h,t)}j(h,t){this.d.push(h),this.e+=t,this.l()}k(h,t){this.d=this.d.concat(h),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$1nc=o}),define(ke[132],Ie([1,0,6,5,3,311,17,65,12,2,316]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0,e.$4nc=l,e.$2nc=(0,P.$Ai)("IExtHostSearch");let w=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(R.$tM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Wnc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const t=l(a),s=this.j.get(r);if(s)return this.l.fileSearch(t,s,n=>{this.c.$handleFileMatch(r,o,n.map(i=>i.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const t=this.e.get(r);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const s=l(a);return this.t(s,t).search(i=>this.c.$handleTextMatch(r,o,i),h)}$provideAITextSearchResults(r,o,a,h){const t=this.h.get(r);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const s=l(a);return this.v(s,t).search(i=>this.c.$handleTextMatch(r,o,i),h)}$enableExtensionHostSearch(){}t(r,o){return new C.$Xnc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new C.$Xnc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$3nc=w,e.$3nc=w=He([Ve(0,A.$XO),Ve(1,T.$Tmc),Ve(2,$.$7j)],w);function l(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function S(d){return{...d,folder:c.URI.revive(d.folder)}}}),define(ke[317],Ie([1,0,22,14,4,6,16,35,2,104,163,149,52,19,30,12,62,63,224,5,268,296,85,91,273,274,275,252,241,39,276,45,277,131,120,278,254,269,279,280,71,70,255,270,46,282,68,283,51,27,297,256,284,95,285,86,87,258,310,287,229,288,298,289,126,259,290,291,292,17,293,132,88,294,260,295,89,92,129,66,57,124,299,300,271,301,302,93,10,7,261,65,262,67,303,304,119,44,81,84,25,128]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u,b,I,D,y,p,k,m,v,F,M,G,q,V,N,L,Z,re,fe,be,oe,pe,$e,se,Ce,Fe,Y,W,ie,De,he,ve,ae,X,x,me,ge,Me,Be,Ee,Re,Oe,j,U,K,J,te,ue,Ae,je,Ge,Ze,tt,_e,it,nt,mt,ut,rt,at,dt,We,Ue,_,H,ye,Ke,xe,ct,gt,Tt,Qt,zt,ui,xt,Xe,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=Ut;function Ut(ft){const pt=ft.get(Ce.$bP),_t=ft.get(se.$Emc),Xt=ft.get(pe.$2mc),jt=ft.get(be.$Anc),bt=ft.get(zt.$Wmc),Ot=ft.get(it.$fP),Gt=ft.get(k.$Zmc),Bt=ft.get(Ke.$Tmc),Qe=ft.get(K.$XO),ei=ft.get(Ze.$inc),ti=ft.get(tt.$3mc),ci=ft.get(r.$8j),Dt=ft.get(r.$7j),Mt=ft.get(Ue.$eEb),Pt=ft.get(i.$Amc),Nt=ft.get(Qt.$Goc),li=ft.get(ue.$snc),Vt=ft.get(Z.$_mc),ri=ft.get(ve.$wnc),Lt=ft.get(g.$Kmc),Yt=ft.get(ie.$pnc);Qe.set(t.$uM.ExtHostFileSystemInfo,_t),Qe.set(t.$uM.ExtHostLogLevelServiceShape,ci),Qe.set(t.$uM.ExtHostWorkspace,bt),Qe.set(t.$uM.ExtHostConfiguration,Gt),Qe.set(t.$uM.ExtHostExtensionService,jt),Qe.set(t.$uM.ExtHostStorage,ei),Qe.set(t.$uM.ExtHostTunnelService,Mt),Qe.set(t.$uM.ExtHostWindow,Nt),Qe.set(t.$uM.ExtHostSecretState,li),Qe.set(t.$uM.ExtHostTelemetry,Ot),Qe.set(t.$uM.ExtHostEditorTabs,Vt),Qe.set(t.$uM.ExtHostManagedSockets,ri),Qe.set(t.$uM.ExtHostAuthentication,Lt),Qe.set(t.$uM.ExtHostChatProvider,Yt);const si=Qe.set(t.$uM.ExtHostDecorations,ft.get(F.$Lnc)),Ct=Qe.set(t.$uM.ExtHostDocumentsAndEditors,ft.get(L.$9O)),vt=Qe.set(t.$uM.ExtHostCommands,ft.get(y.$hP)),$t=Qe.set(t.$uM.ExtHostTerminalService,ft.get(nt.$lnc)),qt=Qe.set(t.$uM.ExtHostTerminalShellIntegration,ft.get(mt.$soc)),St=Qe.set(t.$uM.ExtHostDebugService,ft.get(v.$Fnc)),oi=Qe.set(t.$uM.ExtHostSearch,ft.get(te.$2nc)),Kt=Qe.set(t.$uM.ExtHostTask,ft.get(_e.$roc)),pi=Qe.set(t.$uM.ExtHostOutputService,ft.get(Ee.$eoc)),di=Qe.set(t.$uM.ExtHostLocalization,ft.get(he.$vnc)),ki=Qe.set(t.$uM.ExtHostUrls,new xe.$Doc(Qe)),Rt=Qe.set(t.$uM.ExtHostDocuments,new N.$Hmc(Qe,Ct)),Pi=Qe.set(t.$uM.ExtHostDocumentContentProviders,new q.$Nnc(Qe,Ct,Dt)),ai=Qe.set(t.$uM.ExtHostDocumentSaveParticipant,new V.$Onc(Dt,Rt,Qe.getProxy(t.$tM.MainThreadBulkEdits))),It=Qe.set(t.$uM.ExtHostNotebook,new X.$5nc(Qe,vt,Ct,Rt,Xt,oi,Dt)),Ii=Qe.set(t.$uM.ExtHostNotebookDocuments,new me.$$nc(It)),vi=Qe.set(t.$uM.ExtHostNotebookEditors,new ge.$_nc(Dt,It)),$i=Qe.set(t.$uM.ExtHostNotebookKernels,new Me.$aoc(Qe,pt,It,vt,Dt)),Ri=Qe.set(t.$uM.ExtHostNotebookRenderers,new Be.$coc(Qe,It)),fi=Qe.set(t.$uM.ExtHostNotebookDocumentSaveParticipant,new x.$0nc(Dt,It,Qe.getProxy(t.$tM.MainThreadBulkEdits))),we=Qe.set(t.$uM.ExtHostEditors,new rt.$Qmc(Qe,Ct)),Te=Qe.set(t.$uM.ExtHostTreeViews,new We.$Boc(Qe.getProxy(t.$tM.MainThreadTreeViews),vt,Dt)),le=Qe.set(t.$uM.ExtHostEditorInsets,new D.$Rmc(Qe.getProxy(t.$tM.MainThreadEditorInsets),we,pt.remote)),Q=Qe.set(t.$uM.ExtHostDiagnostics,new M.$Gmc(Qe,Dt,_t,Ct)),Pe=Qe.set(t.$uM.ExtHostLanguages,new De.$8nc(Qe,Rt,vt.converter,Bt)),ze=Qe.set(t.$uM.ExtHostLanguageFeatures,new W.$Imc(Qe,Bt,Rt,vt,Q,Dt,Pt,Ot)),Ye=Qe.set(t.$uM.ExtHostFileSystem,new oe.$Rnc(Qe,ze)),qe=Qe.set(t.$uM.ExtHostFileSystemEventService,new $e.$Snc(Qe,Dt,Ct)),lt=Qe.set(t.$uM.ExtHostQuickOpen,(0,U.$ioc)(Qe,bt,vt)),kt=Qe.set(t.$uM.ExtHostSCM,new J.$koc(Qe,vt,Rt,Dt)),Zt=Qe.set(t.$uM.ExtHostQuickDiff,new j.$hoc(Qe,Bt)),ii=Qe.set(t.$uM.ExtHostShare,new Ae.$loc(Qe,Bt)),Ft=Qe.set(t.$uM.ExtHostComments,(0,p.$Smc)(Qe,vt,Rt)),Ht=Qe.set(t.$uM.ExtHostProgress,new Oe.$goc(Qe.getProxy(t.$tM.MainThreadProgress))),Li=Qe.set(t.$uM.ExtHostLabelService,new Y.$7nc(Qe)),zi=Qe.set(t.$uM.ExtHostTheming,new at.$yoc(Qe)),Yi=Qe.set(t.$uM.ExtHostTimeline,new dt.$Aoc(Qe,vt)),Ui=Qe.set(t.$uM.ExtHostWebviews,new ct.$7mc(Qe,pt.remote,bt,Dt,Pt)),Ti=Qe.set(t.$uM.ExtHostWebviewPanels,new gt.$0mc(Qe,Ui,bt)),ji=Qe.set(t.$uM.ExtHostCustomEditors,new m.$$mc(Qe,Rt,ti,Ui,Ti)),Bi=Qe.set(t.$uM.ExtHostWebviewViews,new Tt.$Eoc(Qe,Ui)),yi=Qe.set(t.$uM.ExtHostTesting,new ut.$uoc(Qe,Dt,vt,Ct)),Zi=Qe.set(t.$uM.ExtHostUriOpeners,new ye.$Coc(Qe)),xi=Qe.set(t.$uM.ExtHostProfileContentHandlers,new Re.$foc(Qe));Qe.set(t.$uM.ExtHostInteractive,new Fe.$6nc(Qe,It,Ct,vt,Dt));const Mi=Qe.set(t.$uM.ExtHostChatAgents2,new u.$Nmc(Qe,Dt,vt,pt.quality)),Wi=Qe.set(t.$uM.ExtHostChatVariables,new b.$Omc(Qe)),Vi=Qe.set(t.$uM.ExtHostAiRelatedInformation,new s.$zmc(Qe)),gn=Qe.set(t.$uM.ExtHostAiEmbeddingVector,new fe.$Qnc(Qe)),_i=Qe.set(t.$uM.ExtHostStatusBar,new Ge.$ooc(Qe,vt.converter)),qi=Qe.set(t.$uM.ExtHostSpeech,new je.$moc(Qe)),Ei=Qe.set(t.$uM.ExtHostEmbeddings,new re.$Pnc(Qe)),mn=Object.values(t.$uM);Qe.assertRegistered(mn);const pn=new f.$Mmc(Qe,Ct),en=new I.$Pmc(Qe),Gi=new ae.$9nc(Qe,Dt),Oi=new G.$Mnc(Qe);return n.$Jmc.register(vt),function(Le,gi,Ki){function st(ee){return(ce,Ne,ot)=>{const Et=ee(At=>{try{ce.call(Ne,At)}catch(Si){R.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ot.onExtensionError(Le.identifier,Si)}});return ot?.push(Et),Et}}const yt=function(){let ee=!Le.isUnderDevelopment;function ce(){ee||(Dt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")ce();else{const Et=ot;typeof Et.scheme>"u"&&ce(),typeof Et.exclusive=="boolean"&&(0,Xe.$TG)(Le,"documentFiltersExclusive")}return ot}}(),tn={getSession(ee,ce,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,Xe.$TG)(Le,"authLearnMore"),Lt.getSession(Le,ee,ce,Ne)},getSessions(ee,ce){return(0,Xe.$TG)(Le,"authGetSessions"),Lt.getSessions(Le,ee,ce)},async hasSession(ee,ce){return(0,Xe.$TG)(Le,"authSession"),!!await Lt.getSession(Le,ee,ce,{silent:!0})},get onDidChangeSessions(){return st(Lt.onDidChangeSessions)},registerAuthenticationProvider(ee,ce,Ne,ot){return Lt.registerAuthenticationProvider(ee,ce,Ne,ot)}},bi={registerCommand(ee,ce,Ne){return vt.registerCommand(!0,ee,ce,Ne,void 0,Le)},registerTextEditorCommand(ee,ce,Ne){return vt.registerCommand(!0,ee,(...ot)=>{const Et=we.getActiveTextEditor();if(!Et){Dt.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Et.edit(At=>{ce.apply(Ne,[Et,At,...ot])}).then(At=>{At||Dt.warn("Edits from command "+ee+" were not applied.")},At=>{Dt.warn("An error occurred while running command "+ee,At)})},void 0,void 0,Le)},registerDiffInformationCommand:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"diffCommand"),vt.registerCommand(!0,ee,async(...ot)=>{const Et=Ct.activeEditor(!0);if(!Et){Dt.warn("Cannot execute "+ee+" because there is no active text editor.");return}const At=await we.getDiffInformation(Et.id);ce.apply(Ne,[At,...ot])},void 0,void 0,Le)),executeCommand(ee,...ce){return vt.executeCommand(ee,...ce)},getCommands(ee=!1){return vt.getCommands(ee)}},Ai={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return en.value},get shell(){return $t.getDefaultShell(!1)},get onDidChangeShell(){return st($t.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$TG)(Le,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$TG)(Le,"telemetry"),st(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$eP)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ce){return it.$dP.validateSender(ee),Ot.instantiateLogger(Le,ee,ce)},openExternal(ee,ce){return Nt.openUri(ee,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===pt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!pt.remote.authority})}catch(ce){if((0,A.$Jg)(ee,A.Schemas.http)||(0,A.$Jg)(ee,A.Schemas.https))return ee;throw ce}},get remoteName(){return(0,o.$Nm)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.$TG)(Le,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return st(Dt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$TG)(Le,"resolvers"),pt.quality},get appCommit(){return(0,Xe.$TG)(Le,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ai);const $n={createTestController(ee,ce,Ne){return yi.createTestController(Le,ee,ce,Ne)},createTestObserver(){return(0,Xe.$TG)(Le,"testObserver"),yi.createTestObserver()},runTests(ee){return(0,Xe.$TG)(Le,"testObserver"),yi.runTests(ee)},registerTestFollowupProvider(ee){return(0,Xe.$TG)(Le,"testObserver"),yi.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Xe.$TG)(Le,"testObserver"),st(yi.onResultsChanged)},get testResults(){return(0,Xe.$TG)(Le,"testObserver"),yi.results}},ni=pt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ni={getExtension(ee,ce){(0,Xe.$SG)(Le,"extensionsAny")||(ce=!1);const Ne=gi.mine.getExtensionDescription(ee);if(Ne)return new be.$Bnc(jt,Le.identifier,Ne,ni,!1);if(ce){const ot=gi.all.getExtensionDescription(ee);if(ot)return new be.$Bnc(jt,Le.identifier,ot,ni,!0)}},get all(){const ee=[];for(const ce of gi.mine.getAllExtensionDescriptions())ee.push(new be.$Bnc(jt,Le.identifier,ce,ni,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$TG)(Le,"extensionsAny");const ee=new S.$Xm(gi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ce=[];for(const Ne of gi.all.getAllExtensionDescriptions()){const ot=!ee.has(Ne.identifier);ce.push(new be.$Bnc(jt,Le.identifier,Ne,ni,ot))}return ce},get onDidChange(){return(0,Xe.$SG)(Le,"extensionsAny")?st(P.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):st(gi.mine.onDidChange)}},nn={createDiagnosticCollection(ee){return Q.createDiagnosticCollection(Le.identifier,ee)},get onDidChangeDiagnostics(){return st(Q.onDidChangeDiagnostics)},getDiagnostics:ee=>Q.getDiagnostics(ee),getLanguages(){return Pe.getLanguages()},setTextDocumentLanguage(ee,ce){return Pe.changeLanguage(ee.uri,ce)},match(ee,ce){const Ne=_.LanguageSelector.from(ee);let ot;return(0,C.$ht)(Ne)&&(ot=It.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(At=>At.document===ce))?.apiNotebook),(0,C.$gt)(Ne,ce.uri,ce.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(ee,ce,Ne){return ze.registerCodeActionProvider(Le,yt(ee),ce,Ne)},registerDocumentPasteEditProvider(ee,ce,Ne){return(0,Xe.$TG)(Le,"documentPaste"),ze.registerDocumentPasteEditProvider(Le,yt(ee),ce,Ne)},registerCodeLensProvider(ee,ce){return ze.registerCodeLensProvider(Le,yt(ee),ce)},registerDefinitionProvider(ee,ce){return ze.registerDefinitionProvider(Le,yt(ee),ce)},registerDeclarationProvider(ee,ce){return ze.registerDeclarationProvider(Le,yt(ee),ce)},registerImplementationProvider(ee,ce){return ze.registerImplementationProvider(Le,yt(ee),ce)},registerTypeDefinitionProvider(ee,ce){return ze.registerTypeDefinitionProvider(Le,yt(ee),ce)},registerHoverProvider(ee,ce){return ze.registerHoverProvider(Le,yt(ee),ce,Le.identifier)},registerEvaluatableExpressionProvider(ee,ce){return ze.registerEvaluatableExpressionProvider(Le,yt(ee),ce,Le.identifier)},registerInlineValuesProvider(ee,ce){return ze.registerInlineValuesProvider(Le,yt(ee),ce,Le.identifier)},registerDocumentHighlightProvider(ee,ce){return ze.registerDocumentHighlightProvider(Le,yt(ee),ce)},registerMultiDocumentHighlightProvider(ee,ce){return ze.registerMultiDocumentHighlightProvider(Le,yt(ee),ce)},registerLinkedEditingRangeProvider(ee,ce){return ze.registerLinkedEditingRangeProvider(Le,yt(ee),ce)},registerReferenceProvider(ee,ce){return ze.registerReferenceProvider(Le,yt(ee),ce)},registerRenameProvider(ee,ce){return ze.registerRenameProvider(Le,yt(ee),ce)},registerNewSymbolNamesProvider(ee,ce){return(0,Xe.$TG)(Le,"newSymbolNamesProvider"),ze.registerNewSymbolNamesProvider(Le,yt(ee),ce)},registerDocumentSymbolProvider(ee,ce,Ne){return ze.registerDocumentSymbolProvider(Le,yt(ee),ce,Ne)},registerWorkspaceSymbolProvider(ee){return ze.registerWorkspaceSymbolProvider(Le,ee)},registerDocumentFormattingEditProvider(ee,ce){return ze.registerDocumentFormattingEditProvider(Le,yt(ee),ce)},registerDocumentRangeFormattingEditProvider(ee,ce){return ze.registerDocumentRangeFormattingEditProvider(Le,yt(ee),ce)},registerOnTypeFormattingEditProvider(ee,ce,Ne,...ot){return ze.registerOnTypeFormattingEditProvider(Le,yt(ee),ce,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ee,ce,Ne){return ze.registerDocumentSemanticTokensProvider(Le,yt(ee),ce,Ne)},registerDocumentRangeSemanticTokensProvider(ee,ce,Ne){return ze.registerDocumentRangeSemanticTokensProvider(Le,yt(ee),ce,Ne)},registerSignatureHelpProvider(ee,ce,Ne,...ot){return typeof Ne=="object"?ze.registerSignatureHelpProvider(Le,yt(ee),ce,Ne):ze.registerSignatureHelpProvider(Le,yt(ee),ce,typeof Ne>"u"?[]:[Ne,...ot])},registerCompletionItemProvider(ee,ce,...Ne){return ze.registerCompletionItemProvider(Le,yt(ee),ce,Ne)},registerInlineCompletionItemProvider(ee,ce,Ne){return ce.handleDidShowCompletionItem&&(0,Xe.$TG)(Le,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$TG)(Le,"inlineCompletionsAdditions"),Ne&&(0,Xe.$TG)(Le,"inlineCompletionsAdditions"),ze.registerInlineCompletionsProvider(Le,yt(ee),ce,Ne)},registerInlineEditProvider(ee,ce){return(0,Xe.$TG)(Le,"inlineEdit"),ze.registerInlineEditProvider(Le,yt(ee),ce)},registerDocumentLinkProvider(ee,ce){return ze.registerDocumentLinkProvider(Le,yt(ee),ce)},registerColorProvider(ee,ce){return ze.registerColorProvider(Le,yt(ee),ce)},registerFoldingRangeProvider(ee,ce){return ze.registerFoldingRangeProvider(Le,yt(ee),ce)},registerSelectionRangeProvider(ee,ce){return ze.registerSelectionRangeProvider(Le,ee,ce)},registerCallHierarchyProvider(ee,ce){return ze.registerCallHierarchyProvider(Le,ee,ce)},registerTypeHierarchyProvider(ee,ce){return ze.registerTypeHierarchyProvider(Le,ee,ce)},setLanguageConfiguration:(ee,ce)=>ze.setLanguageConfiguration(Le,ee,ce),getTokenInformationAtPosition(ee,ce){return(0,Xe.$TG)(Le,"tokenInformation"),Pe.tokenAtPosition(ee,ce)},registerInlayHintsProvider(ee,ce){return ze.registerInlayHintsProvider(Le,ee,ce)},createLanguageStatusItem(ee,ce){return Pe.createLanguageStatusItem(Le,ee,ce)},registerDocumentDropEditProvider(ee,ce,Ne){return ze.registerDocumentOnDropEditProvider(Le,ee,ce,(0,Xe.$SG)(Le,"documentPaste")?Ne:void 0)}},rn={get activeTextEditor(){return we.getActiveTextEditor()},get visibleTextEditors(){return we.getVisibleTextEditors()},get activeTerminal(){return $t.activeTerminal},get terminals(){return $t.terminals},async showTextDocument(ee,ce,Ne){$.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&Pt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await($.URI.isUri(ee)?Promise.resolve(Hi.openTextDocument(ee)):Promise.resolve(ee));return we.showTextDocument(ot,ce,Ne)},createTextEditorDecorationType(ee){return we.createTextEditorDecorationType(Le,ee)},onDidChangeActiveTextEditor(ee,ce,Ne){return st(we.onDidChangeActiveTextEditor)(ee,ce,Ne)},onDidChangeVisibleTextEditors(ee,ce,Ne){return st(we.onDidChangeVisibleTextEditors)(ee,ce,Ne)},onDidChangeTextEditorSelection(ee,ce,Ne){return st(we.onDidChangeTextEditorSelection)(ee,ce,Ne)},onDidChangeTextEditorOptions(ee,ce,Ne){return st(we.onDidChangeTextEditorOptions)(ee,ce,Ne)},onDidChangeTextEditorVisibleRanges(ee,ce,Ne){return st(we.onDidChangeTextEditorVisibleRanges)(ee,ce,Ne)},onDidChangeTextEditorViewColumn(ee,ce,Ne){return st(we.onDidChangeTextEditorViewColumn)(ee,ce,Ne)},onDidCloseTerminal(ee,ce,Ne){return st($t.onDidCloseTerminal)(ee,ce,Ne)},onDidOpenTerminal(ee,ce,Ne){return st($t.onDidOpenTerminal)(ee,ce,Ne)},onDidChangeActiveTerminal(ee,ce,Ne){return st($t.onDidChangeActiveTerminal)(ee,ce,Ne)},onDidChangeTerminalDimensions(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalDimensions"),st($t.onDidChangeTerminalDimensions)(ee,ce,Ne)},onDidChangeTerminalState(ee,ce,Ne){return st($t.onDidChangeTerminalState)(ee,ce,Ne)},onDidWriteTerminalData(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalDataWriteEvent"),st($t.onDidWriteTerminalData)(ee,ce,Ne)},onDidExecuteTerminalCommand(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalExecuteCommandEvent"),st($t.onDidExecuteTerminalCommand)(ee,ce,Ne)},onDidChangeTerminalShellIntegration(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalShellIntegration"),st(qt.onDidChangeTerminalShellIntegration)(ee,ce,Ne)},onDidStartTerminalShellExecution(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalShellIntegration"),st(qt.onDidStartTerminalShellExecution)(ee,ce,Ne)},onDidEndTerminalShellExecution(ee,ce,Ne){return(0,Xe.$TG)(Le,"terminalShellIntegration"),st(qt.onDidEndTerminalShellExecution)(ee,ce,Ne)},get state(){return Nt.getState()},onDidChangeWindowState(ee,ce,Ne){return st(Nt.onDidChangeWindowState)(ee,ce,Ne)},showInformationMessage(ee,...ce){return Gi.showMessage(Le,T.default.Info,ee,ce[0],ce.slice(1))},showWarningMessage(ee,...ce){return Gi.showMessage(Le,T.default.Warning,ee,ce[0],ce.slice(1))},showErrorMessage(ee,...ce){return Gi.showMessage(Le,T.default.Error,ee,ce[0],ce.slice(1))},showQuickPick(ee,ce,Ne){return lt.showQuickPick(Le,ee,ce,Ne)},showWorkspaceFolderPick(ee){return lt.showWorkspaceFolderPick(ee)},showInputBox(ee,ce){return lt.showInput(ee,ce)},showOpenDialog(ee){return Oi.showOpenDialog(Le,ee)},showSaveDialog(ee){return Oi.showSaveDialog(ee)},createStatusBarItem(ee,ce,Ne){let ot,Et,At;return typeof ee=="string"?(ot=ee,Et=ce,At=Ne):(Et=ee,At=ce),_i.createStatusBarEntry(Le,ot,Et,At)},setStatusBarMessage(ee,ce){return _i.setStatusBarMessage(ee,ce)},withScmProgress(ee){return Pt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ht.withProgress(Le,{location:H.ProgressLocation.SourceControl},(ce,Ne)=>ee({report(ot){}}))},withProgress(ee,ce){return Ht.withProgress(Le,ee,ce)},createOutputChannel(ee,ce){return pi.createOutputChannel(ee,ce,Le)},createWebviewPanel(ee,ce,Ne,ot){return Ti.createWebviewPanel(Le,ee,ce,Ne,ot)},createWebviewTextEditorInset(ee,ce,Ne,ot){return(0,Xe.$TG)(Le,"editorInsets"),le.createWebviewEditorInset(ee,ce,Ne,ot,Le)},createTerminal(ee,ce,Ne){return typeof ee=="object"?"pty"in ee?$t.createExtensionTerminal(ee):$t.createTerminalFromOptions(ee):$t.createTerminal(ee,ce,Ne)},registerTerminalLinkProvider(ee){return $t.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ce){return $t.registerProfileProvider(Le,ee,ce)},registerTerminalQuickFixProvider(ee,ce){return(0,Xe.$TG)(Le,"terminalQuickFixProvider"),$t.registerTerminalQuickFixProvider(ee,Le.identifier.value,ce)},registerTreeDataProvider(ee,ce){return Te.registerTreeDataProvider(ee,ce,Le)},createTreeView(ee,ce){return Te.createTreeView(ee,ce,Le)},registerWebviewPanelSerializer:(ee,ce)=>Ti.registerWebviewPanelSerializer(Le,ee,ce),registerCustomEditorProvider:(ee,ce,Ne={})=>ji.registerCustomEditorProvider(Le,ee,ce,Ne),registerFileDecorationProvider(ee){return si.registerFileDecorationProvider(ee,Le)},registerUriHandler(ee){return ki.registerUriHandler(Le,ee)},createQuickPick(){return lt.createQuickPick(Le)},createInputBox(){return lt.createInputBox(Le)},get activeColorTheme(){return zi.activeColorTheme},onDidChangeActiveColorTheme(ee,ce,Ne){return st(zi.onDidChangeActiveColorTheme)(ee,ce,Ne)},registerWebviewViewProvider(ee,ce,Ne){return Bi.registerWebviewViewProvider(Le,ee,ce,Ne?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ce,Ne){return st(It.onDidChangeActiveNotebookEditor)(ee,ce,Ne)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ce,Ne){return st(vi.onDidChangeNotebookEditorSelection)(ee,ce,Ne)},onDidChangeNotebookEditorVisibleRanges(ee,ce,Ne){return st(vi.onDidChangeNotebookEditorVisibleRanges)(ee,ce,Ne)},showNotebookDocument(ee,ce){return It.showNotebookDocument(ee,ce)},registerExternalUriOpener(ee,ce,Ne){return(0,Xe.$TG)(Le,"externalUriOpener"),Zi.registerExternalUriOpener(Le.identifier,ee,ce,Ne)},registerProfileContentHandler(ee,ce){return(0,Xe.$TG)(Le,"profileContentHandlers"),xi.registerProfileContentHandler(Le,ee,ce)},registerQuickDiffProvider(ee,ce,Ne,ot){return(0,Xe.$TG)(Le,"quickDiffProvider"),Zt.registerQuickDiffProvider(yt(ee),ce,Ne,ot)},get tabGroups(){return Vt.tabGroups},registerShareProvider(ee,ce){return(0,Xe.$TG)(Le,"shareProvider"),ii.registerShareProvider(yt(ee),ce)}},Hi={get rootPath(){return Pt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(ee){throw new R.$9("rootPath")},getWorkspaceFolder(ee){return bt.getWorkspaceFolder(ee)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(ee){throw new R.$9("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(ee){throw new R.$9("workspaceFile")},updateWorkspaceFolders:(ee,ce,...Ne)=>bt.updateWorkspaceFolders(Le,ee,ce||0,...Ne),onDidChangeWorkspaceFolders:function(ee,ce,Ne){return st(bt.onDidChangeWorkspace)(ee,ce,Ne)},asRelativePath:(ee,ce)=>bt.getRelativePath(ee,ce),findFiles:(ee,ce,Ne,ot)=>bt.findFiles(ee,ce,Ne,Le.identifier,ot),findFiles2:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"findFiles2"),bt.findFiles2(ee,ce,Le.identifier,Ne)),findTextInFiles:(ee,ce,Ne,ot)=>{(0,Xe.$TG)(Le,"findTextInFiles");let Et,At;return typeof ce=="object"?(Et=ce,At=Ne):(Et={},At=ce,ot=Ne),bt.findTextInFiles(ee,Et||{},At,Le.identifier,ot)},save:ee=>bt.save(ee),saveAs:ee=>bt.saveAs(ee),saveAll:ee=>bt.saveAll(ee),applyEdit(ee,ce){return pn.applyWorkspaceEdit(ee,Le,ce)},createFileSystemWatcher:(ee,ce,Ne,ot)=>{let Et;return typeof ce=="boolean"?Et={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!ot,correlate:!1}:ce&&((0,Xe.$TG)(Le,"createFileSystemWatcher"),Et={...ce,correlate:!0}),qe.createFileSystemWatcher(bt,Le,ee,Et)},get textDocuments(){return Rt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new R.$9("textDocuments")},openTextDocument(ee){let ce;const Ne=ee;if(typeof ee=="string")ce=Promise.resolve($.URI.file(ee));else if($.URI.isUri(ee))ce=Promise.resolve(ee);else if(!Ne||typeof Ne=="object")ce=Rt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ot=>(ot.scheme===A.Schemas.vscodeRemote&&!ot.authority&&Pt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(ot).then(Et=>Et.document)))},onDidOpenTextDocument:(ee,ce,Ne)=>st(Rt.onDidAddDocument)(ee,ce,Ne),onDidCloseTextDocument:(ee,ce,Ne)=>st(Rt.onDidRemoveDocument)(ee,ce,Ne),onDidChangeTextDocument:(ee,ce,Ne)=>st(Rt.onDidChangeDocument)(ee,ce,Ne),onDidSaveTextDocument:(ee,ce,Ne)=>st(Rt.onDidSaveDocument)(ee,ce,Ne),onWillSaveTextDocument:(ee,ce,Ne)=>st(ai.getOnWillSaveTextDocumentEvent(Le))(ee,ce,Ne),get notebookDocuments(){return It.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ce){let Ne;if($.URI.isUri(ee))Ne=ee,await It.openNotebookDocument(ee);else if(typeof ee=="string")Ne=$.URI.revive(await It.createNotebookDocument({viewType:ee,content:ce}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ee,ce,Ne){return st(Ii.onDidSaveNotebookDocument)(ee,ce,Ne)},onDidChangeNotebookDocument(ee,ce,Ne){return st(Ii.onDidChangeNotebookDocument)(ee,ce,Ne)},onWillSaveNotebookDocument(ee,ce,Ne){return st(fi.getOnWillSaveNotebookDocumentEvent(Le))(ee,ce,Ne)},get onDidOpenNotebookDocument(){return st(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ce,Ne,ot){return It.registerNotebookSerializer(Le,ee,ce,Ne,(0,Xe.$SG)(Le,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ce,Ne)=>st(Ki.onDidChangeConfiguration)(ee,ce,Ne),getConfiguration(ee,ce){return ce=arguments.length===1?void 0:ce,Ki.getConfiguration(ee,ce,Le)},registerTextDocumentContentProvider(ee,ce){return Pi.registerTextDocumentContentProvider(ee,ce)},registerTaskProvider:(ee,ce)=>(Pt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Le,ee,ce)),registerFileSystemProvider(ee,ce,Ne){return(0,O.$Rc)(Ye.registerFileSystemProvider(Le,ee,ce,Ne),Xt.addFileSystemProvider(ee,ce,Ne))},get fs(){return Xt.value},registerFileSearchProvider:(ee,ce)=>((0,Xe.$TG)(Le,"fileSearchProvider"),oi.registerFileSearchProvider(ee,ce)),registerTextSearchProvider:(ee,ce)=>((0,Xe.$TG)(Le,"textSearchProvider"),oi.registerTextSearchProvider(ee,ce)),registerAITextSearchProvider:(ee,ce)=>((0,Xe.$TG)(Le,"aiTextSearchProvider"),(0,Xe.$TG)(Le,"textSearchProvider"),oi.registerAITextSearchProvider(ee,ce)),registerRemoteAuthorityResolver:(ee,ce)=>((0,Xe.$TG)(Le,"resolvers"),jt.registerRemoteAuthorityResolver(ee,ce)),registerResourceLabelFormatter:ee=>((0,Xe.$TG)(Le,"resolvers"),Li.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$TG)(Le,"resolvers"),jt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ce,Ne)=>st(qe.onDidCreateFile)(ee,ce,Ne),onDidDeleteFiles:(ee,ce,Ne)=>st(qe.onDidDeleteFile)(ee,ce,Ne),onDidRenameFiles:(ee,ce,Ne)=>st(qe.onDidRenameFile)(ee,ce,Ne),onWillCreateFiles:(ee,ce,Ne)=>st(qe.getOnWillCreateFileEvent(Le))(ee,ce,Ne),onWillDeleteFiles:(ee,ce,Ne)=>st(qe.getOnWillDeleteFileEvent(Le))(ee,ce,Ne),onWillRenameFiles:(ee,ce,Ne)=>st(qe.getOnWillRenameFileEvent(Le))(ee,ce,Ne),openTunnel:ee=>((0,Xe.$TG)(Le,"tunnels"),Mt.openTunnel(Le,ee).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Xe.$TG)(Le,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"tunnels"),st(Mt.onDidChangeTunnels)(ee,ce,Ne)),registerPortAttributesProvider:(ee,ce)=>((0,Xe.$TG)(Le,"portsAttributes"),Mt.registerPortsAttributesProvider(ee,ce)),registerTunnelProvider:(ee,ce)=>((0,Xe.$TG)(Le,"tunnelFactory"),Mt.registerTunnelProvider(ee,ce)),registerTimelineProvider:(ee,ce)=>((0,Xe.$TG)(Le,"timeline"),Yi.registerTimelineProvider(ee,ce,Le.identifier,vt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$TG)(Le,"workspaceTrust"),bt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ce,Ne)=>st(bt.onDidGrantWorkspaceTrust)(ee,ce,Ne),registerEditSessionIdentityProvider:(ee,ce)=>((0,Xe.$TG)(Le,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(ee,ce)),onWillCreateEditSessionIdentity:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"editSessionIdentityProvider"),st(bt.getOnWillCreateEditSessionIdentityEvent(Le))(ee,ce,Ne)),registerCanonicalUriProvider:(ee,ce)=>((0,Xe.$TG)(Le,"canonicalUriProvider"),bt.registerCanonicalUriProvider(ee,ce)),getCanonicalUri:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"canonicalUriProvider"),bt.provideCanonicalUri(ee,ce,Ne))},sn={get inputBox(){return Pt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),kt.getLastInputBox(Le)},createSourceControl(ee,ce,Ne){return kt.createSourceControl(Le,ee,ce,Ne)}},bn={createCommentController(ee,ce){return Ft.createCommentController(Le,ee,ce)}},on={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(ee,ce){return(0,Xe.$TG)(Le,"debugVisualization"),St.registerDebugVisualizationProvider(Le,ee,ce)},registerDebugVisualizationTreeProvider(ee,ce){return(0,Xe.$TG)(Le,"debugVisualization"),St.registerDebugVisualizationTree(Le,ee,ce)},onDidStartDebugSession(ee,ce,Ne){return st(St.onDidStartDebugSession)(ee,ce,Ne)},onDidTerminateDebugSession(ee,ce,Ne){return st(St.onDidTerminateDebugSession)(ee,ce,Ne)},onDidChangeActiveDebugSession(ee,ce,Ne){return st(St.onDidChangeActiveDebugSession)(ee,ce,Ne)},onDidReceiveDebugSessionCustomEvent(ee,ce,Ne){return st(St.onDidReceiveDebugSessionCustomEvent)(ee,ce,Ne)},onDidChangeBreakpoints(ee,ce,Ne){return st(St.onDidChangeBreakpoints)(ee,ce,Ne)},onDidChangeActiveStackItem(ee,ce,Ne){return st(St.onDidChangeActiveStackItem)(ee,ce,Ne)},registerDebugConfigurationProvider(ee,ce,Ne){return St.registerDebugConfigurationProvider(ee,ce,Ne||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ce){return St.registerDebugAdapterDescriptorFactory(Le,ee,ce)},registerDebugAdapterTrackerFactory(ee,ce){return St.registerDebugAdapterTrackerFactory(ee,ce)},startDebugging(ee,ce,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?St.startDebugging(ee,ce,{parentSession:Ne}):St.startDebugging(ee,ce,Ne||{})},stopDebugging(ee){return St.stopDebugging(ee)},addBreakpoints(ee){return St.addBreakpoints(ee)},removeBreakpoints(ee){return St.removeBreakpoints(ee)},asDebugSourceUri(ee,ce){return St.asDebugSourceUri(ee,ce)}},an={registerTaskProvider:(ee,ce)=>Kt.registerTaskProvider(Le,ee,ce),fetchTasks:ee=>Kt.fetchTasks(ee),executeTask:ee=>Kt.executeTask(Le,ee),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(ee,ce,Ne)=>st(Kt.onDidStartTask)(ee,ce,Ne),onDidEndTask:(ee,ce,Ne)=>st(Kt.onDidEndTask)(ee,ce,Ne),onDidStartTaskProcess:(ee,ce,Ne)=>st(Kt.onDidStartTaskProcess)(ee,ce,Ne),onDidEndTaskProcess:(ee,ce,Ne)=>st(Kt.onDidEndTaskProcess)(ee,ce,Ne)},wn={createNotebookController(ee,ce,Ne,ot,Et){return $i.createNotebookController(Le,ee,ce,Ne,ot,(0,Xe.$SG)(Le,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ce)=>It.registerNotebookCellStatusBarItemProvider(Le,ee,ce),createRendererMessaging(ee){return Ri.createRendererMessaging(Le,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$TG)(Le,"notebookKernelSource"),$i.createNotebookControllerDetectionTask(Le,ee)},registerKernelSourceActionProvider(ee,ce){return(0,Xe.$TG)(Le,"notebookKernelSource"),$i.registerKernelSourceActionProvider(Le,ee,ce)},onDidChangeNotebookCellExecutionState(ee,ce,Ne){return(0,Xe.$TG)(Le,"notebookCellExecutionState"),st($i.onDidChangeNotebookCellExecutionState)(ee,ce,Ne)}},vn={t(...ee){if(typeof ee[0]=="string"){const ce=ee.shift(),Ne=!ee||typeof ee[0]!="object"?ee:ee[0];return di.getMessage(Le.identifier.value,{message:ce,args:Ne})}return di.getMessage(Le.identifier.value,ee[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},cn={_version:1,transferActiveChat(ee){return(0,Xe.$TG)(Le,"interactive"),Mi.transferActiveChat(ee)}},Ji={getRelatedInformation(ee,ce){return(0,Xe.$TG)(Le,"aiRelatedInformation"),Vi.getRelatedInformation(Le,ee,ce)},registerRelatedInformationProvider(ee,ce){return(0,Xe.$TG)(Le,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(Le,ee,ce)},registerEmbeddingVectorProvider(ee,ce){return(0,Xe.$TG)(Le,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(Le,ee,ce)}},ln={_version:1,registerChatResponseProvider(ee,ce,Ne){return(0,Xe.$TG)(Le,"chatProvider"),Yt.registerLanguageModel(Le,ee,ce,Ne)},registerChatVariableResolver(ee,ce,Ne,ot,Et,At,Si,Fi){return(0,Xe.$TG)(Le,"chatVariableResolver"),Wi.registerVariableResolver(Le,ee,ce,Ne,ot,Et,At,Si,Fi?.id)},registerMappedEditsProvider(ee,ce){return(0,Xe.$TG)(Le,"mappedEditsProvider"),ze.registerMappedEditsProvider(Le,ee,ce)},createChatParticipant(ee,ce){return Mi.createChatAgent(Le,ee,ce)},createDynamicChatParticipant(ee,ce,Ne){return(0,Xe.$TG)(Le,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Le,ee,ce,Ne)},attachContext(ee,ce,Ne){return(0,Xe.$TG)(Le,"chatVariableResolver"),Wi.attachContext(ee,ce,Ne)}},un={selectChatModels:ee=>pt.quality==="stable"?(console.warn(`[${S.$Wm.toKey(Le.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),Promise.resolve([])):Yt.selectLanguageModels(Le,ee??{}),onDidChangeChatModels:(ee,ce,Ne)=>pt.quality==="stable"?(console.warn(`[${S.$Wm.toKey(Le.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),P.Event.None(ee,ce,Ne)):Yt.onDidChangeProviders(ee,ce,Ne),get embeddingModels(){return(0,Xe.$TG)(Le,"embeddings"),Ei.embeddingsModels},onDidChangeEmbeddingModels:(ee,ce,Ne)=>((0,Xe.$TG)(Le,"embeddings"),Ei.onDidChange(ee,ce,Ne)),registerEmbeddingsProvider(ee,ce){return(0,Xe.$TG)(Le,"embeddings"),Ei.registerEmbeddingsProvider(Le,ee,ce)},async computeEmbeddings(ee,ce,Ne){return(0,Xe.$TG)(Le,"embeddings"),Ei.computeEmbeddings(ee,ce,Ne)}},hn={registerSpeechProvider(ee,ce){return(0,Xe.$TG)(Le,"speech"),qi.registerProvider(Le.identifier,ee,ce)}};return{version:pt.version,ai:Ji,authentication:tn,commands:bi,comments:bn,chat:ln,debug:on,env:Ai,extensions:Ni,interactive:cn,l10n:vn,languages:nn,lm:un,notebooks:wn,scm:sn,speech:hn,tasks:an,tests:$n,window:rn,workspace:Hi,Breakpoint:H.$wN,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatResultFeedbackKind:H.ChatResultFeedbackKind,ChatVariableLevel:H.ChatVariableLevel,ChatCompletionItem:H.$rO,CallHierarchyIncomingCall:H.$UM,CallHierarchyItem:H.$TM,CallHierarchyOutgoingCall:H.$VM,CancellationError:R.$5,CancellationTokenSource:E.$se,CandidatePortSource:t.CandidatePortSource,CodeAction:H.$QM,CodeActionKind:H.$RM,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$WM,Color:H.$0M,ColorInformation:H.$$M,ColorPresentation:H.$_M,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CommentThreadApplicability:H.CommentThreadApplicability,CompletionItem:H.$4M,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$5M,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$hN,DebugAdapterExecutable:H.$AN,DebugAdapterInlineImplementation:H.$DN,DebugAdapterNamedPipeServer:H.$CN,DebugAdapterServer:H.$BN,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DebugVisualization:H.$TN,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$JM,DiagnosticRelatedInformation:H.$IM,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$vM,DocumentHighlight:H.$MM,DocumentHighlightKind:H.DocumentHighlightKind,MultiDocumentHighlight:H.$NM,DocumentLink:H.$9M,DocumentSymbol:H.$PM,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$GN,InlineValueText:H.$HN,InlineValueVariableLookup:H.$IN,InlineValueEvaluatableExpression:H.$JN,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:P.$he,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$VN,FileDecoration2:H.$VN,FileSystemError:H.$MN,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:H.$NN,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$yN,InlineCompletionItem:H.$6M,InlineCompletionList:H.$7M,Hover:H.$KM,VerboseHover:H.$LM,HoverVerbosityAction:H.HoverVerbosityAction,IndentAction:w.IndentAction,Location:H.$HM,MarkdownString:H.$XM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:H.$YM,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$wM,ProcessExecution:H.$fN,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$UN,Range:H.$xM,RelativePattern:H.$uN,Selection:H.$yM,SelectionRange:H.$SM,SemanticTokens:H.$QN,SemanticTokensBuilder:H.$PN,SemanticTokensEdit:H.$RN,SemanticTokensEdits:H.$SN,SemanticTokensLegend:H.$ON,ShellExecution:H.$gN,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$1M,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$ZM,SnippetString:H.$GM,SourceBreakpoint:H.$xN,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$OM,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$iN,TaskGroup:H.$eN,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$aN,TerminalQuickFixTerminalCommand:H.$cN,TerminalQuickFixOpener:H.$bN,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$dN,TerminalExitReason:H.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:H.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$CM,SnippetTextEdit:H.$EM,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$tN,ThemeIcon:H.$sN,TreeItem:H.$jN,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$fO,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$FM,DocumentPasteTriggerKind:H.DocumentPasteTriggerKind,DocumentDropEdit:H.$pN,DocumentDropOrPasteEditKind:H.$qN,DocumentPasteEdit:H.$rN,InlayHint:H.$3M,InlayHintLabelPart:H.$2M,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$BM,ResolvedAuthority:H.$zM,ManagedResolvedAuthority:H.$AM,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$6N,NotebookRange:H.$XN,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$YN,NotebookData:H.$ZN,NotebookRendererScript:H.$4N,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$2N,NotebookCellOutputItem:H.$1N,NotebookCellStatusBarItem:H.$3N,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$DM,NotebookKernelSourceAction:H.$5N,NotebookVariablesRequestKind:H.NotebookVariablesRequestKind,PortAttributes:H.$8N,LinkedEditingRanges:H.$7N,TestResultState:H.TestResultState,TestRunRequest:H.$9N,TestMessage:H.$0N,TestTag:H.$$N,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:H.$oN,DataTransferItem:H.$kN,TestCoverageCount:H.$_N,FileCoverage:H.$bO,FileCoverage2:H.$bO,StatementCoverage:H.$cO,BranchCoverage:H.$dO,DeclarationCoverage:H.$eO,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$gO,TabInputTextDiff:H.$hO,TabInputTextMerge:H.$iO,TabInputCustom:H.$jO,TabInputNotebook:H.$lO,TabInputNotebookDiff:H.$mO,TabInputWebview:H.$kO,TabInputTerminal:H.$nO,TabInputInteractiveWindow:H.$oO,TabInputChat:H.$pO,TabInputTextMultiDiff:H.$qO,TelemetryTrustedValue:a.$np,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,ChatCopyKind:H.ChatCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,DebugStackFrame:H.$EN,DebugThread:H.$FN,RelatedInformationType:H.RelatedInformationType,SpeechToTextStatus:H.SpeechToTextStatus,TextToSpeechStatus:H.TextToSpeechStatus,PartialAcceptTriggerKind:H.PartialAcceptTriggerKind,KeywordRecognitionStatus:H.KeywordRecognitionStatus,ChatResponseMarkdownPart:H.$sO,ChatResponseFileTreePart:H.$wO,ChatResponseAnchorPart:H.$xO,ChatResponseProgressPart:H.$yO,ChatResponseProgressPart2:H.$zO,ChatResponseReferencePart:H.$CO,ChatResponseWarningPart:H.$AO,ChatResponseTextEditPart:H.$DO,ChatResponseMarkdownWithVulnerabilitiesPart:H.$tO,ChatResponseCommandButtonPart:H.$BO,ChatResponseDetectedParticipantPart:H.$uO,ChatResponseConfirmationPart:H.$vO,ChatRequestTurn:H.$EO,ChatResponseTurn:H.$FO,ChatLocation:H.ChatLocation,LanguageModelChatMessageRole:H.LanguageModelChatMessageRole,LanguageModelChatMessage:H.$GO,LanguageModelChatMessage2:H.$GO,LanguageModelChatSystemMessage:H.$HO,LanguageModelChatUserMessage:H.$IO,LanguageModelChatAssistantMessage:H.$JO,LanguageModelError:H.$KO,NewSymbolName:H.$LN,NewSymbolNameTag:H.NewSymbolNameTag,NewSymbolNameTriggerKind:H.NewSymbolNameTriggerKind,InlineEdit:H.$LO,InlineEditTriggerKind:H.InlineEditTriggerKind}}}}),define(ke[318],Ie([1,0,60,126,44,120,45,39,71,57,129,131,132,89,93,85,119,68,51,88,66,70,257,12,130,86,87,91,95,124]),function(de,e,E,R,P,O,A,T,$,c,C,w,l,S,d,r,o,a,h,t,s,n,i,g,f,u,b,I,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Fs)(u.$vnc,u.$unc,E.InstantiationType.Delayed),(0,E.$Fs)(g.$8j,i.$Ioc,E.InstantiationType.Delayed),(0,E.$Fs)(r.$Amc,r.$Bmc,E.InstantiationType.Delayed),(0,E.$Fs)(T.$hP,T.$gP,E.InstantiationType.Eager),(0,E.$Fs)(I.$Kmc,I.$Lmc,E.InstantiationType.Eager),(0,E.$Fs)(D.$pnc,D.$qnc,E.InstantiationType.Eager),(0,E.$Fs)(A.$Zmc,A.$Xmc,E.InstantiationType.Eager),(0,E.$Fs)(a.$2mc,a.$1mc,E.InstantiationType.Eager),(0,E.$Fs)(w.$Fnc,w.$Jnc,E.InstantiationType.Eager),(0,E.$Fs)(O.$Lnc,O.$Knc,E.InstantiationType.Eager),(0,E.$Fs)($.$9O,$.$8O,E.InstantiationType.Eager),(0,E.$Fs)(b.$wnc,b.$xnc,E.InstantiationType.Eager),(0,E.$Fs)(h.$Emc,h.$Dmc,E.InstantiationType.Eager),(0,E.$Fs)(R.$eoc,R.$doc,E.InstantiationType.Delayed),(0,E.$Fs)(l.$2nc,l.$3nc,E.InstantiationType.Eager),(0,E.$Fs)(S.$inc,S.$hnc,E.InstantiationType.Eager),(0,E.$Fs)(C.$roc,C.$qoc,E.InstantiationType.Eager),(0,E.$Fs)(c.$lnc,c.$onc,E.InstantiationType.Eager),(0,E.$Fs)(y.$soc,y.$toc,E.InstantiationType.Eager),(0,E.$Fs)(d.$eEb,d.$fEb,E.InstantiationType.Eager),(0,E.$Fs)(o.$Goc,o.$Foc,E.InstantiationType.Eager),(0,E.$Fs)(P.$Wmc,P.$Vmc,E.InstantiationType.Eager),(0,E.$Fs)(t.$snc,t.$rnc,E.InstantiationType.Eager),(0,E.$Fs)(s.$fP,s.$cP,E.InstantiationType.Eager),(0,E.$Fs)(n.$_mc,n.$anc,E.InstantiationType.Eager),(0,E.$Fs)(f.$Dnc,f.$Enc,E.InstantiationType.Eager)}),define(ke[319],Ie([1,0,317,46,2,314,7,11,264]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=void 0;class c extends O.$Loc{j(){}getModule(S,d){for(const r of this.b){const o=r(S);if(o){S=o;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.$znc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$Tqc);const S=this.h.invokeFunction(E.$Hoc);this.r=this.h.createInstance(c,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,r){d=d.with({path:w(d.path,".js")});const o=S?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const t=await h.text(),s=`${d.toString(!0)}#vscode-extension`,n=`${t}
//# sourceURL=${s}`;let i;try{i=new Function("module","exports","require",n)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${d.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}S&&await this.w.initializeLocalizedMessages(S);const g={},f={exports:g},u=b=>{const I=this.r.getModule(b,d);if(I===void 0)throw new Error(`Cannot load module '${b}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(f,g,u),f.exports!==g?f.exports:g}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Bh)(10)}}e.$Uqc=C;function w(l,S){return l.endsWith(S)?l:l+S}}),define(ke[320],Ie([1,0,74,60,12,46,227,92,319]),function(de,e,E,R,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$Fs)(P.$7j,new E.$xi(A.$Koc,[!0],!0)),(0,R.$Fs)(O.$Anc,$.$Uqc,R.InstantiationType.Eager),(0,R.$Fs)(T.$3mc,T.$4mc,R.InstantiationType.Eager)}),define(ke[328],Ie([1,0,23,4,84,315,266,20,64,16,2,318,320]),function(de,e,E,R,P,O,A,T,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=n;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(i){return/^(file|vscode-remote):/i.test(i)}const d=fetch.bind(self);function r(i){self.fetch=async function(g,f){return g instanceof Request||S(String(g))&&(g=(await i(C.URI.parse(String(g)))).toString(!0)),d(g,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,f,u,b,I){(async()=>(S(f.toString())&&(f=(await i(C.URI.parse(f.toString()))).toString(!0)),super.open(g,f,u??!0,b,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(g,f){if(/^file:/i.test(g.toString()))g=c.$Ug.uriToBrowserUri(C.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(p){function k(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const m=fetch.bind(self);self.fetch=function(F,M){return F instanceof Request?m(F,M):m(k(F),M)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,M,G,q,V){return super.open(F,k(M),G??!0,q,V)}};const v=importScripts.bind(self);self.importScripts=(...F)=>{v(...F.map(k))},v(p)}.toString()}('${g}'))`;f=f||{},f.name=`${name} -> ${f.name||T.$nc(g.toString())}`;const I=new Blob([b],{type:"application/javascript"}),D=URL.createObjectURL(I);return new i(D,f)}}else self.Worker=class extends A.$Vqc{constructor(i,g){super(l,i,{name:T.$nc(i.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(i){w()}};class a{constructor(){const g=new MessageChannel,f=new R.$he;let u=!1;l(g.port2,[g.port2]),g.port1.onmessage=b=>{const{data:I}=b;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=E.$Je.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.$6m)(D,P.MessageType.Terminate)){u=!0,t("received terminate message from renderer");return}f.fire(D)},this.protocol={onMessage:f.event,send:b=>{if(!u){const I=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);g.port1.postMessage(I,[I])}}}}}function h(i){return new Promise(g=>{const f=i.onMessage(u=>{f.dispose();const b=JSON.parse(u.toString());i.send((0,P.$5m)(P.MessageType.Initialized)),g({protocol:i,initData:b})});i.send((0,P.$5m)(P.MessageType.Ready))})}let t=i=>w();function s(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function n(){$.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(g){s(g)&&h(i.protocol).then(f=>{$.mark("code/extHost/didWaitForInitData");const u=new O.$Noc(f.protocol,f.initData,o,null,g.data);r(b=>u.asBrowserUri(b)),t=b=>u.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fc8762e773c35d4e52e8a7375704af2e24698e5d/core/vs/workbench/api/worker/extensionHostWorker.js.map
